package cn.jxufe.iet.code0501.View;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.util.AttributeSet;
import android.view.View;

import java.util.ArrayList;
import java.util.List;

import cn.jxufe.iet.code0501.bean.SchoolRecruit;


/**
 * Created by cd on 2017/1/11.
 */
public class TrendView extends View {
    public TrendView(Context context) {
        super(context);
    }

    public TrendView(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    private List<Integer> firstDatas;// 第一批数据，录取最高分
    private List<Integer> secondDatas;// 第二批数据，录取平均分
    private List<Integer> thirdDatas;// 第三批数据，投档线
    private int xSpace;// 两点X轴之间的间距
    private int x[];// 保存各个点的x坐标
    private int radius = 5;// 每个点的半径
    private Paint pointPaint, textPaint, linePaint, xyPaint,numPaint;// 坐标点画笔、文字画笔、线画笔、坐标轴画笔、数字画笔
    private float textHeight;// 文字高度
    private int width, height;
    private int arrawSpace = 8;// 箭头的间距
    private int year;// 起始年份
    private int ySpace = 2;// 纵向1个单位的间距,默认为2
    private int mindData;// 中间参考值
    private int centerHeight;// 中间参考值对应的纵坐标
    private int maxData;// 最大值
    private int minData;// 最小值
    private List<SchoolRecruit> schoolRecruits;
    public static final int NO_DATA=-1024;//数据不存在
    private boolean isDrawLine = false;

    public void setSchoolRecruits(List<SchoolRecruit> schoolRecruits) {
        this.schoolRecruits = schoolRecruits;
        init();
        isDrawLine=true;//初始化数据后，即可绘制折线图
        invalidate();//重新绘制，刷新显示
    }
    public void init() {// 执行初始化操作
        int textSize = 20;// 文本大小
        // 坐标轴轴画笔的初始化
        xyPaint = new Paint();
        xyPaint.setAntiAlias(true);
        xyPaint.setStrokeWidth(3);
        xyPaint.setColor(Color.RED);// 红色
        // 坐标点画笔的初始化
        pointPaint = new Paint();
        pointPaint.setAntiAlias(true);// 抗锯齿
        pointPaint.setColor(Color.BLACK);// 黑色
        // 线条画笔的初始化
        linePaint = new Paint();
        linePaint.setColor(Color.BLUE);// 连接线的颜色默认为蓝色
        linePaint.setAntiAlias(true);// 抗锯齿
        linePaint.setStrokeWidth(2);// 直线宽度为2像素
        linePaint.setStyle(Paint.Style.FILL);// 填充
        // 文本画笔的初始化
        textPaint = new Paint();
        textPaint.setAntiAlias(true);
        textPaint.setColor(Color.BLACK);// 文本颜色为白色
        textPaint.setTextSize(textSize);// 文字大小为20
        // 数字画笔的初始化
        numPaint = new Paint();
        numPaint.setAntiAlias(true);
        numPaint.setColor(Color.BLACK);// 文本颜色为白色
        numPaint.setTextSize(18);// 文字大小为18
        // 计算文字高度
        Paint.FontMetrics fontMetrics = textPaint.getFontMetrics();
        textHeight = fontMetrics.bottom - fontMetrics.top;// 文字底部坐标减去顶部坐标
        year = schoolRecruits.get(schoolRecruits.size() - 1).getsRecruitYear();// 获取起始年份
        x = new int[schoolRecruits.size()];// X轴坐标点的个数与具体的数据个数有关
        initDatas();//初始化数据
    }

    protected void onDraw(Canvas canvas) {
        super.onDraw(canvas);
        width = this.getWidth();// 获取控件的宽度
        height = this.getHeight();// 获取控件的高度
        if (!isDrawLine) {//如果还没初始化，则不绘制折线，直接结束
            return;
        }
        System.out.println("宽度：" + width + "坐标点的个数：" + x.length);
        xSpace = (width - 200) / (x.length - 1);// 计算两个点之间的X轴间距，左右各留部分空间
        ySpace = (height - 160) / Math.abs(maxData - minData);// 上下各留65
        System.out.println("X轴坐标点的差值为：xSpace=" + xSpace
                + "，Y轴每隔一个点对应的距离为：ySpace=" + ySpace);
        for (int i = 0; i < x.length; i++) {// 初始化各个点的X轴坐标，起始点偏移20像素
            x[i] = 60 + i * xSpace;// 左边偏移40个像素
        }
        centerHeight = height / 2 - 10;// 获取控件的Y轴中线，中线为中间数据，比该数据大的在上方，比该数据小的在下方
        drawXY(canvas);// 绘制坐标轴及其提示信息
        if (firstDatas != null) {// 绘制录取最高分
            linePaint.setColor(Color.RED);
            canvas.drawText("录取最高分", width - 105, 20, linePaint);
            canvas.drawLine(width - 130, 15, width - 110, 15, linePaint);
            drawLine(firstDatas, canvas, linePaint, true);
        }
        if (secondDatas != null) {// 绘制录取平均分
            linePaint.setColor(Color.BLUE);
            canvas.drawText("录取平均分", width - 105, 45, linePaint);
            canvas.drawLine(width - 130, 40, width - 110, 40, linePaint);
            drawLine(secondDatas, canvas, linePaint, true);
        }
        if (thirdDatas != null) {// 绘制投档线
            linePaint.setColor(Color.YELLOW);
            canvas.drawText("录取投档线", width - 105, 70, linePaint);
            canvas.drawLine(width - 130, 65, width - 110, 65, linePaint);
            drawLine(thirdDatas, canvas, linePaint, true);
        }

    }

    public void drawXY(Canvas canvas) {// 绘制坐标轴,底部年份信息等
        // 绘制横坐标和纵坐标
        canvas.drawLine(20, height - 50, width - 30, height - 50, xyPaint);// 绘制X轴
        canvas.drawLine(width - 30 - arrawSpace, height - 50 - arrawSpace,
                width - 30, height - 50, xyPaint);// 绘制X轴箭头
        canvas.drawLine(width - 30 - arrawSpace, height - 50 + arrawSpace,
                width - 30, height - 50, xyPaint);// 绘制X轴箭头
        canvas.drawText("年份", width - 40, height - 50 - arrawSpace - 5,
                textPaint);// X轴坐标提示文本
        canvas.drawLine(20, height - 50, 20, 50, xyPaint);// 绘制Y轴
        canvas.drawLine(20 + arrawSpace, 50 + arrawSpace, 20, 50, xyPaint);// 绘制Y轴箭头
        canvas.drawLine(20 - arrawSpace, 50 + arrawSpace, 20, 50, xyPaint);// 绘制Y轴箭头
        canvas.drawText("分值与省控线差值", 5 + arrawSpace, 40, textPaint);// Y轴坐标提示文本，第三个参数表示
        for (int i = 0; i < x.length; i++) {// 绘制底部年份信息
            canvas.drawText((year + i) + "", x[i] - 20, height - 20, numPaint);
            canvas.drawCircle(x[i], height - 50, radius, pointPaint);
        }

    }

    /**
     * 根据数据绘制折线
     *
     * @param datas
     *            折线中一些关键节点多对应的数据
     * @param canvas
     *            画布
     * @param linePaint
     *            线的画笔，不同折线采用不同的颜色
     * @param isTextUp
     *            文字显示在折线的上方还是下方 ：true显示在上方，false显示在下方
     */
    public void drawLine(List<Integer> datas, Canvas canvas, Paint linePaint,
                         boolean isTextUp) {
        for (int i = 0; i < datas.size(); i++) {// 依次获取每一个数据
            int data = datas.get(i);
            if (data !=NO_DATA) {// 如果对应的值有数据，则绘制
                // 该数据相对于中间数据的偏移量，然后根据偏移量来计算它的位置，偏移1对应ySpace个像素，如果为负值表示在中线下方，如果为正值表示在中线上方
                float point = (-(data - mindData)) * ySpace;// 该点相对于中线的纵坐标
                canvas.drawCircle(x[i], centerHeight + point, radius,
                        pointPaint);// 绘制坐标点
                if (isTextUp) {
                    canvas.drawText(data + "", x[i] - (data + "").length() * 6,
                            centerHeight + point - textHeight / 2, numPaint);// 在上方绘制该点对应的文字信息
                } else {
                    canvas.drawText(data + "", x[i] - (data + "").length() * 6,
                            centerHeight + point + textHeight, numPaint);// 在下方绘制该点对应的文字信息
                }

                if (i != (datas.size() - 1)
                        && datas.get(i + 1) !=NO_DATA) {// 如果该点不是最后一个点，则需要绘制该点到下一个点的连线
                    int nextData = (Integer) datas.get(i + 1);// 获取下一个数据
                    float pointNext = (-(nextData - mindData)) * ySpace;// 该数据相对于中值的偏移量
                    canvas.drawLine(x[i], centerHeight + point, x[i + 1],
                            centerHeight + pointNext, linePaint);
                }
            }
        }
    }

    public int getMaxData(List<Integer> datas) {// 获取这组数据中最大的数据
        int max = datas.get(0);// 默认让第一个数据为最大数
        for (int i = 0; i < datas.size(); i++) {
            if (max < datas.get(i)) {// 如果有数据比最大数大，则将保留该数
                max = datas.get(i);
            }
        }
        return max;
    }

    public int getMinData(List<Integer> datas) {// 获取这组数据中最小的数据
        int min = 1024;// 为最大值
        for (int i = 0; i < datas.size(); i++) {
            int temp = datas.get(i);// 获取每一个数据
            if (temp !=NO_DATA && temp < min) {
                min = temp;
            }
        }
        return min;
    }

    public void initDatas() {// 初始化数据，获取分数与省控线之间的差距，如果不存在则让其为Constants.NO_DATA
        firstDatas = new ArrayList<Integer>();
        secondDatas = new ArrayList<Integer>();
        thirdDatas = new ArrayList<Integer>();
        for (int i = schoolRecruits.size() - 1; i >= 0; i--) {
            int sRecruitHScore = schoolRecruits.get(i).getsRecruitHScore();// 录取最高分
            int controlLine = schoolRecruits.get(i).getControlLine();// 省控线
            int enterLine = schoolRecruits.get(i).getEnterLine();// 投档线
            int sRecruitAScore = schoolRecruits.get(i).getsRecruitAScore();// 录取平均分
            if (controlLine <= 0) {
                firstDatas.add(NO_DATA);
                secondDatas.add(NO_DATA);
                thirdDatas.add(NO_DATA);
            } else {
                if (sRecruitHScore <= 0) {// 如果录取最高分不存在
                    firstDatas.add(NO_DATA);
                } else {
                    firstDatas.add(sRecruitHScore - controlLine);
                }
                if (sRecruitAScore <= 0) {// 如果录取平均分不存在
                    secondDatas.add(NO_DATA);
                } else {
                    secondDatas.add(sRecruitAScore - controlLine);
                }
                if (enterLine <= 0) {// 如果投档线不存在
                    thirdDatas.add(NO_DATA);
                } else {
                    thirdDatas.add(enterLine - controlLine);
                }
            }
        }
        List<Integer> datas = new ArrayList<Integer>();
        datas.addAll(firstDatas);
        datas.addAll(secondDatas);
        datas.addAll(thirdDatas);
        maxData = getMaxData(datas);// 获取所有数据中的最大值
        minData = getMinData(datas);// 获取所有数据中的最小值
        mindData = (maxData + minData) / 2;// 最大值与最小值的平均值，即中间值
    }
}
