package cn.jxufe.iet.code0501.adapter;

import android.content.Context;
import android.text.Html;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import java.util.List;

import cn.jxufe.iet.code0501.R;
import cn.jxufe.iet.code0501.bean.Question;


public class ConsultAdapter extends BaseAdapter {
	private Context context;
	private List<Question> questionList;// 专业录取线列表


	public ConsultAdapter
			(Context context, List<Question> questionList ) {
		// TODO Auto-generated constructor stub
		this.context=context;
		this.questionList=questionList;
	}

	@Override
	public int getCount() {//获取列表数量
		// TODO Auto-generated method stub
		return questionList.size();
	}

	@Override
	public Object getItem(int position) {//获取列表子项
		// TODO Auto-generated method stub
		return questionList;
	}

	@Override
	public long getItemId(int position) {//获取列表项Id
		// TODO Auto-generated method stub
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		// TODO Auto-generated method stub
		ViewHolder holder=new ViewHolder();//实例化ViewHolder对象
		if (convertView == null) {
//将布局转换成View对象
			convertView = LayoutInflater.from(this.context).inflate(R.layout.list_item_question, null, false);

			//关联Id
			holder.contentView=(TextView)convertView.findViewById(R.id.questionContent);
			holder.timeView=(TextView)convertView.findViewById(R.id.questionTime);
			holder.answerView=(TextView) convertView.findViewById(R.id.answer);
			convertView.setTag(holder);
		}else{
			holder = (ViewHolder)convertView.getTag();//取出ViewHolder对象
		}




		//设置对应显示对象
		holder.contentView.setText(position + 1 + "."
				+ questionList.get(position).getQuestionContent());//显示问题内容
		holder.timeView.setText("提问时间：" + questionList.get(position).getAnswerTime());//显示问题时间

		if ("".equals(questionList.get(position).getAnswerTime()) || null == questionList.get(position).getAnswerTime()) {
			holder.answerView.setText("暂无回复");
		} else {
			String[] answers = questionList.get(position).getQuestionContent().split("#");// 将多个回复分割开来
			String[] answerTimes = questionList.get(position).getAnswerTime().split("#");// 将多个回复的时间分割开来
			String answerResult = "";
			for (int i = 0; i < answers.length; i++) {//显示回复内容和时间
				answerResult += "<p><big>" + answers[i]
						+ "</big></p><i><small>回复时间：" + answerTimes[i]
						+ "</small></i>";
			}
			holder.answerView.setText(Html.fromHtml(answerResult));
		}

		return convertView;
	}

	/**存放控件*/
	public final class ViewHolder{
		public TextView contentView;
		public TextView timeView;
		public TextView answerView;

	}
}
