package cn.jxufe.iet.code0501.demo;

import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.view.View;
import android.view.Window;
import android.widget.TabHost;
import android.widget.TextView;

import cn.jxufe.iet.code0501.R;
import cn.jxufe.iet.code0501.fragment.ConsultFragment;
import cn.jxufe.iet.code0501.fragment.ControllineFragment;
import cn.jxufe.iet.code0501.fragment.EnrollScoreFragment;
import cn.jxufe.iet.code0501.fragment.SelfInfoFragment;


public class MainActivity extends FragmentActivity {

    private TabHost mTabHost;
    //选项卡标记
    private String[] tags=new String[]{"page1","page2","page3","page4"};
    private String[] titles=new String[]{"省控线","录取线","报考咨询","个人中心"};
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.activity_main);

        mTabHost=(TabHost) findViewById(R.id.mTabHost);
        mTabHost.setup();
        for(int i=0;i<titles.length;i++){
            TabHost.TabSpec tabSpec=mTabHost.newTabSpec(tags[i]);
            View view=getLayoutInflater().inflate(R.layout.tab, null);
            TextView tv1=(TextView) view.findViewById(R.id.title);
            tv1.setText(titles[i]);
            tabSpec.setIndicator(view);
            tabSpec.setContent(R.id.content);
            mTabHost.addTab(tabSpec);
        }
        mTabHost.setOnTabChangedListener(new MyTabChangedListener());
        mTabHost.setCurrentTab(1);
    }

    private class MyTabChangedListener implements TabHost.OnTabChangeListener {

        public void onTabChanged(String tabId) {
            // TODO Auto-generated method stub
            if(tabId.equals("page1")){
                getSupportFragmentManager().beginTransaction()
                        .replace(R.id.content,new ControllineFragment()).commit();
            }else if(tabId.equals("page2")){
                getSupportFragmentManager().beginTransaction()
                        .replace(R.id.content,new EnrollScoreFragment()).commit();
            }else if(tabId.equals("page3")){
                getSupportFragmentManager().beginTransaction()
                        .replace(R.id.content,new ConsultFragment()).commit();
            }else if(tabId.equals("page4")){
                getSupportFragmentManager().beginTransaction()
                        .replace(R.id.content,new SelfInfoFragment()).commit();
            }
        }

    }
}
