package cn.jxufe.iet.code0501.fragment;

import android.content.DialogInterface;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.support.v7.app.AlertDialog;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;

import java.util.List;

import cn.jxufe.iet.code0501.R;
import cn.jxufe.iet.code0501.adapter.ConsultAdapter;
import cn.jxufe.iet.code0501.bean.Question;
import cn.jxufe.iet.code0501.util.GetService;

/**
 * Created by cd on 2017/1/11.
 */
public class ConsultFragment extends Fragment {
    private ListView questionListView;// 问题列表
    private Button submit, search;// 提交问题按钮、查询按钮
    private String questionString;// 问题字符串
    private EditText contentView;//提交内容编辑框
    private EditText keywordView;//搜索编辑框
    private List<Question> questionList;
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View view=inflater.inflate(R.layout.page3,container,false);

        questionListView = (ListView) view.findViewById(R.id.questionList);// 根据id获取列表控件
        contentView = (EditText) view.findViewById(R.id.content);//获取编辑框按钮id
        submit = (Button)  view.findViewById(R.id.submit);//获取提交按钮Id
        search = (Button)  view.findViewById(R.id.search);// 根据Id找到控件
        keywordView = (EditText)  view.findViewById(R.id.keyword);//获取查询编辑框Id

        GetService getService=new GetService();
        questionList=getService.setQuestionList();

        ConsultAdapter consultAdapter=new ConsultAdapter(getActivity(),questionList);
        questionListView.setAdapter(consultAdapter);
        questionListView.setOnItemLongClickListener(new AdapterView.OnItemLongClickListener() {// 长按某一项进行回复
            @Override
            public boolean onItemLongClick(AdapterView<?> parent,
                                           View view, int position, long id) {
                updateQuestion();
                return false;
            }
        });
        return view;
    }

    public void updateQuestion() {// 更新问题状态
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());//实例化Builder对象
        builder.setTitle("我来回答");
        final EditText answerText = new EditText(getActivity());//实例化EditText对象
        builder.setView(answerText);//把编辑框以View的形式加入对话框
        builder.setPositiveButton("确定", new DialogInterface.OnClickListener() {//设置确定按钮
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
//                String answer = answerText.getText().toString();

                    }
                }
        );
        builder.create().show();// 创建对话框
    }
}
