package cn.jxufe.iet.code0501.fragment;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.text.Html;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;


import java.util.ArrayList;
import java.util.List;

import cn.jxufe.iet.code0501.R;
import cn.jxufe.iet.code0501.adapter.ControlLineAdapter;
import cn.jxufe.iet.code0501.bean.ControlLine;
import cn.jxufe.iet.code0501.util.GetSQLite;
import cn.jxufe.iet.code0501.util.GetService;


/**
 * Created by cd on 2017/1/11.
 */
public class ControllineFragment extends Fragment {
    private Spinner yearSpinner, provinceSpinner, categorySpinner, batchSpinner;//下拉列表控件
    private String[] years = new String[]{"2014", "2013", "2012", "2011", "2010"};// 年份的集合
    private List<String> provinces = new ArrayList<String>();// 省份的集合
    private String[] batchs = new String[]{"不限", "一本", "二本", "三本", "专科", "提前"};
    private String[] categorys = new String[]{"不限", "文史", "理工", "综合类", "艺术类", "体育"};
    private int sourceAreaId, yearId, categoryId, batchId;
    private TextView controlLineTitle;//提示标题

    private List<ControlLine> controlLineList;// 分数线的集合
    private ListView controlLineListView;// 显示分数线的列表
    private GetSQLite dbUtil;
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.page2, container, false);
        yearSpinner = (Spinner) view.findViewById(R.id.yearSpinner);// 年份的下拉列表
        provinceSpinner = (Spinner) view.findViewById(R.id.areaSpinner);// 省份的下拉列表
        categorySpinner = (Spinner) view.findViewById(R.id.categorySpinner);
        batchSpinner = (Spinner) view.findViewById(R.id.batchSpinner);

        controlLineTitle = (TextView) view.findViewById(R.id.controlLineTitle);// 显示结果标题
        controlLineListView = (ListView) view.findViewById(R.id.controlLineList);// 显示查询结

        ArrayAdapter<String> yearAdapter = new ArrayAdapter<String>(
                getActivity(), R.layout.spinner_item_year, years);
        yearSpinner.setAdapter(yearAdapter);

        /*GetSQLite getSQLite = new GetSQLite();
        provinces = getSQLite.setProvince();//获取省份集合*/
        GetSQLite getSQLite=new GetSQLite(getActivity());
        provinces = getSQLite.getField(getActivity(), "select areaName from area");// 获取所有的省份
        ArrayAdapter<String> provincesAdapter = new ArrayAdapter<String>(
                getActivity(), R.layout.spinner_item_year, provinces);
        provinceSpinner.setAdapter(provincesAdapter);

        ArrayAdapter<String> categoryAdapter = new ArrayAdapter<String>(
                getActivity(), R.layout.spinner_item_category, categorys);
        categorySpinner.setAdapter(categoryAdapter);

        categorySpinner.setAdapter(categoryAdapter);
        ArrayAdapter<String> batchAdapter = new ArrayAdapter<String>(
                getActivity(), R.layout.spinner_item_batch, batchs);
        batchSpinner.setAdapter(batchAdapter);

        MyItemSelectedListener itemSelectedListener = new MyItemSelectedListener();
        yearSpinner.setOnItemSelectedListener(itemSelectedListener);
        provinceSpinner.setOnItemSelectedListener(itemSelectedListener);
        categorySpinner.setOnItemSelectedListener(itemSelectedListener);
        batchSpinner.setOnItemSelectedListener(itemSelectedListener);

        provinceSpinner.setSelection(sourceAreaId);
        categorySpinner.setSelection(categoryId);
        batchSpinner.setSelection(batchId);


/*
显示省控线列表
 */
        GetService getService = new GetService();
        controlLineList = getService.setControlLineList();//为controlLineList集合添加集合内容

        ControlLineAdapter controlLineAdapter = new ControlLineAdapter
                (getActivity(), controlLineList);
        controlLineListView.setAdapter(controlLineAdapter);
        return view;
    }

    private class MyItemSelectedListener implements AdapterView.OnItemSelectedListener {
        @Override
        public void onItemSelected(AdapterView<?> parent, View view,
                                   int position, long id) {
            switch (parent.getId()) {
                case R.id.areaSpinner:// 如果是选择省份列表
                    sourceAreaId = position;
                    break;
                case R.id.yearSpinner:// 如果是选择年份列表
                    yearId = position;
                    break;
                case R.id.categorySpinner:// 如果是选择科类列表
                    categoryId = position;
                    break;
                case R.id.batchSpinner:// 如果是选择批次列表
                    batchId = position;
                    break;
                default:
                    break;
            }
/*
设置标题显示
 */
            controlLineTitle.setText(Html.fromHtml("<font color=red><b>"
                    + provinces.get(sourceAreaId)
                    + "</b></font>地区<font color=blue><b>" + years[yearId]
                    + "</b></font>年省控线"));
        }

        @Override
        public void onNothingSelected(AdapterView<?> parent) {

        }
    }
}
