package cn.jxufe.iet.code0501.fragment;

import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.text.Html;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.Spinner;
import android.widget.TextView;


import com.google.gson.Gson;

import java.util.ArrayList;
import java.util.List;

import cn.jxufe.iet.code0501.R;
import cn.jxufe.iet.code0501.adapter.Major_recruitAdapter;
import cn.jxufe.iet.code0501.adapter.School_recruitAdapter;
import cn.jxufe.iet.code0501.bean.MajorRecruit;
import cn.jxufe.iet.code0501.bean.School;
import cn.jxufe.iet.code0501.bean.SchoolRecruit;
import cn.jxufe.iet.code0501.client.ResultActivity;
import cn.jxufe.iet.code0501.util.GetSQLite;
import cn.jxufe.iet.code0501.util.GetService;


/**
 * Created by cd on 2017/1/11.
 */
public class EnrollScoreFragment extends Fragment {
    private Spinner categorySpinner, batchSpinner, sourceAreaSpinner, yearSpinner, schoolSpinner, schoolAreaSpinner;// 类别、批次、生源地、年份、学校、学校省份等列表
    private RadioButton isSearchByMajor;// 是否按专业查询
    private Button searchBtn;// 查询按钮
    private Gson gson = new Gson();
    private String schoolName;// 学校名称，标题上需要显示
    private Button trendBtn;// 生成趋势图按钮
    private TextView titleView;// 显示标题
    private LinearLayout schoolRecruitResultLayout;// 显示学校录取信息的标题
    private LinearLayout majorRecruitResultLayout;// 显示专业录取信息的标题
    private ListView enrollResultView;// 结果列表
    private String[] categories = new String[]{"文史", "理工", "综合类", "艺术类", "体育"};// 类别列表
    private String[] batches = new String[]{"一本", "二本", "三本", "专科", "提前"};// 批次列表
    private String[] years = new String[]{"2014", "2013", "2012", "2011",
            "2010"};// 年份的集合
    private List<String> provinces = new ArrayList<String>();// 省份的集合
    private List<School> schoolList;
    private List<String> schools = new ArrayList<String>();// 学校名称列表

    private int sourceAreaId = 2;// 生源地Id,默认为江西
    private int schoolId = 2;// 选择学校Id
    private int schoolAreaId = 2;
    private int batchId = 1;// 批次id
    private int categoryId = 1;// 科目id
    private int yearId = 1;//年份Id
    private List<SchoolRecruit> schoolRecruits;// 学校录取线列表集合
    private List<MajorRecruit> majorRecruits;// 专业录取线列表集合

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        GetSQLite getSQLite=new GetSQLite(getActivity());
        provinces = getSQLite.getField(getActivity(),
                "select areaName  from area");// 获取所有的省份
        System.out.println("provinces="+provinces);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view=inflater.inflate(R.layout.page1,container,false);
        schoolAreaSpinner = (Spinner) view.findViewById(R.id.schoolAreaSpinner);// 学校所在省份下拉列表
        schoolSpinner = (Spinner) view.findViewById(R.id.schoolSpinner);// 学校下拉列表
        sourceAreaSpinner = (Spinner) view.findViewById(R.id.areaSpinner);// 生源地省份下拉列表
        categorySpinner = (Spinner) view.findViewById(R.id.categorySpinner);// 类别下拉列表
        batchSpinner = (Spinner) view.findViewById(R.id.batchSpinner);// 批次下拉列表
        yearSpinner = (Spinner) view.findViewById(R.id.yearSpinner);// 年份下拉列表
        searchBtn = (Button) view.findViewById(R.id.search);// 搜索按钮
        isSearchByMajor = (RadioButton) view.findViewById(R.id.yes);// 显示专业单选按钮
        titleView = (TextView) view.findViewById(R.id.title_view);// 结果标题控件
        trendBtn = (Button) view.findViewById(R.id.trendBtn);// 生成趋势图的按钮
        enrollResultView = (ListView) view.findViewById(R.id.enrollResultList);// 查询结果的列表
        schoolRecruitResultLayout = (LinearLayout) view.findViewById(R.id.schoolEnrollResultLayout);// 学校录取线结果标题
        majorRecruitResultLayout = (LinearLayout) view.findViewById(R.id.majorEnrollResultLayout);// 专业录取线结果标题


        /*GetSQLite getSQLite=new GetSQLite();//实例化从SQLite查询数据类对象
        provinces=getSQLite.setProvince();//获取省份集合*/
//        provinces=Global.dbUtil.getField(getActivity(),"select areaName from area");

        ArrayAdapter<String> areaAdapter = new ArrayAdapter<String>(getActivity(), R.layout.spinner_item_year, provinces);
        sourceAreaSpinner.setAdapter(areaAdapter);//学校所在地列表
        schoolAreaSpinner.setAdapter(areaAdapter);//生源地所在地列表


        ArrayAdapter<String> categoryAdapter = new ArrayAdapter<String>(
                getActivity(), R.layout.spinner_item_category, categories);
        categorySpinner.setAdapter(categoryAdapter);//科类列表

        ArrayAdapter<String> batchAdapter = new ArrayAdapter<String>(
                getActivity(), R.layout.spinner_item_batch, batches);
        batchSpinner.setAdapter(batchAdapter);//批次列表


        batchSpinner.setSelection(batchId - 1);//默认显示项
        ArrayAdapter<String> yearAdapter = new ArrayAdapter<String>(
                getActivity(), R.layout.spinner_item_year, years);
        yearSpinner.setAdapter(yearAdapter);//年份列表
        yearSpinner.setSelection(years.length - 1);//默认显示项

        MyItemSelectedListener myItemSelectedListener = new MyItemSelectedListener();//实例化事件监听器
        schoolAreaSpinner.setOnItemSelectedListener(myItemSelectedListener);
        schoolSpinner.setOnItemSelectedListener(myItemSelectedListener);
        categorySpinner.setOnItemSelectedListener(myItemSelectedListener);
        batchSpinner.setOnItemSelectedListener(myItemSelectedListener);
        yearSpinner.setOnItemSelectedListener(myItemSelectedListener);
        sourceAreaSpinner.setOnItemSelectedListener(myItemSelectedListener);
        // ATTENTION: This was auto-generated to implement the App Indexing API.
        // See https://g.co/AppIndexing/AndroidStudio for more information.
        searchBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                if (isSearchByMajor.isChecked()) {// 查询学校各专业的录取线
                    showMajorRecruitsResult();
                } else {// 查询学校的录取线
                    showSchoolRecruits();

                }
            }

        });
        trendBtn.setOnClickListener(new View.OnClickListener() {// 生成趋势图的按钮的事件处理
            @Override
            public void onClick(View v) {
                goToShowTrend();// 显示趋势图
            }
        });

        return view;
    }

    public void goToShowTrend() {// 跳转到显示趋势图的页面
        Bundle bundle = new Bundle();
        String schoolRecruitsResult = gson.toJson(schoolRecruits);
        bundle.putString("schoolRecruitsResult", schoolRecruitsResult);// 学校录取线结果信息
        bundle.putString("schoolName", schoolName);// 学校名称
        bundle.putString("batchName",batches[batchId]);// 批次信息
        bundle.putString("categoryName",categories[categoryId]);// 类别信息
        bundle.putString("studentAreaName", provinces.get(sourceAreaId));// 生源地
        Intent intent = new Intent(getActivity(), ResultActivity.class);
        intent.putExtra("bundle", bundle);// 传递数据
        intent.putExtra("fragment", "SchoolRecruitTrendFragment");
        startActivity(intent);// 跳转页面
    }

    private class MyItemSelectedListener implements AdapterView.OnItemSelectedListener {
        @Override
        public void onItemSelected(AdapterView<?> parent, View view,
                                   int position, long id) {
            switch (parent.getId()) {
                case R.id.schoolAreaSpinner:// 如果选择学校所在地
                    schoolAreaId = position;
                    getSchool(provinces.get(schoolAreaId));// 当省份变化时，对应显示的学校都会随之变化
                    break;
                case R.id.areaSpinner:// 如果是选择生源地
                    sourceAreaId = position;
                    break;
                case R.id.categorySpinner:// 如果是选择文理科
                    categoryId = position;// 序号从0开始
                    break;
                case R.id.batchSpinner:// 如果是选择批次
                    batchId = position;
                    break;
                case R.id.schoolSpinner:// 如果是选择学校
//                    schoolId = schoolList.get(position).getSchoolId();// 获取学校Id
                    schoolId = position;// 获取学校名称
                    break;
                case R.id.yearSpinner:
                    yearId = position;
                    break;
                default:
                    break;
            }
        }

        @Override
        public void onNothingSelected(AdapterView<?> parent) {

        }
    }
    public  void getSchool(String areaName){

       //GetSQLite getSQLite =new GetSQLite();
        GetSQLite getSQLite=new GetSQLite(getActivity());
        schoolList=getSQLite.getSchoolsByArea(getActivity(),"select * from school s,area a where s.areaId=a.areaId and a.areaName=?",
                new String[] { areaName });
        schools.clear();//学校名字集合清空
        for (School school : schoolList) {
//            if(school.getAreaName().equals(areaName)){//寻找对应省份的学校
                schools.add(school.getSchoolName());//把数据添加进入学校名字集合
//            }
        }
        ArrayAdapter<String> schoolAdapter = new ArrayAdapter<String>(
               getActivity(), R.layout.spinner_item_year, schools);
        schoolSpinner.setAdapter(schoolAdapter);

    }

    public void showSchoolRecruits() {// 显示学校的录取线信息

        titleView.setText(Html.fromHtml("<font color=blue><b>" + schools.get(schoolAreaId)
                + "</b></font><font color=red><b>"
                + batches[batchId]
                + "</b></font><font color=blue><b>"
                + categories[categoryId]
                + "</b></font>类<br/>在<font color=red><b>"
                + provinces.get(sourceAreaId) + "</b></font>地区历年录取线"));// 标题内容
        schoolRecruitResultLayout.setVisibility(View.VISIBLE);// 显示学校录取线各项标题
        majorRecruitResultLayout.setVisibility(View.GONE);// 专业录取信息标题隐藏
        trendBtn.setVisibility(View.VISIBLE);// 生成趋势图按钮可见
        GetService getService=new GetService();
        schoolRecruits=getService.setSchoolRecruits();
        School_recruitAdapter school_recruitAdapter=new School_recruitAdapter(getActivity(),schoolRecruits);
        enrollResultView.setAdapter(school_recruitAdapter);
    }

    public void showMajorRecruitsResult() {// 显示专业的录取线信息
        trendBtn.setVisibility(View.GONE);// 生成趋势图按钮不可见
        schoolRecruitResultLayout.setVisibility(View.GONE);// 显示学校录取线信息标题
        majorRecruitResultLayout.setVisibility(View.VISIBLE);// 显示专业录取线信息标题
        titleView.setText(Html.fromHtml("<font color=blue><b>" + schools.get(schoolAreaId)
                + "</b></font><font color=red><b>" + years[yearId]
                + "</b></font>年在<br/><font color=blue><b>"
                + provinces.get(sourceAreaId) + "</b></font>地区各专业录取线"));
        GetService getService=new GetService();//实例化从服务端获取数据类
        majorRecruits=getService.setMajorRecruits();//获取专业信息数据
        Major_recruitAdapter major_recruitAdapter=new Major_recruitAdapter(getActivity(),majorRecruits);
        enrollResultView.setAdapter(major_recruitAdapter);

    }
}
