package cn.jxufe.iet.code0501.fragment;

import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.support.v7.app.AlertDialog;
import android.text.Html;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TextView;

import cn.jxufe.iet.code0501.R;


/**
 * Created by cd on 2017/1/11.
 */
public class SelfInfoFragment extends Fragment {
    private Spinner categorySpinner,batchSpinner,sourceAreaSpinner,targetAreaSpinner;
    private String[] years = new String[] { "2014", "2013", "2012", "2011","2010" };// 年份的集合
    private String[] provinces =new String[]{"上海","浙江","江西","北京"};// 省份的集合
    private String[] batches=new String[]{"不限","一本","二本","三本","专科","提前"};//批次集合
    private String[] categories=new String[]{"不限","文史","理工","综合类","艺术类","体育"};//科类集合
    public static int sourceAreaId =2;// 生源地Id,默认为江西
    public static int targetAreaId=2;// 意向省份Id
    public static int batchId = 1;// 批次id
    public static int categoryId = 1;// 科目id
    private SharedPreferences selfInfoPreferences;
    private TextView scoreText,rankText,categoryText,batchText,sourceAreaText,targetAreaText;
    private int score,rank,category,batch;//用于记录对话框选择值
    private Button edit;//便捷按钮
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View view=inflater.inflate(R.layout.page4,container,false);
        selfInfoPreferences=getActivity().getSharedPreferences("selfInfo", Context.MODE_PRIVATE);//读取配置参数
        score=selfInfoPreferences.getInt("score", -1);//设置分数默认值为-1
        rank=selfInfoPreferences.getInt("rank", -1);//设置排名默认值为-1
        category=selfInfoPreferences.getInt("categoryId", 0);//设置科类默认值为-1
        batch=selfInfoPreferences.getInt("batchId", 0);//设置批次默认值为-1
        sourceAreaId=selfInfoPreferences.getInt("sourceAreaId", 0);//设置生源地省份默认值为-1
        targetAreaId=selfInfoPreferences.getInt("targetAreaId",0);//设置目标省份默认值为-1
        boolean isFirst=selfInfoPreferences.getBoolean("isFirst", true);
        //获取组件Id
        scoreText=(TextView)view.findViewById(R.id.scoreText);
        rankText=(TextView)view.findViewById(R.id.rankText);
        categoryText=(TextView)view.findViewById(R.id.categoryText);
        batchText=(TextView)view.findViewById(R.id.batchText);
        sourceAreaText=(TextView)view.findViewById(R.id.sourceAreaText);
        targetAreaText=(TextView)view.findViewById(R.id.targetAreaText);
        if(isFirst){//如果是第一次，则弹出对话框让其填写基本信息
            showDialog();
        }else{//否则直接显示基本信息
            show();
        }

        edit=(Button)view.findViewById(R.id.edit);
        edit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                showDialog();
            }
        });
        return view;
    }
    private void show(){
        if(score!=-1){
            scoreText.setText(Html.fromHtml("高考成绩：<b><font color='red'>"+score+"</font></b>"));
        }else{
            scoreText.setText(Html.fromHtml("高考成绩：<b><font color='red'>暂未提供</font></b>"));
        }
        if(rank!=-1){
            rankText.setText(Html.fromHtml("高考排名：<b><font color='red'>"+rank+"</font></b>"));
        }else{
            rankText.setText(Html.fromHtml("高考排名：<b><font color='red'>暂未提供</font></b>"));
        }
        categoryText.setText(Html.fromHtml("考生类别：<b><font color='red'>"+categories[category]+"</font></b>"));
        batchText.setText(Html.fromHtml("录取批次：<b><font color='red'>"+batches[batch]+"</font></b>"));
        sourceAreaText.setText(Html.fromHtml("生源地：<b><font color='red'>"+provinces[sourceAreaId]+"</font></b>"));
        targetAreaText.setText(Html.fromHtml("意向省份：<b><font color='red'>"+provinces[targetAreaId]+"</font></b>"));
    }


    private class MyItemSelectedListener implements AdapterView.OnItemSelectedListener {
        @Override
        public void onItemSelected(AdapterView<?> parent, View view,
                                   int position, long id) {
            switch (parent.getId()) {
                case R.id.sourceAreaSpinner:// 如果是选择生源地，保存省份的序号，从0开始
                    sourceAreaId = position;
                    break;
                case R.id.categorySpinner:// 如果是选择文理科
                    category= position;
                    break;
                case R.id.batchSpinner:// 如果是选择批次
                    batch = position;
                    break;
                case R.id.targetAreaSpinner://如果是选择意向省份
                    targetAreaId= position;
                    break;
                default:
                    break;
            }
        }

        @Override
        public void onNothingSelected(AdapterView<?> parent) {
        }
    }
    public void showDialog(){//弹出对话框
        AlertDialog.Builder builder=new AlertDialog.Builder(getActivity());
        builder.setTitle("个人基本信息填写");
        View view=getActivity().getLayoutInflater().inflate(R.layout.dialog_self_info_edit, new LinearLayout(getActivity()));
        sourceAreaSpinner = (Spinner) view.findViewById(R.id.sourceAreaSpinner);
        categorySpinner = (Spinner) view.findViewById(R.id.categorySpinner);
        batchSpinner = (Spinner)view.findViewById(R.id.batchSpinner);
        targetAreaSpinner = (Spinner) view.findViewById(R.id.targetAreaSpinner);
        final EditText scoreText = (EditText) view.findViewById(R.id.score);//高考成绩
        final EditText rankText=(EditText)view.findViewById(R.id.rank);//高考排名
        if(score!=-1){
            scoreText.setText("");
        }
        if(rank!=-1){
            rankText.setText("");
        }



        ArrayAdapter<String> areaAdapter = new ArrayAdapter<String>(
                getActivity(), R.layout.spinner_item_year, provinces);
        sourceAreaSpinner.setAdapter(areaAdapter);
        targetAreaSpinner.setAdapter(areaAdapter);
        sourceAreaSpinner.setSelection(sourceAreaId);
        targetAreaSpinner.setSelection(targetAreaId);

        ArrayAdapter<String> categoryAdapter = new ArrayAdapter<String>(
                getActivity(), R.layout.spinner_item_category, categories);
        categorySpinner.setAdapter(categoryAdapter);
        categorySpinner.setSelection(category);// 类型默认为理工

        ArrayAdapter<String> batchAdapter = new ArrayAdapter<String>(
                getActivity(), R.layout.spinner_item_batch, batches);
        batchSpinner.setAdapter(batchAdapter);
        batchSpinner.setSelection(batch);// 批次默认为二本


        MyItemSelectedListener myItemSelectedListener = new MyItemSelectedListener();//实例化事件监听器
        //对Spinner列表进行注册
        sourceAreaSpinner.setOnItemSelectedListener(myItemSelectedListener);
        categorySpinner.setOnItemSelectedListener(myItemSelectedListener);
        batchSpinner.setOnItemSelectedListener(myItemSelectedListener);
        targetAreaSpinner.setOnItemSelectedListener(myItemSelectedListener);

        builder.setView(view);

        builder.setPositiveButton("保存", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                SharedPreferences.Editor editor=selfInfoPreferences.edit();
                editor.putBoolean("isFirst", false);
                String scoreget=scoreText.getText().toString().trim();//获取输入分数
                if("".equals(scoreget)){
                    editor.putInt("score", 0);
                }else{
                    editor.putInt("score", Integer.parseInt(scoreget));//保持编辑分数
                    score= Integer.parseInt(scoreget);
                }
                String rankget=rankText.getText().toString().trim();
                if("".equals(rankget)){
                    editor.putInt("rank", 0);//如果排名没填，设置排名值为0
                }else{
                    editor.putInt("rank", Integer.parseInt(rankget));//保存分排名
                    rank= Integer.parseInt(rankget);
                }
                editor.putInt("categoryId", categoryId);//类别ID
                editor.putInt("batchId",batchId);//批次ID
                editor.putInt("sourceAreaId", sourceAreaId);//生源地ID
                editor.putInt("targetAreaId",targetAreaId);//意向省市ID
                editor.commit();
                show();
            }
        });
        builder.create().show();//创建并显示对话框

    }
}
