package cn.jxufe.iet.code0501.util;

import android.util.Log;

import java.util.ArrayList;
import java.util.List;

import cn.jxufe.iet.code0501.bean.ControlLine;
import cn.jxufe.iet.code0501.bean.MajorRecruit;
import cn.jxufe.iet.code0501.bean.Question;
import cn.jxufe.iet.code0501.bean.SchoolRecruit;


/**
 * Created by ZHG on 2017/01/13.
 * 模拟从SQLite数据库中获取数据类
 */
public class GetService {
    private int[] year=new int[]{2014,2014,2014,2014};
    private String[] categroyString=new String[]{"文史","理工","文史","理工"};
    private String[] batch=new String[]{"一本","一本","二本","专科"};
    private int[] scoreString=new int[]{524,526,390,230};
    private String[] areaNameString=new String[]{"江西","江西","江西","江西"};

    /*设置省控线数据集合，后面服务器端获取数据可以进行替换*/
    public List<ControlLine> setControlLineList(){
        List<ControlLine> list=new ArrayList<ControlLine>();
        for (int i=0;i<4;i++){
            ControlLine controlLine=new ControlLine();
            controlLine.setControlYear(year[i]);
            controlLine.setCategoryName(categroyString[i]);
            controlLine.setBatchName(batch[i]);
            controlLine.setControlLine(scoreString[i]);
            controlLine.setAreaName(areaNameString[i]);
            list.add(controlLine);
        }
        return  list;
    }
    //投档线数据源
    private int[] yearString=new int[]{2014,2013,2012,2011,2010};//年份数组
    private int[] controlLineString=new int[]{524,532,533,511,510};//省控线数组
    private int[] enterLineString=new int[]{521,522,523,501,510};//投档线数组
    private int[] averageScoreString=new int[]{528,532,543,521,520};//平均分数组
    private int[] maxScoreString=new int[]{548,552,553,541,540};//最高分数组


    public List<SchoolRecruit> setSchoolRecruits(){
        List<SchoolRecruit> schoolRe=new ArrayList<>();//实例化集合数组
//        SchoolRecruit[] schoolRecruits=new SchoolRecruit[5];//定义学校投档信息实体数组
        //将数组转换成集合
        for(int i=0;i<5;i++){
            Log.d("tag1", yearString[i]+"");
            SchoolRecruit schoolRecruit=new SchoolRecruit();//定义学校投档信息实体数组
            schoolRecruit.setsRecruitYear(yearString[i]);
            schoolRecruit.setControlLine(controlLineString[i]);
            schoolRecruit.setEnterLine(enterLineString[i]);
            schoolRecruit.setsRecruitAScore(averageScoreString[i]);
            schoolRecruit.setsRecruitHScore(maxScoreString[i]);
            schoolRe.add( schoolRecruit);
        }
        return schoolRe;
    }


    //专业录取线数组

    private String[] majorString=new String[]{"行政管理","护理学","电器信息","历史学","管理科学","临床医学"};//专业数组
    private String[] categoryString=new String[]{"理工","理工","理工","文史","理工","文史"};//省控线数组
    private String[] batchString=new String[]{"一本","一本","一本","一本","一本","一本"};//投档线数组
    private String[] averageScoreStringMaj=new String[]{"528","532","543","521","520","533"};//平均分数组
    private int[] maxScoreStringMaj=new int[]{548,552,553,541,540,566};//最高分数组

    /*
    把专业录取信息数组数据转成集合数据
     */
    public List<MajorRecruit> setMajorRecruits(){
        List<MajorRecruit> majorRe=new ArrayList<>();

        for(int i=0;i<6;i++){
            MajorRecruit majorRecruit=new MajorRecruit();
            majorRecruit.setMajorName(majorString[i]);
            majorRecruit.setCategoryName(categoryString[i]);
            majorRecruit.setBatchName(batchString[i]);
            majorRecruit.setAreaName(averageScoreStringMaj[i]);
            majorRecruit.setmRecruitHScore(maxScoreStringMaj[i]);
            majorRe.add(majorRecruit);
        }
        return majorRe;

    }

    private String[] questionContent=new String[]{"555分报考哪个学下好？","江西哪个学校最好？","今年理工560分能考进江西财经大学吗？"};//问题数组
    private String[] questionTime=new String[]{"2016-1-25 03:55","2016-2-2 13:50","2015-1-1 14:20"};//提问时间数组
    private String[] answerContent=new String[]{"江西财经大学金融学可以的","江西财经大学录取分数最高#南昌大学是211","差不多有些风险#最好的专业进不了"};//回答问题数组
    private String[] answerTime=new String[]{"2016-1-25 06:55","2016-2-2 14:30#2016-2-3 18:30","2015-1-1 16:31#2015-1-2 13:22"};//回复时间数组


    /*
    把问题咨询数组数据转成集合数据
     */
    public List<Question> setQuestionList(){
        List<Question> questionList=new ArrayList<>();

        for(int i=0;i<questionContent.length;i++){
            Question question=new Question();
            question.setQuestionContent(questionContent[i]);
            question.setQuestionTime(questionTime[i]);
            question.setAnswerContent(answerContent[i]);
            question.setAnswerTime(answerTime[i]);
            questionList.add(question);
        }
        return questionList;

    }

}
