/*
Navicat MySQL Data Transfer

Source Server         : localhost
Source Server Version : 50711
Source Host           : localhost:3306
Source Database       : bkt

Target Server Type    : MYSQL
Target Server Version : 50711
File Encoding         : 65001

Date: 2016-07-09 20:28:20
*/

SET FOREIGN_KEY_CHECKS=0;

-- ----------------------------
-- Table structure for area
-- ----------------------------
DROP TABLE IF EXISTS `area`;
CREATE TABLE `area` (
  `areaId` smallint(3) NOT NULL DEFAULT '0',
  `areaName` varchar(10) DEFAULT NULL,
  PRIMARY KEY (`areaId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of area
-- ----------------------------
INSERT INTO `area` VALUES ('3', '上海');
INSERT INTO `area` VALUES ('10', '浙江');
INSERT INTO `area` VALUES ('13', '江西');
INSERT INTO `area` VALUES ('34', '北京');

-- ----------------------------
-- Table structure for batch
-- ----------------------------
DROP TABLE IF EXISTS `batch`;
CREATE TABLE `batch` (
  `batchId` smallint(2) NOT NULL AUTO_INCREMENT,
  `batchName` varchar(10) DEFAULT NULL,
  PRIMARY KEY (`batchId`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of batch
-- ----------------------------
INSERT INTO `batch` VALUES ('1', '一本');
INSERT INTO `batch` VALUES ('2', '二本');
INSERT INTO `batch` VALUES ('3', '三本');
INSERT INTO `batch` VALUES ('4', '专科');
INSERT INTO `batch` VALUES ('5', '提前');

-- ----------------------------
-- Table structure for category
-- ----------------------------
DROP TABLE IF EXISTS `category`;
CREATE TABLE `category` (
  `categoryId` smallint(2) NOT NULL AUTO_INCREMENT,
  `categoryName` varchar(10) DEFAULT NULL,
  PRIMARY KEY (`categoryId`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of category
-- ----------------------------
INSERT INTO `category` VALUES ('1', '文史');
INSERT INTO `category` VALUES ('2', '理工');
INSERT INTO `category` VALUES ('3', '综合');
INSERT INTO `category` VALUES ('4', '艺术类');
INSERT INTO `category` VALUES ('5', '体育类');

-- ----------------------------
-- Table structure for control_line
-- ----------------------------
DROP TABLE IF EXISTS `control_line`;
CREATE TABLE `control_line` (
  `controlId` int(10) NOT NULL,
  `controlLine` smallint(5) DEFAULT NULL,
  `controlYear` smallint(5) DEFAULT NULL,
  `categoryId` smallint(5) NOT NULL DEFAULT '0',
  `batchId` smallint(5) DEFAULT NULL,
  `areaId` smallint(5) DEFAULT NULL,
  PRIMARY KEY (`controlId`),
  KEY `areaId` (`areaId`),
  KEY `batchId` (`batchId`),
  KEY `categoryId` (`categoryId`),
  CONSTRAINT `control_line_ibfk_1` FOREIGN KEY (`areaId`) REFERENCES `area` (`areaId`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `control_line_ibfk_2` FOREIGN KEY (`batchId`) REFERENCES `batch` (`batchId`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `control_line_ibfk_3` FOREIGN KEY (`categoryId`) REFERENCES `category` (`categoryId`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of control_line
-- ----------------------------
INSERT INTO `control_line` VALUES ('224', '400', '2010', '2', '2', '3');
INSERT INTO `control_line` VALUES ('225', '404', '2010', '1', '2', '3');
INSERT INTO `control_line` VALUES ('233', '465', '2010', '2', '1', '3');
INSERT INTO `control_line` VALUES ('235', '464', '2010', '1', '1', '3');
INSERT INTO `control_line` VALUES ('236', '393', '2011', '2', '2', '3');
INSERT INTO `control_line` VALUES ('237', '412', '2011', '1', '2', '3');
INSERT INTO `control_line` VALUES ('243', '462', '2011', '2', '1', '3');
INSERT INTO `control_line` VALUES ('245', '468', '2011', '1', '1', '3');
INSERT INTO `control_line` VALUES ('246', '342', '2012', '2', '2', '3');
INSERT INTO `control_line` VALUES ('247', '379', '2012', '1', '2', '3');
INSERT INTO `control_line` VALUES ('250', '151', '2012', '2', '4', '3');
INSERT INTO `control_line` VALUES ('252', '159', '2012', '1', '4', '3');
INSERT INTO `control_line` VALUES ('253', '423', '2012', '2', '1', '3');
INSERT INTO `control_line` VALUES ('255', '438', '2012', '1', '1', '3');
INSERT INTO `control_line` VALUES ('256', '331', '2013', '2', '2', '3');
INSERT INTO `control_line` VALUES ('257', '403', '2013', '1', '2', '3');
INSERT INTO `control_line` VALUES ('258', '163', '2013', '2', '4', '3');
INSERT INTO `control_line` VALUES ('259', '194', '2013', '1', '4', '3');
INSERT INTO `control_line` VALUES ('260', '405', '2013', '2', '1', '3');
INSERT INTO `control_line` VALUES ('261', '448', '2013', '1', '1', '3');
INSERT INTO `control_line` VALUES ('879', '402', '2010', '2', '2', '10');
INSERT INTO `control_line` VALUES ('880', '459', '2010', '1', '2', '10');
INSERT INTO `control_line` VALUES ('881', '283', '2010', '2', '3', '10');
INSERT INTO `control_line` VALUES ('882', '283', '2010', '1', '3', '10');
INSERT INTO `control_line` VALUES ('888', '551', '2010', '2', '1', '10');
INSERT INTO `control_line` VALUES ('890', '590', '2010', '1', '1', '10');
INSERT INTO `control_line` VALUES ('891', '382', '2011', '2', '2', '10');
INSERT INTO `control_line` VALUES ('892', '431', '2011', '1', '2', '10');
INSERT INTO `control_line` VALUES ('900', '550', '2011', '2', '1', '10');
INSERT INTO `control_line` VALUES ('902', '571', '2011', '1', '1', '10');
INSERT INTO `control_line` VALUES ('903', '433', '2012', '2', '2', '10');
INSERT INTO `control_line` VALUES ('904', '452', '2012', '1', '2', '10');
INSERT INTO `control_line` VALUES ('907', '294', '2012', '2', '4', '10');
INSERT INTO `control_line` VALUES ('909', '249', '2012', '1', '4', '10');
INSERT INTO `control_line` VALUES ('910', '593', '2012', '2', '1', '10');
INSERT INTO `control_line` VALUES ('912', '606', '2012', '1', '1', '10');
INSERT INTO `control_line` VALUES ('913', '438', '2013', '2', '2', '10');
INSERT INTO `control_line` VALUES ('914', '468', '2013', '1', '2', '10');
INSERT INTO `control_line` VALUES ('917', '279', '2013', '2', '4', '10');
INSERT INTO `control_line` VALUES ('918', '271', '2013', '1', '4', '10');
INSERT INTO `control_line` VALUES ('919', '617', '2013', '2', '1', '10');
INSERT INTO `control_line` VALUES ('920', '619', '2013', '1', '1', '10');
INSERT INTO `control_line` VALUES ('1159', '462', '2010', '2', '2', '13');
INSERT INTO `control_line` VALUES ('1160', '479', '2010', '1', '2', '13');
INSERT INTO `control_line` VALUES ('1161', '366', '2010', '2', '3', '13');
INSERT INTO `control_line` VALUES ('1162', '411', '2010', '1', '3', '13');
INSERT INTO `control_line` VALUES ('1168', '515', '2010', '2', '1', '13');
INSERT INTO `control_line` VALUES ('1170', '521', '2010', '1', '1', '13');
INSERT INTO `control_line` VALUES ('1171', '474', '2011', '2', '2', '13');
INSERT INTO `control_line` VALUES ('1172', '484', '2011', '1', '2', '13');
INSERT INTO `control_line` VALUES ('1173', '343', '2011', '2', '3', '13');
INSERT INTO `control_line` VALUES ('1174', '413', '2011', '1', '3', '13');
INSERT INTO `control_line` VALUES ('1175', '200', '2011', '2', '4', '13');
INSERT INTO `control_line` VALUES ('1177', '260', '2011', '1', '4', '13');
INSERT INTO `control_line` VALUES ('1180', '531', '2011', '2', '1', '13');
INSERT INTO `control_line` VALUES ('1182', '532', '2011', '1', '1', '13');
INSERT INTO `control_line` VALUES ('1183', '486', '2012', '2', '2', '13');
INSERT INTO `control_line` VALUES ('1184', '523', '2012', '1', '2', '13');
INSERT INTO `control_line` VALUES ('1185', '378', '2012', '2', '3', '13');
INSERT INTO `control_line` VALUES ('1186', '452', '2012', '1', '3', '13');
INSERT INTO `control_line` VALUES ('1190', '547', '2012', '2', '1', '13');
INSERT INTO `control_line` VALUES ('1192', '570', '2012', '1', '1', '13');
INSERT INTO `control_line` VALUES ('1193', '456', '2013', '2', '2', '13');
INSERT INTO `control_line` VALUES ('1194', '484', '2013', '1', '2', '13');
INSERT INTO `control_line` VALUES ('1195', '406', '2013', '2', '3', '13');
INSERT INTO `control_line` VALUES ('1196', '444', '2013', '1', '3', '13');
INSERT INTO `control_line` VALUES ('1197', '180', '2013', '2', '4', '13');
INSERT INTO `control_line` VALUES ('1198', '180', '2013', '1', '4', '13');
INSERT INTO `control_line` VALUES ('1201', '517', '2013', '2', '1', '13');
INSERT INTO `control_line` VALUES ('1202', '532', '2013', '1', '1', '13');
INSERT INTO `control_line` VALUES ('2815', '441', '2010', '2', '2', '34');
INSERT INTO `control_line` VALUES ('2816', '474', '2010', '1', '2', '34');
INSERT INTO `control_line` VALUES ('2817', '401', '2010', '2', '3', '34');
INSERT INTO `control_line` VALUES ('2818', '439', '2010', '1', '3', '34');
INSERT INTO `control_line` VALUES ('2824', '494', '2010', '2', '1', '34');
INSERT INTO `control_line` VALUES ('2826', '524', '2010', '1', '1', '34');
INSERT INTO `control_line` VALUES ('2827', '435', '2011', '2', '2', '34');
INSERT INTO `control_line` VALUES ('2828', '481', '2011', '1', '2', '34');
INSERT INTO `control_line` VALUES ('2829', '396', '2011', '2', '3', '34');
INSERT INTO `control_line` VALUES ('2830', '443', '2011', '1', '3', '34');
INSERT INTO `control_line` VALUES ('2834', '484', '2011', '2', '1', '34');
INSERT INTO `control_line` VALUES ('2836', '524', '2011', '1', '1', '34');
INSERT INTO `control_line` VALUES ('2837', '433', '2012', '2', '2', '34');
INSERT INTO `control_line` VALUES ('2838', '446', '2012', '1', '2', '34');
INSERT INTO `control_line` VALUES ('2839', '402', '2012', '2', '3', '34');
INSERT INTO `control_line` VALUES ('2840', '416', '2012', '1', '3', '34');
INSERT INTO `control_line` VALUES ('2841', '105', '2012', '2', '4', '34');
INSERT INTO `control_line` VALUES ('2843', '105', '2012', '1', '4', '34');
INSERT INTO `control_line` VALUES ('2844', '477', '2012', '2', '1', '34');
INSERT INTO `control_line` VALUES ('2846', '495', '2012', '1', '1', '34');
INSERT INTO `control_line` VALUES ('2847', '505', '2013', '2', '2', '34');
INSERT INTO `control_line` VALUES ('2848', '494', '2013', '1', '2', '34');
INSERT INTO `control_line` VALUES ('2849', '475', '2013', '2', '3', '34');
INSERT INTO `control_line` VALUES ('2850', '454', '2013', '1', '3', '34');
INSERT INTO `control_line` VALUES ('2853', '550', '2013', '2', '1', '34');
INSERT INTO `control_line` VALUES ('2854', '549', '2013', '1', '1', '34');
INSERT INTO `control_line` VALUES ('2861', '621', '2014', '1', '1', '10');
INSERT INTO `control_line` VALUES ('2864', '597', '2014', '2', '1', '10');
INSERT INTO `control_line` VALUES ('2879', '524', '2014', '1', '1', '13');
INSERT INTO `control_line` VALUES ('2880', '479', '2014', '1', '2', '13');
INSERT INTO `control_line` VALUES ('2881', '450', '2014', '1', '3', '13');
INSERT INTO `control_line` VALUES ('2882', '526', '2014', '2', '1', '13');
INSERT INTO `control_line` VALUES ('2883', '471', '2014', '2', '2', '13');
INSERT INTO `control_line` VALUES ('2884', '438', '2014', '2', '3', '13');
INSERT INTO `control_line` VALUES ('2945', '200', '2014', '1', '4', '13');
INSERT INTO `control_line` VALUES ('2946', '200', '2014', '2', '4', '13');
INSERT INTO `control_line` VALUES ('2947', '565', '2014', '1', '1', '34');
INSERT INTO `control_line` VALUES ('2948', '507', '2014', '1', '2', '34');
INSERT INTO `control_line` VALUES ('2949', '458', '2014', '1', '3', '34');
INSERT INTO `control_line` VALUES ('2950', '543', '2014', '2', '1', '34');
INSERT INTO `control_line` VALUES ('2951', '495', '2014', '2', '2', '34');
INSERT INTO `control_line` VALUES ('2952', '466', '2014', '2', '3', '34');
INSERT INTO `control_line` VALUES ('2995', '485', '2014', '1', '2', '10');
INSERT INTO `control_line` VALUES ('2996', '420', '2014', '2', '2', '10');
INSERT INTO `control_line` VALUES ('3035', '444', '2014', '1', '1', '3');
INSERT INTO `control_line` VALUES ('3036', '390', '2014', '1', '2', '3');
INSERT INTO `control_line` VALUES ('3037', '423', '2014', '2', '1', '3');
INSERT INTO `control_line` VALUES ('3038', '351', '2014', '2', '2', '3');
INSERT INTO `control_line` VALUES ('3065', '292', '2014', '1', '3', '10');
INSERT INTO `control_line` VALUES ('3066', '288', '2014', '2', '3', '10');

-- ----------------------------
-- Table structure for major
-- ----------------------------
DROP TABLE IF EXISTS `major`;
CREATE TABLE `major` (
  `majorId` int(10) NOT NULL,
  `majorName` varchar(50) DEFAULT NULL,
  `majorCode` varchar(20) DEFAULT NULL,
  PRIMARY KEY (`majorId`),
  UNIQUE KEY `majorCode` (`majorCode`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of major
-- ----------------------------
INSERT INTO `major` VALUES ('1', '历史学', '060101');
INSERT INTO `major` VALUES ('2', '工商管理', '120201');
INSERT INTO `major` VALUES ('3', '会计学', '120203');
INSERT INTO `major` VALUES ('4', '中国语言文学', null);
INSERT INTO `major` VALUES ('5', '法学', '030101');
INSERT INTO `major` VALUES ('6', '政治学', null);
INSERT INTO `major` VALUES ('7', '财政学', '020201');
INSERT INTO `major` VALUES ('8', '国际经济与贸易', '020401');
INSERT INTO `major` VALUES ('9', '哲学', '010101');
INSERT INTO `major` VALUES ('10', '英语', '050201');
INSERT INTO `major` VALUES ('11', '新闻传播学', null);
INSERT INTO `major` VALUES ('12', '日语', '050207');
INSERT INTO `major` VALUES ('13', '汉语言文学', '050101');
INSERT INTO `major` VALUES ('14', '社会学', '030301');
INSERT INTO `major` VALUES ('15', '公共管理', null);
INSERT INTO `major` VALUES ('16', '统计学', '071201');
INSERT INTO `major` VALUES ('17', '经济学', '020101');
INSERT INTO `major` VALUES ('18', '国际政治', '030202');
INSERT INTO `major` VALUES ('19', '人类学', '030303');
INSERT INTO `major` VALUES ('20', '政治学与行政学', '030201');
INSERT INTO `major` VALUES ('21', '金融学', '020301');
INSERT INTO `major` VALUES ('22', '法语', '050204');
INSERT INTO `major` VALUES ('23', '财务管理', '120204');
INSERT INTO `major` VALUES ('24', '旅游管理', '120901');
INSERT INTO `major` VALUES ('25', '生物科学', '071001');
INSERT INTO `major` VALUES ('26', '管理科学', '120101');
INSERT INTO `major` VALUES ('27', '临床医学', '100201');
INSERT INTO `major` VALUES ('28', '预防医学', '100401');
INSERT INTO `major` VALUES ('29', '海洋科学', '070701');
INSERT INTO `major` VALUES ('30', '软件工程', '080902');
INSERT INTO `major` VALUES ('31', '土建', null);
INSERT INTO `major` VALUES ('32', '化工与制药', null);
INSERT INTO `major` VALUES ('33', '航空航天', null);
INSERT INTO `major` VALUES ('34', '物理学', '070201');
INSERT INTO `major` VALUES ('35', '材料', null);
INSERT INTO `major` VALUES ('36', '自动化', '080801');
INSERT INTO `major` VALUES ('37', '电子信息工程', '080701');
INSERT INTO `major` VALUES ('38', '计算机科学与技术', '080901');
INSERT INTO `major` VALUES ('39', '数学', null);
INSERT INTO `major` VALUES ('40', '生物工程', '083001');
INSERT INTO `major` VALUES ('41', '博物馆学', null);
INSERT INTO `major` VALUES ('42', '文科试验班', null);
INSERT INTO `major` VALUES ('43', '行政管理', '120402');
INSERT INTO `major` VALUES ('44', '西班牙语', '050205');
INSERT INTO `major` VALUES ('47', '中国语言文学基地班', null);
INSERT INTO `major` VALUES ('48', '广播电视新闻学', null);
INSERT INTO `major` VALUES ('49', '考古学', '060103');
INSERT INTO `major` VALUES ('50', '人文科学试验班', '00156');
INSERT INTO `major` VALUES ('51', '教育学', '040101');
INSERT INTO `major` VALUES ('52', '公共事业管理', '120401');
INSERT INTO `major` VALUES ('54', '图书馆学', '120501');
INSERT INTO `major` VALUES ('55', '城市规划', null);
INSERT INTO `major` VALUES ('56', '应用心理学', '071102');
INSERT INTO `major` VALUES ('57', '社会科学试验班', '00150');
INSERT INTO `major` VALUES ('58', '新闻学', '050301');
INSERT INTO `major` VALUES ('59', '编辑出版学', '050305');
INSERT INTO `major` VALUES ('60', '针灸推拿学', '100502');
INSERT INTO `major` VALUES ('61', '德语', '050203');
INSERT INTO `major` VALUES ('62', '汉语言', '050102');
INSERT INTO `major` VALUES ('63', '对外汉语', null);
INSERT INTO `major` VALUES ('64', '公共关系学', '120409');
INSERT INTO `major` VALUES ('65', '社会工作', '030302');
INSERT INTO `major` VALUES ('66', '中医学', '100501');
INSERT INTO `major` VALUES ('67', '传播学', '050304');
INSERT INTO `major` VALUES ('68', '工业设计', '080205');
INSERT INTO `major` VALUES ('69', '广告学', '050303');
INSERT INTO `major` VALUES ('71', '药学', '100701');
INSERT INTO `major` VALUES ('72', '中西医临床医学', '100601');
INSERT INTO `major` VALUES ('73', '档案学', '120502');
INSERT INTO `major` VALUES ('74', '思想政治教育', '030503');
INSERT INTO `major` VALUES ('75', '中药学', '100801');
INSERT INTO `major` VALUES ('76', '心理学', '071101');
INSERT INTO `major` VALUES ('77', '文科实验班', null);
INSERT INTO `major` VALUES ('78', '市场营销', '120202');
INSERT INTO `major` VALUES ('79', '信息管理与信息系统', '120102');
INSERT INTO `major` VALUES ('80', '过程装备与控制工程', '080206');
INSERT INTO `major` VALUES ('81', '历史学基地班', null);
INSERT INTO `major` VALUES ('83', '材料科学与工程', '080401');
INSERT INTO `major` VALUES ('84', '轻化工程', '081701');
INSERT INTO `major` VALUES ('85', '环境工程', '082502');
INSERT INTO `major` VALUES ('86', '护理学', '101101');
INSERT INTO `major` VALUES ('87', '园林', '090502');
INSERT INTO `major` VALUES ('88', '生物医学工程', '082601');
INSERT INTO `major` VALUES ('89', '电子商务', '120801');
INSERT INTO `major` VALUES ('90', '物流工程', '120602');
INSERT INTO `major` VALUES ('91', '制药工程', '081302');
INSERT INTO `major` VALUES ('92', '数字媒体技术', '080906');
INSERT INTO `major` VALUES ('93', '康复治疗学', '101005');
INSERT INTO `major` VALUES ('94', '机械工程及自动化', null);
INSERT INTO `major` VALUES ('95', '食品科学与工程', '082701');
INSERT INTO `major` VALUES ('96', '信息资源管理', '120503');
INSERT INTO `major` VALUES ('97', '数学与应用数学', '070101');
INSERT INTO `major` VALUES ('98', '城市管理', '120405');
INSERT INTO `major` VALUES ('99', '化学工程与工艺', '081301');
INSERT INTO `major` VALUES ('100', '药学类（中外）', null);
INSERT INTO `major` VALUES ('101', '信息与计算科学', '070102');
INSERT INTO `major` VALUES ('102', '轻工纺织食品', null);
INSERT INTO `major` VALUES ('103', '经济与金融', '020307');
INSERT INTO `major` VALUES ('104', '公共政策学', null);
INSERT INTO `major` VALUES ('105', '建筑学', '082801');
INSERT INTO `major` VALUES ('106', '中医学(针灸推拿英语班)', null);
INSERT INTO `major` VALUES ('107', '车辆工程', '080207');
INSERT INTO `major` VALUES ('108', '系统科学与工程', null);
INSERT INTO `major` VALUES ('109', '材料成型及控制工程', '080203');
INSERT INTO `major` VALUES ('110', '考古', null);
INSERT INTO `major` VALUES ('111', '高分子科学与工程', null);
INSERT INTO `major` VALUES ('112', '交通运输', '081801');
INSERT INTO `major` VALUES ('113', '电气工程及其自动化', '080601');
INSERT INTO `major` VALUES ('114', '中医学(基础医学方向)', null);
INSERT INTO `major` VALUES ('115', '信息工程', '080706');
INSERT INTO `major` VALUES ('116', '电气信息', null);
INSERT INTO `major` VALUES ('117', '中医学(中医方向)', null);
INSERT INTO `major` VALUES ('118', '安全工程', '082901');
INSERT INTO `major` VALUES ('119', '环境科学', '082503');
INSERT INTO `major` VALUES ('120', '物流管理', '120601');
INSERT INTO `major` VALUES ('121', '电子信息科学', null);
INSERT INTO `major` VALUES ('122', '外国语言文学', null);
INSERT INTO `major` VALUES ('123', '电子科学与技术', '080702');
INSERT INTO `major` VALUES ('124', '资源科学与工程', null);
INSERT INTO `major` VALUES ('125', '道路桥梁与渡河工程', '081006');
INSERT INTO `major` VALUES ('126', '人力资源管理', '120206');
INSERT INTO `major` VALUES ('127', '热能与动力工程', null);
INSERT INTO `major` VALUES ('128', '康复治疗学(中西医结合方向)', null);
INSERT INTO `major` VALUES ('129', '土木工程', '081001');
INSERT INTO `major` VALUES ('131', '建筑环境与设备工程', null);
INSERT INTO `major` VALUES ('132', '机械电子工程', '080204');
INSERT INTO `major` VALUES ('134', '工程力学', '080102');
INSERT INTO `major` VALUES ('135', '能源与环境系统工程', '080502');
INSERT INTO `major` VALUES ('136', '劳动与社会保障', '120403');
INSERT INTO `major` VALUES ('137', '中医学(临床方向)', null);
INSERT INTO `major` VALUES ('138', '建筑设施智能技术', null);
INSERT INTO `major` VALUES ('139', '国际商务', '120205');
INSERT INTO `major` VALUES ('140', '电子信息科学与技术', '080714');
INSERT INTO `major` VALUES ('141', '高分子材料与工程', '080407');
INSERT INTO `major` VALUES ('142', '交通建设与装备', null);
INSERT INTO `major` VALUES ('143', '通信工程', '080703');
INSERT INTO `major` VALUES ('144', '电子信息技术及仪器', null);
INSERT INTO `major` VALUES ('145', '微电子制造工程', null);
INSERT INTO `major` VALUES ('146', '工程管理', '120103');
INSERT INTO `major` VALUES ('147', '机械设计制造及其自动化', '080202');
INSERT INTO `major` VALUES ('148', '工业工程', '120701');
INSERT INTO `major` VALUES ('149', '应用物理学', '070202');
INSERT INTO `major` VALUES ('150', '化学', '070301');
INSERT INTO `major` VALUES ('151', '测控技术与仪器', '080301');
INSERT INTO `major` VALUES ('152', '分子科学与工程', '070304');
INSERT INTO `major` VALUES ('153', '给水排水工程', null);
INSERT INTO `major` VALUES ('154', '过程设备与控制工程', null);
INSERT INTO `major` VALUES ('155', '医学检验', null);
INSERT INTO `major` VALUES ('156', '无机非金属材料工程', '080406');
INSERT INTO `major` VALUES ('157', '口腔医学', '100301');
INSERT INTO `major` VALUES ('158', '光信息科学与技术', null);
INSERT INTO `major` VALUES ('159', '翻译', '050261');
INSERT INTO `major` VALUES ('160', '法医学', '100901');
INSERT INTO `major` VALUES ('161', '应用化学', '070302');
INSERT INTO `major` VALUES ('162', '工程物理', '082203');
INSERT INTO `major` VALUES ('163', '蚕学', '090302');
INSERT INTO `major` VALUES ('164', '管理科学与工程', null);
INSERT INTO `major` VALUES ('165', '电气工程与自动化', null);
INSERT INTO `major` VALUES ('166', '生物信息学', '071003');
INSERT INTO `major` VALUES ('167', '能源动力系统及自动化', null);
INSERT INTO `major` VALUES ('168', '广播电视编导', '130305');
INSERT INTO `major` VALUES ('169', '经济管理试验班', '00201');
INSERT INTO `major` VALUES ('170', '光电子技术科学', null);
INSERT INTO `major` VALUES ('171', '医学信息学', null);
INSERT INTO `major` VALUES ('172', '放射医学', '100206');
INSERT INTO `major` VALUES ('173', '交通工程', '081802');
INSERT INTO `major` VALUES ('174', '水利水电工程', '081101');
INSERT INTO `major` VALUES ('175', '教育技术学', '040104');
INSERT INTO `major` VALUES ('176', '交通设备信息工程', null);
INSERT INTO `major` VALUES ('177', '哲学基地班', null);
INSERT INTO `major` VALUES ('178', '房地产经营管理', null);
INSERT INTO `major` VALUES ('179', '麻醉学', '100202');
INSERT INTO `major` VALUES ('180', '理科试验班', '00700');
INSERT INTO `major` VALUES ('181', '农林经济管理', '120301');
INSERT INTO `major` VALUES ('182', '理论与应用力学', '080101');
INSERT INTO `major` VALUES ('183', '工程力学与航天航空工程', null);
INSERT INTO `major` VALUES ('184', '生物技术', '071002');
INSERT INTO `major` VALUES ('185', '机械', null);
INSERT INTO `major` VALUES ('186', '材料物理', '080402');
INSERT INTO `major` VALUES ('187', '医学影像学', '100203');
INSERT INTO `major` VALUES ('188', '数理基础科学', '070103');
INSERT INTO `major` VALUES ('189', '能源动力', null);
INSERT INTO `major` VALUES ('190', '信息安全', '080904');
INSERT INTO `major` VALUES ('191', '制造自动化与测控技术', null);
INSERT INTO `major` VALUES ('192', '给排水科学与工程', '081003');
INSERT INTO `major` VALUES ('193', '计算机软件', null);
INSERT INTO `major` VALUES ('194', '环境科学与工程', '082501');
INSERT INTO `major` VALUES ('195', '制造工程', null);
INSERT INTO `major` VALUES ('196', '光电信息工程', null);
INSERT INTO `major` VALUES ('197', '景观建筑设计', null);
INSERT INTO `major` VALUES ('198', '信息物理工程', null);
INSERT INTO `major` VALUES ('199', '材料科学', null);
INSERT INTO `major` VALUES ('200', '化学工程与工业生物工程', '081305');
INSERT INTO `major` VALUES ('201', '工程造价', '120105');
INSERT INTO `major` VALUES ('202', '微电子学', null);
INSERT INTO `major` VALUES ('203', '文化产业管理', '120210');
INSERT INTO `major` VALUES ('204', '人文科学实验班', null);
INSERT INTO `major` VALUES ('205', '网络工程', '080903');
INSERT INTO `major` VALUES ('206', '船舶与海洋工程', '081901');
INSERT INTO `major` VALUES ('207', '土地资源管理', '120404');
INSERT INTO `major` VALUES ('208', '港口航道与海岸工程', '081103');
INSERT INTO `major` VALUES ('209', '信息显示与光电技术', null);
INSERT INTO `major` VALUES ('210', '应用气象学', '070602');
INSERT INTO `major` VALUES ('211', '汽车服务工程', '080208');
INSERT INTO `major` VALUES ('212', '消防工程', '083102');
INSERT INTO `major` VALUES ('213', '信用管理', '020306');
INSERT INTO `major` VALUES ('214', '工科试验班', '00600');
INSERT INTO `major` VALUES ('215', '生命科学与技术基地班', null);
INSERT INTO `major` VALUES ('216', '材料学', null);
INSERT INTO `major` VALUES ('217', '中医学(骨伤方向)', null);
INSERT INTO `major` VALUES ('218', '大气科学', '070601');
INSERT INTO `major` VALUES ('219', '非织造材料与工程', '081603');
INSERT INTO `major` VALUES ('220', '地理信息系统', null);
INSERT INTO `major` VALUES ('221', '金融工程', '020302');
INSERT INTO `major` VALUES ('222', '园艺', '090102');
INSERT INTO `major` VALUES ('223', '新能源材料与器件', '080414');
INSERT INTO `major` VALUES ('224', '国民经济管理', '020103');
INSERT INTO `major` VALUES ('225', '水利', null);
INSERT INTO `major` VALUES ('226', '食品质量与安全', '082702');
INSERT INTO `major` VALUES ('227', '营养学', null);
INSERT INTO `major` VALUES ('228', '基础医学', '100101');
INSERT INTO `major` VALUES ('229', '冶金工程', '080404');
INSERT INTO `major` VALUES ('230', '科技与创意设计试验班', '00601');
INSERT INTO `major` VALUES ('231', '力学', null);
INSERT INTO `major` VALUES ('232', '地质学', '070901');
INSERT INTO `major` VALUES ('233', '测绘工程', '081201');
INSERT INTO `major` VALUES ('234', '智能科学与技术', '080907');
INSERT INTO `major` VALUES ('235', '地球与空间科学', null);
INSERT INTO `major` VALUES ('236', '生物信息技术', null);
INSERT INTO `major` VALUES ('237', '空间信息与数字技术', '080908');
INSERT INTO `major` VALUES ('238', '遥感科学与技术', '081202');
INSERT INTO `major` VALUES ('239', '药学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('240', '电气信息工程', null);
INSERT INTO `major` VALUES ('241', '医学实验学', null);
INSERT INTO `major` VALUES ('242', '口腔修复工艺学', null);
INSERT INTO `major` VALUES ('243', '历史建筑保护工程', '082804');
INSERT INTO `major` VALUES ('244', '地质学基地班', null);
INSERT INTO `major` VALUES ('245', '纺织工程', '081601');
INSERT INTO `major` VALUES ('246', '印刷工程', '081703');
INSERT INTO `major` VALUES ('247', '逻辑学', '010102');
INSERT INTO `major` VALUES ('248', '景观学', null);
INSERT INTO `major` VALUES ('249', '医学信息工程', '080711');
INSERT INTO `major` VALUES ('250', '高分子材料加工工程', null);
INSERT INTO `major` VALUES ('251', '集成电路设计与集成系统', '080710');
INSERT INTO `major` VALUES ('252', '化学基地班', null);
INSERT INTO `major` VALUES ('253', '生物学基地班', null);
INSERT INTO `major` VALUES ('254', '地质工程', '081401');
INSERT INTO `major` VALUES ('255', '天文学', '070401');
INSERT INTO `major` VALUES ('256', '妇幼保健医学', '100403');
INSERT INTO `major` VALUES ('257', '临床医学与医学技术', null);
INSERT INTO `major` VALUES ('258', '医学信息', null);
INSERT INTO `major` VALUES ('259', '化学生物学', '070303');
INSERT INTO `major` VALUES ('260', '探测制导与控制技术', '082103');
INSERT INTO `major` VALUES ('261', '医学试验班', '00800');
INSERT INTO `major` VALUES ('262', '核工程与核技术', '082201');
INSERT INTO `major` VALUES ('263', '技术科学试验班', '00602');
INSERT INTO `major` VALUES ('264', '自然科学试验班', '00701');
INSERT INTO `major` VALUES ('265', '医学技术', null);
INSERT INTO `major` VALUES ('266', '保险', null);
INSERT INTO `major` VALUES ('267', '卫生检验', null);
INSERT INTO `major` VALUES ('268', '轻工生物技术', null);
INSERT INTO `major` VALUES ('269', '动物医学', '090401');
INSERT INTO `major` VALUES ('270', '朝鲜语', '050209');
INSERT INTO `major` VALUES ('271', '勘查技术与工程', '081402');
INSERT INTO `major` VALUES ('272', '数学基地班', null);
INSERT INTO `major` VALUES ('273', '理科实验班', null);
INSERT INTO `major` VALUES ('274', '测绘', null);
INSERT INTO `major` VALUES ('275', '地理科学', '070501');
INSERT INTO `major` VALUES ('276', '新能源科学与工程', '080503');
INSERT INTO `major` VALUES ('277', '科学教育', '040102');
INSERT INTO `major` VALUES ('278', '粉体材料科学与工程', '080409');
INSERT INTO `major` VALUES ('279', '资源环境与城乡规划管理', null);
INSERT INTO `major` VALUES ('280', '物联网工程', '080905');
INSERT INTO `major` VALUES ('281', '生态学', '071004');
INSERT INTO `major` VALUES ('282', '康复治疗技术(老年管理与服务方向)', null);
INSERT INTO `major` VALUES ('283', '功能材料', '080412');
INSERT INTO `major` VALUES ('284', '医疗美容技术(中医美容方向)', null);
INSERT INTO `major` VALUES ('285', '医学营养(中医营养方向)', null);
INSERT INTO `major` VALUES ('286', '经济学基地班', null);
INSERT INTO `major` VALUES ('287', '医学营养(营养与卫生方向)', null);
INSERT INTO `major` VALUES ('288', '护理(梅陇教学分部)', null);
INSERT INTO `major` VALUES ('289', '护理(中西医结合)', null);
INSERT INTO `major` VALUES ('290', '护理(中外合作)', null);
INSERT INTO `major` VALUES ('291', '建筑节能技术与工程', null);
INSERT INTO `major` VALUES ('292', '地球物理学', '070801');
INSERT INTO `major` VALUES ('293', '俄语', '050202');
INSERT INTO `major` VALUES ('295', '工商管理类（中外）', null);
INSERT INTO `major` VALUES ('296', '水质科学与技术', '082507');
INSERT INTO `major` VALUES ('298', '电子封装技术', '080709');
INSERT INTO `major` VALUES ('299', '基础医学基地班', null);
INSERT INTO `major` VALUES ('300', '贸易经济', '020402');
INSERT INTO `major` VALUES ('301', '外国语言文学类（中外）', null);
INSERT INTO `major` VALUES ('302', '中药制药技术(本部)', null);
INSERT INTO `major` VALUES ('303', '数学基础班', null);
INSERT INTO `major` VALUES ('304', '康复治疗学(中西医结合方向男)', null);
INSERT INTO `major` VALUES ('305', '康复治疗学(中西医结合方向女)', null);
INSERT INTO `major` VALUES ('306', '农业经济管理', null);
INSERT INTO `major` VALUES ('307', '物理学基地班', null);
INSERT INTO `major` VALUES ('308', '中国革命史与中国共产党党史', null);
INSERT INTO `major` VALUES ('309', '轮机工程', '081804');
INSERT INTO `major` VALUES ('310', '金属材料工程', '080405');
INSERT INTO `major` VALUES ('311', '税务', null);
INSERT INTO `major` VALUES ('312', '艺术设计学', '130501');
INSERT INTO `major` VALUES ('313', '海洋生物资源与环境', null);
INSERT INTO `major` VALUES ('314', '港口航道与海洋工程', null);
INSERT INTO `major` VALUES ('315', '工商管理类（中外合作办学）', null);
INSERT INTO `major` VALUES ('316', '工程机械', null);
INSERT INTO `major` VALUES ('317', '材料化学', '080403');
INSERT INTO `major` VALUES ('318', '经济学类（中外）', null);
INSERT INTO `major` VALUES ('322', '戏剧影视文学', '130304');
INSERT INTO `major` VALUES ('323', '水产养殖学', '090601');
INSERT INTO `major` VALUES ('324', '信息对抗技术', '082107');
INSERT INTO `major` VALUES ('325', '数字媒体艺术', '130508');
INSERT INTO `major` VALUES ('326', '光电子材料与器件', null);
INSERT INTO `major` VALUES ('327', '艺术学', null);
INSERT INTO `major` VALUES ('328', '飞行器设计与工程', '082002');
INSERT INTO `major` VALUES ('329', '服装设计与工程', '081602');
INSERT INTO `major` VALUES ('330', '电波传播与天线', '080713');
INSERT INTO `major` VALUES ('331', '影视艺术技术', null);
INSERT INTO `major` VALUES ('332', '飞行器动力工程', '082004');
INSERT INTO `major` VALUES ('334', '地理国情监测', '081204');
INSERT INTO `major` VALUES ('335', '光信息与技术', null);
INSERT INTO `major` VALUES ('336', '导航工程', '081203');
INSERT INTO `major` VALUES ('337', '环境与安全类（中外）', null);
INSERT INTO `major` VALUES ('338', '烹饪与营养教育', '082708');
INSERT INTO `major` VALUES ('339', '商务英语', '050262');
INSERT INTO `major` VALUES ('340', '航天运输与控制', null);
INSERT INTO `major` VALUES ('341', '资源环境与城市规划管理', null);
INSERT INTO `major` VALUES ('342', '海洋工程', null);
INSERT INTO `major` VALUES ('343', '宝石及材料工艺学', '080410');
INSERT INTO `major` VALUES ('344', '临床药学', '100703');
INSERT INTO `major` VALUES ('345', '图书档案学', null);
INSERT INTO `major` VALUES ('346', '世界历史', null);
INSERT INTO `major` VALUES ('347', '植物保护', '090103');
INSERT INTO `major` VALUES ('348', '护理(中西医结合)', null);
INSERT INTO `major` VALUES ('349', '护理(中外合作)', null);
INSERT INTO `major` VALUES ('350', '电气信息类（中外）', null);
INSERT INTO `major` VALUES ('351', '风景园林', '082803');
INSERT INTO `major` VALUES ('352', '艺术设计', null);
INSERT INTO `major` VALUES ('353', '体育经济', null);
INSERT INTO `major` VALUES ('354', '投资学', '020304');
INSERT INTO `major` VALUES ('355', '农学', '090101');
INSERT INTO `major` VALUES ('356', '土建类（中外合作办学）', null);
INSERT INTO `major` VALUES ('357', '会展经济与管理', '120903');
INSERT INTO `major` VALUES ('358', '工程结构分析', null);
INSERT INTO `major` VALUES ('363', '电气信息类（中外合作办学）', null);
INSERT INTO `major` VALUES ('364', '审计学', '120207');
INSERT INTO `major` VALUES ('367', '矿物资源工程', '081505');
INSERT INTO `major` VALUES ('368', '复合材料与工程', '080408');
INSERT INTO `major` VALUES ('369', '外国语言文学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('370', '声学', '070204');
INSERT INTO `major` VALUES ('371', '特殊教育', '040108');
INSERT INTO `major` VALUES ('372', '地球化学', '070902');
INSERT INTO `major` VALUES ('373', '能源经济', '020106');
INSERT INTO `major` VALUES ('374', '酒店管理', '120902');
INSERT INTO `major` VALUES ('375', '工商管理类(中外)', null);
INSERT INTO `major` VALUES ('376', '地面武器机动工程', null);
INSERT INTO `major` VALUES ('377', '武器系统与发射工程', null);
INSERT INTO `major` VALUES ('378', '能源化学工程', '081304');
INSERT INTO `major` VALUES ('379', '项目管理', null);
INSERT INTO `major` VALUES ('380', '资源勘查工程', '081403');
INSERT INTO `major` VALUES ('381', '包装工程', '081702');
INSERT INTO `major` VALUES ('382', '石油工程', '081502');
INSERT INTO `major` VALUES ('384', '理学试验班', null);
INSERT INTO `major` VALUES ('385', '焊接技术与工程', '080411');
INSERT INTO `major` VALUES ('386', '经济学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('387', '环境生态', null);
INSERT INTO `major` VALUES ('388', '动物科学', '090301');
INSERT INTO `major` VALUES ('389', '航海技术', '081803');
INSERT INTO `major` VALUES ('390', '电力工程与管理', null);
INSERT INTO `major` VALUES ('391', '建筑电气与智能化', '081004');
INSERT INTO `major` VALUES ('392', '设施农业科学与工程', '090106');
INSERT INTO `major` VALUES ('393', '农业机械化及其自动化', '082302');
INSERT INTO `major` VALUES ('394', '农产品质量与安全', null);
INSERT INTO `major` VALUES ('395', '农业资源与环境', '090201');
INSERT INTO `major` VALUES ('396', '航空航天工程', '082001');
INSERT INTO `major` VALUES ('397', '草业科学', '090701');
INSERT INTO `major` VALUES ('398', '国际事务', null);
INSERT INTO `major` VALUES ('399', '医学影像技术', '101003');
INSERT INTO `major` VALUES ('400', '医学检验技术', '101001');
INSERT INTO `major` VALUES ('401', '机械类（中外）', null);
INSERT INTO `major` VALUES ('402', '材料科学类（中外）', null);
INSERT INTO `major` VALUES ('403', '生物工程类（中外）', null);
INSERT INTO `major` VALUES ('404', '核物理', '070203');
INSERT INTO `major` VALUES ('405', '社会工作（航海社工）', null);
INSERT INTO `major` VALUES ('406', '法学（海商法方向）', null);
INSERT INTO `major` VALUES ('407', '大气科学基地班', null);
INSERT INTO `major` VALUES ('408', '航运管理', null);
INSERT INTO `major` VALUES ('409', '影视学', null);
INSERT INTO `major` VALUES ('410', '小学教育', '040107');
INSERT INTO `major` VALUES ('411', '外国语言文学（中外）', null);
INSERT INTO `major` VALUES ('412', '核技术', null);
INSERT INTO `major` VALUES ('413', '电磁学与无线技术', null);
INSERT INTO `major` VALUES ('414', '海事管理', '120408');
INSERT INTO `major` VALUES ('415', '资源环境科学', '082506');
INSERT INTO `major` VALUES ('416', '飞行器制造工程', '082003');
INSERT INTO `major` VALUES ('417', '信息科学技术', null);
INSERT INTO `major` VALUES ('418', '生物科学与生物技术', null);
INSERT INTO `major` VALUES ('419', '采矿工程', '081501');
INSERT INTO `major` VALUES ('420', '飞行技术', '081805');
INSERT INTO `major` VALUES ('421', '统计学专业', null);
INSERT INTO `major` VALUES ('422', '飞行器环境与生命保障', null);
INSERT INTO `major` VALUES ('423', '救助与打捞工程', '081807');
INSERT INTO `major` VALUES ('424', '质量与可靠性工程', null);
INSERT INTO `major` VALUES ('425', '传感网技术', null);
INSERT INTO `major` VALUES ('426', '城市地下空间工程', '081005');
INSERT INTO `major` VALUES ('427', '电磁场与无线技术', '080712');
INSERT INTO `major` VALUES ('428', '学前教育', '040106');
INSERT INTO `major` VALUES ('429', '机械类（中外合作办学）', null);
INSERT INTO `major` VALUES ('433', '管理科学与工程类（中外）', null);
INSERT INTO `major` VALUES ('434', '商务策划管理', null);
INSERT INTO `major` VALUES ('435', '边防管理', '030603');
INSERT INTO `major` VALUES ('436', '知识产权', '030102');
INSERT INTO `major` VALUES ('437', '油气储运工程', '081504');
INSERT INTO `major` VALUES ('438', '药物制剂', '100702');
INSERT INTO `major` VALUES ('439', '光信息科技学与技术', null);
INSERT INTO `major` VALUES ('440', '电力工程及其自动化', null);
INSERT INTO `major` VALUES ('441', '矿物加工工程', '081503');
INSERT INTO `major` VALUES ('442', '真空电子技术', null);
INSERT INTO `major` VALUES ('443', '环保设备工程', '082505');
INSERT INTO `major` VALUES ('444', '木材科学与工程', '082402');
INSERT INTO `major` VALUES ('445', '水文与水资源工程', '081102');
INSERT INTO `major` VALUES ('449', '文物保护技术', '060105');
INSERT INTO `major` VALUES ('450', '国际文化贸易', null);
INSERT INTO `major` VALUES ('451', '媒体创意', null);
INSERT INTO `major` VALUES ('452', '船舶电子电气工程', '081808');
INSERT INTO `major` VALUES ('453', '工商管理（营销管理）', null);
INSERT INTO `major` VALUES ('454', '海洋技术', '070702');
INSERT INTO `major` VALUES ('458', '广播电视工程', '080707');
INSERT INTO `major` VALUES ('459', '能源工程及自动化', null);
INSERT INTO `major` VALUES ('465', '资源循环科学与工程', '081303');
INSERT INTO `major` VALUES ('466', '新媒体与信息网络', null);
INSERT INTO `major` VALUES ('467', '水务工程', '081104');
INSERT INTO `major` VALUES ('468', '数字游戏设计', null);
INSERT INTO `major` VALUES ('469', '录音艺术', '130308');
INSERT INTO `major` VALUES ('470', '环境与安全', null);
INSERT INTO `major` VALUES ('471', '葡萄牙语', '050232');
INSERT INTO `major` VALUES ('472', '武器', null);
INSERT INTO `major` VALUES ('476', '摄影', '130404');
INSERT INTO `major` VALUES ('477', '社会体育', null);
INSERT INTO `major` VALUES ('478', '武器系统与工程', '082101');
INSERT INTO `major` VALUES ('479', '纳米材料与技术', '080413');
INSERT INTO `major` VALUES ('480', '资产评估', '120208');
INSERT INTO `major` VALUES ('481', '意大利语', '050238');
INSERT INTO `major` VALUES ('482', '历史学（师范类）', null);
INSERT INTO `major` VALUES ('483', '城乡规划', '082802');
INSERT INTO `major` VALUES ('484', '农学（生物育种方向）', null);
INSERT INTO `major` VALUES ('485', '仪器仪表', null);
INSERT INTO `major` VALUES ('486', '地理信息科学', '070504');
INSERT INTO `major` VALUES ('495', '海洋渔业科学与技术', '090602');
INSERT INTO `major` VALUES ('496', '化学（师范类）', null);
INSERT INTO `major` VALUES ('498', '广播电视学', '050302');
INSERT INTO `major` VALUES ('499', '教育学（师范类）', null);
INSERT INTO `major` VALUES ('500', '智能电网信息工程', '080602');
INSERT INTO `major` VALUES ('501', '编辑出版', null);
INSERT INTO `major` VALUES ('502', '外国语言文学类(中外)', null);
INSERT INTO `major` VALUES ('503', '经济学类(中外)', null);
INSERT INTO `major` VALUES ('504', '管理科学与工程类(中外)', null);
INSERT INTO `major` VALUES ('505', '机械类(中外)', null);
INSERT INTO `major` VALUES ('506', '葡萄与葡萄酒工程', '082706');
INSERT INTO `major` VALUES ('507', '保险学', '020303');
INSERT INTO `major` VALUES ('508', '金融学（国际金融）', null);
INSERT INTO `major` VALUES ('509', '医疗器械工程', null);
INSERT INTO `major` VALUES ('510', '农业水利工程', '082305');
INSERT INTO `major` VALUES ('511', '工商管理类', '1202');
INSERT INTO `major` VALUES ('512', '公共事业管理（城市管理方向）', null);
INSERT INTO `major` VALUES ('513', '数字印刷', null);
INSERT INTO `major` VALUES ('514', '阿拉伯语', '050206');
INSERT INTO `major` VALUES ('522', '刑事科学技术', '083101');
INSERT INTO `major` VALUES ('523', '给排水工程', null);
INSERT INTO `major` VALUES ('524', '文秘教育', null);
INSERT INTO `major` VALUES ('525', '禁毒学', '030604');
INSERT INTO `major` VALUES ('526', '空间科学与技术', '070802');
INSERT INTO `major` VALUES ('527', '英语（法律经贸方向）', null);
INSERT INTO `major` VALUES ('528', '农村区域发展', '120302');
INSERT INTO `major` VALUES ('529', '公共关系文学', null);
INSERT INTO `major` VALUES ('530', '农业工程', '082301');
INSERT INTO `major` VALUES ('533', '植物生产', null);
INSERT INTO `major` VALUES ('537', '标准化工程', '120702');
INSERT INTO `major` VALUES ('538', '人文教育', '040103');
INSERT INTO `major` VALUES ('539', '产品质量工程', null);
INSERT INTO `major` VALUES ('540', '风能与动力工程', null);
INSERT INTO `major` VALUES ('541', '运动人体科学', '040205');
INSERT INTO `major` VALUES ('547', '海洋油气工程', '081506');
INSERT INTO `major` VALUES ('548', '侦查学', '030602');
INSERT INTO `major` VALUES ('549', '外交学', '030203');
INSERT INTO `major` VALUES ('551', '电气工程与管理', null);
INSERT INTO `major` VALUES ('561', '捷克语-斯洛伐克语', null);
INSERT INTO `major` VALUES ('562', '罗马尼亚语', '050231');
INSERT INTO `major` VALUES ('571', '商品学', null);
INSERT INTO `major` VALUES ('572', '物业管理', '120209');
INSERT INTO `major` VALUES ('575', '药事管理', '100704');
INSERT INTO `major` VALUES ('578', '知识产权法', null);
INSERT INTO `major` VALUES ('590', '环境资源与发展经济学', null);
INSERT INTO `major` VALUES ('597', '家政学', '030305');
INSERT INTO `major` VALUES ('610', '化学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('647', '种子科学与工程', '090105');
INSERT INTO `major` VALUES ('676', '机械设计制造及自动化', null);
INSERT INTO `major` VALUES ('696', '光信息科技与技术', null);
INSERT INTO `major` VALUES ('712', '辐射防护与环境工程', null);
INSERT INTO `major` VALUES ('716', '核安全工程', null);
INSERT INTO `major` VALUES ('720', '财务会计教育', '120213');
INSERT INTO `major` VALUES ('721', '应用电子技术教育', '080716');
INSERT INTO `major` VALUES ('722', '核化工与核燃料工程', '082204');
INSERT INTO `major` VALUES ('723', '核反应堆工程', null);
INSERT INTO `major` VALUES ('728', '特种能源工程与烟火技术', null);
INSERT INTO `major` VALUES ('729', '地矿', null);
INSERT INTO `major` VALUES ('730', '弹药工程与爆炸技术', '082104');
INSERT INTO `major` VALUES ('731', '动植物检疫', '090403');
INSERT INTO `major` VALUES ('732', '体育装备工程', null);
INSERT INTO `major` VALUES ('733', '历史学基础', null);
INSERT INTO `major` VALUES ('734', '宗教学', '010103');
INSERT INTO `major` VALUES ('735', '韩国语', null);
INSERT INTO `major` VALUES ('736', '民族学', '030401');
INSERT INTO `major` VALUES ('737', '中药资源与开发', '100802');
INSERT INTO `major` VALUES ('738', '烟草', '090108');
INSERT INTO `major` VALUES ('739', '中国少数民族语言文学', '050104');
INSERT INTO `major` VALUES ('741', '交通运输（汽车运用工程）', null);
INSERT INTO `major` VALUES ('749', '植物科学与技术', '090104');
INSERT INTO `major` VALUES ('750', '经济学专业', null);
INSERT INTO `major` VALUES ('757', '环境工程专业', null);
INSERT INTO `major` VALUES ('758', '秘书学', '050107');
INSERT INTO `major` VALUES ('759', '水土保持与荒漠化防治', '090203');
INSERT INTO `major` VALUES ('760', '资源环境与城乡规化管理', null);
INSERT INTO `major` VALUES ('763', '森林资源保护与游憩', null);
INSERT INTO `major` VALUES ('766', '信息与计算科学专业', null);
INSERT INTO `major` VALUES ('767', '生物技术专业', null);
INSERT INTO `major` VALUES ('768', '航海技术专业', null);
INSERT INTO `major` VALUES ('769', '轮机工程专业', null);
INSERT INTO `major` VALUES ('770', '海洋渔业科学与技术专业', null);
INSERT INTO `major` VALUES ('771', '食品科学与安全', null);
INSERT INTO `major` VALUES ('772', '船舶与海洋工程专业', null);
INSERT INTO `major` VALUES ('776', '地球信息科学与技术', '070903');
INSERT INTO `major` VALUES ('780', '劳动关系', '120211');
INSERT INTO `major` VALUES ('794', '林学', '090501');
INSERT INTO `major` VALUES ('799', '煤及煤层气工程', null);
INSERT INTO `major` VALUES ('800', '古典文献', null);
INSERT INTO `major` VALUES ('801', '物理应用化学', null);
INSERT INTO `major` VALUES ('805', '地下水科学与工程', '081404');
INSERT INTO `major` VALUES ('830', '机械设计与制造', null);
INSERT INTO `major` VALUES ('831', '总图设计与工业运输', null);
INSERT INTO `major` VALUES ('846', '空间工程', null);
INSERT INTO `major` VALUES ('848', '飞行器系统与工程', null);
INSERT INTO `major` VALUES ('850', '指挥自动化工程', null);
INSERT INTO `major` VALUES ('851', '仿真工程', null);
INSERT INTO `major` VALUES ('852', '军用光电工程', null);
INSERT INTO `major` VALUES ('853', '电子工程', null);
INSERT INTO `major` VALUES ('854', '应用数学', null);
INSERT INTO `major` VALUES ('855', '管理工程', null);
INSERT INTO `major` VALUES ('856', '系统工程', null);
INSERT INTO `major` VALUES ('857', '外国语言文学（外国军事）', null);
INSERT INTO `major` VALUES ('858', '工程兵指挥', null);
INSERT INTO `major` VALUES ('859', '导弹工程', null);
INSERT INTO `major` VALUES ('860', '历史学（文化遗产）', null);
INSERT INTO `major` VALUES ('861', '管理工程', null);
INSERT INTO `major` VALUES ('862', '指挥自动化工程', null);
INSERT INTO `major` VALUES ('863', '仿真工程', null);
INSERT INTO `major` VALUES ('864', '市场营销(国际物流)', null);
INSERT INTO `major` VALUES ('865', '应用物理学', null);
INSERT INTO `major` VALUES ('866', '信息工程', null);
INSERT INTO `major` VALUES ('872', '网络工程', null);
INSERT INTO `major` VALUES ('875', '应用数学', null);
INSERT INTO `major` VALUES ('876', '计算机科学与技术', null);
INSERT INTO `major` VALUES ('877', '军用光电工程', null);
INSERT INTO `major` VALUES ('878', '机械工程及自动化', null);
INSERT INTO `major` VALUES ('879', '空间工程', null);
INSERT INTO `major` VALUES ('880', '通信工程', null);
INSERT INTO `major` VALUES ('881', '英语（国际商务英语、英美文化）', null);
INSERT INTO `major` VALUES ('882', '应用化学', null);
INSERT INTO `major` VALUES ('883', '飞行器系统与工程', null);
INSERT INTO `major` VALUES ('884', '电子工程', null);
INSERT INTO `major` VALUES ('885', '档案学（信息开发）', null);
INSERT INTO `major` VALUES ('892', '网络与新媒体', '050306');
INSERT INTO `major` VALUES ('893', '电气工程及自动化', null);
INSERT INTO `major` VALUES ('929', '农业电气化与自动化', null);
INSERT INTO `major` VALUES ('931', '人文地理与城乡规划', '070503');
INSERT INTO `major` VALUES ('932', '建筑环境与能源应用工程', '081002');
INSERT INTO `major` VALUES ('965', '生物安全', null);
INSERT INTO `major` VALUES ('973', '粮食工程', '082703');
INSERT INTO `major` VALUES ('974', '生物功能材料', null);
INSERT INTO `major` VALUES ('978', '轻工业纺织食品', null);
INSERT INTO `major` VALUES ('979', '轻工纺织食品类（中外）', null);
INSERT INTO `major` VALUES ('980', '生物科学类（中外）', null);
INSERT INTO `major` VALUES ('981', '林产化工', '082403');
INSERT INTO `major` VALUES ('996', '野生动物与自然保护区管理', '090202');
INSERT INTO `major` VALUES ('999', '森林资源与保护游憩', null);
INSERT INTO `major` VALUES ('1000', '草业科学类（中外）', null);
INSERT INTO `major` VALUES ('1014', '动物生物技术', null);
INSERT INTO `major` VALUES ('1015', '动画', '130310');
INSERT INTO `major` VALUES ('1016', '草业科学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('1017', '森林资源', null);
INSERT INTO `major` VALUES ('1041', '印地语', '050213');
INSERT INTO `major` VALUES ('1049', '茶学', '090107');
INSERT INTO `major` VALUES ('1063', '泰语', '050220');
INSERT INTO `major` VALUES ('1064', '材料科学与工程　', null);
INSERT INTO `major` VALUES ('1065', '海洋工程类（中外）', null);
INSERT INTO `major` VALUES ('1071', '材料化学　', null);
INSERT INTO `major` VALUES ('1072', '微电子学　', null);
INSERT INTO `major` VALUES ('1073', '酿酒工程', '082705');
INSERT INTO `major` VALUES ('1074', '水声工程', '080708');
INSERT INTO `major` VALUES ('1075', '行政管理（中英文秘书方向）', null);
INSERT INTO `major` VALUES ('1076', '人力资源管理（旅游人力资源管理方向）', null);
INSERT INTO `major` VALUES ('1103', '安全技术', null);
INSERT INTO `major` VALUES ('1128', '斯瓦希里语', '050225');
INSERT INTO `major` VALUES ('1213', '公安管理学', '030612');
INSERT INTO `major` VALUES ('1225', '公安情报学', '030610');
INSERT INTO `major` VALUES ('1226', '犯罪学', '030611');
INSERT INTO `major` VALUES ('1227', '涉外警务', '030613');
INSERT INTO `major` VALUES ('1228', '交通管理工程', '083103');
INSERT INTO `major` VALUES ('1229', '治安学', '030601');
INSERT INTO `major` VALUES ('1230', '安全防范工程', '083104');
INSERT INTO `major` VALUES ('1231', '海洋药学', '100707');
INSERT INTO `major` VALUES ('1234', '基础药学基地班', null);
INSERT INTO `major` VALUES ('1240', '公安学', null);
INSERT INTO `major` VALUES ('1241', '药物化学', '100706');
INSERT INTO `major` VALUES ('1242', '生物制药', '083002');
INSERT INTO `major` VALUES ('1243', '药物分析', '100705');
INSERT INTO `major` VALUES ('1244', '中药制药', '100805');
INSERT INTO `major` VALUES ('1247', '运动康复与健康', null);
INSERT INTO `major` VALUES ('1248', '眼视光学', '101004');
INSERT INTO `major` VALUES ('1329', '连锁经营管理', null);
INSERT INTO `major` VALUES ('1346', '管理科学（东方管理）', null);
INSERT INTO `major` VALUES ('1356', '机械工程', '080201');
INSERT INTO `major` VALUES ('1362', '力学基地班', null);
INSERT INTO `major` VALUES ('1363', '中医', null);
INSERT INTO `major` VALUES ('1372', '光源与照明', '080603');
INSERT INTO `major` VALUES ('1375', '雷电防护科学与技术', null);
INSERT INTO `major` VALUES ('1376', '交通运输类', '0818');
INSERT INTO `major` VALUES ('1382', '资源勘察工程', null);
INSERT INTO `major` VALUES ('1413', '食品经济管理', null);
INSERT INTO `major` VALUES ('1414', '水族科学与技术', '090603');
INSERT INTO `major` VALUES ('1416', '海洋管理', null);
INSERT INTO `major` VALUES ('1424', '音乐学', '130202');
INSERT INTO `major` VALUES ('1446', '商务管理', null);
INSERT INTO `major` VALUES ('1451', '汉语国际教育', '050103');
INSERT INTO `major` VALUES ('1477', '法学类(中外合作办学)', '0301H');
INSERT INTO `major` VALUES ('1491', '通信工程专业', null);
INSERT INTO `major` VALUES ('1534', '交通运输类（中外合作办学）', null);
INSERT INTO `major` VALUES ('1541', '给水排水科学与工程', null);
INSERT INTO `major` VALUES ('1556', '国内安全保卫', '030614');
INSERT INTO `major` VALUES ('1564', '机电一体化技术', '580201');
INSERT INTO `major` VALUES ('1565', '会计电算化', '620204');
INSERT INTO `major` VALUES ('1566', '应用韩语', '660107');
INSERT INTO `major` VALUES ('1567', '工程造价', '560502');
INSERT INTO `major` VALUES ('1569', '旅游管理', '640101');
INSERT INTO `major` VALUES ('1570', '建筑工程技术', '560301');
INSERT INTO `major` VALUES ('1571', '汽车检测与维修技术', '580402');
INSERT INTO `major` VALUES ('1572', '投资与理财', '620111');
INSERT INTO `major` VALUES ('1573', '会计', '620203');
INSERT INTO `major` VALUES ('1579', '物流管理', '620505');
INSERT INTO `major` VALUES ('1581', '水产养殖技术', '510401');
INSERT INTO `major` VALUES ('1582', '汽车技术服务与营销', '580405');
INSERT INTO `major` VALUES ('1583', '市场营销', '620401');
INSERT INTO `major` VALUES ('1596', '精神医学', '100205');
INSERT INTO `major` VALUES ('1597', '数控设备应用与维护', '580302');
INSERT INTO `major` VALUES ('1598', '商务英语', '660108');
INSERT INTO `major` VALUES ('1602', '电子商务', '620405');
INSERT INTO `major` VALUES ('1604', '卫生监督', '100404');
INSERT INTO `major` VALUES ('1605', '食品加工技术', '610301');
INSERT INTO `major` VALUES ('1606', '应用电子技术', '590202');
INSERT INTO `major` VALUES ('1632', '建筑装饰工程技术', '560102');
INSERT INTO `major` VALUES ('1633', '计算机多媒体技术', '590103');
INSERT INTO `major` VALUES ('1661', '环境监测与治理技术', '600101');
INSERT INTO `major` VALUES ('1662', '食品营养与检测', '610302');
INSERT INTO `major` VALUES ('1663', '酒店管理', '640106');
INSERT INTO `major` VALUES ('1664', '园艺技术', '510105');
INSERT INTO `major` VALUES ('1665', '汽车电子技术', '580403');
INSERT INTO `major` VALUES ('1666', '计算机网络技术', '590102');
INSERT INTO `major` VALUES ('1667', '生物技术及应用', '530101');
INSERT INTO `major` VALUES ('1668', '稀土工程', null);
INSERT INTO `major` VALUES ('1669', '数控技术', '580103');
INSERT INTO `major` VALUES ('1670', '会计与统计核算', '620205');
INSERT INTO `major` VALUES ('1671', '电气自动化技术', '580202');
INSERT INTO `major` VALUES ('1672', '工商企业管理', '620501');
INSERT INTO `major` VALUES ('1673', '计算机应用技术', '590101');
INSERT INTO `major` VALUES ('1674', '冶金技术', '550102');
INSERT INTO `major` VALUES ('1675', '建筑设计技术', '560101');
INSERT INTO `major` VALUES ('1676', '汽车整形技术（美容与装潢方向）', null);
INSERT INTO `major` VALUES ('1677', '文秘', '660112');
INSERT INTO `major` VALUES ('1679', '模具设计与制造', '580106');
INSERT INTO `major` VALUES ('1680', '国际商务', '620305');
INSERT INTO `major` VALUES ('1681', '道路桥梁工程技术', '520108');
INSERT INTO `major` VALUES ('1682', '软件技术', '590108');
INSERT INTO `major` VALUES ('1695', '动漫设计与制作', '590110');
INSERT INTO `major` VALUES ('1696', '物业管理', '560702');
INSERT INTO `major` VALUES ('1755', '森林工程', '082401');
INSERT INTO `major` VALUES ('1785', '景区开发与管理', '640105');
INSERT INTO `major` VALUES ('1807', '语文教育', '660201');
INSERT INTO `major` VALUES ('1808', '税务', '620102');
INSERT INTO `major` VALUES ('1809', '广告设计与制作', '670112');
INSERT INTO `major` VALUES ('1810', '工程监理', '560504');
INSERT INTO `major` VALUES ('1811', '高分子材料工程', null);
INSERT INTO `major` VALUES ('1812', '文化市场经营与管理', '660115');
INSERT INTO `major` VALUES ('1813', '英语教育', '660203');
INSERT INTO `major` VALUES ('1815', '物流管理（中外合作办学）', null);
INSERT INTO `major` VALUES ('1816', '食品贮运与营销', '610303');
INSERT INTO `major` VALUES ('1817', '涉外旅游', '640102');
INSERT INTO `major` VALUES ('1818', '汽车检测与维修技术（中外合作办学）', null);
INSERT INTO `major` VALUES ('1819', '建筑设备工程技术（暖通空调方向）', null);
INSERT INTO `major` VALUES ('1820', '渔业综合技术', '510404');
INSERT INTO `major` VALUES ('1821', '税务（税务会计方向）', null);
INSERT INTO `major` VALUES ('1822', '环境监测与治理技术（工业分析方向）', null);
INSERT INTO `major` VALUES ('1823', '英语教育（师范类）', null);
INSERT INTO `major` VALUES ('1824', '语文教育（师范类）', null);
INSERT INTO `major` VALUES ('1825', '旅游管理（中外合作办学）', null);
INSERT INTO `major` VALUES ('1826', '工程测量与监理', '540602');
INSERT INTO `major` VALUES ('1827', '建筑设备工程技术', '560401');
INSERT INTO `major` VALUES ('1828', '服装设计', '610204');
INSERT INTO `major` VALUES ('1829', '软件外包服务', '590125');
INSERT INTO `major` VALUES ('1830', '连锁经营管理', '620504');
INSERT INTO `major` VALUES ('1855', '广告设计与制作(摄影摄像方向)', null);
INSERT INTO `major` VALUES ('1856', '服装设计(服装表演方向)', null);
INSERT INTO `major` VALUES ('1859', '环境艺术设计', '560105');
INSERT INTO `major` VALUES ('1860', '艺术设计', '670101');
INSERT INTO `major` VALUES ('1861', '工业设计（理工类）', null);
INSERT INTO `major` VALUES ('1871', '海关管理', '120406');
INSERT INTO `major` VALUES ('1939', '五年制本科中医学专业', null);
INSERT INTO `major` VALUES ('1940', '五年制本科预防医学专业', null);
INSERT INTO `major` VALUES ('1941', '五年制本科临床医学专业', null);
INSERT INTO `major` VALUES ('1942', '七年制临床医学专业', null);
INSERT INTO `major` VALUES ('1943', '七年制口腔医学专业', null);
INSERT INTO `major` VALUES ('1944', ' 五年制本科口腔医学专业', null);
INSERT INTO `major` VALUES ('1945', '七年制临床医学专业（儿科医学专业方向）', null);
INSERT INTO `major` VALUES ('1946', '五年制本科基础医学专业', null);
INSERT INTO `major` VALUES ('1969', '五年制本科临床药学专业', null);
INSERT INTO `major` VALUES ('1977', '四年制本科假肢矫形工程专业', null);
INSERT INTO `major` VALUES ('1978', '临床医学（平谷区定向）', null);
INSERT INTO `major` VALUES ('1979', '临床医学（儿科医学方向）', null);
INSERT INTO `major` VALUES ('1980', '临床医学（密云县定向）', null);
INSERT INTO `major` VALUES ('1999', '护理学（中外合作办学）', null);
INSERT INTO `major` VALUES ('2000', '临床医学（门头沟区定向）', null);
INSERT INTO `major` VALUES ('2001', '临床医学（通州区定向）', null);
INSERT INTO `major` VALUES ('2002', '临床医学（延庆县定向）', null);
INSERT INTO `major` VALUES ('2003', '临床医学（昌平区定向）', null);
INSERT INTO `major` VALUES ('2004', '临床医学（五年制）', null);
INSERT INTO `major` VALUES ('2005', 'jsyx22', null);
INSERT INTO `major` VALUES ('2006', '四年制本科护理学专业', null);
INSERT INTO `major` VALUES ('2007', '护理学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('2017', '临床医学（基地本科班）', null);
INSERT INTO `major` VALUES ('2022', 'jsyx88', null);
INSERT INTO `major` VALUES ('2134', '信息管理与信息系统专业', null);
INSERT INTO `major` VALUES ('2135', '临床医学专业', null);
INSERT INTO `major` VALUES ('2136', '口腔医学专业', null);
INSERT INTO `major` VALUES ('2137', '麻醉学专业', null);
INSERT INTO `major` VALUES ('2138', '生物医学工程专业', null);
INSERT INTO `major` VALUES ('2139', '预防医学专业', null);
INSERT INTO `major` VALUES ('2140', '生物科学专业', null);
INSERT INTO `major` VALUES ('2141', '药学专业', null);
INSERT INTO `major` VALUES ('2142', '临床药学专业', null);
INSERT INTO `major` VALUES ('2143', '法医学专业', null);
INSERT INTO `major` VALUES ('2144', '金融管理与实务（中外合作）', null);
INSERT INTO `major` VALUES ('2178', '护理学专业', null);
INSERT INTO `major` VALUES ('2179', '医学影像学专业', null);
INSERT INTO `major` VALUES ('2180', '公共事业管理专业', null);
INSERT INTO `major` VALUES ('2200', '材料成型及其控制工程', null);
INSERT INTO `major` VALUES ('2225', '机械制造与自动化', null);
INSERT INTO `major` VALUES ('2226', '电子信息工程（通信等方向）', null);
INSERT INTO `major` VALUES ('2227', '公共事业管理（医院管理）', null);
INSERT INTO `major` VALUES ('2228', '医学影像学本科', null);
INSERT INTO `major` VALUES ('2229', '临床医学（本硕博连读）八年制', null);
INSERT INTO `major` VALUES ('2230', '口腔医学本科', null);
INSERT INTO `major` VALUES ('2231', '基础医学本科', null);
INSERT INTO `major` VALUES ('2242', '电气工程及其自动化（电力系统等方向）', null);
INSERT INTO `major` VALUES ('2243', '英语（国际工程管理）', null);
INSERT INTO `major` VALUES ('2246', '房地产开发与管理', '120104');
INSERT INTO `major` VALUES ('2301', '蜂学', '090303');
INSERT INTO `major` VALUES ('2346', '信息科学与技术', null);
INSERT INTO `major` VALUES ('2400', '环境科学类(中外)', null);
INSERT INTO `major` VALUES ('2401', '机械设计制作及其自动化', null);
INSERT INTO `major` VALUES ('2402', '特许经营管理', null);
INSERT INTO `major` VALUES ('2403', '电气信息类(中外)', null);
INSERT INTO `major` VALUES ('2404', '电子信息', null);
INSERT INTO `major` VALUES ('2405', '中国语言文学类（中外）', null);
INSERT INTO `major` VALUES ('2406', '灾害防治工程', null);
INSERT INTO `major` VALUES ('2407', '给水工程', null);
INSERT INTO `major` VALUES ('2408', '水土保护与荒漠化防治', null);
INSERT INTO `major` VALUES ('2409', '网络经济学', null);
INSERT INTO `major` VALUES ('2410', '计算机科学与技术(ios应用技术)', null);
INSERT INTO `major` VALUES ('2411', '软件工程（云计算系统架构）', null);
INSERT INTO `major` VALUES ('2412', '集成电路设计与集成系统(集成电路设计)', null);
INSERT INTO `major` VALUES ('2440', '软件工程（移动云计算方向）', null);
INSERT INTO `major` VALUES ('2447', '国际经济与贸易（英文教学）', null);
INSERT INTO `major` VALUES ('2448', '光电信息科学与工程', '080705');
INSERT INTO `major` VALUES ('2470', '电子科学与技术（微电子技术方向）', null);
INSERT INTO `major` VALUES ('2471', '软件工程（云应用方向）', null);
INSERT INTO `major` VALUES ('2590', '女性学', '030304');
INSERT INTO `major` VALUES ('2603', '印度尼西亚语', '050212');
INSERT INTO `major` VALUES ('2606', '软件工程（大数据技术方向）', null);
INSERT INTO `major` VALUES ('2607', '软件工程（云安全方向）', null);
INSERT INTO `major` VALUES ('2608', '越南语', '050223');
INSERT INTO `major` VALUES ('2609', '马来语', '050217');
INSERT INTO `major` VALUES ('2610', '老挝语', '050215');
INSERT INTO `major` VALUES ('2611', '缅甸语', '050216');
INSERT INTO `major` VALUES ('2677', '国际文化交流', null);
INSERT INTO `major` VALUES ('2678', '电子信息科学类（中外）', null);
INSERT INTO `major` VALUES ('2679', '仪器仪表类(中外)', null);
INSERT INTO `major` VALUES ('2686', '法学（卓越法律人才培养试点班）', null);
INSERT INTO `major` VALUES ('2694', '电子信息科学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('2699', '教育技术', null);
INSERT INTO `major` VALUES ('2700', '信息管理信息系统', null);
INSERT INTO `major` VALUES ('2732', '环境生态类（中外）', null);
INSERT INTO `major` VALUES ('2737', '公共管理类（中外）', null);
INSERT INTO `major` VALUES ('2761', '动物药学', '090402');
INSERT INTO `major` VALUES ('2762', '柬埔寨语', '050214');
INSERT INTO `major` VALUES ('2763', '建筑工程教育', null);
INSERT INTO `major` VALUES ('2811', '交通设备与控制工程', '081806');
INSERT INTO `major` VALUES ('2812', '对外汉语学', null);
INSERT INTO `major` VALUES ('2963', '旅游管理与服务教育', '120904');
INSERT INTO `major` VALUES ('2967', '应用生物科学', '090109');
INSERT INTO `major` VALUES ('2977', '园艺教育', '090111');
INSERT INTO `major` VALUES ('3027', '法学类（中外）', null);
INSERT INTO `major` VALUES ('3052', '能源与动力工程', '080501');
INSERT INTO `major` VALUES ('3300', '护理学类(中外)', null);
INSERT INTO `major` VALUES ('3393', '信息计算与科学', null);
INSERT INTO `major` VALUES ('3439', '国防教育与管理', null);
INSERT INTO `major` VALUES ('3458', '材料类（中外）', null);
INSERT INTO `major` VALUES ('3538', '材料类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3539', '环境与安全类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3605', '采购管理', '120603');
INSERT INTO `major` VALUES ('3606', '体育产业管理', null);
INSERT INTO `major` VALUES ('3647', '酒店管理（专科）', null);
INSERT INTO `major` VALUES ('3648', '汽车维修工程教育', '080212');
INSERT INTO `major` VALUES ('3649', '监狱学', '030103');
INSERT INTO `major` VALUES ('3650', '农艺教育', '090110');
INSERT INTO `major` VALUES ('3651', '新闻学（综合方向）', null);
INSERT INTO `major` VALUES ('3652', '思想政治教育（含青年社会心理方向）', null);
INSERT INTO `major` VALUES ('3653', '经济学（金融学方向）', null);
INSERT INTO `major` VALUES ('3654', '计算机科学与技术（网络工程）', null);
INSERT INTO `major` VALUES ('3655', '社会学（城市文化规划与设计）', null);
INSERT INTO `major` VALUES ('3656', '园林（城市景观与规划设计）', null);
INSERT INTO `major` VALUES ('3657', '护理', null);
INSERT INTO `major` VALUES ('3671', '职业技术教育管理', null);
INSERT INTO `major` VALUES ('3674', '生物资源科学', null);
INSERT INTO `major` VALUES ('3705', '公共管理类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3721', '化工与制药类(中外合作办学)', '0813H');
INSERT INTO `major` VALUES ('3722', '管理科学与工程类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3723', '化工与制药类(中外)', null);
INSERT INTO `major` VALUES ('3724', '土建类(中外)', null);
INSERT INTO `major` VALUES ('3725', '材料类(中外)', null);
INSERT INTO `major` VALUES ('3726', '能源动力类(中外)', null);
INSERT INTO `major` VALUES ('3727', '仪器仪表类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3728', '能源动力类(中外合作办学)', '0805H');
INSERT INTO `major` VALUES ('3729', '动植物检疫(植物检疫方向)', null);
INSERT INTO `major` VALUES ('3730', '计算机应用技术', null);
INSERT INTO `major` VALUES ('3731', '警犬技术', '030605');
INSERT INTO `major` VALUES ('3732', '公安视听技术', '083105');
INSERT INTO `major` VALUES ('3733', '侦察学', null);
INSERT INTO `major` VALUES ('3734', '经济犯罪侦查', '030606');
INSERT INTO `major` VALUES ('3735', '资源勘查工程（固体矿产）', null);
INSERT INTO `major` VALUES ('3736', '侦察与特种兵指挥', null);
INSERT INTO `major` VALUES ('3737', '中国语言文学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3738', '教育学类(中外合作办学)', '0401H');
INSERT INTO `major` VALUES ('3739', '艺术类(中外合作办学)', null);
INSERT INTO `major` VALUES ('3740', '信息管理与信息系统（电子商务）', null);
INSERT INTO `major` VALUES ('3741', '计算机科学与技术（商业智能）', null);
INSERT INTO `major` VALUES ('3742', '英语（翻译）', null);
INSERT INTO `major` VALUES ('3743', '生物科学类(中外)', null);
INSERT INTO `major` VALUES ('3744', '数学类(中外)', null);
INSERT INTO `major` VALUES ('3745', '地理科学类(中外)', null);
INSERT INTO `major` VALUES ('3746', '环境科学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3747', '生物科学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3748', '数学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3749', '应用药学', null);
INSERT INTO `major` VALUES ('3750', '再生资源科学与技术', null);
INSERT INTO `major` VALUES ('3751', '国际事务与国际关系', '030204');
INSERT INTO `major` VALUES ('3752', '工程力学类(中外合作办学)', null);
INSERT INTO `major` VALUES ('3753', '市场营销教育', '120214');
INSERT INTO `major` VALUES ('3754', '机电技术教育', '080211');
INSERT INTO `major` VALUES ('3755', '生物工程（生物技术与制药）', null);
INSERT INTO `major` VALUES ('3756', '历史学基础班', null);
INSERT INTO `major` VALUES ('3761', '卫生检验与检疫', '101007');
INSERT INTO `major` VALUES ('3762', '农业电气与自动化', null);
INSERT INTO `major` VALUES ('3763', '机械工程及自动化（高速列车及数控技术）', null);
INSERT INTO `major` VALUES ('3764', '临床医学（医学美容）', null);
INSERT INTO `major` VALUES ('3765', '政治学类（中外）', null);
INSERT INTO `major` VALUES ('3766', '新闻传播学类（中外）', null);
INSERT INTO `major` VALUES ('3767', '社会学类（中外）', null);
INSERT INTO `major` VALUES ('3768', '环境科学类（中外）', null);
INSERT INTO `major` VALUES ('3769', '统计学类（中外）', null);
INSERT INTO `major` VALUES ('3770', '英语（英语教育）', null);
INSERT INTO `major` VALUES ('3771', '公共事业管理（卫生事业管理）', null);
INSERT INTO `major` VALUES ('3772', '医学美容技术', null);
INSERT INTO `major` VALUES ('3773', '信息与计算科学（医学信息学）', null);
INSERT INTO `major` VALUES ('3774', '应用统计学', '071202');
INSERT INTO `major` VALUES ('3775', '蒙药学', '100804');
INSERT INTO `major` VALUES ('3776', '蒙医学', '100504');
INSERT INTO `major` VALUES ('3777', '音乐表演', '130201');
INSERT INTO `major` VALUES ('3778', '动物生产', null);
INSERT INTO `major` VALUES ('3779', '地图学与地理信息工程', null);
INSERT INTO `major` VALUES ('3780', '测量工程', null);
INSERT INTO `major` VALUES ('3781', '密码装备工程', null);
INSERT INTO `major` VALUES ('3782', '信息研究与安全', null);
INSERT INTO `major` VALUES ('3783', '信息研究安全（密码学）', null);
INSERT INTO `major` VALUES ('3784', '化妆品营销与使用技术', '530409');
INSERT INTO `major` VALUES ('3785', '卫生信息管理', '630502');
INSERT INTO `major` VALUES ('3786', '眼视光技术', '630404');
INSERT INTO `major` VALUES ('3787', '药学', '630301');
INSERT INTO `major` VALUES ('3788', '口腔医学', '630102');
INSERT INTO `major` VALUES ('3789', '护理', '630201');
INSERT INTO `major` VALUES ('3790', '助产专业', null);
INSERT INTO `major` VALUES ('3791', '口腔医学技术', '630406');
INSERT INTO `major` VALUES ('3792', '护理学（蒙授理科）', null);
INSERT INTO `major` VALUES ('3793', '心理学类(中外合作办学)', '0711H');
INSERT INTO `major` VALUES ('3794', '临床医学', '630101');
INSERT INTO `major` VALUES ('3795', '食品药品监督管理', '530401');
INSERT INTO `major` VALUES ('3796', '药物制剂技术', '530305');
INSERT INTO `major` VALUES ('3797', '生物制药技术', '530302');
INSERT INTO `major` VALUES ('3798', '临床医学（面向厦门）', null);
INSERT INTO `major` VALUES ('3799', '农业经济管理类（中外）', null);
INSERT INTO `major` VALUES ('3800', '农业经济管理类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3801', '动物医学类（中外）', null);
INSERT INTO `major` VALUES ('3802', '植物生产类（中外）', null);
INSERT INTO `major` VALUES ('3803', '地理科学类（中外）', null);
INSERT INTO `major` VALUES ('3804', '动物生产类（中外）', null);
INSERT INTO `major` VALUES ('3805', '森林资源类（中外）', null);
INSERT INTO `major` VALUES ('3806', '植物生产类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3807', '森林资源类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3808', '地理科学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3809', '环境生态类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3810', '轻工纺织食品类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3811', '动物生产类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3812', '中草药栽培与鉴定', '100806');
INSERT INTO `major` VALUES ('3813', '工商管理（医药）', null);
INSERT INTO `major` VALUES ('3814', '国际经济与贸易（医药）', null);
INSERT INTO `major` VALUES ('3815', '市场营销（医药）', null);
INSERT INTO `major` VALUES ('3816', '药物管理', null);
INSERT INTO `major` VALUES ('3817', '生命科学与技术基地班（生物技术制药）', null);
INSERT INTO `major` VALUES ('3818', '工商管理类(中外合作办学)', '1202H');
INSERT INTO `major` VALUES ('3819', '自动化（智能建筑与楼宇自动化）', null);
INSERT INTO `major` VALUES ('3820', '针炙推拿学', null);
INSERT INTO `major` VALUES ('3821', '维医学', '100505');
INSERT INTO `major` VALUES ('3822', '新闻传播学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('3823', '听力学', null);
INSERT INTO `major` VALUES ('3824', '建筑学　', null);
INSERT INTO `major` VALUES ('3825', '土木工程（造价管理）', null);
INSERT INTO `major` VALUES ('3826', '医学影象学', null);
INSERT INTO `major` VALUES ('3827', '港口业务管理', '520601');
INSERT INTO `major` VALUES ('3828', '会计(国际会计)?', null);
INSERT INTO `major` VALUES ('3829', '国际航运业务管理', '520403');
INSERT INTO `major` VALUES ('3830', '水运管理(外贸运输管理)', null);
INSERT INTO `major` VALUES ('3831', '水运管理(港口与航运管理)', null);
INSERT INTO `major` VALUES ('3832', '营销与策划', '620403');
INSERT INTO `major` VALUES ('3833', '文秘(商务秘书)', null);
INSERT INTO `major` VALUES ('3834', '报关与国际货运', '520605');
INSERT INTO `major` VALUES ('3835', '房地产经营与估价', '560701');
INSERT INTO `major` VALUES ('3836', '建筑工程管理(路桥方向)', null);
INSERT INTO `major` VALUES ('3837', '高等级公路维护与管理(高速公路管理方向)', null);
INSERT INTO `major` VALUES ('3838', '人力资源管理', '650204');
INSERT INTO `major` VALUES ('3839', '公路运输与管理', '520101');
INSERT INTO `major` VALUES ('3840', '物流管理(采购管理方向)', null);
INSERT INTO `major` VALUES ('3841', '计算机多媒体技术(广告媒体技术方向)', null);
INSERT INTO `major` VALUES ('3842', '机电一体化技术(自动化技术方向)', null);
INSERT INTO `major` VALUES ('3843', '制冷与冷藏技术', '550204');
INSERT INTO `major` VALUES ('3844', '楼宇智能化工程技术', '560404');
INSERT INTO `major` VALUES ('3845', '计算机应用技术(网络办公自动化方向)', null);
INSERT INTO `major` VALUES ('3846', '计算机应用技术(计算机应用与维护方向)', null);
INSERT INTO `major` VALUES ('3847', '计算机控制技术(智能交通)', null);
INSERT INTO `major` VALUES ('3848', '应用电子技术(电子技术方向)', null);
INSERT INTO `major` VALUES ('3849', '电子信息工程技术(通信与信息技术)', null);
INSERT INTO `major` VALUES ('3850', '航海技术', '520401');
INSERT INTO `major` VALUES ('3851', '轮机工程技术(现代船舶设备与管理)', null);
INSERT INTO `major` VALUES ('3852', '港口物流设备与自动控制', '520602');
INSERT INTO `major` VALUES ('3853', '工程机械运用与维护', '520110');
INSERT INTO `major` VALUES ('3854', '汽车技术服务与营销(汽车营销策划与管理)', null);
INSERT INTO `major` VALUES ('3855', '汽车运用技术(高职)', null);
INSERT INTO `major` VALUES ('3856', '市政工程技术', '560601');
INSERT INTO `major` VALUES ('3857', '交通安全与智能控制', '520105');
INSERT INTO `major` VALUES ('3858', '工业设计', '580109');
INSERT INTO `major` VALUES ('3859', '计算机信息管理', '590106');
INSERT INTO `major` VALUES ('3860', '计算机网络技术(电子商务技术方向)', null);
INSERT INTO `major` VALUES ('3861', '软件技术(数据库方向)', null);
INSERT INTO `major` VALUES ('3862', '软件技术(可视化编程方向)', null);
INSERT INTO `major` VALUES ('3863', '软件工程(软件测试)', null);
INSERT INTO `major` VALUES ('3864', '软件工程(移动互联网应用与开发方向)', null);
INSERT INTO `major` VALUES ('3865', '计算机科学与技术(企业级数据库应用与开)', null);
INSERT INTO `major` VALUES ('3866', '网络工程（网络设计与管理）', null);
INSERT INTO `major` VALUES ('3867', '网络工程（多媒体信息网络）', null);
INSERT INTO `major` VALUES ('3868', '网络工程(网络游戏)', null);
INSERT INTO `major` VALUES ('3869', '动画(游戏设计)', null);
INSERT INTO `major` VALUES ('3870', '动画(二维动画)', null);
INSERT INTO `major` VALUES ('3871', '电子商务(电子商务管理)', null);
INSERT INTO `major` VALUES ('3872', '电子商务(国际贸易与电子商务)', null);
INSERT INTO `major` VALUES ('3873', '软件工程(软件开发)', null);
INSERT INTO `major` VALUES ('3874', '税收学', '020202');
INSERT INTO `major` VALUES ('3875', '材料工程', null);
INSERT INTO `major` VALUES ('3876', ' 建筑环境与设备工程', null);
INSERT INTO `major` VALUES ('3877', '农业建筑环境与能源工程', '082304');
INSERT INTO `major` VALUES ('3878', '工商管理', null);
INSERT INTO `major` VALUES ('3879', '会计学', null);
INSERT INTO `major` VALUES ('3880', '金融学', null);
INSERT INTO `major` VALUES ('3881', '嵌入式软件人才培养', null);
INSERT INTO `major` VALUES ('3882', '法学（经济法）', null);
INSERT INTO `major` VALUES ('3883', '金融学（金融理财）', null);
INSERT INTO `major` VALUES ('3884', '警卫学', '030609');
INSERT INTO `major` VALUES ('3885', '消防指挥', '030608');
INSERT INTO `major` VALUES ('3886', '火灾勘查', '083107');
INSERT INTO `major` VALUES ('3887', '核生化消防', '083109');
INSERT INTO `major` VALUES ('3888', '国际贸易实务', null);
INSERT INTO `major` VALUES ('3889', '边防指挥', '030607');
INSERT INTO `major` VALUES ('3890', '军事外交', null);
INSERT INTO `major` VALUES ('3891', '军事情报', null);
INSERT INTO `major` VALUES ('3892', '国际关系与安全', null);
INSERT INTO `major` VALUES ('3893', '经济学类(中外合作办学)', '0201H');
INSERT INTO `major` VALUES ('3894', '管理科学与工程类(中外合作办学)', '1201H');
INSERT INTO `major` VALUES ('3895', '保险', null);
INSERT INTO `major` VALUES ('3896', '医学检查', null);
INSERT INTO `major` VALUES ('3897', '中医基础学基地班', null);
INSERT INTO `major` VALUES ('3898', '军事历史', null);
INSERT INTO `major` VALUES ('3899', '军事心理学', null);
INSERT INTO `major` VALUES ('3900', '政治经济学', null);
INSERT INTO `major` VALUES ('3901', '电子信息工程（铁道通信信号方向）', null);
INSERT INTO `major` VALUES ('3902', '国防建筑学', null);
INSERT INTO `major` VALUES ('3903', '土木工程（机场工程）', null);
INSERT INTO `major` VALUES ('3904', '军事气象学', null);
INSERT INTO `major` VALUES ('3905', '地雷爆破与障碍工程', null);
INSERT INTO `major` VALUES ('3906', '雷达工程', null);
INSERT INTO `major` VALUES ('3907', '国防工程与防护', null);
INSERT INTO `major` VALUES ('3908', '道路桥梁与渡河濒海工程', null);
INSERT INTO `major` VALUES ('3909', '伪装工程', null);
INSERT INTO `major` VALUES ('3910', '建筑工程管理', null);
INSERT INTO `major` VALUES ('3911', '国防建筑设备工程', null);
INSERT INTO `major` VALUES ('3912', '民族传统体育', null);
INSERT INTO `major` VALUES ('3913', '播音与主持艺术', '130309');
INSERT INTO `major` VALUES ('3914', '植物生物技术', null);
INSERT INTO `major` VALUES ('3915', '国际经济与贸易(金融方向)', null);
INSERT INTO `major` VALUES ('3916', '对外汉语（英语方向、日语方向、韩语方向）', null);
INSERT INTO `major` VALUES ('3917', '藏医学', '100503');
INSERT INTO `major` VALUES ('3918', '计算机科学与技术专业', null);
INSERT INTO `major` VALUES ('3919', '公共事业管理(卫生事业管理)', null);
INSERT INTO `major` VALUES ('3920', '美术学', '130401');
INSERT INTO `major` VALUES ('3921', '测控工程', null);
INSERT INTO `major` VALUES ('3922', '火力指挥与控制工程', null);
INSERT INTO `major` VALUES ('3923', '软件工程专', null);
INSERT INTO `major` VALUES ('3924', '模具设计与制造（普高生、3＋技能证书）', null);
INSERT INTO `major` VALUES ('3925', '应用电子技术（电子电器产品质量检测方向）', null);
INSERT INTO `major` VALUES ('3926', '应用电子技术（集成电路设计技术方向）', null);
INSERT INTO `major` VALUES ('3927', '应用电子技术（电子电器产品质量管理方向）', null);
INSERT INTO `major` VALUES ('3928', '供热通风与空调工程技术', '560402');
INSERT INTO `major` VALUES ('3929', '工商企业管理（连锁经营与管理方向）', null);
INSERT INTO `major` VALUES ('3930', '电子信息工程技术', '590201');
INSERT INTO `major` VALUES ('3931', '计算机辅助设计与制造（家电产品设计）', null);
INSERT INTO `major` VALUES ('3948', '英语（师范）', null);
INSERT INTO `major` VALUES ('3949', '土木工程（建筑工程方向）', null);
INSERT INTO `major` VALUES ('3950', '土木工程（交通土建工程方向）', null);
INSERT INTO `major` VALUES ('3951', '计算机科学与技术（师范）', null);
INSERT INTO `major` VALUES ('3952', '数学与应用数学（师范）', null);
INSERT INTO `major` VALUES ('3953', '汽车制造与装配技术', '580401');
INSERT INTO `major` VALUES ('3954', '计算机控制技术（智能电子产品设计与制作方', null);
INSERT INTO `major` VALUES ('3955', '旅游管理（酒店管理方向）', null);
INSERT INTO `major` VALUES ('3956', '物流管理（航空与快递方向）', null);
INSERT INTO `major` VALUES ('3957', '商务英语(涉外文秘方向)', null);
INSERT INTO `major` VALUES ('3958', '商务英语(翻译方向)', null);
INSERT INTO `major` VALUES ('3959', '商务英语(外事方向)', null);
INSERT INTO `major` VALUES ('3960', '商务英语(会展方向)', null);
INSERT INTO `major` VALUES ('3961', '应用英语（涉外行政管理）', null);
INSERT INTO `major` VALUES ('3962', '商务英语(对外贸易方向)', null);
INSERT INTO `major` VALUES ('3963', '旅游英语（旅游策划与管理）', null);
INSERT INTO `major` VALUES ('3964', '旅游英语（涉外导游方向）', null);
INSERT INTO `major` VALUES ('3965', '建筑电气工程技术', '560403');
INSERT INTO `major` VALUES ('3966', '无人机运用工程', null);
INSERT INTO `major` VALUES ('3967', '炮兵指挥', null);
INSERT INTO `major` VALUES ('3968', '小学教育（师范）', null);
INSERT INTO `major` VALUES ('3969', '汉语言文学（师范）', null);
INSERT INTO `major` VALUES ('3970', '英语（实用英语）', null);
INSERT INTO `major` VALUES ('3971', '物理学（师范）', null);
INSERT INTO `major` VALUES ('3972', '软件技术（游戏软件开发）', null);
INSERT INTO `major` VALUES ('3973', '软件技术（网站开发方向）', null);
INSERT INTO `major` VALUES ('3974', '软件技术（移动应用软件开发）', null);
INSERT INTO `major` VALUES ('3975', '软件技术（网站设计方向）', null);
INSERT INTO `major` VALUES ('3976', '国际贸易实务', '620304');
INSERT INTO `major` VALUES ('3977', '金融管理与实务', '620103');
INSERT INTO `major` VALUES ('3978', '工商企业管理（市场开发与营销方向）', null);
INSERT INTO `major` VALUES ('3979', '计算机网络技术（网络工程管理方向）', null);
INSERT INTO `major` VALUES ('3980', '计算机网络技术（电子商务方向）', null);
INSERT INTO `major` VALUES ('3981', '移动通信技术', '590302');
INSERT INTO `major` VALUES ('3982', '计算机控制技术(嵌入式系统设计方向）', null);
INSERT INTO `major` VALUES ('3983', '旅游管理（中澳合作、毕业获双证）', null);
INSERT INTO `major` VALUES ('3984', '计算机应用技术（电脑艺术设计方向）', null);
INSERT INTO `major` VALUES ('3985', '计算机应用（室内设计方向）', null);
INSERT INTO `major` VALUES ('3986', '财务管理', '620201');
INSERT INTO `major` VALUES ('3987', '计算机应用技术（信息管理方向）', null);
INSERT INTO `major` VALUES ('3988', '计算机应用技术（广告设计方向）', null);
INSERT INTO `major` VALUES ('3989', '机动车保险实务', '620121');
INSERT INTO `major` VALUES ('3990', '音乐科技与艺术', null);
INSERT INTO `major` VALUES ('3991', '计算机控制技术（智能电子产品设计方向）', null);
INSERT INTO `major` VALUES ('3992', '新闻采编与制作（影视制作技术）', null);
INSERT INTO `major` VALUES ('3993', '信息传播与策划（企业会展设计）', null);
INSERT INTO `major` VALUES ('3994', '应用英语', '660102');
INSERT INTO `major` VALUES ('3995', '鞋类设计与工艺', '610251');
INSERT INTO `major` VALUES ('3996', '工商企业管理（涉外企业管理）', null);
INSERT INTO `major` VALUES ('3997', '物流管理（物流管理）', null);
INSERT INTO `major` VALUES ('3998', '会计与审计（注册会计师）', null);
INSERT INTO `major` VALUES ('3999', '商务日语', '660110');
INSERT INTO `major` VALUES ('4000', '应用化工技术', '530201');
INSERT INTO `major` VALUES ('4001', '生产过程自动化技术', '580203');
INSERT INTO `major` VALUES ('4002', '建筑设备工程技术（建筑水电工程）', null);
INSERT INTO `major` VALUES ('4003', '计算机网络技术（物联网技术）', null);
INSERT INTO `major` VALUES ('4004', '高分子材料加工技术', '610102');
INSERT INTO `major` VALUES ('4005', '统计实务', '620208');
INSERT INTO `major` VALUES ('4006', '财务管理(财务主管)', null);
INSERT INTO `major` VALUES ('4007', '机械制造与自动化', '580102');
INSERT INTO `major` VALUES ('4008', '房地产经营与估价(开发项目经理)', null);
INSERT INTO `major` VALUES ('4009', '会计(注册会计师 )', null);
INSERT INTO `major` VALUES ('4010', '通信技术', '590301');
INSERT INTO `major` VALUES ('4011', '机械设计与制造（CAD/CAM）', null);
INSERT INTO `major` VALUES ('4012', '数控技术(数控设备应用与维修)', null);
INSERT INTO `major` VALUES ('4013', '物联网应用技术', '590129');
INSERT INTO `major` VALUES ('4014', '新能源应用技术（风电,光伏太阳能）', null);
INSERT INTO `major` VALUES ('4015', '应用日语', '660103');
INSERT INTO `major` VALUES ('4016', '工程造价(注册造价师)', null);
INSERT INTO `major` VALUES ('4017', '建筑工程管理(施工项目经理)', null);
INSERT INTO `major` VALUES ('4018', '旅游管理（导游管理,酒店经理)', null);
INSERT INTO `major` VALUES ('4019', '会展策划与管理(会展策划师)', null);
INSERT INTO `major` VALUES ('4020', '投资与理财(理财规划师)', null);
INSERT INTO `major` VALUES ('4021', '物流管理（连锁企业物流经理）', null);
INSERT INTO `major` VALUES ('4022', '国际贸易实务(外贸业务经理)', null);
INSERT INTO `major` VALUES ('4023', '机电一体化技术(自动机与自动线)', null);
INSERT INTO `major` VALUES ('4024', '数控技术(数控加工与工艺编程)', null);
INSERT INTO `major` VALUES ('4025', '机电一体化技术(机电设备维护与管理)', null);
INSERT INTO `major` VALUES ('4026', '影视动画（计算机多媒体）', null);
INSERT INTO `major` VALUES ('4027', '产品造型设计（轻工产品造型设计）', null);
INSERT INTO `major` VALUES ('4028', '环境艺术设计（室内设计）　', null);
INSERT INTO `major` VALUES ('4029', '环境艺术设计（施工管理）　', null);
INSERT INTO `major` VALUES ('4030', '环境艺术设计（园林景观设计）　', null);
INSERT INTO `major` VALUES ('4031', '视觉传达艺术设计（广告设计制作）', null);
INSERT INTO `major` VALUES ('4032', '视觉传达艺术设计（品牌设计）', null);
INSERT INTO `major` VALUES ('4033', '影视动画（动漫设计制作(二维)）', null);
INSERT INTO `major` VALUES ('4034', '影视动画（三维动画设计）', null);
INSERT INTO `major` VALUES ('4035', '影视动画（影视多媒体制作）', null);
INSERT INTO `major` VALUES ('4036', '影视动画（摄影与摄像技术）', null);
INSERT INTO `major` VALUES ('4037', '装饰艺术设计（陶瓷美术设计）', null);
INSERT INTO `major` VALUES ('4038', '装饰艺术设计（家纺设计）', null);
INSERT INTO `major` VALUES ('4039', '装饰艺术设计（首饰造型设计）', null);
INSERT INTO `major` VALUES ('4040', '房地产经营与股价', null);
INSERT INTO `major` VALUES ('4041', '外国语言文学(外国军事)', null);
INSERT INTO `major` VALUES ('4042', '兵器工程', null);
INSERT INTO `major` VALUES ('4043', '防化兵指挥', null);
INSERT INTO `major` VALUES ('4044', '电子对抗指挥与工程', null);
INSERT INTO `major` VALUES ('4045', '电器工程及自动化', null);
INSERT INTO `major` VALUES ('4046', '市场营销（物流）', null);
INSERT INTO `major` VALUES ('4047', '装备保障指挥', null);
INSERT INTO `major` VALUES ('4048', '车辆运用工程', null);
INSERT INTO `major` VALUES ('4049', '军用材料工程', null);
INSERT INTO `major` VALUES ('4050', '国际贸易', null);
INSERT INTO `major` VALUES ('4051', '英语（国际商务方向）', null);
INSERT INTO `major` VALUES ('4052', '资源管理与城乡规划管理', null);
INSERT INTO `major` VALUES ('4053', '军事交通指挥与工程', null);
INSERT INTO `major` VALUES ('4054', '汽车指挥', null);
INSERT INTO `major` VALUES ('4055', '材料成型与控制工程', null);
INSERT INTO `major` VALUES ('4056', '朝鲜语（韩英双语）', null);
INSERT INTO `major` VALUES ('4057', '物流', null);
INSERT INTO `major` VALUES ('4058', '财务管理（财务管理方向）', null);
INSERT INTO `major` VALUES ('4059', '英语（英语教育方向）', null);
INSERT INTO `major` VALUES ('4060', '法语（法语语言文学）', null);
INSERT INTO `major` VALUES ('4061', '机械设计制造及其自动化专业', null);
INSERT INTO `major` VALUES ('4062', '法律事务', '690104');
INSERT INTO `major` VALUES ('4063', '城市轨道交通车辆', '520301');
INSERT INTO `major` VALUES ('4064', '机电设备维修与管理', '580301');
INSERT INTO `major` VALUES ('4065', '供用电技术', '550306');
INSERT INTO `major` VALUES ('4066', '城市轨道交通运营管理', '520304');
INSERT INTO `major` VALUES ('4067', '艺术教育（音乐教育与表演方向）', null);
INSERT INTO `major` VALUES ('4068', '通信指挥', null);
INSERT INTO `major` VALUES ('4069', '信息研究与安全（密码学）', null);
INSERT INTO `major` VALUES ('4070', '英语（商务英语方向）', null);
INSERT INTO `major` VALUES ('4071', '市场营销（国际营销）', null);
INSERT INTO `major` VALUES ('4072', '土木工程（交通土建工程）', null);
INSERT INTO `major` VALUES ('4073', '经济贸易', null);
INSERT INTO `major` VALUES ('4074', '军事海洋学', '070704');
INSERT INTO `major` VALUES ('4075', '油料储运工程', null);
INSERT INTO `major` VALUES ('4076', '土木工程(机场工程)', null);
INSERT INTO `major` VALUES ('4077', '电力工程及其自动化', null);
INSERT INTO `major` VALUES ('4078', '国防建筑学', null);
INSERT INTO `major` VALUES ('4079', '油料储运工程', null);
INSERT INTO `major` VALUES ('4080', '汉语言文学（高级文秘方向）', null);
INSERT INTO `major` VALUES ('4081', '植物保护（植物检疫方向）', null);
INSERT INTO `major` VALUES ('4082', '应用语言学', '050106');
INSERT INTO `major` VALUES ('4083', '朝鲜（韩）语', null);
INSERT INTO `major` VALUES ('4084', '商务管理', '620503');
INSERT INTO `major` VALUES ('4085', '计算机多媒体技术（动漫）', null);
INSERT INTO `major` VALUES ('4086', '会计（涉外）', null);
INSERT INTO `major` VALUES ('4087', '产品造型设计（艺术类）', null);
INSERT INTO `major` VALUES ('4088', '装饰艺术设计（艺术类）', null);
INSERT INTO `major` VALUES ('4089', '金属材料与热处理技术', '550101');
INSERT INTO `major` VALUES ('4090', '冶金技术（高端金属材料）', null);
INSERT INTO `major` VALUES ('4091', '环境监测与治理技术（环境工程）', null);
INSERT INTO `major` VALUES ('4092', '环境监测与治理技术（环境保护）', null);
INSERT INTO `major` VALUES ('4093', '计算机辅助设计与制造（中德合作）', null);
INSERT INTO `major` VALUES ('4094', '建筑工程管理', '560501');
INSERT INTO `major` VALUES ('4095', '机械设计与制造', '580101');
INSERT INTO `major` VALUES ('4096', '机电一体化技术（中德合作）', null);
INSERT INTO `major` VALUES ('4097', '工商管理（含国际合作班2+2,3+1等）', null);
INSERT INTO `major` VALUES ('4098', '戏剧影视美术设计', '130307');
INSERT INTO `major` VALUES ('4099', '装备经济管理', null);
INSERT INTO `major` VALUES ('4100', '船舶动力工程', null);
INSERT INTO `major` VALUES ('4101', '核动力工程', null);
INSERT INTO `major` VALUES ('4102', '英语（商务）', null);
INSERT INTO `major` VALUES ('4103', '电子信息工程（达内科技嵌入式）', null);
INSERT INTO `major` VALUES ('4104', '计算机科学与技术（微软IT教育）', null);
INSERT INTO `major` VALUES ('4105', '计算机科学与技术（海康软件）', null);
INSERT INTO `major` VALUES ('4106', '电子信息工程（中软国际3G通信）', null);
INSERT INTO `major` VALUES ('4107', '电子信息工程（北京华清远见嵌入式系统）', null);
INSERT INTO `major` VALUES ('4108', '计算机科学与技术（中软国际软件工程）', null);
INSERT INTO `major` VALUES ('4109', '计算机科学与技术（沈阳东鹏嵌入式）', null);
INSERT INTO `major` VALUES ('4110', '计算机科学与技术（北大青鸟）', null);
INSERT INTO `major` VALUES ('4128', '园林（园林设计）', null);
INSERT INTO `major` VALUES ('4129', '金融', null);
INSERT INTO `major` VALUES ('4130', '金融学（保险、证券、银行）', null);
INSERT INTO `major` VALUES ('4131', '数学教育', '660202');
INSERT INTO `major` VALUES ('4132', '会计学（审计、财务会计、会计信息化、', null);
INSERT INTO `major` VALUES ('4133', '新闻采编与制作', '670308');
INSERT INTO `major` VALUES ('4134', '旅游英语', '660109');
INSERT INTO `major` VALUES ('4135', '初等教育（中文与社会）', null);
INSERT INTO `major` VALUES ('4136', '初等教育（英语）', null);
INSERT INTO `major` VALUES ('4137', '学前教育', '660214');
INSERT INTO `major` VALUES ('4138', '心理咨询', '650304');
INSERT INTO `major` VALUES ('4139', '思想政治教育', '660212');
INSERT INTO `major` VALUES ('4140', '综合文科教育', '660219');
INSERT INTO `major` VALUES ('4141', '历史教育', '660207');
INSERT INTO `major` VALUES ('4142', '动漫设计与制作（学制两年）', null);
INSERT INTO `major` VALUES ('4143', '软件技术（学制两年）', null);
INSERT INTO `major` VALUES ('4144', '计算机网络技术（学制两年）', null);
INSERT INTO `major` VALUES ('4145', '旅游管理（中新合办）', null);
INSERT INTO `major` VALUES ('4146', '物业管理（中俄）', null);
INSERT INTO `major` VALUES ('4147', '计算机应用技术（学制两年）', null);
INSERT INTO `major` VALUES ('4148', '社区管理与服务', '650102');
INSERT INTO `major` VALUES ('4149', '初等教育（数学与科学）', null);
INSERT INTO `major` VALUES ('4150', '计算机教育', '660221');
INSERT INTO `major` VALUES ('4151', '综合理科教育', '660220');
INSERT INTO `major` VALUES ('4152', '化学教育', '660205');
INSERT INTO `major` VALUES ('4153', '生物教育', '660206');
INSERT INTO `major` VALUES ('4154', '现代教育技术', '660215');
INSERT INTO `major` VALUES ('4155', '物理教育', '660204');
INSERT INTO `major` VALUES ('4156', '建筑设备与环境工程', null);
INSERT INTO `major` VALUES ('4157', '机械设计制造及其自动化（数控技术方向）', null);
INSERT INTO `major` VALUES ('4158', '通材料成型及控制工程', null);
INSERT INTO `major` VALUES ('4159', '物理', null);
INSERT INTO `major` VALUES ('4160', '装潢设计与工艺教育', null);
INSERT INTO `major` VALUES ('4161', '针灸推拿', null);
INSERT INTO `major` VALUES ('4162', '酒店管理专业（涉外方向）', null);
INSERT INTO `major` VALUES ('4163', '会展策划与管理专业', null);
INSERT INTO `major` VALUES ('4164', '学前教育（双语教育方向）', null);
INSERT INTO `major` VALUES ('4165', '英语教育专业（家庭教育指导师方向）（师范', null);
INSERT INTO `major` VALUES ('4166', '学前教育（早教方向）', null);
INSERT INTO `major` VALUES ('4167', '英语教育专业（师范类）', null);
INSERT INTO `major` VALUES ('4168', '文秘专业', null);
INSERT INTO `major` VALUES ('4169', '空中乘务', '520503');
INSERT INTO `major` VALUES ('4170', '影视动画', '670305');
INSERT INTO `major` VALUES ('4171', '主持与播音', '670307');
INSERT INTO `major` VALUES ('4172', '应用俄语（商务方向）', null);
INSERT INTO `major` VALUES ('4173', '摄影摄像技术', '670302');
INSERT INTO `major` VALUES ('4174', '家政服务（涉外方向）', null);
INSERT INTO `major` VALUES ('4175', '电视节目制作', '670309');
INSERT INTO `major` VALUES ('4176', '应用西班牙语', '660119');
INSERT INTO `major` VALUES ('4177', '应用韩语（商务方向）', null);
INSERT INTO `major` VALUES ('4178', '旅行社经营管理专业', null);
INSERT INTO `major` VALUES ('4179', '旅游日语', '660111');
INSERT INTO `major` VALUES ('4180', '应用英语（文化与翻译方向）', null);
INSERT INTO `major` VALUES ('4181', '图书档案管理（外文文献管理方向）', null);
INSERT INTO `major` VALUES ('4182', '应用德语', '660105');
INSERT INTO `major` VALUES ('4183', '应用法语', '660106');
INSERT INTO `major` VALUES ('4184', '应用俄语（涉外酒店方向）', null);
INSERT INTO `major` VALUES ('4185', '应用阿拉伯语', '660120');
INSERT INTO `major` VALUES ('4186', '环境监测与评价', '600102');
INSERT INTO `major` VALUES ('4187', '会展策划与管理', '640107');
INSERT INTO `major` VALUES ('4188', '计算机控制技术', '580205');
INSERT INTO `major` VALUES ('4189', '旅行社经营管理', '640104');
INSERT INTO `major` VALUES ('4190', '酒店管理（闽台）', null);
INSERT INTO `major` VALUES ('4191', '视觉传达艺术设计', '670103');
INSERT INTO `major` VALUES ('4192', '物流管理（闽台）', null);
INSERT INTO `major` VALUES ('4193', '军事光电工程', null);
INSERT INTO `major` VALUES ('4194', '瑞典语', '050233');
INSERT INTO `major` VALUES ('4195', '信息管理与信息系统（卫生事业管理方向）', null);
INSERT INTO `major` VALUES ('4196', '土木工程（矿井建设）', null);
INSERT INTO `major` VALUES ('4197', '艺术设计(网络传播)', null);
INSERT INTO `major` VALUES ('4198', '绘画', '130402');
INSERT INTO `major` VALUES ('4199', '表演(影视表现艺术)', null);
INSERT INTO `major` VALUES ('4200', '藏药学', '100803');
INSERT INTO `major` VALUES ('4201', '理科试验班类', '0070');
INSERT INTO `major` VALUES ('4202', '数学类', '0701');
INSERT INTO `major` VALUES ('4203', '经济学类', '0201');
INSERT INTO `major` VALUES ('4204', '农业机械比及其自动化', null);
INSERT INTO `major` VALUES ('4205', '法学类', '0301');
INSERT INTO `major` VALUES ('4206', '新闻传播学类', '0503');
INSERT INTO `major` VALUES ('4207', '中国语言文学类', '0501');
INSERT INTO `major` VALUES ('4208', '外国语言文学类', '0502');
INSERT INTO `major` VALUES ('4209', '历史学类', '0601');
INSERT INTO `major` VALUES ('4210', '社会学类', '0303');
INSERT INTO `major` VALUES ('4211', '土建类', null);
INSERT INTO `major` VALUES ('4212', '临床医学（七年制）', null);
INSERT INTO `major` VALUES ('4213', '环境监察', null);
INSERT INTO `major` VALUES ('4214', '化学类', '0703');
INSERT INTO `major` VALUES ('4215', '力学类', '0801');
INSERT INTO `major` VALUES ('4216', '海洋科学类', '0707');
INSERT INTO `major` VALUES ('4217', '马克思主义理论类', '0305');
INSERT INTO `major` VALUES ('4218', '生物工程类', '0830');
INSERT INTO `major` VALUES ('4219', '能源动力类', '0805');
INSERT INTO `major` VALUES ('4220', '文科试验班类', '0015');
INSERT INTO `major` VALUES ('4221', '生物工程类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4222', '艺术学理论类', '1301');
INSERT INTO `major` VALUES ('4223', '地里国情监测', null);
INSERT INTO `major` VALUES ('4224', '测绘类', '0812');
INSERT INTO `major` VALUES ('4225', '环境科学与工程类', '0825');
INSERT INTO `major` VALUES ('4226', '地理科学类', '0705');
INSERT INTO `major` VALUES ('4227', '物理学类', '0702');
INSERT INTO `major` VALUES ('4228', '建筑类', '0828');
INSERT INTO `major` VALUES ('4229', '土木类', '0810');
INSERT INTO `major` VALUES ('4230', '仪器仪表类', null);
INSERT INTO `major` VALUES ('4231', '机械类', '0802');
INSERT INTO `major` VALUES ('4232', '护理学类', '1011');
INSERT INTO `major` VALUES ('4233', '地矿类', null);
INSERT INTO `major` VALUES ('4234', '地球物理学类', '0708');
INSERT INTO `major` VALUES ('4235', '水资源与海洋工程', null);
INSERT INTO `major` VALUES ('4236', '科学社会主义与国际共产主义运动', null);
INSERT INTO `major` VALUES ('4237', '工科实验班', null);
INSERT INTO `major` VALUES ('4238', '地质学类', '0709');
INSERT INTO `major` VALUES ('4239', '天文学类', '0704');
INSERT INTO `major` VALUES ('4240', '核工程类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4241', '大气科学类', '0706');
INSERT INTO `major` VALUES ('4242', '哲学类', '0101');
INSERT INTO `major` VALUES ('4243', '化工与制药类', '0813');
INSERT INTO `major` VALUES ('4244', '医学技术类', '1010');
INSERT INTO `major` VALUES ('4245', '土木学', null);
INSERT INTO `major` VALUES ('4246', '金融学类', '0203');
INSERT INTO `major` VALUES ('4247', '应刚物理学', null);
INSERT INTO `major` VALUES ('4248', '数字出版', '050307');
INSERT INTO `major` VALUES ('4249', '仿真科学与技术', null);
INSERT INTO `major` VALUES ('4250', '建筑类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4251', '轻工类', '0817');
INSERT INTO `major` VALUES ('4252', '公共卫生与预防医学类', '1004');
INSERT INTO `major` VALUES ('4253', '轨道交通信号与控制', '080802');
INSERT INTO `major` VALUES ('4254', '环境生态工程', '082504');
INSERT INTO `major` VALUES ('4255', '自然地理与资源环境', '070502');
INSERT INTO `major` VALUES ('4256', '经济统计学', '020102');
INSERT INTO `major` VALUES ('4257', '水利类', '0811');
INSERT INTO `major` VALUES ('4258', '社会科学实验班', null);
INSERT INTO `major` VALUES ('4259', '海洋资源与环境', '070703');
INSERT INTO `major` VALUES ('4260', '资源勘察', null);
INSERT INTO `major` VALUES ('4261', '交通翻呈', null);
INSERT INTO `major` VALUES ('4262', '口腔医学技术', '101006');
INSERT INTO `major` VALUES ('4263', '乌尔都语', '050221');
INSERT INTO `major` VALUES ('4264', '微电子科学与工程', '080704');
INSERT INTO `major` VALUES ('4265', '生物系统工程', null);
INSERT INTO `major` VALUES ('4266', '电气类', '0806');
INSERT INTO `major` VALUES ('4267', '生物科学基地班', null);
INSERT INTO `major` VALUES ('4268', '无机非金届材料工程', null);
INSERT INTO `major` VALUES ('4269', '核工程类', '0822');
INSERT INTO `major` VALUES ('4270', '经济管理', null);
INSERT INTO `major` VALUES ('4271', '粉体材科科学与工程', null);
INSERT INTO `major` VALUES ('4272', '医学试验班类', '0080');
INSERT INTO `major` VALUES ('4273', '化工制药类', null);
INSERT INTO `major` VALUES ('4274', '金腿材料工程', null);
INSERT INTO `major` VALUES ('4275', '菲律宾语', '050210');
INSERT INTO `major` VALUES ('4276', '电气工程乃其自动化', null);
INSERT INTO `major` VALUES ('4277', '教育学类', '0401');
INSERT INTO `major` VALUES ('4278', '生物工程娄', null);
INSERT INTO `major` VALUES ('4279', '中医学类', '1005');
INSERT INTO `major` VALUES ('4280', '外围语言文学类', null);
INSERT INTO `major` VALUES ('4281', '痴分子材料与工程', null);
INSERT INTO `major` VALUES ('4282', '金融学类(中外合作办学)', '0203H');
INSERT INTO `major` VALUES ('4283', '金树材料工程', null);
INSERT INTO `major` VALUES ('4284', '金融学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4285', '希伯莱语', null);
INSERT INTO `major` VALUES ('4286', '波斯语', '050208');
INSERT INTO `major` VALUES ('4287', '机械没计制造及其自动化', null);
INSERT INTO `major` VALUES ('4288', '地理国情检测', null);
INSERT INTO `major` VALUES ('4289', '光电信息科掌与工程', null);
INSERT INTO `major` VALUES ('4290', '济学类', null);
INSERT INTO `major` VALUES ('4291', '建筑环境与能源应刚工程', null);
INSERT INTO `major` VALUES ('4292', '中国革命史与中国共产党党', null);
INSERT INTO `major` VALUES ('4293', '金届材料工程', null);
INSERT INTO `major` VALUES ('4294', '离分子材料与工程', null);
INSERT INTO `major` VALUES ('4295', '食品卫生与营养学', '100402');
INSERT INTO `major` VALUES ('4296', '地理国情临测', null);
INSERT INTO `major` VALUES ('4297', '粉体制料科学与工程', null);
INSERT INTO `major` VALUES ('4298', '新闻传插学类', null);
INSERT INTO `major` VALUES ('4299', '口语', null);
INSERT INTO `major` VALUES ('4300', '仪器表类', null);
INSERT INTO `major` VALUES ('4301', '土健类', null);
INSERT INTO `major` VALUES ('4302', '土本类', null);
INSERT INTO `major` VALUES ('4303', '风最园林', null);
INSERT INTO `major` VALUES ('4304', '水土保持与荒漠化治理', null);
INSERT INTO `major` VALUES ('4305', '建筑环境与没备工程', null);
INSERT INTO `major` VALUES ('4306', '纺织类', '0816');
INSERT INTO `major` VALUES ('4307', '文物与博物馆学', '060104');
INSERT INTO `major` VALUES ('4308', '自然保护与环境生态类', '0902');
INSERT INTO `major` VALUES ('4309', '马克思主义理沦类', null);
INSERT INTO `major` VALUES ('4310', '石汕工程', null);
INSERT INTO `major` VALUES ('4311', '外国语育文学类', null);
INSERT INTO `major` VALUES ('4312', '生物庆学工程', null);
INSERT INTO `major` VALUES ('4313', '日腔医学', null);
INSERT INTO `major` VALUES ('4314', '海洋利学类', null);
INSERT INTO `major` VALUES ('4315', '表演', '130301');
INSERT INTO `major` VALUES ('4316', '盘融学', null);
INSERT INTO `major` VALUES ('4317', '物理学', null);
INSERT INTO `major` VALUES ('4318', '数学与应用数学', null);
INSERT INTO `major` VALUES ('4319', '机械设计制造及其自动化', null);
INSERT INTO `major` VALUES ('4320', '化学', null);
INSERT INTO `major` VALUES ('4321', '生物学学工程', null);
INSERT INTO `major` VALUES ('4322', '水文与水资工程', null);
INSERT INTO `major` VALUES ('4323', '产物工物', null);
INSERT INTO `major` VALUES ('4324', '电气工程及自动动化', null);
INSERT INTO `major` VALUES ('4325', '外刚语言文学类', null);
INSERT INTO `major` VALUES ('4326', '口腔退学', null);
INSERT INTO `major` VALUES ('4327', '海洋工程类', '0819');
INSERT INTO `major` VALUES ('4328', '生物医学工程类', '0826');
INSERT INTO `major` VALUES ('4329', '电了信息技术及仪器', null);
INSERT INTO `major` VALUES ('4330', '预防医学类', null);
INSERT INTO `major` VALUES ('4331', '物理工程', null);
INSERT INTO `major` VALUES ('4332', '士建类', null);
INSERT INTO `major` VALUES ('4333', '金融数学', '020305');
INSERT INTO `major` VALUES ('4334', '建筑设智能技术', null);
INSERT INTO `major` VALUES ('4335', '弼分子材料与工程', null);
INSERT INTO `major` VALUES ('4336', '环境亡程', null);
INSERT INTO `major` VALUES ('4337', '水利水电厂程', null);
INSERT INTO `major` VALUES ('4338', '测控技术与仪器.', null);
INSERT INTO `major` VALUES ('4339', '械物保护', null);
INSERT INTO `major` VALUES ('4340', '龟行器设计与工程', null);
INSERT INTO `major` VALUES ('4341', '中国共产党历史', '030502');
INSERT INTO `major` VALUES ('4342', '电子信息科学类', null);
INSERT INTO `major` VALUES ('4343', '治金工程', null);
INSERT INTO `major` VALUES ('4344', '环境经济', null);
INSERT INTO `major` VALUES ('4345', '电气信息', null);
INSERT INTO `major` VALUES ('4346', '土建类（中外）', null);
INSERT INTO `major` VALUES ('4347', '海洋经济学', null);
INSERT INTO `major` VALUES ('4348', '房地产经营与估计', null);
INSERT INTO `major` VALUES ('4349', '航空航天类', '0820');
INSERT INTO `major` VALUES ('4350', '生物化学与分子生物学', null);
INSERT INTO `major` VALUES ('4351', '资源与环境经济学', '020104');
INSERT INTO `major` VALUES ('4352', '预防医院', null);
INSERT INTO `major` VALUES ('4353', '海洋资源开发技术', '081903');
INSERT INTO `major` VALUES ('4354', '机械类（中外台作办学）', null);
INSERT INTO `major` VALUES ('4355', '材料类（中外台作办学）', null);
INSERT INTO `major` VALUES ('4356', '经济与贸易类(中外合作办学)', '0204H');
INSERT INTO `major` VALUES ('4357', '经济与贸易类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4358', '电子信息类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4359', '杌械工程', null);
INSERT INTO `major` VALUES ('4360', '疆感科学与技术', null);
INSERT INTO `major` VALUES ('4361', '经挤与贸易类(中外合作办学)', null);
INSERT INTO `major` VALUES ('4362', '耳语', null);
INSERT INTO `major` VALUES ('4363', '刑班科学技术', null);
INSERT INTO `major` VALUES ('4364', '理利试验班', null);
INSERT INTO `major` VALUES ('4365', '电子信息科学与技木', null);
INSERT INTO `major` VALUES ('4366', '电子信息娄（中外合作办学）', null);
INSERT INTO `major` VALUES ('4367', '材料科学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4368', '风景同林', null);
INSERT INTO `major` VALUES ('4369', '电气程及其自动化', null);
INSERT INTO `major` VALUES ('4370', '地球环境科学', null);
INSERT INTO `major` VALUES ('4371', '电气丁程及其自动化', null);
INSERT INTO `major` VALUES ('4372', '倍息与计算科学', null);
INSERT INTO `major` VALUES ('4373', '经济与贸易类', '0204');
INSERT INTO `major` VALUES ('4374', '上建类', null);
INSERT INTO `major` VALUES ('4375', '机械设汁制造及其自动化', null);
INSERT INTO `major` VALUES ('4376', '财政学类', '0202');
INSERT INTO `major` VALUES ('4377', '食品质療与安全', null);
INSERT INTO `major` VALUES ('4378', '软件工程', null);
INSERT INTO `major` VALUES ('4379', '生物科学类', '0710');
INSERT INTO `major` VALUES ('4380', '电气厂程及其自动化', null);
INSERT INTO `major` VALUES ('4381', '焊接技术工程', null);
INSERT INTO `major` VALUES ('4382', '屯子信息科学与技术', null);
INSERT INTO `major` VALUES ('4383', '土术工程', null);
INSERT INTO `major` VALUES ('4384', '农业电气化', '082303');
INSERT INTO `major` VALUES ('4385', '一国际经济与贸易', null);
INSERT INTO `major` VALUES ('4386', '世界史', '060102');
INSERT INTO `major` VALUES ('4387', '电器信息', null);
INSERT INTO `major` VALUES ('4388', '飞行器设汁与工程', null);
INSERT INTO `major` VALUES ('4389', '高分子材料与工段', null);
INSERT INTO `major` VALUES ('4390', '同际经济与贸易', null);
INSERT INTO `major` VALUES ('4391', '生物医学工程．', null);
INSERT INTO `major` VALUES ('4392', '飞器制造工程', null);
INSERT INTO `major` VALUES ('4393', '机械丁程', null);
INSERT INTO `major` VALUES ('4394', '冰利水电工程', null);
INSERT INTO `major` VALUES ('4395', '金腻材料工程', null);
INSERT INTO `major` VALUES ('4396', '傲学类', null);
INSERT INTO `major` VALUES ('4397', '农业工程类', '0823');
INSERT INTO `major` VALUES ('4398', '矿业类', '0815');
INSERT INTO `major` VALUES ('4399', '光信科技学与技术', null);
INSERT INTO `major` VALUES ('4400', '计算机类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4401', '环境科学与工程类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4402', '飞行器环境与生命保障工程', '082005');
INSERT INTO `major` VALUES ('4403', '士木工程', null);
INSERT INTO `major` VALUES ('4404', '高分子材料与科学', null);
INSERT INTO `major` VALUES ('4405', '交通信息与控制工程', null);
INSERT INTO `major` VALUES ('4406', '导航丁程', null);
INSERT INTO `major` VALUES ('4407', '飞行器带制造工程', null);
INSERT INTO `major` VALUES ('4408', '环境科学与工租', null);
INSERT INTO `major` VALUES ('4409', '辐射防护与核安全', '082202');
INSERT INTO `major` VALUES ('4410', '水利水工程', null);
INSERT INTO `major` VALUES ('4411', '汉语围际教育', null);
INSERT INTO `major` VALUES ('4412', '火气科学类', null);
INSERT INTO `major` VALUES ('4413', '生物利学类', null);
INSERT INTO `major` VALUES ('4414', '围际经济与贸易', null);
INSERT INTO `major` VALUES ('4415', '工科试验班类', '0060');
INSERT INTO `major` VALUES ('4416', '广播影视编导', null);
INSERT INTO `major` VALUES ('4417', '材料科学工程', null);
INSERT INTO `major` VALUES ('4418', '网络安全与执法', '083108');
INSERT INTO `major` VALUES ('4419', '材料利学与工程', null);
INSERT INTO `major` VALUES ('4420', '感应科学与技术', null);
INSERT INTO `major` VALUES ('4421', '市场营销（设有旅游市场营销和电子商务方向）', null);
INSERT INTO `major` VALUES ('4422', '生物学', null);
INSERT INTO `major` VALUES ('4423', '右油工程', null);
INSERT INTO `major` VALUES ('4424', '无机非金腻材料工程', null);
INSERT INTO `major` VALUES ('4425', '测控技术与仪特', null);
INSERT INTO `major` VALUES ('4426', '中国革命与中国共产党党史', null);
INSERT INTO `major` VALUES ('4427', '斌器系统与发射工程', null);
INSERT INTO `major` VALUES ('4428', '能源与动力工裎', null);
INSERT INTO `major` VALUES ('4429', '艺术教育', '040105');
INSERT INTO `major` VALUES ('4430', '飞行动力工程', null);
INSERT INTO `major` VALUES ('4431', '自动化（自动控制与信息技术）', null);
INSERT INTO `major` VALUES ('4432', '言语听觉科学', null);
INSERT INTO `major` VALUES ('4433', '电子工程及其自动化', null);
INSERT INTO `major` VALUES ('4434', '农业机械及其自动化', null);
INSERT INTO `major` VALUES ('4435', '电信工程及管理', '080715');
INSERT INTO `major` VALUES ('4436', '电子商务及法律', '120802');
INSERT INTO `major` VALUES ('4437', '仪器类', '0803');
INSERT INTO `major` VALUES ('4438', '飞行器质地与可靠性', null);
INSERT INTO `major` VALUES ('4439', '乳品工程', '082704');
INSERT INTO `major` VALUES ('4440', '图学馆档案学', null);
INSERT INTO `major` VALUES ('4441', '历史学（基地班）', null);
INSERT INTO `major` VALUES ('4442', '海洋工程类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4443', '电气类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4444', '经济学（数理经济学试验班）', null);
INSERT INTO `major` VALUES ('4445', '国际政治学', null);
INSERT INTO `major` VALUES ('4446', '冲国共产党历史', null);
INSERT INTO `major` VALUES ('4447', '思想政治教育（师范类）', null);
INSERT INTO `major` VALUES ('4448', '勘查技术与工程（录井技术与工程方向）', null);
INSERT INTO `major` VALUES ('4449', '武器发射工程', '082102');
INSERT INTO `major` VALUES ('4450', '特种能源技术与工程', '082105');
INSERT INTO `major` VALUES ('4451', '新闻学（经济新闻）', null);
INSERT INTO `major` VALUES ('4452', '思想政治教育（法制教育方向）', null);
INSERT INTO `major` VALUES ('4453', '法学（实验学院）', null);
INSERT INTO `major` VALUES ('4454', '计算机科学与技术（实验班）', null);
INSERT INTO `major` VALUES ('4455', '材料科学与工程（实验班）', null);
INSERT INTO `major` VALUES ('4456', '信息科学与工程类', null);
INSERT INTO `major` VALUES ('4457', '交通工程（实验班）', null);
INSERT INTO `major` VALUES ('4458', '软件工程（实验班）', null);
INSERT INTO `major` VALUES ('4459', '电子信息工程（实验班）', null);
INSERT INTO `major` VALUES ('4460', '森林保护', '090503');
INSERT INTO `major` VALUES ('4461', '公共安全管理', null);
INSERT INTO `major` VALUES ('4462', '信息管理与信息系统（金融信息化）', null);
INSERT INTO `major` VALUES ('4463', '管理科学（金融风险管理）', null);
INSERT INTO `major` VALUES ('4464', '信息与计算科学（数量金融）', null);
INSERT INTO `major` VALUES ('4465', '软件工程（企业信息化）', null);
INSERT INTO `major` VALUES ('4466', '英语（大类招生）', null);
INSERT INTO `major` VALUES ('4467', '地质类', '0814');
INSERT INTO `major` VALUES ('4468', '古典文献学', '050105');
INSERT INTO `major` VALUES ('4469', '计算机科学与技术（软件方向）', null);
INSERT INTO `major` VALUES ('4470', '城乡规划（五年制）', null);
INSERT INTO `major` VALUES ('4471', '装甲车辆工程', '082106');
INSERT INTO `major` VALUES ('4472', '建筑学（五年制）', null);
INSERT INTO `major` VALUES ('4473', '食品科学与工程类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4474', '林学类', '0905');
INSERT INTO `major` VALUES ('4475', '希腊语', '050236');
INSERT INTO `major` VALUES ('4476', '飞行器质量与可靠性', '082006');
INSERT INTO `major` VALUES ('4477', '机械成型及控制工程', null);
INSERT INTO `major` VALUES ('4478', '水产养殖业', null);
INSERT INTO `major` VALUES ('4479', '捷克语—斯洛伐克语', null);
INSERT INTO `major` VALUES ('4480', '运动康复', '040206');
INSERT INTO `major` VALUES ('4481', '纺织类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4482', '地理学基地班', null);
INSERT INTO `major` VALUES ('4483', '园林(景观设计方向）', null);
INSERT INTO `major` VALUES ('4484', '对外语言文学', null);
INSERT INTO `major` VALUES ('4485', '水产', null);
INSERT INTO `major` VALUES ('4486', '食品科学与工程类', '0827');
INSERT INTO `major` VALUES ('4487', '动物医学类', '0904');
INSERT INTO `major` VALUES ('4488', '土木工程（英语强化）', null);
INSERT INTO `major` VALUES ('4489', '外国语言文学类(中外合作办学)', '0502H');
INSERT INTO `major` VALUES ('4490', '通信工程（建筑智能化方向）', null);
INSERT INTO `major` VALUES ('4491', '工程造价（注册造价工程师方向）', null);
INSERT INTO `major` VALUES ('4492', '妇幼保地医学', null);
INSERT INTO `major` VALUES ('4493', '医学检验(临床血液检验)', null);
INSERT INTO `major` VALUES ('4494', '信用管理(金融风险控制)', null);
INSERT INTO `major` VALUES ('4495', '化学类(中外)', null);
INSERT INTO `major` VALUES ('4496', '机械电子工程（机电一体化等方向）', null);
INSERT INTO `major` VALUES ('4497', '统计学（生物统计）', null);
INSERT INTO `major` VALUES ('4498', '植物资源工程', null);
INSERT INTO `major` VALUES ('4499', '软件工程（图形图像制作等方向）', null);
INSERT INTO `major` VALUES ('4500', '林学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4501', '汉语言文学（文化创意产业方向）', null);
INSERT INTO `major` VALUES ('4502', '新闻学（法制新闻方向）', null);
INSERT INTO `major` VALUES ('4503', '工商管理（国际酒店管理）', null);
INSERT INTO `major` VALUES ('4504', '德语专业', null);
INSERT INTO `major` VALUES ('4505', '中德联合培养各专业（简称“2+3”项目）', null);
INSERT INTO `major` VALUES ('4506', '计算机科学与技术（中澳联合培养）', null);
INSERT INTO `major` VALUES ('4507', '听力与言语康复学', '101008');
INSERT INTO `major` VALUES ('4508', '食品营养与检验教育', '082707');
INSERT INTO `major` VALUES ('4509', '眼视光医学', '100204');
INSERT INTO `major` VALUES ('4510', '森林保护与游憩', null);
INSERT INTO `major` VALUES ('4511', '油气输运工程', null);
INSERT INTO `major` VALUES ('4512', '数学与应用数学（金融数学）', null);
INSERT INTO `major` VALUES ('4513', '新闻传播学类(中外合作办学)', '0503H');
INSERT INTO `major` VALUES ('4514', '政治学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4515', '护理学类(中外合作办学)', '1011H');
INSERT INTO `major` VALUES ('4516', '心理学类（中外合作办学）', null);
INSERT INTO `major` VALUES ('4517', '英语(科技英语方向)', null);
INSERT INTO `major` VALUES ('4518', '环境工程(环保与给排水方向)', null);
INSERT INTO `major` VALUES ('4519', '水利水电工程专业（水务工程专业方向）', null);
INSERT INTO `major` VALUES ('4520', '港口航道与海岸工程专业', null);
INSERT INTO `major` VALUES ('4521', '电子科学与技术（微电子方向）', null);
INSERT INTO `major` VALUES ('4522', '电气技术教育', null);
INSERT INTO `major` VALUES ('4523', '医学实验技术', '101002');
INSERT INTO `major` VALUES ('4524', '计算机科学与技术（计算机应用技术）', null);
INSERT INTO `major` VALUES ('4525', '建筑类(中外合作办学)', '0828H');
INSERT INTO `major` VALUES ('4526', '数学类(中外合作办学)', '0701H');
INSERT INTO `major` VALUES ('4527', '电子信息类（中外合作办犖）', null);
INSERT INTO `major` VALUES ('4528', '旅游管理（酒店管理方向）', null);
INSERT INTO `major` VALUES ('4529', '中医临床医学', null);
INSERT INTO `major` VALUES ('4530', '服装与服饰设计', '130505');

-- ----------------------------
-- Table structure for major_recruit
-- ----------------------------
DROP TABLE IF EXISTS `major_recruit`;
CREATE TABLE `major_recruit` (
  `majorRecruitId` int(10) NOT NULL,
  `majorId` int(10) DEFAULT NULL,
  `schoolId` smallint(6) DEFAULT NULL,
  `year` smallint(5) DEFAULT NULL,
  `mRecruitHScore` smallint(5) DEFAULT NULL,
  `mRecruitAScore` smallint(5) DEFAULT NULL,
  `categoryId` smallint(5) DEFAULT NULL,
  `batchId` smallint(5) DEFAULT NULL,
  `areaId` smallint(5) DEFAULT NULL,
  PRIMARY KEY (`majorRecruitId`),
  KEY `majorId` (`majorId`),
  KEY `schoolId` (`schoolId`),
  KEY `categoryId` (`categoryId`),
  KEY `batchId` (`batchId`),
  KEY `areaId` (`areaId`),
  CONSTRAINT `major_recruit_ibfk_1` FOREIGN KEY (`majorId`) REFERENCES `major` (`majorId`),
  CONSTRAINT `major_recruit_ibfk_2` FOREIGN KEY (`schoolId`) REFERENCES `school` (`schoolId`),
  CONSTRAINT `major_recruit_ibfk_3` FOREIGN KEY (`categoryId`) REFERENCES `category` (`categoryId`),
  CONSTRAINT `major_recruit_ibfk_4` FOREIGN KEY (`batchId`) REFERENCES `batch` (`batchId`),
  CONSTRAINT `major_recruit_ibfk_5` FOREIGN KEY (`areaId`) REFERENCES `area` (`areaId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of major_recruit
-- ----------------------------
INSERT INTO `major_recruit` VALUES ('212', '57', '8', '2013', '646', '635', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('226', '50', '8', '2013', '593', '593', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('685', '10', '6', '2010', '627', '627', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('691', '103', '6', '2010', '659', '656', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('705', '2', '6', '2010', '650', '648', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('710', '58', '6', '2010', '641', '639', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('723', '50', '6', '2010', '645', '638', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('736', '57', '6', '2010', '649', '638', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('761', '5', '6', '2010', '647', '635', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('780', '57', '6', '2011', '634', '633', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('792', '2', '6', '2011', '650', '647', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('808', '5', '6', '2011', '636', '636', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('814', '58', '6', '2011', '673', '660', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('828', '103', '6', '2011', '667', '662', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('839', '50', '6', '2011', '664', '664', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('856', '5', '6', '2012', '614', '614', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('870', '10', '6', '2012', '611', '611', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('889', '2', '6', '2012', '618', '616', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('907', '57', '6', '2012', '611', '611', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('923', '50', '6', '2012', '609', '609', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('941', '76', '6', '2012', '610', '610', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('961', '103', '6', '2012', '630', '627', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('978', '58', '6', '2012', '616', '616', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1003', '57', '6', '2013', '667', '665', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1019', '50', '6', '2013', '677', '664', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1036', '103', '6', '2013', '688', '674', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1038', '1', '14', '2010', '655', '625', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1049', '17', '14', '2010', '628', '618', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1053', '105', '6', '2013', '674', '662', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1059', '58', '6', '2013', '650', '650', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1062', '11', '14', '2010', '617', '613', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1078', '4', '14', '2010', '611', '609', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1093', '14', '14', '2010', '611', '604', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1104', '18', '14', '2010', '625', '622', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1118', '4', '14', '2011', '615', '614', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1132', '11', '14', '2011', '639', '635', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1145', '168', '5', '2010', '620', '620', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1153', '169', '14', '2012', '614', '601', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1161', '10', '5', '2010', '618', '618', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1163', '57', '14', '2012', '606', '597', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1173', '15', '5', '2010', '631', '624', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1180', '11', '14', '2012', '598', '598', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1185', '18', '5', '2010', '651', '640', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1195', '5', '14', '2013', '639', '634', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1201', '4', '5', '2010', '675', '645', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1206', '169', '14', '2013', '654', '646', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1217', '5', '5', '2010', '672', '640', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1223', '57', '14', '2013', '651', '651', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1227', '49', '5', '2010', '653', '634', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1236', '42', '5', '2010', '667', '646', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1257', '17', '5', '2010', '662', '651', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1274', '11', '5', '2010', '645', '634', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1285', '1', '5', '2010', '639', '632', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1310', '14', '5', '2010', '645', '628', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1321', '2', '5', '2010', '655', '641', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1340', '18', '5', '2011', '667', '651', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1349', '49', '5', '2011', '644', '644', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1362', '14', '5', '2011', '641', '632', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1379', '11', '5', '2011', '670', '641', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1393', '42', '5', '2011', '671', '659', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1408', '15', '5', '2011', '637', '633', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1419', '79', '5', '2011', '629', '629', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1437', '168', '5', '2011', '624', '624', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1448', '1', '5', '2011', '656', '643', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1479', '17', '5', '2011', '675', '650', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1502', '9', '5', '2011', '635', '627', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1519', '5', '5', '2011', '675', '643', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1536', '2', '5', '2011', '674', '659', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1559', '4', '5', '2011', '655', '644', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1574', '10', '5', '2011', '666', '643', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1592', '49', '5', '2012', '622', '618', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1620', '17', '5', '2012', '643', '630', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1634', '10', '5', '2012', '641', '624', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1659', '11', '5', '2012', '622', '614', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1681', '18', '5', '2012', '642', '623', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1706', '14', '5', '2012', '607', '603', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1720', '2', '5', '2012', '642', '629', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1740', '79', '5', '2012', '600', '600', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1750', '15', '5', '2012', '616', '611', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1766', '4', '5', '2012', '630', '626', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1784', '5', '5', '2012', '630', '621', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1802', '9', '5', '2012', '633', '633', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1822', '1', '5', '2012', '623', '611', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1845', '42', '5', '2012', '670', '644', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1871', '77', '5', '2013', '679', '667', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1895', '5', '5', '2013', '678', '666', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1927', '14', '5', '2013', '657', '654', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1938', '49', '5', '2013', '661', '651', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('1958', '10', '5', '2013', '663', '652', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('2066', '214', '8', '2011', '655', '627', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('2085', '57', '8', '2011', '653', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('2102', '180', '8', '2011', '652', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('2132', '180', '8', '2012', '653', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('2156', '230', '8', '2012', '657', '638', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('2175', '214', '8', '2012', '656', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('2201', '214', '8', '2013', '687', '673', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('2220', '57', '8', '2013', '666', '666', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('2241', '230', '8', '2013', '694', '677', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('2462', '57', '8', '2011', '653', '630', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('2952', '2', '14', '2010', '655', '651', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('2964', '17', '14', '2010', '667', '652', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('2985', '38', '14', '2010', '615', '615', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('2997', '30', '14', '2010', '631', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3010', '150', '14', '2010', '647', '638', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3027', '34', '14', '2010', '656', '640', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3044', '39', '14', '2010', '682', '664', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3060', '119', '14', '2010', '633', '633', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3099', '38', '14', '2011', '638', '627', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3117', '119', '14', '2011', '635', '624', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3136', '30', '14', '2011', '627', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3156', '39', '14', '2011', '658', '646', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3174', '9', '14', '2011', '631', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3193', '169', '14', '2012', '658', '648', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3217', '261', '14', '2012', '636', '629', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3240', '39', '14', '2012', '663', '648', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3270', '263', '14', '2012', '643', '638', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3296', '119', '14', '2012', '636', '633', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3322', '264', '14', '2012', '670', '650', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3344', '30', '14', '2012', '636', '633', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3361', '169', '14', '2013', '693', '683', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3388', '264', '14', '2013', '688', '680', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3399', '263', '14', '2013', '696', '684', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3441', '113', '6', '2010', '685', '668', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3456', '174', '6', '2010', '637', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3473', '105', '6', '2010', '687', '668', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3487', '103', '6', '2010', '693', '674', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3502', '94', '6', '2010', '646', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3521', '134', '6', '2010', '690', '675', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3533', '148', '6', '2010', '677', '665', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3547', '193', '6', '2010', '649', '642', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3564', '131', '6', '2010', '678', '667', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3575', '58', '6', '2010', '646', '642', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3590', '183', '6', '2010', '658', '655', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3601', '129', '6', '2010', '668', '655', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3614', '164', '22', '2010', '620', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3616', '83', '6', '2010', '675', '655', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3629', '30', '22', '2010', '631', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3634', '167', '6', '2010', '659', '649', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3643', '129', '22', '2010', '638', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3654', '107', '6', '2010', '664', '651', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3664', '116', '22', '2010', '627', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3668', '88', '6', '2010', '653', '651', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3676', '68', '22', '2010', '625', '625', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3683', '141', '6', '2010', '654', '652', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3695', '211', '22', '2010', '616', '615', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3699', '150', '6', '2010', '655', '655', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3721', '33', '22', '2010', '613', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3722', '85', '6', '2010', '666', '649', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3733', '55', '22', '2010', '646', '646', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3737', '36', '6', '2010', '686', '658', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3750', '162', '6', '2010', '646', '646', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3763', '27', '6', '2010', '679', '664', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3764', '274', '22', '2010', '635', '635', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3779', '188', '6', '2010', '688', '663', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3784', '248', '22', '2010', '637', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3794', '107', '22', '2010', '620', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3797', '2', '6', '2010', '670', '662', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3817', '105', '22', '2010', '644', '644', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3824', '200', '6', '2010', '671', '654', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3831', '25', '22', '2010', '629', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3842', '191', '6', '2010', '650', '644', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3844', '138', '22', '2010', '633', '624', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3858', '25', '6', '2010', '671', '662', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3863', '132', '22', '2010', '632', '632', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3875', '121', '6', '2010', '677', '661', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3876', '243', '22', '2010', '635', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3893', '119', '22', '2010', '630', '626', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3896', '38', '6', '2010', '673', '660', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3918', '27', '22', '2010', '609', '609', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3924', '162', '6', '2011', '670', '669', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3932', '2', '22', '2010', '610', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3947', '193', '6', '2011', '652', '646', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3948', '185', '22', '2010', '617', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3962', '112', '22', '2010', '622', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3965', '167', '6', '2011', '652', '647', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3984', '38', '6', '2011', '672', '661', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3992', '17', '22', '2010', '615', '615', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('3999', '113', '6', '2011', '673', '658', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4014', '112', '22', '2011', '631', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4015', '134', '5', '2010', '656', '656', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4016', '105', '6', '2011', '686', '671', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4027', '79', '5', '2010', '652', '652', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4029', '30', '22', '2011', '627', '615', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4031', '129', '6', '2011', '663', '655', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4044', '185', '22', '2011', '591', '580', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4046', '2', '5', '2010', '688', '679', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4050', '36', '6', '2011', '669', '652', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4058', '116', '22', '2011', '605', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4063', '200', '6', '2011', '665', '655', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4067', '150', '5', '2010', '685', '663', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4074', '129', '22', '2011', '647', '640', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4075', '58', '6', '2011', '652', '647', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4079', '17', '5', '2010', '699', '676', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4089', '164', '22', '2011', '592', '585', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4096', '183', '6', '2011', '654', '649', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4107', '138', '22', '2011', '638', '638', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4109', '255', '5', '2010', '678', '653', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4110', '103', '6', '2011', '688', '673', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4118', '25', '22', '2011', '595', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4123', '119', '5', '2010', '667', '661', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4128', '27', '6', '2011', '678', '665', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4138', '121', '5', '2010', '676', '654', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4142', '107', '22', '2011', '625', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4152', '18', '5', '2010', '679', '665', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4153', '97', '6', '2011', '668', '663', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4156', '105', '22', '2011', '665', '665', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4173', '83', '6', '2011', '674', '650', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4175', '243', '22', '2011', '646', '646', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4189', '34', '5', '2010', '686', '666', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4190', '150', '6', '2011', '655', '655', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4192', '55', '22', '2011', '661', '661', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4203', '5', '5', '2010', '662', '654', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4205', '131', '6', '2011', '652', '652', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4215', '274', '22', '2011', '597', '597', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4216', '2', '6', '2011', '677', '661', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4230', '76', '5', '2010', '684', '657', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4231', '2', '22', '2011', '608', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4235', '174', '6', '2011', '638', '638', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4244', '107', '6', '2011', '673', '657', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4246', '211', '22', '2011', '605', '585', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4254', '4', '5', '2010', '660', '649', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4268', '85', '6', '2011', '643', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4269', '33', '22', '2011', '620', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4275', '15', '5', '2010', '656', '648', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4278', '25', '6', '2011', '678', '660', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4285', '11', '5', '2010', '666', '656', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4287', '248', '22', '2011', '641', '641', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4297', '134', '6', '2011', '681', '668', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4302', '119', '22', '2011', '622', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4306', '180', '5', '2010', '677', '668', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4307', '148', '6', '2011', '668', '658', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4320', '132', '22', '2011', '612', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4325', '141', '6', '2011', '674', '657', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4327', '39', '5', '2010', '690', '670', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4340', '27', '22', '2011', '603', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4345', '191', '6', '2011', '644', '644', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4350', '25', '5', '2010', '695', '667', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4358', '94', '6', '2011', '653', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4359', '17', '22', '2011', '626', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4365', '9', '5', '2010', '643', '643', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4381', '121', '6', '2011', '688', '661', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4382', '79', '5', '2011', '668', '668', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4384', '68', '22', '2011', '606', '606', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4400', '17', '5', '2011', '683', '665', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4402', '34', '6', '2011', '674', '657', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4410', '34', '5', '2011', '689', '667', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4413', '17', '22', '2012', '581', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4421', '255', '5', '2011', '664', '660', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4428', '83', '6', '2012', '660', '652', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4431', '112', '22', '2012', '629', '629', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4433', '119', '5', '2011', '685', '660', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4450', '141', '6', '2012', '644', '642', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4452', '5', '5', '2011', '658', '650', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4456', '248', '22', '2012', '594', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4466', '9', '5', '2011', '653', '653', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4471', '94', '6', '2012', '675', '646', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4477', '116', '22', '2012', '619', '609', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4489', '34', '6', '2012', '688', '675', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4490', '49', '5', '2011', '680', '671', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4492', '2', '22', '2012', '563', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4504', '15', '5', '2011', '651', '648', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4506', '55', '22', '2012', '644', '644', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4512', '107', '6', '2012', '678', '648', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4516', '25', '5', '2011', '690', '665', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4521', '30', '22', '2012', '578', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4527', '2', '6', '2012', '663', '660', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4531', '10', '5', '2011', '670', '666', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4537', '25', '22', '2012', '543', '543', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4549', '76', '5', '2011', '637', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4554', '97', '6', '2012', '664', '662', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4558', '167', '6', '2012', '643', '640', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4564', '185', '22', '2012', '624', '606', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4575', '103', '6', '2012', '712', '672', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4581', '150', '5', '2011', '688', '670', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4583', '188', '6', '2012', '672', '664', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4587', '274', '22', '2012', '560', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4591', '60', '16', '2010', '484', '476', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('4600', '151', '6', '2012', '646', '646', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4602', '107', '22', '2012', '646', '625', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4607', '11', '5', '2011', '664', '664', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4613', '66', '16', '2010', '525', '483', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('4621', '180', '5', '2011', '676', '670', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4625', '35', '22', '2012', '606', '606', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4627', '162', '6', '2012', '647', '643', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4634', '244', '5', '2011', '663', '644', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4637', '86', '16', '2010', '454', '442', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('4640', '27', '6', '2012', '673', '658', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4648', '2', '5', '2011', '678', '673', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4649', '164', '22', '2012', '593', '586', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4659', '72', '16', '2010', '467', '450', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('4663', '183', '6', '2012', '674', '657', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4666', '121', '5', '2011', '662', '652', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4667', '27', '22', '2012', '543', '537', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4682', '214', '22', '2012', '649', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4683', '227', '16', '2011', '454', '452', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('4691', '174', '6', '2012', '644', '643', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4695', '39', '5', '2011', '679', '667', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4700', '60', '16', '2011', '485', '477', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('4708', '134', '6', '2012', '663', '663', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4710', '214', '22', '2013', '689', '668', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4718', '72', '16', '2011', '472', '458', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('4720', '134', '5', '2011', '662', '652', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4723', '105', '6', '2012', '683', '667', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4736', '52', '16', '2011', '451', '449', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('4743', '200', '6', '2012', '682', '661', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4749', '18', '5', '2011', '671', '654', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4753', '66', '16', '2011', '523', '485', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('4758', '129', '6', '2012', '666', '655', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4770', '93', '16', '2011', '468', '451', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('4774', '119', '5', '2012', '646', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4779', '85', '6', '2012', '657', '651', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4791', '150', '5', '2012', '677', '667', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4792', '121', '6', '2012', '695', '662', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4794', '86', '16', '2011', '467', '448', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('4807', '134', '5', '2012', '662', '649', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4810', '193', '6', '2012', '657', '651', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4822', '39', '5', '2012', '686', '663', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4826', '227', '16', '2012', '432', '430', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('4833', '88', '6', '2012', '647', '646', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4834', '17', '5', '2012', '683', '664', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4844', '10', '5', '2012', '657', '656', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4846', '86', '16', '2012', '436', '425', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('4849', '71', '6', '2012', '666', '664', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4858', '36', '6', '2012', '670', '654', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4864', '93', '16', '2012', '433', '427', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('4866', '34', '5', '2012', '702', '670', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4874', '148', '6', '2012', '677', '658', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4880', '66', '16', '2012', '475', '472', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('4882', '25', '5', '2012', '691', '664', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4893', '38', '6', '2012', '682', '664', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4898', '72', '16', '2012', '447', '435', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('4903', '4', '5', '2012', '678', '665', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4912', '150', '6', '2012', '643', '642', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4920', '18', '5', '2012', '668', '655', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4923', '52', '16', '2012', '432', '429', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('4927', '25', '6', '2012', '683', '661', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4936', '76', '5', '2012', '659', '645', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4938', '113', '6', '2012', '670', '661', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4945', '2', '5', '2012', '689', '669', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4948', '60', '16', '2013', '469', '467', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('4953', '11', '5', '2012', '670', '655', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4959', '162', '6', '2013', '700', '683', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4968', '66', '16', '2013', '484', '471', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('4969', '49', '5', '2012', '666', '645', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4972', '88', '6', '2013', '680', '678', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4982', '235', '5', '2012', '655', '655', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4983', '86', '16', '2013', '444', '441', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('4985', '200', '6', '2013', '698', '692', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4992', '121', '5', '2012', '678', '653', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('4998', '34', '6', '2013', '700', '695', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5005', '93', '16', '2013', '447', '445', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('5012', '255', '5', '2012', '666', '658', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5013', '188', '6', '2013', '702', '696', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5025', '5', '5', '2012', '690', '664', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5030', '174', '6', '2013', '700', '690', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5035', '244', '5', '2012', '654', '647', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5045', '85', '6', '2013', '696', '689', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5048', '15', '5', '2012', '663', '659', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5060', '180', '5', '2012', '688', '672', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5067', '57', '6', '2013', '699', '687', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5078', '113', '6', '2013', '693', '686', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5089', '150', '6', '2013', '685', '685', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5092', '49', '5', '2013', '683', '675', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5100', '5', '6', '2013', '689', '685', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5111', '182', '5', '2013', '720', '694', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5116', '151', '6', '2013', '703', '683', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5128', '25', '5', '2013', '704', '698', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5136', '141', '6', '2013', '672', '672', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5147', '5', '5', '2013', '697', '694', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5162', '97', '6', '2013', '700', '700', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5169', '105', '6', '2013', '713', '699', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('5183', '103', '6', '2013', '714', '699', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('6183', '71', '16', '2010', '470', '451', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6206', '86', '16', '2010', '464', '452', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6216', '93', '16', '2010', '472', '459', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6245', '72', '16', '2010', '477', '467', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6263', '227', '16', '2010', '462', '456', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6299', '66', '16', '2010', '522', '487', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('6318', '75', '16', '2010', '484', '480', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('6344', '60', '16', '2010', '484', '481', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('6386', '86', '16', '2011', '456', '447', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6403', '8', '28', '2011', '609', '607', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6407', '60', '16', '2011', '497', '487', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('6422', '10', '28', '2011', '613', '593', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6429', '75', '16', '2011', '487', '481', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('6445', '17', '28', '2011', '627', '590', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6447', '227', '16', '2011', '467', '456', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6463', '5', '28', '2011', '576', '570', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6469', '52', '16', '2011', '452', '451', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6489', '93', '16', '2011', '463', '454', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6490', '65', '28', '2011', '576', '574', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6514', '61', '28', '2011', '603', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6516', '71', '16', '2011', '454', '448', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6530', '72', '16', '2011', '479', '459', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6534', '12', '28', '2011', '585', '579', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6558', '66', '16', '2011', '512', '495', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('6573', '10', '28', '2012', '545', '537', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6587', '17', '28', '2012', '590', '557', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6592', '66', '16', '2012', '482', '460', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('6609', '86', '16', '2012', '430', '418', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6613', '61', '28', '2012', '585', '557', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6629', '65', '28', '2012', '536', '535', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6638', '227', '16', '2012', '436', '424', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6660', '12', '28', '2012', '541', '529', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6663', '75', '16', '2012', '460', '448', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('6680', '5', '28', '2012', '529', '527', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6685', '93', '16', '2012', '438', '421', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6694', '8', '28', '2012', '601', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6696', '60', '16', '2012', '453', '452', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('6718', '52', '16', '2012', '424', '419', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6728', '8', '28', '2013', '637', '620', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6738', '72', '16', '2012', '444', '425', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6758', '71', '16', '2012', '427', '418', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('6761', '17', '28', '2013', '614', '608', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6781', '12', '28', '2013', '602', '600', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6794', '65', '28', '2013', '613', '613', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6815', '60', '16', '2013', '443', '437', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('6825', '61', '28', '2013', '639', '623', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6829', '71', '16', '2013', '441', '437', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('6845', '5', '28', '2013', '603', '597', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6863', '86', '16', '2013', '412', '401', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('6868', '10', '28', '2013', '622', '615', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('6883', '93', '16', '2013', '414', '407', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('7133', '11', '27', '2010', '638', '626', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7149', '126', '27', '2010', '624', '624', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7161', '5', '27', '2010', '631', '620', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7174', '18', '27', '2010', '628', '618', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7194', '7', '27', '2010', '627', '618', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7220', '2', '27', '2010', '627', '617', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7223', '17', '31', '2010', '540', '535', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7242', '311', '27', '2010', '633', '617', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7250', '13', '31', '2011', '554', '547', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7260', '8', '27', '2010', '627', '616', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7266', '13', '31', '2012', '512', '507', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7280', '224', '27', '2010', '624', '615', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7282', '13', '31', '2013', '589', '581', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7301', '308', '27', '2010', '606', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7328', '14', '27', '2010', '608', '600', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7336', '15', '27', '2010', '604', '600', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7350', '266', '27', '2010', '608', '602', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7371', '4', '27', '2010', '611', '603', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7397', '50', '27', '2010', '612', '604', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7414', '213', '27', '2010', '606', '604', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7430', '136', '27', '2010', '613', '604', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7444', '300', '27', '2010', '610', '608', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7458', '21', '27', '2010', '638', '632', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7472', '17', '27', '2010', '653', '633', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7497', '36', '31', '2010', '597', '597', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('7498', '11', '27', '2011', '646', '633', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7515', '185', '31', '2010', '580', '558', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('7522', '8', '27', '2011', '641', '632', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7532', '2', '31', '2011', '521', '519', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('7534', '136', '27', '2011', '623', '623', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7546', '300', '27', '2011', '631', '617', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7555', '2', '31', '2012', '529', '521', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('7559', '18', '27', '2011', '634', '629', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7561', '113', '31', '2012', '526', '498', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('7572', '126', '27', '2011', '629', '625', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7581', '113', '31', '2013', '619', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('7593', '15', '27', '2011', '625', '618', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7611', '266', '27', '2011', '623', '621', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7632', '21', '27', '2011', '645', '638', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7646', '7', '27', '2011', '637', '631', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7662', '2', '27', '2011', '642', '630', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7681', '10', '27', '2011', '627', '626', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7691', '4', '27', '2011', '622', '616', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7712', '14', '27', '2011', '645', '633', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7734', '17', '27', '2011', '643', '634', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7751', '306', '27', '2011', '609', '609', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7769', '213', '27', '2011', '629', '623', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7798', '50', '27', '2011', '628', '628', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7818', '73', '27', '2011', '615', '615', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7835', '1', '27', '2011', '625', '624', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7852', '5', '27', '2011', '636', '626', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7866', '311', '27', '2011', '628', '628', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7901', '15', '27', '2012', '591', '584', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7917', '311', '27', '2012', '601', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7929', '136', '27', '2012', '596', '589', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7943', '300', '27', '2012', '593', '593', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7961', '9', '27', '2012', '613', '613', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('7988', '21', '27', '2012', '627', '603', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8006', '306', '27', '2012', '589', '589', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8020', '7', '27', '2012', '608', '606', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8047', '50', '27', '2012', '611', '601', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8080', '224', '27', '2012', '588', '576', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8110', '4', '27', '2012', '598', '594', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8126', '266', '27', '2012', '608', '606', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8144', '17', '27', '2012', '618', '607', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8170', '10', '27', '2012', '593', '593', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8191', '14', '27', '2012', '602', '593', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8198', '213', '27', '2012', '606', '602', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8219', '126', '27', '2012', '609', '601', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8234', '1', '27', '2012', '594', '592', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8252', '18', '27', '2012', '605', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8272', '22', '27', '2012', '579', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8288', '5', '27', '2012', '623', '607', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8302', '8', '27', '2012', '605', '598', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8322', '308', '27', '2012', '569', '569', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8338', '11', '27', '2012', '612', '607', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8357', '2', '27', '2012', '609', '600', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8389', '10', '27', '2013', '645', '633', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8402', '14', '27', '2013', '663', '648', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8417', '300', '27', '2013', '637', '637', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8438', '308', '27', '2013', '652', '646', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8459', '213', '27', '2013', '643', '640', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8476', '7', '27', '2013', '636', '622', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8493', '5', '27', '2013', '625', '617', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8521', '21', '27', '2013', '667', '647', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8536', '8', '27', '2013', '653', '645', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8562', '204', '27', '2013', '650', '649', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('8572', '17', '27', '2013', '661', '654', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('10655', '73', '27', '2010', '628', '628', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10676', '136', '27', '2010', '630', '625', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10702', '79', '27', '2010', '640', '629', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10717', '180', '27', '2010', '655', '649', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10744', '2', '27', '2010', '665', '649', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10789', '9', '27', '2010', '636', '636', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10803', '213', '27', '2010', '644', '644', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10817', '221', '27', '2010', '648', '643', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10830', '224', '27', '2010', '636', '633', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10845', '21', '27', '2010', '668', '668', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10861', '266', '27', '2010', '635', '634', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10877', '126', '27', '2010', '640', '640', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10888', '306', '27', '2010', '634', '634', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10902', '18', '27', '2010', '641', '635', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10920', '56', '27', '2010', '636', '636', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10934', '21', '39', '2010', '625', '614', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('10937', '8', '27', '2010', '658', '640', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10949', '300', '27', '2010', '641', '640', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10951', '311', '39', '2010', '606', '605', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('10963', '52', '27', '2010', '640', '640', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10964', '7', '39', '2010', '609', '603', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('10983', '52', '39', '2010', '587', '578', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('10987', '311', '27', '2010', '642', '642', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('10994', '14', '39', '2010', '588', '579', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11004', '5', '27', '2010', '645', '642', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11012', '43', '39', '2010', '584', '580', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11020', '34', '27', '2010', '643', '629', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11036', '69', '39', '2010', '593', '582', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11045', '11', '27', '2010', '654', '647', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11054', '10', '39', '2010', '593', '584', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11071', '56', '27', '2011', '620', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11080', '5', '39', '2010', '597', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11084', '52', '27', '2011', '618', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11087', '203', '39', '2010', '617', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11098', '13', '39', '2010', '590', '589', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11104', '119', '27', '2011', '622', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11118', '5', '27', '2011', '647', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11125', '58', '39', '2010', '601', '593', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11141', '136', '39', '2010', '599', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11148', '373', '27', '2011', '645', '642', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11156', '3', '39', '2010', '621', '595', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11171', '221', '27', '2011', '662', '655', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11176', '18', '39', '2010', '595', '583', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11190', '21', '27', '2011', '662', '650', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11197', '311', '39', '2011', '620', '617', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11209', '13', '39', '2011', '603', '589', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11213', '7', '27', '2011', '637', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11221', '5', '39', '2011', '610', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11227', '18', '27', '2011', '653', '644', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11237', '58', '39', '2011', '606', '603', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11242', '17', '27', '2011', '653', '650', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11253', '18', '39', '2011', '603', '593', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11268', '306', '27', '2011', '615', '615', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11272', '65', '39', '2011', '591', '587', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11281', '73', '27', '2011', '621', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11284', '14', '39', '2011', '603', '591', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11297', '311', '27', '2011', '633', '628', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11302', '10', '39', '2011', '603', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11313', '69', '39', '2011', '594', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11314', '8', '27', '2011', '646', '641', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11329', '43', '39', '2011', '600', '589', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11338', '2', '27', '2011', '645', '634', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11343', '203', '39', '2011', '607', '604', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11351', '332', '28', '2011', '604', '587', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11356', '180', '27', '2011', '647', '635', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11366', '7', '39', '2011', '616', '608', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11371', '132', '28', '2011', '611', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11372', '10', '27', '2011', '630', '628', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11375', '8', '39', '2011', '619', '614', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11388', '127', '28', '2011', '613', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11397', '3', '39', '2011', '640', '630', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11399', '266', '27', '2011', '640', '640', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11403', '36', '28', '2011', '637', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11420', '300', '27', '2011', '625', '625', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11422', '123', '28', '2011', '644', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11424', '21', '39', '2011', '631', '625', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11436', '213', '27', '2011', '631', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11437', '56', '39', '2011', '601', '599', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11444', '118', '28', '2011', '614', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11456', '136', '27', '2011', '610', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11462', '7', '39', '2012', '591', '586', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11465', '340', '28', '2011', '593', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11473', '15', '27', '2011', '625', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11478', '21', '39', '2012', '597', '594', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11484', '68', '28', '2011', '618', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11489', '126', '27', '2011', '635', '633', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11497', '10', '39', '2012', '592', '575', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11501', '79', '27', '2011', '620', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11509', '65', '39', '2012', '570', '564', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11517', '317', '28', '2011', '605', '601', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11527', '16', '27', '2011', '652', '647', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11536', '69', '39', '2012', '563', '559', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11538', '11', '27', '2011', '652', '644', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11540', '80', '28', '2011', '584', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11550', '18', '39', '2012', '588', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11556', '34', '27', '2012', '614', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11561', '5', '39', '2012', '576', '569', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11564', '149', '28', '2011', '624', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11575', '43', '39', '2012', '587', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11583', '26', '27', '2012', '633', '632', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11587', '12', '39', '2012', '585', '563', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11593', '376', '28', '2011', '588', '587', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11602', '15', '27', '2012', '629', '627', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11611', '311', '39', '2012', '591', '584', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11615', '136', '27', '2012', '631', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11618', '377', '28', '2011', '594', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11629', '58', '39', '2012', '586', '577', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11634', '40', '28', '2011', '589', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11636', '16', '27', '2012', '648', '640', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11652', '3', '39', '2012', '611', '585', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11655', '5', '27', '2012', '647', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11659', '8', '28', '2011', '635', '601', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11666', '14', '39', '2012', '569', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11674', '73', '27', '2012', '632', '632', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11686', '16', '28', '2011', '636', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11689', '13', '39', '2012', '565', '560', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11692', '300', '27', '2012', '620', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11695', '203', '39', '2012', '576', '570', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11698', '141', '28', '2011', '621', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11708', '56', '27', '2012', '640', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11713', '94', '28', '2011', '633', '605', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11716', '150', '27', '2012', '614', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11728', '324', '28', '2011', '639', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11729', '21', '27', '2012', '659', '634', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11730', '13', '39', '2013', '626', '620', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11743', '221', '27', '2012', '657', '653', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11744', '30', '28', '2011', '622', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11752', '65', '39', '2013', '615', '611', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11760', '69', '39', '2013', '617', '615', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11762', '119', '27', '2012', '627', '627', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11769', '3', '28', '2011', '605', '601', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11776', '7', '39', '2013', '652', '642', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11778', '306', '27', '2012', '625', '625', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11783', '85', '28', '2011', '598', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11795', '5', '39', '2013', '637', '626', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11797', '9', '27', '2012', '628', '628', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11808', '378', '28', '2011', '646', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11810', '126', '27', '2012', '645', '642', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11812', '58', '39', '2013', '641', '631', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11822', '134', '28', '2011', '625', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11836', '52', '27', '2012', '625', '625', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11838', '10', '39', '2013', '639', '625', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11842', '79', '28', '2011', '604', '597', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11856', '266', '27', '2012', '639', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11860', '21', '39', '2013', '666', '650', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11864', '148', '28', '2011', '591', '589', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11866', '7', '27', '2012', '640', '640', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11880', '280', '28', '2011', '618', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11883', '5', '31', '2010', '483', '475', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('11884', '12', '39', '2013', '627', '612', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11895', '13', '31', '2010', '490', '475', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('11896', '180', '27', '2012', '640', '635', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11901', '14', '39', '2013', '635', '622', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('11904', '165', '28', '2011', '632', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11910', '73', '31', '2010', '480', '475', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('11923', '2', '27', '2012', '647', '638', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11927', '88', '28', '2011', '611', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11933', '2', '31', '2010', '479', '476', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('11946', '158', '28', '2011', '630', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11947', '8', '27', '2012', '642', '636', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11956', '10', '31', '2010', '492', '477', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('11964', '115', '28', '2011', '649', '624', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11981', '224', '27', '2012', '616', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11982', '184', '28', '2011', '631', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('11984', '58', '31', '2010', '489', '485', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('11992', '168', '31', '2010', '492', '484', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12003', '109', '28', '2011', '586', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12007', '373', '27', '2012', '643', '641', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12015', '85', '27', '2012', '632', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12020', '17', '31', '2010', '494', '482', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12034', '10', '27', '2012', '627', '627', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12041', '328', '28', '2011', '643', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12044', '17', '27', '2012', '662', '650', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12054', '50', '31', '2010', '498', '482', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12060', '213', '27', '2012', '639', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12068', '151', '28', '2011', '611', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12078', '298', '28', '2011', '605', '597', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12084', '14', '27', '2012', '620', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12087', '8', '31', '2010', '491', '481', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12099', '18', '27', '2012', '627', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12102', '83', '28', '2011', '630', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12110', '9', '31', '2010', '493', '481', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12115', '11', '27', '2012', '639', '632', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12127', '260', '28', '2011', '595', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12132', '12', '31', '2010', '489', '480', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12133', '79', '27', '2012', '625', '625', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12145', '21', '31', '2010', '494', '480', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12148', '311', '27', '2012', '639', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12157', '107', '28', '2011', '645', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12161', '22', '27', '2012', '614', '586', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12163', '43', '31', '2010', '506', '479', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12175', '143', '28', '2011', '641', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12185', '69', '31', '2010', '481', '479', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12192', '300', '27', '2013', '675', '673', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12193', '38', '28', '2011', '632', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12202', '3', '31', '2010', '483', '478', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12213', '17', '28', '2011', '644', '605', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12216', '48', '31', '2010', '498', '490', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12219', '8', '27', '2013', '687', '687', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12236', '21', '31', '2011', '502', '492', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12238', '221', '27', '2013', '691', '691', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12244', '109', '28', '2012', '595', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12253', '2', '31', '2011', '499', '486', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12258', '34', '27', '2013', '680', '674', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12261', '298', '28', '2012', '597', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12270', '213', '27', '2013', '683', '683', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12272', '8', '31', '2011', '509', '491', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12285', '5', '27', '2013', '685', '678', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12292', '83', '28', '2012', '645', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12293', '150', '27', '2013', '671', '671', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12295', '3', '31', '2011', '497', '488', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12305', '22', '27', '2013', '663', '646', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12306', '141', '28', '2012', '608', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12313', '17', '31', '2011', '508', '502', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12328', '56', '27', '2013', '676', '676', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12330', '12', '31', '2011', '506', '493', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12335', '149', '28', '2012', '616', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12338', '5', '44', '2010', '597', '597', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('12340', '7', '27', '2013', '666', '654', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12343', '50', '31', '2011', '504', '496', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12359', '324', '28', '2012', '608', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12360', '17', '44', '2011', '629', '629', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('12364', '13', '31', '2011', '506', '484', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12369', '21', '27', '2013', '700', '672', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12382', '17', '31', '2012', '490', '476', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12383', '180', '28', '2012', '636', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12391', '85', '27', '2013', '670', '670', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12392', '17', '44', '2012', '607', '607', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('12398', '8', '31', '2012', '470', '470', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12403', '10', '27', '2013', '680', '679', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12409', '39', '28', '2012', '642', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12410', '50', '31', '2012', '472', '470', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12416', '17', '27', '2013', '681', '681', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12418', '5', '44', '2013', '621', '621', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('12425', '13', '31', '2012', '471', '469', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12431', '328', '28', '2012', '651', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12438', '2', '31', '2012', '476', '476', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12448', '332', '28', '2012', '603', '603', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12461', '12', '31', '2012', '474', '471', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12475', '340', '28', '2012', '633', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12491', '13', '31', '2013', '476', '465', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12506', '30', '28', '2012', '607', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12507', '12', '31', '2013', '477', '473', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12523', '50', '31', '2013', '483', '478', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('12527', '377', '28', '2012', '605', '605', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12544', '376', '28', '2012', '606', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12563', '17', '28', '2012', '639', '609', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12578', '32', '28', '2012', '605', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12597', '8', '28', '2012', '614', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12618', '16', '28', '2012', '609', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12638', '378', '28', '2012', '624', '605', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12656', '25', '28', '2012', '651', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12677', '3', '28', '2012', '624', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12696', '317', '28', '2012', '598', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12715', '2', '28', '2012', '606', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12737', '79', '28', '2012', '607', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12759', '158', '28', '2012', '614', '609', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12770', '148', '28', '2012', '606', '597', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12790', '150', '28', '2012', '616', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12806', '134', '28', '2012', '620', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12837', '260', '28', '2012', '608', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12858', '165', '28', '2012', '650', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12877', '151', '28', '2012', '599', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12900', '112', '28', '2012', '599', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12916', '107', '28', '2012', '642', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12933', '132', '28', '2012', '605', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12952', '118', '28', '2012', '630', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12962', '127', '28', '2012', '632', '606', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12976', '85', '28', '2012', '600', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('12992', '36', '28', '2012', '633', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13010', '143', '28', '2012', '653', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13012', '8', '45', '2010', '606', '594', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13029', '5', '45', '2010', '595', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13035', '80', '28', '2012', '596', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13040', '3', '45', '2010', '620', '613', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13053', '68', '28', '2012', '615', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13057', '21', '45', '2010', '604', '603', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13081', '88', '28', '2012', '596', '589', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13083', '311', '45', '2010', '605', '601', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13099', '139', '45', '2011', '574', '567', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13110', '58', '45', '2011', '581', '568', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13112', '196', '28', '2012', '622', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13130', '5', '45', '2011', '621', '598', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13139', '123', '28', '2012', '645', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13151', '3', '45', '2011', '619', '608', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13156', '115', '28', '2012', '641', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13165', '266', '45', '2011', '579', '564', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13175', '38', '28', '2012', '645', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13178', '21', '45', '2012', '601', '594', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13190', '7', '45', '2012', '581', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13196', '3', '45', '2012', '589', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13199', '280', '28', '2012', '626', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13216', '139', '45', '2012', '580', '572', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13230', '83', '28', '2013', '672', '646', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13234', '58', '45', '2012', '589', '575', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13241', '17', '28', '2013', '643', '638', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13262', '8', '28', '2013', '652', '642', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13266', '7', '45', '2013', '611', '610', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13276', '58', '45', '2013', '614', '602', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('13282', '141', '28', '2013', '646', '641', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13303', '151', '28', '2013', '653', '645', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13319', '113', '28', '2013', '646', '641', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('13338', '180', '28', '2013', '686', '664', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14079', '2', '45', '2010', '592', '579', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14085', '79', '45', '2010', '591', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14100', '89', '45', '2010', '602', '587', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14114', '17', '45', '2010', '630', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14133', '21', '45', '2010', '633', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14145', '3', '45', '2010', '637', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14157', '23', '45', '2010', '625', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14166', '266', '45', '2010', '617', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14184', '16', '45', '2010', '615', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14200', '7', '45', '2010', '606', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14220', '7', '45', '2011', '609', '603', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14232', '21', '45', '2011', '643', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14241', '83', '44', '2010', '649', '644', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14245', '354', '45', '2011', '618', '615', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14252', '311', '39', '2010', '628', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14258', '17', '45', '2011', '625', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14259', '116', '44', '2010', '660', '646', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14265', '26', '39', '2010', '621', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14271', '2', '45', '2011', '610', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14281', '79', '39', '2010', '612', '609', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14283', '3', '45', '2011', '642', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14285', '34', '44', '2010', '642', '642', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14292', '38', '39', '2010', '608', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14293', '16', '45', '2011', '635', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14303', '185', '44', '2010', '638', '636', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14307', '8', '45', '2011', '621', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14313', '120', '39', '2010', '616', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14316', '121', '44', '2010', '663', '663', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14323', '23', '45', '2011', '632', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14329', '89', '39', '2010', '618', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14331', '342', '44', '2010', '637', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14343', '79', '45', '2011', '602', '601', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14346', '94', '44', '2010', '645', '641', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14347', '78', '39', '2010', '615', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14356', '353', '39', '2010', '611', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14366', '10', '44', '2010', '647', '638', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14368', '136', '45', '2012', '611', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14369', '56', '39', '2010', '618', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14380', '21', '45', '2012', '634', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14381', '8', '39', '2010', '639', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14388', '79', '45', '2012', '596', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14393', '16', '39', '2010', '640', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14398', '190', '44', '2010', '642', '641', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14403', '17', '45', '2012', '607', '606', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14405', '3', '39', '2010', '645', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14409', '97', '44', '2010', '649', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14416', '2', '45', '2012', '596', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14421', '23', '39', '2010', '640', '626', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14432', '396', '44', '2010', '628', '628', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14433', '16', '45', '2012', '616', '603', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14434', '17', '39', '2010', '638', '629', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14448', '5', '45', '2012', '590', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14450', '30', '44', '2010', '644', '643', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14456', '97', '39', '2010', '637', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14458', '8', '45', '2012', '610', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14470', '17', '44', '2010', '642', '641', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14471', '3', '45', '2012', '634', '625', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14472', '21', '39', '2010', '655', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14482', '221', '39', '2010', '658', '644', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14491', '116', '44', '2011', '659', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14494', '354', '39', '2010', '626', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14501', '5', '45', '2013', '646', '638', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14512', '83', '44', '2011', '639', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14515', '126', '39', '2010', '620', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14530', '266', '39', '2010', '636', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14537', '97', '44', '2011', '648', '638', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14540', '2', '39', '2010', '622', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14549', '17', '44', '2011', '638', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14553', '146', '39', '2010', '617', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14562', '178', '39', '2010', '623', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14575', '342', '44', '2011', '638', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14576', '379', '39', '2010', '618', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14586', '7', '39', '2010', '625', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14589', '30', '44', '2011', '629', '629', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14610', '94', '44', '2011', '647', '640', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14628', '185', '44', '2011', '635', '633', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14630', '353', '39', '2011', '606', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14639', '52', '39', '2011', '599', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14651', '221', '39', '2011', '642', '624', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14659', '363', '44', '2012', '668', '643', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14668', '266', '39', '2011', '633', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14674', '214', '44', '2012', '652', '651', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14684', '21', '39', '2011', '662', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14688', '342', '44', '2012', '641', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14696', '78', '39', '2011', '602', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14702', '396', '44', '2012', '633', '633', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14708', '7', '39', '2011', '634', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14716', '11', '48', '2010', '527', '527', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('14721', '17', '39', '2011', '630', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14728', '97', '39', '2011', '623', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14732', '30', '44', '2012', '636', '636', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14737', '17', '48', '2010', '530', '530', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('14743', '26', '39', '2011', '601', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14751', '146', '39', '2011', '609', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14754', '86', '48', '2010', '556', '556', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('14755', '94', '44', '2012', '654', '652', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14769', '311', '39', '2011', '629', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14774', '185', '44', '2012', '636', '632', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14781', '120', '39', '2011', '602', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14791', '97', '44', '2012', '643', '643', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14792', '354', '39', '2011', '616', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14801', '12', '48', '2011', '534', '529', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('14804', '17', '44', '2012', '646', '646', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14810', '43', '39', '2011', '597', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14815', '11', '48', '2011', '545', '537', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('14818', '190', '44', '2012', '637', '636', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14824', '126', '39', '2011', '613', '606', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14828', '116', '44', '2012', '654', '642', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14831', '136', '39', '2011', '607', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14841', '12', '48', '2012', '505', '505', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('14842', '215', '44', '2012', '634', '634', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14846', '2', '39', '2011', '618', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14857', '11', '48', '2012', '497', '496', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('14862', '83', '44', '2012', '636', '629', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14864', '14', '39', '2011', '616', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14879', '379', '39', '2011', '611', '603', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14881', '151', '44', '2013', '684', '675', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14897', '56', '39', '2011', '611', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14905', '79', '39', '2011', '611', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14908', '97', '44', '2013', '681', '677', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14926', '16', '39', '2011', '620', '609', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14942', '89', '39', '2011', '610', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14955', '23', '39', '2011', '625', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14972', '8', '39', '2011', '631', '609', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('14989', '178', '39', '2011', '608', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15003', '38', '39', '2011', '604', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15011', '3', '39', '2011', '646', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15045', '311', '39', '2012', '633', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15060', '266', '39', '2012', '642', '624', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15077', '97', '39', '2012', '644', '629', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15093', '190', '39', '2012', '605', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15120', '56', '39', '2012', '622', '606', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15131', '146', '39', '2012', '620', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15146', '221', '39', '2012', '635', '628', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15158', '79', '39', '2012', '611', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15169', '7', '39', '2012', '626', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15181', '23', '39', '2012', '632', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15198', '126', '39', '2012', '651', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15211', '3', '39', '2012', '643', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15224', '78', '39', '2012', '617', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15234', '2', '39', '2012', '622', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15248', '16', '39', '2012', '633', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15261', '38', '39', '2012', '603', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15278', '89', '39', '2012', '607', '605', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15291', '120', '39', '2012', '622', '606', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15305', '17', '39', '2012', '643', '624', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15322', '354', '39', '2012', '626', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15343', '353', '39', '2012', '609', '601', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15356', '52', '39', '2012', '608', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15368', '379', '39', '2012', '619', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15384', '21', '39', '2012', '660', '634', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15399', '136', '39', '2012', '612', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15419', '26', '39', '2012', '617', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15435', '178', '39', '2012', '609', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15447', '8', '39', '2012', '629', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15463', '224', '39', '2012', '613', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15807', '28', '48', '2010', '529', '529', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15823', '157', '48', '2010', '515', '515', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15836', '179', '48', '2010', '522', '509', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15848', '12', '51', '2010', '613', '612', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('15849', '95', '48', '2010', '505', '505', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15856', '10', '51', '2010', '608', '605', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('15868', '116', '48', '2010', '505', '505', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15871', '9', '51', '2010', '606', '606', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('15881', '2', '51', '2010', '601', '598', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('15891', '1', '51', '2010', '621', '614', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('15893', '27', '48', '2010', '571', '543', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15903', '13', '51', '2010', '616', '610', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('15919', '5', '51', '2010', '603', '600', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('15929', '67', '51', '2010', '611', '608', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('15934', '51', '51', '2010', '616', '607', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('15936', '399', '48', '2011', '507', '504', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15949', '21', '51', '2010', '604', '602', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('15954', '27', '48', '2011', '526', '512', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15961', '8', '51', '2010', '609', '605', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('15969', '86', '48', '2011', '501', '501', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15982', '409', '51', '2010', '616', '606', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('15989', '95', '48', '2011', '512', '505', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('15995', '52', '51', '2010', '604', '594', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16011', '95', '48', '2012', '545', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('16016', '58', '31', '2010', '493', '487', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16020', '179', '48', '2012', '508', '495', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('16024', '105', '31', '2010', '501', '490', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16030', '27', '48', '2012', '549', '522', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('16031', '48', '31', '2010', '509', '492', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16033', '13', '51', '2011', '631', '619', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16040', '12', '31', '2010', '497', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16044', '1', '51', '2011', '627', '614', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16051', '17', '31', '2010', '509', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16054', '409', '51', '2011', '600', '597', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16057', '310', '48', '2013', '651', '629', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('16062', '2', '31', '2010', '495', '485', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16073', '43', '31', '2010', '490', '484', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16074', '95', '48', '2013', '615', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('16075', '51', '51', '2011', '616', '607', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16079', '68', '31', '2010', '494', '484', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16082', '5', '51', '2011', '603', '597', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16092', '21', '51', '2011', '611', '605', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16093', '28', '48', '2013', '580', '574', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('16094', '168', '31', '2010', '497', '484', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16101', '180', '31', '2010', '503', '484', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16103', '67', '51', '2011', '619', '606', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16109', '88', '31', '2010', '486', '483', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16113', '10', '51', '2011', '619', '610', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16115', '156', '31', '2010', '484', '474', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16118', '126', '51', '2011', '600', '599', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16121', '8', '51', '2011', '614', '606', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16122', '34', '31', '2010', '498', '477', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16136', '381', '31', '2010', '477', '476', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16147', '115', '31', '2010', '492', '476', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16154', '1', '51', '2012', '616', '598', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16157', '229', '31', '2010', '484', '476', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16166', '409', '51', '2012', '579', '576', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16176', '36', '31', '2010', '497', '475', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16179', '67', '51', '2012', '599', '587', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16189', '94', '31', '2010', '486', '475', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16193', '10', '51', '2012', '579', '578', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16198', '161', '31', '2010', '484', '475', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16200', '51', '51', '2012', '604', '591', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16207', '79', '31', '2010', '481', '474', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16211', '50', '51', '2012', '617', '612', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16215', '99', '31', '2010', '485', '474', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16222', '126', '51', '2012', '580', '576', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16224', '38', '31', '2010', '484', '474', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16239', '8', '51', '2012', '568', '566', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16243', '132', '31', '2010', '495', '474', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16249', '141', '31', '2010', '491', '474', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16250', '21', '51', '2012', '586', '582', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16260', '13', '51', '2012', '615', '597', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16263', '83', '31', '2010', '482', '477', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16272', '21', '31', '2010', '485', '478', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16284', '331', '31', '2010', '485', '479', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16293', '69', '31', '2010', '485', '483', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16301', '13', '31', '2010', '488', '483', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16306', '73', '31', '2010', '485', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16313', '8', '51', '2013', '651', '647', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16315', '164', '31', '2010', '487', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16325', '50', '51', '2013', '653', '647', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16329', '129', '31', '2010', '494', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16332', '13', '51', '2013', '661', '645', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16339', '1', '51', '2013', '644', '642', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16340', '39', '31', '2010', '497', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16349', '5', '51', '2013', '649', '641', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16353', '8', '31', '2010', '497', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16368', '51', '51', '2013', '645', '635', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16377', '10', '31', '2010', '487', '481', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16385', '21', '51', '2013', '639', '632', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16387', '85', '31', '2010', '486', '479', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16393', '40', '31', '2010', '496', '479', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16396', '10', '51', '2013', '637', '628', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16406', '3', '31', '2010', '490', '479', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16415', '5', '31', '2010', '498', '480', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16423', '37', '31', '2010', '495', '480', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16453', '79', '31', '2011', '482', '475', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16465', '94', '31', '2011', '498', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16475', '310', '31', '2011', '488', '483', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16490', '180', '31', '2011', '522', '496', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16503', '2', '31', '2011', '504', '485', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16516', '8', '31', '2011', '497', '483', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16526', '3', '31', '2011', '489', '480', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16535', '37', '31', '2011', '499', '488', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16543', '12', '31', '2011', '488', '479', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16554', '50', '31', '2011', '504', '498', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16568', '115', '31', '2011', '488', '479', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16576', '83', '31', '2011', '501', '488', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16589', '13', '31', '2011', '502', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16596', '57', '57', '2012', '594', '556', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16597', '21', '31', '2011', '503', '484', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16606', '17', '31', '2011', '517', '505', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16615', '40', '31', '2011', '488', '479', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16624', '143', '31', '2011', '507', '492', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16627', '57', '57', '2013', '657', '617', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('16640', '420', '57', '2013', '530', '503', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('16679', '2', '31', '2012', '472', '453', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16692', '8', '31', '2012', '472', '455', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16701', '123', '31', '2012', '460', '457', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16722', '50', '31', '2012', '486', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16735', '17', '31', '2012', '481', '472', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16741', '94', '31', '2012', '468', '452', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16746', '37', '31', '2012', '464', '461', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16753', '143', '31', '2012', '466', '454', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16762', '38', '31', '2012', '463', '459', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16771', '115', '31', '2012', '459', '449', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16784', '40', '31', '2012', '462', '454', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16794', '79', '31', '2012', '458', '447', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16805', '180', '31', '2012', '476', '469', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16820', '83', '31', '2012', '456', '452', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16835', '13', '31', '2012', '463', '452', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16854', '156', '31', '2012', '460', '458', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16870', '310', '31', '2012', '460', '459', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16885', '12', '31', '2012', '462', '458', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16906', '113', '31', '2013', '452', '432', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16927', '310', '31', '2013', '454', '446', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16937', '13', '31', '2013', '464', '447', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16951', '156', '31', '2013', '474', '447', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16964', '55', '31', '2013', '460', '449', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16977', '129', '31', '2013', '451', '451', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('16990', '12', '31', '2013', '445', '445', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('17009', '105', '31', '2013', '459', '455', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('17650', '418', '51', '2010', '645', '624', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17657', '21', '51', '2010', '639', '628', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17666', '415', '51', '2010', '650', '628', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17679', '17', '51', '2010', '635', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17690', '175', '51', '2010', '638', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17698', '76', '51', '2010', '653', '634', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17705', '97', '51', '2010', '650', '641', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17712', '34', '51', '2010', '636', '627', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17720', '150', '51', '2010', '638', '624', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17726', '124', '51', '2010', '612', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17739', '3', '51', '2010', '625', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17747', '279', '59', '2010', '587', '579', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17750', '119', '51', '2010', '618', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17751', '13', '59', '2010', '576', '576', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17760', '10', '51', '2010', '633', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17762', '59', '59', '2010', '586', '586', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17771', '17', '59', '2010', '577', '577', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17773', '126', '51', '2010', '611', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17778', '159', '59', '2010', '573', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17783', '255', '51', '2010', '616', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17786', '63', '59', '2010', '581', '581', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17793', '417', '51', '2010', '639', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17801', '26', '51', '2010', '619', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17802', '63', '59', '2011', '553', '553', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17809', '5', '59', '2011', '583', '581', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17811', '5', '51', '2010', '616', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17820', '168', '59', '2011', '589', '589', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17833', '10', '59', '2011', '543', '543', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17842', '418', '51', '2011', '655', '624', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17845', '178', '59', '2011', '584', '584', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17857', '150', '51', '2011', '631', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17859', '126', '59', '2011', '616', '616', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17865', '417', '51', '2011', '604', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17878', '17', '51', '2011', '623', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17882', '21', '59', '2012', '522', '522', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17889', '10', '59', '2012', '541', '541', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17894', '21', '51', '2011', '638', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17897', '13', '59', '2012', '547', '547', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17913', '34', '51', '2011', '616', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17917', '69', '59', '2012', '507', '507', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17925', '10', '51', '2011', '621', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17934', '126', '59', '2012', '544', '544', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17943', '76', '51', '2011', '650', '635', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17945', '64', '59', '2012', '517', '517', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17955', '175', '51', '2011', '620', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17968', '10', '59', '2013', '625', '625', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17970', '415', '51', '2011', '629', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17982', '58', '59', '2013', '610', '606', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('17989', '119', '51', '2011', '625', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('17999', '13', '59', '2013', '638', '638', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18011', '3', '51', '2011', '603', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18025', '97', '51', '2011', '649', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18034', '126', '51', '2011', '614', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18067', '34', '51', '2012', '630', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18092', '51', '51', '2012', '625', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18110', '150', '51', '2012', '635', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18122', '418', '51', '2012', '648', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18134', '279', '51', '2012', '630', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18149', '97', '51', '2012', '633', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18165', '10', '51', '2012', '638', '638', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18186', '175', '51', '2012', '608', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18200', '417', '51', '2012', '610', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18223', '21', '51', '2012', '626', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18241', '180', '51', '2012', '638', '636', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18251', '126', '51', '2012', '636', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18263', '3', '51', '2012', '600', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18275', '76', '51', '2012', '657', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18293', '415', '51', '2012', '615', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18312', '119', '51', '2012', '629', '628', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18329', '17', '51', '2012', '632', '629', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18374', '5', '51', '2013', '666', '660', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18388', '51', '51', '2013', '665', '660', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18403', '17', '51', '2013', '669', '659', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18424', '415', '51', '2013', '665', '660', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18435', '10', '51', '2013', '666', '653', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18453', '21', '51', '2013', '665', '661', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18462', '150', '51', '2013', '669', '661', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18479', '34', '51', '2013', '683', '659', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18494', '119', '51', '2013', '665', '664', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18509', '97', '51', '2013', '682', '667', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18525', '180', '51', '2013', '676', '672', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18545', '8', '51', '2013', '670', '669', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18566', '12', '61', '2010', '557', '556', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18579', '5', '61', '2010', '568', '568', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18587', '52', '61', '2010', '565', '563', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18607', '10', '61', '2010', '587', '587', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18619', '8', '61', '2010', '586', '582', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18644', '10', '61', '2011', '578', '578', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18662', '5', '61', '2011', '570', '560', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18663', '76', '59', '2010', '607', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18672', '143', '59', '2010', '598', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18674', '52', '61', '2011', '590', '569', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18683', '39', '59', '2010', '595', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18685', '8', '61', '2011', '596', '575', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18691', '12', '61', '2011', '568', '562', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18695', '275', '59', '2010', '594', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18703', '140', '59', '2010', '569', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18709', '8', '61', '2012', '561', '559', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18712', '30', '59', '2010', '574', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18719', '12', '61', '2012', '563', '554', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18720', '14', '59', '2010', '555', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18729', '281', '59', '2010', '572', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18730', '5', '61', '2012', '545', '545', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18743', '10', '61', '2012', '549', '547', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18745', '17', '59', '2010', '581', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18754', '202', '59', '2010', '585', '585', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18761', '52', '61', '2012', '554', '551', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18782', '9', '59', '2011', '571', '566', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18783', '10', '61', '2013', '613', '611', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18792', '202', '59', '2011', '593', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18793', '8', '61', '2013', '625', '624', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18802', '281', '59', '2011', '590', '590', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18803', '12', '61', '2013', '602', '601', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18813', '39', '59', '2011', '620', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18820', '5', '61', '2013', '587', '586', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('18823', '275', '59', '2011', '563', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18838', '21', '59', '2011', '574', '566', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18850', '56', '59', '2011', '591', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18861', '17', '59', '2011', '562', '562', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18872', '143', '59', '2011', '556', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18885', '30', '59', '2011', '555', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18913', '38', '59', '2012', '591', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18929', '281', '59', '2012', '581', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18938', '9', '59', '2012', '554', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18949', '17', '59', '2012', '589', '589', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18965', '39', '59', '2012', '573', '573', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18973', '275', '59', '2012', '573', '573', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18979', '112', '57', '2011', '624', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18981', '21', '59', '2012', '596', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18992', '83', '57', '2011', '629', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('18996', '30', '59', '2012', '563', '557', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19001', '36', '57', '2011', '631', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19006', '56', '59', '2013', '648', '648', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19011', '68', '57', '2011', '611', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19014', '17', '59', '2013', '639', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19025', '21', '57', '2011', '619', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19041', '85', '57', '2011', '610', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19052', '37', '57', '2011', '638', '629', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19064', '30', '57', '2011', '619', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19070', '332', '57', '2011', '625', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19077', '180', '57', '2011', '670', '640', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19087', '88', '57', '2011', '618', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19099', '115', '57', '2011', '611', '603', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19115', '424', '57', '2011', '626', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19128', '129', '57', '2011', '602', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19137', '94', '57', '2011', '618', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19155', '328', '57', '2011', '627', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19164', '164', '57', '2011', '616', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19174', '38', '57', '2011', '640', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19195', '30', '57', '2012', '624', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19204', '2', '57', '2012', '610', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19214', '37', '57', '2012', '649', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19220', '112', '57', '2012', '630', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19227', '180', '57', '2012', '662', '642', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19233', '39', '57', '2012', '627', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19247', '21', '57', '2012', '625', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19262', '150', '57', '2012', '598', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19284', '38', '57', '2012', '646', '632', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19306', '83', '57', '2012', '637', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19318', '85', '57', '2012', '592', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19332', '328', '57', '2012', '655', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19353', '88', '57', '2012', '620', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19364', '129', '57', '2012', '614', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19387', '113', '57', '2012', '631', '627', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19397', '424', '57', '2012', '620', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19412', '115', '57', '2012', '635', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19427', '36', '57', '2012', '632', '625', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19439', '34', '57', '2012', '637', '609', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19452', '68', '57', '2012', '631', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19466', '94', '57', '2012', '627', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19478', '332', '57', '2012', '640', '628', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19576', '238', '57', '2013', '665', '657', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19588', '332', '57', '2013', '699', '674', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19608', '180', '57', '2013', '696', '683', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19623', '83', '57', '2013', '663', '660', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('19825', '10', '68', '2011', '572', '572', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('22660', '58', '39', '2010', '508', '505', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22674', '52', '39', '2010', '512', '505', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22690', '10', '39', '2010', '515', '511', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22706', '21', '39', '2010', '518', '516', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22715', '5', '39', '2010', '503', '498', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22736', '311', '39', '2011', '512', '510', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22758', '18', '39', '2011', '508', '505', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22779', '21', '39', '2011', '516', '515', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22788', '203', '39', '2011', '508', '502', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22801', '5', '39', '2011', '510', '506', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22821', '311', '39', '2012', '480', '480', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22835', '203', '39', '2012', '498', '481', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22848', '3', '39', '2012', '491', '486', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22861', '5', '39', '2012', '472', '472', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22884', '43', '39', '2012', '480', '480', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22900', '18', '39', '2012', '475', '475', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('22916', '5', '39', '2013', '478', '475', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('23137', '13', '75', '2010', '589', '578', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23153', '10', '75', '2010', '586', '583', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23174', '58', '75', '2010', '605', '597', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23195', '63', '75', '2010', '585', '582', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23215', '62', '75', '2010', '582', '579', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23234', '17', '75', '2010', '590', '579', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23251', '5', '75', '2010', '573', '568', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23269', '14', '75', '2010', '590', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23292', '43', '75', '2010', '586', '575', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23317', '48', '75', '2010', '589', '587', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23336', '69', '75', '2010', '595', '590', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23351', '40', '68', '2010', '594', '585', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23355', '451', '75', '2010', '629', '606', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23370', '99', '68', '2010', '618', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23377', '62', '75', '2011', '591', '586', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23391', '14', '75', '2011', '573', '572', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23392', '36', '68', '2010', '554', '537', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23402', '63', '75', '2011', '589', '586', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23404', '38', '68', '2010', '572', '532', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23425', '59', '75', '2011', '604', '602', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23428', '317', '68', '2010', '533', '527', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23439', '113', '68', '2010', '590', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23446', '13', '75', '2011', '590', '584', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23447', '438', '68', '2010', '558', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23463', '141', '68', '2010', '577', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23467', '69', '75', '2011', '595', '594', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23480', '58', '75', '2011', '627', '614', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23492', '184', '68', '2010', '553', '533', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23497', '64', '75', '2011', '585', '581', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23514', '67', '75', '2011', '608', '591', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23528', '226', '68', '2011', '509', '502', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23533', '10', '75', '2011', '633', '605', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23547', '209', '68', '2011', '518', '504', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23559', '67', '75', '2012', '595', '584', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23562', '99', '68', '2011', '593', '568', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23573', '36', '68', '2011', '546', '541', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23574', '5', '75', '2012', '563', '553', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23587', '437', '68', '2011', '533', '514', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23588', '10', '75', '2012', '582', '568', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23603', '322', '75', '2012', '563', '559', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23605', '113', '68', '2011', '586', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23623', '451', '75', '2012', '583', '574', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23625', '40', '68', '2011', '554', '539', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23639', '64', '75', '2012', '562', '561', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23644', '141', '68', '2011', '556', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23653', '203', '75', '2012', '566', '566', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23660', '184', '68', '2011', '590', '522', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23664', '62', '75', '2012', '560', '557', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23672', '438', '68', '2011', '551', '531', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23683', '48', '75', '2012', '587', '577', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23687', '38', '68', '2011', '511', '507', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23696', '58', '75', '2012', '589', '577', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23711', '63', '75', '2012', '565', '564', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23723', '43', '75', '2012', '558', '556', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23729', '2', '68', '2012', '558', '557', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23741', '13', '75', '2012', '571', '567', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23744', '226', '68', '2012', '536', '511', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23761', '62', '75', '2013', '616', '614', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23763', '118', '68', '2012', '520', '508', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23772', '113', '68', '2012', '500', '500', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23776', '59', '75', '2013', '644', '636', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23792', '58', '75', '2013', '660', '652', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23797', '437', '68', '2012', '541', '528', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23805', '322', '75', '2013', '625', '623', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23815', '36', '68', '2012', '544', '531', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23821', '14', '75', '2013', '616', '615', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23822', '40', '68', '2012', '514', '507', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23842', '10', '68', '2012', '505', '500', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23844', '67', '75', '2013', '639', '630', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23846', '23', '39', '2010', '507', '506', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('23859', '8', '39', '2010', '505', '504', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('23867', '10', '75', '2013', '615', '608', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23869', '438', '68', '2012', '538', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23876', '3', '39', '2010', '519', '507', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('23882', '13', '75', '2013', '615', '608', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('23895', '5', '68', '2013', '569', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23905', '89', '39', '2010', '500', '499', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('23915', '40', '68', '2013', '640', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23931', '120', '39', '2010', '499', '498', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('23934', '10', '68', '2013', '570', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23944', '118', '68', '2013', '598', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23950', '78', '39', '2010', '505', '502', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('23968', '17', '39', '2010', '524', '520', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('23971', '226', '68', '2013', '634', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('23993', '221', '39', '2010', '534', '520', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24000', '368', '68', '2013', '604', '586', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('24009', '21', '39', '2010', '526', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24015', '12', '68', '2013', '571', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('24023', '266', '39', '2010', '502', '500', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24027', '129', '68', '2013', '508', '508', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('24045', '126', '39', '2011', '510', '509', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24062', '89', '39', '2011', '510', '509', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24075', '3', '39', '2011', '521', '520', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24095', '16', '39', '2011', '513', '511', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24109', '379', '39', '2011', '510', '509', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24129', '79', '39', '2011', '509', '508', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24154', '7', '39', '2011', '519', '515', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24169', '21', '39', '2011', '531', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24189', '221', '39', '2011', '526', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24210', '52', '39', '2011', '508', '507', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24223', '43', '39', '2011', '506', '506', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24235', '78', '39', '2011', '518', '516', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24259', '17', '39', '2011', '522', '521', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24288', '56', '39', '2011', '515', '511', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24313', '79', '39', '2012', '475', '470', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24328', '17', '39', '2012', '495', '490', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24354', '3', '39', '2012', '480', '479', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24364', '21', '39', '2012', '500', '493', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24379', '16', '39', '2012', '481', '478', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24407', '89', '39', '2012', '469', '468', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24420', '221', '39', '2012', '483', '481', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24433', '7', '39', '2012', '478', '473', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24437', '78', '39', '2012', '478', '476', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24464', '56', '39', '2012', '470', '470', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24480', '2', '79', '2010', '585', '563', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24484', '379', '39', '2012', '474', '472', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24496', '17', '79', '2010', '588', '579', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24511', '52', '39', '2012', '468', '467', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24514', '67', '79', '2010', '581', '570', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24542', '56', '39', '2013', '461', '460', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24545', '10', '79', '2011', '588', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24558', '7', '39', '2013', '475', '469', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24559', '5', '79', '2011', '580', '577', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24577', '2', '79', '2011', '616', '591', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24587', '21', '39', '2013', '470', '467', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24602', '17', '79', '2011', '596', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24603', '17', '39', '2013', '468', '468', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24615', '67', '79', '2011', '587', '570', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24628', '221', '39', '2013', '487', '481', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('24634', '5', '79', '2012', '555', '553', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24646', '44', '79', '2012', '566', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24673', '10', '79', '2012', '565', '564', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24690', '169', '79', '2012', '579', '569', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24706', '67', '79', '2012', '561', '560', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24734', '10', '79', '2013', '611', '611', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24749', '169', '79', '2013', '634', '628', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24763', '5', '79', '2013', '618', '616', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('24780', '44', '79', '2013', '619', '612', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('25110', '69', '75', '2010', '632', '603', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25128', '67', '75', '2010', '616', '606', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25147', '101', '75', '2010', '577', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25168', '92', '75', '2010', '616', '601', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25198', '116', '75', '2010', '610', '589', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25220', '158', '75', '2010', '582', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25237', '38', '75', '2010', '576', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25273', '451', '75', '2011', '633', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25287', '79', '75', '2011', '608', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25305', '466', '75', '2011', '606', '603', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25320', '38', '75', '2011', '539', '523', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25335', '2', '75', '2011', '589', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25351', '16', '75', '2011', '582', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25371', '116', '75', '2011', '608', '562', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25392', '143', '75', '2012', '570', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25408', '17', '75', '2012', '588', '579', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25424', '67', '75', '2012', '628', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25433', '37', '75', '2012', '545', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25451', '158', '75', '2012', '551', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25471', '468', '75', '2012', '605', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25487', '466', '75', '2012', '627', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25510', '38', '75', '2012', '556', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25533', '458', '75', '2012', '581', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25558', '469', '75', '2012', '577', '566', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25578', '190', '75', '2012', '539', '538', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25601', '205', '75', '2012', '587', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25619', '2', '75', '2012', '581', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25639', '79', '75', '2012', '557', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25660', '69', '75', '2012', '600', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25689', '92', '75', '2012', '594', '589', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25715', '92', '75', '2013', '645', '635', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25735', '59', '75', '2013', '664', '655', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25751', '10', '75', '2013', '661', '650', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('25777', '69', '75', '2013', '654', '649', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27171', '129', '79', '2010', '620', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27192', '88', '79', '2010', '601', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27206', '146', '79', '2010', '605', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27225', '143', '79', '2010', '649', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27249', '2', '79', '2010', '627', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27271', '180', '79', '2010', '654', '636', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27295', '105', '79', '2010', '628', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27314', '112', '79', '2010', '639', '605', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27335', '38', '79', '2010', '600', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27352', '127', '79', '2010', '617', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27369', '151', '79', '2010', '601', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27386', '101', '79', '2010', '609', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27409', '85', '79', '2010', '588', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27427', '67', '79', '2010', '610', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27450', '10', '79', '2010', '604', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27470', '123', '79', '2010', '621', '601', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27488', '89', '79', '2010', '603', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27505', '30', '79', '2010', '603', '589', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27523', '36', '79', '2010', '608', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27537', '116', '79', '2010', '608', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27550', '158', '79', '2010', '617', '606', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27571', '190', '79', '2010', '616', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27598', '5', '79', '2010', '606', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27624', '120', '79', '2010', '606', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27653', '79', '79', '2010', '605', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27679', '148', '79', '2010', '594', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27698', '17', '79', '2010', '617', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27719', '94', '79', '2010', '616', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27734', '317', '79', '2010', '592', '589', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27781', '146', '79', '2011', '599', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27797', '105', '79', '2011', '636', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27813', '317', '79', '2011', '594', '580', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27836', '127', '79', '2011', '592', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27850', '36', '79', '2011', '609', '586', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27867', '123', '79', '2011', '588', '579', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27897', '120', '79', '2011', '605', '590', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27909', '85', '79', '2011', '584', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27928', '17', '79', '2011', '616', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27954', '5', '79', '2011', '594', '587', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('27978', '112', '79', '2011', '607', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28004', '79', '79', '2011', '595', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28026', '30', '79', '2011', '605', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28043', '89', '79', '2011', '592', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28064', '180', '79', '2011', '650', '635', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28077', '38', '79', '2011', '603', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28090', '143', '79', '2011', '650', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28106', '10', '79', '2011', '583', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28117', '2', '79', '2011', '606', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28134', '101', '79', '2011', '588', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28147', '94', '79', '2011', '601', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28168', '148', '79', '2011', '587', '579', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28181', '158', '79', '2011', '601', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28199', '129', '79', '2011', '607', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28216', '88', '79', '2011', '584', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28231', '116', '79', '2011', '592', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28245', '190', '79', '2011', '605', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28255', '67', '79', '2011', '598', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28269', '151', '79', '2011', '599', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28316', '158', '79', '2012', '605', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28337', '190', '79', '2012', '608', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28354', '129', '79', '2012', '608', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28370', '85', '79', '2012', '595', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28382', '143', '79', '2012', '650', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28402', '88', '79', '2012', '583', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28423', '148', '79', '2012', '575', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28434', '94', '79', '2012', '592', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28455', '151', '79', '2012', '580', '574', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28475', '79', '79', '2012', '588', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28491', '36', '79', '2012', '604', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28505', '127', '79', '2012', '582', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28514', '5', '79', '2012', '585', '580', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28526', '116', '79', '2012', '600', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28537', '101', '79', '2012', '604', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28545', '169', '79', '2012', '628', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28561', '30', '79', '2012', '602', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28574', '317', '79', '2012', '583', '580', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28582', '44', '79', '2012', '578', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28592', '107', '79', '2012', '602', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28601', '10', '79', '2012', '592', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28617', '180', '79', '2012', '652', '626', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28629', '105', '79', '2012', '631', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28639', '123', '79', '2012', '597', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28647', '112', '79', '2012', '614', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28657', '38', '79', '2012', '608', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28669', '89', '79', '2012', '601', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28682', '67', '79', '2012', '605', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28747', '10', '79', '2013', '646', '646', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28753', '317', '79', '2013', '648', '640', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28767', '113', '79', '2013', '657', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28778', '101', '79', '2013', '659', '653', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28787', '105', '79', '2013', '675', '659', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28797', '129', '79', '2013', '680', '664', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28807', '180', '79', '2013', '690', '666', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28816', '88', '79', '2013', '635', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('28827', '5', '79', '2013', '639', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('29484', '17', '86', '2010', '584', '584', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29488', '2', '86', '2010', '583', '568', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29494', '10', '86', '2010', '573', '565', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29501', '5', '86', '2010', '580', '563', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29510', '43', '86', '2010', '585', '562', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29519', '61', '86', '2010', '560', '560', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29523', '12', '86', '2010', '561', '559', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29529', '65', '86', '2010', '556', '546', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29573', '12', '86', '2011', '568', '559', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29581', '10', '86', '2011', '566', '561', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29592', '2', '86', '2011', '595', '578', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29601', '43', '86', '2011', '569', '557', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29606', '17', '86', '2011', '597', '597', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29613', '5', '86', '2011', '571', '556', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29621', '65', '86', '2011', '573', '547', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29624', '61', '86', '2011', '575', '574', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29644', '43', '86', '2012', '562', '553', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29651', '61', '86', '2012', '568', '560', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29660', '12', '86', '2012', '558', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29672', '17', '86', '2012', '571', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29680', '10', '86', '2012', '560', '556', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29684', '65', '86', '2012', '561', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29689', '5', '86', '2012', '557', '550', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29693', '2', '86', '2012', '572', '569', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29725', '61', '86', '2013', '619', '611', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29731', '10', '86', '2013', '618', '614', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29741', '65', '86', '2013', '624', '605', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29750', '12', '86', '2013', '616', '607', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('29759', '5', '86', '2013', '605', '598', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('31140', '161', '86', '2010', '586', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31151', '97', '86', '2010', '605', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31173', '101', '86', '2010', '601', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31194', '68', '86', '2010', '598', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31220', '121', '86', '2010', '647', '601', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31279', '83', '86', '2010', '649', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31292', '184', '86', '2010', '612', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31313', '281', '86', '2010', '577', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31333', '12', '86', '2010', '582', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31365', '85', '86', '2010', '610', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31387', '10', '86', '2010', '597', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31406', '151', '86', '2010', '582', '574', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31428', '61', '86', '2010', '587', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31458', '129', '86', '2010', '600', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31472', '185', '86', '2010', '626', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31489', '180', '86', '2010', '654', '629', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31510', '118', '86', '2010', '578', '567', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31531', '149', '86', '2010', '599', '589', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31552', '479', '86', '2011', '585', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31569', '143', '86', '2011', '627', '586', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31590', '280', '86', '2011', '596', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31604', '101', '86', '2011', '615', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31626', '94', '86', '2011', '596', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31644', '85', '86', '2011', '585', '573', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31658', '180', '86', '2011', '653', '624', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31676', '2', '86', '2011', '604', '589', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31683', '10', '86', '2011', '556', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31713', '68', '86', '2011', '574', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31719', '149', '86', '2011', '602', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31741', '36', '86', '2011', '638', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31756', '37', '86', '2011', '614', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31766', '118', '86', '2011', '548', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31776', '129', '86', '2011', '583', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31789', '151', '86', '2011', '563', '557', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31798', '185', '86', '2011', '627', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31823', '83', '86', '2011', '635', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31841', '184', '86', '2011', '584', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31858', '161', '86', '2011', '576', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31877', '97', '86', '2011', '610', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31905', '17', '86', '2011', '635', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31926', '190', '86', '2011', '607', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31953', '189', '86', '2012', '587', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31972', '38', '86', '2012', '645', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('31988', '161', '86', '2012', '572', '566', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32004', '151', '86', '2012', '571', '566', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32023', '37', '86', '2012', '593', '586', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32034', '184', '86', '2012', '593', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32053', '36', '86', '2012', '639', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32076', '280', '86', '2012', '598', '590', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32086', '451', '75', '2010', '514', '506', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('32096', '190', '86', '2012', '590', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32103', '10', '75', '2010', '509', '501', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('32119', '69', '75', '2010', '500', '499', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('32122', '10', '86', '2012', '571', '567', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32139', '481', '75', '2010', '512', '500', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('32157', '129', '86', '2012', '583', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32158', '12', '75', '2010', '510', '510', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('32173', '234', '86', '2012', '574', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32184', '143', '86', '2012', '604', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32200', '149', '86', '2012', '606', '586', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32207', '2', '75', '2011', '512', '509', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('32220', '164', '86', '2012', '592', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32225', '466', '75', '2011', '515', '510', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('32238', '97', '86', '2012', '623', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32239', '67', '75', '2011', '539', '530', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('32253', '68', '86', '2012', '607', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32255', '10', '75', '2011', '512', '510', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('32281', '118', '86', '2012', '560', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32284', '58', '75', '2012', '491', '485', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('32290', '90', '86', '2012', '584', '573', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32305', '101', '86', '2012', '583', '573', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32306', '64', '75', '2012', '472', '470', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('32318', '185', '86', '2012', '639', '589', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32325', '59', '75', '2013', '497', '491', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('32330', '2', '86', '2012', '608', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32338', '10', '75', '2013', '494', '486', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('32345', '180', '86', '2012', '652', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32354', '479', '86', '2012', '611', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32377', '94', '86', '2012', '601', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32380', '17', '90', '2010', '629', '608', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32395', '83', '86', '2012', '641', '597', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32398', '23', '90', '2010', '605', '602', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32415', '5', '90', '2010', '623', '605', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32419', '85', '86', '2012', '576', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32438', '17', '86', '2012', '643', '609', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32440', '354', '90', '2010', '608', '608', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32455', '15', '90', '2010', '591', '590', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32457', '151', '86', '2013', '678', '650', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32469', '3', '90', '2010', '627', '613', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32474', '129', '86', '2013', '658', '644', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32486', '21', '90', '2010', '622', '615', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32495', '180', '86', '2013', '686', '670', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32509', '161', '86', '2013', '642', '628', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32510', '126', '90', '2010', '599', '597', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32529', '479', '86', '2013', '634', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32531', '22', '90', '2010', '595', '593', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32539', '85', '86', '2013', '642', '626', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32552', '61', '90', '2010', '605', '601', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32553', '83', '86', '2013', '637', '634', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32563', '44', '90', '2010', '591', '591', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32577', '89', '90', '2010', '597', '592', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32586', '118', '86', '2013', '625', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32589', '63', '90', '2010', '586', '586', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32598', '97', '86', '2013', '645', '635', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32600', '339', '90', '2010', '603', '594', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32615', '481', '90', '2010', '592', '590', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32627', '10', '86', '2013', '641', '640', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32642', '13', '90', '2010', '591', '591', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32657', '10', '90', '2010', '595', '593', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32658', '234', '86', '2013', '640', '625', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32674', '149', '86', '2013', '654', '644', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32679', '78', '90', '2010', '596', '595', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32693', '101', '86', '2013', '635', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('32694', '266', '90', '2010', '604', '600', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32708', '18', '90', '2010', '598', '595', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32719', '43', '90', '2010', '603', '600', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32730', '2', '90', '2010', '611', '600', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32735', '159', '90', '2010', '585', '585', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32765', '18', '90', '2011', '614', '605', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32779', '43', '90', '2011', '614', '604', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32795', '17', '90', '2011', '635', '619', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32810', '21', '90', '2011', '636', '625', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32816', '266', '90', '2011', '616', '616', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32825', '5', '90', '2011', '612', '601', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32836', '13', '90', '2011', '592', '592', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32844', '61', '90', '2011', '632', '621', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32854', '89', '90', '2011', '608', '606', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32863', '23', '90', '2011', '613', '604', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32873', '22', '90', '2011', '616', '614', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32885', '2', '90', '2011', '633', '606', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32902', '3', '90', '2011', '625', '610', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32913', '126', '90', '2011', '613', '612', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32919', '136', '90', '2011', '604', '604', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32926', '63', '90', '2011', '612', '612', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32932', '10', '90', '2011', '611', '611', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32942', '339', '90', '2011', '630', '615', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32949', '159', '90', '2011', '593', '593', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32959', '471', '90', '2011', '613', '607', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32973', '44', '90', '2011', '611', '606', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32983', '481', '90', '2011', '603', '597', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('32993', '52', '90', '2011', '602', '602', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33006', '354', '90', '2011', '619', '619', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33008', '14', '75', '2010', '494', '484', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('33014', '78', '90', '2011', '601', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33017', '471', '75', '2010', '489', '483', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('33026', '58', '75', '2010', '517', '508', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('33033', '116', '75', '2010', '497', '477', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('33043', '2', '75', '2010', '495', '489', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('33072', '21', '90', '2012', '612', '600', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33078', '23', '90', '2012', '588', '584', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33084', '3', '90', '2012', '609', '592', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33089', '78', '90', '2012', '574', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33094', '44', '90', '2012', '596', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33100', '17', '90', '2012', '622', '600', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33104', '116', '75', '2011', '485', '470', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('33107', '471', '90', '2012', '549', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33112', '79', '75', '2011', '478', '477', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('33113', '266', '90', '2012', '581', '581', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33120', '16', '75', '2011', '476', '473', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('33124', '89', '90', '2012', '562', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33131', '17', '75', '2011', '486', '478', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('33133', '13', '90', '2012', '560', '560', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33139', '18', '90', '2012', '573', '560', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33147', '52', '90', '2012', '563', '563', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33153', '43', '90', '2012', '581', '574', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33159', '159', '90', '2012', '587', '583', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33162', '203', '75', '2012', '462', '455', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('33166', '354', '90', '2012', '594', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33173', '136', '90', '2012', '572', '572', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33175', '17', '75', '2012', '462', '455', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('33181', '458', '75', '2012', '465', '464', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('33182', '22', '90', '2012', '571', '564', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33188', '37', '75', '2012', '456', '455', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('33189', '339', '90', '2012', '585', '577', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33194', '92', '75', '2012', '461', '460', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('33196', '61', '90', '2012', '575', '572', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33201', '2', '90', '2012', '624', '581', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33202', '143', '75', '2012', '447', '443', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('33207', '10', '90', '2012', '581', '581', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33216', '63', '90', '2012', '579', '579', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33223', '126', '90', '2012', '593', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33231', '5', '90', '2012', '590', '576', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33250', '92', '75', '2013', '452', '451', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('33271', '44', '90', '2013', '634', '632', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33275', '22', '90', '2013', '631', '630', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33279', '21', '90', '2013', '649', '641', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33282', '8', '90', '2013', '657', '643', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33286', '13', '90', '2013', '621', '621', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33291', '339', '90', '2013', '645', '629', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33297', '5', '90', '2013', '625', '624', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33302', '10', '90', '2013', '646', '646', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33306', '159', '90', '2013', '622', '622', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33308', '61', '90', '2013', '639', '635', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('33310', '12', '90', '2013', '620', '620', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('34125', '3', '95', '2010', '512', '506', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34143', '127', '95', '2010', '594', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34156', '129', '95', '2010', '523', '506', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34171', '147', '95', '2010', '535', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34180', '12', '95', '2010', '484', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('34199', '38', '95', '2010', '522', '522', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34210', '339', '90', '2010', '627', '625', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34215', '61', '95', '2010', '496', '484', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('34225', '159', '90', '2010', '624', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34233', '107', '95', '2010', '522', '522', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34236', '23', '90', '2010', '626', '625', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34247', '126', '90', '2010', '626', '625', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34253', '37', '95', '2010', '560', '521', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34271', '315', '95', '2010', '571', '528', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34275', '3', '90', '2010', '644', '634', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34289', '196', '95', '2010', '530', '516', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34304', '354', '90', '2010', '631', '628', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34305', '10', '95', '2010', '485', '478', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('34329', '147', '95', '2011', '564', '518', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34330', '21', '90', '2010', '651', '635', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34341', '17', '90', '2010', '648', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34354', '315', '95', '2011', '583', '541', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34355', '221', '90', '2010', '655', '645', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34373', '129', '95', '2011', '516', '505', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34375', '22', '90', '2010', '623', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34390', '151', '95', '2011', '509', '503', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34391', '43', '90', '2010', '614', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34404', '78', '90', '2010', '620', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34409', '127', '95', '2011', '551', '532', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34420', '79', '90', '2010', '618', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34427', '37', '95', '2011', '511', '505', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34445', '89', '90', '2010', '617', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34449', '107', '95', '2011', '516', '516', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34471', '15', '90', '2010', '620', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34480', '196', '95', '2011', '529', '511', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34492', '2', '90', '2010', '635', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34493', '38', '95', '2011', '528', '514', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34507', '3', '95', '2011', '539', '514', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34508', '266', '90', '2010', '630', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34523', '61', '90', '2010', '609', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34530', '31', '95', '2012', '493', '483', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34551', '5', '90', '2010', '628', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34557', '386', '95', '2012', '540', '517', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34571', '126', '90', '2011', '624', '624', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34577', '83', '95', '2012', '496', '485', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34584', '3', '90', '2011', '632', '626', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34598', '185', '95', '2012', '513', '502', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34606', '2', '90', '2011', '619', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34628', '189', '95', '2012', '579', '527', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34630', '354', '90', '2011', '631', '624', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34646', '164', '95', '2012', '569', '518', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34651', '79', '90', '2011', '623', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34661', '116', '95', '2012', '592', '507', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34673', '22', '90', '2011', '619', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34685', '315', '95', '2012', '522', '504', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34690', '5', '90', '2011', '625', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34701', '429', '95', '2012', '581', '544', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34708', '266', '90', '2011', '630', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34722', '221', '90', '2011', '646', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34743', '151', '95', '2013', '612', '579', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34748', '61', '90', '2011', '635', '626', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34764', '44', '90', '2011', '622', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34777', '481', '90', '2011', '622', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34811', '52', '90', '2011', '595', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34832', '10', '90', '2011', '616', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34845', '339', '90', '2011', '623', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34865', '159', '90', '2011', '617', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34882', '23', '90', '2011', '625', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34896', '21', '90', '2011', '652', '632', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34908', '43', '90', '2011', '619', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34917', '471', '90', '2011', '611', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34932', '78', '90', '2011', '629', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34951', '17', '90', '2011', '653', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34963', '89', '90', '2011', '619', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('34994', '44', '90', '2012', '622', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35026', '3', '90', '2012', '639', '628', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35050', '78', '90', '2012', '597', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35073', '17', '90', '2012', '653', '634', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35090', '2', '90', '2012', '642', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35102', '23', '90', '2012', '615', '615', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35116', '21', '90', '2012', '644', '632', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35137', '5', '90', '2012', '625', '624', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35154', '89', '90', '2012', '607', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35176', '52', '90', '2012', '609', '609', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35197', '43', '90', '2012', '621', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35219', '159', '90', '2012', '619', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35241', '354', '90', '2012', '641', '636', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35261', '136', '90', '2012', '598', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35270', '221', '90', '2012', '650', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35295', '266', '90', '2012', '626', '615', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35313', '339', '90', '2012', '615', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35348', '61', '90', '2012', '611', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35373', '10', '90', '2012', '599', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35391', '79', '90', '2012', '618', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35406', '126', '90', '2012', '617', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35427', '22', '90', '2013', '647', '647', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35443', '8', '90', '2013', '679', '668', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35461', '12', '90', '2013', '657', '657', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35481', '5', '90', '2013', '646', '646', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35494', '221', '90', '2013', '691', '667', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35518', '339', '90', '2013', '661', '661', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35529', '61', '90', '2013', '659', '651', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35539', '10', '90', '2013', '657', '657', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35554', '21', '90', '2013', '686', '673', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('35568', '44', '90', '2013', '675', '675', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('38425', '43', '105', '2010', '556', '547', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38450', '5', '105', '2010', '551', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38470', '52', '105', '2010', '551', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38483', '10', '105', '2010', '570', '553', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38503', '136', '105', '2010', '556', '553', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38520', '23', '105', '2010', '587', '565', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38544', '3', '105', '2010', '617', '574', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38559', '69', '105', '2010', '547', '545', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38576', '13', '105', '2010', '544', '544', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38599', '69', '105', '2011', '563', '555', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38624', '52', '105', '2011', '547', '538', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38640', '43', '105', '2011', '558', '552', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38656', '136', '105', '2011', '571', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38672', '5', '105', '2011', '560', '548', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38691', '23', '105', '2011', '564', '562', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38709', '10', '105', '2011', '538', '536', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38731', '3', '105', '2011', '584', '579', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38744', '69', '105', '2012', '531', '529', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38765', '136', '105', '2012', '547', '547', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38784', '5', '105', '2012', '535', '524', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38791', '13', '105', '2012', '522', '514', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38810', '10', '105', '2012', '538', '537', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38831', '3', '105', '2012', '579', '559', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38860', '43', '105', '2012', '545', '540', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38869', '52', '105', '2012', '545', '545', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38883', '23', '105', '2012', '549', '546', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38905', '10', '107', '2010', '545', '545', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38928', '5', '107', '2010', '566', '552', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38943', '14', '107', '2010', '564', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38964', '2', '107', '2010', '601', '576', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('38980', '67', '107', '2010', '605', '586', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39001', '528', '107', '2010', '605', '586', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39008', '10', '105', '2013', '591', '590', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39014', '10', '107', '2011', '592', '576', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39015', '5', '105', '2013', '590', '580', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39020', '528', '107', '2011', '582', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39034', '69', '105', '2013', '583', '582', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39043', '14', '107', '2011', '566', '564', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39053', '2', '107', '2011', '572', '570', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39079', '5', '107', '2011', '562', '557', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39093', '67', '107', '2011', '583', '577', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39114', '67', '107', '2012', '564', '560', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39131', '2', '107', '2012', '578', '562', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39152', '528', '107', '2012', '582', '582', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39176', '10', '107', '2012', '547', '539', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39187', '386', '107', '2012', '576', '539', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39199', '14', '107', '2012', '556', '550', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39214', '5', '107', '2012', '549', '541', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('39430', '8', '110', '2011', '496', '495', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('39442', '10', '110', '2011', '485', '485', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('39473', '537', '110', '2012', '479', '467', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('39486', '5', '110', '2012', '474', '470', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('39502', '13', '110', '2012', '452', '451', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('39521', '64', '110', '2012', '447', '447', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('39538', '8', '110', '2012', '484', '480', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('39564', '13', '110', '2013', '507', '507', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('41488', '161', '105', '2010', '565', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41514', '89', '105', '2010', '563', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41519', '37', '110', '2010', '450', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41538', '37', '105', '2010', '597', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41540', '539', '110', '2010', '503', '486', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41551', '436', '110', '2010', '482', '482', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41562', '127', '105', '2010', '599', '580', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41568', '38', '110', '2010', '479', '479', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41571', '540', '105', '2010', '579', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41583', '147', '110', '2010', '487', '477', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41585', '2', '105', '2010', '588', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41598', '184', '110', '2010', '468', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41602', '101', '105', '2010', '620', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41610', '23', '110', '2010', '487', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41623', '131', '105', '2010', '569', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41627', '151', '110', '2010', '478', '470', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41641', '146', '105', '2010', '575', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41646', '127', '110', '2010', '458', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41661', '79', '105', '2010', '565', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41671', '79', '110', '2010', '457', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41679', '151', '105', '2010', '571', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41684', '226', '110', '2010', '455', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41695', '94', '105', '2010', '577', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41705', '158', '110', '2010', '460', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41707', '38', '105', '2010', '577', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41715', '83', '110', '2010', '450', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41736', '123', '105', '2010', '587', '562', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41745', '83', '110', '2011', '450', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41755', '113', '105', '2010', '638', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41761', '78', '110', '2011', '450', '445', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41776', '126', '105', '2010', '560', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41778', '184', '110', '2011', '444', '444', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41786', '262', '105', '2010', '594', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41790', '196', '110', '2011', '440', '440', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41804', '36', '105', '2010', '599', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41810', '132', '110', '2011', '481', '481', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41817', '83', '105', '2010', '575', '562', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41824', '79', '110', '2011', '469', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41825', '143', '105', '2010', '613', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41844', '174', '105', '2010', '600', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41847', '68', '110', '2011', '453', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41855', '68', '107', '2010', '582', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41862', '30', '105', '2010', '565', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41868', '97', '107', '2010', '590', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41878', '151', '110', '2011', '473', '469', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41880', '17', '105', '2010', '615', '585', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41885', '14', '107', '2010', '580', '580', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41892', '8', '110', '2011', '451', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41904', '390', '105', '2010', '603', '590', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41906', '67', '107', '2010', '578', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41915', '143', '110', '2011', '437', '437', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41929', '107', '107', '2010', '582', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41931', '539', '110', '2011', '462', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41933', '500', '105', '2011', '584', '579', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41943', '127', '110', '2011', '457', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41950', '397', '107', '2010', '595', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41951', '126', '105', '2011', '565', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41965', '79', '110', '2012', '462', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41972', '147', '107', '2010', '585', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41976', '143', '105', '2011', '595', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41983', '151', '110', '2012', '464', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('41992', '528', '107', '2010', '573', '573', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('41996', '37', '105', '2011', '585', '566', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42003', '226', '110', '2012', '455', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('42016', '225', '107', '2010', '593', '573', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42017', '101', '105', '2011', '582', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42027', '539', '110', '2012', '451', '442', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('42037', '38', '105', '2011', '570', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42038', '134', '107', '2010', '572', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42052', '143', '110', '2012', '463', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('42058', '151', '107', '2010', '572', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42061', '123', '105', '2011', '572', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42067', '196', '110', '2012', '439', '436', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('42079', '388', '107', '2010', '596', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42090', '36', '105', '2011', '584', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42091', '5', '110', '2013', '543', '543', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('42100', '150', '107', '2010', '602', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42109', '78', '105', '2011', '568', '568', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42115', '530', '107', '2010', '594', '587', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42119', '2', '112', '2010', '579', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42124', '127', '105', '2011', '589', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42127', '9', '112', '2010', '578', '570', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42138', '269', '107', '2010', '629', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42141', '10', '112', '2010', '593', '576', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42144', '116', '107', '2010', '650', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42147', '390', '105', '2011', '604', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42156', '6', '112', '2010', '602', '585', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42164', '113', '105', '2011', '632', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42166', '119', '107', '2010', '627', '603', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42170', '5', '112', '2010', '617', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42180', '61', '112', '2010', '608', '606', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42182', '17', '107', '2010', '621', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42192', '2', '105', '2011', '581', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42199', '139', '112', '2010', '565', '564', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42207', '40', '107', '2010', '606', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42210', '151', '105', '2011', '570', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42214', '15', '112', '2010', '566', '561', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42222', '2', '107', '2010', '640', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42231', '276', '105', '2011', '578', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42236', '13', '112', '2010', '584', '574', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42239', '506', '107', '2010', '607', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42246', '17', '112', '2010', '578', '572', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42253', '83', '105', '2011', '566', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42256', '180', '107', '2010', '614', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42263', '25', '107', '2010', '644', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42267', '58', '112', '2010', '579', '575', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42268', '540', '105', '2011', '585', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42278', '533', '107', '2010', '639', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42289', '31', '107', '2010', '589', '587', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42293', '223', '105', '2011', '579', '574', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42297', '18', '112', '2011', '591', '585', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42306', '146', '105', '2011', '571', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42309', '13', '112', '2011', '582', '582', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42314', '112', '107', '2010', '572', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42326', '139', '112', '2011', '590', '590', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42328', '262', '105', '2011', '575', '562', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42331', '87', '107', '2010', '602', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42343', '17', '105', '2011', '567', '559', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42346', '9', '112', '2011', '592', '592', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42351', '95', '107', '2010', '647', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42356', '94', '105', '2011', '569', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42363', '58', '112', '2011', '611', '586', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42365', '226', '107', '2010', '631', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42370', '30', '105', '2011', '555', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42374', '61', '112', '2011', '609', '603', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42378', '131', '105', '2011', '564', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42391', '2', '112', '2011', '586', '581', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42392', '174', '105', '2011', '604', '587', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42407', '5', '112', '2011', '637', '600', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42410', '533', '107', '2011', '627', '585', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42418', '101', '105', '2012', '559', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42420', '17', '107', '2011', '632', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42424', '10', '112', '2011', '604', '593', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42431', '397', '107', '2011', '584', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42442', '79', '105', '2012', '547', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42448', '15', '112', '2011', '592', '586', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42452', '25', '107', '2011', '644', '625', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42456', '223', '105', '2012', '552', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42463', '147', '107', '2011', '566', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42473', '83', '105', '2012', '561', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42477', '67', '107', '2011', '583', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42479', '58', '112', '2012', '575', '564', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42491', '500', '105', '2012', '602', '585', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42493', '107', '107', '2011', '581', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42494', '20', '112', '2012', '563', '557', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42504', '37', '105', '2012', '571', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42507', '10', '112', '2012', '575', '564', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42509', '14', '107', '2011', '562', '562', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42521', '225', '107', '2011', '567', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42522', '126', '105', '2012', '567', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42525', '13', '112', '2012', '564', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42537', '269', '107', '2011', '598', '587', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42539', '149', '105', '2012', '555', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42541', '18', '112', '2012', '563', '556', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42543', '31', '107', '2011', '579', '573', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42547', '276', '105', '2012', '577', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42549', '9', '112', '2012', '559', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42555', '116', '107', '2011', '602', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42559', '2', '105', '2012', '588', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42561', '139', '112', '2012', '560', '553', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42565', '530', '107', '2011', '568', '568', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42569', '15', '112', '2012', '561', '553', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42573', '506', '107', '2011', '632', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42574', '146', '105', '2012', '565', '557', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42578', '5', '112', '2012', '606', '577', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42581', '95', '107', '2011', '638', '605', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42586', '78', '105', '2012', '551', '544', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42592', '2', '112', '2012', '562', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42597', '68', '107', '2011', '575', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42605', '540', '105', '2012', '561', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42608', '150', '107', '2011', '579', '573', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42610', '61', '112', '2012', '593', '585', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('42621', '180', '107', '2011', '620', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42628', '131', '105', '2012', '566', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42633', '134', '107', '2011', '573', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42639', '190', '105', '2012', '565', '552', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42646', '113', '105', '2012', '640', '606', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42654', '388', '107', '2011', '589', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42663', '151', '105', '2012', '566', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42667', '226', '107', '2011', '635', '609', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42676', '40', '107', '2011', '627', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42681', '174', '105', '2012', '561', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42689', '151', '107', '2011', '562', '562', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42692', '120', '105', '2012', '554', '552', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42703', '2', '107', '2011', '586', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42712', '459', '105', '2012', '579', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42724', '119', '107', '2011', '633', '603', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42728', '262', '105', '2012', '568', '559', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42734', '97', '107', '2011', '582', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42744', '528', '107', '2011', '582', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42751', '30', '105', '2012', '568', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42760', '87', '107', '2011', '623', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42765', '36', '105', '2012', '576', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42781', '390', '105', '2012', '619', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42790', '132', '107', '2012', '565', '562', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42798', '38', '105', '2012', '571', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42802', '97', '107', '2012', '588', '585', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42808', '2', '107', '2012', '620', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42821', '17', '105', '2012', '613', '566', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42825', '67', '107', '2012', '600', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42832', '94', '105', '2012', '577', '574', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42838', '528', '107', '2012', '610', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42847', '123', '105', '2012', '570', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42851', '269', '107', '2012', '637', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42852', '127', '105', '2012', '583', '574', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42865', '150', '107', '2012', '643', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42866', '143', '105', '2012', '583', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42881', '14', '107', '2012', '579', '579', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42886', '89', '105', '2012', '551', '543', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42889', '68', '107', '2012', '572', '568', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42905', '31', '107', '2012', '582', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42922', '225', '107', '2012', '584', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42935', '40', '107', '2012', '641', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42937', '223', '105', '2013', '626', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42948', '8', '105', '2013', '619', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42954', '147', '107', '2012', '581', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42965', '95', '107', '2012', '631', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42970', '262', '105', '2013', '636', '629', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42977', '116', '107', '2012', '594', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42985', '25', '107', '2012', '624', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42987', '113', '105', '2013', '676', '652', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('42993', '107', '107', '2012', '568', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43000', '445', '105', '2013', '620', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43002', '226', '107', '2012', '641', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43014', '36', '105', '2013', '662', '642', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43020', '180', '107', '2012', '630', '626', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43023', '174', '105', '2013', '645', '635', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43026', '530', '107', '2012', '566', '562', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43039', '119', '107', '2012', '637', '603', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43041', '21', '105', '2013', '656', '656', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43049', '101', '105', '2013', '634', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43050', '388', '107', '2012', '589', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43060', '87', '107', '2012', '603', '603', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43063', '17', '105', '2013', '642', '627', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43070', '397', '107', '2012', '575', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43081', '134', '107', '2012', '571', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43083', '151', '105', '2013', '624', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43090', '17', '107', '2012', '644', '606', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43102', '149', '105', '2013', '623', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43110', '533', '107', '2012', '604', '590', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43119', '386', '107', '2012', '612', '551', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43128', '506', '107', '2012', '627', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43148', '14', '107', '2013', '634', '634', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43161', '323', '107', '2013', '635', '635', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43173', '386', '107', '2013', '676', '606', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43185', '40', '107', '2013', '640', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43197', '97', '107', '2013', '644', '641', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43216', '180', '107', '2013', '677', '669', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43231', '506', '107', '2013', '665', '665', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43245', '226', '107', '2013', '659', '654', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43256', '87', '107', '2013', '668', '649', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43269', '95', '107', '2013', '660', '650', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43355', '2', '112', '2010', '593', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43362', '14', '112', '2010', '578', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43371', '15', '112', '2010', '582', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43381', '10', '112', '2010', '629', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43395', '5', '112', '2010', '641', '605', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43410', '61', '112', '2010', '612', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43423', '17', '112', '2010', '617', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43439', '139', '112', '2010', '589', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43449', '56', '112', '2010', '599', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43464', '58', '112', '2010', '583', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43505', '10', '112', '2011', '586', '586', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43511', '61', '112', '2011', '593', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43518', '14', '112', '2011', '567', '567', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43526', '58', '112', '2011', '590', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43534', '15', '112', '2011', '578', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43546', '2', '112', '2011', '582', '574', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43556', '56', '112', '2011', '587', '585', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43564', '17', '112', '2011', '587', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43570', '139', '112', '2011', '580', '579', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43575', '5', '112', '2011', '644', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43607', '58', '112', '2012', '587', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43619', '17', '112', '2012', '611', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43629', '139', '112', '2012', '592', '585', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43639', '61', '112', '2012', '600', '597', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43646', '10', '112', '2012', '598', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43657', '56', '112', '2012', '583', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43666', '5', '112', '2012', '627', '597', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43675', '15', '112', '2012', '582', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43684', '2', '112', '2012', '588', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43711', '10', '112', '2013', '638', '626', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43722', '58', '112', '2013', '642', '634', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43731', '61', '112', '2013', '651', '647', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43738', '17', '112', '2013', '653', '644', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('43746', '56', '112', '2013', '632', '627', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('44006', '10', '115', '2010', '624', '620', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44018', '58', '115', '2010', '633', '615', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44030', '159', '115', '2010', '621', '613', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44038', '63', '115', '2010', '606', '604', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44047', '549', '115', '2010', '606', '601', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44054', '8', '115', '2010', '601', '600', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44068', '79', '115', '2010', '595', '595', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44086', '2', '115', '2010', '596', '595', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44103', '5', '115', '2010', '598', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44114', '3', '115', '2010', '596', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44124', '13', '115', '2010', '604', '599', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44132', '21', '115', '2010', '615', '610', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44234', '8', '115', '2011', '612', '612', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44248', '5', '115', '2011', '591', '586', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44262', '21', '115', '2011', '638', '626', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44272', '58', '115', '2011', '629', '613', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44287', '159', '115', '2011', '629', '611', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44295', '10', '115', '2011', '629', '621', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44311', '63', '115', '2011', '599', '598', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44324', '3', '115', '2011', '594', '594', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44330', '2', '115', '2011', '563', '562', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44338', '549', '115', '2011', '616', '605', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44346', '89', '115', '2011', '573', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44353', '13', '115', '2011', '545', '545', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44376', '10', '115', '2012', '600', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44384', '63', '115', '2012', '576', '575', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44395', '13', '115', '2012', '575', '566', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44407', '159', '115', '2012', '600', '592', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44417', '21', '115', '2012', '584', '584', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44429', '8', '115', '2012', '613', '613', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44441', '5', '115', '2012', '575', '570', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44451', '58', '115', '2012', '597', '590', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44456', '549', '115', '2012', '588', '583', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44466', '3', '115', '2012', '590', '590', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44482', '79', '115', '2012', '563', '563', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44496', '89', '115', '2012', '571', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44506', '2', '115', '2012', '581', '575', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44545', '10', '115', '2013', '660', '657', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44555', '549', '115', '2013', '639', '633', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44563', '13', '115', '2013', '627', '627', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44576', '5', '115', '2013', '639', '630', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44585', '21', '115', '2013', '643', '643', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44600', '159', '115', '2013', '652', '649', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('44611', '58', '115', '2013', '657', '649', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('45685', '21', '115', '2010', '641', '628', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('45704', '13', '115', '2010', '622', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('45721', '3', '115', '2010', '612', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('45737', '63', '115', '2010', '636', '636', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('45750', '159', '115', '2010', '668', '654', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('45767', '10', '115', '2010', '650', '645', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('45795', '2', '115', '2010', '628', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('45812', '5', '115', '2010', '639', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('45836', '79', '115', '2010', '602', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('45850', '8', '115', '2010', '631', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('45870', '549', '115', '2010', '624', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('45884', '38', '115', '2010', '602', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('45921', '58', '115', '2011', '623', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('45948', '21', '115', '2011', '623', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('45976', '5', '115', '2011', '596', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('45995', '13', '115', '2011', '593', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46014', '63', '115', '2011', '647', '647', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46035', '10', '115', '2011', '634', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46047', '159', '115', '2011', '632', '626', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46070', '89', '115', '2011', '600', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46086', '2', '115', '2011', '601', '601', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46102', '549', '115', '2011', '611', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46119', '38', '115', '2011', '594', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46143', '8', '115', '2011', '613', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46161', '3', '115', '2011', '613', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46188', '63', '115', '2012', '627', '627', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46206', '159', '115', '2012', '648', '641', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46227', '549', '115', '2012', '612', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46247', '8', '115', '2012', '615', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46262', '21', '115', '2012', '662', '636', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46286', '58', '115', '2012', '616', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46298', '38', '115', '2012', '594', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46319', '5', '115', '2012', '610', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46335', '10', '115', '2012', '623', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46361', '3', '115', '2012', '616', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46387', '89', '115', '2012', '602', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46409', '2', '115', '2012', '611', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46438', '79', '115', '2012', '604', '603', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46463', '21', '115', '2013', '670', '662', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46479', '8', '115', '2013', '667', '664', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46497', '10', '115', '2013', '667', '664', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46513', '159', '115', '2013', '670', '667', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46531', '58', '115', '2013', '680', '669', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46542', '549', '115', '2013', '657', '655', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('46558', '5', '115', '2013', '650', '649', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('49238', '61', '112', '2010', '515', '515', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49250', '17', '112', '2010', '503', '503', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49276', '139', '112', '2010', '502', '502', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49285', '2', '112', '2010', '502', '502', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49315', '10', '112', '2010', '503', '503', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49324', '5', '112', '2010', '521', '511', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49356', '139', '112', '2011', '493', '493', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49372', '2', '112', '2011', '490', '490', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49383', '13', '112', '2011', '490', '490', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49408', '61', '112', '2011', '513', '513', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49428', '5', '112', '2011', '510', '501', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49447', '10', '112', '2011', '502', '502', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49470', '10', '112', '2012', '491', '491', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49492', '5', '112', '2012', '483', '474', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49512', '139', '112', '2012', '473', '473', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49536', '5', '112', '2013', '496', '486', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49570', '61', '112', '2013', '484', '484', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49612', '10', '112', '2013', '493', '493', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('49942', '5', '112', '2010', '507', '503', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('49963', '58', '112', '2010', '496', '496', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('49985', '2', '112', '2010', '495', '495', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('50000', '139', '112', '2010', '497', '497', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('50032', '2', '112', '2011', '491', '491', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('50054', '139', '112', '2011', '494', '494', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('50068', '5', '112', '2011', '501', '498', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('50083', '17', '112', '2011', '493', '489', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('50097', '5', '112', '2012', '474', '467', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('50111', '139', '112', '2012', '473', '473', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('50131', '17', '112', '2012', '475', '474', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('50148', '2', '112', '2012', '471', '471', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('50157', '58', '112', '2012', '460', '460', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('50174', '5', '112', '2013', '460', '455', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('50193', '17', '112', '2013', '455', '454', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('52708', '43', '105', '2010', '465', '465', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('52730', '3', '105', '2010', '480', '480', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('52751', '52', '105', '2010', '473', '473', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('52774', '52', '105', '2011', '470', '470', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('52795', '43', '105', '2011', '468', '468', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('52813', '10', '105', '2011', '472', '472', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('52840', '3', '105', '2011', '475', '475', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('52857', '5', '105', '2011', '476', '476', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('52886', '10', '105', '2013', '451', '451', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('53636', '481', '75', '2010', '579', '556', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('53646', '293', '75', '2010', '569', '563', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('53655', '63', '75', '2010', '562', '560', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53671', '2', '75', '2010', '563', '560', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53684', '451', '75', '2010', '563', '562', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53697', '10', '75', '2010', '564', '561', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53714', '58', '75', '2010', '566', '564', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53733', '14', '75', '2010', '560', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53768', '67', '75', '2011', '579', '577', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53783', '62', '75', '2011', '574', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53792', '48', '75', '2011', '579', '578', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53800', '17', '75', '2011', '577', '576', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53814', '69', '75', '2011', '578', '577', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53826', '10', '75', '2011', '577', '576', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53869', '67', '75', '2012', '616', '614', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53891', '64', '75', '2012', '613', '612', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53906', '58', '75', '2012', '618', '616', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53923', '13', '75', '2012', '612', '611', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53930', '17', '75', '2012', '612', '612', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('53943', '203', '75', '2012', '613', '612', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('54234', '87', '107', '2010', '482', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54250', '17', '107', '2010', '481', '481', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54271', '269', '107', '2010', '469', '469', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54284', '95', '107', '2010', '470', '470', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54302', '119', '107', '2010', '484', '484', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54331', '119', '107', '2011', '488', '488', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54349', '95', '107', '2011', '472', '472', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54366', '150', '107', '2011', '472', '472', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54382', '87', '107', '2011', '489', '489', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54392', '17', '107', '2011', '470', '470', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54409', '269', '107', '2011', '478', '478', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54425', '533', '107', '2011', '473', '473', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54447', '269', '107', '2012', '486', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54459', '17', '107', '2012', '456', '456', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54481', '87', '107', '2012', '451', '451', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54495', '533', '107', '2012', '456', '456', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54517', '119', '107', '2012', '467', '467', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54536', '95', '107', '2012', '466', '466', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54558', '87', '107', '2013', '450', '450', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54623', '116', '75', '2010', '570', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54644', '17', '75', '2010', '574', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54660', '79', '75', '2010', '565', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54675', '92', '75', '2010', '584', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54692', '69', '75', '2010', '580', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54719', '64', '75', '2011', '592', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54735', '16', '75', '2011', '570', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54740', '123', '105', '2010', '469', '469', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54747', '38', '75', '2011', '595', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54751', '143', '105', '2010', '471', '471', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54757', '116', '75', '2011', '583', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54758', '127', '105', '2010', '472', '471', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54769', '15', '75', '2011', '600', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54771', '36', '105', '2010', '469', '468', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54791', '37', '75', '2012', '602', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54793', '2', '105', '2010', '467', '467', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54808', '38', '105', '2010', '467', '467', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54816', '468', '75', '2012', '596', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54825', '36', '75', '2012', '596', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54828', '83', '105', '2010', '465', '465', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54841', '158', '75', '2012', '596', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54842', '151', '105', '2010', '465', '465', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54852', '92', '75', '2012', '637', '613', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54853', '17', '105', '2010', '467', '467', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54867', '69', '75', '2012', '616', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54876', '126', '105', '2010', '472', '472', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54889', '143', '75', '2012', '611', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54896', '113', '105', '2010', '479', '475', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54907', '390', '105', '2010', '483', '483', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54911', '5', '75', '2012', '598', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54927', '458', '75', '2012', '603', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('54947', '113', '105', '2011', '519', '506', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54966', '89', '105', '2011', '469', '469', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54981', '2', '105', '2011', '482', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('54994', '276', '105', '2011', '474', '474', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55004', '126', '105', '2011', '475', '475', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55020', '143', '105', '2011', '479', '479', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55034', '38', '105', '2011', '471', '470', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55059', '500', '105', '2011', '493', '493', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55080', '78', '105', '2011', '475', '475', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55092', '83', '105', '2011', '471', '471', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55114', '17', '105', '2011', '477', '477', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55140', '151', '105', '2011', '480', '476', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55156', '131', '105', '2011', '471', '471', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55170', '127', '105', '2011', '481', '479', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55179', '36', '105', '2011', '477', '476', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55199', '390', '105', '2011', '487', '487', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55219', '123', '105', '2011', '470', '470', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55255', '190', '105', '2012', '434', '434', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55264', '89', '105', '2012', '424', '424', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55279', '126', '105', '2012', '431', '431', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55296', '500', '105', '2012', '442', '442', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55320', '36', '105', '2012', '440', '439', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55328', '276', '105', '2012', '442', '442', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55340', '17', '105', '2012', '436', '436', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55351', '143', '105', '2012', '440', '440', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55362', '390', '105', '2012', '459', '459', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55373', '83', '105', '2012', '431', '431', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55391', '38', '105', '2012', '443', '435', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55409', '131', '105', '2012', '431', '431', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55428', '120', '105', '2012', '433', '433', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55439', '123', '105', '2012', '433', '433', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55453', '113', '105', '2012', '460', '457', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55476', '2', '105', '2012', '454', '454', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55492', '127', '105', '2012', '444', '444', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55514', '149', '105', '2012', '425', '425', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55536', '78', '105', '2012', '428', '428', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55554', '151', '105', '2012', '427', '427', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55589', '36', '105', '2013', '431', '431', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55601', '8', '105', '2013', '432', '432', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55614', '149', '105', '2013', '429', '429', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55622', '151', '105', '2013', '524', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55636', '113', '105', '2013', '440', '438', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('55649', '174', '105', '2013', '431', '431', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('56352', '58', '39', '2010', '575', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56375', '5', '39', '2010', '574', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56390', '43', '39', '2010', '575', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56405', '18', '39', '2010', '577', '575', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56427', '311', '39', '2010', '577', '576', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56445', '21', '39', '2010', '586', '585', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56457', '10', '39', '2010', '577', '577', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56471', '14', '39', '2010', '577', '576', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56516', '65', '39', '2011', '589', '589', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56527', '43', '39', '2011', '588', '587', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56539', '5', '39', '2011', '589', '588', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56549', '7', '39', '2011', '598', '596', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56566', '58', '39', '2011', '591', '589', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56595', '69', '39', '2011', '588', '587', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56613', '311', '39', '2011', '597', '597', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56628', '3', '39', '2011', '597', '596', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56651', '43', '39', '2012', '623', '622', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56664', '65', '39', '2012', '618', '618', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56679', '69', '39', '2012', '616', '615', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56700', '5', '39', '2012', '622', '621', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56721', '58', '39', '2012', '622', '621', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56735', '3', '39', '2012', '635', '631', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('56750', '14', '39', '2012', '621', '619', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('58075', '146', '39', '2010', '607', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58081', '354', '39', '2010', '605', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58098', '266', '39', '2010', '619', '617', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58114', '97', '39', '2010', '604', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58132', '89', '39', '2010', '606', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58147', '353', '39', '2010', '605', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58172', '126', '39', '2010', '600', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58186', '16', '39', '2010', '606', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58214', '21', '39', '2010', '617', '617', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58231', '311', '39', '2010', '609', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58256', '8', '39', '2010', '612', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58271', '7', '39', '2010', '611', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58288', '79', '39', '2010', '608', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58308', '221', '39', '2010', '611', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58323', '379', '39', '2010', '607', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58337', '3', '39', '2010', '619', '613', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58356', '17', '39', '2010', '625', '616', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58365', '178', '39', '2010', '607', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58423', '3', '39', '2011', '634', '633', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58437', '126', '39', '2011', '627', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58448', '78', '39', '2011', '627', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58459', '354', '39', '2011', '631', '628', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58470', '16', '39', '2011', '629', '628', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58481', '89', '39', '2011', '628', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58491', '266', '39', '2011', '631', '631', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58500', '7', '39', '2011', '634', '632', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58510', '17', '39', '2011', '629', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58519', '353', '39', '2011', '625', '624', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58528', '26', '39', '2011', '626', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58537', '52', '39', '2011', '626', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58551', '311', '39', '2011', '632', '630', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58563', '21', '39', '2011', '638', '634', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58574', '221', '39', '2011', '630', '630', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58584', '23', '39', '2011', '631', '631', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58589', '120', '39', '2011', '627', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58610', '52', '39', '2012', '647', '644', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58618', '311', '39', '2012', '647', '646', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58632', '354', '39', '2012', '648', '646', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58643', '221', '39', '2012', '653', '651', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58655', '266', '39', '2012', '650', '649', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58665', '78', '39', '2012', '644', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58683', '23', '39', '2012', '649', '648', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58698', '89', '39', '2012', '646', '645', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58713', '126', '39', '2012', '645', '644', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58723', '17', '39', '2012', '650', '648', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58738', '26', '39', '2012', '643', '638', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58753', '178', '39', '2012', '646', '645', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58766', '21', '39', '2012', '657', '651', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58779', '16', '39', '2012', '647', '647', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58789', '3', '39', '2012', '653', '651', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58794', '120', '39', '2012', '644', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('58805', '7', '39', '2012', '649', '648', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('65980', '15', '130', '2011', '494', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('65997', '67', '130', '2011', '505', '496', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('66019', '2', '130', '2011', '501', '497', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('66035', '17', '130', '2011', '521', '502', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('66063', '15', '130', '2012', '484', '482', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('66077', '2', '130', '2012', '485', '479', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('66097', '69', '130', '2012', '478', '466', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('66115', '67', '130', '2012', '482', '479', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('66136', '10', '130', '2013', '525', '525', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('66517', '185', '130', '2010', '452', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('66540', '15', '130', '2010', '460', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('66552', '143', '130', '2010', '469', '469', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('66563', '2', '130', '2010', '468', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('66591', '68', '130', '2010', '479', '479', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('66620', '15', '130', '2011', '454', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('66634', '146', '130', '2011', '454', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('66649', '2', '130', '2011', '485', '476', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('66658', '92', '130', '2011', '457', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('66686', '2', '130', '2012', '437', '437', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('66707', '12', '130', '2012', '437', '437', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('66736', '12', '130', '2013', '510', '510', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('66760', '56', '130', '2013', '524', '524', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('66868', '43', '131', '2010', '508', '508', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('66882', '329', '131', '2010', '560', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('66909', '164', '131', '2010', '583', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('66918', '85', '131', '2010', '511', '511', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('66932', '116', '131', '2010', '576', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('66950', '245', '131', '2010', '527', '514', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('66978', '17', '131', '2010', '545', '531', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('66997', '119', '131', '2010', '518', '518', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67013', '97', '131', '2010', '571', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67028', '94', '131', '2010', '609', '601', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67056', '17', '131', '2011', '589', '548', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67077', '245', '131', '2011', '598', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67086', '94', '131', '2011', '534', '524', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67117', '329', '131', '2011', '552', '552', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67141', '164', '131', '2011', '556', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67154', '43', '131', '2011', '484', '484', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67167', '10', '131', '2011', '551', '551', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67181', '97', '131', '2011', '511', '511', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67191', '116', '131', '2011', '537', '517', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67228', '17', '131', '2012', '525', '517', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67248', '40', '131', '2012', '514', '506', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67263', '3', '131', '2012', '525', '515', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67282', '329', '131', '2012', '537', '537', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67299', '85', '131', '2012', '590', '590', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67319', '245', '131', '2012', '529', '519', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67333', '37', '131', '2012', '477', '477', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67346', '119', '131', '2012', '491', '486', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67356', '94', '131', '2012', '584', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67375', '116', '131', '2012', '511', '500', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67400', '283', '131', '2013', '611', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67419', '40', '131', '2013', '616', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('67428', '119', '131', '2013', '646', '646', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('72534', '15', '112', '2010', '571', '569', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72555', '10', '112', '2010', '569', '567', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72571', '13', '112', '2010', '566', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72584', '5', '112', '2010', '587', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72597', '74', '112', '2010', '565', '565', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72617', '6', '112', '2010', '566', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72627', '14', '112', '2010', '566', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72653', '10', '112', '2011', '582', '581', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72665', '14', '112', '2011', '581', '580', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72688', '18', '112', '2011', '581', '580', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72717', '15', '112', '2011', '582', '581', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72737', '5', '112', '2011', '597', '587', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72748', '13', '112', '2011', '579', '579', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72768', '13', '112', '2012', '616', '616', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72783', '10', '112', '2012', '621', '620', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72803', '18', '112', '2012', '619', '618', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72820', '15', '112', '2012', '619', '618', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72834', '5', '112', '2012', '634', '622', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('72852', '74', '112', '2012', '616', '616', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('73299', '15', '112', '2010', '582', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73329', '17', '112', '2010', '590', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73343', '5', '112', '2010', '607', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73362', '56', '112', '2010', '582', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73374', '2', '112', '2010', '582', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73392', '139', '112', '2010', '581', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73424', '5', '112', '2011', '625', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73431', '139', '112', '2011', '606', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73453', '56', '112', '2011', '604', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73471', '2', '112', '2011', '605', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73501', '17', '112', '2011', '611', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73525', '15', '112', '2011', '612', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73558', '17', '112', '2012', '624', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73576', '56', '112', '2012', '635', '635', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73610', '5', '112', '2012', '635', '628', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73618', '15', '112', '2012', '622', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73636', '139', '112', '2012', '621', '620', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('73658', '2', '112', '2012', '623', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('79979', '71', '144', '2010', '466', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80001', '5', '144', '2010', '469', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80008', '40', '144', '2010', '482', '472', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80035', '8', '144', '2010', '488', '481', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80048', '438', '144', '2010', '455', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80082', '2', '144', '2010', '499', '489', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80105', '69', '144', '2010', '504', '494', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80127', '2', '144', '2011', '472', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80141', '5', '144', '2011', '464', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80158', '40', '144', '2011', '557', '483', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80167', '38', '144', '2011', '475', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80176', '85', '144', '2011', '461', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80205', '113', '144', '2012', '464', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80218', '40', '144', '2012', '478', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80235', '38', '144', '2012', '465', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80254', '2', '144', '2012', '476', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('80266', '5', '144', '2012', '442', '439', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('84659', '734', '150', '2010', '535', '535', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84675', '735', '150', '2010', '603', '603', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84694', '63', '150', '2010', '566', '554', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84714', '2', '150', '2010', '593', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84731', '41', '150', '2010', '591', '572', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84747', '9', '150', '2010', '525', '525', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84767', '293', '150', '2010', '546', '546', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84783', '14', '150', '2010', '554', '546', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84794', '51', '150', '2010', '598', '569', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84812', '10', '150', '2010', '567', '562', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84832', '81', '150', '2010', '563', '560', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84848', '5', '150', '2010', '609', '592', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84863', '736', '150', '2010', '563', '555', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84888', '63', '150', '2011', '586', '580', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84907', '9', '150', '2011', '559', '559', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84913', '81', '150', '2011', '576', '570', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84936', '736', '150', '2011', '582', '582', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84949', '51', '150', '2011', '574', '567', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84960', '10', '150', '2011', '549', '546', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84982', '739', '150', '2011', '572', '557', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('84998', '734', '150', '2011', '559', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85016', '5', '150', '2011', '575', '564', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85029', '14', '150', '2011', '578', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85036', '41', '150', '2011', '603', '603', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85056', '293', '150', '2011', '610', '589', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85065', '2', '150', '2011', '588', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85086', '81', '150', '2012', '542', '537', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85105', '41', '150', '2012', '545', '545', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85138', '9', '150', '2012', '551', '551', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85162', '734', '150', '2012', '528', '528', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85170', '10', '150', '2012', '540', '536', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85187', '14', '150', '2012', '524', '524', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85200', '739', '150', '2012', '522', '522', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85211', '5', '150', '2012', '555', '541', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85224', '63', '150', '2012', '547', '541', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85233', '65', '150', '2012', '527', '527', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85258', '15', '150', '2012', '540', '540', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85283', '293', '150', '2012', '563', '563', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85301', '51', '150', '2012', '542', '540', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85329', '735', '150', '2012', '507', '507', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85351', '51', '150', '2013', '560', '560', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85373', '734', '150', '2013', '584', '582', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85385', '9', '150', '2013', '603', '603', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85412', '20', '150', '2013', '639', '619', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85434', '21', '150', '2013', '609', '605', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85440', '13', '150', '2013', '615', '599', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85450', '10', '150', '2013', '558', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85463', '293', '150', '2013', '581', '581', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85476', '1', '150', '2013', '617', '607', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85499', '739', '150', '2013', '590', '569', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('85520', '5', '150', '2013', '588', '575', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('86531', '91', '150', '2010', '535', '517', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86545', '37', '150', '2010', '537', '525', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86557', '14', '150', '2010', '517', '509', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86565', '16', '150', '2010', '582', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86583', '12', '150', '2010', '529', '529', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86591', '119', '150', '2010', '569', '553', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86604', '25', '150', '2010', '556', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86633', '15', '150', '2010', '560', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86643', '17', '150', '2010', '600', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86656', '8', '150', '2010', '589', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86673', '21', '150', '2010', '589', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86684', '2', '150', '2010', '552', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86693', '101', '150', '2010', '556', '539', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86721', '10', '150', '2010', '503', '503', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86734', '5', '150', '2010', '577', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86758', '119', '150', '2011', '552', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86772', '143', '150', '2011', '574', '574', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86790', '5', '150', '2011', '547', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86824', '2', '150', '2011', '573', '559', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86835', '8', '150', '2011', '545', '541', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86844', '15', '150', '2011', '536', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86862', '16', '150', '2011', '557', '544', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86880', '736', '150', '2011', '548', '541', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86893', '37', '150', '2011', '542', '537', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86910', '12', '150', '2011', '526', '526', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86926', '17', '150', '2011', '572', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86936', '21', '150', '2011', '577', '574', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86952', '41', '150', '2011', '540', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86967', '14', '150', '2011', '580', '580', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86980', '10', '150', '2011', '564', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('86994', '25', '150', '2011', '526', '523', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87007', '91', '150', '2011', '541', '532', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87027', '101', '150', '2011', '525', '524', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87052', '16', '150', '2012', '564', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87078', '25', '150', '2012', '582', '538', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87092', '37', '150', '2012', '509', '509', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87113', '119', '150', '2012', '551', '519', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87141', '101', '150', '2012', '514', '511', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87150', '11', '150', '2012', '537', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87161', '41', '150', '2012', '513', '513', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87168', '736', '150', '2012', '604', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87183', '17', '150', '2012', '593', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87199', '65', '150', '2012', '533', '533', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87213', '21', '150', '2012', '629', '603', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87234', '739', '150', '2012', '534', '534', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87255', '5', '150', '2012', '566', '548', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87263', '14', '150', '2012', '578', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87283', '10', '150', '2012', '533', '527', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87294', '143', '150', '2012', '537', '537', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87313', '91', '150', '2012', '580', '523', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87320', '12', '150', '2012', '527', '527', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87336', '8', '150', '2012', '589', '580', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87352', '735', '150', '2012', '507', '507', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87366', '2', '150', '2012', '580', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87380', '17', '150', '2013', '675', '644', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87392', '10', '150', '2013', '604', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87415', '5', '150', '2013', '653', '632', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87434', '8', '150', '2013', '639', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87453', '65', '150', '2013', '589', '589', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87468', '12', '150', '2013', '584', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87485', '101', '150', '2013', '604', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('87494', '14', '150', '2013', '587', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('90700', '269', '107', '2010', '556', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90712', '31', '107', '2010', '560', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90732', '17', '107', '2010', '574', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90741', '40', '107', '2010', '566', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90749', '180', '107', '2010', '567', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90755', '113', '162', '2010', '456', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('90769', '119', '107', '2010', '571', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90791', '95', '107', '2010', '571', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90796', '85', '162', '2013', '542', '542', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('90812', '388', '107', '2010', '556', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90824', '134', '107', '2010', '552', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90858', '25', '107', '2010', '573', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90868', '150', '107', '2010', '556', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90879', '87', '107', '2010', '558', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90889', '225', '107', '2010', '566', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90902', '68', '107', '2010', '562', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90917', '116', '107', '2010', '578', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90929', '530', '107', '2010', '564', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90940', '528', '107', '2010', '556', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90955', '151', '107', '2010', '556', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90969', '533', '107', '2010', '570', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('90987', '2', '107', '2010', '560', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91009', '147', '107', '2010', '560', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91030', '506', '107', '2010', '565', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91039', '97', '107', '2010', '559', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91047', '226', '107', '2010', '564', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91071', '23', '160', '2010', '583', '543', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91075', '107', '107', '2010', '566', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91086', '300', '160', '2010', '591', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91098', '780', '160', '2010', '543', '539', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91101', '95', '107', '2011', '601', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91114', '480', '160', '2010', '583', '572', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91122', '31', '107', '2011', '579', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91130', '126', '160', '2010', '599', '561', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91141', '40', '107', '2011', '583', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91144', '136', '160', '2010', '575', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91161', '107', '107', '2011', '586', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91166', '266', '160', '2010', '591', '554', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91178', '180', '107', '2011', '600', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91191', '79', '160', '2010', '525', '516', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91197', '2', '107', '2011', '581', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91205', '21', '160', '2010', '626', '577', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91219', '388', '107', '2011', '580', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91222', '3', '160', '2010', '619', '584', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91242', '89', '160', '2010', '523', '513', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91251', '52', '160', '2010', '536', '515', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91252', '134', '107', '2011', '576', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91266', '225', '107', '2011', '583', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91269', '43', '160', '2010', '523', '514', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91287', '25', '107', '2011', '596', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91289', '65', '160', '2010', '523', '515', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91302', '98', '160', '2010', '532', '514', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91310', '68', '107', '2011', '579', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91324', '17', '107', '2011', '597', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91327', '69', '160', '2010', '552', '517', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91337', '97', '107', '2011', '577', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91342', '207', '160', '2010', '538', '519', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91347', '226', '107', '2011', '593', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91356', '67', '160', '2010', '564', '521', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91361', '147', '107', '2011', '578', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91372', '311', '160', '2010', '587', '543', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91378', '119', '107', '2011', '586', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91387', '151', '107', '2011', '577', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91393', '7', '160', '2010', '565', '537', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91398', '116', '107', '2011', '583', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91407', '8', '160', '2010', '603', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91413', '533', '107', '2011', '600', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91420', '2', '160', '2010', '585', '533', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91433', '269', '107', '2011', '590', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91437', '17', '160', '2010', '614', '563', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91439', '150', '107', '2011', '580', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91451', '530', '107', '2011', '582', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91453', '10', '160', '2010', '575', '527', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91464', '506', '107', '2011', '583', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91469', '24', '160', '2010', '561', '523', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91478', '5', '160', '2010', '538', '515', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91485', '78', '160', '2010', '587', '522', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91569', '17', '107', '2012', '604', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91572', '40', '107', '2012', '601', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91574', '134', '107', '2012', '597', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91576', '2', '107', '2012', '600', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91578', '533', '107', '2012', '602', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91579', '107', '107', '2012', '602', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91581', '480', '160', '2011', '611', '572', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91582', '269', '107', '2012', '602', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91583', '300', '160', '2011', '597', '553', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91584', '67', '107', '2012', '595', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91585', '23', '160', '2011', '602', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91586', '95', '107', '2012', '611', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91587', '780', '160', '2011', '553', '540', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91588', '388', '107', '2012', '597', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91589', '136', '160', '2011', '589', '555', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91590', '68', '107', '2012', '600', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91591', '8', '160', '2011', '630', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91592', '116', '107', '2012', '601', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91593', '3', '160', '2011', '620', '586', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91594', '530', '107', '2012', '602', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91595', '126', '160', '2011', '620', '574', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91596', '180', '107', '2012', '603', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91597', '17', '160', '2011', '619', '572', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91598', '25', '107', '2012', '602', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91599', '67', '160', '2011', '577', '534', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91600', '226', '107', '2012', '605', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91601', '5', '160', '2011', '564', '517', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91602', '119', '107', '2012', '606', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91603', '21', '160', '2011', '627', '584', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91604', '69', '160', '2011', '570', '527', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91605', '87', '107', '2012', '600', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91606', '10', '160', '2011', '570', '555', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91607', '97', '107', '2012', '596', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91608', '311', '160', '2011', '610', '550', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91609', '147', '107', '2012', '601', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91610', '7', '160', '2011', '582', '561', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91611', '31', '107', '2012', '598', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91612', '79', '160', '2011', '548', '523', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91613', '225', '107', '2012', '610', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('91614', '266', '160', '2011', '552', '540', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91615', '2', '160', '2011', '577', '546', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91766', '3', '160', '2012', '599', '561', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91774', '480', '160', '2012', '584', '546', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91781', '8', '160', '2012', '612', '537', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91786', '780', '160', '2012', '560', '514', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91794', '15', '160', '2012', '549', '500', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91799', '136', '160', '2012', '559', '523', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91806', '23', '160', '2012', '556', '531', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91810', '126', '160', '2012', '584', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91814', '2', '160', '2012', '594', '530', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91817', '17', '160', '2012', '586', '535', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91821', '67', '160', '2012', '585', '515', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91824', '65', '160', '2012', '513', '504', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91828', '10', '160', '2012', '556', '530', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91833', '339', '160', '2012', '548', '502', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91840', '69', '160', '2012', '549', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91860', '5', '160', '2012', '552', '499', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91871', '21', '160', '2012', '598', '553', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91880', '7', '160', '2012', '568', '524', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91896', '300', '160', '2012', '576', '530', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91914', '2', '160', '2012', '592', '526', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91930', '311', '160', '2012', '602', '539', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91940', '79', '160', '2012', '543', '501', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('91948', '266', '160', '2012', '582', '515', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('91992', '10', '160', '2013', '604', '585', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('92006', '300', '160', '2013', '615', '578', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('92017', '339', '160', '2013', '588', '560', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('92020', '7', '160', '2013', '612', '581', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('92030', '21', '160', '2013', '648', '605', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('92037', '5', '160', '2013', '565', '536', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('92048', '65', '160', '2013', '608', '579', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('92055', '69', '160', '2013', '598', '554', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('92065', '17', '160', '2013', '645', '593', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('92084', '8', '160', '2013', '625', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('93591', '38', '160', '2010', '611', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93597', '780', '160', '2010', '594', '541', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93602', '79', '160', '2010', '606', '551', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93607', '136', '160', '2010', '604', '551', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93615', '16', '160', '2010', '636', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93620', '266', '160', '2010', '605', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93629', '300', '160', '2010', '607', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93634', '65', '160', '2010', '563', '502', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93642', '126', '160', '2010', '615', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93649', '24', '160', '2010', '523', '503', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93656', '146', '160', '2010', '532', '503', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93661', '78', '160', '2010', '592', '528', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93665', '79', '160', '2010', '535', '504', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93670', '85', '160', '2010', '527', '505', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93676', '5', '160', '2010', '559', '506', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93683', '43', '160', '2010', '557', '505', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93691', '69', '160', '2010', '541', '509', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93697', '10', '160', '2010', '570', '519', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93703', '67', '160', '2010', '561', '511', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93710', '120', '160', '2010', '563', '515', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93717', '2', '160', '2010', '619', '543', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93724', '118', '160', '2010', '581', '523', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93731', '480', '160', '2010', '596', '577', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93743', '207', '160', '2010', '535', '502', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93752', '311', '160', '2010', '598', '556', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93759', '8', '160', '2010', '624', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93762', '89', '160', '2010', '531', '510', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93767', '17', '160', '2010', '636', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93771', '3', '160', '2010', '639', '589', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93779', '23', '160', '2010', '596', '554', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93784', '21', '160', '2010', '632', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93787', '52', '160', '2010', '522', '499', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93791', '148', '160', '2010', '519', '500', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93794', '98', '160', '2010', '525', '500', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93798', '97', '160', '2010', '620', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93802', '7', '160', '2010', '600', '560', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93865', '300', '160', '2011', '598', '544', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93875', '85', '160', '2011', '587', '504', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93886', '79', '160', '2011', '599', '500', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93898', '148', '160', '2011', '595', '495', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93912', '780', '160', '2011', '537', '524', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93919', '2', '160', '2011', '595', '539', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93926', '10', '160', '2011', '556', '542', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93933', '67', '160', '2011', '552', '495', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('93939', '480', '160', '2011', '606', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93951', '126', '160', '2011', '599', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93964', '136', '160', '2011', '537', '528', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93979', '311', '160', '2011', '608', '552', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('93991', '16', '160', '2011', '619', '539', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94002', '3', '160', '2011', '640', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94013', '23', '160', '2011', '612', '558', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94026', '8', '160', '2011', '632', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94044', '38', '160', '2011', '549', '529', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94057', '5', '160', '2011', '552', '485', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94072', '266', '160', '2011', '607', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94094', '118', '160', '2011', '560', '518', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94105', '7', '160', '2011', '596', '571', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94122', '21', '160', '2011', '627', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94134', '97', '160', '2011', '611', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94149', '17', '160', '2011', '642', '574', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94158', '69', '160', '2011', '560', '515', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94193', '3', '160', '2012', '631', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94205', '780', '160', '2012', '587', '515', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94216', '8', '160', '2012', '628', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94226', '2', '160', '2012', '626', '561', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94238', '136', '160', '2012', '592', '531', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94252', '126', '160', '2012', '611', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94265', '15', '160', '2012', '597', '495', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94283', '23', '160', '2012', '611', '552', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94300', '17', '160', '2012', '634', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94311', '480', '160', '2012', '625', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94328', '5', '160', '2012', '571', '491', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94337', '65', '160', '2012', '514', '503', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94362', '10', '160', '2012', '584', '543', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94376', '339', '160', '2012', '585', '512', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94393', '164', '160', '2012', '605', '515', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94407', '118', '160', '2012', '555', '499', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94432', '85', '160', '2012', '593', '503', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94453', '69', '160', '2012', '567', '513', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94475', '16', '160', '2012', '617', '526', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94494', '97', '160', '2012', '623', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94508', '67', '160', '2012', '552', '495', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94520', '311', '160', '2012', '613', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94544', '7', '160', '2012', '601', '525', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94566', '21', '160', '2012', '617', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94577', '300', '160', '2012', '606', '530', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94591', '2', '160', '2012', '617', '532', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94605', '148', '160', '2012', '565', '490', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94622', '221', '160', '2012', '641', '558', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94642', '266', '160', '2012', '605', '525', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94660', '38', '160', '2012', '603', '530', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94679', '79', '160', '2012', '574', '485', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94715', '118', '160', '2013', '635', '569', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94732', '65', '160', '2013', '597', '590', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94747', '339', '160', '2013', '613', '583', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94764', '69', '160', '2013', '630', '590', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94777', '8', '160', '2013', '661', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94804', '97', '160', '2013', '655', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94821', '300', '160', '2013', '638', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94835', '7', '160', '2013', '641', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94845', '10', '160', '2013', '639', '604', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94859', '21', '160', '2013', '672', '627', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94881', '85', '160', '2013', '647', '562', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('94903', '17', '160', '2013', '678', '626', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94917', '221', '160', '2013', '676', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('94929', '5', '160', '2013', '624', '564', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('98386', '13', '105', '2010', '541', '541', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98402', '5', '105', '2010', '542', '542', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98419', '69', '105', '2010', '544', '544', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98438', '52', '105', '2010', '544', '544', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98462', '10', '105', '2010', '552', '546', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98468', '43', '105', '2010', '546', '546', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98489', '23', '105', '2010', '547', '547', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98502', '136', '105', '2010', '550', '550', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98517', '3', '105', '2010', '560', '560', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98537', '136', '105', '2011', '561', '561', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98553', '3', '105', '2011', '567', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98575', '52', '105', '2011', '562', '562', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98592', '69', '105', '2011', '561', '561', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98605', '5', '105', '2011', '563', '562', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98621', '43', '105', '2011', '566', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98636', '10', '105', '2011', '564', '562', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98650', '23', '105', '2011', '565', '565', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98671', '10', '105', '2012', '599', '598', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98686', '23', '105', '2012', '600', '600', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98704', '13', '105', '2012', '598', '598', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98721', '3', '105', '2012', '605', '604', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98738', '69', '105', '2012', '603', '603', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98761', '5', '105', '2012', '595', '595', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98787', '43', '105', '2012', '598', '598', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('98805', '136', '105', '2012', '598', '598', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('100993', '540', '105', '2010', '576', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101007', '143', '105', '2010', '578', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101028', '94', '105', '2010', '576', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101061', '37', '105', '2010', '572', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101084', '83', '105', '2010', '576', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101096', '127', '105', '2010', '576', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101122', '262', '105', '2010', '590', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101135', '131', '105', '2010', '570', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101151', '38', '105', '2010', '570', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101171', '151', '105', '2010', '571', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101199', '161', '105', '2010', '570', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101219', '2', '105', '2010', '569', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101231', '146', '105', '2010', '569', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101253', '30', '105', '2010', '569', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101269', '79', '105', '2010', '568', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101293', '126', '105', '2010', '567', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101320', '17', '105', '2010', '568', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101345', '89', '105', '2010', '566', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101366', '78', '105', '2010', '568', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101384', '174', '105', '2010', '571', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101394', '445', '105', '2010', '571', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101406', '36', '105', '2010', '577', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101419', '390', '105', '2010', '584', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101437', '113', '105', '2010', '590', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101454', '123', '105', '2010', '576', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101487', '101', '105', '2010', '565', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101515', '78', '105', '2011', '590', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101537', '94', '105', '2011', '603', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101561', '101', '105', '2011', '593', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101571', '276', '105', '2011', '600', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101586', '89', '105', '2011', '592', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101607', '540', '105', '2011', '597', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101627', '127', '105', '2011', '603', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101661', '36', '105', '2011', '601', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101679', '37', '105', '2011', '596', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101721', '131', '105', '2011', '593', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101749', '500', '105', '2011', '604', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101764', '83', '105', '2011', '597', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101784', '143', '105', '2011', '598', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101799', '262', '105', '2011', '601', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101818', '223', '105', '2011', '593', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101839', '146', '105', '2011', '597', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101868', '445', '105', '2011', '590', '590', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101883', '17', '105', '2011', '596', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101897', '126', '105', '2011', '589', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101920', '2', '105', '2011', '598', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101941', '79', '105', '2011', '590', '590', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101967', '174', '105', '2011', '596', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('101983', '30', '105', '2011', '591', '590', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102004', '38', '105', '2011', '591', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102018', '390', '105', '2011', '603', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102035', '113', '105', '2011', '627', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102061', '459', '105', '2012', '611', '611', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102073', '37', '105', '2012', '619', '619', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102091', '38', '105', '2012', '609', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102114', '2', '105', '2012', '612', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102123', '78', '105', '2012', '609', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102139', '143', '105', '2012', '624', '620', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102151', '36', '105', '2012', '617', '615', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102165', '79', '105', '2012', '612', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102188', '126', '105', '2012', '610', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102206', '262', '105', '2012', '618', '615', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102224', '146', '105', '2012', '613', '611', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102241', '17', '105', '2012', '615', '613', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102254', '151', '105', '2012', '613', '611', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102269', '149', '105', '2012', '610', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102286', '540', '105', '2012', '620', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102303', '131', '105', '2012', '614', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102310', '390', '105', '2012', '623', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102338', '83', '105', '2012', '615', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102353', '127', '105', '2012', '623', '617', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102364', '120', '105', '2012', '609', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102381', '101', '105', '2012', '609', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102391', '30', '105', '2012', '618', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102403', '174', '105', '2012', '617', '615', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102424', '500', '105', '2012', '623', '620', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102440', '89', '105', '2012', '612', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102451', '276', '105', '2012', '619', '617', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102465', '113', '105', '2012', '630', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102480', '94', '105', '2012', '618', '618', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102500', '445', '105', '2012', '611', '611', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102518', '223', '105', '2012', '614', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102535', '190', '105', '2012', '611', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('102556', '123', '105', '2012', '615', '615', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('103426', '881', '169', '2010', '520', '490', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103441', '52', '169', '2010', '511', '482', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103456', '56', '169', '2010', '505', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103464', '5', '169', '2010', '513', '485', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103479', '885', '169', '2010', '502', '483', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103490', '864', '169', '2010', '510', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103503', '374', '169', '2010', '509', '484', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103522', '428', '169', '2010', '512', '485', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103536', '371', '169', '2010', '509', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103543', '21', '169', '2010', '529', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103569', '12', '169', '2010', '513', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103591', '69', '169', '2010', '522', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103607', '2', '169', '2010', '508', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103623', '13', '169', '2010', '518', '489', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103636', '23', '169', '2010', '519', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103655', '126', '169', '2010', '519', '493', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103663', '860', '169', '2010', '521', '488', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103675', '58', '169', '2010', '519', '494', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103690', '357', '169', '2010', '503', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103702', '8', '169', '2010', '512', '502', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103713', '279', '169', '2010', '506', '490', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103725', '3', '169', '2010', '534', '514', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103759', '279', '169', '2011', '512', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103777', '21', '169', '2011', '522', '502', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103786', '56', '169', '2011', '540', '497', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103796', '69', '169', '2011', '507', '490', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103806', '860', '169', '2011', '519', '490', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103818', '24', '169', '2011', '514', '496', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103829', '8', '169', '2011', '528', '501', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103838', '5', '169', '2011', '524', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103856', '374', '169', '2011', '515', '496', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103867', '428', '169', '2011', '515', '496', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103878', '13', '169', '2011', '521', '492', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103887', '885', '169', '2011', '521', '492', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103899', '371', '169', '2011', '505', '490', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103916', '23', '169', '2011', '519', '498', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103936', '126', '169', '2011', '521', '496', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103950', '12', '169', '2011', '512', '495', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103961', '58', '169', '2011', '518', '492', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103981', '881', '169', '2011', '531', '495', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('103994', '357', '169', '2011', '520', '499', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104011', '68', '169', '2012', '495', '459', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104022', '126', '169', '2012', '489', '464', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104045', '17', '169', '2012', '500', '465', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104061', '23', '169', '2012', '479', '463', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104073', '3', '169', '2012', '492', '463', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104098', '56', '169', '2012', '481', '463', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104114', '21', '169', '2012', '525', '475', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104135', '279', '169', '2012', '477', '453', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104148', '12', '169', '2012', '482', '460', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104160', '69', '169', '2012', '489', '460', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104174', '860', '169', '2012', '490', '456', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104192', '146', '169', '2012', '475', '455', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104210', '2', '169', '2012', '488', '461', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104220', '5', '169', '2012', '480', '457', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104237', '13', '169', '2012', '488', '458', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104250', '58', '169', '2012', '491', '467', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104264', '881', '169', '2012', '498', '463', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104279', '357', '169', '2012', '487', '467', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104286', '885', '169', '2012', '483', '452', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104304', '374', '169', '2012', '490', '460', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104316', '139', '169', '2012', '481', '462', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104327', '24', '169', '2012', '485', '461', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104343', '56', '169', '2013', '539', '519', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104351', '8', '169', '2013', '538', '516', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104360', '21', '169', '2013', '542', '516', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104370', '10', '169', '2013', '541', '510', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104383', '12', '169', '2013', '548', '515', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104391', '486', '169', '2013', '523', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104400', '58', '169', '2013', '532', '512', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104408', '13', '169', '2013', '539', '511', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104416', '5', '169', '2013', '516', '505', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104429', '69', '169', '2013', '530', '504', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('104445', '892', '169', '2013', '532', '503', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('106481', '148', '169', '2010', '481', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106486', '13', '169', '2010', '502', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106491', '131', '169', '2010', '486', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106495', '220', '169', '2010', '472', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106504', '58', '169', '2010', '484', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106509', '12', '169', '2010', '491', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106514', '83', '169', '2010', '542', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106517', '374', '169', '2010', '492', '461', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106521', '184', '169', '2010', '508', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106527', '140', '169', '2010', '494', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106533', '211', '169', '2010', '483', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106538', '91', '169', '2010', '501', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106544', '94', '169', '2010', '491', '461', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106552', '24', '169', '2010', '486', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106561', '23', '169', '2010', '492', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106568', '893', '169', '2010', '493', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106577', '56', '169', '2010', '493', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106584', '371', '169', '2010', '507', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106590', '40', '169', '2010', '501', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106597', '69', '169', '2010', '485', '461', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106607', '357', '169', '2010', '493', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106612', '126', '169', '2010', '491', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106619', '146', '169', '2010', '481', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106626', '391', '169', '2010', '484', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106635', '38', '169', '2010', '492', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106641', '428', '169', '2010', '490', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106649', '226', '169', '2010', '487', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106653', '119', '169', '2010', '491', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106659', '36', '169', '2010', '490', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106671', '101', '169', '2010', '491', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106679', '885', '169', '2010', '475', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106689', '37', '169', '2010', '491', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106698', '381', '169', '2010', '486', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106710', '95', '169', '2010', '484', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106722', '860', '169', '2010', '476', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106728', '3', '169', '2010', '492', '470', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106736', '279', '169', '2010', '515', '472', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106747', '5', '169', '2010', '492', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106753', '2', '169', '2010', '491', '475', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106759', '68', '169', '2010', '521', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106767', '881', '169', '2010', '506', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106773', '88', '169', '2010', '493', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106786', '864', '169', '2010', '492', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106798', '8', '169', '2010', '495', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106813', '21', '169', '2010', '495', '473', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106816', '143', '169', '2010', '493', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106828', '52', '169', '2010', '485', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106848', '279', '169', '2011', '480', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106860', '23', '169', '2011', '474', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106872', '126', '169', '2011', '471', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106879', '101', '169', '2011', '457', '444', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106896', '3', '169', '2011', '481', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106907', '374', '169', '2011', '463', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106918', '881', '169', '2011', '491', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106932', '371', '169', '2011', '495', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106946', '146', '169', '2011', '535', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106959', '21', '169', '2011', '493', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106966', '5', '169', '2011', '456', '444', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106976', '13', '169', '2011', '482', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106986', '69', '169', '2011', '462', '445', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('106995', '428', '169', '2011', '481', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107002', '860', '169', '2011', '471', '445', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107012', '24', '169', '2011', '481', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107044', '56', '169', '2011', '483', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107064', '143', '169', '2011', '480', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107092', '38', '169', '2011', '500', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107109', '893', '169', '2011', '459', '443', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107128', '131', '169', '2011', '479', '444', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107139', '391', '169', '2011', '450', '439', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107155', '95', '169', '2011', '507', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107184', '885', '169', '2011', '475', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107196', '12', '169', '2011', '499', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107204', '58', '169', '2011', '489', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107216', '357', '169', '2011', '467', '445', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107229', '36', '169', '2011', '482', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107243', '8', '169', '2011', '461', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107253', '226', '169', '2011', '467', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107281', '68', '169', '2011', '461', '443', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107292', '37', '169', '2011', '479', '445', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107314', '143', '169', '2012', '472', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107337', '68', '169', '2012', '465', '442', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107357', '17', '169', '2012', '487', '445', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107373', '3', '169', '2012', '476', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107393', '38', '169', '2012', '557', '445', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107397', '881', '169', '2012', '472', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107407', '56', '169', '2012', '486', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107427', '185', '169', '2012', '474', '439', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107449', '23', '169', '2012', '476', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107465', '37', '169', '2012', '474', '445', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107473', '279', '169', '2012', '448', '438', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107489', '226', '169', '2012', '464', '441', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107502', '95', '169', '2012', '439', '436', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107511', '91', '169', '2012', '472', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107522', '58', '169', '2012', '475', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107533', '36', '169', '2012', '453', '441', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107551', '860', '169', '2012', '456', '439', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107558', '101', '169', '2012', '460', '439', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107565', '90', '169', '2012', '453', '438', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107583', '40', '169', '2012', '474', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107601', '21', '169', '2012', '467', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107616', '2', '169', '2012', '474', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107623', '12', '169', '2012', '474', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107637', '5', '169', '2012', '504', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107659', '131', '169', '2012', '462', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107668', '69', '169', '2012', '455', '444', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107680', '13', '169', '2012', '472', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107691', '146', '169', '2012', '469', '444', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107715', '173', '169', '2012', '457', '440', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107723', '30', '169', '2012', '464', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107740', '885', '169', '2012', '454', '439', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107753', '126', '169', '2012', '458', '445', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107774', '357', '169', '2012', '459', '443', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107789', '374', '169', '2012', '476', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107796', '24', '169', '2012', '474', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107816', '21', '169', '2013', '540', '522', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107829', '8', '169', '2013', '529', '514', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107849', '931', '169', '2013', '531', '511', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107857', '13', '169', '2013', '539', '521', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107867', '92', '169', '2013', '521', '511', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107897', '932', '169', '2013', '535', '514', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107911', '10', '169', '2013', '540', '521', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107926', '91', '169', '2013', '527', '511', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107937', '83', '169', '2013', '535', '514', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107944', '69', '169', '2013', '540', '514', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107958', '892', '169', '2013', '521', '514', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107966', '58', '169', '2013', '543', '519', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107985', '486', '169', '2013', '539', '518', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('107998', '56', '169', '2013', '532', '521', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('108011', '40', '169', '2013', '547', '519', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('108017', '5', '169', '2013', '535', '521', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('108029', '173', '169', '2013', '537', '516', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('108038', '12', '169', '2013', '534', '534', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('109413', '90', '169', '2011', '414', '414', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('109426', '2', '169', '2011', '430', '412', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('109443', '173', '169', '2011', '427', '419', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('109464', '143', '169', '2011', '418', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('109481', '38', '169', '2011', '448', '439', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('109503', '40', '169', '2011', '430', '413', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('109526', '173', '169', '2012', '382', '373', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('109534', '90', '169', '2012', '377', '372', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('109549', '173', '169', '2013', '346', '345', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('111997', '3', '175', '2010', '582', '569', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112011', '76', '175', '2010', '623', '578', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112024', '21', '175', '2010', '611', '593', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112036', '8', '175', '2010', '584', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112058', '5', '175', '2010', '550', '545', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112067', '572', '175', '2010', '566', '547', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112084', '10', '175', '2010', '564', '552', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112097', '126', '175', '2010', '573', '554', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112114', '2', '175', '2010', '579', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112138', '21', '175', '2011', '604', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112150', '8', '175', '2011', '609', '582', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112178', '3', '175', '2011', '589', '579', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112191', '572', '175', '2011', '566', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112203', '126', '175', '2011', '622', '574', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112223', '5', '175', '2011', '622', '575', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112248', '2', '175', '2011', '574', '563', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112260', '10', '175', '2011', '575', '564', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112279', '181', '175', '2011', '614', '614', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112300', '8', '175', '2012', '551', '540', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112314', '10', '175', '2012', '525', '513', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112340', '3', '175', '2012', '575', '550', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112357', '572', '175', '2012', '588', '562', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112367', '2', '175', '2012', '525', '513', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112383', '126', '175', '2012', '541', '528', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112395', '5', '175', '2012', '568', '525', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112407', '56', '175', '2012', '578', '542', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112432', '78', '175', '2012', '513', '513', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112441', '21', '175', '2012', '565', '550', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112475', '21', '175', '2013', '597', '591', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112491', '5', '175', '2013', '589', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112510', '56', '175', '2013', '622', '593', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112529', '10', '175', '2013', '604', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('112548', '8', '175', '2013', '637', '604', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('113842', '23', '180', '2011', '487', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('113866', '3', '180', '2011', '486', '486', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('113886', '3', '180', '2012', '493', '489', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('113907', '17', '180', '2012', '471', '462', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('113925', '23', '180', '2012', '492', '492', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('113936', '364', '180', '2012', '487', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('113951', '2', '180', '2012', '460', '460', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('114151', '23', '180', '2011', '482', '482', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('114170', '3', '180', '2011', '469', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('114193', '3', '180', '2012', '468', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('114204', '17', '180', '2012', '474', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('114215', '2', '180', '2012', '437', '437', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('114220', '23', '180', '2012', '463', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('114235', '364', '180', '2012', '460', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('114257', '38', '180', '2012', '435', '435', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('115712', '129', '175', '2010', '576', '566', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115726', '25', '175', '2010', '633', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115737', '24', '175', '2010', '577', '567', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115757', '222', '175', '2010', '600', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115776', '95', '175', '2010', '619', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115799', '759', '175', '2010', '604', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115810', '181', '175', '2010', '592', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115832', '325', '175', '2010', '594', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115847', '279', '175', '2010', '588', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115861', '381', '175', '2010', '548', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115882', '113', '175', '2010', '583', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115904', '794', '175', '2010', '594', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115923', '87', '175', '2010', '634', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115944', '21', '175', '2010', '629', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115956', '140', '175', '2010', '575', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115966', '12', '175', '2010', '608', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('115984', '55', '175', '2010', '630', '606', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116009', '2', '175', '2010', '570', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116025', '147', '175', '2010', '583', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116045', '996', '175', '2010', '621', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116056', '220', '175', '2010', '573', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116070', '126', '175', '2010', '576', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116094', '397', '175', '2010', '585', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116107', '3', '175', '2010', '585', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116124', '36', '175', '2010', '554', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116140', '68', '175', '2010', '568', '558', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116156', '8', '175', '2010', '580', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116180', '1015', '175', '2010', '588', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116195', '572', '175', '2010', '593', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116210', '351', '175', '2010', '650', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116228', '97', '175', '2010', '574', '558', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116244', '119', '175', '2010', '588', '568', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116253', '38', '175', '2010', '556', '551', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116262', '78', '175', '2010', '568', '553', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116273', '444', '175', '2010', '604', '559', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116286', '85', '175', '2010', '582', '573', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116300', '5', '175', '2010', '562', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116315', '10', '175', '2010', '578', '568', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116325', '107', '175', '2010', '569', '548', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116331', '79', '175', '2010', '561', '552', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116356', '76', '175', '2010', '630', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116382', '222', '175', '2011', '617', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116397', '126', '175', '2011', '568', '558', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116408', '87', '175', '2011', '620', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116425', '759', '175', '2011', '578', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116444', '996', '175', '2011', '609', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116463', '444', '175', '2011', '570', '562', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116473', '21', '175', '2011', '617', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116489', '3', '175', '2011', '576', '558', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116506', '181', '175', '2011', '595', '557', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116516', '794', '175', '2011', '571', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116529', '79', '175', '2011', '544', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116541', '140', '175', '2011', '534', '530', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116553', '25', '175', '2011', '593', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116570', '572', '175', '2011', '531', '527', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116582', '78', '175', '2011', '572', '544', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116600', '24', '175', '2011', '584', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116612', '2', '175', '2011', '574', '545', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116628', '5', '175', '2011', '531', '526', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116635', '55', '175', '2011', '639', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116643', '12', '175', '2011', '536', '533', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116650', '381', '175', '2011', '545', '539', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116667', '397', '175', '2011', '551', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116676', '129', '175', '2011', '566', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116681', '119', '175', '2011', '577', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116689', '220', '175', '2011', '557', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116701', '16', '175', '2011', '573', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116710', '95', '175', '2011', '616', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116720', '8', '175', '2011', '571', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116728', '85', '175', '2011', '565', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116740', '38', '175', '2011', '561', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116753', '147', '175', '2011', '548', '531', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116765', '1015', '175', '2011', '593', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116775', '107', '175', '2011', '557', '532', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116784', '113', '175', '2011', '570', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116796', '325', '175', '2011', '648', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116812', '36', '175', '2011', '541', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116829', '68', '175', '2011', '567', '548', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116841', '351', '175', '2011', '636', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116850', '279', '175', '2011', '557', '545', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116858', '97', '175', '2011', '559', '553', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116879', '56', '175', '2012', '593', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116893', '85', '175', '2012', '568', '553', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116913', '147', '175', '2012', '547', '530', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116927', '87', '175', '2012', '620', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116949', '572', '175', '2012', '555', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116959', '397', '175', '2012', '539', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116969', '113', '175', '2012', '578', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116981', '153', '175', '2012', '550', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('116996', '1016', '175', '2012', '563', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117012', '996', '175', '2012', '559', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117032', '444', '175', '2012', '582', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117042', '222', '175', '2012', '588', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117062', '3', '175', '2012', '598', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117081', '2', '175', '2012', '558', '553', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117102', '25', '175', '2012', '588', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117115', '95', '175', '2012', '611', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117126', '325', '175', '2012', '586', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117150', '36', '175', '2012', '555', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117162', '220', '175', '2012', '547', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117178', '8', '175', '2012', '568', '559', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117190', '5', '175', '2012', '556', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117203', '759', '175', '2012', '576', '559', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117217', '129', '175', '2012', '556', '543', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117238', '89', '175', '2012', '570', '553', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117249', '140', '175', '2012', '543', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117262', '181', '175', '2012', '550', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117276', '1015', '175', '2012', '556', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117292', '119', '175', '2012', '570', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117302', '24', '175', '2012', '543', '538', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117317', '279', '175', '2012', '547', '545', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117330', '21', '175', '2012', '636', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117339', '79', '175', '2012', '568', '543', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117349', '126', '175', '2012', '565', '557', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117368', '68', '175', '2012', '575', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117394', '1017', '175', '2012', '586', '558', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117430', '97', '175', '2012', '568', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117449', '339', '175', '2012', '563', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117474', '55', '175', '2012', '617', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117490', '38', '175', '2012', '549', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117502', '381', '175', '2012', '537', '533', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117512', '205', '175', '2012', '559', '553', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117528', '107', '175', '2012', '569', '544', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117544', '351', '175', '2012', '638', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117576', '351', '175', '2013', '621', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117590', '85', '175', '2013', '624', '619', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117613', '339', '175', '2013', '647', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117629', '8', '175', '2013', '646', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117646', '95', '175', '2013', '677', '638', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117677', '119', '175', '2013', '626', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117688', '222', '175', '2013', '647', '645', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117702', '759', '175', '2013', '638', '627', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117715', '97', '175', '2013', '626', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117724', '12', '175', '2013', '624', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117738', '113', '175', '2013', '616', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('117752', '996', '175', '2013', '614', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('119486', '8', '169', '2010', '517', '516', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('119519', '8', '169', '2011', '534', '532', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('119526', '24', '169', '2011', '530', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('119536', '3', '169', '2011', '544', '543', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('119542', '21', '169', '2011', '557', '550', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('119988', '36', '169', '2010', '513', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('119993', '94', '169', '2010', '514', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('119997', '8', '169', '2010', '514', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('120039', '8', '169', '2011', '532', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('120049', '143', '169', '2011', '536', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('120055', '3', '169', '2011', '548', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('120067', '21', '169', '2011', '547', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('120073', '38', '169', '2011', '530', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('120079', '40', '169', '2011', '527', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('120086', '24', '169', '2011', '527', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('120093', '36', '169', '2011', '529', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('120099', '185', '169', '2011', '529', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('120103', '2', '169', '2011', '534', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('131417', '159', '209', '2010', '595', '585', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131426', '3', '209', '2010', '588', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131442', '63', '209', '2010', '599', '592', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131469', '61', '209', '2010', '594', '594', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131482', '8', '209', '2010', '600', '597', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131493', '21', '209', '2010', '601', '601', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131507', '22', '209', '2010', '589', '589', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131522', '10', '209', '2010', '602', '602', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131544', '159', '209', '2011', '587', '587', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131550', '3', '209', '2011', '553', '553', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131569', '8', '209', '2011', '594', '594', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131579', '22', '209', '2011', '596', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131590', '21', '209', '2011', '563', '563', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131611', '58', '209', '2011', '601', '601', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131628', '44', '209', '2011', '605', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131649', '61', '209', '2011', '596', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131678', '64', '209', '2012', '542', '542', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131712', '3', '209', '2012', '520', '520', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131724', '79', '209', '2012', '513', '513', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131747', '5', '209', '2012', '575', '556', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131758', '58', '209', '2012', '558', '551', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131781', '18', '209', '2012', '556', '556', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131804', '48', '209', '2012', '559', '559', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131823', '10', '209', '2013', '639', '639', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131855', '159', '209', '2013', '631', '631', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131867', '44', '209', '2013', '624', '624', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131877', '58', '209', '2013', '616', '616', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('131895', '22', '209', '2013', '614', '614', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('132061', '8', '209', '2010', '628', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132084', '10', '209', '2010', '616', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132104', '22', '209', '2010', '607', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132117', '3', '209', '2010', '602', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132125', '44', '209', '2010', '639', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132140', '159', '209', '2010', '623', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132160', '61', '209', '2010', '624', '624', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132170', '21', '209', '2010', '639', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132191', '63', '209', '2010', '597', '597', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132210', '3', '209', '2011', '620', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132251', '22', '209', '2011', '598', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132264', '58', '209', '2011', '603', '603', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132275', '21', '209', '2011', '597', '597', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132300', '61', '209', '2011', '632', '632', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132317', '44', '209', '2011', '586', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132329', '10', '209', '2011', '520', '520', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132344', '159', '209', '2011', '569', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132361', '8', '209', '2011', '579', '579', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132390', '64', '209', '2012', '624', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132407', '58', '209', '2012', '530', '517', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132424', '48', '209', '2012', '506', '500', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132441', '18', '209', '2012', '564', '526', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132463', '79', '209', '2012', '596', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132487', '3', '209', '2012', '565', '544', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132508', '5', '209', '2012', '565', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132543', '159', '209', '2013', '649', '643', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132560', '10', '209', '2013', '640', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132574', '22', '209', '2013', '637', '636', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('132587', '58', '209', '2013', '636', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133556', '141', '210', '2010', '632', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133579', '83', '210', '2010', '590', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133590', '99', '210', '2010', '628', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133607', '85', '210', '2010', '616', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133625', '37', '210', '2010', '561', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133642', '91', '210', '2010', '618', '551', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133653', '94', '210', '2010', '617', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133669', '80', '210', '2010', '615', '580', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133681', '8', '210', '2010', '632', '559', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133695', '161', '210', '2010', '610', '559', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133711', '36', '210', '2010', '581', '559', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133729', '40', '210', '2010', '607', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133754', '283', '210', '2010', '610', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133788', '83', '210', '2011', '592', '562', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133810', '36', '210', '2011', '606', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133827', '283', '210', '2011', '607', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133842', '80', '210', '2011', '589', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133857', '141', '210', '2011', '625', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133869', '37', '210', '2011', '551', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133890', '161', '210', '2011', '593', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133915', '94', '210', '2011', '558', '543', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133923', '40', '210', '2011', '597', '548', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133933', '99', '210', '2011', '648', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133948', '91', '210', '2011', '598', '545', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133962', '85', '210', '2011', '564', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133971', '2', '210', '2011', '557', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('133979', '8', '210', '2011', '577', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134040', '94', '210', '2012', '606', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134056', '91', '210', '2012', '589', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134062', '378', '210', '2012', '598', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134077', '8', '210', '2012', '535', '524', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134088', '37', '210', '2012', '541', '528', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134104', '161', '210', '2012', '581', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134118', '36', '210', '2012', '632', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134128', '283', '210', '2012', '626', '551', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134139', '83', '210', '2012', '615', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134147', '40', '210', '2012', '626', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134159', '99', '210', '2012', '634', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134176', '85', '210', '2012', '607', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134191', '2', '210', '2012', '604', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134207', '80', '210', '2012', '620', '552', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134218', '141', '210', '2012', '625', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134261', '8', '210', '2013', '673', '638', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134278', '283', '210', '2013', '593', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134289', '91', '210', '2013', '662', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134296', '85', '210', '2013', '621', '597', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134314', '161', '210', '2013', '667', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134325', '141', '210', '2013', '677', '632', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134342', '378', '210', '2013', '623', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('134360', '151', '210', '2013', '656', '609', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('137831', '3', '218', '2010', '475', '475', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('137854', '120', '218', '2011', '486', '486', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('137890', '120', '218', '2012', '478', '478', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('137915', '3', '218', '2012', '457', '457', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('138248', '143', '218', '2010', '478', '478', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('138256', '220', '218', '2010', '476', '476', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('138272', '30', '218', '2010', '456', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('138280', '184', '218', '2010', '441', '441', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('138366', '203', '219', '2010', '513', '499', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('138379', '5', '219', '2010', '503', '498', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('138388', '65', '219', '2010', '481', '478', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('138411', '5', '219', '2011', '500', '499', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('138419', '203', '219', '2011', '492', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('138429', '24', '219', '2011', '494', '492', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('138452', '13', '219', '2012', '479', '462', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('138459', '58', '219', '2012', '489', '483', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('138473', '436', '219', '2012', '481', '477', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('138485', '5', '219', '2012', '485', '474', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('138508', '13', '219', '2013', '507', '507', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('138912', '59', '219', '2010', '457', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('138949', '78', '219', '2010', '463', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('138968', '43', '219', '2010', '450', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('138992', '78', '219', '2011', '455', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('139008', '59', '219', '2011', '449', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('139024', '99', '210', '2010', '484', '478', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('139036', '5', '219', '2011', '453', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('139040', '141', '210', '2010', '503', '483', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('139055', '43', '219', '2011', '461', '461', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('139064', '141', '210', '2011', '485', '476', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('139082', '99', '210', '2011', '483', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('139084', '5', '219', '2012', '438', '438', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('139101', '161', '210', '2011', '466', '464', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('139103', '58', '219', '2012', '463', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('139110', '378', '210', '2011', '478', '473', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('139127', '436', '219', '2013', '544', '531', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('139139', '99', '210', '2012', '441', '440', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('139157', '8', '210', '2012', '453', '440', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('139175', '141', '210', '2012', '437', '433', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('139199', '141', '210', '2013', '435', '433', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('139933', '1225', '221', '2010', '571', '540', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('139944', '1213', '221', '2010', '542', '539', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('139964', '548', '221', '2010', '552', '528', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('139985', '1226', '221', '2010', '576', '564', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('140000', '1227', '221', '2010', '603', '603', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('140548', '1230', '221', '2010', '544', '524', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('140569', '1213', '221', '2010', '585', '548', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('140584', '1229', '221', '2010', '585', '520', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('140599', '522', '221', '2010', '587', '543', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('140618', '1227', '221', '2010', '558', '543', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('140632', '1228', '221', '2010', '585', '520', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('140645', '1226', '221', '2010', '548', '524', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('140668', '1225', '221', '2010', '567', '539', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('140683', '548', '221', '2010', '577', '544', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('144383', '1227', '221', '2010', '493', '493', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('144396', '1213', '221', '2010', '473', '473', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('144408', '1229', '221', '2010', '467', '467', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('144436', '548', '221', '2010', '474', '474', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('144878', '1213', '221', '2010', '490', '490', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('144902', '1225', '221', '2010', '474', '474', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('144922', '1230', '221', '2010', '473', '470', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('144938', '522', '221', '2010', '469', '469', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('144957', '548', '221', '2010', '489', '483', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('144976', '1227', '221', '2010', '479', '479', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('147244', '5', '231', '2010', '500', '488', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147260', '17', '231', '2010', '490', '485', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147273', '5', '231', '2011', '493', '489', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147298', '12', '231', '2011', '508', '508', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147321', '17', '231', '2011', '501', '493', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147344', '2', '231', '2012', '478', '478', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147357', '5', '231', '2012', '476', '461', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147365', '12', '231', '2012', '476', '461', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147383', '17', '231', '2012', '491', '490', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147597', '3', '234', '2010', '507', '507', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147617', '8', '234', '2011', '491', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147636', '2', '234', '2011', '519', '515', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147647', '67', '234', '2011', '499', '493', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147660', '59', '234', '2011', '507', '502', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147678', '5', '234', '2011', '487', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147704', '67', '234', '2012', '471', '461', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147722', '14', '234', '2012', '475', '462', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147748', '8', '234', '2012', '452', '450', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147763', '67', '234', '2013', '514', '514', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('147813', '17', '231', '2010', '471', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('147829', '121', '231', '2010', '492', '474', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('147862', '17', '231', '2011', '473', '461', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('147876', '5', '231', '2011', '471', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('147909', '2', '231', '2012', '457', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('147924', '29', '231', '2012', '458', '445', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('147935', '17', '231', '2012', '472', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('147950', '116', '231', '2012', '462', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148201', '21', '234', '2010', '451', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148210', '5', '234', '2010', '449', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148221', '85', '234', '2010', '488', '488', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148229', '92', '234', '2010', '491', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148241', '3', '234', '2010', '463', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148248', '68', '234', '2010', '461', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148277', '68', '234', '2011', '459', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148288', '21', '234', '2011', '450', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148297', '196', '234', '2011', '467', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148309', '120', '234', '2011', '439', '439', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148338', '120', '234', '2012', '443', '443', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148354', '240', '234', '2012', '472', '470', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148369', '21', '234', '2012', '462', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148382', '249', '234', '2012', '443', '438', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148396', '83', '234', '2012', '443', '443', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('148567', '21', '234', '2013', '524', '523', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('151219', '311', '242', '2010', '488', '481', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('151237', '226', '242', '2010', '489', '489', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('151269', '3', '242', '2012', '485', '460', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('151476', '226', '242', '2010', '457', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('151483', '311', '242', '2010', '449', '445', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('151518', '226', '242', '2011', '466', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('151541', '3', '242', '2012', '446', '442', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('151548', '226', '242', '2012', '443', '443', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('152311', '173', '244', '2010', '452', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('152321', '38', '244', '2010', '460', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('152332', '2', '244', '2010', '474', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('152342', '23', '244', '2010', '489', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('152353', '21', '244', '2010', '474', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('152370', '147', '244', '2010', '442', '442', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('152385', '146', '244', '2010', '475', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('153162', '52', '247', '2010', '553', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153171', '10', '247', '2010', '545', '545', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153180', '2', '247', '2010', '553', '545', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153197', '86', '247', '2010', '527', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153210', '5', '247', '2010', '548', '548', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153214', '69', '249', '2010', '510', '503', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153226', '66', '247', '2010', '608', '586', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153229', '48', '249', '2010', '510', '499', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153247', '64', '249', '2010', '491', '488', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153261', '66', '247', '2011', '604', '585', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153264', '203', '249', '2010', '490', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153279', '60', '247', '2011', '617', '599', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153292', '48', '249', '2011', '528', '514', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153295', '2', '247', '2011', '546', '536', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153303', '86', '247', '2011', '579', '513', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153304', '203', '249', '2011', '509', '499', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153323', '52', '247', '2011', '570', '554', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153325', '64', '249', '2011', '506', '496', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153333', '10', '247', '2011', '593', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153346', '63', '249', '2011', '503', '499', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153360', '52', '247', '2012', '561', '538', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153363', '69', '249', '2011', '505', '499', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153372', '10', '247', '2012', '531', '531', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153377', '66', '247', '2012', '607', '587', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153390', '2', '247', '2012', '553', '529', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153397', '86', '247', '2012', '559', '480', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153400', '203', '249', '2012', '493', '478', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153415', '60', '247', '2012', '567', '557', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153416', '69', '249', '2012', '484', '476', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153425', '5', '247', '2012', '527', '527', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153430', '67', '249', '2012', '490', '489', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153443', '60', '247', '2013', '597', '592', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153452', '59', '249', '2013', '541', '529', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153462', '10', '247', '2013', '586', '584', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153481', '66', '247', '2013', '627', '619', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153494', '86', '247', '2013', '563', '540', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('153509', '5', '247', '2013', '589', '587', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('153688', '59', '249', '2010', '456', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('153698', '92', '249', '2010', '492', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('153710', '458', '249', '2010', '491', '470', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('153723', '548', '221', '2010', '558', '538', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('153725', '205', '249', '2010', '453', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('153743', '1213', '221', '2010', '544', '544', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('153753', '458', '249', '2011', '464', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('153761', '1229', '221', '2010', '545', '545', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('153774', '92', '249', '2011', '467', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('153789', '59', '249', '2011', '449', '444', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('153815', '92', '249', '2012', '467', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('153830', '458', '249', '2012', '473', '472', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('153926', '92', '249', '2013', '583', '544', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('153942', '1229', '221', '2010', '544', '537', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('153957', '1230', '221', '2010', '560', '542', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('153975', '1227', '221', '2010', '556', '556', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('153996', '548', '221', '2010', '567', '557', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('154012', '1213', '221', '2010', '542', '542', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('154023', '1228', '221', '2010', '550', '538', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('154041', '522', '221', '2010', '533', '530', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('154052', '1226', '221', '2010', '531', '527', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('154072', '1225', '221', '2010', '524', '520', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('154165', '66', '247', '2010', '617', '585', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154174', '10', '247', '2010', '583', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154193', '75', '247', '2010', '574', '567', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154203', '60', '247', '2010', '589', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154211', '86', '247', '2010', '548', '497', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('154227', '91', '247', '2010', '558', '557', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154258', '91', '247', '2011', '570', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154273', '66', '247', '2011', '645', '587', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154287', '2', '247', '2011', '544', '543', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154294', '86', '247', '2011', '532', '469', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('154300', '10', '247', '2011', '562', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154312', '52', '247', '2011', '559', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154325', '5', '247', '2011', '545', '539', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154341', '60', '247', '2011', '570', '566', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154352', '75', '247', '2011', '561', '544', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154380', '66', '247', '2012', '664', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154383', '75', '247', '2012', '573', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154388', '86', '247', '2012', '543', '472', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('154394', '91', '247', '2012', '562', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154399', '52', '247', '2012', '558', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154404', '10', '247', '2012', '601', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154409', '5', '247', '2012', '546', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154415', '60', '247', '2012', '567', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154419', '2', '247', '2012', '550', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154540', '86', '247', '2013', '579', '534', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('154545', '66', '247', '2013', '695', '644', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154552', '60', '247', '2013', '632', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154559', '86', '247', '2013', '611', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154566', '5', '247', '2013', '614', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('154569', '10', '247', '2013', '615', '601', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('156531', '2', '254', '2010', '476', '476', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('157837', '23', '255', '2010', '517', '501', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('157855', '17', '255', '2010', '533', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('157873', '3', '255', '2010', '602', '560', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('157896', '2', '255', '2010', '578', '545', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('157908', '10', '255', '2010', '572', '545', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('157914', '78', '257', '2010', '478', '478', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('157925', '11', '255', '2010', '585', '539', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('157926', '21', '257', '2010', '497', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('157947', '5', '255', '2010', '563', '538', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('157953', '17', '255', '2010', '585', '547', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('157970', '23', '255', '2011', '554', '516', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('157986', '17', '255', '2011', '552', '519', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('158012', '21', '255', '2011', '608', '559', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('158029', '17', '255', '2011', '595', '551', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('158043', '10', '255', '2011', '581', '550', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('158055', '3', '255', '2011', '617', '564', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('158066', '2', '255', '2011', '581', '546', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('158077', '5', '255', '2011', '580', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('158084', '11', '255', '2011', '597', '543', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('158097', '11', '255', '2012', '557', '513', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('158114', '17', '255', '2012', '569', '520', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('158128', '17', '255', '2012', '546', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('158146', '10', '255', '2012', '570', '530', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('158163', '23', '255', '2012', '525', '485', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('158181', '3', '255', '2012', '574', '541', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('158194', '5', '255', '2012', '543', '518', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('158203', '2', '255', '2012', '550', '516', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('158225', '5', '255', '2013', '597', '569', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('158258', '10', '255', '2013', '616', '580', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('158333', '1416', '257', '2010', '459', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('158346', '1414', '257', '2010', '479', '474', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('158366', '21', '257', '2011', '479', '470', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('158382', '454', '257', '2011', '455', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('158409', '79', '257', '2012', '441', '441', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('158426', '1413', '257', '2012', '566', '501', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('159930', '14', '259', '2010', '517', '517', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('159948', '136', '259', '2010', '558', '558', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('159964', '8', '259', '2010', '548', '548', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('159989', '5', '259', '2010', '583', '539', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160003', '20', '259', '2010', '538', '538', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160019', '436', '259', '2010', '554', '538', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160041', '43', '259', '2010', '519', '519', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160055', '58', '259', '2010', '541', '530', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160082', '8', '259', '2011', '551', '551', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160108', '5', '259', '2011', '588', '554', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160121', '43', '259', '2011', '540', '540', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160145', '11', '255', '2010', '589', '533', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160148', '20', '259', '2012', '476', '476', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160158', '43', '259', '2012', '477', '477', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160163', '95', '255', '2010', '593', '528', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160182', '2', '255', '2010', '624', '534', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160183', '136', '259', '2012', '453', '453', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160195', '21', '259', '2012', '518', '518', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160200', '17', '255', '2010', '608', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160210', '3', '255', '2010', '628', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160213', '8', '259', '2012', '456', '456', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160223', '141', '255', '2010', '548', '469', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160227', '436', '259', '2012', '513', '498', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160243', '94', '255', '2010', '502', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160246', '5', '259', '2012', '542', '517', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160270', '85', '255', '2010', '599', '523', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160276', '578', '259', '2013', '581', '571', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160285', '10', '255', '2010', '592', '528', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160293', '21', '259', '2013', '569', '569', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160305', '116', '255', '2010', '598', '522', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160308', '5', '259', '2013', '623', '585', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160331', '8', '259', '2013', '537', '537', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('160341', '101', '255', '2010', '600', '518', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160375', '116', '255', '2010', '551', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160405', '164', '255', '2010', '561', '486', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160418', '17', '255', '2010', '606', '505', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160430', '23', '255', '2010', '595', '503', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160448', '40', '255', '2010', '555', '490', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160475', '5', '255', '2011', '571', '511', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160493', '21', '255', '2011', '604', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160509', '120', '255', '2011', '578', '522', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160521', '116', '255', '2011', '586', '509', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160534', '164', '255', '2011', '510', '481', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160544', '10', '255', '2011', '580', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160563', '17', '255', '2011', '596', '543', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160574', '2', '255', '2011', '590', '529', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160594', '3', '255', '2011', '601', '558', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160604', '17', '255', '2011', '570', '499', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160623', '116', '255', '2011', '506', '479', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160636', '23', '255', '2011', '617', '501', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160653', '141', '255', '2011', '488', '476', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160663', '101', '255', '2011', '576', '513', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160680', '11', '255', '2011', '582', '524', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160701', '185', '255', '2012', '591', '512', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160714', '101', '255', '2012', '593', '514', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160732', '11', '255', '2012', '585', '514', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160747', '10', '255', '2012', '571', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160766', '436', '259', '2010', '515', '515', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160770', '17', '255', '2012', '493', '479', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160778', '5', '259', '2010', '571', '508', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160785', '14', '259', '2010', '492', '492', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160787', '150', '255', '2012', '531', '475', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160809', '116', '255', '2012', '603', '521', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160812', '136', '259', '2010', '489', '488', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160821', '5', '255', '2012', '560', '503', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160829', '20', '259', '2010', '483', '483', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160834', '102', '255', '2012', '578', '510', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160843', '23', '255', '2012', '548', '501', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160846', '43', '259', '2010', '481', '478', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160855', '3', '255', '2012', '596', '552', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160872', '2', '255', '2012', '586', '521', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160875', '436', '259', '2011', '508', '495', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160880', '164', '255', '2012', '516', '476', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160890', '136', '259', '2011', '479', '479', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160904', '43', '259', '2011', '482', '478', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160908', '10', '255', '2013', '617', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160918', '5', '255', '2013', '608', '568', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('160920', '5', '259', '2011', '575', '515', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160929', '20', '259', '2011', '493', '493', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160930', '141', '255', '2013', '579', '551', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160940', '8', '259', '2011', '489', '485', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160966', '20', '259', '2012', '449', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160975', '43', '259', '2012', '496', '475', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('160986', '136', '259', '2012', '441', '441', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('161003', '8', '259', '2012', '475', '475', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('161012', '5', '259', '2012', '622', '514', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('161023', '436', '259', '2012', '498', '480', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('161032', '21', '259', '2012', '564', '523', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('161061', '5', '259', '2013', '684', '582', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('161074', '8', '259', '2013', '524', '524', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('161088', '578', '259', '2013', '546', '539', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('161099', '21', '259', '2013', '564', '547', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('161225', '5', '210', '2010', '547', '540', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('161245', '5', '210', '2011', '556', '551', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('161262', '5', '210', '2012', '592', '591', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('161276', '2', '210', '2012', '595', '590', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('162183', '141', '210', '2010', '567', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162216', '99', '210', '2010', '574', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162236', '80', '210', '2010', '554', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162263', '36', '210', '2010', '556', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162289', '161', '210', '2010', '556', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162310', '37', '210', '2010', '561', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162327', '94', '210', '2010', '561', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162337', '85', '210', '2010', '552', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162356', '40', '210', '2010', '559', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162374', '91', '210', '2011', '574', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162393', '99', '210', '2011', '584', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162411', '40', '210', '2011', '575', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162422', '161', '210', '2011', '578', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162427', '118', '210', '2011', '569', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162444', '80', '210', '2011', '575', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162451', '151', '210', '2011', '571', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162467', '37', '210', '2011', '582', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162491', '123', '210', '2011', '572', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162511', '141', '210', '2011', '594', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162520', '36', '210', '2011', '576', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162530', '94', '210', '2011', '578', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162654', '151', '210', '2012', '590', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162659', '38', '210', '2012', '591', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162671', '39', '210', '2012', '594', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162685', '37', '210', '2012', '591', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162689', '118', '210', '2012', '601', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162702', '80', '210', '2012', '590', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162722', '91', '210', '2012', '593', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162740', '123', '210', '2012', '591', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162751', '94', '210', '2012', '605', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162773', '99', '210', '2012', '605', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162788', '161', '210', '2012', '598', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162803', '141', '210', '2012', '603', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162820', '40', '210', '2012', '598', '590', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('162833', '36', '210', '2012', '593', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('163550', '61', '262', '2010', '589', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163562', '24', '262', '2010', '568', '552', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163576', '44', '262', '2010', '584', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163605', '63', '262', '2010', '597', '564', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163628', '275', '262', '2010', '566', '554', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163642', '1', '262', '2010', '596', '565', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163661', '22', '262', '2010', '603', '570', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163679', '346', '262', '2010', '599', '577', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163693', '76', '262', '2010', '617', '585', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163716', '410', '262', '2010', '537', '507', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('163733', '428', '262', '2010', '534', '517', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('163742', '15', '262', '2010', '566', '539', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163764', '10', '262', '2010', '614', '550', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163777', '322', '262', '2010', '580', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163790', '8', '262', '2010', '593', '547', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163813', '293', '262', '2010', '554', '539', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163825', '74', '262', '2010', '560', '537', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163847', '20', '262', '2010', '562', '537', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163864', '175', '262', '2010', '527', '525', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163878', '12', '262', '2010', '589', '551', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163905', '51', '262', '2010', '578', '542', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163933', '13', '262', '2010', '605', '551', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163947', '5', '262', '2010', '588', '551', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('163968', '65', '262', '2010', '568', '535', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164000', '175', '262', '2011', '557', '542', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164019', '1', '262', '2011', '608', '566', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164034', '76', '262', '2011', '616', '589', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164046', '24', '262', '2011', '580', '552', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164062', '13', '262', '2011', '621', '560', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164081', '346', '262', '2011', '621', '579', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164108', '410', '262', '2011', '540', '516', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('164119', '275', '262', '2011', '595', '562', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164138', '322', '262', '2011', '582', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164159', '9', '262', '2011', '534', '531', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164181', '74', '262', '2011', '566', '543', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164198', '12', '262', '2011', '580', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164212', '428', '262', '2011', '572', '522', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('164234', '20', '262', '2011', '586', '544', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164259', '10', '262', '2011', '602', '555', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164275', '22', '262', '2011', '588', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164293', '51', '262', '2011', '603', '563', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164309', '63', '262', '2011', '612', '567', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164323', '293', '262', '2011', '593', '557', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164345', '65', '262', '2011', '562', '536', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164356', '5', '262', '2011', '560', '537', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164371', '15', '262', '2011', '563', '538', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164385', '8', '262', '2011', '581', '553', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164405', '44', '262', '2011', '604', '583', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164421', '61', '262', '2011', '588', '563', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164439', '13', '262', '2012', '581', '532', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164457', '8', '262', '2012', '558', '510', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164472', '20', '262', '2012', '553', '515', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164486', '63', '262', '2012', '576', '545', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164500', '175', '262', '2012', '555', '519', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164516', '65', '262', '2012', '551', '508', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164528', '5', '262', '2012', '557', '521', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164542', '51', '262', '2012', '563', '522', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164553', '22', '262', '2012', '570', '526', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164567', '61', '262', '2012', '573', '524', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164580', '293', '262', '2012', '557', '516', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164598', '76', '262', '2012', '587', '565', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164613', '203', '262', '2012', '558', '529', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164629', '24', '262', '2012', '552', '526', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164646', '49', '262', '2012', '569', '529', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164666', '346', '262', '2012', '576', '542', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164692', '1', '262', '2012', '590', '533', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164714', '12', '262', '2012', '572', '528', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164734', '44', '262', '2012', '577', '552', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164750', '10', '262', '2012', '585', '527', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164780', '15', '262', '2012', '579', '516', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164802', '322', '262', '2012', '584', '526', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164828', '61', '262', '2013', '628', '602', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164846', '13', '262', '2013', '619', '591', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164866', '22', '262', '2013', '615', '603', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164884', '8', '262', '2013', '619', '574', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164898', '65', '262', '2013', '603', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164909', '1', '262', '2013', '627', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164944', '1451', '262', '2013', '616', '588', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164956', '49', '262', '2013', '605', '587', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164968', '12', '262', '2013', '652', '587', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164979', '10', '262', '2013', '634', '582', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164987', '322', '262', '2013', '609', '581', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('164993', '51', '262', '2013', '615', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('165005', '293', '262', '2013', '608', '582', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('165020', '44', '262', '2013', '625', '613', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('165036', '5', '262', '2013', '606', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('165048', '175', '262', '2013', '603', '567', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('165057', '9', '262', '2013', '609', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('166906', '8', '259', '2010', '501', '492', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('166924', '21', '259', '2010', '508', '493', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('166940', '3', '259', '2010', '508', '501', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('166949', '2', '259', '2010', '501', '493', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('166953', '203', '259', '2010', '499', '491', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('166961', '65', '259', '2010', '491', '485', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('166968', '435', '259', '2010', '483', '478', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('166975', '548', '259', '2010', '498', '476', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('166981', '1229', '259', '2010', '475', '470', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('166990', '58', '259', '2010', '493', '486', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('166997', '136', '259', '2010', '492', '486', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167004', '10', '259', '2010', '500', '491', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167012', '43', '259', '2010', '492', '486', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167019', '17', '259', '2010', '497', '491', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167024', '13', '259', '2010', '499', '490', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167032', '20', '259', '2010', '499', '490', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167039', '5', '259', '2010', '508', '489', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167048', '436', '259', '2010', '495', '488', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167054', '52', '259', '2010', '497', '487', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167059', '12', '259', '2010', '496', '487', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167067', '14', '259', '2010', '499', '487', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167084', '136', '259', '2011', '503', '493', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167092', '436', '259', '2011', '507', '494', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167102', '3', '259', '2011', '515', '506', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167113', '65', '259', '2011', '508', '496', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167124', '14', '259', '2011', '494', '490', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167134', '21', '259', '2011', '509', '497', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167143', '159', '259', '2011', '506', '495', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167151', '5', '259', '2011', '514', '495', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167159', '20', '259', '2011', '499', '491', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167168', '13', '259', '2011', '506', '494', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167178', '52', '259', '2011', '504', '494', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167183', '12', '259', '2011', '506', '494', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167188', '2', '259', '2011', '503', '496', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167197', '203', '259', '2011', '495', '488', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167213', '43', '259', '2011', '498', '492', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167219', '10', '259', '2011', '507', '494', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167225', '17', '259', '2011', '500', '489', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167235', '8', '259', '2011', '508', '498', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167253', '58', '259', '2011', '502', '492', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167281', '136', '259', '2012', '471', '469', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167286', '52', '259', '2012', '470', '470', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167298', '159', '259', '2012', '472', '470', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167308', '5', '259', '2012', '481', '471', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167314', '58', '259', '2012', '471', '469', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167325', '12', '259', '2012', '472', '470', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167336', '8', '259', '2012', '479', '472', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167345', '10', '259', '2012', '470', '468', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167354', '2', '259', '2012', '475', '470', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167365', '3', '259', '2012', '490', '475', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167371', '13', '259', '2012', '475', '473', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167379', '43', '259', '2012', '472', '470', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167389', '21', '259', '2012', '485', '471', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167398', '17', '259', '2012', '473', '471', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167403', '14', '259', '2012', '471', '470', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167414', '65', '259', '2012', '472', '469', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167423', '1', '262', '2010', '640', '567', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167428', '203', '259', '2012', '473', '471', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167433', '150', '262', '2010', '605', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167444', '38', '262', '2010', '599', '528', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167452', '159', '259', '2013', '477', '471', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167460', '63', '262', '2010', '607', '567', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167466', '14', '259', '2013', '478', '472', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167473', '17', '259', '2013', '479', '472', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167476', '44', '262', '2010', '597', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167484', '65', '259', '2013', '476', '469', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167491', '410', '262', '2010', '558', '485', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('167493', '12', '259', '2013', '480', '471', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167500', '10', '262', '2010', '605', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167505', '21', '259', '2013', '483', '471', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167509', '275', '262', '2010', '608', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167513', '10', '259', '2013', '481', '471', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167519', '8', '262', '2010', '603', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167521', '578', '259', '2013', '481', '474', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167527', '5', '262', '2010', '579', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167528', '58', '259', '2013', '480', '473', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167536', '293', '262', '2010', '571', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167545', '34', '262', '2010', '614', '551', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167546', '5', '259', '2013', '493', '473', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167552', '322', '262', '2010', '585', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167553', '13', '259', '2013', '478', '473', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167560', '76', '262', '2010', '604', '574', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167563', '8', '259', '2013', '482', '473', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('167568', '346', '262', '2010', '595', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167574', '12', '262', '2010', '590', '552', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167582', '97', '262', '2010', '593', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167590', '39', '262', '2010', '612', '553', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167598', '220', '262', '2010', '599', '541', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167607', '24', '262', '2010', '585', '537', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167612', '61', '262', '2010', '594', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167619', '22', '262', '2010', '617', '574', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167625', '13', '262', '2010', '610', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167632', '51', '262', '2010', '602', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167646', '116', '262', '2010', '599', '527', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167661', '65', '262', '2010', '566', '532', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167674', '74', '262', '2010', '570', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167685', '37', '262', '2010', '609', '532', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167695', '428', '262', '2010', '504', '493', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('167710', '115', '262', '2010', '573', '515', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167720', '175', '262', '2010', '568', '517', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167729', '15', '262', '2010', '578', '517', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167741', '234', '262', '2010', '582', '520', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167754', '79', '262', '2010', '578', '523', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167768', '20', '262', '2010', '522', '511', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167804', '161', '262', '2010', '602', '528', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167838', '220', '262', '2011', '561', '511', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167853', '116', '262', '2011', '589', '517', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167880', '115', '262', '2011', '568', '509', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167895', '63', '262', '2011', '581', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167912', '51', '262', '2011', '573', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167921', '20', '262', '2011', '510', '507', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167936', '65', '262', '2011', '503', '496', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167958', '24', '262', '2011', '570', '524', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167980', '161', '262', '2011', '579', '527', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('167998', '97', '262', '2011', '597', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168016', '9', '262', '2011', '589', '538', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168031', '37', '262', '2011', '590', '513', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168047', '150', '262', '2011', '588', '548', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168068', '346', '262', '2011', '591', '553', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168086', '12', '262', '2011', '600', '523', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168103', '322', '262', '2011', '525', '519', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168130', '74', '262', '2011', '580', '527', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168147', '39', '262', '2011', '622', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168158', '1', '262', '2011', '582', '528', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168176', '44', '262', '2011', '580', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168189', '61', '262', '2011', '592', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168202', '13', '262', '2011', '581', '548', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168213', '275', '262', '2011', '546', '526', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168227', '293', '262', '2011', '565', '527', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168244', '15', '262', '2011', '521', '504', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168256', '428', '262', '2011', '563', '487', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('168273', '8', '262', '2011', '606', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168287', '22', '262', '2011', '590', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168304', '34', '262', '2011', '601', '530', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168323', '79', '262', '2011', '586', '510', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168337', '410', '262', '2011', '520', '474', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('168346', '175', '262', '2011', '565', '506', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168372', '76', '262', '2011', '596', '568', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168381', '234', '262', '2011', '581', '525', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168392', '38', '262', '2011', '585', '519', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168403', '25', '262', '2011', '624', '529', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168417', '5', '262', '2011', '579', '531', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168428', '10', '262', '2011', '612', '552', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168491', '175', '262', '2012', '591', '515', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168500', '20', '262', '2012', '499', '496', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168515', '5', '262', '2012', '577', '532', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168532', '13', '262', '2012', '602', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168547', '8', '262', '2012', '594', '538', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168565', '51', '262', '2012', '593', '539', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168574', '63', '262', '2012', '599', '553', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168593', '346', '262', '2012', '554', '552', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168606', '161', '262', '2012', '586', '526', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168621', '61', '262', '2012', '597', '544', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168631', '25', '262', '2012', '605', '521', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168640', '220', '262', '2012', '581', '531', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168653', '293', '262', '2012', '582', '545', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168665', '76', '262', '2012', '604', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168677', '89', '262', '2012', '584', '518', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168687', '22', '262', '2012', '597', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168698', '39', '262', '2012', '602', '525', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168712', '49', '262', '2012', '592', '522', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168726', '1', '262', '2012', '598', '522', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168736', '322', '262', '2012', '583', '523', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168745', '12', '262', '2012', '585', '524', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168755', '44', '262', '2012', '614', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168763', '10', '262', '2012', '598', '548', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168771', '116', '262', '2012', '594', '522', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168779', '234', '262', '2012', '592', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168788', '15', '262', '2012', '573', '519', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168795', '37', '262', '2012', '592', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168803', '115', '262', '2012', '594', '520', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168810', '238', '262', '2012', '584', '528', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168816', '24', '262', '2012', '592', '522', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168826', '79', '262', '2012', '577', '511', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168831', '203', '262', '2012', '578', '524', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168898', '1451', '262', '2013', '641', '609', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168910', '13', '262', '2013', '635', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168924', '12', '262', '2013', '640', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168935', '293', '262', '2013', '649', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168950', '322', '262', '2013', '619', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168964', '51', '262', '2013', '630', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168979', '65', '262', '2013', '622', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('168990', '5', '262', '2013', '620', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('169000', '9', '262', '2013', '630', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('169012', '8', '262', '2013', '641', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('169021', '238', '262', '2013', '630', '589', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('169029', '1', '262', '2013', '631', '589', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('169041', '161', '262', '2013', '649', '587', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('169047', '435', '259', '2010', '468', '468', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('169050', '10', '262', '2013', '671', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('169054', '2', '259', '2010', '506', '492', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169063', '44', '262', '2013', '644', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('169066', '548', '259', '2010', '504', '477', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('169074', '136', '259', '2010', '490', '485', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169082', '3', '259', '2010', '502', '492', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169084', '22', '262', '2013', '660', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('169092', '5', '259', '2010', '509', '491', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169101', '486', '262', '2013', '646', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('169103', '436', '259', '2010', '491', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169115', '58', '259', '2010', '498', '490', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169116', '234', '262', '2013', '631', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('169127', '13', '259', '2010', '497', '489', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169131', '175', '262', '2013', '621', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('169140', '8', '259', '2010', '498', '488', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169148', '17', '259', '2010', '496', '488', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169184', '38', '259', '2010', '488', '485', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169194', '43', '259', '2010', '492', '485', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169209', '21', '259', '2010', '497', '487', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169245', '2', '259', '2011', '505', '494', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169264', '13', '259', '2011', '496', '495', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169271', '52', '259', '2011', '497', '493', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169285', '8', '259', '2011', '502', '488', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169292', '43', '259', '2011', '502', '490', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169303', '3', '259', '2011', '506', '499', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169316', '136', '259', '2011', '493', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169325', '17', '259', '2011', '501', '490', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169336', '10', '259', '2011', '496', '488', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169346', '21', '259', '2011', '502', '488', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169357', '14', '259', '2011', '496', '487', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169368', '5', '259', '2011', '522', '494', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169375', '65', '259', '2011', '496', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169390', '20', '259', '2011', '493', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169400', '58', '259', '2011', '495', '488', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169420', '38', '259', '2011', '496', '487', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169432', '159', '259', '2011', '505', '494', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169434', '436', '259', '2011', '496', '488', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169446', '203', '259', '2011', '498', '489', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169487', '5', '259', '2012', '484', '461', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169504', '136', '259', '2012', '457', '454', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169521', '3', '259', '2012', '485', '463', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169551', '21', '259', '2012', '478', '456', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169567', '58', '259', '2012', '464', '455', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169578', '159', '259', '2012', '469', '459', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169589', '8', '259', '2012', '467', '456', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169602', '38', '259', '2012', '478', '458', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169609', '10', '259', '2012', '478', '457', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169620', '2', '259', '2012', '470', '459', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169627', '13', '259', '2012', '471', '460', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169639', '17', '259', '2012', '469', '456', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169649', '20', '259', '2012', '461', '455', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169658', '14', '259', '2012', '456', '452', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169671', '203', '259', '2012', '459', '455', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169694', '436', '259', '2012', '464', '455', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169711', '65', '259', '2012', '455', '452', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169736', '12', '259', '2013', '456', '439', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169752', '58', '259', '2013', '446', '442', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169761', '159', '259', '2013', '445', '439', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169770', '10', '259', '2013', '455', '441', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169786', '8', '259', '2013', '458', '442', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169798', '578', '259', '2013', '456', '442', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169807', '5', '259', '2013', '481', '447', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169821', '14', '259', '2013', '447', '439', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169842', '13', '259', '2013', '440', '438', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169853', '65', '259', '2013', '442', '438', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169859', '17', '259', '2013', '438', '435', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('169874', '21', '259', '2013', '452', '438', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('175228', '139', '279', '2010', '526', '526', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('175252', '311', '279', '2010', '507', '507', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('175277', '5', '279', '2010', '514', '505', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('175299', '120', '279', '2010', '494', '494', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('175313', '364', '279', '2010', '513', '513', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('175341', '364', '279', '2011', '509', '509', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('175360', '120', '279', '2011', '524', '524', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('175378', '139', '279', '2011', '522', '522', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('175397', '5', '279', '2011', '515', '515', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('175424', '311', '279', '2012', '468', '468', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('175444', '5', '279', '2012', '487', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('175459', '120', '279', '2012', '484', '484', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('175696', '311', '279', '2010', '518', '505', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('175720', '120', '279', '2010', '518', '498', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('175734', '364', '279', '2010', '523', '508', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('175747', '139', '279', '2010', '592', '579', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('175779', '139', '279', '2011', '551', '551', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('175788', '311', '279', '2011', '574', '574', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('175802', '5', '279', '2011', '453', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('175822', '120', '279', '2011', '501', '501', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('175854', '311', '279', '2012', '467', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('175862', '24', '278', '2010', '466', '457', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('175873', '184', '278', '2010', '458', '450', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('175874', '120', '279', '2012', '433', '433', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('175886', '279', '278', '2010', '468', '456', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('175905', '21', '278', '2010', '473', '457', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('175911', '79', '278', '2010', '456', '453', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('175921', '129', '278', '2010', '470', '456', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('175937', '79', '278', '2010', '487', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('175951', '52', '278', '2010', '471', '457', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('175962', '3', '278', '2010', '512', '492', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('175972', '10', '278', '2010', '471', '463', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('175983', '173', '278', '2010', '471', '461', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('175993', '75', '278', '2010', '473', '460', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176005', '67', '278', '2010', '472', '458', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176022', '67', '278', '2010', '502', '489', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176035', '21', '278', '2010', '494', '483', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176054', '5', '278', '2010', '501', '483', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176064', '2', '278', '2010', '472', '455', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176078', '3', '278', '2010', '473', '457', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176090', '8', '278', '2010', '484', '454', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176103', '22', '278', '2010', '466', '456', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176126', '22', '278', '2011', '515', '515', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176134', '8', '278', '2011', '476', '458', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176143', '21', '278', '2011', '506', '493', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176161', '5', '278', '2011', '498', '489', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176172', '173', '278', '2011', '511', '496', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176180', '67', '278', '2011', '499', '490', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176193', '22', '278', '2011', '475', '461', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176202', '10', '278', '2011', '516', '501', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176214', '79', '278', '2011', '493', '493', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176224', '3', '278', '2011', '519', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176244', '2', '278', '2011', '481', '456', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176256', '75', '278', '2011', '485', '468', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176266', '21', '278', '2011', '480', '460', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176276', '52', '278', '2011', '462', '452', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176287', '10', '278', '2011', '479', '458', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176299', '129', '278', '2011', '474', '451', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176310', '184', '278', '2011', '479', '453', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176321', '67', '278', '2011', '480', '459', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176341', '279', '278', '2011', '471', '455', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176349', '30', '278', '2011', '478', '454', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176366', '3', '278', '2011', '513', '460', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176378', '79', '278', '2011', '474', '455', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176398', '24', '278', '2011', '471', '459', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176412', '173', '278', '2011', '477', '465', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176444', '22', '278', '2012', '473', '473', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176464', '22', '278', '2012', '481', '434', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176481', '1015', '278', '2012', '453', '430', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176494', '10', '278', '2012', '438', '425', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176517', '44', '278', '2012', '478', '460', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176530', '44', '278', '2012', '444', '430', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176558', '67', '278', '2012', '489', '466', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176573', '67', '278', '2012', '452', '431', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176593', '98', '278', '2012', '436', '423', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176614', '173', '278', '2012', '432', '423', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176629', '75', '278', '2012', '438', '428', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176658', '126', '278', '2012', '480', '457', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176672', '21', '278', '2012', '450', '427', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176686', '21', '278', '2012', '548', '474', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176703', '3', '278', '2012', '485', '461', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176730', '8', '278', '2012', '436', '423', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176738', '2', '278', '2012', '427', '421', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176761', '24', '278', '2012', '469', '469', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176767', '24', '278', '2012', '461', '426', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176786', '10', '278', '2012', '487', '469', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176806', '173', '278', '2012', '481', '464', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176830', '51', '278', '2012', '443', '424', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176841', '79', '278', '2012', '434', '425', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176854', '52', '278', '2012', '439', '424', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176874', '65', '278', '2012', '443', '424', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176882', '5', '278', '2012', '475', '473', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176895', '55', '278', '2012', '443', '424', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176910', '55', '278', '2012', '447', '446', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('176918', '143', '278', '2012', '438', '429', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176929', '184', '278', '2012', '437', '422', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176953', '3', '278', '2012', '444', '430', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176965', '129', '278', '2012', '441', '427', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('176977', '279', '278', '2012', '435', '425', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('177007', '21', '278', '2013', '529', '529', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('177027', '51', '278', '2013', '530', '530', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('177045', '65', '278', '2013', '484', '468', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('177058', '129', '278', '2013', '478', '465', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('177074', '22', '278', '2013', '518', '508', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('177083', '10', '278', '2013', '504', '498', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('177091', '173', '278', '2013', '477', '461', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('177102', '44', '278', '2013', '551', '515', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('177123', '22', '278', '2013', '485', '472', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('177139', '8', '278', '2013', '486', '467', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('177152', '1015', '278', '2013', '485', '465', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('177171', '44', '278', '2013', '486', '475', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('178202', '120', '279', '2010', '469', '469', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178227', '5', '279', '2010', '474', '474', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178244', '364', '279', '2010', '489', '480', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178261', '139', '279', '2010', '490', '472', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178272', '311', '279', '2010', '474', '474', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178292', '10', '279', '2011', '479', '469', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178321', '120', '279', '2011', '478', '475', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178338', '5', '279', '2011', '476', '474', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178360', '139', '279', '2011', '479', '471', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178371', '311', '279', '2011', '485', '476', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178399', '364', '279', '2011', '471', '469', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178422', '139', '279', '2012', '449', '444', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178439', '311', '279', '2012', '444', '439', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178463', '364', '279', '2012', '444', '444', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178484', '5', '279', '2012', '444', '442', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178504', '10', '279', '2012', '443', '442', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178521', '120', '279', '2012', '444', '444', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178546', '5', '279', '2013', '457', '455', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178560', '10', '279', '2013', '457', '455', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('178694', '21', '278', '2010', '479', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('178709', '67', '278', '2010', '490', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('178724', '5', '278', '2010', '478', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('178744', '3', '278', '2010', '560', '474', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('178759', '37', '278', '2010', '469', '469', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('178772', '30', '278', '2010', '465', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('178783', '153', '278', '2010', '490', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('178805', '129', '278', '2010', '459', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('178821', '75', '278', '2010', '455', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('178823', '364', '279', '2010', '485', '481', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('178837', '173', '278', '2010', '474', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('178842', '311', '279', '2010', '492', '486', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('178850', '79', '278', '2010', '449', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('178859', '139', '279', '2010', '485', '473', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('178871', '5', '279', '2010', '488', '488', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('178889', '120', '279', '2010', '480', '480', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('178896', '173', '278', '2011', '432', '409', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('178908', '38', '278', '2011', '428', '406', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('178909', '120', '279', '2011', '484', '475', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('178918', '184', '278', '2011', '441', '441', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('178927', '364', '279', '2011', '485', '480', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('178928', '52', '278', '2011', '419', '406', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('178936', '2', '278', '2011', '458', '414', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('178943', '311', '279', '2011', '485', '482', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('178944', '79', '278', '2011', '529', '417', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('178950', '139', '279', '2011', '479', '471', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('178951', '8', '278', '2011', '433', '411', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('178956', '279', '278', '2011', '432', '416', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('178957', '10', '279', '2011', '471', '469', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('178962', '30', '278', '2011', '424', '408', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('178966', '10', '278', '2011', '431', '409', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('178971', '67', '278', '2011', '434', '417', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('178977', '22', '278', '2011', '431', '413', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('178982', '3', '278', '2011', '524', '418', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('178988', '24', '278', '2011', '434', '412', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('178993', '129', '278', '2011', '434', '413', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('178996', '30', '278', '2011', '442', '437', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179006', '22', '278', '2011', '462', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179008', '311', '279', '2012', '452', '445', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('179019', '364', '279', '2012', '445', '440', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('179022', '3', '278', '2011', '472', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179038', '5', '279', '2012', '435', '433', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('179042', '79', '278', '2011', '449', '442', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179054', '153', '278', '2011', '449', '443', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179056', '10', '279', '2012', '434', '431', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('179066', '10', '278', '2011', '452', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179070', '139', '279', '2012', '442', '435', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('179079', '67', '278', '2011', '450', '442', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179086', '120', '279', '2012', '440', '438', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('179096', '21', '278', '2011', '440', '414', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179102', '184', '278', '2011', '430', '409', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179105', '10', '279', '2013', '416', '413', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('179106', '75', '278', '2011', '430', '416', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179120', '5', '279', '2013', '412', '411', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('179123', '37', '278', '2011', '434', '416', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179132', '153', '278', '2011', '428', '408', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179144', '75', '278', '2011', '436', '436', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179156', '21', '278', '2011', '472', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179173', '129', '278', '2011', '464', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179188', '173', '278', '2011', '467', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179216', '22', '278', '2012', '442', '442', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179238', '10', '278', '2012', '432', '417', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179248', '21', '278', '2012', '454', '443', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179260', '44', '278', '2012', '473', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179268', '67', '278', '2012', '432', '417', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179274', '44', '278', '2012', '432', '422', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179283', '22', '278', '2012', '426', '414', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179293', '67', '278', '2012', '481', '481', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179306', '98', '278', '2012', '416', '406', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179319', '153', '278', '2012', '425', '412', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179327', '173', '278', '2012', '431', '412', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179333', '21', '278', '2012', '454', '417', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179340', '3', '278', '2012', '431', '418', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179348', '3', '278', '2012', '456', '443', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179361', '2', '278', '2012', '428', '415', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179372', '52', '278', '2012', '420', '408', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179378', '51', '278', '2012', '420', '407', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179389', '173', '278', '2012', '450', '441', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179399', '51', '278', '2012', '463', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179415', '65', '278', '2012', '420', '411', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179428', '24', '278', '2012', '431', '414', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179442', '79', '278', '2012', '444', '414', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179450', '129', '278', '2012', '429', '414', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179457', '55', '278', '2012', '425', '421', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179467', '30', '278', '2012', '444', '444', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179475', '37', '278', '2012', '429', '410', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179481', '55', '278', '2012', '438', '438', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179490', '75', '278', '2012', '431', '419', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179495', '8', '278', '2012', '428', '411', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179501', '30', '278', '2012', '432', '411', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179513', '38', '278', '2012', '441', '441', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179521', '38', '278', '2012', '427', '410', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179528', '279', '278', '2012', '432', '413', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179536', '129', '278', '2012', '442', '437', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179549', '184', '278', '2012', '425', '410', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179561', '184', '278', '2012', '433', '433', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179571', '143', '278', '2012', '431', '412', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('179591', '173', '278', '2013', '532', '532', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179599', '44', '278', '2013', '537', '523', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179613', '22', '278', '2013', '523', '515', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179621', '21', '278', '2013', '533', '513', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('179632', '10', '278', '2013', '508', '507', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('180716', '2', '282', '2010', '507', '500', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('180735', '10', '282', '2010', '480', '479', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('180749', '10', '282', '2011', '501', '501', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('180781', '2', '282', '2011', '496', '496', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('180810', '2', '282', '2012', '501', '482', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('180825', '10', '282', '2012', '452', '452', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('180841', '10', '282', '2013', '511', '507', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('181691', '37', '282', '2010', '468', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('181714', '143', '282', '2010', '464', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('181727', '38', '282', '2010', '447', '444', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('181794', '23', '255', '2010', '555', '555', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('181796', '36', '282', '2010', '477', '469', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('181811', '17', '255', '2010', '550', '550', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('181821', '146', '282', '2010', '487', '478', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('181839', '17', '255', '2011', '563', '560', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('181843', '30', '282', '2010', '470', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('181854', '23', '255', '2011', '563', '561', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('181870', '79', '282', '2010', '455', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('181883', '17', '255', '2012', '605', '599', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('181894', '146', '282', '2011', '439', '439', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('181901', '23', '255', '2012', '597', '597', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('181914', '79', '282', '2011', '493', '478', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('181929', '113', '282', '2011', '482', '479', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('181941', '38', '282', '2011', '454', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('181955', '390', '282', '2011', '481', '473', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('181974', '151', '282', '2011', '460', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('181994', '36', '282', '2011', '478', '477', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('182010', '37', '282', '2011', '466', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('182038', '146', '282', '2012', '462', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('182058', '390', '282', '2012', '471', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('182071', '37', '282', '2012', '461', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('182089', '38', '282', '2012', '458', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('182106', '36', '282', '2012', '441', '438', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('182119', '113', '282', '2012', '490', '476', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('182842', '2', '255', '2010', '552', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('182869', '161', '255', '2010', '540', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('182886', '17', '255', '2010', '548', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('182904', '94', '255', '2010', '542', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('182921', '164', '255', '2010', '541', '540', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('182936', '141', '255', '2010', '544', '539', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('182953', '150', '255', '2011', '561', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('182971', '141', '255', '2011', '560', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('182982', '2', '255', '2011', '573', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('182994', '21', '255', '2011', '571', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('183012', '164', '255', '2011', '573', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('183025', '150', '255', '2012', '582', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('183038', '17', '255', '2012', '590', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('183051', '2', '255', '2012', '583', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('183060', '141', '255', '2012', '582', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('183072', '164', '255', '2012', '582', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('186137', '38', '289', '2010', '488', '488', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('186146', '30', '289', '2010', '454', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('186167', '37', '289', '2011', '452', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('186180', '89', '289', '2011', '458', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('186188', '101', '289', '2011', '448', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('186401', '364', '279', '2010', '536', '536', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('186419', '5', '279', '2010', '536', '536', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('186437', '120', '279', '2010', '554', '554', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('186460', '139', '279', '2010', '542', '542', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('186473', '311', '279', '2010', '541', '541', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('186493', '311', '279', '2011', '555', '555', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('186517', '10', '279', '2011', '554', '554', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('186543', '139', '279', '2011', '555', '555', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('186565', '139', '279', '2012', '595', '595', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('186581', '5', '279', '2012', '581', '581', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('186596', '10', '279', '2012', '582', '582', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('186648', '15', '262', '2010', '542', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('186668', '24', '262', '2010', '539', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('186685', '13', '262', '2010', '529', '528', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('186714', '74', '262', '2011', '557', '554', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('186736', '13', '262', '2011', '563', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('186751', '12', '262', '2011', '559', '557', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('186755', '364', '279', '2010', '554', '548', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('186765', '5', '279', '2010', '537', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('186768', '15', '262', '2011', '554', '553', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('186790', '311', '279', '2010', '551', '551', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('186797', '15', '262', '2012', '599', '591', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('186813', '120', '279', '2010', '557', '557', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('186831', '139', '279', '2010', '542', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('186850', '120', '279', '2011', '565', '565', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('186862', '139', '279', '2011', '581', '581', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('186868', '364', '279', '2011', '566', '566', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('186890', '364', '279', '2012', '583', '583', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('186910', '120', '279', '2012', '605', '605', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('186917', '311', '279', '2012', '584', '584', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('187087', '1', '262', '2010', '532', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('187096', '13', '262', '2010', '533', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('187108', '39', '262', '2010', '541', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('187117', '5', '262', '2010', '539', '539', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('187144', '5', '262', '2011', '560', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('187152', '13', '262', '2011', '564', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('187155', '39', '262', '2011', '562', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('187166', '97', '262', '2011', '563', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('187175', '115', '262', '2011', '551', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('187186', '34', '262', '2011', '552', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('187213', '39', '262', '2012', '592', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('187225', '25', '262', '2012', '572', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('191028', '2', '294', '2011', '523', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('191042', '65', '294', '2011', '523', '500', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('191052', '5', '294', '2011', '528', '498', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('191061', '78', '294', '2011', '521', '489', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('191087', '2', '294', '2012', '494', '481', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('191099', '52', '294', '2012', '488', '473', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('191113', '65', '294', '2012', '502', '461', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('191129', '78', '294', '2012', '489', '469', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('191141', '5', '294', '2012', '494', '472', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('191173', '5', '294', '2013', '540', '516', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('191200', '65', '294', '2013', '543', '515', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('191218', '243', '294', '2013', '563', '562', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('191285', '220', '294', '2011', '482', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191296', '140', '294', '2011', '480', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191308', '113', '294', '2011', '541', '481', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191323', '391', '294', '2011', '515', '477', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191335', '68', '294', '2011', '563', '539', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191345', '146', '294', '2011', '585', '508', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191366', '173', '294', '2011', '557', '507', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191371', '55', '294', '2011', '576', '543', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191388', '153', '294', '2011', '544', '505', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191399', '101', '294', '2011', '477', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191410', '148', '294', '2011', '480', '465', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191422', '2', '294', '2011', '480', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191437', '36', '294', '2011', '581', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191450', '78', '294', '2011', '491', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191462', '105', '294', '2011', '624', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191479', '38', '294', '2011', '482', '461', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191507', '105', '294', '2012', '627', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191520', '2', '294', '2012', '483', '465', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191531', '173', '294', '2012', '572', '509', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191541', '233', '294', '2012', '554', '500', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191567', '146', '294', '2012', '573', '511', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191579', '131', '294', '2012', '572', '509', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191591', '129', '294', '2012', '595', '525', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191600', '153', '294', '2012', '593', '511', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191612', '55', '294', '2012', '618', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191624', '391', '294', '2012', '502', '470', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191627', '243', '294', '2012', '586', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191641', '52', '294', '2012', '503', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191653', '5', '294', '2012', '474', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191666', '38', '294', '2012', '484', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191676', '156', '294', '2012', '569', '516', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191686', '101', '294', '2012', '472', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191702', '148', '294', '2012', '474', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191716', '78', '294', '2012', '462', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191731', '36', '294', '2012', '478', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191745', '113', '294', '2012', '515', '475', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191755', '140', '294', '2012', '476', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191770', '220', '294', '2012', '563', '517', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191784', '127', '294', '2012', '573', '521', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191803', '68', '294', '2012', '585', '525', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191824', '94', '294', '2012', '504', '474', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191836', '39', '294', '2012', '551', '472', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191847', '119', '294', '2012', '561', '510', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191870', '243', '294', '2013', '666', '603', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191893', '105', '294', '2013', '667', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191917', '5', '294', '2013', '534', '528', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191936', '391', '294', '2013', '556', '540', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191954', '233', '294', '2013', '549', '539', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('191966', '156', '294', '2013', '617', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('191985', '113', '294', '2013', '574', '547', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('192001', '101', '294', '2013', '549', '530', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('192009', '119', '294', '2013', '647', '573', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('192028', '173', '294', '2013', '626', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('192255', '127', '294', '2011', '550', '504', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('193502', '5', '294', '2011', '428', '428', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('193513', '52', '294', '2011', '428', '428', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('193529', '65', '294', '2011', '412', '412', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('193546', '52', '294', '2012', '391', '391', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('193559', '2', '294', '2012', '401', '401', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('193575', '5', '294', '2013', '413', '413', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('193623', '131', '294', '2011', '460', '460', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('193626', '140', '294', '2011', '449', '449', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('193637', '119', '294', '2011', '445', '445', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('193645', '5', '278', '2010', '488', '484', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('193647', '129', '294', '2011', '452', '452', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('193657', '21', '278', '2010', '501', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('193659', '55', '294', '2011', '454', '454', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('193669', '3', '278', '2010', '502', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('193675', '79', '278', '2010', '493', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('193687', '94', '294', '2011', '446', '445', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('193700', '22', '278', '2011', '513', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('193709', '153', '294', '2012', '408', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('193715', '79', '278', '2011', '498', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('193717', '129', '294', '2012', '428', '418', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('193722', '10', '278', '2011', '495', '495', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('193728', '105', '294', '2012', '418', '418', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('193738', '3', '278', '2011', '502', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('193740', '55', '294', '2012', '421', '421', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('193755', '44', '278', '2011', '499', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('193761', '140', '294', '2012', '414', '414', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('193774', '113', '294', '2012', '411', '411', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('193778', '22', '278', '2012', '548', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('193812', '184', '278', '2012', '537', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('193813', '105', '294', '2013', '434', '434', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('193835', '44', '278', '2012', '527', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('193845', '67', '278', '2012', '556', '538', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('193862', '79', '278', '2012', '544', '540', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('194001', '79', '278', '2010', '467', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194015', '21', '278', '2010', '498', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194024', '30', '278', '2010', '505', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194040', '173', '278', '2010', '495', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194053', '153', '278', '2010', '505', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194070', '129', '278', '2010', '495', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194083', '3', '278', '2010', '491', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194106', '37', '278', '2010', '493', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194116', '5', '278', '2010', '471', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194142', '22', '278', '2011', '479', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194183', '38', '278', '2011', '505', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194192', '129', '278', '2011', '499', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194225', '153', '278', '2011', '491', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194246', '22', '278', '2012', '487', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194257', '129', '278', '2012', '508', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194271', '184', '278', '2012', '486', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194294', '3', '278', '2012', '498', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194324', '30', '278', '2012', '492', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('194345', '38', '278', '2012', '491', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('196829', '16', '297', '2012', '460', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('196844', '22', '297', '2012', '476', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('196856', '364', '297', '2012', '474', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('196863', '339', '297', '2012', '454', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('196880', '79', '297', '2012', '458', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('196899', '339', '297', '2013', '584', '566', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('198577', '52', '299', '2011', '527', '526', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('198595', '1939', '299', '2011', '618', '566', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('198608', '5', '299', '2011', '583', '550', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('199336', '1944', '299', '2010', '587', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199353', '1940', '299', '2010', '580', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199366', '1969', '299', '2010', '634', '568', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199373', '52', '299', '2010', '620', '567', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199383', '1945', '299', '2010', '645', '597', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199398', '1943', '299', '2010', '626', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199410', '1946', '299', '2010', '613', '559', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199427', '1939', '299', '2010', '573', '568', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199435', '1942', '299', '2010', '622', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199451', '1941', '299', '2010', '575', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199464', '88', '299', '2010', '579', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199477', '5', '299', '2010', '582', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199490', '344', '299', '2010', '580', '568', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199515', '1944', '299', '2011', '577', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199525', '1940', '299', '2011', '574', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199540', '1978', '299', '2011', '544', '508', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('199554', '52', '299', '2011', '558', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199570', '1979', '299', '2011', '609', '592', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199596', '1980', '299', '2011', '532', '508', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('199641', '1946', '299', '2011', '558', '545', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199658', '1969', '299', '2011', '576', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199668', '1942', '299', '2011', '567', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199677', '1999', '299', '2011', '542', '480', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('199687', '2000', '299', '2011', '562', '522', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('199695', '2001', '299', '2011', '576', '539', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('199704', '2002', '299', '2011', '539', '503', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('199713', '2003', '299', '2011', '540', '497', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('199723', '2004', '299', '2011', '591', '574', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199732', '1939', '299', '2011', '579', '566', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199819', '2005', '299', '2012', '613', '585', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199827', '1969', '299', '2012', '558', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199831', '155', '299', '2012', '562', '483', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('199842', '5', '299', '2012', '539', '528', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199852', '344', '299', '2012', '569', '557', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199861', '75', '299', '2012', '545', '513', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199871', '27', '299', '2012', '625', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199877', '1944', '299', '2012', '567', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199896', '52', '299', '2012', '541', '518', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199906', '88', '299', '2012', '552', '530', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199912', '1940', '299', '2012', '595', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199924', '2006', '299', '2012', '563', '520', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199935', '66', '299', '2012', '574', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199946', '1977', '299', '2012', '542', '505', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199958', '2007', '299', '2012', '481', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('199973', '66', '299', '2013', '648', '613', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199982', '27', '299', '2013', '664', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('199991', '5', '299', '2013', '617', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('200007', '88', '299', '2013', '618', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('200018', '2007', '299', '2013', '561', '537', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('201479', '65', '294', '2011', '521', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('201505', '78', '294', '2011', '523', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('201564', '38', '294', '2011', '531', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201584', '233', '294', '2011', '544', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201600', '173', '294', '2011', '535', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201616', '119', '294', '2011', '535', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201635', '220', '294', '2011', '530', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201655', '146', '294', '2011', '543', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201667', '131', '294', '2011', '541', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201681', '129', '294', '2011', '552', '548', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201710', '148', '294', '2012', '541', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201722', '173', '294', '2012', '542', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201732', '243', '294', '2012', '552', '552', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201749', '156', '294', '2012', '565', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('201759', '131', '294', '2012', '569', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('201767', '129', '294', '2012', '573', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('201777', '105', '294', '2012', '584', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('201790', '146', '294', '2012', '568', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('201807', '36', '294', '2012', '558', '558', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201817', '113', '294', '2012', '544', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201836', '127', '294', '2012', '540', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201848', '94', '294', '2012', '553', '553', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201857', '140', '294', '2012', '546', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('201863', '220', '294', '2012', '570', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('201876', '101', '294', '2012', '545', '545', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('203790', '10', '306', '2010', '506', '494', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('203809', '364', '306', '2010', '514', '493', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('203837', '266', '306', '2010', '498', '493', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('203848', '136', '306', '2010', '504', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('203867', '126', '306', '2010', '514', '484', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('203909', '89', '306', '2010', '495', '482', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('203932', '266', '306', '2011', '500', '490', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('203942', '78', '306', '2011', '517', '507', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('203955', '12', '306', '2011', '508', '496', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('203964', '10', '306', '2011', '508', '508', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('203977', '364', '306', '2011', '525', '507', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('203988', '89', '306', '2011', '523', '500', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('204008', '126', '306', '2011', '515', '500', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('204026', '136', '306', '2011', '503', '492', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('204037', '126', '306', '2012', '484', '469', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('204047', '136', '306', '2012', '463', '453', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('204056', '266', '306', '2012', '494', '471', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('204079', '89', '306', '2012', '492', '466', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('204094', '78', '306', '2012', '469', '460', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('204111', '213', '306', '2012', '461', '453', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('204204', '5', '306', '2010', '480', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('204220', '17', '306', '2010', '486', '473', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('204233', '65', '306', '2010', '444', '443', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('204241', '16', '306', '2010', '492', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('204251', '79', '306', '2010', '459', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('204291', '79', '306', '2011', '458', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('204307', '16', '306', '2011', '544', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('204330', '17', '306', '2012', '459', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('204342', '5', '306', '2012', '445', '439', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('204350', '78', '306', '2012', '454', '444', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('204360', '15', '306', '2012', '459', '442', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('204373', '325', '306', '2012', '456', '445', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('204392', '325', '306', '2013', '525', '512', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('204400', '65', '306', '2013', '511', '510', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('204407', '5', '306', '2013', '531', '531', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('210017', '88', '299', '2011', '619', '615', '2', '1', '10');
INSERT INTO `major_recruit` VALUES ('210025', '1943', '299', '2011', '619', '619', '2', '1', '10');
INSERT INTO `major_recruit` VALUES ('210044', '2004', '299', '2011', '636', '624', '2', '1', '10');
INSERT INTO `major_recruit` VALUES ('210058', '1979', '299', '2011', '640', '635', '2', '1', '10');
INSERT INTO `major_recruit` VALUES ('210075', '1941', '299', '2011', '612', '609', '2', '1', '10');
INSERT INTO `major_recruit` VALUES ('210087', '344', '299', '2011', '611', '609', '2', '1', '10');
INSERT INTO `major_recruit` VALUES ('210109', '1942', '299', '2011', '604', '603', '2', '1', '10');
INSERT INTO `major_recruit` VALUES ('210129', '5', '299', '2011', '605', '596', '2', '1', '10');
INSERT INTO `major_recruit` VALUES ('210138', '2017', '299', '2011', '626', '624', '2', '1', '10');
INSERT INTO `major_recruit` VALUES ('210162', '1940', '299', '2011', '604', '602', '2', '1', '10');
INSERT INTO `major_recruit` VALUES ('210176', '1939', '299', '2011', '599', '599', '2', '1', '10');
INSERT INTO `major_recruit` VALUES ('210188', '1946', '299', '2011', '602', '602', '2', '1', '10');
INSERT INTO `major_recruit` VALUES ('210204', '1945', '299', '2011', '638', '635', '2', '1', '10');
INSERT INTO `major_recruit` VALUES ('210434', '63', '314', '2010', '489', '489', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('210453', '8', '314', '2011', '483', '483', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('210543', '126', '315', '2011', '459', '459', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('210550', '8', '315', '2011', '452', '452', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('210572', '8', '315', '2012', '417', '417', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('210709', '143', '315', '2011', '398', '398', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('210717', '211', '315', '2011', '397', '397', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('210743', '143', '315', '2012', '416', '416', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('212614', '10', '315', '2011', '415', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('212619', '8', '315', '2011', '412', '412', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('212626', '86', '315', '2012', '395', '395', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('212632', '10', '315', '2012', '399', '394', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('212636', '8', '315', '2012', '396', '391', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('212642', '78', '315', '2012', '393', '393', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('212646', '12', '315', '2012', '393', '393', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('212730', '211', '315', '2011', '393', '393', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('212746', '36', '315', '2012', '352', '352', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('212753', '83', '315', '2012', '366', '355', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('213243', '5', '299', '2010', '545', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213256', '52', '299', '2010', '568', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213272', '1946', '299', '2010', '541', '541', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213282', '1940', '299', '2010', '525', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213291', '1942', '299', '2010', '525', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213303', '88', '299', '2010', '569', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213315', '1945', '299', '2010', '603', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213322', '344', '299', '2010', '574', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213330', '1943', '299', '2010', '579', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213348', '1969', '299', '2010', '580', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213361', '1939', '299', '2010', '578', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213368', '1944', '299', '2010', '551', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213393', '2004', '299', '2011', '598', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213402', '66', '299', '2011', '596', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213421', '2005', '299', '2011', '597', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213432', '27', '299', '2011', '623', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213443', '1969', '299', '2011', '601', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213465', '1979', '299', '2011', '600', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213480', '75', '299', '2011', '593', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213488', '52', '299', '2011', '584', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213503', '1939', '299', '2011', '596', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213517', '1942', '299', '2011', '593', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213528', '1941', '299', '2011', '589', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213539', '1945', '299', '2011', '623', '611', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213555', '1943', '299', '2011', '597', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213568', '1946', '299', '2011', '593', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213581', '2017', '299', '2011', '598', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213594', '1940', '299', '2011', '592', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213607', '2022', '299', '2011', '597', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213632', '2005', '299', '2012', '615', '615', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213642', '27', '299', '2012', '634', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213657', '75', '299', '2012', '615', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213663', '66', '299', '2012', '622', '620', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213671', '1940', '299', '2012', '606', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213683', '1969', '299', '2012', '604', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213697', '1977', '299', '2012', '604', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('213766', '5', '324', '2010', '475', '475', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('213781', '203', '324', '2011', '502', '502', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('213790', '69', '324', '2011', '511', '511', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('213816', '5', '324', '2012', '461', '461', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('213824', '8', '324', '2012', '447', '447', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('213834', '69', '324', '2012', '464', '464', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('213845', '2', '324', '2012', '470', '465', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('213857', '43', '324', '2012', '480', '480', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('213867', '203', '324', '2012', '450', '450', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('213884', '13', '324', '2012', '478', '478', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('213907', '13', '324', '2013', '516', '516', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('213927', '5', '324', '2013', '531', '531', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('214136', '92', '324', '2010', '479', '479', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('214148', '8', '324', '2010', '470', '470', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('214156', '2', '324', '2010', '460', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('214181', '2', '324', '2012', '435', '435', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('214761', '43', '331', '2010', '533', '530', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('214957', '143', '331', '2010', '537', '520', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('214966', '190', '331', '2010', '501', '501', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('214981', '38', '331', '2010', '559', '550', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('214995', '101', '331', '2010', '507', '507', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('215011', '37', '331', '2010', '505', '501', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('224943', '43', '331', '2010', '536', '523', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('225114', '38', '331', '2010', '537', '530', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('225133', '190', '331', '2010', '534', '525', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('225145', '143', '331', '2010', '540', '521', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('225154', '79', '331', '2010', '543', '543', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('225165', '37', '331', '2010', '508', '492', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('225180', '101', '331', '2010', '545', '545', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('229149', '1451', '358', '2010', '493', '493', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229159', '3', '358', '2010', '495', '494', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229168', '10', '358', '2010', '507', '489', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229175', '56', '358', '2010', '506', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229182', '65', '358', '2010', '511', '497', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229190', '14', '358', '2010', '504', '499', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229199', '428', '358', '2010', '515', '488', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229207', '24', '358', '2010', '496', '485', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229215', '5', '358', '2010', '486', '484', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229222', '126', '358', '2010', '492', '483', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229234', '2590', '358', '2010', '531', '531', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('229252', '3', '358', '2011', '507', '502', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229258', '56', '358', '2011', '512', '508', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229267', '428', '358', '2011', '529', '499', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229279', '2590', '358', '2011', '525', '525', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('229285', '24', '358', '2011', '500', '499', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229298', '14', '358', '2011', '500', '494', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229315', '5', '358', '2011', '515', '504', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229328', '65', '358', '2011', '519', '512', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229339', '126', '358', '2011', '516', '500', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229354', '2590', '358', '2012', '504', '500', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('229367', '24', '358', '2012', '473', '473', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229383', '3', '358', '2012', '483', '483', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229394', '428', '358', '2012', '491', '465', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229406', '126', '358', '2012', '484', '481', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229415', '56', '358', '2012', '469', '469', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229426', '14', '358', '2012', '465', '464', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229451', '65', '358', '2012', '472', '470', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229466', '14', '358', '2013', '508', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('229484', '56', '358', '2013', '521', '521', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('230235', '126', '358', '2010', '492', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230248', '428', '358', '2010', '491', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230261', '24', '358', '2010', '477', '474', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230277', '38', '358', '2010', '490', '479', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230293', '65', '358', '2010', '522', '483', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230302', '2590', '358', '2010', '544', '527', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('230311', '5', '358', '2010', '451', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230325', '10', '358', '2010', '468', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230337', '364', '358', '2010', '468', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230347', '23', '358', '2010', '482', '469', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230357', '21', '358', '2010', '483', '469', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230370', '3', '358', '2010', '490', '476', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230385', '65', '358', '2011', '460', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230393', '428', '358', '2011', '496', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230406', '21', '358', '2011', '466', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230422', '126', '358', '2011', '449', '445', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230438', '3', '358', '2011', '479', '474', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230454', '10', '358', '2011', '457', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230470', '364', '358', '2011', '509', '492', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230483', '23', '358', '2011', '461', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230497', '2590', '358', '2011', '491', '488', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('230513', '5', '358', '2011', '461', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230525', '38', '358', '2011', '448', '445', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230546', '56', '358', '2012', '437', '437', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230566', '38', '358', '2012', '594', '518', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230579', '364', '358', '2012', '439', '439', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230588', '3', '358', '2012', '457', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230596', '126', '358', '2012', '471', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230606', '428', '358', '2012', '461', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230613', '23', '358', '2012', '447', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230621', '2590', '358', '2012', '531', '516', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('230629', '5', '358', '2012', '460', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230639', '10', '358', '2012', '445', '442', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230647', '65', '358', '2012', '447', '445', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230659', '21', '358', '2012', '449', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230678', '10', '358', '2013', '535', '523', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230690', '5', '358', '2013', '537', '525', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230699', '56', '358', '2013', '536', '536', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('230711', '21', '358', '2013', '508', '507', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('231955', '63', '363', '2010', '605', '591', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('231978', '12', '363', '2010', '598', '598', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('231993', '159', '363', '2010', '607', '596', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232002', '8', '363', '2010', '578', '578', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232018', '514', '363', '2010', '591', '577', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232035', '3', '363', '2010', '595', '581', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232050', '10', '363', '2010', '589', '582', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232066', '481', '363', '2010', '584', '583', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232080', '44', '363', '2010', '582', '577', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232099', '13', '363', '2010', '579', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232121', '18', '363', '2010', '572', '572', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232138', '21', '363', '2010', '600', '579', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232158', '58', '363', '2010', '585', '585', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232171', '270', '363', '2010', '572', '569', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232190', '8', '363', '2011', '599', '599', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232203', '21', '363', '2011', '603', '592', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232217', '159', '363', '2011', '603', '599', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232297', '13', '363', '2011', '606', '589', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232310', '58', '363', '2011', '584', '584', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232326', '3', '363', '2012', '572', '553', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232350', '514', '363', '2012', '560', '557', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232368', '12', '363', '2012', '561', '530', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232388', '10', '363', '2012', '580', '529', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232402', '21', '363', '2012', '564', '537', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232422', '8', '363', '2012', '513', '513', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232437', '44', '363', '2012', '575', '575', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232448', '58', '363', '2012', '566', '566', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232462', '159', '363', '2012', '574', '564', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232481', '63', '363', '2012', '572', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232503', '13', '363', '2012', '568', '547', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232519', '22', '363', '2012', '573', '573', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232524', '428', '358', '2010', '429', '412', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('232526', '126', '363', '2012', '530', '530', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232530', '65', '358', '2010', '421', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('232539', '2590', '358', '2010', '429', '427', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('232542', '18', '363', '2012', '521', '521', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232557', '61', '363', '2012', '573', '562', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232576', '2677', '363', '2012', '549', '540', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232580', '428', '358', '2011', '457', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('232592', '2590', '358', '2011', '447', '444', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('232597', '270', '363', '2013', '592', '590', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232602', '8', '363', '2013', '592', '592', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232608', '65', '358', '2011', '416', '413', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('232618', '58', '363', '2013', '613', '613', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232628', '12', '363', '2013', '603', '594', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232638', '10', '363', '2013', '640', '625', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232639', '428', '358', '2012', '407', '399', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('232647', '65', '358', '2012', '394', '394', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('232651', '21', '363', '2013', '621', '597', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232661', '13', '363', '2013', '644', '620', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('232677', '159', '363', '2013', '633', '625', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('233204', '2590', '358', '2010', '438', '425', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('233209', '364', '358', '2010', '419', '417', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('233213', '428', '358', '2010', '415', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('233221', '65', '358', '2010', '410', '406', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('233233', '2590', '358', '2011', '470', '457', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('233240', '364', '358', '2011', '409', '406', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('233245', '428', '358', '2011', '430', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('233253', '65', '358', '2011', '411', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('233268', '65', '358', '2012', '376', '367', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('233272', '364', '358', '2012', '358', '357', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('233277', '428', '358', '2012', '404', '373', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('233336', '92', '363', '2010', '583', '573', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233346', '270', '363', '2010', '587', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233354', '514', '363', '2010', '585', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233363', '38', '363', '2010', '567', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233370', '79', '363', '2010', '587', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233378', '8', '363', '2010', '590', '585', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233384', '21', '363', '2010', '633', '609', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233391', '159', '363', '2010', '616', '602', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233397', '3', '363', '2010', '588', '585', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233402', '10', '363', '2010', '635', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233410', '44', '363', '2010', '629', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233417', '12', '363', '2010', '620', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233425', '63', '363', '2010', '621', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233433', '481', '363', '2010', '617', '606', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233467', '21', '363', '2011', '601', '590', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233471', '44', '363', '2011', '617', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233475', '61', '363', '2011', '583', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233480', '514', '363', '2011', '584', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233484', '79', '363', '2011', '566', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233488', '3', '363', '2011', '580', '574', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233493', '12', '363', '2011', '595', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233498', '22', '363', '2011', '595', '595', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233504', '38', '363', '2011', '578', '566', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233507', '159', '363', '2011', '594', '585', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233511', '63', '363', '2011', '603', '597', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233515', '270', '363', '2011', '574', '567', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233519', '92', '363', '2011', '586', '573', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233522', '10', '363', '2011', '602', '594', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233525', '8', '363', '2011', '572', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233543', '44', '363', '2012', '604', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233551', '10', '363', '2012', '562', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233556', '12', '363', '2012', '569', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233565', '79', '363', '2012', '551', '522', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233570', '8', '363', '2012', '558', '558', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233576', '21', '363', '2012', '589', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233585', '92', '363', '2012', '582', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233594', '514', '363', '2012', '589', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233604', '38', '363', '2012', '542', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233609', '3', '363', '2012', '559', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233618', '159', '363', '2012', '585', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233623', '63', '363', '2012', '601', '581', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233628', '61', '363', '2012', '599', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233631', '270', '363', '2012', '557', '544', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233635', '22', '363', '2012', '612', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233660', '159', '363', '2013', '650', '649', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233674', '92', '363', '2013', '632', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233683', '21', '363', '2013', '652', '641', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233691', '8', '363', '2013', '629', '629', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233699', '10', '363', '2013', '648', '645', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233707', '58', '363', '2013', '638', '638', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233711', '270', '363', '2013', '624', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('233719', '12', '363', '2013', '622', '618', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('234934', '10', '366', '2010', '554', '543', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('234950', '23', '366', '2010', '557', '557', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('234974', '10', '366', '2012', '531', '518', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('234981', '17', '366', '2012', '544', '544', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('234997', '2', '366', '2012', '570', '556', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('235017', '10', '366', '2013', '621', '608', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('235211', '65', '368', '2010', '485', '485', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('235234', '65', '368', '2011', '486', '486', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('235253', '10', '368', '2012', '448', '448', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('235273', '2686', '368', '2012', '471', '466', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('235284', '8', '368', '2012', '454', '454', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('235311', '8', '368', '2013', '529', '529', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('235326', '2686', '368', '2013', '506', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('235428', '2686', '368', '2010', '446', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('235459', '10', '368', '2012', '467', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('235476', '2686', '368', '2013', '255', '525', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('235485', '10', '368', '2013', '541', '541', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('236360', '8', '366', '2010', '564', '557', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236365', '271', '366', '2010', '602', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236370', '161', '366', '2010', '566', '545', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236373', '127', '366', '2010', '580', '557', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236376', '80', '366', '2010', '591', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236379', '151', '366', '2010', '548', '548', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236382', '118', '366', '2010', '545', '537', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236386', '83', '366', '2010', '569', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236390', '79', '366', '2010', '551', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236396', '36', '366', '2010', '583', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236403', '254', '366', '2010', '591', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236411', '38', '366', '2010', '564', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236415', '119', '366', '2010', '578', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236420', '3', '366', '2010', '575', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236425', '78', '366', '2010', '546', '545', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236430', '382', '366', '2010', '620', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236435', '23', '366', '2010', '562', '552', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236438', '206', '366', '2010', '565', '548', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236442', '147', '366', '2010', '587', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236446', '97', '366', '2010', '556', '553', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236449', '99', '366', '2010', '613', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236452', '437', '366', '2010', '588', '580', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236456', '85', '366', '2010', '583', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236482', '10', '366', '2011', '586', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236487', '3', '366', '2011', '601', '557', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236492', '23', '366', '2011', '600', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236520', '79', '366', '2012', '540', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236525', '254', '366', '2012', '594', '566', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236527', '17', '366', '2012', '567', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236530', '36', '366', '2012', '558', '539', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236533', '151', '366', '2012', '533', '531', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236535', '271', '366', '2012', '577', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236538', '127', '366', '2012', '540', '537', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236541', '437', '366', '2012', '590', '568', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236544', '97', '366', '2012', '555', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236546', '161', '366', '2012', '560', '558', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236549', '2', '366', '2012', '559', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236552', '147', '366', '2012', '592', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236555', '83', '366', '2012', '554', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236559', '378', '366', '2012', '566', '562', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236563', '547', '366', '2012', '586', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236566', '80', '366', '2012', '546', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236570', '118', '366', '2012', '534', '533', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236574', '99', '366', '2012', '569', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236578', '85', '366', '2012', '540', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236583', '382', '366', '2012', '634', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236590', '38', '366', '2012', '622', '557', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236594', '119', '366', '2012', '539', '537', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236630', '118', '366', '2013', '609', '587', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236635', '147', '366', '2013', '624', '586', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236638', '151', '366', '2013', '612', '593', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236641', '206', '366', '2013', '643', '631', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236646', '97', '366', '2013', '631', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236650', '161', '366', '2013', '596', '596', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236654', '119', '366', '2013', '624', '621', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236659', '378', '366', '2013', '617', '605', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236663', '233', '366', '2013', '618', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('236668', '85', '366', '2013', '627', '614', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('237181', '271', '366', '2011', '598', '561', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237194', '3', '366', '2011', '567', '560', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237221', '79', '366', '2011', '529', '524', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237237', '127', '366', '2011', '561', '556', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237256', '206', '366', '2011', '538', '521', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237270', '254', '366', '2011', '599', '566', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237276', '119', '366', '2011', '528', '522', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237288', '161', '366', '2011', '566', '551', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237305', '97', '366', '2011', '578', '566', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237320', '78', '366', '2011', '566', '540', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237334', '118', '366', '2011', '514', '502', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237349', '36', '366', '2011', '567', '535', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237361', '80', '366', '2011', '555', '539', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237375', '83', '366', '2011', '606', '571', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237390', '151', '366', '2011', '535', '508', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237400', '437', '366', '2011', '594', '571', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237416', '378', '366', '2011', '549', '543', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237426', '85', '366', '2011', '517', '509', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237435', '382', '366', '2011', '605', '587', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237449', '8', '366', '2011', '528', '528', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237462', '23', '366', '2011', '534', '531', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237477', '147', '366', '2011', '569', '526', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237486', '38', '366', '2011', '610', '610', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('237499', '99', '366', '2011', '606', '569', '5', '1', '34');
INSERT INTO `major_recruit` VALUES ('238639', '67', '373', '2011', '523', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('238644', '126', '373', '2011', '525', '513', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('238664', '43', '373', '2011', '520', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('238678', '10', '373', '2011', '522', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('238691', '17', '373', '2011', '524', '507', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('238734', '126', '373', '2012', '509', '493', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('238739', '43', '373', '2012', '494', '483', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('238748', '17', '373', '2012', '503', '483', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('238763', '67', '373', '2012', '500', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('238771', '10', '373', '2012', '497', '485', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('238793', '17', '373', '2013', '571', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('238807', '10', '373', '2013', '547', '522', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('239469', '89', '373', '2011', '481', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239486', '101', '373', '2011', '482', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239500', '234', '373', '2011', '482', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239510', '140', '373', '2011', '534', '472', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239520', '16', '373', '2011', '482', '472', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239530', '30', '373', '2011', '561', '478', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239538', '190', '373', '2011', '560', '510', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('239553', '364', '373', '2011', '494', '480', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239568', '205', '373', '2011', '480', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239580', '36', '373', '2011', '578', '501', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('239595', '2', '373', '2011', '483', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239606', '151', '373', '2011', '583', '502', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('239624', '147', '373', '2011', '541', '500', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('239641', '10', '373', '2011', '483', '472', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239652', '107', '373', '2011', '544', '506', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('239658', '143', '373', '2011', '581', '515', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('239675', '23', '373', '2011', '545', '503', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('239692', '79', '373', '2011', '563', '501', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('239707', '3', '373', '2011', '558', '507', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('239721', '38', '373', '2011', '585', '502', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('239737', '148', '373', '2011', '480', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239746', '43', '373', '2011', '478', '469', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239763', '67', '373', '2011', '483', '475', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239770', '78', '373', '2011', '484', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239783', '37', '373', '2011', '490', '475', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239791', '113', '373', '2011', '516', '474', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239815', '68', '373', '2011', '483', '465', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239826', '158', '373', '2011', '483', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239842', '26', '373', '2011', '483', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239857', '23', '373', '2012', '517', '492', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('239869', '36', '373', '2012', '582', '500', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('239884', '113', '373', '2012', '480', '465', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239895', '276', '373', '2012', '479', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239919', '43', '373', '2012', '468', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239937', '89', '373', '2012', '484', '465', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239953', '78', '373', '2012', '472', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239972', '364', '373', '2012', '498', '479', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('239993', '26', '373', '2012', '472', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('240003', '78', '376', '2010', '483', '483', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('240005', '3', '373', '2012', '542', '506', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('240022', '151', '373', '2012', '541', '499', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('240042', '205', '373', '2012', '500', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('240068', '148', '373', '2012', '476', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('240084', '16', '373', '2012', '561', '478', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('240101', '143', '373', '2012', '590', '502', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('240114', '147', '373', '2012', '551', '497', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('240139', '38', '373', '2012', '594', '506', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('240150', '79', '373', '2012', '545', '499', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('240160', '68', '373', '2012', '536', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('240167', '234', '373', '2012', '472', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('240179', '107', '373', '2012', '580', '504', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('240189', '30', '373', '2012', '514', '469', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('240201', '37', '373', '2012', '487', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('240208', '190', '373', '2012', '558', '505', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('240230', '147', '373', '2013', '577', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('240237', '101', '373', '2013', '600', '527', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('240253', '234', '373', '2013', '613', '527', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('240265', '113', '373', '2013', '551', '536', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('240277', '10', '373', '2013', '549', '539', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('242687', '13', '387', '2010', '522', '496', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('242793', '8', '387', '2011', '524', '512', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('242796', '12', '387', '2011', '530', '524', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('242797', '5', '387', '2011', '523', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('242799', '69', '387', '2011', '538', '517', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('242802', '13', '387', '2011', '530', '509', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('242806', '10', '387', '2011', '524', '520', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('242922', '12', '387', '2012', '491', '482', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('242938', '69', '387', '2012', '499', '472', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('242951', '5', '387', '2012', '487', '462', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('242962', '13', '387', '2012', '513', '474', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('242972', '8', '387', '2012', '511', '492', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('242980', '10', '387', '2012', '506', '485', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('242999', '69', '387', '2013', '550', '530', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('243010', '5', '387', '2013', '552', '528', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('243019', '13', '387', '2013', '574', '527', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('243032', '12', '387', '2013', '560', '544', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('243040', '8', '387', '2013', '557', '538', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('243056', '10', '387', '2013', '551', '544', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('243830', '202', '387', '2010', '547', '519', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243834', '325', '387', '2010', '556', '526', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243838', '147', '387', '2010', '577', '517', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243842', '69', '387', '2010', '500', '474', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('243847', '12', '387', '2010', '533', '478', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('243851', '38', '387', '2010', '565', '520', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243853', '109', '387', '2010', '544', '520', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243857', '197', '387', '2010', '558', '517', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243864', '129', '387', '2010', '598', '518', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243870', '55', '387', '2010', '537', '513', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243879', '143', '387', '2010', '607', '516', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243882', '37', '387', '2010', '588', '522', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243888', '113', '387', '2010', '566', '512', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243891', '146', '387', '2010', '569', '512', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243894', '68', '387', '2010', '589', '519', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243898', '2', '387', '2010', '559', '510', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243901', '105', '387', '2010', '566', '529', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243905', '8', '387', '2010', '493', '472', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('243910', '10', '387', '2010', '558', '479', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('243915', '3', '387', '2010', '595', '520', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243919', '16', '387', '2010', '561', '514', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243922', '131', '387', '2010', '528', '515', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243924', '101', '387', '2010', '585', '520', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243926', '36', '387', '2010', '590', '525', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243969', '105', '387', '2011', '544', '512', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243973', '55', '387', '2011', '575', '505', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243977', '38', '387', '2011', '589', '503', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243978', '325', '387', '2011', '561', '509', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243979', '12', '387', '2011', '486', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('243980', '2', '387', '2011', '543', '500', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243981', '3', '387', '2011', '597', '510', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243982', '69', '387', '2011', '481', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('243983', '113', '387', '2011', '573', '504', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243985', '8', '387', '2011', '481', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('243987', '101', '387', '2011', '572', '503', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243989', '202', '387', '2011', '593', '503', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243991', '37', '387', '2011', '580', '504', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243992', '16', '387', '2011', '552', '500', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243994', '129', '387', '2011', '552', '499', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243995', '147', '387', '2011', '557', '504', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('243997', '10', '387', '2011', '479', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('243999', '68', '387', '2011', '524', '499', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244001', '146', '387', '2011', '550', '498', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244003', '197', '387', '2011', '548', '500', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244005', '131', '387', '2011', '520', '494', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244008', '143', '387', '2011', '609', '509', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244012', '109', '387', '2011', '535', '495', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244017', '36', '387', '2011', '571', '503', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244038', '38', '387', '2012', '539', '498', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244041', '129', '387', '2012', '552', '495', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244045', '325', '387', '2012', '538', '503', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244048', '202', '387', '2012', '596', '495', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244051', '147', '387', '2012', '557', '500', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244054', '101', '387', '2012', '555', '498', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244058', '116', '387', '2012', '600', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244063', '2811', '387', '2012', '478', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('244068', '143', '387', '2012', '572', '501', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244072', '12', '387', '2012', '479', '470', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('244076', '69', '387', '2012', '494', '473', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('244080', '16', '387', '2012', '562', '491', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244083', '185', '387', '2012', '588', '559', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244085', '36', '387', '2012', '577', '499', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244088', '105', '387', '2012', '557', '506', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244091', '146', '387', '2012', '533', '494', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244094', '459', '387', '2012', '475', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('244098', '131', '387', '2012', '514', '489', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244103', '8', '387', '2012', '485', '478', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('244106', '197', '387', '2012', '563', '498', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244109', '113', '387', '2012', '537', '500', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244111', '2', '387', '2012', '550', '497', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244113', '10', '387', '2012', '489', '472', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('244115', '68', '387', '2012', '517', '491', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244116', '37', '387', '2012', '568', '503', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244118', '3', '387', '2012', '560', '505', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244120', '109', '387', '2012', '557', '492', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244122', '55', '387', '2012', '523', '493', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244131', '105', '387', '2013', '668', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244135', '113', '387', '2013', '615', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244138', '101', '387', '2013', '627', '568', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244140', '129', '387', '2013', '621', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244143', '131', '387', '2013', '589', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244145', '2811', '387', '2013', '599', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('244234', '5', '358', '2011', '522', '508', '1', '2', '10');
INSERT INTO `major_recruit` VALUES ('244238', '428', '358', '2011', '508', '505', '1', '2', '10');
INSERT INTO `major_recruit` VALUES ('244242', '10', '358', '2011', '515', '505', '1', '2', '10');
INSERT INTO `major_recruit` VALUES ('244245', '65', '358', '2011', '518', '509', '1', '2', '10');
INSERT INTO `major_recruit` VALUES ('244539', '21', '358', '2011', '480', '473', '2', '2', '10');
INSERT INTO `major_recruit` VALUES ('244541', '65', '358', '2011', '502', '469', '2', '2', '10');
INSERT INTO `major_recruit` VALUES ('244546', '14', '358', '2011', '462', '456', '2', '2', '10');
INSERT INTO `major_recruit` VALUES ('244552', '126', '358', '2011', '485', '475', '2', '2', '10');
INSERT INTO `major_recruit` VALUES ('244558', '428', '358', '2011', '475', '471', '2', '2', '10');
INSERT INTO `major_recruit` VALUES ('244568', '38', '358', '2011', '455', '452', '2', '2', '10');
INSERT INTO `major_recruit` VALUES ('244578', '24', '358', '2011', '451', '450', '2', '2', '10');
INSERT INTO `major_recruit` VALUES ('244583', '56', '358', '2011', '458', '455', '2', '2', '10');
INSERT INTO `major_recruit` VALUES ('244587', '3', '358', '2011', '470', '468', '2', '2', '10');
INSERT INTO `major_recruit` VALUES ('248724', '23', '395', '2011', '480', '480', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('248914', '10', '358', '2010', '523', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('248929', '65', '358', '2010', '517', '517', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('248949', '126', '358', '2010', '520', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('248963', '5', '358', '2010', '527', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('248982', '65', '358', '2011', '526', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('248994', '5', '358', '2011', '525', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('249011', '126', '358', '2011', '528', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('249031', '10', '358', '2011', '530', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('249057', '126', '358', '2012', '567', '566', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('249072', '10', '358', '2012', '566', '565', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('249081', '65', '358', '2012', '567', '565', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('249095', '5', '358', '2012', '566', '564', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('249703', '56', '358', '2010', '503', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249711', '65', '358', '2010', '508', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249723', '3', '358', '2010', '518', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249746', '21', '358', '2010', '516', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249760', '23', '358', '2010', '514', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249771', '364', '358', '2010', '509', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249788', '24', '358', '2010', '502', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249801', '5', '358', '2010', '504', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249814', '38', '358', '2010', '507', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249832', '126', '358', '2010', '504', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249852', '14', '358', '2010', '508', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249875', '126', '358', '2011', '522', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249892', '14', '358', '2011', '519', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249896', '78', '358', '2011', '530', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249901', '38', '358', '2011', '517', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249933', '21', '358', '2011', '524', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249948', '5', '358', '2011', '541', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249956', '65', '358', '2011', '531', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249964', '24', '358', '2011', '522', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('249983', '56', '358', '2011', '521', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250010', '126', '358', '2012', '541', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250023', '23', '358', '2012', '545', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250036', '38', '358', '2012', '537', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250056', '78', '358', '2012', '542', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250081', '5', '358', '2012', '542', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250102', '21', '358', '2012', '547', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250127', '364', '358', '2012', '541', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250145', '14', '358', '2012', '542', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250153', '3', '358', '2012', '551', '548', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250166', '65', '358', '2012', '535', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250183', '56', '358', '2012', '538', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250195', '24', '358', '2012', '542', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250411', '10', '373', '2011', '531', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('250432', '43', '373', '2011', '539', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('250451', '126', '373', '2011', '544', '536', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('250456', '17', '373', '2011', '541', '534', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('250476', '126', '373', '2012', '569', '569', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('250491', '17', '373', '2012', '574', '571', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('250500', '10', '373', '2012', '569', '568', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('250513', '43', '373', '2012', '568', '567', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('250814', '147', '373', '2011', '584', '560', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250828', '78', '373', '2011', '538', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250842', '79', '373', '2011', '543', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250850', '36', '373', '2011', '542', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250861', '2', '373', '2011', '542', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250878', '89', '373', '2011', '541', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250893', '234', '373', '2011', '548', '543', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250908', '38', '373', '2011', '555', '549', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250918', '68', '373', '2011', '540', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250931', '37', '373', '2011', '550', '548', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250944', '113', '373', '2011', '553', '551', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250962', '107', '373', '2011', '544', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250972', '30', '373', '2011', '542', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('250988', '143', '373', '2011', '542', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('251012', '89', '373', '2012', '558', '549', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('251022', '107', '373', '2012', '576', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('251035', '147', '373', '2012', '563', '557', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('251055', '30', '373', '2012', '562', '556', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('251070', '101', '373', '2012', '553', '549', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('251087', '38', '373', '2012', '567', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('251102', '37', '373', '2012', '581', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('251121', '78', '373', '2012', '553', '547', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('251137', '151', '373', '2012', '567', '557', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('251154', '2', '373', '2012', '563', '556', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('251174', '79', '373', '2012', '564', '554', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('251184', '113', '373', '2012', '563', '555', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('251197', '36', '373', '2012', '575', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('256276', '58', '363', '2010', '558', '558', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256294', '10', '363', '2010', '567', '567', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256302', '18', '363', '2010', '559', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256321', '21', '363', '2010', '566', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256336', '13', '363', '2010', '559', '558', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256349', '3', '363', '2010', '562', '562', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256361', '63', '363', '2010', '564', '564', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256386', '3', '363', '2011', '569', '569', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256396', '10', '363', '2011', '570', '569', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256404', '21', '363', '2011', '571', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256435', '13', '363', '2011', '569', '569', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256456', '58', '363', '2011', '572', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256466', '63', '363', '2011', '575', '575', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256488', '63', '363', '2012', '614', '610', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256504', '13', '363', '2012', '613', '609', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256520', '3', '363', '2012', '607', '607', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256544', '21', '363', '2012', '611', '611', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256557', '10', '363', '2012', '608', '606', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('256571', '58', '363', '2012', '606', '606', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('257090', '79', '363', '2010', '556', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('257103', '58', '363', '2010', '547', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('257118', '63', '363', '2010', '568', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('257188', '61', '363', '2012', '643', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('257204', '10', '363', '2012', '600', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('257221', '63', '363', '2012', '604', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('257232', '270', '363', '2012', '578', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('257250', '58', '363', '2012', '592', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('257270', '38', '363', '2012', '584', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('257288', '92', '363', '2012', '576', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('257307', '79', '363', '2012', '593', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('257325', '3', '363', '2012', '605', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('257353', '21', '363', '2012', '594', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('257366', '22', '363', '2012', '617', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('260973', '10', '387', '2010', '492', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('262048', '147', '387', '2010', '534', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('262053', '3', '387', '2010', '500', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('262066', '69', '387', '2010', '526', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('262084', '38', '387', '2010', '536', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('262101', '129', '387', '2010', '604', '566', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('262132', '38', '387', '2011', '544', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('262144', '129', '387', '2011', '547', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('262162', '459', '387', '2011', '547', '545', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('262177', '147', '387', '2011', '572', '569', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('262208', '2811', '387', '2012', '557', '557', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('262232', '129', '387', '2012', '560', '558', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('262240', '113', '387', '2012', '570', '566', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('273510', '5', '418', '2010', '510', '493', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273514', '136', '418', '2010', '516', '500', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273521', '8', '418', '2010', '520', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273526', '78', '418', '2010', '508', '497', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273530', '126', '418', '2010', '549', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273533', '17', '418', '2010', '517', '513', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273536', '3', '418', '2010', '536', '519', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273539', '10', '418', '2010', '522', '496', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273545', '78', '418', '2011', '514', '505', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273550', '5', '418', '2011', '519', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273553', '17', '418', '2011', '526', '518', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273563', '10', '418', '2011', '515', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273574', '136', '418', '2011', '522', '507', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273579', '126', '418', '2011', '537', '513', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273585', '3', '418', '2011', '546', '522', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273588', '23', '418', '2011', '520', '515', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273609', '17', '418', '2012', '496', '488', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273612', '126', '418', '2012', '504', '483', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273615', '5', '418', '2012', '480', '472', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273620', '3605', '418', '2012', '494', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273623', '23', '418', '2012', '494', '486', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273624', '3', '418', '2012', '529', '494', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273626', '78', '418', '2012', '492', '482', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273627', '10', '418', '2012', '499', '477', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273631', '136', '418', '2012', '486', '478', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273657', '5', '418', '2013', '530', '519', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273658', '10', '418', '2013', '560', '526', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273661', '8', '418', '2013', '548', '534', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('273664', '17', '418', '2013', '554', '542', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('274383', '17', '418', '2010', '497', '478', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274393', '23', '418', '2010', '494', '480', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274400', '120', '418', '2010', '520', '491', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274404', '79', '418', '2010', '508', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274407', '38', '418', '2010', '492', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274410', '101', '418', '2010', '478', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274414', '5', '418', '2010', '473', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274417', '89', '418', '2010', '501', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274421', '16', '418', '2010', '503', '469', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274424', '126', '418', '2010', '524', '481', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274429', '8', '418', '2010', '495', '482', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274432', '10', '418', '2010', '524', '488', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274435', '3', '418', '2010', '536', '500', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274438', '21', '418', '2010', '543', '486', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274461', '571', '418', '2011', '484', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274470', '10', '418', '2011', '491', '473', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274480', '120', '418', '2011', '495', '480', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274497', '2', '418', '2011', '484', '470', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274503', '78', '418', '2011', '473', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274517', '17', '418', '2011', '536', '478', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274530', '90', '418', '2011', '509', '475', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274539', '89', '418', '2011', '481', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274547', '23', '418', '2011', '497', '476', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274556', '38', '418', '2011', '470', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274568', '147', '418', '2011', '477', '465', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274577', '136', '418', '2011', '479', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274586', '126', '418', '2011', '486', '472', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274597', '79', '418', '2011', '481', '461', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274607', '16', '418', '2011', '479', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274616', '101', '418', '2011', '482', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274624', '5', '418', '2011', '467', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274630', '3', '418', '2011', '522', '487', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274651', '38', '418', '2012', '470', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274663', '17', '418', '2012', '509', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274672', '147', '418', '2012', '475', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274679', '16', '418', '2012', '469', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274689', '101', '418', '2012', '467', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274697', '126', '418', '2012', '495', '470', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274702', '571', '418', '2012', '475', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274706', '89', '418', '2012', '482', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274710', '120', '418', '2012', '504', '476', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274718', '115', '418', '2012', '476', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274723', '5', '418', '2012', '466', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274731', '3605', '418', '2012', '474', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274735', '79', '418', '2012', '472', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274749', '10', '418', '2012', '485', '473', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274755', '90', '418', '2012', '498', '465', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274765', '23', '418', '2012', '480', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274778', '2', '418', '2012', '475', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274784', '3', '418', '2012', '508', '483', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274790', '136', '418', '2012', '483', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274802', '78', '418', '2012', '475', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274831', '101', '418', '2013', '534', '525', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274835', '5', '418', '2013', '538', '426', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274842', '10', '418', '2013', '549', '542', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274848', '8', '418', '2013', '563', '544', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274857', '21', '418', '2013', '591', '545', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('274869', '17', '418', '2013', '576', '546', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('276097', '8', '428', '2011', '491', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276101', '3', '428', '2011', '486', '486', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276106', '203', '428', '2011', '498', '498', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276301', '351', '428', '2013', '531', '530', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('276772', '126', '429', '2010', '508', '500', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276778', '13', '429', '2010', '519', '502', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276787', '5', '429', '2010', '509', '495', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276796', '2', '429', '2010', '514', '495', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276805', '780', '429', '2010', '510', '495', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276823', '43', '429', '2010', '516', '496', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276832', '136', '429', '2010', '518', '497', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276840', '23', '429', '2010', '518', '501', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276847', '17', '429', '2010', '518', '493', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276857', '65', '429', '2010', '501', '497', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276868', '58', '429', '2010', '512', '492', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276896', '23', '429', '2011', '515', '506', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276905', '136', '429', '2011', '517', '507', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276911', '65', '429', '2011', '519', '497', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276919', '5', '429', '2011', '513', '497', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276929', '17', '429', '2011', '520', '496', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276938', '13', '429', '2011', '517', '499', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276944', '126', '429', '2011', '508', '498', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276954', '2', '429', '2011', '524', '504', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276961', '780', '429', '2011', '512', '498', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276969', '43', '429', '2011', '517', '505', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276977', '58', '429', '2011', '512', '495', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('276998', '43', '429', '2012', '483', '470', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277006', '2', '429', '2012', '490', '478', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277018', '126', '429', '2012', '488', '481', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277034', '3647', '429', '2012', '498', '470', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277041', '23', '429', '2012', '488', '479', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277048', '780', '429', '2012', '486', '476', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277053', '58', '429', '2012', '491', '473', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277059', '17', '429', '2012', '489', '468', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277066', '5', '429', '2012', '491', '473', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277070', '13', '429', '2012', '473', '461', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277077', '65', '429', '2012', '475', '463', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277085', '136', '429', '2012', '486', '481', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277129', '17', '429', '2013', '544', '525', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277132', '5', '429', '2013', '536', '514', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277135', '58', '429', '2013', '534', '528', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277139', '13', '429', '2013', '551', '530', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277144', '65', '429', '2013', '536', '514', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('277524', '2', '429', '2010', '481', '474', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277532', '65', '429', '2010', '465', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277539', '136', '429', '2010', '475', '470', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277548', '23', '429', '2010', '483', '477', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277557', '780', '429', '2010', '490', '475', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277566', '126', '429', '2010', '479', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277579', '17', '429', '2010', '485', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277588', '43', '429', '2010', '498', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277597', '58', '429', '2010', '485', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277611', '5', '429', '2010', '497', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277619', '118', '429', '2010', '484', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277653', '58', '429', '2011', '480', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277660', '118', '429', '2011', '468', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277665', '43', '429', '2011', '473', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277671', '780', '429', '2011', '479', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277680', '65', '429', '2011', '478', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277690', '5', '429', '2011', '473', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277699', '2', '429', '2011', '477', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277705', '126', '429', '2011', '489', '475', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277710', '136', '429', '2011', '469', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277718', '23', '429', '2011', '474', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277730', '17', '429', '2011', '467', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277755', '43', '429', '2012', '464', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277762', '126', '429', '2012', '484', '479', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277768', '118', '429', '2012', '470', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277773', '2', '429', '2012', '465', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277775', '23', '429', '2012', '470', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277780', '780', '429', '2012', '477', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277792', '136', '429', '2012', '472', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277802', '5', '429', '2012', '459', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277812', '58', '429', '2012', '464', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277822', '17', '429', '2012', '481', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277834', '65', '429', '2012', '466', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277860', '65', '429', '2013', '523', '516', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277872', '17', '429', '2013', '568', '540', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277879', '58', '429', '2013', '542', '530', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277890', '5', '429', '2013', '534', '528', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('277900', '118', '429', '2013', '535', '524', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('278420', '8', '418', '2010', '430', '430', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278426', '136', '418', '2010', '426', '426', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278433', '5', '418', '2010', '432', '432', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278437', '10', '418', '2010', '439', '439', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278451', '3605', '418', '2011', '429', '429', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278453', '17', '418', '2011', '442', '442', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278454', '5', '418', '2011', '426', '426', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278457', '10', '418', '2011', '423', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278458', '78', '418', '2011', '448', '448', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278461', '136', '418', '2011', '417', '417', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278476', '10', '418', '2012', '409', '408', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278479', '17', '418', '2012', '433', '433', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278489', '5', '418', '2012', '409', '409', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278496', '3', '418', '2012', '412', '412', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278500', '136', '418', '2012', '411', '411', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278529', '8', '418', '2013', '430', '430', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278538', '5', '418', '2013', '420', '420', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278547', '10', '418', '2013', '419', '419', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278553', '17', '418', '2013', '433', '433', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('278705', '21', '418', '2010', '447', '447', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('278708', '90', '418', '2010', '434', '434', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('278716', '23', '418', '2010', '443', '443', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('278739', '17', '418', '2011', '433', '433', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('278752', '120', '418', '2011', '445', '445', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('278760', '115', '418', '2011', '444', '444', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('278766', '571', '418', '2011', '436', '436', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('278795', '120', '418', '2012', '414', '414', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('278802', '23', '418', '2012', '400', '400', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('278807', '115', '418', '2012', '409', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('278817', '78', '418', '2012', '408', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('279016', '203', '428', '2011', '430', '430', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279022', '69', '428', '2011', '433', '433', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279028', '52', '428', '2011', '425', '425', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279034', '3', '428', '2011', '432', '432', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279048', '8', '428', '2011', '430', '430', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279073', '203', '428', '2012', '405', '405', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279084', '3', '428', '2012', '413', '413', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279097', '52', '428', '2012', '404', '404', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279105', '8', '428', '2012', '408', '408', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279112', '69', '428', '2012', '405', '405', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279138', '69', '428', '2013', '418', '418', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279147', '444', '428', '2013', '395', '395', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279153', '351', '428', '2013', '379', '379', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279164', '95', '428', '2013', '369', '369', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279171', '141', '428', '2013', '364', '364', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279180', '10', '428', '2013', '359', '359', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279188', '222', '428', '2013', '361', '361', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279195', '8', '428', '2013', '428', '428', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279207', '5', '428', '2013', '421', '421', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('279549', '141', '428', '2011', '402', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('279552', '95', '428', '2011', '403', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('279556', '98', '428', '2011', '405', '405', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('279560', '203', '428', '2011', '405', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('279633', '98', '428', '2012', '375', '375', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('279636', '141', '428', '2012', '368', '368', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('279639', '95', '428', '2012', '375', '375', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('279640', '203', '428', '2012', '374', '374', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281590', '126', '429', '2010', '431', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281593', '5', '429', '2010', '426', '424', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281595', '17', '429', '2010', '458', '442', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281597', '136', '429', '2010', '426', '421', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281598', '780', '429', '2010', '421', '418', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281599', '13', '429', '2010', '417', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281606', '17', '429', '2011', '429', '427', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281608', '65', '429', '2011', '419', '418', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281610', '5', '429', '2011', '425', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281612', '780', '429', '2011', '425', '422', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281613', '126', '429', '2011', '431', '426', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281614', '13', '429', '2011', '423', '422', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281615', '136', '429', '2011', '429', '425', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281643', '136', '429', '2012', '404', '403', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281644', '126', '429', '2012', '408', '405', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281645', '65', '429', '2012', '408', '408', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281646', '13', '429', '2012', '405', '403', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281647', '5', '429', '2012', '401', '400', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281648', '17', '429', '2012', '408', '408', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281649', '780', '429', '2012', '402', '402', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281650', '23', '429', '2012', '410', '410', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281659', '65', '429', '2013', '426', '426', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281663', '13', '429', '2013', '416', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281666', '5', '429', '2013', '416', '416', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281669', '17', '429', '2013', '421', '420', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('281868', '780', '429', '2010', '403', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281872', '136', '429', '2010', '418', '416', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281877', '5', '429', '2010', '435', '421', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281885', '17', '429', '2010', '425', '423', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281890', '126', '429', '2010', '419', '418', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281895', '118', '429', '2010', '415', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281921', '65', '429', '2011', '404', '404', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281928', '136', '429', '2011', '409', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281932', '126', '429', '2011', '415', '412', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281938', '780', '429', '2011', '406', '406', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281944', '17', '429', '2011', '411', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281948', '5', '429', '2011', '407', '407', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281951', '118', '429', '2011', '425', '414', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281980', '126', '429', '2012', '377', '375', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281982', '23', '429', '2012', '366', '366', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281991', '118', '429', '2012', '367', '367', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('281998', '780', '429', '2012', '373', '373', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('282002', '136', '429', '2012', '377', '377', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('282007', '5', '429', '2012', '378', '378', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('282010', '17', '429', '2012', '370', '356', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('282014', '65', '429', '2012', '368', '366', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('282028', '5', '429', '2013', '354', '354', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('282033', '17', '429', '2013', '354', '351', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('282037', '65', '429', '2013', '346', '346', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('282047', '118', '429', '2013', '348', '348', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('286586', '5', '444', '2010', '604', '584', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('286595', '10', '444', '2010', '586', '564', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('286604', '136', '444', '2010', '564', '560', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('286610', '498', '444', '2010', '562', '560', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('286615', '13', '444', '2010', '563', '559', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('286620', '3651', '444', '2010', '581', '573', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('286625', '14', '444', '2010', '572', '566', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('286631', '20', '444', '2010', '573', '570', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('286638', '65', '444', '2010', '560', '559', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('286645', '3652', '444', '2010', '558', '557', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('286839', '23', '444', '2010', '590', '575', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('286842', '5', '444', '2010', '618', '570', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('286846', '8', '444', '2010', '579', '578', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('286851', '3653', '444', '2010', '599', '599', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('286854', '20', '444', '2010', '578', '578', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('287178', '105', '447', '2010', '466', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('287215', '56', '447', '2012', '477', '477', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('289381', '136', '444', '2010', '472', '471', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('289387', '3652', '444', '2010', '470', '470', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('289391', '20', '444', '2010', '475', '470', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('289396', '10', '444', '2010', '469', '469', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('289399', '65', '444', '2010', '471', '468', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('289402', '14', '444', '2010', '485', '476', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('289404', '13', '444', '2010', '491', '477', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('289407', '3651', '444', '2010', '478', '478', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('289410', '5', '444', '2010', '491', '483', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('289615', '23', '444', '2010', '476', '475', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('289619', '498', '444', '2010', '495', '488', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('289624', '3653', '444', '2010', '480', '480', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('289628', '3651', '444', '2010', '480', '479', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('289635', '20', '444', '2010', '478', '478', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('289638', '8', '444', '2010', '479', '476', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('289642', '3652', '444', '2010', '475', '473', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('290674', '3', '418', '2010', '530', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290676', '136', '418', '2010', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290678', '17', '418', '2010', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290680', '78', '418', '2010', '528', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290682', '8', '418', '2010', '528', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290684', '10', '418', '2010', '527', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290687', '5', '418', '2010', '527', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290703', '10', '418', '2011', '541', '541', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290705', '3', '418', '2011', '543', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290707', '136', '418', '2011', '535', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290708', '78', '418', '2011', '535', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290709', '3605', '418', '2011', '536', '536', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290711', '17', '418', '2011', '541', '539', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290713', '5', '418', '2011', '535', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290726', '3605', '418', '2012', '573', '573', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290729', '78', '418', '2012', '576', '576', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290731', '126', '418', '2012', '569', '569', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290732', '5', '418', '2012', '569', '569', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290733', '10', '418', '2012', '570', '570', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290734', '17', '418', '2012', '587', '587', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290735', '3', '418', '2012', '578', '578', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('290894', '93', '455', '2011', '509', '499', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290896', '71', '455', '2011', '489', '486', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290898', '56', '455', '2011', '506', '506', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290899', '1248', '455', '2011', '530', '517', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290900', '155', '455', '2011', '492', '488', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290901', '27', '455', '2011', '508', '499', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290903', '28', '455', '2011', '520', '515', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290926', '93', '455', '2012', '491', '487', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290929', '155', '455', '2012', '482', '482', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290931', '56', '455', '2012', '483', '483', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290932', '71', '455', '2012', '489', '488', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290934', '27', '455', '2012', '501', '487', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290935', '2', '418', '2010', '518', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290937', '28', '455', '2012', '524', '520', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290939', '120', '418', '2010', '534', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290943', '3', '418', '2010', '528', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290945', '21', '418', '2010', '530', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290947', '56', '455', '2013', '608', '608', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290949', '28', '455', '2013', '590', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290951', '101', '418', '2010', '517', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290953', '157', '455', '2013', '558', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290957', '79', '418', '2010', '517', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290958', '93', '455', '2013', '599', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('290960', '126', '418', '2010', '518', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290962', '571', '418', '2010', '521', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290963', '38', '418', '2010', '523', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290979', '79', '418', '2011', '528', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290980', '2', '418', '2011', '530', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290981', '3', '418', '2011', '536', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290982', '571', '418', '2011', '533', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290983', '101', '418', '2011', '527', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290985', '17', '418', '2011', '535', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290990', '126', '418', '2011', '530', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('290996', '115', '418', '2011', '530', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291001', '120', '418', '2011', '532', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291005', '38', '418', '2011', '529', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291013', '101', '418', '2012', '550', '550', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291014', '115', '418', '2012', '550', '550', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291015', '120', '418', '2012', '556', '555', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291016', '38', '418', '2012', '552', '552', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291017', '79', '418', '2012', '549', '549', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291018', '17', '418', '2012', '558', '556', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291019', '3', '418', '2012', '567', '561', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291022', '23', '418', '2012', '553', '553', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291025', '89', '418', '2012', '552', '552', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291509', '23', '429', '2010', '519', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('291514', '2', '429', '2010', '510', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('291517', '43', '429', '2010', '514', '511', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('291521', '5', '429', '2010', '516', '514', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('291542', '23', '429', '2011', '529', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('291543', '2', '429', '2011', '526', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('291547', '43', '429', '2011', '526', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('291550', '5', '429', '2011', '525', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('291603', '5', '429', '2012', '569', '569', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('291605', '2', '429', '2012', '563', '563', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('291607', '43', '429', '2012', '580', '566', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('291613', '23', '429', '2012', '567', '565', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('291952', '5', '429', '2010', '498', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291966', '118', '429', '2010', '497', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291980', '2', '429', '2010', '497', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291992', '23', '429', '2010', '496', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('291997', '43', '429', '2010', '507', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('292024', '118', '429', '2011', '514', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('292387', '3', '458', '2010', '526', '508', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292391', '10', '458', '2010', '512', '493', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292398', '78', '458', '2010', '513', '492', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292402', '24', '458', '2010', '511', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292408', '8', '458', '2010', '514', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292428', '52', '458', '2011', '506', '494', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292430', '24', '458', '2011', '513', '490', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292432', '78', '458', '2011', '513', '494', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292434', '3', '458', '2011', '534', '518', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292435', '10', '458', '2011', '516', '496', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292436', '8', '458', '2011', '522', '500', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292471', '10', '458', '2012', '493', '467', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292475', '24', '458', '2012', '494', '464', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292483', '52', '458', '2012', '481', '462', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292489', '78', '458', '2012', '489', '463', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292493', '3', '458', '2012', '508', '484', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292499', '8', '458', '2012', '510', '466', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292526', '10', '458', '2013', '530', '517', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('292530', '8', '458', '2013', '546', '517', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('293414', '24', '458', '2010', '490', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293422', '36', '458', '2010', '497', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293428', '38', '458', '2010', '528', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293434', '113', '458', '2010', '493', '476', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293442', '147', '458', '2010', '515', '478', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293449', '437', '458', '2010', '497', '483', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293459', '3', '458', '2010', '507', '493', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293469', '91', '458', '2010', '505', '485', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293481', '85', '458', '2010', '496', '474', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293496', '78', '458', '2010', '490', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293509', '8', '458', '2010', '500', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293517', '141', '458', '2010', '496', '470', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293527', '99', '458', '2010', '498', '469', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293537', '127', '458', '2010', '502', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293549', '83', '458', '2010', '492', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293567', '132', '458', '2010', '511', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293575', '143', '458', '2010', '494', '483', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293585', '151', '458', '2010', '487', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293592', '101', '458', '2010', '486', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293597', '79', '458', '2010', '494', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293603', '10', '458', '2010', '488', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293610', '161', '458', '2010', '499', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293617', '80', '458', '2010', '493', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293628', '52', '458', '2010', '487', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293665', '52', '458', '2011', '473', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293670', '36', '458', '2011', '481', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293676', '24', '458', '2011', '476', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293691', '80', '458', '2011', '478', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293705', '141', '458', '2011', '551', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293718', '8', '458', '2011', '472', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293737', '132', '458', '2011', '462', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293754', '3', '458', '2011', '512', '482', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293768', '127', '458', '2011', '483', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293781', '151', '458', '2011', '511', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293793', '83', '458', '2011', '476', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293816', '85', '458', '2011', '482', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293822', '437', '458', '2011', '483', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293836', '101', '458', '2011', '502', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293845', '79', '458', '2011', '479', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293857', '10', '458', '2011', '481', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293868', '113', '458', '2011', '479', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293878', '78', '458', '2011', '475', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293887', '143', '458', '2011', '483', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293903', '38', '458', '2011', '481', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293914', '99', '458', '2011', '483', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293925', '91', '458', '2011', '482', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293933', '161', '458', '2011', '500', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293964', '94', '458', '2012', '476', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293973', '10', '458', '2012', '483', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293984', '283', '458', '2012', '473', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('293993', '437', '458', '2012', '476', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294006', '99', '458', '2012', '534', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294015', '24', '458', '2012', '476', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294030', '83', '458', '2012', '572', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294041', '80', '458', '2012', '476', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294048', '52', '458', '2012', '476', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294056', '141', '458', '2012', '497', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294065', '79', '458', '2012', '474', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294071', '132', '458', '2012', '476', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294078', '8', '458', '2012', '481', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294087', '127', '458', '2012', '473', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294094', '85', '458', '2012', '479', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294098', '113', '458', '2012', '476', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294101', '101', '458', '2012', '485', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294107', '36', '458', '2012', '476', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294116', '91', '458', '2012', '480', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294127', '143', '458', '2012', '484', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294133', '38', '458', '2012', '477', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294140', '161', '458', '2012', '497', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294147', '3', '458', '2012', '572', '473', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('294155', '151', '458', '2012', '536', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('296569', '127', '458', '2010', '433', '433', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('296571', '52', '458', '2010', '400', '400', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('296573', '8', '458', '2010', '450', '450', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('296575', '91', '458', '2010', '403', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('296576', '85', '458', '2010', '413', '413', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('296590', '8', '458', '2011', '442', '442', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('296592', '85', '458', '2011', '414', '414', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('296594', '52', '458', '2011', '450', '432', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('296597', '161', '458', '2011', '430', '430', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('296618', '85', '458', '2012', '386', '386', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('296620', '52', '458', '2012', '381', '381', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('296622', '36', '458', '2012', '394', '394', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('296625', '8', '458', '2012', '383', '383', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('296627', '91', '458', '2012', '382', '382', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('296639', '8', '458', '2013', '373', '373', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('296641', '91', '458', '2013', '356', '356', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('296643', '10', '458', '2013', '353', '353', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('297557', '136', '444', '2010', '564', '553', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('297565', '13', '444', '2010', '541', '539', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('297577', '10', '444', '2010', '540', '540', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('297586', '3651', '444', '2010', '548', '541', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('297599', '20', '444', '2010', '561', '553', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('297609', '14', '444', '2010', '541', '541', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('297845', '23', '444', '2010', '580', '574', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('297855', '498', '444', '2010', '577', '577', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('297863', '3652', '444', '2010', '562', '562', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('297878', '8', '444', '2010', '586', '574', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('297889', '3653', '444', '2010', '571', '571', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('300155', '120', '473', '2012', '486', '486', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('300161', '8', '473', '2012', '455', '450', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('300245', '132', '473', '2011', '436', '436', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('300246', '113', '473', '2011', '437', '437', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('300270', '147', '473', '2012', '453', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('300275', '132', '473', '2012', '445', '442', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('301164', '164', '475', '2010', '571', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('301165', '5', '475', '2010', '541', '538', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('301166', '10', '475', '2010', '540', '531', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('301176', '164', '475', '2011', '544', '541', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('301179', '10', '475', '2011', '580', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('301180', '5', '475', '2011', '573', '549', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('301192', '5', '475', '2012', '524', '523', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('301194', '164', '475', '2012', '549', '540', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('301195', '10', '475', '2012', '527', '521', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('301206', '10', '475', '2013', '570', '564', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('301210', '5', '475', '2013', '585', '572', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('301479', '147', '475', '2010', '551', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301482', '271', '475', '2010', '560', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301488', '37', '475', '2010', '589', '562', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301495', '372', '475', '2010', '535', '530', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301503', '38', '475', '2010', '535', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301516', '164', '475', '2010', '589', '562', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301522', '85', '475', '2010', '551', '543', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301533', '29', '475', '2010', '589', '572', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301538', '317', '475', '2010', '562', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301547', '113', '475', '2010', '551', '537', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301558', '83', '475', '2010', '559', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301565', '343', '475', '2010', '627', '612', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301573', '220', '475', '2010', '606', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301584', '97', '475', '2010', '595', '569', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301596', '244', '475', '2010', '616', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301605', '233', '475', '2010', '537', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301614', '129', '475', '2010', '563', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301618', '232', '475', '2010', '603', '564', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301622', '30', '475', '2010', '549', '538', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301626', '5', '475', '2010', '540', '526', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301629', '805', '475', '2010', '573', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301633', '118', '475', '2010', '572', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301637', '380', '475', '2010', '580', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301640', '151', '475', '2010', '526', '525', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301642', '10', '475', '2010', '526', '526', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301644', '207', '475', '2010', '575', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301647', '445', '475', '2010', '604', '586', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301670', '164', '475', '2011', '541', '538', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301673', '129', '475', '2011', '535', '527', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301681', '83', '475', '2011', '566', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301683', '805', '475', '2011', '555', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301688', '445', '475', '2011', '551', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301692', '118', '475', '2011', '533', '528', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301695', '37', '475', '2011', '526', '519', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301698', '5', '475', '2011', '529', '524', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301703', '317', '475', '2011', '523', '521', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301710', '97', '475', '2011', '542', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301716', '232', '475', '2011', '575', '573', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301719', '220', '475', '2011', '587', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301724', '271', '475', '2011', '600', '554', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301728', '113', '475', '2011', '524', '522', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301732', '207', '475', '2011', '561', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301735', '233', '475', '2011', '557', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301738', '244', '475', '2011', '580', '579', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301741', '147', '475', '2011', '527', '518', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301744', '343', '475', '2011', '573', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301746', '38', '475', '2011', '545', '534', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301748', '85', '475', '2011', '572', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301750', '10', '475', '2011', '537', '527', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301752', '380', '475', '2011', '566', '550', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301754', '29', '475', '2011', '551', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301781', '17', '475', '2012', '550', '545', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301785', '271', '475', '2012', '552', '548', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301792', '233', '475', '2012', '552', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301796', '97', '475', '2012', '600', '558', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301802', '244', '475', '2012', '593', '590', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301808', '129', '475', '2012', '564', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301814', '445', '475', '2012', '566', '563', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301819', '232', '475', '2012', '584', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301825', '805', '475', '2012', '533', '531', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301829', '380', '475', '2012', '588', '559', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301833', '85', '475', '2012', '532', '523', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301836', '83', '475', '2012', '547', '533', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301839', '207', '475', '2012', '547', '533', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301843', '147', '475', '2012', '539', '539', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301846', '343', '475', '2012', '605', '588', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301849', '29', '475', '2012', '539', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301852', '164', '475', '2012', '570', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301856', '37', '475', '2012', '559', '539', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301859', '317', '475', '2012', '526', '519', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301861', '30', '475', '2012', '549', '531', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301864', '113', '475', '2012', '546', '532', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301867', '10', '475', '2012', '562', '541', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301871', '38', '475', '2012', '563', '539', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301878', '118', '475', '2012', '521', '516', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301885', '220', '475', '2012', '570', '565', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301912', '343', '475', '2013', '641', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301928', '5', '475', '2013', '570', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301936', '113', '475', '2013', '571', '568', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301946', '85', '475', '2013', '629', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301954', '445', '475', '2013', '608', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301961', '151', '475', '2013', '598', '579', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301971', '233', '475', '2013', '575', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301984', '118', '475', '2013', '580', '579', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('301997', '292', '475', '2013', '586', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('302007', '10', '475', '2013', '575', '575', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('302018', '17', '475', '2013', '602', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('302025', '97', '475', '2013', '591', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('304753', '164', '475', '2010', '473', '473', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('304768', '164', '475', '2011', '468', '468', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('304860', '343', '475', '2010', '478', '478', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('304863', '343', '475', '2011', '484', '469', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('304867', '343', '475', '2012', '439', '436', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('304869', '29', '475', '2012', '445', '432', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('304871', '343', '475', '2013', '448', '444', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('306923', '22', '479', '2010', '641', '614', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('306930', '549', '479', '2010', '627', '616', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('306932', '10', '479', '2010', '616', '609', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('306936', '5', '479', '2010', '633', '606', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('306939', '8', '479', '2010', '615', '607', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('306944', '12', '479', '2010', '609', '606', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('306949', '159', '479', '2010', '626', '617', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('306953', '21', '479', '2010', '622', '619', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('307252', '159', '479', '2010', '641', '641', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('307254', '5', '479', '2010', '646', '633', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('307256', '8', '479', '2010', '636', '629', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('307259', '10', '479', '2010', '639', '628', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('307262', '21', '479', '2010', '656', '643', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('307264', '549', '479', '2010', '660', '646', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('307696', '8', '458', '2010', '520', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('307698', '78', '458', '2010', '514', '514', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('307700', '10', '458', '2010', '514', '514', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('307702', '24', '458', '2010', '509', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('307726', '24', '458', '2011', '524', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('307729', '10', '458', '2011', '523', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('307732', '8', '458', '2011', '526', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('307752', '8', '458', '2012', '566', '565', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('307756', '10', '458', '2012', '566', '565', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('307761', '3', '458', '2012', '571', '570', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('307767', '24', '458', '2012', '564', '564', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('308114', '127', '458', '2010', '513', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308122', '143', '458', '2010', '512', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308129', '132', '458', '2010', '528', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308137', '99', '458', '2010', '517', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308143', '101', '458', '2010', '514', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308148', '80', '458', '2010', '515', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308156', '113', '458', '2010', '521', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308160', '8', '458', '2010', '516', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308164', '36', '458', '2010', '511', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308169', '3', '458', '2010', '525', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308205', '127', '458', '2011', '529', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308209', '36', '458', '2011', '527', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308213', '38', '458', '2011', '528', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308216', '85', '458', '2011', '526', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308221', '101', '458', '2011', '537', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308225', '141', '458', '2011', '534', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308229', '99', '458', '2011', '531', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308247', '141', '458', '2012', '546', '545', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308250', '132', '458', '2012', '550', '547', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308252', '127', '458', '2012', '584', '554', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308254', '79', '458', '2012', '538', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308256', '99', '458', '2012', '545', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308258', '85', '458', '2012', '539', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('308260', '38', '458', '2012', '542', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('309753', '549', '479', '2010', '538', '538', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('309756', '5', '479', '2010', '527', '527', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('309759', '12', '479', '2010', '526', '526', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('309763', '159', '479', '2010', '534', '531', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('309864', '549', '479', '2010', '542', '542', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('309868', '8', '479', '2010', '546', '538', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('309872', '10', '479', '2010', '532', '531', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('312653', '10', '475', '2010', '542', '542', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('312655', '164', '475', '2010', '548', '546', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('312670', '10', '475', '2011', '560', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('312672', '164', '475', '2011', '566', '564', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('312685', '10', '475', '2012', '596', '593', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('312688', '164', '475', '2012', '592', '582', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('312795', '220', '475', '2010', '548', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312798', '118', '475', '2010', '546', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312800', '292', '475', '2010', '551', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312803', '29', '475', '2010', '548', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312805', '805', '475', '2010', '545', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312806', '382', '475', '2010', '548', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312807', '232', '475', '2010', '567', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312808', '343', '475', '2010', '565', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312809', '129', '475', '2010', '557', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312810', '113', '475', '2010', '552', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312812', '37', '475', '2010', '549', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312813', '207', '475', '2010', '556', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312816', '233', '475', '2010', '548', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312821', '164', '475', '2010', '550', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312825', '317', '475', '2010', '549', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312828', '83', '475', '2010', '549', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312830', '380', '475', '2010', '562', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312833', '151', '475', '2010', '547', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312835', '271', '475', '2010', '568', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312846', '164', '475', '2011', '566', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312847', '129', '475', '2011', '577', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312848', '151', '475', '2011', '566', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312850', '83', '475', '2011', '566', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312852', '292', '475', '2011', '567', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312855', '805', '475', '2011', '563', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312859', '220', '475', '2011', '565', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312864', '118', '475', '2011', '563', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312867', '317', '475', '2011', '566', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312870', '37', '475', '2011', '574', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312872', '29', '475', '2011', '567', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312875', '232', '475', '2011', '585', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312877', '207', '475', '2011', '569', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312878', '382', '475', '2011', '570', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312879', '233', '475', '2011', '563', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312880', '38', '475', '2011', '566', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312882', '113', '475', '2011', '568', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312884', '343', '475', '2011', '575', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312885', '271', '475', '2011', '569', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312886', '380', '475', '2011', '569', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312897', '343', '475', '2012', '593', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312900', '244', '475', '2012', '588', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312903', '805', '475', '2012', '583', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312905', '271', '475', '2012', '586', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312906', '83', '475', '2012', '589', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312908', '37', '475', '2012', '588', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312910', '232', '475', '2012', '593', '590', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312912', '38', '475', '2012', '586', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312913', '380', '475', '2012', '594', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312914', '372', '475', '2012', '586', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312915', '220', '475', '2012', '583', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312916', '317', '475', '2012', '586', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312918', '29', '475', '2012', '582', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312921', '382', '475', '2012', '588', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312924', '151', '475', '2012', '586', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312928', '129', '475', '2012', '590', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312933', '113', '475', '2012', '586', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312937', '233', '475', '2012', '586', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312942', '118', '475', '2012', '584', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312948', '164', '475', '2012', '587', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('312953', '207', '475', '2012', '595', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('315332', '12', '479', '2010', '568', '568', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('315334', '10', '479', '2010', '581', '581', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('315337', '549', '479', '2010', '583', '583', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('315417', '8', '479', '2010', '610', '610', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('315419', '5', '479', '2010', '609', '609', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('316032', '69', '510', '2010', '523', '501', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('316033', '10', '510', '2010', '522', '495', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('316050', '10', '510', '2011', '544', '503', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('316052', '69', '510', '2011', '530', '502', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('316066', '69', '510', '2012', '504', '485', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('316069', '10', '510', '2012', '496', '462', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('316078', '8', '511', '2010', '612', '598', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('316080', '18', '511', '2010', '633', '590', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('316083', '5', '511', '2010', '596', '569', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('316084', '69', '510', '2013', '571', '535', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('316087', '43', '511', '2010', '586', '556', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('316088', '8', '510', '2013', '532', '508', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('316090', '15', '511', '2010', '572', '551', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('316092', '22', '511', '2010', '577', '573', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('316094', '10', '511', '2010', '604', '574', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('316096', '67', '511', '2010', '601', '581', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('316098', '12', '511', '2010', '606', '569', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('316229', '67', '511', '2010', '619', '612', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('316230', '8', '511', '2010', '633', '618', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('316231', '18', '511', '2010', '616', '609', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('316233', '79', '511', '2010', '625', '600', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('316237', '22', '511', '2010', '613', '600', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('316241', '5', '511', '2010', '598', '594', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('316246', '12', '511', '2010', '615', '592', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('316252', '10', '511', '2010', '614', '601', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('316302', '8', '483', '2010', '475', '475', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('316303', '84', '510', '2010', '487', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316305', '2', '483', '2010', '466', '465', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('316306', '2', '510', '2010', '501', '461', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316307', '11', '483', '2010', '466', '466', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('316308', '78', '510', '2010', '534', '473', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316310', '161', '510', '2010', '556', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316315', '141', '510', '2010', '541', '463', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316319', '10', '510', '2010', '524', '475', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316323', '79', '510', '2010', '497', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316327', '63', '483', '2011', '475', '475', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('316328', '8', '510', '2010', '492', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316330', '12', '483', '2011', '475', '475', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('316332', '329', '510', '2010', '570', '479', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316334', '8', '483', '2011', '488', '488', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('316336', '68', '510', '2010', '545', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316339', '69', '510', '2010', '500', '475', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316342', '3', '510', '2010', '494', '475', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316354', '13', '483', '2012', '494', '494', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('316357', '8', '483', '2012', '498', '498', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('316363', '69', '510', '2011', '474', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316364', '63', '483', '2012', '527', '507', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('316370', '84', '510', '2011', '481', '461', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316371', '12', '483', '2012', '503', '503', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('316375', '2', '510', '2011', '465', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316379', '141', '510', '2011', '560', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316381', '329', '510', '2011', '545', '469', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316384', '79', '510', '2011', '477', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316387', '10', '510', '2011', '472', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316390', '3', '510', '2011', '483', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316392', '68', '510', '2011', '528', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316395', '8', '510', '2011', '482', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316398', '161', '510', '2011', '505', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316401', '36', '510', '2011', '454', '444', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316404', '78', '510', '2011', '470', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316407', '37', '510', '2011', '463', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316468', '78', '510', '2012', '473', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316471', '10', '510', '2012', '576', '456', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316476', '68', '510', '2012', '550', '465', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316481', '84', '510', '2012', '472', '464', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316485', '69', '510', '2012', '578', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316489', '141', '510', '2012', '463', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316492', '329', '510', '2012', '553', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316496', '161', '510', '2012', '476', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316500', '79', '510', '2012', '462', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316504', '2', '510', '2012', '482', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316507', '36', '510', '2012', '464', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316510', '3', '510', '2012', '479', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316513', '37', '510', '2012', '459', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316515', '8', '510', '2012', '498', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316547', '8', '510', '2013', '547', '528', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316548', '143', '483', '2011', '455', '453', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('316551', '141', '510', '2013', '544', '528', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316552', '36', '483', '2011', '455', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('316555', '161', '510', '2013', '546', '538', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316556', '8', '483', '2011', '458', '458', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('316559', '69', '510', '2013', '549', '529', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('316560', '38', '483', '2011', '461', '461', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('316562', '2', '483', '2011', '460', '457', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('316584', '8', '483', '2012', '466', '466', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('316585', '148', '483', '2012', '465', '465', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('316587', '2', '483', '2012', '473', '470', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('317802', '27', '514', '2010', '674', '647', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317805', '157', '514', '2010', '653', '641', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317807', '86', '514', '2010', '608', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317811', '241', '514', '2010', '636', '601', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('317816', '155', '514', '2010', '616', '583', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('317821', '228', '514', '2010', '650', '639', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317826', '71', '514', '2010', '640', '627', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317831', '28', '514', '2010', '639', '627', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317845', '241', '514', '2011', '616', '587', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('317846', '27', '514', '2011', '689', '643', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317847', '71', '514', '2011', '647', '623', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317849', '157', '514', '2011', '655', '633', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317851', '28', '514', '2011', '636', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317852', '155', '514', '2011', '614', '574', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('317853', '86', '514', '2011', '610', '607', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317854', '228', '514', '2011', '649', '633', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317864', '228', '514', '2012', '663', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317867', '157', '514', '2012', '671', '643', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317870', '28', '514', '2012', '634', '624', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317873', '155', '514', '2012', '641', '603', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('317875', '27', '514', '2012', '668', '647', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317877', '86', '514', '2012', '611', '610', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317879', '71', '514', '2012', '641', '627', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317882', '241', '514', '2012', '641', '607', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('317901', '28', '514', '2013', '703', '684', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317904', '86', '514', '2013', '661', '656', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317905', '27', '514', '2013', '686', '681', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317907', '228', '514', '2013', '691', '677', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317910', '10', '514', '2013', '657', '653', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('317911', '157', '514', '2013', '679', '667', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('318572', '8', '511', '2010', '522', '505', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('318574', '22', '511', '2010', '510', '501', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('318576', '67', '511', '2010', '509', '487', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('318579', '10', '511', '2010', '505', '486', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('318583', '5', '511', '2010', '514', '486', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('318716', '79', '511', '2010', '522', '498', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('318720', '8', '511', '2010', '507', '502', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('318724', '67', '511', '2010', '486', '483', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('318727', '10', '511', '2010', '508', '496', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('320103', '139', '517', '2010', '581', '570', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('320107', '3751', '517', '2010', '626', '626', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('320128', '139', '517', '2011', '612', '577', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('320130', '2677', '517', '2011', '622', '611', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('320132', '23', '517', '2011', '566', '560', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('320133', '3751', '517', '2011', '578', '574', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('320136', '3751', '517', '2012', '573', '557', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('320140', '23', '517', '2012', '573', '572', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('320144', '139', '517', '2012', '560', '552', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('320149', '2677', '517', '2012', '552', '531', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('320210', '3751', '517', '2010', '571', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('320212', '139', '517', '2010', '622', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('320214', '23', '517', '2010', '589', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('320216', '2677', '517', '2010', '587', '587', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('320238', '139', '517', '2011', '573', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('320241', '38', '517', '2011', '623', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('320243', '23', '517', '2011', '576', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('320252', '8', '517', '2012', '553', '551', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('320255', '3752', '517', '2012', '609', '587', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('320257', '139', '517', '2012', '592', '591', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('320258', '38', '517', '2012', '616', '600', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('320260', '23', '517', '2012', '600', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321471', '24', '523', '2010', '590', '545', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321473', '21', '523', '2010', '590', '548', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321475', '58', '523', '2010', '587', '550', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321477', '450', '523', '2010', '573', '551', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321479', '63', '523', '2010', '625', '551', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321482', '12', '523', '2010', '572', '551', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321485', '18', '523', '2010', '579', '555', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321491', '159', '523', '2010', '613', '555', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321496', '10', '523', '2010', '607', '556', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321500', '13', '523', '2010', '631', '557', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321504', '357', '523', '2010', '600', '544', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321509', '23', '523', '2010', '578', '536', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321513', '78', '523', '2010', '566', '532', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321515', '8', '523', '2010', '597', '545', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321517', '5', '523', '2010', '571', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321540', '23', '523', '2011', '574', '548', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321545', '13', '523', '2011', '601', '535', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321549', '357', '523', '2011', '575', '534', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321550', '8', '523', '2011', '601', '556', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321551', '18', '523', '2011', '555', '529', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321552', '63', '523', '2011', '592', '551', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321553', '10', '523', '2011', '602', '552', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321554', '159', '523', '2011', '585', '562', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321555', '24', '523', '2011', '606', '552', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321556', '21', '523', '2011', '597', '558', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321558', '5', '523', '2011', '599', '545', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321560', '12', '523', '2011', '585', '574', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321562', '450', '523', '2011', '584', '544', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321565', '58', '523', '2011', '577', '546', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321569', '78', '523', '2011', '591', '535', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321582', '3751', '523', '2012', '538', '520', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321585', '24', '523', '2012', '575', '522', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321588', '339', '523', '2012', '542', '517', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321592', '58', '523', '2012', '557', '521', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321597', '374', '523', '2012', '525', '511', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321600', '159', '523', '2012', '572', '544', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321603', '12', '523', '2012', '552', '550', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321606', '8', '523', '2012', '578', '514', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321608', '78', '523', '2012', '508', '501', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321610', '5', '523', '2012', '549', '512', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321612', '10', '523', '2012', '607', '525', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321616', '18', '523', '2012', '503', '501', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321619', '63', '523', '2012', '528', '517', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321622', '21', '523', '2012', '570', '533', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321626', '23', '523', '2012', '539', '512', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321628', '357', '523', '2012', '545', '517', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321629', '450', '523', '2012', '554', '521', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321631', '13', '523', '2012', '523', '504', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321639', '339', '523', '2013', '610', '578', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321643', '5', '523', '2013', '567', '556', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321646', '21', '523', '2013', '623', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321648', '8', '523', '2013', '623', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321650', '159', '523', '2013', '634', '604', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321652', '12', '523', '2013', '625', '604', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321654', '58', '523', '2013', '623', '581', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321656', '3751', '523', '2013', '597', '577', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321658', '10', '523', '2013', '630', '579', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321659', '13', '523', '2013', '587', '563', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('321717', '12', '523', '2010', '584', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321718', '21', '523', '2010', '594', '573', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321719', '159', '523', '2010', '603', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321721', '8', '523', '2010', '612', '559', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321723', '5', '523', '2010', '598', '552', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321724', '23', '523', '2010', '602', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321725', '10', '523', '2010', '603', '545', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321727', '24', '523', '2010', '611', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321729', '357', '523', '2010', '610', '532', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321731', '58', '523', '2010', '544', '530', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321733', '450', '523', '2010', '563', '529', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321735', '78', '523', '2010', '600', '519', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321738', '13', '523', '2010', '535', '516', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321742', '63', '523', '2010', '572', '553', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321745', '18', '523', '2010', '599', '527', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321760', '357', '523', '2011', '588', '515', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321762', '21', '523', '2011', '595', '533', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321764', '13', '523', '2011', '573', '539', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321766', '450', '523', '2011', '574', '510', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321768', '5', '523', '2011', '565', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321769', '24', '523', '2011', '642', '513', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321770', '63', '523', '2011', '595', '527', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321771', '10', '523', '2011', '618', '529', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321772', '159', '523', '2011', '600', '549', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321774', '23', '523', '2011', '581', '525', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321776', '8', '523', '2011', '633', '524', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321778', '18', '523', '2011', '573', '538', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321781', '58', '523', '2011', '589', '520', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321786', '12', '523', '2011', '551', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321789', '78', '523', '2011', '598', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321821', '374', '523', '2012', '566', '507', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321824', '24', '523', '2012', '590', '517', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321829', '58', '523', '2012', '535', '506', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321835', '357', '523', '2012', '580', '508', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321840', '13', '523', '2012', '525', '493', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321847', '23', '523', '2012', '545', '507', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321853', '159', '523', '2012', '605', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321858', '12', '523', '2012', '569', '555', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321864', '8', '523', '2012', '595', '530', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321868', '5', '523', '2012', '590', '498', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321872', '63', '523', '2012', '567', '513', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321875', '18', '523', '2012', '503', '494', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321881', '10', '523', '2012', '619', '527', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321885', '78', '523', '2012', '591', '494', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321889', '450', '523', '2012', '546', '502', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321893', '21', '523', '2012', '601', '533', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321896', '339', '523', '2012', '537', '524', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321908', '13', '523', '2013', '587', '556', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321910', '21', '523', '2013', '635', '583', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321911', '339', '523', '2013', '636', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321914', '5', '523', '2013', '624', '590', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321917', '10', '523', '2013', '661', '578', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321920', '8', '523', '2013', '643', '576', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321924', '3751', '523', '2013', '595', '570', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321927', '58', '523', '2013', '581', '560', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321930', '159', '523', '2013', '637', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('321935', '12', '523', '2013', '638', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('322957', '66', '16', '2013', '475', '449', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('322960', '16', '27', '2010', '665', '659', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('322961', '7', '27', '2010', '668', '668', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('322971', '56', '59', '2012', '584', '584', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('322981', '99', '68', '2012', '586', '545', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('322986', '10', '79', '2010', '570', '554', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('322987', '5', '79', '2010', '567', '557', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('323006', '17', '86', '2010', '635', '609', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('323007', '2', '86', '2010', '643', '611', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('323009', '38', '86', '2011', '640', '580', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('323028', '23', '110', '2010', '510', '492', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('323029', '63', '110', '2010', '491', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('323030', '52', '110', '2010', '486', '486', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('323031', '436', '110', '2010', '484', '483', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('323032', '69', '110', '2010', '493', '493', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('323046', '58', '115', '2010', '640', '637', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('323115', '11', '150', '2012', '570', '556', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('323116', '736', '150', '2012', '543', '543', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('323118', '735', '150', '2010', '535', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('323122', '126', '162', '2010', '484', '484', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('323188', '12', '175', '2012', '565', '548', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('323189', '56', '175', '2013', '626', '622', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('323190', '5', '175', '2013', '628', '617', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('323310', '24', '219', '2010', '512', '500', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('323315', '5', '219', '2010', '473', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('323432', '67', '234', '2010', '501', '494', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('323585', '48', '249', '2012', '497', '495', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('323666', '21', '259', '2010', '525', '525', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('323667', '8', '259', '2010', '520', '520', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('323674', '5', '255', '2010', '576', '520', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('323676', '141', '255', '2012', '536', '475', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('323677', '17', '255', '2012', '598', '537', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('323811', '203', '259', '2010', '493', '487', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('323813', '65', '259', '2010', '489', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('323815', '10', '259', '2010', '509', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('323817', '12', '259', '2010', '495', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('323819', '1229', '259', '2010', '494', '487', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('323821', '52', '259', '2010', '486', '484', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('323822', '20', '259', '2010', '492', '485', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('323823', '14', '259', '2010', '490', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('323837', '12', '259', '2012', '461', '452', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('323838', '52', '259', '2012', '464', '460', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('323839', '43', '259', '2012', '471', '456', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('323861', '390', '282', '2010', '479', '478', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('323862', '151', '282', '2010', '501', '496', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('323863', '113', '282', '2010', '491', '487', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('323971', '10', '297', '2012', '498', '494', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('323972', '12', '297', '2012', '483', '476', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('323973', '63', '297', '2012', '486', '476', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('323975', '10', '297', '2013', '590', '574', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('324103', '78', '306', '2010', '494', '484', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('324104', '12', '306', '2010', '491', '483', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('324119', '325', '306', '2010', '481', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('324122', '5', '306', '2011', '455', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('324123', '65', '306', '2011', '438', '438', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('324124', '325', '306', '2011', '455', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('324125', '17', '306', '2011', '485', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('324504', '69', '324', '2010', '490', '490', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('324505', '43', '324', '2010', '504', '504', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('324510', '8', '324', '2011', '491', '491', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('324511', '13', '324', '2011', '511', '511', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('324513', '65', '324', '2011', '502', '502', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('327179', '3606', '423', '2010', '568', '545', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('327180', '58', '423', '2010', '594', '569', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('327181', '52', '423', '2010', '550', '538', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('327182', '10', '423', '2010', '558', '538', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('327198', '1247', '423', '2010', '539', '513', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('327199', '3606', '423', '2010', '545', '510', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('327200', '52', '423', '2010', '529', '510', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('327201', '10', '423', '2010', '562', '547', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('327202', '541', '423', '2010', '580', '526', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('327203', '58', '423', '2010', '570', '560', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('327204', '56', '423', '2010', '515', '500', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('329641', '71', '514', '2010', '635', '633', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329642', '27', '514', '2010', '639', '636', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329643', '228', '514', '2010', '635', '635', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329644', '28', '514', '2010', '634', '632', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329645', '28', '514', '2011', '651', '651', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329646', '27', '514', '2011', '679', '663', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329647', '228', '514', '2011', '652', '652', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329648', '71', '514', '2011', '653', '652', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329649', '157', '514', '2011', '656', '656', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329650', '27', '514', '2012', '674', '668', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329651', '71', '514', '2012', '672', '669', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329652', '28', '514', '2012', '667', '666', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329653', '157', '514', '2012', '669', '669', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329654', '228', '514', '2012', '668', '668', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329655', '10', '514', '2013', '651', '647', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329656', '86', '514', '2013', '652', '651', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329657', '27', '514', '2013', '658', '658', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329658', '228', '514', '2013', '656', '654', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329659', '28', '514', '2013', '662', '657', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('329660', '157', '514', '2013', '654', '654', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('330559', '12', '511', '2010', '564', '546', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('330560', '18', '511', '2010', '565', '553', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('330607', '79', '511', '2010', '573', '567', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('330609', '8', '511', '2010', '581', '572', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('333724', '60', '539', '2010', '512', '497', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('333726', '66', '539', '2010', '491', '487', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('333730', '60', '539', '2011', '514', '499', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('333731', '66', '539', '2011', '516', '503', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('333733', '52', '539', '2012', '456', '454', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('333734', '60', '539', '2012', '474', '469', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('333735', '66', '539', '2012', '481', '480', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('333738', '66', '539', '2013', '527', '523', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('333810', '91', '539', '2010', '485', '479', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('333817', '66', '539', '2010', '522', '522', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('333820', '71', '539', '2010', '493', '493', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('333825', '72', '539', '2010', '447', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('333835', '66', '539', '2011', '465', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('333836', '72', '539', '2011', '478', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('333837', '71', '539', '2011', '478', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('333840', '75', '539', '2011', '443', '441', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('333848', '75', '539', '2012', '435', '435', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('333850', '72', '539', '2012', '444', '444', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344466', '67', '581', '2010', '520', '488', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344467', '203', '581', '2010', '512', '492', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344468', '69', '581', '2010', '518', '496', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344469', '59', '581', '2010', '549', '505', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344470', '10', '581', '2010', '517', '492', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344471', '10', '581', '2011', '523', '505', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344472', '59', '581', '2011', '576', '518', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344473', '67', '581', '2011', '535', '508', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344474', '203', '581', '2011', '513', '503', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344475', '2', '581', '2011', '514', '502', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344476', '69', '581', '2011', '514', '504', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344477', '67', '581', '2012', '490', '472', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344478', '59', '581', '2012', '520', '485', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344479', '69', '581', '2012', '490', '476', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344481', '10', '581', '2012', '493', '481', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344483', '2', '581', '2012', '476', '467', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344485', '203', '581', '2012', '491', '469', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344488', '69', '581', '2013', '561', '534', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344489', '67', '581', '2013', '564', '551', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('344640', '2', '581', '2010', '493', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344641', '10', '581', '2010', '492', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344642', '92', '581', '2010', '506', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344643', '67', '581', '2010', '485', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344644', '59', '581', '2010', '521', '493', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344647', '141', '581', '2010', '491', '479', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344648', '69', '581', '2010', '493', '479', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344649', '246', '581', '2010', '509', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344651', '203', '581', '2010', '476', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344653', '381', '581', '2010', '496', '461', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344655', '116', '581', '2010', '540', '465', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344660', '68', '581', '2010', '492', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344662', '94', '581', '2010', '491', '466', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344672', '246', '581', '2011', '484', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344675', '94', '581', '2011', '464', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344678', '67', '581', '2011', '497', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344681', '10', '581', '2011', '477', '467', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344683', '381', '581', '2011', '476', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344685', '2', '581', '2011', '477', '458', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344687', '69', '581', '2011', '480', '465', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344689', '59', '581', '2011', '498', '476', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344691', '116', '581', '2011', '483', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344692', '141', '581', '2011', '463', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344693', '203', '581', '2011', '472', '460', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344694', '68', '581', '2011', '484', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344695', '79', '581', '2011', '457', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344699', '69', '581', '2012', '474', '461', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344700', '141', '581', '2012', '471', '465', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344701', '94', '581', '2012', '467', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344702', '59', '581', '2012', '487', '468', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344705', '67', '581', '2012', '473', '450', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344707', '10', '581', '2012', '465', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344708', '68', '581', '2012', '566', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344709', '116', '581', '2012', '471', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344710', '79', '581', '2012', '459', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344711', '381', '581', '2012', '480', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344712', '203', '581', '2012', '500', '461', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344713', '2', '581', '2012', '481', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344714', '246', '581', '2012', '573', '452', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344716', '141', '581', '2013', '523', '517', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344718', '67', '581', '2013', '567', '561', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344720', '92', '581', '2013', '551', '535', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344721', '69', '581', '2013', '551', '535', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('344722', '246', '581', '2013', '549', '521', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('347473', '10', '586', '2010', '433', '417', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347477', '58', '586', '2010', '433', '417', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347480', '23', '586', '2010', '426', '418', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347483', '146', '586', '2010', '425', '416', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347486', '43', '586', '2010', '428', '418', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347488', '5', '586', '2010', '435', '420', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347491', '3', '586', '2010', '433', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347494', '24', '586', '2010', '449', '422', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347497', '21', '586', '2010', '433', '422', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347500', '12', '586', '2010', '436', '419', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347503', '8', '586', '2010', '433', '419', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347506', '136', '586', '2010', '427', '417', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347509', '78', '586', '2010', '429', '418', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347523', '5', '586', '2011', '435', '426', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347524', '3', '586', '2011', '436', '424', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347525', '8', '586', '2011', '440', '426', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347526', '43', '586', '2011', '437', '422', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347528', '23', '586', '2011', '436', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347530', '10', '586', '2011', '435', '422', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347532', '24', '586', '2011', '436', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347536', '146', '586', '2011', '436', '425', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347539', '21', '586', '2011', '445', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347542', '78', '586', '2011', '433', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347545', '58', '586', '2011', '441', '421', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347548', '12', '586', '2011', '432', '422', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347551', '86', '586', '2011', '433', '420', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347554', '136', '586', '2011', '435', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347558', '44', '586', '2011', '434', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347561', '374', '586', '2011', '435', '425', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347578', '43', '586', '2012', '409', '400', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347580', '58', '586', '2012', '414', '396', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347582', '86', '586', '2012', '407', '393', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347584', '374', '586', '2012', '409', '396', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347586', '8', '586', '2012', '416', '404', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347588', '10', '586', '2012', '413', '398', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347590', '5', '586', '2012', '404', '396', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347592', '23', '586', '2012', '413', '401', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347594', '3', '586', '2012', '413', '405', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347596', '21', '586', '2012', '429', '401', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347598', '24', '586', '2012', '410', '396', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347602', '44', '586', '2012', '414', '400', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347604', '12', '586', '2012', '413', '398', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347606', '136', '586', '2012', '408', '396', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347608', '146', '586', '2012', '411', '397', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347610', '78', '586', '2012', '407', '398', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347619', '10', '586', '2013', '435', '416', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347623', '8', '586', '2013', '433', '420', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347626', '44', '586', '2013', '430', '419', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347628', '21', '586', '2013', '427', '418', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347630', '58', '586', '2013', '435', '417', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347633', '12', '586', '2013', '431', '417', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347635', '5', '586', '2013', '425', '416', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347637', '86', '586', '2013', '430', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('347824', '24', '586', '2010', '421', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347826', '5', '586', '2010', '421', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347828', '3', '586', '2010', '449', '414', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347830', '8', '586', '2010', '448', '415', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347832', '136', '586', '2010', '417', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347834', '21', '586', '2010', '446', '413', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347836', '78', '586', '2010', '416', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347838', '12', '586', '2010', '426', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347840', '10', '586', '2010', '427', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347841', '43', '586', '2010', '426', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347842', '89', '586', '2010', '420', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347843', '23', '586', '2010', '421', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347844', '38', '586', '2010', '424', '411', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347845', '58', '586', '2010', '432', '412', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347846', '79', '586', '2010', '416', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347847', '146', '586', '2010', '424', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347858', '86', '586', '2011', '419', '405', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347860', '5', '586', '2011', '414', '405', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347863', '24', '586', '2011', '414', '405', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347867', '89', '586', '2011', '427', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347870', '23', '586', '2011', '422', '406', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347873', '10', '586', '2011', '418', '406', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347875', '146', '586', '2011', '414', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347876', '3', '586', '2011', '428', '407', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347877', '78', '586', '2011', '423', '404', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347879', '38', '586', '2011', '434', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347881', '43', '586', '2011', '422', '404', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347883', '44', '586', '2011', '428', '407', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347888', '12', '586', '2011', '424', '404', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347891', '8', '586', '2011', '429', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347893', '79', '586', '2011', '429', '404', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347895', '136', '586', '2011', '414', '406', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347896', '21', '586', '2011', '435', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347898', '58', '586', '2011', '415', '404', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347900', '374', '586', '2011', '412', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347913', '43', '586', '2012', '376', '361', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347915', '374', '586', '2012', '383', '367', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347917', '5', '586', '2012', '374', '363', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347919', '79', '586', '2012', '379', '360', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347921', '136', '586', '2012', '376', '367', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347923', '86', '586', '2012', '379', '362', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347925', '38', '586', '2012', '378', '360', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347927', '58', '586', '2012', '383', '366', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347929', '24', '586', '2012', '377', '366', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347931', '10', '586', '2012', '382', '366', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347933', '89', '586', '2012', '376', '365', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347935', '21', '586', '2012', '390', '373', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347937', '3', '586', '2012', '397', '378', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347939', '8', '586', '2012', '411', '377', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347941', '23', '586', '2012', '376', '365', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347943', '78', '586', '2012', '387', '370', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347945', '146', '586', '2012', '382', '367', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347947', '12', '586', '2012', '377', '365', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347949', '44', '586', '2012', '376', '367', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('347957', '10', '586', '2013', '367', '356', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('347959', '58', '586', '2013', '382', '361', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('347961', '21', '586', '2013', '379', '361', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('347963', '5', '586', '2013', '362', '352', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('347965', '86', '586', '2013', '368', '352', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('347968', '44', '586', '2013', '358', '357', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('347971', '8', '586', '2013', '384', '359', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('348102', '10', '581', '2010', '508', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('348109', '10', '581', '2011', '527', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('348115', '67', '581', '2012', '540', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('348118', '10', '581', '2012', '557', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('348187', '381', '581', '2010', '514', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348189', '164', '581', '2010', '513', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348191', '246', '581', '2010', '517', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348192', '116', '581', '2010', '510', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348193', '94', '581', '2010', '513', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348198', '79', '581', '2011', '522', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348200', '246', '581', '2011', '533', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348202', '94', '581', '2011', '542', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348204', '2', '581', '2011', '527', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348207', '381', '581', '2011', '537', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348210', '116', '581', '2011', '527', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348216', '2', '581', '2012', '536', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348218', '79', '581', '2012', '546', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348222', '381', '581', '2012', '543', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348225', '246', '581', '2012', '543', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348227', '94', '581', '2012', '544', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('348229', '116', '581', '2012', '537', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('350404', '155', '598', '2010', '616', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('350406', '157', '598', '2010', '630', '630', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('350408', '28', '598', '2010', '604', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('350410', '227', '598', '2010', '616', '616', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('350413', '27', '598', '2010', '674', '632', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('350417', '27', '598', '2011', '625', '604', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('350418', '157', '598', '2011', '620', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('350419', '28', '598', '2011', '551', '551', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('350428', '27', '598', '2012', '663', '620', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('350430', '28', '598', '2013', '684', '664', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('350432', '157', '598', '2013', '660', '660', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('350481', '24', '586', '2011', '442', '442', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('350483', '374', '586', '2011', '459', '459', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('350485', '12', '586', '2011', '444', '444', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('350487', '8', '586', '2011', '496', '464', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('350496', '24', '586', '2012', '502', '482', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('350497', '374', '586', '2012', '494', '476', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('350498', '5', '586', '2012', '494', '494', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('350500', '12', '586', '2012', '473', '473', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('350502', '23', '586', '2012', '512', '486', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('350504', '58', '586', '2013', '464', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('350505', '10', '586', '2013', '471', '465', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('350507', '12', '586', '2013', '469', '469', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('350509', '86', '586', '2013', '462', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('350515', '21', '586', '2011', '462', '429', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('350517', '8', '586', '2012', '401', '401', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('350518', '3', '586', '2012', '428', '428', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('350519', '58', '586', '2012', '421', '412', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('350520', '21', '586', '2012', '447', '425', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('350521', '24', '586', '2012', '409', '394', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('350522', '374', '586', '2012', '425', '408', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('350523', '89', '586', '2012', '410', '399', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('350524', '10', '586', '2012', '465', '465', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('350526', '38', '586', '2012', '462', '435', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('351038', '86', '598', '2010', '509', '484', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('351059', '86', '598', '2013', '482', '482', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('351129', '28', '598', '2010', '516', '503', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351130', '86', '598', '2010', '487', '475', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('351131', '227', '598', '2010', '505', '495', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351132', '155', '598', '2010', '504', '498', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351133', '27', '598', '2010', '536', '509', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351135', '157', '598', '2010', '519', '510', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351147', '28', '598', '2011', '526', '514', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351149', '227', '598', '2011', '517', '513', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351151', '155', '598', '2011', '523', '510', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351152', '157', '598', '2011', '545', '523', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351154', '27', '598', '2011', '548', '519', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351163', '28', '598', '2012', '479', '476', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351165', '157', '598', '2012', '517', '483', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351167', '155', '598', '2012', '484', '476', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351170', '27', '598', '2012', '522', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351172', '227', '598', '2012', '487', '478', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351177', '27', '598', '2013', '491', '474', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351179', '157', '598', '2013', '483', '469', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('351182', '28', '598', '2013', '523', '480', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('353181', '89', '613', '2010', '469', '455', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('353182', '23', '613', '2010', '466', '456', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('353184', '10', '613', '2010', '468', '456', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('353191', '23', '613', '2011', '474', '467', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('353194', '89', '613', '2011', '474', '462', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('353197', '10', '613', '2011', '475', '460', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('353210', '89', '613', '2012', '442', '424', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('353216', '23', '613', '2012', '443', '429', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('353218', '52', '613', '2012', '445', '429', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('353220', '78', '613', '2012', '457', '426', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('353222', '10', '613', '2012', '437', '429', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('353228', '10', '613', '2013', '491', '466', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('353293', '92', '613', '2011', '426', '411', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353295', '37', '613', '2011', '451', '409', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353297', '89', '613', '2011', '429', '419', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353299', '10', '613', '2011', '424', '413', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353301', '23', '613', '2011', '430', '417', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353303', '143', '613', '2011', '433', '416', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353305', '90', '613', '2011', '446', '410', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353307', '90', '613', '2012', '432', '416', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353309', '143', '613', '2012', '431', '418', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353311', '23', '613', '2012', '425', '413', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353314', '30', '613', '2012', '430', '406', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353316', '10', '613', '2012', '431', '421', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353318', '37', '613', '2012', '432', '414', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353320', '123', '613', '2012', '431', '409', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353322', '38', '613', '2012', '432', '413', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353324', '94', '613', '2012', '431', '414', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353325', '92', '613', '2012', '440', '416', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353326', '89', '613', '2012', '429', '418', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('353763', '92', '613', '2013', '356', '356', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('354469', '2', '615', '2010', '431', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354470', '8', '615', '2010', '432', '420', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354471', '343', '615', '2010', '428', '413', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354472', '58', '615', '2010', '424', '409', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354473', '67', '615', '2010', '427', '409', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354475', '69', '615', '2010', '442', '409', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354477', '89', '615', '2010', '421', '408', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354479', '24', '615', '2010', '425', '412', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354480', '120', '615', '2010', '429', '412', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354481', '10', '615', '2010', '439', '411', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354482', '12', '615', '2010', '432', '410', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354488', '67', '615', '2011', '433', '418', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354490', '10', '615', '2011', '427', '417', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354492', '24', '615', '2011', '430', '422', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354494', '69', '615', '2011', '436', '419', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354496', '120', '615', '2011', '434', '420', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354497', '58', '615', '2011', '439', '418', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354500', '12', '615', '2011', '442', '422', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354501', '3', '615', '2011', '431', '425', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354505', '343', '615', '2011', '435', '426', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354507', '89', '615', '2011', '432', '421', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354509', '8', '615', '2011', '442', '429', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354510', '2', '615', '2011', '432', '427', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354516', '89', '615', '2012', '411', '393', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354517', '120', '615', '2012', '409', '392', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354518', '343', '615', '2012', '409', '403', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354519', '24', '615', '2012', '404', '391', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354520', '3', '615', '2012', '414', '399', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354521', '2', '615', '2012', '419', '395', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354523', '69', '615', '2012', '413', '391', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354525', '67', '615', '2012', '405', '386', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354529', '58', '615', '2012', '413', '390', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354533', '12', '615', '2012', '409', '387', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354536', '8', '615', '2012', '415', '403', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354538', '10', '615', '2012', '406', '393', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354547', '343', '615', '2013', '434', '425', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354550', '8', '615', '2013', '430', '425', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354553', '10', '615', '2013', '426', '416', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354555', '69', '615', '2013', '427', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354559', '58', '615', '2013', '425', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354562', '12', '615', '2013', '423', '412', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('354739', '24', '615', '2010', '424', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354742', '12', '615', '2010', '456', '411', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354745', '2', '615', '2010', '438', '411', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354748', '58', '615', '2010', '427', '412', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354751', '67', '615', '2010', '424', '413', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354753', '38', '615', '2010', '427', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354756', '123', '615', '2010', '416', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354759', '343', '615', '2010', '437', '413', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354762', '89', '615', '2010', '444', '413', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354765', '120', '615', '2010', '429', '414', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354768', '8', '615', '2010', '425', '415', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354770', '10', '615', '2010', '449', '417', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354773', '146', '615', '2010', '434', '411', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354775', '325', '615', '2010', '426', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354777', '69', '615', '2010', '416', '407', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354780', '202', '615', '2010', '416', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354782', '147', '615', '2010', '441', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354798', '211', '615', '2011', '413', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354800', '10', '615', '2011', '408', '399', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354802', '24', '615', '2011', '414', '404', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354804', '67', '615', '2011', '411', '404', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354806', '343', '615', '2011', '420', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354808', '147', '615', '2011', '418', '400', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354810', '38', '615', '2011', '417', '401', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354812', '89', '615', '2011', '422', '406', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354814', '202', '615', '2011', '412', '399', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354815', '2', '615', '2011', '431', '401', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354816', '8', '615', '2011', '424', '413', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354817', '146', '615', '2011', '423', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354818', '69', '615', '2011', '417', '404', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354819', '12', '615', '2011', '410', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354821', '58', '615', '2011', '430', '406', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354823', '123', '615', '2011', '409', '399', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354825', '325', '615', '2011', '421', '401', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354827', '120', '615', '2011', '423', '405', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354829', '3', '615', '2011', '425', '411', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354837', '202', '615', '2012', '378', '361', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354839', '89', '615', '2012', '375', '364', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354841', '211', '615', '2012', '375', '364', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354842', '147', '615', '2012', '377', '367', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354843', '146', '615', '2012', '378', '368', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354844', '343', '615', '2012', '408', '376', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354845', '38', '615', '2012', '390', '368', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354846', '24', '615', '2012', '373', '369', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354848', '3', '615', '2012', '382', '375', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354850', '123', '615', '2012', '374', '361', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354852', '2', '615', '2012', '393', '372', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354854', '325', '615', '2012', '376', '364', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354856', '120', '615', '2012', '388', '366', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354858', '8', '615', '2012', '394', '380', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354859', '205', '615', '2012', '389', '366', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354860', '69', '615', '2012', '374', '367', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354861', '12', '615', '2012', '374', '365', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354862', '58', '615', '2012', '377', '366', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354863', '67', '615', '2012', '378', '363', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354864', '10', '615', '2012', '379', '369', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('354873', '69', '615', '2013', '359', '352', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('354874', '343', '615', '2013', '359', '352', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('354875', '10', '615', '2013', '360', '354', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('354876', '58', '615', '2013', '367', '356', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('354877', '12', '615', '2013', '358', '349', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('354878', '8', '615', '2013', '386', '367', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('358038', '24', '627', '2012', '495', '479', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('358043', '3', '627', '2012', '501', '478', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('358052', '2', '627', '2012', '494', '477', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('358056', '78', '627', '2012', '494', '460', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('358066', '357', '627', '2012', '502', '473', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('358072', '65', '627', '2012', '473', '459', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('358079', '8', '627', '2012', '497', '467', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('358084', '5', '627', '2012', '490', '462', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('358094', '528', '627', '2012', '492', '472', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('358102', '181', '627', '2012', '520', '469', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('358111', '65', '627', '2013', '537', '513', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('358118', '5', '627', '2013', '546', '513', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('358127', '8', '627', '2013', '575', '522', '1', '2', '34');
INSERT INTO `major_recruit` VALUES ('358172', '8', '627', '2011', '523', '502', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358175', '3', '627', '2011', '522', '506', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358177', '2', '627', '2011', '520', '498', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358181', '181', '627', '2011', '523', '504', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358183', '78', '627', '2011', '508', '492', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358192', '78', '627', '2012', '447', '441', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358196', '3', '627', '2012', '487', '471', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358201', '355', '627', '2012', '470', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358206', '388', '627', '2012', '468', '448', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358211', '24', '627', '2012', '467', '457', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358216', '184', '627', '2012', '509', '455', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358221', '395', '627', '2012', '481', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358228', '269', '627', '2012', '489', '459', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358233', '79', '627', '2012', '492', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358237', '38', '627', '2012', '464', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358245', '347', '627', '2012', '550', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358251', '2', '627', '2012', '474', '465', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358256', '95', '627', '2012', '483', '454', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358263', '222', '627', '2012', '474', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358269', '8', '627', '2012', '476', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358273', '40', '627', '2012', '481', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358276', '794', '627', '2012', '479', '474', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358281', '87', '627', '2012', '497', '453', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358287', '5', '627', '2012', '471', '446', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358295', '181', '627', '2012', '474', '449', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358302', '528', '627', '2012', '456', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358312', '226', '627', '2012', '484', '462', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358314', '381', '627', '2012', '466', '447', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358322', '65', '627', '2012', '463', '451', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358338', '388', '627', '2013', '548', '531', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358340', '8', '627', '2013', '568', '529', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358350', '222', '627', '2013', '580', '526', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358354', '226', '627', '2013', '564', '528', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358361', '95', '627', '2013', '592', '525', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358373', '355', '627', '2013', '535', '524', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358379', '794', '627', '2013', '559', '521', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358381', '5', '627', '2013', '542', '521', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358392', '347', '627', '2013', '542', '521', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358396', '40', '627', '2013', '539', '521', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358398', '65', '627', '2013', '535', '518', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358400', '87', '627', '2013', '580', '526', '2', '2', '34');
INSERT INTO `major_recruit` VALUES ('358547', '40', '627', '2011', '478', '451', '5', '2', '34');
INSERT INTO `major_recruit` VALUES ('358548', '2', '627', '2011', '474', '465', '5', '2', '34');
INSERT INTO `major_recruit` VALUES ('358553', '269', '627', '2011', '538', '467', '5', '2', '34');
INSERT INTO `major_recruit` VALUES ('358557', '3', '627', '2011', '483', '472', '5', '2', '34');
INSERT INTO `major_recruit` VALUES ('358562', '184', '627', '2011', '528', '456', '5', '2', '34');
INSERT INTO `major_recruit` VALUES ('358566', '181', '627', '2011', '470', '455', '5', '2', '34');
INSERT INTO `major_recruit` VALUES ('358570', '8', '627', '2011', '492', '455', '5', '2', '34');
INSERT INTO `major_recruit` VALUES ('358574', '388', '627', '2011', '483', '454', '5', '2', '34');
INSERT INTO `major_recruit` VALUES ('358577', '395', '627', '2011', '483', '453', '5', '2', '34');
INSERT INTO `major_recruit` VALUES ('358579', '222', '627', '2011', '498', '453', '5', '2', '34');
INSERT INTO `major_recruit` VALUES ('358582', '78', '627', '2011', '481', '457', '5', '2', '34');
INSERT INTO `major_recruit` VALUES ('358983', '12', '615', '2010', '466', '456', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('358986', '10', '615', '2010', '472', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('358988', '343', '615', '2010', '483', '460', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('358990', '120', '615', '2010', '493', '454', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('358992', '67', '615', '2010', '467', '437', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('358996', '12', '615', '2011', '468', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('358998', '58', '615', '2011', '448', '442', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359000', '120', '615', '2011', '468', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359001', '24', '615', '2011', '460', '445', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359002', '69', '615', '2011', '479', '464', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359004', '89', '615', '2011', '502', '447', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359006', '67', '615', '2011', '453', '440', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359007', '10', '615', '2011', '466', '460', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359009', '2', '615', '2011', '483', '459', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359015', '67', '615', '2012', '469', '468', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359017', '12', '615', '2012', '516', '485', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359021', '69', '615', '2012', '486', '475', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359024', '58', '615', '2012', '514', '485', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359025', '2', '615', '2012', '516', '501', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359027', '10', '615', '2012', '513', '492', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359028', '120', '615', '2012', '514', '487', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359029', '89', '615', '2012', '512', '488', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359031', '24', '615', '2012', '490', '478', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('359076', '12', '615', '2011', '473', '434', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359077', '325', '615', '2011', '450', '426', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359079', '120', '615', '2011', '467', '430', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359081', '202', '615', '2011', '504', '441', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359083', '211', '615', '2011', '476', '432', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359085', '123', '615', '2011', '461', '426', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359086', '2', '615', '2011', '460', '437', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359088', '38', '615', '2011', '467', '429', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359091', '147', '615', '2011', '465', '452', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359093', '89', '615', '2011', '466', '434', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359095', '343', '615', '2011', '496', '435', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359097', '146', '615', '2011', '473', '433', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359100', '24', '615', '2011', '449', '419', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359102', '10', '615', '2011', '468', '454', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359111', '38', '615', '2012', '477', '436', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359113', '343', '615', '2012', '459', '441', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359114', '202', '615', '2012', '452', '425', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359115', '10', '615', '2012', '471', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359117', '123', '615', '2012', '466', '426', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359119', '12', '615', '2012', '461', '429', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359121', '120', '615', '2012', '472', '437', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359123', '147', '615', '2012', '474', '430', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359126', '24', '615', '2012', '477', '431', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359128', '211', '615', '2012', '497', '441', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359132', '2', '615', '2012', '483', '465', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359136', '89', '615', '2012', '452', '431', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359139', '146', '615', '2012', '460', '437', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('359141', '325', '615', '2012', '460', '425', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('377715', '44', '675', '2010', '444', '424', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377718', '21', '675', '2010', '445', '427', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377720', '24', '675', '2010', '421', '409', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377722', '8', '675', '2010', '442', '421', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377724', '22', '675', '2010', '444', '420', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377726', '514', '675', '2010', '422', '417', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377728', '61', '675', '2010', '453', '417', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377729', '3', '675', '2010', '431', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377732', '270', '675', '2010', '438', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377734', '10', '675', '2010', '434', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377736', '2', '675', '2010', '434', '414', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377737', '12', '675', '2010', '445', '414', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377738', '5', '675', '2010', '451', '414', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377740', '58', '675', '2010', '428', '413', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377742', '69', '675', '2010', '433', '414', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377751', '203', '675', '2011', '434', '420', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377753', '44', '675', '2011', '450', '431', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377755', '24', '675', '2011', '438', '421', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377758', '69', '675', '2011', '446', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377762', '61', '675', '2011', '431', '422', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377765', '428', '675', '2011', '433', '427', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377768', '5', '675', '2011', '433', '416', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377771', '21', '675', '2011', '444', '435', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377773', '22', '675', '2011', '439', '426', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377774', '2', '675', '2011', '439', '421', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377776', '58', '675', '2011', '431', '421', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377777', '12', '675', '2011', '429', '418', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377779', '3', '675', '2011', '439', '426', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377780', '8', '675', '2011', '435', '427', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377782', '270', '675', '2011', '426', '418', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377783', '10', '675', '2011', '441', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377790', '10', '675', '2012', '414', '404', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377791', '8', '675', '2012', '413', '405', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377792', '2', '675', '2012', '408', '403', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377793', '58', '675', '2012', '412', '403', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377794', '203', '675', '2012', '413', '402', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377795', '44', '675', '2012', '420', '413', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377796', '3', '675', '2012', '417', '406', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377798', '428', '675', '2012', '420', '412', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377799', '12', '675', '2012', '430', '406', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377800', '5', '675', '2012', '408', '402', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377801', '24', '675', '2012', '413', '402', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377802', '21', '675', '2012', '421', '408', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377804', '270', '675', '2012', '409', '404', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377805', '61', '675', '2012', '423', '412', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377806', '69', '675', '2012', '407', '404', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377807', '22', '675', '2012', '418', '409', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377808', '22', '675', '2013', '447', '428', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377809', '5', '675', '2013', '423', '416', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377810', '61', '675', '2013', '436', '429', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377811', '44', '675', '2013', '437', '427', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377813', '58', '675', '2013', '428', '421', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377815', '12', '675', '2013', '432', '421', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377816', '10', '675', '2013', '439', '420', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377817', '8', '675', '2013', '423', '420', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377818', '21', '675', '2013', '437', '419', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377819', '69', '675', '2013', '423', '416', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377821', '514', '675', '2013', '453', '429', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377823', '270', '675', '2013', '430', '420', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('377886', '10', '675', '2010', '437', '414', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377887', '61', '675', '2010', '442', '422', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377888', '8', '675', '2010', '452', '421', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377889', '44', '675', '2010', '437', '417', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377890', '21', '675', '2010', '442', '415', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377891', '270', '675', '2010', '429', '412', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377892', '514', '675', '2010', '416', '412', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377893', '3', '675', '2010', '435', '411', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377894', '58', '675', '2010', '457', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377895', '2', '675', '2010', '417', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377896', '22', '675', '2010', '445', '427', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377897', '24', '675', '2010', '413', '407', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377898', '69', '675', '2010', '415', '407', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377899', '5', '675', '2010', '451', '407', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377900', '12', '675', '2010', '436', '418', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377901', '44', '675', '2011', '437', '412', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377902', '12', '675', '2011', '451', '407', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377903', '3', '675', '2011', '430', '411', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377904', '2', '675', '2011', '423', '406', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377905', '61', '675', '2011', '428', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377906', '5', '675', '2011', '409', '400', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377907', '8', '675', '2011', '441', '417', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377908', '22', '675', '2011', '429', '418', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377909', '21', '675', '2011', '423', '413', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377910', '58', '675', '2011', '414', '401', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377911', '69', '675', '2011', '414', '400', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377912', '428', '675', '2011', '432', '415', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377913', '203', '675', '2011', '418', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377914', '270', '675', '2011', '410', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377915', '10', '675', '2011', '452', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377916', '24', '675', '2011', '414', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377917', '10', '675', '2012', '402', '372', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377918', '203', '675', '2012', '387', '362', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377919', '44', '675', '2012', '381', '372', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377920', '2', '675', '2012', '387', '369', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377921', '270', '675', '2012', '367', '361', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377922', '5', '675', '2012', '369', '361', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377923', '428', '675', '2012', '401', '381', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377924', '3', '675', '2012', '404', '371', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377925', '21', '675', '2012', '408', '377', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377926', '58', '675', '2012', '382', '364', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377927', '61', '675', '2012', '390', '372', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377928', '69', '675', '2012', '370', '362', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377929', '12', '675', '2012', '411', '371', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377930', '24', '675', '2012', '371', '361', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377931', '8', '675', '2012', '411', '382', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377932', '22', '675', '2012', '418', '385', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('377933', '514', '675', '2013', '375', '362', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('377934', '21', '675', '2013', '373', '362', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('377935', '61', '675', '2013', '371', '359', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('377936', '10', '675', '2013', '381', '358', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('377937', '58', '675', '2013', '364', '353', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('377938', '270', '675', '2013', '354', '352', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('377939', '12', '675', '2013', '358', '352', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('377940', '5', '675', '2013', '363', '352', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('377941', '22', '675', '2013', '375', '364', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('377942', '8', '675', '2013', '387', '365', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('377943', '69', '675', '2013', '356', '353', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('377944', '44', '675', '2013', '395', '361', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('378174', '43', '682', '2010', '534', '531', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('378175', '5', '682', '2010', '564', '560', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('378176', '10', '682', '2010', '533', '530', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('378177', '43', '682', '2011', '570', '563', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('378178', '5', '682', '2011', '551', '548', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('378179', '10', '682', '2011', '565', '551', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('378180', '10', '682', '2012', '544', '542', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('378181', '5', '682', '2012', '539', '536', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('378182', '43', '682', '2012', '557', '526', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('378183', '5', '682', '2013', '587', '571', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('378184', '10', '682', '2013', '574', '566', '1', '1', '34');
INSERT INTO `major_recruit` VALUES ('378360', '129', '682', '2010', '556', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378363', '94', '682', '2010', '564', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378366', '119', '682', '2010', '556', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378369', '150', '682', '2010', '538', '530', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378373', '101', '682', '2010', '530', '520', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378375', '83', '682', '2010', '540', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378377', '2', '682', '2010', '552', '538', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378380', '165', '682', '2010', '569', '541', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378382', '105', '682', '2010', '569', '553', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378384', '441', '682', '2010', '574', '552', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378386', '254', '682', '2010', '557', '548', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378389', '134', '682', '2010', '549', '547', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378392', '118', '682', '2010', '552', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378394', '233', '682', '2010', '548', '545', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378400', '83', '682', '2011', '518', '504', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378403', '134', '682', '2011', '533', '515', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378406', '441', '682', '2011', '515', '508', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378409', '38', '682', '2011', '561', '531', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378412', '94', '682', '2011', '552', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378415', '101', '682', '2011', '518', '510', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378418', '165', '682', '2011', '569', '546', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378421', '105', '682', '2011', '523', '520', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378424', '233', '682', '2011', '512', '504', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378428', '2', '682', '2011', '575', '516', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378433', '129', '682', '2011', '557', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378437', '151', '682', '2011', '519', '515', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378440', '118', '682', '2011', '511', '505', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378442', '97', '682', '2011', '572', '561', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378444', '150', '682', '2011', '551', '521', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378445', '119', '682', '2011', '514', '510', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378446', '254', '682', '2011', '511', '502', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378456', '254', '682', '2012', '522', '517', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378457', '129', '682', '2012', '552', '520', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378458', '165', '682', '2012', '555', '535', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378459', '105', '682', '2012', '532', '522', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378460', '2', '682', '2012', '537', '513', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378461', '119', '682', '2012', '562', '525', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378462', '94', '682', '2012', '544', '520', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378463', '83', '682', '2012', '533', '523', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378465', '151', '682', '2012', '496', '495', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378466', '101', '682', '2012', '499', '498', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378467', '441', '682', '2012', '524', '514', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378468', '134', '682', '2012', '495', '495', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378469', '292', '682', '2012', '552', '540', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378470', '118', '682', '2012', '544', '539', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378471', '150', '682', '2012', '559', '515', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378472', '38', '682', '2012', '526', '510', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378473', '97', '682', '2012', '501', '495', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378474', '233', '682', '2012', '545', '532', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378475', '118', '682', '2013', '608', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378476', '292', '682', '2013', '572', '571', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378477', '233', '682', '2013', '578', '577', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378478', '85', '682', '2013', '619', '582', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378479', '105', '682', '2013', '610', '601', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378480', '151', '682', '2013', '606', '589', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378481', '113', '682', '2013', '616', '598', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378482', '97', '682', '2013', '594', '587', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378483', '101', '682', '2013', '603', '599', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('378484', '112', '682', '2013', '599', '587', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('381302', '10', '682', '2010', '541', '540', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('381309', '10', '682', '2011', '552', '549', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('381311', '10', '682', '2012', '586', '586', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('381313', '10', '682', '2013', '558', '556', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('381425', '101', '682', '2010', '544', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('381428', '150', '682', '2010', '548', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('381431', '83', '682', '2010', '548', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('381432', '129', '682', '2010', '564', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('381433', '2', '682', '2010', '553', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('381436', '129', '682', '2011', '560', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('381438', '2', '682', '2011', '560', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('381440', '101', '682', '2011', '565', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('381442', '150', '682', '2011', '573', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('381443', '83', '682', '2011', '568', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('381449', '83', '682', '2012', '588', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('381451', '150', '682', '2012', '582', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('381452', '129', '682', '2012', '580', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('381453', '101', '682', '2012', '578', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('381454', '2', '682', '2012', '589', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('382931', '10', '696', '2010', '441', '421', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382932', '56', '696', '2010', '439', '424', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382935', '23', '696', '2010', '431', '417', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382937', '139', '696', '2010', '426', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382939', '12', '696', '2010', '432', '414', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382940', '63', '696', '2010', '427', '413', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382944', '24', '696', '2010', '423', '412', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382947', '428', '696', '2010', '468', '428', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('382960', '61', '696', '2011', '437', '432', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382962', '23', '696', '2011', '433', '424', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382964', '12', '696', '2011', '429', '422', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382966', '120', '696', '2011', '438', '424', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382968', '24', '696', '2011', '428', '422', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382970', '139', '696', '2011', '439', '424', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382973', '63', '696', '2011', '440', '424', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382976', '10', '696', '2011', '429', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382983', '10', '696', '2012', '407', '394', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382984', '24', '696', '2012', '403', '396', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382985', '23', '696', '2012', '405', '397', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382987', '61', '696', '2012', '419', '411', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382989', '139', '696', '2012', '414', '399', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382991', '12', '696', '2012', '411', '398', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382993', '63', '696', '2012', '409', '399', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('382999', '10', '696', '2013', '426', '424', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('383001', '12', '696', '2013', '429', '424', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('383005', '61', '696', '2013', '433', '431', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('383125', '38', '696', '2010', '457', '412', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383127', '143', '696', '2010', '426', '411', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383129', '428', '696', '2010', '425', '414', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('383131', '37', '696', '2010', '426', '411', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383133', '211', '696', '2010', '434', '411', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383135', '147', '696', '2010', '420', '411', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383137', '132', '696', '2010', '432', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383139', '23', '696', '2010', '427', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383141', '10', '696', '2010', '423', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383143', '205', '696', '2010', '418', '407', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383145', '112', '696', '2010', '420', '413', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383147', '24', '696', '2010', '424', '414', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383149', '120', '696', '2010', '423', '414', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383151', '139', '696', '2010', '449', '420', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383153', '12', '696', '2010', '446', '416', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383155', '56', '696', '2010', '422', '407', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383163', '112', '696', '2011', '410', '405', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383165', '37', '696', '2011', '417', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383167', '139', '696', '2011', '418', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383169', '24', '696', '2011', '414', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383171', '120', '696', '2011', '420', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383173', '10', '696', '2011', '411', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383175', '147', '696', '2011', '422', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383176', '61', '696', '2011', '426', '417', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383177', '211', '696', '2011', '414', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383178', '23', '696', '2011', '415', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383179', '205', '696', '2011', '425', '416', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383180', '38', '696', '2011', '417', '409', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383181', '143', '696', '2011', '413', '407', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383182', '56', '696', '2011', '420', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383184', '12', '696', '2011', '413', '407', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383191', '112', '696', '2012', '371', '370', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383193', '37', '696', '2012', '391', '380', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383195', '143', '696', '2012', '374', '371', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383197', '38', '696', '2012', '387', '375', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383199', '211', '696', '2012', '379', '374', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383201', '132', '696', '2012', '376', '373', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383203', '205', '696', '2012', '373', '372', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383205', '120', '696', '2012', '387', '378', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383207', '147', '696', '2012', '399', '382', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383209', '56', '696', '2012', '391', '380', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('383217', '56', '696', '2013', '393', '381', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('383857', '86', '703', '2010', '587', '542', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('383863', '86', '703', '2011', '562', '536', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('383868', '86', '703', '2012', '571', '531', '2', '1', '34');
INSERT INTO `major_recruit` VALUES ('384544', '10', '696', '2010', '474', '469', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('384552', '10', '696', '2011', '486', '476', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('384554', '24', '696', '2011', '484', '472', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('384614', '120', '696', '2011', '472', '454', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('384616', '37', '696', '2011', '453', '444', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('384618', '112', '696', '2011', '476', '443', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('384620', '147', '696', '2011', '457', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('384633', '205', '696', '2012', '473', '467', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('384636', '132', '696', '2012', '486', '474', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('391953', '69', '749', '2011', '458', '458', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('392003', '151', '749', '2011', '414', '414', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('392005', '5', '749', '2011', '417', '411', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('392011', '151', '749', '2012', '416', '416', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('392015', '539', '749', '2012', '417', '417', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('392402', '69', '749', '2011', '416', '416', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('392403', '13', '749', '2011', '413', '413', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('392404', '5', '749', '2011', '413', '413', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('392405', '78', '749', '2011', '416', '414', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('392406', '5', '749', '2012', '409', '404', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('392407', '8', '749', '2012', '414', '402', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('392408', '78', '749', '2012', '406', '395', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('392409', '52', '749', '2012', '408', '407', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('392425', '68', '749', '2010', '403', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('392426', '539', '749', '2010', '400', '400', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('392427', '68', '749', '2011', '406', '399', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('392428', '123', '749', '2011', '396', '394', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('392429', '5', '749', '2011', '402', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('392430', '151', '749', '2011', '393', '393', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('392431', '147', '749', '2011', '404', '399', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('392432', '38', '749', '2011', '397', '397', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('392433', '8', '749', '2011', '401', '397', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('392434', '5', '749', '2012', '373', '370', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('392435', '143', '749', '2012', '374', '374', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('392437', '8', '749', '2012', '348', '348', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('392439', '37', '749', '2012', '376', '373', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('392440', '151', '749', '2012', '377', '377', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('392441', '132', '749', '2012', '353', '353', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('393648', '78', '753', '2010', '477', '477', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('393649', '58', '753', '2010', '523', '500', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('393650', '52', '753', '2010', '506', '506', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('393685', '58', '753', '2010', '479', '476', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('393686', '52', '753', '2010', '463', '463', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('393688', '78', '753', '2010', '486', '486', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('393901', '8', '749', '2010', '466', '466', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('393902', '10', '749', '2010', '450', '432', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('393904', '13', '749', '2010', '433', '426', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('393978', '8', '749', '2011', '455', '452', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('393980', '123', '749', '2011', '440', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('393982', '37', '749', '2011', '449', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('393983', '118', '749', '2011', '440', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('393985', '147', '749', '2011', '453', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('393988', '151', '749', '2011', '455', '451', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('393990', '68', '749', '2011', '459', '459', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('393992', '143', '749', '2011', '451', '449', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('393995', '68', '749', '2012', '449', '449', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('393996', '151', '749', '2012', '455', '454', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('393997', '113', '749', '2012', '459', '457', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('393998', '148', '749', '2012', '440', '435', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('393999', '118', '749', '2012', '441', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('394001', '2', '749', '2012', '471', '459', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('394002', '132', '749', '2012', '456', '452', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('394003', '37', '749', '2012', '471', '462', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('394089', '58', '753', '2010', '452', '436', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394090', '56', '753', '2010', '439', '435', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394091', '541', '753', '2010', '429', '428', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394092', '52', '753', '2010', '427', '426', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394093', '78', '753', '2010', '426', '426', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394094', '10', '753', '2010', '429', '426', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394096', '1247', '753', '2011', '435', '433', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394098', '541', '753', '2011', '434', '432', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394100', '58', '753', '2011', '451', '438', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394102', '78', '753', '2011', '434', '430', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394104', '52', '753', '2011', '436', '436', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394106', '10', '753', '2011', '433', '430', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394108', '56', '753', '2011', '445', '440', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394114', '10', '753', '2012', '415', '413', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394115', '58', '753', '2012', '420', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394117', '56', '753', '2012', '419', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394119', '78', '753', '2012', '413', '409', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394121', '1247', '753', '2012', '413', '412', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394123', '52', '753', '2012', '413', '412', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394125', '541', '753', '2012', '413', '412', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394132', '58', '753', '2013', '447', '436', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394133', '56', '753', '2013', '433', '431', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394135', '10', '753', '2013', '437', '429', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394137', '3912', '753', '2013', '427', '427', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('394238', '10', '753', '2010', '427', '424', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394239', '58', '753', '2010', '446', '435', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394240', '52', '753', '2010', '442', '425', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394242', '56', '753', '2010', '434', '427', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394243', '78', '753', '2010', '424', '420', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394245', '541', '753', '2010', '426', '423', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394248', '79', '753', '2010', '424', '421', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394251', '541', '753', '2011', '422', '415', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394253', '58', '753', '2011', '460', '428', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394255', '10', '753', '2011', '418', '417', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394257', '56', '753', '2011', '429', '423', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394259', '79', '753', '2011', '418', '417', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394260', '78', '753', '2011', '419', '415', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394262', '1247', '753', '2011', '422', '421', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394264', '52', '753', '2011', '422', '421', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394269', '10', '753', '2012', '399', '390', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394272', '58', '753', '2012', '395', '386', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394274', '1247', '753', '2012', '391', '386', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394277', '52', '753', '2012', '396', '387', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394280', '56', '753', '2012', '401', '395', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394282', '79', '753', '2012', '381', '378', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394284', '541', '753', '2012', '396', '387', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394286', '78', '753', '2012', '394', '382', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('394290', '3912', '753', '2013', '484', '483', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('394291', '56', '753', '2013', '487', '481', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('394292', '58', '753', '2013', '491', '474', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('395142', '10', '757', '2010', '432', '432', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('395149', '428', '757', '2012', '393', '393', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('395150', '13', '757', '2013', '409', '409', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('395167', '38', '757', '2011', '404', '404', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('395174', '25', '757', '2012', '357', '357', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('399242', '10', '784', '2010', '458', '446', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399244', '52', '784', '2010', '459', '444', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399246', '8', '784', '2010', '473', '454', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399248', '69', '784', '2010', '469', '450', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399250', '23', '784', '2010', '469', '449', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399252', '146', '784', '2010', '469', '449', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399254', '78', '784', '2010', '466', '445', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399255', '62', '784', '2010', '466', '446', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399259', '10', '784', '2011', '472', '458', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399261', '62', '784', '2011', '473', '452', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399263', '23', '784', '2011', '475', '455', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399265', '8', '784', '2011', '472', '461', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399267', '69', '784', '2011', '476', '463', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399269', '52', '784', '2011', '473', '451', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399270', '78', '784', '2011', '471', '452', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399273', '78', '784', '2012', '439', '426', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399275', '10', '784', '2012', '445', '427', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399277', '23', '784', '2012', '444', '426', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399279', '52', '784', '2012', '440', '430', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399281', '8', '784', '2012', '444', '426', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399282', '69', '784', '2012', '436', '426', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399283', '62', '784', '2012', '440', '430', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399284', '65', '784', '2012', '437', '430', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399290', '65', '784', '2013', '470', '466', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399291', '10', '784', '2013', '468', '463', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399292', '62', '784', '2013', '493', '471', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399293', '8', '784', '2013', '488', '472', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('399347', '146', '784', '2011', '427', '408', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399348', '52', '784', '2011', '434', '409', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399349', '10', '784', '2011', '425', '409', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399350', '38', '784', '2011', '430', '410', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399352', '8', '784', '2011', '452', '426', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399354', '62', '784', '2011', '421', '406', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399355', '23', '784', '2011', '430', '416', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399356', '69', '784', '2011', '426', '409', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399357', '78', '784', '2011', '418', '406', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399359', '68', '784', '2011', '431', '410', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399361', '147', '784', '2011', '426', '409', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399362', '78', '784', '2012', '425', '411', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399363', '10', '784', '2012', '427', '416', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399364', '23', '784', '2012', '431', '412', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399365', '52', '784', '2012', '432', '416', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399366', '62', '784', '2012', '424', '415', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399367', '8', '784', '2012', '427', '416', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399369', '116', '784', '2012', '424', '411', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399371', '38', '784', '2012', '424', '412', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399372', '68', '784', '2012', '415', '407', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399373', '147', '784', '2012', '431', '414', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399374', '65', '784', '2012', '413', '407', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399375', '69', '784', '2012', '431', '416', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399376', '146', '784', '2012', '428', '413', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('399607', '62', '784', '2010', '408', '408', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('399615', '23', '784', '2012', '396', '396', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('399617', '10', '784', '2012', '386', '386', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('399619', '52', '784', '2012', '387', '387', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('399621', '65', '784', '2012', '396', '396', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('399622', '62', '784', '2012', '385', '385', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('399623', '78', '784', '2012', '387', '387', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('399628', '62', '784', '2013', '403', '403', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('399630', '65', '784', '2013', '403', '403', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('399632', '10', '784', '2013', '405', '405', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('399633', '8', '784', '2013', '407', '407', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('399655', '78', '784', '2011', '402', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('399656', '146', '784', '2011', '395', '395', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('399658', '69', '784', '2011', '395', '395', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('399659', '62', '784', '2011', '397', '397', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('399665', '8', '784', '2013', '337', '337', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('401103', '62', '784', '2011', '464', '438', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('401104', '10', '784', '2011', '443', '428', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('401105', '23', '784', '2011', '461', '435', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('401106', '69', '784', '2011', '444', '428', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('401107', '8', '784', '2011', '461', '436', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('401109', '52', '784', '2011', '433', '433', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('401111', '65', '784', '2011', '436', '436', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('401113', '78', '784', '2011', '423', '421', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('401119', '65', '784', '2013', '452', '451', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('401121', '62', '784', '2013', '457', '454', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('401122', '10', '784', '2013', '455', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('401124', '8', '784', '2013', '460', '458', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('401169', '10', '784', '2011', '429', '396', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('401170', '116', '784', '2011', '441', '405', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('401171', '69', '784', '2011', '449', '417', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('401172', '78', '784', '2011', '460', '425', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('401173', '147', '784', '2011', '448', '409', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('401174', '38', '784', '2011', '451', '401', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('401175', '23', '784', '2011', '429', '391', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('401176', '68', '784', '2011', '392', '388', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('401178', '8', '784', '2011', '442', '401', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('401180', '62', '784', '2011', '456', '408', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('401182', '146', '784', '2011', '432', '398', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('409929', '52', '855', '2010', '495', '475', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('409934', '52', '855', '2011', '488', '480', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('409935', '3990', '855', '2011', '491', '480', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('409936', '52', '855', '2012', '474', '474', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('409942', '52', '855', '2010', '475', '472', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('409943', '3990', '855', '2011', '490', '474', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('409944', '52', '855', '2011', '486', '479', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('409945', '52', '855', '2012', '468', '445', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('409946', '3990', '855', '2012', '450', '435', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('413748', '5', '876', '2011', '427', '427', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('413749', '65', '876', '2011', '414', '414', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('413750', '69', '876', '2011', '415', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('413751', '8', '876', '2011', '435', '435', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('413752', '21', '876', '2011', '420', '420', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('413753', '21', '876', '2010', '403', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('413754', '21', '876', '2011', '395', '395', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('413755', '69', '876', '2011', '414', '414', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('413756', '161', '876', '2011', '411', '411', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('413757', '119', '876', '2011', '394', '394', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('413758', '8', '876', '2011', '396', '396', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('414482', '2', '876', '2010', '462', '458', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('414483', '5', '876', '2010', '449', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('414484', '10', '876', '2010', '453', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('414485', '24', '876', '2010', '453', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('414487', '13', '876', '2010', '457', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('414491', '2', '876', '2011', '461', '461', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('414493', '13', '876', '2011', '462', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('414495', '24', '876', '2011', '460', '460', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('414497', '10', '876', '2011', '465', '465', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('414518', '37', '876', '2011', '451', '442', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('414519', '147', '876', '2011', '442', '437', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('414520', '2', '876', '2011', '457', '443', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('415943', '10', '894', '2011', '428', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('415944', '43', '894', '2011', '426', '422', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('415945', '10', '894', '2012', '397', '392', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('415946', '43', '894', '2012', '395', '389', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('415978', '129', '894', '2010', '425', '406', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415980', '147', '894', '2010', '417', '406', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415982', '113', '894', '2010', '411', '404', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415984', '8', '894', '2010', '414', '404', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415985', '85', '894', '2010', '406', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415986', '131', '894', '2010', '403', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415987', '2', '894', '2010', '409', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415988', '36', '894', '2011', '394', '394', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415991', '43', '894', '2011', '393', '393', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415992', '153', '894', '2011', '407', '407', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415993', '173', '894', '2011', '403', '397', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415994', '2', '894', '2011', '409', '400', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415995', '85', '894', '2011', '410', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415996', '8', '894', '2011', '423', '400', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415997', '131', '894', '2011', '409', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415998', '113', '894', '2011', '412', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('415999', '83', '894', '2011', '401', '397', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('416000', '113', '894', '2012', '376', '362', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('416001', '83', '894', '2012', '371', '357', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('416002', '36', '894', '2012', '355', '351', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('416003', '131', '894', '2012', '359', '353', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('416005', '10', '894', '2012', '353', '348', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('416007', '153', '894', '2012', '359', '352', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('416008', '85', '894', '2012', '376', '355', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('416009', '173', '894', '2012', '354', '349', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('416010', '2', '894', '2012', '371', '352', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('416011', '43', '894', '2012', '366', '356', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('416012', '8', '894', '2012', '403', '357', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('416630', '83', '894', '2011', '461', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('416631', '36', '894', '2011', '440', '433', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('416632', '147', '894', '2011', '472', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('416633', '113', '894', '2011', '450', '435', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('416634', '36', '894', '2012', '450', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('416635', '113', '894', '2012', '463', '443', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('416636', '147', '894', '2012', '490', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('416637', '83', '894', '2012', '472', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('418530', '2', '911', '2010', '466', '459', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('418533', '17', '911', '2010', '465', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('418539', '5', '911', '2011', '467', '466', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('418541', '10', '911', '2011', '476', '465', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('418543', '17', '911', '2011', '469', '468', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('418544', '2', '911', '2011', '478', '472', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('418545', '17', '911', '2012', '518', '516', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('418546', '10', '911', '2012', '509', '508', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('418547', '2', '911', '2012', '514', '509', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('418562', '5', '911', '2011', '447', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('418563', '17', '911', '2011', '470', '461', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('418564', '10', '911', '2011', '457', '453', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('418565', '2', '911', '2011', '461', '460', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('418566', '147', '911', '2011', '453', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('418567', '10', '911', '2012', '464', '460', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('418568', '17', '911', '2012', '471', '458', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('418569', '2', '911', '2012', '475', '469', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('418570', '147', '911', '2012', '467', '462', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('430190', '21', '1028', '2010', '466', '466', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('430191', '3', '1028', '2010', '445', '442', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('430192', '21', '1028', '2011', '445', '445', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('430193', '23', '1028', '2011', '448', '448', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('430194', '3', '1028', '2011', '460', '460', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('430195', '21', '1028', '2012', '421', '421', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('430196', '3', '1028', '2012', '444', '444', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('430197', '23', '1028', '2012', '418', '418', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('430204', '23', '1028', '2011', '396', '396', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('430205', '21', '1028', '2011', '411', '411', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('430206', '3', '1028', '2011', '414', '414', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('430207', '21', '1028', '2012', '408', '408', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('430208', '3', '1028', '2012', '418', '413', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('430209', '23', '1028', '2012', '402', '402', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('431198', '2', '1038', '2010', '471', '469', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431199', '3', '1038', '2010', '499', '492', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431200', '78', '1038', '2010', '468', '468', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431201', '8', '1038', '2010', '478', '476', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431202', '17', '1038', '2011', '485', '485', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431203', '5', '1038', '2011', '477', '477', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431204', '126', '1038', '2011', '479', '477', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431205', '78', '1038', '2011', '479', '479', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431206', '3', '1038', '2011', '490', '490', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431207', '2', '1038', '2011', '487', '485', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431208', '8', '1038', '2011', '486', '482', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431209', '5', '1038', '2012', '517', '517', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431210', '8', '1038', '2012', '516', '515', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431211', '2', '1038', '2012', '519', '519', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431212', '78', '1038', '2012', '517', '517', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431213', '3', '1038', '2012', '525', '525', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431214', '126', '1038', '2012', '515', '515', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431215', '17', '1038', '2012', '530', '530', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('431216', '17', '1038', '2011', '463', '462', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431217', '5', '1038', '2011', '463', '461', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431218', '126', '1038', '2011', '460', '460', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431219', '2', '1038', '2011', '460', '458', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431220', '3', '1038', '2011', '469', '467', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431221', '8', '1038', '2011', '472', '469', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431222', '21', '1038', '2011', '472', '472', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431223', '78', '1038', '2011', '464', '460', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431224', '5', '1038', '2012', '471', '471', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431225', '21', '1038', '2012', '473', '473', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431226', '2', '1038', '2012', '474', '468', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431227', '8', '1038', '2012', '478', '474', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431228', '78', '1038', '2012', '475', '470', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431229', '3', '1038', '2012', '482', '476', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431230', '126', '1038', '2012', '466', '465', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431231', '17', '1038', '2012', '467', '467', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('431709', '8', '1060', '2011', '405', '405', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('431710', '173', '1060', '2011', '420', '420', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('431711', '5', '1060', '2011', '403', '403', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('432200', '3', '1065', '2012', '416', '416', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('432324', '3', '1060', '2010', '474', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432325', '8', '1060', '2010', '468', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432326', '10', '1060', '2010', '466', '454', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432327', '21', '1060', '2010', '470', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432328', '78', '1060', '2010', '468', '451', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432329', '126', '1060', '2010', '467', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432330', '5', '1060', '2010', '463', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432331', '120', '1060', '2010', '468', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432332', '89', '1060', '2010', '457', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432333', '120', '1060', '2011', '493', '465', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432334', '78', '1060', '2011', '492', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432335', '3', '1060', '2011', '475', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432336', '5', '1060', '2011', '506', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432337', '21', '1060', '2011', '478', '461', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432338', '89', '1060', '2011', '479', '459', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432339', '8', '1060', '2011', '472', '461', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432340', '126', '1060', '2011', '480', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432342', '10', '1060', '2011', '480', '459', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432347', '21', '1060', '2012', '515', '503', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432349', '5', '1060', '2012', '524', '500', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432351', '10', '1060', '2012', '519', '502', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432352', '8', '1060', '2012', '514', '504', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432353', '78', '1060', '2012', '515', '499', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432354', '120', '1060', '2012', '515', '502', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432356', '89', '1060', '2012', '520', '502', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432357', '126', '1060', '2012', '510', '500', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432358', '3', '1060', '2012', '516', '503', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432359', '21', '1060', '2013', '480', '465', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432360', '10', '1060', '2013', '471', '460', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432361', '5', '1060', '2013', '476', '457', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432362', '8', '1060', '2013', '473', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('432386', '21', '1060', '2011', '463', '440', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432387', '211', '1060', '2011', '466', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432388', '153', '1060', '2011', '475', '441', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432389', '79', '1060', '2011', '456', '437', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432390', '105', '1060', '2011', '467', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432391', '120', '1060', '2011', '460', '437', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432392', '78', '1060', '2011', '454', '438', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432393', '37', '1060', '2011', '464', '435', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432394', '3', '1060', '2011', '460', '444', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432395', '126', '1060', '2011', '473', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432396', '5', '1060', '2011', '461', '441', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432397', '109', '1060', '2011', '461', '437', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432398', '38', '1060', '2011', '470', '437', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432399', '143', '1060', '2011', '504', '440', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432400', '113', '1060', '2011', '461', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432401', '147', '1060', '2011', '471', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432402', '173', '1060', '2011', '471', '440', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432403', '10', '1060', '2011', '454', '436', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432404', '89', '1060', '2011', '467', '438', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432405', '8', '1060', '2011', '454', '441', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432406', '146', '1060', '2011', '461', '440', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432407', '129', '1060', '2011', '477', '449', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432408', '132', '1060', '2011', '471', '440', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432409', '125', '1060', '2011', '467', '440', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432410', '21', '1060', '2012', '478', '457', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432411', '143', '1060', '2012', '473', '450', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432412', '5', '1060', '2012', '492', '451', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432413', '37', '1060', '2012', '478', '450', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432414', '10', '1060', '2012', '485', '457', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432415', '147', '1060', '2012', '484', '461', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432416', '211', '1060', '2012', '474', '454', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432417', '105', '1060', '2012', '473', '453', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432418', '101', '1060', '2012', '476', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432419', '38', '1060', '2012', '499', '452', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432420', '109', '1060', '2012', '477', '449', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432421', '132', '1060', '2012', '472', '450', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432422', '113', '1060', '2012', '479', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432423', '8', '1060', '2012', '477', '459', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432424', '79', '1060', '2012', '477', '457', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432425', '146', '1060', '2012', '468', '451', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432426', '78', '1060', '2012', '472', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432427', '120', '1060', '2012', '477', '450', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432428', '89', '1060', '2012', '467', '450', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432429', '126', '1060', '2012', '467', '454', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432430', '3', '1060', '2012', '483', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432431', '173', '1060', '2012', '464', '451', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432432', '153', '1060', '2012', '471', '453', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432433', '125', '1060', '2012', '477', '450', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('432434', '129', '1060', '2012', '484', '463', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('437067', '13', '1122', '2010', '404', '404', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('437068', '24', '1122', '2010', '404', '404', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('437069', '61', '1122', '2010', '404', '404', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('437070', '8', '1122', '2011', '423', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('437071', '3', '1122', '2011', '423', '423', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('437072', '8', '1122', '2012', '386', '386', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('437073', '8', '1122', '2013', '410', '410', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('437079', '113', '1122', '2010', '402', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('437080', '147', '1122', '2010', '402', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('437081', '3', '1122', '2010', '402', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('437082', '5', '1122', '2010', '405', '405', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('437083', '61', '1122', '2010', '401', '401', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('437084', '113', '1122', '2011', '407', '407', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('437085', '40', '1122', '2011', '405', '405', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('437086', '3', '1122', '2011', '400', '398', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('437087', '85', '1122', '2012', '369', '369', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('437088', '113', '1122', '2012', '358', '358', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('437089', '40', '1122', '2012', '356', '356', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('437090', '120', '1122', '2012', '363', '359', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('437091', '21', '1122', '2012', '357', '357', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('437092', '85', '1122', '2013', '331', '331', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('437154', '1579', '1127', '2011', '283', '237', '1', '4', '34');
INSERT INTO `major_recruit` VALUES ('437155', '1602', '1127', '2011', '227', '193', '1', '4', '34');
INSERT INTO `major_recruit` VALUES ('437156', '3838', '1127', '2011', '294', '247', '1', '4', '34');
INSERT INTO `major_recruit` VALUES ('437157', '4084', '1127', '2011', '272', '228', '1', '4', '34');
INSERT INTO `major_recruit` VALUES ('437158', '3832', '1127', '2011', '254', '222', '1', '4', '34');
INSERT INTO `major_recruit` VALUES ('437159', '1673', '1127', '2011', '232', '193', '1', '4', '34');
INSERT INTO `major_recruit` VALUES ('437160', '4085', '1127', '2011', '279', '242', '1', '4', '34');
INSERT INTO `major_recruit` VALUES ('437161', '4086', '1127', '2011', '273', '242', '1', '4', '34');
INSERT INTO `major_recruit` VALUES ('437162', '1666', '1127', '2011', '236', '196', '1', '4', '34');
INSERT INTO `major_recruit` VALUES ('437163', '4087', '1127', '2011', '246', '186', '1', '4', '34');
INSERT INTO `major_recruit` VALUES ('437164', '4088', '1127', '2011', '246', '186', '1', '4', '34');
INSERT INTO `major_recruit` VALUES ('437165', '4089', '1127', '2011', '241', '198', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437166', '4084', '1127', '2011', '219', '175', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437167', '1579', '1127', '2011', '213', '191', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437168', '3838', '1127', '2011', '238', '213', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437169', '4088', '1127', '2011', '181', '157', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437170', '4087', '1127', '2011', '181', '157', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437171', '1602', '1127', '2011', '228', '184', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437172', '3832', '1127', '2011', '207', '180', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437173', '4090', '1127', '2011', '254', '222', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437174', '1674', '1127', '2011', '268', '209', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437175', '4091', '1127', '2011', '216', '192', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437176', '4092', '1127', '2011', '259', '203', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437177', '4093', '1127', '2011', '175', '170', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437178', '4094', '1127', '2011', '250', '202', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437179', '1570', '1127', '2011', '271', '226', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437180', '4095', '1127', '2011', '244', '193', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437181', '4096', '1127', '2011', '237', '201', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437182', '1564', '1127', '2011', '254', '199', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437183', '1671', '1127', '2011', '238', '201', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437184', '4085', '1127', '2011', '233', '198', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437185', '1673', '1127', '2011', '231', '182', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437186', '1666', '1127', '2011', '233', '190', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('437187', '4086', '1127', '2011', '237', '209', '2', '4', '34');
INSERT INTO `major_recruit` VALUES ('438242', '4098', '1144', '2013', '420', '414', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('438969', '8', '1157', '2011', '469', '454', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('438970', '2', '1157', '2011', '466', '452', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('438971', '2', '1157', '2012', '510', '499', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('438972', '5', '1157', '2012', '502', '491', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('438973', '8', '1157', '2012', '500', '493', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('438974', '38', '1157', '2011', '452', '427', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('438975', '94', '1157', '2011', '436', '417', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('438976', '5', '1157', '2012', '462', '441', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('438977', '94', '1157', '2012', '467', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('438978', '39', '1157', '2012', '442', '425', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('438979', '150', '1157', '2012', '454', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('438980', '38', '1157', '2012', '484', '443', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('438981', '37', '1157', '2012', '430', '422', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('443032', '157', '1236', '2010', '406', '404', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('443033', '86', '1236', '2010', '415', '408', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('443034', '27', '1236', '2010', '416', '410', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('443035', '88', '1236', '2010', '403', '401', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('443036', '71', '1236', '2011', '405', '405', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('443037', '15', '1236', '2011', '396', '396', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('443038', '157', '1236', '2011', '396', '396', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('443039', '88', '1236', '2011', '397', '397', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('443040', '27', '1236', '2011', '409', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('443041', '86', '1236', '2011', '404', '398', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('443042', '71', '1236', '2012', '374', '364', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('443043', '27', '1236', '2012', '385', '375', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('443044', '157', '1236', '2012', '377', '361', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('443045', '86', '1236', '2012', '375', '359', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('443046', '15', '1236', '2012', '356', '355', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('443254', '27', '1236', '2011', '462', '458', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('443255', '86', '1236', '2011', '459', '450', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('443256', '66', '1236', '2011', '450', '450', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('443257', '79', '1236', '2011', '451', '451', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('443258', '155', '1236', '2011', '454', '453', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('443259', '71', '1236', '2011', '450', '450', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('443260', '155', '1236', '2012', '469', '468', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('443261', '27', '1236', '2012', '475', '475', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('443262', '86', '1236', '2012', '474', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('443263', '15', '1236', '2012', '472', '460', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('443264', '71', '1236', '2012', '475', '465', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('443265', '79', '1236', '2012', '459', '453', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('444123', '58', '1257', '2010', '563', '512', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('444124', '52', '1257', '2010', '528', '488', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('444125', '541', '1257', '2010', '510', '486', '1', '5', '34');
INSERT INTO `major_recruit` VALUES ('444130', '541', '1257', '2010', '520', '469', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('444131', '58', '1257', '2010', '550', '514', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('444132', '52', '1257', '2010', '509', '477', '2', '5', '34');
INSERT INTO `major_recruit` VALUES ('449606', '13', '1309', '2013', '469', '465', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('451456', '66', '1329', '2010', '442', '442', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('451458', '86', '1329', '2010', '443', '443', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('451460', '60', '1329', '2010', '453', '448', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('451471', '60', '1329', '2011', '448', '448', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('451473', '86', '1329', '2011', '447', '447', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('451475', '66', '1329', '2011', '452', '452', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('451481', '60', '1329', '2012', '431', '431', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('451483', '86', '1329', '2012', '432', '424', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('451485', '66', '1329', '2012', '417', '417', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('451494', '66', '1329', '2013', '465', '465', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('451536', '66', '1329', '2011', '414', '414', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('451537', '72', '1329', '2012', '413', '413', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('451538', '66', '1329', '2012', '414', '414', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('451898', '86', '1329', '2010', '411', '411', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('451903', '66', '1329', '2011', '418', '416', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('451909', '52', '1329', '2012', '388', '388', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('451911', '10', '1329', '2012', '387', '387', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('451914', '60', '1329', '2012', '387', '387', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('451916', '66', '1329', '2012', '404', '388', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('451919', '71', '1329', '2012', '390', '385', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('451922', '86', '1329', '2012', '389', '385', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('451925', '66', '1329', '2013', '412', '408', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('451927', '60', '1329', '2013', '443', '416', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('451929', '86', '1329', '2013', '408', '405', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('451948', '71', '1329', '2010', '408', '405', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451949', '72', '1329', '2010', '406', '406', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451950', '56', '1329', '2010', '402', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451951', '86', '1329', '2011', '394', '394', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451953', '71', '1329', '2011', '397', '397', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451955', '56', '1329', '2011', '397', '397', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451957', '72', '1329', '2011', '395', '395', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451959', '66', '1329', '2011', '393', '393', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451961', '438', '1329', '2011', '393', '393', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451963', '91', '1329', '2011', '394', '394', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451967', '10', '1329', '2012', '364', '354', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451968', '88', '1329', '2012', '358', '358', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451969', '438', '1329', '2012', '342', '342', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451970', '91', '1329', '2012', '347', '346', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451971', '56', '1329', '2012', '351', '347', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451973', '66', '1329', '2012', '358', '351', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451975', '71', '1329', '2012', '345', '343', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451977', '60', '1329', '2012', '353', '347', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451979', '75', '1329', '2012', '349', '346', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451981', '72', '1329', '2012', '345', '343', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451983', '86', '1329', '2012', '362', '350', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451987', '88', '1329', '2013', '362', '347', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('451989', '66', '1329', '2013', '339', '339', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('452513', '266', '1329', '2010', '462', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452514', '10', '1329', '2010', '457', '447', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452515', '71', '1329', '2010', '466', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452516', '52', '1329', '2010', '473', '447', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452517', '66', '1329', '2010', '477', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452518', '60', '1329', '2010', '468', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452520', '86', '1329', '2010', '466', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452522', '66', '1329', '2011', '494', '459', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452523', '266', '1329', '2011', '452', '446', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452524', '71', '1329', '2011', '471', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452525', '10', '1329', '2011', '464', '448', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452526', '52', '1329', '2011', '457', '446', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452527', '60', '1329', '2011', '470', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452528', '86', '1329', '2011', '474', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452529', '266', '1329', '2012', '499', '471', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452530', '66', '1329', '2012', '527', '496', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452531', '10', '1329', '2012', '495', '487', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452532', '71', '1329', '2012', '511', '487', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452533', '52', '1329', '2012', '506', '487', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452534', '60', '1329', '2012', '514', '488', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452535', '86', '1329', '2012', '518', '480', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('452550', '91', '1329', '2011', '456', '431', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452551', '40', '1329', '2011', '466', '437', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452552', '75', '1329', '2011', '451', '432', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452553', '266', '1329', '2011', '463', '434', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452554', '52', '1329', '2011', '444', '428', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452555', '438', '1329', '2011', '463', '430', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452556', '10', '1329', '2011', '452', '436', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452557', '66', '1329', '2011', '470', '442', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452558', '72', '1329', '2011', '469', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452559', '56', '1329', '2011', '454', '431', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452560', '38', '1329', '2011', '466', '429', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452561', '88', '1329', '2011', '444', '429', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452562', '86', '1329', '2011', '453', '430', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452563', '71', '1329', '2011', '470', '436', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452564', '60', '1329', '2011', '472', '438', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452565', '266', '1329', '2012', '467', '408', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452566', '91', '1329', '2012', '476', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452567', '10', '1329', '2012', '452', '443', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452568', '438', '1329', '2012', '481', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452569', '72', '1329', '2012', '484', '461', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452570', '86', '1329', '2012', '475', '425', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452571', '88', '1329', '2012', '470', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452572', '71', '1329', '2012', '482', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452573', '52', '1329', '2012', '454', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452574', '60', '1329', '2012', '483', '453', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452575', '75', '1329', '2012', '476', '444', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452576', '66', '1329', '2012', '489', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('452577', '56', '1329', '2012', '478', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('453537', '3', '1353', '2010', '462', '462', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('453538', '5', '1353', '2010', '449', '449', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('453539', '78', '1353', '2010', '442', '442', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('453540', '10', '1353', '2013', '464', '464', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('454172', '37', '1357', '2012', '432', '426', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('454173', '147', '1357', '2012', '453', '431', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('454174', '38', '1357', '2012', '455', '430', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('454175', '101', '1357', '2012', '456', '432', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('455348', '17', '1381', '2010', '444', '444', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('455349', '146', '1381', '2012', '414', '414', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('455465', '17', '1381', '2010', '409', '406', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('455466', '2', '1381', '2011', '417', '415', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('455473', '10', '1381', '2012', '402', '392', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('455474', '2', '1381', '2012', '400', '388', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('455475', '58', '1381', '2012', '383', '382', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('455476', '58', '1381', '2013', '409', '408', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('455477', '10', '1381', '2013', '414', '411', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('455498', '109', '1381', '2010', '403', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('455499', '36', '1381', '2011', '402', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('455500', '109', '1381', '2011', '399', '396', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('455501', '147', '1381', '2011', '405', '399', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('455502', '109', '1381', '2012', '350', '350', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('455503', '147', '1381', '2012', '367', '367', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('455504', '89', '1381', '2012', '365', '358', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('455505', '79', '1381', '2012', '355', '353', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('455506', '38', '1381', '2012', '356', '356', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('455507', '205', '1381', '2012', '356', '351', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('455555', '136', '1383', '2012', '405', '395', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('455556', '78', '1383', '2012', '405', '401', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('455557', '10', '1383', '2012', '410', '403', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('455558', '364', '1383', '2012', '415', '385', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('455559', '8', '1383', '2012', '409', '401', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('455560', '120', '1383', '2012', '375', '375', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('455561', '21', '1383', '2012', '402', '376', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('456056', '17', '1381', '2010', '474', '448', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456057', '10', '1381', '2010', '472', '446', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456058', '78', '1381', '2010', '459', '445', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456059', '2', '1381', '2010', '463', '445', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456060', '3', '1381', '2011', '480', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456061', '78', '1381', '2011', '479', '454', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456062', '2', '1381', '2011', '480', '451', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456063', '17', '1381', '2011', '463', '452', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456064', '58', '1381', '2011', '478', '457', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456065', '10', '1381', '2011', '483', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456066', '17', '1381', '2012', '514', '497', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456067', '78', '1381', '2012', '520', '499', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456068', '10', '1381', '2012', '518', '497', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456069', '3', '1381', '2012', '514', '497', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456070', '58', '1381', '2012', '513', '499', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456071', '2', '1381', '2012', '513', '498', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456072', '58', '1381', '2013', '477', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456073', '10', '1381', '2013', '494', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456074', '17', '1381', '2013', '475', '464', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('456093', '310', '1381', '2011', '460', '432', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456094', '151', '1381', '2011', '470', '435', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456095', '129', '1381', '2011', '471', '434', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456096', '143', '1381', '2011', '464', '432', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456097', '38', '1381', '2011', '453', '428', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456098', '205', '1381', '2011', '444', '427', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456099', '416', '1381', '2011', '468', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456100', '141', '1381', '2011', '450', '433', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456101', '89', '1381', '2011', '463', '430', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456102', '385', '1381', '2011', '473', '430', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456103', '36', '1381', '2011', '458', '426', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456104', '146', '1381', '2011', '452', '430', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456105', '37', '1381', '2011', '464', '432', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456106', '147', '1381', '2011', '463', '437', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456107', '109', '1381', '2011', '468', '428', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456108', '161', '1381', '2011', '480', '434', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456109', '78', '1381', '2011', '465', '432', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456110', '146', '1381', '2012', '449', '437', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456111', '416', '1381', '2012', '472', '452', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456112', '37', '1381', '2012', '475', '440', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456113', '385', '1381', '2012', '477', '443', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456114', '143', '1381', '2012', '473', '441', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456115', '153', '1381', '2012', '496', '438', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456116', '205', '1381', '2012', '475', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456117', '109', '1381', '2012', '469', '442', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456118', '89', '1381', '2012', '476', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456119', '147', '1381', '2012', '483', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456120', '161', '1381', '2012', '476', '444', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456121', '36', '1381', '2012', '449', '436', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456122', '310', '1381', '2012', '497', '442', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456123', '129', '1381', '2012', '468', '441', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456124', '151', '1381', '2012', '481', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456125', '141', '1381', '2012', '496', '443', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456126', '38', '1381', '2012', '473', '440', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456127', '79', '1381', '2012', '475', '442', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456128', '2', '1381', '2012', '478', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('456986', '2', '1413', '2011', '457', '457', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('456987', '2', '1413', '2012', '425', '425', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('456988', '62', '1413', '2012', '424', '424', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('456994', '146', '1413', '2011', '420', '420', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('456995', '38', '1413', '2012', '404', '404', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('456996', '146', '1413', '2012', '411', '411', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('456997', '87', '1413', '2012', '425', '425', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('457103', '58', '1413', '2012', '384', '384', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('457104', '8', '1413', '2012', '389', '389', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('457105', '126', '1413', '2012', '394', '394', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('457106', '10', '1413', '2012', '380', '380', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('457107', '78', '1413', '2012', '390', '390', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('457108', '12', '1413', '2013', '404', '404', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('457109', '58', '1413', '2013', '405', '405', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('457114', '8', '1413', '2011', '401', '397', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('457115', '3', '1413', '2011', '395', '395', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('457116', '146', '1413', '2012', '349', '349', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('457117', '3', '1413', '2012', '345', '345', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('457118', '79', '1413', '2012', '348', '348', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('457119', '12', '1413', '2012', '348', '348', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('457120', '8', '1413', '2012', '358', '358', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('457806', '69', '1413', '2010', '464', '448', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457807', '3', '1413', '2010', '468', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457808', '24', '1413', '2010', '470', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457809', '78', '1413', '2010', '463', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457810', '62', '1413', '2010', '455', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457811', '58', '1413', '2010', '458', '448', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457812', '23', '1413', '2010', '465', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457813', '2', '1413', '2010', '466', '458', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457814', '12', '1413', '2010', '467', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457815', '17', '1413', '2010', '463', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457816', '52', '1413', '2010', '460', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457817', '5', '1413', '2010', '463', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457818', '8', '1413', '2010', '468', '452', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457819', '10', '1413', '2010', '474', '451', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457820', '126', '1413', '2010', '466', '451', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457821', '24', '1413', '2011', '472', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457822', '23', '1413', '2011', '479', '456', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457823', '120', '1413', '2011', '471', '457', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457824', '3', '1413', '2011', '477', '458', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457825', '2', '1413', '2011', '473', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457826', '10', '1413', '2011', '474', '456', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457827', '62', '1413', '2011', '479', '454', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457828', '8', '1413', '2011', '471', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457829', '126', '1413', '2011', '472', '457', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457830', '58', '1413', '2011', '465', '452', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457831', '17', '1413', '2011', '472', '458', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457832', '5', '1413', '2011', '467', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457833', '78', '1413', '2011', '471', '457', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457834', '12', '1413', '2011', '475', '454', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457835', '69', '1413', '2011', '473', '456', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457836', '52', '1413', '2011', '466', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457837', '12', '1413', '2012', '551', '502', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457838', '10', '1413', '2012', '505', '495', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457839', '62', '1413', '2012', '520', '495', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457840', '5', '1413', '2012', '513', '496', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457841', '78', '1413', '2012', '511', '497', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457842', '58', '1413', '2012', '514', '494', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457843', '69', '1413', '2012', '518', '496', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457844', '2', '1413', '2012', '519', '502', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457845', '23', '1413', '2012', '518', '498', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457846', '3', '1413', '2012', '515', '499', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457847', '24', '1413', '2012', '507', '494', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457848', '120', '1413', '2012', '511', '500', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457849', '52', '1413', '2012', '510', '494', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457850', '126', '1413', '2012', '512', '498', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457851', '8', '1413', '2012', '510', '494', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457852', '17', '1413', '2012', '512', '498', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('457872', '120', '1413', '2011', '451', '433', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457873', '8', '1413', '2011', '459', '431', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457874', '78', '1413', '2011', '454', '432', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457875', '17', '1413', '2011', '456', '431', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457876', '5', '1413', '2011', '446', '425', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457877', '69', '1413', '2011', '452', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457878', '146', '1413', '2011', '485', '431', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457879', '37', '1413', '2011', '462', '424', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457880', '24', '1413', '2011', '467', '429', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457881', '52', '1413', '2011', '446', '424', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457882', '10', '1413', '2011', '458', '433', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457883', '87', '1413', '2011', '466', '432', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457884', '23', '1413', '2011', '447', '426', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457885', '38', '1413', '2011', '440', '424', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457886', '3', '1413', '2011', '453', '428', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457887', '2', '1413', '2011', '460', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457888', '89', '1413', '2011', '434', '426', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457889', '79', '1413', '2011', '432', '421', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457890', '12', '1413', '2011', '441', '423', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457891', '126', '1413', '2011', '459', '432', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457892', '79', '1413', '2012', '474', '438', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457893', '12', '1413', '2012', '486', '452', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457894', '3', '1413', '2012', '471', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457895', '5', '1413', '2012', '449', '440', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457896', '10', '1413', '2012', '475', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457897', '78', '1413', '2012', '472', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457898', '87', '1413', '2012', '476', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457899', '38', '1413', '2012', '486', '443', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457900', '37', '1413', '2012', '473', '444', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457901', '146', '1413', '2012', '479', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457902', '69', '1413', '2012', '470', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457903', '2', '1413', '2012', '468', '449', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457904', '23', '1413', '2012', '488', '444', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457905', '8', '1413', '2012', '467', '444', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457906', '126', '1413', '2012', '479', '442', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457907', '24', '1413', '2012', '471', '442', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457908', '89', '1413', '2012', '461', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457909', '120', '1413', '2012', '468', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457910', '52', '1413', '2012', '476', '452', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('457911', '17', '1413', '2012', '465', '443', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('459676', '37', '1445', '2012', '406', '406', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('459727', '21', '1445', '2011', '482', '464', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('459728', '21', '1445', '2012', '508', '503', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('459729', '38', '1445', '2011', '456', '450', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('459730', '165', '1445', '2011', '457', '453', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('459731', '115', '1445', '2011', '455', '454', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('459732', '37', '1445', '2011', '470', '464', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('459733', '144', '1445', '2011', '447', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('459734', '165', '1445', '2012', '461', '460', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('459735', '115', '1445', '2012', '478', '460', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('459736', '38', '1445', '2012', '482', '470', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('459737', '37', '1445', '2012', '492', '472', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460066', '71', '1456', '2011', '462', '451', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460067', '3823', '1456', '2011', '438', '423', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460068', '38', '1456', '2011', '464', '434', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460069', '52', '1456', '2011', '435', '423', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460070', '184', '1456', '2011', '438', '434', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460071', '78', '1456', '2011', '424', '420', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460072', '60', '1456', '2011', '449', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460073', '38', '1456', '2012', '466', '462', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460074', '60', '1456', '2012', '449', '449', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460075', '86', '1456', '2012', '460', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460076', '52', '1456', '2012', '464', '463', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460077', '93', '1456', '2012', '462', '462', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460078', '3823', '1456', '2012', '470', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460079', '78', '1456', '2012', '451', '450', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460080', '91', '1456', '2012', '468', '467', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460081', '184', '1456', '2012', '465', '453', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460082', '10', '1456', '2012', '461', '453', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460236', '12', '1463', '2010', '406', '406', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('460237', '17', '1463', '2012', '399', '399', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('460242', '116', '1463', '2010', '404', '404', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('460243', '31', '1463', '2010', '402', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('460244', '10', '1463', '2010', '403', '403', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('460245', '17', '1463', '2011', '424', '424', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('460249', '2', '1463', '2012', '355', '352', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('460251', '17', '1463', '2012', '347', '347', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('460252', '10', '1463', '2012', '344', '344', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('460356', '10', '1466', '2012', '398', '397', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('460357', '13', '1466', '2012', '394', '390', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('460358', '69', '1466', '2012', '403', '400', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('460359', '8', '1466', '2012', '380', '380', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('460360', '78', '1466', '2012', '398', '396', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('460368', '8', '1466', '2011', '407', '406', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('460370', '89', '1466', '2011', '405', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('460371', '86', '1466', '2011', '400', '399', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('460372', '78', '1466', '2012', '355', '355', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('460373', '317', '1466', '2012', '356', '356', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('460374', '91', '1466', '2012', '369', '356', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('460375', '89', '1466', '2012', '364', '361', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('460376', '8', '1466', '2012', '359', '359', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('460506', '10', '1463', '2010', '436', '434', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('460507', '2', '1463', '2010', '464', '446', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('460508', '12', '1463', '2010', '448', '448', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('460509', '17', '1463', '2010', '466', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('460510', '2', '1463', '2011', '455', '451', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('460511', '17', '1463', '2011', '457', '456', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('460512', '17', '1463', '2012', '490', '489', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('460513', '2', '1463', '2012', '514', '500', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('460516', '2', '1463', '2011', '465', '463', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460517', '116', '1463', '2011', '447', '437', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460518', '2', '1463', '2012', '449', '449', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460519', '17', '1463', '2012', '452', '451', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460520', '27', '1463', '2012', '450', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460680', '78', '1466', '2011', '433', '428', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('460681', '12', '1466', '2011', '428', '427', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('460682', '10', '1466', '2011', '429', '425', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('460683', '8', '1466', '2011', '437', '434', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('460684', '12', '1466', '2012', '473', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('460685', '8', '1466', '2012', '474', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('460686', '8', '1466', '2011', '390', '387', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460687', '78', '1466', '2011', '420', '410', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460689', '147', '1466', '2011', '416', '411', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460691', '91', '1466', '2011', '434', '408', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460693', '147', '1466', '2012', '404', '397', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460695', '91', '1466', '2012', '405', '394', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460696', '78', '1466', '2012', '399', '398', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460698', '8', '1466', '2012', '408', '408', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('460699', '317', '1466', '2012', '394', '386', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('461804', '10', '1482', '2010', '446', '446', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('461819', '94', '1482', '2011', '407', '407', '2', '3', '34');
INSERT INTO `major_recruit` VALUES ('461970', '120', '1482', '2010', '408', '408', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('461971', '10', '1482', '2012', '397', '397', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('461972', '12', '1482', '2012', '383', '383', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('461973', '24', '1482', '2012', '406', '406', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('461974', '79', '1482', '2012', '397', '397', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('461975', '8', '1482', '2012', '400', '400', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('461976', '23', '1482', '2012', '397', '395', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('461977', '5', '1482', '2013', '406', '406', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('461978', '8', '1482', '2013', '416', '412', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('461979', '10', '1482', '2013', '409', '408', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('461980', '12', '1482', '2013', '408', '407', '1', '2', '3');
INSERT INTO `major_recruit` VALUES ('461988', '37', '1482', '2010', '402', '402', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('461989', '38', '1482', '2010', '404', '404', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('461990', '37', '1482', '2011', '393', '393', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('461991', '146', '1482', '2011', '394', '394', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('461992', '78', '1482', '2012', '354', '354', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('461993', '146', '1482', '2012', '348', '348', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('461994', '120', '1482', '2012', '349', '349', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('461995', '37', '1482', '2012', '356', '356', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('462583', '206', '1510', '2011', '457', '449', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('462584', '119', '1510', '2011', '449', '440', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('462585', '120', '1510', '2011', '431', '428', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('462586', '129', '1510', '2011', '439', '436', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('462587', '147', '1510', '2011', '472', '453', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('462588', '113', '1510', '2011', '437', '427', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('462589', '38', '1510', '2011', '427', '421', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('462590', '101', '1510', '2011', '419', '415', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('462591', '131', '1510', '2011', '427', '420', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('462592', '437', '1510', '2011', '446', '431', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('462593', '206', '1510', '2012', '463', '463', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('462594', '147', '1510', '2012', '451', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('462595', '437', '1510', '2012', '432', '432', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('463399', '8', '1557', '2012', '443', '443', '1', '3', '34');
INSERT INTO `major_recruit` VALUES ('463587', '10', '1557', '2011', '413', '404', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('463590', '89', '1557', '2011', '467', '449', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('463593', '3', '1557', '2011', '454', '435', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('463596', '38', '1557', '2011', '407', '404', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('463599', '329', '1557', '2011', '413', '404', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('463601', '37', '1557', '2011', '410', '401', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465836', '98', '1618', '2011', '451', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('465837', '89', '1618', '2011', '453', '452', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('465838', '5', '1618', '2011', '460', '457', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('465839', '23', '1618', '2011', '457', '454', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('465840', '3', '1618', '2011', '474', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('465841', '2', '1618', '2011', '458', '458', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('465842', '10', '1618', '2011', '458', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('465843', '3', '1618', '2012', '506', '500', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('465844', '2', '1618', '2012', '490', '489', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('465845', '8', '1618', '2012', '501', '488', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('465846', '5', '1618', '2012', '493', '490', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('465847', '10', '1618', '2012', '503', '499', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('465848', '69', '1618', '2012', '498', '490', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('465849', '87', '1618', '2011', '435', '435', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465850', '129', '1618', '2011', '450', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465851', '444', '1618', '2011', '444', '444', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465852', '2', '1618', '2011', '442', '441', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465853', '112', '1618', '2011', '440', '437', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465854', '24', '1618', '2011', '436', '434', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465855', '10', '1618', '2011', '444', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465856', '38', '1618', '2011', '463', '457', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465857', '23', '1618', '2011', '448', '440', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465858', '79', '1618', '2011', '434', '433', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465859', '3', '1618', '2011', '459', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465860', '3', '1618', '2012', '451', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465861', '23', '1618', '2012', '454', '453', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465862', '2', '1618', '2012', '463', '451', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465863', '79', '1618', '2012', '433', '430', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465864', '87', '1618', '2012', '468', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465865', '85', '1618', '2012', '440', '433', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465866', '147', '1618', '2012', '464', '462', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465867', '8', '1618', '2012', '438', '436', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465868', '10', '1618', '2012', '440', '438', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('465869', '279', '1618', '2012', '470', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('466363', '10', '1645', '2010', '454', '446', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('466364', '8', '1645', '2010', '453', '431', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('466365', '10', '1645', '2011', '439', '432', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('466366', '2', '1645', '2012', '482', '473', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('466367', '10', '1645', '2012', '505', '490', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('466368', '37', '1645', '2011', '434', '415', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('466369', '129', '1645', '2011', '456', '441', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('466370', '10', '1645', '2011', '434', '416', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('466371', '2', '1645', '2012', '456', '433', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('466372', '37', '1645', '2012', '444', '429', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469310', '38', '1741', '2012', '342', '342', '2', '2', '3');
INSERT INTO `major_recruit` VALUES ('469522', '8', '1741', '2010', '460', '421', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469523', '10', '1741', '2010', '460', '424', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469524', '23', '1741', '2010', '449', '422', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469525', '78', '1741', '2010', '443', '420', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469526', '89', '1741', '2010', '444', '419', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469527', '5', '1741', '2010', '441', '416', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469528', '12', '1741', '2010', '438', '420', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469529', '23', '1741', '2011', '458', '427', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469530', '8', '1741', '2011', '477', '429', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469531', '10', '1741', '2011', '467', '432', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469532', '89', '1741', '2011', '441', '426', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469533', '5', '1741', '2011', '440', '426', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469534', '12', '1741', '2011', '444', '427', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469535', '78', '1741', '2011', '442', '424', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469536', '78', '1741', '2012', '492', '471', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469537', '8', '1741', '2012', '485', '471', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469538', '5', '1741', '2012', '490', '467', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469539', '12', '1741', '2012', '493', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469540', '23', '1741', '2012', '497', '469', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469541', '10', '1741', '2012', '511', '472', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469542', '89', '1741', '2012', '495', '472', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469543', '5', '1741', '2013', '454', '448', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469544', '12', '1741', '2013', '455', '447', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469545', '10', '1741', '2013', '471', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469546', '8', '1741', '2013', '469', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469558', '8', '1741', '2011', '458', '408', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469559', '89', '1741', '2011', '426', '399', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469560', '23', '1741', '2011', '444', '403', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469561', '156', '1741', '2011', '465', '417', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469562', '12', '1741', '2011', '443', '411', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469563', '127', '1741', '2011', '414', '398', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469564', '36', '1741', '2011', '426', '399', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469565', '78', '1741', '2011', '417', '402', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469566', '10', '1741', '2011', '445', '412', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469567', '147', '1741', '2011', '450', '407', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469568', '38', '1741', '2011', '440', '399', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469569', '89', '1741', '2012', '446', '409', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469570', '8', '1741', '2012', '449', '408', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469571', '156', '1741', '2012', '470', '419', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469572', '10', '1741', '2012', '475', '417', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469573', '147', '1741', '2012', '467', '409', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469574', '127', '1741', '2012', '429', '403', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469575', '36', '1741', '2012', '433', '407', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469576', '38', '1741', '2012', '464', '410', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469577', '78', '1741', '2012', '431', '406', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469578', '12', '1741', '2012', '416', '403', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469579', '23', '1741', '2012', '463', '408', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469966', '10', '1786', '2010', '471', '447', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469967', '1', '1786', '2010', '469', '446', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469968', '5', '1786', '2010', '462', '443', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469969', '8', '1786', '2010', '460', '445', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469970', '12', '1786', '2010', '455', '445', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469971', '13', '1786', '2010', '469', '446', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469972', '10', '1786', '2011', '472', '451', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469973', '12', '1786', '2011', '457', '447', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469974', '1', '1786', '2011', '468', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469975', '13', '1786', '2011', '478', '452', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469976', '8', '1786', '2011', '477', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469977', '5', '1786', '2011', '474', '451', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469978', '1', '1786', '2012', '523', '489', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469979', '8', '1786', '2012', '512', '490', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469980', '12', '1786', '2012', '515', '489', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469981', '10', '1786', '2012', '517', '489', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469982', '13', '1786', '2012', '520', '490', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469983', '5', '1786', '2012', '508', '485', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469984', '1', '1786', '2013', '472', '459', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469985', '5', '1786', '2013', '476', '457', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469986', '8', '1786', '2013', '465', '458', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469987', '10', '1786', '2013', '474', '459', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469988', '12', '1786', '2013', '466', '456', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469989', '13', '1786', '2013', '479', '460', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('469997', '37', '1786', '2011', '467', '424', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469998', '5', '1786', '2011', '459', '422', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('469999', '97', '1786', '2011', '468', '422', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('470000', '8', '1786', '2011', '467', '421', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('470001', '10', '1786', '2011', '462', '424', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('470002', '38', '1786', '2011', '463', '420', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('470003', '12', '1786', '2011', '465', '425', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('470004', '37', '1786', '2012', '460', '433', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('470005', '97', '1786', '2012', '466', '436', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('470006', '12', '1786', '2012', '457', '430', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('470007', '38', '1786', '2012', '478', '438', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('470008', '10', '1786', '2012', '478', '438', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('470009', '5', '1786', '2012', '465', '435', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('470010', '8', '1786', '2012', '473', '433', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('472919', '57', '8', '2011', '540', '534', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('472929', '50', '8', '2011', '526', '524', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('472962', '50', '8', '2013', '498', '498', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('472974', '57', '8', '2013', '508', '501', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('474273', '180', '8', '2011', '551', '534', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('474286', '57', '8', '2011', '540', '534', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('474312', '214', '8', '2011', '542', '530', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('474334', '214', '8', '2012', '515', '497', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('474346', '230', '8', '2012', '517', '504', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('474356', '180', '8', '2012', '508', '500', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('474391', '4237', '8', '2013', '499', '487', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('474652', '57', '8', '2011', '544', '531', '5', '1', '3');
INSERT INTO `major_recruit` VALUES ('476115', '270', '14', '2010', '527', '527', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('476125', '9', '14', '2010', '525', '525', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476137', '22', '14', '2010', '538', '533', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('476147', '293', '14', '2010', '528', '526', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('476161', '12', '14', '2010', '531', '525', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('476175', '74', '14', '2010', '527', '522', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('476189', '86', '14', '2010', '503', '487', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('476201', '5', '14', '2010', '535', '526', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476215', '14', '14', '2010', '538', '526', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476231', '61', '14', '2010', '539', '532', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('476243', '17', '14', '2010', '548', '536', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476256', '11', '14', '2010', '553', '533', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476264', '159', '14', '2010', '537', '531', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476278', '18', '14', '2010', '534', '530', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476286', '10', '14', '2010', '529', '529', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476302', '24', '14', '2010', '535', '528', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476307', '1', '14', '2010', '529', '528', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476319', '4', '14', '2010', '532', '527', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476344', '22', '14', '2011', '546', '516', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476360', '12', '14', '2011', '540', '536', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476372', '9', '14', '2011', '551', '526', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476384', '76', '14', '2011', '529', '529', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476393', '61', '14', '2011', '534', '534', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476402', '5', '14', '2011', '561', '531', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476405', '4', '14', '2011', '553', '533', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476421', '11', '14', '2011', '574', '540', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476434', '10', '14', '2011', '576', '540', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476442', '1', '14', '2011', '549', '528', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476473', '42', '14', '2012', '525', '495', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476480', '57', '14', '2012', '484', '484', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476493', '169', '14', '2012', '511', '500', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476502', '11', '14', '2012', '513', '502', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476509', '22', '14', '2012', '478', '478', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476519', '61', '14', '2012', '503', '503', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476530', '5', '14', '2012', '501', '501', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476559', '10', '14', '2013', '512', '512', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476568', '12', '14', '2013', '524', '517', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476578', '22', '14', '2013', '520', '514', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476588', '169', '14', '2013', '519', '501', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476598', '57', '14', '2013', '522', '497', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476610', '5', '14', '2013', '516', '493', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476625', '61', '14', '2013', '521', '504', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('476720', '58', '6', '2010', '550', '550', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('476728', '2', '6', '2010', '550', '550', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('477167', '85', '6', '2010', '538', '535', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('477175', '191', '6', '2010', '558', '558', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('477187', '129', '6', '2010', '534', '534', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('477198', '107', '6', '2010', '532', '532', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('477210', '105', '6', '2010', '569', '569', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('477219', '188', '6', '2010', '565', '549', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('478502', '14', '5', '2010', '551', '550', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('478505', '1', '5', '2010', '547', '547', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('478508', '49', '5', '2010', '546', '546', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('478511', '12', '5', '2010', '529', '529', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('478513', '10', '5', '2010', '543', '543', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('478516', '61', '5', '2010', '556', '556', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('478519', '4', '5', '2010', '560', '560', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('479045', '244', '5', '2010', '543', '543', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('479055', '134', '5', '2010', '543', '543', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('479068', '25', '5', '2010', '553', '553', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('479079', '49', '5', '2010', '547', '547', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('479092', '9', '5', '2010', '545', '539', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('479519', '22', '14', '2010', '548', '536', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('479530', '12', '14', '2010', '546', '528', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('479541', '10', '14', '2010', '535', '532', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479552', '24', '14', '2010', '536', '532', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479562', '11', '14', '2010', '549', '534', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479569', '150', '14', '2010', '545', '535', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479583', '74', '14', '2010', '540', '528', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('479597', '159', '14', '2010', '541', '536', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479607', '270', '14', '2010', '523', '523', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('479623', '76', '14', '2010', '535', '525', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479636', '61', '14', '2010', '535', '531', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('479646', '14', '14', '2010', '530', '526', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479658', '18', '14', '2010', '535', '526', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479670', '27', '14', '2010', '534', '526', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479683', '34', '14', '2010', '539', '529', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479700', '119', '14', '2010', '537', '529', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479712', '293', '14', '2010', '533', '533', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('479725', '5', '14', '2010', '538', '531', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479734', '38', '14', '2010', '536', '531', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479745', '30', '14', '2010', '534', '530', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479756', '2', '14', '2010', '549', '536', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479770', '17', '14', '2010', '551', '540', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479784', '71', '14', '2010', '548', '538', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479792', '9', '14', '2010', '537', '537', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479801', '52', '14', '2010', '541', '536', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479812', '86', '14', '2010', '513', '491', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('479829', '39', '14', '2010', '553', '536', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479880', '11', '14', '2011', '562', '533', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479889', '30', '14', '2011', '552', '525', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479898', '4', '14', '2011', '552', '522', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479908', '12', '14', '2011', '497', '497', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479917', '9', '14', '2011', '538', '516', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479930', '160', '14', '2011', '562', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479941', '76', '14', '2011', '565', '531', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479949', '119', '14', '2011', '558', '528', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479958', '39', '14', '2011', '566', '530', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479965', '61', '14', '2011', '556', '548', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479972', '5', '14', '2011', '557', '522', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479978', '10', '14', '2011', '547', '526', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479985', '121', '14', '2011', '556', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('479997', '412', '14', '2011', '558', '522', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('480010', '199', '14', '2011', '552', '522', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('480022', '38', '14', '2011', '554', '522', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('480098', '57', '14', '2012', '517', '506', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('480110', '263', '14', '2012', '523', '523', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('480127', '39', '14', '2012', '512', '509', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('480140', '169', '14', '2012', '525', '509', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('480150', '11', '14', '2012', '521', '517', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('480158', '180', '14', '2012', '557', '491', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('480170', '264', '14', '2012', '520', '502', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('480215', '61', '14', '2013', '465', '450', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('498319', '214', '8', '2011', '653', '640', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('498332', '180', '8', '2011', '642', '638', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('498339', '57', '8', '2011', '642', '639', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('498366', '180', '8', '2012', '661', '658', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('498379', '230', '8', '2012', '657', '655', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('498393', '214', '8', '2012', '664', '657', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('498412', '214', '8', '2013', '651', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('498421', '57', '8', '2013', '647', '644', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('498431', '4201', '8', '2013', '643', '638', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('498729', '57', '8', '2011', '642', '639', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('508359', '5', '6', '2010', '600', '600', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('508362', '57', '6', '2010', '598', '598', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('508365', '103', '6', '2010', '608', '606', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('508373', '103', '6', '2011', '630', '622', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('508375', '5', '6', '2011', '615', '615', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('508378', '58', '6', '2011', '615', '615', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('508389', '103', '6', '2012', '656', '655', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('508392', '10', '6', '2012', '648', '648', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('508401', '103', '6', '2013', '631', '628', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('509110', '94', '6', '2010', '631', '631', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509117', '183', '6', '2010', '643', '643', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('509121', '262', '6', '2010', '649', '647', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('509129', '103', '6', '2010', '656', '656', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509137', '27', '6', '2010', '651', '651', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509144', '121', '6', '2010', '662', '652', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509152', '36', '6', '2010', '655', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509162', '2', '6', '2010', '644', '644', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509171', '188', '6', '2010', '640', '640', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509180', '167', '6', '2010', '641', '641', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509188', '148', '6', '2010', '642', '640', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509196', '191', '6', '2010', '641', '640', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509203', '83', '6', '2010', '643', '640', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('509208', '174', '6', '2010', '639', '639', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509215', '129', '6', '2010', '643', '642', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509222', '113', '6', '2010', '643', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509227', '183', '6', '2010', '641', '641', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509234', '38', '6', '2010', '644', '644', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509240', '193', '6', '2010', '648', '644', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509249', '25', '6', '2010', '638', '638', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509256', '85', '6', '2010', '644', '644', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509264', '107', '6', '2010', '628', '628', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509272', '83', '6', '2010', '647', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509288', '36', '6', '2010', '641', '640', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('509305', '162', '6', '2011', '671', '666', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509315', '2', '6', '2011', '663', '663', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509325', '121', '6', '2011', '675', '671', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509333', '174', '6', '2011', '659', '655', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509342', '103', '6', '2011', '686', '682', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509351', '38', '6', '2011', '677', '677', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509358', '129', '6', '2011', '670', '665', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509371', '113', '6', '2011', '666', '666', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509381', '167', '6', '2011', '668', '665', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509390', '36', '6', '2011', '665', '665', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509399', '200', '6', '2011', '665', '662', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509406', '85', '6', '2011', '657', '657', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509413', '94', '6', '2011', '667', '665', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509428', '167', '6', '2012', '667', '666', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509436', '148', '6', '2012', '674', '674', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509444', '129', '6', '2012', '686', '684', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509452', '113', '6', '2012', '687', '684', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509459', '36', '6', '2012', '678', '677', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509467', '121', '6', '2012', '692', '687', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509477', '151', '6', '2012', '667', '667', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509488', '174', '6', '2012', '680', '680', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509497', '38', '6', '2012', '687', '687', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509503', '25', '6', '2012', '679', '679', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509510', '193', '6', '2012', '677', '677', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509516', '83', '6', '2012', '678', '677', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509520', '97', '6', '2012', '664', '664', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509529', '162', '6', '2012', '681', '678', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509539', '94', '6', '2012', '674', '674', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509548', '85', '6', '2012', '676', '669', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509559', '107', '6', '2012', '677', '677', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509579', '233', '6', '2013', '670', '668', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509589', '99', '6', '2013', '644', '644', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509595', '85', '6', '2013', '663', '658', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509604', '151', '6', '2013', '671', '671', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509617', '113', '6', '2013', '677', '676', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509624', '174', '6', '2013', '673', '673', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509630', '103', '6', '2013', '677', '677', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509636', '162', '6', '2013', '663', '663', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509640', '29', '6', '2013', '664', '664', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509646', '4211', '6', '2013', '680', '678', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509652', '105', '6', '2013', '684', '681', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509654', '3052', '6', '2013', '665', '664', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509660', '385', '6', '2013', '669', '669', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('509664', '1356', '6', '2013', '663', '663', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('510100', '4', '5', '2010', '597', '596', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510110', '17', '5', '2010', '607', '607', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510123', '18', '5', '2010', '604', '604', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510129', '5', '5', '2010', '612', '608', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510137', '11', '5', '2010', '602', '602', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510149', '10', '5', '2010', '602', '599', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510158', '14', '5', '2010', '598', '597', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510168', '9', '5', '2010', '596', '596', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510179', '42', '5', '2010', '627', '620', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510192', '2', '5', '2010', '626', '626', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510219', '9', '5', '2011', '610', '610', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510229', '14', '5', '2011', '617', '615', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510241', '5', '5', '2011', '622', '622', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510253', '42', '5', '2011', '635', '635', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510266', '2', '5', '2011', '627', '627', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510270', '4', '5', '2011', '612', '612', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510284', '18', '5', '2011', '617', '617', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510295', '17', '5', '2011', '620', '620', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510311', '10', '5', '2011', '613', '613', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510323', '11', '5', '2011', '617', '615', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510326', '15', '5', '2011', '615', '614', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510350', '15', '5', '2012', '654', '654', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510357', '11', '5', '2012', '651', '651', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510366', '4', '5', '2012', '656', '656', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510377', '1', '5', '2012', '646', '646', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510383', '17', '5', '2012', '660', '658', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510396', '2', '5', '2012', '662', '662', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510408', '10', '5', '2012', '649', '649', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510426', '42', '5', '2012', '658', '658', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510438', '9', '5', '2012', '646', '646', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510449', '14', '5', '2012', '647', '647', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510470', '308', '5', '2013', '626', '626', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510485', '10', '5', '2013', '622', '622', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510496', '4242', '5', '2013', '619', '619', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510512', '4209', '5', '2013', '620', '620', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510524', '14', '5', '2013', '621', '621', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510538', '4', '14', '2010', '589', '588', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510540', '4207', '5', '2013', '624', '624', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510549', '17', '14', '2010', '596', '595', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510556', '4206', '5', '2013', '628', '626', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510564', '5', '14', '2010', '591', '589', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510567', '5', '5', '2013', '628', '628', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510575', '14', '14', '2010', '592', '590', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510580', '4203', '5', '2013', '634', '634', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510588', '11', '14', '2010', '595', '594', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510601', '270', '14', '2010', '567', '567', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('510627', '11', '14', '2011', '606', '605', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510637', '1', '14', '2011', '601', '601', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510652', '5', '14', '2011', '601', '601', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510671', '5', '14', '2012', '639', '638', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510681', '57', '14', '2012', '640', '637', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510691', '169', '14', '2012', '644', '643', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510704', '11', '14', '2012', '642', '641', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510728', '5', '14', '2013', '612', '609', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510736', '4207', '14', '2013', '608', '608', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510749', '4242', '14', '2013', '609', '608', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510758', '4209', '14', '2013', '617', '612', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510768', '169', '14', '2013', '617', '614', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510779', '4206', '14', '2013', '616', '614', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('510788', '57', '14', '2013', '611', '609', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('511259', '235', '5', '2010', '636', '636', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511275', '255', '5', '2010', '636', '636', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511286', '34', '5', '2010', '639', '639', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511295', '121', '5', '2010', '648', '640', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511306', '244', '5', '2010', '636', '635', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511314', '17', '5', '2010', '653', '653', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511323', '25', '5', '2010', '653', '653', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511335', '2', '5', '2010', '663', '662', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511348', '180', '5', '2010', '668', '659', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511359', '150', '5', '2010', '637', '637', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511385', '134', '5', '2011', '657', '657', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511396', '34', '5', '2011', '660', '648', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511405', '119', '5', '2011', '661', '660', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511415', '180', '5', '2011', '672', '668', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511426', '2', '5', '2011', '690', '690', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511431', '39', '5', '2011', '657', '657', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511440', '121', '5', '2011', '662', '660', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511451', '150', '5', '2011', '661', '659', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511461', '34', '5', '2012', '677', '677', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511471', '119', '5', '2012', '675', '675', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511483', '39', '5', '2012', '681', '681', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511499', '2', '5', '2012', '688', '685', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511508', '150', '5', '2012', '675', '675', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511516', '180', '5', '2012', '685', '685', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511529', '121', '5', '2012', '684', '684', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511537', '25', '5', '2012', '669', '669', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511558', '4225', '5', '2013', '664', '664', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511569', '4211', '5', '2013', '668', '666', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511577', '4202', '5', '2013', '671', '671', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511585', '25', '5', '2013', '662', '662', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511590', '29', '5', '2013', '663', '663', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511597', '4201', '5', '2013', '673', '673', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511604', '4241', '5', '2013', '662', '662', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511614', '4227', '5', '2013', '664', '664', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511620', '4203', '5', '2013', '672', '672', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511816', '38', '14', '2010', '625', '624', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511822', '30', '14', '2010', '624', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511828', '39', '14', '2010', '626', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511834', '150', '14', '2010', '629', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511841', '27', '14', '2010', '632', '629', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511847', '2', '14', '2010', '632', '629', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511850', '17', '14', '2010', '634', '632', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511858', '34', '14', '2010', '626', '624', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511871', '121', '14', '2011', '649', '644', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511875', '39', '14', '2011', '653', '648', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511892', '27', '14', '2012', '669', '665', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511901', '231', '14', '2012', '659', '659', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511907', '263', '14', '2012', '668', '661', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511914', '261', '14', '2012', '663', '660', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511919', '264', '14', '2012', '668', '662', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511931', '30', '14', '2012', '664', '660', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511938', '169', '14', '2012', '673', '667', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511945', '39', '14', '2012', '664', '662', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511957', '169', '14', '2013', '661', '652', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511964', '264', '14', '2013', '654', '650', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511972', '4202', '14', '2013', '655', '654', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('511981', '263', '14', '2013', '652', '649', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('578621', '11', '22', '2010', '523', '511', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578638', '203', '22', '2010', '526', '507', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578650', '12', '22', '2010', '524', '504', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578657', '10', '22', '2010', '508', '501', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578672', '5', '22', '2010', '507', '495', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578688', '13', '22', '2010', '518', '500', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578700', '14', '22', '2010', '512', '499', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578713', '20', '22', '2010', '512', '500', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578726', '9', '22', '2010', '501', '496', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578759', '11', '22', '2011', '530', '517', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578773', '9', '22', '2011', '507', '504', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578786', '13', '22', '2011', '509', '505', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578795', '10', '22', '2011', '514', '508', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578810', '12', '22', '2011', '521', '510', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578828', '203', '22', '2011', '519', '510', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578844', '20', '22', '2011', '513', '504', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578856', '14', '22', '2011', '516', '505', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578870', '5', '22', '2011', '519', '506', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578898', '11', '22', '2012', '501', '485', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578909', '20', '22', '2012', '476', '474', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578930', '10', '22', '2012', '488', '478', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578940', '12', '22', '2012', '485', '479', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578944', '14', '22', '2012', '481', '477', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578958', '5', '22', '2012', '485', '475', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578968', '50', '22', '2012', '494', '480', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('578994', '10', '22', '2013', '496', '485', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('579010', '243', '22', '2013', '509', '509', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('579024', '12', '22', '2013', '503', '485', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('581763', '35', '22', '2010', '525', '517', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581777', '164', '22', '2010', '523', '513', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581789', '25', '22', '2010', '489', '489', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581799', '112', '22', '2010', '522', '513', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581811', '15', '22', '2010', '513', '507', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581819', '274', '22', '2010', '515', '513', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581838', '116', '22', '2010', '519', '513', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581855', '2', '22', '2010', '524', '512', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581862', '11', '22', '2010', '525', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581873', '61', '22', '2010', '525', '518', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581894', '248', '22', '2010', '524', '520', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581906', '55', '22', '2010', '521', '521', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581915', '17', '22', '2010', '523', '517', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581926', '129', '22', '2010', '527', '515', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581938', '121', '22', '2010', '524', '515', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581954', '243', '22', '2010', '523', '518', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581966', '107', '22', '2010', '524', '520', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581977', '134', '22', '2010', '520', '514', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('581992', '119', '22', '2010', '527', '514', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582004', '10', '22', '2010', '514', '514', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582013', '33', '22', '2010', '520', '511', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582025', '138', '22', '2010', '514', '511', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582043', '2', '22', '2010', '504', '488', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('582049', '34', '22', '2010', '534', '534', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582062', '68', '22', '2010', '522', '518', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582075', '37', '22', '2010', '506', '493', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('582091', '105', '22', '2010', '532', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582103', '39', '22', '2010', '521', '511', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582116', '203', '22', '2010', '510', '510', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582132', '27', '22', '2010', '515', '510', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582149', '208', '22', '2010', '511', '510', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582161', '30', '22', '2010', '515', '510', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582182', '189', '22', '2010', '520', '510', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582192', '132', '22', '2010', '523', '510', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582206', '185', '22', '2010', '517', '509', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582214', '211', '22', '2010', '512', '503', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582228', '254', '22', '2010', '490', '490', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582236', '150', '22', '2010', '518', '508', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582264', '129', '22', '2011', '536', '526', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582282', '119', '22', '2011', '528', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582299', '185', '22', '2011', '534', '528', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582311', '208', '22', '2011', '525', '525', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582325', '189', '22', '2011', '531', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582334', '150', '22', '2011', '527', '526', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582349', '35', '22', '2011', '534', '530', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582368', '39', '22', '2011', '533', '523', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582381', '61', '22', '2011', '543', '533', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582397', '17', '22', '2011', '534', '527', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582409', '2', '22', '2011', '535', '521', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582417', '203', '22', '2011', '525', '525', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582432', '211', '22', '2011', '531', '521', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582444', '132', '22', '2011', '530', '526', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582451', '138', '22', '2011', '532', '528', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582467', '68', '22', '2011', '537', '537', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582479', '34', '22', '2011', '548', '539', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582487', '164', '22', '2011', '532', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582498', '121', '22', '2011', '532', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582511', '134', '22', '2011', '529', '529', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582525', '274', '22', '2011', '526', '525', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582543', '243', '22', '2011', '538', '538', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582551', '116', '22', '2011', '535', '525', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582564', '107', '22', '2011', '541', '533', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582578', '30', '22', '2011', '528', '526', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582589', '55', '22', '2011', '541', '541', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582608', '248', '22', '2011', '542', '542', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582620', '112', '22', '2011', '539', '528', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582633', '33', '22', '2011', '525', '525', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582643', '25', '22', '2011', '531', '531', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582651', '105', '22', '2011', '557', '540', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582677', '248', '22', '2012', '510', '491', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582693', '34', '22', '2012', '489', '488', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582703', '107', '22', '2012', '502', '495', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582714', '134', '22', '2012', '511', '503', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582727', '12', '22', '2012', '493', '493', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582741', '61', '22', '2012', '497', '495', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582748', '164', '22', '2012', '494', '491', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582764', '11', '22', '2012', '497', '492', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582776', '342', '22', '2012', '495', '485', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582786', '10', '22', '2012', '494', '494', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582798', '2', '22', '2012', '492', '492', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582809', '27', '22', '2012', '493', '492', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582821', '33', '22', '2012', '499', '491', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582830', '150', '22', '2012', '504', '490', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582838', '112', '22', '2012', '491', '487', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582848', '30', '22', '2012', '499', '493', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582861', '17', '22', '2012', '498', '493', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582868', '55', '22', '2012', '504', '499', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582885', '25', '22', '2012', '498', '492', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582897', '121', '22', '2012', '499', '489', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582908', '35', '22', '2012', '477', '477', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582918', '39', '22', '2012', '499', '493', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582929', '189', '22', '2012', '491', '479', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582944', '185', '22', '2012', '493', '487', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582960', '116', '22', '2012', '494', '488', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582976', '61', '22', '2013', '492', '483', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('582989', '243', '22', '2013', '489', '489', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('614078', '55', '22', '2010', '621', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614084', '164', '22', '2010', '597', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614096', '105', '22', '2010', '633', '633', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614099', '232', '22', '2010', '602', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614109', '2', '22', '2010', '591', '581', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('614116', '129', '22', '2010', '633', '588', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('614123', '129', '22', '2010', '625', '616', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614130', '138', '22', '2010', '614', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614137', '150', '22', '2010', '600', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614142', '116', '22', '2010', '613', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614151', '17', '22', '2010', '605', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614157', '112', '22', '2010', '612', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614164', '30', '22', '2010', '611', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614172', '27', '22', '2010', '609', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614180', '134', '22', '2010', '608', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614189', '25', '22', '2010', '606', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614192', '119', '22', '2010', '610', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614195', '39', '22', '2010', '610', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614199', '2', '22', '2010', '601', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614205', '274', '22', '2010', '599', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614214', '107', '22', '2010', '615', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614219', '776', '22', '2010', '599', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614221', '33', '22', '2010', '598', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614227', '132', '22', '2010', '611', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614233', '35', '22', '2010', '613', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614236', '121', '22', '2010', '607', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614242', '68', '22', '2010', '612', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614249', '189', '22', '2010', '611', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614254', '211', '22', '2010', '610', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614261', '34', '22', '2010', '607', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614265', '185', '22', '2010', '611', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614278', '189', '22', '2011', '630', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614286', '164', '22', '2011', '625', '624', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614296', '107', '22', '2011', '633', '630', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614305', '25', '22', '2011', '632', '631', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614309', '129', '22', '2011', '642', '634', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614318', '134', '22', '2011', '626', '619', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614324', '27', '22', '2011', '624', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614332', '138', '22', '2011', '630', '630', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614335', '150', '22', '2011', '623', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614338', '232', '22', '2011', '630', '630', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614341', '185', '22', '2011', '635', '629', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614346', '116', '22', '2011', '632', '628', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614351', '34', '22', '2011', '630', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614357', '17', '22', '2011', '631', '629', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614363', '105', '22', '2011', '638', '638', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614373', '274', '22', '2011', '629', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614378', '15', '22', '2011', '623', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614385', '35', '22', '2011', '631', '624', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614392', '39', '22', '2011', '631', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614400', '119', '22', '2011', '631', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614408', '132', '22', '2011', '631', '631', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614415', '33', '22', '2011', '624', '624', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614419', '112', '22', '2011', '630', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614428', '248', '22', '2011', '630', '630', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614435', '55', '22', '2011', '640', '639', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614442', '30', '22', '2011', '630', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614450', '211', '22', '2011', '630', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614456', '121', '22', '2011', '630', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614463', '776', '22', '2011', '623', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614470', '2', '22', '2011', '632', '630', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614485', '68', '22', '2011', '625', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614519', '342', '22', '2012', '643', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614528', '150', '22', '2012', '641', '638', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614537', '107', '22', '2012', '652', '648', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614548', '121', '22', '2012', '648', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614562', '17', '22', '2012', '647', '644', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614576', '112', '22', '2012', '649', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614592', '25', '22', '2012', '645', '641', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614604', '164', '22', '2012', '645', '644', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614612', '27', '22', '2012', '643', '640', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614625', '189', '22', '2012', '648', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614636', '34', '22', '2012', '644', '642', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614650', '33', '22', '2012', '643', '641', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614659', '248', '22', '2012', '655', '655', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614669', '55', '22', '2012', '654', '654', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614678', '157', '22', '2012', '641', '641', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614688', '30', '22', '2012', '648', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614705', '116', '22', '2012', '649', '644', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614714', '39', '22', '2012', '643', '641', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614722', '134', '22', '2012', '639', '639', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614730', '15', '22', '2012', '641', '641', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614740', '2', '22', '2012', '650', '647', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614751', '35', '22', '2012', '653', '647', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614763', '185', '22', '2012', '649', '647', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614778', '274', '22', '2012', '642', '640', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614805', '351', '22', '2013', '637', '637', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614817', '483', '22', '2013', '638', '638', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614832', '385', '22', '2013', '634', '632', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614846', '214', '22', '2013', '654', '629', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614858', '57', '22', '2013', '633', '629', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614868', '27', '22', '2013', '627', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614880', '28', '22', '2013', '632', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614891', '180', '22', '2013', '634', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('614906', '4216', '22', '2013', '625', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('620595', '126', '27', '2010', '513', '512', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620600', '17', '27', '2010', '533', '530', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620605', '300', '27', '2010', '522', '522', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620609', '2', '27', '2010', '528', '525', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620616', '10', '27', '2010', '504', '501', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620621', '12', '27', '2010', '526', '522', '1', '5', '3');
INSERT INTO `major_recruit` VALUES ('620626', '18', '27', '2010', '522', '521', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620630', '5', '27', '2010', '530', '529', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620634', '21', '27', '2010', '535', '535', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620663', '8', '27', '2011', '537', '537', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620667', '2', '27', '2011', '544', '539', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620673', '21', '27', '2011', '545', '545', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620677', '18', '27', '2011', '540', '540', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620683', '300', '27', '2011', '533', '532', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620685', '11', '27', '2011', '549', '547', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620690', '10', '27', '2011', '532', '528', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620695', '126', '27', '2011', '539', '535', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620722', '11', '27', '2012', '503', '503', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620727', '8', '27', '2012', '511', '501', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620730', '18', '27', '2012', '507', '493', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620734', '10', '27', '2012', '496', '496', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620738', '5', '27', '2012', '497', '496', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620742', '2', '27', '2012', '502', '499', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620745', '21', '27', '2012', '502', '502', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620767', '21', '27', '2013', '509', '508', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620773', '10', '27', '2013', '522', '509', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('620778', '8', '27', '2013', '502', '489', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('621152', '34', '27', '2010', '501', '501', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621162', '8', '27', '2010', '534', '527', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621167', '56', '27', '2010', '524', '521', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621176', '136', '27', '2010', '520', '519', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621186', '2', '27', '2010', '544', '544', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621194', '26', '27', '2010', '535', '528', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621206', '11', '27', '2010', '527', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621215', '21', '27', '2010', '544', '544', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621228', '21', '27', '2011', '545', '545', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621237', '373', '27', '2011', '527', '526', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621247', '26', '27', '2011', '534', '529', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621258', '5', '27', '2011', '531', '531', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621264', '11', '27', '2011', '531', '531', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621272', '2', '27', '2011', '537', '537', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621279', '56', '27', '2011', '511', '511', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621286', '79', '27', '2011', '531', '529', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621296', '180', '27', '2011', '524', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621310', '34', '27', '2012', '489', '489', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621320', '180', '27', '2012', '500', '500', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621325', '79', '27', '2012', '496', '492', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621334', '56', '27', '2012', '496', '493', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621341', '21', '27', '2012', '501', '501', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621352', '373', '27', '2012', '492', '491', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621363', '2', '27', '2012', '504', '500', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621375', '21', '27', '2013', '494', '491', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621393', '56', '27', '2013', '481', '479', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('621411', '300', '27', '2013', '477', '476', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('629648', '17', '28', '2011', '483', '483', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('629661', '5', '28', '2011', '478', '478', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('629675', '10', '28', '2011', '487', '487', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('629704', '12', '28', '2013', '466', '463', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('629719', '65', '28', '2013', '476', '476', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('629727', '10', '28', '2013', '473', '470', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('630229', '109', '28', '2011', '483', '483', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630238', '94', '28', '2011', '506', '506', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630242', '30', '28', '2011', '494', '492', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630249', '132', '28', '2011', '494', '494', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630256', '151', '28', '2011', '488', '488', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630265', '107', '28', '2011', '515', '515', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630272', '38', '28', '2011', '483', '483', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630280', '88', '28', '2011', '482', '479', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630295', '280', '28', '2011', '490', '490', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630305', '148', '28', '2011', '484', '484', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630316', '378', '28', '2011', '482', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630326', '17', '28', '2011', '489', '489', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630339', '83', '28', '2011', '480', '480', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630352', '165', '28', '2011', '487', '485', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630363', '149', '28', '2011', '487', '487', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630375', '180', '28', '2011', '509', '509', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630391', '196', '28', '2011', '485', '485', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630399', '32', '28', '2011', '482', '481', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630412', '36', '28', '2011', '501', '494', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630423', '123', '28', '2011', '493', '493', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630434', '340', '28', '2011', '491', '491', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630445', '328', '28', '2011', '499', '499', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630461', '36', '28', '2012', '469', '469', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630470', '83', '28', '2012', '465', '465', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630481', '328', '28', '2012', '478', '478', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630490', '196', '28', '2012', '459', '459', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630500', '280', '28', '2012', '464', '464', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630516', '149', '28', '2012', '467', '466', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630525', '88', '28', '2012', '464', '461', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630543', '38', '28', '2012', '472', '472', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630551', '123', '28', '2012', '465', '465', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630561', '340', '28', '2012', '465', '465', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630572', '151', '28', '2012', '461', '461', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630582', '30', '28', '2012', '463', '461', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630594', '165', '28', '2012', '476', '471', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630611', '17', '28', '2012', '465', '465', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630619', '180', '28', '2012', '474', '474', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630632', '107', '28', '2012', '471', '471', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630647', '32', '28', '2012', '460', '460', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630654', '132', '28', '2012', '469', '469', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630664', '109', '28', '2012', '446', '446', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630684', '180', '28', '2013', '460', '457', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('630699', '113', '28', '2013', '452', '447', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('641602', '13', '31', '2010', '552', '551', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('641612', '69', '31', '2010', '554', '552', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('641621', '10', '31', '2010', '558', '555', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('641635', '5', '31', '2010', '556', '553', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('641649', '12', '31', '2010', '558', '554', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('641663', '17', '31', '2010', '562', '560', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('641686', '2', '31', '2011', '577', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('641698', '50', '31', '2011', '569', '567', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('641712', '13', '31', '2011', '569', '565', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('641720', '315', '31', '2011', '569', '568', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('641732', '386', '31', '2011', '574', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('641752', '2', '31', '2012', '609', '606', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('641762', '13', '31', '2012', '604', '598', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('641782', '50', '31', '2012', '605', '604', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('641794', '315', '31', '2012', '602', '601', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('641806', '386', '31', '2012', '610', '606', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('643188', '381', '31', '2010', '547', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643194', '68', '31', '2010', '560', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643204', '36', '31', '2010', '563', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643219', '34', '31', '2010', '559', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643229', '12', '31', '2010', '554', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643242', '48', '31', '2010', '566', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643262', '39', '31', '2010', '556', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643274', '156', '31', '2010', '558', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643283', '73', '31', '2010', '561', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643291', '85', '31', '2010', '561', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643300', '229', '31', '2010', '560', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643312', '161', '31', '2010', '560', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643324', '5', '31', '2010', '551', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643336', '99', '31', '2010', '550', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643348', '38', '31', '2010', '563', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643361', '88', '31', '2010', '560', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643373', '37', '31', '2010', '563', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643382', '185', '31', '2010', '573', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643392', '141', '31', '2010', '574', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643407', '164', '31', '2010', '568', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643417', '17', '31', '2010', '579', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643423', '2', '31', '2010', '579', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643434', '180', '31', '2010', '570', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643447', '129', '31', '2010', '565', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643459', '10', '31', '2010', '561', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643473', '143', '31', '2011', '585', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643482', '17', '31', '2011', '586', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643500', '13', '31', '2011', '573', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643515', '180', '31', '2011', '587', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643527', '94', '31', '2011', '600', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643539', '2', '31', '2011', '599', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643554', '50', '31', '2011', '582', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643573', '3722', '31', '2011', '575', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643585', '386', '31', '2011', '586', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643600', '315', '31', '2011', '580', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643612', '310', '31', '2011', '578', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643647', '13', '31', '2012', '602', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643658', '363', '31', '2012', '605', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643667', '38', '31', '2012', '598', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643680', '315', '31', '2012', '606', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643692', '37', '31', '2012', '601', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643702', '2', '31', '2012', '618', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643717', '94', '31', '2012', '612', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643729', '310', '31', '2012', '601', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643738', '386', '31', '2012', '606', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643752', '180', '31', '2012', '611', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643769', '3722', '31', '2012', '595', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643780', '17', '31', '2012', '612', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643799', '105', '31', '2013', '579', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643811', '233', '31', '2013', '577', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643818', '13', '31', '2013', '579', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643827', '310', '31', '2013', '577', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643835', '429', '31', '2013', '575', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643844', '113', '31', '2013', '581', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643859', '1356', '31', '2013', '574', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643874', '4357', '31', '2013', '586', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643886', '180', '31', '2013', '587', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('643901', '4203', '31', '2013', '587', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('646051', '21', '27', '2010', '596', '595', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646063', '17', '27', '2010', '594', '594', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646075', '8', '27', '2010', '593', '592', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646091', '300', '27', '2010', '592', '591', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646103', '12', '27', '2010', '582', '582', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('646114', '224', '27', '2010', '593', '590', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646124', '306', '27', '2010', '590', '588', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646133', '2', '27', '2010', '590', '588', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646143', '4', '27', '2010', '589', '588', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646156', '5', '27', '2010', '591', '591', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646165', '136', '27', '2010', '587', '586', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646188', '18', '27', '2010', '587', '586', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646197', '15', '27', '2010', '586', '586', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646209', '14', '27', '2010', '588', '586', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646237', '306', '27', '2011', '599', '599', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646246', '5', '27', '2011', '608', '607', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646256', '2', '27', '2011', '603', '603', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646266', '4', '27', '2011', '602', '600', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646276', '21', '27', '2011', '609', '608', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646288', '18', '27', '2011', '602', '601', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646300', '8', '27', '2011', '606', '605', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646312', '136', '27', '2011', '600', '599', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646324', '126', '27', '2011', '603', '602', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646340', '224', '27', '2011', '602', '602', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646349', '300', '27', '2011', '607', '606', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646365', '14', '27', '2011', '603', '601', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646376', '11', '27', '2011', '604', '603', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646388', '136', '27', '2012', '636', '634', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646396', '21', '27', '2012', '644', '643', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646399', '8', '27', '2012', '643', '641', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646410', '18', '27', '2012', '639', '637', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646420', '11', '27', '2012', '645', '643', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646424', '4', '27', '2012', '636', '635', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646435', '1', '27', '2012', '633', '632', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646444', '17', '27', '2012', '643', '642', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646451', '14', '27', '2012', '635', '634', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646457', '126', '27', '2012', '640', '640', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646465', '2', '27', '2012', '642', '641', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646469', '300', '27', '2012', '641', '639', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646478', '308', '27', '2012', '630', '630', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646495', '4207', '27', '2013', '605', '605', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646505', '308', '27', '2013', '609', '607', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646521', '4210', '27', '2013', '608', '607', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646533', '17', '27', '2013', '614', '613', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646543', '300', '27', '2013', '617', '614', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646554', '5', '27', '2013', '613', '611', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646573', '8', '27', '2013', '612', '611', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646581', '4209', '27', '2013', '609', '605', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('646592', '21', '27', '2013', '619', '618', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('647451', '16', '27', '2010', '622', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647456', '2', '27', '2010', '622', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647464', '17', '27', '2010', '627', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647471', '224', '27', '2010', '622', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647481', '26', '27', '2010', '621', '619', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647494', '52', '27', '2010', '618', '615', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647501', '15', '27', '2010', '616', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647512', '11', '27', '2010', '617', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647518', '180', '27', '2010', '618', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647525', '21', '27', '2010', '614', '613', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647536', '150', '27', '2010', '607', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647547', '221', '27', '2010', '632', '630', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647561', '61', '27', '2010', '620', '607', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('647581', '224', '27', '2011', '645', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647589', '136', '27', '2011', '639', '638', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647600', '5', '27', '2011', '644', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647610', '221', '27', '2011', '654', '653', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647619', '16', '27', '2011', '641', '640', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647625', '11', '27', '2011', '642', '639', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647636', '2', '27', '2011', '648', '645', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647647', '15', '27', '2011', '640', '638', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647658', '52', '27', '2011', '636', '635', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647666', '21', '27', '2011', '651', '651', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647677', '180', '27', '2011', '642', '638', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647687', '26', '27', '2011', '637', '636', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647701', '34', '27', '2012', '653', '652', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647717', '26', '27', '2012', '659', '656', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647729', '21', '27', '2012', '672', '671', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647737', '136', '27', '2012', '659', '655', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647748', '52', '27', '2012', '657', '654', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647761', '221', '27', '2012', '667', '665', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647770', '5', '27', '2012', '666', '659', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647783', '79', '27', '2012', '653', '652', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647794', '180', '27', '2012', '654', '652', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647800', '2', '27', '2012', '664', '662', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647817', '180', '27', '2013', '639', '638', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647824', '221', '27', '2013', '658', '656', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647836', '7', '27', '2013', '640', '640', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647842', '4342', '27', '2013', '652', '647', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647849', '8', '27', '2013', '650', '646', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('647855', '21', '27', '2013', '646', '642', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('665608', '5', '28', '2011', '574', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('665624', '61', '28', '2011', '575', '575', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('665633', '10', '28', '2011', '569', '568', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('665641', '8', '28', '2011', '577', '577', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('665649', '65', '28', '2011', '569', '569', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('665668', '5', '28', '2012', '610', '608', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('665680', '65', '28', '2012', '605', '605', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('665693', '10', '28', '2012', '605', '604', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('665707', '8', '28', '2012', '611', '611', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('665717', '61', '28', '2012', '605', '605', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('665741', '8', '28', '2013', '582', '582', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('665766', '5', '28', '2013', '572', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('665777', '10', '28', '2013', '572', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('665794', '61', '28', '2013', '572', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('668645', '8', '28', '2011', '607', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668654', '40', '28', '2011', '606', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668666', '141', '28', '2011', '605', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668674', '280', '28', '2011', '606', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668684', '83', '28', '2011', '618', '618', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668702', '165', '28', '2011', '612', '611', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668711', '38', '28', '2011', '608', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668725', '143', '28', '2011', '616', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668736', '107', '28', '2011', '620', '619', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668748', '260', '28', '2011', '604', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668761', '328', '28', '2011', '615', '613', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668774', '94', '28', '2011', '614', '613', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668785', '30', '28', '2011', '605', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668796', '85', '28', '2011', '602', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668814', '196', '28', '2011', '615', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668825', '39', '28', '2011', '608', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668842', '150', '28', '2011', '600', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668856', '32', '28', '2011', '604', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668869', '180', '28', '2011', '611', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668886', '112', '28', '2011', '608', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668899', '3', '28', '2011', '605', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668919', '148', '28', '2011', '600', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668935', '79', '28', '2011', '603', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668949', '134', '28', '2011', '614', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668962', '324', '28', '2011', '603', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668974', '378', '28', '2011', '612', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668984', '115', '28', '2011', '622', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('668995', '36', '28', '2011', '612', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669006', '127', '28', '2011', '612', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669017', '132', '28', '2011', '607', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669024', '80', '28', '2011', '605', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669040', '68', '28', '2011', '601', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669048', '317', '28', '2011', '600', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669061', '149', '28', '2011', '604', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669076', '123', '28', '2011', '608', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669085', '158', '28', '2011', '608', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669098', '184', '28', '2011', '603', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669115', '118', '28', '2011', '603', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669129', '17', '28', '2011', '618', '618', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669143', '376', '28', '2011', '610', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669154', '340', '28', '2011', '607', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669166', '332', '28', '2011', '619', '613', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669178', '151', '28', '2011', '605', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669203', '109', '28', '2011', '600', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669222', '118', '28', '2012', '622', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669238', '340', '28', '2012', '624', '624', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669251', '332', '28', '2012', '630', '628', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669263', '148', '28', '2012', '619', '619', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669271', '472', '28', '2012', '625', '624', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669283', '328', '28', '2012', '632', '631', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669302', '32', '28', '2012', '620', '619', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669315', '112', '28', '2012', '622', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669329', '30', '28', '2012', '620', '619', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669337', '134', '28', '2012', '625', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669358', '260', '28', '2012', '620', '619', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669369', '196', '28', '2012', '628', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669381', '165', '28', '2012', '629', '628', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669393', '79', '28', '2012', '619', '619', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669409', '115', '28', '2012', '636', '629', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669428', '3', '28', '2012', '625', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669444', '85', '28', '2012', '621', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669458', '324', '28', '2012', '634', '628', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669470', '376', '28', '2012', '623', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669484', '280', '28', '2012', '621', '620', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669492', '377', '28', '2012', '623', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669513', '378', '28', '2012', '622', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669522', '39', '28', '2012', '624', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669533', '149', '28', '2012', '621', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669551', '132', '28', '2012', '627', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669568', '150', '28', '2012', '621', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669584', '317', '28', '2012', '621', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669588', '141', '28', '2012', '632', '628', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669602', '83', '28', '2012', '633', '633', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669618', '109', '28', '2012', '621', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669638', '68', '28', '2012', '623', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669648', '80', '28', '2012', '624', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669664', '107', '28', '2012', '637', '635', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669687', '8', '28', '2012', '625', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669698', '17', '28', '2012', '634', '634', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669713', '158', '28', '2012', '626', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669725', '123', '28', '2012', '624', '624', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669733', '38', '28', '2012', '624', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669747', '143', '28', '2012', '631', '630', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669766', '180', '28', '2012', '627', '624', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669775', '36', '28', '2012', '632', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669786', '127', '28', '2012', '629', '628', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669806', '151', '28', '2012', '623', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669821', '8', '28', '2013', '602', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669828', '174', '28', '2013', '608', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669845', '238', '28', '2013', '601', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669856', '151', '28', '2013', '605', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669874', '4211', '28', '2013', '616', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669881', '4224', '28', '2013', '607', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669894', '1356', '28', '2013', '607', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669908', '522', '28', '2013', '602', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669919', '4214', '28', '2013', '593', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669937', '4349', '28', '2013', '616', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669944', '88', '28', '2013', '601', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669958', '4327', '28', '2013', '596', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669966', '83', '28', '2013', '596', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669976', '4202', '28', '2013', '592', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669985', '382', '28', '2013', '602', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('669997', '141', '28', '2013', '600', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('670009', '180', '28', '2013', '619', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('670019', '17', '28', '2013', '600', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('670030', '2448', '28', '2013', '608', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('670041', '385', '28', '2013', '620', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('731766', '17', '44', '2010', '525', '525', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731767', '5', '44', '2010', '528', '525', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731768', '10', '44', '2010', '532', '529', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731769', '61', '44', '2010', '524', '523', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731770', '15', '44', '2010', '524', '522', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731771', '12', '44', '2011', '549', '525', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731772', '61', '44', '2011', '539', '527', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731773', '13', '44', '2011', '556', '524', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731774', '5', '44', '2011', '539', '520', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731775', '17', '44', '2011', '554', '543', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731776', '52', '44', '2011', '536', '515', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731777', '67', '44', '2011', '550', '538', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731778', '10', '44', '2011', '545', '524', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731779', '15', '44', '2011', '541', '527', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731780', '4416', '44', '2011', '539', '519', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731781', '5', '44', '2012', '503', '490', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731782', '10', '44', '2012', '512', '493', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731783', '61', '44', '2012', '520', '501', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731784', '17', '44', '2012', '534', '504', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731785', '13', '44', '2012', '509', '490', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731786', '4416', '44', '2012', '505', '497', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731787', '15', '44', '2012', '500', '485', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731788', '52', '44', '2012', '501', '493', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731789', '67', '44', '2012', '523', '494', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731790', '12', '44', '2012', '508', '490', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731791', '5', '44', '2013', '508', '490', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731792', '12', '44', '2013', '510', '489', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731793', '61', '44', '2013', '519', '495', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('731794', '10', '44', '2013', '504', '492', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('732122', '150', '44', '2010', '518', '510', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732124', '342', '44', '2010', '533', '528', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732126', '387', '44', '2010', '523', '505', '2', '5', '3');
INSERT INTO `major_recruit` VALUES ('732128', '30', '44', '2010', '535', '527', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732130', '12', '44', '2010', '523', '521', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732132', '116', '44', '2010', '541', '527', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732134', '71', '44', '2010', '535', '521', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732136', '185', '44', '2010', '532', '525', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732138', '68', '44', '2010', '524', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732140', '396', '44', '2010', '537', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732143', '34', '44', '2010', '535', '529', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732144', '83', '44', '2010', '534', '529', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732147', '15', '44', '2010', '536', '529', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732149', '25', '44', '2010', '542', '530', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732151', '202', '44', '2010', '537', '530', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732154', '97', '44', '2010', '539', '531', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732156', '88', '44', '2010', '531', '531', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732158', '61', '44', '2010', '529', '529', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732160', '67', '44', '2010', '532', '532', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732161', '105', '44', '2010', '537', '532', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732163', '121', '44', '2010', '542', '541', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732164', '190', '44', '2010', '542', '540', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732167', '10', '44', '2010', '539', '539', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732168', '194', '44', '2010', '548', '534', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732170', '94', '44', '2010', '537', '533', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732173', '121', '44', '2011', '547', '532', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732174', '94', '44', '2011', '555', '534', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732175', '30', '44', '2011', '555', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732176', '150', '44', '2011', '527', '527', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732177', '68', '44', '2011', '540', '512', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732178', '34', '44', '2011', '551', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732179', '5', '44', '2011', '541', '515', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732180', '17', '44', '2011', '570', '530', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732181', '12', '44', '2011', '561', '530', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732182', '71', '44', '2011', '547', '538', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732183', '396', '44', '2011', '567', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732184', '61', '44', '2011', '536', '511', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732185', '97', '44', '2011', '546', '518', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732186', '116', '44', '2011', '575', '527', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732187', '185', '44', '2011', '544', '522', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732188', '83', '44', '2011', '558', '523', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732189', '190', '44', '2011', '561', '531', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732190', '202', '44', '2011', '543', '528', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732191', '194', '44', '2011', '538', '515', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732192', '15', '44', '2011', '541', '522', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732193', '88', '44', '2011', '556', '509', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732194', '25', '44', '2011', '558', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732195', '4416', '44', '2011', '522', '511', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732196', '67', '44', '2011', '539', '519', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732197', '164', '44', '2011', '554', '550', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732198', '363', '44', '2011', '568', '525', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732200', '10', '44', '2011', '564', '530', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732202', '105', '44', '2011', '550', '522', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732204', '342', '44', '2011', '561', '528', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732206', '194', '44', '2012', '511', '485', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732207', '30', '44', '2012', '515', '491', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732210', '5', '44', '2012', '517', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732213', '363', '44', '2012', '540', '493', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732215', '396', '44', '2012', '514', '494', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732217', '116', '44', '2012', '525', '489', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732219', '10', '44', '2012', '508', '494', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732221', '68', '44', '2012', '516', '484', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732223', '342', '44', '2012', '530', '493', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732225', '94', '44', '2012', '530', '489', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732226', '105', '44', '2012', '510', '491', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732228', '185', '44', '2012', '527', '493', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732231', '88', '44', '2012', '523', '500', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732232', '67', '44', '2012', '505', '495', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732234', '97', '44', '2012', '507', '491', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732236', '4416', '44', '2012', '498', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732237', '17', '44', '2012', '525', '496', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732239', '34', '44', '2012', '526', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732241', '180', '44', '2012', '520', '505', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732244', '214', '44', '2012', '517', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732245', '190', '44', '2012', '534', '494', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732247', '202', '44', '2012', '528', '490', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732249', '150', '44', '2012', '512', '483', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732251', '25', '44', '2012', '508', '489', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732253', '121', '44', '2012', '525', '500', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732255', '71', '44', '2012', '510', '493', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732257', '83', '44', '2012', '525', '489', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732259', '15', '44', '2012', '506', '492', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732261', '61', '44', '2012', '521', '494', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732262', '12', '44', '2012', '505', '484', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732267', '105', '44', '2013', '493', '476', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732268', '10', '44', '2013', '505', '481', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732269', '194', '44', '2013', '513', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732271', '97', '44', '2013', '539', '487', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732272', '88', '44', '2013', '531', '490', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732276', '5', '44', '2013', '495', '464', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732277', '61', '44', '2013', '494', '467', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732279', '12', '44', '2013', '512', '468', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('732281', '83', '44', '2013', '504', '474', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('737268', '21', '45', '2010', '536', '522', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737272', '3', '45', '2010', '541', '520', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737276', '17', '45', '2010', '530', '518', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737280', '2', '45', '2010', '516', '512', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737283', '311', '45', '2010', '519', '516', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737286', '23', '45', '2010', '518', '515', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737290', '12', '45', '2010', '518', '515', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737293', '8', '45', '2010', '520', '515', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737299', '339', '45', '2010', '520', '513', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737302', '63', '45', '2010', '517', '512', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737305', '5', '45', '2010', '512', '510', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737309', '15', '45', '2010', '512', '510', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737312', '7', '45', '2010', '519', '514', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737317', '14', '45', '2010', '513', '508', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737327', '139', '45', '2010', '515', '514', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737334', '178', '45', '2010', '491', '491', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737335', '58', '45', '2010', '521', '514', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737406', '17', '45', '2011', '536', '528', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737412', '21', '45', '2011', '542', '535', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737416', '7', '45', '2011', '525', '523', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737421', '58', '45', '2011', '527', '521', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737429', '139', '45', '2011', '524', '522', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737439', '5', '45', '2011', '525', '514', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737444', '266', '45', '2011', '523', '519', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737449', '23', '45', '2011', '534', '527', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737454', '3', '45', '2011', '548', '531', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737461', '8', '45', '2011', '534', '528', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737466', '14', '45', '2011', '527', '527', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737472', '311', '45', '2011', '530', '524', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737476', '15', '45', '2011', '527', '522', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737480', '2', '45', '2011', '528', '519', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737484', '178', '45', '2011', '521', '521', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737488', '339', '45', '2011', '529', '522', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737494', '139', '45', '2012', '495', '490', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737497', '21', '45', '2012', '505', '498', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737501', '136', '45', '2012', '485', '484', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737505', '43', '45', '2012', '494', '484', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737509', '266', '45', '2012', '488', '485', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737512', '178', '45', '2012', '492', '479', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737517', '339', '45', '2012', '476', '475', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737521', '14', '45', '2012', '489', '483', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737524', '5', '45', '2012', '486', '483', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737530', '311', '45', '2012', '495', '490', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737534', '58', '45', '2012', '487', '482', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737537', '8', '45', '2012', '508', '494', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737543', '7', '45', '2012', '501', '488', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737548', '23', '45', '2012', '497', '491', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737555', '2', '45', '2012', '498', '485', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737560', '3', '45', '2012', '516', '499', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737564', '17', '45', '2012', '493', '487', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737574', '21', '45', '2013', '507', '498', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737578', '58', '45', '2013', '490', '489', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737582', '14', '45', '2013', '494', '491', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737587', '7', '45', '2013', '499', '491', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737591', '8', '45', '2013', '495', '489', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('737595', '5', '45', '2013', '493', '488', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('738166', '101', '45', '2010', '513', '510', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738172', '12', '45', '2010', '511', '510', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738178', '5', '45', '2010', '513', '505', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738183', '16', '45', '2010', '514', '507', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738189', '2', '45', '2010', '521', '510', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738195', '266', '45', '2010', '525', '512', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738201', '7', '45', '2010', '523', '513', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738208', '339', '45', '2010', '519', '513', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738212', '139', '45', '2010', '520', '513', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738219', '8', '45', '2010', '522', '514', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738225', '311', '45', '2010', '522', '516', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738231', '354', '45', '2010', '524', '516', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738236', '23', '45', '2010', '523', '518', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738241', '17', '45', '2010', '523', '513', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738246', '21', '45', '2010', '544', '520', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738254', '97', '45', '2010', '517', '512', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738260', '58', '45', '2010', '516', '506', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738266', '79', '45', '2010', '513', '507', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738271', '89', '45', '2010', '514', '509', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738277', '38', '45', '2010', '515', '509', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738285', '14', '45', '2010', '511', '509', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738292', '178', '45', '2010', '509', '508', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738300', '221', '45', '2010', '540', '522', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738307', '213', '45', '2010', '519', '510', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738313', '3', '45', '2010', '546', '520', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738317', '15', '45', '2010', '512', '508', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738328', '15', '45', '2011', '519', '515', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738332', '311', '45', '2011', '528', '522', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738340', '339', '45', '2011', '523', '519', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738345', '38', '45', '2011', '519', '514', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738351', '3', '45', '2011', '544', '528', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738359', '16', '45', '2011', '526', '517', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738363', '8', '45', '2011', '531', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738366', '101', '45', '2011', '520', '513', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738371', '178', '45', '2011', '520', '515', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738376', '5', '45', '2011', '520', '507', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738383', '97', '45', '2011', '526', '517', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738387', '139', '45', '2011', '524', '515', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738393', '213', '45', '2011', '523', '517', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738397', '354', '45', '2011', '548', '525', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738400', '58', '45', '2011', '522', '514', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738403', '221', '45', '2011', '541', '532', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738404', '266', '45', '2011', '539', '521', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738408', '2', '45', '2011', '523', '515', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738412', '23', '45', '2011', '545', '525', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738416', '89', '45', '2011', '523', '510', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738420', '17', '45', '2011', '531', '521', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738423', '21', '45', '2011', '543', '527', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738427', '79', '45', '2011', '524', '515', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738429', '14', '45', '2011', '523', '513', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738431', '7', '45', '2011', '530', '524', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738435', '266', '45', '2012', '497', '490', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738438', '7', '45', '2012', '492', '487', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738439', '38', '45', '2012', '487', '483', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738442', '139', '45', '2012', '490', '485', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738445', '178', '45', '2012', '490', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738448', '21', '45', '2012', '511', '497', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738451', '3', '45', '2012', '509', '494', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738454', '79', '45', '2012', '487', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738457', '43', '45', '2012', '487', '481', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738461', '221', '45', '2012', '502', '490', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738464', '58', '45', '2012', '489', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738467', '14', '45', '2012', '484', '478', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738471', '339', '45', '2012', '488', '485', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738473', '97', '45', '2012', '491', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738478', '5', '45', '2012', '487', '482', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738482', '101', '45', '2012', '487', '484', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738487', '354', '45', '2012', '499', '489', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738491', '213', '45', '2012', '494', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738493', '16', '45', '2012', '490', '485', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738496', '311', '45', '2012', '499', '490', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738501', '8', '45', '2012', '494', '486', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738505', '23', '45', '2012', '502', '488', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738510', '89', '45', '2012', '490', '483', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738513', '17', '45', '2012', '507', '487', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738516', '2', '45', '2012', '489', '485', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738522', '21', '45', '2013', '508', '484', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738525', '8', '45', '2013', '482', '477', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738530', '354', '45', '2013', '484', '476', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738531', '17', '45', '2013', '486', '476', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738533', '7', '45', '2013', '479', '475', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738535', '58', '45', '2013', '479', '473', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738539', '14', '45', '2013', '473', '473', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738543', '97', '45', '2013', '475', '472', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738547', '5', '45', '2013', '475', '472', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738550', '101', '45', '2013', '472', '469', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738554', '221', '45', '2013', '504', '494', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738561', '339', '45', '2013', '474', '469', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('738566', '213', '45', '2013', '484', '473', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('741352', '52', '44', '2010', '568', '568', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('741356', '5', '44', '2010', '565', '565', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('741369', '67', '44', '2011', '594', '594', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('741382', '17', '44', '2012', '637', '637', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('741387', '4203', '44', '2013', '611', '610', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('742359', '83', '44', '2010', '631', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742363', '387', '44', '2010', '620', '608', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('742367', '190', '44', '2010', '627', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742372', '97', '44', '2010', '625', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742377', '31', '44', '2010', '632', '628', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742379', '121', '44', '2010', '637', '634', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742387', '94', '44', '2010', '635', '634', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742392', '30', '44', '2010', '631', '631', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742397', '116', '44', '2010', '635', '629', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742403', '25', '44', '2010', '629', '629', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742408', '185', '44', '2010', '631', '629', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742419', '116', '44', '2011', '654', '648', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742424', '185', '44', '2011', '653', '647', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742429', '83', '44', '2011', '650', '647', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742433', '121', '44', '2011', '654', '653', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742438', '97', '44', '2011', '646', '646', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742442', '25', '44', '2011', '642', '642', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742444', '94', '44', '2011', '655', '652', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742450', '30', '44', '2011', '647', '645', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742452', '34', '44', '2011', '643', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742454', '31', '44', '2011', '645', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742461', '17', '44', '2012', '665', '663', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742465', '180', '44', '2012', '673', '669', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742469', '190', '44', '2012', '662', '662', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742472', '121', '44', '2012', '667', '667', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742476', '215', '44', '2012', '663', '663', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742479', '97', '44', '2012', '664', '662', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742484', '31', '44', '2012', '663', '661', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742487', '94', '44', '2012', '672', '670', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742489', '150', '44', '2012', '660', '660', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742494', '185', '44', '2012', '666', '664', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742499', '116', '44', '2012', '671', '666', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742502', '363', '44', '2012', '651', '651', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742507', '83', '44', '2012', '665', '663', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742523', '1356', '44', '2013', '661', '656', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742526', '4201', '44', '2013', '655', '650', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742529', '336', '44', '2013', '648', '648', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742541', '97', '44', '2013', '649', '649', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742547', '151', '44', '2013', '656', '644', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742552', '4203', '44', '2013', '653', '652', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742554', '4229', '44', '2013', '650', '649', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742560', '4231', '44', '2013', '656', '650', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('742566', '4211', '44', '2013', '655', '649', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('743654', '10', '48', '2011', '471', '471', '1', '1', '3');
INSERT INTO `major_recruit` VALUES ('743842', '27', '48', '2012', '440', '440', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('744516', '28', '48', '2013', '411', '408', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('744521', '151', '48', '2013', '411', '411', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('744526', '95', '48', '2013', '412', '412', '2', '1', '3');
INSERT INTO `major_recruit` VALUES ('748640', '311', '45', '2010', '574', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('748646', '21', '45', '2010', '581', '578', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('748650', '5', '45', '2010', '569', '568', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('748661', '15', '45', '2010', '571', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('748664', '2', '45', '2011', '592', '591', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('748670', '3', '45', '2011', '594', '594', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('748676', '8', '45', '2011', '593', '592', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('748678', '5', '45', '2011', '591', '590', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('748684', '8', '45', '2012', '630', '629', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('748686', '7', '45', '2012', '632', '631', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('748701', '21', '45', '2012', '630', '630', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('748706', '23', '45', '2012', '634', '631', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('748715', '14', '45', '2013', '599', '598', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('748726', '3874', '45', '2013', '602', '600', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('748734', '4282', '45', '2013', '603', '603', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('748806', '12', '51', '2010', '576', '574', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('748816', '3', '51', '2010', '584', '583', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('748825', '52', '51', '2010', '573', '572', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('748831', '1', '51', '2010', '574', '572', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('748841', '126', '51', '2010', '576', '575', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('748851', '2', '51', '2010', '580', '579', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('748859', '13', '51', '2010', '603', '579', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('748871', '21', '51', '2010', '591', '590', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('748878', '8', '51', '2010', '593', '587', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('748885', '51', '51', '2010', '598', '586', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('748891', '10', '51', '2010', '588', '584', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('748900', '5', '51', '2010', '578', '577', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('749089', '150', '51', '2010', '600', '598', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749091', '2', '45', '2010', '603', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749097', '175', '51', '2010', '631', '614', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749100', '89', '45', '2010', '602', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749105', '10', '51', '2010', '623', '614', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749108', '213', '45', '2010', '605', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749111', '119', '51', '2010', '620', '616', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749113', '23', '45', '2010', '609', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749116', '26', '51', '2010', '617', '604', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749125', '124', '51', '2010', '608', '604', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749127', '3', '45', '2010', '619', '615', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749132', '79', '45', '2010', '607', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749135', '418', '51', '2010', '619', '617', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749139', '17', '51', '2010', '632', '619', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749144', '17', '45', '2010', '606', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749148', '34', '51', '2010', '611', '604', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749151', '16', '45', '2010', '602', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749156', '79', '51', '2010', '601', '600', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749162', '58', '45', '2011', '627', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749163', '8', '51', '2010', '631', '620', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749168', '415', '51', '2010', '604', '599', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749174', '15', '45', '2011', '630', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749178', '89', '45', '2011', '628', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749181', '417', '51', '2010', '614', '607', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749183', '221', '45', '2011', '638', '634', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749188', '354', '45', '2011', '628', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749189', '97', '51', '2010', '629', '611', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749194', '76', '51', '2010', '611', '607', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749195', '17', '45', '2011', '630', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749202', '126', '51', '2010', '608', '607', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749204', '16', '45', '2011', '629', '629', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749212', '3', '45', '2011', '633', '632', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749213', '21', '51', '2010', '620', '613', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749218', '5', '51', '2010', '606', '606', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('749223', '2', '45', '2012', '647', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749231', '3', '45', '2012', '655', '652', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749239', '5', '45', '2012', '638', '635', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749247', '89', '45', '2012', '644', '640', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749252', '16', '45', '2012', '648', '644', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749259', '38', '45', '2012', '644', '637', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749263', '17', '45', '2012', '653', '650', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749271', '3774', '45', '2013', '618', '616', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749278', '5', '45', '2013', '617', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749286', '17', '45', '2013', '632', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('749484', '10', '48', '2010', '537', '526', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749493', '12', '48', '2010', '531', '526', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749504', '61', '48', '2010', '537', '527', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749513', '2', '48', '2010', '535', '527', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749521', '3', '48', '2010', '532', '527', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749527', '5', '48', '2010', '542', '528', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749536', '17', '48', '2010', '543', '529', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749543', '11', '48', '2010', '539', '529', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749553', '56', '48', '2010', '499', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('749557', '10', '48', '2010', '512', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('749569', '24', '48', '2010', '518', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('749580', '13', '48', '2010', '504', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('749588', '86', '48', '2010', '511', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('749595', '52', '48', '2010', '549', '525', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749604', '43', '48', '2010', '534', '525', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749612', '1', '48', '2010', '526', '522', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749622', '86', '48', '2010', '530', '522', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749632', '9', '48', '2010', '524', '523', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749639', '65', '48', '2010', '529', '523', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749644', '51', '48', '2010', '526', '523', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749654', '64', '48', '2010', '527', '523', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749666', '4', '48', '2010', '542', '525', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749675', '22', '48', '2010', '530', '525', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749684', '56', '48', '2010', '532', '525', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749693', '24', '48', '2010', '531', '525', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749706', '3439', '48', '2010', '511', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('749717', '12', '48', '2011', '548', '538', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749724', '24', '48', '2011', '540', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749739', '1', '48', '2011', '542', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749742', '17', '48', '2011', '554', '541', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749750', '64', '48', '2011', '539', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749760', '86', '48', '2011', '524', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('749769', '61', '48', '2011', '554', '539', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749779', '24', '48', '2011', '491', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('749786', '120', '48', '2011', '512', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('749796', '52', '48', '2011', '540', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749808', '51', '48', '2011', '535', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749817', '9', '48', '2011', '541', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749829', '65', '48', '2011', '565', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749842', '56', '48', '2011', '540', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749851', '5', '48', '2011', '558', '540', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749862', '11', '48', '2011', '552', '541', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749870', '86', '48', '2011', '548', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749880', '22', '48', '2011', '542', '538', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749893', '3439', '48', '2011', '513', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('749900', '2', '48', '2011', '569', '543', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749911', '13', '48', '2011', '507', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('749917', '56', '48', '2011', '509', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('749924', '10', '48', '2011', '512', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('749933', '10', '48', '2011', '568', '541', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749943', '4', '48', '2011', '543', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749947', '3', '48', '2011', '559', '541', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749952', '57', '57', '2012', '616', '611', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749953', '3', '48', '2011', '503', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('749961', '43', '48', '2011', '543', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749968', '57', '57', '2013', '580', '577', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749971', '44', '48', '2011', '556', '541', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749979', '2', '48', '2012', '609', '580', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('749986', '10', '48', '2012', '555', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('750000', '86', '48', '2012', '561', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('750005', '22', '48', '2012', '581', '580', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750014', '61', '48', '2012', '594', '580', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750024', '86', '48', '2012', '573', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750026', '11', '48', '2012', '590', '580', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750037', '9', '48', '2012', '582', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750045', '56', '48', '2012', '582', '575', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750057', '12', '48', '2012', '599', '578', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750068', '56', '48', '2012', '540', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('750081', '51', '48', '2012', '580', '576', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750090', '1', '48', '2012', '577', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750099', '578', '48', '2012', '575', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750107', '4', '48', '2012', '598', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750110', '3439', '48', '2012', '553', '532', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('750122', '64', '48', '2012', '579', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750131', '52', '48', '2012', '567', '541', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('750139', '17', '48', '2012', '612', '580', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750148', '13', '48', '2012', '565', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('750159', '5', '48', '2012', '594', '578', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750170', '52', '48', '2012', '579', '575', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750185', '65', '48', '2012', '577', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750197', '24', '48', '2012', '579', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750205', '10', '48', '2012', '584', '578', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750213', '3', '48', '2012', '547', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('750217', '3', '48', '2012', '587', '579', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750231', '24', '48', '2012', '530', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('750244', '43', '48', '2012', '584', '576', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750254', '120', '48', '2012', '526', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('750263', '44', '48', '2013', '546', '543', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750274', '5', '48', '2013', '562', '543', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750286', '4246', '48', '2013', '555', '543', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750297', '51', '48', '2013', '553', '540', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750308', '4209', '48', '2013', '543', '539', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750312', '74', '59', '2010', '555', '555', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('750318', '293', '48', '2013', '543', '539', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750321', '428', '59', '2010', '562', '562', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('750323', '22', '48', '2013', '563', '545', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750331', '1', '59', '2010', '564', '562', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('750337', '56', '48', '2013', '548', '538', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750342', '10', '59', '2010', '567', '563', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('750345', '12', '48', '2013', '541', '538', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750352', '13', '59', '2010', '574', '567', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('750354', '4207', '48', '2013', '547', '538', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750360', '357', '59', '2010', '573', '569', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('750364', '65', '48', '2013', '542', '538', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750370', '12', '59', '2010', '573', '571', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('750375', '4206', '48', '2013', '556', '543', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750380', '126', '59', '2010', '574', '574', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('750382', '4203', '48', '2013', '564', '544', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750387', '86', '48', '2013', '519', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('750389', '2', '59', '2010', '580', '578', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('750398', '10', '48', '2013', '493', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('750399', '63', '59', '2010', '582', '582', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('750407', '22', '59', '2010', '578', '577', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('750415', '4373', '48', '2013', '563', '545', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750420', '61', '48', '2013', '546', '544', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750429', '578', '48', '2013', '542', '538', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750437', '86', '48', '2013', '539', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750445', '10', '48', '2013', '550', '542', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750456', '4242', '48', '2013', '540', '537', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750597', '16', '59', '2010', '604', '602', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750606', '21', '59', '2010', '605', '601', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750612', '34', '59', '2010', '596', '596', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750621', '2', '59', '2010', '596', '594', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750631', '39', '59', '2010', '603', '594', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750641', '143', '59', '2010', '598', '592', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750650', '79', '59', '2010', '602', '590', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750659', '30', '59', '2010', '601', '589', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750669', '10', '59', '2010', '595', '589', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750678', '279', '59', '2010', '597', '588', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750687', '25', '59', '2010', '584', '582', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750698', '202', '59', '2010', '584', '582', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750713', '123', '59', '2010', '582', '582', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750723', '175', '59', '2010', '593', '585', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750730', '150', '59', '2010', '596', '585', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750739', '38', '59', '2010', '597', '585', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750754', '140', '59', '2010', '588', '586', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750763', '161', '59', '2010', '590', '586', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750773', '275', '59', '2010', '592', '586', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750785', '56', '59', '2010', '589', '586', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750792', '97', '59', '2010', '594', '588', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750799', '281', '59', '2010', '580', '580', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('750915', '10', '61', '2010', '558', '557', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750924', '12', '61', '2010', '559', '558', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750933', '52', '61', '2010', '563', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750945', '10', '61', '2011', '576', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750954', '12', '61', '2011', '575', '568', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750968', '52', '61', '2011', '559', '555', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750982', '12', '61', '2012', '600', '599', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750990', '10', '61', '2012', '612', '606', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('750999', '52', '61', '2012', '605', '602', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('751009', '12', '61', '2013', '566', '564', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('751018', '10', '61', '2013', '577', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('751545', '94', '57', '2011', '627', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751548', '150', '57', '2011', '621', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751558', '39', '57', '2011', '622', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751568', '332', '57', '2011', '630', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751573', '38', '57', '2011', '630', '628', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751583', '112', '57', '2011', '623', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751587', '34', '57', '2011', '621', '620', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751596', '30', '57', '2011', '625', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751606', '424', '57', '2011', '623', '619', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751611', '180', '57', '2011', '634', '630', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751619', '164', '57', '2011', '622', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751627', '37', '57', '2011', '628', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751638', '21', '57', '2011', '619', '619', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751646', '129', '57', '2011', '624', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751653', '328', '57', '2011', '633', '628', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751663', '83', '57', '2011', '629', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751669', '68', '57', '2011', '623', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751680', '36', '57', '2011', '628', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751684', '88', '57', '2011', '621', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751692', '115', '57', '2011', '625', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751700', '83', '57', '2012', '643', '641', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751706', '112', '57', '2012', '647', '642', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751725', '37', '57', '2012', '646', '642', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751736', '68', '57', '2012', '639', '639', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751746', '94', '57', '2012', '646', '642', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751752', '150', '57', '2012', '635', '635', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751761', '113', '57', '2012', '643', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751770', '34', '57', '2012', '638', '637', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751781', '21', '57', '2012', '639', '639', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751790', '39', '57', '2012', '642', '639', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751799', '38', '57', '2012', '650', '646', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751807', '36', '57', '2012', '646', '642', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751814', '30', '57', '2012', '649', '641', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751819', '332', '57', '2012', '650', '644', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751829', '115', '57', '2012', '640', '638', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751835', '129', '57', '2012', '639', '633', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751844', '88', '57', '2012', '639', '639', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751854', '424', '57', '2012', '639', '639', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751863', '328', '57', '2012', '646', '643', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751876', '4266', '57', '2013', '624', '624', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751888', '4230', '57', '2013', '632', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751907', '4437', '57', '2013', '629', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751917', '4211', '57', '2013', '630', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751920', '151', '61', '2010', '594', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751928', '4257', '57', '2013', '631', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751933', '121', '61', '2010', '599', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751937', '233', '57', '2013', '630', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751940', '3', '61', '2010', '594', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751952', '444', '57', '2013', '639', '628', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751953', '38', '61', '2010', '594', '590', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751960', '4201', '57', '2013', '635', '631', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751961', '30', '61', '2010', '594', '590', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751970', '1356', '61', '2010', '593', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751972', '332', '57', '2013', '640', '635', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751979', '205', '61', '2010', '600', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751981', '1356', '57', '2013', '626', '624', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751988', '68', '61', '2010', '585', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751993', '238', '57', '2013', '625', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('751997', '234', '61', '2010', '593', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752002', '4218', '57', '2013', '622', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752010', '143', '61', '2010', '612', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752013', '4227', '57', '2013', '621', '620', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752017', '115', '61', '2010', '603', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752020', '4214', '57', '2013', '618', '618', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752028', '37', '61', '2010', '600', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752031', '4229', '57', '2013', '620', '620', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752039', '79', '61', '2010', '594', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752042', '4438', '57', '2013', '620', '620', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752046', '149', '61', '2010', '592', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752050', '4246', '57', '2013', '621', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752052', '190', '61', '2010', '598', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752059', '4202', '57', '2013', '622', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752061', '89', '61', '2010', '589', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752074', '78', '61', '2010', '591', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752082', '30', '61', '2011', '611', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752089', '68', '61', '2011', '612', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752096', '149', '61', '2011', '612', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752110', '89', '61', '2011', '614', '613', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752116', '37', '61', '2011', '625', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752126', '234', '61', '2011', '613', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752139', '1356', '61', '2011', '615', '615', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752147', '38', '61', '2011', '617', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752159', '143', '61', '2011', '633', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752169', '205', '61', '2011', '611', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752179', '79', '61', '2011', '616', '613', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752187', '3', '61', '2011', '610', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752197', '115', '61', '2011', '619', '617', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752210', '151', '61', '2011', '609', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752221', '190', '61', '2011', '616', '615', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752234', '78', '61', '2011', '609', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752244', '121', '61', '2011', '617', '615', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752256', '89', '61', '2012', '632', '629', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752268', '158', '61', '2012', '635', '634', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752278', '115', '61', '2012', '638', '637', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752284', '143', '61', '2012', '650', '642', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752293', '3', '61', '2012', '629', '628', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752300', '140', '61', '2012', '634', '632', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752309', '30', '61', '2012', '632', '629', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752321', '149', '61', '2012', '630', '629', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752329', '38', '61', '2012', '638', '634', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752340', '78', '61', '2012', '627', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752345', '123', '61', '2012', '633', '632', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752358', '79', '61', '2012', '630', '630', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752370', '151', '61', '2012', '628', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752378', '234', '61', '2012', '633', '632', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752383', '190', '61', '2012', '635', '633', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752394', '1356', '61', '2012', '634', '633', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752405', '205', '61', '2012', '631', '630', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752415', '68', '61', '2012', '634', '631', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752419', '37', '61', '2012', '638', '637', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752427', '238', '61', '2013', '601', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752432', '55', '61', '2013', '618', '613', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752445', '149', '61', '2013', '600', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752455', '129', '61', '2013', '632', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752465', '83', '61', '2013', '601', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752472', '426', '61', '2013', '618', '616', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752483', '351', '61', '2013', '616', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752493', '336', '61', '2013', '625', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752502', '105', '61', '2013', '617', '616', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752507', '147', '61', '2013', '608', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752519', '2448', '61', '2013', '616', '613', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752530', '237', '61', '2013', '616', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752540', '92', '61', '2013', '608', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752546', '234', '61', '2013', '604', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752556', '1356', '61', '2013', '607', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('752568', '233', '61', '2013', '615', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753175', '147', '68', '2010', '580', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753183', '317', '68', '2010', '578', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753187', '310', '68', '2010', '569', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753201', '80', '68', '2010', '571', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753209', '113', '68', '2010', '569', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753217', '36', '68', '2010', '579', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753224', '161', '68', '2010', '578', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753234', '115', '68', '2010', '576', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753244', '40', '68', '2010', '568', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753259', '99', '68', '2010', '591', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753263', '184', '68', '2010', '567', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753274', '109', '68', '2010', '566', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753280', '25', '68', '2010', '572', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753298', '38', '68', '2010', '568', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753311', '226', '68', '2010', '568', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753324', '71', '68', '2011', '586', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753331', '226', '68', '2011', '590', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753338', '17', '68', '2011', '596', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753351', '80', '68', '2011', '593', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753360', '36', '68', '2011', '592', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753368', '99', '68', '2011', '598', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753379', '141', '68', '2011', '601', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753389', '109', '68', '2011', '588', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753395', '25', '68', '2011', '590', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753406', '437', '68', '2011', '593', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753421', '115', '68', '2011', '591', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753433', '38', '68', '2011', '591', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753442', '85', '68', '2011', '586', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753452', '161', '68', '2011', '595', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753462', '184', '68', '2011', '591', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753467', '22', '48', '2010', '540', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753470', '465', '68', '2011', '597', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753478', '24', '48', '2010', '462', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('753482', '147', '68', '2011', '599', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753487', '147', '48', '2010', '555', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753489', '40', '68', '2011', '591', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753497', '56', '48', '2010', '474', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('753501', '113', '68', '2011', '594', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753511', '85', '68', '2012', '605', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753513', '3439', '48', '2010', '497', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('753514', '184', '68', '2012', '609', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753526', '141', '68', '2012', '611', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753530', '157', '48', '2010', '540', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753532', '437', '68', '2012', '605', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753545', '95', '48', '2010', '555', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753546', '84', '68', '2012', '605', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753554', '190', '48', '2010', '563', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753555', '36', '68', '2012', '611', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753563', '129', '48', '2010', '554', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753564', '80', '68', '2012', '609', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753572', '99', '68', '2012', '617', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753573', '105', '48', '2010', '560', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753579', '5', '68', '2012', '602', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753582', '83', '48', '2010', '553', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753586', '38', '68', '2012', '618', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753587', '158', '48', '2010', '538', '529', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753595', '40', '68', '2012', '614', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753596', '17', '48', '2010', '552', '529', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753603', '226', '68', '2012', '606', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753606', '150', '48', '2010', '509', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('753611', '95', '68', '2012', '609', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753613', '193', '48', '2010', '527', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753622', '17', '68', '2012', '612', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753623', '27', '48', '2010', '577', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753631', '465', '68', '2012', '609', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753632', '97', '48', '2010', '496', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('753636', '97', '68', '2012', '604', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753640', '161', '68', '2012', '615', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753643', '4422', '48', '2010', '479', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('753647', '43', '48', '2010', '535', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753649', '109', '68', '2012', '610', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753655', '115', '68', '2012', '608', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753658', '34', '48', '2010', '495', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('753664', '147', '68', '2012', '624', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753667', '38', '48', '2010', '495', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('753670', '71', '68', '2012', '614', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753677', '10', '48', '2010', '505', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('753685', '86', '48', '2010', '509', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('753688', '25', '68', '2012', '605', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753695', '27', '48', '2010', '515', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('753699', '226', '68', '2013', '577', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753707', '174', '48', '2010', '540', '526', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753710', '97', '68', '2013', '584', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753716', '55', '48', '2010', '535', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753720', '156', '68', '2013', '591', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753724', '85', '48', '2010', '532', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753731', '10', '68', '2013', '579', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753733', '68', '48', '2010', '534', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753746', '368', '68', '2013', '590', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753747', '323', '48', '2010', '528', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753756', '454', '68', '2013', '583', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753757', '56', '48', '2010', '546', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753768', '233', '68', '2013', '587', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753769', '186', '48', '2010', '539', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753778', '101', '48', '2010', '537', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753780', '5', '68', '2013', '585', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753790', '438', '68', '2013', '589', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753792', '5', '48', '2010', '535', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753799', '400', '48', '2010', '541', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753807', '4442', '68', '2013', '588', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753808', '99', '48', '2010', '531', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753814', '2', '48', '2010', '531', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753823', '4443', '68', '2013', '584', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753827', '148', '48', '2010', '540', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753829', '144', '68', '2013', '584', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753837', '30', '48', '2010', '542', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753840', '317', '68', '2013', '588', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753846', '71', '48', '2010', '533', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753851', '40', '68', '2013', '586', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753856', '28', '48', '2010', '531', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753863', '29', '68', '2013', '579', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753867', '164', '48', '2010', '529', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753872', '118', '68', '2013', '579', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753877', '153', '48', '2010', '532', '526', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753882', '161', '48', '2010', '537', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753884', '426', '68', '2013', '586', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753892', '40', '48', '2010', '542', '526', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753893', '4353', '68', '2013', '583', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753900', '351', '68', '2013', '590', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753903', '399', '48', '2010', '558', '526', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753911', '206', '68', '2013', '592', '590', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753916', '127', '48', '2010', '538', '526', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753921', '86', '68', '2013', '596', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753926', '4203', '68', '2013', '597', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753927', '10', '48', '2010', '544', '527', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753937', '174', '68', '2013', '589', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753938', '65', '48', '2010', '527', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753947', '95', '68', '2013', '582', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753950', '12', '48', '2010', '534', '527', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753955', '4402', '68', '2013', '583', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753961', '150', '48', '2010', '551', '526', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753966', '310', '68', '2013', '604', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753971', '9', '48', '2010', '533', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753976', '85', '68', '2013', '580', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753983', '97', '48', '2010', '547', '526', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753984', '161', '68', '2013', '590', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753990', '141', '68', '2013', '592', '590', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('753995', '11', '48', '2010', '542', '526', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754009', '61', '48', '2010', '534', '526', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754023', '194', '48', '2010', '538', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754030', '86', '48', '2010', '532', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754037', '64', '48', '2010', '525', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754049', '179', '48', '2010', '538', '528', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754058', '146', '48', '2010', '532', '526', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754062', '51', '48', '2010', '526', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754071', '3', '48', '2010', '536', '527', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754080', '118', '48', '2010', '528', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754090', '52', '48', '2010', '524', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754103', '141', '48', '2010', '539', '528', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754113', '88', '48', '2010', '533', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754123', '26', '48', '2010', '530', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754135', '80', '48', '2010', '534', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754141', '91', '48', '2010', '535', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754156', '109', '48', '2010', '548', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754162', '4422', '48', '2010', '532', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754173', '226', '48', '2010', '538', '528', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754180', '151', '48', '2010', '542', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754187', '184', '48', '2010', '544', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754194', '34', '48', '2010', '539', '527', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754210', '107', '48', '2010', '534', '527', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754221', '149', '48', '2010', '540', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754230', '116', '48', '2010', '554', '527', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754246', '158', '48', '2011', '550', '542', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754255', '27', '48', '2011', '536', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('754270', '150', '48', '2011', '525', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('754277', '24', '48', '2011', '483', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('754291', '149', '48', '2011', '552', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754299', '150', '48', '2011', '558', '539', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754301', '118', '48', '2011', '541', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754307', '68', '48', '2011', '555', '541', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754321', '80', '48', '2011', '555', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754330', '10', '48', '2011', '494', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('754337', '323', '48', '2011', '544', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754342', '127', '48', '2011', '577', '542', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754348', '12', '48', '2011', '548', '542', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754356', '120', '48', '2011', '490', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('754366', '86', '48', '2011', '530', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('754373', '97', '48', '2011', '492', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('754383', '226', '48', '2011', '603', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754396', '64', '48', '2011', '543', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754404', '3439', '48', '2011', '518', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('754416', '86', '48', '2011', '556', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754422', '3', '48', '2011', '495', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('754433', '3', '48', '2011', '570', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754439', '2', '48', '2011', '555', '541', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754447', '190', '48', '2011', '599', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754454', '148', '48', '2011', '559', '539', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754463', '28', '48', '2011', '546', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754472', '85', '48', '2011', '558', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754476', '174', '48', '2011', '560', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754481', '153', '48', '2011', '551', '541', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754492', '10', '48', '2011', '556', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754500', '55', '48', '2011', '588', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754503', '184', '48', '2011', '542', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754514', '4422', '48', '2011', '498', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('754522', '38', '48', '2011', '474', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('754528', '194', '48', '2011', '552', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754536', '164', '48', '2011', '552', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754544', '116', '48', '2011', '578', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754551', '27', '48', '2011', '617', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754563', '193', '48', '2011', '544', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754571', '151', '48', '2011', '555', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754578', '109', '48', '2011', '568', '540', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754589', '44', '48', '2011', '544', '540', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754597', '129', '48', '2011', '583', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754604', '83', '48', '2011', '591', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754610', '291', '48', '2011', '561', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754617', '52', '48', '2011', '541', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754624', '179', '48', '2011', '558', '541', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754631', '56', '48', '2011', '520', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('754641', '71', '48', '2011', '554', '539', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754648', '30', '48', '2011', '568', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754654', '95', '48', '2011', '585', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754663', '146', '48', '2011', '552', '542', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754674', '17', '48', '2011', '596', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754678', '99', '48', '2011', '544', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754690', '5', '48', '2011', '571', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754697', '400', '48', '2011', '549', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754706', '399', '48', '2011', '551', '539', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754707', '67', '79', '2010', '564', '564', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754715', '17', '79', '2010', '561', '561', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754717', '88', '48', '2011', '546', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754722', '2', '79', '2010', '560', '560', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754725', '10', '79', '2010', '560', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754728', '56', '48', '2011', '551', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754732', '5', '79', '2010', '561', '561', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754739', '223', '48', '2011', '565', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754740', '44', '79', '2011', '570', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754746', '147', '48', '2011', '595', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754747', '5', '79', '2011', '573', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754753', '107', '48', '2011', '569', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754754', '17', '79', '2011', '578', '578', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754761', '105', '48', '2011', '570', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754763', '67', '79', '2011', '572', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754768', '40', '48', '2011', '565', '542', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754776', '2', '79', '2011', '573', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754778', '91', '48', '2011', '555', '540', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754789', '44', '79', '2012', '606', '606', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754791', '157', '48', '2011', '574', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754800', '26', '48', '2011', '551', '539', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754801', '67', '79', '2012', '609', '609', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754809', '169', '79', '2012', '612', '611', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754810', '97', '48', '2011', '595', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754812', '5', '79', '2012', '609', '609', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754817', '101', '48', '2011', '567', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754824', '169', '79', '2013', '578', '576', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754827', '44', '79', '2013', '571', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754831', '11', '48', '2011', '563', '542', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754838', '22', '48', '2011', '557', '542', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754839', '5', '79', '2013', '570', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754846', '34', '48', '2011', '567', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754847', '59', '79', '2013', '565', '565', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('754857', '161', '48', '2011', '567', '541', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754866', '43', '48', '2011', '556', '542', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754874', '4422', '48', '2011', '550', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754880', '51', '48', '2011', '543', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754892', '141', '48', '2011', '568', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754899', '61', '48', '2011', '557', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754908', '141', '48', '2012', '609', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754916', '34', '48', '2012', '577', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754929', '190', '48', '2012', '590', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754933', '400', '48', '2012', '583', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754943', '179', '48', '2012', '594', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754949', '157', '48', '2012', '587', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754961', '2', '48', '2012', '605', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754968', '194', '48', '2012', '570', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754977', '399', '48', '2012', '585', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754984', '149', '48', '2012', '597', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('754992', '150', '48', '2012', '567', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755001', '4422', '48', '2012', '563', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755013', '22', '48', '2012', '562', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755020', '4422', '48', '2012', '499', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755028', '61', '48', '2012', '574', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755036', '184', '48', '2012', '596', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755042', '161', '48', '2012', '580', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755049', '27', '48', '2012', '608', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755058', '56', '48', '2012', '488', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755065', '10', '48', '2012', '502', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755074', '158', '48', '2012', '572', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755079', '150', '48', '2012', '546', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755093', '118', '48', '2012', '560', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755109', '226', '48', '2012', '586', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755122', '11', '48', '2012', '585', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755128', '71', '48', '2012', '565', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755136', '99', '48', '2012', '574', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755145', '56', '48', '2012', '564', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755156', '51', '48', '2012', '570', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755166', '95', '48', '2012', '624', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755173', '91', '48', '2012', '577', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755177', '26', '48', '2012', '585', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755191', '164', '48', '2012', '573', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755201', '86', '48', '2012', '520', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755210', '27', '48', '2012', '563', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755223', '148', '48', '2012', '573', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755226', '323', '48', '2012', '561', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755236', '86', '48', '2012', '563', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755247', '28', '48', '2012', '563', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755260', '97', '48', '2012', '583', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755271', '101', '48', '2012', '577', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755280', '40', '48', '2012', '576', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755286', '146', '48', '2012', '570', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755293', '12', '48', '2012', '581', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755303', '85', '48', '2012', '580', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755314', '109', '48', '2012', '567', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755324', '151', '48', '2012', '565', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755340', '578', '48', '2012', '560', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755350', '55', '48', '2012', '586', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755361', '3439', '48', '2012', '507', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755370', '64', '48', '2012', '557', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755379', '52', '48', '2012', '546', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755388', '129', '48', '2012', '598', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755398', '52', '48', '2012', '568', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755407', '116', '48', '2012', '597', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755415', '38', '48', '2012', '497', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755423', '65', '86', '2010', '551', '546', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('755427', '88', '48', '2012', '567', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755434', '12', '86', '2010', '550', '546', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('755436', '5', '86', '2010', '553', '550', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('755440', '30', '48', '2012', '588', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755450', '43', '86', '2010', '557', '551', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('755451', '97', '48', '2012', '538', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755460', '68', '48', '2012', '574', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755462', '12', '86', '2011', '567', '563', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('755468', '127', '48', '2012', '588', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755470', '65', '86', '2011', '562', '560', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('755478', '5', '48', '2012', '586', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755482', '43', '86', '2011', '565', '563', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('755487', '193', '48', '2012', '574', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755489', '5', '86', '2011', '569', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('755496', '147', '48', '2012', '605', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755500', '12', '86', '2012', '602', '600', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('755504', '153', '48', '2012', '582', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755508', '5', '86', '2012', '605', '600', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('755514', '83', '48', '2012', '627', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755517', '65', '86', '2012', '598', '597', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('755524', '10', '48', '2012', '584', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755527', '43', '86', '2012', '603', '599', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('755533', '291', '48', '2012', '576', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755540', '105', '48', '2012', '590', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755541', '65', '86', '2013', '565', '562', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('755549', '174', '48', '2012', '580', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755552', '12', '86', '2013', '565', '563', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('755562', '5', '86', '2013', '568', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('755564', '3', '48', '2012', '548', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755570', '3', '48', '2012', '590', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755579', '24', '48', '2012', '504', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755591', '80', '48', '2012', '583', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755599', '43', '48', '2012', '584', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755608', '107', '48', '2012', '604', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755619', '120', '48', '2012', '506', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755635', '17', '48', '2012', '607', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755645', '223', '48', '2012', '569', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755653', '105', '48', '2013', '583', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755660', '141', '48', '2013', '566', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755672', '86', '48', '2013', '493', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755678', '4206', '48', '2013', '555', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755692', '22', '48', '2013', '545', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755700', '233', '48', '2013', '486', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755715', '119', '48', '2013', '542', '530', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755720', '118', '48', '2013', '534', '530', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755738', '10', '48', '2013', '479', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755748', '269', '48', '2013', '535', '530', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755756', '150', '48', '2013', '520', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755770', '28', '48', '2013', '532', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('755779', '454', '48', '2013', '537', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755784', '101', '48', '2013', '545', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755791', '3052', '48', '2013', '559', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755800', '51', '48', '2013', '538', '530', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755808', '29', '48', '2013', '535', '530', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755816', '147', '48', '2013', '551', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755828', '3761', '48', '2013', '537', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755834', '293', '48', '2013', '533', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755840', '97', '48', '2013', '561', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755851', '334', '48', '2013', '539', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755864', '368', '48', '2013', '553', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755869', '91', '48', '2013', '548', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755878', '83', '48', '2013', '552', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755893', '92', '48', '2013', '542', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755905', '157', '48', '2013', '542', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755915', '578', '48', '2013', '535', '530', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755921', '237', '48', '2013', '545', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755928', '27', '48', '2013', '564', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755939', '256', '48', '2013', '557', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755950', '296', '48', '2013', '557', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755961', '233', '48', '2013', '581', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755977', '932', '48', '2013', '535', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755982', '30', '79', '2010', '572', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755986', '156', '48', '2013', '542', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('755989', '151', '79', '2010', '575', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756001', '116', '79', '2010', '580', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756002', '4246', '48', '2013', '567', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756010', '38', '79', '2010', '576', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756011', '206', '48', '2013', '561', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756022', '158', '79', '2010', '577', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756023', '223', '48', '2013', '547', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756031', '127', '79', '2010', '576', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756033', '12', '48', '2013', '538', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756039', '144', '48', '2013', '563', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756043', '101', '79', '2010', '574', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756048', '61', '48', '2013', '545', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756054', '105', '79', '2010', '572', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756058', '10', '48', '2013', '562', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756063', '85', '79', '2010', '570', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756067', '267', '48', '2013', '553', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756071', '4373', '48', '2013', '542', '539', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756075', '88', '79', '2010', '571', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756079', '174', '48', '2013', '554', '539', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756085', '317', '79', '2010', '570', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756086', '28', '48', '2013', '590', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756093', '5', '79', '2010', '570', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756094', '85', '48', '2013', '586', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756102', '89', '79', '2010', '573', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756111', '226', '48', '2013', '566', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756112', '129', '79', '2010', '577', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756121', '95', '48', '2013', '584', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756122', '17', '79', '2010', '579', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756128', '120', '79', '2010', '580', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756129', '4074', '48', '2013', '535', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756138', '146', '79', '2010', '579', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756139', '113', '48', '2013', '591', '542', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756148', '310', '48', '2013', '583', '542', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756151', '180', '79', '2010', '589', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756159', '385', '48', '2013', '568', '541', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756163', '123', '79', '2010', '580', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756170', '129', '48', '2013', '568', '540', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756176', '190', '79', '2010', '588', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756179', '99', '48', '2013', '547', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756184', '2', '79', '2010', '577', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756187', '40', '48', '2013', '542', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756191', '112', '79', '2010', '583', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756197', '4203', '48', '2013', '546', '540', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756204', '94', '79', '2010', '583', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756210', '483', '48', '2013', '549', '539', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756215', '36', '79', '2010', '580', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756222', '5', '48', '2013', '561', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756224', '79', '79', '2010', '577', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756231', '143', '79', '2010', '586', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756235', '34', '48', '2013', '571', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756242', '148', '79', '2010', '579', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756248', '44', '48', '2013', '537', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756254', '149', '48', '2013', '549', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756255', '94', '79', '2011', '597', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756264', '150', '48', '2013', '539', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756267', '101', '79', '2011', '591', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756270', '161', '48', '2013', '542', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756276', '180', '79', '2011', '603', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756281', '86', '48', '2013', '559', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756285', '127', '79', '2011', '589', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756291', '56', '48', '2013', '539', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756293', '317', '79', '2011', '591', '590', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756301', '44', '79', '2011', '595', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756308', '2448', '48', '2013', '538', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756309', '158', '79', '2011', '593', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756316', '2', '79', '2011', '598', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756317', '88', '48', '2013', '545', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756324', '123', '79', '2011', '598', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756325', '238', '48', '2013', '587', '527', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756332', '151', '48', '2013', '570', '540', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756342', '89', '79', '2011', '593', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756343', '336', '48', '2013', '552', '527', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756352', '146', '79', '2011', '589', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756360', '36', '79', '2011', '597', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756367', '129', '79', '2011', '598', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756376', '116', '79', '2011', '601', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756386', '151', '79', '2011', '592', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756396', '180', '86', '2010', '588', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756398', '190', '79', '2011', '591', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756405', '30', '79', '2011', '598', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756411', '281', '86', '2010', '560', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756414', '85', '79', '2011', '594', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756420', '367', '86', '2010', '566', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756421', '148', '79', '2011', '591', '590', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756429', '85', '86', '2010', '566', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756431', '38', '79', '2011', '596', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756440', '118', '86', '2010', '565', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756441', '143', '79', '2011', '603', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756450', '88', '79', '2011', '594', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756451', '151', '86', '2010', '567', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756458', '105', '79', '2011', '596', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756460', '149', '86', '2010', '568', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756465', '17', '86', '2010', '575', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756469', '79', '79', '2011', '594', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756475', '83', '86', '2010', '577', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756479', '17', '79', '2011', '602', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756483', '184', '86', '2010', '574', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756493', '2', '86', '2010', '574', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756494', '5', '79', '2011', '592', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756503', '112', '79', '2011', '599', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756505', '121', '86', '2010', '577', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756513', '120', '79', '2011', '600', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756517', '97', '86', '2010', '569', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756531', '129', '79', '2012', '616', '611', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756532', '129', '86', '2010', '569', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756541', '89', '79', '2012', '614', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756542', '185', '86', '2010', '573', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756551', '116', '79', '2012', '618', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756553', '161', '86', '2010', '573', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756561', '101', '79', '2012', '612', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756568', '229', '86', '2010', '572', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756572', '30', '79', '2012', '616', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756580', '105', '79', '2012', '618', '613', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756583', '164', '86', '2011', '591', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756584', '151', '79', '2012', '608', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756592', '2', '86', '2011', '594', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756596', '112', '79', '2012', '618', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756601', '36', '86', '2011', '590', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756604', '123', '79', '2012', '618', '616', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756610', '127', '79', '2012', '613', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756614', '281', '86', '2011', '585', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756620', '148', '79', '2012', '613', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756622', '189', '86', '2011', '590', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756630', '38', '79', '2012', '615', '611', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756631', '149', '86', '2011', '595', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756644', '88', '79', '2012', '621', '615', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756645', '161', '86', '2011', '592', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756655', '317', '79', '2012', '611', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756662', '234', '86', '2011', '591', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756669', '180', '79', '2012', '619', '616', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756671', '90', '86', '2011', '588', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756679', '36', '79', '2012', '617', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756682', '37', '86', '2011', '591', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756689', '85', '79', '2012', '613', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756694', '85', '86', '2011', '587', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756699', '143', '79', '2012', '620', '618', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756705', '94', '86', '2011', '596', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756710', '169', '79', '2012', '615', '611', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756711', '367', '86', '2011', '588', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756720', '180', '86', '2011', '599', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756722', '158', '79', '2012', '617', '611', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756729', '280', '86', '2011', '594', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756732', '94', '79', '2012', '612', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756743', '38', '86', '2011', '592', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756746', '5', '79', '2012', '609', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756756', '143', '86', '2011', '593', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756759', '44', '79', '2012', '607', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756767', '17', '86', '2011', '595', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756771', '4218', '79', '2013', '591', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756776', '229', '86', '2011', '595', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756779', '113', '79', '2013', '591', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756787', '185', '86', '2011', '592', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756790', '55', '79', '2013', '589', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756792', '118', '86', '2011', '586', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756800', '88', '79', '2013', '589', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756804', '97', '86', '2011', '595', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756813', '385', '79', '2013', '586', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756816', '184', '86', '2011', '590', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756826', '4257', '79', '2013', '591', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756829', '190', '86', '2011', '588', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756833', '238', '79', '2013', '589', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756840', '83', '86', '2011', '601', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756843', '101', '79', '2013', '582', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756850', '483', '79', '2013', '578', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756851', '151', '86', '2011', '588', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756859', '5', '79', '2013', '581', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756861', '129', '86', '2011', '590', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756868', '1356', '79', '2013', '587', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756870', '143', '86', '2012', '614', '611', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756876', '317', '79', '2013', '585', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756880', '234', '86', '2012', '615', '615', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756885', '85', '79', '2013', '582', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756896', '3052', '79', '2013', '585', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756902', '2448', '79', '2013', '588', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756903', '185', '86', '2012', '612', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756916', '280', '86', '2012', '611', '611', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756918', '180', '79', '2013', '587', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756925', '149', '86', '2012', '606', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756928', '169', '79', '2013', '592', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756936', '281', '86', '2012', '607', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756938', '147', '79', '2013', '581', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756946', '118', '86', '2012', '606', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756947', '4201', '79', '2013', '591', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756956', '17', '86', '2012', '618', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756960', '105', '79', '2013', '589', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756962', '38', '86', '2012', '611', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756971', '85', '86', '2012', '606', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756972', '4224', '79', '2013', '595', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756977', '129', '79', '2013', '594', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756979', '37', '86', '2012', '606', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756987', '4229', '79', '2013', '594', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756988', '97', '86', '2012', '606', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('756996', '180', '86', '2012', '616', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757004', '83', '86', '2012', '623', '613', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757012', '129', '86', '2012', '612', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757018', '229', '86', '2012', '615', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757023', '15', '90', '2010', '574', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757025', '190', '86', '2012', '606', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757037', '78', '90', '2010', '574', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757039', '90', '86', '2012', '605', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757046', '266', '90', '2010', '574', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757048', '36', '86', '2012', '611', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757053', '126', '90', '2010', '575', '575', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757056', '2', '86', '2012', '611', '611', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757063', '61', '90', '2010', '577', '576', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757064', '164', '86', '2012', '608', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757072', '481', '90', '2010', '576', '576', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757074', '189', '86', '2012', '612', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757079', '339', '90', '2010', '573', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757082', '151', '86', '2012', '607', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757089', '5', '90', '2010', '574', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757092', '94', '86', '2012', '617', '615', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757098', '13', '90', '2010', '572', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757102', '184', '86', '2012', '607', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757108', '18', '90', '2010', '573', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757110', '161', '86', '2012', '607', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757119', '174', '86', '2013', '590', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757123', '63', '90', '2010', '572', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757130', '233', '86', '2013', '583', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757132', '21', '90', '2010', '583', '583', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757140', '4231', '86', '2013', '591', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757141', '17', '90', '2010', '583', '580', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757147', '334', '86', '2013', '585', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757151', '3', '90', '2010', '585', '579', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757156', '97', '86', '2013', '585', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757163', '2', '90', '2010', '577', '577', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757164', '229', '86', '2013', '592', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757172', '149', '86', '2013', '585', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757175', '63', '90', '2011', '588', '588', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757179', '4219', '86', '2013', '590', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757184', '126', '90', '2011', '589', '589', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757192', '101', '86', '2013', '579', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757193', '10', '90', '2011', '590', '590', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757199', '3', '90', '2011', '593', '593', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757200', '85', '86', '2013', '592', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757207', '61', '90', '2011', '593', '592', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757211', '336', '86', '2013', '582', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757218', '481', '90', '2011', '591', '591', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757222', '454', '86', '2013', '582', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757226', '5', '90', '2011', '592', '591', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757229', '4373', '86', '2013', '587', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757233', '266', '90', '2011', '591', '591', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757235', '129', '86', '2013', '587', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757240', '354', '90', '2011', '590', '590', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757242', '416', '86', '2013', '577', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757248', '18', '90', '2011', '590', '589', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757249', '4074', '86', '2013', '578', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757253', '147', '86', '2013', '578', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757256', '2', '90', '2011', '593', '593', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757258', '118', '86', '2013', '580', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757260', '339', '90', '2011', '590', '589', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757266', '328', '86', '2013', '579', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757270', '13', '90', '2011', '588', '588', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757275', '180', '86', '2013', '595', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757277', '23', '90', '2011', '593', '593', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757286', '43', '90', '2011', '591', '591', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757287', '161', '86', '2013', '583', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757295', '1356', '86', '2013', '588', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757296', '17', '90', '2011', '598', '595', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757303', '234', '86', '2013', '597', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757306', '78', '90', '2011', '590', '590', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757313', '151', '86', '2013', '596', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('757315', '21', '90', '2011', '598', '598', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757330', '63', '90', '2012', '621', '621', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757335', '5', '90', '2012', '623', '623', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757346', '266', '90', '2012', '624', '624', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757352', '354', '90', '2012', '619', '619', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757362', '18', '90', '2012', '621', '620', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757371', '21', '90', '2012', '634', '634', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757378', '17', '90', '2012', '634', '629', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757386', '339', '90', '2012', '622', '621', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757395', '52', '95', '2010', '549', '547', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757400', '61', '90', '2012', '626', '626', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757407', '59', '95', '2010', '544', '542', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757414', '10', '90', '2012', '621', '621', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757416', '67', '95', '2010', '543', '541', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757424', '13', '90', '2012', '618', '618', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757426', '8', '95', '2010', '550', '547', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757435', '44', '90', '2012', '618', '618', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757436', '10', '95', '2010', '541', '540', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757444', '108', '95', '2010', '540', '538', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757449', '2', '90', '2012', '625', '625', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757454', '12', '95', '2010', '543', '541', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757458', '3', '90', '2012', '625', '625', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757465', '78', '90', '2012', '624', '624', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757466', '67', '95', '2011', '555', '551', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757476', '369', '95', '2011', '563', '558', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757481', '43', '90', '2012', '624', '623', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757484', '8', '95', '2011', '561', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757492', '10', '95', '2011', '557', '554', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757497', '23', '90', '2012', '626', '626', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757505', '59', '95', '2011', '552', '551', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757507', '52', '95', '2011', '558', '556', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757508', '44', '90', '2013', '610', '610', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757516', '12', '95', '2011', '555', '554', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757520', '8', '90', '2013', '602', '600', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757524', '10', '95', '2012', '592', '591', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757529', '21', '90', '2013', '599', '597', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757532', '12', '95', '2012', '593', '590', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757541', '369', '95', '2012', '590', '589', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757542', '354', '90', '2013', '596', '596', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757545', '5', '90', '2013', '593', '591', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757547', '11', '95', '2012', '596', '593', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757552', '1451', '90', '2013', '591', '591', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757557', '164', '95', '2012', '594', '593', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757560', '13', '90', '2013', '590', '590', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757563', '17', '95', '2012', '597', '595', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757565', '308', '90', '2013', '590', '588', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757573', '4206', '95', '2013', '562', '557', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757576', '507', '90', '2013', '595', '595', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757585', '12', '95', '2013', '554', '553', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757586', '339', '90', '2013', '597', '594', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757593', '61', '90', '2013', '600', '600', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757595', '10', '95', '2013', '560', '556', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757600', '4246', '95', '2013', '560', '560', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757604', '10', '90', '2013', '591', '591', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757609', '4373', '95', '2013', '561', '561', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757888', '5', '99', '2010', '542', '542', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('757894', '68', '99', '2010', '545', '545', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('758780', '149', '99', '2010', '570', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758797', '4219', '99', '2010', '559', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758811', '1356', '99', '2010', '563', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758820', '4459', '99', '2010', '564', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758837', '4458', '99', '2010', '558', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758849', '78', '99', '2010', '554', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758857', '88', '99', '2010', '554', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758868', '4453', '99', '2010', '554', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758894', '92', '99', '2010', '554', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758909', '226', '99', '2010', '554', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758924', '101', '99', '2010', '556', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758938', '12', '95', '2010', '548', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758944', '4457', '99', '2010', '555', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758951', '315', '95', '2010', '559', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758965', '68', '95', '2010', '554', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758969', '270', '99', '2010', '556', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758979', '113', '95', '2010', '551', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758985', '4454', '99', '2010', '559', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('758991', '107', '95', '2010', '551', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759001', '129', '99', '2010', '559', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759004', '226', '95', '2010', '553', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759017', '10', '95', '2010', '551', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759025', '88', '95', '2010', '554', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759038', '4459', '99', '2011', '585', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759043', '151', '95', '2010', '549', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759055', '129', '99', '2011', '588', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759061', '23', '97', '2010', '549', '542', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759063', '147', '95', '2010', '556', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759074', '37', '95', '2010', '556', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759077', '1356', '99', '2011', '582', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759079', '508', '97', '2010', '553', '542', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759086', '246', '95', '2010', '549', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759091', '101', '99', '2011', '576', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759095', '7', '97', '2010', '549', '541', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759108', '8', '97', '2010', '550', '541', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759110', '4458', '99', '2011', '584', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759111', '161', '95', '2010', '550', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759119', '17', '97', '2010', '553', '541', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759120', '127', '95', '2010', '551', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759130', '89', '97', '2010', '546', '539', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759140', '932', '99', '2012', '594', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759145', '3', '97', '2010', '568', '544', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759147', '234', '95', '2011', '567', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759156', '101', '99', '2012', '597', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759158', '78', '97', '2010', '517', '509', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('759167', '31', '95', '2011', '570', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759169', '311', '97', '2010', '548', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759173', '105', '99', '2012', '600', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759182', '513', '95', '2011', '568', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759190', '224', '97', '2010', '536', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759191', '4459', '99', '2012', '604', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759195', '196', '95', '2011', '570', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759206', '78', '97', '2010', '544', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759211', '12', '95', '2011', '569', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759212', '4455', '99', '2012', '594', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759217', '69', '97', '2010', '536', '532', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759223', '113', '95', '2011', '572', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759227', '10', '97', '2010', '546', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759230', '1356', '99', '2012', '602', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759236', '107', '95', '2011', '579', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759246', '5', '97', '2010', '547', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759248', '4458', '99', '2012', '595', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759249', '21', '90', '2010', '607', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759250', '68', '95', '2011', '567', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759255', '354', '90', '2010', '596', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759257', '507', '97', '2010', '541', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759264', '147', '95', '2011', '573', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759265', '129', '99', '2012', '600', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759271', '89', '90', '2010', '593', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759272', '52', '97', '2010', '533', '532', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759280', '10', '95', '2011', '564', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759281', '266', '90', '2010', '594', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759283', '65', '97', '2010', '534', '533', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759290', '315', '95', '2011', '571', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759291', '15', '90', '2010', '592', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759292', '4451', '97', '2010', '537', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759295', '105', '99', '2013', '582', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759300', '126', '97', '2010', '552', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759304', '61', '90', '2010', '597', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759305', '127', '95', '2011', '577', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759306', '85', '99', '2013', '576', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759308', '2', '97', '2010', '549', '539', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759319', '1356', '99', '2013', '573', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759322', '26', '95', '2011', '567', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759323', '2', '90', '2010', '595', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759327', '24', '97', '2010', '517', '509', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('759331', '151', '95', '2011', '576', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759332', '221', '90', '2010', '606', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759334', '151', '99', '2013', '571', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759340', '483', '97', '2010', '546', '537', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759346', '108', '95', '2011', '565', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759349', '17', '90', '2010', '616', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759350', '932', '99', '2013', '570', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759354', '12', '97', '2010', '543', '537', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759362', '136', '97', '2010', '539', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759363', '339', '90', '2010', '595', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759364', '21', '95', '2011', '576', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759367', '4400', '99', '2013', '568', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759375', '120', '97', '2010', '548', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759379', '78', '90', '2010', '595', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759380', '4284', '99', '2013', '576', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759381', '88', '95', '2011', '570', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759387', '43', '97', '2010', '536', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759395', '3', '90', '2010', '599', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759398', '101', '99', '2013', '569', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759401', '37', '95', '2011', '576', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759408', '23', '90', '2010', '595', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759419', '4451', '97', '2011', '556', '548', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759422', '126', '90', '2010', '594', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759429', '85', '95', '2012', '586', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759431', '203', '97', '2011', '546', '546', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759434', '79', '90', '2010', '595', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759440', '10', '95', '2012', '585', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759444', '24', '97', '2011', '530', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('759450', '12', '95', '2012', '584', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759453', '78', '97', '2011', '536', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('759460', '369', '95', '2012', '584', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759461', '120', '97', '2011', '553', '547', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759462', '266', '90', '2011', '618', '616', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759466', '164', '95', '2012', '593', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759470', '43', '97', '2011', '546', '545', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759472', '221', '90', '2011', '623', '620', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759481', '89', '97', '2011', '547', '546', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759482', '189', '95', '2012', '589', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759483', '61', '90', '2011', '613', '613', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759490', '68', '95', '2012', '583', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759492', '89', '90', '2011', '613', '613', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759495', '23', '97', '2011', '561', '551', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759499', '116', '95', '2012', '594', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759503', '126', '90', '2011', '614', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759506', '311', '97', '2011', '560', '548', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759507', '185', '95', '2012', '589', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759509', '513', '95', '2012', '583', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759510', '3', '90', '2011', '621', '620', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759514', '136', '97', '2011', '546', '546', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759520', '438', '95', '2012', '582', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759522', '126', '97', '2011', '552', '548', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759524', '2', '90', '2011', '618', '618', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759531', '17', '95', '2012', '592', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759533', '2', '97', '2011', '557', '549', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759536', '79', '90', '2011', '615', '614', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759540', '88', '95', '2012', '587', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759547', '17', '90', '2011', '627', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759550', '483', '97', '2011', '557', '549', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759554', '315', '95', '2012', '588', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759560', '52', '97', '2011', '546', '545', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759561', '78', '90', '2011', '615', '615', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759562', '31', '95', '2012', '589', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759573', '17', '97', '2011', '567', '550', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759574', '123', '105', '2011', '594', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759578', '21', '90', '2011', '622', '618', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759583', '7', '97', '2011', '565', '551', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759586', '78', '97', '2011', '562', '549', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759594', '10', '95', '2013', '559', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759595', '354', '90', '2011', '620', '620', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759602', '85', '95', '2013', '560', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759603', '12', '97', '2011', '557', '548', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759613', '4328', '95', '2013', '561', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759617', '69', '97', '2011', '553', '547', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759620', '221', '90', '2012', '647', '645', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759626', '151', '105', '2011', '592', '590', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759627', '4219', '95', '2013', '566', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759631', '266', '90', '2012', '638', '637', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759632', '65', '97', '2011', '558', '547', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759637', '4246', '95', '2013', '566', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759639', '5', '97', '2011', '550', '546', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759640', '354', '90', '2012', '639', '639', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759646', '246', '95', '2013', '560', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759653', '17', '90', '2012', '644', '641', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759656', '507', '97', '2011', '557', '548', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759658', '4231', '95', '2013', '569', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759664', '224', '97', '2011', '548', '547', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759666', '44', '90', '2012', '638', '638', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759667', '12', '95', '2013', '558', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759678', '508', '97', '2011', '575', '553', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759685', '61', '90', '2012', '638', '637', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759689', '4229', '95', '2013', '563', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759690', '8', '97', '2011', '562', '549', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759695', '21', '90', '2012', '649', '645', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759704', '4211', '95', '2013', '565', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759705', '3', '97', '2011', '576', '557', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759708', '2', '90', '2012', '639', '639', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759717', '4327', '95', '2013', '563', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759721', '339', '97', '2011', '554', '547', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759724', '3', '90', '2012', '647', '647', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759731', '83', '95', '2013', '564', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759736', '79', '90', '2012', '637', '637', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759742', '339', '97', '2012', '589', '586', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759751', '89', '90', '2012', '637', '637', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759756', '24', '97', '2012', '567', '564', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('759763', '78', '90', '2012', '638', '638', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759769', '2', '97', '2012', '598', '589', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759773', '508', '97', '2012', '604', '593', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759786', '221', '90', '2013', '627', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759788', '4451', '97', '2012', '586', '585', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759799', '23', '97', '2012', '597', '591', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759802', '61', '90', '2013', '619', '618', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759811', '224', '97', '2012', '589', '588', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759819', '8', '90', '2013', '627', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759825', '203', '97', '2012', '590', '586', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759831', '44', '90', '2013', '617', '617', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759837', '89', '97', '2012', '593', '587', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759840', '103', '90', '2013', '623', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759847', '3', '97', '2012', '615', '595', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759852', '507', '90', '2013', '624', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759857', '311', '97', '2012', '596', '587', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759864', '3874', '90', '2013', '621', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759874', '7', '97', '2012', '597', '589', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759884', '8', '110', '2010', '530', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('759885', '21', '90', '2013', '628', '626', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('759888', '12', '97', '2012', '587', '585', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759896', '5', '97', '2012', '598', '586', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759900', '13', '110', '2010', '520', '519', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('759906', '17', '97', '2012', '605', '589', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759912', '10', '110', '2010', '526', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('759915', '507', '97', '2012', '587', '586', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759926', '52', '110', '2010', '523', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('759928', '78', '97', '2012', '577', '563', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('759936', '78', '110', '2010', '526', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('759938', '120', '97', '2012', '593', '587', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759948', '69', '97', '2012', '585', '585', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759964', '8', '97', '2012', '600', '590', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759968', '63', '110', '2011', '529', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('759975', '126', '97', '2012', '600', '587', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759980', '13', '110', '2011', '529', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('759989', '78', '97', '2012', '590', '586', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('759992', '23', '110', '2011', '530', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('759997', '483', '97', '2012', '588', '586', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760015', '13', '110', '2012', '567', '566', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('760026', '537', '110', '2012', '567', '567', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('760032', '7', '97', '2013', '556', '554', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760039', '10', '110', '2012', '567', '567', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('760046', '17', '97', '2013', '571', '554', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760051', '4205', '110', '2013', '527', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('760062', '69', '110', '2013', '527', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('760069', '21', '97', '2013', '572', '558', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760080', '65', '97', '2013', '550', '550', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760091', '339', '97', '2013', '558', '551', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760112', '58', '97', '2013', '558', '552', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760117', '3874', '97', '2013', '566', '552', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760126', '4256', '97', '2013', '557', '552', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760138', '5', '97', '2013', '563', '551', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760149', '69', '97', '2013', '552', '550', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760160', '507', '97', '2013', '565', '554', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760171', '12', '97', '2013', '552', '550', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760184', '8', '97', '2013', '565', '553', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760254', '8', '115', '2010', '573', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760268', '514', '115', '2010', '582', '582', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('760281', '13', '115', '2010', '524', '524', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760294', '2', '115', '2010', '531', '531', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760306', '61', '115', '2010', '591', '585', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('760321', '471', '115', '2010', '593', '588', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('760332', '5', '115', '2010', '565', '565', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760347', '58', '115', '2010', '568', '568', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('760421', '10', '115', '2011', '620', '620', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('760437', '2', '115', '2011', '609', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('760449', '5', '115', '2011', '610', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('760462', '58', '115', '2011', '612', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('760477', '38', '115', '2011', '602', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('760499', '10', '115', '2012', '634', '634', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('760505', '2', '115', '2012', '627', '627', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('760521', '58', '115', '2012', '632', '632', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('760538', '5', '115', '2012', '631', '631', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('760551', '38', '115', '2012', '625', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('760732', '5', '115', '2013', '604', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('760739', '10', '115', '2013', '623', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('760748', '58', '115', '2013', '622', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('761339', '3', '130', '2011', '553', '549', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761354', '3', '127', '2010', '536', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('761357', '15', '130', '2011', '556', '542', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761368', '24', '127', '2010', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('761373', '5', '130', '2011', '539', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761387', '13', '130', '2011', '534', '533', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761395', '4466', '127', '2010', '528', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('761404', '69', '130', '2011', '539', '539', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761407', '17', '127', '2010', '529', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('761432', '17', '127', '2011', '559', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761433', '69', '130', '2012', '580', '579', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761445', '3', '127', '2011', '544', '542', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('761446', '13', '130', '2012', '582', '580', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761456', '408', '127', '2011', '572', '565', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761459', '2', '130', '2012', '592', '587', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761474', '10', '130', '2012', '583', '581', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761481', '4466', '127', '2011', '540', '539', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('761497', '15', '130', '2012', '581', '580', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761505', '408', '127', '2012', '600', '598', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761517', '2', '127', '2012', '590', '588', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761524', '65', '130', '2013', '542', '542', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761531', '3', '127', '2012', '602', '597', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761535', '12', '130', '2013', '544', '543', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761557', '4208', '127', '2013', '565', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761559', '10', '130', '2013', '545', '544', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761579', '13', '130', '2013', '547', '545', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761590', '69', '130', '2013', '546', '545', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('761745', '143', '110', '2010', '517', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761759', '127', '110', '2010', '515', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761773', '85', '110', '2010', '517', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761783', '79', '110', '2010', '522', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761794', '148', '110', '2010', '521', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761810', '83', '110', '2010', '522', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761823', '147', '110', '2010', '524', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761835', '2', '110', '2010', '531', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761848', '151', '110', '2010', '534', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761861', '184', '110', '2010', '518', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761873', '97', '110', '2010', '519', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761885', '38', '110', '2010', '514', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761903', '317', '110', '2010', '514', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761916', '202', '110', '2010', '514', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761923', '71', '110', '2010', '525', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761936', '158', '110', '2010', '514', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761951', '101', '110', '2010', '516', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761964', '123', '110', '2010', '516', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761996', '185', '127', '2010', '546', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('761997', '134', '110', '2011', '529', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762010', '79', '127', '2010', '533', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762018', '83', '110', '2011', '537', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762024', '309', '127', '2010', '528', '509', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('762030', '38', '110', '2011', '542', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762037', '389', '127', '2010', '534', '497', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('762044', '79', '110', '2011', '527', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762054', '452', '127', '2010', '566', '552', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762056', '143', '110', '2011', '546', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762070', '79', '127', '2011', '556', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762075', '97', '110', '2011', '530', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762083', '38', '127', '2011', '558', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762091', '408', '127', '2011', '571', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762092', '184', '110', '2011', '531', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762105', '143', '127', '2011', '559', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762107', '151', '110', '2011', '539', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762121', '101', '110', '2011', '529', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762122', '26', '127', '2011', '558', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762133', '317', '110', '2011', '529', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762134', '112', '127', '2011', '580', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762145', '185', '127', '2011', '563', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762147', '140', '110', '2011', '529', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762160', '127', '110', '2011', '536', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762162', '120', '127', '2011', '564', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762173', '196', '110', '2011', '534', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762186', '118', '110', '2011', '528', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762195', '2', '110', '2011', '533', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762207', '148', '110', '2011', '528', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762221', '132', '110', '2011', '536', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762286', '148', '110', '2012', '552', '549', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762288', '112', '127', '2012', '591', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762299', '202', '110', '2012', '547', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762300', '79', '127', '2012', '578', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762314', '43', '127', '2012', '585', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762316', '101', '110', '2012', '547', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762329', '83', '110', '2012', '550', '549', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762331', '89', '127', '2012', '579', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762343', '185', '127', '2012', '581', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762353', '38', '110', '2012', '546', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762366', '79', '110', '2012', '550', '548', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762367', '120', '127', '2012', '587', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762375', '127', '127', '2012', '582', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762389', '78', '110', '2012', '547', '547', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762391', '173', '127', '2012', '581', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762402', '149', '110', '2012', '546', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762409', '143', '127', '2012', '583', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762416', '132', '110', '2012', '557', '554', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762426', '15', '130', '2010', '545', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762431', '38', '127', '2012', '581', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762434', '113', '110', '2012', '553', '551', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762437', '90', '127', '2012', '580', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762443', '131', '130', '2010', '545', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762452', '37', '110', '2012', '559', '559', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762453', '84', '130', '2010', '545', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762455', '5', '97', '2010', '537', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762457', '2', '127', '2012', '581', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762473', '185', '130', '2010', '549', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762474', '408', '127', '2012', '594', '590', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762478', '88', '110', '2012', '548', '547', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762480', '224', '97', '2010', '545', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762489', '140', '130', '2010', '552', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762496', '2246', '97', '2010', '546', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762498', '40', '127', '2013', '559', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762499', '151', '110', '2012', '555', '554', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762502', '38', '97', '2010', '551', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762505', '92', '130', '2010', '546', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762522', '245', '130', '2010', '551', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762523', '4266', '127', '2013', '556', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762524', '127', '110', '2012', '549', '549', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762525', '16', '97', '2010', '570', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762532', '4211', '127', '2013', '561', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762535', '101', '130', '2010', '545', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762542', '8', '97', '2010', '562', '540', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762545', '140', '110', '2012', '548', '547', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762552', '4231', '127', '2013', '558', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762554', '148', '130', '2010', '545', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762555', '4464', '97', '2010', '542', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762558', '196', '110', '2012', '552', '551', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762563', '233', '127', '2013', '554', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762577', '123', '110', '2012', '549', '549', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762579', '381', '130', '2010', '543', '542', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762583', '2', '97', '2010', '546', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762598', '36', '130', '2010', '551', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762599', '89', '97', '2010', '539', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762603', '78', '97', '2010', '567', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762610', '134', '110', '2012', '547', '547', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762615', '143', '130', '2010', '550', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762622', '65', '97', '2010', '556', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762631', '83', '130', '2010', '551', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762639', '143', '97', '2010', '541', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762644', '310', '110', '2013', '529', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762647', '146', '97', '2010', '543', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762651', '351', '130', '2010', '564', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762653', '317', '110', '2013', '528', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762659', '120', '97', '2010', '544', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762666', '10', '110', '2013', '518', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762669', '136', '97', '2010', '536', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762677', '507', '97', '2010', '539', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762683', '113', '130', '2011', '564', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762685', '454', '110', '2013', '517', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762690', '311', '97', '2010', '551', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762696', '2448', '110', '2013', '528', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762698', '148', '130', '2011', '563', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762708', '37', '97', '2010', '556', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762715', '101', '130', '2011', '566', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762716', '8', '110', '2013', '520', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762721', '12', '97', '2010', '547', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762732', '381', '130', '2011', '558', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762733', '395', '110', '2013', '521', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762739', '55', '97', '2010', '543', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762753', '97', '110', '2013', '516', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762754', '84', '130', '2011', '560', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762761', '23', '97', '2010', '559', '540', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762770', '283', '110', '2013', '516', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762775', '131', '130', '2011', '559', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762780', '17', '97', '2010', '559', '541', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762786', '129', '110', '2013', '518', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762795', '92', '130', '2011', '556', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762801', '3052', '110', '2013', '520', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762803', '69', '97', '2010', '534', '530', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762809', '245', '130', '2011', '562', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762816', '149', '110', '2013', '516', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762817', '4451', '97', '2010', '537', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762833', '174', '110', '2013', '519', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762840', '483', '97', '2010', '539', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762841', '83', '130', '2011', '577', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762849', '147', '110', '2013', '549', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762856', '4463', '97', '2010', '538', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762865', '185', '130', '2011', '567', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762868', '101', '110', '2013', '517', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762875', '4462', '97', '2010', '544', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762876', '140', '130', '2011', '563', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762895', '78', '97', '2010', '518', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762900', '15', '130', '2011', '556', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762910', '508', '97', '2010', '568', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762934', '56', '130', '2012', '578', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762935', '4465', '97', '2010', '515', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('762950', '7', '97', '2010', '557', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762954', '184', '130', '2012', '579', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762964', '185', '130', '2012', '598', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762972', '3', '97', '2010', '568', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762985', '131', '130', '2012', '587', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('762996', '5', '130', '2012', '578', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763002', '52', '97', '2010', '531', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763012', '43', '97', '2010', '534', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763013', '84', '130', '2012', '576', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763034', '15', '130', '2012', '577', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763037', '10', '97', '2010', '547', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763043', '351', '130', '2012', '577', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763052', '126', '97', '2010', '541', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763054', '68', '130', '2012', '582', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763069', '24', '97', '2010', '507', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('763070', '38', '130', '2012', '579', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763088', '92', '130', '2012', '577', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763100', '2', '130', '2012', '591', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763121', '40', '131', '2010', '549', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763127', '339', '97', '2011', '566', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763139', '83', '130', '2013', '546', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763142', '329', '131', '2010', '561', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763146', '2246', '97', '2011', '551', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763155', '5', '130', '2013', '548', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763163', '30', '131', '2010', '553', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763169', '508', '97', '2011', '590', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763179', '134', '130', '2013', '551', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763183', '170', '131', '2010', '553', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763188', '7', '97', '2011', '585', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763200', '932', '130', '2013', '548', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763201', '131', '131', '2010', '549', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763202', '17', '97', '2011', '571', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763218', '16', '131', '2010', '548', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763219', '4211', '130', '2013', '557', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763226', '78', '97', '2011', '554', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763233', '233', '130', '2013', '550', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763237', '24', '131', '2010', '549', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763247', '4306', '130', '2013', '550', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763250', '85', '131', '2010', '549', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763253', '37', '97', '2011', '560', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763262', '454', '130', '2013', '550', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763263', '4451', '97', '2011', '554', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763269', '161', '131', '2010', '549', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763277', '84', '131', '2010', '552', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763281', '4202', '130', '2013', '549', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763288', '12', '97', '2011', '550', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763293', '4231', '130', '2013', '562', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763295', '245', '131', '2010', '562', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763305', '4230', '130', '2013', '558', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763309', '120', '97', '2011', '555', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763313', '116', '131', '2010', '559', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763323', '224', '97', '2011', '554', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763325', '38', '131', '2010', '553', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763329', '4214', '130', '2013', '551', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763336', '507', '97', '2011', '553', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763339', '351', '130', '2013', '549', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763344', '5', '97', '2011', '558', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763351', '4266', '130', '2013', '559', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763354', '190', '131', '2010', '548', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763357', '38', '97', '2011', '574', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763365', '149', '131', '2010', '548', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763374', '143', '97', '2011', '564', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763385', '94', '131', '2010', '564', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763388', '311', '97', '2011', '564', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763393', '63', '144', '2011', '545', '540', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('763397', '52', '97', '2011', '549', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763405', '175', '131', '2010', '548', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763410', '10', '144', '2011', '543', '539', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('763413', '146', '97', '2011', '567', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763419', '35', '131', '2010', '555', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763428', '10', '131', '2010', '554', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763429', '4463', '97', '2011', '554', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763439', '97', '131', '2010', '561', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763444', '69', '97', '2011', '559', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763445', '15', '144', '2012', '587', '580', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('763456', '65', '97', '2011', '548', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763457', '164', '131', '2010', '552', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763466', '10', '144', '2012', '589', '579', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('763474', '126', '97', '2011', '567', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763475', '67', '131', '2010', '548', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763484', '24', '144', '2012', '583', '576', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('763486', '43', '97', '2011', '559', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763490', '2', '131', '2010', '568', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763507', '8', '97', '2011', '588', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763508', '17', '131', '2010', '566', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763511', '4206', '144', '2013', '542', '537', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('763524', '4208', '144', '2013', '541', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('763525', '135', '131', '2010', '557', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763528', '24', '97', '2011', '563', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('763538', '119', '131', '2010', '556', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763541', '483', '97', '2011', '551', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763554', '5', '131', '2010', '556', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763557', '16', '97', '2011', '561', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763569', '68', '131', '2010', '560', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763575', '78', '97', '2011', '530', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('763589', '2', '97', '2011', '574', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763603', '55', '97', '2011', '556', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763610', '40', '131', '2011', '567', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763614', '4462', '97', '2011', '553', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763625', '329', '131', '2011', '572', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763629', '4465', '97', '2011', '527', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('763640', '30', '131', '2011', '578', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763643', '136', '97', '2011', '547', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763661', '23', '97', '2011', '572', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763664', '135', '131', '2011', '567', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763669', '4464', '97', '2011', '556', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763678', '94', '131', '2011', '580', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763686', '3', '97', '2011', '599', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763691', '16', '131', '2011', '570', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763711', '89', '97', '2011', '559', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763724', '10', '131', '2011', '572', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763732', '224', '97', '2012', '574', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763744', '175', '131', '2011', '563', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763751', '339', '97', '2012', '578', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763756', '85', '131', '2011', '575', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763760', '2', '131', '2011', '577', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763773', '16', '97', '2012', '580', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763777', '38', '131', '2011', '568', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763792', '78', '97', '2012', '580', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763793', '84', '131', '2011', '563', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763811', '24', '97', '2012', '542', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('763813', '67', '131', '2011', '574', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763827', '4463', '97', '2012', '571', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763830', '131', '131', '2011', '563', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763842', '311', '97', '2012', '585', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763844', '3', '131', '2011', '571', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763869', '119', '131', '2011', '575', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763870', '3', '97', '2012', '619', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763879', '38', '97', '2012', '573', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763887', '190', '131', '2011', '566', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763895', '4465', '97', '2012', '549', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('763902', '161', '131', '2011', '565', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763913', '55', '97', '2012', '583', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763917', '97', '131', '2011', '584', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763924', '17', '97', '2012', '591', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763929', '5', '131', '2011', '561', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763943', '37', '97', '2012', '599', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763945', '17', '131', '2011', '576', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763961', '4462', '97', '2012', '583', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763963', '24', '131', '2011', '570', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763981', '8', '97', '2012', '588', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763983', '164', '131', '2011', '568', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('763996', '170', '131', '2011', '562', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764001', '507', '97', '2012', '580', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764007', '116', '131', '2011', '573', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764013', '146', '97', '2012', '579', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764024', '35', '131', '2011', '582', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764032', '89', '97', '2012', '588', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764039', '245', '131', '2011', '572', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764042', '126', '97', '2012', '585', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764050', '68', '131', '2011', '568', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764052', '12', '97', '2012', '569', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764067', '149', '131', '2011', '564', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764068', '5', '97', '2012', '580', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764085', '120', '97', '2012', '576', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764091', '35', '131', '2012', '590', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764102', '143', '97', '2012', '578', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764109', '85', '131', '2012', '588', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764114', '508', '97', '2012', '613', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764123', '67', '131', '2012', '584', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764136', '190', '131', '2012', '585', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764141', '78', '97', '2012', '557', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('764150', '7', '97', '2012', '586', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764151', '94', '131', '2012', '598', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764161', '23', '97', '2012', '584', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764167', '161', '131', '2012', '588', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764170', '5', '144', '2010', '544', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764174', '4451', '97', '2012', '573', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764182', '10', '144', '2010', '550', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764188', '68', '131', '2012', '590', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764193', '2', '97', '2012', '595', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764202', '95', '144', '2010', '547', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764206', '2246', '97', '2012', '573', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764215', '438', '144', '2010', '545', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764217', '116', '131', '2012', '589', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764221', '483', '97', '2012', '568', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764231', '184', '144', '2010', '551', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764239', '4464', '97', '2012', '569', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764242', '30', '131', '2012', '587', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764243', '36', '144', '2010', '548', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764253', '21', '144', '2010', '552', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764258', '37', '131', '2012', '595', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764263', '339', '97', '2013', '561', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764267', '2', '144', '2010', '551', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764275', '329', '131', '2012', '594', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764282', '80', '144', '2010', '550', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764289', '97', '131', '2012', '591', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764293', '334', '97', '2013', '550', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764297', '153', '144', '2010', '544', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764299', '283', '131', '2012', '596', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764308', '17', '97', '2013', '567', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764313', '149', '131', '2012', '586', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764315', '94', '144', '2010', '553', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764326', '3774', '97', '2013', '564', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764327', '17', '131', '2012', '601', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764330', '143', '144', '2010', '560', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764340', '2', '131', '2012', '591', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764341', '507', '97', '2013', '551', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764343', '129', '144', '2010', '557', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764354', '233', '97', '2013', '558', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764357', '16', '131', '2012', '587', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764360', '105', '144', '2010', '559', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764370', '101', '97', '2013', '549', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764373', '10', '131', '2012', '589', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764374', '113', '144', '2010', '569', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764383', '483', '97', '2013', '546', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764390', '71', '144', '2010', '544', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764391', '3', '131', '2012', '598', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764393', '238', '97', '2013', '516', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('764407', '38', '131', '2012', '602', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764408', '37', '144', '2010', '550', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764413', '3874', '97', '2013', '565', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764422', '164', '131', '2012', '589', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764427', '68', '144', '2010', '544', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764431', '7', '97', '2013', '549', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764437', '170', '131', '2012', '588', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764447', '129', '97', '2013', '551', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764453', '245', '131', '2012', '594', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764456', '56', '144', '2011', '558', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764461', '105', '97', '2013', '550', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764469', '84', '131', '2012', '588', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764476', '58', '97', '2013', '552', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764481', '2', '144', '2011', '591', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764487', '119', '131', '2012', '585', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764489', '78', '147', '2010', '510', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764497', '94', '144', '2011', '574', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764498', '65', '147', '2010', '507', '505', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764506', '131', '131', '2012', '585', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764508', '4256', '97', '2013', '555', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764520', '21', '97', '2013', '581', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764521', '37', '144', '2011', '564', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764523', '2', '147', '2010', '515', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764524', '24', '131', '2012', '585', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764532', '175', '131', '2012', '584', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764533', '129', '144', '2011', '570', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764537', '69', '97', '2013', '566', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764540', '52', '147', '2010', '509', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764544', '150', '144', '2011', '579', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764549', '135', '131', '2012', '586', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764550', '17', '147', '2010', '516', '509', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764554', '8', '97', '2013', '559', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764560', '34', '144', '2011', '571', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764561', '205', '131', '2012', '584', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764566', '22', '147', '2010', '517', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764568', '5', '97', '2013', '561', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764578', '5', '147', '2010', '517', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764580', '30', '144', '2011', '566', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764593', '58', '147', '2010', '521', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764594', '175', '131', '2013', '560', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764596', '2', '150', '2010', '555', '552', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764599', '150', '144', '2012', '583', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764602', '61', '147', '2010', '519', '511', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764607', '233', '131', '2013', '562', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764610', '2', '144', '2012', '600', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764612', '14', '150', '2010', '552', '552', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764614', '10', '147', '2010', '514', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764624', '237', '131', '2013', '561', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764625', '129', '144', '2012', '585', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764626', '5', '150', '2010', '552', '552', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764631', '56', '144', '2012', '577', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764635', '149', '131', '2013', '561', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764636', '10', '150', '2010', '550', '550', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764639', '94', '144', '2012', '590', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764641', '134', '131', '2013', '562', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764645', '3', '147', '2011', '530', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764648', '734', '150', '2010', '550', '550', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764653', '37', '144', '2012', '585', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764654', '13', '150', '2010', '549', '549', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764657', '59', '131', '2013', '562', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764663', '22', '147', '2011', '531', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764667', '2448', '131', '2013', '562', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764671', '10', '147', '2011', '528', '517', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764673', '30', '144', '2012', '581', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764677', '13', '150', '2011', '564', '563', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764685', '119', '131', '2013', '561', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764686', '52', '147', '2011', '522', '517', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764689', '5', '150', '2011', '564', '564', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764694', '161', '131', '2013', '562', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764698', '78', '147', '2011', '521', '517', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764699', '10', '150', '2011', '563', '563', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764700', '4231', '144', '2013', '562', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764708', '2', '150', '2011', '570', '560', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764709', '83', '131', '2013', '564', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764712', '61', '147', '2011', '525', '519', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764716', '4266', '144', '2013', '566', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764722', '65', '150', '2011', '556', '556', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764724', '5', '131', '2013', '560', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764726', '17', '147', '2011', '530', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764727', '4232', '144', '2013', '562', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764731', '11', '150', '2011', '564', '564', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764735', '65', '147', '2011', '518', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764737', '4214', '144', '2013', '575', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764740', '1356', '131', '2013', '566', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764743', '734', '150', '2011', '556', '556', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764748', '85', '131', '2013', '561', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764749', '2', '147', '2011', '526', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764751', '4229', '144', '2013', '559', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764762', '56', '144', '2013', '555', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764763', '58', '147', '2011', '524', '516', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764764', '10', '131', '2013', '564', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764769', '734', '150', '2012', '603', '603', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764774', '5', '147', '2011', '524', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764778', '262', '131', '2013', '562', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764781', '10', '150', '2012', '602', '602', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764787', '336', '131', '2013', '560', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764791', '5', '150', '2012', '602', '602', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764798', '2', '147', '2012', '564', '539', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764800', '238', '131', '2013', '562', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764806', '65', '150', '2012', '604', '604', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764809', '78', '147', '2012', '558', '556', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764810', '932', '131', '2013', '562', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764816', '13', '150', '2012', '604', '603', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764822', '140', '131', '2013', '562', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764823', '52', '147', '2012', '558', '555', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764829', '129', '131', '2013', '565', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764831', '11', '150', '2012', '603', '603', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764832', '89', '147', '2012', '567', '558', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764838', '4306', '131', '2013', '577', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764844', '3', '147', '2012', '567', '546', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764853', '97', '131', '2013', '565', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764855', '51', '150', '2013', '568', '568', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764856', '5', '147', '2012', '560', '557', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764864', '105', '131', '2013', '565', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764866', '65', '150', '2013', '569', '569', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764867', '17', '147', '2012', '567', '560', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764876', '174', '131', '2013', '566', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764878', '5', '150', '2013', '570', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764882', '10', '147', '2012', '564', '549', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764885', '4230', '131', '2013', '570', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764890', '13', '150', '2013', '570', '569', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764893', '65', '147', '2012', '554', '553', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764899', '113', '131', '2013', '567', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764902', '10', '150', '2013', '572', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764905', '61', '147', '2012', '562', '556', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764907', '260', '131', '2013', '567', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764912', '21', '150', '2013', '571', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764917', '22', '147', '2012', '568', '558', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764919', '4373', '131', '2013', '570', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764926', '283', '131', '2013', '577', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('764927', '58', '147', '2012', '567', '557', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764932', '4206', '150', '2013', '570', '569', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764947', '5', '147', '2013', '526', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764959', '22', '147', '2013', '527', '519', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764976', '58', '147', '2013', '522', '517', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764980', '17', '147', '2013', '539', '537', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('764990', '61', '147', '2013', '527', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('764998', '10', '147', '2013', '531', '513', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765009', '65', '147', '2013', '518', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765198', '374', '158', '2010', '527', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765212', '10', '158', '2010', '529', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765218', '126', '158', '2010', '530', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765226', '5', '158', '2010', '522', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765245', '15', '158', '2010', '525', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765265', '126', '158', '2011', '535', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765280', '374', '158', '2011', '531', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765291', '10', '158', '2011', '543', '539', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765305', '15', '158', '2011', '532', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765331', '9', '158', '2012', '581', '575', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765344', '63', '158', '2012', '591', '583', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765359', '51', '158', '2012', '590', '585', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765373', '13', '158', '2012', '597', '586', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765385', '800', '158', '2012', '587', '578', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765394', '69', '158', '2012', '568', '566', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765405', '1', '158', '2012', '579', '577', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765410', '74', '158', '2012', '580', '576', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765416', '17', '158', '2012', '576', '570', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765461', '10', '158', '2013', '547', '546', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765465', '101', '150', '2010', '558', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765471', '435', '158', '2013', '541', '537', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765481', '37', '150', '2010', '553', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765494', '143', '150', '2010', '553', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765495', '4468', '158', '2013', '543', '539', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765510', '1', '158', '2013', '541', '539', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765514', '14', '150', '2010', '563', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765525', '8', '150', '2010', '562', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765526', '12', '158', '2013', '543', '542', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765537', '38', '150', '2010', '553', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765547', '13', '158', '2013', '555', '549', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765550', '158', '150', '2010', '552', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765554', '1451', '158', '2013', '548', '545', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765567', '36', '150', '2010', '556', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765570', '9', '158', '2013', '538', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765575', '207', '160', '2010', '540', '539', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765580', '5', '150', '2010', '553', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765587', '3', '160', '2010', '561', '559', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765589', '69', '158', '2013', '529', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765599', '17', '158', '2013', '540', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765600', '10', '150', '2010', '559', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765604', '3', '160', '2011', '567', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765620', '2', '160', '2011', '570', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765629', '5', '150', '2011', '569', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765635', '2', '160', '2012', '608', '607', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765639', '37', '150', '2011', '573', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765646', '10', '159', '2010', '520', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765657', '36', '150', '2011', '568', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765659', '3', '160', '2012', '611', '607', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765661', '5', '159', '2010', '510', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765666', '14', '150', '2011', '571', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765670', '30', '159', '2010', '509', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765674', '65', '160', '2012', '601', '600', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765682', '10', '150', '2011', '570', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765688', '21', '159', '2010', '511', '504', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765692', '65', '160', '2013', '566', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765696', '21', '150', '2011', '575', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765703', '3', '159', '2010', '514', '505', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765712', '78', '159', '2010', '508', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765713', '101', '150', '2011', '576', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765725', '8', '150', '2011', '577', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765728', '12', '159', '2010', '510', '503', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765744', '38', '150', '2011', '566', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765754', '89', '159', '2010', '509', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765758', '158', '150', '2011', '566', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765773', '43', '159', '2010', '507', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765777', '143', '150', '2011', '570', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765780', '8', '159', '2010', '514', '503', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765799', '8', '150', '2012', '591', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765800', '69', '159', '2010', '510', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765813', '10', '150', '2012', '608', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765819', '1451', '159', '2010', '505', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765826', '38', '150', '2012', '607', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765855', '2', '150', '2012', '590', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765857', '120', '159', '2011', '523', '511', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765869', '158', '150', '2012', '591', '590', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765871', '325', '159', '2011', '512', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765882', '37', '150', '2012', '588', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765883', '30', '159', '2011', '527', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765891', '43', '159', '2011', '518', '511', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765896', '21', '150', '2012', '596', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765905', '23', '159', '2011', '525', '511', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765907', '5', '150', '2012', '601', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765917', '36', '150', '2012', '594', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765923', '89', '159', '2011', '515', '512', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765935', '10', '159', '2011', '526', '512', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765941', '14', '150', '2012', '595', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765945', '78', '159', '2011', '523', '511', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765952', '101', '150', '2012', '590', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765961', '3', '159', '2011', '532', '516', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765968', '143', '150', '2012', '590', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('765980', '146', '159', '2011', '532', '532', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('765993', '21', '159', '2011', '523', '514', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('765994', '101', '150', '2013', '563', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766003', '12', '159', '2011', '512', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766007', '233', '150', '2013', '562', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766013', '5', '159', '2011', '521', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766020', '105', '150', '2013', '565', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766027', '69', '159', '2011', '516', '511', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766036', '14', '150', '2013', '565', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766046', '1451', '159', '2011', '510', '509', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766053', '8', '159', '2011', '529', '512', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766055', '2448', '150', '2013', '570', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766072', '8', '150', '2013', '572', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766076', '69', '159', '2012', '554', '550', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766086', '78', '159', '2012', '559', '551', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766087', '5', '150', '2013', '572', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766097', '159', '150', '2013', '572', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766098', '3', '159', '2012', '567', '556', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766109', '222', '158', '2010', '517', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766116', '23', '159', '2012', '558', '552', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766125', '12', '159', '2012', '554', '551', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766126', '116', '158', '2010', '520', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766140', '147', '158', '2010', '518', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766141', '1451', '159', '2012', '554', '550', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766154', '37', '158', '2010', '525', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766156', '89', '159', '2012', '554', '551', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766164', '410', '158', '2010', '520', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766171', '43', '159', '2012', '561', '551', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766183', '17', '158', '2010', '523', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766184', '325', '159', '2012', '554', '550', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766198', '150', '158', '2010', '529', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766203', '8', '159', '2012', '560', '552', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766209', '79', '160', '2010', '541', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766211', '184', '158', '2010', '524', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766219', '5', '159', '2012', '556', '550', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766223', '24', '158', '2010', '516', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766231', '24', '160', '2010', '535', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766237', '357', '158', '2010', '516', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766238', '146', '159', '2012', '570', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766246', '97', '160', '2010', '547', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766249', '129', '158', '2010', '516', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766250', '30', '159', '2012', '566', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766260', '136', '160', '2010', '536', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766264', '21', '159', '2012', '565', '554', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766271', '8', '160', '2010', '547', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766275', '222', '158', '2011', '531', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766277', '120', '159', '2012', '563', '554', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766283', '69', '160', '2010', '528', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766289', '10', '159', '2012', '567', '551', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766292', '357', '158', '2011', '529', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766301', '148', '160', '2010', '540', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766305', '129', '158', '2011', '535', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766309', '238', '159', '2013', '520', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766314', '37', '158', '2011', '535', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766326', '10', '159', '2013', '515', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766328', '24', '158', '2011', '529', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766330', '136', '160', '2011', '563', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766335', '5', '159', '2013', '526', '511', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766336', '148', '160', '2011', '560', '552', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766343', '410', '158', '2011', '529', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766345', '30', '162', '2010', '520', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766349', '126', '160', '2011', '572', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766353', '12', '159', '2013', '512', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766359', '13', '162', '2010', '516', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766361', '69', '159', '2013', '515', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766362', '116', '158', '2011', '534', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766364', '38', '160', '2011', '565', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766373', '63', '162', '2010', '520', '511', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766377', '1451', '159', '2013', '515', '511', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766379', '17', '158', '2011', '544', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766382', '97', '160', '2011', '572', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766388', '52', '162', '2010', '517', '511', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766392', '21', '159', '2013', '527', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766396', '21', '160', '2011', '578', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766400', '150', '158', '2011', '530', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766402', '10', '162', '2010', '520', '512', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766405', '483', '159', '2013', '517', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766408', '8', '160', '2011', '574', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766412', '5', '162', '2010', '517', '513', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766415', '8', '159', '2013', '525', '513', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766418', '480', '160', '2011', '573', '560', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766422', '78', '162', '2010', '515', '513', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766425', '2', '160', '2011', '571', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766431', '38', '158', '2012', '550', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766438', '23', '162', '2010', '519', '513', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766439', '129', '158', '2012', '546', '543', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766446', '3', '162', '2010', '520', '514', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766447', '97', '160', '2012', '596', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766451', '56', '158', '2012', '581', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766461', '2', '162', '2010', '519', '516', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766463', '37', '158', '2012', '552', '545', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766467', '8', '160', '2012', '599', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766472', '17', '162', '2010', '524', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766479', '85', '158', '2012', '571', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766480', '38', '160', '2012', '594', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766485', '8', '162', '2010', '521', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766494', '2', '160', '2012', '597', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766500', '85', '158', '2013', '524', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766509', '3', '162', '2010', '533', '526', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766512', '21', '160', '2012', '604', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766514', '4211', '158', '2013', '539', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766520', '21', '162', '2010', '532', '526', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766524', '148', '160', '2012', '593', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766525', '233', '158', '2013', '520', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766533', '222', '158', '2013', '513', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766541', '126', '160', '2012', '596', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766543', '120', '162', '2010', '531', '525', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766548', '4246', '158', '2013', '552', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766556', '126', '162', '2010', '530', '522', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766560', '480', '160', '2012', '598', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766566', '4202', '158', '2013', '546', '539', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766573', '8', '160', '2013', '576', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766575', '85', '158', '2013', '539', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766586', '52', '162', '2011', '526', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766587', '56', '158', '2013', '539', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766590', '233', '160', '2013', '572', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766593', '13', '162', '2011', '527', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766603', '343', '158', '2013', '518', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('766607', '97', '160', '2013', '572', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766612', '5', '162', '2011', '528', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766622', '21', '160', '2013', '591', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('766625', '78', '162', '2011', '527', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766639', '120', '162', '2011', '543', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766650', '21', '162', '2011', '541', '538', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766663', '3', '162', '2011', '559', '537', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766676', '8', '162', '2011', '530', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766690', '17', '162', '2011', '541', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766703', '126', '162', '2011', '544', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766711', '63', '162', '2011', '527', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766721', '10', '162', '2011', '527', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766729', '2', '162', '2011', '530', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766740', '23', '162', '2011', '529', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766752', '3', '162', '2011', '530', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766761', '30', '162', '2011', '525', '503', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766782', '21', '162', '2012', '578', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766798', '8', '162', '2012', '580', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766809', '17', '162', '2012', '575', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766819', '126', '162', '2012', '583', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766833', '78', '162', '2012', '568', '561', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766847', '120', '162', '2012', '576', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766852', '23', '162', '2012', '567', '561', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766862', '3', '162', '2012', '569', '560', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766882', '3', '162', '2012', '591', '577', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('766902', '13', '162', '2012', '567', '555', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766922', '5', '162', '2012', '567', '560', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766938', '10', '162', '2012', '568', '556', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766949', '63', '162', '2012', '565', '555', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766967', '30', '162', '2012', '560', '549', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766976', '52', '162', '2012', '564', '555', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('766992', '2', '162', '2012', '576', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767062', '13', '162', '2013', '531', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767076', '17', '162', '2013', '538', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767092', '21', '162', '2013', '541', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767103', '159', '162', '2013', '537', '514', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767115', '10', '162', '2013', '529', '519', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767129', '1451', '162', '2013', '529', '514', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767138', '5', '162', '2013', '547', '538', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767149', '8', '162', '2013', '540', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767158', '238', '162', '2013', '527', '509', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767161', '37', '147', '2010', '514', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767172', '109', '147', '2010', '547', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('767185', '416', '147', '2010', '547', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('767192', '146', '147', '2010', '506', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767200', '148', '147', '2010', '506', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767211', '38', '147', '2010', '513', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767228', '79', '147', '2010', '509', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767239', '36', '147', '2010', '512', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767257', '85', '147', '2010', '508', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767270', '101', '147', '2010', '501', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767281', '161', '147', '2010', '510', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767294', '175', '147', '2010', '500', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767309', '89', '147', '2010', '503', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767319', '97', '147', '2010', '511', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767333', '328', '147', '2010', '546', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('767351', '140', '147', '2010', '512', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767367', '151', '147', '2010', '544', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('767382', '30', '147', '2010', '516', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767389', '332', '147', '2010', '534', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('767402', '317', '147', '2010', '513', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767419', '153', '147', '2010', '506', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767431', '385', '147', '2010', '534', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('767440', '205', '147', '2010', '505', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767451', '123', '147', '2010', '512', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767463', '141', '147', '2010', '514', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767470', '78', '147', '2010', '504', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767481', '310', '147', '2010', '514', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767492', '129', '147', '2010', '514', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767498', '2', '147', '2010', '514', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767511', '147', '147', '2010', '514', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767525', '143', '147', '2010', '514', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767538', '88', '147', '2010', '508', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767568', '89', '147', '2011', '521', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767579', '3', '147', '2011', '534', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767598', '146', '147', '2011', '526', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767609', '140', '147', '2011', '528', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767627', '147', '147', '2011', '529', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767645', '173', '147', '2011', '523', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767661', '129', '147', '2011', '530', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767671', '143', '147', '2011', '530', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767684', '205', '147', '2011', '522', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767704', '88', '147', '2011', '520', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767715', '38', '147', '2011', '525', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767723', '126', '172', '2010', '531', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767732', '153', '147', '2011', '518', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767736', '266', '172', '2010', '530', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767747', '141', '147', '2011', '525', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767751', '213', '172', '2010', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767760', '148', '147', '2011', '521', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767767', '5', '172', '2010', '530', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767773', '2', '147', '2011', '518', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767775', '10', '172', '2010', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767785', '79', '147', '2011', '517', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767794', '78', '172', '2010', '532', '532', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767797', '416', '147', '2011', '550', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('767805', '21', '175', '2010', '551', '549', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767810', '2', '172', '2010', '531', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767811', '310', '147', '2011', '543', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('767815', '7', '172', '2010', '530', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767816', '126', '175', '2010', '548', '548', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767822', '109', '147', '2011', '568', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('767830', '17', '172', '2010', '531', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767834', '85', '147', '2011', '517', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767836', '2', '175', '2010', '548', '547', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767849', '120', '172', '2010', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767854', '151', '147', '2011', '544', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('767860', '5', '175', '2010', '548', '547', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767865', '3', '172', '2010', '534', '532', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767867', '328', '147', '2011', '579', '540', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('767878', '78', '175', '2010', '546', '546', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767879', '23', '172', '2010', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767885', '101', '147', '2011', '520', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767891', '76', '175', '2010', '546', '545', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767896', '30', '147', '2011', '529', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767904', '17', '147', '2011', '523', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767906', '126', '172', '2011', '542', '542', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767907', '10', '175', '2010', '544', '544', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767915', '317', '147', '2011', '518', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767922', '68', '147', '2011', '520', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767928', '213', '172', '2011', '543', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767934', '97', '147', '2011', '518', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767939', '126', '175', '2011', '559', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767942', '17', '172', '2011', '550', '548', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767953', '332', '147', '2011', '551', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('767955', '78', '175', '2011', '556', '556', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767959', '7', '172', '2011', '544', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767966', '266', '172', '2011', '542', '542', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767968', '123', '147', '2011', '531', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('767976', '5', '175', '2011', '557', '556', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767980', '10', '172', '2011', '543', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767985', '37', '147', '2011', '543', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('767991', '2', '175', '2011', '559', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('767993', '3', '172', '2011', '543', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('767999', '161', '147', '2011', '521', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768002', '78', '172', '2011', '542', '542', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768006', '196', '147', '2011', '519', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768007', '21', '175', '2011', '562', '561', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('768015', '311', '172', '2011', '544', '544', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768022', '10', '175', '2011', '559', '558', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('768025', '78', '147', '2011', '520', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768029', '136', '172', '2011', '541', '541', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768030', '385', '147', '2011', '540', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768041', '36', '147', '2011', '524', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768042', '21', '175', '2012', '603', '601', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('768044', '10', '172', '2012', '577', '577', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768057', '156', '147', '2011', '525', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768060', '3', '172', '2012', '586', '566', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768064', '2', '175', '2012', '598', '598', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('768074', '17', '172', '2012', '584', '582', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768075', '5', '175', '2012', '597', '597', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('768089', '10', '175', '2012', '598', '597', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('768091', '126', '172', '2012', '580', '580', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768104', '266', '172', '2012', '578', '578', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768108', '78', '175', '2012', '596', '596', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('768110', '310', '147', '2012', '575', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768116', '213', '172', '2012', '582', '582', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768128', '126', '175', '2012', '596', '595', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('768131', '136', '172', '2012', '577', '577', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768135', '109', '147', '2012', '576', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768142', '78', '172', '2012', '576', '576', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768149', '78', '147', '2012', '537', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768153', '21', '175', '2013', '565', '563', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('768154', '7', '172', '2012', '583', '583', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768167', '10', '175', '2013', '561', '560', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('768168', '153', '147', '2012', '545', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768170', '43', '172', '2012', '578', '578', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768180', '2', '147', '2012', '544', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768184', '311', '172', '2012', '579', '579', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768185', '5', '175', '2013', '560', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('768197', '385', '147', '2012', '559', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768206', '129', '147', '2012', '557', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768213', '89', '147', '2012', '545', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768225', '507', '172', '2013', '534', '534', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768229', '416', '147', '2012', '570', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768238', '213', '172', '2013', '536', '536', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768245', '205', '147', '2012', '537', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768252', '3874', '172', '2013', '535', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768258', '37', '147', '2012', '560', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768265', '7', '172', '2013', '539', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768272', '156', '147', '2012', '548', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768277', '17', '172', '2013', '542', '541', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768281', '151', '147', '2012', '560', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768293', '68', '147', '2012', '539', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768313', '3', '147', '2012', '545', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768330', '196', '147', '2012', '542', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768336', '23', '180', '2011', '545', '545', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768347', '17', '147', '2012', '541', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768353', '364', '180', '2011', '547', '546', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768369', '141', '147', '2012', '546', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768370', '3', '180', '2011', '558', '554', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768378', '317', '147', '2012', '541', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768383', '10', '180', '2011', '546', '546', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768387', '147', '147', '2012', '566', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768394', '65', '180', '2011', '544', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768406', '5', '180', '2011', '544', '544', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768414', '36', '147', '2012', '544', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768421', '17', '180', '2011', '556', '551', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768428', '88', '147', '2012', '537', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768437', '2', '180', '2011', '544', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768441', '123', '147', '2012', '538', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768459', '85', '147', '2012', '538', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768465', '13', '180', '2011', '543', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768480', '143', '147', '2012', '545', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768491', '480', '180', '2011', '546', '546', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768492', '140', '147', '2012', '545', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768500', '79', '147', '2012', '534', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768510', '17', '180', '2012', '593', '588', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768516', '161', '147', '2012', '540', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768528', '480', '180', '2012', '588', '588', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768530', '148', '147', '2012', '537', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768541', '364', '180', '2012', '589', '586', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768546', '38', '147', '2012', '543', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768557', '3', '180', '2012', '608', '606', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('768563', '30', '147', '2012', '546', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768575', '13', '180', '2012', '583', '583', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768579', '332', '147', '2012', '562', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768588', '2', '180', '2012', '584', '582', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768597', '328', '147', '2012', '568', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768606', '10', '180', '2012', '581', '581', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768615', '173', '147', '2012', '541', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768618', '23', '180', '2012', '586', '584', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768631', '101', '147', '2012', '543', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768643', '4203', '180', '2013', '547', '547', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768652', '10', '147', '2012', '538', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768658', '4376', '180', '2013', '555', '548', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768664', '146', '147', '2012', '544', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768672', '4246', '180', '2013', '572', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('768678', '97', '147', '2012', '542', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768688', '5', '180', '2013', '534', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768707', '101', '147', '2013', '502', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768708', '339', '180', '2013', '537', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768714', '141', '147', '2013', '516', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768724', '13', '180', '2013', '533', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768730', '175', '147', '2013', '502', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768741', '65', '180', '2013', '534', '534', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('768753', '317', '147', '2013', '512', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768769', '237', '147', '2013', '515', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768787', '88', '147', '2013', '506', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768800', '58', '147', '2013', '499', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768815', '5', '147', '2013', '502', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('768820', '17', '147', '2013', '534', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768842', '105', '147', '2013', '532', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768859', '174', '147', '2013', '546', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768883', '444', '147', '2013', '528', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768896', '310', '147', '2013', '547', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768910', '156', '147', '2013', '541', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768932', '85', '147', '2013', '545', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768940', '981', '147', '2013', '551', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768956', '332', '147', '2013', '540', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('768982', '147', '147', '2013', '570', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('769001', '385', '147', '2013', '531', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('769021', '238', '147', '2013', '541', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769037', '85', '147', '2013', '510', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769053', '10', '147', '2013', '509', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769082', '296', '147', '2013', '511', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769087', '83', '147', '2013', '509', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769102', '129', '147', '2013', '516', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769125', '113', '147', '2013', '520', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769135', '55', '147', '2013', '514', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769152', '351', '147', '2013', '515', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769168', '156', '147', '2013', '511', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769188', '173', '147', '2013', '511', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769202', '334', '147', '2013', '511', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769223', '2448', '147', '2013', '510', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769237', '233', '147', '2013', '511', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769254', '161', '147', '2013', '513', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769273', '97', '147', '2013', '509', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769453', '16', '180', '2011', '542', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769469', '17', '180', '2011', '546', '543', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769484', '2', '180', '2011', '545', '543', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769501', '79', '180', '2011', '548', '548', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769518', '3', '180', '2011', '563', '560', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769533', '480', '180', '2011', '553', '548', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769545', '97', '180', '2011', '542', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769563', '10', '180', '2011', '542', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769580', '13', '180', '2011', '541', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769595', '38', '180', '2011', '540', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769605', '364', '180', '2011', '556', '553', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769624', '23', '180', '2011', '546', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769645', '17', '180', '2012', '599', '573', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769663', '97', '180', '2012', '562', '560', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769684', '3', '180', '2012', '597', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('769706', '10', '180', '2012', '563', '563', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769714', '16', '172', '2010', '528', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769718', '38', '180', '2012', '559', '559', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769729', '10', '172', '2010', '532', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769737', '364', '180', '2012', '565', '564', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769747', '79', '172', '2010', '527', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769753', '23', '180', '2012', '564', '563', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769764', '38', '172', '2010', '525', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769767', '13', '180', '2012', '559', '559', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769784', '266', '172', '2010', '527', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769786', '16', '180', '2012', '562', '561', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769799', '79', '180', '2012', '561', '560', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769805', '78', '172', '2010', '526', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769812', '480', '180', '2012', '569', '568', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769827', '97', '172', '2010', '525', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769835', '2', '180', '2012', '565', '563', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769852', '2', '172', '2010', '526', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769863', '97', '180', '2013', '525', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769868', '120', '172', '2010', '524', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769884', '4246', '180', '2013', '567', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('769889', '136', '172', '2010', '525', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769900', '339', '180', '2013', '518', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769906', '43', '172', '2010', '524', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769914', '65', '180', '2013', '524', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769922', '89', '172', '2010', '529', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769929', '4376', '180', '2013', '529', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769932', '221', '172', '2010', '539', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769945', '5', '180', '2013', '530', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769953', '8', '172', '2010', '529', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769959', '3774', '180', '2013', '542', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769974', '4203', '180', '2013', '537', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769975', '5', '172', '2010', '529', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769991', '233', '180', '2013', '526', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('769994', '17', '172', '2010', '530', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770018', '3', '172', '2010', '533', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770021', '317', '159', '2010', '498', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770032', '364', '172', '2010', '532', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770037', '37', '159', '2010', '503', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770056', '254', '159', '2010', '495', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770058', '213', '172', '2010', '533', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770074', '21', '159', '2010', '510', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770080', '126', '172', '2010', '533', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770090', '419', '159', '2010', '507', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770095', '7', '172', '2010', '537', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770100', '192', '159', '2010', '502', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770111', '23', '172', '2010', '534', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770118', '4469', '159', '2010', '499', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770129', '139', '172', '2010', '528', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770139', '40', '159', '2010', '502', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770153', '43', '159', '2010', '497', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770160', '97', '172', '2011', '559', '549', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770169', '118', '159', '2010', '510', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770177', '17', '172', '2011', '543', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770187', '5', '159', '2010', '500', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770190', '266', '172', '2011', '566', '548', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770201', '981', '175', '2010', '545', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770203', '4470', '159', '2010', '509', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770211', '7', '172', '2011', '543', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770224', '10', '172', '2011', '546', '543', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770225', '759', '175', '2010', '549', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770230', '932', '159', '2010', '501', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770243', '85', '159', '2010', '498', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770244', '221', '172', '2011', '547', '547', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770256', '3', '175', '2010', '545', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770264', '5', '172', '2011', '554', '554', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770266', '572', '175', '2010', '544', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770269', '148', '159', '2010', '504', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770282', '139', '172', '2011', '544', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770284', '8', '159', '2010', '512', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770292', '147', '175', '2010', '546', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770297', '213', '172', '2011', '544', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770305', '10', '159', '2010', '504', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770308', '24', '175', '2010', '548', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770314', '364', '172', '2011', '553', '553', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770325', '78', '159', '2010', '494', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770328', '23', '172', '2011', '542', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770335', '99', '159', '2010', '505', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770345', '1015', '175', '2010', '546', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770348', '16', '172', '2011', '542', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770356', '140', '175', '2010', '548', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770365', '2448', '159', '2010', '498', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770372', '444', '175', '2010', '547', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770374', '126', '172', '2011', '541', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770389', '43', '172', '2011', '553', '553', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770390', '156', '159', '2010', '505', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770393', '222', '175', '2010', '547', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770407', '38', '175', '2010', '546', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770408', '151', '159', '2010', '503', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770410', '120', '172', '2011', '539', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770422', '325', '175', '2010', '542', '542', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770423', '173', '159', '2010', '500', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770428', '113', '162', '2010', '538', '518', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770429', '113', '175', '2010', '550', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770433', '79', '172', '2011', '539', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770437', '12', '159', '2010', '502', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770438', '10', '162', '2010', '516', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770444', '2', '172', '2011', '547', '547', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770446', '89', '162', '2010', '508', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770452', '89', '159', '2010', '505', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770453', '8', '175', '2010', '550', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770456', '3', '172', '2011', '552', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770457', '161', '162', '2010', '515', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770468', '1668', '159', '2010', '502', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770469', '95', '175', '2010', '553', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770475', '79', '162', '2010', '514', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770476', '8', '172', '2011', '570', '558', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770482', '55', '175', '2010', '547', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770490', '129', '159', '2010', '528', '517', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770491', '136', '172', '2011', '539', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770492', '23', '162', '2010', '508', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770495', '794', '175', '2010', '554', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770500', '52', '162', '2010', '510', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770502', '89', '172', '2011', '543', '543', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770504', '30', '159', '2010', '501', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770508', '97', '175', '2010', '549', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770519', '151', '162', '2010', '514', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770520', '38', '172', '2011', '544', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770522', '55', '159', '2010', '499', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770526', '85', '175', '2010', '559', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770536', '38', '162', '2010', '516', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770538', '311', '172', '2011', '540', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770543', '107', '175', '2010', '550', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770546', '101', '159', '2010', '493', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770555', '233', '162', '2010', '514', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770556', '78', '172', '2011', '543', '543', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770557', '325', '159', '2010', '491', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770563', '87', '175', '2010', '558', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770570', '69', '159', '2010', '496', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770578', '148', '162', '2010', '513', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770579', '351', '175', '2010', '556', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770584', '143', '159', '2010', '506', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770588', '3', '172', '2012', '567', '562', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770592', '129', '175', '2010', '550', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770597', '3', '162', '2010', '514', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770600', '229', '159', '2010', '534', '526', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770604', '10', '172', '2012', '563', '563', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770609', '141', '162', '2010', '513', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770612', '25', '175', '2010', '550', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770614', '120', '172', '2012', '560', '560', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770617', '441', '159', '2010', '518', '518', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770624', '107', '162', '2010', '519', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770630', '38', '172', '2012', '566', '564', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770636', '444', '175', '2011', '569', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770637', '4472', '159', '2010', '514', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770646', '115', '162', '2010', '513', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770650', '36', '159', '2010', '521', '517', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770652', '78', '172', '2012', '559', '559', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770653', '24', '175', '2011', '569', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770662', '16', '162', '2010', '510', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770667', '5', '172', '2012', '558', '558', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770669', '146', '159', '2010', '529', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770673', '759', '175', '2011', '566', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770683', '572', '175', '2011', '560', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770684', '36', '162', '2010', '548', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770686', '310', '159', '2010', '530', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770689', '17', '172', '2012', '585', '574', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770699', '222', '175', '2011', '564', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770708', '139', '172', '2012', '562', '562', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770710', '1356', '159', '2010', '528', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770711', '173', '162', '2010', '532', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770716', '87', '175', '2011', '574', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770725', '126', '172', '2012', '556', '556', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770729', '112', '162', '2010', '528', '518', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770730', '97', '159', '2010', '497', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770736', '266', '172', '2012', '558', '558', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770739', '3', '175', '2011', '576', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770746', '105', '162', '2010', '531', '518', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770747', '486', '159', '2010', '494', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770754', '8', '172', '2012', '567', '566', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770756', '325', '175', '2011', '564', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770763', '153', '162', '2010', '547', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770769', '233', '159', '2010', '498', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770771', '213', '172', '2012', '560', '560', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770772', '143', '162', '2010', '537', '518', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770777', '109', '159', '2010', '506', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770781', '97', '175', '2011', '563', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770793', '136', '172', '2012', '559', '559', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770796', '3', '162', '2010', '536', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770801', '129', '175', '2011', '566', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770802', '140', '159', '2010', '510', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770811', '21', '162', '2010', '529', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770813', '97', '172', '2012', '565', '562', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770815', '95', '175', '2011', '568', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770824', '123', '159', '2010', '512', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770829', '351', '175', '2011', '570', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770836', '79', '172', '2012', '559', '558', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770838', '113', '159', '2010', '533', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770839', '131', '162', '2010', '539', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770842', '794', '175', '2011', '567', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770854', '43', '172', '2012', '564', '564', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770856', '3', '159', '2010', '511', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770857', '126', '162', '2010', '531', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770861', '8', '175', '2011', '574', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770872', '205', '159', '2010', '494', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770875', '129', '162', '2010', '546', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770879', '2', '172', '2012', '563', '563', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770882', '1015', '175', '2011', '565', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770892', '176', '162', '2010', '571', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770894', '186', '159', '2010', '494', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770900', '23', '172', '2012', '558', '558', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770905', '107', '175', '2011', '567', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770907', '5', '162', '2010', '507', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770926', '311', '172', '2012', '559', '559', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770927', '147', '162', '2010', '538', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770928', '205', '159', '2011', '515', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770932', '38', '175', '2011', '569', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770942', '364', '172', '2012', '563', '563', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770944', '4469', '159', '2011', '526', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770945', '391', '162', '2010', '513', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770948', '147', '175', '2011', '567', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770954', '99', '159', '2011', '524', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770955', '30', '162', '2010', '518', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770960', '7', '172', '2012', '564', '562', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770970', '55', '175', '2011', '567', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770975', '158', '162', '2010', '533', '517', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770978', '140', '159', '2011', '517', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770982', '16', '172', '2012', '558', '558', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770987', '140', '175', '2011', '563', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('770990', '78', '162', '2010', '515', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('770997', '37', '159', '2011', '519', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771001', '89', '172', '2012', '568', '568', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771004', '25', '175', '2011', '578', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771010', '129', '159', '2011', '550', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771018', '221', '172', '2012', '567', '567', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771019', '981', '175', '2011', '565', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771021', '17', '162', '2010', '517', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771026', '233', '159', '2011', '514', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771037', '109', '162', '2010', '550', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771038', '763', '175', '2011', '561', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771041', '932', '159', '2011', '518', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771048', '221', '172', '2013', '536', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771056', '101', '162', '2010', '512', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771057', '113', '175', '2011', '571', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771060', '36', '159', '2011', '532', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771062', '213', '172', '2013', '534', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771073', '85', '162', '2010', '512', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771075', '153', '175', '2011', '569', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771080', '113', '159', '2011', '534', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771085', '7', '172', '2013', '538', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771092', '2', '162', '2010', '514', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771098', '4472', '159', '2011', '519', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771100', '1015', '175', '2012', '581', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771102', '17', '172', '2013', '535', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771103', '120', '162', '2010', '527', '517', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771116', '123', '159', '2011', '518', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771117', '140', '175', '2012', '586', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771120', '146', '162', '2010', '523', '517', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771126', '10', '172', '2013', '535', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771131', '8', '159', '2011', '515', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771133', '8', '162', '2010', '516', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771136', '351', '175', '2012', '596', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771145', '507', '172', '2013', '532', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771147', '317', '159', '2011', '524', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771149', '97', '175', '2012', '589', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771157', '37', '162', '2010', '517', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771159', '4333', '172', '2013', '547', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771164', '161', '159', '2011', '527', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771165', '153', '175', '2012', '584', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771175', '132', '162', '2010', '542', '517', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771176', '25', '175', '2012', '598', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771177', '1668', '159', '2011', '523', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771179', '233', '172', '2013', '528', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771195', '8', '172', '2013', '538', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771196', '186', '159', '2011', '513', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771197', '325', '175', '2012', '587', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771208', '148', '162', '2011', '612', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771212', '190', '159', '2011', '505', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771213', '113', '175', '2012', '590', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771214', '4256', '172', '2013', '539', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771229', '37', '162', '2011', '528', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771231', '572', '175', '2012', '584', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771232', '3874', '172', '2013', '527', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771233', '441', '159', '2011', '537', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771248', '146', '162', '2011', '539', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771249', '55', '175', '2012', '594', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771250', '132', '159', '2011', '530', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771266', '12', '159', '2011', '518', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771268', '759', '175', '2012', '591', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771269', '131', '162', '2011', '536', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771279', '10', '159', '2011', '511', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771287', '981', '175', '2012', '583', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771289', '105', '162', '2011', '546', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771300', '143', '159', '2011', '522', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771301', '222', '175', '2012', '591', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771304', '126', '162', '2011', '545', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771313', '23', '159', '2011', '522', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771316', '95', '175', '2012', '588', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771328', '147', '175', '2012', '587', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771329', '158', '162', '2011', '574', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771332', '325', '159', '2011', '510', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771344', '24', '175', '2012', '589', '588', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771349', '151', '162', '2011', '537', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771350', '146', '159', '2011', '544', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771365', '8', '175', '2012', '589', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771366', '153', '162', '2011', '542', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771370', '118', '159', '2011', '521', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771377', '109', '162', '2011', '541', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771383', '78', '159', '2011', '522', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771384', '87', '175', '2012', '595', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771393', '23', '162', '2011', '523', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771394', '101', '159', '2011', '523', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771402', '107', '175', '2012', '586', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771410', '85', '162', '2011', '555', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771417', '229', '159', '2011', '545', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771418', '129', '175', '2012', '593', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771427', '141', '162', '2011', '542', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771434', '4470', '159', '2011', '515', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771436', '444', '175', '2012', '584', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771449', '16', '162', '2011', '546', '542', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771451', '173', '159', '2011', '532', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771457', '339', '175', '2012', '582', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771462', '3', '162', '2011', '558', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771464', '3', '159', '2011', '525', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771465', '38', '175', '2012', '587', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771480', '38', '162', '2011', '542', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771481', '85', '159', '2011', '510', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771483', '3', '175', '2012', '591', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771492', '419', '159', '2011', '519', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771494', '143', '162', '2011', '546', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771505', '113', '175', '2013', '561', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771507', '151', '159', '2011', '514', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771510', '173', '162', '2011', '544', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771528', '69', '159', '2011', '519', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771531', '89', '162', '2011', '524', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771535', '981', '175', '2013', '560', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771542', '5', '159', '2011', '521', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771551', '10', '162', '2011', '530', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771552', '85', '175', '2013', '568', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771564', '385', '175', '2013', '557', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771567', '310', '159', '2011', '538', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771578', '95', '175', '2013', '558', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771579', '52', '162', '2011', '522', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771588', '89', '159', '2011', '516', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771595', '8', '175', '2013', '565', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771597', '176', '162', '2011', '549', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771608', '21', '159', '2011', '521', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771610', '444', '175', '2013', '565', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771615', '5', '162', '2011', '523', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771622', '148', '159', '2011', '512', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771629', '351', '175', '2013', '562', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771631', '233', '162', '2011', '546', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771641', '43', '159', '2011', '531', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771647', '107', '162', '2011', '548', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771649', '759', '175', '2013', '566', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771662', '156', '159', '2011', '528', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771664', '296', '175', '2013', '558', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771666', '391', '162', '2011', '533', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771678', '233', '175', '2013', '558', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771680', '101', '162', '2011', '522', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771681', '254', '159', '2011', '510', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771692', '4216', '175', '2013', '571', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771693', '3', '162', '2011', '532', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771694', '109', '159', '2011', '520', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771707', '2448', '159', '2011', '511', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771714', '237', '175', '2013', '555', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771716', '2', '162', '2011', '528', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771730', '55', '159', '2011', '512', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771737', '79', '162', '2011', '527', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771742', '163', '175', '2013', '577', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771743', '1356', '159', '2011', '540', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771750', '115', '162', '2011', '544', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771756', '83', '175', '2013', '555', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771760', '192', '159', '2011', '519', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771766', '147', '162', '2011', '557', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771767', '222', '175', '2013', '570', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771775', '97', '159', '2011', '516', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771780', '129', '162', '2011', '559', '540', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771782', '483', '175', '2013', '577', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771787', '30', '162', '2011', '558', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771789', '30', '159', '2011', '520', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771799', '310', '175', '2013', '557', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771803', '120', '159', '2011', '522', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771809', '8', '162', '2011', '529', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771814', '40', '159', '2011', '512', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771817', '4474', '175', '2013', '566', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771819', '78', '162', '2011', '525', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771832', '486', '159', '2011', '504', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771834', '339', '175', '2013', '557', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771835', '161', '162', '2011', '547', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771847', '97', '175', '2013', '556', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771849', '113', '162', '2011', '565', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771864', '17', '162', '2011', '540', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771871', '23', '159', '2012', '541', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771880', '36', '162', '2011', '539', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771887', '441', '159', '2012', '578', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771896', '132', '162', '2011', '560', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771898', '113', '159', '2012', '559', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771909', '120', '162', '2011', '541', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771912', '55', '159', '2012', '533', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771931', '101', '159', '2012', '527', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771934', '21', '162', '2011', '539', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771940', '310', '159', '2012', '566', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771945', '112', '162', '2011', '566', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771952', '254', '159', '2012', '536', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771969', '78', '159', '2012', '527', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771982', '173', '162', '2012', '567', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771984', '37', '159', '2012', '541', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('771995', '129', '162', '2012', '585', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('771997', '3', '159', '2012', '548', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772007', '151', '159', '2012', '527', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772017', '112', '162', '2012', '564', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772025', '40', '159', '2012', '528', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772029', '8', '162', '2012', '559', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772040', '1356', '159', '2012', '562', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772049', '131', '162', '2012', '553', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772055', '69', '159', '2012', '527', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772069', '176', '162', '2012', '562', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772075', '148', '159', '2012', '528', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772086', '85', '162', '2012', '552', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772096', '146', '162', '2012', '574', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772098', '132', '159', '2012', '542', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772104', '391', '162', '2012', '549', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772113', '140', '159', '2012', '528', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772123', '148', '162', '2012', '560', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772130', '2448', '159', '2012', '532', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772135', '233', '162', '2012', '551', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772144', '12', '159', '2012', '527', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772151', '79', '162', '2012', '545', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772161', '419', '159', '2012', '541', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772168', '126', '162', '2012', '555', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772178', '17', '162', '2012', '563', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772186', '4470', '159', '2012', '526', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772189', '105', '162', '2012', '562', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772194', '4472', '159', '2012', '549', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772204', '21', '162', '2012', '557', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772210', '99', '159', '2012', '527', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772216', '151', '162', '2012', '553', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772226', '932', '159', '2012', '527', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772233', '186', '159', '2012', '529', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772237', '78', '162', '2012', '546', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772247', '4469', '159', '2012', '536', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772251', '37', '162', '2012', '554', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772260', '486', '159', '2012', '524', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772262', '107', '162', '2012', '554', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772278', '129', '159', '2012', '554', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772280', '109', '162', '2012', '556', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772291', '325', '159', '2012', '528', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772301', '143', '162', '2012', '567', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772309', '192', '159', '2012', '543', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772318', '38', '162', '2012', '553', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772328', '161', '159', '2012', '545', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772335', '147', '162', '2012', '569', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772347', '120', '162', '2012', '555', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772353', '229', '159', '2012', '567', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772366', '205', '159', '2012', '546', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772367', '23', '162', '2012', '544', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772376', '43', '159', '2012', '537', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772384', '113', '162', '2012', '572', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772386', '8', '159', '2012', '547', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772396', '190', '159', '2012', '543', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772399', '3', '162', '2012', '553', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772408', '36', '162', '2012', '552', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772412', '89', '159', '2012', '540', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772422', '3', '162', '2012', '566', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772429', '317', '159', '2012', '541', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772430', '132', '162', '2012', '562', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772439', '2', '162', '2012', '559', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772441', '1668', '159', '2012', '543', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772453', '115', '162', '2012', '550', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772454', '21', '159', '2012', '544', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772467', '109', '159', '2012', '538', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772468', '16', '162', '2012', '552', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772478', '158', '162', '2012', '553', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772482', '30', '159', '2012', '544', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772494', '146', '159', '2012', '556', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772500', '161', '162', '2012', '551', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772506', '36', '159', '2012', '553', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772514', '101', '162', '2012', '546', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772521', '97', '159', '2012', '523', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772530', '85', '159', '2012', '546', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772536', '10', '162', '2012', '544', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772546', '5', '159', '2012', '523', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772555', '30', '162', '2012', '546', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772566', '153', '162', '2012', '553', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772570', '123', '159', '2012', '544', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772579', '5', '162', '2012', '542', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772580', '143', '159', '2012', '543', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772595', '141', '162', '2012', '552', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772600', '118', '159', '2012', '538', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772609', '52', '162', '2012', '543', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772617', '156', '159', '2012', '532', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772624', '10', '159', '2012', '535', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772642', '120', '159', '2012', '528', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772643', '385', '162', '2013', '541', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772651', '310', '162', '2013', '538', '526', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772656', '233', '159', '2012', '548', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772668', '112', '162', '2013', '525', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772683', '113', '162', '2013', '539', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772686', '97', '159', '2013', '500', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772695', '161', '159', '2013', '510', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772703', '391', '162', '2013', '549', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772712', '296', '162', '2013', '528', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772716', '12', '159', '2013', '508', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772725', '8', '162', '2013', '527', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772736', '174', '162', '2013', '527', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772741', '40', '159', '2013', '499', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772761', '4253', '162', '2013', '533', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772762', '156', '159', '2013', '507', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772780', '129', '162', '2013', '534', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772782', '174', '159', '2013', '535', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772798', '483', '159', '2013', '503', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772801', '238', '162', '2013', '519', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772813', '317', '159', '2013', '495', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772821', '173', '162', '2013', '527', '526', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772832', '113', '159', '2013', '532', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772844', '21', '162', '2013', '566', '530', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772855', '147', '159', '2013', '517', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772860', '334', '162', '2013', '526', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772875', '85', '162', '2013', '557', '529', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772881', '1356', '159', '2013', '538', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772894', '105', '162', '2013', '527', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772900', '206', '159', '2013', '514', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772913', '5', '162', '2013', '526', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772925', '141', '159', '2013', '511', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772943', '233', '162', '2013', '528', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772944', '238', '159', '2013', '515', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('772955', '416', '159', '2013', '536', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772962', '17', '162', '2013', '527', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772964', '310', '159', '2013', '540', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772981', '293', '209', '2010', '572', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('772986', '229', '159', '2013', '541', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772987', '40', '162', '2013', '532', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('772988', '471', '209', '2010', '569', '569', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773002', '112', '159', '2013', '511', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773004', '140', '162', '2013', '526', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773011', '22', '209', '2010', '569', '569', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773017', '351', '159', '2013', '499', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773026', '101', '162', '2013', '526', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773028', '85', '159', '2013', '526', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773039', '156', '162', '2013', '525', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773041', '8', '209', '2010', '570', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773049', '296', '159', '2013', '504', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773055', '161', '162', '2013', '527', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773059', '159', '209', '2010', '568', '568', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773068', '336', '159', '2013', '499', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773073', '932', '162', '2013', '525', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773077', '79', '209', '2010', '566', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773080', '85', '159', '2013', '498', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773085', '270', '209', '2010', '566', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773087', '2448', '162', '2013', '527', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773096', '63', '209', '2010', '566', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773099', '237', '159', '2013', '503', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773101', '147', '162', '2013', '531', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773110', '426', '162', '2013', '526', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773117', '18', '209', '2010', '566', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773118', '233', '159', '2013', '515', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773126', '3052', '162', '2013', '526', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773132', '2', '209', '2010', '565', '565', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773140', '10', '162', '2013', '521', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773142', '21', '159', '2013', '516', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773144', '48', '209', '2010', '565', '565', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773153', '105', '159', '2013', '508', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773157', '10', '209', '2010', '566', '565', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773158', '141', '162', '2013', '526', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773170', '83', '159', '2013', '496', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773176', '5', '209', '2010', '565', '565', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773187', '144', '159', '2013', '499', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773200', '118', '159', '2013', '510', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773205', '8', '209', '2011', '581', '581', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773218', '8', '159', '2013', '505', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773223', '2', '209', '2011', '582', '580', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773232', '932', '159', '2013', '507', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773241', '18', '209', '2011', '582', '582', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773247', '101', '159', '2013', '491', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773260', '22', '209', '2011', '592', '592', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773264', '95', '159', '2013', '508', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773277', '4475', '209', '2011', '581', '581', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773279', '328', '159', '2013', '512', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773298', '10', '159', '2013', '510', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773300', '471', '209', '2011', '588', '588', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773313', '12', '209', '2011', '582', '582', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773320', '5', '209', '2011', '580', '580', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773322', '55', '159', '2013', '501', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773335', '159', '209', '2011', '585', '585', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773346', '129', '159', '2013', '518', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773348', '10', '209', '2011', '579', '579', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773358', '63', '209', '2011', '579', '579', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773361', '486', '159', '2013', '497', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773375', '2448', '159', '2013', '493', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('773377', '79', '209', '2011', '579', '579', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773392', '48', '209', '2011', '580', '580', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773407', '339', '209', '2011', '585', '585', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773433', '64', '209', '2012', '620', '620', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773448', '5', '209', '2012', '612', '612', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773464', '10', '209', '2012', '621', '620', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773487', '3', '209', '2012', '622', '622', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773494', '18', '209', '2012', '612', '612', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773507', '63', '209', '2012', '613', '613', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773528', '5', '209', '2013', '583', '583', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773537', '175', '209', '2013', '582', '582', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773550', '8', '209', '2013', '588', '588', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773562', '10', '209', '2013', '583', '583', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('773792', '5', '209', '2010', '583', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773820', '2', '209', '2010', '587', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773837', '18', '209', '2010', '583', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773855', '514', '209', '2010', '583', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773874', '8', '209', '2010', '597', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773888', '63', '209', '2010', '594', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773907', '159', '209', '2010', '590', '590', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773926', '10', '209', '2010', '591', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773955', '22', '209', '2010', '600', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773973', '270', '209', '2010', '586', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('773997', '79', '209', '2010', '585', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774021', '69', '209', '2010', '583', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774061', '8', '209', '2011', '612', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774076', '63', '209', '2011', '603', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774095', '10', '209', '2011', '612', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774111', '159', '209', '2011', '610', '610', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774132', '175', '209', '2011', '602', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774146', '22', '209', '2011', '617', '617', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774164', '79', '209', '2011', '604', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774185', '12', '209', '2011', '608', '608', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774202', '69', '209', '2011', '601', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774222', '5', '209', '2011', '609', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774237', '339', '209', '2011', '612', '612', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774252', '2', '209', '2011', '602', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774266', '18', '209', '2011', '601', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774284', '4194', '209', '2011', '609', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774317', '10', '209', '2012', '630', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774331', '64', '209', '2012', '627', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774338', '18', '209', '2012', '641', '629', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774359', '5', '209', '2012', '628', '622', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774368', '63', '209', '2012', '626', '623', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774383', '3', '209', '2012', '634', '632', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774417', '8', '209', '2013', '609', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774432', '175', '209', '2013', '593', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774451', '5', '209', '2013', '597', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774464', '10', '209', '2013', '598', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774604', '2', '219', '2010', '546', '546', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('774617', '16', '219', '2010', '549', '546', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('774639', '16', '219', '2011', '567', '564', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('774660', '2', '219', '2011', '562', '561', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('774689', '4256', '219', '2013', '563', '562', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('774941', '2', '219', '2010', '559', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774966', '16', '219', '2010', '546', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('774984', '95', '219', '2010', '543', '540', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('775006', '95', '219', '2011', '563', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('775025', '2', '219', '2011', '567', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('775041', '21', '219', '2011', '569', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('775057', '16', '219', '2011', '564', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('775187', '5', '218', '2010', '504', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775202', '30', '218', '2010', '514', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775215', '207', '218', '2010', '500', '495', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775228', '3', '218', '2010', '505', '497', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775245', '23', '218', '2010', '504', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775259', '10', '218', '2010', '504', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775268', '78', '218', '2010', '504', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775279', '8', '218', '2010', '499', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775287', '120', '218', '2010', '503', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775303', '69', '218', '2010', '494', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775314', '13', '218', '2010', '506', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775336', '207', '218', '2011', '513', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775348', '12', '218', '2011', '509', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775363', '78', '218', '2011', '510', '505', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775377', '120', '218', '2011', '520', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775383', '5', '218', '2011', '511', '503', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775396', '13', '218', '2011', '514', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775411', '69', '218', '2011', '512', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775436', '10', '218', '2011', '514', '505', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775453', '23', '218', '2011', '517', '509', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775469', '8', '218', '2011', '516', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775490', '30', '218', '2011', '512', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775510', '3', '218', '2011', '522', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775530', '3', '218', '2012', '556', '548', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775548', '78', '218', '2012', '554', '544', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775560', '23', '218', '2012', '554', '546', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775579', '428', '218', '2012', '547', '540', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775596', '207', '218', '2012', '548', '546', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775615', '30', '218', '2012', '567', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775640', '120', '218', '2012', '564', '546', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775653', '5', '218', '2012', '550', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775672', '8', '218', '2012', '553', '547', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775688', '69', '218', '2012', '548', '540', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775705', '13', '218', '2012', '550', '540', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775733', '10', '218', '2012', '551', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775748', '12', '218', '2012', '558', '541', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775767', '8', '218', '2013', '530', '511', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775783', '10', '218', '2013', '518', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775801', '4429', '218', '2013', '511', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775815', '238', '218', '2013', '519', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775825', '13', '218', '2013', '510', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775841', '12', '218', '2013', '513', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775856', '5', '218', '2013', '514', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775874', '69', '218', '2013', '515', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('775979', '5', '231', '2010', '545', '540', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('775996', '61', '231', '2010', '545', '545', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('776011', '10', '231', '2010', '549', '549', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('776026', '17', '231', '2010', '550', '550', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('776057', '10', '231', '2011', '562', '562', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('776074', '24', '231', '2011', '558', '558', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('776091', '5', '231', '2011', '561', '558', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('776105', '17', '231', '2011', '563', '562', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('776122', '2', '231', '2011', '565', '565', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('776140', '17', '231', '2012', '606', '604', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('776157', '5', '231', '2012', '597', '593', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('776169', '10', '231', '2012', '600', '600', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('776182', '24', '231', '2012', '595', '595', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('776229', '10', '231', '2013', '562', '561', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('776254', '4203', '231', '2013', '566', '565', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('776271', '4205', '231', '2013', '562', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('776288', '92', '234', '2010', '547', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776295', '205', '234', '2010', '546', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776310', '144', '234', '2010', '547', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776335', '324', '234', '2010', '547', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776356', '101', '234', '2010', '545', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776370', '115', '234', '2010', '550', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776383', '30', '234', '2010', '547', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776410', '165', '234', '2010', '553', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776427', '38', '234', '2010', '547', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776441', '97', '234', '2010', '542', '542', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776460', '37', '234', '2010', '566', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776474', '149', '234', '2010', '544', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776498', '324', '234', '2011', '557', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776507', '10', '234', '2011', '556', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776526', '246', '234', '2011', '556', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776537', '79', '234', '2011', '566', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776562', '119', '234', '2011', '557', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776575', '149', '234', '2011', '555', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776596', '30', '234', '2011', '566', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776614', '101', '234', '2011', '560', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776628', '205', '234', '2011', '565', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776644', '165', '234', '2011', '571', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776664', '38', '234', '2011', '565', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776679', '92', '234', '2011', '558', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776696', '196', '234', '2011', '563', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776712', '143', '234', '2011', '567', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776730', '36', '234', '2011', '566', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776735', '107', '234', '2011', '560', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776755', '381', '234', '2011', '555', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776774', '144', '234', '2011', '569', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776789', '147', '234', '2011', '572', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776800', '2', '234', '2011', '588', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776817', '190', '234', '2011', '554', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776835', '97', '234', '2011', '557', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776857', '37', '234', '2011', '573', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776871', '115', '234', '2011', '560', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776887', '251', '234', '2011', '564', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776902', '148', '234', '2011', '554', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776921', '38', '234', '2012', '582', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776932', '165', '234', '2012', '581', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776958', '92', '234', '2012', '577', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776974', '115', '234', '2012', '580', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('776989', '251', '234', '2012', '585', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777006', '30', '234', '2012', '578', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777023', '97', '234', '2012', '586', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777038', '83', '234', '2012', '581', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777052', '36', '234', '2012', '581', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777071', '3', '234', '2012', '582', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777088', '144', '234', '2012', '581', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777106', '10', '234', '2012', '581', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777123', '107', '234', '2012', '580', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777139', '2', '234', '2012', '582', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777156', '68', '234', '2012', '576', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777171', '246', '234', '2012', '575', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777178', '147', '234', '2012', '583', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777195', '37', '234', '2012', '592', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777215', '79', '234', '2012', '580', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777225', '1329', '242', '2010', '528', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777242', '148', '234', '2012', '575', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777246', '5', '242', '2010', '531', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777264', '8', '234', '2012', '578', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777266', '79', '242', '2010', '527', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777283', '143', '234', '2012', '589', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777284', '3', '242', '2010', '530', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777293', '158', '234', '2012', '579', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777302', '10', '242', '2011', '536', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777303', '17', '231', '2010', '559', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777319', '324', '234', '2012', '586', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777320', '2', '231', '2010', '551', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777327', '87', '242', '2011', '537', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777336', '21', '234', '2012', '579', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777338', '3', '242', '2011', '543', '540', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777341', '147', '231', '2010', '551', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777347', '27', '231', '2010', '551', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777352', '89', '242', '2011', '537', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777368', '5', '231', '2010', '544', '541', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777371', '238', '234', '2013', '571', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777380', '21', '242', '2011', '547', '541', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777381', '101', '234', '2013', '547', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777382', '105', '231', '2010', '557', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777390', '121', '231', '2010', '565', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777393', '78', '242', '2012', '573', '569', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777396', '10', '234', '2013', '548', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777399', '61', '231', '2010', '548', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777408', '1329', '242', '2012', '577', '572', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777412', '105', '234', '2013', '567', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777416', '10', '231', '2010', '546', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777424', '12', '242', '2012', '568', '565', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777425', '246', '234', '2013', '546', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777434', '97', '231', '2010', '546', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777442', '4342', '234', '2013', '551', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777446', '69', '242', '2012', '575', '570', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777449', '29', '231', '2010', '547', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777460', '113', '234', '2013', '561', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777468', '3', '242', '2012', '584', '577', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777469', '8', '244', '2010', '519', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777471', '34', '231', '2010', '545', '539', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777475', '92', '234', '2013', '554', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777487', '52', '244', '2010', '511', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777489', '10', '242', '2013', '532', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777491', '309', '231', '2010', '554', '533', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('777494', '233', '234', '2013', '559', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777501', '5', '242', '2013', '530', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777502', '389', '231', '2010', '557', '532', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('777512', '52', '244', '2011', '526', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777516', '174', '234', '2013', '554', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777522', '2', '231', '2011', '571', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777529', '8', '244', '2011', '530', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777531', '97', '234', '2013', '551', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777543', '138', '234', '2013', '553', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777548', '29', '231', '2011', '567', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777553', '8', '244', '2012', '569', '568', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('777554', '60', '247', '2013', '571', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('777559', '5', '231', '2011', '564', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777561', '310', '234', '2013', '558', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777569', '39', '231', '2011', '564', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777575', '10', '247', '2013', '559', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('777583', '2448', '234', '2013', '557', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777592', '27', '231', '2011', '574', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777595', '5', '247', '2013', '557', '557', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('777609', '116', '231', '2011', '572', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777610', '151', '234', '2013', '551', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777612', '66', '247', '2013', '566', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('777625', '24', '231', '2011', '561', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777632', '336', '234', '2013', '553', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777640', '10', '231', '2011', '569', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777646', '385', '234', '2013', '551', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777657', '147', '234', '2013', '549', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777664', '1329', '242', '2010', '520', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777668', '17', '231', '2011', '574', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777676', '129', '234', '2013', '558', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777684', '12', '231', '2011', '561', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777685', '79', '242', '2010', '522', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777699', '5', '234', '2013', '549', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777700', '3', '242', '2010', '523', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777706', '12', '231', '2012', '580', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777716', '8', '234', '2013', '550', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777720', '5', '242', '2010', '518', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777724', '39', '231', '2012', '584', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777735', '88', '234', '2013', '553', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777745', '10', '242', '2011', '537', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777756', '29', '231', '2012', '582', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777758', '89', '242', '2011', '534', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777777', '10', '231', '2012', '581', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777788', '21', '242', '2011', '536', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777800', '116', '231', '2012', '588', '585', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777808', '87', '242', '2011', '530', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777814', '27', '231', '2012', '593', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777829', '3', '242', '2011', '536', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777838', '5', '231', '2012', '584', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777846', '3', '242', '2012', '553', '549', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777858', '24', '231', '2012', '581', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777867', '1329', '242', '2012', '557', '553', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777874', '17', '231', '2012', '589', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777885', '69', '242', '2012', '547', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777906', '12', '242', '2012', '550', '550', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777912', '10', '231', '2013', '557', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777924', '310', '231', '2013', '553', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777928', '79', '242', '2012', '565', '550', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777946', '78', '242', '2012', '552', '548', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777949', '4205', '231', '2013', '559', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777969', '87', '242', '2012', '557', '549', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('777970', '12', '231', '2013', '552', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777985', '4202', '231', '2013', '558', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('777990', '233', '242', '2013', '521', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778006', '4211', '231', '2013', '580', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778010', '10', '242', '2013', '520', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778023', '4226', '231', '2013', '555', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778027', '5', '242', '2013', '513', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778041', '69', '249', '2010', '525', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778043', '4330', '231', '2013', '565', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778057', '10', '249', '2010', '522', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778060', '4203', '231', '2013', '561', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778072', '13', '249', '2010', '519', '517', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778089', '203', '249', '2010', '521', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778108', '13', '249', '2011', '527', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778123', '357', '249', '2011', '529', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778142', '203', '249', '2011', '536', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778161', '59', '249', '2011', '533', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778181', '69', '249', '2011', '534', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778202', '13', '249', '2012', '567', '566', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778221', '66', '247', '2010', '614', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778222', '203', '249', '2012', '568', '566', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778237', '59', '249', '2012', '571', '569', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778239', '60', '247', '2010', '573', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778256', '75', '247', '2010', '559', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778259', '69', '249', '2012', '574', '572', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778271', '5', '247', '2010', '557', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778281', '13', '249', '2013', '530', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778287', '91', '247', '2010', '558', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778304', '58', '249', '2013', '537', '536', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778308', '52', '247', '2011', '559', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778317', '69', '249', '2013', '535', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778321', '91', '247', '2011', '573', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778335', '498', '249', '2013', '539', '538', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778343', '66', '247', '2011', '629', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778366', '60', '247', '2011', '574', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778382', '10', '247', '2011', '556', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778398', '86', '247', '2011', '559', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778414', '75', '247', '2011', '568', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778434', '91', '247', '2012', '584', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778452', '52', '247', '2012', '581', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778469', '86', '247', '2012', '587', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778487', '66', '247', '2012', '611', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778508', '10', '247', '2012', '581', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778525', '75', '247', '2012', '595', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778544', '71', '247', '2013', '563', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778555', '60', '247', '2013', '573', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778569', '66', '247', '2013', '609', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778587', '4200', '247', '2013', '560', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778607', '86', '247', '2013', '567', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778630', '5', '247', '2013', '559', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('778712', '13', '254', '2010', '546', '526', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('778714', '123', '249', '2010', '503', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778727', '21', '254', '2010', '551', '526', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('778730', '79', '249', '2010', '506', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778744', '69', '254', '2010', '529', '525', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('778747', '92', '249', '2010', '522', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778762', '12', '254', '2010', '532', '525', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('778767', '458', '249', '2010', '509', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778777', '12', '254', '2010', '516', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778779', '205', '249', '2010', '503', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778788', '37', '249', '2010', '506', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778793', '5', '254', '2010', '534', '527', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('778805', '275', '254', '2010', '537', '526', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('778814', '205', '249', '2011', '528', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778820', '74', '254', '2010', '533', '527', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('778826', '92', '249', '2011', '535', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778832', '10', '254', '2010', '548', '527', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('778845', '123', '249', '2011', '521', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778853', '2', '254', '2010', '560', '528', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('778860', '99', '244', '2010', '519', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778864', '37', '249', '2011', '522', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778870', '67', '254', '2010', '548', '538', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('778875', '85', '244', '2010', '518', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778879', '458', '249', '2011', '537', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778887', '30', '254', '2010', '514', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778896', '741', '244', '2010', '519', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778898', '79', '249', '2011', '523', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778901', '10', '254', '2010', '519', '495', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778913', '79', '249', '2012', '539', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778916', '120', '244', '2010', '515', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778918', '63', '254', '2010', '533', '526', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('778931', '357', '249', '2012', '548', '543', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778935', '1356', '244', '2010', '525', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778936', '52', '254', '2010', '531', '526', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('778949', '37', '244', '2010', '518', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778951', '458', '249', '2012', '541', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778953', '126', '254', '2010', '531', '525', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('778964', '79', '244', '2010', '523', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778968', '17', '254', '2010', '532', '524', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('778970', '37', '249', '2012', '536', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778981', '173', '244', '2010', '514', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778983', '9', '254', '2010', '523', '523', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('778985', '12', '257', '2010', '539', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('778990', '92', '249', '2012', '545', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778997', '107', '244', '2010', '535', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('778999', '43', '257', '2010', '517', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779002', '69', '249', '2012', '560', '548', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779006', '428', '254', '2010', '527', '525', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779014', '123', '249', '2012', '535', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779016', '78', '257', '2010', '518', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779021', '2', '244', '2010', '523', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779024', '24', '254', '2010', '527', '524', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779029', '184', '218', '2010', '499', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779030', '205', '249', '2012', '546', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779034', '146', '244', '2010', '520', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779039', '65', '257', '2010', '517', '514', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779044', '3', '218', '2010', '507', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779045', '55', '254', '2010', '525', '523', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779050', '105', '249', '2013', '508', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779052', '147', '244', '2010', '519', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779058', '78', '257', '2011', '527', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779061', '151', '218', '2010', '495', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779062', '10', '254', '2011', '565', '538', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779070', '129', '249', '2013', '507', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779071', '135', '244', '2010', '517', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779075', '12', '257', '2011', '527', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779083', '120', '218', '2010', '484', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779086', '428', '254', '2011', '524', '514', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779091', '83', '244', '2010', '522', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779092', '92', '249', '2013', '512', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779096', '21', '257', '2012', '579', '572', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779101', '85', '218', '2010', '489', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779104', '55', '254', '2011', '531', '519', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779106', '55', '249', '2013', '505', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779111', '37', '244', '2011', '538', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779114', '12', '257', '2012', '579', '571', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779116', '37', '218', '2010', '507', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779119', '10', '254', '2011', '531', '504', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779122', '69', '249', '2013', '510', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779129', '83', '244', '2011', '553', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779132', '78', '257', '2012', '570', '568', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779133', '23', '218', '2010', '491', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779135', '52', '254', '2011', '521', '516', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779143', '243', '249', '2013', '510', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779147', '1356', '244', '2011', '542', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779151', '237', '249', '2013', '511', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779152', '8', '257', '2013', '530', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779153', '8', '218', '2010', '494', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779157', '21', '254', '2011', '544', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779162', '69', '244', '2011', '530', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779168', '5', '254', '2011', '543', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779169', '271', '218', '2010', '509', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779170', '892', '249', '2013', '514', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779171', '12', '257', '2013', '533', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779178', '146', '244', '2011', '538', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779184', '13', '254', '2011', '558', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779186', '233', '218', '2010', '502', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779193', '135', '244', '2011', '543', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779198', '10', '218', '2010', '502', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779200', '12', '254', '2011', '558', '540', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779207', '94', '218', '2010', '510', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779211', '74', '254', '2011', '527', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779213', '173', '244', '2011', '537', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779219', '78', '218', '2010', '487', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779227', '12', '254', '2011', '526', '511', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779230', '99', '244', '2011', '533', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779239', '722', '218', '2010', '495', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779244', '13', '254', '2011', '503', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779245', '113', '244', '2011', '534', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779257', '143', '218', '2010', '490', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779262', '17', '254', '2011', '542', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779271', '107', '244', '2011', '543', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779273', '129', '218', '2010', '503', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779279', '9', '254', '2011', '515', '512', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779285', '36', '218', '2010', '497', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779288', '141', '244', '2011', '528', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779297', '380', '218', '2010', '511', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779299', '65', '254', '2011', '526', '516', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779306', '2', '244', '2011', '530', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779312', '445', '218', '2010', '508', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779320', '79', '244', '2011', '530', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779321', '69', '254', '2011', '528', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779326', '69', '218', '2010', '480', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779334', '741', '244', '2011', '536', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779336', '30', '254', '2011', '533', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779343', '83', '218', '2010', '493', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779355', '43', '254', '2011', '529', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779357', '120', '244', '2011', '527', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779361', '38', '218', '2010', '505', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779374', '58', '254', '2011', '528', '519', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779376', '85', '244', '2011', '543', '543', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779380', '372', '218', '2010', '492', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779395', '30', '218', '2010', '489', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779398', '203', '254', '2011', '524', '516', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779402', '99', '244', '2012', '546', '545', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779409', '205', '218', '2010', '483', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779410', '78', '254', '2011', '544', '544', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779420', '161', '218', '2010', '488', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779424', '76', '254', '2011', '538', '538', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779425', '91', '244', '2012', '546', '545', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779434', '101', '218', '2010', '500', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779435', '85', '244', '2012', '546', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779439', '1', '254', '2011', '543', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779450', '279', '218', '2010', '487', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779454', '741', '244', '2012', '551', '545', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779458', '23', '254', '2011', '537', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779466', '292', '218', '2010', '481', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779468', '109', '244', '2012', '547', '545', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779469', '410', '254', '2011', '531', '517', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779476', '79', '218', '2010', '483', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779480', '136', '254', '2011', '520', '514', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779488', '113', '244', '2012', '558', '552', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779496', '3', '254', '2011', '544', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779500', '5', '218', '2010', '485', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779505', '1356', '244', '2012', '566', '556', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779509', '135', '244', '2012', '547', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779517', '97', '218', '2010', '493', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779519', '48', '254', '2011', '542', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779526', '99', '218', '2010', '492', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779531', '37', '244', '2012', '547', '547', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779536', '126', '254', '2011', '541', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779543', '220', '218', '2010', '490', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779547', '83', '244', '2012', '547', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779548', '2', '254', '2011', '544', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779561', '13', '218', '2010', '481', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779572', '173', '244', '2012', '548', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779573', '8', '254', '2011', '539', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779581', '34', '218', '2010', '492', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779583', '275', '254', '2011', '541', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779585', '141', '244', '2012', '549', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779600', '41', '254', '2011', '517', '513', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779603', '207', '218', '2010', '496', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779607', '2', '244', '2012', '546', '545', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779616', '67', '254', '2011', '521', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779625', '262', '218', '2010', '540', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779627', '79', '244', '2012', '548', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779636', '123', '218', '2010', '494', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779640', '63', '254', '2011', '544', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779649', '153', '218', '2010', '484', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779650', '120', '244', '2012', '545', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779661', '712', '218', '2010', '490', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779663', '107', '244', '2012', '559', '551', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779677', '126', '254', '2012', '570', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779680', '317', '218', '2010', '493', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779701', '52', '254', '2012', '567', '558', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779702', '113', '244', '2013', '534', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779706', '123', '218', '2011', '510', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779716', '101', '218', '2011', '525', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779717', '40', '244', '2013', '531', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779727', '371', '254', '2012', '560', '555', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779732', '37', '218', '2011', '510', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779733', '141', '244', '2013', '524', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779743', '36', '218', '2011', '512', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779745', '43', '254', '2012', '567', '560', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779749', '385', '244', '2013', '527', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779751', '317', '218', '2011', '499', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779757', '203', '254', '2012', '566', '561', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779759', '83', '244', '2013', '513', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779767', '129', '218', '2011', '525', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779774', '9', '254', '2012', '559', '554', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779780', '34', '218', '2011', '510', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779786', '17', '254', '2012', '581', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779791', '206', '244', '2013', '516', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779792', '372', '218', '2011', '513', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779802', '279', '218', '2011', '506', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779808', '262', '244', '2013', '520', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779812', '24', '254', '2012', '570', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779820', '8', '218', '2011', '512', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779823', '151', '244', '2013', '515', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779830', '445', '218', '2011', '507', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779831', '136', '254', '2012', '567', '557', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779844', '120', '218', '2011', '517', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779853', '23', '254', '2012', '579', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779856', '78', '218', '2011', '514', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779868', '3', '254', '2012', '584', '575', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779871', '262', '218', '2011', '526', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779884', '153', '218', '2011', '507', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779892', '30', '254', '2012', '566', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779899', '292', '218', '2011', '497', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779900', '48', '254', '2012', '571', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779915', '38', '218', '2011', '513', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779921', '12', '254', '2012', '576', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779932', '207', '218', '2011', '505', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779937', '10', '254', '2012', '567', '545', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779949', '16', '218', '2011', '501', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779951', '10', '254', '2012', '597', '575', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779958', '55', '254', '2012', '566', '560', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('779960', '3', '218', '2011', '521', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779975', '63', '254', '2012', '580', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('779977', '220', '218', '2011', '511', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779985', '79', '218', '2011', '507', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('779987', '13', '254', '2012', '565', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780000', '13', '218', '2011', '498', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780013', '12', '254', '2012', '565', '545', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780026', '10', '218', '2011', '519', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780034', '271', '218', '2011', '510', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780036', '69', '254', '2012', '570', '561', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780051', '205', '218', '2011', '500', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780057', '67', '254', '2012', '566', '559', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780068', '23', '218', '2011', '522', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780077', '1', '254', '2012', '576', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780083', '85', '218', '2011', '507', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780091', '233', '218', '2011', '525', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780092', '41', '254', '2012', '560', '556', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780104', '92', '218', '2011', '490', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780114', '58', '254', '2012', '566', '559', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780130', '30', '218', '2011', '513', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780134', '8', '254', '2012', '574', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780144', '97', '218', '2011', '509', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780153', '428', '254', '2012', '567', '558', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780159', '722', '218', '2011', '527', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780163', '2', '254', '2012', '579', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780172', '161', '218', '2011', '521', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780177', '115', '218', '2011', '499', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780181', '78', '254', '2012', '573', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780186', '83', '218', '2011', '509', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780196', '74', '254', '2012', '565', '560', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780203', '99', '218', '2011', '521', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780208', '203', '259', '2010', '558', '557', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780211', '65', '254', '2012', '557', '554', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780213', '1229', '259', '2010', '531', '529', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('780224', '94', '218', '2011', '520', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780226', '5', '254', '2012', '581', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780228', '87', '257', '2010', '521', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780230', '435', '259', '2010', '544', '544', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('780240', '5', '218', '2011', '497', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780242', '21', '254', '2012', '583', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780245', '17', '259', '2010', '562', '562', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780246', '43', '257', '2010', '511', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780251', '380', '218', '2011', '524', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780253', '275', '254', '2012', '592', '576', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780257', '52', '259', '2010', '560', '560', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780262', '78', '257', '2010', '514', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780266', '13', '254', '2012', '604', '575', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780268', '712', '218', '2011', '517', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780270', '20', '259', '2010', '560', '560', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780271', '148', '257', '2010', '510', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780276', '1414', '257', '2010', '511', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780277', '410', '254', '2012', '568', '557', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780278', '184', '218', '2011', '511', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780280', '5', '259', '2010', '563', '560', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780287', '143', '218', '2011', '513', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780288', '25', '257', '2010', '508', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780290', '8', '259', '2010', '561', '560', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780295', '151', '218', '2011', '511', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780299', '131', '257', '2010', '515', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780301', '58', '254', '2013', '531', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780302', '436', '259', '2010', '560', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780311', '255', '254', '2013', '546', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780312', '454', '257', '2010', '528', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780314', '43', '259', '2010', '558', '558', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780324', '79', '257', '2010', '527', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780325', '8', '254', '2013', '553', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780329', '2', '259', '2010', '563', '563', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780332', '226', '257', '2010', '519', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780334', '21', '259', '2010', '564', '564', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780335', '182', '254', '2013', '539', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780336', '23', '218', '2012', '535', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780346', '5', '254', '2013', '548', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780347', '548', '259', '2010', '571', '548', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('780348', '115', '218', '2012', '520', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780354', '1413', '257', '2010', '513', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780360', '21', '254', '2013', '545', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780362', '79', '218', '2012', '526', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780364', '65', '259', '2010', '555', '555', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780370', '17', '254', '2013', '549', '535', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780373', '3', '218', '2012', '538', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780376', '14', '259', '2010', '557', '556', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780381', '1', '254', '2013', '540', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780383', '38', '218', '2012', '531', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780385', '10', '259', '2010', '559', '557', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780393', '129', '218', '2012', '543', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780394', '498', '254', '2013', '549', '534', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780395', '184', '257', '2011', '531', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780398', '58', '259', '2010', '557', '557', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780402', '153', '218', '2012', '524', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780409', '12', '254', '2013', '535', '533', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780410', '136', '259', '2010', '558', '557', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780411', '147', '257', '2011', '545', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780416', '13', '259', '2010', '561', '558', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780417', '78', '218', '2012', '516', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780421', '380', '218', '2012', '539', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780424', '1413', '257', '2011', '537', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780427', '1451', '254', '2013', '544', '533', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780429', '445', '218', '2012', '523', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780433', '148', '257', '2011', '525', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780436', '79', '257', '2011', '527', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780440', '13', '254', '2013', '555', '538', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780441', '205', '218', '2012', '536', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780445', '1414', '257', '2011', '525', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780447', '101', '257', '2011', '526', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780449', '30', '218', '2012', '562', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780454', '78', '257', '2011', '533', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780455', '36', '218', '2012', '526', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780460', '454', '257', '2011', '528', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780462', '2', '259', '2011', '573', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780467', '262', '218', '2012', '553', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780468', '43', '257', '2011', '525', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780470', '10', '254', '2013', '561', '540', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780471', '207', '218', '2012', '513', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780473', '3', '259', '2011', '569', '569', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780477', '238', '254', '2013', '531', '495', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780480', '131', '257', '2011', '531', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780481', '92', '218', '2012', '527', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780483', '120', '257', '2011', '524', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780486', '159', '254', '2013', '531', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780492', '712', '218', '2012', '516', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780494', '136', '259', '2011', '571', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780498', '435', '254', '2013', '531', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780501', '8', '259', '2011', '574', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780502', '483', '254', '2013', '531', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780503', '722', '218', '2012', '533', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780508', '59', '254', '2013', '530', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780511', '233', '218', '2012', '534', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780514', '10', '259', '2011', '572', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780517', '69', '254', '2013', '531', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780518', '58', '259', '2011', '572', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780522', '151', '218', '2012', '526', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780524', '4429', '254', '2013', '530', '519', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780526', '83', '218', '2012', '521', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780528', '203', '259', '2011', '571', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780531', '277', '254', '2013', '526', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780532', '123', '218', '2012', '519', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780533', '13', '259', '2011', '572', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780537', '65', '254', '2013', '525', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780538', '94', '218', '2012', '539', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780539', '20', '259', '2011', '573', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780543', '9', '254', '2013', '524', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780544', '143', '218', '2012', '539', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780545', '43', '259', '2011', '572', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780548', '538', '254', '2013', '531', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780549', '37', '218', '2012', '528', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780550', '436', '259', '2011', '571', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780553', '10', '254', '2013', '532', '504', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780554', '85', '218', '2012', '535', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780555', '14', '259', '2011', '573', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780557', '12', '254', '2013', '527', '503', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('780558', '120', '218', '2012', '517', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780560', '17', '259', '2011', '574', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780561', '184', '218', '2012', '520', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780563', '21', '259', '2011', '574', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780564', '292', '218', '2012', '511', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780566', '5', '259', '2011', '577', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780568', '5', '218', '2012', '514', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780569', '65', '259', '2011', '569', '569', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780570', '271', '218', '2012', '529', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780571', '52', '259', '2011', '573', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780572', '16', '218', '2012', '520', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780573', '317', '218', '2012', '524', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780574', '8', '218', '2012', '524', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780575', '99', '218', '2012', '531', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780576', '13', '218', '2012', '532', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780577', '372', '218', '2012', '527', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780578', '101', '218', '2012', '520', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780579', '279', '218', '2012', '520', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780582', '34', '218', '2012', '515', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780585', '69', '218', '2012', '524', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780588', '220', '218', '2012', '529', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780591', '8', '257', '2012', '558', '551', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780592', '10', '218', '2012', '526', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780595', '161', '218', '2012', '528', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780596', '4485', '257', '2012', '543', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780600', '97', '218', '2012', '517', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780601', '79', '257', '2012', '540', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780605', '184', '257', '2012', '543', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780610', '95', '257', '2012', '547', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780614', '131', '257', '2012', '546', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780617', '454', '257', '2012', '547', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780619', '388', '257', '2012', '541', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780620', '237', '257', '2012', '541', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780621', '226', '257', '2012', '552', '547', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780623', '29', '257', '2012', '561', '545', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780625', '85', '257', '2012', '543', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780682', '10', '259', '2012', '609', '607', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780686', '436', '259', '2012', '610', '607', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780689', '52', '259', '2012', '608', '608', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780692', '17', '259', '2012', '606', '606', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780696', '58', '259', '2012', '608', '606', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780698', '2', '259', '2012', '609', '609', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780700', '3', '259', '2012', '614', '614', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780702', '5', '259', '2012', '614', '608', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780704', '43', '259', '2012', '604', '604', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780705', '13', '259', '2012', '609', '608', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780706', '65', '259', '2012', '605', '605', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780707', '21', '259', '2012', '609', '609', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780708', '20', '259', '2012', '609', '609', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780711', '203', '259', '2012', '605', '605', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780714', '14', '259', '2012', '607', '606', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780717', '136', '259', '2012', '612', '610', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780720', '8', '259', '2012', '612', '611', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780737', '279', '257', '2013', '534', '530', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('780741', '4486', '257', '2013', '580', '529', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('780743', '4487', '257', '2013', '519', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('780745', '4216', '257', '2013', '541', '526', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('780747', '237', '257', '2013', '514', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780748', '4226', '257', '2013', '542', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('780749', '4219', '257', '2013', '517', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780750', '454', '257', '2013', '527', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('780751', '8', '257', '2013', '518', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780752', '310', '257', '2013', '514', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780753', '483', '218', '2013', '501', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780755', '55', '218', '2013', '507', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780757', '328', '218', '2013', '495', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780759', '112', '218', '2013', '531', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('780761', '262', '218', '2013', '522', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('780763', '4409', '218', '2013', '493', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780765', '296', '218', '2013', '515', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780767', '105', '218', '2013', '510', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780770', '85', '218', '2013', '497', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780772', '147', '218', '2013', '503', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780775', '426', '218', '2013', '493', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780777', '381', '218', '2013', '531', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('780780', '173', '218', '2013', '501', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780782', '454', '218', '2013', '496', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780784', '210', '218', '2013', '494', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780786', '292', '218', '2013', '486', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780788', '206', '218', '2013', '499', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780789', '486', '218', '2013', '492', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780791', '140', '218', '2013', '490', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780793', '97', '218', '2013', '500', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780795', '92', '218', '2013', '498', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780797', '4429', '218', '2013', '487', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780799', '334', '218', '2013', '480', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780801', '161', '218', '2013', '511', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780803', '237', '218', '2013', '504', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780804', '34', '218', '2013', '502', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780807', '238', '218', '2013', '493', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780810', '151', '218', '2013', '497', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780813', '233', '218', '2013', '517', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780816', '129', '218', '2013', '505', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780818', '722', '218', '2013', '511', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780821', '13', '218', '2013', '494', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780825', '8', '218', '2013', '513', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780828', '1356', '218', '2013', '511', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780831', '5', '218', '2013', '500', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780835', '317', '218', '2013', '497', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780837', '174', '218', '2013', '505', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780839', '445', '218', '2013', '512', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780843', '84', '218', '2013', '511', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780847', '58', '259', '2013', '571', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780851', '10', '218', '2013', '495', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('780854', '578', '259', '2013', '572', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780860', '21', '259', '2013', '577', '577', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780865', '14', '259', '2013', '574', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780869', '17', '259', '2013', '570', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780877', '4236', '259', '2013', '582', '582', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780885', '8', '259', '2013', '574', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780894', '5', '259', '2013', '583', '575', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780899', '10', '259', '2013', '574', '573', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780903', '13', '259', '2013', '571', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('780909', '65', '259', '2013', '572', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('781214', '175', '254', '2010', '518', '517', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781226', '101', '254', '2010', '519', '516', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781231', '55', '254', '2010', '540', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781239', '79', '254', '2010', '519', '517', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781247', '205', '254', '2010', '540', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781260', '89', '254', '2010', '538', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781272', '8', '254', '2010', '572', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781281', '126', '254', '2010', '516', '515', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781293', '146', '254', '2010', '536', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781308', '10', '254', '2010', '547', '528', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781318', '40', '254', '2010', '546', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781326', '37', '254', '2010', '546', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781334', '97', '254', '2010', '551', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781341', '12', '254', '2010', '529', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781353', '2', '254', '2010', '532', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781365', '38', '254', '2010', '541', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781376', '143', '254', '2010', '541', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781385', '65', '254', '2010', '519', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781396', '21', '254', '2010', '561', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781405', '24', '254', '2010', '525', '518', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781412', '12', '254', '2010', '507', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781419', '69', '254', '2010', '539', '539', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781427', '34', '254', '2010', '462', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781437', '30', '254', '2010', '513', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781448', '17', '254', '2010', '532', '518', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781462', '97', '254', '2010', '487', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781470', '34', '254', '2010', '558', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781483', '67', '254', '2010', '518', '518', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781493', '161', '254', '2010', '536', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781503', '10', '254', '2010', '510', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781555', '12', '254', '2011', '536', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781568', '17', '254', '2011', '538', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781582', '21', '254', '2011', '541', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781593', '97', '254', '2011', '582', '539', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781603', '161', '254', '2011', '534', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781613', '67', '254', '2011', '522', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781627', '89', '254', '2011', '523', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781640', '205', '254', '2011', '529', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781654', '146', '254', '2011', '526', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781673', '220', '254', '2011', '510', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781685', '65', '254', '2011', '508', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781695', '69', '254', '2011', '517', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781709', '12', '254', '2011', '517', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781727', '37', '254', '2011', '541', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781742', '10', '254', '2011', '529', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781754', '55', '254', '2011', '526', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781772', '30', '254', '2011', '540', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781785', '3', '278', '2012', '547', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('781787', '175', '254', '2011', '535', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781797', '24', '254', '2011', '540', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781809', '143', '254', '2011', '549', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781823', '38', '254', '2011', '550', '539', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781844', '40', '254', '2011', '544', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781849', '10', '254', '2011', '553', '537', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781863', '2', '254', '2011', '556', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781876', '275', '254', '2011', '545', '545', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781881', '8', '254', '2011', '545', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781893', '435', '259', '2010', '540', '540', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('781894', '34', '254', '2011', '551', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781898', '20', '259', '2010', '561', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781900', '101', '254', '2011', '522', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781908', '21', '259', '2010', '567', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781910', '150', '254', '2011', '561', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781916', '10', '259', '2010', '563', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781922', '105', '254', '2011', '532', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781927', '203', '259', '2010', '559', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781934', '25', '254', '2011', '480', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781939', '14', '259', '2010', '561', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781945', '17', '259', '2010', '558', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781950', '16', '254', '2011', '522', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('781957', '65', '259', '2010', '558', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781960', '48', '254', '2011', '556', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781967', '52', '259', '2010', '561', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781971', '3', '254', '2011', '547', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781978', '436', '259', '2010', '568', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781984', '25', '254', '2011', '568', '536', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781991', '8', '259', '2010', '577', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('781998', '23', '254', '2011', '541', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782002', '2', '259', '2010', '571', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782010', '5', '259', '2010', '592', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782012', '76', '254', '2011', '535', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782016', '43', '259', '2010', '589', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782023', '78', '254', '2011', '537', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782024', '3', '259', '2010', '574', '574', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782025', '317', '254', '2011', '538', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782034', '410', '254', '2011', '530', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782038', '136', '259', '2010', '577', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782041', '38', '259', '2010', '575', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782044', '136', '254', '2011', '517', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782045', '30', '278', '2011', '538', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782049', '1229', '259', '2010', '557', '547', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('782050', '10', '278', '2011', '488', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782055', '184', '254', '2011', '528', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782059', '548', '259', '2010', '583', '551', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('782063', '126', '254', '2011', '536', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782072', '203', '254', '2011', '523', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782114', '17', '259', '2011', '595', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782118', '43', '259', '2011', '585', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782123', '8', '259', '2011', '588', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782128', '20', '259', '2011', '573', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782134', '136', '259', '2011', '582', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782139', '2', '259', '2011', '584', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782143', '38', '259', '2011', '584', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782149', '436', '259', '2011', '587', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782153', '5', '259', '2011', '610', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782158', '203', '259', '2011', '581', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782159', '317', '254', '2012', '553', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782164', '52', '259', '2011', '575', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782165', '37', '254', '2012', '578', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782174', '3', '259', '2011', '579', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782176', '220', '254', '2012', '529', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782184', '65', '259', '2011', '581', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782188', '203', '254', '2012', '533', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782189', '14', '259', '2011', '581', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782199', '21', '259', '2011', '594', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782203', '9', '254', '2012', '538', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782210', '24', '254', '2012', '556', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782222', '38', '254', '2012', '536', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782229', '126', '254', '2012', '559', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782245', '52', '259', '2012', '595', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782246', '23', '254', '2012', '556', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782253', '21', '259', '2012', '616', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782256', '3', '254', '2012', '561', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782259', '436', '259', '2012', '600', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782266', '76', '254', '2012', '551', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782273', '17', '259', '2012', '603', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782279', '136', '254', '2012', '533', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782280', '38', '259', '2012', '594', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782287', '89', '254', '2012', '539', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782289', '5', '259', '2012', '618', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782291', '16', '254', '2012', '541', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782295', '2', '259', '2012', '595', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782302', '3', '259', '2012', '602', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782303', '17', '254', '2012', '555', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782310', '43', '259', '2012', '602', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782315', '40', '254', '2012', '551', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782323', '10', '259', '2012', '595', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782325', '55', '254', '2012', '542', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782328', '14', '259', '2012', '596', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782332', '146', '254', '2012', '545', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782335', '136', '259', '2012', '602', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782339', '10', '254', '2012', '545', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782340', '20', '259', '2012', '592', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782344', '184', '254', '2012', '545', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782345', '65', '259', '2012', '593', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782350', '10', '254', '2012', '589', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782351', '8', '259', '2012', '601', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782358', '203', '259', '2012', '597', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782359', '12', '254', '2012', '559', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782365', '41', '254', '2012', '516', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782369', '69', '254', '2012', '543', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782375', '79', '254', '2012', '565', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782381', '25', '254', '2012', '566', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782389', '67', '254', '2012', '534', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782390', '21', '259', '2013', '575', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782396', '10', '259', '2013', '580', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782397', '205', '254', '2012', '545', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782403', '17', '259', '2013', '592', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782405', '48', '254', '2012', '551', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782412', '58', '254', '2012', '539', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782413', '65', '259', '2013', '562', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782421', '143', '254', '2012', '569', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782422', '5', '259', '2013', '590', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782429', '578', '259', '2013', '567', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782430', '105', '254', '2012', '548', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782436', '14', '259', '2013', '572', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782437', '65', '254', '2012', '525', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782444', '13', '259', '2013', '570', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782451', '78', '254', '2012', '551', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782453', '8', '259', '2013', '569', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782456', '30', '254', '2012', '534', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782457', '233', '259', '2013', '568', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782462', '21', '254', '2012', '566', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782465', '8', '254', '2012', '565', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782467', '150', '254', '2012', '565', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782478', '34', '254', '2012', '586', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782485', '275', '254', '2012', '548', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782491', '2', '254', '2012', '554', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782495', '410', '254', '2012', '541', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782497', '97', '254', '2012', '592', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782502', '101', '254', '2012', '546', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782506', '38', '254', '2012', '584', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782511', '12', '254', '2012', '536', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782515', '161', '254', '2012', '561', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782530', '175', '254', '2012', '543', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782594', '10', '282', '2010', '524', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('782596', '105', '254', '2013', '526', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782599', '129', '254', '2013', '526', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782601', '2', '282', '2010', '526', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('782606', '17', '254', '2013', '528', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782610', '8', '282', '2010', '528', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('782611', '182', '254', '2013', '531', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782615', '317', '254', '2013', '521', '518', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782621', '12', '254', '2013', '523', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782624', '159', '254', '2013', '513', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782630', '255', '254', '2013', '528', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782634', '140', '254', '2013', '514', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782638', '9', '254', '2013', '503', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782642', '59', '254', '2013', '506', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782645', '101', '254', '2013', '525', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782648', '2', '282', '2011', '528', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('782650', '12', '254', '2013', '516', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782653', '58', '254', '2013', '516', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782657', '8', '282', '2011', '534', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('782658', '97', '254', '2013', '553', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782663', '10', '282', '2011', '530', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('782665', '105', '254', '2013', '516', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782673', '4256', '254', '2013', '513', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782683', '175', '254', '2013', '509', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782690', '10', '254', '2013', '550', '527', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782694', '238', '254', '2013', '509', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782705', '8', '282', '2012', '578', '577', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('782706', '10', '254', '2013', '514', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782713', '65', '254', '2013', '496', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782714', '2', '282', '2012', '569', '569', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('782721', '486', '254', '2013', '504', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782725', '237', '254', '2013', '503', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782729', '10', '282', '2012', '568', '568', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('782732', '334', '254', '2013', '516', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782743', '454', '254', '2013', '512', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782750', '483', '254', '2013', '513', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782755', '21', '254', '2013', '534', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782757', '10', '282', '2013', '520', '503', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('782763', '538', '254', '2013', '516', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782772', '498', '254', '2013', '526', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782775', '40', '254', '2013', '524', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782776', '29', '254', '2013', '536', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782777', '69', '254', '2013', '516', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('782778', '34', '254', '2013', '540', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782779', '161', '254', '2013', '528', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782780', '233', '254', '2013', '532', '521', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782781', '8', '254', '2013', '533', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('782782', '150', '254', '2013', '544', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('783129', '86', '289', '2010', '518', '517', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783134', '428', '289', '2010', '520', '519', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783139', '78', '289', '2010', '517', '516', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783153', '24', '289', '2010', '516', '516', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783186', '13', '289', '2011', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783192', '78', '289', '2011', '532', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783197', '86', '289', '2011', '529', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783210', '5', '289', '2011', '529', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783234', '74', '289', '2012', '566', '566', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783238', '78', '289', '2012', '566', '565', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783245', '86', '289', '2012', '566', '565', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783251', '538', '289', '2012', '567', '567', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783274', '1451', '289', '2013', '531', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783275', '147', '282', '2010', '543', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783277', '149', '282', '2010', '521', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783278', '5', '289', '2013', '534', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783279', '2', '294', '2012', '560', '560', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783281', '37', '282', '2010', '527', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783283', '371', '289', '2013', '530', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783284', '38', '282', '2010', '529', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783285', '78', '294', '2012', '562', '562', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783291', '86', '289', '2013', '528', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('783292', '123', '282', '2010', '527', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783299', '151', '282', '2010', '525', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783304', '146', '282', '2010', '522', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783312', '190', '282', '2010', '524', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783322', '120', '282', '2010', '522', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783328', '30', '282', '2010', '532', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783330', '10', '282', '2010', '521', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783335', '101', '282', '2010', '521', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783342', '2', '282', '2010', '522', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783346', '113', '282', '2010', '553', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783350', '390', '282', '2010', '531', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783354', '127', '282', '2010', '541', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783358', '99', '282', '2010', '534', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783362', '36', '282', '2010', '535', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783401', '101', '282', '2011', '535', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783403', '36', '282', '2011', '555', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783413', '30', '282', '2011', '538', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783416', '147', '282', '2011', '549', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783424', '2', '282', '2011', '536', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783428', '127', '282', '2011', '568', '551', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783431', '37', '282', '2011', '542', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783436', '149', '282', '2011', '533', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783438', '120', '282', '2011', '534', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783440', '55', '294', '2011', '562', '562', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783444', '146', '282', '2011', '535', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783449', '99', '282', '2011', '540', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783453', '38', '282', '2011', '541', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783457', '113', '282', '2011', '564', '554', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783463', '17', '282', '2011', '538', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783468', '196', '282', '2011', '542', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783563', '116', '289', '2010', '519', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783567', '86', '289', '2010', '507', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783572', '38', '289', '2010', '512', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783574', '410', '289', '2010', '510', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783578', '89', '289', '2010', '510', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783582', '30', '289', '2010', '511', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783589', '150', '289', '2011', '525', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783592', '119', '289', '2011', '526', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783596', '5', '289', '2011', '523', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783598', '86', '289', '2011', '523', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783600', '127', '294', '2011', '531', '531', '5', '2', '13');
INSERT INTO `major_recruit` VALUES ('783603', '116', '289', '2011', '533', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783605', '78', '289', '2011', '530', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783612', '27', '289', '2012', '548', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783615', '157', '289', '2012', '545', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783618', '86', '289', '2012', '542', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783622', '38', '289', '2012', '549', '543', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783627', '78', '289', '2012', '543', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783634', '238', '289', '2013', '512', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783638', '5', '289', '2013', '515', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783642', '86', '289', '2013', '511', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783645', '233', '289', '2013', '519', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783648', '91', '289', '2013', '510', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783653', '105', '289', '2013', '519', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783800', '123', '282', '2012', '559', '557', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783801', '196', '282', '2012', '564', '562', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783802', '38', '282', '2012', '556', '554', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783803', '30', '282', '2012', '558', '555', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783804', '36', '282', '2012', '565', '561', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783805', '113', '282', '2012', '586', '577', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783806', '120', '282', '2012', '560', '558', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783807', '146', '282', '2012', '564', '560', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783808', '147', '282', '2012', '567', '565', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783809', '17', '282', '2012', '572', '567', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783810', '127', '282', '2012', '569', '562', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783811', '101', '282', '2012', '574', '568', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783812', '2', '282', '2012', '563', '560', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783813', '3052', '282', '2013', '571', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783814', '233', '282', '2013', '530', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783815', '151', '282', '2013', '534', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783816', '113', '282', '2013', '573', '552', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783817', '149', '282', '2013', '518', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783822', '85', '282', '2013', '526', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783827', '161', '282', '2013', '520', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783830', '174', '282', '2013', '534', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783832', '101', '282', '2013', '520', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783834', '317', '282', '2013', '521', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783835', '238', '282', '2013', '526', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783836', '55', '282', '2013', '522', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783837', '17', '282', '2013', '523', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('783859', '10', '297', '2010', '555', '553', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('783862', '21', '297', '2010', '557', '556', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('783864', '139', '297', '2010', '555', '554', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('783867', '12', '297', '2010', '554', '554', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('783873', '10', '297', '2011', '566', '561', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('783877', '139', '297', '2011', '568', '567', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('783881', '12', '297', '2011', '563', '560', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('783892', '139', '297', '2012', '602', '601', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('783896', '8', '297', '2012', '607', '605', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('783900', '10', '297', '2012', '599', '598', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('783903', '8', '297', '2013', '571', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('783906', '1451', '297', '2013', '567', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('784230', '339', '297', '2010', '565', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784245', '8', '297', '2010', '578', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784268', '89', '297', '2010', '560', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784276', '16', '297', '2010', '558', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784295', '120', '297', '2010', '558', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784304', '266', '297', '2010', '560', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784313', '357', '297', '2010', '561', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784329', '480', '297', '2010', '561', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784339', '17', '297', '2010', '567', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784347', '364', '297', '2010', '570', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784359', '21', '297', '2010', '572', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784368', '3', '297', '2010', '572', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784379', '79', '313', '2010', '516', '514', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784386', '3', '297', '2011', '596', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784396', '61', '313', '2010', '514', '513', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784408', '58', '297', '2011', '577', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784412', '8', '313', '2010', '518', '513', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784415', '4494', '316', '2010', '518', '517', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784424', '357', '297', '2011', '583', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784435', '65', '313', '2010', '512', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784438', '23', '316', '2010', '520', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784441', '17', '297', '2011', '589', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784453', '203', '313', '2010', '509', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784457', '21', '297', '2011', '592', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784461', '4494', '316', '2011', '534', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784471', '221', '297', '2011', '583', '582', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784474', '64', '316', '2011', '525', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784480', '203', '313', '2011', '524', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784483', '357', '316', '2011', '527', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784489', '8', '315', '2011', '457', '426', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784490', '5', '297', '2011', '579', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784495', '211', '315', '2011', '439', '422', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784497', '65', '313', '2011', '524', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784508', '126', '315', '2011', '438', '424', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784510', '2', '297', '2011', '581', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784512', '61', '313', '2011', '528', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784513', '4494', '316', '2012', '570', '565', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784518', '10', '315', '2011', '477', '428', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784520', '16', '297', '2011', '579', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784521', '8', '313', '2011', '525', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784525', '357', '316', '2012', '565', '565', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784526', '22', '297', '2011', '580', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784532', '143', '315', '2011', '436', '428', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784533', '79', '313', '2011', '526', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784541', '364', '297', '2011', '585', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784547', '38', '315', '2011', '457', '429', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784553', '213', '316', '2013', '526', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784555', '8', '297', '2011', '597', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784557', '12', '315', '2011', '417', '415', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784562', '61', '313', '2012', '568', '564', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784569', '339', '297', '2011', '585', '584', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784570', '78', '315', '2011', '441', '428', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784574', '136', '313', '2012', '558', '558', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784582', '129', '315', '2011', '457', '428', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784583', '87', '313', '2012', '562', '559', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784589', '10', '297', '2011', '579', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784608', '329', '315', '2011', '433', '424', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784612', '78', '313', '2012', '565', '561', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784614', '357', '297', '2012', '597', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784625', '22', '297', '2012', '602', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784635', '38', '315', '2012', '477', '474', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784638', '21', '297', '2012', '610', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784641', '61', '313', '2013', '526', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784645', '1015', '315', '2012', '473', '473', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784651', '221', '297', '2012', '602', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784657', '126', '315', '2012', '482', '468', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784665', '364', '297', '2012', '608', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784668', '129', '315', '2012', '494', '467', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784675', '5', '297', '2012', '596', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784682', '143', '315', '2012', '474', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784685', '58', '297', '2012', '594', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784691', '17', '297', '2012', '603', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784703', '3', '297', '2012', '605', '603', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784704', '8', '315', '2012', '498', '467', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784710', '12', '315', '2012', '530', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784712', '10', '297', '2012', '601', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784716', '211', '315', '2012', '485', '465', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784721', '12', '315', '2012', '486', '478', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784724', '339', '297', '2012', '596', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784728', '8', '297', '2012', '608', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784729', '10', '315', '2012', '503', '469', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('784731', '16', '297', '2012', '602', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('784734', '8', '315', '2012', '545', '545', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('784736', '120', '297', '2012', '598', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('785176', '343', '315', '2013', '473', '452', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('785177', '1451', '297', '2013', '567', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('785193', '3774', '297', '2013', '572', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('785196', '85', '315', '2013', '467', '452', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('785207', '86', '315', '2013', '463', '454', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('785209', '10', '297', '2013', '569', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('785219', '21', '297', '2013', '582', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('785221', '10', '315', '2013', '465', '451', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('785233', '339', '297', '2013', '571', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('785235', '1', '324', '2010', '539', '537', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('785239', '129', '315', '2013', '464', '464', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('785244', '203', '324', '2010', '544', '541', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('785251', '260', '315', '2013', '473', '473', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('785252', '22', '297', '2013', '572', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('785259', '8', '315', '2013', '459', '451', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('785262', '63', '324', '2010', '562', '550', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('785266', '221', '297', '2013', '574', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('785280', '758', '315', '2013', '449', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('785281', '17', '297', '2013', '576', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('785285', '538', '324', '2010', '537', '537', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('785288', '65', '324', '2010', '540', '539', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('785300', '233', '315', '2013', '444', '444', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('785306', '5', '324', '2010', '542', '541', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('785315', '12', '315', '2013', '451', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('785318', '8', '324', '2010', '551', '551', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('785323', '10', '315', '2013', '489', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785335', '2', '324', '2010', '566', '554', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('785336', '58', '315', '2013', '456', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('785343', '8', '315', '2013', '504', '504', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785350', '13', '324', '2010', '544', '540', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('785358', '85', '316', '2010', '511', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785375', '148', '316', '2010', '510', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785387', '30', '316', '2010', '511', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785395', '38', '316', '2010', '513', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785410', '36', '316', '2010', '516', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785422', '79', '316', '2010', '517', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785446', '85', '316', '2011', '525', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785462', '79', '316', '2011', '530', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785473', '38', '316', '2011', '529', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785485', '23', '316', '2011', '527', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785504', '36', '316', '2011', '534', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785515', '30', '316', '2011', '531', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785534', '148', '316', '2011', '528', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785560', '13', '324', '2010', '551', '551', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785562', '143', '316', '2012', '545', '543', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785578', '97', '324', '2010', '555', '551', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785584', '30', '316', '2012', '545', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785591', '184', '324', '2010', '554', '554', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785592', '85', '316', '2012', '547', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785608', '23', '316', '2012', '557', '549', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785612', '175', '324', '2010', '556', '556', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785619', '79', '316', '2012', '545', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785620', '2', '324', '2010', '566', '556', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785633', '186', '324', '2010', '560', '557', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785634', '36', '316', '2012', '546', '545', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785644', '150', '324', '2010', '559', '559', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785651', '151', '316', '2012', '541', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785662', '147', '324', '2010', '569', '563', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785664', '148', '316', '2012', '542', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785668', '161', '324', '2010', '577', '569', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785678', '38', '324', '2010', '557', '550', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785689', '158', '324', '2010', '554', '550', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785691', '129', '316', '2013', '514', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785699', '65', '324', '2010', '540', '540', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785703', '147', '316', '2013', '515', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785715', '277', '324', '2010', '544', '542', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785717', '85', '316', '2013', '512', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785725', '34', '324', '2010', '554', '548', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785731', '174', '316', '2013', '515', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785735', '112', '324', '2010', '549', '545', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785746', '105', '316', '2013', '517', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785749', '25', '324', '2010', '566', '546', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785755', '4224', '316', '2013', '526', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785762', '43', '324', '2010', '548', '548', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('785831', '279', '314', '2010', '483', '481', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785842', '83', '315', '2011', '439', '391', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785844', '13', '314', '2010', '494', '481', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785849', '109', '315', '2011', '438', '390', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785854', '10', '314', '2010', '504', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785856', '129', '315', '2011', '450', '382', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785861', '12', '314', '2010', '500', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785865', '10', '315', '2011', '433', '385', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785870', '55', '314', '2010', '494', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785871', '143', '315', '2011', '419', '378', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785881', '21', '314', '2010', '509', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785890', '78', '314', '2010', '505', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785892', '147', '315', '2011', '442', '392', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785897', '2', '314', '2010', '525', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785899', '78', '315', '2011', '439', '387', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785905', '5', '314', '2010', '507', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785909', '94', '315', '2011', '427', '380', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785916', '79', '314', '2010', '505', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785918', '12', '315', '2011', '417', '378', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785922', '127', '315', '2011', '405', '394', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785926', '52', '314', '2010', '505', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785933', '36', '315', '2011', '383', '381', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785935', '3', '314', '2010', '521', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785944', '37', '315', '2011', '428', '382', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785946', '63', '314', '2010', '505', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785954', '38', '315', '2011', '418', '374', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785956', '24', '314', '2010', '499', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785962', '8', '315', '2011', '431', '384', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785968', '8', '315', '2011', '497', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('785973', '86', '314', '2010', '489', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785978', '126', '315', '2011', '419', '374', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785983', '71', '314', '2010', '496', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('785988', '211', '315', '2011', '432', '382', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('785995', '120', '314', '2010', '503', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786002', '8', '314', '2010', '505', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786016', '69', '314', '2010', '502', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786028', '201', '314', '2010', '498', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786029', '12', '315', '2012', '427', '408', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('786036', '126', '314', '2010', '500', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786037', '38', '315', '2012', '486', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786046', '126', '315', '2012', '425', '399', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('786049', '23', '314', '2010', '504', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786059', '129', '315', '2012', '472', '404', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('786069', '129', '315', '2012', '494', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786079', '38', '315', '2012', '465', '402', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('786080', '79', '314', '2011', '504', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786089', '143', '315', '2012', '476', '417', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('786092', '8', '314', '2011', '510', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786098', '69', '314', '2011', '496', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786100', '211', '315', '2012', '495', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786108', '94', '315', '2012', '475', '407', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('786109', '24', '314', '2011', '492', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786113', '99', '313', '2010', '513', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786114', '109', '315', '2012', '402', '398', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('786119', '52', '314', '2011', '492', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786122', '161', '313', '2010', '509', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786126', '211', '315', '2012', '453', '417', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('786127', '63', '314', '2011', '509', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786131', '91', '313', '2010', '509', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786135', '94', '315', '2012', '510', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786138', '10', '314', '2011', '511', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786143', '95', '313', '2010', '511', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786147', '23', '314', '2011', '522', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786153', '37', '315', '2012', '475', '404', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('786157', '40', '313', '2010', '512', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786158', '8', '315', '2012', '454', '407', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('786159', '279', '314', '2011', '511', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786165', '10', '315', '2012', '464', '412', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('786167', '3', '313', '2010', '513', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786168', '55', '314', '2011', '510', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786173', '147', '315', '2012', '447', '406', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('786178', '10', '313', '2010', '510', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786180', '201', '314', '2011', '506', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786183', '127', '315', '2012', '439', '431', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('786185', '118', '313', '2010', '510', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786191', '2', '314', '2011', '497', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786194', '85', '313', '2010', '509', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786196', '83', '315', '2012', '438', '416', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('786197', '3', '314', '2011', '518', '495', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786201', '38', '313', '2010', '512', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786202', '36', '315', '2012', '445', '419', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('786206', '52', '329', '2010', '510', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786210', '126', '314', '2011', '495', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786214', '80', '313', '2010', '510', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786218', '58', '329', '2010', '515', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786220', '233', '315', '2013', '456', '456', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786223', '13', '314', '2011', '493', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786226', '109', '313', '2010', '506', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786231', '78', '329', '2010', '516', '509', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786235', '5', '314', '2011', '513', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786236', '10', '315', '2013', '461', '459', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786237', '83', '313', '2010', '510', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786243', '5', '329', '2010', '518', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786244', '85', '315', '2013', '463', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786245', '175', '314', '2011', '489', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786254', '78', '313', '2010', '507', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786256', '12', '314', '2011', '510', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786257', '136', '329', '2010', '509', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786258', '343', '315', '2013', '469', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786260', '1356', '315', '2013', '472', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786262', '24', '329', '2010', '509', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786269', '205', '313', '2010', '504', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786270', '86', '314', '2011', '500', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786275', '10', '329', '2010', '518', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786278', '222', '313', '2010', '504', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786281', '78', '314', '2011', '517', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786283', '2', '329', '2010', '518', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786290', '84', '313', '2010', '506', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786293', '23', '329', '2010', '520', '511', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786296', '120', '314', '2011', '492', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786303', '87', '313', '2010', '513', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786305', '21', '314', '2011', '514', '495', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786306', '26', '329', '2010', '509', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786313', '147', '313', '2010', '527', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786316', '13', '329', '2010', '510', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786320', '30', '313', '2010', '519', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786327', '181', '329', '2010', '520', '512', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786331', '37', '313', '2010', '518', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786334', '69', '314', '2012', '530', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786340', '129', '313', '2010', '512', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786344', '52', '314', '2012', '536', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786351', '36', '313', '2010', '513', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786356', '279', '314', '2012', '558', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786360', '12', '329', '2011', '523', '517', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786363', '113', '313', '2010', '514', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786364', '120', '314', '2012', '535', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786367', '21', '329', '2011', '527', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786369', '127', '313', '2010', '508', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786375', '30', '329', '2011', '526', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786377', '86', '314', '2012', '537', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786379', '175', '329', '2011', '516', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786386', '55', '314', '2012', '550', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786390', '79', '314', '2012', '536', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786392', '3', '329', '2011', '529', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786396', '84', '313', '2011', '524', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786397', '24', '314', '2012', '536', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786401', '207', '329', '2011', '526', '519', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786406', '97', '313', '2011', '525', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786409', '126', '314', '2012', '543', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786410', '58', '329', '2011', '527', '517', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786417', '23', '314', '2012', '546', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786418', '78', '329', '2011', '525', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786420', '87', '313', '2011', '517', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786423', '5', '329', '2011', '527', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786429', '3', '314', '2012', '561', '534', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786432', '205', '313', '2011', '519', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786434', '136', '329', '2011', '521', '516', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786439', '78', '314', '2012', '534', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786441', '368', '313', '2011', '526', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786445', '2', '329', '2011', '526', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786452', '146', '313', '2011', '520', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786455', '2', '314', '2012', '561', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786457', '8', '329', '2011', '530', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786465', '201', '314', '2012', '547', '534', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786466', '181', '329', '2011', '525', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786469', '222', '313', '2011', '519', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786473', '10', '314', '2012', '549', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786476', '23', '329', '2011', '527', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786480', '99', '313', '2011', '522', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786487', '10', '329', '2011', '526', '516', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786488', '37', '313', '2011', '526', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786490', '63', '314', '2012', '546', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786496', '524', '329', '2011', '521', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786500', '12', '314', '2012', '538', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786501', '80', '313', '2011', '522', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786507', '52', '329', '2011', '523', '517', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786509', '13', '314', '2012', '538', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786510', '40', '313', '2011', '528', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786519', '8', '314', '2012', '548', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786520', '91', '313', '2011', '519', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786524', '24', '329', '2011', '518', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786526', '5', '314', '2012', '542', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786528', '95', '313', '2011', '518', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786534', '26', '329', '2011', '518', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786538', '161', '313', '2011', '521', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786540', '21', '314', '2012', '554', '532', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786546', '13', '329', '2011', '524', '517', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786547', '175', '314', '2012', '529', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786550', '186', '313', '2011', '524', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786557', '3', '313', '2011', '530', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786565', '109', '313', '2011', '523', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786566', '23', '329', '2012', '568', '563', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786569', '13', '314', '2013', '504', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786571', '3', '329', '2012', '569', '562', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786574', '83', '313', '2011', '524', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786577', '1451', '314', '2013', '494', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786582', '78', '329', '2012', '562', '559', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786585', '610', '313', '2011', '521', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786588', '4255', '314', '2013', '497', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786592', '2', '329', '2012', '566', '562', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786595', '173', '313', '2011', '524', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786596', '156', '314', '2013', '491', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786597', '24', '329', '2012', '561', '558', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786602', '85', '313', '2011', '528', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786606', '429', '313', '2011', '525', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786607', '233', '314', '2013', '498', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786610', '181', '329', '2012', '579', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('786617', '334', '314', '2013', '494', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786623', '207', '329', '2012', '567', '560', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786624', '438', '314', '2013', '493', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786629', '136', '329', '2012', '561', '557', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786632', '86', '314', '2013', '493', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786639', '10', '314', '2013', '506', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786642', '118', '313', '2011', '522', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786647', '52', '329', '2012', '563', '558', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786648', '175', '314', '2013', '493', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786654', '12', '314', '2013', '494', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786655', '58', '329', '2012', '561', '557', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786656', '129', '313', '2011', '532', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786664', '483', '314', '2013', '496', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786666', '127', '313', '2011', '524', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786670', '30', '329', '2012', '567', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786676', '92', '314', '2013', '519', '495', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786677', '10', '313', '2011', '523', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786678', '12', '329', '2012', '565', '559', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786683', '36', '313', '2011', '538', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786684', '21', '314', '2013', '512', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786689', '5', '329', '2012', '566', '558', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786691', '30', '313', '2011', '523', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786692', '10', '329', '2012', '563', '557', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786694', '385', '314', '2013', '503', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786700', '69', '314', '2013', '500', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786701', '524', '329', '2012', '561', '556', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786706', '147', '313', '2011', '531', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786710', '931', '314', '2013', '499', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786711', '363', '313', '2011', '520', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786714', '26', '329', '2012', '559', '557', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786717', '209', '313', '2011', '524', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786718', '415', '314', '2013', '494', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786720', '13', '329', '2012', '566', '558', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786725', '113', '313', '2011', '527', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786729', '8', '329', '2012', '567', '561', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786730', '8', '314', '2013', '508', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786731', '38', '313', '2011', '523', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786733', '21', '329', '2012', '569', '561', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786737', '5', '314', '2013', '501', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786744', '255', '314', '2013', '499', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786748', '222', '313', '2012', '539', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786750', '5', '329', '2013', '526', '519', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786754', '186', '313', '2012', '540', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786757', '10', '329', '2013', '530', '519', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786762', '58', '329', '2013', '521', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786763', '209', '313', '2012', '540', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786770', '12', '329', '2013', '522', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786774', '127', '313', '2012', '541', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786779', '13', '329', '2013', '527', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786781', '113', '313', '2012', '552', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786785', '238', '329', '2013', '530', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786791', '84', '313', '2012', '541', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786792', '21', '329', '2013', '530', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786798', '147', '313', '2012', '549', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786801', '8', '329', '2013', '528', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('786805', '83', '313', '2012', '542', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786811', '30', '313', '2012', '538', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786820', '38', '313', '2012', '550', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786828', '146', '313', '2012', '542', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786835', '78', '313', '2012', '544', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786842', '97', '313', '2012', '535', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786845', '368', '313', '2012', '540', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786851', '118', '313', '2012', '548', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786854', '161', '313', '2012', '545', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786863', '61', '313', '2012', '552', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786873', '99', '313', '2012', '541', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786884', '136', '313', '2012', '537', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786895', '173', '313', '2012', '542', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786902', '109', '313', '2012', '541', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786919', '4230', '313', '2013', '513', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786926', '4224', '313', '2013', '513', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786933', '429', '313', '2013', '510', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786940', '61', '313', '2013', '509', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786951', '4443', '313', '2013', '510', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786960', '129', '313', '2013', '507', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786967', '85', '313', '2013', '511', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786974', '105', '313', '2013', '509', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786982', '4327', '313', '2013', '516', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786991', '163', '313', '2013', '506', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('786999', '610', '313', '2013', '507', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('787006', '4266', '313', '2013', '515', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('787012', '310', '313', '2013', '516', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('787746', '10', '348', '2013', '503', '497', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('787749', '13', '348', '2013', '502', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('787967', '34', '348', '2010', '473', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('787972', '38', '348', '2010', '470', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('787977', '37', '348', '2010', '475', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('787988', '97', '348', '2010', '474', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('787992', '99', '348', '2010', '475', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788000', '147', '348', '2010', '475', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788005', '38', '314', '2010', '501', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788009', '116', '348', '2011', '490', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788013', '37', '314', '2010', '493', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788014', '2', '348', '2011', '497', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788018', '310', '314', '2010', '488', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788021', '87', '348', '2011', '494', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788025', '21', '314', '2010', '498', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788027', '37', '348', '2011', '500', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788033', '8', '314', '2010', '483', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788034', '150', '348', '2011', '489', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788040', '129', '348', '2011', '497', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788044', '3', '314', '2010', '497', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788047', '97', '348', '2011', '491', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788050', '27', '314', '2010', '508', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788056', '99', '314', '2010', '483', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788061', '129', '348', '2012', '517', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788065', '87', '314', '2010', '481', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788067', '101', '348', '2012', '517', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788074', '2', '314', '2010', '503', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788076', '87', '348', '2012', '506', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788080', '120', '314', '2010', '496', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788084', '97', '348', '2012', '511', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788089', '107', '314', '2010', '503', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788092', '24', '348', '2012', '508', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788098', '279', '314', '2010', '488', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788100', '34', '348', '2012', '511', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788103', '37', '348', '2012', '529', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788110', '149', '314', '2010', '484', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788113', '116', '348', '2012', '513', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788117', '36', '314', '2010', '490', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788119', '36', '348', '2012', '513', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788139', '10', '314', '2010', '487', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788149', '101', '348', '2013', '476', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788150', '175', '314', '2010', '490', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788155', '105', '348', '2013', '475', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788158', '85', '314', '2010', '484', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788162', '163', '348', '2013', '484', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788167', '55', '314', '2010', '491', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788175', '37', '348', '2013', '471', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788177', '155', '314', '2010', '496', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788178', '1242', '348', '2013', '488', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788186', '86', '314', '2010', '473', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788187', '161', '348', '2013', '480', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788192', '233', '348', '2013', '482', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788193', '97', '314', '2010', '480', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788196', '206', '348', '2013', '479', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788199', '101', '314', '2010', '482', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788204', '85', '348', '2013', '491', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788211', '151', '314', '2010', '476', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788218', '129', '314', '2010', '496', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788221', '184', '314', '2010', '480', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788231', '25', '314', '2010', '479', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788249', '79', '314', '2010', '481', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788258', '71', '314', '2010', '475', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788266', '143', '314', '2010', '490', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788274', '109', '314', '2010', '492', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788279', '147', '314', '2010', '495', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788283', '12', '314', '2010', '476', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788293', '136', '329', '2010', '496', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788299', '5', '314', '2010', '480', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788302', '101', '329', '2010', '502', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788308', '78', '314', '2010', '483', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788312', '161', '329', '2010', '511', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788315', '69', '314', '2010', '473', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788317', '38', '329', '2010', '507', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788322', '201', '314', '2010', '484', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788325', '226', '329', '2010', '501', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788328', '222', '329', '2010', '509', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788331', '24', '314', '2010', '484', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788334', '79', '329', '2010', '495', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788335', '23', '314', '2010', '485', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788337', '17', '329', '2010', '501', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788338', '161', '314', '2010', '485', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788339', '52', '329', '2010', '493', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788344', '269', '329', '2010', '503', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788352', '388', '329', '2010', '502', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788359', '5', '314', '2011', '485', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788360', '395', '329', '2010', '496', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788365', '69', '314', '2011', '491', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788367', '2761', '329', '2010', '494', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788371', '97', '314', '2011', '484', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788372', '25', '329', '2010', '499', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788376', '21', '314', '2011', '507', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788379', '119', '329', '2010', '497', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788382', '211', '314', '2011', '496', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788386', '84', '329', '2010', '499', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788387', '202', '314', '2011', '484', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788391', '794', '329', '2010', '502', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788395', '23', '314', '2011', '492', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788400', '981', '329', '2010', '491', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788402', '155', '314', '2011', '498', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788404', '184', '329', '2010', '507', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788406', '12', '314', '2011', '482', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788408', '112', '329', '2010', '500', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788411', '129', '329', '2010', '511', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788412', '99', '314', '2011', '488', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788414', '78', '329', '2010', '505', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788415', '415', '314', '2011', '481', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788417', '55', '329', '2010', '506', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788418', '38', '314', '2011', '495', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788420', '147', '329', '2010', '512', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788421', '143', '314', '2011', '505', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788423', '10', '329', '2010', '505', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788424', '161', '314', '2011', '486', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788426', '146', '329', '2010', '510', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788427', '109', '314', '2011', '496', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788429', '87', '329', '2010', '508', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788430', '24', '314', '2011', '479', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788432', '40', '329', '2010', '506', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788433', '78', '314', '2011', '491', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788434', '37', '329', '2010', '505', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788435', '86', '314', '2011', '480', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788436', '2', '329', '2010', '501', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788437', '27', '314', '2011', '511', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788438', '23', '329', '2010', '508', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788439', '87', '314', '2011', '504', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788440', '95', '329', '2010', '505', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788441', '37', '314', '2011', '491', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788442', '393', '329', '2010', '512', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788443', '36', '314', '2011', '490', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788444', '355', '329', '2010', '508', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788445', '149', '314', '2011', '480', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788446', '323', '329', '2010', '499', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788447', '71', '314', '2011', '488', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788448', '26', '329', '2010', '497', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788449', '8', '329', '2010', '504', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788450', '438', '314', '2011', '488', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788451', '85', '329', '2010', '503', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788452', '129', '314', '2011', '499', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788453', '91', '329', '2010', '515', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788454', '151', '314', '2011', '491', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788455', '24', '329', '2010', '500', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788456', '120', '314', '2011', '502', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788457', '220', '329', '2010', '503', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788458', '85', '314', '2011', '499', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788459', '347', '329', '2010', '493', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788460', '79', '314', '2011', '489', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788461', '181', '329', '2010', '515', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788462', '8', '314', '2011', '498', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788463', '3', '314', '2011', '510', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788464', '201', '314', '2011', '495', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788465', '107', '314', '2011', '492', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788466', '147', '314', '2011', '506', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788467', '10', '314', '2011', '499', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788468', '63', '314', '2011', '479', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788469', '55', '314', '2011', '489', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788472', '310', '314', '2011', '495', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788475', '186', '314', '2011', '485', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788479', '279', '314', '2011', '479', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788487', '25', '314', '2011', '494', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788495', '10', '329', '2011', '523', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788497', '101', '314', '2011', '494', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788500', '175', '314', '2011', '510', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788503', '136', '329', '2011', '512', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788508', '2', '314', '2011', '495', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788510', '2', '329', '2011', '532', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788515', '184', '314', '2011', '485', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788519', '79', '329', '2011', '513', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788523', '388', '329', '2011', '517', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788525', '85', '329', '2011', '513', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788531', '55', '329', '2011', '532', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788536', '25', '329', '2011', '518', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788540', '101', '329', '2011', '516', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788546', '109', '314', '2012', '496', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788550', '175', '329', '2011', '503', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788552', '107', '314', '2012', '511', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788557', '147', '329', '2011', '524', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788562', '211', '314', '2012', '500', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788566', '38', '329', '2011', '515', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788567', '151', '314', '2012', '493', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788571', '36', '314', '2012', '499', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788572', '205', '329', '2011', '508', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788576', '37', '314', '2012', '524', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788579', '181', '329', '2011', '523', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788585', '385', '314', '2012', '498', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788586', '161', '329', '2011', '526', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788589', '143', '314', '2012', '502', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788592', '89', '329', '2011', '518', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788595', '23', '329', '2011', '523', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788596', '38', '314', '2012', '505', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788602', '120', '314', '2012', '498', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788605', '794', '329', '2011', '510', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788606', '147', '314', '2012', '516', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788609', '347', '329', '2011', '518', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788610', '415', '314', '2012', '496', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788614', '40', '329', '2011', '519', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788615', '186', '314', '2012', '514', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788622', '84', '329', '2011', '513', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788623', '69', '314', '2012', '511', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788627', '981', '329', '2011', '520', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788631', '8', '314', '2012', '514', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788636', '97', '314', '2012', '497', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788639', '95', '329', '2011', '524', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788643', '101', '314', '2012', '509', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788647', '91', '329', '2011', '518', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788652', '149', '314', '2012', '498', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788653', '17', '329', '2011', '518', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788656', '161', '314', '2012', '505', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788657', '8', '329', '2011', '521', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788662', '3', '329', '2011', '527', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788663', '25', '314', '2012', '498', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788668', '30', '329', '2011', '540', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788672', '184', '314', '2012', '500', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788676', '279', '314', '2012', '498', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788679', '207', '329', '2011', '520', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788681', '21', '329', '2011', '529', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788682', '202', '314', '2012', '496', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788684', '184', '329', '2011', '520', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788685', '24', '314', '2012', '495', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788688', '220', '329', '2011', '508', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788693', '438', '314', '2012', '501', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788698', '112', '329', '2011', '511', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788700', '71', '314', '2012', '497', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788704', '226', '329', '2011', '526', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788707', '86', '314', '2012', '501', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788708', '155', '314', '2012', '508', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788713', '393', '329', '2011', '516', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788714', '27', '314', '2012', '521', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788717', '222', '329', '2011', '518', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788718', '87', '314', '2012', '496', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788721', '87', '329', '2011', '522', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788723', '99', '314', '2012', '503', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788725', '2761', '329', '2011', '513', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788727', '323', '329', '2011', '506', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788728', '85', '314', '2012', '493', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788731', '78', '329', '2011', '519', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788732', '129', '314', '2012', '517', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788735', '79', '314', '2012', '493', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788737', '37', '329', '2011', '514', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788740', '21', '314', '2012', '512', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788741', '12', '329', '2011', '517', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788745', '23', '314', '2012', '503', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788747', '52', '329', '2011', '509', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788753', '3', '314', '2012', '528', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788756', '78', '314', '2012', '499', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788759', '119', '329', '2011', '511', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788766', '129', '329', '2011', '521', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788768', '2', '314', '2012', '511', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788774', '355', '329', '2011', '530', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788776', '55', '314', '2012', '496', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788781', '395', '329', '2011', '510', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788782', '10', '314', '2012', '506', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788787', '310', '314', '2012', '511', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788789', '269', '329', '2011', '517', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788795', '201', '314', '2012', '528', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788800', '26', '329', '2011', '511', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788801', '12', '314', '2012', '493', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788806', '146', '329', '2011', '519', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788807', '175', '314', '2012', '505', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788810', '24', '329', '2011', '519', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788814', '5', '314', '2012', '496', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788831', '23', '329', '2012', '542', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788832', '5', '314', '2013', '485', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788836', '69', '314', '2013', '470', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788839', '3', '329', '2012', '546', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788842', '78', '329', '2012', '542', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788843', '4255', '314', '2013', '463', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788846', '10', '314', '2013', '474', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788847', '2', '329', '2012', '539', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788850', '26', '329', '2012', '525', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788851', '310', '314', '2013', '495', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788855', '149', '314', '2013', '470', '461', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788856', '79', '329', '2012', '534', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788860', '454', '314', '2013', '470', '463', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788861', '146', '329', '2012', '540', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788862', '89', '329', '2012', '534', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788863', '101', '314', '2013', '465', '461', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788868', '24', '329', '2012', '528', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788869', '147', '314', '2013', '465', '463', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788874', '161', '314', '2013', '469', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788876', '181', '329', '2012', '547', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('788881', '255', '314', '2013', '469', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788883', '207', '329', '2012', '539', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788885', '27', '314', '2013', '500', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788891', '131', '314', '2013', '488', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788894', '136', '329', '2012', '530', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788898', '85', '314', '2013', '478', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788900', '52', '329', '2012', '536', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788905', '269', '329', '2012', '546', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788906', '317', '314', '2013', '472', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788911', '86', '314', '2013', '482', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788915', '355', '329', '2012', '554', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('788919', '29', '314', '2013', '469', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788923', '95', '329', '2012', '537', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788924', '400', '314', '2013', '471', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788926', '931', '314', '2013', '466', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788927', '112', '329', '2012', '528', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788931', '12', '314', '2013', '477', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788933', '91', '329', '2012', '546', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788935', '40', '314', '2013', '472', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788941', '2761', '329', '2012', '555', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788942', '28', '314', '2013', '494', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788948', '323', '329', '2012', '527', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788949', '21', '314', '2013', '485', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788952', '129', '329', '2012', '543', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788957', '385', '314', '2013', '495', '463', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788960', '55', '329', '2012', '540', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788965', '205', '329', '2012', '534', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788967', '156', '314', '2013', '479', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788971', '343', '314', '2013', '478', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788975', '84', '329', '2012', '529', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788977', '174', '314', '2013', '477', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788980', '163', '314', '2013', '476', '463', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788982', '40', '329', '2012', '536', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788987', '92', '314', '2013', '475', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788989', '393', '329', '2012', '528', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788995', '4253', '314', '2013', '475', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('788996', '226', '329', '2012', '533', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789002', '206', '314', '2013', '478', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789007', '388', '329', '2012', '550', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789010', '105', '314', '2013', '477', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789012', '395', '329', '2012', '523', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789015', '129', '314', '2013', '474', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789018', '87', '329', '2012', '556', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789020', '97', '314', '2013', '478', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789021', '794', '329', '2012', '542', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789024', '334', '314', '2013', '472', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789026', '347', '329', '2012', '538', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789027', '483', '314', '2013', '469', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789028', '222', '329', '2012', '546', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789031', '981', '329', '2012', '527', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789034', '415', '314', '2013', '465', '463', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789035', '85', '329', '2012', '540', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789038', '8', '314', '2013', '495', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789040', '30', '329', '2012', '543', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789042', '438', '314', '2013', '468', '463', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789044', '38', '329', '2012', '531', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789046', '175', '314', '2013', '471', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789049', '10', '329', '2012', '540', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789052', '233', '314', '2013', '478', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789054', '12', '329', '2012', '530', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789059', '161', '329', '2012', '529', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789064', '184', '329', '2012', '537', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789073', '25', '329', '2012', '541', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789079', '175', '329', '2012', '522', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789084', '101', '329', '2012', '535', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789088', '17', '329', '2012', '537', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789093', '8', '329', '2012', '543', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789094', '10', '366', '2010', '527', '527', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('789100', '37', '329', '2012', '539', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789105', '147', '329', '2012', '552', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789115', '220', '329', '2012', '526', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789119', '119', '329', '2012', '523', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789124', '21', '329', '2012', '541', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789128', '10', '366', '2012', '592', '591', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('789135', '2', '366', '2012', '593', '593', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('789151', '483', '329', '2013', '503', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789159', '85', '329', '2013', '520', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789163', '12', '329', '2013', '500', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789168', '233', '329', '2013', '508', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789177', '981', '329', '2013', '506', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789185', '759', '329', '2013', '510', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789190', '29', '329', '2013', '507', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789196', '226', '329', '2013', '504', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789205', '91', '329', '2013', '505', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789211', '510', '329', '2013', '502', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789223', '105', '329', '2013', '513', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789234', '269', '329', '2013', '495', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789245', '395', '329', '2013', '499', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789260', '397', '329', '2013', '500', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789266', '486', '329', '2013', '499', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789277', '237', '329', '2013', '503', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789281', '134', '329', '2013', '501', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789286', '40', '329', '2013', '507', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789291', '8', '329', '2013', '516', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789296', '119', '329', '2013', '498', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789302', '222', '329', '2013', '509', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789305', '393', '329', '2013', '504', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789311', '21', '329', '2013', '514', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789315', '351', '329', '2013', '527', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789318', '310', '329', '2013', '514', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789320', '95', '329', '2013', '539', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789321', '794', '329', '2013', '524', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789323', '40', '329', '2013', '532', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789325', '355', '329', '2013', '525', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789327', '17', '329', '2013', '533', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789329', '163', '329', '2013', '524', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789330', '87', '329', '2013', '520', '518', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789332', '238', '329', '2013', '500', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789333', '334', '329', '2013', '498', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789334', '222', '329', '2013', '518', '517', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789335', '10', '329', '2013', '513', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789336', '738', '329', '2013', '500', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789337', '347', '329', '2013', '507', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789338', '161', '329', '2013', '508', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789339', '175', '329', '2013', '497', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789340', '454', '329', '2013', '500', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789341', '101', '329', '2013', '498', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789359', '10', '368', '2010', '526', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789365', '4502', '368', '2010', '520', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789369', '14', '368', '2010', '521', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789371', '4501', '368', '2010', '520', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789373', '23', '358', '2011', '521', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789375', '18', '368', '2010', '520', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789376', '3', '358', '2011', '527', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789377', '8', '368', '2010', '534', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789379', '364', '358', '2011', '530', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789380', '2686', '368', '2010', '532', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789383', '43', '368', '2010', '523', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789387', '20', '368', '2010', '522', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789404', '43', '368', '2011', '540', '536', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789407', '2686', '368', '2011', '550', '534', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789411', '65', '368', '2011', '531', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789426', '4502', '368', '2011', '533', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789434', '74', '368', '2011', '531', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789449', '10', '368', '2011', '533', '532', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789458', '8', '368', '2011', '537', '536', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789470', '18', '368', '2011', '533', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789493', '4502', '368', '2012', '573', '573', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789504', '43', '368', '2012', '571', '570', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789510', '65', '368', '2012', '572', '572', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789519', '2686', '368', '2012', '578', '572', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789533', '4501', '368', '2012', '571', '571', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789546', '8', '368', '2012', '574', '572', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789554', '10', '368', '2012', '574', '573', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789569', '18', '368', '2012', '574', '574', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789587', '74', '368', '2012', '569', '569', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789593', '136', '368', '2012', '570', '569', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789608', '10', '368', '2013', '534', '532', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789617', '38', '363', '2010', '550', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789621', '436', '368', '2013', '531', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789629', '92', '363', '2010', '555', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789634', '435', '368', '2013', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789644', '14', '368', '2013', '529', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789654', '5', '368', '2013', '561', '546', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('789658', '3', '363', '2010', '560', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789663', '8', '368', '2013', '541', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('789669', '21', '363', '2010', '563', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789692', '10', '363', '2010', '557', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789717', '3', '363', '2011', '573', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789729', '58', '363', '2011', '570', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789742', '21', '363', '2011', '595', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789763', '92', '363', '2011', '566', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789778', '38', '363', '2011', '568', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789795', '270', '363', '2011', '576', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789804', '10', '363', '2011', '577', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789818', '63', '363', '2011', '581', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789832', '79', '363', '2011', '573', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('789956', '43', '368', '2010', '511', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789969', '2686', '368', '2010', '528', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789984', '65', '368', '2010', '517', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('789995', '8', '368', '2010', '514', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790008', '14', '368', '2010', '513', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790023', '136', '368', '2010', '516', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790027', '120', '376', '2010', '508', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790034', '3649', '368', '2010', '513', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790039', '10', '376', '2010', '504', '484', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790043', '2', '368', '2010', '512', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790053', '48', '376', '2010', '506', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790063', '10', '368', '2011', '533', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790072', '24', '376', '2010', '504', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790080', '17', '368', '2011', '531', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790081', '8', '376', '2010', '506', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790089', '2686', '368', '2011', '546', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790102', '23', '376', '2010', '505', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790104', '20', '368', '2011', '539', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790119', '78', '376', '2010', '501', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790121', '136', '368', '2011', '527', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790138', '23', '368', '2011', '533', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790151', '59', '376', '2011', '506', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790157', '8', '368', '2011', '532', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790168', '78', '376', '2011', '517', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790169', '3649', '368', '2011', '533', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790175', '120', '376', '2011', '507', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790186', '24', '376', '2011', '500', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790188', '2', '368', '2011', '555', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790194', '10', '376', '2011', '511', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790204', '83', '366', '2010', '556', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790210', '48', '376', '2011', '511', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790214', '17', '368', '2012', '548', '547', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790217', '437', '366', '2010', '566', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790222', '23', '376', '2011', '513', '497', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790225', '119', '366', '2010', '555', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790230', '23', '368', '2012', '553', '547', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790243', '151', '366', '2010', '552', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790246', '8', '376', '2011', '510', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790248', '10', '368', '2012', '546', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790263', '2686', '368', '2012', '554', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790264', '147', '366', '2010', '562', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790277', '8', '376', '2012', '554', '536', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790278', '271', '366', '2010', '563', '561', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790281', '2', '368', '2012', '552', '551', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790293', '161', '366', '2010', '553', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790294', '120', '376', '2012', '549', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790298', '8', '368', '2012', '563', '558', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790307', '10', '376', '2012', '553', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790308', '127', '366', '2010', '556', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790315', '20', '368', '2012', '559', '552', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790320', '206', '366', '2010', '557', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790327', '48', '376', '2012', '551', '534', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790332', '99', '366', '2010', '557', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790333', '3649', '368', '2012', '545', '545', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790343', '89', '376', '2012', '549', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790351', '136', '368', '2012', '548', '548', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790352', '36', '366', '2010', '559', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790360', '24', '376', '2012', '550', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790370', '254', '366', '2010', '569', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790379', '59', '376', '2012', '547', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790380', '56', '368', '2013', '515', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790388', '382', '366', '2010', '579', '569', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790395', '436', '368', '2013', '515', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790397', '23', '376', '2012', '552', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790406', '97', '366', '2010', '551', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790414', '78', '376', '2012', '549', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790416', '8', '368', '2013', '519', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790422', '78', '366', '2010', '550', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790429', '578', '368', '2013', '520', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790438', '85', '366', '2010', '550', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790442', '10', '376', '2013', '506', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790447', '65', '368', '2013', '518', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790449', '38', '366', '2010', '547', '547', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790457', '22', '376', '2013', '504', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790460', '17', '368', '2013', '517', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790465', '159', '376', '2013', '513', '504', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790472', '10', '368', '2013', '516', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790475', '80', '366', '2010', '558', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790485', '14', '368', '2013', '515', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('790487', '498', '376', '2013', '502', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790488', '118', '366', '2010', '551', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790497', '5', '368', '2013', '582', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790500', '13', '376', '2013', '500', '495', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790514', '10', '366', '2011', '559', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790519', '67', '376', '2013', '503', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790530', '8', '376', '2013', '515', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('790538', '79', '366', '2012', '591', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790551', '80', '366', '2012', '601', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790566', '119', '366', '2012', '592', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790577', '2', '366', '2012', '590', '587', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790590', '99', '366', '2012', '596', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790598', '254', '366', '2012', '602', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790604', '36', '366', '2012', '601', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790610', '127', '366', '2012', '591', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790616', '378', '366', '2012', '594', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790624', '83', '366', '2012', '597', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790628', '151', '366', '2012', '596', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790636', '271', '366', '2012', '600', '597', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790640', '161', '366', '2012', '597', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790645', '38', '366', '2012', '593', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790651', '118', '366', '2012', '595', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790655', '437', '366', '2012', '609', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790658', '97', '366', '2012', '592', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790664', '17', '366', '2012', '593', '593', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790668', '382', '366', '2012', '612', '606', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790673', '85', '366', '2012', '598', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790683', '147', '366', '2012', '601', '600', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790699', '332', '366', '2013', '573', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790705', '183', '366', '2013', '567', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790709', '97', '366', '2013', '581', '556', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790715', '147', '366', '2013', '534', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790718', '85', '366', '2013', '551', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790721', '310', '366', '2013', '570', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790725', '4402', '366', '2013', '576', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790728', '206', '366', '2013', '570', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790731', '84', '366', '2013', '569', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790735', '368', '366', '2013', '560', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790738', '3052', '366', '2013', '569', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790741', '119', '366', '2013', '557', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790745', '118', '366', '2013', '559', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790749', '233', '366', '2013', '561', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790755', '4203', '366', '2013', '562', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790760', '161', '366', '2013', '564', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790764', '378', '366', '2013', '563', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790769', '95', '366', '2013', '571', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790775', '151', '366', '2013', '566', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790778', '174', '366', '2013', '573', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('790926', '97', '366', '2011', '569', '569', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790931', '254', '366', '2011', '577', '575', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790934', '83', '366', '2011', '576', '575', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790938', '119', '366', '2011', '571', '571', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790941', '161', '366', '2011', '571', '570', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790945', '80', '366', '2011', '575', '572', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790948', '147', '366', '2011', '583', '580', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790951', '127', '366', '2011', '580', '577', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790956', '36', '366', '2011', '578', '576', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790959', '271', '366', '2011', '583', '582', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790962', '118', '366', '2011', '573', '572', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790966', '78', '366', '2011', '569', '569', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790970', '151', '366', '2011', '572', '572', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790973', '38', '366', '2011', '570', '570', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790975', '437', '366', '2011', '593', '588', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790978', '206', '366', '2011', '583', '580', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790981', '378', '366', '2011', '583', '580', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790984', '3', '366', '2011', '569', '569', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790990', '79', '366', '2011', '569', '569', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790993', '85', '366', '2011', '578', '578', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('790996', '382', '366', '2011', '598', '590', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('791000', '23', '366', '2011', '572', '572', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('791004', '99', '366', '2011', '581', '581', '5', '1', '13');
INSERT INTO `major_recruit` VALUES ('791016', '10', '376', '2010', '490', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791019', '132', '376', '2010', '484', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791024', '107', '376', '2010', '495', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791028', '48', '376', '2010', '479', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791032', '129', '376', '2010', '498', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791035', '147', '376', '2010', '495', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791038', '146', '376', '2010', '492', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791041', '8', '376', '2010', '486', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791042', '23', '376', '2010', '487', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791044', '174', '376', '2010', '510', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791048', '78', '376', '2010', '485', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791052', '153', '376', '2010', '499', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791056', '113', '376', '2010', '504', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791061', '109', '376', '2010', '498', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791065', '55', '376', '2010', '487', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791070', '37', '376', '2010', '484', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791073', '38', '376', '2010', '490', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791075', '101', '376', '2010', '475', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791076', '759', '376', '2010', '474', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791077', '36', '376', '2010', '495', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791078', '445', '376', '2010', '478', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791080', '120', '376', '2010', '496', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791081', '143', '376', '2010', '483', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791083', '127', '376', '2010', '492', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791085', '79', '376', '2010', '480', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791086', '87', '376', '2010', '475', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791088', '233', '376', '2010', '487', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791094', '233', '376', '2011', '504', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791097', '759', '376', '2011', '491', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791101', '146', '376', '2011', '506', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791104', '24', '376', '2011', '492', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791107', '38', '376', '2011', '503', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791110', '143', '376', '2011', '524', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791112', '113', '376', '2011', '525', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791114', '107', '376', '2011', '517', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791116', '147', '376', '2011', '515', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791118', '10', '376', '2011', '513', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791120', '23', '376', '2011', '499', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791122', '109', '376', '2011', '498', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791123', '129', '376', '2011', '521', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791126', '37', '376', '2011', '498', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791127', '254', '376', '2011', '490', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791129', '59', '376', '2011', '486', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791130', '266', '376', '2011', '498', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791132', '30', '376', '2011', '493', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791136', '87', '376', '2011', '504', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791140', '445', '376', '2011', '514', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791143', '36', '376', '2011', '510', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791146', '127', '376', '2011', '498', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791152', '132', '376', '2011', '500', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791157', '120', '376', '2011', '503', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791161', '78', '376', '2011', '500', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791164', '510', '376', '2011', '495', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791167', '174', '376', '2011', '530', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791168', '153', '376', '2011', '505', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791171', '79', '376', '2011', '495', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791174', '48', '376', '2011', '494', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791178', '101', '376', '2011', '495', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791181', '8', '376', '2011', '509', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791183', '55', '376', '2011', '498', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791194', '8', '376', '2012', '522', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791197', '59', '376', '2012', '509', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791199', '143', '376', '2012', '524', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791202', '55', '376', '2012', '529', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791204', '153', '376', '2012', '518', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791205', '101', '376', '2012', '524', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791206', '120', '376', '2012', '512', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791207', '48', '376', '2012', '506', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791208', '266', '376', '2012', '507', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791211', '10', '376', '2012', '523', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791212', '113', '376', '2012', '536', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791214', '89', '376', '2012', '513', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791219', '24', '376', '2012', '507', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791223', '23', '376', '2012', '519', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791228', '254', '376', '2012', '528', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791232', '87', '376', '2012', '527', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791235', '109', '376', '2012', '513', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791237', '233', '376', '2012', '514', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791240', '510', '376', '2012', '522', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791243', '445', '376', '2012', '517', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791245', '78', '376', '2012', '507', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791246', '37', '376', '2012', '524', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791249', '107', '376', '2012', '535', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791252', '759', '376', '2012', '516', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791255', '127', '376', '2012', '511', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791258', '36', '376', '2012', '539', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791261', '79', '376', '2012', '514', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791265', '146', '376', '2012', '524', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791268', '147', '376', '2012', '534', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791271', '174', '376', '2012', '537', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791273', '132', '376', '2012', '517', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791276', '129', '376', '2012', '544', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791285', '141', '376', '2013', '496', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791287', '483', '376', '2013', '478', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791290', '759', '376', '2013', '484', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791292', '4224', '376', '2013', '482', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791293', '8', '376', '2013', '493', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791295', '105', '376', '2013', '489', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791297', '156', '376', '2013', '479', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791299', '147', '376', '2013', '478', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791301', '498', '376', '2013', '476', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791303', '99', '376', '2013', '517', '517', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('791306', '296', '376', '2013', '492', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791307', '85', '376', '2013', '518', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791308', '174', '376', '2013', '496', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791309', '4213', '376', '2013', '516', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791310', '3052', '376', '2013', '497', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791312', '507', '376', '2013', '493', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791314', '112', '376', '2013', '480', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791316', '101', '376', '2013', '477', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791317', '67', '376', '2013', '475', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791318', '159', '376', '2013', '477', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791319', '113', '376', '2013', '520', '520', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('791321', '445', '376', '2013', '496', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791322', '385', '376', '2013', '510', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791325', '95', '376', '2013', '480', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791326', '163', '376', '2013', '484', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791328', '310', '376', '2013', '498', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791330', '129', '376', '2013', '492', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791332', '22', '376', '2013', '478', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791334', '510', '376', '2013', '501', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791336', '10', '376', '2013', '481', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791549', '2', '394', '2010', '522', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791559', '8', '394', '2010', '523', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791572', '5', '394', '2010', '521', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791587', '8', '394', '2011', '534', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791595', '43', '394', '2011', '531', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791602', '2', '394', '2011', '537', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791616', '5', '394', '2011', '532', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791635', '5', '394', '2012', '569', '568', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791644', '8', '394', '2012', '574', '573', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791653', '2', '394', '2012', '570', '569', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791657', '43', '394', '2012', '572', '570', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791675', '8', '394', '2013', '531', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791686', '5', '394', '2013', '531', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791687', '21', '395', '2010', '515', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791695', '126', '395', '2010', '517', '517', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791705', '2', '395', '2010', '516', '516', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791717', '63', '395', '2010', '516', '516', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791731', '13', '395', '2010', '515', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791744', '78', '395', '2010', '514', '513', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791759', '5', '395', '2010', '513', '512', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791777', '3', '395', '2010', '518', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791790', '12', '395', '2011', '527', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791802', '21', '395', '2011', '528', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791810', '5', '395', '2011', '526', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791815', '126', '395', '2011', '523', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791823', '13', '395', '2011', '527', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791829', '63', '395', '2011', '526', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791843', '10', '395', '2011', '529', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791851', '2', '395', '2011', '524', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791861', '3', '395', '2011', '531', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791879', '8', '395', '2012', '567', '566', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791880', '150', '394', '2010', '513', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791886', '5', '395', '2012', '568', '568', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791893', '105', '394', '2010', '513', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791898', '126', '395', '2012', '568', '568', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791904', '116', '394', '2010', '514', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791910', '3', '395', '2012', '569', '569', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791916', '2', '394', '2010', '516', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791925', '185', '394', '2010', '522', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791926', '2', '395', '2012', '567', '567', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791934', '63', '395', '2012', '566', '565', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791943', '10', '395', '2012', '563', '562', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791945', '12', '395', '2012', '566', '565', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791949', '2', '394', '2011', '530', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791956', '13', '395', '2012', '565', '565', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791958', '150', '394', '2011', '532', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791963', '185', '394', '2011', '534', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791973', '116', '394', '2011', '529', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791976', '8', '395', '2013', '530', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791981', '105', '394', '2011', '530', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('791988', '5', '395', '2013', '528', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('791996', '12', '395', '2013', '526', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('792001', '2', '394', '2012', '552', '551', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792008', '1451', '395', '2013', '527', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('792010', '150', '394', '2012', '545', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792017', '185', '394', '2012', '552', '549', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792019', '4429', '395', '2013', '527', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('792029', '10', '395', '2013', '529', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('792033', '105', '394', '2012', '545', '545', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792041', '116', '394', '2012', '554', '548', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792061', '4224', '394', '2013', '516', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792070', '4214', '394', '2013', '516', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792086', '4231', '394', '2013', '518', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792090', '13', '412', '2013', '524', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('792100', '10', '412', '2013', '526', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('792103', '105', '394', '2013', '523', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792113', '61', '412', '2013', '520', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('792335', '146', '395', '2010', '507', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792341', '113', '395', '2010', '511', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792345', '79', '395', '2010', '493', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792350', '97', '395', '2010', '497', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792359', '84', '395', '2010', '497', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792361', '99', '395', '2010', '499', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792366', '38', '395', '2010', '500', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792376', '40', '395', '2010', '499', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792380', '85', '395', '2010', '499', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792383', '37', '395', '2010', '501', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792387', '8', '395', '2010', '513', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792406', '37', '395', '2011', '512', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792411', '245', '395', '2011', '508', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792417', '219', '395', '2011', '507', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792421', '109', '395', '2011', '510', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792426', '71', '395', '2011', '510', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792433', '78', '395', '2011', '517', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792439', '38', '395', '2011', '509', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792444', '27', '395', '2011', '529', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792449', '146', '395', '2011', '521', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792453', '79', '395', '2011', '519', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792456', '10', '395', '2011', '516', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792459', '113', '395', '2011', '516', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792463', '99', '395', '2011', '509', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792466', '84', '395', '2011', '517', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792468', '329', '395', '2011', '510', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792470', '40', '395', '2011', '512', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792475', '85', '395', '2011', '513', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792477', '8', '395', '2011', '522', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792479', '97', '395', '2011', '513', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792499', '95', '412', '2011', '525', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792501', '148', '412', '2011', '523', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792502', '79', '412', '2011', '527', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792503', '113', '412', '2011', '526', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792504', '92', '412', '2011', '536', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792505', '173', '412', '2011', '531', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792507', '84', '412', '2011', '524', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792508', '391', '412', '2011', '524', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792510', '107', '412', '2011', '529', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792516', '8', '395', '2012', '542', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792519', '3', '395', '2012', '541', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792522', '71', '395', '2012', '534', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792525', '21', '395', '2012', '537', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792528', '23', '395', '2012', '539', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792531', '109', '395', '2012', '531', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792534', '79', '395', '2012', '536', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792537', '84', '412', '2012', '540', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792541', '148', '395', '2012', '532', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792544', '391', '412', '2012', '542', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792545', '37', '395', '2012', '541', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792548', '95', '412', '2012', '543', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792549', '38', '395', '2012', '536', '535', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792553', '105', '395', '2012', '534', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792554', '79', '412', '2012', '559', '559', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792556', '30', '412', '2012', '542', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792557', '151', '395', '2012', '532', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792559', '129', '395', '2012', '539', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792561', '78', '395', '2012', '539', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792564', '146', '395', '2012', '532', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792567', '113', '395', '2012', '538', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792569', '107', '412', '2012', '542', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792570', '68', '395', '2012', '537', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792572', '113', '412', '2012', '545', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792573', '84', '395', '2012', '532', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792575', '329', '395', '2012', '532', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792578', '85', '395', '2012', '531', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792581', '147', '395', '2012', '540', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792583', '97', '395', '2012', '537', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792585', '99', '395', '2012', '531', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792587', '10', '395', '2012', '536', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792589', '27', '395', '2012', '537', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792591', '245', '395', '2012', '530', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792593', '161', '395', '2012', '530', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792595', '40', '395', '2012', '530', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792597', '219', '395', '2012', '531', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792598', '141', '395', '2012', '533', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792599', '4211', '412', '2013', '515', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792602', '134', '412', '2013', '512', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792606', '385', '412', '2013', '516', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792612', '113', '412', '2013', '524', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792615', '95', '412', '2013', '513', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792618', '391', '412', '2013', '514', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792620', '262', '412', '2013', '513', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792628', '85', '395', '2013', '510', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792633', '8', '395', '2013', '508', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792637', '21', '395', '2013', '510', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792638', '260', '395', '2013', '523', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792641', '28', '395', '2013', '516', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792644', '3774', '395', '2013', '518', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792648', '105', '395', '2013', '508', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792651', '141', '395', '2013', '510', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792654', '86', '395', '2013', '507', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792658', '134', '395', '2013', '500', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792661', '932', '395', '2013', '501', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792664', '377', '395', '2013', '501', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792666', '730', '395', '2013', '500', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792667', '40', '395', '2013', '501', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792668', '156', '395', '2013', '502', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792669', '147', '395', '2013', '501', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792670', '206', '395', '2013', '502', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792671', '83', '395', '2013', '506', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792672', '233', '395', '2013', '507', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792673', '113', '395', '2013', '506', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792674', '310', '395', '2013', '506', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792675', '161', '395', '2013', '506', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792677', '97', '395', '2013', '504', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('792947', '3606', '423', '2010', '538', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('792948', '52', '423', '2010', '549', '540', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('792953', '89', '425', '2010', '477', '430', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('792954', '10', '423', '2010', '539', '536', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('792956', '69', '425', '2010', '428', '423', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('792958', '58', '423', '2010', '549', '545', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('792962', '143', '425', '2010', '435', '423', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('792965', '78', '425', '2010', '450', '424', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('792968', '2', '425', '2010', '468', '426', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('792971', '143', '425', '2010', '488', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('792972', '10', '425', '2010', '490', '484', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('792974', '14', '425', '2010', '438', '428', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('792975', '48', '425', '2010', '439', '426', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('792976', '78', '425', '2010', '501', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('792977', '10', '425', '2010', '466', '430', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('792981', '3606', '423', '2011', '545', '539', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('792983', '58', '423', '2011', '548', '547', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('792985', '52', '423', '2011', '553', '549', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('792986', '10', '423', '2011', '548', '547', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('792996', '68', '425', '2011', '496', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('792997', '68', '425', '2011', '441', '434', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('792998', '329', '425', '2011', '425', '425', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('792999', '168', '425', '2011', '475', '452', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793000', '69', '425', '2011', '440', '437', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793001', '143', '425', '2011', '453', '428', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793002', '10', '425', '2011', '485', '432', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793003', '14', '425', '2011', '441', '429', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793004', '2', '425', '2011', '507', '431', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793005', '48', '425', '2011', '439', '431', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793006', '129', '425', '2011', '454', '428', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793007', '3606', '423', '2012', '584', '582', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('793008', '78', '425', '2011', '462', '436', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793009', '52', '423', '2012', '589', '588', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('793010', '78', '425', '2011', '498', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793011', '58', '423', '2012', '590', '588', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('793012', '10', '425', '2011', '492', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793013', '10', '423', '2012', '584', '583', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('793014', '89', '425', '2011', '466', '432', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793032', '58', '423', '2013', '560', '558', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('793034', '69', '423', '2013', '547', '547', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('793036', '10', '423', '2013', '546', '545', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('793038', '30', '425', '2012', '493', '484', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793039', '10', '425', '2012', '518', '469', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793040', '143', '425', '2012', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793041', '68', '425', '2012', '481', '477', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793042', '69', '425', '2012', '489', '473', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793043', '48', '425', '2012', '477', '468', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793044', '329', '425', '2012', '512', '485', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793045', '129', '425', '2012', '493', '472', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793046', '78', '425', '2012', '496', '479', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793047', '168', '425', '2012', '469', '468', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793048', '78', '425', '2012', '525', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793049', '2', '425', '2012', '552', '546', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793050', '14', '425', '2012', '477', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793051', '143', '425', '2012', '500', '477', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793052', '2', '425', '2012', '510', '471', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793053', '89', '425', '2012', '500', '474', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793058', '24', '428', '2011', '526', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793060', '69', '428', '2011', '526', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793062', '52', '428', '2011', '526', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793064', '23', '428', '2011', '530', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793065', '5', '428', '2011', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793067', '203', '428', '2011', '530', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793069', '2', '428', '2011', '528', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793072', '8', '428', '2011', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793076', '98', '428', '2011', '526', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793078', '3', '428', '2011', '535', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793082', '221', '425', '2013', '454', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793083', '13', '428', '2011', '526', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793085', '14', '425', '2013', '466', '454', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793087', '181', '428', '2011', '530', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793089', '85', '425', '2013', '472', '454', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793092', '498', '425', '2013', '462', '457', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793095', '238', '425', '2013', '475', '459', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793097', '129', '425', '2013', '453', '448', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793099', '10', '425', '2013', '493', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793102', '238', '425', '2013', '514', '514', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793105', '10', '425', '2013', '472', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793107', '69', '425', '2013', '449', '446', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793110', '12', '425', '2013', '449', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793115', '334', '425', '2013', '451', '447', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('793121', '69', '428', '2012', '549', '549', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793125', '24', '428', '2012', '568', '568', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793128', '203', '428', '2012', '566', '566', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793130', '2', '428', '2012', '568', '567', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793131', '8', '428', '2012', '576', '576', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793133', '181', '428', '2012', '568', '568', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793135', '23', '428', '2012', '568', '568', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793137', '3', '428', '2012', '571', '571', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793139', '13', '428', '2012', '566', '566', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793141', '5', '428', '2012', '567', '567', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793145', '78', '428', '2012', '567', '567', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793149', '98', '428', '2012', '567', '567', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793152', '52', '428', '2012', '567', '566', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793158', '5', '428', '2013', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793162', '8', '428', '2013', '532', '532', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793165', '69', '428', '2013', '528', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793171', '13', '428', '2013', '528', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793174', '10', '428', '2013', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('793207', '3606', '423', '2010', '531', '528', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793210', '10', '423', '2010', '537', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793213', '58', '423', '2010', '545', '542', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793216', '541', '423', '2010', '539', '525', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793219', '1247', '423', '2010', '533', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793228', '52', '423', '2010', '525', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793229', '56', '423', '2010', '540', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793256', '56', '423', '2011', '532', '531', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793261', '1247', '423', '2011', '545', '540', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793264', '10', '423', '2011', '560', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793268', '52', '423', '2011', '547', '544', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793273', '58', '423', '2011', '550', '549', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793276', '3606', '423', '2011', '562', '554', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793279', '541', '423', '2011', '540', '538', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793280', '78', '425', '2010', '488', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793286', '40', '425', '2010', '486', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793293', '10', '425', '2010', '468', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793297', '143', '425', '2010', '479', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793299', '10', '423', '2012', '566', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793303', '56', '423', '2012', '559', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793304', '129', '425', '2010', '484', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793308', '58', '423', '2012', '576', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793309', '541', '423', '2012', '567', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793315', '5', '429', '2011', '528', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793319', '1247', '423', '2012', '567', '557', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793322', '68', '425', '2011', '483', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793323', '43', '429', '2011', '517', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793325', '3606', '423', '2012', '562', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793328', '30', '425', '2011', '455', '396', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793331', '23', '429', '2011', '525', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793333', '52', '423', '2012', '560', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793334', '129', '425', '2011', '466', '389', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793337', '2', '429', '2011', '523', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793340', '68', '425', '2011', '425', '395', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793344', '158', '425', '2011', '468', '402', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793346', '205', '425', '2011', '455', '390', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793347', '329', '425', '2011', '443', '410', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793348', '147', '425', '2011', '498', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793349', '14', '425', '2011', '432', '391', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793351', '143', '425', '2011', '437', '390', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793352', '5', '429', '2012', '537', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793353', '56', '423', '2013', '528', '527', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793356', '3912', '423', '2013', '550', '529', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793358', '147', '425', '2011', '462', '397', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793360', '2', '429', '2012', '541', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793363', '109', '425', '2011', '450', '399', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793364', '23', '429', '2012', '545', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793366', '10', '423', '2013', '533', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793370', '43', '429', '2012', '546', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793371', '161', '425', '2011', '449', '402', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793372', '69', '423', '2013', '534', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793375', '118', '429', '2012', '535', '532', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793377', '58', '423', '2013', '551', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793378', '143', '425', '2011', '486', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793383', '10', '425', '2011', '476', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793384', '4480', '423', '2013', '531', '524', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('793389', '40', '425', '2011', '478', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793393', '38', '425', '2011', '500', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793394', '78', '425', '2011', '480', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793398', '78', '425', '2011', '447', '393', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793401', '37', '425', '2011', '453', '396', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793404', '196', '425', '2011', '436', '398', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793407', '69', '425', '2011', '410', '385', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793410', '416', '425', '2011', '448', '404', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793412', '2', '425', '2011', '451', '390', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793414', '48', '425', '2011', '418', '395', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793416', '85', '425', '2011', '424', '388', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793418', '129', '425', '2011', '512', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793420', '38', '425', '2011', '435', '388', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793422', '89', '425', '2011', '447', '392', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793424', '40', '425', '2011', '442', '393', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793426', '113', '425', '2011', '465', '393', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793427', '10', '425', '2011', '456', '404', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793443', '30', '425', '2012', '473', '409', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793456', '196', '425', '2012', '490', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793469', '30', '425', '2012', '491', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793474', '113', '425', '2012', '434', '402', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793482', '38', '425', '2012', '457', '416', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793494', '196', '425', '2012', '462', '424', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793500', '129', '425', '2012', '475', '409', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793505', '329', '425', '2012', '441', '421', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793512', '68', '425', '2012', '409', '394', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793519', '147', '425', '2012', '463', '410', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793534', '85', '425', '2012', '418', '404', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793540', '37', '425', '2012', '465', '414', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793548', '205', '425', '2012', '435', '410', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793561', '147', '425', '2012', '522', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793567', '69', '425', '2012', '397', '393', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793572', '48', '425', '2012', '414', '414', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793577', '10', '425', '2012', '463', '408', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793580', '10', '425', '2012', '487', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793585', '129', '425', '2012', '504', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793589', '14', '425', '2012', '415', '396', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793595', '38', '425', '2012', '492', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793597', '444', '428', '2011', '522', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793599', '2', '425', '2012', '508', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793603', '141', '428', '2011', '527', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793606', '109', '425', '2012', '446', '410', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793610', '393', '428', '2011', '519', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793612', '143', '425', '2012', '498', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793616', '68', '428', '2011', '523', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793617', '78', '425', '2012', '434', '405', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793621', '79', '428', '2011', '524', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793622', '78', '425', '2012', '487', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793624', '2', '425', '2012', '459', '406', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793625', '3', '428', '2011', '522', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793627', '40', '425', '2012', '458', '421', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793628', '794', '428', '2011', '527', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793629', '143', '425', '2012', '465', '409', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793630', '351', '428', '2011', '536', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793631', '38', '428', '2011', '526', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793633', '89', '425', '2012', '459', '412', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793634', '147', '428', '2011', '524', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793638', '416', '425', '2012', '439', '416', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('793643', '40', '425', '2012', '496', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793645', '89', '428', '2011', '523', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793651', '24', '428', '2011', '522', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793658', '220', '428', '2011', '523', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793662', '184', '428', '2011', '520', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793667', '233', '425', '2013', '469', '461', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793670', '98', '428', '2011', '519', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793674', '85', '425', '2013', '472', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793675', '16', '428', '2011', '520', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793683', '310', '425', '2013', '488', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793684', '222', '428', '2011', '530', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793693', '129', '425', '2013', '477', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793695', '8', '428', '2011', '530', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793703', '2448', '425', '2013', '460', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793708', '112', '428', '2011', '522', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793712', '10', '425', '2013', '479', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793717', '83', '425', '2013', '467', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793719', '75', '428', '2011', '519', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793725', '279', '428', '2011', '523', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793728', '203', '428', '2011', '520', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793732', '25', '428', '2011', '521', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793735', '37', '428', '2011', '522', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793738', '101', '428', '2011', '519', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793767', '203', '428', '2012', '539', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793773', '75', '428', '2012', '540', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793781', '351', '428', '2012', '545', '543', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793788', '68', '428', '2012', '542', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793798', '98', '428', '2012', '542', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793806', '147', '428', '2012', '546', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793812', '79', '428', '2012', '540', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793819', '3', '428', '2012', '544', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793827', '24', '428', '2012', '546', '546', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793832', '8', '428', '2012', '554', '554', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793839', '38', '428', '2012', '540', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793850', '184', '428', '2012', '539', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793860', '52', '428', '2012', '541', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793869', '794', '428', '2012', '524', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793881', '16', '428', '2012', '547', '547', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793888', '222', '428', '2012', '545', '545', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793891', '444', '428', '2012', '539', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793899', '279', '428', '2012', '542', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793915', '351', '428', '2013', '539', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793921', '112', '428', '2013', '503', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793926', '10', '428', '2013', '507', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793930', '498', '444', '2010', '543', '543', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('793935', '3652', '444', '2010', '544', '544', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('793936', '233', '428', '2013', '513', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793940', '65', '444', '2010', '547', '546', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('793942', '310', '428', '2013', '508', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793945', '95', '428', '2013', '514', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793946', '5', '444', '2010', '575', '561', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('793949', '29', '428', '2013', '514', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793955', '222', '428', '2013', '510', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793959', '8', '428', '2013', '513', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793961', '85', '428', '2013', '511', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793964', '83', '428', '2013', '512', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793968', '71', '428', '2013', '506', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793972', '3774', '428', '2013', '506', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793975', '444', '428', '2013', '504', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793978', '647', '428', '2013', '503', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('793983', '388', '428', '2013', '513', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('794270', '12', '443', '2010', '505', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794274', '69', '443', '2010', '501', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794279', '24', '443', '2010', '506', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794283', '5', '443', '2010', '507', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794292', '1', '443', '2010', '504', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794302', '428', '443', '2010', '498', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794309', '89', '443', '2010', '503', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794313', '51', '443', '2010', '507', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794316', '13', '443', '2010', '513', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794319', '8', '443', '2010', '512', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794322', '74', '443', '2010', '509', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794325', '23', '443', '2010', '508', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794327', '3', '443', '2010', '508', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794331', '48', '443', '2010', '506', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794338', '10', '443', '2010', '511', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794345', '63', '443', '2010', '504', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794403', '69', '443', '2011', '509', '497', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794409', '10', '443', '2011', '523', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794417', '9', '443', '2011', '497', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794419', '74', '443', '2011', '501', '495', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794422', '12', '443', '2011', '514', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794424', '65', '443', '2011', '501', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794429', '13', '443', '2011', '524', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794430', '1', '443', '2011', '511', '497', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794433', '24', '443', '2011', '513', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794437', '5', '443', '2011', '518', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794438', '13', '447', '2010', '507', '483', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794445', '63', '443', '2011', '512', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794446', '24', '447', '2010', '503', '483', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794450', '52', '447', '2010', '497', '483', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794452', '38', '443', '2011', '506', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794460', '95', '443', '2011', '513', '505', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794461', '10', '447', '2010', '515', '484', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794466', '58', '447', '2010', '503', '484', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794468', '40', '443', '2011', '516', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794473', '3', '443', '2011', '514', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794476', '86', '447', '2010', '500', '484', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794480', '101', '443', '2011', '519', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794482', '5', '447', '2010', '516', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794487', '48', '443', '2011', '513', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794489', '65', '447', '2010', '491', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794494', '175', '443', '2011', '508', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794496', '410', '447', '2010', '494', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794501', '428', '443', '2011', '507', '497', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794503', '66', '447', '2010', '502', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794506', '23', '443', '2011', '517', '503', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794510', '74', '447', '2010', '497', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794513', '8', '443', '2011', '516', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794517', '78', '447', '2010', '497', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794525', '56', '447', '2010', '489', '482', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794529', '51', '447', '2010', '503', '483', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794533', '428', '447', '2010', '485', '481', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794535', '48', '447', '2010', '494', '482', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794542', '20', '447', '2010', '496', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794547', '12', '447', '2010', '505', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794553', '1', '447', '2010', '505', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794559', '8', '447', '2010', '504', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794563', '8', '443', '2012', '554', '545', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794564', '23', '447', '2010', '505', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794569', '10', '443', '2012', '554', '546', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794570', '17', '447', '2010', '505', '495', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794572', '428', '443', '2012', '553', '544', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794573', '63', '447', '2010', '519', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794578', '65', '443', '2012', '554', '542', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794585', '3', '447', '2011', '514', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794591', '308', '447', '2011', '506', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794593', '5', '443', '2012', '554', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794599', '56', '447', '2011', '510', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794601', '13', '443', '2012', '567', '545', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794604', '23', '447', '2011', '527', '497', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794608', '74', '443', '2012', '549', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794610', '8', '447', '2011', '518', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794614', '428', '447', '2011', '505', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794616', '63', '443', '2012', '557', '544', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794621', '48', '447', '2011', '503', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794622', '12', '443', '2012', '554', '544', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794625', '66', '447', '2011', '503', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794628', '1', '443', '2012', '549', '542', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794631', '410', '447', '2011', '511', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794632', '3', '443', '2012', '562', '547', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794635', '24', '443', '2012', '552', '544', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794636', '52', '447', '2011', '514', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794640', '48', '443', '2012', '558', '545', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794641', '24', '447', '2011', '502', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794645', '69', '443', '2012', '546', '542', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794646', '74', '447', '2011', '493', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794649', '23', '443', '2012', '564', '545', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794654', '12', '447', '2011', '510', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794658', '58', '447', '2011', '505', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794663', '86', '447', '2011', '491', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794668', '78', '447', '2011', '507', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794674', '17', '447', '2011', '514', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794681', '5', '447', '2011', '514', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794687', '65', '447', '2011', '493', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794688', '5', '443', '2013', '514', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794693', '20', '447', '2011', '504', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794695', '4429', '443', '2013', '511', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794700', '51', '447', '2011', '511', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794701', '8', '443', '2013', '516', '509', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794711', '13', '447', '2011', '519', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794715', '4307', '443', '2013', '512', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794720', '1', '447', '2011', '507', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794723', '498', '443', '2013', '515', '509', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794728', '65', '443', '2013', '511', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794731', '63', '447', '2011', '507', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794736', '10', '443', '2013', '523', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794739', '10', '447', '2011', '513', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794743', '1451', '443', '2013', '513', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794754', '12', '443', '2013', '511', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794760', '69', '443', '2013', '510', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794764', '13', '443', '2013', '524', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794766', '435', '443', '2013', '514', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794770', '1', '443', '2013', '512', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794773', '159', '443', '2013', '515', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794776', '52', '447', '2012', '541', '534', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794778', '10', '447', '2012', '546', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794780', '13', '447', '2012', '546', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794782', '428', '447', '2012', '534', '532', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794784', '56', '447', '2012', '553', '540', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794787', '63', '447', '2012', '548', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794791', '86', '447', '2012', '535', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794795', '3', '447', '2012', '551', '545', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794801', '308', '447', '2012', '537', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794805', '8', '447', '2012', '549', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794811', '23', '447', '2012', '550', '540', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794818', '410', '447', '2012', '537', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794827', '24', '447', '2012', '538', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794833', '5', '447', '2012', '546', '536', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794839', '1', '447', '2012', '541', '536', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794845', '17', '447', '2012', '574', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('794850', '66', '447', '2012', '565', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794854', '58', '447', '2012', '541', '534', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794856', '74', '447', '2012', '542', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794859', '12', '447', '2012', '539', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794864', '20', '447', '2012', '552', '536', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794866', '48', '447', '2012', '544', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794869', '78', '447', '2012', '549', '534', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794955', '5', '447', '2013', '502', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794962', '4341', '447', '2013', '497', '495', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794973', '61', '447', '2013', '510', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794980', '8', '447', '2013', '511', '503', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794990', '538', '447', '2013', '503', '497', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('794999', '1451', '447', '2013', '507', '497', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('795006', '86', '447', '2013', '502', '497', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('795014', '10', '447', '2013', '513', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('795020', '56', '447', '2013', '507', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('795026', '12', '447', '2013', '503', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('795034', '4429', '447', '2013', '503', '497', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('795038', '1', '447', '2013', '510', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('795044', '58', '447', '2013', '506', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('795049', '13', '447', '2013', '542', '542', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('795052', '66', '447', '2013', '510', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('795062', '4236', '447', '2013', '508', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('795069', '435', '447', '2013', '496', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('795082', '498', '447', '2013', '506', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('795544', '56', '455', '2011', '518', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795555', '541', '455', '2011', '520', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795569', '86', '455', '2011', '523', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795577', '27', '455', '2011', '582', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('795581', '1248', '455', '2011', '583', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('795584', '71', '455', '2011', '537', '528', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795587', '155', '455', '2011', '568', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('795590', '66', '455', '2011', '566', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('795595', '93', '455', '2011', '522', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795597', '187', '455', '2011', '569', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('795604', '56', '455', '2012', '558', '547', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795607', '27', '455', '2012', '594', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('795610', '187', '455', '2012', '581', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('795613', '155', '455', '2012', '584', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('795616', '86', '455', '2012', '583', '550', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795619', '93', '455', '2012', '536', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795622', '66', '455', '2012', '614', '609', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('795624', '71', '455', '2012', '539', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795631', '256', '455', '2013', '560', '559', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('795634', '4509', '455', '2013', '568', '568', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('795636', '86', '455', '2013', '513', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795640', '4232', '455', '2013', '516', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795643', '66', '455', '2013', '576', '563', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('795645', '28', '455', '2013', '572', '565', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('795647', '93', '455', '2013', '509', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795649', '56', '455', '2013', '509', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795651', '400', '455', '2013', '517', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795862', '23', '443', '2010', '500', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795868', '34', '443', '2010', '507', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795871', '10', '443', '2010', '500', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795878', '175', '443', '2010', '482', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795882', '129', '443', '2010', '491', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795886', '38', '443', '2010', '485', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795892', '37', '443', '2010', '491', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795897', '310', '443', '2010', '493', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795901', '79', '443', '2010', '484', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795906', '101', '443', '2010', '500', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795917', '71', '443', '2010', '485', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795924', '91', '443', '2010', '491', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795932', '123', '443', '2010', '481', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795943', '95', '443', '2010', '484', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795949', '147', '447', '2010', '487', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795951', '186', '443', '2010', '484', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795956', '40', '443', '2010', '494', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795958', '78', '447', '2010', '513', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795961', '97', '447', '2010', '494', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795964', '150', '443', '2010', '492', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795967', '101', '447', '2010', '483', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795973', '30', '447', '2010', '492', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795975', '141', '443', '2010', '494', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795981', '161', '447', '2010', '497', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795982', '5', '443', '2010', '493', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795988', '51', '443', '2010', '488', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795989', '129', '447', '2010', '494', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795994', '17', '447', '2010', '488', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795995', '89', '443', '2010', '500', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795998', '25', '447', '2010', '484', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('795999', '12', '443', '2010', '492', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796003', '3', '443', '2010', '492', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796004', '150', '447', '2010', '491', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796008', '97', '443', '2010', '494', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796009', '79', '447', '2010', '516', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796014', '8', '447', '2010', '500', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796018', '12', '447', '2010', '474', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796022', '51', '447', '2010', '481', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796026', '105', '443', '2010', '497', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796031', '8', '443', '2010', '485', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796035', '88', '447', '2010', '478', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796041', '184', '447', '2010', '483', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796042', '24', '443', '2010', '485', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796047', '428', '443', '2010', '482', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796049', '24', '447', '2010', '477', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796054', '146', '447', '2010', '483', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796055', '161', '443', '2010', '500', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796062', '66', '447', '2010', '474', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796065', '140', '447', '2010', '490', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796069', '5', '447', '2010', '471', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796073', '71', '447', '2010', '478', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796077', '87', '447', '2010', '481', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796082', '109', '447', '2010', '489', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796083', '34', '443', '2011', '519', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796091', '56', '447', '2010', '469', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796092', '38', '443', '2011', '502', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796096', '34', '447', '2010', '487', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796098', '161', '443', '2011', '498', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796101', '97', '443', '2011', '507', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796105', '119', '447', '2010', '481', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796108', '5', '443', '2011', '504', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796109', '175', '447', '2010', '470', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796115', '99', '447', '2010', '484', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796118', '23', '443', '2011', '498', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796119', '48', '447', '2010', '485', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796124', '40', '443', '2011', '498', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796129', '95', '443', '2011', '511', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796133', '27', '447', '2010', '491', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796136', '91', '443', '2011', '492', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796138', '38', '447', '2010', '487', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796149', '10', '447', '2010', '501', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796152', '105', '443', '2011', '498', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796156', '23', '447', '2010', '483', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796163', '129', '443', '2011', '509', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796164', '105', '447', '2010', '482', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796170', '310', '443', '2011', '502', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796175', '113', '447', '2010', '479', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796179', '86', '447', '2010', '473', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796181', '3', '443', '2011', '506', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796191', '10', '443', '2011', '521', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796199', '186', '443', '2011', '491', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796208', '16', '447', '2011', '484', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796209', '123', '443', '2011', '506', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796214', '143', '447', '2011', '496', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796215', '65', '443', '2011', '487', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796216', '205', '447', '2011', '493', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796218', '37', '443', '2011', '498', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796224', '131', '447', '2011', '488', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796225', '150', '443', '2011', '515', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796233', '12', '443', '2011', '511', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796235', '157', '447', '2011', '562', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796238', '10', '473', '2011', '527', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('796240', '3', '447', '2011', '498', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796244', '101', '443', '2011', '511', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796246', '8', '447', '2011', '500', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796247', '175', '443', '2011', '492', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796248', '23', '473', '2011', '525', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('796256', '428', '447', '2011', '482', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796257', '24', '443', '2011', '505', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796258', '120', '473', '2011', '526', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('796262', '8', '473', '2011', '523', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('796263', '71', '443', '2011', '495', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796264', '48', '447', '2011', '496', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796269', '101', '447', '2011', '486', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796270', '141', '443', '2011', '508', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796275', '148', '473', '2011', '525', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('796276', '428', '443', '2011', '516', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796278', '34', '447', '2011', '491', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796280', '8', '443', '2011', '503', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796281', '25', '447', '2011', '493', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796282', '30', '447', '2011', '499', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796283', '66', '447', '2011', '486', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796284', '79', '447', '2011', '491', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796285', '119', '447', '2011', '509', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796286', '109', '447', '2011', '496', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796287', '129', '447', '2011', '497', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796288', '71', '447', '2011', '511', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796289', '146', '447', '2011', '497', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796290', '24', '447', '2011', '499', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796291', '52', '447', '2011', '489', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796292', '150', '447', '2011', '500', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796293', '87', '447', '2011', '484', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796294', '27', '447', '2011', '498', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796295', '86', '447', '2011', '482', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796296', '78', '447', '2011', '497', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796297', '184', '447', '2011', '488', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796298', '97', '447', '2011', '508', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796299', '20', '447', '2011', '485', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796300', '10', '447', '2011', '499', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796301', '140', '447', '2011', '508', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796302', '56', '447', '2011', '507', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796303', '147', '447', '2011', '516', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796304', '113', '447', '2011', '501', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796305', '38', '447', '2011', '496', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796306', '88', '447', '2011', '494', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796307', '105', '447', '2011', '492', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796308', '23', '447', '2011', '493', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796309', '17', '447', '2011', '497', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796310', '5', '447', '2011', '492', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796311', '65', '447', '2011', '479', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796312', '161', '447', '2011', '501', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796313', '99', '447', '2011', '491', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796330', '105', '447', '2012', '512', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796338', '205', '447', '2012', '499', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796341', '86', '447', '2012', '507', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796344', '10', '447', '2012', '532', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796347', '79', '447', '2012', '498', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796350', '140', '447', '2012', '513', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796355', '184', '447', '2012', '506', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796358', '119', '447', '2012', '505', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796362', '52', '447', '2012', '502', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796365', '428', '447', '2012', '493', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796368', '147', '447', '2012', '526', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796370', '109', '447', '2012', '504', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796373', '113', '447', '2012', '533', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796377', '143', '447', '2012', '518', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796379', '71', '447', '2012', '499', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796382', '38', '447', '2012', '511', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796385', '63', '447', '2012', '507', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796387', '88', '447', '2012', '506', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796389', '3', '447', '2012', '519', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796392', '30', '447', '2012', '511', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796394', '16', '447', '2012', '497', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796397', '146', '447', '2012', '531', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796400', '56', '447', '2012', '497', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796402', '5', '447', '2012', '509', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796404', '8', '447', '2012', '511', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796405', '97', '447', '2012', '534', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796407', '101', '447', '2012', '502', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796409', '99', '447', '2012', '512', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796411', '23', '447', '2012', '526', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796412', '34', '447', '2012', '499', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796413', '161', '447', '2012', '510', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796414', '150', '447', '2012', '516', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796415', '131', '447', '2012', '501', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796416', '410', '447', '2012', '504', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796417', '17', '447', '2012', '550', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('796419', '20', '447', '2012', '518', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796421', '66', '447', '2012', '501', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796423', '12', '447', '2012', '494', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796427', '24', '447', '2012', '506', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796430', '129', '447', '2012', '574', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('796432', '157', '447', '2012', '536', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796434', '87', '447', '2012', '509', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796435', '78', '447', '2012', '507', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796437', '48', '447', '2012', '509', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796438', '27', '447', '2012', '525', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796440', '25', '447', '2012', '550', '550', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('796448', '56', '447', '2013', '474', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796449', '105', '447', '2013', '488', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796450', '4236', '447', '2013', '466', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796451', '129', '447', '2013', '482', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796453', '351', '447', '2013', '475', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796455', '1451', '447', '2013', '480', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796457', '28', '447', '2013', '492', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796459', '113', '447', '2013', '489', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796461', '27', '447', '2013', '490', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796463', '5', '447', '2013', '471', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796467', '61', '447', '2013', '469', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796469', '498', '447', '2013', '467', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796470', '4429', '447', '2013', '472', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796471', '149', '447', '2013', '484', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796473', '97', '447', '2013', '483', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796476', '206', '447', '2013', '476', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796479', '101', '447', '2013', '470', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796482', '233', '447', '2013', '487', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796484', '34', '447', '2013', '475', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796485', '157', '447', '2013', '473', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796487', '86', '447', '2013', '478', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796489', '10', '447', '2013', '484', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796491', '454', '447', '2013', '477', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796493', '140', '447', '2013', '476', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796495', '85', '447', '2013', '482', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796496', '88', '447', '2013', '487', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796497', '163', '447', '2013', '485', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796498', '12', '447', '2013', '479', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796499', '538', '447', '2013', '478', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796500', '932', '447', '2013', '482', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796501', '237', '447', '2013', '481', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796502', '238', '447', '2013', '487', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796503', '156', '447', '2013', '480', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796504', '150', '447', '2013', '478', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796505', '8', '447', '2013', '478', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796506', '66', '447', '2013', '473', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796507', '119', '447', '2013', '481', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796675', '10', '443', '2012', '539', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796678', '8', '443', '2012', '539', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796684', '101', '443', '2012', '517', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796690', '8', '473', '2012', '558', '558', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('796693', '105', '443', '2012', '527', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796694', '120', '473', '2012', '563', '563', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('796701', '23', '473', '2012', '568', '566', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('796704', '428', '443', '2012', '520', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796710', '10', '473', '2012', '567', '565', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('796715', '65', '443', '2012', '507', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796723', '23', '443', '2012', '526', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796726', '61', '473', '2012', '561', '561', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('796732', '91', '443', '2012', '524', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796738', '175', '443', '2012', '509', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796743', '5', '443', '2012', '525', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796750', '61', '473', '2013', '525', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('796753', '129', '443', '2012', '537', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796758', '12', '443', '2012', '510', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796759', '8', '473', '2013', '528', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('796765', '71', '443', '2012', '513', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796766', '10', '473', '2013', '530', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('796775', '150', '443', '2012', '537', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796782', '37', '443', '2012', '512', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796785', '3', '443', '2012', '533', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796791', '141', '443', '2012', '526', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796797', '161', '443', '2012', '522', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796803', '24', '443', '2012', '523', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796807', '186', '443', '2012', '505', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796814', '317', '443', '2012', '510', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796818', '310', '443', '2012', '524', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796823', '34', '443', '2012', '522', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796833', '147', '443', '2012', '513', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796840', '48', '443', '2012', '522', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796842', '123', '443', '2012', '515', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796846', '95', '443', '2012', '513', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796848', '69', '443', '2012', '514', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796851', '40', '443', '2012', '511', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796853', '38', '443', '2012', '518', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796856', '97', '443', '2012', '533', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796885', '932', '443', '2013', '482', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796892', '29', '443', '2013', '493', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796900', '5', '443', '2013', '488', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796904', '310', '443', '2013', '483', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796911', '91', '443', '2013', '484', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796920', '334', '443', '2013', '481', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796925', '141', '443', '2013', '490', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796931', '175', '443', '2013', '483', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796936', '65', '443', '2013', '479', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796941', '105', '443', '2013', '503', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796949', '69', '443', '2013', '480', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796955', '498', '443', '2013', '481', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796963', '101', '443', '2013', '487', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796971', '95', '443', '2013', '483', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796976', '40', '443', '2013', '486', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796987', '2448', '443', '2013', '478', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796992', '86', '443', '2013', '483', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('796996', '55', '443', '2013', '485', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797004', '317', '443', '2013', '495', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797009', '161', '443', '2013', '491', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797014', '144', '443', '2013', '479', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797017', '233', '443', '2013', '499', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797023', '105', '443', '2013', '519', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('797032', '8', '443', '2013', '485', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797035', '97', '443', '2013', '510', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797040', '12', '443', '2013', '483', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797047', '38', '473', '2011', '519', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797049', '159', '443', '2013', '487', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797054', '143', '473', '2011', '527', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797058', '150', '443', '2013', '495', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797065', '113', '473', '2011', '531', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797069', '10', '443', '2013', '506', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797077', '107', '473', '2011', '519', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797079', '34', '443', '2013', '501', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797088', '147', '473', '2011', '524', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797089', '85', '443', '2013', '497', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797094', '4429', '443', '2013', '486', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797095', '211', '473', '2011', '519', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797097', '8', '473', '2011', '523', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797101', '205', '473', '2011', '519', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797106', '151', '473', '2011', '521', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797111', '37', '473', '2011', '524', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797114', '36', '473', '2011', '520', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797117', '68', '473', '2011', '520', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797178', '36', '473', '2012', '541', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797183', '37', '473', '2012', '547', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797190', '143', '473', '2012', '538', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797193', '38', '473', '2012', '542', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797197', '205', '473', '2012', '535', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797205', '8', '473', '2012', '536', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797209', '113', '473', '2012', '546', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797216', '132', '473', '2012', '536', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797222', '211', '473', '2012', '535', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797227', '151', '473', '2012', '541', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797231', '68', '473', '2012', '534', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797234', '147', '473', '2012', '555', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797257', '174', '473', '2013', '510', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797263', '343', '473', '2013', '506', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797266', '147', '473', '2013', '506', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797269', '233', '473', '2013', '505', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797271', '237', '473', '2013', '507', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797274', '8', '473', '2013', '507', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797280', '113', '473', '2013', '517', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797285', '141', '473', '2013', '506', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797292', '310', '473', '2013', '511', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797296', '385', '473', '2013', '515', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797301', '129', '473', '2013', '510', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797308', '105', '473', '2013', '508', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('797706', '10', '503', '2010', '506', '505', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797712', '8', '503', '2010', '514', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797716', '61', '503', '2010', '512', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797720', '78', '503', '2010', '501', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797722', '13', '503', '2010', '501', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797726', '69', '503', '2010', '509', '504', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797742', '8', '503', '2011', '525', '523', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797744', '10', '503', '2011', '529', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797746', '69', '503', '2011', '520', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797748', '61', '503', '2011', '522', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797751', '13', '503', '2011', '522', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797754', '78', '503', '2011', '521', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797759', '3', '503', '2011', '529', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797773', '10', '503', '2012', '568', '565', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797777', '13', '503', '2012', '561', '559', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797781', '8', '503', '2012', '565', '564', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797783', '69', '503', '2012', '562', '559', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797785', '61', '503', '2012', '565', '563', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797788', '3', '503', '2012', '563', '559', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797789', '78', '503', '2012', '560', '556', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797805', '8', '503', '2013', '526', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797807', '61', '503', '2013', '527', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797810', '43', '506', '2010', '509', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797811', '69', '503', '2013', '523', '520', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797815', '1', '506', '2010', '515', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797817', '10', '503', '2013', '520', '519', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797820', '23', '506', '2010', '515', '513', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797822', '13', '503', '2013', '520', '519', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797824', '24', '506', '2010', '515', '513', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797826', '78', '506', '2010', '514', '514', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797846', '78', '506', '2011', '525', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797851', '1', '506', '2011', '524', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797858', '24', '506', '2011', '522', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797861', '23', '506', '2011', '525', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797864', '43', '506', '2011', '523', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797876', '78', '506', '2012', '560', '558', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797883', '1', '506', '2012', '561', '560', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797890', '13', '506', '2012', '562', '559', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797898', '43', '506', '2012', '561', '560', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797926', '13', '506', '2013', '523', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('797929', '1', '506', '2013', '527', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('798059', '109', '503', '2010', '509', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798064', '38', '503', '2010', '507', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798075', '10', '503', '2010', '508', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798084', '37', '503', '2010', '509', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798091', '123', '503', '2010', '508', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798097', '146', '503', '2010', '508', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798108', '99', '503', '2010', '511', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798115', '139', '517', '2010', '549', '537', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798117', '8', '503', '2010', '509', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798123', '2677', '517', '2010', '534', '527', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798125', '147', '503', '2010', '510', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798130', '23', '517', '2010', '532', '531', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798132', '131', '503', '2010', '510', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798140', '129', '503', '2010', '514', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798148', '3', '503', '2010', '512', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798156', '120', '503', '2010', '511', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798157', '139', '517', '2011', '552', '550', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798165', '23', '517', '2011', '564', '563', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798171', '2677', '517', '2011', '545', '544', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798184', '139', '503', '2011', '523', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798190', '120', '503', '2011', '525', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798191', '139', '517', '2012', '582', '579', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798199', '2677', '517', '2012', '586', '581', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798200', '99', '503', '2011', '521', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798206', '38', '503', '2011', '526', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798207', '23', '517', '2012', '593', '585', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798211', '146', '503', '2011', '525', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798214', '147', '503', '2011', '526', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798219', '109', '503', '2011', '525', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798223', '129', '503', '2011', '538', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798226', '10', '503', '2011', '531', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798230', '37', '503', '2011', '528', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798232', '4513', '517', '2013', '555', '549', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798236', '123', '503', '2011', '524', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798241', '16', '503', '2011', '521', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798248', '8', '503', '2011', '538', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798253', '205', '503', '2011', '520', '518', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798257', '131', '503', '2011', '520', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798283', '129', '503', '2012', '544', '543', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798285', '139', '503', '2012', '537', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798287', '205', '503', '2012', '541', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798292', '38', '503', '2012', '546', '541', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798298', '146', '503', '2012', '541', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798305', '8', '503', '2012', '540', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798309', '10', '503', '2012', '543', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798314', '120', '503', '2012', '539', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798321', '37', '503', '2012', '541', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798326', '109', '503', '2012', '541', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798331', '123', '503', '2012', '538', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798337', '99', '503', '2012', '537', '536', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798345', '131', '503', '2012', '540', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798351', '147', '503', '2012', '545', '543', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798360', '16', '503', '2012', '540', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798371', '2677', '517', '2010', '520', '519', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798372', '309', '506', '2010', '513', '491', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('798375', '237', '503', '2013', '509', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798376', '85', '506', '2010', '504', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798377', '23', '517', '2010', '549', '546', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798380', '105', '503', '2013', '545', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798381', '129', '506', '2010', '507', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798382', '99', '517', '2010', '523', '518', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798384', '8', '503', '2013', '514', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798385', '3751', '517', '2010', '523', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798386', '131', '506', '2010', '504', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798387', '233', '503', '2013', '510', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798389', '495', '506', '2010', '526', '509', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('798390', '85', '517', '2010', '549', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798391', '221', '503', '2013', '514', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798393', '323', '506', '2010', '507', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798394', '139', '517', '2010', '543', '533', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798395', '156', '503', '2013', '519', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798397', '389', '506', '2010', '516', '491', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('798398', '85', '503', '2013', '515', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798400', '310', '503', '2013', '517', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798401', '395', '506', '2010', '498', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798402', '55', '503', '2013', '511', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798403', '38', '506', '2010', '502', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798405', '10', '503', '2013', '510', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798406', '119', '506', '2010', '498', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798407', '437', '506', '2010', '502', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798408', '932', '503', '2013', '510', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798410', '97', '506', '2010', '493', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798411', '206', '503', '2013', '508', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798413', '3774', '503', '2013', '507', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798414', '120', '506', '2010', '496', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798417', '2677', '517', '2011', '545', '543', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798421', '71', '506', '2010', '507', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798426', '23', '517', '2011', '577', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798429', '3751', '517', '2011', '554', '551', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798432', '139', '517', '2011', '551', '548', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798441', '120', '506', '2011', '515', '514', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798443', '395', '506', '2011', '517', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798445', '323', '506', '2011', '519', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798449', '437', '506', '2011', '518', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798453', '206', '506', '2011', '529', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798455', '3752', '517', '2012', '576', '564', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798458', '29', '506', '2011', '520', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798459', '139', '517', '2012', '579', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798465', '3751', '517', '2012', '571', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798469', '2677', '517', '2012', '563', '562', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798472', '23', '517', '2012', '609', '599', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798478', '147', '506', '2012', '540', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798480', '342', '506', '2012', '575', '558', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798484', '3822', '517', '2013', '551', '534', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798485', '118', '506', '2012', '529', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798489', '4400', '517', '2013', '529', '529', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798490', '95', '506', '2012', '528', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798494', '37', '506', '2012', '535', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798495', '4514', '517', '2013', '535', '535', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798498', '71', '506', '2012', '531', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798501', '4401', '517', '2013', '549', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798502', '132', '506', '2012', '539', '534', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798505', '323', '506', '2012', '533', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798507', '437', '506', '2012', '545', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798510', '99', '506', '2012', '532', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798512', '101', '506', '2012', '529', '529', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798515', '23', '506', '2012', '528', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798517', '34', '506', '2012', '531', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798518', '38', '506', '2012', '531', '530', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798519', '129', '506', '2012', '535', '533', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798524', '34', '506', '2013', '500', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798527', '118', '506', '2013', '502', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798529', '86', '506', '2013', '504', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798531', '233', '506', '2013', '503', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798533', '4216', '506', '2013', '503', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798535', '4397', '506', '2013', '536', '523', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('798538', '4231', '506', '2013', '511', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798543', '4225', '506', '2013', '508', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798546', '4229', '506', '2013', '512', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798549', '4202', '506', '2013', '510', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798552', '4266', '506', '2013', '506', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798555', '4486', '506', '2013', '504', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798558', '206', '506', '2013', '503', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798560', '4402', '506', '2013', '512', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798562', '269', '506', '2013', '503', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('798606', '63', '523', '2010', '557', '556', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798611', '12', '523', '2010', '521', '521', '1', '5', '13');
INSERT INTO `major_recruit` VALUES ('798621', '10', '523', '2010', '559', '559', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798627', '159', '523', '2010', '558', '558', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798633', '8', '523', '2010', '564', '561', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798642', '5', '523', '2011', '580', '580', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798648', '21', '523', '2011', '571', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798657', '339', '523', '2011', '572', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798663', '22', '523', '2011', '574', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798674', '78', '523', '2011', '568', '568', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798684', '58', '523', '2011', '568', '568', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798690', '514', '523', '2011', '578', '578', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798699', '13', '523', '2011', '568', '568', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798711', '293', '523', '2012', '601', '601', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798724', '339', '523', '2012', '614', '614', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798731', '21', '523', '2012', '622', '622', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798742', '270', '523', '2012', '601', '601', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798751', '78', '523', '2012', '600', '600', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798758', '5', '523', '2012', '600', '600', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798769', '374', '523', '2012', '608', '608', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798781', '58', '523', '2012', '604', '604', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798793', '514', '523', '2012', '612', '612', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798803', '61', '523', '2012', '613', '613', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798948', '339', '523', '2013', '567', '567', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798959', '4194', '523', '2013', '578', '578', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798970', '514', '523', '2013', '572', '572', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798982', '10', '523', '2013', '571', '571', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('798993', '270', '523', '2013', '570', '570', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('799009', '13', '523', '2013', '568', '568', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('799013', '357', '541', '2011', '471', '448', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('799025', '4416', '541', '2011', '456', '436', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('799028', '21', '523', '2013', '568', '568', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('799042', '58', '523', '2013', '566', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('799058', '5', '523', '2013', '566', '566', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('799073', '3751', '523', '2013', '565', '565', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('799083', '293', '523', '2013', '581', '581', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('799096', '61', '523', '2013', '581', '581', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('799098', '357', '541', '2011', '460', '429', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('799110', '12', '523', '2013', '574', '574', '1', '1', '13');
INSERT INTO `major_recruit` VALUES ('799113', '4416', '541', '2011', '446', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('799205', '56', '544', '2010', '491', '481', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799207', '66', '539', '2010', '515', '503', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799214', '52', '544', '2010', '494', '483', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799216', '86', '539', '2010', '509', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799226', '60', '539', '2010', '514', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799228', '10', '544', '2010', '509', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799229', '23', '523', '2010', '560', '560', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799233', '52', '539', '2010', '503', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799237', '86', '544', '2010', '504', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799238', '10', '539', '2010', '500', '497', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799244', '44', '523', '2010', '517', '517', '2', '5', '13');
INSERT INTO `major_recruit` VALUES ('799246', '71', '539', '2010', '505', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799250', '450', '523', '2010', '552', '552', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799255', '78', '539', '2011', '507', '504', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799260', '52', '544', '2011', '501', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799261', '10', '523', '2010', '579', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799265', '66', '539', '2011', '533', '512', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799267', '10', '544', '2011', '510', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799272', '21', '523', '2010', '554', '553', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799274', '52', '539', '2011', '516', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799275', '56', '544', '2011', '510', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799282', '86', '544', '2011', '502', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799283', '60', '539', '2011', '528', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799284', '24', '523', '2010', '568', '566', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799291', '10', '539', '2011', '507', '504', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799294', '5', '544', '2011', '506', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799298', '22', '523', '2011', '586', '586', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799300', '71', '539', '2011', '524', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799304', '56', '544', '2012', '543', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799305', '63', '523', '2011', '572', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799311', '86', '539', '2011', '520', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799313', '10', '544', '2012', '552', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799316', '44', '523', '2011', '579', '579', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799320', '5', '544', '2012', '546', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799323', '86', '539', '2012', '564', '545', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799327', '86', '544', '2012', '539', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799332', '450', '523', '2011', '571', '571', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799336', '52', '539', '2012', '557', '546', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799337', '52', '544', '2012', '539', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799339', '514', '523', '2011', '572', '572', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799345', '10', '539', '2012', '552', '545', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799347', '293', '523', '2011', '578', '578', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799349', '86', '544', '2013', '510', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799352', '60', '539', '2012', '562', '546', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799356', '56', '544', '2013', '506', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799358', '8', '523', '2011', '576', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799361', '10', '544', '2013', '499', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799365', '78', '539', '2012', '547', '544', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799367', '24', '523', '2011', '580', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799370', '5', '544', '2013', '494', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799374', '71', '539', '2012', '555', '546', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799379', '10', '523', '2011', '581', '581', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799385', '2007', '539', '2012', '544', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799389', '159', '523', '2011', '580', '580', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799390', '66', '539', '2012', '570', '550', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799402', '86', '539', '2013', '518', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799404', '44', '523', '2012', '602', '602', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799405', '60', '539', '2013', '522', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799412', '270', '523', '2012', '601', '601', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799419', '10', '539', '2013', '519', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799426', '66', '539', '2013', '530', '513', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799427', '12', '523', '2012', '598', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799436', '22', '523', '2012', '611', '611', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799437', '4515', '539', '2013', '516', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799445', '159', '523', '2012', '596', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799456', '450', '523', '2012', '592', '592', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799465', '61', '523', '2012', '604', '604', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799472', '293', '523', '2012', '598', '598', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799485', '23', '523', '2012', '591', '591', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799491', '24', '523', '2012', '594', '594', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799499', '63', '523', '2012', '600', '596', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799505', '514', '523', '2012', '595', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799511', '10', '523', '2012', '595', '595', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799524', '44', '523', '2013', '577', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799531', '58', '523', '2013', '567', '567', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799537', '8', '523', '2013', '570', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799541', '270', '523', '2013', '570', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799553', '1451', '523', '2013', '573', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799561', '293', '523', '2013', '573', '573', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799572', '61', '523', '2013', '575', '575', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799581', '10', '523', '2013', '576', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799591', '159', '523', '2013', '576', '576', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799599', '300', '523', '2013', '570', '570', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799610', '22', '523', '2013', '583', '583', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799618', '12', '523', '2013', '589', '589', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799626', '514', '523', '2013', '577', '577', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('799737', '27', '544', '2010', '527', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799740', '93', '544', '2010', '509', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799747', '179', '544', '2010', '507', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799752', '86', '544', '2010', '511', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799758', '52', '544', '2010', '503', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799762', '71', '544', '2010', '492', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799772', '56', '544', '2010', '508', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799774', '28', '544', '2010', '492', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799780', '160', '544', '2010', '493', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799869', '78', '548', '2010', '504', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799870', '8', '548', '2010', '502', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799871', '10', '548', '2010', '508', '503', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799872', '13', '548', '2010', '501', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799873', '13', '548', '2011', '510', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799874', '10', '548', '2011', '513', '512', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799875', '78', '548', '2011', '510', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799877', '13', '548', '2012', '550', '549', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799880', '8', '548', '2012', '553', '552', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799888', '8', '548', '2013', '519', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799890', '13', '548', '2013', '516', '516', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('799942', '27', '544', '2011', '533', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799947', '71', '544', '2011', '524', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799958', '56', '544', '2011', '518', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799963', '160', '544', '2011', '529', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799970', '93', '544', '2011', '524', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799980', '179', '544', '2011', '521', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799983', '52', '544', '2011', '502', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799987', '28', '544', '2011', '526', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799990', '399', '544', '2011', '521', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('799995', '75', '544', '2011', '510', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800000', '184', '544', '2011', '513', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800005', '88', '544', '2011', '523', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800009', '86', '544', '2011', '505', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800029', '75', '544', '2012', '532', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800042', '56', '544', '2012', '539', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800046', '86', '544', '2012', '523', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800050', '28', '544', '2012', '519', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800054', '93', '544', '2012', '560', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800058', '27', '544', '2012', '560', '526', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800068', '179', '544', '2012', '537', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800070', '399', '544', '2012', '539', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800073', '71', '544', '2012', '528', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800076', '160', '544', '2012', '535', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800078', '52', '544', '2012', '541', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800080', '88', '544', '2012', '526', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800085', '28', '544', '2013', '531', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800087', '88', '544', '2013', '489', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800089', '56', '544', '2013', '490', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800090', '400', '544', '2013', '504', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800093', '454', '544', '2013', '487', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800095', '399', '544', '2013', '514', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800098', '267', '544', '2013', '511', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800100', '86', '544', '2013', '491', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800102', '91', '544', '2013', '491', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800104', '93', '544', '2013', '507', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800106', '160', '544', '2013', '491', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800107', '71', '544', '2013', '493', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800108', '157', '544', '2013', '491', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800109', '23', '560', '2010', '499', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800110', '12', '560', '2010', '499', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800111', '78', '560', '2010', '484', '481', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800112', '52', '560', '2010', '494', '484', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800113', '3', '560', '2010', '504', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800114', '10', '560', '2010', '499', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800115', '5', '560', '2010', '502', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800116', '8', '560', '2010', '504', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800117', '12', '560', '2011', '511', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800118', '8', '560', '2011', '515', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800119', '10', '560', '2011', '511', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800120', '23', '560', '2011', '507', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800121', '3', '560', '2011', '514', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800122', '78', '560', '2011', '501', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800123', '5', '560', '2011', '500', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800124', '10', '560', '2012', '536', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800125', '5', '560', '2012', '539', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800126', '8', '560', '2012', '549', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800127', '12', '560', '2012', '542', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800128', '3', '560', '2012', '558', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800129', '23', '560', '2012', '550', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800130', '52', '560', '2012', '527', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800131', '78', '560', '2012', '555', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800132', '12', '560', '2013', '530', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800133', '5', '560', '2013', '497', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800134', '8', '560', '2013', '496', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800135', '10', '560', '2013', '531', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800294', '8', '566', '2010', '503', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800301', '13', '566', '2010', '503', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800314', '10', '566', '2010', '508', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800336', '10', '566', '2011', '525', '518', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800338', '8', '566', '2011', '518', '516', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800354', '266', '539', '2010', '495', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800356', '10', '566', '2012', '562', '561', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800360', '8', '566', '2012', '564', '561', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800365', '40', '539', '2010', '494', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800371', '91', '539', '2010', '500', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800376', '25', '548', '2010', '485', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800379', '56', '539', '2010', '496', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800382', '8', '566', '2013', '526', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800383', '438', '539', '2010', '511', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800386', '10', '566', '2013', '522', '521', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('800388', '88', '539', '2010', '494', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800392', '155', '548', '2010', '487', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800396', '161', '539', '2010', '495', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800402', '52', '539', '2010', '491', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800406', '38', '548', '2010', '489', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800410', '21', '571', '2013', '485', '461', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('800412', '147', '548', '2010', '495', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800418', '119', '539', '2010', '494', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800421', '8', '571', '2013', '474', '474', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('800426', '91', '548', '2010', '489', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800427', '38', '539', '2010', '488', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800429', '354', '571', '2013', '469', '469', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('800433', '129', '548', '2010', '500', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800440', '60', '539', '2010', '501', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800444', '113', '548', '2010', '489', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800449', '66', '539', '2010', '514', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800456', '72', '539', '2010', '518', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800466', '86', '539', '2010', '494', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800467', '155', '548', '2011', '510', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800473', '71', '539', '2010', '507', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800477', '75', '539', '2010', '496', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800478', '147', '548', '2011', '509', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800488', '129', '548', '2011', '514', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800493', '113', '548', '2011', '503', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800498', '38', '548', '2011', '504', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800513', '56', '539', '2011', '512', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800517', '438', '539', '2011', '517', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800523', '150', '548', '2012', '567', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800526', '66', '539', '2011', '527', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800529', '99', '548', '2012', '509', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800533', '38', '539', '2011', '511', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800534', '27', '548', '2012', '527', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800542', '78', '539', '2011', '499', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800546', '141', '548', '2012', '520', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800551', '88', '539', '2011', '508', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800559', '75', '539', '2011', '517', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800563', '737', '539', '2011', '520', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800566', '91', '539', '2011', '526', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800571', '266', '539', '2011', '510', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800574', '72', '539', '2011', '534', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800579', '161', '539', '2011', '511', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800584', '86', '539', '2011', '510', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800587', '60', '539', '2011', '523', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800590', '71', '539', '2011', '524', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800593', '1244', '539', '2011', '523', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800596', '40', '539', '2011', '508', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800599', '52', '539', '2011', '531', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800603', '1244', '539', '2012', '524', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800605', '52', '539', '2012', '533', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800609', '91', '539', '2012', '535', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800610', '37', '560', '2010', '487', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800612', '266', '539', '2012', '541', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800613', '149', '560', '2010', '495', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800615', '88', '539', '2012', '551', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800616', '2', '560', '2010', '492', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800618', '86', '539', '2012', '525', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800619', '40', '539', '2012', '526', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800621', '120', '560', '2010', '484', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800622', '438', '539', '2012', '535', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800623', '23', '560', '2010', '490', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800624', '60', '539', '2012', '535', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800626', '79', '560', '2010', '489', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800627', '161', '539', '2012', '525', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800629', '156', '560', '2010', '519', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800630', '2007', '539', '2012', '534', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800632', '38', '560', '2010', '483', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800633', '56', '539', '2012', '527', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800635', '109', '560', '2010', '482', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800636', '75', '539', '2012', '535', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800638', '317', '560', '2010', '505', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800640', '72', '539', '2012', '546', '525', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800642', '186', '560', '2010', '502', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800643', '38', '539', '2012', '539', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800645', '71', '539', '2012', '543', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800646', '89', '560', '2010', '484', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800648', '123', '560', '2010', '475', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800649', '119', '539', '2012', '525', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800650', '66', '539', '2012', '554', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800651', '8', '560', '2010', '474', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800652', '78', '539', '2012', '541', '507', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800653', '147', '560', '2010', '496', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800654', '127', '560', '2010', '483', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800655', '36', '560', '2010', '477', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800656', '507', '539', '2013', '488', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800657', '160', '539', '2013', '527', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800658', '3', '560', '2010', '494', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800659', '56', '539', '2013', '493', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800660', '75', '539', '2013', '493', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800661', '78', '560', '2010', '478', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800662', '91', '539', '2013', '507', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800663', '85', '560', '2010', '473', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800664', '86', '539', '2013', '518', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800665', '10', '560', '2010', '486', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800666', '40', '539', '2013', '491', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800667', '88', '539', '2013', '507', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800668', '85', '560', '2011', '491', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800669', '186', '560', '2011', '493', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800670', '71', '539', '2013', '515', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800671', '101', '560', '2011', '485', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800672', '438', '539', '2013', '492', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800673', '4200', '539', '2013', '492', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800674', '8', '560', '2011', '497', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800675', '60', '539', '2013', '505', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800676', '156', '560', '2011', '533', '532', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('800677', '2007', '539', '2013', '480', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800678', '149', '560', '2011', '490', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800679', '233', '539', '2013', '510', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800680', '79', '560', '2011', '480', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800681', '2', '560', '2011', '490', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800682', '66', '539', '2013', '521', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800683', '5', '560', '2011', '488', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800684', '78', '560', '2011', '484', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800685', '123', '560', '2011', '490', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800686', '37', '560', '2011', '485', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800687', '278', '560', '2011', '485', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800688', '36', '560', '2011', '505', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800689', '127', '560', '2011', '498', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800690', '317', '560', '2011', '512', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800691', '109', '560', '2011', '508', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800692', '89', '560', '2011', '502', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800693', '23', '560', '2011', '497', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800694', '38', '560', '2011', '498', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800695', '10', '560', '2011', '490', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800696', '3', '560', '2011', '516', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800697', '120', '560', '2011', '499', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800698', '8', '560', '2012', '500', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800699', '38', '560', '2012', '504', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800700', '109', '560', '2012', '531', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800701', '149', '560', '2012', '508', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800702', '127', '560', '2012', '513', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800703', '10', '560', '2012', '509', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800704', '123', '560', '2012', '498', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800705', '5', '560', '2012', '506', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800706', '36', '560', '2012', '510', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800707', '37', '560', '2012', '498', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800708', '78', '560', '2012', '502', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800709', '79', '560', '2012', '508', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800712', '85', '560', '2012', '505', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800714', '186', '560', '2012', '502', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800716', '3', '560', '2012', '524', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800718', '101', '560', '2012', '494', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800720', '120', '560', '2012', '517', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800722', '89', '560', '2012', '501', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800724', '317', '560', '2012', '526', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800725', '23', '560', '2012', '521', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800726', '278', '560', '2012', '502', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800727', '2', '560', '2012', '512', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800728', '156', '560', '2012', '566', '555', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('800731', '150', '548', '2013', '494', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800734', '206', '548', '2013', '498', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800736', '10', '560', '2013', '472', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800739', '5', '560', '2013', '472', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800741', '8', '560', '2013', '476', '461', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800742', '4213', '548', '2013', '490', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800746', '144', '560', '2013', '473', '461', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800747', '296', '548', '2013', '506', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800755', '113', '548', '2013', '497', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800756', '233', '560', '2013', '490', '463', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800764', '141', '548', '2013', '480', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800765', '101', '560', '2013', '491', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800775', '278', '560', '2013', '478', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800777', '28', '548', '2013', '499', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800783', '317', '560', '2013', '491', '461', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800787', '85', '560', '2013', '487', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800791', '174', '560', '2013', '474', '461', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800799', '12', '560', '2013', '467', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800800', '85', '548', '2013', '499', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800807', '310', '560', '2013', '524', '522', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('800812', '149', '560', '2013', '466', '459', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800813', '3052', '560', '2013', '494', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800815', '105', '560', '2013', '477', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800820', '55', '560', '2013', '467', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800823', '156', '560', '2013', '477', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800826', '38', '566', '2010', '493', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800832', '13', '566', '2010', '500', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800838', '129', '566', '2010', '498', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800843', '8', '566', '2010', '504', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800845', '150', '566', '2010', '494', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800847', '101', '566', '2010', '498', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800851', '27', '566', '2010', '506', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800857', '10', '566', '2010', '498', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800905', '8', '566', '2011', '534', '527', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800910', '101', '566', '2011', '514', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800915', '79', '566', '2011', '515', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800923', '25', '566', '2011', '520', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800930', '10', '566', '2011', '518', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800938', '129', '566', '2011', '514', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800946', '150', '566', '2011', '515', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800952', '38', '566', '2011', '511', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800971', '25', '566', '2012', '516', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800980', '129', '566', '2012', '546', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800990', '101', '566', '2012', '522', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('800996', '38', '566', '2012', '523', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('801008', '71', '566', '2012', '523', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('801019', '79', '566', '2012', '527', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('801032', '141', '566', '2013', '498', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('801040', '1073', '566', '2013', '481', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('801051', '233', '566', '2013', '484', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('801055', '86', '566', '2013', '506', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('801065', '101', '566', '2013', '498', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('801076', '85', '566', '2013', '500', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('801082', '29', '566', '2013', '481', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('801404', '10', '600', '2013', '501', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801616', '28', '598', '2010', '607', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('801628', '155', '598', '2010', '609', '607', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('801642', '233', '600', '2013', '497', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('801643', '157', '598', '2010', '621', '621', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('801651', '238', '600', '2013', '471', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('801662', '227', '598', '2010', '605', '605', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('801668', '334', '600', '2013', '475', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('801674', '69', '594', '2010', '496', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801678', '95', '600', '2013', '461', '461', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('801679', '27', '598', '2010', '621', '615', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('801685', '538', '594', '2010', '482', '482', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801692', '10', '613', '2010', '490', '490', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('801694', '157', '598', '2011', '637', '637', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('801695', '23', '594', '2010', '498', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801711', '27', '598', '2011', '642', '632', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('801712', '63', '594', '2010', '492', '482', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801713', '23', '613', '2010', '478', '478', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('801727', '17', '594', '2010', '506', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801728', '155', '598', '2011', '628', '625', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('801736', '86', '594', '2010', '492', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801739', '52', '613', '2011', '461', '461', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('801744', '155', '598', '2012', '651', '650', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('801746', '5', '594', '2010', '503', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801750', '89', '613', '2011', '480', '477', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('801754', '279', '594', '2010', '496', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801759', '27', '598', '2012', '662', '653', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('801761', '10', '613', '2011', '476', '476', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('801762', '48', '594', '2010', '490', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801770', '87', '594', '2010', '490', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801773', '23', '613', '2011', '464', '464', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('801779', '28', '598', '2013', '653', '639', '2', '1', '13');
INSERT INTO `major_recruit` VALUES ('801781', '13', '594', '2010', '491', '483', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801787', '78', '613', '2011', '476', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('801791', '74', '594', '2010', '489', '483', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801799', '78', '594', '2010', '495', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801806', '22', '594', '2010', '488', '482', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801810', '3772', '594', '2010', '499', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801814', '10', '594', '2010', '504', '484', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801819', '52', '594', '2010', '483', '480', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801822', '126', '594', '2010', '484', '481', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801823', '8', '594', '2010', '503', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801824', '10', '613', '2013', '476', '476', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('801850', '87', '594', '2011', '512', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801855', '86', '594', '2011', '488', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801863', '78', '594', '2011', '517', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801872', '17', '594', '2011', '512', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801877', '13', '594', '2011', '495', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801886', '5', '594', '2011', '508', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801890', '69', '594', '2011', '495', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801902', '538', '594', '2011', '495', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801910', '74', '594', '2011', '501', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801917', '126', '594', '2011', '509', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801920', '24', '594', '2011', '500', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801926', '279', '594', '2011', '499', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801933', '48', '594', '2011', '498', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801940', '22', '594', '2011', '512', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801945', '10', '594', '2011', '513', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801954', '8', '594', '2011', '514', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801963', '3772', '594', '2011', '504', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801973', '52', '594', '2011', '513', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801981', '63', '594', '2011', '497', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801985', '23', '613', '2011', '451', '451', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('801991', '23', '594', '2011', '509', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('801992', '10', '613', '2011', '471', '471', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('801995', '90', '613', '2011', '461', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('802007', '37', '613', '2011', '467', '459', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('802011', '89', '613', '2011', '448', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('802013', '123', '613', '2011', '457', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('802017', '143', '613', '2011', '480', '466', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('802021', '30', '613', '2011', '449', '449', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('802025', '38', '613', '2011', '462', '452', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('802031', '94', '613', '2011', '472', '466', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('802052', '23', '594', '2012', '548', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802058', '24', '594', '2012', '537', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802061', '126', '594', '2012', '538', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802071', '87', '594', '2012', '534', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802076', '52', '594', '2012', '529', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802081', '279', '594', '2012', '539', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802086', '78', '594', '2012', '529', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802090', '48', '594', '2012', '553', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802093', '8', '594', '2012', '548', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802095', '86', '594', '2012', '545', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802101', '69', '594', '2012', '532', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802104', '63', '594', '2012', '553', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802107', '17', '594', '2012', '541', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802110', '74', '594', '2012', '529', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802113', '10', '594', '2012', '538', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802116', '3772', '594', '2012', '542', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802119', '538', '594', '2012', '543', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802122', '13', '594', '2012', '535', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802124', '5', '594', '2012', '538', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802127', '22', '594', '2012', '538', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802132', '435', '594', '2013', '488', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802134', '17', '594', '2013', '503', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802136', '22', '594', '2013', '499', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802140', '10', '594', '2013', '510', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802143', '159', '594', '2013', '494', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802144', '5', '594', '2013', '528', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802146', '15', '605', '2010', '507', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802147', '13', '594', '2013', '509', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802149', '498', '594', '2013', '499', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802150', '51', '605', '2010', '505', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802152', '8', '594', '2013', '495', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802153', '5', '605', '2010', '503', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802154', '86', '594', '2013', '493', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802155', '1', '605', '2010', '514', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802156', '931', '594', '2013', '490', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802158', '12', '605', '2010', '517', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802159', '69', '594', '2013', '491', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802161', '63', '605', '2010', '503', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802162', '163', '594', '2013', '507', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802164', '4429', '594', '2013', '502', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802166', '13', '605', '2010', '514', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802167', '1451', '594', '2013', '500', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802168', '24', '605', '2010', '504', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802170', '8', '605', '2010', '511', '495', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802173', '58', '605', '2010', '509', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802176', '120', '605', '2010', '507', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802179', '428', '605', '2010', '505', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802183', '69', '605', '2010', '502', '493', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802185', '56', '605', '2010', '507', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802189', '79', '605', '2010', '511', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802190', '23', '605', '2010', '517', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802194', '10', '605', '2010', '514', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802198', '126', '605', '2010', '502', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802200', '74', '605', '2010', '514', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802202', '78', '605', '2010', '510', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802205', '275', '605', '2010', '513', '497', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802209', '65', '605', '2011', '513', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802211', '275', '605', '2011', '524', '504', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802213', '74', '605', '2011', '512', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802214', '126', '605', '2011', '512', '503', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802217', '3', '605', '2011', '520', '509', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802220', '1', '605', '2011', '525', '503', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802223', '63', '605', '2011', '513', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802226', '13', '605', '2011', '526', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802229', '410', '605', '2011', '514', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802231', '56', '605', '2011', '513', '505', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802234', '51', '605', '2011', '511', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802237', '5', '605', '2011', '514', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802240', '120', '605', '2011', '517', '503', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802241', '23', '605', '2011', '514', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802245', '15', '605', '2011', '510', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802248', '78', '605', '2011', '512', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802251', '58', '605', '2011', '510', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802255', '12', '605', '2011', '515', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802257', '428', '605', '2011', '514', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802260', '69', '605', '2011', '519', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802264', '524', '605', '2011', '506', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802265', '24', '605', '2011', '518', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802268', '79', '605', '2011', '510', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802271', '10', '605', '2011', '519', '504', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802275', '8', '605', '2011', '513', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802280', '58', '605', '2012', '551', '539', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802283', '410', '605', '2012', '547', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802286', '428', '605', '2012', '552', '538', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802289', '69', '605', '2012', '547', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802291', '51', '605', '2012', '553', '538', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802293', '74', '605', '2012', '552', '539', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802295', '65', '605', '2012', '544', '536', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802297', '120', '605', '2012', '551', '541', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802299', '126', '605', '2012', '552', '539', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802302', '524', '605', '2012', '559', '538', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802304', '8', '605', '2012', '552', '540', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802306', '24', '605', '2012', '547', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802309', '10', '605', '2012', '561', '545', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802311', '63', '605', '2012', '550', '539', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802313', '15', '605', '2012', '545', '537', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802315', '79', '605', '2012', '549', '540', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802317', '78', '605', '2012', '552', '539', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802319', '3', '605', '2012', '553', '546', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802323', '136', '605', '2012', '548', '538', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802326', '23', '605', '2012', '553', '543', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802330', '5', '605', '2012', '555', '539', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802334', '13', '605', '2012', '565', '540', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802344', '275', '605', '2012', '555', '539', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802353', '56', '605', '2012', '548', '538', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802363', '12', '605', '2012', '552', '538', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802372', '1', '605', '2012', '552', '538', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802384', '56', '605', '2013', '508', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802390', '5', '605', '2013', '514', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802400', '435', '605', '2013', '515', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802408', '1451', '605', '2013', '515', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802420', '1', '605', '2013', '522', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802428', '8', '605', '2013', '513', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802433', '58', '605', '2013', '508', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802441', '4429', '605', '2013', '512', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802451', '10', '605', '2013', '526', '502', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802458', '13', '605', '2013', '530', '503', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802462', '538', '605', '2013', '516', '499', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802470', '51', '605', '2013', '513', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802474', '758', '605', '2013', '504', '497', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802477', '65', '605', '2013', '505', '497', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802483', '69', '605', '2013', '516', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802487', '255', '605', '2013', '524', '503', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802489', '12', '605', '2013', '504', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('802883', '150', '594', '2010', '489', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802886', '205', '594', '2010', '491', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802891', '69', '594', '2010', '474', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802896', '91', '594', '2010', '476', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802901', '146', '594', '2010', '487', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802905', '129', '594', '2010', '490', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802906', '37', '594', '2010', '481', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802909', '279', '594', '2010', '479', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802910', '5', '594', '2010', '484', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802914', '269', '594', '2010', '469', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802917', '40', '594', '2010', '480', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802920', '87', '594', '2010', '478', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802922', '27', '594', '2010', '515', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802924', '184', '594', '2010', '479', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802926', '52', '594', '2010', '482', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802928', '179', '594', '2010', '494', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802929', '10', '594', '2010', '495', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802930', '161', '594', '2010', '494', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802931', '388', '594', '2010', '479', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802932', '158', '594', '2010', '513', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802933', '23', '594', '2010', '482', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802934', '3772', '594', '2010', '494', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802935', '147', '594', '2010', '508', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802936', '97', '594', '2010', '483', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802937', '36', '594', '2010', '474', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802938', '22', '594', '2010', '466', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802939', '86', '594', '2010', '467', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802940', '28', '594', '2010', '465', '463', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802941', '222', '594', '2010', '463', '463', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802942', '126', '594', '2010', '462', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802943', '78', '594', '2010', '472', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802944', '140', '594', '2010', '493', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802945', '8', '594', '2010', '485', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802946', '17', '594', '2010', '484', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802947', '25', '594', '2010', '483', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802948', '48', '594', '2010', '471', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802949', '71', '594', '2010', '473', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802950', '38', '594', '2010', '482', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802951', '34', '594', '2010', '467', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802952', '101', '594', '2010', '468', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802953', '119', '594', '2010', '466', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802954', '40', '594', '2011', '493', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802955', '23', '594', '2011', '517', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802956', '150', '594', '2011', '492', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802957', '146', '594', '2011', '494', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802958', '36', '594', '2011', '487', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802959', '37', '594', '2011', '489', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802960', '222', '594', '2011', '483', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802961', '87', '594', '2011', '485', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802962', '205', '594', '2011', '489', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802963', '27', '594', '2011', '517', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802964', '52', '594', '2011', '484', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802965', '69', '594', '2011', '477', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802966', '8', '594', '2011', '488', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802967', '126', '594', '2011', '483', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802968', '184', '594', '2011', '494', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802969', '186', '594', '2011', '487', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802970', '10', '594', '2011', '498', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802971', '24', '594', '2011', '474', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802972', '3772', '594', '2011', '476', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802973', '28', '594', '2011', '494', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802974', '22', '594', '2011', '502', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802975', '101', '594', '2011', '491', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802976', '97', '594', '2011', '482', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802977', '161', '594', '2011', '488', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802978', '34', '594', '2011', '490', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802979', '48', '594', '2011', '518', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802980', '279', '594', '2011', '497', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802981', '388', '594', '2011', '477', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802982', '5', '594', '2011', '485', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802983', '17', '594', '2011', '491', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802984', '140', '594', '2011', '493', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802985', '119', '594', '2011', '493', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802986', '355', '594', '2011', '476', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802987', '78', '594', '2011', '484', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802988', '71', '594', '2011', '484', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802989', '179', '594', '2011', '506', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802990', '38', '594', '2011', '499', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802991', '129', '594', '2011', '505', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802992', '147', '594', '2011', '503', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802993', '226', '594', '2011', '493', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802994', '86', '594', '2011', '482', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802995', '91', '594', '2011', '487', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802996', '38', '594', '2012', '511', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802997', '23', '594', '2012', '508', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802998', '150', '594', '2012', '512', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('802999', '158', '594', '2012', '512', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803000', '126', '594', '2012', '509', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803001', '36', '594', '2012', '502', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803002', '147', '594', '2012', '510', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803003', '279', '594', '2012', '520', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803004', '129', '594', '2012', '515', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803005', '205', '594', '2012', '495', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803006', '91', '594', '2012', '498', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803007', '186', '594', '2012', '490', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803008', '226', '594', '2012', '503', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803009', '40', '594', '2012', '503', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803010', '355', '594', '2012', '507', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803011', '25', '594', '2012', '509', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803012', '24', '594', '2012', '490', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803013', '222', '594', '2012', '500', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803014', '161', '594', '2012', '497', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803015', '52', '594', '2012', '493', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803016', '146', '594', '2012', '498', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803017', '8', '594', '2012', '524', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803018', '48', '594', '2012', '492', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803019', '34', '594', '2012', '490', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803020', '69', '594', '2012', '486', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803021', '86', '594', '2012', '489', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803022', '17', '594', '2012', '497', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803023', '71', '594', '2012', '504', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803024', '97', '594', '2012', '528', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803025', '87', '594', '2012', '494', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803026', '78', '594', '2012', '509', '496', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803027', '37', '594', '2012', '498', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803028', '10', '594', '2012', '508', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803029', '28', '594', '2012', '498', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803030', '179', '594', '2012', '515', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803031', '5', '594', '2012', '493', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803032', '27', '594', '2012', '513', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803033', '22', '594', '2012', '497', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803034', '3772', '594', '2012', '515', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803035', '269', '594', '2012', '507', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803036', '388', '594', '2012', '491', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803037', '222', '594', '2013', '457', '457', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803038', '157', '594', '2013', '469', '457', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803042', '97', '594', '2013', '482', '459', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803043', '4429', '594', '2013', '462', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803046', '86', '594', '2013', '468', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803048', '161', '594', '2013', '471', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803053', '498', '594', '2013', '459', '459', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803058', '5', '594', '2013', '469', '459', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803064', '931', '594', '2013', '458', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803067', '105', '594', '2013', '464', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803071', '2448', '594', '2013', '466', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803075', '34', '594', '2013', '460', '457', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803079', '150', '594', '2013', '465', '457', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803085', '40', '594', '2013', '461', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803089', '91', '594', '2013', '472', '459', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803093', '174', '594', '2013', '470', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803095', '159', '594', '2013', '482', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803099', '17', '594', '2013', '484', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803101', '87', '594', '2013', '462', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803106', '310', '594', '2013', '495', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803111', '28', '594', '2013', '489', '463', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803117', '355', '594', '2013', '471', '463', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803120', '226', '594', '2013', '473', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803124', '85', '594', '2013', '478', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803128', '22', '594', '2013', '463', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803132', '8', '594', '2013', '468', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803139', '238', '594', '2013', '464', '461', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803146', '69', '594', '2013', '469', '461', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803152', '163', '594', '2013', '463', '461', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803156', '10', '594', '2013', '469', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803159', '794', '594', '2013', '473', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803162', '233', '594', '2013', '465', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803165', '267', '594', '2013', '475', '461', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803197', '52', '646', '2010', '513', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803200', '71', '646', '2010', '515', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803202', '86', '646', '2010', '528', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803204', '60', '646', '2010', '511', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803206', '155', '646', '2010', '510', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803209', '95', '646', '2010', '512', '508', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803212', '38', '646', '2010', '510', '505', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803215', '3823', '646', '2010', '507', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803219', '10', '646', '2010', '514', '504', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803222', '78', '646', '2010', '505', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803226', '78', '646', '2011', '522', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803230', '3823', '646', '2011', '522', '519', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803233', '40', '646', '2011', '528', '522', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803237', '38', '646', '2011', '522', '520', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803239', '25', '646', '2011', '527', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803242', '71', '646', '2011', '539', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803244', '86', '646', '2011', '524', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803271', '86', '646', '2012', '542', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803273', '56', '605', '2010', '490', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803277', '52', '646', '2012', '539', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803282', '92', '605', '2010', '500', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803283', '438', '646', '2012', '543', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803286', '40', '646', '2012', '540', '538', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803288', '8', '605', '2010', '491', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803299', '157', '646', '2012', '547', '544', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803302', '34', '605', '2010', '495', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803306', '3823', '646', '2012', '540', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803308', '15', '605', '2010', '485', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803309', '75', '646', '2012', '549', '548', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803313', '161', '605', '2010', '489', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803317', '155', '646', '2012', '547', '543', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803319', '101', '605', '2010', '493', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803323', '25', '646', '2012', '541', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803324', '23', '605', '2010', '496', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803327', '78', '646', '2012', '543', '542', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803330', '428', '605', '2010', '484', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803334', '279', '605', '2010', '500', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803337', '79', '605', '2010', '484', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803338', '10', '605', '2010', '507', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803342', '78', '605', '2010', '480', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803346', '51', '605', '2010', '507', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803350', '175', '605', '2010', '486', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803353', '69', '605', '2010', '475', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803356', '126', '605', '2010', '487', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803359', '4522', '605', '2010', '477', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803362', '12', '605', '2010', '489', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803365', '97', '605', '2010', '555', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803368', '317', '605', '2010', '481', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803371', '205', '605', '2010', '491', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803372', '123', '605', '2010', '481', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803374', '25', '605', '2010', '498', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803376', '38', '605', '2010', '497', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803378', '150', '605', '2010', '511', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803380', '275', '605', '2010', '483', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803382', '120', '605', '2010', '485', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803384', '37', '605', '2010', '489', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803390', '438', '646', '2013', '513', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803393', '3761', '646', '2013', '514', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803394', '91', '646', '2013', '516', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803395', '400', '646', '2013', '516', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803397', '86', '646', '2013', '518', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803400', '27', '646', '2013', '524', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803404', '29', '646', '2013', '513', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803408', '192', '646', '2013', '512', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803411', '4507', '646', '2013', '515', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803437', '30', '605', '2011', '489', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803438', '8', '605', '2011', '497', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803441', '428', '605', '2011', '508', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803443', '175', '605', '2011', '496', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803445', '101', '605', '2011', '493', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803447', '34', '605', '2011', '506', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803450', '69', '605', '2011', '502', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803452', '25', '605', '2011', '517', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803453', '205', '605', '2011', '495', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803459', '23', '605', '2011', '507', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803462', '92', '605', '2011', '505', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803466', '51', '605', '2011', '498', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803469', '78', '605', '2011', '492', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803473', '123', '605', '2011', '497', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803487', '4522', '605', '2011', '493', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803491', '150', '605', '2011', '523', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803497', '37', '605', '2011', '499', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803505', '97', '605', '2011', '520', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803511', '161', '605', '2011', '503', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803516', '12', '605', '2011', '497', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803520', '317', '605', '2011', '494', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803522', '15', '605', '2011', '493', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803524', '38', '605', '2011', '497', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803526', '65', '605', '2011', '489', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803528', '126', '605', '2011', '496', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803529', '79', '605', '2011', '492', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803531', '120', '605', '2011', '495', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803532', '279', '605', '2011', '499', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803533', '410', '605', '2011', '512', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803534', '10', '605', '2011', '520', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803535', '3', '605', '2011', '502', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803536', '275', '605', '2011', '510', '485', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803537', '56', '605', '2011', '517', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803573', '92', '605', '2012', '513', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803583', '220', '605', '2012', '505', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803593', '12', '605', '2012', '508', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803603', '205', '605', '2012', '512', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803611', '69', '605', '2012', '510', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803622', '175', '605', '2012', '508', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803631', '123', '605', '2012', '509', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803637', '30', '605', '2012', '503', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803645', '428', '605', '2012', '513', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803648', '99', '605', '2012', '510', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803656', '410', '605', '2012', '513', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803663', '23', '605', '2012', '527', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803670', '126', '605', '2012', '511', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803678', '10', '605', '2012', '536', '503', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803691', '120', '605', '2012', '516', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803697', '8', '605', '2012', '510', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803704', '79', '605', '2012', '504', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803711', '78', '605', '2012', '505', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803716', '4522', '605', '2012', '499', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803719', '12', '675', '2010', '480', '480', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803721', '3', '605', '2012', '527', '501', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803725', '24', '675', '2010', '481', '481', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803729', '279', '605', '2012', '512', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803731', '10', '675', '2010', '491', '491', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803732', '38', '605', '2012', '510', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803738', '150', '605', '2012', '540', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803739', '69', '675', '2010', '500', '494', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803750', '56', '605', '2012', '512', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803751', '61', '675', '2010', '501', '501', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803756', '21', '675', '2010', '503', '503', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803757', '37', '605', '2012', '516', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803767', '161', '605', '2012', '512', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803773', '317', '605', '2012', '511', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803776', '25', '605', '2012', '520', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803780', '97', '605', '2012', '534', '499', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803785', '101', '605', '2012', '510', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803786', '34', '605', '2012', '531', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803788', '275', '605', '2012', '504', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803790', '21', '675', '2011', '492', '488', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803791', '69', '675', '2011', '526', '526', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803794', '61', '675', '2011', '486', '485', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803796', '10', '675', '2011', '498', '494', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803799', '22', '675', '2012', '522', '522', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803801', '58', '675', '2012', '522', '520', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803803', '5', '675', '2012', '520', '512', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803805', '270', '675', '2012', '513', '513', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803807', '61', '675', '2012', '519', '517', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803809', '10', '675', '2012', '519', '518', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803811', '44', '675', '2012', '523', '523', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803813', '12', '675', '2012', '515', '515', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803815', '8', '675', '2012', '533', '528', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803817', '428', '675', '2012', '514', '514', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803819', '2', '675', '2012', '513', '513', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803821', '24', '675', '2012', '513', '513', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803825', '203', '675', '2012', '516', '512', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803829', '3', '675', '2012', '521', '521', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803830', '21', '675', '2012', '532', '532', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803831', '222', '605', '2013', '473', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803832', '101', '605', '2013', '473', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803836', '4429', '675', '2013', '480', '480', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803837', '105', '605', '2013', '482', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803840', '65', '605', '2013', '471', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803842', '8', '675', '2013', '478', '478', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803845', '113', '605', '2013', '477', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803847', '22', '675', '2013', '502', '502', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803851', '56', '605', '2013', '480', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803855', '61', '675', '2013', '492', '492', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803856', '21', '675', '2013', '492', '492', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803859', '55', '605', '2013', '477', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803861', '44', '675', '2013', '483', '483', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803863', '175', '605', '2013', '473', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803866', '12', '675', '2013', '481', '481', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803867', '206', '605', '2013', '504', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803871', '129', '605', '2013', '479', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803872', '10', '675', '2013', '479', '479', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('803874', '238', '605', '2013', '486', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803877', '29', '605', '2013', '489', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803881', '237', '605', '2013', '479', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803885', '931', '605', '2013', '479', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803890', '233', '605', '2013', '487', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803893', '12', '605', '2013', '504', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803896', '161', '605', '2013', '478', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803902', '317', '605', '2013', '474', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803911', '255', '605', '2013', '487', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803921', '4429', '605', '2013', '485', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803926', '97', '605', '2013', '506', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803931', '538', '605', '2013', '486', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803937', '8', '605', '2013', '478', '473', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803942', '150', '605', '2013', '516', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803947', '69', '605', '2013', '476', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803952', '51', '605', '2013', '498', '484', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803962', '34', '605', '2013', '489', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803967', '10', '605', '2013', '496', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('803973', '4255', '605', '2013', '474', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('804013', '428', '675', '2011', '467', '467', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804016', '69', '675', '2011', '468', '468', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804025', '10', '675', '2011', '473', '473', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804032', '21', '675', '2011', '478', '478', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804043', '3', '675', '2011', '511', '511', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804058', '3', '675', '2012', '506', '506', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804067', '22', '675', '2012', '476', '476', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804077', '10', '675', '2012', '482', '482', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804086', '428', '675', '2012', '479', '479', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804094', '44', '675', '2012', '474', '474', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804098', '24', '675', '2012', '483', '483', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804107', '12', '675', '2012', '475', '475', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804115', '8', '675', '2012', '514', '512', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804121', '61', '675', '2012', '476', '476', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804125', '58', '675', '2012', '477', '477', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804128', '21', '675', '2012', '502', '492', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('804136', '203', '675', '2012', '479', '477', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('805162', '56', '753', '2010', '508', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805163', '58', '753', '2010', '520', '515', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805164', '10', '753', '2010', '511', '510', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805165', '1247', '753', '2011', '527', '524', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805166', '58', '753', '2011', '530', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805167', '10', '753', '2011', '522', '522', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805168', '10', '753', '2012', '579', '571', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805169', '58', '753', '2012', '571', '568', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805170', '58', '753', '2013', '529', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805171', '10', '753', '2013', '531', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805222', '10', '753', '2010', '508', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805223', '58', '753', '2010', '509', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805224', '78', '756', '2010', '511', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805225', '58', '756', '2010', '484', '482', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805227', '8', '756', '2010', '486', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805229', '56', '753', '2011', '516', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805231', '58', '753', '2011', '524', '524', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805233', '78', '753', '2011', '513', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805235', '10', '753', '2011', '521', '521', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805242', '24', '756', '2011', '504', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805244', '8', '756', '2011', '502', '501', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805249', '10', '753', '2012', '533', '531', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805251', '58', '753', '2012', '538', '537', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805254', '24', '756', '2012', '547', '547', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805255', '8', '756', '2012', '553', '551', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805258', '10', '753', '2013', '502', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805259', '8', '756', '2013', '511', '511', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805260', '58', '753', '2013', '512', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805261', '69', '756', '2013', '508', '507', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805324', '78', '757', '2010', '484', '481', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805325', '24', '757', '2010', '496', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805326', '52', '757', '2010', '491', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805328', '23', '757', '2010', '497', '486', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805330', '13', '757', '2010', '520', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805332', '275', '757', '2010', '504', '484', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805333', '76', '757', '2010', '504', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805340', '3', '757', '2010', '496', '483', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805344', '428', '757', '2010', '486', '484', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805346', '1', '757', '2010', '492', '483', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805348', '10', '757', '2010', '504', '483', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805349', '410', '757', '2010', '489', '483', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805350', '8', '757', '2010', '497', '483', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805351', '5', '757', '2010', '488', '482', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805352', '48', '757', '2010', '483', '480', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805353', '58', '757', '2010', '496', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805358', '48', '757', '2011', '495', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805359', '76', '757', '2011', '484', '484', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805360', '1', '757', '2011', '497', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805361', '13', '757', '2011', '515', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805362', '5', '757', '2011', '503', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805364', '74', '757', '2011', '511', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805366', '78', '757', '2011', '503', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805367', '24', '757', '2011', '502', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805368', '275', '757', '2011', '495', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805369', '175', '757', '2011', '496', '496', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805370', '8', '756', '2010', '476', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805371', '91', '756', '2010', '479', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805372', '79', '757', '2011', '492', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805373', '3', '757', '2011', '509', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805374', '147', '756', '2010', '493', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805375', '428', '757', '2011', '493', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805376', '123', '756', '2010', '489', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805377', '8', '757', '2011', '508', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805378', '23', '757', '2011', '500', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805379', '10', '757', '2011', '508', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805381', '52', '757', '2011', '490', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805383', '58', '757', '2011', '488', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805385', '2', '757', '2011', '496', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805386', '8', '756', '2011', '510', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805387', '410', '757', '2011', '497', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805388', '24', '756', '2012', '510', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805389', '132', '756', '2012', '508', '506', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805390', '8', '756', '2012', '524', '517', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805395', '10', '757', '2012', '542', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805397', '13', '757', '2012', '544', '527', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805398', '101', '756', '2013', '482', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805399', '76', '757', '2012', '531', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805400', '8', '756', '2013', '483', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805401', '410', '757', '2012', '536', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805402', '79', '757', '2012', '530', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805403', '1', '757', '2012', '553', '532', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805404', '275', '757', '2012', '540', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805405', '48', '757', '2012', '534', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805406', '58', '757', '2012', '526', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805407', '3', '757', '2012', '544', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805408', '8', '757', '2012', '529', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805409', '24', '757', '2012', '531', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805410', '5', '757', '2012', '547', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805411', '175', '757', '2012', '528', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805412', '428', '757', '2012', '549', '536', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805413', '2', '757', '2012', '530', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805414', '74', '757', '2012', '539', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805415', '78', '757', '2012', '530', '525', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805416', '23', '757', '2012', '536', '526', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805420', '163', '757', '2013', '495', '492', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805421', '175', '757', '2013', '490', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805422', '1', '757', '2013', '492', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805423', '5', '757', '2013', '501', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805425', '4429', '757', '2013', '494', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805427', '255', '757', '2013', '494', '487', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805429', '435', '757', '2013', '499', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805431', '538', '757', '2013', '494', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805432', '13', '757', '2013', '503', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805433', '222', '757', '2013', '489', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805434', '182', '757', '2013', '503', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805435', '8', '757', '2013', '500', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805436', '4256', '757', '2013', '499', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805437', '58', '757', '2013', '497', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805438', '10', '757', '2013', '509', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805559', '184', '757', '2010', '475', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805560', '3', '757', '2010', '494', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805561', '23', '757', '2010', '480', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805562', '140', '757', '2010', '492', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805563', '25', '757', '2010', '477', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805564', '101', '757', '2010', '513', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805565', '34', '757', '2010', '481', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805566', '150', '757', '2010', '483', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805568', '78', '757', '2010', '465', '463', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805569', '10', '757', '2010', '488', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805570', '79', '757', '2010', '474', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805572', '24', '757', '2010', '467', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805573', '428', '757', '2010', '481', '467', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805574', '8', '757', '2010', '485', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805575', '175', '757', '2010', '479', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805577', '410', '757', '2010', '472', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805579', '119', '757', '2010', '502', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805581', '38', '757', '2010', '462', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805583', '76', '757', '2010', '503', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805585', '275', '757', '2010', '512', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805587', '87', '757', '2010', '485', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805589', '97', '757', '2010', '489', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805599', '38', '757', '2011', '492', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805600', '23', '757', '2011', '478', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805601', '97', '757', '2011', '499', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805602', '161', '757', '2011', '479', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805603', '184', '757', '2011', '494', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805604', '76', '757', '2011', '479', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805605', '24', '757', '2011', '476', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805606', '52', '757', '2011', '480', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805607', '150', '757', '2011', '508', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805608', '87', '757', '2011', '474', '474', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805609', '78', '757', '2011', '483', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805610', '140', '757', '2011', '480', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805611', '10', '757', '2011', '504', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805612', '428', '757', '2011', '475', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805613', '175', '757', '2011', '476', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805614', '34', '757', '2011', '488', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805615', '25', '757', '2011', '483', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805616', '275', '757', '2011', '481', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805617', '79', '757', '2011', '476', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805618', '3', '757', '2011', '513', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805619', '410', '757', '2011', '501', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805620', '2', '757', '2011', '481', '480', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805621', '101', '757', '2011', '476', '476', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805622', '16', '757', '2011', '499', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805623', '158', '757', '2011', '487', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805625', '8', '757', '2011', '493', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805632', '87', '757', '2012', '508', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805633', '410', '757', '2012', '486', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805635', '79', '757', '2012', '487', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805636', '10', '757', '2012', '520', '494', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805637', '119', '757', '2012', '540', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805638', '140', '757', '2012', '490', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805640', '34', '757', '2012', '494', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805641', '150', '757', '2012', '508', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805642', '25', '757', '2012', '496', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805643', '184', '757', '2012', '499', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805644', '275', '757', '2012', '495', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805645', '175', '757', '2012', '502', '502', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805646', '8', '757', '2012', '510', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805647', '3', '757', '2012', '530', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805648', '23', '757', '2012', '502', '492', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805649', '24', '757', '2012', '493', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805650', '92', '757', '2012', '489', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805651', '78', '757', '2012', '512', '497', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805652', '97', '757', '2012', '524', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805653', '2', '757', '2012', '502', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805654', '5', '757', '2012', '496', '489', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805660', '4429', '757', '2013', '476', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805661', '163', '757', '2013', '481', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805663', '97', '757', '2013', '512', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805664', '182', '757', '2013', '466', '461', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805665', '150', '757', '2013', '493', '461', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805666', '5', '757', '2013', '478', '461', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805667', '175', '757', '2013', '476', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805668', '454', '757', '2013', '472', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805669', '34', '757', '2013', '469', '459', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805670', '119', '757', '2013', '464', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805671', '29', '757', '2013', '480', '459', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805672', '233', '757', '2013', '465', '459', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805673', '2448', '757', '2013', '463', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805674', '4256', '757', '2013', '476', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805675', '255', '757', '2013', '460', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805676', '10', '757', '2013', '491', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805678', '161', '757', '2013', '468', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805680', '8', '757', '2013', '462', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805682', '538', '757', '2013', '470', '459', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805684', '351', '757', '2013', '465', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805813', '24', '780', '2011', '514', '447', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('805814', '10', '780', '2011', '473', '438', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('805822', '12', '781', '2012', '569', '567', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805824', '24', '781', '2012', '568', '566', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805825', '8', '781', '2012', '567', '566', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805826', '10', '781', '2013', '535', '534', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805827', '4479', '781', '2013', '531', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805828', '4194', '781', '2013', '531', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805829', '22', '781', '2013', '531', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805830', '44', '781', '2013', '532', '532', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805831', '339', '781', '2013', '532', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805832', '12', '781', '2013', '530', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805834', '13', '781', '2013', '529', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805835', '514', '781', '2013', '528', '528', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805836', '1451', '781', '2013', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805837', '8', '781', '2013', '531', '530', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('805848', '12', '781', '2012', '542', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805849', '8', '781', '2012', '543', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805850', '38', '781', '2012', '548', '540', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805851', '24', '781', '2012', '540', '539', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805854', '233', '781', '2013', '511', '511', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805856', '161', '781', '2013', '510', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805858', '4194', '781', '2013', '510', '510', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805859', '12', '781', '2013', '512', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805860', '4479', '781', '2013', '512', '512', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805861', '8', '781', '2013', '516', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805862', '22', '781', '2013', '525', '523', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805863', '44', '781', '2013', '516', '516', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805864', '339', '781', '2013', '518', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805865', '10', '781', '2013', '517', '515', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805866', '514', '781', '2013', '513', '513', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('805969', '24', '780', '2011', '443', '407', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('805970', '10', '780', '2011', '445', '406', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806038', '10', '809', '2011', '486', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('806039', '13', '809', '2011', '484', '484', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('806050', '10', '809', '2012', '541', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('806057', '13', '809', '2013', '484', '484', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('806059', '86', '809', '2013', '487', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('806063', '93', '809', '2013', '490', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('806067', '10', '809', '2013', '508', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('806121', '147', '809', '2011', '499', '479', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806123', '113', '809', '2011', '484', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806124', '38', '809', '2011', '479', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806125', '186', '809', '2011', '478', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806126', '37', '809', '2011', '476', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806128', '97', '809', '2012', '493', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806130', '113', '809', '2012', '491', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806132', '38', '809', '2012', '532', '509', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806134', '147', '809', '2012', '499', '491', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806138', '113', '809', '2013', '490', '462', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806141', '310', '809', '2013', '483', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806144', '223', '809', '2013', '461', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806146', '85', '809', '2013', '485', '459', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806148', '233', '809', '2013', '460', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806150', '97', '809', '2013', '460', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806152', '86', '809', '2013', '457', '457', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806153', '105', '809', '2013', '459', '457', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806155', '10', '809', '2013', '460', '457', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806157', '93', '809', '2013', '456', '456', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806158', '162', '809', '2013', '458', '456', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806160', '156', '809', '2013', '463', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806889', '3', '968', '2010', '456', '430', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806890', '13', '968', '2010', '461', '429', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806891', '8', '968', '2010', '447', '429', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806892', '17', '968', '2010', '459', '429', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806893', '2', '968', '2010', '459', '431', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806894', '10', '968', '2010', '467', '429', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806895', '2', '968', '2011', '472', '441', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806896', '8', '968', '2011', '470', '441', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806897', '3', '968', '2011', '465', '440', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806898', '329', '968', '2011', '456', '442', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806899', '13', '968', '2011', '467', '442', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806900', '17', '968', '2011', '470', '442', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806901', '10', '968', '2011', '480', '441', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806906', '10', '968', '2012', '520', '481', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806908', '3', '968', '2012', '513', '481', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806910', '13', '968', '2012', '495', '478', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806912', '8', '968', '2012', '520', '483', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806915', '2', '968', '2012', '500', '480', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806917', '351', '968', '2012', '519', '487', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806918', '17', '968', '2012', '508', '482', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806920', '329', '968', '2012', '507', '487', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806921', '10', '968', '2013', '473', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806922', '351', '968', '2013', '467', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806923', '17', '968', '2013', '475', '454', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806925', '260', '968', '2013', '465', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806926', '13', '968', '2013', '481', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806927', '8', '968', '2013', '468', '452', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('806944', '109', '968', '2011', '454', '405', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806945', '8', '968', '2011', '470', '408', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806946', '92', '968', '2011', '431', '403', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806948', '329', '968', '2011', '443', '409', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806951', '3', '968', '2011', '447', '408', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806952', '2', '968', '2011', '457', '411', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806953', '38', '968', '2011', '431', '404', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806954', '113', '968', '2011', '449', '404', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806955', '37', '968', '2011', '425', '405', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806956', '10', '968', '2011', '463', '409', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806957', '17', '968', '2011', '454', '412', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806958', '109', '968', '2012', '447', '417', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806959', '92', '968', '2012', '485', '431', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806960', '38', '968', '2012', '457', '422', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806961', '10', '968', '2012', '462', '420', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806962', '37', '968', '2012', '471', '421', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806963', '3', '968', '2012', '471', '421', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806964', '8', '968', '2012', '462', '424', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806965', '2', '968', '2012', '457', '421', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806966', '17', '968', '2012', '450', '421', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806967', '113', '968', '2012', '459', '421', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806968', '329', '968', '2012', '454', '426', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('806969', '10', '980', '2011', '523', '508', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('806970', '5', '980', '2011', '526', '498', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('806971', '5', '980', '2012', '551', '531', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('806972', '10', '980', '2012', '550', '538', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('806973', '5', '980', '2013', '522', '506', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('806974', '10', '980', '2013', '508', '500', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('806975', '5', '980', '2011', '513', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806976', '10', '980', '2011', '516', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806977', '190', '980', '2011', '510', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806978', '190', '980', '2012', '521', '493', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806979', '10', '980', '2012', '514', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806980', '5', '980', '2012', '522', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806981', '10', '980', '2013', '509', '475', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806982', '336', '980', '2013', '500', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('806983', '5', '980', '2013', '477', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('807067', '58', '1028', '2010', '469', '468', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807068', '23', '1028', '2010', '478', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807069', '10', '1028', '2010', '478', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807070', '5', '1028', '2010', '476', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807071', '89', '1028', '2010', '471', '469', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807072', '24', '1028', '2010', '474', '469', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807073', '78', '1028', '2010', '472', '469', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807074', '3', '1028', '2010', '495', '473', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807075', '8', '1028', '2010', '495', '472', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807076', '120', '1028', '2010', '473', '469', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807077', '126', '1028', '2010', '478', '471', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807078', '21', '1028', '2010', '497', '476', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807083', '3', '1028', '2011', '489', '479', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807084', '126', '1028', '2011', '481', '476', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807085', '8', '1028', '2011', '485', '477', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807086', '120', '1028', '2011', '479', '475', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807087', '78', '1028', '2011', '482', '476', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807088', '10', '1028', '2011', '481', '477', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807089', '23', '1028', '2011', '485', '477', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807090', '58', '1028', '2011', '479', '475', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807091', '24', '1028', '2011', '477', '474', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807092', '89', '1028', '2011', '480', '476', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807093', '21', '1028', '2011', '487', '480', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807094', '5', '1028', '2011', '480', '476', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807095', '8', '1028', '2012', '538', '517', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807096', '89', '1028', '2012', '518', '516', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807097', '5', '1028', '2012', '524', '517', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807098', '126', '1028', '2012', '520', '516', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807099', '24', '1028', '2012', '518', '514', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807100', '78', '1028', '2012', '519', '515', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807102', '23', '1028', '2012', '525', '517', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807103', '58', '1028', '2012', '518', '515', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807104', '21', '1028', '2012', '556', '521', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807105', '3', '1028', '2012', '528', '520', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807106', '10', '1028', '2012', '520', '517', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807107', '120', '1028', '2012', '520', '515', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807124', '68', '1028', '2011', '473', '461', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807125', '120', '1028', '2011', '469', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807126', '78', '1028', '2011', '473', '457', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807127', '126', '1028', '2011', '466', '458', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807128', '58', '1028', '2011', '459', '454', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807129', '3', '1028', '2011', '496', '463', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807130', '79', '1028', '2011', '471', '454', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807131', '8', '1028', '2011', '476', '459', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807132', '24', '1028', '2011', '465', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807133', '89', '1028', '2011', '463', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807134', '23', '1028', '2011', '471', '458', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807135', '38', '1028', '2011', '470', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807136', '21', '1028', '2011', '487', '462', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807137', '5', '1028', '2011', '466', '462', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807138', '10', '1028', '2011', '473', '459', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807139', '5', '1028', '2012', '482', '477', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807140', '89', '1028', '2012', '477', '470', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807141', '126', '1028', '2012', '481', '470', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807142', '24', '1028', '2012', '480', '469', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807143', '38', '1028', '2012', '478', '470', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807144', '23', '1028', '2012', '484', '472', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807145', '58', '1028', '2012', '506', '475', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807146', '3', '1028', '2012', '525', '476', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807147', '21', '1028', '2012', '501', '477', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807148', '78', '1028', '2012', '481', '470', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807150', '120', '1028', '2012', '480', '469', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807152', '10', '1028', '2012', '481', '472', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807153', '79', '1028', '2012', '473', '468', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807154', '8', '1028', '2012', '484', '472', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807195', '13', '1051', '2011', '493', '490', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('807196', '13', '1051', '2012', '542', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('807197', '10', '1051', '2012', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('807198', '339', '1051', '2013', '495', '495', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('807199', '13', '1051', '2013', '494', '491', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('807200', '109', '1051', '2011', '477', '477', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('807201', '10', '1051', '2011', '486', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('807202', '99', '1051', '2011', '491', '483', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('807203', '99', '1051', '2012', '489', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('807204', '10', '1051', '2012', '510', '500', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('807205', '109', '1051', '2012', '503', '498', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('807206', '97', '1051', '2012', '486', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('807207', '206', '1051', '2013', '461', '459', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('807208', '97', '1051', '2013', '491', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('807209', '156', '1051', '2013', '470', '466', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('807210', '10', '1051', '2013', '470', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('807262', '23', '1065', '2011', '462', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807263', '10', '1065', '2011', '459', '458', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807264', '3', '1065', '2011', '478', '478', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807265', '2', '1065', '2011', '461', '461', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807266', '21', '1065', '2011', '464', '464', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807267', '21', '1065', '2012', '506', '506', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807268', '23', '1065', '2012', '531', '531', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807269', '2', '1065', '2012', '507', '507', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807270', '10', '1065', '2012', '505', '505', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807271', '78', '1065', '2012', '506', '506', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807272', '23', '1065', '2011', '438', '432', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807273', '21', '1065', '2011', '468', '460', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807274', '10', '1065', '2011', '422', '422', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807275', '2', '1065', '2011', '442', '435', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807276', '3', '1065', '2011', '484', '454', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807277', '23', '1065', '2012', '469', '462', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807278', '21', '1065', '2012', '478', '465', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807279', '78', '1065', '2012', '449', '449', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807280', '2', '1065', '2012', '456', '454', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807281', '10', '1065', '2012', '462', '458', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807298', '10', '1122', '2010', '468', '456', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807299', '63', '1122', '2010', '466', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807300', '78', '1122', '2010', '471', '457', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807301', '24', '1122', '2010', '467', '456', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807302', '8', '1122', '2010', '470', '458', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807303', '5', '1122', '2010', '473', '458', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807304', '2', '1122', '2010', '466', '458', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807305', '58', '1122', '2010', '481', '456', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807306', '13', '1122', '2010', '467', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807307', '3', '1122', '2010', '476', '461', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807308', '61', '1122', '2010', '470', '456', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807309', '12', '1122', '2010', '463', '456', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807310', '120', '1122', '2010', '477', '458', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807311', '12', '1122', '2011', '470', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807312', '13', '1122', '2011', '479', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807313', '5', '1122', '2011', '480', '464', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807314', '8', '1122', '2011', '477', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807315', '2', '1122', '2011', '475', '464', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807316', '3', '1122', '2011', '479', '467', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807317', '63', '1122', '2011', '474', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807318', '10', '1122', '2011', '480', '464', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807319', '61', '1122', '2011', '478', '466', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807320', '24', '1122', '2011', '480', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807321', '78', '1122', '2011', '471', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807322', '120', '1122', '2011', '475', '464', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807323', '23', '1122', '2011', '478', '466', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807324', '21', '1122', '2011', '475', '466', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807325', '58', '1122', '2011', '476', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807326', '13', '1122', '2012', '520', '506', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807327', '61', '1122', '2012', '517', '507', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807328', '5', '1122', '2012', '514', '505', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807329', '63', '1122', '2012', '515', '506', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807330', '58', '1122', '2012', '518', '505', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807331', '12', '1122', '2012', '518', '508', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807332', '10', '1122', '2012', '518', '507', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807333', '120', '1122', '2012', '517', '505', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807334', '3', '1122', '2012', '534', '509', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807335', '78', '1122', '2012', '513', '504', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807336', '2', '1122', '2012', '514', '507', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807337', '8', '1122', '2012', '520', '505', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807338', '23', '1122', '2012', '514', '508', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807339', '21', '1122', '2012', '514', '508', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807340', '24', '1122', '2012', '517', '507', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807342', '12', '1122', '2013', '475', '468', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807344', '8', '1122', '2013', '482', '471', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807346', '21', '1122', '2013', '477', '473', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807349', '1451', '1122', '2013', '473', '468', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807351', '13', '1122', '2013', '477', '468', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807353', '5', '1122', '2013', '476', '469', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807355', '61', '1122', '2013', '475', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807357', '58', '1122', '2013', '480', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807359', '10', '1122', '2013', '478', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807417', '85', '1122', '2011', '463', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807418', '113', '1122', '2011', '463', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807419', '107', '1122', '2011', '470', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807420', '147', '1122', '2011', '476', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807421', '10', '1122', '2011', '487', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807422', '24', '1122', '2011', '456', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807423', '146', '1122', '2011', '472', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807424', '91', '1122', '2011', '463', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807425', '129', '1122', '2011', '484', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807426', '109', '1122', '2011', '463', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807427', '143', '1122', '2011', '468', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807428', '38', '1122', '2011', '461', '444', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807429', '2', '1122', '2011', '468', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807430', '3', '1122', '2011', '473', '450', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807431', '153', '1122', '2011', '473', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807432', '30', '1122', '2011', '489', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807433', '141', '1122', '2011', '470', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807434', '8', '1122', '2011', '462', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807435', '89', '1122', '2011', '464', '443', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807436', '40', '1122', '2011', '471', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807437', '105', '1122', '2011', '467', '452', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807438', '78', '1122', '2011', '458', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807440', '184', '1122', '2011', '467', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807442', '61', '1122', '2011', '457', '444', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807444', '5', '1122', '2011', '458', '444', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807446', '23', '1122', '2011', '460', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807448', '120', '1122', '2011', '463', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807450', '37', '1122', '2011', '469', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807452', '36', '1122', '2011', '453', '442', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807454', '80', '1122', '2011', '460', '440', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807456', '58', '1122', '2011', '458', '443', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807458', '12', '1122', '2011', '457', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807460', '21', '1122', '2011', '465', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807464', '107', '1122', '2012', '482', '460', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807466', '113', '1122', '2012', '473', '459', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807468', '36', '1122', '2012', '469', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807470', '5', '1122', '2012', '471', '457', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807472', '3', '1122', '2012', '477', '462', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807474', '120', '1122', '2012', '474', '459', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807476', '109', '1122', '2012', '476', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807478', '61', '1122', '2012', '466', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807480', '141', '1122', '2012', '471', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807482', '10', '1122', '2012', '479', '461', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807483', '12', '1122', '2012', '467', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807484', '147', '1122', '2012', '483', '465', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807485', '184', '1122', '2012', '471', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807486', '80', '1122', '2012', '477', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807487', '37', '1122', '2012', '476', '457', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807488', '143', '1122', '2012', '468', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807489', '78', '1122', '2012', '470', '458', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807490', '2', '1122', '2012', '477', '460', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807491', '146', '1122', '2012', '483', '458', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807492', '40', '1122', '2012', '473', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807493', '91', '1122', '2012', '476', '457', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807494', '85', '1122', '2012', '483', '458', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807495', '23', '1122', '2012', '471', '462', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807496', '21', '1122', '2012', '479', '462', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807497', '89', '1122', '2012', '477', '457', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807498', '38', '1122', '2012', '476', '458', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807499', '30', '1122', '2012', '476', '458', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807500', '105', '1122', '2012', '483', '463', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807501', '8', '1122', '2012', '468', '459', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807502', '24', '1122', '2012', '470', '457', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807503', '129', '1122', '2012', '483', '466', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807504', '153', '1122', '2012', '465', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807505', '58', '1122', '2012', '470', '461', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807681', '2', '1309', '2010', '471', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807682', '78', '1309', '2010', '493', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807683', '63', '1309', '2010', '469', '459', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807684', '10', '1309', '2010', '473', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807685', '8', '1309', '2010', '468', '461', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807686', '67', '1309', '2010', '467', '459', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807687', '13', '1309', '2010', '474', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807688', '5', '1309', '2010', '467', '460', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807689', '3', '1309', '2010', '471', '464', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807690', '275', '1309', '2010', '475', '463', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807701', '13', '1309', '2011', '492', '467', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807702', '5', '1309', '2011', '478', '465', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807703', '67', '1309', '2011', '478', '466', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807704', '78', '1309', '2011', '473', '466', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807705', '10', '1309', '2011', '479', '468', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807706', '3', '1309', '2011', '480', '469', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807707', '275', '1309', '2011', '475', '466', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807708', '8', '1309', '2011', '478', '467', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807715', '13', '1309', '2012', '532', '508', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807717', '8', '1309', '2012', '514', '508', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807719', '78', '1309', '2012', '513', '506', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807721', '63', '1309', '2012', '516', '505', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807722', '5', '1309', '2012', '518', '505', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807724', '3', '1309', '2012', '514', '510', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807725', '275', '1309', '2012', '519', '510', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807726', '10', '1309', '2012', '520', '508', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807739', '5', '1309', '2013', '482', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807741', '255', '1309', '2013', '481', '471', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807743', '4429', '1309', '2013', '479', '474', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807745', '10', '1309', '2013', '481', '472', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807746', '4256', '1309', '2013', '476', '472', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807747', '13', '1309', '2013', '482', '474', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807748', '8', '1309', '2013', '478', '471', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807749', '12', '1309', '2013', '476', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807750', '69', '1309', '2013', '476', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807776', '78', '1309', '2011', '460', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807777', '67', '1309', '2011', '467', '445', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807778', '97', '1309', '2011', '470', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807779', '10', '1309', '2011', '466', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807780', '38', '1309', '2011', '464', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807781', '8', '1309', '2011', '462', '444', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807782', '34', '1309', '2011', '464', '449', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807783', '275', '1309', '2011', '463', '447', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807784', '3', '1309', '2011', '461', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807792', '97', '1309', '2012', '477', '460', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807793', '78', '1309', '2012', '468', '456', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807794', '38', '1309', '2012', '469', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807795', '3', '1309', '2012', '476', '462', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807796', '8', '1309', '2012', '473', '459', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807797', '37', '1309', '2012', '478', '455', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807798', '10', '1309', '2012', '478', '461', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807799', '275', '1309', '2012', '476', '458', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807828', '61', '1324', '2011', '453', '451', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807829', '293', '1324', '2011', '478', '474', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807830', '13', '1324', '2011', '470', '466', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807831', '10', '1324', '2011', '443', '432', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807832', '10', '1324', '2012', '484', '479', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807833', '293', '1324', '2012', '476', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807834', '59', '1324', '2012', '475', '474', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807835', '22', '1324', '2012', '479', '467', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807836', '44', '1324', '2012', '490', '490', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807837', '2', '1324', '2012', '503', '478', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807838', '44', '1324', '2013', '470', '466', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807839', '10', '1324', '2013', '471', '467', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807841', '2', '1324', '2011', '442', '422', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807842', '481', '1324', '2011', '397', '397', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807843', '10', '1324', '2011', '496', '434', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807844', '10', '1324', '2012', '442', '441', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807845', '2', '1324', '2012', '437', '427', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807852', '78', '1353', '2010', '456', '437', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807853', '10', '1353', '2010', '452', '435', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807854', '8', '1353', '2010', '465', '441', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807855', '3', '1353', '2010', '468', '440', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807856', '2', '1353', '2010', '456', '437', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807857', '5', '1353', '2010', '467', '436', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807858', '480', '1353', '2011', '477', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807859', '2', '1353', '2011', '473', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807860', '78', '1353', '2011', '465', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807861', '5', '1353', '2011', '472', '456', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807862', '10', '1353', '2011', '481', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807863', '8', '1353', '2011', '480', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807864', '3', '1353', '2011', '476', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807865', '10', '1353', '2012', '501', '487', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807866', '3', '1353', '2012', '519', '488', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807867', '8', '1353', '2012', '501', '484', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807868', '5', '1353', '2012', '500', '487', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807869', '78', '1353', '2012', '507', '486', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807870', '2', '1353', '2012', '498', '485', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807871', '480', '1353', '2012', '512', '489', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807872', '5', '1353', '2013', '474', '460', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807873', '8', '1353', '2013', '473', '457', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807874', '10', '1353', '2013', '474', '460', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807909', '118', '1353', '2011', '439', '415', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807910', '441', '1353', '2011', '450', '426', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807911', '68', '1353', '2011', '443', '421', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807912', '380', '1353', '2011', '430', '418', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807913', '480', '1353', '2011', '430', '416', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807914', '3', '1353', '2011', '459', '424', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807915', '129', '1353', '2011', '467', '428', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807916', '419', '1353', '2011', '485', '427', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807917', '140', '1353', '2011', '429', '417', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807918', '10', '1353', '2011', '451', '423', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807919', '146', '1353', '2011', '465', '427', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807920', '151', '1353', '2011', '454', '418', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807921', '5', '1353', '2011', '441', '420', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807922', '21', '1353', '2011', '473', '425', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807923', '78', '1353', '2011', '458', '423', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807924', '37', '1353', '2011', '471', '420', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807925', '36', '1353', '2011', '456', '419', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807926', '229', '1353', '2011', '468', '432', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807927', '113', '1353', '2011', '461', '426', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807928', '2', '1353', '2011', '458', '424', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807929', '148', '1353', '2011', '454', '421', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807930', '94', '1353', '2011', '468', '424', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807931', '310', '1353', '2011', '472', '423', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807932', '101', '1353', '2011', '459', '422', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807933', '8', '1353', '2011', '448', '422', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807934', '89', '1353', '2011', '445', '417', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807935', '233', '1353', '2011', '470', '420', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807936', '205', '1353', '2011', '435', '419', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807937', '38', '1353', '2011', '445', '421', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807938', '143', '1353', '2011', '461', '421', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807939', '229', '1353', '2012', '478', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807940', '10', '1353', '2012', '468', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807941', '3', '1353', '2012', '466', '435', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807942', '233', '1353', '2012', '470', '438', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807943', '5', '1353', '2012', '444', '431', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807944', '8', '1353', '2012', '481', '443', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807945', '113', '1353', '2012', '483', '440', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807946', '94', '1353', '2012', '472', '434', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807947', '129', '1353', '2012', '478', '439', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807949', '205', '1353', '2012', '450', '427', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807952', '380', '1353', '2012', '467', '438', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807954', '480', '1353', '2012', '463', '428', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807955', '38', '1353', '2012', '470', '435', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807956', '441', '1353', '2012', '469', '430', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807957', '419', '1353', '2012', '487', '434', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807958', '78', '1353', '2012', '475', '438', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807959', '21', '1353', '2012', '467', '433', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807960', '146', '1353', '2012', '477', '440', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807961', '2', '1353', '2012', '466', '438', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807962', '36', '1353', '2012', '456', '428', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807963', '140', '1353', '2012', '443', '426', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807964', '37', '1353', '2012', '471', '429', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807965', '143', '1353', '2012', '465', '430', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807966', '310', '1353', '2012', '479', '431', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807967', '89', '1353', '2012', '462', '435', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('807998', '79', '1432', '2010', '445', '445', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('807999', '12', '1432', '2010', '411', '411', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808000', '23', '1432', '2010', '421', '421', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808001', '8', '1432', '2010', '442', '442', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808002', '10', '1432', '2010', '431', '431', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808003', '23', '1432', '2011', '436', '436', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808004', '2', '1432', '2011', '439', '430', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808008', '2', '1432', '2011', '444', '414', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808009', '23', '1432', '2011', '446', '412', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808010', '8', '1432', '2011', '400', '397', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808011', '147', '1432', '2011', '391', '391', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808012', '113', '1432', '2011', '443', '429', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808013', '13', '1440', '2013', '488', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('808014', '233', '1440', '2013', '461', '459', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808015', '10', '1440', '2013', '458', '457', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808016', '343', '1440', '2013', '456', '456', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808017', '40', '1440', '2013', '459', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808029', '120', '1482', '2010', '462', '432', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808030', '3', '1482', '2010', '472', '435', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808031', '8', '1482', '2010', '466', '430', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808032', '23', '1482', '2010', '457', '430', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808033', '5', '1482', '2010', '449', '427', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808034', '10', '1482', '2010', '454', '429', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808035', '79', '1482', '2010', '457', '428', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808036', '16', '1482', '2010', '431', '422', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808037', '12', '1482', '2010', '456', '426', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808038', '78', '1482', '2010', '446', '425', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808039', '8', '1482', '2011', '473', '440', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808040', '12', '1482', '2011', '451', '435', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808041', '78', '1482', '2011', '459', '437', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808042', '120', '1482', '2011', '466', '441', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808043', '5', '1482', '2011', '461', '438', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808044', '63', '1482', '2011', '468', '437', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808045', '79', '1482', '2011', '459', '436', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808046', '24', '1482', '2011', '469', '439', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808047', '3', '1482', '2011', '467', '443', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808048', '10', '1482', '2011', '472', '439', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808049', '23', '1482', '2011', '471', '441', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808050', '79', '1482', '2012', '512', '476', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808051', '23', '1482', '2012', '501', '477', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808052', '10', '1482', '2012', '504', '474', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808053', '120', '1482', '2012', '513', '478', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808054', '78', '1482', '2012', '501', '479', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808055', '3', '1482', '2012', '512', '484', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808056', '12', '1482', '2012', '492', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808057', '24', '1482', '2012', '489', '470', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808058', '8', '1482', '2012', '510', '475', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808059', '5', '1482', '2012', '493', '473', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808060', '63', '1482', '2012', '495', '472', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808061', '5', '1482', '2013', '477', '447', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808062', '83', '1482', '2013', '471', '448', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808063', '1451', '1482', '2013', '467', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808064', '10', '1482', '2013', '456', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808065', '12', '1482', '2013', '469', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808066', '8', '1482', '2013', '467', '451', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808098', '79', '1482', '2011', '429', '409', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808099', '68', '1482', '2011', '420', '404', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808100', '132', '1482', '2011', '431', '407', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808101', '36', '1482', '2011', '441', '407', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808102', '37', '1482', '2011', '442', '406', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808103', '271', '1482', '2011', '445', '408', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808104', '120', '1482', '2011', '461', '417', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808105', '109', '1482', '2011', '457', '406', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808106', '129', '1482', '2011', '461', '415', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808107', '146', '1482', '2011', '430', '409', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808108', '380', '1482', '2011', '457', '410', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808109', '38', '1482', '2011', '428', '409', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808110', '233', '1482', '2011', '452', '410', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808111', '94', '1482', '2011', '466', '416', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808112', '115', '1482', '2011', '413', '402', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808113', '24', '1482', '2011', '424', '411', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808114', '143', '1482', '2011', '440', '410', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808115', '23', '1482', '2012', '452', '427', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808116', '79', '1482', '2012', '496', '419', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808117', '68', '1482', '2012', '452', '418', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808118', '78', '1482', '2012', '466', '430', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808119', '3', '1482', '2012', '465', '430', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808120', '271', '1482', '2012', '480', '423', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808121', '146', '1482', '2012', '468', '424', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808122', '380', '1482', '2012', '477', '428', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808123', '24', '1482', '2012', '447', '423', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808124', '120', '1482', '2012', '445', '426', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808125', '143', '1482', '2012', '442', '422', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808126', '37', '1482', '2012', '446', '417', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808127', '36', '1482', '2012', '430', '417', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808128', '38', '1482', '2012', '443', '421', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808129', '132', '1482', '2012', '449', '417', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808130', '115', '1482', '2012', '421', '415', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808131', '129', '1482', '2012', '477', '434', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808132', '233', '1482', '2012', '462', '419', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808133', '109', '1482', '2012', '443', '418', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808134', '94', '1482', '2012', '458', '429', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808153', '8', '1536', '2010', '472', '441', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808154', '48', '1536', '2010', '459', '441', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808155', '13', '1536', '2010', '456', '441', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808156', '24', '1536', '2010', '467', '441', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808157', '10', '1536', '2010', '470', '443', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808158', '5', '1536', '2010', '471', '441', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808159', '69', '1536', '2010', '469', '442', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808160', '8', '1536', '2011', '474', '452', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808161', '69', '1536', '2011', '455', '446', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808162', '48', '1536', '2011', '471', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808163', '24', '1536', '2011', '508', '457', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808164', '5', '1536', '2011', '483', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808165', '10', '1536', '2011', '470', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808166', '13', '1536', '2011', '470', '453', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808167', '69', '1536', '2012', '500', '488', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808168', '48', '1536', '2012', '500', '488', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808169', '5', '1536', '2012', '501', '486', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808170', '8', '1536', '2012', '508', '490', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808171', '24', '1536', '2012', '503', '490', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808172', '13', '1536', '2012', '512', '492', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808173', '10', '1536', '2012', '514', '492', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808174', '69', '1536', '2013', '469', '459', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808175', '5', '1536', '2013', '467', '458', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808176', '498', '1536', '2013', '460', '457', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808177', '159', '1536', '2013', '464', '457', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808178', '10', '1536', '2013', '468', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808179', '12', '1536', '2013', '471', '460', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808180', '8', '1536', '2013', '476', '461', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808181', '13', '1536', '2013', '468', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808191', '24', '1536', '2011', '459', '432', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808192', '79', '1536', '2011', '448', '427', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808193', '8', '1536', '2011', '459', '427', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808194', '105', '1536', '2011', '443', '424', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808195', '10', '1536', '2011', '459', '430', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808196', '129', '1536', '2011', '460', '424', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808197', '69', '1536', '2011', '461', '438', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808198', '37', '1536', '2011', '455', '424', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808199', '38', '1536', '2011', '444', '423', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808200', '8', '1536', '2012', '451', '442', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808201', '69', '1536', '2012', '480', '449', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808202', '10', '1536', '2012', '469', '446', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808203', '129', '1536', '2012', '464', '437', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808204', '37', '1536', '2012', '474', '436', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808205', '24', '1536', '2012', '464', '448', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808206', '105', '1536', '2012', '449', '435', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808207', '38', '1536', '2012', '457', '436', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808295', '10', '1701', '2013', '485', '485', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('808296', '13', '1701', '2013', '490', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('808297', '310', '1701', '2013', '460', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808298', '156', '1701', '2013', '457', '456', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808299', '105', '1701', '2013', '457', '456', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808300', '10', '1701', '2013', '462', '459', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808318', '37', '1759', '2011', '452', '430', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808319', '205', '1759', '2011', '476', '433', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808320', '147', '1759', '2011', '456', '436', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808321', '129', '1759', '2011', '456', '433', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808322', '3', '1759', '2011', '474', '429', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808323', '129', '1759', '2011', '489', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('808324', '129', '1759', '2012', '514', '475', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808325', '205', '1759', '2012', '490', '472', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808326', '129', '1759', '2012', '529', '529', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('808327', '147', '1759', '2012', '500', '467', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808328', '3', '1759', '2012', '511', '466', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808329', '37', '1759', '2012', '500', '474', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808330', '146', '1759', '2012', '535', '535', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('808331', '334', '1759', '2013', '453', '448', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808332', '113', '1759', '2013', '461', '461', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808333', '310', '1759', '2013', '482', '461', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808334', '85', '1759', '2013', '489', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('808335', '105', '1759', '2013', '453', '449', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808336', '85', '1759', '2013', '492', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808337', '237', '1759', '2013', '455', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808338', '129', '1759', '2011', '492', '490', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808339', '147', '1759', '2011', '482', '482', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808340', '37', '1759', '2011', '480', '389', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808341', '129', '1759', '2011', '451', '395', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808342', '147', '1759', '2011', '439', '389', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808343', '3', '1759', '2011', '458', '399', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808344', '205', '1759', '2011', '432', '385', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808345', '205', '1759', '2012', '425', '398', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808346', '129', '1759', '2012', '502', '495', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808347', '129', '1759', '2012', '494', '406', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808348', '205', '1759', '2012', '486', '486', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808349', '112', '1759', '2012', '487', '487', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808350', '147', '1759', '2012', '472', '416', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808351', '37', '1759', '2012', '489', '488', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808352', '37', '1759', '2012', '434', '402', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808353', '3', '1759', '2012', '475', '409', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808354', '85', '1759', '2013', '492', '470', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808355', '105', '1759', '2013', '471', '471', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808356', '310', '1759', '2013', '513', '472', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808357', '40', '1759', '2013', '465', '465', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808358', '237', '1759', '2013', '458', '458', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808359', '141', '1759', '2013', '456', '456', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808360', '174', '1759', '2013', '477', '469', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808361', '113', '1759', '2013', '497', '481', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808450', '329', '2258', '2011', '484', '484', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('808451', '352', '2258', '2012', '475', '462', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808452', '78', '2258', '2012', '468', '460', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808453', '329', '2258', '2012', '490', '465', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808454', '69', '2258', '2012', '477', '465', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808455', '329', '2258', '2012', '533', '533', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('808456', '377', '2258', '2013', '482', '482', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808457', '168', '2258', '2013', '456', '456', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808458', '8', '2258', '2013', '455', '455', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808459', '260', '2258', '2013', '502', '495', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('808460', '4315', '2258', '2013', '445', '445', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808461', '260', '2258', '2013', '460', '450', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808462', '4530', '2258', '2013', '454', '454', '1', '3', '13');
INSERT INTO `major_recruit` VALUES ('808463', '329', '2258', '2011', '481', '478', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808464', '78', '2258', '2012', '440', '410', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808465', '329', '2258', '2012', '456', '408', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808466', '69', '2258', '2012', '400', '396', '2', '3', '13');
INSERT INTO `major_recruit` VALUES ('808467', '4530', '2258', '2013', '459', '459', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808468', '260', '2258', '2013', '460', '460', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808469', '10', '2557', '2013', '503', '488', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('808470', '13', '2557', '2013', '517', '489', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('808471', '4429', '2557', '2013', '518', '494', '1', '2', '13');
INSERT INTO `major_recruit` VALUES ('808472', '10', '2557', '2013', '516', '468', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808473', '29', '2557', '2013', '489', '464', '2', '2', '13');
INSERT INTO `major_recruit` VALUES ('808474', '4429', '2557', '2013', '463', '459', '2', '2', '13');

-- ----------------------------
-- Table structure for question
-- ----------------------------
DROP TABLE IF EXISTS `question`;
CREATE TABLE `question` (
  `questionId` int(10) NOT NULL AUTO_INCREMENT,
  `questionContent` varchar(100) DEFAULT NULL,
  `questionTime` varchar(20) DEFAULT NULL,
  `answerContent` varchar(100) DEFAULT NULL,
  `answerTime` varchar(100) DEFAULT NULL,
  `questionStatus` varchar(20) DEFAULT NULL,
  PRIMARY KEY (`questionId`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of question
-- ----------------------------
INSERT INTO `question` VALUES ('1', 'test', '2016-01-25 02:49', '1234678', '2016-01-25 04:02', '未审核');
INSERT INTO `question` VALUES ('2', 'hello', '2016-01-25 02:53', 'haha#www#ttt', '2016-01-25 03:38#2016-01-25 03:47#2016-01-25 03:47', '未审核');
INSERT INTO `question` VALUES ('3', 'get', '2016-01-25 02:56', null, null, '暂未回复');
INSERT INTO `question` VALUES ('4', 'ddd', '2016-01-25 04:13', 'ff', '2016-01-25 04:13', '未审核');

-- ----------------------------
-- Table structure for school
-- ----------------------------
DROP TABLE IF EXISTS `school`;
CREATE TABLE `school` (
  `schoolId` smallint(6) NOT NULL DEFAULT '0',
  `schoolName` varchar(50) DEFAULT NULL,
  `schoolCode` int(10) DEFAULT NULL,
  `areaId` smallint(3) NOT NULL DEFAULT '0',
  `is985` bit(1) NOT NULL,
  `is211` bit(1) NOT NULL,
  `isMinistry` bit(1) NOT NULL,
  PRIMARY KEY (`schoolId`),
  KEY `areaId` (`areaId`),
  CONSTRAINT `school_ibfk_1` FOREIGN KEY (`areaId`) REFERENCES `area` (`areaId`),
  CONSTRAINT `school_ibfk_2` FOREIGN KEY (`areaId`) REFERENCES `area` (`areaId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of school
-- ----------------------------
INSERT INTO `school` VALUES ('5', '北京大学', '10001', '34', '', '', '');
INSERT INTO `school` VALUES ('6', '清华大学', '10003', '34', '', '', '');
INSERT INTO `school` VALUES ('8', '浙江大学', '10335', '10', '', '', '');
INSERT INTO `school` VALUES ('14', '复旦大学', '10246', '3', '', '', '');
INSERT INTO `school` VALUES ('16', '上海中医药大学', '10268', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('22', '同济大学', '10247', '3', '', '', '');
INSERT INTO `school` VALUES ('27', '中国人民大学', '10002', '34', '', '', '');
INSERT INTO `school` VALUES ('28', '北京理工大学', '10007', '34', '', '', '\0');
INSERT INTO `school` VALUES ('31', '上海大学', '10280', '3', '\0', '', '\0');
INSERT INTO `school` VALUES ('39', '中央财经大学', '10034', '34', '\0', '', '');
INSERT INTO `school` VALUES ('44', '上海交通大学', '10248', '3', '', '', '');
INSERT INTO `school` VALUES ('45', '上海财经大学', '10272', '3', '\0', '', '');
INSERT INTO `school` VALUES ('48', '南昌大学', '10403', '13', '\0', '', '\0');
INSERT INTO `school` VALUES ('51', '北京师范大学', '10027', '34', '', '', '');
INSERT INTO `school` VALUES ('57', '北京航空航天大学', '10006', '34', '', '', '\0');
INSERT INTO `school` VALUES ('59', '华东师范大学', '10269', '3', '', '', '');
INSERT INTO `school` VALUES ('61', '北京邮电大学', '10013', '34', '\0', '', '');
INSERT INTO `school` VALUES ('68', '华东理工大学', '10251', '3', '\0', '', '');
INSERT INTO `school` VALUES ('75', '中国传媒大学', '10033', '34', '\0', '', '');
INSERT INTO `school` VALUES ('79', '北京交通大学', '10004', '34', '\0', '', '');
INSERT INTO `school` VALUES ('86', '北京科技大学', '10008', '34', '\0', '', '');
INSERT INTO `school` VALUES ('90', '对外经济贸易大学', '10036', '34', '\0', '', '');
INSERT INTO `school` VALUES ('95', '上海理工大学', '10252', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('97', '江西财经大学', '10421', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('99', '北京工业大学', '10005', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('105', '华北电力大学', null, '34', '\0', '', '');
INSERT INTO `school` VALUES ('107', '中国农业大学', '10019', '34', '', '', '');
INSERT INTO `school` VALUES ('110', '中国计量学院', '10356', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('112', '中国政法大学', '10053', '34', '\0', '', '');
INSERT INTO `school` VALUES ('115', '北京外国语大学', '10030', '34', '\0', '', '');
INSERT INTO `school` VALUES ('127', '上海海事大学', '10254', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('130', '浙江理工大学', '10338', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('131', '东华大学', '10255', '3', '\0', '', '');
INSERT INTO `school` VALUES ('144', '浙江工业大学', '10337', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('147', '南昌航空大学', '10406', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('150', '中央民族大学', '10052', '34', '', '', '\0');
INSERT INTO `school` VALUES ('158', '上海师范大学', '10270', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('159', '江西理工大学', '10407', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('160', '首都经济贸易大学', '10038', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('162', '华东交通大学', '10404', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('169', '北京联合大学', '11417', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('172', '上海金融学院', '11639', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('175', '北京林业大学', '10022', '34', '\0', '', '');
INSERT INTO `school` VALUES ('180', '上海立信会计学院', '11047', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('209', '上海外国语大学', '10271', '3', '\0', '', '');
INSERT INTO `school` VALUES ('210', '北京化工大学', '10010', '34', '\0', '', '');
INSERT INTO `school` VALUES ('218', '东华理工大学', '10405', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('219', '浙江工商大学', '10353', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('221', '中国人民公安大学', '10041', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('231', '宁波大学', '11646', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('234', '杭州电子科技大学', '10336', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('242', '上海商学院', '12050', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('244', '上海工程技术大学', '10856', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('247', '北京中医药大学', '10026', '34', '\0', '', '');
INSERT INTO `school` VALUES ('249', '浙江传媒学院', '11647', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('254', '江西师范大学', '10414', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('255', '北京工商大学', '10011', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('257', '上海海洋大学', '10264', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('259', '华东政法大学', '10276', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('262', '首都师范大学', '10028', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('278', '北京城市学院', '11418', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('279', '上海海关学院', '10274', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('282', '上海电力学院', '10256', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('289', '杭州师范大学', '10346', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('294', '北京建筑大学', '10016', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('297', '上海对外经贸大学', '10273', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('299', '首都医科大学', '10025', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('306', '浙江财经大学', '11482', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('313', '上海应用技术学院', '10259', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('314', '九江学院', '11843', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('315', '江西科技学院', '10846', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('316', '上海第二工业大学', '12044', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('324', '浙江师范大学', '10345', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('329', '江西农业大学', '10410', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('331', '北京电子科技学院', '10018', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('348', '丽水学院', '10352', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('358', '中华女子学院', '11149', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('363', '北京语言大学', '10032', '34', '\0', '\0', '');
INSERT INTO `school` VALUES ('366', '中国石油大学（北京校区）', null, '34', '\0', '', '');
INSERT INTO `school` VALUES ('368', '上海政法学院', '11835', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('373', '北京信息科技大学', '11232', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('376', '南昌工程学院', '11319', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('387', '北方工业大学', '10009', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('394', '温州大学', '10351', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('395', '嘉兴学院', '10354', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('412', '浙江科技学院', '11057', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('418', '北京物资学院', '10037', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('423', '北京体育大学', '10043', '34', '\0', '', '\0');
INSERT INTO `school` VALUES ('425', '南昌理工学院', '12795', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('428', '浙江农林大学', '10341', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('429', '中国劳动关系学院', '12453', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('443', '江西科技师范大学', '11318', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('444', '中国青年政治学院', '11625', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('447', '井冈山大学', '10419', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('450', '浙江大学城市学院', '13021', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('455', '温州医科大学', '10343', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('458', '北京石油化工学院', '10017', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('473', '上海电机学院', '11458', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('475', '北京.中国地质大学', null, '34', '\0', '', '');
INSERT INTO `school` VALUES ('479', '外交学院', '10040', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('483', '浙江工业大学之江学院', '13275', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('503', '宁波工程学院', '11058', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('506', '浙江海洋学院', '10340', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('510', '北京服装学院', '10012', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('511', '国际关系学院', '10042', '34', '\0', '\0', '');
INSERT INTO `school` VALUES ('514', '北京大学医学部', '19001', '34', '', '', '');
INSERT INTO `school` VALUES ('517', '宁波诺丁汉大学', '16301', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('523', '北京第二外国语学院', '10031', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('531', '北京翻译研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('534', '解放军第二军医大学', null, '3', '\0', '', '\0');
INSERT INTO `school` VALUES ('539', '江西中医药大学', '10412', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('541', '首都师范大学科德学院', '13629', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('544', '赣南医学院', '10413', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('548', '台州学院', '10350', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('560', '景德镇陶瓷学院', '10408', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('566', '绍兴文理学院', '10349', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('571', '北京工商大学嘉华学院', '13630', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('581', '北京印刷学院', '10015', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('586', '上海杉达学院', '11833', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('594', '宜春学院', '10417', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('598', '上海交通大学医学院', '19248', '3', '', '', '');
INSERT INTO `school` VALUES ('600', '浙江万里学院', '10876', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('605', '赣南师范学院', '10418', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('613', '北京邮电大学世纪学院', '13901', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('615', '上海建桥学院', '12799', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('627', '北京农学院', '10020', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('646', '浙江中医药大学', '10344', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('663', '浙江大学宁波理工学院', '13022', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('675', '上海外国语大学贤达经济人文学院', '13636', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('682', '中国矿业大学(北京)', '11413', '34', '\0', '', '');
INSERT INTO `school` VALUES ('696', '上海师范大学天华学院', '13893', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('703', '北京协和医学院', '10023', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('715', '中国信息大学', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('728', '上海医药高等专科学校', '14033', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('730', '北京吉利大学', '12802', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('749', '中国计量学院现代科技学院', '13292', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('753', '上海体育大学', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('756', '湖州师范学院', '10347', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('757', '上饶师范学院', '10416', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('780', '北京第二外国语学院中瑞酒店管理学院', '14201', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('781', '浙江外国语学院', '14275', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('784', '北京工业大学耿丹学院', '13904', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('809', '新余学院', '11508', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('841', '北京科技职业学院', '13703', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('855', '上海音乐学院', '10278', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('871', '北京电子科技职业学院', '10858', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('876', '浙江师范大学行知学院', '13276', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('877', '北京财贸职业学院', '12561', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('878', '北京第二外国语学院留学国际本科、硕士项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('888', '北京电影学院', '10050', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('889', '北京信息职业技术学院', '10857', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('891', '上海大学悉尼工商学院', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('894', '同济大学浙江学院', '14206', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('901', '中国人民解放军装甲兵工程学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('911', '宁波大学科学技术学院', '13277', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('924', '北京工业职业技术学院', '10853', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('934', '九江职业技术学院', '11785', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('942', '公安海警学院', '10829', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('951', '上海医疗器械高等专科学校', '10262', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('954', '北京科技经营管理学院', '12733', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('967', '立信国际', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('968', '南昌大学共青学院', '13430', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('978', '北京人文大学', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('980', '江西警察学院', '11504', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('985', '上海旅游高等专科学校', '10275', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1011', '浙江金融职业学院', '12870', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1028', '江西财经大学现代经济管理学院', '13441', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1032', '中央音乐学院', '10045', '34', '\0', '', '');
INSERT INTO `school` VALUES ('1038', '浙江工商大学杭州商学院', '13290', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1051', '衢州学院', '11488', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1053', '上海理工大学中英国际学院', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1055', '北京青年政治学院', '11626', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1060', '华东交通大学理工学院', '13431', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1065', '上海财经大学浙江学院', '14207', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1067', '中央美术学院', '10047', '34', '\0', '\0', '');
INSERT INTO `school` VALUES ('1083', '中国美术学院', '10355', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1089', '浙江警察学院', '11483', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1122', '南昌大学科学技术学院', '13429', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1127', '首钢工学院', '11831', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1134', '解放军陆军航空兵学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1138', '中央戏剧学院', '10048', '34', '\0', '\0', '');
INSERT INTO `school` VALUES ('1139', '北京经贸职业学院', '12565', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1144', '上海戏剧学院', '10279', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1157', '温州大学瓯江学院', '13289', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1164', '北京政法职业学院', '12451', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1166', '北京经济技术职业学院', '12566', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1186', '解放军装备学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1188', '北京劳动保障职业学院', '14075', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1189', '北京民族大学', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1190', '上海健康职业技术学院', '14292', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1200', '上海东海职业技术学院', '10851', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1208', '上海视觉艺术学院', '13632', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1214', '江西中医药高等专科学校', '13775', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1230', '北京农业职业学院', '12448', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1234', '解放军防化学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1235', '上海财经大学国际教育学院', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1236', '温州医科大学仁济学院', '13284', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1240', '上海海事职业技术学院', '12498', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1257', '首都体育学院', '10029', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1271', '北京交通职业技术学院', '13910', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1296', '北京汇佳职业学院', '12568', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1309', '江西师范大学科学技术学院', '13438', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1311', '北京国际经贸学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1318', '北京北大方正软件技术学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1321', '浙江商业职业技术学院', '12865', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1324', '浙江越秀外国语学院', '12792', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1329', '江西中医药大学科技学院', null, '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1338', '上海民航职业技术学院', '14394', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1348', '上海济光职业技术学院', '12798', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1349', '上海中医药大学中药学院', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1353', '江西理工大学应用科学学院', '13434', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1357', '杭州师范大学钱江学院', '13286', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1358', '浙江建设职业技术学院', '12862', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1371', '北京经济管理职业学院', '14073', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1381', '南昌航空大学科技学院', '13433', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1383', '浙江财经学院东方学院', null, '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1386', '南昌职业学院', '13420', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1398', '北京培黎职业学院', '13728', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1411', '上海城市管理职业技术学院', '12495', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1413', '江西农业大学南昌商学院', '13436', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1418', '江西财经职业学院', '12941', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1420', '浙江水利水电学院', '11481', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1427', '北京东方大学', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1432', '宁波大红鹰学院', '13001', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1437', '上海工艺美术职业学院', '12588', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1440', '景德镇学院', '10894', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1445', '杭州电子科技大学信息工程学院', '13279', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1448', '北京国际商务学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1452', '浙江树人学院', '11842', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1456', '浙江中医药大学滨江学院', '13285', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1459', '上海公安高等专科学校', '10283', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1463', '嘉兴学院南湖学院', '13291', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1466', '湖州师范学院求真学院', '13287', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1467', '九江职业大学', '11505', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1472', '浙江工商职业技术学院', '12789', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1475', '北京现代职业技术学院', '12569', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1478', '台州职业技术学院', '12790', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1482', '东华理工大学长江学院', '13432', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1497', '北京交通运输职业学院', '14279', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1501', '北京京北职业技术学院', '11090', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1508', '上海建峰', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1510', '浙江海洋学院东海科学技术学院', '13282', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1516', '南昌师范高等专科学校', '13774', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1525', '北京舞蹈学院', '10051', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1531', '浙江经贸职业技术学院', '12864', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1536', '江西科技师范大学理工学院', '13440', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1543', '杭州之江专修学院', null, '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1546', '江西电力职业技术学院', '12933', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1548', '上海立达职业技术学院', '12587', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1553', '江西经济管理干部学院', '51285', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1554', '北京联合大学商务学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1557', '浙江理工大学科技与艺术学院', '13280', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1591', '中国戏曲学院', '10049', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1594', '江西外语外贸职业学院', '13422', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1598', '中国人民大学财政金融学院', null, '34', '', '', '\0');
INSERT INTO `school` VALUES ('1599', '温州大学城市学院', '13637', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1604', '中国音乐学院', '10046', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1614', '上海出版印刷高等专科学校', '11733', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1618', '浙江农林大学天目学院', '13283', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1620', '上海电子信息职业技术学院', '12499', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1623', '江西护理职业技术学院', '13965', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1625', '上海科学技术职业学院', '12801', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1633', '金华职业技术学院', '12061', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1644', '江西建设职业技术学院', '13427', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1645', '绍兴文理学院元培学院', '13288', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1647', '上海欧文经济学院', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1655', '北京建设大学', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1657', '江西渝州科技职业学院', '12766', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1662', '宁波职业技术学院', '10863', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1663', '浙江机电职业技术学院', '12861', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1671', '北京戏曲艺术职业学院', '12567', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1673', '上海应用技术学院泰尔弗国际商学院', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1674', '上海思博职业技术学院', '12586', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1695', '上海工商外国语职业学院', '12800', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1696', '江西旅游商贸职业学院', '12932', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1701', '萍乡学院', '10895', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1702', '北京黄埔大学', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1704', '江西城市职业学院', '12938', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1706', '浙江医药高等专科学校', '11956', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1708', '现代管理大学', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1711', '北京联合大学师范学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1715', '北京美国英语语言学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1721', '北京舞蹈学院继续教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1728', '上海中侨职业技术学院', '12915', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1729', '江西现代职业技术学院', '12943', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1735', '湖州职业技术学院', '12875', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1740', '中国管理软件学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1741', '景德镇陶瓷学院科技艺术学院', '13435', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1744', '首都师范大学继续教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1750', '浙江经济职业技术学院', '12866', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1751', '北京工商管理专修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1753', '上海中华职业技术学院', '13907', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1759', '南昌工学院', '13421', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1763', '上海新侨职业技术学院', '10852', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1766', '北京联合大学广告学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1770', '杭州职业技术学院', '12872', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1772', '浙江医学高等专科学校', '13023', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1773', '江西工业职业技术学院', '10839', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1774', '江西环境工程职业学院', '12934', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1776', '江西司法警官职业学院', '12929', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1786', '赣南师范学院科技学院', '13439', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1788', '浙江长征职业技术学院', '13027', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1789', '浙江警官职业学院', '12869', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1798', '温州职业技术学院', '10864', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1805', '江西应用技术职业学院', '12942', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1811', '北京卫生职业学院', '14395', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1817', '江西交通职业技术学院', '12940', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1822', '浙江横店影视职业学院', '14090', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1833', '上海建峰职业技术学院', '12916', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1838', '华东师范大学中澳班', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1840', '上海工会管理职业学院', '14023', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1849', '上海震旦职业学院', '12583', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1858', '宁波卫生职业技术学院', '13742', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1866', '北京华夏管理学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1874', '上海农林职业技术学院', '12912', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1877', '解放军艺术学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1879', '上海行健职业学院', '12493', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1880', '浙江旅游职业学院', '12867', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1884', '江西机电职业技术学院', '12976', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1891', '江西信息应用职业技术学院', '12939', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1895', '武警北京指挥学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1898', '东华大学莱佛士国际设计专修学院', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1899', '江西科技职业学院', '13419', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1904', '江西工程职业学院', '13868', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1912', '北京理工大学远程教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1920', '上海兴韦信息技术职业学院', '12914', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1922', '宜春职业技术学院', '13424', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1936', '上海邦德职业技术学院', '12913', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1944', '华东师范大学中外合作项目', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1949', '杭州科技职业技术学院', '13026', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1951', '江西航空职业技术学院', '13871', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1969', '浙江交通职业技术学院', '12036', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1971', '北京社会管理职业学院', '14139', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1974', '杭州万向职业技术学院', '13030', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1975', '宁波城市职业技术学院', '12645', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1981', '北京中山学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('1993', '北京科技大学国际学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2022', '江西农业工程职业学院', '13872', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2024', '上海欧华职业技术学院', '12585', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2032', '北方工商管理学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2039', '北京现代音乐研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2041', '江西生物科技职业学院', '13426', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2044', '嘉兴职业技术学院', '12874', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2051', '义乌工商职业技术学院', '13003', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2057', '江西陶瓷工艺美术职业技术学院', '12930', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2059', '北京联合大学应用文理学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2076', '锦江国际理诺士酒店管理学院', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2077', '赣西科技职业学院', '13873', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2081', '温州科技职业学院', '14088', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2088', '绍兴职业技术学院', '12876', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2091', '江西赣江职业技术学院', null, '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2098', '浙江第二师范学院', null, '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2099', '北京金融学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2101', '上海电影艺术职业学院', '13747', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2119', '江西工业贸易职业技术学院', '13423', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2120', '浙江育英职业技术学院', '12868', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2127', '江西青年职业学院', '13869', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2128', '浙江工贸职业技术学院', '12791', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2132', '浙江工业职业技术学院', '12871', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2146', '浙江同济科技职业学院', '12647', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2154', '江西应用工程职业学院', '13425', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2167', '江西工业工程职业技术学院', '12944', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2168', '上海博华教育集团美国部', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2171', '浙江艺术职业学院', '12863', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2175', '丽水职业技术学院', '12878', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2176', '江西先锋软件职业技术学院', '13776', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2188', '宁波教育学院', '50559', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2194', '北京服装学院莱佛士国际学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2195', '浙江广厦建设职业技术学院', '13029', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2201', '江西艺术职业学院', '12936', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2204', '江西制造职业技术学院', '13867', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2225', '上海大学ACCA国际项目', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2234', '嘉兴南洋职业技术学院', '13028', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2238', '浙江电力职业技术学院', '12646', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2258', '江西服装学院', '13418', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2260', '武警政治学院', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2272', '上海民远职业技术学院', '12584', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2278', '江西医学院上饶分院', '10888', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2284', '浙江东方职业技术学院', '13002', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2285', '江西服装职业技术学院', null, '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2287', '解放军南昌陆军学院', null, '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2288', '浙江纺织服装职业技术学院', '13025', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2298', '北京旅游专修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2303', '北京新圆明职业学院', '14140', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2308', '上海纽约大学', '16404', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2319', '抚州职业技术学院', '13428', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2324', '北京财经专修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2326', '浙江国际海运职业技术学院', '13853', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2346', '国家检察官学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2352', '江西太阳能科技职业学院', '14166', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2353', '衢州职业技术学院', '12877', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2365', '浙江汽车职业技术学院', '14089', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2385', '立信CMA考试培训美国注册管理会计师', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2402', '台州科技职业学院', '13746', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2404', '武警警种学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2406', '北京经济研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2412', '江西冶金职业技术学院', '14241', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2414', '首都经济贸易大学密云分校', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2416', '北京计算机专修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2426', '浙江邮电职业技术学院', '13688', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2429', '浙江体育职业技术学院', '13854', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2430', '北京体育职业学院', '14215', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2436', '鹰潭职业技术学院', '12937', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2437', '北京英迪经贸学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2439', '上海体育职业学院', '14179', '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2473', '江西泰豪动漫职业学院', '14168', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2479', '北京警察学院', '14019', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2480', '北京锡华国际经贸职业学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2487', '北京文理研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2489', '中国人民大学HND项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2498', '北京前进大学', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2503', '北京理工大学国际教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2505', '北京会计专修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2507', '北京艾思蒙特高级时装艺术学校', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2514', '北京理工大学继续教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2515', '北京工业大学通州分校', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2518', '江西新闻出版职业技术学院', '14250', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2519', '北京高等秘书研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2523', '上饶职业技术学院', '13870', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2533', '北京理工大学房山分校培训中心', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2538', '解放军后勤学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2542', '北京兴华大学', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2547', '中国政法大学继续教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2549', '北京航空航天大学英美留学本硕连读（商务、金融、计算机）', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2550', '江西枫林涉外经贸职业学院', '14167', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2555', '解放军空军指挥学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2557', '南昌师范学院', '14437', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2567', '北京自修大学', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2572', '北京航空航天大学软件学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2575', '首都经济贸易大学华侨学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2576', '中国政法大学职业能力教育中心', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2583', '北京北大资源研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2586', '华北电力大学电气工程及其自动化专业国际合作班2+2', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2588', '北京应用技术大学', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2599', '北京邮电大学国际学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2601', '对外经济贸易大学远程教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2604', '首都师范大学科德学院高教自考', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2609', '浙江农业商贸职业学院', '14269', '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2624', '上海光华进修学院', null, '3', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2625', '北京师范大学HND', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2629', '北京理工大学SQA-HND项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2635', '南昌教育学院', '51283', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2637', '中国政法大学司法考试学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2643', '北京明园大学', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2648', '景德镇陶瓷职业技术学院', '14402', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2651', '清华大学与香港中文大学合作举办工商管理硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2653', '首都经济贸易大学HND', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2654', '北京京海研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2655', '北京科技大学延庆分校', '19008', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2656', '北京电影学院继续教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2659', '中国农业大学国际学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2663', '中国石油大学（北京）网络学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2665', '北京邮电大学世纪学院HND', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2666', '北京邮电大学继续教育学院职业教育', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2669', '中央财经大学与澳大利亚维多利亚大学合作举办国际经济与贸易专业本科教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2672', '西卡国际设计学校', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2676', '北京中新企业管理学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2677', '江西管理职业学院', '14249', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2681', '中国人民大学培训学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2683', '东方文化艺术学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2685', '北京航空航天大学中法工程师学院', '16101', '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2688', '江西工商职业技术学院', '14321', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2689', '北京涉外经济专修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2690', '北京邮电大学与英国伦敦大学玛丽女王学院合作本科及硕士研究生教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2691', '中央财经大学HND', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2692', '对外经济贸易大学HND', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2694', '北京工业大学3+1本硕连读项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2696', '北京卓达经济管理研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2698', '北京珠宝首饰研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2700', '北京卡秋莎俄语学校', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2702', '北京外国语大学远程教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2704', '北京交通大学远程与继续教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2705', '北京科技大学继续教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2708', '北京邮电大学软件学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2709', '北京东方研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2713', '赣南教育学院', null, '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2714', '北京航空航天大学远程教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2715', '北京语言大学网络教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2716', '北京军地专修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2719', '清华大学与美国天普大学合作举办法学硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2720', '北京服装学院国际学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2722', '中国传媒大学远程与继续教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2723', '北京建筑工程学院国际合作交流处', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2724', '对外经济贸易大学与美国马里兰大学合作举办工商管理硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2725', '中央财经大学国际教育中心', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2726', '北京邮电大学远程教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2727', '首都经济贸易大学与澳大利亚迪肯大学合作举办会计学硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2730', '北京师范大学网络教育', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2732', '北京演艺专修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2733', '北京中医药大学远程教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2735', '中国人民大学网络学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2736', '北京物资学院继续教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2737', '北京大学与香港理工大学合作举办中国社会工作文学硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2739', '中国政法大学民商法学院中外合作项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2740', '中国政法大学中美本硕连读项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2741', '北京航空航天大学与美国佛罗里达国际大学合作举办计算机科学硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2743', '北京航空航天大学与澳大利亚墨尔本大学合作举办市场营销硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2744', '华北电力大学培训学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2746', '北京大学与美国福坦莫大学 / 比利时弗拉瑞克-鲁汶-根特管理学院合作举办工商管理硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2747', '中央财经大学网络教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2748', '北京石油化工学院国际教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2749', '北京邮电大学网络教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2750', '首都师范大学HND', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2751', '清华大学与澳大利亚麦考瑞大学合作举办应用金融硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2752', '国际关系学院继续教育部', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2753', '北京科技大学与美国德克萨斯大学阿灵顿分校合作举办工商管理硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2754', '北京大学与香港大学合作举办牙医硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2755', '清华大学与澳大利亚悉尼科技大学合作举办体育管理硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2756', '对外经济贸易大学与法国巴黎第一大学、法国国家企业管理教育基金会合作举办企业管理硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2757', '中央财经大学与美国史蒂文斯理工学院合作举办项目管理理学硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2758', '首都经济贸易大学与美国莱特州立大学合作举办工商管理硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2760', '浙江大学宁波理工学院国际交流中心', null, '10', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2761', '对外经济贸易大学与法国兰斯高等工商管理学院合作举办零售管理硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2764', '北京交通大学与澳大利亚维多利亚大学合作举办工商管理硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2765', '中国政法大学中美名校“2+3”硕士项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2766', '北京理工大学与美国史蒂文斯理工学院合作举办微电子学与光子学硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2767', '江西教育学院赣南分院', null, '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2769', '中国农业大学网络学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2770', '北京理工大学与英国瑞丁大学合作举办信息科学硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2771', '中国科学院研究生院与香港中文大学合作举办心理咨询与治疗文学硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2773', '首都师范大学国际文化学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2774', '中国科学院大学', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2776', '中国逻辑与语言函授大学', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2777', '北京心理学函授学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2779', '现代管理大学民航管理学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2780', '北京工业大学中美双学位国际项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2783', '北京交通大学与澳大利亚维多利亚大学合作举办企业资源计划系统硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2784', '北京理工大学与美国史蒂文斯理工学院合作举办电信管理硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2785', '北京企业管理研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2786', '清华大学与澳大利亚国立大学合作举办管理硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2787', '北京理工大学与德国德累斯顿工业大学合作举办职业技术教育理学硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2788', '共青科技职业学院', '14403', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2789', '北京科技大学远程教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2790', '北京大学远程教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2791', '北京体育大学与美国俄亥俄大学合作举办体育管理硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2793', '北京大学与澳大利亚拉筹伯大学合作举办卫生事业管理硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2794', '北京服装学院HND项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2798', '北京理工大学与澳大利亚新南威尔士大学合作举办通信工程硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2801', '中国科学院研究生院与香港理工大学合作举办软件科技理学硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2802', '北京华大研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2803', '北京瀚林职业研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2804', '北京涉外设计艺术学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2806', '北京社会函授大学', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2808', '北京长城研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2809', '中央音乐学院远程教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2812', '北京科技大学与比利时鲁汶工程技术学院合作举办电子媒体工程硕士学位教育项目', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2813', '北京影视研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2816', '北京联合大学特殊教育学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2818', '中国政法大学留学服务中心', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2819', '北京联合大学应用科技学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2823', '北京礼仪专修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2824', '南昌钢铁有限责任公司职工大学', '50607', '13', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2825', '中关村创新研修学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2827', '北京联合大学旅游学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2829', '国家留学基金委员留学预科学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2830', '北京邮电大学宏福校区', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2832', '北京联合大学管理学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2833', '北京华嘉实用文化艺术学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2840', '北京联合大学自动化学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2841', '北京联合大学生物化学工程学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2843', '北京联合大学机电学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2846', '北京联合大学信息学院', null, '34', '\0', '\0', '\0');
INSERT INTO `school` VALUES ('2852', '中国石油大学(北京)', '0', '34', '\0', '\0', '\0');

-- ----------------------------
-- Table structure for school_recruit
-- ----------------------------
DROP TABLE IF EXISTS `school_recruit`;
CREATE TABLE `school_recruit` (
  `sRecruitId` int(10) NOT NULL DEFAULT '0',
  `schoolId` smallint(6) DEFAULT NULL,
  `sRecruitYear` smallint(5) DEFAULT NULL,
  `batchId` smallint(5) DEFAULT NULL,
  `categoryId` smallint(5) DEFAULT NULL,
  `areaId` smallint(5) DEFAULT NULL,
  `sRecruitAScore` smallint(5) DEFAULT NULL,
  `sRecruitHScore` smallint(5) DEFAULT NULL,
  `enterLine` smallint(5) DEFAULT NULL,
  PRIMARY KEY (`sRecruitId`),
  KEY `areaId` (`areaId`),
  KEY `batchId` (`batchId`),
  KEY `categoryId` (`categoryId`),
  KEY `schoolId` (`schoolId`),
  CONSTRAINT `school_recruit_ibfk_1` FOREIGN KEY (`areaId`) REFERENCES `area` (`areaId`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `school_recruit_ibfk_2` FOREIGN KEY (`batchId`) REFERENCES `batch` (`batchId`),
  CONSTRAINT `school_recruit_ibfk_3` FOREIGN KEY (`categoryId`) REFERENCES `category` (`categoryId`),
  CONSTRAINT `school_recruit_ibfk_4` FOREIGN KEY (`schoolId`) REFERENCES `school` (`schoolId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of school_recruit
-- ----------------------------
INSERT INTO `school_recruit` VALUES ('2392', '5', '2013', '1', '1', '34', '604', '659', '0');
INSERT INTO `school_recruit` VALUES ('2393', '5', '2012', '1', '1', '34', '622', '670', '0');
INSERT INTO `school_recruit` VALUES ('2394', '5', '2011', '1', '1', '34', '645', '675', '0');
INSERT INTO `school_recruit` VALUES ('2395', '5', '2010', '1', '1', '34', '639', '675', '0');
INSERT INTO `school_recruit` VALUES ('2399', '5', '2013', '1', '2', '34', '617', '685', '0');
INSERT INTO `school_recruit` VALUES ('2400', '5', '2012', '1', '2', '34', '660', '702', '0');
INSERT INTO `school_recruit` VALUES ('2401', '5', '2011', '1', '2', '34', '662', '690', '0');
INSERT INTO `school_recruit` VALUES ('2402', '5', '2010', '1', '2', '34', '663', '699', '0');
INSERT INTO `school_recruit` VALUES ('2407', '5', '2013', '2', '2', '34', '578', '651', '0');
INSERT INTO `school_recruit` VALUES ('2445', '5', '2010', '5', '1', '3', '545', '560', '0');
INSERT INTO `school_recruit` VALUES ('2451', '5', '2010', '5', '2', '3', '544', '553', '0');
INSERT INTO `school_recruit` VALUES ('2557', '5', '2010', '1', '1', '10', '690', '725', '0');
INSERT INTO `school_recruit` VALUES ('2562', '5', '2010', '5', '1', '10', '687', '688', '0');
INSERT INTO `school_recruit` VALUES ('2563', '5', '2010', '1', '2', '10', '686', '709', '0');
INSERT INTO `school_recruit` VALUES ('2603', '5', '2013', '1', '1', '13', '624', '634', '619');
INSERT INTO `school_recruit` VALUES ('2604', '5', '2012', '1', '1', '13', '654', '662', '646');
INSERT INTO `school_recruit` VALUES ('2605', '5', '2011', '1', '1', '13', '617', '635', '610');
INSERT INTO `school_recruit` VALUES ('2606', '5', '2010', '1', '1', '13', '604', '627', '596');
INSERT INTO `school_recruit` VALUES ('2611', '5', '2013', '1', '2', '13', '666', '673', '662');
INSERT INTO `school_recruit` VALUES ('2612', '5', '2012', '1', '2', '13', '680', '688', '675');
INSERT INTO `school_recruit` VALUES ('2613', '5', '2011', '1', '2', '13', '660', '690', '657');
INSERT INTO `school_recruit` VALUES ('2614', '5', '2010', '1', '2', '13', '644', '668', '634');
INSERT INTO `school_recruit` VALUES ('2923', '6', '2013', '1', '1', '34', '607', '666', '0');
INSERT INTO `school_recruit` VALUES ('2924', '6', '2012', '1', '1', '34', '615', '630', '0');
INSERT INTO `school_recruit` VALUES ('2925', '6', '2011', '1', '1', '34', '651', '673', '0');
INSERT INTO `school_recruit` VALUES ('2926', '6', '2010', '1', '1', '34', '643', '659', '0');
INSERT INTO `school_recruit` VALUES ('2933', '6', '2013', '1', '2', '34', '621', '692', '0');
INSERT INTO `school_recruit` VALUES ('2934', '6', '2012', '1', '2', '34', '659', '712', '0');
INSERT INTO `school_recruit` VALUES ('2935', '6', '2011', '1', '2', '34', '659', '688', '0');
INSERT INTO `school_recruit` VALUES ('2936', '6', '2010', '1', '2', '34', '660', '693', '0');
INSERT INTO `school_recruit` VALUES ('2979', '6', '2010', '5', '1', '3', '550', '550', '0');
INSERT INTO `school_recruit` VALUES ('2986', '6', '2010', '5', '2', '3', '545', '569', '0');
INSERT INTO `school_recruit` VALUES ('3109', '6', '2010', '1', '1', '10', '696', '705', '0');
INSERT INTO `school_recruit` VALUES ('3115', '6', '2010', '5', '1', '10', '685', '685', '0');
INSERT INTO `school_recruit` VALUES ('3116', '6', '2010', '1', '2', '10', '691', '720', '0');
INSERT INTO `school_recruit` VALUES ('3158', '6', '2013', '1', '1', '13', '628', '631', '626');
INSERT INTO `school_recruit` VALUES ('3159', '6', '2012', '1', '1', '13', '652', '656', '648');
INSERT INTO `school_recruit` VALUES ('3160', '6', '2011', '1', '1', '13', '619', '630', '615');
INSERT INTO `school_recruit` VALUES ('3161', '6', '2010', '1', '1', '13', '602', '608', '598');
INSERT INTO `school_recruit` VALUES ('3167', '6', '2013', '1', '2', '13', '669', '684', '663');
INSERT INTO `school_recruit` VALUES ('3168', '6', '2012', '1', '2', '13', '677', '692', '674');
INSERT INTO `school_recruit` VALUES ('3169', '6', '2011', '1', '2', '13', '666', '686', '659');
INSERT INTO `school_recruit` VALUES ('3170', '6', '2010', '1', '2', '13', '643', '662', '638');
INSERT INTO `school_recruit` VALUES ('3176', '6', '2010', '5', '2', '13', '643', '649', '0');
INSERT INTO `school_recruit` VALUES ('4098', '8', '2013', '1', '1', '34', '587', '625', '0');
INSERT INTO `school_recruit` VALUES ('4099', '8', '2013', '1', '2', '34', '612', '674', '0');
INSERT INTO `school_recruit` VALUES ('4100', '8', '2012', '1', '2', '34', '638', '657', '0');
INSERT INTO `school_recruit` VALUES ('4101', '8', '2011', '1', '2', '34', '626', '655', '0');
INSERT INTO `school_recruit` VALUES ('4102', '8', '2010', '1', '2', '34', '632', '665', '0');
INSERT INTO `school_recruit` VALUES ('4142', '8', '2013', '1', '1', '3', '474', '501', '0');
INSERT INTO `school_recruit` VALUES ('4143', '8', '2012', '1', '1', '3', '491', '499', '0');
INSERT INTO `school_recruit` VALUES ('4144', '8', '2011', '1', '1', '3', '530', '540', '0');
INSERT INTO `school_recruit` VALUES ('4146', '8', '2012', '1', '2', '3', '498', '517', '0');
INSERT INTO `school_recruit` VALUES ('4147', '8', '2011', '1', '2', '3', '532', '551', '0');
INSERT INTO `school_recruit` VALUES ('4148', '8', '2010', '1', '2', '3', '518', '544', '0');
INSERT INTO `school_recruit` VALUES ('4260', '8', '2010', '1', '1', '10', '652', '673', '0');
INSERT INTO `school_recruit` VALUES ('4267', '8', '2010', '1', '2', '10', '645', '681', '0');
INSERT INTO `school_recruit` VALUES ('4273', '8', '2010', '5', '2', '10', '610', '638', '0');
INSERT INTO `school_recruit` VALUES ('4314', '8', '2013', '1', '2', '13', '643', '651', '640');
INSERT INTO `school_recruit` VALUES ('4315', '8', '2012', '1', '2', '13', '656', '664', '654');
INSERT INTO `school_recruit` VALUES ('4316', '8', '2011', '1', '2', '13', '639', '653', '636');
INSERT INTO `school_recruit` VALUES ('4317', '8', '2010', '1', '2', '13', '619', '626', '608');
INSERT INTO `school_recruit` VALUES ('4323', '8', '2010', '5', '2', '13', '598', '615', '0');
INSERT INTO `school_recruit` VALUES ('7531', '14', '2013', '1', '1', '34', '597', '646', '0');
INSERT INTO `school_recruit` VALUES ('7532', '14', '2012', '1', '1', '34', '599', '614', '0');
INSERT INTO `school_recruit` VALUES ('7533', '14', '2011', '1', '1', '34', '627', '650', '0');
INSERT INTO `school_recruit` VALUES ('7534', '14', '2010', '1', '1', '34', '614', '655', '0');
INSERT INTO `school_recruit` VALUES ('7541', '14', '2013', '1', '2', '34', '614', '678', '0');
INSERT INTO `school_recruit` VALUES ('7542', '14', '2012', '1', '2', '34', '640', '670', '0');
INSERT INTO `school_recruit` VALUES ('7543', '14', '2011', '1', '2', '34', '637', '664', '0');
INSERT INTO `school_recruit` VALUES ('7544', '14', '2010', '1', '2', '34', '644', '682', '0');
INSERT INTO `school_recruit` VALUES ('7590', '14', '2013', '1', '1', '3', '472', '497', '0');
INSERT INTO `school_recruit` VALUES ('7591', '14', '2012', '1', '1', '3', '496', '525', '0');
INSERT INTO `school_recruit` VALUES ('7592', '14', '2011', '1', '1', '3', '532', '576', '0');
INSERT INTO `school_recruit` VALUES ('7593', '14', '2010', '1', '1', '3', '530', '553', '0');
INSERT INTO `school_recruit` VALUES ('7599', '14', '2010', '5', '1', '3', '517', '539', '0');
INSERT INTO `school_recruit` VALUES ('7604', '14', '2012', '1', '2', '3', '492', '557', '0');
INSERT INTO `school_recruit` VALUES ('7605', '14', '2011', '1', '2', '3', '527', '581', '0');
INSERT INTO `school_recruit` VALUES ('7606', '14', '2010', '1', '2', '3', '531', '553', '0');
INSERT INTO `school_recruit` VALUES ('7612', '14', '2010', '5', '2', '3', '515', '548', '0');
INSERT INTO `school_recruit` VALUES ('7732', '14', '2010', '1', '1', '10', '676', '687', '0');
INSERT INTO `school_recruit` VALUES ('7738', '14', '2010', '5', '1', '10', '666', '673', '0');
INSERT INTO `school_recruit` VALUES ('7742', '14', '2010', '1', '2', '10', '674', '687', '0');
INSERT INTO `school_recruit` VALUES ('7787', '14', '2013', '1', '1', '13', '610', '617', '609');
INSERT INTO `school_recruit` VALUES ('7788', '14', '2012', '1', '1', '13', '639', '644', '637');
INSERT INTO `school_recruit` VALUES ('7789', '14', '2011', '1', '1', '13', '605', '611', '601');
INSERT INTO `school_recruit` VALUES ('7790', '14', '2010', '1', '1', '13', '590', '596', '589');
INSERT INTO `school_recruit` VALUES ('7796', '14', '2010', '5', '1', '13', '567', '567', '0');
INSERT INTO `school_recruit` VALUES ('7799', '14', '2013', '1', '2', '13', '651', '661', '649');
INSERT INTO `school_recruit` VALUES ('7800', '14', '2012', '1', '2', '13', '663', '673', '660');
INSERT INTO `school_recruit` VALUES ('7801', '14', '2011', '1', '2', '13', '647', '656', '643');
INSERT INTO `school_recruit` VALUES ('7802', '14', '2010', '1', '2', '13', '626', '634', '626');
INSERT INTO `school_recruit` VALUES ('8566', '16', '2013', '1', '1', '3', '459', '471', '0');
INSERT INTO `school_recruit` VALUES ('8567', '16', '2012', '1', '1', '3', '472', '475', '0');
INSERT INTO `school_recruit` VALUES ('8568', '16', '2011', '1', '1', '3', '483', '523', '0');
INSERT INTO `school_recruit` VALUES ('8569', '16', '2010', '1', '1', '3', '481', '525', '0');
INSERT INTO `school_recruit` VALUES ('8572', '16', '2013', '2', '1', '3', '423', '444', '0');
INSERT INTO `school_recruit` VALUES ('8573', '16', '2012', '2', '1', '3', '427', '447', '0');
INSERT INTO `school_recruit` VALUES ('8574', '16', '2011', '2', '1', '3', '451', '472', '0');
INSERT INTO `school_recruit` VALUES ('8575', '16', '2010', '2', '1', '3', '444', '467', '0');
INSERT INTO `school_recruit` VALUES ('8580', '16', '2013', '1', '2', '3', '424', '444', '0');
INSERT INTO `school_recruit` VALUES ('8581', '16', '2012', '1', '2', '3', '454', '482', '0');
INSERT INTO `school_recruit` VALUES ('8582', '16', '2011', '1', '2', '3', '488', '512', '0');
INSERT INTO `school_recruit` VALUES ('8583', '16', '2010', '1', '2', '3', '484', '522', '0');
INSERT INTO `school_recruit` VALUES ('8588', '16', '2013', '2', '2', '3', '368', '406', '0');
INSERT INTO `school_recruit` VALUES ('8589', '16', '2012', '2', '2', '3', '420', '444', '0');
INSERT INTO `school_recruit` VALUES ('8590', '16', '2011', '2', '2', '3', '452', '479', '0');
INSERT INTO `school_recruit` VALUES ('8591', '16', '2010', '2', '2', '3', '455', '477', '0');
INSERT INTO `school_recruit` VALUES ('8639', '16', '2010', '1', '2', '10', '592', '629', '0');
INSERT INTO `school_recruit` VALUES ('11725', '22', '2013', '1', '2', '34', '608', '667', '0');
INSERT INTO `school_recruit` VALUES ('11726', '22', '2012', '1', '2', '34', '593', '649', '0');
INSERT INTO `school_recruit` VALUES ('11727', '22', '2011', '1', '2', '34', '610', '665', '0');
INSERT INTO `school_recruit` VALUES ('11728', '22', '2010', '1', '2', '34', '622', '646', '0');
INSERT INTO `school_recruit` VALUES ('11759', '22', '2013', '1', '1', '3', '467', '487', '0');
INSERT INTO `school_recruit` VALUES ('11760', '22', '2012', '1', '1', '3', '478', '501', '0');
INSERT INTO `school_recruit` VALUES ('11761', '22', '2011', '1', '1', '3', '508', '530', '0');
INSERT INTO `school_recruit` VALUES ('11762', '22', '2010', '1', '1', '3', '502', '526', '0');
INSERT INTO `school_recruit` VALUES ('11769', '22', '2012', '1', '2', '3', '492', '511', '0');
INSERT INTO `school_recruit` VALUES ('11770', '22', '2011', '1', '2', '3', '527', '557', '0');
INSERT INTO `school_recruit` VALUES ('11771', '22', '2010', '1', '2', '3', '514', '534', '0');
INSERT INTO `school_recruit` VALUES ('11778', '22', '2010', '5', '2', '3', '490', '506', '0');
INSERT INTO `school_recruit` VALUES ('11847', '22', '2010', '1', '1', '10', '643', '654', '0');
INSERT INTO `school_recruit` VALUES ('11852', '22', '2010', '1', '2', '10', '640', '682', '0');
INSERT INTO `school_recruit` VALUES ('11883', '22', '2013', '1', '2', '13', '629', '654', '624');
INSERT INTO `school_recruit` VALUES ('11884', '22', '2012', '1', '2', '13', '645', '664', '639');
INSERT INTO `school_recruit` VALUES ('11885', '22', '2011', '1', '2', '13', '627', '642', '622');
INSERT INTO `school_recruit` VALUES ('11886', '22', '2010', '1', '2', '13', '605', '633', '597');
INSERT INTO `school_recruit` VALUES ('11892', '22', '2010', '5', '2', '13', '587', '633', '0');
INSERT INTO `school_recruit` VALUES ('13867', '27', '2013', '1', '1', '34', '596', '643', '0');
INSERT INTO `school_recruit` VALUES ('13868', '27', '2012', '1', '1', '34', '598', '627', '0');
INSERT INTO `school_recruit` VALUES ('13869', '27', '2011', '1', '1', '34', '628', '646', '0');
INSERT INTO `school_recruit` VALUES ('13870', '27', '2010', '1', '1', '34', '614', '653', '0');
INSERT INTO `school_recruit` VALUES ('13876', '27', '2013', '1', '2', '34', '611', '673', '0');
INSERT INTO `school_recruit` VALUES ('13877', '27', '2012', '1', '2', '34', '629', '662', '0');
INSERT INTO `school_recruit` VALUES ('13878', '27', '2011', '1', '2', '34', '638', '662', '0');
INSERT INTO `school_recruit` VALUES ('13879', '27', '2010', '1', '2', '34', '640', '668', '0');
INSERT INTO `school_recruit` VALUES ('13927', '27', '2013', '1', '1', '3', '473', '499', '0');
INSERT INTO `school_recruit` VALUES ('13928', '27', '2012', '1', '1', '3', '498', '511', '0');
INSERT INTO `school_recruit` VALUES ('13929', '27', '2011', '1', '1', '3', '537', '549', '0');
INSERT INTO `school_recruit` VALUES ('13930', '27', '2010', '1', '1', '3', '521', '535', '0');
INSERT INTO `school_recruit` VALUES ('13936', '27', '2010', '5', '1', '3', '522', '526', '0');
INSERT INTO `school_recruit` VALUES ('13937', '27', '2013', '1', '2', '3', '441', '477', '0');
INSERT INTO `school_recruit` VALUES ('13938', '27', '2012', '1', '2', '3', '495', '504', '0');
INSERT INTO `school_recruit` VALUES ('13939', '27', '2011', '1', '2', '3', '528', '545', '0');
INSERT INTO `school_recruit` VALUES ('13940', '27', '2010', '1', '2', '3', '525', '544', '0');
INSERT INTO `school_recruit` VALUES ('14071', '27', '2010', '1', '1', '10', '679', '686', '0');
INSERT INTO `school_recruit` VALUES ('14077', '27', '2010', '5', '1', '10', '672', '673', '0');
INSERT INTO `school_recruit` VALUES ('14081', '27', '2010', '1', '2', '10', '671', '684', '0');
INSERT INTO `school_recruit` VALUES ('14087', '27', '2010', '5', '2', '10', '651', '660', '0');
INSERT INTO `school_recruit` VALUES ('14130', '27', '2013', '1', '1', '13', '610', '619', '603');
INSERT INTO `school_recruit` VALUES ('14131', '27', '2012', '1', '1', '13', '637', '645', '630');
INSERT INTO `school_recruit` VALUES ('14132', '27', '2011', '1', '1', '13', '603', '609', '599');
INSERT INTO `school_recruit` VALUES ('14133', '27', '2010', '1', '1', '13', '589', '596', '586');
INSERT INTO `school_recruit` VALUES ('14139', '27', '2010', '5', '1', '13', '582', '582', '0');
INSERT INTO `school_recruit` VALUES ('14141', '27', '2013', '1', '2', '13', '644', '658', '635');
INSERT INTO `school_recruit` VALUES ('14142', '27', '2012', '1', '2', '13', '657', '672', '651');
INSERT INTO `school_recruit` VALUES ('14143', '27', '2011', '1', '2', '13', '641', '654', '635');
INSERT INTO `school_recruit` VALUES ('14144', '27', '2010', '1', '2', '13', '618', '632', '612');
INSERT INTO `school_recruit` VALUES ('14150', '27', '2010', '5', '2', '13', '607', '620', '0');
INSERT INTO `school_recruit` VALUES ('14516', '28', '2013', '1', '1', '34', '579', '610', '0');
INSERT INTO `school_recruit` VALUES ('14517', '28', '2012', '1', '1', '34', '546', '601', '0');
INSERT INTO `school_recruit` VALUES ('14518', '28', '2011', '1', '1', '34', '588', '627', '0');
INSERT INTO `school_recruit` VALUES ('14519', '28', '2010', '1', '1', '34', '573', '609', '0');
INSERT INTO `school_recruit` VALUES ('14526', '28', '2013', '1', '2', '34', '600', '651', '0');
INSERT INTO `school_recruit` VALUES ('14527', '28', '2012', '1', '2', '34', '610', '653', '0');
INSERT INTO `school_recruit` VALUES ('14528', '28', '2011', '1', '2', '34', '604', '649', '0');
INSERT INTO `school_recruit` VALUES ('14529', '28', '2010', '1', '2', '34', '612', '655', '0');
INSERT INTO `school_recruit` VALUES ('14580', '28', '2013', '1', '1', '3', '458', '468', '0');
INSERT INTO `school_recruit` VALUES ('14581', '28', '2011', '1', '1', '3', '482', '487', '0');
INSERT INTO `school_recruit` VALUES ('14582', '28', '2010', '1', '1', '3', '482', '490', '0');
INSERT INTO `school_recruit` VALUES ('14587', '28', '2013', '1', '2', '3', '428', '452', '0');
INSERT INTO `school_recruit` VALUES ('14588', '28', '2012', '1', '2', '3', '465', '478', '0');
INSERT INTO `school_recruit` VALUES ('14589', '28', '2011', '1', '2', '3', '489', '515', '0');
INSERT INTO `school_recruit` VALUES ('14590', '28', '2010', '1', '2', '3', '493', '511', '0');
INSERT INTO `school_recruit` VALUES ('14716', '28', '2010', '1', '1', '10', '631', '638', '0');
INSERT INTO `school_recruit` VALUES ('14722', '28', '2010', '1', '2', '10', '622', '660', '0');
INSERT INTO `school_recruit` VALUES ('14766', '28', '2013', '1', '1', '13', '573', '582', '571');
INSERT INTO `school_recruit` VALUES ('14767', '28', '2012', '1', '1', '13', '606', '611', '603');
INSERT INTO `school_recruit` VALUES ('14768', '28', '2011', '1', '1', '13', '571', '577', '568');
INSERT INTO `school_recruit` VALUES ('14769', '28', '2010', '1', '1', '13', '555', '563', '549');
INSERT INTO `school_recruit` VALUES ('14775', '28', '2013', '1', '2', '13', '600', '620', '590');
INSERT INTO `school_recruit` VALUES ('14776', '28', '2012', '1', '2', '13', '624', '637', '619');
INSERT INTO `school_recruit` VALUES ('14777', '28', '2011', '1', '2', '13', '606', '622', '600');
INSERT INTO `school_recruit` VALUES ('14778', '28', '2010', '1', '2', '13', '586', '601', '578');
INSERT INTO `school_recruit` VALUES ('16428', '31', '2013', '1', '1', '34', '565', '582', '0');
INSERT INTO `school_recruit` VALUES ('16429', '31', '2012', '1', '1', '34', '507', '512', '0');
INSERT INTO `school_recruit` VALUES ('16430', '31', '2011', '1', '1', '34', '547', '554', '0');
INSERT INTO `school_recruit` VALUES ('16431', '31', '2010', '1', '1', '34', '535', '540', '0');
INSERT INTO `school_recruit` VALUES ('16435', '31', '2013', '1', '2', '34', '565', '581', '0');
INSERT INTO `school_recruit` VALUES ('16436', '31', '2012', '1', '2', '34', '504', '529', '0');
INSERT INTO `school_recruit` VALUES ('16437', '31', '2011', '1', '2', '34', '521', '557', '0');
INSERT INTO `school_recruit` VALUES ('16438', '31', '2010', '1', '2', '34', '565', '597', '0');
INSERT INTO `school_recruit` VALUES ('16460', '31', '2013', '1', '1', '3', '457', '467', '0');
INSERT INTO `school_recruit` VALUES ('16461', '31', '2012', '1', '1', '3', '471', '490', '0');
INSERT INTO `school_recruit` VALUES ('16462', '31', '2011', '1', '1', '3', '486', '509', '0');
INSERT INTO `school_recruit` VALUES ('16463', '31', '2010', '1', '1', '3', '479', '506', '0');
INSERT INTO `school_recruit` VALUES ('16473', '31', '2013', '1', '2', '3', '421', '437', '0');
INSERT INTO `school_recruit` VALUES ('16474', '31', '2012', '1', '2', '3', '450', '486', '0');
INSERT INTO `school_recruit` VALUES ('16475', '31', '2011', '1', '2', '3', '482', '522', '0');
INSERT INTO `school_recruit` VALUES ('16476', '31', '2010', '1', '2', '3', '478', '509', '0');
INSERT INTO `school_recruit` VALUES ('16569', '31', '2010', '1', '1', '10', '630', '641', '0');
INSERT INTO `school_recruit` VALUES ('16578', '31', '2010', '1', '2', '10', '600', '620', '0');
INSERT INTO `school_recruit` VALUES ('16614', '31', '2013', '1', '1', '13', '550', '568', '565');
INSERT INTO `school_recruit` VALUES ('16615', '31', '2012', '1', '1', '13', '601', '610', '595');
INSERT INTO `school_recruit` VALUES ('16616', '31', '2011', '1', '1', '13', '568', '577', '564');
INSERT INTO `school_recruit` VALUES ('16617', '31', '2010', '1', '1', '13', '554', '564', '550');
INSERT INTO `school_recruit` VALUES ('16623', '31', '2013', '1', '2', '13', '571', '587', '566');
INSERT INTO `school_recruit` VALUES ('16624', '31', '2012', '1', '2', '13', '594', '618', '588');
INSERT INTO `school_recruit` VALUES ('16625', '31', '2011', '1', '2', '13', '575', '600', '571');
INSERT INTO `school_recruit` VALUES ('16626', '31', '2010', '1', '2', '13', '555', '579', '545');
INSERT INTO `school_recruit` VALUES ('20526', '39', '2013', '1', '1', '34', '627', '666', '0');
INSERT INTO `school_recruit` VALUES ('20527', '39', '2012', '1', '1', '34', '572', '611', '0');
INSERT INTO `school_recruit` VALUES ('20528', '39', '2011', '1', '1', '34', '599', '640', '0');
INSERT INTO `school_recruit` VALUES ('20529', '39', '2010', '1', '1', '34', '591', '625', '0');
INSERT INTO `school_recruit` VALUES ('20534', '39', '2013', '1', '2', '34', '659', '693', '0');
INSERT INTO `school_recruit` VALUES ('20535', '39', '2012', '1', '2', '34', '616', '660', '0');
INSERT INTO `school_recruit` VALUES ('20536', '39', '2011', '1', '2', '34', '613', '662', '0');
INSERT INTO `school_recruit` VALUES ('20537', '39', '2010', '1', '2', '34', '621', '658', '0');
INSERT INTO `school_recruit` VALUES ('20574', '39', '2013', '1', '1', '3', '483', '493', '0');
INSERT INTO `school_recruit` VALUES ('20575', '39', '2012', '1', '1', '3', '480', '498', '0');
INSERT INTO `school_recruit` VALUES ('20576', '39', '2011', '1', '1', '3', '507', '516', '0');
INSERT INTO `school_recruit` VALUES ('20577', '39', '2010', '1', '1', '3', '505', '518', '0');
INSERT INTO `school_recruit` VALUES ('20582', '39', '2013', '1', '2', '3', '465', '487', '0');
INSERT INTO `school_recruit` VALUES ('20583', '39', '2012', '1', '2', '3', '476', '500', '0');
INSERT INTO `school_recruit` VALUES ('20584', '39', '2011', '1', '2', '3', '513', '531', '0');
INSERT INTO `school_recruit` VALUES ('20585', '39', '2010', '1', '2', '3', '508', '534', '0');
INSERT INTO `school_recruit` VALUES ('20684', '39', '2013', '1', '1', '10', '654', '690', '0');
INSERT INTO `school_recruit` VALUES ('20685', '39', '2010', '1', '1', '10', '661', '668', '0');
INSERT INTO `school_recruit` VALUES ('20690', '39', '2013', '1', '2', '10', '669', '722', '0');
INSERT INTO `school_recruit` VALUES ('20691', '39', '2010', '1', '2', '10', '654', '672', '0');
INSERT INTO `school_recruit` VALUES ('20728', '39', '2013', '1', '1', '13', '589', '597', '585');
INSERT INTO `school_recruit` VALUES ('20729', '39', '2012', '1', '1', '13', '621', '635', '615');
INSERT INTO `school_recruit` VALUES ('20730', '39', '2011', '1', '1', '13', '591', '598', '586');
INSERT INTO `school_recruit` VALUES ('20731', '39', '2010', '1', '1', '13', '576', '586', '573');
INSERT INTO `school_recruit` VALUES ('20736', '39', '2013', '1', '2', '13', '631', '639', '624');
INSERT INTO `school_recruit` VALUES ('20737', '39', '2012', '1', '2', '13', '646', '657', '642');
INSERT INTO `school_recruit` VALUES ('20738', '39', '2011', '1', '2', '13', '628', '638', '624');
INSERT INTO `school_recruit` VALUES ('20739', '39', '2010', '1', '2', '13', '608', '625', '600');
INSERT INTO `school_recruit` VALUES ('23003', '44', '2013', '1', '1', '34', '590', '631', '0');
INSERT INTO `school_recruit` VALUES ('23004', '44', '2012', '1', '1', '34', '607', '607', '0');
INSERT INTO `school_recruit` VALUES ('23005', '44', '2011', '1', '1', '34', '629', '629', '0');
INSERT INTO `school_recruit` VALUES ('23006', '44', '2010', '1', '1', '34', '597', '597', '0');
INSERT INTO `school_recruit` VALUES ('23007', '44', '2013', '1', '2', '34', '613', '677', '0');
INSERT INTO `school_recruit` VALUES ('23008', '44', '2012', '1', '2', '34', '641', '668', '0');
INSERT INTO `school_recruit` VALUES ('23009', '44', '2011', '1', '2', '34', '640', '663', '0');
INSERT INTO `school_recruit` VALUES ('23010', '44', '2010', '1', '2', '34', '640', '663', '0');
INSERT INTO `school_recruit` VALUES ('23043', '44', '2013', '1', '1', '3', '470', '493', '0');
INSERT INTO `school_recruit` VALUES ('23044', '44', '2012', '1', '1', '3', '494', '534', '0');
INSERT INTO `school_recruit` VALUES ('23045', '44', '2011', '1', '1', '3', '526', '556', '0');
INSERT INTO `school_recruit` VALUES ('23046', '44', '2010', '1', '1', '3', '525', '532', '0');
INSERT INTO `school_recruit` VALUES ('23056', '44', '2012', '1', '2', '3', '491', '540', '0');
INSERT INTO `school_recruit` VALUES ('23057', '44', '2011', '1', '2', '3', '526', '575', '0');
INSERT INTO `school_recruit` VALUES ('23058', '44', '2010', '1', '2', '3', '528', '548', '0');
INSERT INTO `school_recruit` VALUES ('23067', '44', '2010', '5', '2', '3', '505', '523', '0');
INSERT INTO `school_recruit` VALUES ('23160', '44', '2010', '1', '1', '10', '669', '682', '0');
INSERT INTO `school_recruit` VALUES ('23166', '44', '2010', '1', '2', '10', '673', '685', '0');
INSERT INTO `school_recruit` VALUES ('23172', '44', '2010', '5', '2', '10', '618', '632', '0');
INSERT INTO `school_recruit` VALUES ('23204', '44', '2013', '1', '1', '13', '610', '611', '611');
INSERT INTO `school_recruit` VALUES ('23205', '44', '2012', '1', '1', '13', '637', '637', '637');
INSERT INTO `school_recruit` VALUES ('23206', '44', '2011', '1', '1', '13', '594', '594', '594');
INSERT INTO `school_recruit` VALUES ('23207', '44', '2010', '1', '1', '13', '566', '568', '565');
INSERT INTO `school_recruit` VALUES ('23213', '44', '2013', '1', '2', '13', '650', '661', '648');
INSERT INTO `school_recruit` VALUES ('23214', '44', '2012', '1', '2', '13', '664', '673', '660');
INSERT INTO `school_recruit` VALUES ('23215', '44', '2011', '1', '2', '13', '647', '655', '642');
INSERT INTO `school_recruit` VALUES ('23216', '44', '2010', '1', '2', '13', '629', '637', '627');
INSERT INTO `school_recruit` VALUES ('23222', '44', '2010', '5', '2', '13', '608', '620', '0');
INSERT INTO `school_recruit` VALUES ('23474', '45', '2013', '1', '1', '34', '581', '614', '0');
INSERT INTO `school_recruit` VALUES ('23475', '45', '2012', '1', '1', '34', '578', '601', '0');
INSERT INTO `school_recruit` VALUES ('23476', '45', '2011', '1', '1', '34', '581', '621', '0');
INSERT INTO `school_recruit` VALUES ('23477', '45', '2010', '1', '1', '34', '598', '620', '0');
INSERT INTO `school_recruit` VALUES ('23483', '45', '2013', '1', '2', '34', '598', '647', '0');
INSERT INTO `school_recruit` VALUES ('23484', '45', '2012', '1', '2', '34', '595', '634', '0');
INSERT INTO `school_recruit` VALUES ('23485', '45', '2011', '1', '2', '34', '610', '643', '0');
INSERT INTO `school_recruit` VALUES ('23486', '45', '2010', '1', '2', '34', '600', '637', '0');
INSERT INTO `school_recruit` VALUES ('23529', '45', '2013', '1', '1', '3', '470', '492', '0');
INSERT INTO `school_recruit` VALUES ('23530', '45', '2012', '1', '1', '3', '489', '516', '0');
INSERT INTO `school_recruit` VALUES ('23531', '45', '2011', '1', '1', '3', '525', '548', '0');
INSERT INTO `school_recruit` VALUES ('23532', '45', '2010', '1', '1', '3', '515', '541', '0');
INSERT INTO `school_recruit` VALUES ('23538', '45', '2013', '1', '2', '3', '440', '476', '0');
INSERT INTO `school_recruit` VALUES ('23539', '45', '2012', '1', '2', '3', '487', '511', '0');
INSERT INTO `school_recruit` VALUES ('23540', '45', '2011', '1', '2', '3', '520', '548', '0');
INSERT INTO `school_recruit` VALUES ('23541', '45', '2010', '1', '2', '3', '513', '546', '0');
INSERT INTO `school_recruit` VALUES ('23646', '45', '2010', '1', '1', '10', '671', '677', '0');
INSERT INTO `school_recruit` VALUES ('23653', '45', '2010', '1', '2', '10', '664', '680', '0');
INSERT INTO `school_recruit` VALUES ('23694', '45', '2013', '1', '1', '13', '600', '603', '598');
INSERT INTO `school_recruit` VALUES ('23695', '45', '2012', '1', '1', '13', '630', '634', '628');
INSERT INTO `school_recruit` VALUES ('23696', '45', '2011', '1', '1', '13', '591', '594', '589');
INSERT INTO `school_recruit` VALUES ('23697', '45', '2010', '1', '1', '13', '572', '581', '568');
INSERT INTO `school_recruit` VALUES ('23703', '45', '2013', '1', '2', '13', '617', '632', '610');
INSERT INTO `school_recruit` VALUES ('23704', '45', '2012', '1', '2', '13', '641', '655', '633');
INSERT INTO `school_recruit` VALUES ('23705', '45', '2011', '1', '2', '13', '628', '638', '624');
INSERT INTO `school_recruit` VALUES ('23706', '45', '2010', '1', '2', '13', '601', '619', '596');
INSERT INTO `school_recruit` VALUES ('25132', '48', '2013', '1', '1', '34', '553', '558', '0');
INSERT INTO `school_recruit` VALUES ('25133', '48', '2012', '1', '1', '34', '499', '505', '0');
INSERT INTO `school_recruit` VALUES ('25134', '48', '2011', '1', '1', '34', '533', '545', '0');
INSERT INTO `school_recruit` VALUES ('25135', '48', '2010', '1', '1', '34', '537', '556', '0');
INSERT INTO `school_recruit` VALUES ('25141', '48', '2013', '1', '2', '34', '574', '599', '0');
INSERT INTO `school_recruit` VALUES ('25142', '48', '2012', '1', '2', '34', '520', '549', '0');
INSERT INTO `school_recruit` VALUES ('25143', '48', '2011', '1', '2', '34', '506', '526', '0');
INSERT INTO `school_recruit` VALUES ('25144', '48', '2010', '1', '2', '34', '522', '571', '0');
INSERT INTO `school_recruit` VALUES ('25192', '48', '2013', '1', '1', '3', '449', '450', '0');
INSERT INTO `school_recruit` VALUES ('25193', '48', '2011', '1', '1', '3', '471', '471', '0');
INSERT INTO `school_recruit` VALUES ('25197', '48', '2012', '1', '2', '3', '440', '440', '0');
INSERT INTO `school_recruit` VALUES ('25330', '48', '2010', '1', '1', '10', '608', '618', '0');
INSERT INTO `school_recruit` VALUES ('25336', '48', '2010', '1', '2', '10', '579', '599', '0');
INSERT INTO `school_recruit` VALUES ('25381', '48', '2013', '1', '1', '13', '541', '564', '535');
INSERT INTO `school_recruit` VALUES ('25382', '48', '2012', '1', '1', '13', '577', '612', '571');
INSERT INTO `school_recruit` VALUES ('25383', '48', '2011', '1', '1', '13', '538', '569', '532');
INSERT INTO `school_recruit` VALUES ('25384', '48', '2010', '1', '1', '13', '526', '549', '521');
INSERT INTO `school_recruit` VALUES ('25390', '48', '2013', '2', '1', '13', '497', '519', '490');
INSERT INTO `school_recruit` VALUES ('25391', '48', '2012', '2', '1', '13', '534', '567', '531');
INSERT INTO `school_recruit` VALUES ('25392', '48', '2011', '2', '1', '13', '493', '524', '494');
INSERT INTO `school_recruit` VALUES ('25393', '48', '2010', '2', '1', '13', '491', '518', '0');
INSERT INTO `school_recruit` VALUES ('25402', '48', '2013', '1', '2', '13', '538', '591', '517');
INSERT INTO `school_recruit` VALUES ('25403', '48', '2012', '1', '2', '13', '563', '627', '553');
INSERT INTO `school_recruit` VALUES ('25404', '48', '2011', '1', '2', '13', '544', '617', '534');
INSERT INTO `school_recruit` VALUES ('25405', '48', '2010', '1', '2', '13', '527', '577', '520');
INSERT INTO `school_recruit` VALUES ('25411', '48', '2013', '2', '2', '13', '489', '532', '474');
INSERT INTO `school_recruit` VALUES ('25412', '48', '2012', '2', '2', '13', '514', '563', '500');
INSERT INTO `school_recruit` VALUES ('25413', '48', '2011', '2', '2', '13', '497', '536', '483');
INSERT INTO `school_recruit` VALUES ('25414', '48', '2010', '2', '2', '13', '481', '515', '0');
INSERT INTO `school_recruit` VALUES ('26611', '51', '2013', '1', '1', '34', '595', '642', '0');
INSERT INTO `school_recruit` VALUES ('26612', '51', '2012', '1', '1', '34', '590', '617', '0');
INSERT INTO `school_recruit` VALUES ('26613', '51', '2011', '1', '1', '34', '609', '631', '0');
INSERT INTO `school_recruit` VALUES ('26614', '51', '2010', '1', '1', '34', '605', '621', '0');
INSERT INTO `school_recruit` VALUES ('26620', '51', '2010', '5', '1', '34', '608', '613', '0');
INSERT INTO `school_recruit` VALUES ('26622', '51', '2013', '1', '2', '34', '607', '664', '0');
INSERT INTO `school_recruit` VALUES ('26623', '51', '2012', '1', '2', '34', '623', '657', '0');
INSERT INTO `school_recruit` VALUES ('26624', '51', '2011', '1', '2', '34', '620', '655', '0');
INSERT INTO `school_recruit` VALUES ('26625', '51', '2010', '1', '2', '34', '626', '653', '0');
INSERT INTO `school_recruit` VALUES ('26670', '51', '2010', '5', '1', '3', '508', '510', '0');
INSERT INTO `school_recruit` VALUES ('26677', '51', '2010', '5', '2', '3', '507', '509', '0');
INSERT INTO `school_recruit` VALUES ('26777', '51', '2010', '1', '1', '10', '654', '669', '0');
INSERT INTO `school_recruit` VALUES ('26786', '51', '2010', '1', '2', '10', '630', '642', '0');
INSERT INTO `school_recruit` VALUES ('26815', '51', '2010', '5', '1', '13', '579', '603', '0');
INSERT INTO `school_recruit` VALUES ('26822', '51', '2010', '5', '2', '13', '608', '632', '0');
INSERT INTO `school_recruit` VALUES ('29506', '57', '2013', '1', '1', '34', '583', '617', '0');
INSERT INTO `school_recruit` VALUES ('29507', '57', '2012', '1', '1', '34', '556', '594', '0');
INSERT INTO `school_recruit` VALUES ('29508', '57', '2011', '1', '1', '34', '600', '628', '0');
INSERT INTO `school_recruit` VALUES ('29509', '57', '2010', '1', '1', '34', '579', '600', '0');
INSERT INTO `school_recruit` VALUES ('29515', '57', '2013', '3', '1', '34', '479', '504', '0');
INSERT INTO `school_recruit` VALUES ('29516', '57', '2013', '1', '2', '34', '609', '668', '0');
INSERT INTO `school_recruit` VALUES ('29517', '57', '2012', '1', '2', '34', '624', '662', '0');
INSERT INTO `school_recruit` VALUES ('29518', '57', '2011', '1', '2', '34', '617', '670', '0');
INSERT INTO `school_recruit` VALUES ('29519', '57', '2010', '1', '2', '34', '628', '666', '0');
INSERT INTO `school_recruit` VALUES ('29525', '57', '2013', '3', '2', '34', '500', '526', '0');
INSERT INTO `school_recruit` VALUES ('29568', '57', '2013', '1', '1', '3', '462', '477', '0');
INSERT INTO `school_recruit` VALUES ('29569', '57', '2012', '1', '1', '3', '472', '475', '0');
INSERT INTO `school_recruit` VALUES ('29570', '57', '2011', '1', '1', '3', '499', '502', '0');
INSERT INTO `school_recruit` VALUES ('29572', '57', '2013', '1', '2', '3', '438', '472', '0');
INSERT INTO `school_recruit` VALUES ('29573', '57', '2012', '1', '2', '3', '480', '494', '0');
INSERT INTO `school_recruit` VALUES ('29574', '57', '2011', '1', '2', '3', '514', '539', '0');
INSERT INTO `school_recruit` VALUES ('29575', '57', '2010', '1', '2', '3', '500', '525', '0');
INSERT INTO `school_recruit` VALUES ('29717', '57', '2010', '1', '2', '10', '633', '663', '0');
INSERT INTO `school_recruit` VALUES ('29760', '57', '2013', '1', '1', '13', '577', '580', '576');
INSERT INTO `school_recruit` VALUES ('29761', '57', '2012', '1', '1', '13', '611', '616', '610');
INSERT INTO `school_recruit` VALUES ('29762', '57', '2011', '1', '1', '13', '572', '573', '570');
INSERT INTO `school_recruit` VALUES ('29763', '57', '2010', '1', '1', '13', '552', '556', '549');
INSERT INTO `school_recruit` VALUES ('29769', '57', '2013', '1', '2', '13', '626', '640', '620');
INSERT INTO `school_recruit` VALUES ('29770', '57', '2012', '1', '2', '13', '641', '650', '637');
INSERT INTO `school_recruit` VALUES ('29771', '57', '2011', '1', '2', '13', '625', '634', '619');
INSERT INTO `school_recruit` VALUES ('29772', '57', '2010', '1', '2', '13', '604', '628', '594');
INSERT INTO `school_recruit` VALUES ('30315', '59', '2013', '1', '1', '34', '584', '619', '0');
INSERT INTO `school_recruit` VALUES ('30316', '59', '2012', '1', '1', '34', '529', '547', '0');
INSERT INTO `school_recruit` VALUES ('30317', '59', '2011', '1', '1', '34', '578', '616', '0');
INSERT INTO `school_recruit` VALUES ('30318', '59', '2010', '1', '1', '34', '578', '587', '0');
INSERT INTO `school_recruit` VALUES ('30322', '59', '2013', '1', '2', '34', '597', '645', '0');
INSERT INTO `school_recruit` VALUES ('30323', '59', '2012', '1', '2', '34', '572', '596', '0');
INSERT INTO `school_recruit` VALUES ('30324', '59', '2011', '1', '2', '34', '574', '620', '0');
INSERT INTO `school_recruit` VALUES ('30325', '59', '2010', '1', '2', '34', '580', '607', '0');
INSERT INTO `school_recruit` VALUES ('30364', '59', '2013', '1', '1', '3', '468', '489', '0');
INSERT INTO `school_recruit` VALUES ('30365', '59', '2012', '1', '1', '3', '482', '505', '0');
INSERT INTO `school_recruit` VALUES ('30366', '59', '2011', '1', '1', '3', '515', '541', '0');
INSERT INTO `school_recruit` VALUES ('30367', '59', '2010', '1', '1', '3', '506', '525', '0');
INSERT INTO `school_recruit` VALUES ('30373', '59', '2010', '5', '1', '3', '494', '524', '0');
INSERT INTO `school_recruit` VALUES ('30378', '59', '2013', '1', '2', '3', '436', '468', '0');
INSERT INTO `school_recruit` VALUES ('30379', '59', '2012', '1', '2', '3', '478', '511', '0');
INSERT INTO `school_recruit` VALUES ('30380', '59', '2011', '1', '2', '3', '511', '536', '0');
INSERT INTO `school_recruit` VALUES ('30381', '59', '2010', '1', '2', '3', '503', '524', '0');
INSERT INTO `school_recruit` VALUES ('30387', '59', '2010', '5', '2', '3', '498', '524', '0');
INSERT INTO `school_recruit` VALUES ('30478', '59', '2010', '1', '1', '10', '644', '650', '0');
INSERT INTO `school_recruit` VALUES ('30487', '59', '2010', '1', '2', '10', '625', '636', '0');
INSERT INTO `school_recruit` VALUES ('30541', '59', '2010', '5', '1', '13', '568', '582', '0');
INSERT INTO `school_recruit` VALUES ('30549', '59', '2010', '5', '2', '13', '588', '605', '0');
INSERT INTO `school_recruit` VALUES ('31262', '61', '2013', '1', '1', '34', '578', '608', '0');
INSERT INTO `school_recruit` VALUES ('31263', '61', '2012', '1', '1', '34', '556', '567', '0');
INSERT INTO `school_recruit` VALUES ('31264', '61', '2011', '1', '1', '34', '568', '596', '0');
INSERT INTO `school_recruit` VALUES ('31265', '61', '2010', '1', '1', '34', '571', '587', '0');
INSERT INTO `school_recruit` VALUES ('31271', '61', '2013', '1', '2', '34', '598', '647', '0');
INSERT INTO `school_recruit` VALUES ('31272', '61', '2012', '1', '2', '34', '610', '653', '0');
INSERT INTO `school_recruit` VALUES ('31273', '61', '2011', '1', '2', '34', '598', '649', '0');
INSERT INTO `school_recruit` VALUES ('31274', '61', '2010', '1', '2', '34', '603', '649', '0');
INSERT INTO `school_recruit` VALUES ('31308', '61', '2013', '1', '2', '3', '424', '444', '0');
INSERT INTO `school_recruit` VALUES ('31309', '61', '2012', '1', '2', '3', '460', '485', '0');
INSERT INTO `school_recruit` VALUES ('31310', '61', '2011', '1', '2', '3', '505', '524', '0');
INSERT INTO `school_recruit` VALUES ('31311', '61', '2010', '1', '2', '3', '498', '514', '0');
INSERT INTO `school_recruit` VALUES ('31408', '61', '2012', '1', '2', '10', '669', '681', '0');
INSERT INTO `school_recruit` VALUES ('31409', '61', '2010', '1', '2', '10', '626', '632', '0');
INSERT INTO `school_recruit` VALUES ('31442', '61', '2013', '1', '1', '13', '567', '577', '562');
INSERT INTO `school_recruit` VALUES ('31443', '61', '2012', '1', '1', '13', '603', '612', '599');
INSERT INTO `school_recruit` VALUES ('31444', '61', '2011', '1', '1', '13', '566', '576', '552');
INSERT INTO `school_recruit` VALUES ('31445', '61', '2010', '1', '1', '13', '558', '563', '556');
INSERT INTO `school_recruit` VALUES ('31451', '61', '2013', '1', '2', '13', '612', '632', '599');
INSERT INTO `school_recruit` VALUES ('31452', '61', '2012', '1', '2', '13', '634', '650', '626');
INSERT INTO `school_recruit` VALUES ('31453', '61', '2011', '1', '2', '13', '614', '633', '608');
INSERT INTO `school_recruit` VALUES ('31454', '61', '2010', '1', '2', '13', '594', '612', '584');
INSERT INTO `school_recruit` VALUES ('34581', '68', '2011', '1', '1', '34', '572', '572', '0');
INSERT INTO `school_recruit` VALUES ('34582', '68', '2013', '1', '2', '34', '573', '596', '0');
INSERT INTO `school_recruit` VALUES ('34583', '68', '2012', '1', '2', '34', '528', '586', '0');
INSERT INTO `school_recruit` VALUES ('34584', '68', '2011', '1', '2', '34', '532', '593', '0');
INSERT INTO `school_recruit` VALUES ('34585', '68', '2010', '1', '2', '34', '552', '618', '0');
INSERT INTO `school_recruit` VALUES ('34609', '68', '2013', '1', '1', '3', '459', '471', '0');
INSERT INTO `school_recruit` VALUES ('34610', '68', '2012', '1', '1', '3', '469', '472', '0');
INSERT INTO `school_recruit` VALUES ('34611', '68', '2011', '1', '1', '3', '484', '509', '0');
INSERT INTO `school_recruit` VALUES ('34612', '68', '2010', '1', '1', '3', '477', '500', '0');
INSERT INTO `school_recruit` VALUES ('34617', '68', '2013', '1', '2', '3', '430', '455', '0');
INSERT INTO `school_recruit` VALUES ('34618', '68', '2012', '1', '2', '3', '467', '505', '0');
INSERT INTO `school_recruit` VALUES ('34619', '68', '2011', '1', '2', '3', '498', '536', '0');
INSERT INTO `school_recruit` VALUES ('34620', '68', '2010', '1', '2', '3', '493', '520', '0');
INSERT INTO `school_recruit` VALUES ('34626', '68', '2010', '5', '2', '3', '495', '517', '0');
INSERT INTO `school_recruit` VALUES ('34700', '68', '2010', '1', '1', '10', '627', '635', '0');
INSERT INTO `school_recruit` VALUES ('34704', '68', '2010', '1', '2', '10', '619', '631', '0');
INSERT INTO `school_recruit` VALUES ('34742', '68', '2013', '1', '2', '13', '583', '604', '576');
INSERT INTO `school_recruit` VALUES ('34743', '68', '2012', '1', '2', '13', '607', '624', '602');
INSERT INTO `school_recruit` VALUES ('34744', '68', '2011', '1', '2', '13', '589', '601', '584');
INSERT INTO `school_recruit` VALUES ('34745', '68', '2010', '1', '2', '13', '569', '591', '563');
INSERT INTO `school_recruit` VALUES ('38062', '75', '2013', '1', '1', '34', '586', '623', '0');
INSERT INTO `school_recruit` VALUES ('38063', '75', '2012', '1', '1', '34', '568', '595', '0');
INSERT INTO `school_recruit` VALUES ('38064', '75', '2011', '1', '1', '34', '591', '633', '0');
INSERT INTO `school_recruit` VALUES ('38065', '75', '2010', '1', '1', '34', '584', '629', '0');
INSERT INTO `school_recruit` VALUES ('38071', '75', '2013', '1', '2', '34', '593', '636', '0');
INSERT INTO `school_recruit` VALUES ('38072', '75', '2012', '1', '2', '34', '576', '628', '0');
INSERT INTO `school_recruit` VALUES ('38073', '75', '2011', '1', '2', '34', '573', '633', '0');
INSERT INTO `school_recruit` VALUES ('38074', '75', '2010', '1', '2', '34', '591', '632', '0');
INSERT INTO `school_recruit` VALUES ('38124', '75', '2013', '1', '1', '3', '467', '486', '0');
INSERT INTO `school_recruit` VALUES ('38125', '75', '2012', '1', '1', '3', '479', '491', '0');
INSERT INTO `school_recruit` VALUES ('38126', '75', '2011', '1', '1', '3', '514', '539', '0');
INSERT INTO `school_recruit` VALUES ('38127', '75', '2010', '1', '1', '3', '500', '514', '0');
INSERT INTO `school_recruit` VALUES ('38133', '75', '2010', '5', '1', '3', '503', '512', '0');
INSERT INTO `school_recruit` VALUES ('38135', '75', '2013', '1', '2', '3', '425', '446', '0');
INSERT INTO `school_recruit` VALUES ('38136', '75', '2012', '1', '2', '3', '455', '465', '0');
INSERT INTO `school_recruit` VALUES ('38137', '75', '2011', '1', '2', '3', '472', '486', '0');
INSERT INTO `school_recruit` VALUES ('38138', '75', '2010', '1', '2', '3', '485', '517', '0');
INSERT INTO `school_recruit` VALUES ('38144', '75', '2010', '5', '2', '3', '483', '489', '0');
INSERT INTO `school_recruit` VALUES ('38270', '75', '2010', '1', '1', '10', '640', '646', '0');
INSERT INTO `school_recruit` VALUES ('38276', '75', '2010', '5', '1', '10', '637', '641', '0');
INSERT INTO `school_recruit` VALUES ('38278', '75', '2010', '1', '2', '10', '615', '623', '0');
INSERT INTO `school_recruit` VALUES ('38325', '75', '2013', '1', '1', '13', '581', '584', '579');
INSERT INTO `school_recruit` VALUES ('38326', '75', '2012', '1', '1', '13', '613', '618', '611');
INSERT INTO `school_recruit` VALUES ('38327', '75', '2011', '1', '1', '13', '576', '579', '574');
INSERT INTO `school_recruit` VALUES ('38328', '75', '2010', '1', '1', '13', '561', '566', '558');
INSERT INTO `school_recruit` VALUES ('38334', '75', '2010', '5', '1', '13', '560', '579', '0');
INSERT INTO `school_recruit` VALUES ('38336', '75', '2013', '1', '2', '13', '579', '598', '574');
INSERT INTO `school_recruit` VALUES ('38337', '75', '2012', '1', '2', '13', '601', '637', '595');
INSERT INTO `school_recruit` VALUES ('38338', '75', '2011', '1', '2', '13', '575', '600', '569');
INSERT INTO `school_recruit` VALUES ('38339', '75', '2010', '1', '2', '13', '561', '584', '551');
INSERT INTO `school_recruit` VALUES ('38345', '75', '2010', '5', '2', '13', '555', '574', '0');
INSERT INTO `school_recruit` VALUES ('40332', '79', '2013', '1', '1', '34', '585', '621', '0');
INSERT INTO `school_recruit` VALUES ('40333', '79', '2012', '1', '1', '34', '563', '579', '0');
INSERT INTO `school_recruit` VALUES ('40334', '79', '2011', '1', '1', '34', '580', '616', '0');
INSERT INTO `school_recruit` VALUES ('40335', '79', '2010', '1', '1', '34', '566', '588', '0');
INSERT INTO `school_recruit` VALUES ('40341', '79', '2013', '1', '2', '34', '597', '644', '0');
INSERT INTO `school_recruit` VALUES ('40342', '79', '2012', '1', '2', '34', '595', '652', '0');
INSERT INTO `school_recruit` VALUES ('40343', '79', '2011', '1', '2', '34', '591', '650', '0');
INSERT INTO `school_recruit` VALUES ('40344', '79', '2010', '1', '2', '34', '603', '654', '0');
INSERT INTO `school_recruit` VALUES ('40386', '79', '2013', '1', '2', '3', '418', '431', '0');
INSERT INTO `school_recruit` VALUES ('40387', '79', '2012', '1', '2', '3', '445', '459', '0');
INSERT INTO `school_recruit` VALUES ('40388', '79', '2011', '1', '2', '3', '477', '489', '0');
INSERT INTO `school_recruit` VALUES ('40389', '79', '2010', '1', '2', '3', '475', '495', '0');
INSERT INTO `school_recruit` VALUES ('40509', '79', '2010', '1', '2', '10', '614', '624', '0');
INSERT INTO `school_recruit` VALUES ('40537', '79', '2013', '1', '1', '13', '571', '578', '565');
INSERT INTO `school_recruit` VALUES ('40538', '79', '2012', '1', '1', '13', '609', '612', '606');
INSERT INTO `school_recruit` VALUES ('40539', '79', '2011', '1', '1', '13', '572', '578', '570');
INSERT INTO `school_recruit` VALUES ('40540', '79', '2010', '1', '1', '13', '560', '564', '558');
INSERT INTO `school_recruit` VALUES ('40546', '79', '2013', '1', '2', '13', '585', '595', '573');
INSERT INTO `school_recruit` VALUES ('40547', '79', '2012', '1', '2', '13', '612', '621', '607');
INSERT INTO `school_recruit` VALUES ('40548', '79', '2011', '1', '2', '13', '593', '603', '587');
INSERT INTO `school_recruit` VALUES ('40549', '79', '2010', '1', '2', '13', '575', '589', '569');
INSERT INTO `school_recruit` VALUES ('43505', '86', '2013', '1', '1', '34', '579', '609', '0');
INSERT INTO `school_recruit` VALUES ('43506', '86', '2012', '1', '1', '34', '554', '572', '0');
INSERT INTO `school_recruit` VALUES ('43507', '86', '2011', '1', '1', '34', '560', '597', '0');
INSERT INTO `school_recruit` VALUES ('43508', '86', '2010', '1', '1', '34', '561', '585', '0');
INSERT INTO `school_recruit` VALUES ('43514', '86', '2013', '1', '2', '34', '593', '637', '0');
INSERT INTO `school_recruit` VALUES ('43515', '86', '2012', '1', '2', '34', '585', '652', '0');
INSERT INTO `school_recruit` VALUES ('43516', '86', '2011', '1', '2', '34', '580', '653', '0');
INSERT INTO `school_recruit` VALUES ('43517', '86', '2010', '1', '2', '34', '594', '654', '0');
INSERT INTO `school_recruit` VALUES ('43561', '86', '2013', '1', '2', '3', '420', '436', '0');
INSERT INTO `school_recruit` VALUES ('43562', '86', '2012', '1', '2', '3', '441', '453', '0');
INSERT INTO `school_recruit` VALUES ('43563', '86', '2011', '1', '2', '3', '474', '499', '0');
INSERT INTO `school_recruit` VALUES ('43564', '86', '2010', '1', '2', '3', '475', '488', '0');
INSERT INTO `school_recruit` VALUES ('43680', '86', '2010', '1', '1', '10', '627', '633', '0');
INSERT INTO `school_recruit` VALUES ('43684', '86', '2010', '1', '2', '10', '612', '625', '0');
INSERT INTO `school_recruit` VALUES ('43710', '86', '2013', '1', '1', '13', '563', '568', '561');
INSERT INTO `school_recruit` VALUES ('43711', '86', '2012', '1', '1', '13', '599', '605', '597');
INSERT INTO `school_recruit` VALUES ('43712', '86', '2011', '1', '1', '13', '563', '569', '560');
INSERT INTO `school_recruit` VALUES ('43713', '86', '2010', '1', '1', '13', '548', '557', '543');
INSERT INTO `school_recruit` VALUES ('43719', '86', '2013', '1', '2', '13', '583', '597', '576');
INSERT INTO `school_recruit` VALUES ('43720', '86', '2012', '1', '2', '13', '608', '623', '604');
INSERT INTO `school_recruit` VALUES ('43721', '86', '2011', '1', '2', '13', '590', '601', '585');
INSERT INTO `school_recruit` VALUES ('43722', '86', '2010', '1', '2', '13', '569', '588', '564');
INSERT INTO `school_recruit` VALUES ('45430', '90', '2013', '1', '1', '34', '590', '632', '0');
INSERT INTO `school_recruit` VALUES ('45431', '90', '2012', '1', '1', '34', '585', '624', '0');
INSERT INTO `school_recruit` VALUES ('45432', '90', '2011', '1', '1', '34', '611', '636', '0');
INSERT INTO `school_recruit` VALUES ('45433', '90', '2010', '1', '1', '34', '602', '629', '0');
INSERT INTO `school_recruit` VALUES ('45439', '90', '2013', '1', '2', '34', '606', '663', '0');
INSERT INTO `school_recruit` VALUES ('45440', '90', '2012', '1', '2', '34', '623', '653', '0');
INSERT INTO `school_recruit` VALUES ('45441', '90', '2011', '1', '2', '34', '625', '653', '0');
INSERT INTO `school_recruit` VALUES ('45442', '90', '2010', '1', '2', '34', '628', '655', '0');
INSERT INTO `school_recruit` VALUES ('45492', '90', '2013', '1', '1', '3', '467', '486', '0');
INSERT INTO `school_recruit` VALUES ('45493', '90', '2012', '1', '1', '3', '477', '495', '0');
INSERT INTO `school_recruit` VALUES ('45494', '90', '2011', '1', '1', '3', '514', '529', '0');
INSERT INTO `school_recruit` VALUES ('45495', '90', '2010', '1', '1', '3', '503', '513', '0');
INSERT INTO `school_recruit` VALUES ('45501', '90', '2013', '1', '2', '3', '433', '461', '0');
INSERT INTO `school_recruit` VALUES ('45502', '90', '2012', '1', '2', '3', '475', '483', '0');
INSERT INTO `school_recruit` VALUES ('45503', '90', '2011', '1', '2', '3', '505', '520', '0');
INSERT INTO `school_recruit` VALUES ('45504', '90', '2010', '1', '2', '3', '507', '520', '0');
INSERT INTO `school_recruit` VALUES ('45640', '90', '2010', '1', '1', '10', '663', '669', '0');
INSERT INTO `school_recruit` VALUES ('45647', '90', '2010', '1', '2', '10', '643', '660', '0');
INSERT INTO `school_recruit` VALUES ('45689', '90', '2013', '1', '1', '13', '595', '610', '587');
INSERT INTO `school_recruit` VALUES ('45690', '90', '2012', '1', '1', '13', '624', '634', '618');
INSERT INTO `school_recruit` VALUES ('45691', '90', '2011', '1', '1', '13', '592', '598', '588');
INSERT INTO `school_recruit` VALUES ('45692', '90', '2010', '1', '1', '13', '575', '585', '571');
INSERT INTO `school_recruit` VALUES ('45699', '90', '2013', '1', '2', '13', '622', '628', '612');
INSERT INTO `school_recruit` VALUES ('45700', '90', '2012', '1', '2', '13', '640', '649', '636');
INSERT INTO `school_recruit` VALUES ('45701', '90', '2011', '1', '2', '13', '618', '627', '613');
INSERT INTO `school_recruit` VALUES ('45702', '90', '2010', '1', '2', '13', '598', '616', '592');
INSERT INTO `school_recruit` VALUES ('47635', '95', '2013', '1', '2', '34', '564', '578', '0');
INSERT INTO `school_recruit` VALUES ('47636', '95', '2012', '1', '2', '34', '509', '592', '0');
INSERT INTO `school_recruit` VALUES ('47637', '95', '2011', '1', '2', '34', '518', '583', '0');
INSERT INTO `school_recruit` VALUES ('47638', '95', '2010', '1', '2', '34', '525', '594', '0');
INSERT INTO `school_recruit` VALUES ('47641', '95', '2010', '2', '2', '34', '474', '496', '0');
INSERT INTO `school_recruit` VALUES ('47666', '95', '2013', '1', '1', '3', '452', '457', '0');
INSERT INTO `school_recruit` VALUES ('47667', '95', '2011', '1', '1', '3', '472', '498', '0');
INSERT INTO `school_recruit` VALUES ('47668', '95', '2010', '1', '1', '3', '468', '488', '0');
INSERT INTO `school_recruit` VALUES ('47678', '95', '2013', '1', '2', '3', '412', '420', '0');
INSERT INTO `school_recruit` VALUES ('47679', '95', '2012', '1', '2', '3', '435', '486', '0');
INSERT INTO `school_recruit` VALUES ('47680', '95', '2011', '1', '2', '3', '468', '503', '0');
INSERT INTO `school_recruit` VALUES ('47681', '95', '2010', '1', '2', '3', '469', '495', '0');
INSERT INTO `school_recruit` VALUES ('47766', '95', '2010', '1', '1', '10', '611', '623', '0');
INSERT INTO `school_recruit` VALUES ('47770', '95', '2010', '1', '2', '10', '587', '626', '0');
INSERT INTO `school_recruit` VALUES ('47809', '95', '2013', '1', '1', '13', '556', '562', '553');
INSERT INTO `school_recruit` VALUES ('47810', '95', '2012', '1', '1', '13', '591', '597', '588');
INSERT INTO `school_recruit` VALUES ('47811', '95', '2011', '1', '1', '13', '555', '563', '550');
INSERT INTO `school_recruit` VALUES ('47812', '95', '2010', '1', '1', '13', '542', '550', '538');
INSERT INTO `school_recruit` VALUES ('47818', '95', '2013', '1', '2', '13', '560', '569', '557');
INSERT INTO `school_recruit` VALUES ('47819', '95', '2012', '1', '2', '13', '585', '594', '581');
INSERT INTO `school_recruit` VALUES ('47820', '95', '2011', '1', '2', '13', '568', '579', '564');
INSERT INTO `school_recruit` VALUES ('47821', '95', '2010', '1', '2', '13', '548', '559', '544');
INSERT INTO `school_recruit` VALUES ('48538', '97', '2013', '2', '1', '34', '504', '515', '0');
INSERT INTO `school_recruit` VALUES ('48539', '97', '2012', '2', '1', '34', '481', '493', '0');
INSERT INTO `school_recruit` VALUES ('48540', '97', '2011', '2', '1', '34', '507', '546', '0');
INSERT INTO `school_recruit` VALUES ('48541', '97', '2010', '2', '1', '34', '491', '515', '0');
INSERT INTO `school_recruit` VALUES ('48546', '97', '2013', '2', '2', '34', '522', '539', '0');
INSERT INTO `school_recruit` VALUES ('48547', '97', '2012', '2', '2', '34', '458', '480', '0');
INSERT INTO `school_recruit` VALUES ('48548', '97', '2011', '2', '2', '34', '475', '573', '0');
INSERT INTO `school_recruit` VALUES ('48549', '97', '2010', '2', '2', '34', '471', '524', '0');
INSERT INTO `school_recruit` VALUES ('48586', '97', '2013', '2', '1', '3', '419', '435', '0');
INSERT INTO `school_recruit` VALUES ('48587', '97', '2012', '2', '1', '3', '417', '423', '0');
INSERT INTO `school_recruit` VALUES ('48588', '97', '2011', '2', '1', '3', '439', '449', '0');
INSERT INTO `school_recruit` VALUES ('48589', '97', '2010', '2', '1', '3', '430', '445', '0');
INSERT INTO `school_recruit` VALUES ('48594', '97', '2013', '2', '2', '3', '357', '384', '0');
INSERT INTO `school_recruit` VALUES ('48595', '97', '2012', '2', '2', '3', '403', '416', '0');
INSERT INTO `school_recruit` VALUES ('48596', '97', '2011', '2', '2', '3', '434', '449', '0');
INSERT INTO `school_recruit` VALUES ('48597', '97', '2010', '2', '2', '3', '437', '452', '0');
INSERT INTO `school_recruit` VALUES ('48710', '97', '2010', '2', '1', '10', '549', '565', '0');
INSERT INTO `school_recruit` VALUES ('48718', '97', '2010', '2', '2', '10', '508', '522', '0');
INSERT INTO `school_recruit` VALUES ('48753', '97', '2013', '1', '1', '13', '554', '572', '548');
INSERT INTO `school_recruit` VALUES ('48754', '97', '2012', '1', '1', '13', '591', '615', '584');
INSERT INTO `school_recruit` VALUES ('48755', '97', '2011', '1', '1', '13', '552', '576', '544');
INSERT INTO `school_recruit` VALUES ('48756', '97', '2010', '1', '1', '13', '540', '568', '532');
INSERT INTO `school_recruit` VALUES ('48761', '97', '2013', '2', '1', '13', '504', '525', '520');
INSERT INTO `school_recruit` VALUES ('48762', '97', '2012', '2', '1', '13', '563', '577', '562');
INSERT INTO `school_recruit` VALUES ('48763', '97', '2011', '2', '1', '13', '522', '536', '518');
INSERT INTO `school_recruit` VALUES ('48764', '97', '2010', '2', '1', '13', '509', '517', '0');
INSERT INTO `school_recruit` VALUES ('48769', '97', '2013', '1', '2', '13', '551', '581', '542');
INSERT INTO `school_recruit` VALUES ('48770', '97', '2012', '1', '2', '13', '577', '619', '568');
INSERT INTO `school_recruit` VALUES ('48771', '97', '2011', '1', '2', '13', '555', '599', '545');
INSERT INTO `school_recruit` VALUES ('48772', '97', '2010', '1', '2', '13', '537', '570', '528');
INSERT INTO `school_recruit` VALUES ('48777', '97', '2013', '2', '2', '13', '488', '516', '476');
INSERT INTO `school_recruit` VALUES ('48778', '97', '2012', '2', '2', '13', '521', '557', '505');
INSERT INTO `school_recruit` VALUES ('48779', '97', '2011', '2', '2', '13', '506', '563', '491');
INSERT INTO `school_recruit` VALUES ('48780', '97', '2010', '2', '2', '13', '486', '518', '0');
INSERT INTO `school_recruit` VALUES ('49489', '99', '2013', '1', '1', '34', '563', '577', '0');
INSERT INTO `school_recruit` VALUES ('49490', '99', '2012', '1', '1', '34', '523', '599', '0');
INSERT INTO `school_recruit` VALUES ('49491', '99', '2011', '1', '1', '34', '549', '602', '0');
INSERT INTO `school_recruit` VALUES ('49492', '99', '2010', '1', '1', '34', '545', '626', '0');
INSERT INTO `school_recruit` VALUES ('49497', '99', '2013', '1', '2', '34', '575', '600', '0');
INSERT INTO `school_recruit` VALUES ('49498', '99', '2012', '1', '2', '34', '536', '654', '0');
INSERT INTO `school_recruit` VALUES ('49499', '99', '2011', '1', '2', '34', '538', '648', '0');
INSERT INTO `school_recruit` VALUES ('49500', '99', '2010', '1', '2', '34', '552', '652', '0');
INSERT INTO `school_recruit` VALUES ('49526', '99', '2010', '1', '1', '3', '475', '475', '0');
INSERT INTO `school_recruit` VALUES ('49530', '99', '2013', '1', '2', '3', '414', '424', '0');
INSERT INTO `school_recruit` VALUES ('49531', '99', '2012', '1', '2', '3', '438', '444', '0');
INSERT INTO `school_recruit` VALUES ('49532', '99', '2011', '1', '2', '3', '467', '470', '0');
INSERT INTO `school_recruit` VALUES ('49533', '99', '2010', '1', '2', '3', '469', '475', '0');
INSERT INTO `school_recruit` VALUES ('49618', '99', '2010', '1', '1', '10', '605', '611', '0');
INSERT INTO `school_recruit` VALUES ('49622', '99', '2010', '1', '2', '10', '607', '615', '0');
INSERT INTO `school_recruit` VALUES ('49657', '99', '2010', '1', '1', '13', '543', '545', '542');
INSERT INTO `school_recruit` VALUES ('49662', '99', '2013', '1', '2', '13', '571', '582', '563');
INSERT INTO `school_recruit` VALUES ('49663', '99', '2012', '1', '2', '13', '596', '604', '591');
INSERT INTO `school_recruit` VALUES ('49664', '99', '2011', '1', '2', '13', '578', '588', '571');
INSERT INTO `school_recruit` VALUES ('49665', '99', '2010', '1', '2', '13', '557', '570', '551');
INSERT INTO `school_recruit` VALUES ('52410', '105', '2013', '1', '1', '34', '573', '597', '0');
INSERT INTO `school_recruit` VALUES ('52411', '105', '2012', '1', '1', '34', '538', '579', '0');
INSERT INTO `school_recruit` VALUES ('52412', '105', '2011', '1', '1', '34', '555', '584', '0');
INSERT INTO `school_recruit` VALUES ('52413', '105', '2010', '1', '1', '34', '556', '617', '0');
INSERT INTO `school_recruit` VALUES ('52418', '105', '2013', '1', '2', '34', '590', '631', '0');
INSERT INTO `school_recruit` VALUES ('52419', '105', '2012', '1', '2', '34', '573', '640', '0');
INSERT INTO `school_recruit` VALUES ('52420', '105', '2011', '1', '2', '34', '576', '632', '0');
INSERT INTO `school_recruit` VALUES ('52421', '105', '2010', '1', '2', '34', '584', '638', '0');
INSERT INTO `school_recruit` VALUES ('52458', '105', '2013', '1', '1', '3', '453', '458', '0');
INSERT INTO `school_recruit` VALUES ('52459', '105', '2011', '1', '1', '3', '472', '476', '0');
INSERT INTO `school_recruit` VALUES ('52460', '105', '2010', '1', '1', '3', '472', '480', '0');
INSERT INTO `school_recruit` VALUES ('52465', '105', '2013', '1', '2', '3', '418', '431', '0');
INSERT INTO `school_recruit` VALUES ('52466', '105', '2012', '1', '2', '3', '438', '460', '0');
INSERT INTO `school_recruit` VALUES ('52467', '105', '2011', '1', '2', '3', '479', '519', '0');
INSERT INTO `school_recruit` VALUES ('52468', '105', '2010', '1', '2', '3', '471', '483', '0');
INSERT INTO `school_recruit` VALUES ('52558', '105', '2010', '1', '1', '10', '622', '636', '0');
INSERT INTO `school_recruit` VALUES ('52563', '105', '2010', '1', '2', '10', '621', '633', '0');
INSERT INTO `school_recruit` VALUES ('52590', '105', '2013', '1', '1', '13', '548', '565', '0');
INSERT INTO `school_recruit` VALUES ('52591', '105', '2012', '1', '1', '13', '599', '605', '0');
INSERT INTO `school_recruit` VALUES ('52592', '105', '2011', '1', '1', '13', '563', '567', '0');
INSERT INTO `school_recruit` VALUES ('52593', '105', '2010', '1', '1', '13', '546', '560', '0');
INSERT INTO `school_recruit` VALUES ('52598', '105', '2013', '1', '2', '13', '555', '594', '0');
INSERT INTO `school_recruit` VALUES ('52599', '105', '2012', '1', '2', '13', '616', '630', '0');
INSERT INTO `school_recruit` VALUES ('52600', '105', '2011', '1', '2', '13', '597', '627', '0');
INSERT INTO `school_recruit` VALUES ('52601', '105', '2010', '1', '2', '13', '573', '590', '0');
INSERT INTO `school_recruit` VALUES ('53373', '107', '2013', '1', '1', '34', '574', '599', '0');
INSERT INTO `school_recruit` VALUES ('53374', '107', '2012', '1', '1', '34', '543', '582', '0');
INSERT INTO `school_recruit` VALUES ('53375', '107', '2011', '1', '1', '34', '563', '598', '0');
INSERT INTO `school_recruit` VALUES ('53376', '107', '2010', '1', '1', '34', '564', '605', '0');
INSERT INTO `school_recruit` VALUES ('53383', '107', '2013', '1', '2', '34', '590', '630', '0');
INSERT INTO `school_recruit` VALUES ('53384', '107', '2012', '1', '2', '34', '576', '644', '0');
INSERT INTO `school_recruit` VALUES ('53385', '107', '2011', '1', '2', '34', '574', '644', '0');
INSERT INTO `school_recruit` VALUES ('53386', '107', '2010', '1', '2', '34', '584', '650', '0');
INSERT INTO `school_recruit` VALUES ('53421', '107', '2013', '1', '2', '3', '425', '446', '0');
INSERT INTO `school_recruit` VALUES ('53422', '107', '2012', '1', '2', '3', '461', '486', '0');
INSERT INTO `school_recruit` VALUES ('53423', '107', '2011', '1', '2', '3', '477', '489', '0');
INSERT INTO `school_recruit` VALUES ('53424', '107', '2010', '1', '2', '3', '477', '484', '0');
INSERT INTO `school_recruit` VALUES ('53513', '107', '2010', '1', '1', '10', '631', '639', '0');
INSERT INTO `school_recruit` VALUES ('53518', '107', '2010', '1', '2', '10', '607', '626', '0');
INSERT INTO `school_recruit` VALUES ('53545', '107', '2013', '1', '2', '13', '577', '588', '573');
INSERT INTO `school_recruit` VALUES ('53546', '107', '2012', '1', '2', '13', '599', '611', '595');
INSERT INTO `school_recruit` VALUES ('53547', '107', '2011', '1', '2', '13', '582', '601', '576');
INSERT INTO `school_recruit` VALUES ('53548', '107', '2010', '1', '2', '13', '560', '578', '550');
INSERT INTO `school_recruit` VALUES ('54800', '110', '2013', '2', '1', '34', '501', '508', '0');
INSERT INTO `school_recruit` VALUES ('54801', '110', '2012', '2', '1', '34', '465', '484', '0');
INSERT INTO `school_recruit` VALUES ('54802', '110', '2011', '2', '1', '34', '495', '508', '0');
INSERT INTO `school_recruit` VALUES ('54803', '110', '2010', '2', '1', '34', '488', '510', '0');
INSERT INTO `school_recruit` VALUES ('54808', '110', '2013', '2', '2', '34', '505', '505', '0');
INSERT INTO `school_recruit` VALUES ('54809', '110', '2012', '2', '2', '34', '449', '475', '0');
INSERT INTO `school_recruit` VALUES ('54810', '110', '2011', '2', '2', '34', '453', '481', '0');
INSERT INTO `school_recruit` VALUES ('54811', '110', '2010', '2', '2', '34', '464', '503', '0');
INSERT INTO `school_recruit` VALUES ('54844', '110', '2013', '2', '1', '3', '416', '430', '0');
INSERT INTO `school_recruit` VALUES ('54845', '110', '2012', '2', '1', '3', '413', '422', '0');
INSERT INTO `school_recruit` VALUES ('54846', '110', '2011', '2', '1', '3', '429', '437', '0');
INSERT INTO `school_recruit` VALUES ('54847', '110', '2010', '2', '1', '3', '427', '442', '0');
INSERT INTO `school_recruit` VALUES ('54852', '110', '2013', '2', '2', '3', '347', '364', '0');
INSERT INTO `school_recruit` VALUES ('54853', '110', '2012', '2', '2', '3', '379', '395', '0');
INSERT INTO `school_recruit` VALUES ('54854', '110', '2011', '2', '2', '3', '419', '444', '0');
INSERT INTO `school_recruit` VALUES ('54855', '110', '2010', '2', '2', '3', '423', '446', '0');
INSERT INTO `school_recruit` VALUES ('54953', '110', '2010', '2', '1', '10', '542', '561', '0');
INSERT INTO `school_recruit` VALUES ('54958', '110', '2010', '1', '2', '10', '558', '576', '0');
INSERT INTO `school_recruit` VALUES ('54962', '110', '2010', '2', '2', '10', '502', '541', '0');
INSERT INTO `school_recruit` VALUES ('54998', '110', '2013', '2', '1', '13', '526', '527', '525');
INSERT INTO `school_recruit` VALUES ('54999', '110', '2012', '2', '1', '13', '566', '567', '566');
INSERT INTO `school_recruit` VALUES ('55000', '110', '2011', '2', '1', '13', '527', '530', '525');
INSERT INTO `school_recruit` VALUES ('55001', '110', '2010', '2', '1', '13', '522', '530', '0');
INSERT INTO `school_recruit` VALUES ('55006', '110', '2013', '2', '2', '13', '520', '549', '515');
INSERT INTO `school_recruit` VALUES ('55007', '110', '2012', '2', '2', '13', '549', '559', '546');
INSERT INTO `school_recruit` VALUES ('55008', '110', '2011', '2', '2', '13', '531', '546', '527');
INSERT INTO `school_recruit` VALUES ('55009', '110', '2010', '2', '2', '13', '517', '534', '0');
INSERT INTO `school_recruit` VALUES ('55664', '112', '2013', '1', '1', '34', '589', '629', '0');
INSERT INTO `school_recruit` VALUES ('55665', '112', '2012', '1', '1', '34', '569', '606', '0');
INSERT INTO `school_recruit` VALUES ('55666', '112', '2011', '1', '1', '34', '595', '637', '0');
INSERT INTO `school_recruit` VALUES ('55667', '112', '2010', '1', '1', '34', '582', '617', '0');
INSERT INTO `school_recruit` VALUES ('55673', '112', '2013', '1', '2', '34', '595', '640', '0');
INSERT INTO `school_recruit` VALUES ('55674', '112', '2012', '1', '2', '34', '593', '627', '0');
INSERT INTO `school_recruit` VALUES ('55675', '112', '2011', '1', '2', '34', '593', '644', '0');
INSERT INTO `school_recruit` VALUES ('55676', '112', '2010', '1', '2', '34', '599', '641', '0');
INSERT INTO `school_recruit` VALUES ('55723', '112', '2013', '1', '1', '3', '467', '486', '0');
INSERT INTO `school_recruit` VALUES ('55724', '112', '2012', '1', '1', '3', '476', '491', '0');
INSERT INTO `school_recruit` VALUES ('55725', '112', '2011', '1', '1', '3', '499', '513', '0');
INSERT INTO `school_recruit` VALUES ('55726', '112', '2010', '1', '1', '3', '507', '521', '0');
INSERT INTO `school_recruit` VALUES ('55732', '112', '2013', '1', '2', '3', '430', '455', '0');
INSERT INTO `school_recruit` VALUES ('55733', '112', '2012', '1', '2', '3', '469', '475', '0');
INSERT INTO `school_recruit` VALUES ('55734', '112', '2011', '1', '2', '3', '494', '501', '0');
INSERT INTO `school_recruit` VALUES ('55735', '112', '2010', '1', '2', '3', '500', '507', '0');
INSERT INTO `school_recruit` VALUES ('55863', '112', '2010', '1', '1', '10', '657', '674', '0');
INSERT INTO `school_recruit` VALUES ('55869', '112', '2010', '5', '1', '10', '620', '631', '0');
INSERT INTO `school_recruit` VALUES ('55870', '112', '2010', '1', '2', '10', '633', '647', '0');
INSERT INTO `school_recruit` VALUES ('55876', '112', '2010', '5', '2', '10', '589', '608', '0');
INSERT INTO `school_recruit` VALUES ('55913', '112', '2013', '1', '1', '13', '587', '603', '579');
INSERT INTO `school_recruit` VALUES ('55914', '112', '2012', '1', '1', '13', '620', '634', '616');
INSERT INTO `school_recruit` VALUES ('55915', '112', '2011', '1', '1', '13', '584', '597', '579');
INSERT INTO `school_recruit` VALUES ('55916', '112', '2010', '1', '1', '13', '569', '587', '565');
INSERT INTO `school_recruit` VALUES ('55922', '112', '2013', '1', '2', '13', '605', '625', '581');
INSERT INTO `school_recruit` VALUES ('55923', '112', '2012', '1', '2', '13', '626', '635', '620');
INSERT INTO `school_recruit` VALUES ('55924', '112', '2011', '1', '2', '13', '611', '625', '603');
INSERT INTO `school_recruit` VALUES ('55925', '112', '2010', '1', '2', '13', '588', '607', '579');
INSERT INTO `school_recruit` VALUES ('57272', '115', '2013', '1', '1', '34', '639', '678', '0');
INSERT INTO `school_recruit` VALUES ('57273', '115', '2012', '1', '1', '34', '582', '613', '0');
INSERT INTO `school_recruit` VALUES ('57274', '115', '2011', '1', '1', '34', '601', '638', '0');
INSERT INTO `school_recruit` VALUES ('57275', '115', '2010', '1', '1', '34', '605', '633', '0');
INSERT INTO `school_recruit` VALUES ('57281', '115', '2013', '1', '2', '34', '655', '680', '0');
INSERT INTO `school_recruit` VALUES ('57282', '115', '2012', '1', '2', '34', '614', '662', '0');
INSERT INTO `school_recruit` VALUES ('57283', '115', '2011', '1', '2', '34', '610', '647', '0');
INSERT INTO `school_recruit` VALUES ('57284', '115', '2010', '1', '2', '34', '623', '668', '0');
INSERT INTO `school_recruit` VALUES ('57318', '115', '2012', '1', '1', '3', '487', '487', '0');
INSERT INTO `school_recruit` VALUES ('57319', '115', '2011', '1', '1', '3', '517', '533', '0');
INSERT INTO `school_recruit` VALUES ('57320', '115', '2010', '1', '1', '3', '506', '517', '0');
INSERT INTO `school_recruit` VALUES ('57325', '115', '2010', '5', '1', '3', '517', '532', '0');
INSERT INTO `school_recruit` VALUES ('57327', '115', '2013', '1', '2', '3', '432', '460', '0');
INSERT INTO `school_recruit` VALUES ('57328', '115', '2012', '1', '2', '3', '477', '481', '0');
INSERT INTO `school_recruit` VALUES ('57329', '115', '2011', '1', '2', '3', '494', '501', '0');
INSERT INTO `school_recruit` VALUES ('57330', '115', '2010', '1', '2', '3', '508', '518', '0');
INSERT INTO `school_recruit` VALUES ('57445', '115', '2010', '1', '1', '10', '659', '671', '0');
INSERT INTO `school_recruit` VALUES ('57451', '115', '2010', '5', '1', '10', '661', '675', '0');
INSERT INTO `school_recruit` VALUES ('57453', '115', '2010', '1', '2', '10', '644', '667', '0');
INSERT INTO `school_recruit` VALUES ('57459', '115', '2010', '5', '2', '10', '646', '670', '0');
INSERT INTO `school_recruit` VALUES ('57492', '115', '2010', '1', '1', '13', '552', '573', '524');
INSERT INTO `school_recruit` VALUES ('57497', '115', '2010', '5', '1', '13', '586', '593', '0');
INSERT INTO `school_recruit` VALUES ('57499', '115', '2013', '1', '2', '13', '616', '623', '598');
INSERT INTO `school_recruit` VALUES ('57500', '115', '2012', '1', '2', '13', '629', '634', '625');
INSERT INTO `school_recruit` VALUES ('57501', '115', '2011', '1', '2', '13', '610', '620', '602');
INSERT INTO `school_recruit` VALUES ('62750', '127', '2013', '2', '1', '34', '511', '528', '0');
INSERT INTO `school_recruit` VALUES ('62751', '127', '2012', '2', '1', '34', '481', '538', '0');
INSERT INTO `school_recruit` VALUES ('62752', '127', '2011', '2', '1', '34', '506', '525', '0');
INSERT INTO `school_recruit` VALUES ('62753', '127', '2010', '2', '1', '34', '516', '583', '0');
INSERT INTO `school_recruit` VALUES ('62759', '127', '2013', '2', '2', '34', '514', '524', '0');
INSERT INTO `school_recruit` VALUES ('62760', '127', '2012', '2', '2', '34', '476', '587', '0');
INSERT INTO `school_recruit` VALUES ('62761', '127', '2011', '2', '2', '34', '464', '578', '0');
INSERT INTO `school_recruit` VALUES ('62762', '127', '2010', '2', '2', '34', '478', '530', '0');
INSERT INTO `school_recruit` VALUES ('62768', '127', '2010', '5', '2', '34', '471', '497', '0');
INSERT INTO `school_recruit` VALUES ('62818', '127', '2013', '1', '1', '3', '453', '459', '0');
INSERT INTO `school_recruit` VALUES ('62819', '127', '2012', '1', '1', '3', '472', '481', '0');
INSERT INTO `school_recruit` VALUES ('62820', '127', '2011', '1', '1', '3', '489', '505', '0');
INSERT INTO `school_recruit` VALUES ('62821', '127', '2010', '1', '1', '3', '486', '500', '0');
INSERT INTO `school_recruit` VALUES ('62826', '127', '2013', '2', '1', '3', '427', '452', '0');
INSERT INTO `school_recruit` VALUES ('62827', '127', '2012', '2', '1', '3', '439', '451', '0');
INSERT INTO `school_recruit` VALUES ('62828', '127', '2011', '2', '1', '3', '465', '478', '0');
INSERT INTO `school_recruit` VALUES ('62829', '127', '2010', '2', '1', '3', '461', '479', '0');
INSERT INTO `school_recruit` VALUES ('62835', '127', '2013', '1', '2', '3', '411', '417', '0');
INSERT INTO `school_recruit` VALUES ('62836', '127', '2012', '1', '2', '3', '441', '477', '0');
INSERT INTO `school_recruit` VALUES ('62837', '127', '2011', '1', '2', '3', '477', '504', '0');
INSERT INTO `school_recruit` VALUES ('62838', '127', '2010', '1', '2', '3', '480', '499', '0');
INSERT INTO `school_recruit` VALUES ('62843', '127', '2013', '2', '2', '3', '366', '402', '0');
INSERT INTO `school_recruit` VALUES ('62844', '127', '2012', '2', '2', '3', '422', '453', '0');
INSERT INTO `school_recruit` VALUES ('62845', '127', '2011', '2', '2', '3', '458', '485', '0');
INSERT INTO `school_recruit` VALUES ('62846', '127', '2010', '2', '2', '3', '459', '491', '0');
INSERT INTO `school_recruit` VALUES ('62852', '127', '2010', '5', '2', '3', '420', '468', '0');
INSERT INTO `school_recruit` VALUES ('62992', '127', '2010', '2', '1', '10', '559', '575', '0');
INSERT INTO `school_recruit` VALUES ('63001', '127', '2010', '2', '2', '10', '515', '543', '0');
INSERT INTO `school_recruit` VALUES ('63006', '127', '2010', '5', '2', '10', '532', '554', '0');
INSERT INTO `school_recruit` VALUES ('63052', '127', '2013', '1', '1', '13', '559', '565', '554');
INSERT INTO `school_recruit` VALUES ('63053', '127', '2012', '1', '1', '13', '595', '602', '586');
INSERT INTO `school_recruit` VALUES ('63054', '127', '2011', '1', '1', '13', '562', '572', '559');
INSERT INTO `school_recruit` VALUES ('63056', '127', '2011', '2', '1', '13', '541', '544', '539');
INSERT INTO `school_recruit` VALUES ('63057', '127', '2010', '2', '1', '13', '529', '536', '0');
INSERT INTO `school_recruit` VALUES ('63063', '127', '2013', '1', '2', '13', '555', '561', '553');
INSERT INTO `school_recruit` VALUES ('63064', '127', '2012', '1', '2', '13', '581', '594', '577');
INSERT INTO `school_recruit` VALUES ('63065', '127', '2011', '1', '2', '13', '560', '580', '555');
INSERT INTO `school_recruit` VALUES ('63067', '127', '2010', '2', '2', '13', '544', '566', '0');
INSERT INTO `school_recruit` VALUES ('63073', '127', '2010', '5', '2', '13', '502', '534', '0');
INSERT INTO `school_recruit` VALUES ('64281', '130', '2013', '2', '1', '34', '503', '513', '0');
INSERT INTO `school_recruit` VALUES ('64282', '130', '2012', '2', '1', '34', '476', '485', '0');
INSERT INTO `school_recruit` VALUES ('64283', '130', '2011', '2', '1', '34', '496', '521', '0');
INSERT INTO `school_recruit` VALUES ('64285', '130', '2013', '2', '2', '34', '512', '519', '0');
INSERT INTO `school_recruit` VALUES ('64286', '130', '2012', '2', '2', '34', '435', '437', '0');
INSERT INTO `school_recruit` VALUES ('64287', '130', '2011', '2', '2', '34', '459', '485', '0');
INSERT INTO `school_recruit` VALUES ('64288', '130', '2010', '2', '2', '34', '460', '479', '0');
INSERT INTO `school_recruit` VALUES ('64309', '130', '2013', '2', '1', '3', '408', '413', '0');
INSERT INTO `school_recruit` VALUES ('64310', '130', '2013', '2', '2', '3', '350', '370', '0');
INSERT INTO `school_recruit` VALUES ('64311', '130', '2012', '2', '2', '3', '382', '397', '0');
INSERT INTO `school_recruit` VALUES ('64312', '130', '2011', '2', '2', '3', '410', '433', '0');
INSERT INTO `school_recruit` VALUES ('64313', '130', '2010', '2', '2', '3', '418', '427', '0');
INSERT INTO `school_recruit` VALUES ('64382', '130', '2010', '1', '1', '10', '602', '618', '0');
INSERT INTO `school_recruit` VALUES ('64386', '130', '2010', '2', '1', '10', '543', '559', '0');
INSERT INTO `school_recruit` VALUES ('64391', '130', '2010', '1', '2', '10', '571', '623', '0');
INSERT INTO `school_recruit` VALUES ('64396', '130', '2010', '2', '2', '10', '502', '525', '0');
INSERT INTO `school_recruit` VALUES ('64424', '130', '2013', '1', '1', '13', '544', '547', '542');
INSERT INTO `school_recruit` VALUES ('64425', '130', '2012', '1', '1', '13', '582', '592', '579');
INSERT INTO `school_recruit` VALUES ('64426', '130', '2011', '1', '1', '13', '539', '556', '532');
INSERT INTO `school_recruit` VALUES ('64427', '130', '2013', '1', '2', '13', '549', '562', '544');
INSERT INTO `school_recruit` VALUES ('64428', '130', '2012', '1', '2', '13', '578', '598', '573');
INSERT INTO `school_recruit` VALUES ('64429', '130', '2011', '1', '2', '13', '560', '577', '554');
INSERT INTO `school_recruit` VALUES ('64430', '130', '2010', '1', '2', '13', '546', '564', '542');
INSERT INTO `school_recruit` VALUES ('64556', '131', '2013', '1', '2', '34', '573', '597', '0');
INSERT INTO `school_recruit` VALUES ('64557', '131', '2012', '1', '2', '34', '517', '590', '0');
INSERT INTO `school_recruit` VALUES ('64558', '131', '2011', '1', '2', '34', '534', '598', '0');
INSERT INTO `school_recruit` VALUES ('64559', '131', '2010', '1', '2', '34', '541', '609', '0');
INSERT INTO `school_recruit` VALUES ('64583', '131', '2013', '1', '1', '3', '460', '473', '0');
INSERT INTO `school_recruit` VALUES ('64584', '131', '2012', '1', '1', '3', '471', '476', '0');
INSERT INTO `school_recruit` VALUES ('64585', '131', '2011', '1', '1', '3', '494', '533', '0');
INSERT INTO `school_recruit` VALUES ('64586', '131', '2010', '1', '1', '3', '487', '510', '0');
INSERT INTO `school_recruit` VALUES ('64592', '131', '2013', '1', '2', '3', '422', '440', '0');
INSERT INTO `school_recruit` VALUES ('64593', '131', '2012', '1', '2', '3', '453', '474', '0');
INSERT INTO `school_recruit` VALUES ('64594', '131', '2011', '1', '2', '3', '483', '516', '0');
INSERT INTO `school_recruit` VALUES ('64595', '131', '2010', '1', '2', '3', '480', '507', '0');
INSERT INTO `school_recruit` VALUES ('64662', '131', '2010', '1', '1', '10', '632', '640', '0');
INSERT INTO `school_recruit` VALUES ('64665', '131', '2010', '1', '2', '10', '599', '627', '0');
INSERT INTO `school_recruit` VALUES ('64691', '131', '2013', '1', '2', '13', '563', '577', '560');
INSERT INTO `school_recruit` VALUES ('64692', '131', '2012', '1', '2', '13', '587', '602', '584');
INSERT INTO `school_recruit` VALUES ('64693', '131', '2011', '1', '2', '13', '567', '584', '560');
INSERT INTO `school_recruit` VALUES ('64694', '131', '2010', '1', '2', '13', '552', '568', '547');
INSERT INTO `school_recruit` VALUES ('70377', '144', '2013', '2', '2', '34', '517', '529', '0');
INSERT INTO `school_recruit` VALUES ('70378', '144', '2012', '2', '2', '34', '451', '478', '0');
INSERT INTO `school_recruit` VALUES ('70379', '144', '2011', '2', '2', '34', '459', '557', '0');
INSERT INTO `school_recruit` VALUES ('70380', '144', '2010', '2', '2', '34', '470', '504', '0');
INSERT INTO `school_recruit` VALUES ('70402', '144', '2011', '2', '1', '3', '437', '449', '0');
INSERT INTO `school_recruit` VALUES ('70403', '144', '2013', '2', '2', '3', '356', '381', '0');
INSERT INTO `school_recruit` VALUES ('70404', '144', '2012', '2', '2', '3', '403', '423', '0');
INSERT INTO `school_recruit` VALUES ('70405', '144', '2011', '2', '2', '3', '439', '458', '0');
INSERT INTO `school_recruit` VALUES ('70406', '144', '2010', '2', '2', '3', '443', '456', '0');
INSERT INTO `school_recruit` VALUES ('70475', '144', '2010', '1', '1', '10', '605', '640', '0');
INSERT INTO `school_recruit` VALUES ('70483', '144', '2010', '1', '2', '10', '586', '631', '0');
INSERT INTO `school_recruit` VALUES ('70488', '144', '2010', '2', '2', '10', '498', '523', '0');
INSERT INTO `school_recruit` VALUES ('70519', '144', '2013', '1', '1', '13', '536', '542', '533');
INSERT INTO `school_recruit` VALUES ('70520', '144', '2012', '1', '1', '13', '578', '589', '574');
INSERT INTO `school_recruit` VALUES ('70521', '144', '2011', '1', '1', '13', '539', '545', '536');
INSERT INTO `school_recruit` VALUES ('70522', '144', '2013', '1', '2', '13', '557', '575', '554');
INSERT INTO `school_recruit` VALUES ('70523', '144', '2012', '1', '2', '13', '580', '600', '575');
INSERT INTO `school_recruit` VALUES ('70524', '144', '2011', '1', '2', '13', '564', '591', '556');
INSERT INTO `school_recruit` VALUES ('70525', '144', '2010', '1', '2', '13', '548', '569', '543');
INSERT INTO `school_recruit` VALUES ('71767', '147', '2013', '2', '1', '34', '494', '494', '0');
INSERT INTO `school_recruit` VALUES ('71768', '147', '2011', '2', '1', '34', '489', '489', '0');
INSERT INTO `school_recruit` VALUES ('71769', '147', '2010', '2', '1', '34', '484', '485', '0');
INSERT INTO `school_recruit` VALUES ('71775', '147', '2012', '2', '2', '34', '450', '468', '0');
INSERT INTO `school_recruit` VALUES ('71776', '147', '2011', '2', '2', '34', '449', '495', '0');
INSERT INTO `school_recruit` VALUES ('71777', '147', '2010', '2', '2', '34', '469', '521', '0');
INSERT INTO `school_recruit` VALUES ('71822', '147', '2013', '2', '1', '3', '411', '420', '0');
INSERT INTO `school_recruit` VALUES ('71823', '147', '2012', '2', '1', '3', '394', '408', '0');
INSERT INTO `school_recruit` VALUES ('71824', '147', '2011', '2', '1', '3', '425', '433', '0');
INSERT INTO `school_recruit` VALUES ('71825', '147', '2010', '2', '1', '3', '411', '419', '0');
INSERT INTO `school_recruit` VALUES ('71831', '147', '2013', '2', '2', '3', '344', '357', '0');
INSERT INTO `school_recruit` VALUES ('71832', '147', '2012', '2', '2', '3', '368', '387', '0');
INSERT INTO `school_recruit` VALUES ('71833', '147', '2011', '2', '2', '3', '408', '423', '0');
INSERT INTO `school_recruit` VALUES ('71834', '147', '2010', '2', '2', '3', '409', '437', '0');
INSERT INTO `school_recruit` VALUES ('71956', '147', '2010', '2', '1', '10', '525', '529', '0');
INSERT INTO `school_recruit` VALUES ('71962', '147', '2010', '2', '2', '10', '494', '513', '0');
INSERT INTO `school_recruit` VALUES ('72013', '147', '2013', '1', '1', '13', '537', '539', '532');
INSERT INTO `school_recruit` VALUES ('72014', '147', '2013', '2', '1', '13', '516', '531', '491');
INSERT INTO `school_recruit` VALUES ('72015', '147', '2012', '2', '1', '13', '550', '568', '524');
INSERT INTO `school_recruit` VALUES ('72016', '147', '2011', '2', '1', '13', '518', '531', '514');
INSERT INTO `school_recruit` VALUES ('72017', '147', '2010', '2', '1', '13', '508', '521', '0');
INSERT INTO `school_recruit` VALUES ('72023', '147', '2013', '1', '2', '13', '521', '570', '517');
INSERT INTO `school_recruit` VALUES ('72024', '147', '2012', '1', '2', '13', '551', '576', '547');
INSERT INTO `school_recruit` VALUES ('72025', '147', '2011', '1', '2', '13', '536', '579', '531');
INSERT INTO `school_recruit` VALUES ('72026', '147', '2010', '1', '2', '13', '521', '547', '515');
INSERT INTO `school_recruit` VALUES ('72029', '147', '2013', '2', '2', '13', '493', '541', '456');
INSERT INTO `school_recruit` VALUES ('72030', '147', '2012', '2', '2', '13', '524', '550', '486');
INSERT INTO `school_recruit` VALUES ('72031', '147', '2011', '2', '2', '13', '509', '534', '474');
INSERT INTO `school_recruit` VALUES ('72032', '147', '2010', '2', '2', '13', '498', '516', '0');
INSERT INTO `school_recruit` VALUES ('73152', '150', '2013', '1', '1', '34', '572', '595', '0');
INSERT INTO `school_recruit` VALUES ('73153', '150', '2012', '1', '1', '34', '538', '570', '0');
INSERT INTO `school_recruit` VALUES ('73154', '150', '2011', '1', '1', '34', '569', '610', '0');
INSERT INTO `school_recruit` VALUES ('73155', '150', '2010', '1', '1', '34', '564', '609', '0');
INSERT INTO `school_recruit` VALUES ('73161', '150', '2013', '1', '2', '34', '582', '614', '0');
INSERT INTO `school_recruit` VALUES ('73162', '150', '2012', '1', '2', '34', '545', '629', '0');
INSERT INTO `school_recruit` VALUES ('73163', '150', '2011', '1', '2', '34', '546', '580', '0');
INSERT INTO `school_recruit` VALUES ('73164', '150', '2010', '1', '2', '34', '549', '600', '0');
INSERT INTO `school_recruit` VALUES ('73209', '150', '2013', '1', '1', '3', '451', '455', '0');
INSERT INTO `school_recruit` VALUES ('73210', '150', '2012', '1', '1', '3', '471', '471', '0');
INSERT INTO `school_recruit` VALUES ('73211', '150', '2011', '1', '1', '3', '497', '512', '0');
INSERT INTO `school_recruit` VALUES ('73212', '150', '2010', '1', '1', '3', '481', '491', '0');
INSERT INTO `school_recruit` VALUES ('73218', '150', '2013', '1', '2', '3', '411', '418', '0');
INSERT INTO `school_recruit` VALUES ('73219', '150', '2012', '1', '2', '3', '436', '462', '0');
INSERT INTO `school_recruit` VALUES ('73220', '150', '2011', '1', '2', '3', '480', '480', '0');
INSERT INTO `school_recruit` VALUES ('73221', '150', '2010', '1', '2', '3', '475', '484', '0');
INSERT INTO `school_recruit` VALUES ('73333', '150', '2010', '1', '1', '10', '632', '640', '0');
INSERT INTO `school_recruit` VALUES ('73339', '150', '2010', '1', '2', '10', '603', '619', '0');
INSERT INTO `school_recruit` VALUES ('73380', '150', '2013', '1', '1', '13', '569', '572', '568');
INSERT INTO `school_recruit` VALUES ('73381', '150', '2012', '1', '1', '13', '603', '604', '602');
INSERT INTO `school_recruit` VALUES ('73382', '150', '2011', '1', '1', '13', '561', '570', '556');
INSERT INTO `school_recruit` VALUES ('73383', '150', '2010', '1', '1', '13', '551', '559', '549');
INSERT INTO `school_recruit` VALUES ('73389', '150', '2013', '1', '2', '13', '566', '572', '562');
INSERT INTO `school_recruit` VALUES ('73390', '150', '2012', '1', '2', '13', '592', '608', '588');
INSERT INTO `school_recruit` VALUES ('73391', '150', '2011', '1', '2', '13', '570', '577', '565');
INSERT INTO `school_recruit` VALUES ('73392', '150', '2010', '1', '2', '13', '553', '563', '548');
INSERT INTO `school_recruit` VALUES ('76932', '158', '2013', '1', '1', '3', '454', '460', '0');
INSERT INTO `school_recruit` VALUES ('76933', '158', '2012', '1', '1', '3', '470', '470', '0');
INSERT INTO `school_recruit` VALUES ('76934', '158', '2011', '1', '1', '3', '475', '502', '0');
INSERT INTO `school_recruit` VALUES ('76935', '158', '2010', '1', '1', '3', '472', '488', '0');
INSERT INTO `school_recruit` VALUES ('76940', '158', '2013', '2', '1', '3', '427', '452', '0');
INSERT INTO `school_recruit` VALUES ('76941', '158', '2012', '2', '1', '3', '435', '450', '0');
INSERT INTO `school_recruit` VALUES ('76942', '158', '2011', '2', '1', '3', '459', '490', '0');
INSERT INTO `school_recruit` VALUES ('76943', '158', '2010', '2', '1', '3', '455', '476', '0');
INSERT INTO `school_recruit` VALUES ('76948', '158', '2010', '5', '1', '3', '464', '516', '0');
INSERT INTO `school_recruit` VALUES ('76953', '158', '2013', '1', '2', '3', '414', '423', '0');
INSERT INTO `school_recruit` VALUES ('76954', '158', '2012', '1', '2', '3', '437', '462', '0');
INSERT INTO `school_recruit` VALUES ('76955', '158', '2011', '1', '2', '3', '472', '487', '0');
INSERT INTO `school_recruit` VALUES ('76956', '158', '2010', '1', '2', '3', '472', '485', '0');
INSERT INTO `school_recruit` VALUES ('76959', '158', '2013', '2', '2', '3', '365', '400', '0');
INSERT INTO `school_recruit` VALUES ('76960', '158', '2012', '2', '2', '3', '416', '443', '0');
INSERT INTO `school_recruit` VALUES ('76961', '158', '2011', '2', '2', '3', '448', '471', '0');
INSERT INTO `school_recruit` VALUES ('76962', '158', '2010', '2', '2', '3', '449', '479', '0');
INSERT INTO `school_recruit` VALUES ('76967', '158', '2010', '5', '2', '3', '459', '501', '0');
INSERT INTO `school_recruit` VALUES ('77018', '158', '2010', '2', '1', '10', '547', '567', '0');
INSERT INTO `school_recruit` VALUES ('77023', '158', '2010', '2', '2', '10', '502', '529', '0');
INSERT INTO `school_recruit` VALUES ('77063', '158', '2013', '1', '1', '13', '541', '555', '537');
INSERT INTO `school_recruit` VALUES ('77064', '158', '2012', '1', '1', '13', '579', '597', '571');
INSERT INTO `school_recruit` VALUES ('77065', '158', '2013', '2', '1', '13', '531', '540', '528');
INSERT INTO `school_recruit` VALUES ('77066', '158', '2012', '2', '1', '13', '569', '576', '565');
INSERT INTO `school_recruit` VALUES ('77067', '158', '2011', '2', '1', '13', '533', '543', '530');
INSERT INTO `school_recruit` VALUES ('77068', '158', '2010', '2', '1', '13', '522', '530', '0');
INSERT INTO `school_recruit` VALUES ('77071', '158', '2013', '1', '2', '13', '538', '552', '534');
INSERT INTO `school_recruit` VALUES ('77072', '158', '2012', '1', '2', '13', '564', '581', '551');
INSERT INTO `school_recruit` VALUES ('77074', '158', '2013', '2', '2', '13', '514', '524', '509');
INSERT INTO `school_recruit` VALUES ('77075', '158', '2012', '2', '2', '13', '543', '552', '540');
INSERT INTO `school_recruit` VALUES ('77076', '158', '2011', '2', '2', '13', '528', '544', '524');
INSERT INTO `school_recruit` VALUES ('77077', '158', '2010', '2', '2', '13', '514', '529', '0');
INSERT INTO `school_recruit` VALUES ('77193', '159', '2010', '2', '1', '34', '480', '480', '0');
INSERT INTO `school_recruit` VALUES ('77198', '159', '2012', '2', '2', '34', '444', '444', '0');
INSERT INTO `school_recruit` VALUES ('77199', '159', '2011', '2', '2', '34', '457', '479', '0');
INSERT INTO `school_recruit` VALUES ('77200', '159', '2010', '2', '2', '34', '460', '476', '0');
INSERT INTO `school_recruit` VALUES ('77242', '159', '2013', '2', '1', '3', '407', '412', '0');
INSERT INTO `school_recruit` VALUES ('77243', '159', '2012', '2', '1', '3', '400', '408', '0');
INSERT INTO `school_recruit` VALUES ('77244', '159', '2011', '2', '1', '3', '418', '427', '0');
INSERT INTO `school_recruit` VALUES ('77245', '159', '2010', '2', '1', '3', '414', '426', '0');
INSERT INTO `school_recruit` VALUES ('77250', '159', '2013', '2', '2', '3', '336', '342', '0');
INSERT INTO `school_recruit` VALUES ('77251', '159', '2012', '2', '2', '3', '362', '379', '0');
INSERT INTO `school_recruit` VALUES ('77252', '159', '2011', '2', '2', '3', '404', '408', '0');
INSERT INTO `school_recruit` VALUES ('77253', '159', '2010', '2', '2', '3', '405', '413', '0');
INSERT INTO `school_recruit` VALUES ('77375', '159', '2010', '2', '1', '10', '521', '530', '0');
INSERT INTO `school_recruit` VALUES ('77381', '159', '2010', '2', '2', '10', '481', '506', '0');
INSERT INTO `school_recruit` VALUES ('77427', '159', '2012', '1', '1', '13', '570', '570', '570');
INSERT INTO `school_recruit` VALUES ('77428', '159', '2011', '1', '1', '13', '532', '532', '532');
INSERT INTO `school_recruit` VALUES ('77429', '159', '2013', '2', '1', '13', '506', '527', '484');
INSERT INTO `school_recruit` VALUES ('77430', '159', '2012', '2', '1', '13', '548', '567', '548');
INSERT INTO `school_recruit` VALUES ('77431', '159', '2011', '2', '1', '13', '508', '532', '508');
INSERT INTO `school_recruit` VALUES ('77432', '159', '2010', '2', '1', '13', '500', '520', '0');
INSERT INTO `school_recruit` VALUES ('77438', '159', '2013', '1', '2', '13', '521', '541', '517');
INSERT INTO `school_recruit` VALUES ('77439', '159', '2012', '1', '2', '13', '551', '578', '550');
INSERT INTO `school_recruit` VALUES ('77440', '159', '2011', '1', '2', '13', '536', '550', '531');
INSERT INTO `school_recruit` VALUES ('77441', '159', '2010', '1', '2', '13', '519', '534', '515');
INSERT INTO `school_recruit` VALUES ('77443', '159', '2013', '2', '2', '13', '485', '518', '456');
INSERT INTO `school_recruit` VALUES ('77444', '159', '2012', '2', '2', '13', '518', '549', '522');
INSERT INTO `school_recruit` VALUES ('77445', '159', '2011', '2', '2', '13', '503', '532', '505');
INSERT INTO `school_recruit` VALUES ('77446', '159', '2010', '2', '2', '13', '489', '514', '0');
INSERT INTO `school_recruit` VALUES ('77761', '160', '2013', '1', '1', '34', '570', '592', '0');
INSERT INTO `school_recruit` VALUES ('77762', '160', '2012', '1', '1', '34', '539', '612', '0');
INSERT INTO `school_recruit` VALUES ('77763', '160', '2011', '1', '1', '34', '568', '630', '0');
INSERT INTO `school_recruit` VALUES ('77764', '160', '2010', '1', '1', '34', '565', '626', '0');
INSERT INTO `school_recruit` VALUES ('77770', '160', '2013', '2', '1', '34', '523', '553', '0');
INSERT INTO `school_recruit` VALUES ('77771', '160', '2012', '2', '1', '34', '507', '594', '0');
INSERT INTO `school_recruit` VALUES ('77772', '160', '2011', '2', '1', '34', '530', '607', '0');
INSERT INTO `school_recruit` VALUES ('77773', '160', '2010', '2', '1', '34', '525', '587', '0');
INSERT INTO `school_recruit` VALUES ('77778', '160', '2013', '1', '2', '34', '580', '611', '0');
INSERT INTO `school_recruit` VALUES ('77779', '160', '2012', '1', '2', '34', '545', '641', '0');
INSERT INTO `school_recruit` VALUES ('77780', '160', '2011', '1', '2', '34', '555', '642', '0');
INSERT INTO `school_recruit` VALUES ('77781', '160', '2010', '1', '2', '34', '570', '639', '0');
INSERT INTO `school_recruit` VALUES ('77787', '160', '2013', '2', '2', '34', '541', '578', '0');
INSERT INTO `school_recruit` VALUES ('77788', '160', '2012', '2', '2', '34', '506', '626', '0');
INSERT INTO `school_recruit` VALUES ('77789', '160', '2011', '2', '2', '34', '509', '599', '0');
INSERT INTO `school_recruit` VALUES ('77790', '160', '2010', '2', '2', '34', '523', '619', '0');
INSERT INTO `school_recruit` VALUES ('77832', '160', '2013', '2', '1', '3', '427', '452', '0');
INSERT INTO `school_recruit` VALUES ('77833', '160', '2012', '2', '1', '3', '437', '443', '0');
INSERT INTO `school_recruit` VALUES ('77834', '160', '2011', '2', '1', '3', '462', '467', '0');
INSERT INTO `school_recruit` VALUES ('77835', '160', '2010', '2', '1', '3', '461', '467', '0');
INSERT INTO `school_recruit` VALUES ('77841', '160', '2013', '2', '2', '3', '361', '391', '0');
INSERT INTO `school_recruit` VALUES ('77842', '160', '2012', '2', '2', '3', '411', '416', '0');
INSERT INTO `school_recruit` VALUES ('77843', '160', '2011', '2', '2', '3', '447', '454', '0');
INSERT INTO `school_recruit` VALUES ('77844', '160', '2010', '2', '2', '3', '453', '461', '0');
INSERT INTO `school_recruit` VALUES ('77957', '160', '2010', '2', '1', '10', '564', '591', '0');
INSERT INTO `school_recruit` VALUES ('77966', '160', '2010', '2', '2', '10', '523', '545', '0');
INSERT INTO `school_recruit` VALUES ('78005', '160', '2013', '1', '1', '13', '566', '566', '566');
INSERT INTO `school_recruit` VALUES ('78006', '160', '2012', '1', '1', '13', '604', '611', '600');
INSERT INTO `school_recruit` VALUES ('78007', '160', '2011', '1', '1', '13', '566', '570', '563');
INSERT INTO `school_recruit` VALUES ('78009', '160', '2010', '2', '1', '13', '549', '561', '0');
INSERT INTO `school_recruit` VALUES ('78014', '160', '2013', '1', '2', '13', '575', '591', '568');
INSERT INTO `school_recruit` VALUES ('78015', '160', '2012', '1', '2', '13', '596', '604', '592');
INSERT INTO `school_recruit` VALUES ('78016', '160', '2011', '1', '2', '13', '568', '578', '562');
INSERT INTO `school_recruit` VALUES ('78018', '160', '2011', '2', '2', '13', '556', '573', '544');
INSERT INTO `school_recruit` VALUES ('78019', '160', '2010', '2', '2', '13', '535', '547', '0');
INSERT INTO `school_recruit` VALUES ('78672', '162', '2013', '2', '2', '34', '512', '520', '0');
INSERT INTO `school_recruit` VALUES ('78673', '162', '2010', '2', '2', '34', '493', '546', '0');
INSERT INTO `school_recruit` VALUES ('78710', '162', '2013', '2', '1', '3', '417', '431', '0');
INSERT INTO `school_recruit` VALUES ('78711', '162', '2012', '2', '1', '3', '418', '426', '0');
INSERT INTO `school_recruit` VALUES ('78717', '162', '2010', '4', '1', '3', '128', '257', '0');
INSERT INTO `school_recruit` VALUES ('78718', '162', '2013', '2', '2', '3', '344', '357', '0');
INSERT INTO `school_recruit` VALUES ('78719', '162', '2012', '2', '2', '3', '380', '408', '0');
INSERT INTO `school_recruit` VALUES ('78720', '162', '2011', '2', '2', '3', '402', '412', '0');
INSERT INTO `school_recruit` VALUES ('78721', '162', '2010', '2', '2', '3', '411', '422', '0');
INSERT INTO `school_recruit` VALUES ('78727', '162', '2010', '4', '2', '3', '138', '276', '0');
INSERT INTO `school_recruit` VALUES ('78865', '162', '2011', '2', '1', '10', '481', '532', '0');
INSERT INTO `school_recruit` VALUES ('78866', '162', '2010', '2', '1', '10', '499', '539', '0');
INSERT INTO `school_recruit` VALUES ('78872', '162', '2010', '4', '1', '10', '203', '407', '0');
INSERT INTO `school_recruit` VALUES ('78873', '162', '2011', '2', '2', '10', '443', '504', '0');
INSERT INTO `school_recruit` VALUES ('78874', '162', '2010', '2', '2', '10', '462', '522', '0');
INSERT INTO `school_recruit` VALUES ('78880', '162', '2010', '4', '2', '10', '192', '385', '0');
INSERT INTO `school_recruit` VALUES ('78937', '162', '2013', '1', '1', '13', '534', '547', '532');
INSERT INTO `school_recruit` VALUES ('78938', '162', '2012', '1', '1', '13', '572', '591', '570');
INSERT INTO `school_recruit` VALUES ('78939', '162', '2011', '1', '1', '13', '545', '559', '532');
INSERT INTO `school_recruit` VALUES ('78940', '162', '2010', '1', '1', '13', '527', '533', '521');
INSERT INTO `school_recruit` VALUES ('78943', '162', '2013', '2', '1', '13', '515', '537', '504');
INSERT INTO `school_recruit` VALUES ('78944', '162', '2012', '2', '1', '13', '557', '569', '545');
INSERT INTO `school_recruit` VALUES ('78945', '162', '2011', '2', '1', '13', '507', '530', '495');
INSERT INTO `school_recruit` VALUES ('78946', '162', '2010', '2', '1', '13', '501', '524', '0');
INSERT INTO `school_recruit` VALUES ('78952', '162', '2010', '4', '1', '13', '236', '472', '0');
INSERT INTO `school_recruit` VALUES ('78953', '162', '2013', '1', '2', '13', '525', '566', '521');
INSERT INTO `school_recruit` VALUES ('78954', '162', '2012', '1', '2', '13', '552', '585', '548');
INSERT INTO `school_recruit` VALUES ('78955', '162', '2011', '1', '2', '13', '571', '612', '531');
INSERT INTO `school_recruit` VALUES ('78956', '162', '2010', '1', '2', '13', '543', '571', '515');
INSERT INTO `school_recruit` VALUES ('78959', '162', '2013', '2', '2', '13', '476', '521', '458');
INSERT INTO `school_recruit` VALUES ('78960', '162', '2012', '2', '2', '13', '517', '553', '490');
INSERT INTO `school_recruit` VALUES ('78961', '162', '2011', '2', '2', '13', '503', '533', '474');
INSERT INTO `school_recruit` VALUES ('78962', '162', '2010', '2', '2', '13', '506', '550', '0');
INSERT INTO `school_recruit` VALUES ('78968', '162', '2010', '4', '2', '13', '228', '457', '0');
INSERT INTO `school_recruit` VALUES ('81886', '169', '2013', '2', '1', '34', '501', '509', '0');
INSERT INTO `school_recruit` VALUES ('81887', '169', '2012', '2', '1', '34', '461', '525', '0');
INSERT INTO `school_recruit` VALUES ('81888', '169', '2011', '2', '1', '34', '494', '540', '0');
INSERT INTO `school_recruit` VALUES ('81889', '169', '2010', '2', '1', '34', '489', '534', '0');
INSERT INTO `school_recruit` VALUES ('81894', '169', '2013', '2', '2', '34', '508', '512', '0');
INSERT INTO `school_recruit` VALUES ('81895', '169', '2012', '2', '2', '34', '445', '557', '0');
INSERT INTO `school_recruit` VALUES ('81896', '169', '2011', '2', '2', '34', '448', '535', '0');
INSERT INTO `school_recruit` VALUES ('81897', '169', '2010', '2', '2', '34', '459', '542', '0');
INSERT INTO `school_recruit` VALUES ('81912', '169', '2013', '2', '2', '3', '352', '375', '0');
INSERT INTO `school_recruit` VALUES ('81913', '169', '2012', '2', '2', '3', '372', '382', '0');
INSERT INTO `school_recruit` VALUES ('81914', '169', '2011', '2', '2', '3', '417', '448', '0');
INSERT INTO `school_recruit` VALUES ('82000', '169', '2013', '2', '1', '10', '281', '563', '0');
INSERT INTO `school_recruit` VALUES ('82001', '169', '2010', '2', '1', '10', '514', '533', '0');
INSERT INTO `school_recruit` VALUES ('82005', '169', '2013', '2', '2', '10', '276', '553', '0');
INSERT INTO `school_recruit` VALUES ('82006', '169', '2010', '2', '2', '10', '469', '475', '0');
INSERT INTO `school_recruit` VALUES ('82041', '169', '2013', '1', '1', '13', '551', '558', '547');
INSERT INTO `school_recruit` VALUES ('82042', '169', '2011', '1', '1', '13', '548', '557', '543');
INSERT INTO `school_recruit` VALUES ('82043', '169', '2013', '2', '1', '13', '528', '542', '523');
INSERT INTO `school_recruit` VALUES ('82044', '169', '2011', '2', '1', '13', '530', '534', '528');
INSERT INTO `school_recruit` VALUES ('82045', '169', '2010', '2', '1', '13', '518', '528', '0');
INSERT INTO `school_recruit` VALUES ('82050', '169', '2013', '1', '2', '13', '540', '543', '535');
INSERT INTO `school_recruit` VALUES ('82051', '169', '2011', '1', '2', '13', '544', '548', '541');
INSERT INTO `school_recruit` VALUES ('82052', '169', '2013', '2', '2', '13', '505', '520', '487');
INSERT INTO `school_recruit` VALUES ('82053', '169', '2011', '2', '2', '13', '527', '536', '524');
INSERT INTO `school_recruit` VALUES ('82054', '169', '2010', '2', '2', '13', '511', '516', '0');
INSERT INTO `school_recruit` VALUES ('82997', '172', '2013', '2', '1', '3', '424', '446', '0');
INSERT INTO `school_recruit` VALUES ('82998', '172', '2012', '2', '1', '3', '431', '450', '0');
INSERT INTO `school_recruit` VALUES ('82999', '172', '2011', '2', '1', '3', '455', '476', '0');
INSERT INTO `school_recruit` VALUES ('83000', '172', '2010', '2', '1', '3', '450', '470', '0');
INSERT INTO `school_recruit` VALUES ('83005', '172', '2013', '2', '2', '3', '369', '407', '0');
INSERT INTO `school_recruit` VALUES ('83006', '172', '2012', '2', '2', '3', '427', '450', '0');
INSERT INTO `school_recruit` VALUES ('83007', '172', '2011', '2', '2', '3', '459', '481', '0');
INSERT INTO `school_recruit` VALUES ('83008', '172', '2010', '2', '2', '3', '458', '471', '0');
INSERT INTO `school_recruit` VALUES ('83140', '172', '2010', '2', '1', '10', '550', '568', '0');
INSERT INTO `school_recruit` VALUES ('83146', '172', '2010', '2', '2', '10', '515', '533', '0');
INSERT INTO `school_recruit` VALUES ('83195', '172', '2013', '2', '1', '13', '536', '542', '531');
INSERT INTO `school_recruit` VALUES ('83196', '172', '2012', '2', '1', '13', '577', '586', '576');
INSERT INTO `school_recruit` VALUES ('83197', '172', '2011', '2', '1', '13', '543', '550', '541');
INSERT INTO `school_recruit` VALUES ('83198', '172', '2010', '2', '1', '13', '530', '534', '0');
INSERT INTO `school_recruit` VALUES ('83204', '172', '2013', '2', '2', '13', '533', '547', '526');
INSERT INTO `school_recruit` VALUES ('83205', '172', '2012', '2', '2', '13', '562', '585', '558');
INSERT INTO `school_recruit` VALUES ('83206', '172', '2011', '2', '2', '13', '545', '570', '539');
INSERT INTO `school_recruit` VALUES ('83207', '172', '2010', '2', '2', '13', '528', '539', '0');
INSERT INTO `school_recruit` VALUES ('84304', '175', '2013', '1', '1', '34', '570', '591', '0');
INSERT INTO `school_recruit` VALUES ('84305', '175', '2012', '1', '1', '34', '533', '588', '0');
INSERT INTO `school_recruit` VALUES ('84306', '175', '2011', '1', '1', '34', '574', '622', '0');
INSERT INTO `school_recruit` VALUES ('84307', '175', '2010', '1', '1', '34', '561', '623', '0');
INSERT INTO `school_recruit` VALUES ('84313', '175', '2013', '1', '2', '34', '588', '627', '0');
INSERT INTO `school_recruit` VALUES ('84314', '175', '2012', '1', '2', '34', '561', '638', '0');
INSERT INTO `school_recruit` VALUES ('84315', '175', '2011', '1', '2', '34', '560', '648', '0');
INSERT INTO `school_recruit` VALUES ('84316', '175', '2010', '1', '2', '34', '572', '650', '0');
INSERT INTO `school_recruit` VALUES ('84359', '175', '2013', '1', '1', '3', '448', '449', '0');
INSERT INTO `school_recruit` VALUES ('84360', '175', '2011', '1', '1', '3', '477', '486', '0');
INSERT INTO `school_recruit` VALUES ('84361', '175', '2010', '1', '1', '3', '477', '486', '0');
INSERT INTO `school_recruit` VALUES ('84366', '175', '2013', '1', '2', '3', '410', '415', '0');
INSERT INTO `school_recruit` VALUES ('84367', '175', '2012', '1', '2', '3', '434', '458', '0');
INSERT INTO `school_recruit` VALUES ('84368', '175', '2011', '1', '2', '3', '472', '502', '0');
INSERT INTO `school_recruit` VALUES ('84369', '175', '2010', '1', '2', '3', '475', '517', '0');
INSERT INTO `school_recruit` VALUES ('84497', '175', '2010', '1', '1', '10', '622', '634', '0');
INSERT INTO `school_recruit` VALUES ('84503', '175', '2010', '1', '2', '10', '588', '607', '0');
INSERT INTO `school_recruit` VALUES ('84546', '175', '2013', '1', '1', '13', '561', '565', '559');
INSERT INTO `school_recruit` VALUES ('84547', '175', '2012', '1', '1', '13', '597', '603', '595');
INSERT INTO `school_recruit` VALUES ('84548', '175', '2011', '1', '1', '13', '558', '562', '555');
INSERT INTO `school_recruit` VALUES ('84549', '175', '2010', '1', '1', '13', '546', '551', '544');
INSERT INTO `school_recruit` VALUES ('84556', '175', '2013', '1', '2', '13', '562', '587', '553');
INSERT INTO `school_recruit` VALUES ('84557', '175', '2012', '1', '2', '13', '586', '598', '581');
INSERT INTO `school_recruit` VALUES ('84558', '175', '2011', '1', '2', '13', '565', '578', '560');
INSERT INTO `school_recruit` VALUES ('84559', '175', '2010', '1', '2', '13', '546', '559', '542');
INSERT INTO `school_recruit` VALUES ('86821', '180', '2013', '2', '1', '34', '506', '519', '0');
INSERT INTO `school_recruit` VALUES ('86822', '180', '2012', '2', '1', '34', '475', '493', '0');
INSERT INTO `school_recruit` VALUES ('86823', '180', '2011', '2', '1', '34', '497', '519', '0');
INSERT INTO `school_recruit` VALUES ('86824', '180', '2013', '2', '2', '34', '516', '528', '0');
INSERT INTO `school_recruit` VALUES ('86825', '180', '2012', '2', '2', '34', '456', '474', '0');
INSERT INTO `school_recruit` VALUES ('86826', '180', '2011', '2', '2', '34', '472', '482', '0');
INSERT INTO `school_recruit` VALUES ('86827', '180', '2010', '2', '2', '34', '461', '500', '0');
INSERT INTO `school_recruit` VALUES ('86854', '180', '2013', '2', '1', '3', '425', '448', '0');
INSERT INTO `school_recruit` VALUES ('86855', '180', '2012', '2', '1', '3', '433', '446', '0');
INSERT INTO `school_recruit` VALUES ('86856', '180', '2011', '2', '1', '3', '460', '490', '0');
INSERT INTO `school_recruit` VALUES ('86857', '180', '2010', '2', '1', '3', '456', '474', '0');
INSERT INTO `school_recruit` VALUES ('86862', '180', '2013', '2', '2', '3', '366', '401', '0');
INSERT INTO `school_recruit` VALUES ('86863', '180', '2012', '2', '2', '3', '420', '456', '0');
INSERT INTO `school_recruit` VALUES ('86864', '180', '2011', '2', '2', '3', '452', '474', '0');
INSERT INTO `school_recruit` VALUES ('86865', '180', '2010', '2', '2', '3', '453', '478', '0');
INSERT INTO `school_recruit` VALUES ('86948', '180', '2010', '2', '1', '10', '552', '571', '0');
INSERT INTO `school_recruit` VALUES ('86954', '180', '2010', '2', '2', '10', '511', '532', '0');
INSERT INTO `school_recruit` VALUES ('87001', '180', '2013', '1', '1', '13', '570', '572', '569');
INSERT INTO `school_recruit` VALUES ('87002', '180', '2012', '1', '1', '13', '606', '608', '606');
INSERT INTO `school_recruit` VALUES ('87004', '180', '2013', '2', '1', '13', '536', '555', '528');
INSERT INTO `school_recruit` VALUES ('87005', '180', '2012', '2', '1', '13', '584', '593', '581');
INSERT INTO `school_recruit` VALUES ('87006', '180', '2011', '2', '1', '13', '547', '558', '543');
INSERT INTO `school_recruit` VALUES ('87007', '180', '2010', '2', '1', '13', '536', '559', '0');
INSERT INTO `school_recruit` VALUES ('87012', '180', '2013', '1', '2', '13', '566', '567', '565');
INSERT INTO `school_recruit` VALUES ('87013', '180', '2012', '1', '2', '13', '588', '597', '582');
INSERT INTO `school_recruit` VALUES ('87015', '180', '2013', '2', '2', '13', '527', '542', '518');
INSERT INTO `school_recruit` VALUES ('87016', '180', '2012', '2', '2', '13', '565', '599', '559');
INSERT INTO `school_recruit` VALUES ('87017', '180', '2011', '2', '2', '13', '547', '563', '540');
INSERT INTO `school_recruit` VALUES ('87018', '180', '2010', '2', '2', '13', '529', '540', '0');
INSERT INTO `school_recruit` VALUES ('99582', '209', '2013', '1', '1', '34', '585', '622', '0');
INSERT INTO `school_recruit` VALUES ('99583', '209', '2012', '1', '1', '34', '544', '575', '0');
INSERT INTO `school_recruit` VALUES ('99584', '209', '2011', '1', '1', '34', '587', '605', '0');
INSERT INTO `school_recruit` VALUES ('99585', '209', '2010', '1', '1', '34', '592', '602', '0');
INSERT INTO `school_recruit` VALUES ('99591', '209', '2013', '1', '2', '34', '593', '637', '0');
INSERT INTO `school_recruit` VALUES ('99592', '209', '2012', '1', '2', '34', '550', '624', '0');
INSERT INTO `school_recruit` VALUES ('99593', '209', '2011', '1', '2', '34', '587', '632', '0');
INSERT INTO `school_recruit` VALUES ('99594', '209', '2010', '1', '2', '34', '614', '639', '0');
INSERT INTO `school_recruit` VALUES ('99633', '209', '2013', '1', '1', '3', '470', '492', '0');
INSERT INTO `school_recruit` VALUES ('99634', '209', '2012', '1', '1', '3', '487', '516', '0');
INSERT INTO `school_recruit` VALUES ('99635', '209', '2011', '1', '1', '3', '521', '542', '0');
INSERT INTO `school_recruit` VALUES ('99636', '209', '2010', '1', '1', '3', '511', '532', '0');
INSERT INTO `school_recruit` VALUES ('99641', '209', '2010', '5', '1', '3', '514', '524', '0');
INSERT INTO `school_recruit` VALUES ('99642', '209', '2013', '1', '2', '3', '435', '465', '0');
INSERT INTO `school_recruit` VALUES ('99643', '209', '2012', '1', '2', '3', '479', '502', '0');
INSERT INTO `school_recruit` VALUES ('99644', '209', '2011', '1', '2', '3', '512', '541', '0');
INSERT INTO `school_recruit` VALUES ('99645', '209', '2010', '1', '2', '3', '503', '531', '0');
INSERT INTO `school_recruit` VALUES ('99650', '209', '2010', '5', '2', '3', '506', '511', '0');
INSERT INTO `school_recruit` VALUES ('99745', '209', '2010', '1', '1', '10', '659', '671', '0');
INSERT INTO `school_recruit` VALUES ('99750', '209', '2010', '1', '2', '10', '636', '657', '0');
INSERT INTO `school_recruit` VALUES ('99786', '209', '2013', '1', '1', '13', '584', '588', '582');
INSERT INTO `school_recruit` VALUES ('99787', '209', '2012', '1', '1', '13', '617', '622', '612');
INSERT INTO `school_recruit` VALUES ('99788', '209', '2011', '1', '1', '13', '582', '592', '579');
INSERT INTO `school_recruit` VALUES ('99789', '209', '2010', '1', '1', '13', '567', '572', '565');
INSERT INTO `school_recruit` VALUES ('99794', '209', '2013', '1', '2', '13', '597', '609', '591');
INSERT INTO `school_recruit` VALUES ('99795', '209', '2012', '1', '2', '13', '625', '641', '617');
INSERT INTO `school_recruit` VALUES ('99796', '209', '2011', '1', '2', '13', '607', '617', '601');
INSERT INTO `school_recruit` VALUES ('99797', '209', '2010', '1', '2', '13', '587', '600', '583');
INSERT INTO `school_recruit` VALUES ('100076', '210', '2013', '1', '2', '34', '582', '614', '0');
INSERT INTO `school_recruit` VALUES ('100077', '210', '2012', '1', '2', '34', '563', '634', '0');
INSERT INTO `school_recruit` VALUES ('100078', '210', '2011', '1', '2', '34', '563', '648', '0');
INSERT INTO `school_recruit` VALUES ('100079', '210', '2010', '1', '2', '34', '568', '632', '0');
INSERT INTO `school_recruit` VALUES ('100116', '210', '2013', '1', '2', '3', '421', '438', '0');
INSERT INTO `school_recruit` VALUES ('100117', '210', '2012', '1', '2', '3', '437', '453', '0');
INSERT INTO `school_recruit` VALUES ('100118', '210', '2011', '1', '2', '3', '474', '485', '0');
INSERT INTO `school_recruit` VALUES ('100119', '210', '2010', '1', '2', '3', '481', '503', '0');
INSERT INTO `school_recruit` VALUES ('100226', '210', '2010', '1', '1', '10', '608', '613', '0');
INSERT INTO `school_recruit` VALUES ('100228', '210', '2010', '1', '2', '10', '591', '613', '0');
INSERT INTO `school_recruit` VALUES ('100258', '210', '2013', '1', '1', '13', '550', '554', '548');
INSERT INTO `school_recruit` VALUES ('100259', '210', '2012', '1', '1', '13', '591', '595', '591');
INSERT INTO `school_recruit` VALUES ('100260', '210', '2011', '1', '1', '13', '551', '556', '549');
INSERT INTO `school_recruit` VALUES ('100261', '210', '2010', '1', '1', '13', '540', '547', '537');
INSERT INTO `school_recruit` VALUES ('100264', '210', '2013', '1', '2', '13', '566', '578', '558');
INSERT INTO `school_recruit` VALUES ('100265', '210', '2012', '1', '2', '13', '592', '605', '587');
INSERT INTO `school_recruit` VALUES ('100266', '210', '2011', '1', '2', '13', '574', '594', '568');
INSERT INTO `school_recruit` VALUES ('100267', '210', '2010', '1', '2', '13', '556', '574', '551');
INSERT INTO `school_recruit` VALUES ('103384', '218', '2012', '2', '1', '34', '467', '478', '0');
INSERT INTO `school_recruit` VALUES ('103385', '218', '2011', '2', '1', '34', '486', '486', '0');
INSERT INTO `school_recruit` VALUES ('103386', '218', '2010', '2', '1', '34', '475', '475', '0');
INSERT INTO `school_recruit` VALUES ('103393', '218', '2010', '2', '2', '34', '462', '478', '0');
INSERT INTO `school_recruit` VALUES ('103436', '218', '2013', '2', '1', '3', '409', '415', '0');
INSERT INTO `school_recruit` VALUES ('103437', '218', '2012', '2', '1', '3', '392', '406', '0');
INSERT INTO `school_recruit` VALUES ('103438', '218', '2011', '2', '1', '3', '419', '429', '0');
INSERT INTO `school_recruit` VALUES ('103439', '218', '2010', '2', '1', '3', '412', '428', '0');
INSERT INTO `school_recruit` VALUES ('103445', '218', '2013', '2', '2', '3', '339', '347', '0');
INSERT INTO `school_recruit` VALUES ('103446', '218', '2012', '2', '2', '3', '367', '379', '0');
INSERT INTO `school_recruit` VALUES ('103447', '218', '2011', '2', '2', '3', '401', '420', '0');
INSERT INTO `school_recruit` VALUES ('103448', '218', '2010', '2', '2', '3', '406', '415', '0');
INSERT INTO `school_recruit` VALUES ('103566', '218', '2010', '2', '1', '10', '521', '539', '0');
INSERT INTO `school_recruit` VALUES ('103574', '218', '2010', '2', '2', '10', '477', '500', '0');
INSERT INTO `school_recruit` VALUES ('103619', '218', '2013', '2', '1', '13', '505', '530', '484');
INSERT INTO `school_recruit` VALUES ('103620', '218', '2012', '2', '1', '13', '542', '567', '523');
INSERT INTO `school_recruit` VALUES ('103621', '218', '2011', '2', '1', '13', '501', '522', '484');
INSERT INTO `school_recruit` VALUES ('103622', '218', '2010', '2', '1', '13', '491', '514', '0');
INSERT INTO `school_recruit` VALUES ('103629', '218', '2013', '1', '2', '13', '521', '531', '517');
INSERT INTO `school_recruit` VALUES ('103630', '218', '2013', '2', '2', '13', '483', '522', '456');
INSERT INTO `school_recruit` VALUES ('103631', '218', '2012', '2', '2', '13', '511', '562', '486');
INSERT INTO `school_recruit` VALUES ('103632', '218', '2011', '2', '2', '13', '498', '527', '474');
INSERT INTO `school_recruit` VALUES ('103633', '218', '2010', '2', '2', '13', '481', '540', '0');
INSERT INTO `school_recruit` VALUES ('103965', '219', '2013', '2', '1', '34', '495', '496', '0');
INSERT INTO `school_recruit` VALUES ('103966', '219', '2012', '2', '1', '34', '474', '489', '0');
INSERT INTO `school_recruit` VALUES ('103967', '219', '2011', '2', '1', '34', '493', '500', '0');
INSERT INTO `school_recruit` VALUES ('103968', '219', '2010', '2', '1', '34', '493', '513', '0');
INSERT INTO `school_recruit` VALUES ('103974', '219', '2013', '2', '2', '34', '516', '528', '0');
INSERT INTO `school_recruit` VALUES ('103975', '219', '2012', '2', '2', '34', '450', '463', '0');
INSERT INTO `school_recruit` VALUES ('103976', '219', '2011', '2', '2', '34', '454', '461', '0');
INSERT INTO `school_recruit` VALUES ('103977', '219', '2010', '2', '2', '34', '461', '473', '0');
INSERT INTO `school_recruit` VALUES ('104019', '219', '2013', '2', '1', '3', '417', '432', '0');
INSERT INTO `school_recruit` VALUES ('104020', '219', '2012', '2', '1', '3', '416', '422', '0');
INSERT INTO `school_recruit` VALUES ('104021', '219', '2011', '2', '1', '3', '435', '439', '0');
INSERT INTO `school_recruit` VALUES ('104022', '219', '2010', '2', '1', '3', '440', '462', '0');
INSERT INTO `school_recruit` VALUES ('104028', '219', '2013', '2', '2', '3', '349', '367', '0');
INSERT INTO `school_recruit` VALUES ('104029', '219', '2012', '2', '2', '3', '387', '410', '0');
INSERT INTO `school_recruit` VALUES ('104030', '219', '2011', '2', '2', '3', '423', '447', '0');
INSERT INTO `school_recruit` VALUES ('104031', '219', '2010', '2', '2', '3', '428', '447', '0');
INSERT INTO `school_recruit` VALUES ('104090', '219', '2010', '1', '1', '10', '615', '639', '0');
INSERT INTO `school_recruit` VALUES ('104095', '219', '2010', '2', '1', '10', '547', '565', '0');
INSERT INTO `school_recruit` VALUES ('104100', '219', '2010', '5', '1', '10', '546', '582', '0');
INSERT INTO `school_recruit` VALUES ('104103', '219', '2010', '1', '2', '10', '583', '621', '0');
INSERT INTO `school_recruit` VALUES ('104108', '219', '2010', '2', '2', '10', '505', '527', '0');
INSERT INTO `school_recruit` VALUES ('104113', '219', '2010', '5', '2', '10', '467', '593', '0');
INSERT INTO `school_recruit` VALUES ('104151', '219', '2013', '1', '1', '13', '562', '563', '556');
INSERT INTO `school_recruit` VALUES ('104152', '219', '2011', '1', '1', '13', '562', '567', '560');
INSERT INTO `school_recruit` VALUES ('104153', '219', '2010', '1', '1', '13', '546', '549', '543');
INSERT INTO `school_recruit` VALUES ('104158', '219', '2013', '1', '2', '13', '537', '558', '557');
INSERT INTO `school_recruit` VALUES ('104159', '219', '2011', '1', '2', '13', '563', '569', '559');
INSERT INTO `school_recruit` VALUES ('104160', '219', '2010', '1', '2', '13', '545', '559', '541');
INSERT INTO `school_recruit` VALUES ('104695', '221', '2010', '5', '1', '34', '550', '603', '0');
INSERT INTO `school_recruit` VALUES ('104702', '221', '2010', '5', '2', '34', '534', '611', '0');
INSERT INTO `school_recruit` VALUES ('104737', '221', '2010', '5', '1', '3', '476', '493', '0');
INSERT INTO `school_recruit` VALUES ('104744', '221', '2010', '5', '2', '3', '476', '490', '0');
INSERT INTO `school_recruit` VALUES ('104827', '221', '2010', '5', '1', '10', '615', '661', '0');
INSERT INTO `school_recruit` VALUES ('104834', '221', '2010', '5', '2', '10', '599', '647', '0');
INSERT INTO `school_recruit` VALUES ('104861', '221', '2010', '5', '1', '13', '540', '558', '0');
INSERT INTO `school_recruit` VALUES ('104868', '221', '2010', '5', '2', '13', '536', '567', '0');
INSERT INTO `school_recruit` VALUES ('109120', '231', '2013', '2', '1', '34', '499', '504', '0');
INSERT INTO `school_recruit` VALUES ('109121', '231', '2012', '2', '1', '34', '469', '491', '0');
INSERT INTO `school_recruit` VALUES ('109122', '231', '2011', '2', '1', '34', '494', '508', '0');
INSERT INTO `school_recruit` VALUES ('109123', '231', '2010', '2', '1', '34', '486', '500', '0');
INSERT INTO `school_recruit` VALUES ('109129', '231', '2013', '2', '2', '34', '507', '509', '0');
INSERT INTO `school_recruit` VALUES ('109130', '231', '2012', '2', '2', '34', '458', '472', '0');
INSERT INTO `school_recruit` VALUES ('109131', '231', '2011', '2', '2', '34', '460', '473', '0');
INSERT INTO `school_recruit` VALUES ('109132', '231', '2010', '2', '2', '34', '467', '492', '0');
INSERT INTO `school_recruit` VALUES ('109175', '231', '2013', '2', '1', '3', '419', '436', '0');
INSERT INTO `school_recruit` VALUES ('109176', '231', '2012', '2', '1', '3', '423', '437', '0');
INSERT INTO `school_recruit` VALUES ('109177', '231', '2011', '2', '1', '3', '446', '450', '0');
INSERT INTO `school_recruit` VALUES ('109178', '231', '2010', '2', '1', '3', '443', '454', '0');
INSERT INTO `school_recruit` VALUES ('109184', '231', '2013', '2', '2', '3', '354', '378', '0');
INSERT INTO `school_recruit` VALUES ('109185', '231', '2012', '2', '2', '3', '402', '425', '0');
INSERT INTO `school_recruit` VALUES ('109186', '231', '2011', '2', '2', '3', '433', '453', '0');
INSERT INTO `school_recruit` VALUES ('109187', '231', '2010', '2', '2', '3', '433', '445', '0');
INSERT INTO `school_recruit` VALUES ('109298', '231', '2010', '1', '1', '10', '613', '634', '0');
INSERT INTO `school_recruit` VALUES ('109303', '231', '2010', '2', '1', '10', '543', '561', '0');
INSERT INTO `school_recruit` VALUES ('109308', '231', '2010', '1', '2', '10', '572', '617', '0');
INSERT INTO `school_recruit` VALUES ('109314', '231', '2010', '2', '2', '10', '502', '516', '0');
INSERT INTO `school_recruit` VALUES ('109358', '231', '2013', '1', '1', '13', '561', '566', '558');
INSERT INTO `school_recruit` VALUES ('109359', '231', '2012', '1', '1', '13', '596', '606', '592');
INSERT INTO `school_recruit` VALUES ('109360', '231', '2011', '1', '1', '13', '560', '565', '556');
INSERT INTO `school_recruit` VALUES ('109361', '231', '2010', '1', '1', '13', '543', '550', '537');
INSERT INTO `school_recruit` VALUES ('109367', '231', '2013', '1', '2', '13', '557', '580', '551');
INSERT INTO `school_recruit` VALUES ('109368', '231', '2012', '1', '2', '13', '583', '593', '579');
INSERT INTO `school_recruit` VALUES ('109369', '231', '2011', '1', '2', '13', '565', '574', '561');
INSERT INTO `school_recruit` VALUES ('109370', '231', '2010', '1', '2', '13', '545', '565', '537');
INSERT INTO `school_recruit` VALUES ('109376', '231', '2010', '5', '2', '13', '533', '557', '0');
INSERT INTO `school_recruit` VALUES ('110407', '234', '2013', '2', '1', '34', '504', '514', '0');
INSERT INTO `school_recruit` VALUES ('110408', '234', '2012', '2', '1', '34', '457', '475', '0');
INSERT INTO `school_recruit` VALUES ('110409', '234', '2011', '2', '1', '34', '500', '519', '0');
INSERT INTO `school_recruit` VALUES ('110410', '234', '2010', '2', '1', '34', '498', '507', '0');
INSERT INTO `school_recruit` VALUES ('110415', '234', '2013', '2', '2', '34', '516', '527', '0');
INSERT INTO `school_recruit` VALUES ('110416', '234', '2012', '2', '2', '34', '450', '472', '0');
INSERT INTO `school_recruit` VALUES ('110417', '234', '2011', '2', '2', '34', '448', '467', '0');
INSERT INTO `school_recruit` VALUES ('110418', '234', '2010', '2', '2', '34', '463', '491', '0');
INSERT INTO `school_recruit` VALUES ('110434', '234', '2013', '2', '2', '3', '347', '363', '0');
INSERT INTO `school_recruit` VALUES ('110435', '234', '2012', '2', '2', '3', '384', '415', '0');
INSERT INTO `school_recruit` VALUES ('110436', '234', '2011', '2', '2', '3', '416', '429', '0');
INSERT INTO `school_recruit` VALUES ('110437', '234', '2010', '2', '2', '3', '417', '426', '0');
INSERT INTO `school_recruit` VALUES ('110498', '234', '2010', '1', '1', '10', '599', '620', '0');
INSERT INTO `school_recruit` VALUES ('110502', '234', '2010', '2', '1', '10', '534', '555', '0');
INSERT INTO `school_recruit` VALUES ('110508', '234', '2010', '1', '2', '10', '565', '609', '0');
INSERT INTO `school_recruit` VALUES ('110513', '234', '2010', '2', '2', '10', '508', '520', '0');
INSERT INTO `school_recruit` VALUES ('110535', '234', '2013', '1', '2', '13', '552', '571', '546');
INSERT INTO `school_recruit` VALUES ('110536', '234', '2012', '1', '2', '13', '579', '592', '574');
INSERT INTO `school_recruit` VALUES ('110537', '234', '2011', '1', '2', '13', '560', '588', '552');
INSERT INTO `school_recruit` VALUES ('110538', '234', '2010', '1', '2', '13', '547', '566', '542');
INSERT INTO `school_recruit` VALUES ('113372', '242', '2012', '2', '1', '34', '460', '485', '0');
INSERT INTO `school_recruit` VALUES ('113373', '242', '2011', '2', '1', '34', '500', '516', '0');
INSERT INTO `school_recruit` VALUES ('113374', '242', '2010', '2', '1', '34', '487', '506', '0');
INSERT INTO `school_recruit` VALUES ('113379', '242', '2012', '2', '2', '34', '442', '446', '0');
INSERT INTO `school_recruit` VALUES ('113380', '242', '2011', '2', '2', '34', '451', '466', '0');
INSERT INTO `school_recruit` VALUES ('113381', '242', '2010', '2', '2', '34', '449', '457', '0');
INSERT INTO `school_recruit` VALUES ('113400', '242', '2013', '2', '1', '3', '421', '439', '0');
INSERT INTO `school_recruit` VALUES ('113401', '242', '2012', '2', '1', '3', '423', '434', '0');
INSERT INTO `school_recruit` VALUES ('113402', '242', '2011', '2', '1', '3', '445', '463', '0');
INSERT INTO `school_recruit` VALUES ('113403', '242', '2010', '2', '1', '3', '438', '461', '0');
INSERT INTO `school_recruit` VALUES ('113408', '242', '2013', '2', '2', '3', '362', '393', '0');
INSERT INTO `school_recruit` VALUES ('113409', '242', '2012', '2', '2', '3', '411', '428', '0');
INSERT INTO `school_recruit` VALUES ('113410', '242', '2011', '2', '2', '3', '443', '471', '0');
INSERT INTO `school_recruit` VALUES ('113411', '242', '2010', '2', '2', '3', '442', '467', '0');
INSERT INTO `school_recruit` VALUES ('113510', '242', '2010', '2', '1', '10', '539', '547', '0');
INSERT INTO `school_recruit` VALUES ('113515', '242', '2010', '2', '2', '10', '501', '508', '0');
INSERT INTO `school_recruit` VALUES ('113551', '242', '2013', '2', '1', '13', '530', '532', '529');
INSERT INTO `school_recruit` VALUES ('113552', '242', '2012', '2', '1', '13', '570', '584', '564');
INSERT INTO `school_recruit` VALUES ('113553', '242', '2011', '2', '1', '13', '538', '547', '535');
INSERT INTO `school_recruit` VALUES ('113554', '242', '2010', '2', '1', '13', '527', '531', '0');
INSERT INTO `school_recruit` VALUES ('113559', '242', '2013', '2', '2', '13', '516', '521', '512');
INSERT INTO `school_recruit` VALUES ('113560', '242', '2012', '2', '2', '13', '549', '565', '544');
INSERT INTO `school_recruit` VALUES ('113561', '242', '2011', '2', '2', '13', '533', '537', '530');
INSERT INTO `school_recruit` VALUES ('113562', '242', '2010', '2', '2', '13', '520', '523', '0');
INSERT INTO `school_recruit` VALUES ('114388', '244', '2013', '2', '2', '34', '509', '513', '0');
INSERT INTO `school_recruit` VALUES ('114389', '244', '2012', '2', '2', '34', '443', '455', '0');
INSERT INTO `school_recruit` VALUES ('114390', '244', '2011', '2', '2', '34', '449', '473', '0');
INSERT INTO `school_recruit` VALUES ('114391', '244', '2010', '2', '2', '34', '461', '496', '0');
INSERT INTO `school_recruit` VALUES ('114416', '244', '2013', '2', '1', '3', '418', '433', '0');
INSERT INTO `school_recruit` VALUES ('114417', '244', '2012', '2', '1', '3', '419', '430', '0');
INSERT INTO `school_recruit` VALUES ('114418', '244', '2011', '2', '1', '3', '442', '466', '0');
INSERT INTO `school_recruit` VALUES ('114419', '244', '2010', '2', '1', '3', '438', '459', '0');
INSERT INTO `school_recruit` VALUES ('114424', '244', '2013', '2', '2', '3', '361', '392', '0');
INSERT INTO `school_recruit` VALUES ('114425', '244', '2012', '2', '2', '3', '409', '451', '0');
INSERT INTO `school_recruit` VALUES ('114426', '244', '2011', '2', '2', '3', '441', '493', '0');
INSERT INTO `school_recruit` VALUES ('114427', '244', '2010', '2', '2', '3', '442', '476', '0');
INSERT INTO `school_recruit` VALUES ('114432', '244', '2010', '5', '2', '3', '406', '478', '0');
INSERT INTO `school_recruit` VALUES ('114493', '244', '2010', '2', '2', '10', '496', '506', '0');
INSERT INTO `school_recruit` VALUES ('114518', '244', '2012', '2', '1', '13', '568', '569', '568');
INSERT INTO `school_recruit` VALUES ('114519', '244', '2011', '2', '1', '13', '526', '530', '526');
INSERT INTO `school_recruit` VALUES ('114520', '244', '2010', '2', '1', '13', '512', '519', '0');
INSERT INTO `school_recruit` VALUES ('114522', '244', '2013', '2', '2', '13', '518', '534', '512');
INSERT INTO `school_recruit` VALUES ('114523', '244', '2012', '2', '2', '13', '547', '566', '543');
INSERT INTO `school_recruit` VALUES ('114524', '244', '2011', '2', '2', '13', '532', '553', '527');
INSERT INTO `school_recruit` VALUES ('114525', '244', '2010', '2', '2', '13', '517', '535', '0');
INSERT INTO `school_recruit` VALUES ('115259', '247', '2013', '1', '1', '34', '571', '594', '0');
INSERT INTO `school_recruit` VALUES ('115260', '247', '2012', '1', '1', '34', '551', '607', '0');
INSERT INTO `school_recruit` VALUES ('115261', '247', '2011', '1', '1', '34', '564', '617', '0');
INSERT INTO `school_recruit` VALUES ('115262', '247', '2010', '1', '1', '34', '563', '608', '0');
INSERT INTO `school_recruit` VALUES ('115268', '247', '2013', '2', '1', '34', '517', '541', '0');
INSERT INTO `school_recruit` VALUES ('115269', '247', '2012', '2', '1', '34', '480', '559', '0');
INSERT INTO `school_recruit` VALUES ('115270', '247', '2011', '2', '1', '34', '513', '579', '0');
INSERT INTO `school_recruit` VALUES ('115271', '247', '2010', '2', '1', '34', '506', '527', '0');
INSERT INTO `school_recruit` VALUES ('115276', '247', '2013', '1', '2', '34', '590', '630', '0');
INSERT INTO `school_recruit` VALUES ('115277', '247', '2012', '1', '2', '34', '572', '664', '0');
INSERT INTO `school_recruit` VALUES ('115278', '247', '2011', '1', '2', '34', '569', '645', '0');
INSERT INTO `school_recruit` VALUES ('115279', '247', '2010', '1', '2', '34', '579', '617', '0');
INSERT INTO `school_recruit` VALUES ('115285', '247', '2013', '2', '2', '34', '520', '535', '0');
INSERT INTO `school_recruit` VALUES ('115286', '247', '2012', '2', '2', '34', '472', '543', '0');
INSERT INTO `school_recruit` VALUES ('115287', '247', '2011', '2', '2', '34', '469', '532', '0');
INSERT INTO `school_recruit` VALUES ('115288', '247', '2010', '2', '2', '34', '497', '548', '0');
INSERT INTO `school_recruit` VALUES ('115322', '247', '2013', '1', '2', '3', '416', '428', '0');
INSERT INTO `school_recruit` VALUES ('115323', '247', '2012', '1', '2', '3', '446', '462', '0');
INSERT INTO `school_recruit` VALUES ('115324', '247', '2011', '1', '2', '3', '474', '489', '0');
INSERT INTO `school_recruit` VALUES ('115421', '247', '2010', '1', '2', '10', '601', '649', '0');
INSERT INTO `school_recruit` VALUES ('115450', '247', '2013', '1', '1', '13', '563', '571', '553');
INSERT INTO `school_recruit` VALUES ('115454', '247', '2013', '1', '2', '13', '571', '609', '556');
INSERT INTO `school_recruit` VALUES ('115455', '247', '2012', '1', '2', '13', '587', '611', '580');
INSERT INTO `school_recruit` VALUES ('115456', '247', '2011', '1', '2', '13', '571', '629', '554');
INSERT INTO `school_recruit` VALUES ('115457', '247', '2010', '1', '2', '13', '564', '614', '557');
INSERT INTO `school_recruit` VALUES ('116181', '249', '2013', '2', '1', '34', '512', '531', '0');
INSERT INTO `school_recruit` VALUES ('116182', '249', '2012', '2', '1', '34', '484', '497', '0');
INSERT INTO `school_recruit` VALUES ('116183', '249', '2011', '2', '1', '34', '503', '528', '0');
INSERT INTO `school_recruit` VALUES ('116184', '249', '2010', '2', '1', '34', '493', '510', '0');
INSERT INTO `school_recruit` VALUES ('116189', '249', '2013', '2', '2', '34', '514', '524', '0');
INSERT INTO `school_recruit` VALUES ('116190', '249', '2012', '2', '2', '34', '461', '473', '0');
INSERT INTO `school_recruit` VALUES ('116191', '249', '2011', '2', '2', '34', '453', '467', '0');
INSERT INTO `school_recruit` VALUES ('116192', '249', '2010', '2', '2', '34', '460', '492', '0');
INSERT INTO `school_recruit` VALUES ('116228', '249', '2013', '2', '1', '3', '419', '436', '0');
INSERT INTO `school_recruit` VALUES ('116229', '249', '2012', '2', '1', '3', '414', '427', '0');
INSERT INTO `school_recruit` VALUES ('116230', '249', '2011', '2', '1', '3', '437', '467', '0');
INSERT INTO `school_recruit` VALUES ('116231', '249', '2010', '2', '1', '3', '433', '446', '0');
INSERT INTO `school_recruit` VALUES ('116236', '249', '2013', '2', '2', '3', '355', '379', '0');
INSERT INTO `school_recruit` VALUES ('116237', '249', '2012', '2', '2', '3', '393', '420', '0');
INSERT INTO `school_recruit` VALUES ('116238', '249', '2011', '2', '2', '3', '438', '452', '0');
INSERT INTO `school_recruit` VALUES ('116239', '249', '2010', '2', '2', '3', '430', '449', '0');
INSERT INTO `school_recruit` VALUES ('116344', '249', '2010', '2', '1', '10', '536', '553', '0');
INSERT INTO `school_recruit` VALUES ('116349', '249', '2010', '2', '2', '10', '487', '524', '0');
INSERT INTO `school_recruit` VALUES ('116386', '249', '2013', '2', '1', '13', '532', '539', '529');
INSERT INTO `school_recruit` VALUES ('116387', '249', '2012', '2', '1', '13', '568', '574', '564');
INSERT INTO `school_recruit` VALUES ('116388', '249', '2011', '2', '1', '13', '529', '536', '526');
INSERT INTO `school_recruit` VALUES ('116389', '249', '2010', '2', '1', '13', '519', '525', '0');
INSERT INTO `school_recruit` VALUES ('116394', '249', '2013', '2', '2', '13', '508', '514', '504');
INSERT INTO `school_recruit` VALUES ('116395', '249', '2012', '2', '2', '13', '538', '560', '532');
INSERT INTO `school_recruit` VALUES ('116396', '249', '2011', '2', '2', '13', '524', '537', '518');
INSERT INTO `school_recruit` VALUES ('116397', '249', '2010', '2', '2', '13', '504', '522', '0');
INSERT INTO `school_recruit` VALUES ('118444', '254', '2010', '2', '1', '34', '476', '476', '0');
INSERT INTO `school_recruit` VALUES ('118483', '254', '2013', '2', '1', '3', '413', '424', '0');
INSERT INTO `school_recruit` VALUES ('118484', '254', '2012', '2', '1', '3', '414', '416', '0');
INSERT INTO `school_recruit` VALUES ('118485', '254', '2011', '2', '1', '3', '426', '426', '0');
INSERT INTO `school_recruit` VALUES ('118486', '254', '2010', '2', '1', '3', '412', '413', '0');
INSERT INTO `school_recruit` VALUES ('118491', '254', '2013', '2', '2', '3', '346', '362', '0');
INSERT INTO `school_recruit` VALUES ('118492', '254', '2012', '2', '2', '3', '385', '390', '0');
INSERT INTO `school_recruit` VALUES ('118493', '254', '2011', '2', '2', '3', '407', '407', '0');
INSERT INTO `school_recruit` VALUES ('118494', '254', '2010', '2', '2', '3', '410', '410', '0');
INSERT INTO `school_recruit` VALUES ('118592', '254', '2010', '2', '1', '10', '530', '552', '0');
INSERT INTO `school_recruit` VALUES ('118597', '254', '2010', '2', '2', '10', '477', '495', '0');
INSERT INTO `school_recruit` VALUES ('118635', '254', '2013', '1', '1', '13', '536', '561', '532');
INSERT INTO `school_recruit` VALUES ('118636', '254', '2012', '1', '1', '13', '574', '604', '570');
INSERT INTO `school_recruit` VALUES ('118637', '254', '2011', '1', '1', '13', '537', '565', '532');
INSERT INTO `school_recruit` VALUES ('118638', '254', '2010', '1', '1', '13', '526', '560', '521');
INSERT INTO `school_recruit` VALUES ('118639', '254', '2013', '2', '1', '13', '508', '532', '487');
INSERT INTO `school_recruit` VALUES ('118640', '254', '2012', '2', '1', '13', '547', '570', '523');
INSERT INTO `school_recruit` VALUES ('118641', '254', '2011', '2', '1', '13', '508', '533', '484');
INSERT INTO `school_recruit` VALUES ('118642', '254', '2010', '2', '1', '13', '495', '519', '0');
INSERT INTO `school_recruit` VALUES ('118651', '254', '2013', '1', '2', '13', '522', '553', '517');
INSERT INTO `school_recruit` VALUES ('118652', '254', '2012', '1', '2', '13', '552', '592', '547');
INSERT INTO `school_recruit` VALUES ('118653', '254', '2011', '1', '2', '13', '536', '582', '531');
INSERT INTO `school_recruit` VALUES ('118654', '254', '2010', '1', '2', '13', '521', '572', '515');
INSERT INTO `school_recruit` VALUES ('118655', '254', '2013', '2', '2', '13', '484', '525', '456');
INSERT INTO `school_recruit` VALUES ('118656', '254', '2012', '2', '2', '13', '516', '548', '486');
INSERT INTO `school_recruit` VALUES ('118657', '254', '2011', '2', '2', '13', '500', '540', '474');
INSERT INTO `school_recruit` VALUES ('118658', '254', '2010', '2', '2', '13', '477', '513', '0');
INSERT INTO `school_recruit` VALUES ('118908', '255', '2013', '1', '1', '34', '561', '573', '0');
INSERT INTO `school_recruit` VALUES ('118909', '255', '2012', '1', '1', '34', '520', '574', '0');
INSERT INTO `school_recruit` VALUES ('118910', '255', '2011', '1', '1', '34', '550', '617', '0');
INSERT INTO `school_recruit` VALUES ('118911', '255', '2010', '1', '1', '34', '544', '602', '0');
INSERT INTO `school_recruit` VALUES ('118916', '255', '2013', '2', '1', '34', '520', '547', '0');
INSERT INTO `school_recruit` VALUES ('118917', '255', '2012', '2', '1', '34', '490', '546', '0');
INSERT INTO `school_recruit` VALUES ('118918', '255', '2011', '2', '1', '34', '518', '554', '0');
INSERT INTO `school_recruit` VALUES ('118919', '255', '2010', '2', '1', '34', '504', '533', '0');
INSERT INTO `school_recruit` VALUES ('118924', '255', '2013', '1', '2', '34', '565', '581', '0');
INSERT INTO `school_recruit` VALUES ('118925', '255', '2012', '1', '2', '34', '521', '603', '0');
INSERT INTO `school_recruit` VALUES ('118926', '255', '2011', '1', '2', '34', '521', '604', '0');
INSERT INTO `school_recruit` VALUES ('118927', '255', '2010', '1', '2', '34', '534', '628', '0');
INSERT INTO `school_recruit` VALUES ('118932', '255', '2013', '2', '2', '34', '526', '547', '0');
INSERT INTO `school_recruit` VALUES ('118933', '255', '2012', '2', '2', '34', '479', '548', '0');
INSERT INTO `school_recruit` VALUES ('118934', '255', '2011', '2', '2', '34', '484', '617', '0');
INSERT INTO `school_recruit` VALUES ('118935', '255', '2010', '2', '2', '34', '482', '606', '0');
INSERT INTO `school_recruit` VALUES ('119116', '255', '2013', '1', '1', '13', '564', '565', '564');
INSERT INTO `school_recruit` VALUES ('119117', '255', '2012', '1', '1', '13', '598', '605', '597');
INSERT INTO `school_recruit` VALUES ('119118', '255', '2011', '1', '1', '13', '560', '563', '558');
INSERT INTO `school_recruit` VALUES ('119119', '255', '2010', '1', '1', '13', '552', '555', '550');
INSERT INTO `school_recruit` VALUES ('119124', '255', '2013', '1', '2', '13', '543', '564', '519');
INSERT INTO `school_recruit` VALUES ('119125', '255', '2012', '1', '2', '13', '580', '590', '577');
INSERT INTO `school_recruit` VALUES ('119126', '255', '2011', '1', '2', '13', '561', '573', '555');
INSERT INTO `school_recruit` VALUES ('119127', '255', '2010', '1', '2', '13', '541', '552', '536');
INSERT INTO `school_recruit` VALUES ('119946', '257', '2010', '2', '1', '34', '484', '497', '0');
INSERT INTO `school_recruit` VALUES ('119951', '257', '2013', '2', '2', '34', '518', '532', '0');
INSERT INTO `school_recruit` VALUES ('119952', '257', '2012', '2', '2', '34', '481', '566', '0');
INSERT INTO `school_recruit` VALUES ('119953', '257', '2011', '2', '2', '34', '465', '479', '0');
INSERT INTO `school_recruit` VALUES ('119954', '257', '2010', '2', '2', '34', '469', '479', '0');
INSERT INTO `school_recruit` VALUES ('119983', '257', '2013', '1', '1', '3', '450', '453', '0');
INSERT INTO `school_recruit` VALUES ('119984', '257', '2013', '2', '1', '3', '442', '452', '0');
INSERT INTO `school_recruit` VALUES ('119985', '257', '2012', '2', '1', '3', '425', '443', '0');
INSERT INTO `school_recruit` VALUES ('119986', '257', '2011', '2', '1', '3', '449', '481', '0');
INSERT INTO `school_recruit` VALUES ('119987', '257', '2010', '2', '1', '3', '443', '463', '0');
INSERT INTO `school_recruit` VALUES ('119992', '257', '2010', '5', '1', '3', '448', '463', '0');
INSERT INTO `school_recruit` VALUES ('119995', '257', '2013', '1', '2', '3', '407', '410', '0');
INSERT INTO `school_recruit` VALUES ('119996', '257', '2012', '1', '2', '3', '432', '469', '0');
INSERT INTO `school_recruit` VALUES ('119997', '257', '2011', '1', '2', '3', '469', '487', '0');
INSERT INTO `school_recruit` VALUES ('119998', '257', '2010', '1', '2', '3', '469', '481', '0');
INSERT INTO `school_recruit` VALUES ('120003', '257', '2013', '2', '2', '3', '381', '404', '0');
INSERT INTO `school_recruit` VALUES ('120004', '257', '2012', '2', '2', '3', '398', '438', '0');
INSERT INTO `school_recruit` VALUES ('120005', '257', '2011', '2', '2', '3', '431', '468', '0');
INSERT INTO `school_recruit` VALUES ('120006', '257', '2010', '2', '2', '3', '434', '454', '0');
INSERT INTO `school_recruit` VALUES ('120011', '257', '2010', '5', '2', '3', '423', '453', '0');
INSERT INTO `school_recruit` VALUES ('120107', '257', '2013', '2', '1', '10', '570', '573', '0');
INSERT INTO `school_recruit` VALUES ('120108', '257', '2010', '2', '1', '10', '539', '547', '0');
INSERT INTO `school_recruit` VALUES ('120113', '257', '2013', '2', '2', '10', '554', '583', '0');
INSERT INTO `school_recruit` VALUES ('120114', '257', '2010', '2', '2', '10', '495', '520', '0');
INSERT INTO `school_recruit` VALUES ('120119', '257', '2010', '5', '2', '10', '499', '533', '0');
INSERT INTO `school_recruit` VALUES ('120164', '257', '2013', '1', '1', '13', '537', '543', '532');
INSERT INTO `school_recruit` VALUES ('120165', '257', '2013', '2', '1', '13', '530', '533', '528');
INSERT INTO `school_recruit` VALUES ('120166', '257', '2012', '2', '1', '13', '570', '579', '567');
INSERT INTO `school_recruit` VALUES ('120167', '257', '2011', '2', '1', '13', '526', '527', '525');
INSERT INTO `school_recruit` VALUES ('120168', '257', '2010', '2', '1', '13', '518', '539', '0');
INSERT INTO `school_recruit` VALUES ('120173', '257', '2013', '1', '2', '13', '529', '580', '517');
INSERT INTO `school_recruit` VALUES ('120174', '257', '2013', '2', '2', '13', '514', '518', '512');
INSERT INTO `school_recruit` VALUES ('120175', '257', '2012', '2', '2', '13', '543', '561', '538');
INSERT INTO `school_recruit` VALUES ('120176', '257', '2011', '2', '2', '13', '525', '545', '521');
INSERT INTO `school_recruit` VALUES ('120177', '257', '2010', '2', '2', '13', '511', '528', '0');
INSERT INTO `school_recruit` VALUES ('120698', '259', '2013', '2', '1', '34', '534', '575', '0');
INSERT INTO `school_recruit` VALUES ('120699', '259', '2012', '2', '1', '34', '504', '542', '0');
INSERT INTO `school_recruit` VALUES ('120700', '259', '2011', '2', '1', '34', '553', '588', '0');
INSERT INTO `school_recruit` VALUES ('120701', '259', '2010', '2', '1', '34', '537', '583', '0');
INSERT INTO `school_recruit` VALUES ('120707', '259', '2013', '2', '2', '34', '535', '565', '0');
INSERT INTO `school_recruit` VALUES ('120708', '259', '2012', '2', '2', '34', '501', '622', '0');
INSERT INTO `school_recruit` VALUES ('120709', '259', '2011', '2', '2', '34', '502', '575', '0');
INSERT INTO `school_recruit` VALUES ('120710', '259', '2010', '2', '2', '34', '503', '571', '0');
INSERT INTO `school_recruit` VALUES ('120771', '259', '2013', '1', '1', '3', '460', '473', '0');
INSERT INTO `school_recruit` VALUES ('120772', '259', '2012', '1', '1', '3', '471', '490', '0');
INSERT INTO `school_recruit` VALUES ('120773', '259', '2011', '1', '1', '3', '495', '515', '0');
INSERT INTO `school_recruit` VALUES ('120774', '259', '2010', '1', '1', '3', '490', '508', '0');
INSERT INTO `school_recruit` VALUES ('120780', '259', '2010', '5', '1', '3', '476', '498', '0');
INSERT INTO `school_recruit` VALUES ('120785', '259', '2013', '1', '2', '3', '424', '443', '0');
INSERT INTO `school_recruit` VALUES ('120786', '259', '2012', '1', '2', '3', '458', '485', '0');
INSERT INTO `school_recruit` VALUES ('120787', '259', '2011', '1', '2', '3', '491', '522', '0');
INSERT INTO `school_recruit` VALUES ('120788', '259', '2010', '1', '2', '3', '489', '509', '0');
INSERT INTO `school_recruit` VALUES ('120794', '259', '2010', '5', '2', '3', '478', '504', '0');
INSERT INTO `school_recruit` VALUES ('120912', '259', '2010', '1', '1', '10', '641', '655', '0');
INSERT INTO `school_recruit` VALUES ('120918', '259', '2010', '5', '1', '10', '616', '635', '0');
INSERT INTO `school_recruit` VALUES ('120923', '259', '2010', '1', '2', '10', '620', '639', '0');
INSERT INTO `school_recruit` VALUES ('120929', '259', '2010', '5', '2', '10', '585', '630', '0');
INSERT INTO `school_recruit` VALUES ('120981', '259', '2013', '1', '1', '13', '574', '583', '570');
INSERT INTO `school_recruit` VALUES ('120982', '259', '2012', '1', '1', '13', '608', '614', '604');
INSERT INTO `school_recruit` VALUES ('120983', '259', '2011', '1', '1', '13', '572', '577', '569');
INSERT INTO `school_recruit` VALUES ('120984', '259', '2010', '1', '1', '13', '559', '564', '555');
INSERT INTO `school_recruit` VALUES ('120990', '259', '2010', '5', '1', '13', '541', '571', '0');
INSERT INTO `school_recruit` VALUES ('120995', '259', '2013', '1', '2', '13', '573', '592', '562');
INSERT INTO `school_recruit` VALUES ('120996', '259', '2012', '1', '2', '13', '601', '618', '592');
INSERT INTO `school_recruit` VALUES ('120997', '259', '2011', '1', '2', '13', '584', '610', '573');
INSERT INTO `school_recruit` VALUES ('120998', '259', '2010', '1', '2', '13', '566', '592', '556');
INSERT INTO `school_recruit` VALUES ('121004', '259', '2010', '5', '2', '13', '549', '583', '0');
INSERT INTO `school_recruit` VALUES ('122148', '262', '2013', '1', '1', '34', '568', '588', '0');
INSERT INTO `school_recruit` VALUES ('122149', '262', '2012', '1', '1', '34', '527', '590', '0');
INSERT INTO `school_recruit` VALUES ('122150', '262', '2011', '1', '1', '34', '556', '621', '0');
INSERT INTO `school_recruit` VALUES ('122151', '262', '2010', '1', '1', '34', '552', '617', '0');
INSERT INTO `school_recruit` VALUES ('122157', '262', '2013', '2', '1', '34', '518', '542', '0');
INSERT INTO `school_recruit` VALUES ('122158', '262', '2011', '2', '1', '34', '517', '572', '0');
INSERT INTO `school_recruit` VALUES ('122159', '262', '2010', '2', '1', '34', '508', '537', '0');
INSERT INTO `school_recruit` VALUES ('122164', '262', '2013', '1', '2', '34', '572', '595', '0');
INSERT INTO `school_recruit` VALUES ('122165', '262', '2012', '1', '2', '34', '529', '614', '0');
INSERT INTO `school_recruit` VALUES ('122166', '262', '2011', '1', '2', '34', '532', '624', '0');
INSERT INTO `school_recruit` VALUES ('122167', '262', '2010', '1', '2', '34', '543', '640', '0');
INSERT INTO `school_recruit` VALUES ('122173', '262', '2013', '2', '2', '34', '526', '547', '0');
INSERT INTO `school_recruit` VALUES ('122174', '262', '2011', '2', '2', '34', '475', '563', '0');
INSERT INTO `school_recruit` VALUES ('122175', '262', '2010', '2', '2', '34', '485', '558', '0');
INSERT INTO `school_recruit` VALUES ('122330', '262', '2010', '1', '1', '10', '625', '635', '0');
INSERT INTO `school_recruit` VALUES ('122335', '262', '2010', '1', '2', '10', '596', '617', '0');
INSERT INTO `school_recruit` VALUES ('122365', '262', '2013', '1', '1', '13', '551', '556', '547');
INSERT INTO `school_recruit` VALUES ('122366', '262', '2012', '1', '1', '13', '591', '599', '587');
INSERT INTO `school_recruit` VALUES ('122367', '262', '2011', '1', '1', '13', '555', '563', '551');
INSERT INTO `school_recruit` VALUES ('122368', '262', '2010', '1', '1', '13', '533', '542', '527');
INSERT INTO `school_recruit` VALUES ('122371', '262', '2013', '1', '2', '13', '539', '566', '517');
INSERT INTO `school_recruit` VALUES ('122372', '262', '2012', '1', '2', '13', '578', '592', '572');
INSERT INTO `school_recruit` VALUES ('122373', '262', '2011', '1', '2', '13', '556', '564', '550');
INSERT INTO `school_recruit` VALUES ('122374', '262', '2010', '1', '2', '13', '535', '541', '532');
INSERT INTO `school_recruit` VALUES ('128926', '278', '2012', '2', '1', '34', '464', '548', '0');
INSERT INTO `school_recruit` VALUES ('128927', '278', '2011', '2', '1', '34', '492', '519', '0');
INSERT INTO `school_recruit` VALUES ('128928', '278', '2010', '2', '1', '34', '488', '512', '0');
INSERT INTO `school_recruit` VALUES ('128933', '278', '2013', '3', '1', '34', '461', '469', '0');
INSERT INTO `school_recruit` VALUES ('128934', '278', '2012', '3', '1', '34', '426', '481', '0');
INSERT INTO `school_recruit` VALUES ('128935', '278', '2011', '3', '1', '34', '458', '513', '0');
INSERT INTO `school_recruit` VALUES ('128936', '278', '2010', '3', '1', '34', '457', '484', '0');
INSERT INTO `school_recruit` VALUES ('128942', '278', '2012', '2', '2', '34', '445', '481', '0');
INSERT INTO `school_recruit` VALUES ('128943', '278', '2011', '2', '2', '34', '446', '472', '0');
INSERT INTO `school_recruit` VALUES ('128944', '278', '2010', '2', '2', '34', '463', '560', '0');
INSERT INTO `school_recruit` VALUES ('128949', '278', '2013', '3', '2', '34', '480', '485', '0');
INSERT INTO `school_recruit` VALUES ('128950', '278', '2012', '3', '2', '34', '414', '454', '0');
INSERT INTO `school_recruit` VALUES ('128951', '278', '2011', '3', '2', '34', '413', '529', '0');
INSERT INTO `school_recruit` VALUES ('128952', '278', '2010', '3', '2', '34', '423', '502', '0');
INSERT INTO `school_recruit` VALUES ('129120', '278', '2010', '2', '1', '10', '499', '523', '0');
INSERT INTO `school_recruit` VALUES ('129128', '278', '2010', '2', '2', '10', '439', '477', '0');
INSERT INTO `school_recruit` VALUES ('129165', '278', '2013', '2', '1', '13', '496', '510', '484');
INSERT INTO `school_recruit` VALUES ('129166', '278', '2012', '2', '1', '13', '537', '556', '523');
INSERT INTO `school_recruit` VALUES ('129167', '278', '2011', '2', '1', '13', '499', '513', '494');
INSERT INTO `school_recruit` VALUES ('129168', '278', '2010', '2', '1', '13', '491', '502', '0');
INSERT INTO `school_recruit` VALUES ('129175', '278', '2013', '2', '2', '13', '478', '521', '456');
INSERT INTO `school_recruit` VALUES ('129176', '278', '2012', '2', '2', '13', '492', '508', '486');
INSERT INTO `school_recruit` VALUES ('129177', '278', '2011', '2', '2', '13', '495', '538', '474');
INSERT INTO `school_recruit` VALUES ('129178', '278', '2010', '2', '2', '13', '481', '505', '0');
INSERT INTO `school_recruit` VALUES ('129431', '279', '2013', '2', '1', '34', '507', '520', '0');
INSERT INTO `school_recruit` VALUES ('129432', '279', '2012', '2', '1', '34', '479', '487', '0');
INSERT INTO `school_recruit` VALUES ('129433', '279', '2011', '2', '1', '34', '515', '524', '0');
INSERT INTO `school_recruit` VALUES ('129434', '279', '2010', '2', '1', '34', '508', '526', '0');
INSERT INTO `school_recruit` VALUES ('129437', '279', '2010', '5', '1', '34', '566', '583', '0');
INSERT INTO `school_recruit` VALUES ('129440', '279', '2013', '2', '2', '34', '546', '587', '0');
INSERT INTO `school_recruit` VALUES ('129441', '279', '2012', '2', '2', '34', '450', '467', '0');
INSERT INTO `school_recruit` VALUES ('129442', '279', '2011', '2', '2', '34', '505', '574', '0');
INSERT INTO `school_recruit` VALUES ('129443', '279', '2010', '2', '2', '34', '522', '592', '0');
INSERT INTO `school_recruit` VALUES ('129446', '279', '2010', '5', '2', '34', '585', '647', '0');
INSERT INTO `school_recruit` VALUES ('129485', '279', '2013', '2', '1', '3', '429', '456', '0');
INSERT INTO `school_recruit` VALUES ('129486', '279', '2012', '2', '1', '3', '442', '449', '0');
INSERT INTO `school_recruit` VALUES ('129487', '279', '2011', '2', '1', '3', '471', '485', '0');
INSERT INTO `school_recruit` VALUES ('129488', '279', '2010', '2', '1', '3', '473', '490', '0');
INSERT INTO `school_recruit` VALUES ('129490', '279', '2010', '5', '1', '3', '505', '509', '0');
INSERT INTO `school_recruit` VALUES ('129494', '279', '2013', '2', '2', '3', '374', '417', '0');
INSERT INTO `school_recruit` VALUES ('129495', '279', '2012', '2', '2', '3', '437', '452', '0');
INSERT INTO `school_recruit` VALUES ('129496', '279', '2011', '2', '2', '3', '473', '485', '0');
INSERT INTO `school_recruit` VALUES ('129497', '279', '2010', '2', '2', '3', '476', '492', '0');
INSERT INTO `school_recruit` VALUES ('129499', '279', '2010', '5', '2', '3', '524', '544', '0');
INSERT INTO `school_recruit` VALUES ('129586', '279', '2010', '2', '1', '10', '562', '584', '0');
INSERT INTO `school_recruit` VALUES ('129590', '279', '2010', '5', '1', '10', '607', '631', '0');
INSERT INTO `school_recruit` VALUES ('129594', '279', '2010', '2', '2', '10', '525', '543', '0');
INSERT INTO `school_recruit` VALUES ('129598', '279', '2010', '5', '2', '10', '590', '621', '0');
INSERT INTO `school_recruit` VALUES ('129631', '279', '2013', '2', '1', '13', '534', '541', '528');
INSERT INTO `school_recruit` VALUES ('129632', '279', '2012', '2', '1', '13', '586', '595', '581');
INSERT INTO `school_recruit` VALUES ('129633', '279', '2011', '2', '1', '13', '554', '555', '554');
INSERT INTO `school_recruit` VALUES ('129634', '279', '2010', '2', '1', '13', '540', '554', '0');
INSERT INTO `school_recruit` VALUES ('129637', '279', '2010', '5', '1', '13', '562', '583', '0');
INSERT INTO `school_recruit` VALUES ('129640', '279', '2013', '2', '2', '13', '557', '570', '537');
INSERT INTO `school_recruit` VALUES ('129641', '279', '2012', '2', '2', '13', '590', '605', '583');
INSERT INTO `school_recruit` VALUES ('129642', '279', '2011', '2', '2', '13', '570', '581', '565');
INSERT INTO `school_recruit` VALUES ('129643', '279', '2010', '2', '2', '13', '546', '557', '0');
INSERT INTO `school_recruit` VALUES ('129646', '279', '2010', '5', '2', '13', '568', '577', '0');
INSERT INTO `school_recruit` VALUES ('130580', '282', '2013', '2', '1', '34', '501', '508', '0');
INSERT INTO `school_recruit` VALUES ('130581', '282', '2012', '2', '1', '34', '472', '501', '0');
INSERT INTO `school_recruit` VALUES ('130582', '282', '2011', '2', '1', '34', '498', '501', '0');
INSERT INTO `school_recruit` VALUES ('130583', '282', '2010', '2', '1', '34', '489', '507', '0');
INSERT INTO `school_recruit` VALUES ('130586', '282', '2013', '2', '2', '34', '520', '536', '0');
INSERT INTO `school_recruit` VALUES ('130587', '282', '2012', '2', '2', '34', '455', '490', '0');
INSERT INTO `school_recruit` VALUES ('130588', '282', '2011', '2', '2', '34', '465', '493', '0');
INSERT INTO `school_recruit` VALUES ('130589', '282', '2010', '2', '2', '34', '470', '501', '0');
INSERT INTO `school_recruit` VALUES ('130616', '282', '2013', '2', '1', '3', '419', '435', '0');
INSERT INTO `school_recruit` VALUES ('130617', '282', '2012', '2', '1', '3', '419', '436', '0');
INSERT INTO `school_recruit` VALUES ('130618', '282', '2011', '2', '1', '3', '441', '464', '0');
INSERT INTO `school_recruit` VALUES ('130619', '282', '2010', '2', '1', '3', '436', '463', '0');
INSERT INTO `school_recruit` VALUES ('130625', '282', '2013', '2', '2', '3', '356', '381', '0');
INSERT INTO `school_recruit` VALUES ('130626', '282', '2012', '2', '2', '3', '400', '466', '0');
INSERT INTO `school_recruit` VALUES ('130627', '282', '2011', '2', '2', '3', '433', '480', '0');
INSERT INTO `school_recruit` VALUES ('130628', '282', '2010', '2', '2', '3', '435', '469', '0');
INSERT INTO `school_recruit` VALUES ('130696', '282', '2010', '2', '1', '10', '540', '551', '0');
INSERT INTO `school_recruit` VALUES ('130701', '282', '2010', '2', '2', '10', '515', '552', '0');
INSERT INTO `school_recruit` VALUES ('130736', '282', '2013', '2', '1', '13', '503', '520', '487');
INSERT INTO `school_recruit` VALUES ('130737', '282', '2012', '2', '1', '13', '571', '578', '568');
INSERT INTO `school_recruit` VALUES ('130738', '282', '2011', '2', '1', '13', '530', '534', '527');
INSERT INTO `school_recruit` VALUES ('130739', '282', '2010', '2', '1', '13', '523', '528', '0');
INSERT INTO `school_recruit` VALUES ('130745', '282', '2013', '2', '2', '13', '530', '573', '517');
INSERT INTO `school_recruit` VALUES ('130746', '282', '2012', '2', '2', '13', '563', '586', '553');
INSERT INTO `school_recruit` VALUES ('130747', '282', '2011', '2', '2', '13', '542', '568', '533');
INSERT INTO `school_recruit` VALUES ('130748', '282', '2010', '2', '2', '13', '527', '553', '0');
INSERT INTO `school_recruit` VALUES ('133123', '289', '2011', '2', '2', '34', '449', '458', '0');
INSERT INTO `school_recruit` VALUES ('133124', '289', '2010', '2', '2', '34', '471', '488', '0');
INSERT INTO `school_recruit` VALUES ('133149', '289', '2013', '2', '1', '3', '417', '431', '0');
INSERT INTO `school_recruit` VALUES ('133150', '289', '2012', '2', '1', '3', '414', '425', '0');
INSERT INTO `school_recruit` VALUES ('133151', '289', '2011', '2', '1', '3', '440', '454', '0');
INSERT INTO `school_recruit` VALUES ('133152', '289', '2010', '2', '1', '3', '432', '443', '0');
INSERT INTO `school_recruit` VALUES ('133154', '289', '2013', '2', '2', '3', '350', '369', '0');
INSERT INTO `school_recruit` VALUES ('133155', '289', '2012', '2', '2', '3', '381', '397', '0');
INSERT INTO `school_recruit` VALUES ('133156', '289', '2011', '2', '2', '3', '411', '427', '0');
INSERT INTO `school_recruit` VALUES ('133157', '289', '2010', '2', '2', '3', '424', '442', '0');
INSERT INTO `school_recruit` VALUES ('133238', '289', '2010', '1', '1', '10', '599', '629', '0');
INSERT INTO `school_recruit` VALUES ('133242', '289', '2010', '2', '1', '10', '543', '558', '0');
INSERT INTO `school_recruit` VALUES ('133250', '289', '2010', '1', '2', '10', '566', '603', '0');
INSERT INTO `school_recruit` VALUES ('133254', '289', '2010', '2', '2', '10', '502', '525', '0');
INSERT INTO `school_recruit` VALUES ('133290', '289', '2013', '2', '1', '13', '529', '534', '528');
INSERT INTO `school_recruit` VALUES ('133291', '289', '2012', '2', '1', '13', '566', '570', '565');
INSERT INTO `school_recruit` VALUES ('133292', '289', '2011', '2', '1', '13', '529', '532', '527');
INSERT INTO `school_recruit` VALUES ('133293', '289', '2010', '2', '1', '13', '517', '520', '0');
INSERT INTO `school_recruit` VALUES ('133298', '289', '2013', '2', '2', '13', '512', '519', '509');
INSERT INTO `school_recruit` VALUES ('133299', '289', '2012', '2', '2', '13', '542', '549', '538');
INSERT INTO `school_recruit` VALUES ('133300', '289', '2011', '2', '2', '13', '525', '533', '521');
INSERT INTO `school_recruit` VALUES ('133301', '289', '2010', '2', '2', '13', '509', '519', '0');
INSERT INTO `school_recruit` VALUES ('135017', '294', '2013', '1', '1', '34', '563', '577', '0');
INSERT INTO `school_recruit` VALUES ('135018', '294', '2013', '2', '1', '34', '509', '525', '0');
INSERT INTO `school_recruit` VALUES ('135019', '294', '2012', '2', '1', '34', '469', '502', '0');
INSERT INTO `school_recruit` VALUES ('135020', '294', '2011', '2', '1', '34', '500', '530', '0');
INSERT INTO `school_recruit` VALUES ('135021', '294', '2010', '2', '1', '34', '496', '529', '0');
INSERT INTO `school_recruit` VALUES ('135026', '294', '2013', '1', '2', '34', '567', '585', '0');
INSERT INTO `school_recruit` VALUES ('135027', '294', '2012', '1', '2', '34', '520', '627', '0');
INSERT INTO `school_recruit` VALUES ('135028', '294', '2011', '1', '2', '34', '521', '624', '0');
INSERT INTO `school_recruit` VALUES ('135029', '294', '2010', '1', '2', '34', '532', '616', '0');
INSERT INTO `school_recruit` VALUES ('135034', '294', '2013', '2', '2', '34', '523', '541', '0');
INSERT INTO `school_recruit` VALUES ('135035', '294', '2012', '2', '2', '34', '466', '551', '0');
INSERT INTO `school_recruit` VALUES ('135036', '294', '2011', '2', '2', '34', '467', '581', '0');
INSERT INTO `school_recruit` VALUES ('135037', '294', '2010', '2', '2', '34', '483', '580', '0');
INSERT INTO `school_recruit` VALUES ('135064', '294', '2013', '2', '1', '3', '410', '417', '0');
INSERT INTO `school_recruit` VALUES ('135065', '294', '2012', '2', '1', '3', '396', '401', '0');
INSERT INTO `school_recruit` VALUES ('135066', '294', '2011', '2', '1', '3', '422', '428', '0');
INSERT INTO `school_recruit` VALUES ('135067', '294', '2010', '2', '1', '3', '411', '411', '0');
INSERT INTO `school_recruit` VALUES ('135068', '294', '2013', '2', '2', '3', '362', '393', '0');
INSERT INTO `school_recruit` VALUES ('135069', '294', '2012', '2', '2', '3', '414', '428', '0');
INSERT INTO `school_recruit` VALUES ('135070', '294', '2011', '2', '2', '3', '450', '460', '0');
INSERT INTO `school_recruit` VALUES ('135071', '294', '2010', '2', '2', '3', '453', '463', '0');
INSERT INTO `school_recruit` VALUES ('135155', '294', '2012', '2', '1', '10', '497', '543', '0');
INSERT INTO `school_recruit` VALUES ('135156', '294', '2010', '2', '1', '10', '533', '535', '0');
INSERT INTO `school_recruit` VALUES ('135158', '294', '2012', '2', '2', '10', '494', '555', '0');
INSERT INTO `school_recruit` VALUES ('135159', '294', '2010', '2', '2', '10', '510', '536', '0');
INSERT INTO `school_recruit` VALUES ('135180', '294', '2013', '2', '1', '13', '525', '525', '525');
INSERT INTO `school_recruit` VALUES ('135181', '294', '2012', '2', '1', '13', '561', '562', '0');
INSERT INTO `school_recruit` VALUES ('135182', '294', '2011', '2', '1', '13', '522', '523', '0');
INSERT INTO `school_recruit` VALUES ('135183', '294', '2010', '2', '1', '13', '506', '507', '0');
INSERT INTO `school_recruit` VALUES ('135185', '294', '2013', '1', '2', '13', '556', '563', '548');
INSERT INTO `school_recruit` VALUES ('135186', '294', '2012', '1', '2', '13', '570', '584', '0');
INSERT INTO `school_recruit` VALUES ('135187', '294', '2013', '2', '2', '13', '515', '520', '513');
INSERT INTO `school_recruit` VALUES ('135188', '294', '2012', '2', '2', '13', '544', '558', '0');
INSERT INTO `school_recruit` VALUES ('135189', '294', '2011', '2', '2', '13', '540', '562', '0');
INSERT INTO `school_recruit` VALUES ('135190', '294', '2010', '2', '2', '13', '522', '535', '0');
INSERT INTO `school_recruit` VALUES ('136141', '297', '2013', '2', '1', '34', '515', '537', '0');
INSERT INTO `school_recruit` VALUES ('136142', '297', '2012', '2', '1', '34', '482', '498', '0');
INSERT INTO `school_recruit` VALUES ('136143', '297', '2013', '2', '2', '34', '528', '551', '0');
INSERT INTO `school_recruit` VALUES ('136144', '297', '2012', '2', '2', '34', '454', '476', '0');
INSERT INTO `school_recruit` VALUES ('136177', '297', '2013', '1', '1', '3', '463', '479', '0');
INSERT INTO `school_recruit` VALUES ('136178', '297', '2012', '1', '1', '3', '472', '493', '0');
INSERT INTO `school_recruit` VALUES ('136179', '297', '2011', '1', '1', '3', '505', '525', '0');
INSERT INTO `school_recruit` VALUES ('136180', '297', '2010', '1', '1', '3', '497', '513', '0');
INSERT INTO `school_recruit` VALUES ('136185', '297', '2013', '2', '1', '3', '432', '461', '0');
INSERT INTO `school_recruit` VALUES ('136186', '297', '2012', '2', '1', '3', '449', '468', '0');
INSERT INTO `school_recruit` VALUES ('136187', '297', '2011', '2', '1', '3', '476', '500', '0');
INSERT INTO `school_recruit` VALUES ('136188', '297', '2010', '2', '1', '3', '471', '493', '0');
INSERT INTO `school_recruit` VALUES ('136193', '297', '2013', '1', '2', '3', '429', '453', '0');
INSERT INTO `school_recruit` VALUES ('136194', '297', '2012', '1', '2', '3', '467', '481', '0');
INSERT INTO `school_recruit` VALUES ('136195', '297', '2011', '1', '2', '3', '497', '522', '0');
INSERT INTO `school_recruit` VALUES ('136196', '297', '2010', '1', '2', '3', '495', '515', '0');
INSERT INTO `school_recruit` VALUES ('136201', '297', '2013', '2', '2', '3', '379', '428', '0');
INSERT INTO `school_recruit` VALUES ('136202', '297', '2012', '2', '2', '3', '444', '461', '0');
INSERT INTO `school_recruit` VALUES ('136203', '297', '2011', '2', '2', '3', '473', '500', '0');
INSERT INTO `school_recruit` VALUES ('136204', '297', '2010', '2', '2', '3', '471', '489', '0');
INSERT INTO `school_recruit` VALUES ('136261', '297', '2010', '1', '1', '10', '631', '642', '0');
INSERT INTO `school_recruit` VALUES ('136266', '297', '2010', '1', '2', '10', '609', '623', '0');
INSERT INTO `school_recruit` VALUES ('136302', '297', '2013', '1', '1', '13', '569', '571', '566');
INSERT INTO `school_recruit` VALUES ('136303', '297', '2012', '1', '1', '13', '601', '607', '0');
INSERT INTO `school_recruit` VALUES ('136304', '297', '2011', '1', '1', '13', '562', '568', '0');
INSERT INTO `school_recruit` VALUES ('136305', '297', '2010', '1', '1', '13', '554', '557', '0');
INSERT INTO `school_recruit` VALUES ('136310', '297', '2013', '1', '2', '13', '572', '582', '566');
INSERT INTO `school_recruit` VALUES ('136311', '297', '2012', '1', '2', '13', '599', '610', '0');
INSERT INTO `school_recruit` VALUES ('136312', '297', '2011', '1', '2', '13', '583', '597', '0');
INSERT INTO `school_recruit` VALUES ('136313', '297', '2010', '1', '2', '13', '564', '578', '0');
INSERT INTO `school_recruit` VALUES ('136810', '299', '2011', '1', '1', '34', '555', '618', '0');
INSERT INTO `school_recruit` VALUES ('136811', '299', '2013', '1', '2', '34', '585', '620', '0');
INSERT INTO `school_recruit` VALUES ('136812', '299', '2012', '1', '2', '34', '561', '625', '0');
INSERT INTO `school_recruit` VALUES ('136813', '299', '2011', '1', '2', '34', '576', '646', '0');
INSERT INTO `school_recruit` VALUES ('136814', '299', '2010', '1', '2', '34', '582', '645', '0');
INSERT INTO `school_recruit` VALUES ('136819', '299', '2013', '2', '2', '34', '530', '555', '0');
INSERT INTO `school_recruit` VALUES ('136820', '299', '2012', '2', '2', '34', '477', '562', '0');
INSERT INTO `school_recruit` VALUES ('136821', '299', '2011', '2', '2', '34', '504', '556', '0');
INSERT INTO `school_recruit` VALUES ('136822', '299', '2010', '2', '2', '34', '502', '545', '0');
INSERT INTO `school_recruit` VALUES ('136898', '299', '2010', '1', '2', '10', '622', '644', '0');
INSERT INTO `school_recruit` VALUES ('136913', '299', '2013', '1', '2', '13', '595', '615', '582');
INSERT INTO `school_recruit` VALUES ('136914', '299', '2012', '1', '2', '13', '612', '634', '599');
INSERT INTO `school_recruit` VALUES ('136915', '299', '2011', '1', '2', '13', '596', '623', '581');
INSERT INTO `school_recruit` VALUES ('136916', '299', '2010', '1', '2', '13', '571', '603', '525');
INSERT INTO `school_recruit` VALUES ('139481', '306', '2013', '2', '1', '34', '503', '512', '0');
INSERT INTO `school_recruit` VALUES ('139482', '306', '2011', '2', '1', '34', '499', '525', '0');
INSERT INTO `school_recruit` VALUES ('139483', '306', '2010', '2', '1', '34', '488', '514', '0');
INSERT INTO `school_recruit` VALUES ('139485', '306', '2013', '2', '2', '34', '507', '509', '0');
INSERT INTO `school_recruit` VALUES ('139486', '306', '2011', '2', '2', '34', '455', '544', '0');
INSERT INTO `school_recruit` VALUES ('139487', '306', '2010', '2', '2', '34', '461', '492', '0');
INSERT INTO `school_recruit` VALUES ('139499', '306', '2013', '2', '1', '3', '417', '431', '0');
INSERT INTO `school_recruit` VALUES ('139500', '306', '2011', '2', '1', '3', '432', '446', '0');
INSERT INTO `school_recruit` VALUES ('139501', '306', '2010', '2', '1', '3', '430', '439', '0');
INSERT INTO `school_recruit` VALUES ('139503', '306', '2013', '2', '2', '3', '352', '374', '0');
INSERT INTO `school_recruit` VALUES ('139504', '306', '2011', '2', '2', '3', '421', '436', '0');
INSERT INTO `school_recruit` VALUES ('139505', '306', '2010', '2', '2', '3', '428', '451', '0');
INSERT INTO `school_recruit` VALUES ('139541', '306', '2010', '1', '1', '10', '625', '642', '0');
INSERT INTO `school_recruit` VALUES ('139545', '306', '2010', '2', '1', '10', '551', '573', '0');
INSERT INTO `school_recruit` VALUES ('139550', '306', '2010', '1', '2', '10', '605', '630', '0');
INSERT INTO `school_recruit` VALUES ('139554', '306', '2010', '2', '2', '10', '513', '557', '0');
INSERT INTO `school_recruit` VALUES ('141262', '313', '2013', '2', '1', '3', '415', '428', '0');
INSERT INTO `school_recruit` VALUES ('141263', '313', '2012', '2', '1', '3', '413', '433', '0');
INSERT INTO `school_recruit` VALUES ('141264', '313', '2011', '2', '1', '3', '438', '461', '0');
INSERT INTO `school_recruit` VALUES ('141265', '313', '2010', '2', '1', '3', '431', '449', '0');
INSERT INTO `school_recruit` VALUES ('141270', '313', '2013', '2', '2', '3', '351', '371', '0');
INSERT INTO `school_recruit` VALUES ('141271', '313', '2012', '2', '2', '3', '387', '422', '0');
INSERT INTO `school_recruit` VALUES ('141272', '313', '2011', '2', '2', '3', '420', '452', '0');
INSERT INTO `school_recruit` VALUES ('141273', '313', '2010', '2', '2', '3', '422', '461', '0');
INSERT INTO `school_recruit` VALUES ('141356', '313', '2010', '2', '1', '10', '507', '537', '0');
INSERT INTO `school_recruit` VALUES ('141361', '313', '2010', '2', '2', '10', '482', '511', '0');
INSERT INTO `school_recruit` VALUES ('141396', '313', '2013', '2', '1', '13', '525', '526', '524');
INSERT INTO `school_recruit` VALUES ('141397', '313', '2012', '2', '1', '13', '561', '568', '556');
INSERT INTO `school_recruit` VALUES ('141398', '313', '2011', '2', '1', '13', '524', '528', '522');
INSERT INTO `school_recruit` VALUES ('141399', '313', '2010', '2', '1', '13', '510', '518', '0');
INSERT INTO `school_recruit` VALUES ('141404', '313', '2013', '2', '2', '13', '508', '516', '503');
INSERT INTO `school_recruit` VALUES ('141405', '313', '2012', '2', '2', '13', '539', '552', '534');
INSERT INTO `school_recruit` VALUES ('141406', '313', '2011', '2', '2', '13', '521', '538', '517');
INSERT INTO `school_recruit` VALUES ('141407', '313', '2010', '2', '2', '13', '507', '527', '0');
INSERT INTO `school_recruit` VALUES ('141587', '314', '2011', '2', '1', '34', '483', '483', '0');
INSERT INTO `school_recruit` VALUES ('141588', '314', '2010', '2', '1', '34', '489', '489', '0');
INSERT INTO `school_recruit` VALUES ('141627', '314', '2013', '2', '1', '3', '403', '404', '0');
INSERT INTO `school_recruit` VALUES ('141628', '314', '2012', '2', '1', '3', '411', '411', '0');
INSERT INTO `school_recruit` VALUES ('141629', '314', '2011', '2', '1', '3', '413', '414', '0');
INSERT INTO `school_recruit` VALUES ('141635', '314', '2013', '2', '2', '3', '334', '337', '0');
INSERT INTO `school_recruit` VALUES ('141636', '314', '2012', '2', '2', '3', '362', '375', '0');
INSERT INTO `school_recruit` VALUES ('141637', '314', '2011', '2', '2', '3', '399', '403', '0');
INSERT INTO `school_recruit` VALUES ('141638', '314', '2010', '2', '2', '3', '408', '413', '0');
INSERT INTO `school_recruit` VALUES ('141742', '314', '2010', '2', '1', '10', '517', '526', '0');
INSERT INTO `school_recruit` VALUES ('141747', '314', '2010', '2', '2', '10', '469', '479', '0');
INSERT INTO `school_recruit` VALUES ('141783', '314', '2013', '2', '1', '13', '493', '519', '484');
INSERT INTO `school_recruit` VALUES ('141784', '314', '2012', '2', '1', '13', '531', '561', '527');
INSERT INTO `school_recruit` VALUES ('141785', '314', '2011', '2', '1', '13', '490', '522', '485');
INSERT INTO `school_recruit` VALUES ('141786', '314', '2010', '2', '1', '13', '487', '525', '0');
INSERT INTO `school_recruit` VALUES ('141792', '314', '2013', '2', '2', '13', '465', '500', '456');
INSERT INTO `school_recruit` VALUES ('141793', '314', '2012', '2', '2', '13', '493', '528', '487');
INSERT INTO `school_recruit` VALUES ('141794', '314', '2011', '2', '2', '13', '480', '511', '474');
INSERT INTO `school_recruit` VALUES ('141795', '314', '2010', '2', '2', '13', '469', '508', '0');
INSERT INTO `school_recruit` VALUES ('142058', '315', '2012', '3', '1', '34', '417', '417', '0');
INSERT INTO `school_recruit` VALUES ('142059', '315', '2011', '3', '1', '34', '455', '459', '0');
INSERT INTO `school_recruit` VALUES ('142060', '315', '2010', '3', '1', '34', '439', '439', '0');
INSERT INTO `school_recruit` VALUES ('142062', '315', '2012', '3', '2', '34', '416', '416', '0');
INSERT INTO `school_recruit` VALUES ('142063', '315', '2011', '3', '2', '34', '397', '398', '0');
INSERT INTO `school_recruit` VALUES ('142064', '315', '2010', '3', '2', '34', '403', '405', '0');
INSERT INTO `school_recruit` VALUES ('142095', '315', '2012', '2', '1', '3', '394', '408', '0');
INSERT INTO `school_recruit` VALUES ('142096', '315', '2011', '2', '1', '3', '413', '415', '0');
INSERT INTO `school_recruit` VALUES ('142097', '315', '2012', '2', '2', '3', '358', '389', '0');
INSERT INTO `school_recruit` VALUES ('142098', '315', '2011', '2', '2', '3', '394', '395', '0');
INSERT INTO `school_recruit` VALUES ('142190', '315', '2010', '2', '1', '10', '493', '504', '0');
INSERT INTO `school_recruit` VALUES ('142195', '315', '2010', '2', '2', '10', '442', '461', '0');
INSERT INTO `school_recruit` VALUES ('142231', '315', '2013', '2', '1', '13', '491', '504', '484');
INSERT INTO `school_recruit` VALUES ('142232', '315', '2012', '2', '1', '13', '531', '545', '523');
INSERT INTO `school_recruit` VALUES ('142233', '315', '2010', '2', '1', '13', '497', '497', '0');
INSERT INTO `school_recruit` VALUES ('142235', '315', '2013', '3', '1', '13', '452', '473', '444');
INSERT INTO `school_recruit` VALUES ('142236', '315', '2012', '3', '1', '13', '467', '505', '458');
INSERT INTO `school_recruit` VALUES ('142237', '315', '2011', '3', '1', '13', '425', '477', '0');
INSERT INTO `school_recruit` VALUES ('142238', '315', '2010', '3', '1', '13', '425', '461', '0');
INSERT INTO `school_recruit` VALUES ('142242', '315', '2013', '2', '2', '13', '462', '472', '456');
INSERT INTO `school_recruit` VALUES ('142243', '315', '2012', '2', '2', '13', '492', '510', '486');
INSERT INTO `school_recruit` VALUES ('142244', '315', '2011', '2', '2', '13', '487', '497', '0');
INSERT INTO `school_recruit` VALUES ('142246', '315', '2013', '3', '2', '13', '415', '478', '406');
INSERT INTO `school_recruit` VALUES ('142247', '315', '2012', '3', '2', '13', '407', '476', '418');
INSERT INTO `school_recruit` VALUES ('142248', '315', '2011', '3', '2', '13', '383', '450', '0');
INSERT INTO `school_recruit` VALUES ('142249', '315', '2010', '3', '2', '13', '387', '490', '0');
INSERT INTO `school_recruit` VALUES ('142511', '316', '2013', '2', '1', '3', '418', '433', '0');
INSERT INTO `school_recruit` VALUES ('142512', '316', '2012', '2', '1', '3', '417', '429', '0');
INSERT INTO `school_recruit` VALUES ('142513', '316', '2011', '2', '1', '3', '438', '454', '0');
INSERT INTO `school_recruit` VALUES ('142514', '316', '2010', '2', '1', '3', '431', '456', '0');
INSERT INTO `school_recruit` VALUES ('142519', '316', '2013', '4', '1', '3', '298', '309', '0');
INSERT INTO `school_recruit` VALUES ('142520', '316', '2012', '4', '1', '3', '296', '342', '0');
INSERT INTO `school_recruit` VALUES ('142521', '316', '2011', '4', '1', '3', '160', '321', '0');
INSERT INTO `school_recruit` VALUES ('142522', '316', '2013', '2', '2', '3', '356', '382', '0');
INSERT INTO `school_recruit` VALUES ('142523', '316', '2012', '2', '2', '3', '399', '418', '0');
INSERT INTO `school_recruit` VALUES ('142524', '316', '2011', '2', '2', '3', '429', '449', '0');
INSERT INTO `school_recruit` VALUES ('142525', '316', '2010', '2', '2', '3', '430', '456', '0');
INSERT INTO `school_recruit` VALUES ('142530', '316', '2013', '4', '2', '3', '264', '282', '0');
INSERT INTO `school_recruit` VALUES ('142531', '316', '2012', '4', '2', '3', '270', '299', '0');
INSERT INTO `school_recruit` VALUES ('142532', '316', '2011', '4', '2', '3', '170', '340', '0');
INSERT INTO `school_recruit` VALUES ('142617', '316', '2013', '2', '1', '10', '558', '567', '0');
INSERT INTO `school_recruit` VALUES ('142618', '316', '2012', '2', '1', '10', '544', '549', '0');
INSERT INTO `school_recruit` VALUES ('142619', '316', '2010', '2', '1', '10', '533', '536', '0');
INSERT INTO `school_recruit` VALUES ('142624', '316', '2013', '4', '1', '10', '373', '397', '0');
INSERT INTO `school_recruit` VALUES ('142625', '316', '2012', '4', '1', '10', '367', '382', '0');
INSERT INTO `school_recruit` VALUES ('142626', '316', '2011', '4', '1', '10', '193', '386', '0');
INSERT INTO `school_recruit` VALUES ('142627', '316', '2012', '2', '2', '10', '539', '551', '0');
INSERT INTO `school_recruit` VALUES ('142628', '316', '2010', '2', '2', '10', '496', '518', '0');
INSERT INTO `school_recruit` VALUES ('142633', '316', '2013', '4', '2', '10', '358', '395', '0');
INSERT INTO `school_recruit` VALUES ('142634', '316', '2012', '4', '2', '10', '368', '397', '0');
INSERT INTO `school_recruit` VALUES ('142635', '316', '2011', '4', '2', '10', '195', '391', '0');
INSERT INTO `school_recruit` VALUES ('142676', '316', '2013', '2', '1', '13', '525', '526', '524');
INSERT INTO `school_recruit` VALUES ('142677', '316', '2012', '2', '1', '13', '566', '571', '564');
INSERT INTO `school_recruit` VALUES ('142678', '316', '2011', '2', '1', '13', '526', '534', '521');
INSERT INTO `school_recruit` VALUES ('142679', '316', '2010', '2', '1', '13', '517', '520', '0');
INSERT INTO `school_recruit` VALUES ('142684', '316', '2013', '4', '1', '13', '292', '406', '0');
INSERT INTO `school_recruit` VALUES ('142685', '316', '2012', '4', '1', '13', '481', '503', '0');
INSERT INTO `school_recruit` VALUES ('142686', '316', '2011', '4', '1', '13', '356', '453', '0');
INSERT INTO `school_recruit` VALUES ('142687', '316', '2013', '2', '2', '13', '511', '526', '507');
INSERT INTO `school_recruit` VALUES ('142688', '316', '2012', '2', '2', '13', '544', '558', '540');
INSERT INTO `school_recruit` VALUES ('142689', '316', '2011', '2', '2', '13', '525', '534', '521');
INSERT INTO `school_recruit` VALUES ('142690', '316', '2010', '2', '2', '13', '509', '517', '0');
INSERT INTO `school_recruit` VALUES ('142695', '316', '2013', '4', '2', '13', '386', '431', '0');
INSERT INTO `school_recruit` VALUES ('142696', '316', '2012', '4', '2', '13', '431', '477', '0');
INSERT INTO `school_recruit` VALUES ('142697', '316', '2011', '4', '2', '13', '327', '455', '0');
INSERT INTO `school_recruit` VALUES ('145699', '324', '2013', '2', '1', '34', '506', '518', '0');
INSERT INTO `school_recruit` VALUES ('145700', '324', '2012', '2', '1', '34', '463', '480', '0');
INSERT INTO `school_recruit` VALUES ('145701', '324', '2011', '2', '1', '34', '497', '511', '0');
INSERT INTO `school_recruit` VALUES ('145702', '324', '2010', '2', '1', '34', '489', '504', '0');
INSERT INTO `school_recruit` VALUES ('145707', '324', '2013', '2', '2', '34', '507', '510', '0');
INSERT INTO `school_recruit` VALUES ('145708', '324', '2012', '2', '2', '34', '435', '435', '0');
INSERT INTO `school_recruit` VALUES ('145709', '324', '2010', '2', '2', '34', '469', '479', '0');
INSERT INTO `school_recruit` VALUES ('145742', '324', '2013', '2', '1', '3', '415', '428', '0');
INSERT INTO `school_recruit` VALUES ('145743', '324', '2012', '2', '1', '3', '415', '416', '0');
INSERT INTO `school_recruit` VALUES ('145744', '324', '2011', '2', '1', '3', '423', '430', '0');
INSERT INTO `school_recruit` VALUES ('145745', '324', '2013', '2', '2', '3', '357', '384', '0');
INSERT INTO `school_recruit` VALUES ('145746', '324', '2012', '2', '2', '3', '400', '404', '0');
INSERT INTO `school_recruit` VALUES ('145747', '324', '2011', '2', '2', '3', '424', '429', '0');
INSERT INTO `school_recruit` VALUES ('145807', '324', '2010', '1', '1', '10', '608', '637', '0');
INSERT INTO `school_recruit` VALUES ('145812', '324', '2010', '2', '1', '10', '530', '554', '0');
INSERT INTO `school_recruit` VALUES ('145816', '324', '2010', '5', '1', '10', '558', '578', '0');
INSERT INTO `school_recruit` VALUES ('145821', '324', '2010', '1', '2', '10', '577', '634', '0');
INSERT INTO `school_recruit` VALUES ('145826', '324', '2010', '2', '2', '10', '486', '520', '0');
INSERT INTO `school_recruit` VALUES ('145830', '324', '2010', '5', '2', '10', '532', '563', '0');
INSERT INTO `school_recruit` VALUES ('145866', '324', '2010', '5', '1', '13', '543', '566', '0');
INSERT INTO `school_recruit` VALUES ('145871', '324', '2010', '5', '2', '13', '551', '577', '0');
INSERT INTO `school_recruit` VALUES ('147777', '329', '2011', '2', '1', '34', '492', '492', '0');
INSERT INTO `school_recruit` VALUES ('147821', '329', '2013', '2', '1', '3', '408', '413', '0');
INSERT INTO `school_recruit` VALUES ('147822', '329', '2012', '2', '1', '3', '383', '388', '0');
INSERT INTO `school_recruit` VALUES ('147823', '329', '2011', '2', '1', '3', '420', '423', '0');
INSERT INTO `school_recruit` VALUES ('147824', '329', '2010', '2', '1', '3', '414', '424', '0');
INSERT INTO `school_recruit` VALUES ('147829', '329', '2013', '2', '2', '3', '335', '340', '0');
INSERT INTO `school_recruit` VALUES ('147830', '329', '2012', '2', '2', '3', '360', '376', '0');
INSERT INTO `school_recruit` VALUES ('147831', '329', '2011', '2', '2', '3', '398', '409', '0');
INSERT INTO `school_recruit` VALUES ('147832', '329', '2010', '2', '2', '3', '408', '421', '0');
INSERT INTO `school_recruit` VALUES ('147947', '329', '2010', '2', '1', '10', '522', '529', '0');
INSERT INTO `school_recruit` VALUES ('147953', '329', '2010', '2', '2', '10', '475', '498', '0');
INSERT INTO `school_recruit` VALUES ('147993', '329', '2012', '1', '1', '13', '574', '579', '570');
INSERT INTO `school_recruit` VALUES ('147994', '329', '2013', '2', '1', '13', '513', '530', '484');
INSERT INTO `school_recruit` VALUES ('147995', '329', '2012', '2', '1', '13', '555', '569', '523');
INSERT INTO `school_recruit` VALUES ('147996', '329', '2011', '2', '1', '13', '515', '530', '484');
INSERT INTO `school_recruit` VALUES ('147997', '329', '2010', '2', '1', '13', '507', '521', '0');
INSERT INTO `school_recruit` VALUES ('148003', '329', '2013', '1', '2', '13', '521', '539', '517');
INSERT INTO `school_recruit` VALUES ('148004', '329', '2012', '1', '2', '13', '550', '556', '547');
INSERT INTO `school_recruit` VALUES ('148005', '329', '2013', '2', '2', '13', '489', '520', '456');
INSERT INTO `school_recruit` VALUES ('148006', '329', '2012', '2', '2', '13', '519', '555', '486');
INSERT INTO `school_recruit` VALUES ('148007', '329', '2011', '2', '2', '13', '504', '540', '474');
INSERT INTO `school_recruit` VALUES ('148008', '329', '2010', '2', '2', '13', '490', '515', '0');
INSERT INTO `school_recruit` VALUES ('148985', '331', '2010', '5', '1', '34', '530', '533', '0');
INSERT INTO `school_recruit` VALUES ('148991', '331', '2010', '5', '2', '34', '519', '559', '0');
INSERT INTO `school_recruit` VALUES ('149079', '331', '2010', '5', '1', '10', '616', '632', '0');
INSERT INTO `school_recruit` VALUES ('149085', '331', '2010', '5', '2', '10', '568', '574', '0');
INSERT INTO `school_recruit` VALUES ('149107', '331', '2010', '5', '1', '13', '523', '536', '0');
INSERT INTO `school_recruit` VALUES ('149113', '331', '2010', '5', '2', '13', '520', '545', '0');
INSERT INTO `school_recruit` VALUES ('154909', '348', '2010', '2', '1', '10', '513', '533', '0');
INSERT INTO `school_recruit` VALUES ('154916', '348', '2010', '2', '2', '10', '464', '498', '0');
INSERT INTO `school_recruit` VALUES ('154954', '348', '2013', '2', '1', '13', '499', '503', '484');
INSERT INTO `school_recruit` VALUES ('154958', '348', '2013', '2', '2', '13', '474', '491', '461');
INSERT INTO `school_recruit` VALUES ('154959', '348', '2012', '2', '2', '13', '511', '529', '505');
INSERT INTO `school_recruit` VALUES ('154960', '348', '2011', '2', '2', '13', '492', '500', '488');
INSERT INTO `school_recruit` VALUES ('154961', '348', '2010', '2', '2', '13', '471', '475', '0');
INSERT INTO `school_recruit` VALUES ('158315', '358', '2013', '1', '1', '34', '559', '570', '0');
INSERT INTO `school_recruit` VALUES ('158316', '358', '2012', '1', '1', '34', '500', '504', '0');
INSERT INTO `school_recruit` VALUES ('158317', '358', '2011', '1', '1', '34', '524', '524', '0');
INSERT INTO `school_recruit` VALUES ('158318', '358', '2010', '1', '1', '34', '531', '531', '0');
INSERT INTO `school_recruit` VALUES ('158319', '358', '2013', '2', '1', '34', '504', '515', '0');
INSERT INTO `school_recruit` VALUES ('158320', '358', '2012', '2', '1', '34', '467', '491', '0');
INSERT INTO `school_recruit` VALUES ('158321', '358', '2011', '2', '1', '34', '498', '529', '0');
INSERT INTO `school_recruit` VALUES ('158322', '358', '2010', '2', '1', '34', '489', '515', '0');
INSERT INTO `school_recruit` VALUES ('158327', '358', '2013', '1', '2', '34', '558', '567', '0');
INSERT INTO `school_recruit` VALUES ('158328', '358', '2012', '1', '2', '34', '516', '531', '0');
INSERT INTO `school_recruit` VALUES ('158329', '358', '2011', '1', '2', '34', '487', '491', '0');
INSERT INTO `school_recruit` VALUES ('158330', '358', '2010', '1', '2', '34', '527', '544', '0');
INSERT INTO `school_recruit` VALUES ('158331', '358', '2013', '2', '2', '34', '517', '529', '0');
INSERT INTO `school_recruit` VALUES ('158332', '358', '2012', '2', '2', '34', '450', '594', '0');
INSERT INTO `school_recruit` VALUES ('158333', '358', '2011', '2', '2', '34', '458', '509', '0');
INSERT INTO `school_recruit` VALUES ('158334', '358', '2010', '2', '2', '34', '469', '522', '0');
INSERT INTO `school_recruit` VALUES ('158361', '358', '2013', '2', '1', '3', '409', '416', '0');
INSERT INTO `school_recruit` VALUES ('158362', '358', '2012', '2', '1', '3', '399', '407', '0');
INSERT INTO `school_recruit` VALUES ('158363', '358', '2011', '2', '1', '3', '421', '452', '0');
INSERT INTO `school_recruit` VALUES ('158364', '358', '2010', '2', '1', '3', '413', '429', '0');
INSERT INTO `school_recruit` VALUES ('158369', '358', '2011', '1', '2', '3', '470', '470', '0');
INSERT INTO `school_recruit` VALUES ('158370', '358', '2013', '2', '2', '3', '342', '353', '0');
INSERT INTO `school_recruit` VALUES ('158371', '358', '2012', '2', '2', '3', '371', '404', '0');
INSERT INTO `school_recruit` VALUES ('158372', '358', '2011', '2', '2', '3', '409', '430', '0');
INSERT INTO `school_recruit` VALUES ('158373', '358', '2010', '2', '2', '3', '412', '438', '0');
INSERT INTO `school_recruit` VALUES ('158478', '358', '2010', '2', '1', '10', '525', '532', '0');
INSERT INTO `school_recruit` VALUES ('158483', '358', '2010', '2', '2', '10', '471', '503', '0');
INSERT INTO `school_recruit` VALUES ('158530', '358', '2013', '2', '1', '13', '522', '526', '517');
INSERT INTO `school_recruit` VALUES ('158531', '358', '2012', '2', '1', '13', '565', '567', '563');
INSERT INTO `school_recruit` VALUES ('158532', '358', '2011', '2', '1', '13', '526', '530', '524');
INSERT INTO `school_recruit` VALUES ('158533', '358', '2010', '2', '1', '13', '520', '527', '0');
INSERT INTO `school_recruit` VALUES ('158538', '358', '2013', '2', '2', '13', '506', '521', '503');
INSERT INTO `school_recruit` VALUES ('158539', '358', '2012', '2', '2', '13', '541', '551', '535');
INSERT INTO `school_recruit` VALUES ('158540', '358', '2011', '2', '2', '13', '522', '541', '515');
INSERT INTO `school_recruit` VALUES ('158541', '358', '2010', '2', '2', '13', '506', '518', '0');
INSERT INTO `school_recruit` VALUES ('160634', '363', '2013', '1', '1', '34', '578', '608', '0');
INSERT INTO `school_recruit` VALUES ('160635', '363', '2012', '1', '1', '34', '546', '580', '0');
INSERT INTO `school_recruit` VALUES ('160636', '363', '2011', '1', '1', '34', '596', '633', '0');
INSERT INTO `school_recruit` VALUES ('160637', '363', '2010', '1', '1', '34', '582', '607', '0');
INSERT INTO `school_recruit` VALUES ('160642', '363', '2013', '1', '2', '34', '591', '633', '0');
INSERT INTO `school_recruit` VALUES ('160643', '363', '2012', '1', '2', '34', '560', '612', '0');
INSERT INTO `school_recruit` VALUES ('160644', '363', '2011', '1', '2', '34', '582', '617', '0');
INSERT INTO `school_recruit` VALUES ('160645', '363', '2010', '1', '2', '34', '594', '635', '0');
INSERT INTO `school_recruit` VALUES ('160771', '363', '2010', '1', '1', '10', '638', '650', '0');
INSERT INTO `school_recruit` VALUES ('160776', '363', '2010', '1', '2', '10', '611', '619', '0');
INSERT INTO `school_recruit` VALUES ('160807', '363', '2013', '1', '1', '13', '571', '576', '559');
INSERT INTO `school_recruit` VALUES ('160808', '363', '2012', '1', '1', '13', '608', '614', '605');
INSERT INTO `school_recruit` VALUES ('160809', '363', '2011', '1', '1', '13', '571', '575', '569');
INSERT INTO `school_recruit` VALUES ('160810', '363', '2010', '1', '1', '13', '561', '567', '558');
INSERT INTO `school_recruit` VALUES ('160815', '363', '2013', '1', '2', '13', '564', '574', '555');
INSERT INTO `school_recruit` VALUES ('160816', '363', '2012', '1', '2', '13', '594', '643', '573');
INSERT INTO `school_recruit` VALUES ('160817', '363', '2011', '1', '2', '13', '571', '595', '564');
INSERT INTO `school_recruit` VALUES ('160818', '363', '2010', '1', '2', '13', '554', '568', '546');
INSERT INTO `school_recruit` VALUES ('161486', '366', '2013', '1', '1', '34', '568', '587', '0');
INSERT INTO `school_recruit` VALUES ('161487', '366', '2012', '1', '1', '34', '531', '570', '0');
INSERT INTO `school_recruit` VALUES ('161488', '366', '2011', '1', '1', '34', '565', '601', '0');
INSERT INTO `school_recruit` VALUES ('161489', '366', '2010', '1', '1', '34', '547', '557', '0');
INSERT INTO `school_recruit` VALUES ('161494', '366', '2013', '1', '2', '34', '581', '613', '0');
INSERT INTO `school_recruit` VALUES ('161495', '366', '2012', '1', '2', '34', '556', '634', '0');
INSERT INTO `school_recruit` VALUES ('161496', '366', '2011', '1', '2', '34', '550', '610', '0');
INSERT INTO `school_recruit` VALUES ('161497', '366', '2010', '1', '2', '34', '565', '620', '0');
INSERT INTO `school_recruit` VALUES ('161534', '366', '2013', '1', '2', '3', '414', '424', '0');
INSERT INTO `school_recruit` VALUES ('161535', '366', '2012', '1', '2', '3', '442', '459', '0');
INSERT INTO `school_recruit` VALUES ('161536', '366', '2011', '1', '2', '3', '471', '483', '0');
INSERT INTO `school_recruit` VALUES ('161537', '366', '2010', '1', '2', '3', '471', '482', '0');
INSERT INTO `school_recruit` VALUES ('161624', '366', '2010', '1', '1', '10', '613', '615', '0');
INSERT INTO `school_recruit` VALUES ('161628', '366', '2010', '1', '2', '10', '598', '618', '0');
INSERT INTO `school_recruit` VALUES ('161657', '366', '2013', '1', '1', '13', '546', '560', '0');
INSERT INTO `school_recruit` VALUES ('161658', '366', '2012', '1', '1', '13', '592', '593', '0');
INSERT INTO `school_recruit` VALUES ('161659', '366', '2011', '1', '1', '13', '555', '559', '552');
INSERT INTO `school_recruit` VALUES ('161660', '366', '2010', '1', '1', '13', '527', '527', '527');
INSERT INTO `school_recruit` VALUES ('161664', '366', '2013', '1', '2', '13', '563', '581', '0');
INSERT INTO `school_recruit` VALUES ('161665', '366', '2012', '1', '2', '13', '596', '612', '0');
INSERT INTO `school_recruit` VALUES ('161666', '366', '2011', '1', '2', '13', '576', '598', '569');
INSERT INTO `school_recruit` VALUES ('161667', '366', '2010', '1', '2', '13', '556', '579', '547');
INSERT INTO `school_recruit` VALUES ('162306', '368', '2013', '2', '1', '34', '506', '518', '0');
INSERT INTO `school_recruit` VALUES ('162307', '368', '2012', '2', '1', '34', '458', '471', '0');
INSERT INTO `school_recruit` VALUES ('162308', '368', '2011', '2', '1', '34', '486', '486', '0');
INSERT INTO `school_recruit` VALUES ('162309', '368', '2010', '2', '1', '34', '485', '485', '0');
INSERT INTO `school_recruit` VALUES ('162311', '368', '2013', '2', '2', '34', '519', '533', '0');
INSERT INTO `school_recruit` VALUES ('162312', '368', '2012', '2', '2', '34', '467', '467', '0');
INSERT INTO `school_recruit` VALUES ('162313', '368', '2010', '2', '2', '34', '446', '446', '0');
INSERT INTO `school_recruit` VALUES ('162331', '368', '2013', '2', '1', '3', '421', '439', '0');
INSERT INTO `school_recruit` VALUES ('162332', '368', '2012', '2', '1', '3', '422', '441', '0');
INSERT INTO `school_recruit` VALUES ('162333', '368', '2011', '2', '1', '3', '447', '470', '0');
INSERT INTO `school_recruit` VALUES ('162334', '368', '2010', '2', '1', '3', '442', '466', '0');
INSERT INTO `school_recruit` VALUES ('162339', '368', '2010', '5', '1', '3', '444', '484', '0');
INSERT INTO `school_recruit` VALUES ('162344', '368', '2013', '2', '2', '3', '359', '387', '0');
INSERT INTO `school_recruit` VALUES ('162345', '368', '2012', '2', '2', '3', '404', '430', '0');
INSERT INTO `school_recruit` VALUES ('162346', '368', '2011', '2', '2', '3', '436', '459', '0');
INSERT INTO `school_recruit` VALUES ('162347', '368', '2010', '2', '2', '3', '437', '465', '0');
INSERT INTO `school_recruit` VALUES ('162352', '368', '2010', '5', '2', '3', '428', '462', '0');
INSERT INTO `school_recruit` VALUES ('162446', '368', '2010', '2', '1', '10', '549', '557', '0');
INSERT INTO `school_recruit` VALUES ('162451', '368', '2010', '2', '2', '10', '508', '523', '0');
INSERT INTO `school_recruit` VALUES ('162489', '368', '2013', '1', '1', '13', '546', '561', '542');
INSERT INTO `school_recruit` VALUES ('162490', '368', '2013', '2', '1', '13', '532', '541', '528');
INSERT INTO `school_recruit` VALUES ('162491', '368', '2012', '2', '1', '13', '571', '578', '569');
INSERT INTO `school_recruit` VALUES ('162492', '368', '2011', '2', '1', '13', '533', '550', '530');
INSERT INTO `school_recruit` VALUES ('162493', '368', '2010', '2', '1', '13', '523', '534', '0');
INSERT INTO `school_recruit` VALUES ('162498', '368', '2013', '1', '2', '13', '534', '582', '517');
INSERT INTO `school_recruit` VALUES ('162499', '368', '2013', '2', '2', '13', '516', '520', '514');
INSERT INTO `school_recruit` VALUES ('162500', '368', '2012', '2', '2', '13', '548', '563', '545');
INSERT INTO `school_recruit` VALUES ('162501', '368', '2011', '2', '2', '13', '532', '555', '526');
INSERT INTO `school_recruit` VALUES ('162502', '368', '2010', '2', '2', '13', '516', '528', '0');
INSERT INTO `school_recruit` VALUES ('164233', '373', '2013', '1', '1', '34', '552', '556', '0');
INSERT INTO `school_recruit` VALUES ('164234', '373', '2013', '2', '1', '34', '509', '525', '0');
INSERT INTO `school_recruit` VALUES ('164235', '373', '2011', '2', '1', '34', '507', '525', '0');
INSERT INTO `school_recruit` VALUES ('164236', '373', '2010', '2', '1', '34', '505', '526', '0');
INSERT INTO `school_recruit` VALUES ('164241', '373', '2013', '1', '2', '34', '559', '569', '0');
INSERT INTO `school_recruit` VALUES ('164242', '373', '2011', '1', '2', '34', '505', '585', '0');
INSERT INTO `school_recruit` VALUES ('164243', '373', '2010', '1', '2', '34', '518', '617', '0');
INSERT INTO `school_recruit` VALUES ('164246', '373', '2013', '2', '2', '34', '518', '531', '0');
INSERT INTO `school_recruit` VALUES ('164247', '373', '2011', '2', '2', '34', '469', '561', '0');
INSERT INTO `school_recruit` VALUES ('164248', '373', '2010', '2', '2', '34', '478', '575', '0');
INSERT INTO `school_recruit` VALUES ('164364', '373', '2010', '1', '1', '10', '303', '446', '0');
INSERT INTO `school_recruit` VALUES ('164365', '373', '2010', '2', '1', '10', '541', '547', '0');
INSERT INTO `school_recruit` VALUES ('164370', '373', '2010', '2', '2', '10', '502', '508', '0');
INSERT INTO `school_recruit` VALUES ('164399', '373', '2013', '2', '1', '13', '506', '528', '520');
INSERT INTO `school_recruit` VALUES ('164400', '373', '2011', '2', '1', '13', '533', '544', '528');
INSERT INTO `school_recruit` VALUES ('164401', '373', '2010', '2', '1', '13', '527', '530', '0');
INSERT INTO `school_recruit` VALUES ('164406', '373', '2013', '1', '2', '13', '530', '544', '537');
INSERT INTO `school_recruit` VALUES ('164407', '373', '2013', '2', '2', '13', '487', '519', '509');
INSERT INTO `school_recruit` VALUES ('164408', '373', '2011', '2', '2', '13', '543', '584', '537');
INSERT INTO `school_recruit` VALUES ('164409', '373', '2010', '2', '2', '13', '527', '554', '0');
INSERT INTO `school_recruit` VALUES ('165366', '376', '2010', '2', '1', '34', '483', '483', '0');
INSERT INTO `school_recruit` VALUES ('165406', '376', '2013', '2', '1', '3', '407', '412', '0');
INSERT INTO `school_recruit` VALUES ('165407', '376', '2012', '2', '1', '3', '389', '399', '0');
INSERT INTO `school_recruit` VALUES ('165408', '376', '2011', '2', '1', '3', '421', '430', '0');
INSERT INTO `school_recruit` VALUES ('165409', '376', '2010', '2', '1', '3', '415', '418', '0');
INSERT INTO `school_recruit` VALUES ('165415', '376', '2013', '2', '2', '3', '337', '343', '0');
INSERT INTO `school_recruit` VALUES ('165416', '376', '2012', '2', '2', '3', '366', '366', '0');
INSERT INTO `school_recruit` VALUES ('165417', '376', '2011', '2', '2', '3', '403', '413', '0');
INSERT INTO `school_recruit` VALUES ('165418', '376', '2010', '2', '2', '3', '403', '406', '0');
INSERT INTO `school_recruit` VALUES ('165504', '376', '2010', '2', '1', '10', '518', '525', '0');
INSERT INTO `school_recruit` VALUES ('165509', '376', '2010', '2', '2', '10', '471', '481', '0');
INSERT INTO `school_recruit` VALUES ('165545', '376', '2013', '2', '1', '13', '497', '515', '493');
INSERT INTO `school_recruit` VALUES ('165546', '376', '2012', '2', '1', '13', '535', '554', '530');
INSERT INTO `school_recruit` VALUES ('165547', '376', '2011', '2', '1', '13', '493', '517', '487');
INSERT INTO `school_recruit` VALUES ('165548', '376', '2010', '2', '1', '13', '486', '508', '0');
INSERT INTO `school_recruit` VALUES ('165554', '376', '2013', '1', '2', '13', '517', '520', '517');
INSERT INTO `school_recruit` VALUES ('165555', '376', '2013', '2', '2', '13', '476', '523', '456');
INSERT INTO `school_recruit` VALUES ('165556', '376', '2012', '2', '2', '13', '506', '544', '499');
INSERT INTO `school_recruit` VALUES ('165557', '376', '2011', '2', '2', '13', '491', '530', '485');
INSERT INTO `school_recruit` VALUES ('165558', '376', '2010', '2', '2', '13', '475', '510', '0');
INSERT INTO `school_recruit` VALUES ('169120', '387', '2013', '2', '1', '34', '533', '574', '0');
INSERT INTO `school_recruit` VALUES ('169121', '387', '2012', '2', '1', '34', '475', '513', '0');
INSERT INTO `school_recruit` VALUES ('169122', '387', '2011', '2', '1', '34', '512', '538', '0');
INSERT INTO `school_recruit` VALUES ('169123', '387', '2010', '2', '1', '34', '498', '524', '0');
INSERT INTO `school_recruit` VALUES ('169128', '387', '2013', '1', '2', '34', '558', '567', '0');
INSERT INTO `school_recruit` VALUES ('169129', '387', '2012', '1', '2', '34', '499', '600', '0');
INSERT INTO `school_recruit` VALUES ('169130', '387', '2011', '1', '2', '34', '504', '609', '0');
INSERT INTO `school_recruit` VALUES ('169131', '387', '2010', '1', '2', '34', '518', '607', '0');
INSERT INTO `school_recruit` VALUES ('169137', '387', '2013', '2', '2', '34', '533', '591', '0');
INSERT INTO `school_recruit` VALUES ('169138', '387', '2012', '2', '2', '34', '469', '494', '0');
INSERT INTO `school_recruit` VALUES ('169139', '387', '2011', '2', '2', '34', '469', '486', '0');
INSERT INTO `school_recruit` VALUES ('169140', '387', '2010', '2', '2', '34', '475', '558', '0');
INSERT INTO `school_recruit` VALUES ('169275', '387', '2010', '2', '2', '10', '508', '519', '0');
INSERT INTO `school_recruit` VALUES ('169317', '387', '2010', '2', '1', '13', '492', '492', '0');
INSERT INTO `school_recruit` VALUES ('169322', '387', '2013', '1', '2', '13', '532', '544', '526');
INSERT INTO `school_recruit` VALUES ('169325', '387', '2012', '2', '2', '13', '561', '570', '555');
INSERT INTO `school_recruit` VALUES ('169326', '387', '2011', '2', '2', '13', '550', '572', '541');
INSERT INTO `school_recruit` VALUES ('169327', '387', '2010', '2', '2', '13', '534', '604', '0');
INSERT INTO `school_recruit` VALUES ('171920', '394', '2010', '1', '1', '10', '593', '603', '0');
INSERT INTO `school_recruit` VALUES ('171924', '394', '2010', '2', '1', '10', '534', '551', '0');
INSERT INTO `school_recruit` VALUES ('171929', '394', '2010', '1', '2', '10', '558', '572', '0');
INSERT INTO `school_recruit` VALUES ('171933', '394', '2010', '2', '2', '10', '491', '525', '0');
INSERT INTO `school_recruit` VALUES ('171971', '394', '2013', '2', '1', '13', '531', '531', '530');
INSERT INTO `school_recruit` VALUES ('171972', '394', '2012', '2', '1', '13', '570', '574', '568');
INSERT INTO `school_recruit` VALUES ('171973', '394', '2011', '2', '1', '13', '533', '537', '531');
INSERT INTO `school_recruit` VALUES ('171974', '394', '2010', '2', '1', '13', '520', '523', '0');
INSERT INTO `school_recruit` VALUES ('171979', '394', '2013', '2', '2', '13', '516', '523', '515');
INSERT INTO `school_recruit` VALUES ('171980', '394', '2012', '2', '2', '13', '547', '554', '544');
INSERT INTO `school_recruit` VALUES ('171981', '394', '2011', '2', '2', '13', '529', '534', '527');
INSERT INTO `school_recruit` VALUES ('171982', '394', '2010', '2', '2', '13', '514', '522', '0');
INSERT INTO `school_recruit` VALUES ('172122', '395', '2011', '2', '2', '34', '480', '480', '0');
INSERT INTO `school_recruit` VALUES ('172156', '395', '2013', '2', '1', '3', '411', '419', '0');
INSERT INTO `school_recruit` VALUES ('172157', '395', '2012', '2', '1', '3', '411', '415', '0');
INSERT INTO `school_recruit` VALUES ('172158', '395', '2011', '2', '1', '3', '425', '435', '0');
INSERT INTO `school_recruit` VALUES ('172159', '395', '2010', '2', '1', '3', '424', '433', '0');
INSERT INTO `school_recruit` VALUES ('172164', '395', '2013', '2', '2', '3', '348', '365', '0');
INSERT INTO `school_recruit` VALUES ('172165', '395', '2012', '2', '2', '3', '376', '393', '0');
INSERT INTO `school_recruit` VALUES ('172166', '395', '2011', '2', '2', '3', '416', '426', '0');
INSERT INTO `school_recruit` VALUES ('172167', '395', '2010', '2', '2', '3', '419', '425', '0');
INSERT INTO `school_recruit` VALUES ('172262', '395', '2010', '1', '1', '10', '591', '597', '0');
INSERT INTO `school_recruit` VALUES ('172263', '395', '2010', '2', '1', '10', '529', '549', '0');
INSERT INTO `school_recruit` VALUES ('172268', '395', '2010', '1', '2', '10', '555', '564', '0');
INSERT INTO `school_recruit` VALUES ('172269', '395', '2010', '2', '2', '10', '481', '510', '0');
INSERT INTO `school_recruit` VALUES ('172306', '395', '2013', '2', '1', '13', '526', '530', '522');
INSERT INTO `school_recruit` VALUES ('172307', '395', '2012', '2', '1', '13', '565', '569', '562');
INSERT INTO `school_recruit` VALUES ('172308', '395', '2011', '2', '1', '13', '526', '531', '523');
INSERT INTO `school_recruit` VALUES ('172309', '395', '2010', '2', '1', '13', '515', '518', '0');
INSERT INTO `school_recruit` VALUES ('172314', '395', '2013', '2', '2', '13', '503', '523', '500');
INSERT INTO `school_recruit` VALUES ('172315', '395', '2012', '2', '2', '13', '533', '542', '529');
INSERT INTO `school_recruit` VALUES ('172316', '395', '2011', '2', '2', '13', '512', '529', '506');
INSERT INTO `school_recruit` VALUES ('172317', '395', '2010', '2', '2', '13', '499', '513', '0');
INSERT INTO `school_recruit` VALUES ('177936', '412', '2010', '2', '1', '10', '538', '550', '0');
INSERT INTO `school_recruit` VALUES ('177940', '412', '2010', '1', '2', '10', '560', '589', '0');
INSERT INTO `school_recruit` VALUES ('177944', '412', '2010', '2', '2', '10', '494', '520', '0');
INSERT INTO `school_recruit` VALUES ('177973', '412', '2013', '2', '1', '13', '521', '526', '516');
INSERT INTO `school_recruit` VALUES ('177974', '412', '2010', '2', '1', '13', '485', '488', '0');
INSERT INTO `school_recruit` VALUES ('177976', '412', '2013', '2', '2', '13', '513', '524', '510');
INSERT INTO `school_recruit` VALUES ('177977', '412', '2012', '2', '2', '13', '541', '559', '538');
INSERT INTO `school_recruit` VALUES ('177978', '412', '2011', '2', '2', '13', '525', '536', '521');
INSERT INTO `school_recruit` VALUES ('177979', '412', '2010', '2', '2', '13', '509', '516', '0');
INSERT INTO `school_recruit` VALUES ('179593', '418', '2013', '2', '1', '34', '513', '533', '0');
INSERT INTO `school_recruit` VALUES ('179594', '418', '2012', '2', '1', '34', '483', '529', '0');
INSERT INTO `school_recruit` VALUES ('179595', '418', '2011', '2', '1', '34', '511', '546', '0');
INSERT INTO `school_recruit` VALUES ('179596', '418', '2010', '2', '1', '34', '504', '549', '0');
INSERT INTO `school_recruit` VALUES ('179601', '418', '2013', '2', '2', '34', '520', '535', '0');
INSERT INTO `school_recruit` VALUES ('179602', '418', '2012', '2', '2', '34', '463', '509', '0');
INSERT INTO `school_recruit` VALUES ('179603', '418', '2011', '2', '2', '34', '470', '536', '0');
INSERT INTO `school_recruit` VALUES ('179604', '418', '2010', '2', '2', '34', '474', '543', '0');
INSERT INTO `school_recruit` VALUES ('179641', '418', '2013', '2', '1', '3', '414', '425', '0');
INSERT INTO `school_recruit` VALUES ('179642', '418', '2012', '2', '1', '3', '413', '433', '0');
INSERT INTO `school_recruit` VALUES ('179643', '418', '2011', '2', '1', '3', '430', '448', '0');
INSERT INTO `school_recruit` VALUES ('179644', '418', '2010', '2', '1', '3', '430', '439', '0');
INSERT INTO `school_recruit` VALUES ('179649', '418', '2013', '2', '2', '3', '353', '375', '0');
INSERT INTO `school_recruit` VALUES ('179650', '418', '2012', '2', '2', '3', '407', '414', '0');
INSERT INTO `school_recruit` VALUES ('179651', '418', '2011', '2', '2', '3', '439', '445', '0');
INSERT INTO `school_recruit` VALUES ('179652', '418', '2010', '2', '2', '3', '441', '447', '0');
INSERT INTO `school_recruit` VALUES ('179759', '418', '2010', '2', '1', '10', '543', '549', '0');
INSERT INTO `school_recruit` VALUES ('179764', '418', '2010', '2', '2', '10', '505', '508', '0');
INSERT INTO `school_recruit` VALUES ('179802', '418', '2013', '2', '1', '13', '519', '521', '518');
INSERT INTO `school_recruit` VALUES ('179803', '418', '2012', '2', '1', '13', '574', '587', '569');
INSERT INTO `school_recruit` VALUES ('179804', '418', '2011', '2', '1', '13', '538', '543', '535');
INSERT INTO `school_recruit` VALUES ('179805', '418', '2010', '2', '1', '13', '528', '533', '0');
INSERT INTO `school_recruit` VALUES ('179810', '418', '2013', '2', '2', '13', '514', '522', '507');
INSERT INTO `school_recruit` VALUES ('179811', '418', '2012', '2', '2', '13', '554', '567', '549');
INSERT INTO `school_recruit` VALUES ('179812', '418', '2011', '2', '2', '13', '531', '536', '527');
INSERT INTO `school_recruit` VALUES ('179813', '418', '2010', '2', '2', '13', '523', '534', '0');
INSERT INTO `school_recruit` VALUES ('181473', '423', '2010', '5', '1', '34', '547', '594', '0');
INSERT INTO `school_recruit` VALUES ('181478', '423', '2010', '5', '2', '34', '521', '580', '0');
INSERT INTO `school_recruit` VALUES ('181515', '423', '2013', '1', '1', '3', '450', '452', '0');
INSERT INTO `school_recruit` VALUES ('181516', '423', '2010', '1', '1', '3', '487', '487', '0');
INSERT INTO `school_recruit` VALUES ('181519', '423', '2013', '1', '2', '3', '411', '418', '0');
INSERT INTO `school_recruit` VALUES ('181520', '423', '2012', '1', '2', '3', '432', '437', '0');
INSERT INTO `school_recruit` VALUES ('181521', '423', '2011', '1', '2', '3', '467', '470', '0');
INSERT INTO `school_recruit` VALUES ('181522', '423', '2010', '1', '2', '3', '467', '467', '0');
INSERT INTO `school_recruit` VALUES ('181620', '423', '2010', '1', '1', '10', '607', '624', '0');
INSERT INTO `school_recruit` VALUES ('181625', '423', '2010', '1', '2', '10', '567', '583', '0');
INSERT INTO `school_recruit` VALUES ('181661', '423', '2013', '1', '1', '13', '550', '560', '540');
INSERT INTO `school_recruit` VALUES ('181662', '423', '2012', '1', '1', '13', '585', '590', '582');
INSERT INTO `school_recruit` VALUES ('181663', '423', '2011', '1', '1', '13', '545', '553', '544');
INSERT INTO `school_recruit` VALUES ('181664', '423', '2010', '1', '1', '13', '539', '549', '533');
INSERT INTO `school_recruit` VALUES ('181669', '423', '2013', '1', '2', '13', '530', '551', '517');
INSERT INTO `school_recruit` VALUES ('181670', '423', '2012', '1', '2', '13', '560', '576', '553');
INSERT INTO `school_recruit` VALUES ('181671', '423', '2011', '1', '2', '13', '543', '562', '531');
INSERT INTO `school_recruit` VALUES ('181672', '423', '2010', '1', '2', '13', '528', '545', '520');
INSERT INTO `school_recruit` VALUES ('182467', '425', '2012', '3', '1', '34', '428', '428', '0');
INSERT INTO `school_recruit` VALUES ('182468', '425', '2011', '3', '1', '34', '457', '457', '0');
INSERT INTO `school_recruit` VALUES ('182471', '425', '2013', '3', '2', '34', '475', '476', '0');
INSERT INTO `school_recruit` VALUES ('182472', '425', '2012', '3', '2', '34', '403', '403', '0');
INSERT INTO `school_recruit` VALUES ('182473', '425', '2010', '3', '2', '34', '410', '410', '0');
INSERT INTO `school_recruit` VALUES ('182500', '425', '2013', '2', '1', '3', '407', '412', '0');
INSERT INTO `school_recruit` VALUES ('182501', '425', '2013', '2', '2', '3', '331', '332', '0');
INSERT INTO `school_recruit` VALUES ('182502', '425', '2012', '2', '2', '3', '358', '358', '0');
INSERT INTO `school_recruit` VALUES ('182574', '425', '2010', '2', '1', '10', '498', '508', '0');
INSERT INTO `school_recruit` VALUES ('182578', '425', '2010', '2', '2', '10', '450', '482', '0');
INSERT INTO `school_recruit` VALUES ('182607', '425', '2013', '2', '1', '13', '499', '514', '484');
INSERT INTO `school_recruit` VALUES ('182608', '425', '2012', '2', '1', '13', '536', '552', '523');
INSERT INTO `school_recruit` VALUES ('182609', '425', '2011', '2', '1', '13', '493', '498', '484');
INSERT INTO `school_recruit` VALUES ('182610', '425', '2010', '2', '1', '13', '491', '501', '0');
INSERT INTO `school_recruit` VALUES ('182612', '425', '2013', '3', '1', '13', '452', '475', '444');
INSERT INTO `school_recruit` VALUES ('182613', '425', '2012', '3', '1', '13', '472', '518', '462');
INSERT INTO `school_recruit` VALUES ('182614', '425', '2011', '3', '1', '13', '431', '507', '431');
INSERT INTO `school_recruit` VALUES ('182615', '425', '2010', '3', '1', '13', '427', '477', '0');
INSERT INTO `school_recruit` VALUES ('182618', '425', '2013', '2', '2', '13', '463', '488', '456');
INSERT INTO `school_recruit` VALUES ('182619', '425', '2012', '2', '2', '13', '495', '522', '486');
INSERT INTO `school_recruit` VALUES ('182620', '425', '2011', '2', '2', '13', '483', '512', '474');
INSERT INTO `school_recruit` VALUES ('182621', '425', '2010', '2', '2', '13', '471', '505', '0');
INSERT INTO `school_recruit` VALUES ('182623', '425', '2013', '3', '2', '13', '416', '452', '407');
INSERT INTO `school_recruit` VALUES ('182624', '425', '2012', '3', '2', '13', '409', '475', '410');
INSERT INTO `school_recruit` VALUES ('182625', '425', '2011', '3', '2', '13', '393', '468', '411');
INSERT INTO `school_recruit` VALUES ('182626', '425', '2010', '3', '2', '13', '401', '460', '0');
INSERT INTO `school_recruit` VALUES ('183191', '428', '2011', '2', '1', '34', '491', '498', '0');
INSERT INTO `school_recruit` VALUES ('183192', '428', '2010', '2', '2', '34', '444', '450', '0');
INSERT INTO `school_recruit` VALUES ('183215', '428', '2013', '2', '1', '3', '413', '423', '0');
INSERT INTO `school_recruit` VALUES ('183216', '428', '2012', '2', '1', '3', '407', '413', '0');
INSERT INTO `school_recruit` VALUES ('183217', '428', '2011', '2', '1', '3', '430', '433', '0');
INSERT INTO `school_recruit` VALUES ('183218', '428', '2010', '2', '1', '3', '420', '433', '0');
INSERT INTO `school_recruit` VALUES ('183222', '428', '2013', '2', '2', '3', '349', '368', '0');
INSERT INTO `school_recruit` VALUES ('183223', '428', '2012', '2', '2', '3', '373', '375', '0');
INSERT INTO `school_recruit` VALUES ('183224', '428', '2011', '2', '2', '3', '403', '405', '0');
INSERT INTO `school_recruit` VALUES ('183225', '428', '2010', '2', '2', '3', '414', '418', '0');
INSERT INTO `school_recruit` VALUES ('183316', '428', '2010', '2', '1', '10', '533', '550', '0');
INSERT INTO `school_recruit` VALUES ('183321', '428', '2010', '1', '2', '10', '558', '572', '0');
INSERT INTO `school_recruit` VALUES ('183325', '428', '2010', '2', '2', '10', '487', '513', '0');
INSERT INTO `school_recruit` VALUES ('183330', '428', '2010', '5', '2', '10', '513', '560', '0');
INSERT INTO `school_recruit` VALUES ('183358', '428', '2013', '2', '1', '13', '529', '532', '528');
INSERT INTO `school_recruit` VALUES ('183359', '428', '2012', '2', '1', '13', '566', '576', '566');
INSERT INTO `school_recruit` VALUES ('183360', '428', '2011', '2', '1', '13', '528', '535', '526');
INSERT INTO `school_recruit` VALUES ('183361', '428', '2010', '2', '1', '13', '517', '524', '0');
INSERT INTO `school_recruit` VALUES ('183366', '428', '2013', '2', '2', '13', '510', '539', '502');
INSERT INTO `school_recruit` VALUES ('183367', '428', '2012', '2', '2', '13', '540', '554', '538');
INSERT INTO `school_recruit` VALUES ('183368', '428', '2011', '2', '2', '13', '523', '536', '519');
INSERT INTO `school_recruit` VALUES ('183369', '428', '2010', '2', '2', '13', '507', '516', '0');
INSERT INTO `school_recruit` VALUES ('183572', '429', '2013', '2', '1', '34', '506', '518', '0');
INSERT INTO `school_recruit` VALUES ('183573', '429', '2012', '2', '1', '34', '472', '498', '0');
INSERT INTO `school_recruit` VALUES ('183574', '429', '2011', '2', '1', '34', '500', '524', '0');
INSERT INTO `school_recruit` VALUES ('183575', '429', '2010', '2', '1', '34', '497', '519', '0');
INSERT INTO `school_recruit` VALUES ('183581', '429', '2013', '2', '2', '34', '516', '527', '0');
INSERT INTO `school_recruit` VALUES ('183582', '429', '2012', '2', '2', '34', '456', '484', '0');
INSERT INTO `school_recruit` VALUES ('183583', '429', '2011', '2', '2', '34', '458', '489', '0');
INSERT INTO `school_recruit` VALUES ('183584', '429', '2010', '2', '2', '34', '462', '498', '0');
INSERT INTO `school_recruit` VALUES ('183624', '429', '2013', '2', '1', '3', '411', '419', '0');
INSERT INTO `school_recruit` VALUES ('183625', '429', '2012', '2', '1', '3', '404', '410', '0');
INSERT INTO `school_recruit` VALUES ('183626', '429', '2011', '2', '1', '3', '423', '431', '0');
INSERT INTO `school_recruit` VALUES ('183627', '429', '2010', '2', '1', '3', '423', '458', '0');
INSERT INTO `school_recruit` VALUES ('183633', '429', '2013', '2', '2', '3', '340', '349', '0');
INSERT INTO `school_recruit` VALUES ('183634', '429', '2012', '2', '2', '3', '364', '378', '0');
INSERT INTO `school_recruit` VALUES ('183635', '429', '2011', '2', '2', '3', '409', '425', '0');
INSERT INTO `school_recruit` VALUES ('183636', '429', '2010', '2', '2', '3', '415', '435', '0');
INSERT INTO `school_recruit` VALUES ('183750', '429', '2010', '2', '1', '10', '533', '544', '0');
INSERT INTO `school_recruit` VALUES ('183756', '429', '2010', '2', '2', '10', '486', '502', '0');
INSERT INTO `school_recruit` VALUES ('183797', '429', '2013', '2', '1', '13', '525', '525', '520');
INSERT INTO `school_recruit` VALUES ('183798', '429', '2012', '2', '1', '13', '565', '580', '560');
INSERT INTO `school_recruit` VALUES ('183799', '429', '2011', '2', '1', '13', '524', '529', '523');
INSERT INTO `school_recruit` VALUES ('183800', '429', '2010', '2', '1', '13', '512', '519', '0');
INSERT INTO `school_recruit` VALUES ('183806', '429', '2013', '2', '2', '13', '481', '508', '456');
INSERT INTO `school_recruit` VALUES ('183807', '429', '2012', '2', '2', '13', '536', '546', '531');
INSERT INTO `school_recruit` VALUES ('183808', '429', '2011', '2', '2', '13', '517', '528', '513');
INSERT INTO `school_recruit` VALUES ('183809', '429', '2010', '2', '2', '13', '495', '507', '0');
INSERT INTO `school_recruit` VALUES ('188815', '443', '2013', '2', '1', '3', '412', '422', '0');
INSERT INTO `school_recruit` VALUES ('188816', '443', '2012', '2', '1', '3', '397', '401', '0');
INSERT INTO `school_recruit` VALUES ('188817', '443', '2011', '2', '1', '3', '427', '433', '0');
INSERT INTO `school_recruit` VALUES ('188818', '443', '2010', '2', '1', '3', '407', '407', '0');
INSERT INTO `school_recruit` VALUES ('188821', '443', '2013', '2', '2', '3', '345', '360', '0');
INSERT INTO `school_recruit` VALUES ('188822', '443', '2012', '2', '2', '3', '372', '394', '0');
INSERT INTO `school_recruit` VALUES ('188823', '443', '2011', '2', '2', '3', '410', '422', '0');
INSERT INTO `school_recruit` VALUES ('188824', '443', '2010', '2', '2', '3', '413', '415', '0');
INSERT INTO `school_recruit` VALUES ('188921', '443', '2010', '2', '1', '10', '513', '519', '0');
INSERT INTO `school_recruit` VALUES ('188928', '443', '2010', '2', '2', '10', '463', '472', '0');
INSERT INTO `school_recruit` VALUES ('188968', '443', '2013', '2', '1', '13', '508', '524', '484');
INSERT INTO `school_recruit` VALUES ('188969', '443', '2012', '2', '1', '13', '545', '567', '539');
INSERT INTO `school_recruit` VALUES ('188970', '443', '2011', '2', '1', '13', '499', '524', '0');
INSERT INTO `school_recruit` VALUES ('188971', '443', '2010', '2', '1', '13', '490', '513', '0');
INSERT INTO `school_recruit` VALUES ('188976', '443', '2013', '1', '2', '13', '519', '519', '517');
INSERT INTO `school_recruit` VALUES ('188977', '443', '2013', '2', '2', '13', '477', '510', '456');
INSERT INTO `school_recruit` VALUES ('188978', '443', '2012', '2', '2', '13', '506', '539', '499');
INSERT INTO `school_recruit` VALUES ('188979', '443', '2011', '2', '2', '13', '487', '521', '0');
INSERT INTO `school_recruit` VALUES ('188980', '443', '2010', '2', '2', '13', '471', '507', '0');
INSERT INTO `school_recruit` VALUES ('189167', '444', '2013', '5', '1', '34', '303', '606', '0');
INSERT INTO `school_recruit` VALUES ('189168', '444', '2010', '5', '1', '34', '565', '604', '0');
INSERT INTO `school_recruit` VALUES ('189174', '444', '2013', '5', '2', '34', '317', '635', '0');
INSERT INTO `school_recruit` VALUES ('189175', '444', '2010', '5', '2', '34', '572', '618', '0');
INSERT INTO `school_recruit` VALUES ('189206', '444', '2010', '5', '1', '3', '474', '491', '0');
INSERT INTO `school_recruit` VALUES ('189212', '444', '2010', '5', '2', '3', '478', '495', '0');
INSERT INTO `school_recruit` VALUES ('189282', '444', '2010', '5', '1', '10', '630', '650', '0');
INSERT INTO `school_recruit` VALUES ('189288', '444', '2010', '5', '2', '10', '618', '623', '0');
INSERT INTO `school_recruit` VALUES ('189310', '444', '2010', '5', '1', '13', '547', '575', '0');
INSERT INTO `school_recruit` VALUES ('189316', '444', '2010', '5', '2', '13', '572', '586', '0');
INSERT INTO `school_recruit` VALUES ('190167', '447', '2012', '2', '2', '34', '477', '477', '0');
INSERT INTO `school_recruit` VALUES ('190168', '447', '2010', '2', '2', '34', '463', '466', '0');
INSERT INTO `school_recruit` VALUES ('190201', '447', '2012', '2', '1', '3', '382', '384', '0');
INSERT INTO `school_recruit` VALUES ('190202', '447', '2011', '2', '1', '3', '416', '418', '0');
INSERT INTO `school_recruit` VALUES ('190207', '447', '2012', '2', '2', '3', '369', '381', '0');
INSERT INTO `school_recruit` VALUES ('190208', '447', '2011', '2', '2', '3', '393', '393', '0');
INSERT INTO `school_recruit` VALUES ('190209', '447', '2010', '2', '2', '3', '406', '413', '0');
INSERT INTO `school_recruit` VALUES ('190303', '447', '2010', '2', '1', '10', '511', '538', '0');
INSERT INTO `school_recruit` VALUES ('190312', '447', '2010', '2', '2', '10', '463', '487', '0');
INSERT INTO `school_recruit` VALUES ('190354', '447', '2013', '1', '1', '13', '542', '542', '532');
INSERT INTO `school_recruit` VALUES ('190355', '447', '2012', '1', '1', '13', '572', '574', '570');
INSERT INTO `school_recruit` VALUES ('190356', '447', '2013', '2', '1', '13', '498', '513', '494');
INSERT INTO `school_recruit` VALUES ('190357', '447', '2012', '2', '1', '13', '536', '565', '531');
INSERT INTO `school_recruit` VALUES ('190358', '447', '2011', '2', '1', '13', '493', '527', '488');
INSERT INTO `school_recruit` VALUES ('190359', '447', '2010', '2', '1', '13', '486', '519', '0');
INSERT INTO `school_recruit` VALUES ('190365', '447', '2012', '1', '2', '13', '557', '574', '547');
INSERT INTO `school_recruit` VALUES ('190366', '447', '2013', '2', '2', '13', '470', '492', '466');
INSERT INTO `school_recruit` VALUES ('190367', '447', '2012', '2', '2', '13', '497', '536', '491');
INSERT INTO `school_recruit` VALUES ('190368', '447', '2011', '2', '2', '13', '483', '562', '476');
INSERT INTO `school_recruit` VALUES ('190369', '447', '2010', '2', '2', '13', '470', '516', '0');
INSERT INTO `school_recruit` VALUES ('191487', '450', '2010', '2', '1', '10', '520', '546', '0');
INSERT INTO `school_recruit` VALUES ('191492', '450', '2010', '2', '2', '10', '473', '519', '0');
INSERT INTO `school_recruit` VALUES ('193033', '455', '2013', '1', '2', '34', '562', '574', '0');
INSERT INTO `school_recruit` VALUES ('193034', '455', '2011', '1', '2', '34', '505', '530', '0');
INSERT INTO `school_recruit` VALUES ('193035', '455', '2010', '1', '2', '34', '518', '560', '0');
INSERT INTO `school_recruit` VALUES ('193053', '455', '2011', '1', '2', '3', '467', '478', '0');
INSERT INTO `school_recruit` VALUES ('193054', '455', '2010', '1', '2', '3', '472', '479', '0');
INSERT INTO `school_recruit` VALUES ('193058', '455', '2013', '2', '2', '3', '360', '389', '0');
INSERT INTO `school_recruit` VALUES ('193059', '455', '2011', '2', '2', '3', '428', '453', '0');
INSERT INTO `school_recruit` VALUES ('193060', '455', '2010', '2', '2', '3', '437', '466', '0');
INSERT INTO `school_recruit` VALUES ('193084', '455', '2010', '1', '1', '10', '605', '619', '0');
INSERT INTO `school_recruit` VALUES ('193087', '455', '2010', '2', '1', '10', '523', '554', '0');
INSERT INTO `school_recruit` VALUES ('193091', '455', '2010', '1', '2', '10', '589', '631', '0');
INSERT INTO `school_recruit` VALUES ('193096', '455', '2010', '2', '2', '10', '496', '530', '0');
INSERT INTO `school_recruit` VALUES ('193119', '455', '2013', '1', '2', '13', '563', '576', '559');
INSERT INTO `school_recruit` VALUES ('193120', '455', '2011', '1', '2', '13', '569', '583', '0');
INSERT INTO `school_recruit` VALUES ('193121', '455', '2010', '1', '2', '13', '550', '558', '0');
INSERT INTO `school_recruit` VALUES ('193126', '455', '2013', '2', '2', '13', '511', '517', '507');
INSERT INTO `school_recruit` VALUES ('193127', '455', '2011', '2', '2', '13', '521', '537', '0');
INSERT INTO `school_recruit` VALUES ('193128', '455', '2010', '2', '2', '13', '502', '511', '0');
INSERT INTO `school_recruit` VALUES ('193872', '458', '2013', '2', '1', '34', '505', '517', '0');
INSERT INTO `school_recruit` VALUES ('193873', '458', '2012', '2', '1', '34', '468', '510', '0');
INSERT INTO `school_recruit` VALUES ('193874', '458', '2011', '2', '1', '34', '498', '534', '0');
INSERT INTO `school_recruit` VALUES ('193875', '458', '2010', '2', '1', '34', '493', '526', '0');
INSERT INTO `school_recruit` VALUES ('193881', '458', '2013', '2', '2', '34', '514', '523', '0');
INSERT INTO `school_recruit` VALUES ('193882', '458', '2012', '2', '2', '34', '452', '572', '0');
INSERT INTO `school_recruit` VALUES ('193883', '458', '2011', '2', '2', '34', '457', '551', '0');
INSERT INTO `school_recruit` VALUES ('193884', '458', '2010', '2', '2', '34', '468', '528', '0');
INSERT INTO `school_recruit` VALUES ('193913', '458', '2013', '2', '2', '3', '349', '367', '0');
INSERT INTO `school_recruit` VALUES ('193914', '458', '2012', '2', '2', '3', '385', '394', '0');
INSERT INTO `school_recruit` VALUES ('193915', '458', '2011', '2', '2', '3', '430', '450', '0');
INSERT INTO `school_recruit` VALUES ('193916', '458', '2010', '2', '2', '3', '419', '450', '0');
INSERT INTO `school_recruit` VALUES ('194002', '458', '2010', '2', '2', '10', '493', '499', '0');
INSERT INTO `school_recruit` VALUES ('194034', '458', '2013', '2', '1', '13', '527', '529', '524');
INSERT INTO `school_recruit` VALUES ('194035', '458', '2012', '2', '1', '13', '566', '571', '564');
INSERT INTO `school_recruit` VALUES ('194036', '458', '2011', '2', '1', '13', '523', '526', '522');
INSERT INTO `school_recruit` VALUES ('194037', '458', '2010', '2', '1', '13', '514', '520', '0');
INSERT INTO `school_recruit` VALUES ('194043', '458', '2013', '2', '2', '13', '510', '518', '498');
INSERT INTO `school_recruit` VALUES ('194044', '458', '2012', '2', '2', '13', '544', '584', '538');
INSERT INTO `school_recruit` VALUES ('194045', '458', '2011', '2', '2', '13', '527', '537', '524');
INSERT INTO `school_recruit` VALUES ('194046', '458', '2010', '2', '2', '13', '514', '528', '0');
INSERT INTO `school_recruit` VALUES ('198637', '473', '2012', '2', '1', '34', '462', '486', '0');
INSERT INTO `school_recruit` VALUES ('198638', '473', '2010', '2', '1', '34', '487', '487', '0');
INSERT INTO `school_recruit` VALUES ('198639', '473', '2012', '2', '2', '34', '446', '453', '0');
INSERT INTO `school_recruit` VALUES ('198640', '473', '2011', '2', '2', '34', '436', '437', '0');
INSERT INTO `school_recruit` VALUES ('198657', '473', '2013', '2', '1', '3', '416', '430', '0');
INSERT INTO `school_recruit` VALUES ('198658', '473', '2012', '2', '1', '3', '412', '427', '0');
INSERT INTO `school_recruit` VALUES ('198659', '473', '2011', '2', '1', '3', '433', '445', '0');
INSERT INTO `school_recruit` VALUES ('198660', '473', '2010', '2', '1', '3', '426', '445', '0');
INSERT INTO `school_recruit` VALUES ('198665', '473', '2013', '2', '2', '3', '349', '367', '0');
INSERT INTO `school_recruit` VALUES ('198666', '473', '2012', '2', '2', '3', '384', '415', '0');
INSERT INTO `school_recruit` VALUES ('198667', '473', '2011', '2', '2', '3', '416', '436', '0');
INSERT INTO `school_recruit` VALUES ('198668', '473', '2010', '2', '2', '3', '420', '459', '0');
INSERT INTO `school_recruit` VALUES ('198744', '473', '2010', '2', '1', '10', '529', '534', '0');
INSERT INTO `school_recruit` VALUES ('198749', '473', '2010', '2', '2', '10', '486', '491', '0');
INSERT INTO `school_recruit` VALUES ('198786', '473', '2013', '2', '1', '13', '527', '530', '523');
INSERT INTO `school_recruit` VALUES ('198787', '473', '2012', '2', '1', '13', '562', '568', '558');
INSERT INTO `school_recruit` VALUES ('198788', '473', '2011', '2', '1', '13', '524', '527', '521');
INSERT INTO `school_recruit` VALUES ('198789', '473', '2010', '2', '1', '13', '507', '518', '0');
INSERT INTO `school_recruit` VALUES ('198794', '473', '2013', '2', '2', '13', '507', '517', '503');
INSERT INTO `school_recruit` VALUES ('198795', '473', '2012', '2', '2', '13', '537', '555', '532');
INSERT INTO `school_recruit` VALUES ('198796', '473', '2011', '2', '2', '13', '521', '531', '517');
INSERT INTO `school_recruit` VALUES ('198797', '473', '2010', '2', '2', '13', '505', '522', '0');
INSERT INTO `school_recruit` VALUES ('199280', '475', '2013', '1', '1', '34', '558', '567', '0');
INSERT INTO `school_recruit` VALUES ('199281', '475', '2012', '1', '1', '34', '528', '549', '0');
INSERT INTO `school_recruit` VALUES ('199282', '475', '2011', '1', '1', '34', '546', '580', '0');
INSERT INTO `school_recruit` VALUES ('199283', '475', '2010', '1', '1', '34', '540', '571', '0');
INSERT INTO `school_recruit` VALUES ('199288', '475', '2013', '1', '2', '34', '571', '592', '0');
INSERT INTO `school_recruit` VALUES ('199289', '475', '2012', '1', '2', '34', '546', '605', '0');
INSERT INTO `school_recruit` VALUES ('199290', '475', '2011', '1', '2', '34', '543', '600', '0');
INSERT INTO `school_recruit` VALUES ('199291', '475', '2010', '1', '2', '34', '556', '627', '0');
INSERT INTO `school_recruit` VALUES ('199327', '475', '2011', '1', '1', '3', '468', '468', '0');
INSERT INTO `school_recruit` VALUES ('199328', '475', '2010', '1', '1', '3', '473', '473', '0');
INSERT INTO `school_recruit` VALUES ('199330', '475', '2013', '1', '2', '3', '414', '423', '0');
INSERT INTO `school_recruit` VALUES ('199331', '475', '2012', '1', '2', '3', '433', '445', '0');
INSERT INTO `school_recruit` VALUES ('199332', '475', '2011', '1', '2', '3', '469', '484', '0');
INSERT INTO `school_recruit` VALUES ('199333', '475', '2010', '1', '2', '3', '478', '478', '0');
INSERT INTO `school_recruit` VALUES ('199429', '475', '2010', '1', '1', '10', '618', '623', '0');
INSERT INTO `school_recruit` VALUES ('199434', '475', '2010', '1', '2', '10', '588', '613', '0');
INSERT INTO `school_recruit` VALUES ('199470', '475', '2012', '1', '1', '13', '588', '596', '0');
INSERT INTO `school_recruit` VALUES ('199471', '475', '2011', '1', '1', '13', '562', '566', '0');
INSERT INTO `school_recruit` VALUES ('199472', '475', '2010', '1', '1', '13', '544', '548', '0');
INSERT INTO `school_recruit` VALUES ('199477', '475', '2013', '1', '2', '13', '538', '560', '0');
INSERT INTO `school_recruit` VALUES ('199478', '475', '2012', '1', '2', '13', '585', '595', '0');
INSERT INTO `school_recruit` VALUES ('199479', '475', '2011', '1', '2', '13', '566', '585', '0');
INSERT INTO `school_recruit` VALUES ('199480', '475', '2010', '1', '2', '13', '550', '568', '0');
INSERT INTO `school_recruit` VALUES ('200462', '479', '2010', '5', '1', '34', '611', '641', '0');
INSERT INTO `school_recruit` VALUES ('200467', '479', '2010', '5', '2', '34', '634', '660', '0');
INSERT INTO `school_recruit` VALUES ('200491', '479', '2010', '5', '1', '3', '530', '538', '0');
INSERT INTO `school_recruit` VALUES ('200496', '479', '2010', '5', '2', '3', '536', '546', '0');
INSERT INTO `school_recruit` VALUES ('200540', '479', '2010', '5', '1', '10', '665', '667', '0');
INSERT INTO `school_recruit` VALUES ('200545', '479', '2010', '5', '2', '10', '658', '668', '0');
INSERT INTO `school_recruit` VALUES ('200562', '479', '2010', '5', '1', '13', '577', '583', '0');
INSERT INTO `school_recruit` VALUES ('200565', '479', '2010', '5', '2', '13', '609', '610', '0');
INSERT INTO `school_recruit` VALUES ('201634', '483', '2010', '3', '2', '34', '401', '401', '0');
INSERT INTO `school_recruit` VALUES ('201665', '483', '2010', '2', '1', '10', '502', '537', '0');
INSERT INTO `school_recruit` VALUES ('201670', '483', '2010', '2', '2', '10', '451', '499', '0');
INSERT INTO `school_recruit` VALUES ('201702', '483', '2013', '3', '1', '13', '461', '470', '456');
INSERT INTO `school_recruit` VALUES ('201703', '483', '2012', '3', '1', '13', '501', '527', '482');
INSERT INTO `school_recruit` VALUES ('201704', '483', '2011', '3', '1', '13', '479', '488', '475');
INSERT INTO `school_recruit` VALUES ('201705', '483', '2010', '3', '1', '13', '467', '475', '0');
INSERT INTO `school_recruit` VALUES ('201708', '483', '2013', '3', '2', '13', '439', '446', '434');
INSERT INTO `school_recruit` VALUES ('201709', '483', '2012', '3', '2', '13', '468', '473', '465');
INSERT INTO `school_recruit` VALUES ('201710', '483', '2011', '3', '2', '13', '456', '461', '452');
INSERT INTO `school_recruit` VALUES ('201711', '483', '2010', '3', '2', '13', '453', '466', '0');
INSERT INTO `school_recruit` VALUES ('207701', '503', '2010', '2', '1', '10', '523', '544', '0');
INSERT INTO `school_recruit` VALUES ('207705', '503', '2010', '2', '2', '10', '480', '512', '0');
INSERT INTO `school_recruit` VALUES ('207735', '503', '2013', '2', '1', '13', '521', '527', '518');
INSERT INTO `school_recruit` VALUES ('207736', '503', '2012', '2', '1', '13', '560', '568', '552');
INSERT INTO `school_recruit` VALUES ('207737', '503', '2011', '2', '1', '13', '522', '529', '519');
INSERT INTO `school_recruit` VALUES ('207738', '503', '2010', '2', '1', '13', '504', '514', '0');
INSERT INTO `school_recruit` VALUES ('207741', '503', '2013', '2', '2', '13', '511', '545', '507');
INSERT INTO `school_recruit` VALUES ('207742', '503', '2012', '2', '2', '13', '539', '546', '535');
INSERT INTO `school_recruit` VALUES ('207743', '503', '2011', '2', '2', '13', '522', '538', '518');
INSERT INTO `school_recruit` VALUES ('207744', '503', '2010', '2', '2', '13', '508', '514', '0');
INSERT INTO `school_recruit` VALUES ('208629', '506', '2013', '2', '2', '3', '335', '339', '0');
INSERT INTO `school_recruit` VALUES ('208681', '506', '2010', '2', '1', '10', '523', '537', '0');
INSERT INTO `school_recruit` VALUES ('208686', '506', '2010', '1', '2', '10', '556', '590', '0');
INSERT INTO `school_recruit` VALUES ('208687', '506', '2010', '2', '2', '10', '478', '500', '0');
INSERT INTO `school_recruit` VALUES ('208692', '506', '2010', '5', '2', '10', '513', '544', '0');
INSERT INTO `school_recruit` VALUES ('208731', '506', '2013', '2', '1', '13', '522', '527', '520');
INSERT INTO `school_recruit` VALUES ('208732', '506', '2012', '2', '1', '13', '559', '562', '552');
INSERT INTO `school_recruit` VALUES ('208733', '506', '2011', '2', '1', '13', '522', '525', '520');
INSERT INTO `school_recruit` VALUES ('208734', '506', '2010', '2', '1', '13', '512', '515', '0');
INSERT INTO `school_recruit` VALUES ('208739', '506', '2013', '1', '2', '13', '523', '536', '518');
INSERT INTO `school_recruit` VALUES ('208740', '506', '2012', '1', '2', '13', '558', '575', '547');
INSERT INTO `school_recruit` VALUES ('208741', '506', '2013', '2', '2', '13', '503', '512', '500');
INSERT INTO `school_recruit` VALUES ('208742', '506', '2012', '2', '2', '13', '531', '545', '525');
INSERT INTO `school_recruit` VALUES ('208743', '506', '2011', '2', '2', '13', '517', '529', '514');
INSERT INTO `school_recruit` VALUES ('208744', '506', '2010', '2', '2', '13', '498', '507', '0');
INSERT INTO `school_recruit` VALUES ('208749', '506', '2010', '5', '2', '13', '495', '526', '0');
INSERT INTO `school_recruit` VALUES ('209922', '510', '2013', '2', '1', '34', '519', '578', '0');
INSERT INTO `school_recruit` VALUES ('209923', '510', '2012', '2', '1', '34', '474', '504', '0');
INSERT INTO `school_recruit` VALUES ('209924', '510', '2011', '2', '1', '34', '502', '544', '0');
INSERT INTO `school_recruit` VALUES ('209925', '510', '2010', '2', '1', '34', '498', '523', '0');
INSERT INTO `school_recruit` VALUES ('209931', '510', '2013', '2', '2', '34', '526', '658', '0');
INSERT INTO `school_recruit` VALUES ('209932', '510', '2012', '2', '2', '34', '455', '578', '0');
INSERT INTO `school_recruit` VALUES ('209933', '510', '2011', '2', '2', '34', '457', '560', '0');
INSERT INTO `school_recruit` VALUES ('209934', '510', '2010', '2', '2', '34', '470', '570', '0');
INSERT INTO `school_recruit` VALUES ('209991', '510', '2010', '2', '2', '10', '479', '509', '0');
INSERT INTO `school_recruit` VALUES ('210057', '511', '2013', '5', '1', '34', '0', '598', '0');
INSERT INTO `school_recruit` VALUES ('210058', '511', '2010', '5', '1', '34', '574', '633', '0');
INSERT INTO `school_recruit` VALUES ('210064', '511', '2013', '5', '2', '34', '0', '637', '0');
INSERT INTO `school_recruit` VALUES ('210065', '511', '2010', '5', '2', '34', '605', '633', '0');
INSERT INTO `school_recruit` VALUES ('210095', '511', '2010', '5', '1', '3', '493', '522', '0');
INSERT INTO `school_recruit` VALUES ('210101', '511', '2010', '5', '2', '3', '495', '522', '0');
INSERT INTO `school_recruit` VALUES ('210154', '511', '2010', '5', '1', '10', '633', '659', '0');
INSERT INTO `school_recruit` VALUES ('210160', '511', '2010', '5', '2', '10', '614', '631', '0');
INSERT INTO `school_recruit` VALUES ('210176', '511', '2010', '5', '1', '13', '549', '565', '0');
INSERT INTO `school_recruit` VALUES ('210181', '511', '2010', '5', '2', '13', '569', '581', '0');
INSERT INTO `school_recruit` VALUES ('210933', '514', '2012', '1', '2', '34', '637', '671', '0');
INSERT INTO `school_recruit` VALUES ('210934', '514', '2011', '1', '2', '34', '632', '689', '0');
INSERT INTO `school_recruit` VALUES ('210935', '514', '2010', '1', '2', '34', '636', '674', '0');
INSERT INTO `school_recruit` VALUES ('210940', '514', '2012', '2', '2', '34', '606', '641', '0');
INSERT INTO `school_recruit` VALUES ('210941', '514', '2011', '2', '2', '34', '582', '616', '0');
INSERT INTO `school_recruit` VALUES ('210942', '514', '2010', '2', '2', '34', '594', '636', '0');
INSERT INTO `school_recruit` VALUES ('211011', '514', '2010', '1', '2', '10', '657', '683', '0');
INSERT INTO `school_recruit` VALUES ('211027', '514', '2013', '1', '2', '13', '653', '662', '651');
INSERT INTO `school_recruit` VALUES ('211028', '514', '2012', '1', '2', '13', '667', '674', '664');
INSERT INTO `school_recruit` VALUES ('211029', '514', '2011', '1', '2', '13', '654', '679', '650');
INSERT INTO `school_recruit` VALUES ('211030', '514', '2010', '1', '2', '13', '633', '639', '631');
INSERT INTO `school_recruit` VALUES ('211615', '517', '2013', '1', '1', '34', '570', '591', '0');
INSERT INTO `school_recruit` VALUES ('211616', '517', '2012', '1', '1', '34', '553', '573', '0');
INSERT INTO `school_recruit` VALUES ('211617', '517', '2011', '1', '1', '34', '580', '622', '0');
INSERT INTO `school_recruit` VALUES ('211618', '517', '2010', '1', '1', '34', '588', '626', '0');
INSERT INTO `school_recruit` VALUES ('211619', '517', '2013', '1', '2', '34', '594', '638', '0');
INSERT INTO `school_recruit` VALUES ('211620', '517', '2012', '1', '2', '34', '582', '616', '0');
INSERT INTO `school_recruit` VALUES ('211621', '517', '2011', '1', '2', '34', '567', '623', '0');
INSERT INTO `school_recruit` VALUES ('211622', '517', '2010', '1', '2', '34', '580', '622', '0');
INSERT INTO `school_recruit` VALUES ('211651', '517', '2013', '1', '1', '3', '451', '454', '0');
INSERT INTO `school_recruit` VALUES ('211652', '517', '2011', '1', '1', '3', '479', '500', '0');
INSERT INTO `school_recruit` VALUES ('211653', '517', '2010', '1', '1', '3', '485', '490', '0');
INSERT INTO `school_recruit` VALUES ('211658', '517', '2013', '1', '2', '3', '416', '428', '0');
INSERT INTO `school_recruit` VALUES ('211659', '517', '2012', '1', '2', '3', '441', '474', '0');
INSERT INTO `school_recruit` VALUES ('211660', '517', '2011', '1', '2', '3', '474', '492', '0');
INSERT INTO `school_recruit` VALUES ('211661', '517', '2010', '1', '2', '3', '478', '497', '0');
INSERT INTO `school_recruit` VALUES ('211754', '517', '2010', '1', '1', '10', '607', '634', '0');
INSERT INTO `school_recruit` VALUES ('211759', '517', '2010', '5', '1', '10', '605', '652', '0');
INSERT INTO `school_recruit` VALUES ('211763', '517', '2010', '1', '2', '10', '574', '632', '0');
INSERT INTO `school_recruit` VALUES ('211768', '517', '2010', '5', '2', '10', '570', '627', '0');
INSERT INTO `school_recruit` VALUES ('211799', '517', '2013', '1', '1', '13', '549', '555', '547');
INSERT INTO `school_recruit` VALUES ('211800', '517', '2012', '1', '1', '13', '581', '593', '577');
INSERT INTO `school_recruit` VALUES ('211801', '517', '2011', '1', '1', '13', '551', '564', '544');
INSERT INTO `school_recruit` VALUES ('211802', '517', '2010', '1', '1', '13', '531', '549', '529');
INSERT INTO `school_recruit` VALUES ('211805', '517', '2013', '1', '2', '13', '532', '551', '517');
INSERT INTO `school_recruit` VALUES ('211806', '517', '2012', '1', '2', '13', '570', '609', '557');
INSERT INTO `school_recruit` VALUES ('211807', '517', '2011', '1', '2', '13', '550', '577', '538');
INSERT INTO `school_recruit` VALUES ('211808', '517', '2010', '1', '2', '13', '528', '549', '515');
INSERT INTO `school_recruit` VALUES ('213384', '523', '2013', '1', '1', '34', '562', '575', '0');
INSERT INTO `school_recruit` VALUES ('213385', '523', '2012', '1', '1', '34', '520', '607', '0');
INSERT INTO `school_recruit` VALUES ('213386', '523', '2011', '1', '1', '34', '548', '611', '0');
INSERT INTO `school_recruit` VALUES ('213387', '523', '2010', '1', '1', '34', '550', '631', '0');
INSERT INTO `school_recruit` VALUES ('213392', '523', '2013', '1', '2', '34', '563', '577', '0');
INSERT INTO `school_recruit` VALUES ('213393', '523', '2012', '1', '2', '34', '516', '619', '0');
INSERT INTO `school_recruit` VALUES ('213394', '523', '2011', '1', '2', '34', '526', '642', '0');
INSERT INTO `school_recruit` VALUES ('213395', '523', '2010', '1', '2', '34', '542', '612', '0');
INSERT INTO `school_recruit` VALUES ('213432', '523', '2013', '1', '1', '3', '462', '476', '0');
INSERT INTO `school_recruit` VALUES ('213433', '523', '2012', '1', '1', '3', '471', '478', '0');
INSERT INTO `school_recruit` VALUES ('213434', '523', '2011', '1', '1', '3', '501', '506', '0');
INSERT INTO `school_recruit` VALUES ('213435', '523', '2010', '1', '1', '3', '488', '491', '0');
INSERT INTO `school_recruit` VALUES ('213440', '523', '2010', '5', '1', '3', '482', '485', '0');
INSERT INTO `school_recruit` VALUES ('213441', '523', '2013', '1', '2', '3', '421', '438', '0');
INSERT INTO `school_recruit` VALUES ('213442', '523', '2012', '1', '2', '3', '449', '467', '0');
INSERT INTO `school_recruit` VALUES ('213443', '523', '2011', '1', '2', '3', '493', '504', '0');
INSERT INTO `school_recruit` VALUES ('213444', '523', '2010', '1', '2', '3', '486', '492', '0');
INSERT INTO `school_recruit` VALUES ('213548', '523', '2010', '1', '1', '10', '638', '641', '0');
INSERT INTO `school_recruit` VALUES ('213553', '523', '2010', '5', '1', '10', '610', '630', '0');
INSERT INTO `school_recruit` VALUES ('213554', '523', '2010', '1', '2', '10', '618', '628', '0');
INSERT INTO `school_recruit` VALUES ('213559', '523', '2010', '5', '2', '10', '579', '611', '0');
INSERT INTO `school_recruit` VALUES ('213592', '523', '2013', '1', '1', '13', '571', '581', '565');
INSERT INTO `school_recruit` VALUES ('213593', '523', '2012', '1', '1', '13', '607', '622', '599');
INSERT INTO `school_recruit` VALUES ('213594', '523', '2011', '1', '1', '13', '572', '580', '568');
INSERT INTO `school_recruit` VALUES ('213595', '523', '2010', '1', '1', '13', '558', '564', '555');
INSERT INTO `school_recruit` VALUES ('213599', '523', '2010', '5', '1', '13', '521', '521', '0');
INSERT INTO `school_recruit` VALUES ('213600', '523', '2013', '1', '2', '13', '575', '589', '567');
INSERT INTO `school_recruit` VALUES ('213601', '523', '2012', '1', '2', '13', '597', '611', '591');
INSERT INTO `school_recruit` VALUES ('213602', '523', '2011', '1', '2', '13', '577', '586', '571');
INSERT INTO `school_recruit` VALUES ('213603', '523', '2010', '1', '2', '13', '561', '579', '552');
INSERT INTO `school_recruit` VALUES ('213608', '523', '2010', '5', '2', '13', '517', '517', '0');
INSERT INTO `school_recruit` VALUES ('215862', '531', '2010', '4', '1', '10', '351', '424', '0');
INSERT INTO `school_recruit` VALUES ('215863', '531', '2010', '4', '2', '10', '265', '282', '0');
INSERT INTO `school_recruit` VALUES ('215868', '531', '2010', '4', '1', '13', '237', '254', '0');
INSERT INTO `school_recruit` VALUES ('215869', '531', '2010', '4', '2', '13', '276', '286', '0');
INSERT INTO `school_recruit` VALUES ('218109', '539', '2013', '2', '1', '34', '496', '499', '0');
INSERT INTO `school_recruit` VALUES ('218110', '539', '2011', '2', '1', '34', '501', '516', '0');
INSERT INTO `school_recruit` VALUES ('218111', '539', '2010', '2', '1', '34', '492', '512', '0');
INSERT INTO `school_recruit` VALUES ('218116', '539', '2011', '2', '2', '34', '456', '478', '0');
INSERT INTO `school_recruit` VALUES ('218117', '539', '2010', '2', '2', '34', '484', '522', '0');
INSERT INTO `school_recruit` VALUES ('218151', '539', '2013', '2', '1', '3', '412', '421', '0');
INSERT INTO `school_recruit` VALUES ('218152', '539', '2011', '2', '1', '3', '423', '437', '0');
INSERT INTO `school_recruit` VALUES ('218153', '539', '2010', '2', '1', '3', '422', '430', '0');
INSERT INTO `school_recruit` VALUES ('218159', '539', '2013', '2', '2', '3', '340', '349', '0');
INSERT INTO `school_recruit` VALUES ('218160', '539', '2011', '2', '2', '3', '402', '413', '0');
INSERT INTO `school_recruit` VALUES ('218161', '539', '2010', '2', '2', '3', '409', '424', '0');
INSERT INTO `school_recruit` VALUES ('218235', '539', '2010', '2', '1', '10', '528', '547', '0');
INSERT INTO `school_recruit` VALUES ('218240', '539', '2010', '2', '2', '10', '477', '505', '0');
INSERT INTO `school_recruit` VALUES ('218273', '539', '2013', '2', '1', '13', '509', '530', '484');
INSERT INTO `school_recruit` VALUES ('218274', '539', '2011', '2', '1', '13', '509', '533', '0');
INSERT INTO `school_recruit` VALUES ('218275', '539', '2010', '2', '1', '13', '501', '515', '0');
INSERT INTO `school_recruit` VALUES ('218280', '539', '2013', '2', '2', '13', '481', '527', '456');
INSERT INTO `school_recruit` VALUES ('218281', '539', '2011', '2', '2', '13', '499', '534', '0');
INSERT INTO `school_recruit` VALUES ('218282', '539', '2010', '2', '2', '13', '485', '518', '0');
INSERT INTO `school_recruit` VALUES ('218667', '541', '2013', '3', '1', '34', '454', '455', '0');
INSERT INTO `school_recruit` VALUES ('218668', '541', '2012', '3', '1', '34', '426', '439', '0');
INSERT INTO `school_recruit` VALUES ('218669', '541', '2011', '3', '1', '34', '459', '497', '0');
INSERT INTO `school_recruit` VALUES ('218670', '541', '2010', '3', '1', '34', '450', '466', '0');
INSERT INTO `school_recruit` VALUES ('218677', '541', '2013', '3', '2', '34', '477', '480', '0');
INSERT INTO `school_recruit` VALUES ('218678', '541', '2012', '3', '2', '34', '403', '403', '0');
INSERT INTO `school_recruit` VALUES ('218679', '541', '2011', '3', '2', '34', '409', '423', '0');
INSERT INTO `school_recruit` VALUES ('218680', '541', '2010', '3', '2', '34', '417', '477', '0');
INSERT INTO `school_recruit` VALUES ('218808', '541', '2010', '2', '1', '10', '468', '477', '0');
INSERT INTO `school_recruit` VALUES ('218814', '541', '2010', '2', '2', '10', '430', '439', '0');
INSERT INTO `school_recruit` VALUES ('218846', '541', '2013', '3', '1', '13', '445', '446', '447');
INSERT INTO `school_recruit` VALUES ('218847', '541', '2011', '3', '1', '13', '444', '471', '419');
INSERT INTO `school_recruit` VALUES ('218848', '541', '2010', '3', '1', '13', '435', '435', '0');
INSERT INTO `school_recruit` VALUES ('218854', '541', '2011', '3', '2', '13', '432', '460', '380');
INSERT INTO `school_recruit` VALUES ('218855', '541', '2010', '3', '2', '13', '448', '448', '0');
INSERT INTO `school_recruit` VALUES ('219740', '544', '2012', '2', '1', '3', '386', '395', '0');
INSERT INTO `school_recruit` VALUES ('219741', '544', '2010', '2', '1', '3', '416', '416', '0');
INSERT INTO `school_recruit` VALUES ('219743', '544', '2013', '2', '2', '3', '332', '333', '0');
INSERT INTO `school_recruit` VALUES ('219744', '544', '2012', '2', '2', '3', '356', '375', '0');
INSERT INTO `school_recruit` VALUES ('219745', '544', '2011', '2', '2', '3', '397', '408', '0');
INSERT INTO `school_recruit` VALUES ('219746', '544', '2010', '2', '2', '3', '413', '425', '0');
INSERT INTO `school_recruit` VALUES ('219807', '544', '2010', '2', '1', '10', '508', '515', '0');
INSERT INTO `school_recruit` VALUES ('219812', '544', '2010', '2', '2', '10', '484', '516', '0');
INSERT INTO `school_recruit` VALUES ('219847', '544', '2013', '2', '1', '13', '489', '510', '484');
INSERT INTO `school_recruit` VALUES ('219848', '544', '2012', '2', '1', '13', '528', '552', '523');
INSERT INTO `school_recruit` VALUES ('219849', '544', '2011', '2', '1', '13', '490', '510', '484');
INSERT INTO `school_recruit` VALUES ('219850', '544', '2010', '2', '1', '13', '487', '516', '0');
INSERT INTO `school_recruit` VALUES ('219856', '544', '2013', '2', '2', '13', '495', '531', '483');
INSERT INTO `school_recruit` VALUES ('219857', '544', '2012', '2', '2', '13', '521', '560', '508');
INSERT INTO `school_recruit` VALUES ('219858', '544', '2011', '2', '2', '13', '503', '533', '490');
INSERT INTO `school_recruit` VALUES ('219859', '544', '2010', '2', '2', '13', '489', '527', '0');
INSERT INTO `school_recruit` VALUES ('220789', '548', '2010', '2', '1', '10', '519', '544', '0');
INSERT INTO `school_recruit` VALUES ('220794', '548', '2010', '2', '2', '10', '470', '520', '0');
INSERT INTO `school_recruit` VALUES ('220832', '548', '2013', '2', '1', '13', '517', '519', '514');
INSERT INTO `school_recruit` VALUES ('220833', '548', '2012', '2', '1', '13', '551', '553', '549');
INSERT INTO `school_recruit` VALUES ('220834', '548', '2011', '2', '1', '13', '508', '513', '502');
INSERT INTO `school_recruit` VALUES ('220835', '548', '2010', '2', '1', '13', '501', '508', '0');
INSERT INTO `school_recruit` VALUES ('220840', '548', '2013', '2', '2', '13', '490', '506', '479');
INSERT INTO `school_recruit` VALUES ('220841', '548', '2012', '2', '2', '13', '522', '567', '509');
INSERT INTO `school_recruit` VALUES ('220842', '548', '2011', '2', '2', '13', '506', '514', '501');
INSERT INTO `school_recruit` VALUES ('220843', '548', '2010', '2', '2', '13', '489', '500', '0');
INSERT INTO `school_recruit` VALUES ('223907', '560', '2013', '2', '1', '3', '403', '403', '0');
INSERT INTO `school_recruit` VALUES ('223908', '560', '2012', '2', '1', '3', '405', '411', '0');
INSERT INTO `school_recruit` VALUES ('223909', '560', '2011', '2', '1', '3', '427', '427', '0');
INSERT INTO `school_recruit` VALUES ('223910', '560', '2010', '2', '1', '3', '407', '407', '0');
INSERT INTO `school_recruit` VALUES ('223916', '560', '2013', '2', '2', '3', '334', '338', '0');
INSERT INTO `school_recruit` VALUES ('223917', '560', '2012', '2', '2', '3', '363', '376', '0');
INSERT INTO `school_recruit` VALUES ('223918', '560', '2011', '2', '2', '3', '395', '398', '0');
INSERT INTO `school_recruit` VALUES ('223919', '560', '2010', '2', '2', '3', '405', '411', '0');
INSERT INTO `school_recruit` VALUES ('223988', '560', '2010', '2', '1', '10', '508', '514', '0');
INSERT INTO `school_recruit` VALUES ('223994', '560', '2010', '2', '2', '10', '456', '486', '0');
INSERT INTO `school_recruit` VALUES ('224035', '560', '2013', '2', '1', '13', '488', '531', '484');
INSERT INTO `school_recruit` VALUES ('224036', '560', '2012', '2', '1', '13', '528', '558', '523');
INSERT INTO `school_recruit` VALUES ('224037', '560', '2011', '2', '1', '13', '490', '515', '484');
INSERT INTO `school_recruit` VALUES ('224038', '560', '2010', '2', '1', '13', '488', '504', '0');
INSERT INTO `school_recruit` VALUES ('224045', '560', '2013', '1', '2', '13', '522', '524', '517');
INSERT INTO `school_recruit` VALUES ('224046', '560', '2012', '1', '2', '13', '555', '566', '547');
INSERT INTO `school_recruit` VALUES ('224047', '560', '2011', '1', '2', '13', '532', '533', '531');
INSERT INTO `school_recruit` VALUES ('224048', '560', '2013', '2', '2', '13', '461', '494', '456');
INSERT INTO `school_recruit` VALUES ('224049', '560', '2012', '2', '2', '13', '493', '531', '486');
INSERT INTO `school_recruit` VALUES ('224050', '560', '2011', '2', '2', '13', '481', '516', '474');
INSERT INTO `school_recruit` VALUES ('224051', '560', '2010', '2', '2', '13', '472', '519', '0');
INSERT INTO `school_recruit` VALUES ('225922', '566', '2010', '2', '1', '10', '530', '552', '0');
INSERT INTO `school_recruit` VALUES ('225929', '566', '2010', '2', '2', '10', '484', '543', '0');
INSERT INTO `school_recruit` VALUES ('225967', '566', '2013', '2', '1', '13', '523', '526', '521');
INSERT INTO `school_recruit` VALUES ('225968', '566', '2012', '2', '1', '13', '561', '564', '559');
INSERT INTO `school_recruit` VALUES ('225969', '566', '2011', '2', '1', '13', '517', '525', '514');
INSERT INTO `school_recruit` VALUES ('225970', '566', '2010', '2', '1', '13', '502', '508', '0');
INSERT INTO `school_recruit` VALUES ('225973', '566', '2013', '2', '2', '13', '488', '506', '478');
INSERT INTO `school_recruit` VALUES ('225974', '566', '2012', '2', '2', '13', '513', '546', '486');
INSERT INTO `school_recruit` VALUES ('225975', '566', '2011', '2', '2', '13', '514', '534', '508');
INSERT INTO `school_recruit` VALUES ('225976', '566', '2010', '2', '2', '13', '495', '506', '0');
INSERT INTO `school_recruit` VALUES ('227360', '571', '2013', '3', '1', '34', '455', '456', '0');
INSERT INTO `school_recruit` VALUES ('227361', '571', '2012', '3', '1', '34', '428', '444', '0');
INSERT INTO `school_recruit` VALUES ('227362', '571', '2011', '3', '1', '34', '456', '479', '0');
INSERT INTO `school_recruit` VALUES ('227363', '571', '2010', '3', '1', '34', '451', '510', '0');
INSERT INTO `school_recruit` VALUES ('227369', '571', '2013', '3', '2', '34', '475', '476', '0');
INSERT INTO `school_recruit` VALUES ('227370', '571', '2012', '3', '2', '34', '415', '452', '0');
INSERT INTO `school_recruit` VALUES ('227371', '571', '2011', '3', '2', '34', '411', '434', '0');
INSERT INTO `school_recruit` VALUES ('227372', '571', '2010', '3', '2', '34', '416', '451', '0');
INSERT INTO `school_recruit` VALUES ('227410', '571', '2013', '2', '1', '3', '410', '418', '0');
INSERT INTO `school_recruit` VALUES ('227411', '571', '2012', '2', '1', '3', '391', '403', '0');
INSERT INTO `school_recruit` VALUES ('227412', '571', '2011', '2', '1', '3', '412', '412', '0');
INSERT INTO `school_recruit` VALUES ('227413', '571', '2010', '2', '1', '3', '408', '408', '0');
INSERT INTO `school_recruit` VALUES ('227415', '571', '2013', '2', '2', '3', '336', '341', '0');
INSERT INTO `school_recruit` VALUES ('227416', '571', '2012', '2', '2', '3', '346', '350', '0');
INSERT INTO `school_recruit` VALUES ('227417', '571', '2011', '2', '2', '3', '404', '413', '0');
INSERT INTO `school_recruit` VALUES ('227418', '571', '2010', '2', '2', '3', '405', '405', '0');
INSERT INTO `school_recruit` VALUES ('227526', '571', '2010', '2', '1', '10', '505', '549', '0');
INSERT INTO `school_recruit` VALUES ('227532', '571', '2010', '2', '2', '10', '441', '478', '0');
INSERT INTO `school_recruit` VALUES ('227570', '571', '2013', '3', '1', '13', '465', '485', '463');
INSERT INTO `school_recruit` VALUES ('227571', '571', '2011', '3', '1', '13', '435', '470', '418');
INSERT INTO `school_recruit` VALUES ('227577', '571', '2013', '3', '2', '13', '442', '443', '435');
INSERT INTO `school_recruit` VALUES ('227578', '571', '2011', '3', '2', '13', '406', '469', '376');
INSERT INTO `school_recruit` VALUES ('229703', '581', '2013', '2', '1', '34', '510', '527', '0');
INSERT INTO `school_recruit` VALUES ('229704', '581', '2012', '2', '1', '34', '478', '520', '0');
INSERT INTO `school_recruit` VALUES ('229705', '581', '2011', '2', '1', '34', '510', '576', '0');
INSERT INTO `school_recruit` VALUES ('229706', '581', '2010', '2', '1', '34', '496', '549', '0');
INSERT INTO `school_recruit` VALUES ('229711', '581', '2013', '2', '2', '34', '513', '521', '0');
INSERT INTO `school_recruit` VALUES ('229712', '581', '2012', '2', '2', '34', '453', '573', '0');
INSERT INTO `school_recruit` VALUES ('229713', '581', '2011', '2', '2', '34', '456', '498', '0');
INSERT INTO `school_recruit` VALUES ('229714', '581', '2010', '2', '2', '34', '468', '540', '0');
INSERT INTO `school_recruit` VALUES ('229819', '581', '2010', '2', '1', '10', '532', '532', '0');
INSERT INTO `school_recruit` VALUES ('229824', '581', '2010', '2', '2', '10', '477', '498', '0');
INSERT INTO `school_recruit` VALUES ('229859', '581', '2013', '1', '1', '13', '533', '534', '532');
INSERT INTO `school_recruit` VALUES ('229860', '581', '2013', '2', '1', '13', '528', '530', '526');
INSERT INTO `school_recruit` VALUES ('229861', '581', '2012', '2', '1', '13', '541', '557', '530');
INSERT INTO `school_recruit` VALUES ('229862', '581', '2011', '2', '1', '13', '527', '527', '527');
INSERT INTO `school_recruit` VALUES ('229863', '581', '2010', '2', '1', '13', '501', '508', '0');
INSERT INTO `school_recruit` VALUES ('229868', '581', '2013', '1', '2', '13', '524', '540', '517');
INSERT INTO `school_recruit` VALUES ('229869', '581', '2013', '2', '2', '13', '504', '510', '497');
INSERT INTO `school_recruit` VALUES ('229870', '581', '2012', '2', '2', '13', '538', '546', '532');
INSERT INTO `school_recruit` VALUES ('229871', '581', '2011', '2', '2', '13', '527', '542', '521');
INSERT INTO `school_recruit` VALUES ('229872', '581', '2010', '2', '2', '13', '511', '517', '0');
INSERT INTO `school_recruit` VALUES ('230999', '586', '2013', '2', '1', '3', '410', '417', '0');
INSERT INTO `school_recruit` VALUES ('231000', '586', '2012', '2', '1', '3', '398', '429', '0');
INSERT INTO `school_recruit` VALUES ('231001', '586', '2011', '2', '1', '3', '423', '445', '0');
INSERT INTO `school_recruit` VALUES ('231002', '586', '2010', '2', '1', '3', '418', '449', '0');
INSERT INTO `school_recruit` VALUES ('231007', '586', '2013', '2', '2', '3', '343', '355', '0');
INSERT INTO `school_recruit` VALUES ('231008', '586', '2012', '2', '2', '3', '366', '411', '0');
INSERT INTO `school_recruit` VALUES ('231009', '586', '2011', '2', '2', '3', '405', '435', '0');
INSERT INTO `school_recruit` VALUES ('231010', '586', '2010', '2', '2', '3', '411', '449', '0');
INSERT INTO `school_recruit` VALUES ('231062', '586', '2010', '2', '1', '10', '480', '508', '0');
INSERT INTO `school_recruit` VALUES ('231067', '586', '2010', '2', '2', '10', '417', '485', '0');
INSERT INTO `school_recruit` VALUES ('231095', '586', '2013', '3', '1', '13', '465', '471', '461');
INSERT INTO `school_recruit` VALUES ('231096', '586', '2012', '3', '1', '13', '482', '512', '456');
INSERT INTO `school_recruit` VALUES ('231097', '586', '2011', '3', '1', '13', '456', '496', '442');
INSERT INTO `school_recruit` VALUES ('231098', '586', '2013', '3', '2', '13', '439', '488', '422');
INSERT INTO `school_recruit` VALUES ('231099', '586', '2012', '3', '2', '13', '414', '465', '379');
INSERT INTO `school_recruit` VALUES ('231100', '586', '2011', '3', '2', '13', '429', '462', '403');
INSERT INTO `school_recruit` VALUES ('233126', '594', '2012', '2', '1', '3', '388', '394', '0');
INSERT INTO `school_recruit` VALUES ('233127', '594', '2011', '2', '1', '3', '419', '421', '0');
INSERT INTO `school_recruit` VALUES ('233128', '594', '2010', '2', '1', '3', '413', '425', '0');
INSERT INTO `school_recruit` VALUES ('233132', '594', '2012', '2', '2', '3', '352', '357', '0');
INSERT INTO `school_recruit` VALUES ('233133', '594', '2011', '2', '2', '3', '394', '399', '0');
INSERT INTO `school_recruit` VALUES ('233134', '594', '2010', '2', '2', '3', '404', '408', '0');
INSERT INTO `school_recruit` VALUES ('233222', '594', '2010', '2', '1', '10', '511', '532', '0');
INSERT INTO `school_recruit` VALUES ('233228', '594', '2010', '2', '2', '10', '464', '497', '0');
INSERT INTO `school_recruit` VALUES ('233266', '594', '2013', '2', '1', '13', '488', '528', '484');
INSERT INTO `school_recruit` VALUES ('233267', '594', '2012', '2', '1', '13', '527', '553', '523');
INSERT INTO `school_recruit` VALUES ('233268', '594', '2011', '2', '1', '13', '489', '517', '484');
INSERT INTO `school_recruit` VALUES ('233269', '594', '2010', '2', '1', '13', '485', '506', '0');
INSERT INTO `school_recruit` VALUES ('233275', '594', '2013', '2', '2', '13', '460', '495', '456');
INSERT INTO `school_recruit` VALUES ('233276', '594', '2012', '2', '2', '13', '491', '528', '486');
INSERT INTO `school_recruit` VALUES ('233277', '594', '2011', '2', '2', '13', '480', '518', '474');
INSERT INTO `school_recruit` VALUES ('233278', '594', '2010', '2', '2', '13', '470', '515', '0');
INSERT INTO `school_recruit` VALUES ('234060', '598', '2012', '1', '2', '34', '620', '663', '0');
INSERT INTO `school_recruit` VALUES ('234061', '598', '2011', '1', '2', '34', '601', '625', '0');
INSERT INTO `school_recruit` VALUES ('234062', '598', '2010', '1', '2', '34', '628', '674', '0');
INSERT INTO `school_recruit` VALUES ('234078', '598', '2010', '5', '1', '3', '484', '509', '0');
INSERT INTO `school_recruit` VALUES ('234083', '598', '2012', '1', '2', '3', '483', '522', '0');
INSERT INTO `school_recruit` VALUES ('234084', '598', '2011', '1', '2', '3', '517', '548', '0');
INSERT INTO `school_recruit` VALUES ('234085', '598', '2010', '1', '2', '3', '505', '536', '0');
INSERT INTO `school_recruit` VALUES ('234090', '598', '2010', '5', '2', '3', '475', '487', '0');
INSERT INTO `school_recruit` VALUES ('234133', '598', '2010', '1', '2', '10', '625', '678', '0');
INSERT INTO `school_recruit` VALUES ('234153', '598', '2013', '1', '2', '13', '639', '653', '633');
INSERT INTO `school_recruit` VALUES ('234154', '598', '2012', '1', '2', '13', '653', '662', '649');
INSERT INTO `school_recruit` VALUES ('234155', '598', '2011', '1', '2', '13', '631', '642', '624');
INSERT INTO `school_recruit` VALUES ('234156', '598', '2010', '1', '2', '13', '613', '621', '605');
INSERT INTO `school_recruit` VALUES ('234560', '600', '2010', '2', '1', '10', '482', '512', '0');
INSERT INTO `school_recruit` VALUES ('234567', '600', '2010', '2', '2', '10', '426', '518', '0');
INSERT INTO `school_recruit` VALUES ('234604', '600', '2013', '2', '1', '13', '494', '501', '484');
INSERT INTO `school_recruit` VALUES ('234606', '600', '2013', '2', '2', '13', '470', '497', '456');
INSERT INTO `school_recruit` VALUES ('235973', '605', '2012', '2', '1', '3', '398', '404', '0');
INSERT INTO `school_recruit` VALUES ('235974', '605', '2011', '2', '1', '3', '420', '428', '0');
INSERT INTO `school_recruit` VALUES ('235975', '605', '2010', '2', '1', '3', '412', '418', '0');
INSERT INTO `school_recruit` VALUES ('235980', '605', '2013', '2', '2', '3', '335', '340', '0');
INSERT INTO `school_recruit` VALUES ('235981', '605', '2012', '2', '2', '3', '362', '374', '0');
INSERT INTO `school_recruit` VALUES ('235982', '605', '2011', '2', '2', '3', '403', '413', '0');
INSERT INTO `school_recruit` VALUES ('235983', '605', '2010', '2', '2', '3', '401', '403', '0');
INSERT INTO `school_recruit` VALUES ('236075', '605', '2010', '2', '1', '10', '511', '522', '0');
INSERT INTO `school_recruit` VALUES ('236084', '605', '2010', '2', '2', '10', '457', '475', '0');
INSERT INTO `school_recruit` VALUES ('236125', '605', '2013', '2', '1', '13', '501', '530', '495');
INSERT INTO `school_recruit` VALUES ('236126', '605', '2012', '2', '1', '13', '540', '565', '532');
INSERT INTO `school_recruit` VALUES ('236127', '605', '2011', '2', '1', '13', '503', '526', '496');
INSERT INTO `school_recruit` VALUES ('236128', '605', '2010', '2', '1', '13', '494', '517', '0');
INSERT INTO `school_recruit` VALUES ('236133', '605', '2013', '2', '2', '13', '469', '516', '462');
INSERT INTO `school_recruit` VALUES ('236134', '605', '2012', '2', '2', '13', '496', '540', '487');
INSERT INTO `school_recruit` VALUES ('236135', '605', '2011', '2', '2', '13', '485', '523', '476');
INSERT INTO `school_recruit` VALUES ('236136', '605', '2010', '2', '2', '13', '473', '555', '0');
INSERT INTO `school_recruit` VALUES ('237923', '613', '2013', '3', '1', '34', '460', '466', '0');
INSERT INTO `school_recruit` VALUES ('237924', '613', '2012', '3', '1', '34', '427', '457', '0');
INSERT INTO `school_recruit` VALUES ('237925', '613', '2011', '3', '1', '34', '458', '477', '0');
INSERT INTO `school_recruit` VALUES ('237926', '613', '2010', '3', '1', '34', '452', '486', '0');
INSERT INTO `school_recruit` VALUES ('237931', '613', '2013', '3', '2', '34', '478', '481', '0');
INSERT INTO `school_recruit` VALUES ('237932', '613', '2012', '3', '2', '34', '414', '440', '0');
INSERT INTO `school_recruit` VALUES ('237933', '613', '2011', '3', '2', '34', '412', '451', '0');
INSERT INTO `school_recruit` VALUES ('237934', '613', '2010', '3', '2', '34', '415', '454', '0');
INSERT INTO `school_recruit` VALUES ('237959', '613', '2013', '2', '2', '3', '343', '356', '0');
INSERT INTO `school_recruit` VALUES ('238059', '613', '2010', '2', '1', '10', '485', '489', '0');
INSERT INTO `school_recruit` VALUES ('238064', '613', '2010', '2', '2', '10', '434', '454', '0');
INSERT INTO `school_recruit` VALUES ('238100', '613', '2013', '3', '1', '13', '476', '476', '470');
INSERT INTO `school_recruit` VALUES ('238101', '613', '2011', '3', '1', '13', '469', '480', '459');
INSERT INTO `school_recruit` VALUES ('238102', '613', '2010', '3', '1', '13', '481', '490', '0');
INSERT INTO `school_recruit` VALUES ('238107', '613', '2013', '3', '2', '13', '428', '452', '412');
INSERT INTO `school_recruit` VALUES ('238108', '613', '2011', '3', '2', '13', '459', '480', '447');
INSERT INTO `school_recruit` VALUES ('238109', '613', '2010', '3', '2', '13', '463', '491', '0');
INSERT INTO `school_recruit` VALUES ('238507', '615', '2013', '2', '1', '3', '410', '417', '0');
INSERT INTO `school_recruit` VALUES ('238508', '615', '2012', '2', '1', '3', '394', '419', '0');
INSERT INTO `school_recruit` VALUES ('238509', '615', '2011', '2', '1', '3', '421', '442', '0');
INSERT INTO `school_recruit` VALUES ('238510', '615', '2010', '2', '1', '3', '412', '442', '0');
INSERT INTO `school_recruit` VALUES ('238515', '615', '2013', '2', '2', '3', '342', '354', '0');
INSERT INTO `school_recruit` VALUES ('238516', '615', '2012', '2', '2', '3', '367', '408', '0');
INSERT INTO `school_recruit` VALUES ('238517', '615', '2011', '2', '2', '3', '403', '431', '0');
INSERT INTO `school_recruit` VALUES ('238518', '615', '2010', '2', '2', '3', '410', '456', '0');
INSERT INTO `school_recruit` VALUES ('238600', '615', '2010', '2', '1', '10', '488', '511', '0');
INSERT INTO `school_recruit` VALUES ('238604', '615', '2010', '2', '2', '10', '425', '478', '0');
INSERT INTO `school_recruit` VALUES ('238636', '615', '2013', '3', '1', '13', '477', '494', '469');
INSERT INTO `school_recruit` VALUES ('238637', '615', '2012', '3', '1', '13', '486', '516', '466');
INSERT INTO `school_recruit` VALUES ('238638', '615', '2011', '3', '1', '13', '452', '502', '432');
INSERT INTO `school_recruit` VALUES ('238639', '615', '2010', '3', '1', '13', '447', '493', '0');
INSERT INTO `school_recruit` VALUES ('238644', '615', '2013', '3', '2', '13', '447', '491', '437');
INSERT INTO `school_recruit` VALUES ('238645', '615', '2012', '3', '2', '13', '435', '497', '399');
INSERT INTO `school_recruit` VALUES ('238646', '615', '2011', '3', '2', '13', '434', '504', '408');
INSERT INTO `school_recruit` VALUES ('238647', '615', '2010', '3', '2', '13', '417', '492', '0');
INSERT INTO `school_recruit` VALUES ('241886', '627', '2013', '2', '1', '34', '507', '520', '0');
INSERT INTO `school_recruit` VALUES ('241887', '627', '2012', '2', '1', '34', '470', '520', '0');
INSERT INTO `school_recruit` VALUES ('241888', '627', '2011', '2', '1', '34', '498', '536', '0');
INSERT INTO `school_recruit` VALUES ('241889', '627', '2010', '2', '1', '34', '493', '537', '0');
INSERT INTO `school_recruit` VALUES ('241894', '627', '2013', '2', '2', '34', '514', '524', '0');
INSERT INTO `school_recruit` VALUES ('241895', '627', '2012', '2', '2', '34', '453', '550', '0');
INSERT INTO `school_recruit` VALUES ('241896', '627', '2011', '2', '2', '34', '457', '543', '0');
INSERT INTO `school_recruit` VALUES ('241897', '627', '2010', '2', '2', '34', '468', '527', '0');
INSERT INTO `school_recruit` VALUES ('246053', '646', '2010', '2', '1', '10', '531', '558', '0');
INSERT INTO `school_recruit` VALUES ('246057', '646', '2010', '1', '2', '10', '575', '623', '0');
INSERT INTO `school_recruit` VALUES ('246061', '646', '2010', '2', '2', '10', '498', '518', '0');
INSERT INTO `school_recruit` VALUES ('246075', '646', '2013', '2', '2', '13', '509', '524', '509');
INSERT INTO `school_recruit` VALUES ('246076', '646', '2012', '2', '2', '13', '541', '549', '537');
INSERT INTO `school_recruit` VALUES ('246077', '646', '2011', '2', '2', '13', '522', '539', '517');
INSERT INTO `school_recruit` VALUES ('246078', '646', '2010', '2', '2', '13', '507', '528', '0');
INSERT INTO `school_recruit` VALUES ('250126', '663', '2010', '2', '1', '10', '507', '549', '0');
INSERT INTO `school_recruit` VALUES ('250131', '663', '2010', '2', '2', '10', '456', '510', '0');
INSERT INTO `school_recruit` VALUES ('252549', '675', '2013', '2', '1', '3', '412', '422', '0');
INSERT INTO `school_recruit` VALUES ('252550', '675', '2012', '2', '1', '3', '406', '430', '0');
INSERT INTO `school_recruit` VALUES ('252551', '675', '2011', '2', '1', '3', '424', '450', '0');
INSERT INTO `school_recruit` VALUES ('252552', '675', '2010', '2', '1', '3', '417', '453', '0');
INSERT INTO `school_recruit` VALUES ('252557', '675', '2013', '2', '2', '3', '345', '359', '0');
INSERT INTO `school_recruit` VALUES ('252558', '675', '2012', '2', '2', '3', '372', '418', '0');
INSERT INTO `school_recruit` VALUES ('252559', '675', '2011', '2', '2', '3', '409', '452', '0');
INSERT INTO `school_recruit` VALUES ('252560', '675', '2010', '2', '2', '3', '414', '457', '0');
INSERT INTO `school_recruit` VALUES ('252645', '675', '2010', '2', '1', '10', '506', '545', '0');
INSERT INTO `school_recruit` VALUES ('252651', '675', '2010', '2', '2', '10', '472', '500', '0');
INSERT INTO `school_recruit` VALUES ('252686', '675', '2013', '3', '1', '13', '485', '502', '477');
INSERT INTO `school_recruit` VALUES ('252687', '675', '2012', '3', '1', '13', '517', '533', '510');
INSERT INTO `school_recruit` VALUES ('252688', '675', '2011', '3', '1', '13', '493', '526', '485');
INSERT INTO `school_recruit` VALUES ('252689', '675', '2010', '3', '1', '13', '492', '503', '0');
INSERT INTO `school_recruit` VALUES ('252694', '675', '2013', '3', '2', '13', '459', '477', '441');
INSERT INTO `school_recruit` VALUES ('252695', '675', '2012', '3', '2', '13', '485', '514', '474');
INSERT INTO `school_recruit` VALUES ('252696', '675', '2011', '3', '2', '13', '477', '511', '467');
INSERT INTO `school_recruit` VALUES ('252697', '675', '2010', '3', '2', '13', '458', '470', '0');
INSERT INTO `school_recruit` VALUES ('253819', '682', '2013', '1', '1', '34', '560', '571', '0');
INSERT INTO `school_recruit` VALUES ('253820', '682', '2012', '1', '1', '34', '535', '557', '0');
INSERT INTO `school_recruit` VALUES ('253821', '682', '2011', '1', '1', '34', '554', '570', '0');
INSERT INTO `school_recruit` VALUES ('253822', '682', '2010', '1', '1', '34', '540', '564', '0');
INSERT INTO `school_recruit` VALUES ('253828', '682', '2013', '1', '2', '34', '568', '586', '0');
INSERT INTO `school_recruit` VALUES ('253829', '682', '2012', '1', '2', '34', '519', '562', '0');
INSERT INTO `school_recruit` VALUES ('253830', '682', '2011', '1', '2', '34', '522', '575', '0');
INSERT INTO `school_recruit` VALUES ('253831', '682', '2010', '1', '2', '34', '538', '574', '0');
INSERT INTO `school_recruit` VALUES ('253960', '682', '2010', '1', '1', '10', '611', '616', '0');
INSERT INTO `school_recruit` VALUES ('253965', '682', '2010', '1', '2', '10', '576', '579', '0');
INSERT INTO `school_recruit` VALUES ('253997', '682', '2013', '1', '1', '13', '556', '558', '554');
INSERT INTO `school_recruit` VALUES ('253998', '682', '2012', '1', '1', '13', '586', '586', '586');
INSERT INTO `school_recruit` VALUES ('253999', '682', '2011', '1', '1', '13', '549', '552', '0');
INSERT INTO `school_recruit` VALUES ('254000', '682', '2010', '1', '1', '13', '540', '541', '0');
INSERT INTO `school_recruit` VALUES ('254002', '682', '2013', '1', '2', '13', '536', '555', '550');
INSERT INTO `school_recruit` VALUES ('254003', '682', '2012', '1', '2', '13', '581', '589', '578');
INSERT INTO `school_recruit` VALUES ('254004', '682', '2011', '1', '2', '13', '562', '573', '0');
INSERT INTO `school_recruit` VALUES ('254005', '682', '2010', '1', '2', '13', '549', '564', '0');
INSERT INTO `school_recruit` VALUES ('257406', '696', '2013', '2', '1', '3', '414', '426', '0');
INSERT INTO `school_recruit` VALUES ('257407', '696', '2012', '2', '1', '3', '398', '419', '0');
INSERT INTO `school_recruit` VALUES ('257408', '696', '2011', '2', '1', '3', '424', '440', '0');
INSERT INTO `school_recruit` VALUES ('257409', '696', '2010', '2', '1', '3', '416', '446', '0');
INSERT INTO `school_recruit` VALUES ('257414', '696', '2010', '5', '1', '3', '424', '468', '0');
INSERT INTO `school_recruit` VALUES ('257419', '696', '2013', '2', '2', '3', '348', '366', '0');
INSERT INTO `school_recruit` VALUES ('257420', '696', '2012', '2', '2', '3', '376', '399', '0');
INSERT INTO `school_recruit` VALUES ('257421', '696', '2011', '2', '2', '3', '409', '426', '0');
INSERT INTO `school_recruit` VALUES ('257422', '696', '2010', '2', '2', '3', '412', '457', '0');
INSERT INTO `school_recruit` VALUES ('257427', '696', '2010', '5', '2', '3', '413', '431', '0');
INSERT INTO `school_recruit` VALUES ('257481', '696', '2010', '2', '1', '10', '493', '526', '0');
INSERT INTO `school_recruit` VALUES ('257486', '696', '2010', '2', '2', '10', '422', '489', '0');
INSERT INTO `school_recruit` VALUES ('257518', '696', '2011', '3', '1', '13', '474', '486', '467');
INSERT INTO `school_recruit` VALUES ('257519', '696', '2010', '3', '1', '13', '469', '474', '0');
INSERT INTO `school_recruit` VALUES ('257520', '696', '2013', '3', '2', '13', '434', '445', '406');
INSERT INTO `school_recruit` VALUES ('257521', '696', '2012', '3', '2', '13', '470', '486', '461');
INSERT INTO `school_recruit` VALUES ('257522', '696', '2011', '3', '2', '13', '447', '476', '435');
INSERT INTO `school_recruit` VALUES ('257523', '696', '2010', '3', '2', '13', '438', '447', '0');
INSERT INTO `school_recruit` VALUES ('258841', '703', '2013', '1', '2', '34', '563', '577', '0');
INSERT INTO `school_recruit` VALUES ('258842', '703', '2012', '1', '2', '34', '531', '571', '0');
INSERT INTO `school_recruit` VALUES ('258843', '703', '2011', '1', '2', '34', '536', '562', '0');
INSERT INTO `school_recruit` VALUES ('258844', '703', '2010', '1', '2', '34', '542', '587', '0');
INSERT INTO `school_recruit` VALUES ('258869', '703', '2010', '1', '2', '10', '576', '607', '0');
INSERT INTO `school_recruit` VALUES ('261275', '715', '2010', '4', '1', '10', '296', '300', '0');
INSERT INTO `school_recruit` VALUES ('261276', '715', '2010', '4', '2', '10', '293', '358', '0');
INSERT INTO `school_recruit` VALUES ('261281', '715', '2010', '4', '1', '13', '250', '261', '0');
INSERT INTO `school_recruit` VALUES ('261282', '715', '2010', '4', '2', '13', '288', '362', '0');
INSERT INTO `school_recruit` VALUES ('263968', '728', '2010', '4', '1', '10', '195', '390', '0');
INSERT INTO `school_recruit` VALUES ('263969', '728', '2010', '4', '2', '10', '200', '400', '0');
INSERT INTO `school_recruit` VALUES ('263974', '728', '2010', '4', '1', '13', '232', '464', '0');
INSERT INTO `school_recruit` VALUES ('263975', '728', '2010', '4', '2', '13', '232', '464', '0');
INSERT INTO `school_recruit` VALUES ('264227', '730', '2010', '4', '1', '34', '175', '350', '0');
INSERT INTO `school_recruit` VALUES ('264228', '730', '2010', '4', '2', '34', '165', '330', '0');
INSERT INTO `school_recruit` VALUES ('264233', '730', '2010', '4', '1', '3', '230', '460', '0');
INSERT INTO `school_recruit` VALUES ('264234', '730', '2010', '4', '2', '3', '227', '454', '0');
INSERT INTO `school_recruit` VALUES ('264251', '730', '2010', '4', '1', '10', '210', '421', '0');
INSERT INTO `school_recruit` VALUES ('264252', '730', '2010', '4', '2', '10', '236', '473', '0');
INSERT INTO `school_recruit` VALUES ('264257', '730', '2010', '4', '1', '13', '248', '497', '0');
INSERT INTO `school_recruit` VALUES ('264258', '730', '2010', '4', '2', '13', '200', '400', '0');
INSERT INTO `school_recruit` VALUES ('267977', '749', '2011', '3', '1', '34', '458', '458', '0');
INSERT INTO `school_recruit` VALUES ('267981', '749', '2012', '3', '2', '34', '416', '417', '0');
INSERT INTO `school_recruit` VALUES ('267982', '749', '2011', '3', '2', '34', '412', '417', '0');
INSERT INTO `school_recruit` VALUES ('267983', '749', '2010', '3', '2', '34', '420', '438', '0');
INSERT INTO `school_recruit` VALUES ('268005', '749', '2013', '2', '1', '3', '416', '429', '0');
INSERT INTO `school_recruit` VALUES ('268006', '749', '2012', '2', '1', '3', '402', '414', '0');
INSERT INTO `school_recruit` VALUES ('268007', '749', '2011', '2', '1', '3', '414', '416', '0');
INSERT INTO `school_recruit` VALUES ('268011', '749', '2013', '2', '2', '3', '337', '344', '0');
INSERT INTO `school_recruit` VALUES ('268012', '749', '2012', '2', '2', '3', '367', '377', '0');
INSERT INTO `school_recruit` VALUES ('268013', '749', '2011', '2', '2', '3', '397', '406', '0');
INSERT INTO `school_recruit` VALUES ('268014', '749', '2010', '2', '2', '3', '401', '403', '0');
INSERT INTO `school_recruit` VALUES ('268062', '749', '2010', '2', '1', '10', '493', '523', '0');
INSERT INTO `school_recruit` VALUES ('268067', '749', '2010', '2', '2', '10', '437', '505', '0');
INSERT INTO `school_recruit` VALUES ('268097', '749', '2010', '3', '1', '13', '436', '466', '0');
INSERT INTO `school_recruit` VALUES ('268100', '749', '2013', '3', '2', '13', '426', '442', '413');
INSERT INTO `school_recruit` VALUES ('268101', '749', '2012', '3', '2', '13', '451', '471', '431');
INSERT INTO `school_recruit` VALUES ('268102', '749', '2011', '3', '2', '13', '447', '459', '438');
INSERT INTO `school_recruit` VALUES ('268103', '749', '2010', '3', '2', '13', '431', '439', '0');
INSERT INTO `school_recruit` VALUES ('268931', '753', '2010', '5', '1', '34', '497', '530', '0');
INSERT INTO `school_recruit` VALUES ('268937', '753', '2010', '5', '2', '34', '475', '486', '0');
INSERT INTO `school_recruit` VALUES ('268957', '753', '2013', '2', '1', '3', '416', '429', '0');
INSERT INTO `school_recruit` VALUES ('268958', '753', '2011', '2', '1', '3', '435', '451', '0');
INSERT INTO `school_recruit` VALUES ('268959', '753', '2010', '2', '1', '3', '430', '452', '0');
INSERT INTO `school_recruit` VALUES ('268964', '753', '2013', '2', '2', '3', '351', '372', '0');
INSERT INTO `school_recruit` VALUES ('268965', '753', '2011', '2', '2', '3', '421', '460', '0');
INSERT INTO `school_recruit` VALUES ('268966', '753', '2010', '2', '2', '3', '426', '446', '0');
INSERT INTO `school_recruit` VALUES ('269006', '753', '2010', '2', '1', '10', '531', '537', '0');
INSERT INTO `school_recruit` VALUES ('269011', '753', '2010', '2', '2', '10', '480', '496', '0');
INSERT INTO `school_recruit` VALUES ('269043', '753', '2013', '2', '1', '13', '526', '531', '0');
INSERT INTO `school_recruit` VALUES ('269044', '753', '2011', '2', '1', '13', '524', '530', '0');
INSERT INTO `school_recruit` VALUES ('269045', '753', '2010', '2', '1', '13', '510', '520', '0');
INSERT INTO `school_recruit` VALUES ('269050', '753', '2013', '2', '2', '13', '504', '512', '0');
INSERT INTO `school_recruit` VALUES ('269051', '753', '2011', '2', '2', '13', '516', '524', '0');
INSERT INTO `school_recruit` VALUES ('269052', '753', '2010', '2', '2', '13', '501', '509', '0');
INSERT INTO `school_recruit` VALUES ('269745', '756', '2013', '2', '1', '3', '413', '423', '0');
INSERT INTO `school_recruit` VALUES ('269746', '756', '2012', '2', '1', '3', '405', '425', '0');
INSERT INTO `school_recruit` VALUES ('269747', '756', '2011', '2', '1', '3', '423', '432', '0');
INSERT INTO `school_recruit` VALUES ('269748', '756', '2010', '2', '1', '3', '420', '428', '0');
INSERT INTO `school_recruit` VALUES ('269750', '756', '2013', '2', '2', '3', '343', '356', '0');
INSERT INTO `school_recruit` VALUES ('269751', '756', '2012', '2', '2', '3', '366', '387', '0');
INSERT INTO `school_recruit` VALUES ('269752', '756', '2011', '2', '2', '3', '407', '414', '0');
INSERT INTO `school_recruit` VALUES ('269753', '756', '2010', '2', '2', '3', '408', '416', '0');
INSERT INTO `school_recruit` VALUES ('269801', '756', '2010', '2', '1', '10', '524', '553', '0');
INSERT INTO `school_recruit` VALUES ('269809', '756', '2010', '2', '2', '10', '476', '521', '0');
INSERT INTO `school_recruit` VALUES ('269834', '756', '2013', '2', '1', '13', '509', '511', '506');
INSERT INTO `school_recruit` VALUES ('269835', '756', '2012', '2', '1', '13', '549', '553', '547');
INSERT INTO `school_recruit` VALUES ('269836', '756', '2011', '2', '1', '13', '500', '504', '499');
INSERT INTO `school_recruit` VALUES ('269837', '756', '2010', '2', '1', '13', '491', '511', '0');
INSERT INTO `school_recruit` VALUES ('269840', '756', '2013', '2', '2', '13', '481', '483', '476');
INSERT INTO `school_recruit` VALUES ('269841', '756', '2012', '2', '2', '13', '510', '524', '505');
INSERT INTO `school_recruit` VALUES ('269842', '756', '2011', '2', '2', '13', '497', '510', '488');
INSERT INTO `school_recruit` VALUES ('269843', '756', '2010', '2', '2', '13', '476', '493', '0');
INSERT INTO `school_recruit` VALUES ('269993', '757', '2013', '2', '1', '3', '406', '409', '0');
INSERT INTO `school_recruit` VALUES ('269994', '757', '2012', '2', '1', '3', '393', '393', '0');
INSERT INTO `school_recruit` VALUES ('269995', '757', '2010', '2', '1', '3', '432', '432', '0');
INSERT INTO `school_recruit` VALUES ('270000', '757', '2013', '2', '2', '3', '335', '339', '0');
INSERT INTO `school_recruit` VALUES ('270001', '757', '2012', '2', '2', '3', '357', '357', '0');
INSERT INTO `school_recruit` VALUES ('270002', '757', '2011', '2', '2', '3', '404', '404', '0');
INSERT INTO `school_recruit` VALUES ('270084', '757', '2013', '2', '1', '13', '488', '509', '484');
INSERT INTO `school_recruit` VALUES ('270085', '757', '2012', '2', '1', '13', '527', '553', '523');
INSERT INTO `school_recruit` VALUES ('270086', '757', '2011', '2', '1', '13', '488', '515', '484');
INSERT INTO `school_recruit` VALUES ('270087', '757', '2010', '2', '1', '13', '484', '520', '0');
INSERT INTO `school_recruit` VALUES ('270093', '757', '2013', '2', '2', '13', '460', '512', '456');
INSERT INTO `school_recruit` VALUES ('270094', '757', '2012', '2', '2', '13', '493', '540', '486');
INSERT INTO `school_recruit` VALUES ('270095', '757', '2011', '2', '2', '13', '479', '513', '474');
INSERT INTO `school_recruit` VALUES ('270096', '757', '2010', '2', '2', '13', '470', '513', '0');
INSERT INTO `school_recruit` VALUES ('274364', '780', '2012', '3', '1', '34', '430', '488', '0');
INSERT INTO `school_recruit` VALUES ('274365', '780', '2011', '3', '1', '34', '438', '479', '0');
INSERT INTO `school_recruit` VALUES ('274366', '780', '2010', '3', '1', '34', '433', '477', '0');
INSERT INTO `school_recruit` VALUES ('274369', '780', '2012', '3', '2', '34', '419', '445', '0');
INSERT INTO `school_recruit` VALUES ('274370', '780', '2011', '3', '2', '34', '429', '473', '0');
INSERT INTO `school_recruit` VALUES ('274371', '780', '2010', '3', '2', '34', '425', '470', '0');
INSERT INTO `school_recruit` VALUES ('274383', '780', '2012', '2', '1', '3', '389', '395', '0');
INSERT INTO `school_recruit` VALUES ('274384', '780', '2011', '2', '1', '3', '414', '415', '0');
INSERT INTO `school_recruit` VALUES ('274385', '780', '2010', '2', '1', '3', '411', '426', '0');
INSERT INTO `school_recruit` VALUES ('274386', '780', '2013', '2', '2', '3', '332', '334', '0');
INSERT INTO `school_recruit` VALUES ('274387', '780', '2012', '2', '2', '3', '351', '370', '0');
INSERT INTO `school_recruit` VALUES ('274388', '780', '2011', '2', '2', '3', '399', '406', '0');
INSERT INTO `school_recruit` VALUES ('274389', '780', '2010', '2', '2', '3', '415', '422', '0');
INSERT INTO `school_recruit` VALUES ('274432', '780', '2010', '2', '1', '10', '502', '544', '0');
INSERT INTO `school_recruit` VALUES ('274435', '780', '2010', '2', '2', '10', '443', '484', '0');
INSERT INTO `school_recruit` VALUES ('274451', '780', '2013', '3', '1', '13', '448', '452', '0');
INSERT INTO `school_recruit` VALUES ('274452', '780', '2011', '3', '1', '13', '456', '514', '419');
INSERT INTO `school_recruit` VALUES ('274453', '780', '2010', '3', '1', '13', '448', '484', '0');
INSERT INTO `school_recruit` VALUES ('274456', '780', '2013', '3', '2', '13', '419', '433', '0');
INSERT INTO `school_recruit` VALUES ('274457', '780', '2011', '3', '2', '13', '412', '445', '374');
INSERT INTO `school_recruit` VALUES ('274458', '780', '2010', '3', '2', '13', '400', '453', '0');
INSERT INTO `school_recruit` VALUES ('274547', '781', '2010', '2', '1', '10', '517', '552', '0');
INSERT INTO `school_recruit` VALUES ('274548', '781', '2010', '2', '2', '10', '463', '509', '0');
INSERT INTO `school_recruit` VALUES ('274558', '781', '2013', '2', '1', '13', '530', '535', '528');
INSERT INTO `school_recruit` VALUES ('274559', '781', '2012', '2', '1', '13', '567', '578', '565');
INSERT INTO `school_recruit` VALUES ('274560', '781', '2013', '2', '2', '13', '514', '525', '510');
INSERT INTO `school_recruit` VALUES ('274561', '781', '2012', '2', '2', '13', '541', '551', '538');
INSERT INTO `school_recruit` VALUES ('274864', '784', '2013', '3', '1', '34', '454', '455', '0');
INSERT INTO `school_recruit` VALUES ('274865', '784', '2012', '3', '1', '34', '428', '445', '0');
INSERT INTO `school_recruit` VALUES ('274866', '784', '2011', '3', '1', '34', '456', '476', '0');
INSERT INTO `school_recruit` VALUES ('274867', '784', '2010', '3', '1', '34', '449', '473', '0');
INSERT INTO `school_recruit` VALUES ('274875', '784', '2013', '3', '2', '34', '475', '475', '0');
INSERT INTO `school_recruit` VALUES ('274876', '784', '2012', '3', '2', '34', '413', '432', '0');
INSERT INTO `school_recruit` VALUES ('274877', '784', '2011', '3', '2', '34', '410', '452', '0');
INSERT INTO `school_recruit` VALUES ('274878', '784', '2010', '3', '2', '34', '415', '446', '0');
INSERT INTO `school_recruit` VALUES ('274906', '784', '2013', '2', '1', '3', '404', '405', '0');
INSERT INTO `school_recruit` VALUES ('274907', '784', '2012', '2', '1', '3', '389', '396', '0');
INSERT INTO `school_recruit` VALUES ('274908', '784', '2010', '2', '1', '3', '408', '408', '0');
INSERT INTO `school_recruit` VALUES ('274913', '784', '2013', '2', '2', '3', '337', '343', '0');
INSERT INTO `school_recruit` VALUES ('274914', '784', '2011', '2', '2', '3', '397', '402', '0');
INSERT INTO `school_recruit` VALUES ('275025', '784', '2010', '2', '1', '10', '487', '500', '0');
INSERT INTO `school_recruit` VALUES ('275030', '784', '2010', '4', '1', '10', '303', '397', '0');
INSERT INTO `school_recruit` VALUES ('275031', '784', '2010', '2', '2', '10', '425', '451', '0');
INSERT INTO `school_recruit` VALUES ('275036', '784', '2011', '4', '2', '10', '282', '296', '0');
INSERT INTO `school_recruit` VALUES ('275067', '784', '2013', '3', '1', '13', '454', '460', '449');
INSERT INTO `school_recruit` VALUES ('275068', '784', '2011', '3', '1', '13', '433', '464', '419');
INSERT INTO `school_recruit` VALUES ('275073', '784', '2010', '4', '1', '13', '310', '354', '0');
INSERT INTO `school_recruit` VALUES ('275074', '784', '2013', '3', '2', '13', '419', '432', '410');
INSERT INTO `school_recruit` VALUES ('275075', '784', '2011', '3', '2', '13', '401', '460', '373');
INSERT INTO `school_recruit` VALUES ('275080', '784', '2011', '4', '2', '13', '273', '289', '0');
INSERT INTO `school_recruit` VALUES ('279358', '809', '2013', '2', '1', '3', '409', '415', '0');
INSERT INTO `school_recruit` VALUES ('279364', '809', '2012', '2', '1', '3', '393', '398', '0');
INSERT INTO `school_recruit` VALUES ('279371', '809', '2011', '2', '1', '3', '424', '424', '0');
INSERT INTO `school_recruit` VALUES ('279381', '809', '2013', '2', '2', '3', '334', '337', '0');
INSERT INTO `school_recruit` VALUES ('279384', '809', '2012', '2', '2', '3', '347', '349', '0');
INSERT INTO `school_recruit` VALUES ('279386', '809', '2011', '2', '2', '3', '395', '395', '0');
INSERT INTO `school_recruit` VALUES ('279806', '809', '2010', '2', '1', '10', '515', '527', '0');
INSERT INTO `school_recruit` VALUES ('279822', '809', '2010', '2', '2', '10', '450', '460', '0');
INSERT INTO `school_recruit` VALUES ('280000', '809', '2013', '2', '1', '13', '489', '508', '484');
INSERT INTO `school_recruit` VALUES ('280003', '809', '2012', '2', '1', '13', '531', '541', '523');
INSERT INTO `school_recruit` VALUES ('280006', '809', '2011', '2', '1', '13', '485', '486', '484');
INSERT INTO `school_recruit` VALUES ('280009', '809', '2010', '2', '1', '13', '479', '479', '0');
INSERT INTO `school_recruit` VALUES ('280011', '809', '2013', '2', '2', '13', '459', '490', '456');
INSERT INTO `school_recruit` VALUES ('280013', '809', '2012', '2', '2', '13', '491', '532', '486');
INSERT INTO `school_recruit` VALUES ('280016', '809', '2011', '2', '2', '13', '478', '499', '474');
INSERT INTO `school_recruit` VALUES ('280019', '809', '2010', '2', '2', '13', '475', '502', '0');
INSERT INTO `school_recruit` VALUES ('285006', '841', '2010', '4', '1', '13', '401', '475', '0');
INSERT INTO `school_recruit` VALUES ('285017', '841', '2010', '4', '2', '13', '406', '440', '0');
INSERT INTO `school_recruit` VALUES ('286643', '855', '2013', '1', '1', '3', '452', '457', '0');
INSERT INTO `school_recruit` VALUES ('286644', '855', '2012', '1', '1', '3', '474', '474', '0');
INSERT INTO `school_recruit` VALUES ('286645', '855', '2011', '1', '1', '3', '480', '491', '0');
INSERT INTO `school_recruit` VALUES ('286646', '855', '2010', '1', '1', '3', '474', '495', '0');
INSERT INTO `school_recruit` VALUES ('286658', '855', '2013', '1', '2', '3', '412', '420', '0');
INSERT INTO `school_recruit` VALUES ('286659', '855', '2012', '1', '2', '3', '439', '468', '0');
INSERT INTO `school_recruit` VALUES ('286661', '855', '2011', '1', '2', '3', '476', '490', '0');
INSERT INTO `school_recruit` VALUES ('286662', '855', '2010', '1', '2', '3', '475', '492', '0');
INSERT INTO `school_recruit` VALUES ('286872', '855', '2010', '2', '1', '10', '532', '535', '0');
INSERT INTO `school_recruit` VALUES ('286885', '855', '2010', '2', '2', '10', '491', '496', '0');
INSERT INTO `school_recruit` VALUES ('288939', '871', '2010', '4', '1', '34', '155', '310', '0');
INSERT INTO `school_recruit` VALUES ('288946', '871', '2010', '4', '2', '34', '129', '259', '0');
INSERT INTO `school_recruit` VALUES ('289243', '871', '2010', '4', '1', '10', '178', '356', '0');
INSERT INTO `school_recruit` VALUES ('289246', '871', '2010', '4', '2', '10', '191', '382', '0');
INSERT INTO `school_recruit` VALUES ('289334', '871', '2010', '4', '1', '13', '237', '475', '0');
INSERT INTO `school_recruit` VALUES ('289340', '871', '2010', '4', '2', '13', '220', '440', '0');
INSERT INTO `school_recruit` VALUES ('289519', '876', '2011', '2', '1', '3', '422', '435', '0');
INSERT INTO `school_recruit` VALUES ('289522', '876', '2011', '2', '2', '3', '402', '414', '0');
INSERT INTO `school_recruit` VALUES ('289523', '876', '2010', '2', '2', '3', '403', '403', '0');
INSERT INTO `school_recruit` VALUES ('289741', '889', '2010', '4', '1', '34', '155', '310', '0');
INSERT INTO `school_recruit` VALUES ('289798', '942', '2010', '5', '2', '3', '464', '464', '0');
INSERT INTO `school_recruit` VALUES ('289801', '951', '2011', '4', '2', '34', '189', '378', '0');
INSERT INTO `school_recruit` VALUES ('289804', '954', '2010', '4', '1', '34', '205', '259', '0');
INSERT INTO `school_recruit` VALUES ('289825', '978', '2010', '4', '1', '34', '155', '310', '0');
INSERT INTO `school_recruit` VALUES ('289869', '1028', '2013', '3', '1', '34', '460', '466', '0');
INSERT INTO `school_recruit` VALUES ('289899', '1065', '2012', '3', '1', '34', '416', '416', '0');
INSERT INTO `school_recruit` VALUES ('290223', '876', '2010', '2', '1', '10', '493', '519', '0');
INSERT INTO `school_recruit` VALUES ('290238', '876', '2010', '2', '2', '10', '428', '509', '0');
INSERT INTO `school_recruit` VALUES ('290390', '876', '2011', '3', '1', '13', '462', '465', '460');
INSERT INTO `school_recruit` VALUES ('290392', '876', '2010', '3', '1', '13', '455', '462', '0');
INSERT INTO `school_recruit` VALUES ('290405', '876', '2011', '3', '2', '13', '441', '457', '427');
INSERT INTO `school_recruit` VALUES ('290406', '876', '2010', '3', '2', '13', '414', '454', '0');
INSERT INTO `school_recruit` VALUES ('291595', '889', '2010', '4', '2', '34', '129', '259', '0');
INSERT INTO `school_recruit` VALUES ('291736', '894', '2012', '2', '1', '3', '390', '397', '0');
INSERT INTO `school_recruit` VALUES ('291737', '894', '2011', '2', '1', '3', '422', '428', '0');
INSERT INTO `school_recruit` VALUES ('291739', '894', '2013', '2', '2', '3', '336', '342', '0');
INSERT INTO `school_recruit` VALUES ('291740', '894', '2012', '2', '2', '3', '355', '403', '0');
INSERT INTO `school_recruit` VALUES ('291741', '894', '2011', '2', '2', '3', '400', '423', '0');
INSERT INTO `school_recruit` VALUES ('291742', '894', '2010', '2', '2', '3', '404', '425', '0');
INSERT INTO `school_recruit` VALUES ('291890', '889', '2010', '4', '1', '10', '178', '356', '0');
INSERT INTO `school_recruit` VALUES ('291893', '889', '2010', '4', '2', '10', '191', '382', '0');
INSERT INTO `school_recruit` VALUES ('291956', '889', '2010', '4', '1', '13', '237', '475', '0');
INSERT INTO `school_recruit` VALUES ('291968', '889', '2010', '4', '2', '13', '220', '440', '0');
INSERT INTO `school_recruit` VALUES ('292006', '894', '2010', '2', '1', '10', '478', '516', '0');
INSERT INTO `school_recruit` VALUES ('292021', '894', '2010', '2', '2', '10', '428', '481', '0');
INSERT INTO `school_recruit` VALUES ('292112', '894', '2013', '3', '2', '13', '426', '452', '409');
INSERT INTO `school_recruit` VALUES ('292115', '894', '2012', '3', '2', '13', '449', '490', '434');
INSERT INTO `school_recruit` VALUES ('292118', '894', '2011', '3', '2', '13', '442', '472', '429');
INSERT INTO `school_recruit` VALUES ('292120', '894', '2010', '3', '2', '13', '430', '455', '0');
INSERT INTO `school_recruit` VALUES ('294101', '911', '2010', '2', '1', '10', '498', '533', '0');
INSERT INTO `school_recruit` VALUES ('294125', '911', '2010', '2', '2', '10', '444', '500', '0');
INSERT INTO `school_recruit` VALUES ('294328', '911', '2013', '3', '1', '13', '475', '477', '471');
INSERT INTO `school_recruit` VALUES ('294331', '911', '2012', '3', '1', '13', '511', '518', '504');
INSERT INTO `school_recruit` VALUES ('294334', '911', '2011', '3', '1', '13', '468', '478', '462');
INSERT INTO `school_recruit` VALUES ('294336', '911', '2010', '3', '1', '13', '457', '467', '0');
INSERT INTO `school_recruit` VALUES ('294363', '911', '2013', '3', '2', '13', '440', '451', '432');
INSERT INTO `school_recruit` VALUES ('294370', '911', '2012', '3', '2', '13', '461', '475', '451');
INSERT INTO `school_recruit` VALUES ('294375', '911', '2011', '3', '2', '13', '451', '470', '441');
INSERT INTO `school_recruit` VALUES ('294378', '911', '2010', '3', '2', '13', '433', '451', '0');
INSERT INTO `school_recruit` VALUES ('295815', '924', '2010', '4', '1', '10', '295', '295', '0');
INSERT INTO `school_recruit` VALUES ('295820', '924', '2010', '4', '2', '10', '255', '257', '0');
INSERT INTO `school_recruit` VALUES ('295878', '924', '2010', '4', '1', '13', '256', '276', '0');
INSERT INTO `school_recruit` VALUES ('295885', '924', '2010', '4', '2', '13', '324', '332', '0');
INSERT INTO `school_recruit` VALUES ('296447', '934', '2011', '4', '1', '10', '293', '314', '0');
INSERT INTO `school_recruit` VALUES ('296452', '934', '2011', '4', '2', '10', '283', '321', '0');
INSERT INTO `school_recruit` VALUES ('296534', '934', '2011', '4', '1', '13', '321', '483', '0');
INSERT INTO `school_recruit` VALUES ('296537', '934', '2011', '4', '2', '13', '287', '476', '0');
INSERT INTO `school_recruit` VALUES ('297570', '942', '2010', '5', '2', '10', '547', '611', '0');
INSERT INTO `school_recruit` VALUES ('298775', '951', '2010', '4', '2', '34', '125', '250', '0');
INSERT INTO `school_recruit` VALUES ('298877', '951', '2011', '4', '1', '3', '148', '297', '0');
INSERT INTO `school_recruit` VALUES ('298878', '951', '2010', '4', '1', '3', '148', '296', '0');
INSERT INTO `school_recruit` VALUES ('298883', '951', '2011', '4', '2', '3', '163', '327', '0');
INSERT INTO `school_recruit` VALUES ('298885', '951', '2010', '4', '2', '3', '159', '318', '0');
INSERT INTO `school_recruit` VALUES ('298976', '954', '2010', '4', '2', '34', '215', '279', '0');
INSERT INTO `school_recruit` VALUES ('299057', '954', '2010', '4', '1', '3', '231', '463', '0');
INSERT INTO `school_recruit` VALUES ('299061', '954', '2010', '4', '2', '3', '215', '431', '0');
INSERT INTO `school_recruit` VALUES ('299198', '951', '2011', '4', '1', '10', '174', '349', '0');
INSERT INTO `school_recruit` VALUES ('299200', '951', '2010', '4', '1', '10', '183', '366', '0');
INSERT INTO `school_recruit` VALUES ('299209', '951', '2011', '4', '2', '10', '171', '342', '0');
INSERT INTO `school_recruit` VALUES ('299210', '951', '2010', '4', '2', '10', '190', '381', '0');
INSERT INTO `school_recruit` VALUES ('299268', '954', '2010', '4', '1', '10', '350', '360', '0');
INSERT INTO `school_recruit` VALUES ('299282', '954', '2010', '4', '2', '10', '324', '356', '0');
INSERT INTO `school_recruit` VALUES ('299301', '951', '2011', '4', '1', '13', '366', '472', '0');
INSERT INTO `school_recruit` VALUES ('299304', '951', '2010', '4', '1', '13', '229', '458', '0');
INSERT INTO `school_recruit` VALUES ('299311', '951', '2011', '4', '2', '13', '327', '454', '0');
INSERT INTO `school_recruit` VALUES ('299314', '951', '2010', '4', '2', '13', '228', '457', '0');
INSERT INTO `school_recruit` VALUES ('299349', '954', '2010', '4', '1', '13', '417', '441', '0');
INSERT INTO `school_recruit` VALUES ('299354', '954', '2010', '4', '2', '13', '408', '448', '0');
INSERT INTO `school_recruit` VALUES ('301024', '967', '2011', '2', '1', '13', '521', '558', '0');
INSERT INTO `school_recruit` VALUES ('301320', '968', '2013', '3', '1', '13', '454', '481', '445');
INSERT INTO `school_recruit` VALUES ('301321', '968', '2012', '3', '1', '13', '481', '520', '472');
INSERT INTO `school_recruit` VALUES ('301323', '968', '2011', '3', '1', '13', '441', '480', '434');
INSERT INTO `school_recruit` VALUES ('301325', '968', '2010', '3', '1', '13', '430', '467', '0');
INSERT INTO `school_recruit` VALUES ('301339', '968', '2013', '3', '2', '13', '413', '448', '406');
INSERT INTO `school_recruit` VALUES ('301340', '968', '2012', '3', '2', '13', '421', '485', '409');
INSERT INTO `school_recruit` VALUES ('301341', '968', '2011', '3', '2', '13', '407', '470', '397');
INSERT INTO `school_recruit` VALUES ('301342', '968', '2010', '3', '2', '13', '391', '454', '0');
INSERT INTO `school_recruit` VALUES ('302023', '978', '2010', '4', '2', '34', '129', '259', '0');
INSERT INTO `school_recruit` VALUES ('302326', '978', '2010', '4', '1', '10', '178', '356', '0');
INSERT INTO `school_recruit` VALUES ('302327', '978', '2010', '4', '2', '10', '191', '382', '0');
INSERT INTO `school_recruit` VALUES ('302375', '978', '2010', '4', '1', '13', '237', '475', '0');
INSERT INTO `school_recruit` VALUES ('302378', '978', '2010', '4', '2', '13', '220', '440', '0');
INSERT INTO `school_recruit` VALUES ('302622', '980', '2013', '2', '1', '13', '505', '522', '497');
INSERT INTO `school_recruit` VALUES ('302623', '980', '2012', '2', '1', '13', '532', '551', '523');
INSERT INTO `school_recruit` VALUES ('302625', '980', '2011', '2', '1', '13', '500', '526', '489');
INSERT INTO `school_recruit` VALUES ('302627', '980', '2010', '2', '1', '13', '491', '514', '0');
INSERT INTO `school_recruit` VALUES ('302629', '980', '2010', '5', '1', '13', '472', '506', '0');
INSERT INTO `school_recruit` VALUES ('302631', '980', '2013', '2', '2', '13', '469', '509', '460');
INSERT INTO `school_recruit` VALUES ('302632', '980', '2012', '2', '2', '13', '497', '522', '488');
INSERT INTO `school_recruit` VALUES ('302633', '980', '2011', '2', '2', '13', '485', '516', '475');
INSERT INTO `school_recruit` VALUES ('302636', '980', '2010', '2', '2', '13', '477', '507', '0');
INSERT INTO `school_recruit` VALUES ('302645', '980', '2010', '5', '2', '13', '461', '547', '0');
INSERT INTO `school_recruit` VALUES ('306682', '1028', '2012', '3', '1', '34', '427', '444', '0');
INSERT INTO `school_recruit` VALUES ('306684', '1028', '2011', '3', '1', '34', '451', '460', '0');
INSERT INTO `school_recruit` VALUES ('306685', '1028', '2010', '3', '1', '34', '450', '466', '0');
INSERT INTO `school_recruit` VALUES ('306691', '1028', '2013', '3', '2', '34', '482', '489', '0');
INSERT INTO `school_recruit` VALUES ('306693', '1028', '2012', '3', '2', '34', '409', '418', '0');
INSERT INTO `school_recruit` VALUES ('306694', '1028', '2011', '3', '2', '34', '407', '414', '0');
INSERT INTO `school_recruit` VALUES ('306695', '1028', '2010', '3', '2', '34', '410', '418', '0');
INSERT INTO `school_recruit` VALUES ('306784', '1028', '2013', '2', '1', '3', '411', '419', '0');
INSERT INTO `school_recruit` VALUES ('306785', '1028', '2012', '2', '1', '3', '394', '409', '0');
INSERT INTO `school_recruit` VALUES ('306786', '1028', '2011', '2', '1', '3', '414', '414', '0');
INSERT INTO `school_recruit` VALUES ('306787', '1028', '2010', '2', '1', '3', '411', '423', '0');
INSERT INTO `school_recruit` VALUES ('306791', '1028', '2013', '2', '2', '3', '341', '352', '0');
INSERT INTO `school_recruit` VALUES ('306792', '1028', '2012', '2', '2', '3', '373', '397', '0');
INSERT INTO `school_recruit` VALUES ('306793', '1028', '2011', '2', '2', '3', '397', '411', '0');
INSERT INTO `school_recruit` VALUES ('306794', '1028', '2010', '2', '2', '3', '402', '404', '0');
INSERT INTO `school_recruit` VALUES ('307196', '1028', '2010', '2', '1', '10', '507', '526', '0');
INSERT INTO `school_recruit` VALUES ('307219', '1028', '2010', '2', '2', '10', '462', '480', '0');
INSERT INTO `school_recruit` VALUES ('307414', '1028', '2013', '3', '1', '13', '462', '480', '476');
INSERT INTO `school_recruit` VALUES ('307418', '1028', '2012', '3', '1', '13', '517', '556', '515');
INSERT INTO `school_recruit` VALUES ('307423', '1028', '2011', '3', '1', '13', '477', '489', '474');
INSERT INTO `school_recruit` VALUES ('307425', '1028', '2010', '3', '1', '13', '471', '497', '0');
INSERT INTO `school_recruit` VALUES ('307433', '1028', '2013', '3', '2', '13', '445', '476', '440');
INSERT INTO `school_recruit` VALUES ('307437', '1028', '2012', '3', '2', '13', '473', '525', '467');
INSERT INTO `school_recruit` VALUES ('307442', '1028', '2011', '3', '2', '13', '459', '496', '453');
INSERT INTO `school_recruit` VALUES ('307446', '1028', '2010', '3', '2', '13', '447', '482', '0');
INSERT INTO `school_recruit` VALUES ('307504', '1038', '2010', '2', '1', '10', '512', '545', '0');
INSERT INTO `school_recruit` VALUES ('307526', '1038', '2010', '2', '2', '10', '462', '497', '0');
INSERT INTO `school_recruit` VALUES ('307702', '1038', '2013', '3', '1', '13', '480', '486', '474');
INSERT INTO `school_recruit` VALUES ('307703', '1038', '2012', '3', '1', '13', '519', '530', '515');
INSERT INTO `school_recruit` VALUES ('307705', '1038', '2011', '3', '1', '13', '482', '490', '476');
INSERT INTO `school_recruit` VALUES ('307707', '1038', '2010', '3', '1', '13', '475', '499', '0');
INSERT INTO `school_recruit` VALUES ('307715', '1038', '2013', '3', '2', '13', '449', '467', '438');
INSERT INTO `school_recruit` VALUES ('307717', '1038', '2012', '3', '2', '13', '470', '482', '465');
INSERT INTO `school_recruit` VALUES ('307721', '1038', '2011', '3', '2', '13', '463', '472', '456');
INSERT INTO `school_recruit` VALUES ('307726', '1038', '2010', '3', '2', '13', '446', '473', '0');
INSERT INTO `school_recruit` VALUES ('308779', '1051', '2010', '2', '1', '10', '508', '519', '0');
INSERT INTO `school_recruit` VALUES ('308785', '1053', '2011', '1', '1', '3', '477', '487', '0');
INSERT INTO `school_recruit` VALUES ('308791', '1051', '2010', '2', '2', '10', '456', '487', '0');
INSERT INTO `school_recruit` VALUES ('308793', '1053', '2011', '1', '2', '3', '473', '484', '0');
INSERT INTO `school_recruit` VALUES ('308874', '1051', '2013', '2', '1', '13', '492', '495', '491');
INSERT INTO `school_recruit` VALUES ('308879', '1051', '2012', '2', '1', '13', '529', '542', '523');
INSERT INTO `school_recruit` VALUES ('308882', '1051', '2011', '2', '1', '13', '490', '493', '484');
INSERT INTO `school_recruit` VALUES ('308890', '1051', '2013', '2', '2', '13', '465', '491', '456');
INSERT INTO `school_recruit` VALUES ('308894', '1051', '2012', '2', '2', '13', '493', '510', '486');
INSERT INTO `school_recruit` VALUES ('308898', '1051', '2011', '2', '2', '13', '482', '491', '474');
INSERT INTO `school_recruit` VALUES ('308911', '1053', '2011', '1', '1', '10', '587', '603', '0');
INSERT INTO `school_recruit` VALUES ('308916', '1053', '2011', '1', '2', '10', '584', '618', '0');
INSERT INTO `school_recruit` VALUES ('309214', '1060', '2011', '3', '2', '34', '409', '420', '0');
INSERT INTO `school_recruit` VALUES ('309215', '1060', '2010', '3', '2', '34', '417', '435', '0');
INSERT INTO `school_recruit` VALUES ('309709', '1065', '2013', '2', '1', '3', '412', '422', '0');
INSERT INTO `school_recruit` VALUES ('309715', '1065', '2012', '2', '1', '3', '396', '416', '0');
INSERT INTO `school_recruit` VALUES ('309722', '1065', '2011', '2', '1', '3', '422', '434', '0');
INSERT INTO `school_recruit` VALUES ('309730', '1065', '2013', '2', '2', '3', '337', '344', '0');
INSERT INTO `school_recruit` VALUES ('309733', '1065', '2012', '2', '2', '3', '357', '397', '0');
INSERT INTO `school_recruit` VALUES ('309737', '1065', '2011', '2', '2', '3', '418', '460', '0');
INSERT INTO `school_recruit` VALUES ('309776', '1060', '2010', '2', '1', '10', '496', '514', '0');
INSERT INTO `school_recruit` VALUES ('309794', '1060', '2010', '2', '2', '10', '454', '497', '0');
INSERT INTO `school_recruit` VALUES ('309915', '1065', '2010', '2', '1', '10', '475', '505', '0');
INSERT INTO `school_recruit` VALUES ('309923', '1065', '2010', '2', '2', '10', '419', '502', '0');
INSERT INTO `school_recruit` VALUES ('309939', '1060', '2013', '3', '1', '13', '461', '480', '455');
INSERT INTO `school_recruit` VALUES ('309941', '1060', '2012', '3', '1', '13', '502', '524', '495');
INSERT INTO `school_recruit` VALUES ('309944', '1060', '2011', '3', '1', '13', '462', '506', '453');
INSERT INTO `school_recruit` VALUES ('309945', '1060', '2010', '3', '1', '13', '452', '474', '0');
INSERT INTO `school_recruit` VALUES ('309954', '1060', '2013', '3', '2', '13', '427', '466', '419');
INSERT INTO `school_recruit` VALUES ('309957', '1060', '2012', '3', '2', '13', '455', '499', '443');
INSERT INTO `school_recruit` VALUES ('309959', '1060', '2011', '3', '2', '13', '441', '504', '430');
INSERT INTO `school_recruit` VALUES ('309961', '1060', '2010', '3', '2', '13', '429', '462', '0');
INSERT INTO `school_recruit` VALUES ('309999', '1065', '2013', '3', '1', '13', '456', '469', '461');
INSERT INTO `school_recruit` VALUES ('310000', '1065', '2012', '3', '1', '13', '511', '531', '505');
INSERT INTO `school_recruit` VALUES ('310002', '1065', '2011', '3', '1', '13', '463', '478', '458');
INSERT INTO `school_recruit` VALUES ('310009', '1065', '2013', '3', '2', '13', '432', '445', '422');
INSERT INTO `school_recruit` VALUES ('310012', '1065', '2012', '3', '2', '13', '460', '478', '449');
INSERT INTO `school_recruit` VALUES ('310015', '1065', '2011', '3', '2', '13', '443', '484', '422');
INSERT INTO `school_recruit` VALUES ('311788', '1089', '2010', '5', '1', '10', '551', '631', '0');
INSERT INTO `school_recruit` VALUES ('311796', '1089', '2010', '5', '2', '10', '546', '626', '0');
INSERT INTO `school_recruit` VALUES ('313563', '1122', '2012', '2', '1', '3', '386', '386', '0');
INSERT INTO `school_recruit` VALUES ('313564', '1122', '2011', '2', '1', '3', '423', '423', '0');
INSERT INTO `school_recruit` VALUES ('313565', '1122', '2010', '2', '1', '3', '404', '404', '0');
INSERT INTO `school_recruit` VALUES ('313568', '1122', '2012', '2', '2', '3', '359', '369', '0');
INSERT INTO `school_recruit` VALUES ('313569', '1122', '2011', '2', '2', '3', '402', '407', '0');
INSERT INTO `school_recruit` VALUES ('313570', '1122', '2010', '2', '2', '3', '402', '405', '0');
INSERT INTO `school_recruit` VALUES ('313756', '1122', '2010', '2', '1', '10', '489', '513', '0');
INSERT INTO `school_recruit` VALUES ('313775', '1122', '2010', '2', '2', '10', '447', '458', '0');
INSERT INTO `school_recruit` VALUES ('313810', '1127', '2011', '4', '1', '34', '229', '294', '0');
INSERT INTO `school_recruit` VALUES ('313812', '1127', '2010', '4', '1', '34', '245', '296', '0');
INSERT INTO `school_recruit` VALUES ('313814', '1127', '2011', '4', '2', '34', '202', '271', '0');
INSERT INTO `school_recruit` VALUES ('313817', '1127', '2010', '4', '2', '34', '205', '277', '0');
INSERT INTO `school_recruit` VALUES ('313861', '1122', '2013', '3', '1', '13', '470', '482', '466');
INSERT INTO `school_recruit` VALUES ('313862', '1122', '2012', '3', '1', '13', '507', '534', '501');
INSERT INTO `school_recruit` VALUES ('313865', '1122', '2011', '3', '1', '13', '464', '480', '458');
INSERT INTO `school_recruit` VALUES ('313867', '1122', '2010', '3', '1', '13', '458', '481', '0');
INSERT INTO `school_recruit` VALUES ('313894', '1122', '2013', '3', '2', '13', '435', '458', '428');
INSERT INTO `school_recruit` VALUES ('313895', '1122', '2012', '3', '2', '13', '460', '483', '450');
INSERT INTO `school_recruit` VALUES ('313898', '1122', '2011', '3', '2', '13', '448', '489', '437');
INSERT INTO `school_recruit` VALUES ('313901', '1122', '2010', '3', '2', '13', '435', '492', '0');
INSERT INTO `school_recruit` VALUES ('314123', '1127', '2011', '4', '1', '10', '374', '395', '0');
INSERT INTO `school_recruit` VALUES ('314125', '1127', '2010', '4', '1', '10', '191', '383', '0');
INSERT INTO `school_recruit` VALUES ('314129', '1127', '2011', '4', '2', '10', '273', '311', '0');
INSERT INTO `school_recruit` VALUES ('314131', '1127', '2010', '4', '2', '10', '181', '363', '0');
INSERT INTO `school_recruit` VALUES ('314209', '1127', '2010', '4', '1', '13', '135', '270', '0');
INSERT INTO `school_recruit` VALUES ('314213', '1127', '2010', '4', '2', '13', '162', '325', '0');
INSERT INTO `school_recruit` VALUES ('314708', '1139', '2010', '4', '1', '10', '302', '316', '0');
INSERT INTO `school_recruit` VALUES ('314711', '1139', '2010', '4', '2', '10', '259', '318', '0');
INSERT INTO `school_recruit` VALUES ('314750', '1139', '2010', '4', '1', '13', '267', '338', '0');
INSERT INTO `school_recruit` VALUES ('314767', '1139', '2010', '4', '2', '13', '284', '304', '0');
INSERT INTO `school_recruit` VALUES ('314960', '1144', '2013', '1', '1', '3', '452', '456', '0');
INSERT INTO `school_recruit` VALUES ('314963', '1144', '2013', '1', '2', '3', '409', '414', '0');
INSERT INTO `school_recruit` VALUES ('315844', '1157', '2010', '2', '1', '10', '473', '511', '0');
INSERT INTO `school_recruit` VALUES ('315850', '1157', '2010', '2', '2', '10', '415', '465', '0');
INSERT INTO `school_recruit` VALUES ('315929', '1157', '2013', '3', '1', '13', '453', '462', '449');
INSERT INTO `school_recruit` VALUES ('315930', '1157', '2012', '3', '1', '13', '494', '510', '486');
INSERT INTO `school_recruit` VALUES ('315931', '1157', '2011', '3', '1', '13', '453', '469', '446');
INSERT INTO `school_recruit` VALUES ('315932', '1157', '2010', '3', '1', '13', '448', '473', '0');
INSERT INTO `school_recruit` VALUES ('315941', '1157', '2013', '3', '2', '13', '417', '438', '406');
INSERT INTO `school_recruit` VALUES ('315943', '1157', '2012', '3', '2', '13', '437', '484', '412');
INSERT INTO `school_recruit` VALUES ('315945', '1157', '2011', '3', '2', '13', '423', '452', '404');
INSERT INTO `school_recruit` VALUES ('315948', '1157', '2010', '3', '2', '13', '407', '480', '0');
INSERT INTO `school_recruit` VALUES ('316198', '1166', '2010', '4', '1', '34', '203', '228', '0');
INSERT INTO `school_recruit` VALUES ('316205', '1166', '2010', '4', '2', '34', '301', '365', '0');
INSERT INTO `school_recruit` VALUES ('316350', '1166', '2010', '4', '1', '10', '279', '289', '0');
INSERT INTO `school_recruit` VALUES ('316351', '1166', '2010', '4', '2', '10', '283', '286', '0');
INSERT INTO `school_recruit` VALUES ('316385', '1166', '2010', '4', '1', '13', '277', '285', '0');
INSERT INTO `school_recruit` VALUES ('316389', '1166', '2010', '4', '2', '13', '202', '202', '0');
INSERT INTO `school_recruit` VALUES ('316527', '1164', '2010', '4', '1', '10', '374', '396', '0');
INSERT INTO `school_recruit` VALUES ('316528', '1164', '2010', '4', '2', '10', '285', '367', '0');
INSERT INTO `school_recruit` VALUES ('316551', '1164', '2010', '4', '1', '13', '237', '286', '0');
INSERT INTO `school_recruit` VALUES ('316553', '1164', '2010', '4', '2', '13', '276', '336', '0');
INSERT INTO `school_recruit` VALUES ('317484', '1188', '2010', '4', '1', '34', '216', '255', '0');
INSERT INTO `school_recruit` VALUES ('317490', '1188', '2010', '4', '2', '34', '194', '227', '0');
INSERT INTO `school_recruit` VALUES ('317497', '1189', '2013', '2', '1', '34', '486', '512', '0');
INSERT INTO `school_recruit` VALUES ('317499', '1189', '2012', '2', '1', '34', '466', '545', '0');
INSERT INTO `school_recruit` VALUES ('317500', '1189', '2011', '2', '1', '34', '494', '523', '0');
INSERT INTO `school_recruit` VALUES ('317503', '1189', '2013', '3', '1', '34', '431', '481', '0');
INSERT INTO `school_recruit` VALUES ('317505', '1189', '2012', '3', '1', '34', '424', '485', '0');
INSERT INTO `school_recruit` VALUES ('317506', '1189', '2011', '3', '1', '34', '456', '521', '0');
INSERT INTO `school_recruit` VALUES ('317509', '1189', '2010', '4', '1', '34', '317', '634', '0');
INSERT INTO `school_recruit` VALUES ('317511', '1189', '2013', '2', '2', '34', '491', '523', '0');
INSERT INTO `school_recruit` VALUES ('317513', '1189', '2012', '2', '2', '34', '442', '483', '0');
INSERT INTO `school_recruit` VALUES ('317515', '1189', '2011', '2', '2', '34', '441', '475', '0');
INSERT INTO `school_recruit` VALUES ('317516', '1189', '2013', '3', '2', '34', '421', '480', '0');
INSERT INTO `school_recruit` VALUES ('317517', '1189', '2012', '3', '2', '34', '418', '451', '0');
INSERT INTO `school_recruit` VALUES ('317518', '1189', '2011', '3', '2', '34', '426', '453', '0');
INSERT INTO `school_recruit` VALUES ('317596', '1190', '2012', '4', '1', '3', '228', '297', '0');
INSERT INTO `school_recruit` VALUES ('317597', '1190', '2011', '4', '1', '3', '157', '314', '0');
INSERT INTO `school_recruit` VALUES ('317599', '1189', '2012', '2', '1', '3', '357', '382', '0');
INSERT INTO `school_recruit` VALUES ('317600', '1189', '2011', '2', '1', '3', '365', '401', '0');
INSERT INTO `school_recruit` VALUES ('317602', '1189', '2012', '3', '1', '3', '344', '361', '0');
INSERT INTO `school_recruit` VALUES ('317603', '1189', '2011', '3', '1', '3', '323', '377', '0');
INSERT INTO `school_recruit` VALUES ('317604', '1190', '2012', '4', '2', '3', '213', '275', '0');
INSERT INTO `school_recruit` VALUES ('317605', '1190', '2011', '4', '2', '3', '150', '301', '0');
INSERT INTO `school_recruit` VALUES ('317606', '1189', '2010', '4', '1', '3', '312', '624', '0');
INSERT INTO `school_recruit` VALUES ('317611', '1189', '2012', '2', '2', '3', '343', '371', '0');
INSERT INTO `school_recruit` VALUES ('317613', '1189', '2011', '2', '2', '3', '333', '367', '0');
INSERT INTO `school_recruit` VALUES ('317622', '1189', '2012', '3', '2', '3', '322', '352', '0');
INSERT INTO `school_recruit` VALUES ('317626', '1189', '2011', '3', '2', '3', '312', '346', '0');
INSERT INTO `school_recruit` VALUES ('317831', '1190', '2012', '4', '1', '10', '317', '385', '0');
INSERT INTO `school_recruit` VALUES ('317833', '1190', '2011', '4', '1', '10', '168', '337', '0');
INSERT INTO `school_recruit` VALUES ('317836', '1190', '2012', '4', '2', '10', '331', '368', '0');
INSERT INTO `school_recruit` VALUES ('317837', '1190', '2011', '4', '2', '10', '155', '311', '0');
INSERT INTO `school_recruit` VALUES ('317876', '1189', '2012', '2', '1', '10', '513', '532', '0');
INSERT INTO `school_recruit` VALUES ('317878', '1189', '2011', '2', '1', '10', '485', '516', '0');
INSERT INTO `school_recruit` VALUES ('317881', '1189', '2012', '3', '1', '10', '491', '508', '0');
INSERT INTO `school_recruit` VALUES ('317883', '1189', '2011', '3', '1', '10', '472', '499', '0');
INSERT INTO `school_recruit` VALUES ('317885', '1189', '2010', '4', '1', '10', '319', '639', '0');
INSERT INTO `school_recruit` VALUES ('317888', '1189', '2012', '2', '2', '10', '432', '471', '0');
INSERT INTO `school_recruit` VALUES ('317892', '1189', '2011', '2', '2', '10', '488', '506', '0');
INSERT INTO `school_recruit` VALUES ('317896', '1189', '2012', '3', '2', '10', '418', '455', '0');
INSERT INTO `school_recruit` VALUES ('317901', '1189', '2011', '3', '2', '10', '464', '496', '0');
INSERT INTO `school_recruit` VALUES ('317949', '1190', '2012', '4', '1', '13', '220', '440', '0');
INSERT INTO `school_recruit` VALUES ('317953', '1190', '2011', '4', '1', '13', '351', '443', '0');
INSERT INTO `school_recruit` VALUES ('317964', '1190', '2012', '4', '2', '13', '202', '404', '0');
INSERT INTO `school_recruit` VALUES ('317968', '1190', '2011', '4', '2', '13', '295', '391', '0');
INSERT INTO `school_recruit` VALUES ('318022', '1189', '2013', '2', '1', '13', '405', '456', '0');
INSERT INTO `school_recruit` VALUES ('318023', '1189', '2012', '2', '1', '13', '228', '540', '0');
INSERT INTO `school_recruit` VALUES ('318024', '1189', '2011', '2', '1', '13', '492', '511', '0');
INSERT INTO `school_recruit` VALUES ('318026', '1189', '2013', '3', '1', '13', '380', '442', '0');
INSERT INTO `school_recruit` VALUES ('318027', '1189', '2012', '3', '1', '13', '504', '521', '0');
INSERT INTO `school_recruit` VALUES ('318029', '1189', '2011', '3', '1', '13', '467', '486', '0');
INSERT INTO `school_recruit` VALUES ('318032', '1189', '2010', '4', '1', '13', '304', '608', '0');
INSERT INTO `school_recruit` VALUES ('318034', '1189', '2013', '2', '2', '13', '385', '434', '0');
INSERT INTO `school_recruit` VALUES ('318035', '1189', '2012', '2', '2', '13', '491', '518', '0');
INSERT INTO `school_recruit` VALUES ('318037', '1189', '2011', '2', '2', '13', '491', '538', '0');
INSERT INTO `school_recruit` VALUES ('318039', '1189', '2013', '3', '2', '13', '368', '420', '0');
INSERT INTO `school_recruit` VALUES ('318041', '1189', '2012', '3', '2', '13', '463', '498', '0');
INSERT INTO `school_recruit` VALUES ('318043', '1189', '2011', '3', '2', '13', '477', '511', '0');
INSERT INTO `school_recruit` VALUES ('320261', '1230', '2010', '4', '1', '10', '321', '357', '0');
INSERT INTO `school_recruit` VALUES ('320266', '1230', '2010', '4', '2', '10', '273', '389', '0');
INSERT INTO `school_recruit` VALUES ('320326', '1230', '2010', '4', '1', '13', '203', '241', '0');
INSERT INTO `school_recruit` VALUES ('320347', '1230', '2010', '4', '2', '13', '349', '412', '0');
INSERT INTO `school_recruit` VALUES ('320693', '1235', '2011', '1', '1', '13', '301', '603', '0');
INSERT INTO `school_recruit` VALUES ('320728', '1236', '2012', '2', '2', '3', '364', '385', '0');
INSERT INTO `school_recruit` VALUES ('320732', '1236', '2011', '2', '2', '3', '399', '409', '0');
INSERT INTO `school_recruit` VALUES ('320733', '1236', '2010', '2', '2', '3', '405', '416', '0');
INSERT INTO `school_recruit` VALUES ('320837', '1236', '2010', '2', '1', '10', '491', '526', '0');
INSERT INTO `school_recruit` VALUES ('320841', '1236', '2010', '2', '2', '10', '444', '513', '0');
INSERT INTO `school_recruit` VALUES ('320912', '1236', '2013', '3', '2', '13', '428', '451', '408');
INSERT INTO `school_recruit` VALUES ('320913', '1236', '2012', '3', '2', '13', '461', '475', '0');
INSERT INTO `school_recruit` VALUES ('320914', '1236', '2011', '3', '2', '13', '451', '462', '0');
INSERT INTO `school_recruit` VALUES ('320915', '1236', '2010', '3', '2', '13', '433', '453', '0');
INSERT INTO `school_recruit` VALUES ('321704', '1257', '2010', '5', '1', '34', '490', '563', '0');
INSERT INTO `school_recruit` VALUES ('321718', '1257', '2010', '5', '2', '34', '473', '550', '0');
INSERT INTO `school_recruit` VALUES ('322071', '1257', '2010', '1', '1', '10', '379', '484', '0');
INSERT INTO `school_recruit` VALUES ('322077', '1257', '2010', '1', '2', '10', '302', '426', '0');
INSERT INTO `school_recruit` VALUES ('322203', '1257', '2010', '1', '1', '13', '320', '420', '0');
INSERT INTO `school_recruit` VALUES ('322220', '1257', '2010', '1', '2', '13', '415', '465', '0');
INSERT INTO `school_recruit` VALUES ('322819', '1271', '2010', '4', '1', '10', '402', '408', '0');
INSERT INTO `school_recruit` VALUES ('322823', '1271', '2010', '4', '2', '10', '299', '373', '0');
INSERT INTO `school_recruit` VALUES ('322856', '1271', '2010', '4', '1', '13', '209', '216', '0');
INSERT INTO `school_recruit` VALUES ('322857', '1271', '2010', '4', '2', '13', '269', '293', '0');
INSERT INTO `school_recruit` VALUES ('324942', '1296', '2010', '4', '1', '10', '357', '384', '0');
INSERT INTO `school_recruit` VALUES ('324949', '1296', '2010', '4', '2', '10', '261', '279', '0');
INSERT INTO `school_recruit` VALUES ('325104', '1296', '2010', '4', '1', '13', '217', '293', '0');
INSERT INTO `school_recruit` VALUES ('325112', '1296', '2010', '4', '2', '13', '280', '315', '0');
INSERT INTO `school_recruit` VALUES ('325670', '1309', '2013', '2', '1', '3', '406', '409', '0');
INSERT INTO `school_recruit` VALUES ('325672', '1309', '2012', '2', '1', '3', '385', '400', '0');
INSERT INTO `school_recruit` VALUES ('325676', '1309', '2011', '2', '1', '3', '418', '423', '0');
INSERT INTO `school_recruit` VALUES ('325681', '1309', '2010', '2', '1', '3', '420', '433', '0');
INSERT INTO `school_recruit` VALUES ('325691', '1309', '2013', '2', '2', '3', '332', '333', '0');
INSERT INTO `school_recruit` VALUES ('325693', '1309', '2012', '2', '2', '3', '354', '375', '0');
INSERT INTO `school_recruit` VALUES ('325695', '1309', '2011', '2', '2', '3', '398', '400', '0');
INSERT INTO `school_recruit` VALUES ('325697', '1309', '2010', '2', '2', '3', '406', '418', '0');
INSERT INTO `school_recruit` VALUES ('325956', '1309', '2010', '2', '1', '10', '490', '504', '0');
INSERT INTO `school_recruit` VALUES ('325976', '1309', '2010', '2', '2', '10', '440', '452', '0');
INSERT INTO `school_recruit` VALUES ('326077', '1309', '2013', '3', '1', '13', '472', '482', '468');
INSERT INTO `school_recruit` VALUES ('326080', '1309', '2012', '3', '1', '13', '508', '532', '502');
INSERT INTO `school_recruit` VALUES ('326081', '1309', '2011', '3', '1', '13', '467', '492', '461');
INSERT INTO `school_recruit` VALUES ('326082', '1309', '2010', '3', '1', '13', '462', '493', '0');
INSERT INTO `school_recruit` VALUES ('326089', '1309', '2013', '3', '2', '13', '437', '454', '431');
INSERT INTO `school_recruit` VALUES ('326091', '1309', '2012', '3', '2', '13', '459', '478', '449');
INSERT INTO `school_recruit` VALUES ('326093', '1309', '2011', '3', '2', '13', '447', '470', '438');
INSERT INTO `school_recruit` VALUES ('326094', '1309', '2010', '3', '2', '13', '437', '459', '0');
INSERT INTO `school_recruit` VALUES ('326657', '1318', '2010', '4', '1', '10', '309', '315', '0');
INSERT INTO `school_recruit` VALUES ('326663', '1318', '2010', '4', '2', '10', '316', '385', '0');
INSERT INTO `school_recruit` VALUES ('326750', '1318', '2010', '4', '1', '13', '258', '351', '0');
INSERT INTO `school_recruit` VALUES ('326760', '1318', '2010', '4', '2', '13', '347', '362', '0');
INSERT INTO `school_recruit` VALUES ('327214', '1324', '2010', '2', '1', '10', '468', '533', '0');
INSERT INTO `school_recruit` VALUES ('327217', '1329', '2012', '3', '1', '34', '424', '432', '0');
INSERT INTO `school_recruit` VALUES ('327218', '1329', '2011', '3', '1', '34', '449', '452', '0');
INSERT INTO `school_recruit` VALUES ('327219', '1329', '2010', '3', '1', '34', '445', '453', '0');
INSERT INTO `school_recruit` VALUES ('327221', '1324', '2010', '2', '2', '10', '415', '477', '0');
INSERT INTO `school_recruit` VALUES ('327227', '1329', '2012', '3', '2', '34', '413', '414', '0');
INSERT INTO `school_recruit` VALUES ('327228', '1329', '2011', '3', '2', '34', '414', '414', '0');
INSERT INTO `school_recruit` VALUES ('327231', '1329', '2010', '3', '2', '34', '410', '416', '0');
INSERT INTO `school_recruit` VALUES ('327297', '1324', '2013', '3', '1', '13', '466', '471', '453');
INSERT INTO `school_recruit` VALUES ('327298', '1324', '2012', '3', '1', '13', '477', '503', '452');
INSERT INTO `school_recruit` VALUES ('327299', '1324', '2011', '3', '1', '13', '456', '478', '418');
INSERT INTO `school_recruit` VALUES ('327300', '1324', '2013', '3', '2', '13', '425', '432', '409');
INSERT INTO `school_recruit` VALUES ('327301', '1324', '2012', '3', '2', '13', '432', '442', '417');
INSERT INTO `school_recruit` VALUES ('327302', '1324', '2011', '3', '2', '13', '425', '496', '373');
INSERT INTO `school_recruit` VALUES ('327370', '1329', '2013', '2', '1', '3', '403', '403', '0');
INSERT INTO `school_recruit` VALUES ('327373', '1329', '2012', '2', '1', '3', '386', '404', '0');
INSERT INTO `school_recruit` VALUES ('327376', '1329', '2011', '2', '1', '3', '416', '418', '0');
INSERT INTO `school_recruit` VALUES ('327379', '1329', '2010', '2', '1', '3', '411', '411', '0');
INSERT INTO `school_recruit` VALUES ('327403', '1329', '2012', '2', '2', '3', '348', '364', '0');
INSERT INTO `school_recruit` VALUES ('327404', '1329', '2011', '2', '2', '3', '394', '397', '0');
INSERT INTO `school_recruit` VALUES ('327405', '1329', '2010', '2', '2', '3', '404', '408', '0');
INSERT INTO `school_recruit` VALUES ('327699', '1329', '2010', '2', '1', '10', '491', '504', '0');
INSERT INTO `school_recruit` VALUES ('327719', '1329', '2010', '2', '2', '10', '447', '460', '0');
INSERT INTO `school_recruit` VALUES ('327813', '1329', '2013', '3', '1', '13', '451', '459', '444');
INSERT INTO `school_recruit` VALUES ('327817', '1329', '2012', '3', '1', '13', '485', '527', '0');
INSERT INTO `school_recruit` VALUES ('327820', '1329', '2011', '3', '1', '13', '453', '494', '0');
INSERT INTO `school_recruit` VALUES ('327824', '1329', '2010', '3', '1', '13', '451', '477', '0');
INSERT INTO `school_recruit` VALUES ('327845', '1329', '2013', '3', '2', '13', '415', '424', '406');
INSERT INTO `school_recruit` VALUES ('327847', '1329', '2012', '3', '2', '13', '442', '489', '0');
INSERT INTO `school_recruit` VALUES ('327848', '1329', '2011', '3', '2', '13', '437', '472', '0');
INSERT INTO `school_recruit` VALUES ('327849', '1329', '2010', '3', '2', '13', '432', '467', '0');
INSERT INTO `school_recruit` VALUES ('328294', '1338', '2012', '4', '1', '34', '161', '217', '0');
INSERT INTO `school_recruit` VALUES ('328299', '1338', '2012', '4', '2', '34', '162', '219', '0');
INSERT INTO `school_recruit` VALUES ('328334', '1338', '2012', '4', '1', '3', '233', '308', '0');
INSERT INTO `school_recruit` VALUES ('328338', '1338', '2012', '4', '2', '3', '219', '288', '0');
INSERT INTO `school_recruit` VALUES ('328392', '1338', '2012', '4', '1', '10', '311', '374', '0');
INSERT INTO `school_recruit` VALUES ('328393', '1338', '2012', '4', '2', '10', '337', '381', '0');
INSERT INTO `school_recruit` VALUES ('328421', '1338', '2012', '4', '1', '13', '244', '489', '0');
INSERT INTO `school_recruit` VALUES ('328422', '1338', '2012', '4', '2', '13', '217', '435', '0');
INSERT INTO `school_recruit` VALUES ('328797', '1348', '2011', '4', '1', '3', '143', '286', '0');
INSERT INTO `school_recruit` VALUES ('328799', '1348', '2011', '4', '2', '3', '151', '303', '0');
INSERT INTO `school_recruit` VALUES ('328922', '1348', '2011', '4', '1', '10', '171', '342', '0');
INSERT INTO `school_recruit` VALUES ('328928', '1348', '2011', '4', '2', '10', '164', '328', '0');
INSERT INTO `school_recruit` VALUES ('328969', '1348', '2011', '4', '1', '13', '316', '372', '0');
INSERT INTO `school_recruit` VALUES ('328970', '1348', '2011', '4', '2', '13', '319', '438', '0');
INSERT INTO `school_recruit` VALUES ('329072', '1353', '2013', '3', '1', '34', '454', '454', '0');
INSERT INTO `school_recruit` VALUES ('329073', '1353', '2010', '3', '1', '34', '451', '462', '0');
INSERT INTO `school_recruit` VALUES ('329080', '1353', '2012', '3', '2', '34', '421', '421', '0');
INSERT INTO `school_recruit` VALUES ('329083', '1353', '2011', '3', '2', '34', '407', '407', '0');
INSERT INTO `school_recruit` VALUES ('329085', '1353', '2010', '3', '2', '34', '409', '411', '0');
INSERT INTO `school_recruit` VALUES ('329157', '1353', '2013', '2', '1', '3', '403', '403', '0');
INSERT INTO `school_recruit` VALUES ('329158', '1353', '2012', '2', '1', '3', '388', '388', '0');
INSERT INTO `school_recruit` VALUES ('329159', '1353', '2011', '2', '1', '3', '429', '429', '0');
INSERT INTO `school_recruit` VALUES ('329166', '1353', '2013', '2', '2', '3', '337', '343', '0');
INSERT INTO `school_recruit` VALUES ('329167', '1353', '2012', '2', '2', '3', '346', '349', '0');
INSERT INTO `school_recruit` VALUES ('329168', '1353', '2011', '2', '2', '3', '398', '402', '0');
INSERT INTO `school_recruit` VALUES ('329429', '1353', '2010', '2', '1', '10', '484', '491', '0');
INSERT INTO `school_recruit` VALUES ('329435', '1353', '2010', '2', '2', '10', '440', '458', '0');
INSERT INTO `school_recruit` VALUES ('329541', '1353', '2013', '3', '1', '13', '458', '474', '453');
INSERT INTO `school_recruit` VALUES ('329542', '1353', '2012', '3', '1', '13', '487', '519', '480');
INSERT INTO `school_recruit` VALUES ('329544', '1353', '2011', '3', '1', '13', '452', '481', '444');
INSERT INTO `school_recruit` VALUES ('329546', '1353', '2010', '3', '1', '13', '438', '468', '0');
INSERT INTO `school_recruit` VALUES ('329572', '1353', '2013', '3', '2', '13', '421', '459', '412');
INSERT INTO `school_recruit` VALUES ('329573', '1353', '2012', '3', '2', '13', '435', '487', '422');
INSERT INTO `school_recruit` VALUES ('329574', '1353', '2011', '3', '2', '13', '424', '485', '412');
INSERT INTO `school_recruit` VALUES ('329575', '1353', '2010', '3', '2', '13', '410', '458', '0');
INSERT INTO `school_recruit` VALUES ('329719', '1357', '2010', '2', '1', '10', '497', '526', '0');
INSERT INTO `school_recruit` VALUES ('329730', '1357', '2010', '2', '2', '10', '438', '469', '0');
INSERT INTO `school_recruit` VALUES ('329876', '1357', '2013', '3', '1', '13', '463', '465', '462');
INSERT INTO `school_recruit` VALUES ('329884', '1357', '2013', '3', '2', '13', '430', '455', '424');
INSERT INTO `school_recruit` VALUES ('329886', '1357', '2012', '3', '2', '13', '430', '456', '408');
INSERT INTO `school_recruit` VALUES ('330675', '1371', '2010', '4', '1', '10', '307', '415', '0');
INSERT INTO `school_recruit` VALUES ('330676', '1371', '2010', '4', '2', '10', '263', '264', '0');
INSERT INTO `school_recruit` VALUES ('330689', '1371', '2010', '4', '1', '13', '278', '328', '0');
INSERT INTO `school_recruit` VALUES ('330690', '1371', '2010', '4', '2', '13', '296', '362', '0');
INSERT INTO `school_recruit` VALUES ('331006', '1381', '2010', '3', '1', '34', '444', '444', '0');
INSERT INTO `school_recruit` VALUES ('331026', '1381', '2012', '3', '2', '34', '414', '414', '0');
INSERT INTO `school_recruit` VALUES ('331028', '1381', '2010', '3', '2', '34', '411', '411', '0');
INSERT INTO `school_recruit` VALUES ('331108', '1381', '2013', '2', '1', '3', '403', '403', '0');
INSERT INTO `school_recruit` VALUES ('331111', '1381', '2012', '2', '1', '3', '388', '402', '0');
INSERT INTO `school_recruit` VALUES ('331113', '1381', '2011', '2', '1', '3', '415', '417', '0');
INSERT INTO `school_recruit` VALUES ('331115', '1381', '2010', '2', '1', '3', '406', '409', '0');
INSERT INTO `school_recruit` VALUES ('331127', '1381', '2012', '2', '2', '3', '354', '367', '0');
INSERT INTO `school_recruit` VALUES ('331129', '1381', '2011', '2', '2', '3', '398', '405', '0');
INSERT INTO `school_recruit` VALUES ('331131', '1381', '2010', '2', '2', '3', '403', '403', '0');
INSERT INTO `school_recruit` VALUES ('331362', '1381', '2010', '2', '1', '10', '494', '500', '0');
INSERT INTO `school_recruit` VALUES ('331373', '1381', '2010', '2', '2', '10', '437', '457', '0');
INSERT INTO `school_recruit` VALUES ('331457', '1383', '2012', '2', '1', '3', '400', '410', '0');
INSERT INTO `school_recruit` VALUES ('331458', '1383', '2012', '2', '2', '3', '383', '415', '0');
INSERT INTO `school_recruit` VALUES ('331460', '1381', '2013', '3', '1', '13', '463', '494', '457');
INSERT INTO `school_recruit` VALUES ('331462', '1381', '2012', '3', '1', '13', '497', '520', '492');
INSERT INTO `school_recruit` VALUES ('331464', '1381', '2011', '3', '1', '13', '454', '483', '448');
INSERT INTO `school_recruit` VALUES ('331466', '1381', '2010', '3', '1', '13', '446', '474', '0');
INSERT INTO `school_recruit` VALUES ('331476', '1381', '2013', '3', '2', '13', '422', '468', '414');
INSERT INTO `school_recruit` VALUES ('331478', '1381', '2012', '3', '2', '13', '443', '497', '432');
INSERT INTO `school_recruit` VALUES ('331480', '1381', '2011', '3', '2', '13', '432', '480', '421');
INSERT INTO `school_recruit` VALUES ('331482', '1381', '2010', '3', '2', '13', '424', '483', '0');
INSERT INTO `school_recruit` VALUES ('331610', '1383', '2010', '2', '1', '10', '502', '553', '0');
INSERT INTO `school_recruit` VALUES ('331623', '1383', '2010', '2', '2', '10', '450', '507', '0');
INSERT INTO `school_recruit` VALUES ('332403', '1398', '2010', '4', '1', '10', '287', '290', '0');
INSERT INTO `school_recruit` VALUES ('332410', '1398', '2010', '4', '2', '10', '279', '347', '0');
INSERT INTO `school_recruit` VALUES ('332470', '1398', '2010', '4', '1', '13', '208', '220', '0');
INSERT INTO `school_recruit` VALUES ('332472', '1398', '2010', '4', '2', '13', '320', '329', '0');
INSERT INTO `school_recruit` VALUES ('333165', '1413', '2012', '3', '1', '34', '424', '425', '0');
INSERT INTO `school_recruit` VALUES ('333166', '1413', '2011', '3', '1', '34', '457', '457', '0');
INSERT INTO `school_recruit` VALUES ('333167', '1413', '2012', '3', '2', '34', '413', '425', '0');
INSERT INTO `school_recruit` VALUES ('333170', '1413', '2011', '3', '2', '34', '420', '420', '0');
INSERT INTO `school_recruit` VALUES ('333172', '1413', '2010', '3', '2', '34', '405', '409', '0');
INSERT INTO `school_recruit` VALUES ('333265', '1413', '2013', '2', '1', '3', '404', '405', '0');
INSERT INTO `school_recruit` VALUES ('333267', '1413', '2012', '2', '1', '3', '387', '394', '0');
INSERT INTO `school_recruit` VALUES ('333277', '1413', '2012', '2', '2', '3', '349', '358', '0');
INSERT INTO `school_recruit` VALUES ('333279', '1413', '2011', '2', '2', '3', '396', '401', '0');
INSERT INTO `school_recruit` VALUES ('333532', '1413', '2010', '2', '1', '10', '496', '508', '0');
INSERT INTO `school_recruit` VALUES ('333552', '1413', '2010', '2', '2', '10', '434', '456', '0');
INSERT INTO `school_recruit` VALUES ('333687', '1413', '2013', '3', '1', '13', '454', '465', '460');
INSERT INTO `school_recruit` VALUES ('333690', '1413', '2012', '3', '1', '13', '497', '551', '490');
INSERT INTO `school_recruit` VALUES ('333693', '1413', '2011', '3', '1', '13', '456', '479', '449');
INSERT INTO `school_recruit` VALUES ('333695', '1413', '2010', '3', '1', '13', '452', '474', '0');
INSERT INTO `school_recruit` VALUES ('333705', '1413', '2013', '3', '2', '13', '425', '448', '418');
INSERT INTO `school_recruit` VALUES ('333706', '1413', '2012', '3', '2', '13', '445', '488', '434');
INSERT INTO `school_recruit` VALUES ('333708', '1413', '2011', '3', '2', '13', '429', '485', '419');
INSERT INTO `school_recruit` VALUES ('333710', '1413', '2010', '3', '2', '13', '417', '461', '0');
INSERT INTO `school_recruit` VALUES ('333869', '1427', '2011', '2', '1', '34', '275', '360', '0');
INSERT INTO `school_recruit` VALUES ('333873', '1427', '2010', '2', '1', '34', '334', '340', '0');
INSERT INTO `school_recruit` VALUES ('333896', '1427', '2011', '2', '2', '34', '285', '291', '0');
INSERT INTO `school_recruit` VALUES ('333898', '1427', '2010', '2', '2', '34', '259', '284', '0');
INSERT INTO `school_recruit` VALUES ('334146', '1427', '2011', '2', '1', '10', '325', '430', '0');
INSERT INTO `school_recruit` VALUES ('334152', '1427', '2010', '2', '1', '10', '323', '345', '0');
INSERT INTO `school_recruit` VALUES ('334159', '1427', '2011', '2', '2', '10', '325', '372', '0');
INSERT INTO `school_recruit` VALUES ('334165', '1427', '2010', '2', '2', '10', '277', '299', '0');
INSERT INTO `school_recruit` VALUES ('334238', '1427', '2011', '2', '1', '13', '210', '242', '0');
INSERT INTO `school_recruit` VALUES ('334240', '1427', '2010', '2', '1', '13', '239', '288', '0');
INSERT INTO `school_recruit` VALUES ('334246', '1427', '2011', '2', '2', '13', '351', '357', '0');
INSERT INTO `school_recruit` VALUES ('334249', '1427', '2010', '2', '2', '13', '309', '379', '0');
INSERT INTO `school_recruit` VALUES ('334597', '1432', '2010', '2', '1', '10', '467', '527', '0');
INSERT INTO `school_recruit` VALUES ('334603', '1432', '2010', '2', '2', '10', '410', '469', '0');
INSERT INTO `school_recruit` VALUES ('334652', '1432', '2011', '3', '1', '13', '432', '439', '421');
INSERT INTO `school_recruit` VALUES ('334653', '1432', '2010', '3', '1', '13', '432', '445', '0');
INSERT INTO `school_recruit` VALUES ('334660', '1432', '2011', '3', '2', '13', '409', '446', '391');
INSERT INTO `school_recruit` VALUES ('334662', '1432', '2010', '3', '2', '13', '437', '459', '0');
INSERT INTO `school_recruit` VALUES ('334827', '1440', '2013', '2', '1', '13', '488', '488', '484');
INSERT INTO `school_recruit` VALUES ('334829', '1440', '2013', '2', '2', '13', '457', '461', '456');
INSERT INTO `school_recruit` VALUES ('334839', '1445', '2013', '3', '1', '34', '456', '458', '0');
INSERT INTO `school_recruit` VALUES ('334840', '1445', '2012', '3', '2', '34', '406', '406', '0');
INSERT INTO `school_recruit` VALUES ('334841', '1445', '2010', '3', '2', '34', '407', '407', '0');
INSERT INTO `school_recruit` VALUES ('334889', '1445', '2010', '2', '1', '10', '501', '534', '0');
INSERT INTO `school_recruit` VALUES ('334896', '1445', '2010', '2', '2', '10', '448', '512', '0');
INSERT INTO `school_recruit` VALUES ('334934', '1445', '2013', '3', '1', '13', '460', '467', '444');
INSERT INTO `school_recruit` VALUES ('334936', '1445', '2012', '3', '1', '13', '503', '508', '500');
INSERT INTO `school_recruit` VALUES ('334937', '1445', '2011', '3', '1', '13', '464', '482', '456');
INSERT INTO `school_recruit` VALUES ('334941', '1445', '2013', '3', '2', '13', '433', '450', '424');
INSERT INTO `school_recruit` VALUES ('334942', '1445', '2012', '3', '2', '13', '464', '492', '454');
INSERT INTO `school_recruit` VALUES ('334943', '1445', '2011', '3', '2', '13', '454', '470', '445');
INSERT INTO `school_recruit` VALUES ('334944', '1445', '2010', '3', '2', '13', '440', '493', '0');
INSERT INTO `school_recruit` VALUES ('335041', '1448', '2010', '4', '1', '10', '207', '414', '0');
INSERT INTO `school_recruit` VALUES ('335043', '1448', '2010', '4', '2', '10', '181', '362', '0');
INSERT INTO `school_recruit` VALUES ('335055', '1448', '2010', '4', '1', '13', '160', '321', '0');
INSERT INTO `school_recruit` VALUES ('335056', '1448', '2010', '4', '2', '13', '172', '345', '0');
INSERT INTO `school_recruit` VALUES ('335087', '1452', '2010', '2', '1', '10', '484', '523', '0');
INSERT INTO `school_recruit` VALUES ('335091', '1452', '2010', '2', '2', '10', '427', '510', '0');
INSERT INTO `school_recruit` VALUES ('335177', '1456', '2010', '2', '1', '10', '498', '528', '0');
INSERT INTO `school_recruit` VALUES ('335181', '1456', '2010', '2', '2', '10', '441', '493', '0');
INSERT INTO `school_recruit` VALUES ('335214', '1456', '2013', '3', '2', '13', '431', '453', '415');
INSERT INTO `school_recruit` VALUES ('335216', '1456', '2012', '3', '2', '13', '459', '481', '441');
INSERT INTO `school_recruit` VALUES ('335218', '1456', '2011', '3', '2', '13', '432', '464', '416');
INSERT INTO `school_recruit` VALUES ('335219', '1456', '2010', '3', '2', '13', '412', '457', '0');
INSERT INTO `school_recruit` VALUES ('335354', '1463', '2013', '2', '1', '3', '405', '408', '0');
INSERT INTO `school_recruit` VALUES ('335355', '1463', '2012', '2', '1', '3', '399', '399', '0');
INSERT INTO `school_recruit` VALUES ('335356', '1463', '2010', '2', '1', '3', '406', '406', '0');
INSERT INTO `school_recruit` VALUES ('335361', '1463', '2013', '2', '2', '3', '336', '342', '0');
INSERT INTO `school_recruit` VALUES ('335362', '1463', '2012', '2', '2', '3', '349', '355', '0');
INSERT INTO `school_recruit` VALUES ('335363', '1463', '2011', '2', '2', '3', '424', '424', '0');
INSERT INTO `school_recruit` VALUES ('335364', '1463', '2010', '2', '2', '3', '403', '404', '0');
INSERT INTO `school_recruit` VALUES ('335517', '1463', '2010', '2', '1', '10', '474', '510', '0');
INSERT INTO `school_recruit` VALUES ('335551', '1463', '2010', '2', '2', '10', '418', '470', '0');
INSERT INTO `school_recruit` VALUES ('335585', '1466', '2012', '2', '1', '3', '395', '403', '0');
INSERT INTO `school_recruit` VALUES ('335586', '1466', '2012', '2', '2', '3', '357', '369', '0');
INSERT INTO `school_recruit` VALUES ('335587', '1466', '2011', '2', '2', '3', '402', '407', '0');
INSERT INTO `school_recruit` VALUES ('335589', '1466', '2010', '2', '2', '3', '403', '425', '0');
INSERT INTO `school_recruit` VALUES ('335651', '1463', '2013', '3', '1', '13', '466', '467', '444');
INSERT INTO `school_recruit` VALUES ('335653', '1463', '2012', '3', '1', '13', '496', '514', '489');
INSERT INTO `school_recruit` VALUES ('335655', '1463', '2011', '3', '1', '13', '452', '457', '449');
INSERT INTO `school_recruit` VALUES ('335657', '1463', '2010', '3', '1', '13', '446', '466', '0');
INSERT INTO `school_recruit` VALUES ('335665', '1463', '2013', '3', '2', '13', '423', '429', '406');
INSERT INTO `school_recruit` VALUES ('335667', '1463', '2012', '3', '2', '13', '448', '452', '441');
INSERT INTO `school_recruit` VALUES ('335668', '1463', '2011', '3', '2', '13', '450', '465', '427');
INSERT INTO `school_recruit` VALUES ('335669', '1463', '2010', '3', '2', '13', '430', '436', '0');
INSERT INTO `school_recruit` VALUES ('335717', '1466', '2010', '2', '1', '10', '477', '533', '0');
INSERT INTO `school_recruit` VALUES ('335723', '1466', '2010', '2', '2', '10', '414', '472', '0');
INSERT INTO `school_recruit` VALUES ('335772', '1466', '2013', '3', '1', '13', '447', '449', '444');
INSERT INTO `school_recruit` VALUES ('335773', '1466', '2012', '3', '1', '13', '465', '474', '454');
INSERT INTO `school_recruit` VALUES ('335774', '1466', '2011', '3', '1', '13', '429', '437', '418');
INSERT INTO `school_recruit` VALUES ('335775', '1466', '2010', '3', '1', '13', '450', '474', '0');
INSERT INTO `school_recruit` VALUES ('335776', '1466', '2013', '3', '2', '13', '409', '415', '406');
INSERT INTO `school_recruit` VALUES ('335777', '1466', '2012', '3', '2', '13', '397', '413', '378');
INSERT INTO `school_recruit` VALUES ('335778', '1466', '2011', '3', '2', '13', '403', '434', '373');
INSERT INTO `school_recruit` VALUES ('335779', '1466', '2010', '3', '2', '13', '418', '461', '0');
INSERT INTO `school_recruit` VALUES ('336310', '1475', '2010', '4', '1', '10', '357', '384', '0');
INSERT INTO `school_recruit` VALUES ('336318', '1475', '2010', '4', '2', '10', '261', '279', '0');
INSERT INTO `school_recruit` VALUES ('336361', '1475', '2010', '4', '1', '13', '217', '293', '0');
INSERT INTO `school_recruit` VALUES ('336368', '1475', '2010', '4', '2', '13', '280', '315', '0');
INSERT INTO `school_recruit` VALUES ('336580', '1482', '2010', '3', '1', '34', '446', '446', '0');
INSERT INTO `school_recruit` VALUES ('336601', '1482', '2011', '3', '2', '34', '407', '407', '0');
INSERT INTO `school_recruit` VALUES ('336602', '1482', '2010', '3', '2', '34', '426', '426', '0');
INSERT INTO `school_recruit` VALUES ('336683', '1482', '2013', '2', '1', '3', '404', '406', '0');
INSERT INTO `school_recruit` VALUES ('336684', '1482', '2012', '2', '1', '3', '396', '406', '0');
INSERT INTO `school_recruit` VALUES ('336685', '1482', '2010', '2', '1', '3', '408', '408', '0');
INSERT INTO `school_recruit` VALUES ('336694', '1482', '2013', '2', '2', '3', '334', '337', '0');
INSERT INTO `school_recruit` VALUES ('336695', '1482', '2012', '2', '2', '3', '351', '356', '0');
INSERT INTO `school_recruit` VALUES ('336696', '1482', '2011', '2', '2', '3', '393', '394', '0');
INSERT INTO `school_recruit` VALUES ('336697', '1482', '2010', '2', '2', '3', '403', '404', '0');
INSERT INTO `school_recruit` VALUES ('336877', '1482', '2010', '2', '1', '10', '490', '506', '0');
INSERT INTO `school_recruit` VALUES ('336883', '1482', '2010', '2', '2', '10', '439', '482', '0');
INSERT INTO `school_recruit` VALUES ('336945', '1482', '2013', '3', '1', '13', '449', '477', '444');
INSERT INTO `school_recruit` VALUES ('336946', '1482', '2012', '3', '1', '13', '475', '513', '466');
INSERT INTO `school_recruit` VALUES ('336947', '1482', '2011', '3', '1', '13', '439', '473', '432');
INSERT INTO `school_recruit` VALUES ('336948', '1482', '2010', '3', '1', '13', '428', '472', '0');
INSERT INTO `school_recruit` VALUES ('336957', '1482', '2013', '3', '2', '13', '413', '453', '406');
INSERT INTO `school_recruit` VALUES ('336960', '1482', '2012', '3', '2', '13', '422', '496', '412');
INSERT INTO `school_recruit` VALUES ('336962', '1482', '2011', '3', '2', '13', '409', '466', '400');
INSERT INTO `school_recruit` VALUES ('336964', '1482', '2010', '3', '2', '13', '398', '466', '0');
INSERT INTO `school_recruit` VALUES ('337445', '1497', '2010', '4', '1', '10', '305', '327', '0');
INSERT INTO `school_recruit` VALUES ('337446', '1497', '2010', '4', '2', '10', '263', '266', '0');
INSERT INTO `school_recruit` VALUES ('337455', '1497', '2010', '4', '1', '13', '211', '248', '0');
INSERT INTO `school_recruit` VALUES ('337456', '1497', '2010', '4', '2', '13', '324', '345', '0');
INSERT INTO `school_recruit` VALUES ('337529', '1501', '2010', '4', '1', '10', '291', '379', '0');
INSERT INTO `school_recruit` VALUES ('337540', '1501', '2010', '4', '2', '10', '275', '282', '0');
INSERT INTO `school_recruit` VALUES ('337552', '1501', '2010', '4', '1', '13', '225', '241', '0');
INSERT INTO `school_recruit` VALUES ('337553', '1501', '2010', '4', '2', '13', '349', '385', '0');
INSERT INTO `school_recruit` VALUES ('337726', '1510', '2010', '2', '1', '10', '469', '507', '0');
INSERT INTO `school_recruit` VALUES ('337733', '1510', '2010', '2', '2', '10', '413', '473', '0');
INSERT INTO `school_recruit` VALUES ('337767', '1510', '2013', '3', '2', '13', '419', '441', '406');
INSERT INTO `school_recruit` VALUES ('337768', '1510', '2012', '3', '2', '13', '447', '464', '430');
INSERT INTO `school_recruit` VALUES ('337769', '1510', '2011', '3', '2', '13', '432', '472', '411');
INSERT INTO `school_recruit` VALUES ('337770', '1510', '2010', '3', '2', '13', '413', '459', '0');
INSERT INTO `school_recruit` VALUES ('338545', '1536', '2010', '2', '1', '10', '486', '500', '0');
INSERT INTO `school_recruit` VALUES ('338550', '1536', '2010', '2', '2', '10', '433', '451', '0');
INSERT INTO `school_recruit` VALUES ('338636', '1536', '2013', '3', '1', '13', '460', '476', '455');
INSERT INTO `school_recruit` VALUES ('338637', '1536', '2012', '3', '1', '13', '490', '514', '484');
INSERT INTO `school_recruit` VALUES ('338638', '1536', '2011', '3', '1', '13', '451', '508', '0');
INSERT INTO `school_recruit` VALUES ('338639', '1536', '2010', '3', '1', '13', '442', '472', '0');
INSERT INTO `school_recruit` VALUES ('338645', '1536', '2013', '3', '2', '13', '422', '452', '415');
INSERT INTO `school_recruit` VALUES ('338646', '1536', '2012', '3', '2', '13', '440', '480', '431');
INSERT INTO `school_recruit` VALUES ('338648', '1536', '2011', '3', '2', '13', '426', '461', '0');
INSERT INTO `school_recruit` VALUES ('338650', '1536', '2010', '3', '2', '13', '413', '449', '0');
INSERT INTO `school_recruit` VALUES ('339063', '1548', '2012', '4', '1', '3', '212', '265', '0');
INSERT INTO `school_recruit` VALUES ('339064', '1548', '2012', '4', '2', '3', '210', '270', '0');
INSERT INTO `school_recruit` VALUES ('339103', '1548', '2012', '4', '1', '10', '300', '352', '0');
INSERT INTO `school_recruit` VALUES ('339104', '1548', '2012', '4', '2', '10', '319', '345', '0');
INSERT INTO `school_recruit` VALUES ('339117', '1548', '2012', '4', '1', '13', '181', '362', '0');
INSERT INTO `school_recruit` VALUES ('339202', '1557', '2012', '3', '1', '34', '443', '443', '0');
INSERT INTO `school_recruit` VALUES ('339266', '1557', '2010', '2', '1', '10', '495', '532', '0');
INSERT INTO `school_recruit` VALUES ('339271', '1557', '2010', '2', '2', '10', '446', '478', '0');
INSERT INTO `school_recruit` VALUES ('339280', '1557', '2011', '3', '2', '13', '415', '467', '395');
INSERT INTO `school_recruit` VALUES ('340777', '1598', '2010', '1', '1', '34', '578', '632', '0');
INSERT INTO `school_recruit` VALUES ('340786', '1598', '2010', '1', '1', '3', '558', '653', '0');
INSERT INTO `school_recruit` VALUES ('340825', '1599', '2010', '2', '1', '10', '482', '519', '0');
INSERT INTO `school_recruit` VALUES ('340829', '1599', '2010', '2', '2', '10', '427', '476', '0');
INSERT INTO `school_recruit` VALUES ('340888', '1598', '2010', '1', '1', '10', '632', '674', '0');
INSERT INTO `school_recruit` VALUES ('340899', '1598', '2010', '1', '1', '13', '581', '642', '0');
INSERT INTO `school_recruit` VALUES ('341195', '1618', '2010', '2', '1', '10', '478', '516', '0');
INSERT INTO `school_recruit` VALUES ('341202', '1618', '2010', '2', '2', '10', '426', '482', '0');
INSERT INTO `school_recruit` VALUES ('341238', '1618', '2013', '3', '1', '13', '451', '452', '451');
INSERT INTO `school_recruit` VALUES ('341240', '1618', '2012', '3', '1', '13', '492', '506', '481');
INSERT INTO `school_recruit` VALUES ('341242', '1618', '2011', '3', '1', '13', '456', '474', '448');
INSERT INTO `school_recruit` VALUES ('341244', '1618', '2010', '3', '1', '13', '440', '459', '0');
INSERT INTO `school_recruit` VALUES ('341245', '1618', '2013', '3', '2', '13', '418', '426', '409');
INSERT INTO `school_recruit` VALUES ('341246', '1618', '2012', '3', '2', '13', '445', '470', '423');
INSERT INTO `school_recruit` VALUES ('341247', '1618', '2011', '3', '2', '13', '442', '463', '432');
INSERT INTO `school_recruit` VALUES ('341248', '1618', '2010', '3', '2', '13', '422', '443', '0');
INSERT INTO `school_recruit` VALUES ('341735', '1645', '2010', '2', '1', '10', '485', '512', '0');
INSERT INTO `school_recruit` VALUES ('341739', '1645', '2010', '2', '2', '10', '426', '471', '0');
INSERT INTO `school_recruit` VALUES ('341757', '1645', '2013', '3', '1', '13', '452', '473', '444');
INSERT INTO `school_recruit` VALUES ('341758', '1645', '2012', '3', '1', '13', '480', '505', '466');
INSERT INTO `school_recruit` VALUES ('341759', '1645', '2011', '3', '1', '13', '432', '439', '427');
INSERT INTO `school_recruit` VALUES ('341760', '1645', '2010', '3', '1', '13', '438', '454', '0');
INSERT INTO `school_recruit` VALUES ('341761', '1645', '2013', '3', '2', '13', '417', '447', '406');
INSERT INTO `school_recruit` VALUES ('341762', '1645', '2012', '3', '2', '13', '432', '456', '411');
INSERT INTO `school_recruit` VALUES ('341763', '1645', '2011', '3', '2', '13', '425', '456', '400');
INSERT INTO `school_recruit` VALUES ('341764', '1645', '2010', '3', '2', '13', '414', '451', '0');
INSERT INTO `school_recruit` VALUES ('342105', '1671', '2010', '4', '1', '34', '239', '262', '0');
INSERT INTO `school_recruit` VALUES ('342106', '1671', '2010', '4', '2', '34', '239', '262', '0');
INSERT INTO `school_recruit` VALUES ('342204', '1671', '2010', '4', '1', '13', '294', '294', '0');
INSERT INTO `school_recruit` VALUES ('342208', '1671', '2010', '4', '2', '13', '294', '294', '0');
INSERT INTO `school_recruit` VALUES ('343578', '1701', '2013', '2', '1', '13', '487', '490', '484');
INSERT INTO `school_recruit` VALUES ('343580', '1701', '2013', '2', '2', '13', '457', '462', '456');
INSERT INTO `school_recruit` VALUES ('343589', '1702', '2010', '4', '1', '10', '202', '405', '0');
INSERT INTO `school_recruit` VALUES ('343590', '1702', '2010', '4', '2', '10', '202', '404', '0');
INSERT INTO `school_recruit` VALUES ('343601', '1702', '2010', '4', '1', '13', '160', '320', '0');
INSERT INTO `school_recruit` VALUES ('343602', '1702', '2010', '4', '2', '13', '193', '386', '0');
INSERT INTO `school_recruit` VALUES ('343792', '1708', '2010', '4', '1', '13', '401', '475', '0');
INSERT INTO `school_recruit` VALUES ('343793', '1708', '2010', '4', '2', '13', '406', '440', '0');
INSERT INTO `school_recruit` VALUES ('343814', '1715', '2010', '4', '1', '10', '290', '331', '0');
INSERT INTO `school_recruit` VALUES ('343816', '1715', '2010', '4', '2', '10', '308', '377', '0');
INSERT INTO `school_recruit` VALUES ('343876', '1715', '2010', '4', '1', '13', '278', '331', '0');
INSERT INTO `school_recruit` VALUES ('343883', '1715', '2010', '4', '2', '13', '399', '410', '0');
INSERT INTO `school_recruit` VALUES ('344501', '1721', '2010', '4', '1', '10', '296', '349', '0');
INSERT INTO `school_recruit` VALUES ('344502', '1721', '2010', '4', '2', '10', '336', '370', '0');
INSERT INTO `school_recruit` VALUES ('344557', '1721', '2010', '4', '1', '13', '277', '310', '0');
INSERT INTO `school_recruit` VALUES ('344558', '1721', '2010', '4', '2', '13', '275', '304', '0');
INSERT INTO `school_recruit` VALUES ('344717', '1741', '2012', '2', '2', '3', '342', '342', '0');
INSERT INTO `school_recruit` VALUES ('344791', '1741', '2010', '2', '1', '10', '488', '515', '0');
INSERT INTO `school_recruit` VALUES ('344796', '1741', '2010', '2', '2', '10', '425', '441', '0');
INSERT INTO `school_recruit` VALUES ('344861', '1741', '2013', '3', '1', '13', '450', '471', '444');
INSERT INTO `school_recruit` VALUES ('344862', '1741', '2012', '3', '1', '13', '470', '511', '463');
INSERT INTO `school_recruit` VALUES ('344863', '1741', '2011', '3', '1', '13', '428', '477', '420');
INSERT INTO `school_recruit` VALUES ('344864', '1741', '2010', '3', '1', '13', '421', '460', '0');
INSERT INTO `school_recruit` VALUES ('344875', '1741', '2013', '3', '2', '13', '413', '441', '406');
INSERT INTO `school_recruit` VALUES ('344877', '1741', '2012', '3', '2', '13', '410', '475', '397');
INSERT INTO `school_recruit` VALUES ('344879', '1741', '2011', '3', '2', '13', '405', '465', '394');
INSERT INTO `school_recruit` VALUES ('344880', '1741', '2010', '3', '2', '13', '388', '453', '0');
INSERT INTO `school_recruit` VALUES ('345138', '1751', '2010', '4', '1', '10', '293', '358', '0');
INSERT INTO `school_recruit` VALUES ('345142', '1751', '2010', '4', '2', '10', '280', '321', '0');
INSERT INTO `school_recruit` VALUES ('345154', '1751', '2010', '4', '1', '13', '230', '264', '0');
INSERT INTO `school_recruit` VALUES ('345155', '1751', '2010', '4', '2', '13', '297', '335', '0');
INSERT INTO `school_recruit` VALUES ('345216', '1759', '2012', '2', '1', '3', '396', '396', '0');
INSERT INTO `school_recruit` VALUES ('345318', '1759', '2013', '2', '1', '13', '489', '489', '484');
INSERT INTO `school_recruit` VALUES ('345319', '1759', '2012', '2', '1', '13', '532', '535', '523');
INSERT INTO `school_recruit` VALUES ('345320', '1759', '2011', '2', '1', '13', '489', '489', '484');
INSERT INTO `school_recruit` VALUES ('345321', '1759', '2013', '3', '1', '13', '457', '492', '444');
INSERT INTO `school_recruit` VALUES ('345322', '1759', '2012', '3', '1', '13', '468', '514', '452');
INSERT INTO `school_recruit` VALUES ('345324', '1759', '2011', '3', '1', '13', '431', '476', '438');
INSERT INTO `school_recruit` VALUES ('345331', '1759', '2013', '2', '2', '13', '470', '513', '456');
INSERT INTO `school_recruit` VALUES ('345333', '1759', '2012', '2', '2', '13', '490', '502', '486');
INSERT INTO `school_recruit` VALUES ('345334', '1759', '2011', '2', '2', '13', '487', '492', '474');
INSERT INTO `school_recruit` VALUES ('345335', '1759', '2013', '3', '2', '13', '418', '452', '406');
INSERT INTO `school_recruit` VALUES ('345336', '1759', '2012', '3', '2', '13', '408', '494', '407');
INSERT INTO `school_recruit` VALUES ('345337', '1759', '2011', '3', '2', '13', '391', '480', '398');
INSERT INTO `school_recruit` VALUES ('345604', '1786', '2013', '3', '1', '13', '459', '479', '453');
INSERT INTO `school_recruit` VALUES ('345605', '1786', '2012', '3', '1', '13', '489', '523', '479');
INSERT INTO `school_recruit` VALUES ('345606', '1786', '2011', '3', '1', '13', '451', '478', '443');
INSERT INTO `school_recruit` VALUES ('345607', '1786', '2010', '3', '1', '13', '446', '471', '0');
INSERT INTO `school_recruit` VALUES ('345612', '1786', '2013', '3', '2', '13', '418', '446', '408');
INSERT INTO `school_recruit` VALUES ('345613', '1786', '2012', '3', '2', '13', '436', '478', '420');
INSERT INTO `school_recruit` VALUES ('345614', '1786', '2011', '3', '2', '13', '423', '468', '409');
INSERT INTO `school_recruit` VALUES ('345615', '1786', '2010', '3', '2', '13', '416', '453', '0');
INSERT INTO `school_recruit` VALUES ('346351', '1811', '2010', '4', '1', '10', '304', '322', '0');
INSERT INTO `school_recruit` VALUES ('346355', '1811', '2010', '4', '2', '10', '259', '267', '0');
INSERT INTO `school_recruit` VALUES ('346369', '1811', '2010', '4', '1', '13', '204', '244', '0');
INSERT INTO `school_recruit` VALUES ('346370', '1811', '2010', '4', '2', '13', '302', '344', '0');
INSERT INTO `school_recruit` VALUES ('346803', '1866', '2010', '4', '1', '10', '289', '300', '0');
INSERT INTO `school_recruit` VALUES ('346808', '1866', '2010', '4', '2', '10', '302', '362', '0');
INSERT INTO `school_recruit` VALUES ('346827', '1866', '2010', '4', '1', '13', '266', '322', '0');
INSERT INTO `school_recruit` VALUES ('346835', '1866', '2010', '4', '2', '13', '298', '311', '0');
INSERT INTO `school_recruit` VALUES ('347219', '1912', '2010', '4', '1', '10', '216', '433', '0');
INSERT INTO `school_recruit` VALUES ('347220', '1912', '2010', '4', '2', '10', '179', '358', '0');
INSERT INTO `school_recruit` VALUES ('347225', '1912', '2010', '4', '1', '13', '164', '328', '0');
INSERT INTO `school_recruit` VALUES ('347226', '1912', '2010', '4', '2', '13', '207', '414', '0');
INSERT INTO `school_recruit` VALUES ('347676', '1971', '2010', '4', '1', '10', '144', '289', '0');
INSERT INTO `school_recruit` VALUES ('347677', '1971', '2010', '4', '2', '10', '181', '362', '0');
INSERT INTO `school_recruit` VALUES ('347682', '1971', '2010', '4', '1', '13', '132', '265', '0');
INSERT INTO `school_recruit` VALUES ('347683', '1971', '2010', '4', '2', '13', '164', '329', '0');
INSERT INTO `school_recruit` VALUES ('347867', '1993', '2010', '4', '1', '10', '329', '350', '0');
INSERT INTO `school_recruit` VALUES ('347868', '1993', '2010', '4', '2', '10', '286', '324', '0');
INSERT INTO `school_recruit` VALUES ('347873', '1993', '2010', '4', '1', '13', '241', '299', '0');
INSERT INTO `school_recruit` VALUES ('347874', '1993', '2010', '4', '2', '13', '282', '381', '0');
INSERT INTO `school_recruit` VALUES ('348108', '2039', '2010', '4', '1', '10', '404', '434', '0');
INSERT INTO `school_recruit` VALUES ('348109', '2039', '2010', '4', '2', '10', '257', '370', '0');
INSERT INTO `school_recruit` VALUES ('348114', '2039', '2010', '4', '1', '13', '221', '227', '0');
INSERT INTO `school_recruit` VALUES ('348115', '2039', '2010', '4', '2', '13', '283', '321', '0');
INSERT INTO `school_recruit` VALUES ('348742', '2258', '2013', '2', '1', '13', '495', '502', '484');
INSERT INTO `school_recruit` VALUES ('348743', '2258', '2012', '2', '1', '13', '533', '533', '523');
INSERT INTO `school_recruit` VALUES ('348744', '2258', '2011', '2', '1', '13', '484', '484', '484');
INSERT INTO `school_recruit` VALUES ('348745', '2258', '2013', '3', '1', '13', '453', '482', '444');
INSERT INTO `school_recruit` VALUES ('348746', '2258', '2012', '3', '1', '13', '464', '512', '452');
INSERT INTO `school_recruit` VALUES ('348747', '2258', '2013', '2', '2', '13', '459', '460', '456');
INSERT INTO `school_recruit` VALUES ('348748', '2258', '2011', '2', '2', '13', '478', '481', '474');
INSERT INTO `school_recruit` VALUES ('348749', '2258', '2013', '3', '2', '13', '417', '446', '406');
INSERT INTO `school_recruit` VALUES ('348750', '2258', '2012', '3', '2', '13', '406', '470', '399');
INSERT INTO `school_recruit` VALUES ('348856', '2303', '2010', '4', '1', '10', '292', '293', '0');
INSERT INTO `school_recruit` VALUES ('348857', '2303', '2010', '4', '2', '10', '254', '261', '0');
INSERT INTO `school_recruit` VALUES ('348866', '2303', '2010', '4', '1', '13', '288', '310', '0');
INSERT INTO `school_recruit` VALUES ('348867', '2303', '2010', '4', '2', '13', '367', '412', '0');
INSERT INTO `school_recruit` VALUES ('348922', '2324', '2010', '4', '1', '13', '401', '475', '0');
INSERT INTO `school_recruit` VALUES ('348923', '2324', '2010', '4', '2', '13', '406', '440', '0');
INSERT INTO `school_recruit` VALUES ('349070', '2406', '2010', '4', '1', '10', '290', '294', '0');
INSERT INTO `school_recruit` VALUES ('349071', '2406', '2010', '4', '2', '10', '328', '329', '0');
INSERT INTO `school_recruit` VALUES ('349076', '2406', '2010', '4', '1', '13', '279', '295', '0');
INSERT INTO `school_recruit` VALUES ('349077', '2406', '2010', '4', '2', '13', '280', '282', '0');
INSERT INTO `school_recruit` VALUES ('349392', '2503', '2010', '4', '1', '10', '274', '548', '0');
INSERT INTO `school_recruit` VALUES ('349393', '2503', '2010', '4', '2', '10', '280', '560', '0');
INSERT INTO `school_recruit` VALUES ('349402', '2507', '2010', '4', '1', '10', '348', '417', '0');
INSERT INTO `school_recruit` VALUES ('349403', '2503', '2010', '4', '1', '13', '223', '446', '0');
INSERT INTO `school_recruit` VALUES ('349404', '2507', '2010', '4', '2', '10', '258', '263', '0');
INSERT INTO `school_recruit` VALUES ('349405', '2503', '2010', '4', '2', '13', '223', '447', '0');
INSERT INTO `school_recruit` VALUES ('349414', '2507', '2010', '4', '1', '13', '217', '219', '0');
INSERT INTO `school_recruit` VALUES ('349415', '2507', '2010', '4', '2', '13', '377', '397', '0');
INSERT INTO `school_recruit` VALUES ('349452', '2514', '2010', '4', '2', '34', '177', '355', '0');
INSERT INTO `school_recruit` VALUES ('349463', '2514', '2010', '4', '2', '10', '197', '394', '0');
INSERT INTO `school_recruit` VALUES ('349468', '2514', '2010', '4', '2', '13', '137', '274', '0');
INSERT INTO `school_recruit` VALUES ('349481', '2547', '2012', '4', '1', '34', '180', '256', '0');
INSERT INTO `school_recruit` VALUES ('349482', '2547', '2011', '4', '1', '34', '185', '370', '0');
INSERT INTO `school_recruit` VALUES ('349483', '2547', '2012', '4', '2', '34', '197', '290', '0');
INSERT INTO `school_recruit` VALUES ('349484', '2547', '2011', '4', '2', '34', '182', '365', '0');
INSERT INTO `school_recruit` VALUES ('349495', '2547', '2012', '4', '1', '10', '268', '288', '0');
INSERT INTO `school_recruit` VALUES ('349496', '2547', '2011', '4', '1', '10', '176', '352', '0');
INSERT INTO `school_recruit` VALUES ('349497', '2547', '2012', '4', '2', '10', '300', '306', '0');
INSERT INTO `school_recruit` VALUES ('349498', '2547', '2011', '4', '2', '10', '178', '356', '0');
INSERT INTO `school_recruit` VALUES ('349499', '2547', '2012', '4', '1', '13', '161', '322', '0');
INSERT INTO `school_recruit` VALUES ('349500', '2547', '2011', '4', '1', '13', '272', '284', '0');
INSERT INTO `school_recruit` VALUES ('349501', '2547', '2012', '4', '2', '13', '153', '307', '0');
INSERT INTO `school_recruit` VALUES ('349502', '2547', '2011', '4', '2', '13', '251', '302', '0');
INSERT INTO `school_recruit` VALUES ('349533', '2557', '2013', '2', '1', '13', '489', '518', '484');
INSERT INTO `school_recruit` VALUES ('349534', '2557', '2013', '2', '2', '13', '466', '516', '456');
INSERT INTO `school_recruit` VALUES ('349549', '2572', '2010', '1', '2', '34', '435', '464', '0');
INSERT INTO `school_recruit` VALUES ('349558', '2572', '2010', '1', '2', '3', '422', '443', '0');
INSERT INTO `school_recruit` VALUES ('349562', '2567', '2010', '4', '1', '10', '290', '323', '0');
INSERT INTO `school_recruit` VALUES ('349563', '2567', '2010', '4', '2', '10', '287', '327', '0');
INSERT INTO `school_recruit` VALUES ('349571', '2567', '2010', '4', '1', '13', '291', '291', '0');
INSERT INTO `school_recruit` VALUES ('349572', '2567', '2010', '4', '2', '13', '300', '397', '0');
INSERT INTO `school_recruit` VALUES ('349579', '2572', '2010', '1', '2', '10', '425', '488', '0');
INSERT INTO `school_recruit` VALUES ('349580', '2575', '2010', '1', '1', '34', '560', '596', '0');
INSERT INTO `school_recruit` VALUES ('349587', '2572', '2010', '1', '2', '13', '424', '469', '0');
INSERT INTO `school_recruit` VALUES ('349588', '2575', '2010', '1', '1', '3', '526', '589', '0');
INSERT INTO `school_recruit` VALUES ('349611', '2575', '2010', '1', '1', '10', '596', '602', '0');
INSERT INTO `school_recruit` VALUES ('349619', '2575', '2010', '1', '1', '13', '564', '608', '0');
INSERT INTO `school_recruit` VALUES ('349724', '2637', '2012', '4', '1', '34', '180', '256', '0');
INSERT INTO `school_recruit` VALUES ('349725', '2637', '2011', '4', '1', '34', '185', '370', '0');
INSERT INTO `school_recruit` VALUES ('349727', '2637', '2010', '4', '1', '34', '166', '333', '0');
INSERT INTO `school_recruit` VALUES ('349729', '2637', '2012', '4', '2', '34', '197', '290', '0');
INSERT INTO `school_recruit` VALUES ('349730', '2637', '2011', '4', '2', '34', '182', '365', '0');
INSERT INTO `school_recruit` VALUES ('349731', '2637', '2010', '4', '2', '34', '161', '323', '0');
INSERT INTO `school_recruit` VALUES ('349787', '2637', '2012', '4', '1', '10', '268', '288', '0');
INSERT INTO `school_recruit` VALUES ('349788', '2637', '2011', '4', '1', '10', '176', '352', '0');
INSERT INTO `school_recruit` VALUES ('349789', '2637', '2010', '4', '1', '10', '174', '348', '0');
INSERT INTO `school_recruit` VALUES ('349790', '2637', '2012', '4', '2', '10', '300', '306', '0');
INSERT INTO `school_recruit` VALUES ('349791', '2637', '2011', '4', '2', '10', '178', '356', '0');
INSERT INTO `school_recruit` VALUES ('349792', '2637', '2010', '4', '2', '10', '127', '254', '0');
INSERT INTO `school_recruit` VALUES ('349797', '2637', '2012', '4', '1', '13', '161', '322', '0');
INSERT INTO `school_recruit` VALUES ('349798', '2637', '2011', '4', '1', '13', '272', '284', '0');
INSERT INTO `school_recruit` VALUES ('349799', '2637', '2010', '4', '1', '13', '130', '261', '0');
INSERT INTO `school_recruit` VALUES ('349800', '2637', '2012', '4', '2', '13', '153', '307', '0');
INSERT INTO `school_recruit` VALUES ('349801', '2637', '2011', '4', '2', '13', '251', '302', '0');
INSERT INTO `school_recruit` VALUES ('349802', '2637', '2010', '4', '2', '13', '202', '405', '0');
INSERT INTO `school_recruit` VALUES ('349855', '2656', '2012', '2', '1', '34', '431', '438', '0');
INSERT INTO `school_recruit` VALUES ('349871', '2656', '2012', '2', '1', '3', '401', '423', '0');
INSERT INTO `school_recruit` VALUES ('349925', '2656', '2012', '2', '1', '10', '438', '445', '0');
INSERT INTO `school_recruit` VALUES ('349940', '2656', '2012', '2', '1', '13', '420', '471', '0');
INSERT INTO `school_recruit` VALUES ('350057', '2681', '2012', '4', '1', '34', '219', '334', '0');
INSERT INTO `school_recruit` VALUES ('350058', '2681', '2011', '4', '1', '34', '129', '258', '0');
INSERT INTO `school_recruit` VALUES ('350059', '2681', '2012', '4', '2', '34', '201', '297', '0');
INSERT INTO `school_recruit` VALUES ('350060', '2681', '2011', '4', '2', '34', '191', '382', '0');
INSERT INTO `school_recruit` VALUES ('350120', '2681', '2012', '4', '1', '10', '299', '349', '0');
INSERT INTO `school_recruit` VALUES ('350121', '2681', '2011', '4', '1', '10', '136', '273', '0');
INSERT INTO `school_recruit` VALUES ('350122', '2681', '2012', '4', '2', '10', '317', '340', '0');
INSERT INTO `school_recruit` VALUES ('350123', '2681', '2011', '4', '2', '10', '112', '225', '0');
INSERT INTO `school_recruit` VALUES ('350144', '2681', '2012', '4', '1', '13', '122', '244', '0');
INSERT INTO `school_recruit` VALUES ('350145', '2681', '2011', '4', '1', '13', '291', '322', '0');
INSERT INTO `school_recruit` VALUES ('350146', '2681', '2012', '4', '2', '13', '107', '214', '0');
INSERT INTO `school_recruit` VALUES ('350147', '2681', '2011', '4', '2', '13', '270', '341', '0');
INSERT INTO `school_recruit` VALUES ('350240', '2705', '2012', '1', '2', '34', '543', '609', '0');
INSERT INTO `school_recruit` VALUES ('350241', '2705', '2011', '1', '2', '34', '548', '612', '0');
INSERT INTO `school_recruit` VALUES ('350242', '2705', '2010', '1', '2', '34', '564', '635', '0');
INSERT INTO `school_recruit` VALUES ('350254', '2705', '2012', '1', '2', '3', '434', '446', '0');
INSERT INTO `school_recruit` VALUES ('350255', '2705', '2011', '1', '2', '3', '449', '455', '0');
INSERT INTO `school_recruit` VALUES ('350256', '2705', '2010', '1', '2', '3', '468', '472', '0');
INSERT INTO `school_recruit` VALUES ('350267', '2700', '2010', '4', '1', '10', '368', '422', '0');
INSERT INTO `school_recruit` VALUES ('350268', '2700', '2010', '4', '2', '10', '266', '398', '0');
INSERT INTO `school_recruit` VALUES ('350288', '2700', '2010', '4', '1', '13', '244', '246', '0');
INSERT INTO `school_recruit` VALUES ('350289', '2700', '2010', '4', '2', '13', '348', '390', '0');
INSERT INTO `school_recruit` VALUES ('350295', '2705', '2012', '1', '2', '10', '584', '588', '0');
INSERT INTO `school_recruit` VALUES ('350296', '2705', '2011', '1', '2', '10', '568', '587', '0');
INSERT INTO `school_recruit` VALUES ('350297', '2705', '2010', '1', '2', '10', '580', '610', '0');
INSERT INTO `school_recruit` VALUES ('350313', '2705', '2012', '1', '2', '13', '532', '539', '0');
INSERT INTO `school_recruit` VALUES ('350314', '2705', '2011', '1', '2', '13', '533', '535', '0');
INSERT INTO `school_recruit` VALUES ('350315', '2705', '2010', '1', '2', '13', '536', '558', '0');
INSERT INTO `school_recruit` VALUES ('350343', '2708', '2010', '4', '1', '10', '285', '339', '0');
INSERT INTO `school_recruit` VALUES ('350345', '2708', '2010', '4', '2', '10', '274', '330', '0');
INSERT INTO `school_recruit` VALUES ('350362', '2708', '2010', '4', '1', '13', '229', '338', '0');
INSERT INTO `school_recruit` VALUES ('350366', '2708', '2010', '4', '2', '13', '289', '301', '0');
INSERT INTO `school_recruit` VALUES ('350407', '2720', '2012', '2', '2', '34', '488', '543', '0');
INSERT INTO `school_recruit` VALUES ('350408', '2720', '2011', '2', '2', '34', '499', '564', '0');
INSERT INTO `school_recruit` VALUES ('350409', '2720', '2010', '2', '2', '34', '496', '552', '0');
INSERT INTO `school_recruit` VALUES ('350423', '2720', '2012', '2', '2', '3', '453', '564', '0');
INSERT INTO `school_recruit` VALUES ('350424', '2720', '2011', '2', '2', '3', '489', '585', '0');
INSERT INTO `school_recruit` VALUES ('350425', '2720', '2010', '2', '2', '3', '486', '573', '0');
INSERT INTO `school_recruit` VALUES ('350459', '2720', '2012', '2', '2', '10', '509', '585', '0');
INSERT INTO `school_recruit` VALUES ('350460', '2720', '2011', '2', '2', '10', '494', '606', '0');
INSERT INTO `school_recruit` VALUES ('350461', '2720', '2010', '2', '2', '10', '498', '594', '0');
INSERT INTO `school_recruit` VALUES ('350476', '2720', '2012', '2', '2', '13', '519', '553', '0');
INSERT INTO `school_recruit` VALUES ('350477', '2720', '2011', '2', '2', '13', '524', '574', '0');
INSERT INTO `school_recruit` VALUES ('350478', '2720', '2010', '2', '2', '13', '512', '562', '0');
INSERT INTO `school_recruit` VALUES ('350479', '2726', '2010', '4', '1', '10', '340', '349', '0');
INSERT INTO `school_recruit` VALUES ('350480', '2726', '2010', '4', '2', '10', '340', '394', '0');
INSERT INTO `school_recruit` VALUES ('350494', '2726', '2010', '4', '1', '13', '210', '224', '0');
INSERT INTO `school_recruit` VALUES ('350495', '2726', '2010', '4', '2', '13', '210', '224', '0');
INSERT INTO `school_recruit` VALUES ('350526', '2736', '2012', '2', '1', '34', '412', '429', '0');
INSERT INTO `school_recruit` VALUES ('350527', '2736', '2011', '2', '1', '34', '410', '445', '0');
INSERT INTO `school_recruit` VALUES ('350542', '2736', '2012', '2', '1', '3', '389', '400', '0');
INSERT INTO `school_recruit` VALUES ('350543', '2736', '2011', '2', '1', '3', '398', '405', '0');
INSERT INTO `school_recruit` VALUES ('350584', '2736', '2012', '2', '1', '10', '405', '428', '0');
INSERT INTO `school_recruit` VALUES ('350585', '2736', '2011', '2', '1', '10', '403', '417', '0');
INSERT INTO `school_recruit` VALUES ('350592', '2736', '2012', '2', '1', '13', '421', '472', '0');
INSERT INTO `school_recruit` VALUES ('350593', '2736', '2011', '2', '1', '13', '419', '451', '0');
INSERT INTO `school_recruit` VALUES ('350657', '14', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350658', '16', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350659', '22', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350660', '27', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350661', '31', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350664', '39', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350665', '44', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350666', '45', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350667', '59', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350668', '68', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350669', '75', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350670', '90', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350671', '112', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350672', '127', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350673', '131', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350674', '150', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350675', '158', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350676', '209', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350678', '259', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350679', '297', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350680', '523', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350681', '855', '2014', '1', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350693', '16', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350701', '27', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350702', '28', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350704', '31', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350709', '39', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350712', '45', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350717', '57', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350718', '59', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350719', '61', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350722', '68', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350724', '75', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350727', '79', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350729', '86', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350730', '90', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350731', '95', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350732', '99', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350736', '105', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350737', '107', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350738', '112', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350739', '115', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350740', '127', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350741', '131', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350744', '150', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350745', '158', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350746', '175', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350748', '209', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350749', '210', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350755', '257', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350756', '259', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350757', '297', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350759', '366', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350761', '423', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350762', '475', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350763', '517', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350764', '523', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350766', '855', '2014', '1', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350767', '16', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350779', '97', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350783', '110', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350791', '127', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350796', '147', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350801', '158', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350802', '159', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350803', '160', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350805', '172', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350809', '180', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350820', '218', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350821', '219', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350822', '231', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350825', '242', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350827', '244', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350828', '249', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350829', '254', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350831', '257', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350834', '279', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350835', '282', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350837', '289', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350838', '294', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350839', '297', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350843', '313', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350844', '316', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350845', '329', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350850', '358', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350852', '368', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350853', '376', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350858', '395', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350860', '418', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350862', '428', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350863', '429', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350864', '443', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350867', '473', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350872', '560', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350873', '571', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350874', '586', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350875', '615', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350878', '675', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350879', '696', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350884', '756', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350892', '1028', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350894', '1309', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350895', '1329', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350896', '1381', '2014', '2', '1', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350897', '16', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350915', '97', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350919', '110', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350931', '127', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350934', '130', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350940', '144', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350942', '147', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350947', '158', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350948', '159', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350949', '160', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350950', '162', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350955', '172', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350960', '180', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350976', '218', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350977', '219', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350979', '231', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350982', '234', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350986', '242', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350988', '244', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350990', '249', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350993', '254', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('350995', '257', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351004', '279', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351005', '282', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351008', '289', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351009', '294', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351011', '297', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351017', '313', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351018', '314', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351019', '316', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351022', '329', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351033', '358', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351035', '368', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351038', '376', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351042', '395', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351047', '418', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351048', '428', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351049', '429', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351051', '443', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351053', '458', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351057', '473', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351068', '544', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351069', '560', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351070', '571', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351071', '586', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351073', '605', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351074', '615', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351081', '675', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351084', '696', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351086', '749', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351087', '756', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351089', '780', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351095', '894', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351099', '1028', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351104', '1309', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351105', '1463', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('351106', '1482', '2014', '2', '2', '3', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353206', '5', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353207', '6', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353213', '14', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353222', '27', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353223', '28', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353226', '31', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353231', '39', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353235', '44', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353236', '45', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353238', '48', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353240', '51', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353243', '57', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353244', '59', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353245', '61', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353250', '75', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353253', '79', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353255', '86', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353256', '90', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353257', '99', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353261', '105', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353262', '107', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353263', '112', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353264', '115', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353269', '150', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353271', '160', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353273', '175', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353277', '209', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353282', '247', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353284', '255', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353285', '262', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353287', '358', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353288', '363', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353289', '366', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353290', '475', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353291', '517', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353292', '523', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353293', '682', '2014', '1', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353298', '5', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353299', '6', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353301', '8', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353307', '14', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353314', '22', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353318', '27', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353319', '28', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353322', '31', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353327', '39', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353331', '44', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353332', '45', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353334', '48', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353336', '51', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353339', '57', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353340', '59', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353341', '61', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353345', '68', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353348', '75', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353352', '79', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353354', '86', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353355', '90', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353357', '95', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353359', '99', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353363', '105', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353364', '107', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353365', '112', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353366', '115', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353367', '131', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353373', '150', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353375', '160', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353378', '175', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353381', '209', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353382', '210', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353391', '247', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353394', '255', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353396', '262', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353403', '294', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353405', '299', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353410', '358', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353411', '363', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353412', '366', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353414', '387', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353416', '475', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353417', '517', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353418', '523', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353419', '682', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353421', '703', '2014', '1', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353422', '278', '2014', '3', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353430', '541', '2014', '3', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353433', '571', '2014', '3', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353434', '613', '2014', '3', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353441', '784', '2014', '3', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353445', '1028', '2014', '3', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353447', '278', '2014', '3', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353457', '541', '2014', '3', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353460', '571', '2014', '3', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353463', '613', '2014', '3', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353469', '784', '2014', '3', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353476', '1028', '2014', '3', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353495', '97', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353498', '110', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353503', '127', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353511', '160', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353513', '169', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353526', '219', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353527', '231', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353528', '234', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353531', '247', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353532', '249', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353534', '255', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353536', '259', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353539', '279', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353540', '282', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353541', '294', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353544', '324', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353549', '358', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353551', '368', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353552', '387', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353555', '418', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353556', '429', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353558', '458', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353559', '510', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353561', '581', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353562', '627', '2014', '2', '1', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353584', '97', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353585', '110', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353594', '127', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353595', '130', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353598', '144', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353605', '160', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353606', '169', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353612', '180', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353623', '219', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353624', '231', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353626', '234', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353629', '244', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353630', '247', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353631', '249', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353633', '255', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353635', '257', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353636', '259', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353641', '279', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353642', '282', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353644', '294', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353647', '299', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353654', '358', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353657', '387', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353661', '418', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353662', '429', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353665', '458', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353670', '510', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353672', '581', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('353674', '627', '2014', '2', '2', '34', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364378', '5', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364379', '6', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364385', '14', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364394', '27', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364395', '28', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364398', '31', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364403', '39', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364406', '44', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364407', '45', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364409', '48', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364413', '57', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364414', '61', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364422', '75', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364426', '79', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364428', '86', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364430', '90', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364432', '95', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364434', '97', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364438', '105', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364439', '112', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364446', '150', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364449', '162', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364452', '175', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364456', '209', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364457', '210', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364462', '231', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364466', '254', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364467', '255', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364468', '259', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364470', '262', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364474', '297', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364477', '363', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364478', '366', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364480', '423', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364482', '517', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364483', '523', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364485', '682', '2014', '1', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364491', '5', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364492', '6', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364494', '8', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364500', '14', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364507', '22', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364512', '27', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364513', '28', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364516', '31', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364522', '39', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364526', '44', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364527', '45', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364529', '48', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364534', '57', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364536', '61', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364542', '68', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364546', '75', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364550', '79', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364555', '86', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364558', '90', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364560', '95', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364562', '97', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364564', '99', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364569', '105', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364570', '107', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364573', '112', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364576', '130', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364577', '131', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364586', '144', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364588', '147', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364589', '150', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364593', '159', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364594', '162', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364598', '175', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364607', '209', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364608', '210', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364616', '231', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364618', '234', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364621', '247', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364624', '254', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364625', '255', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364626', '259', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364628', '262', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364637', '297', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364638', '299', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364644', '363', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364645', '366', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364651', '423', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364656', '475', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364658', '514', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364659', '517', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364660', '523', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364663', '598', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364665', '682', '2014', '1', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364667', '315', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364678', '425', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364681', '483', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364695', '615', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364708', '675', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364740', '911', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364746', '968', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364755', '1028', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364757', '1038', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364758', '1060', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364763', '1122', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364764', '1157', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364778', '1309', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364780', '1329', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364782', '1353', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364784', '1381', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364789', '1413', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364790', '1463', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364791', '1466', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364794', '1482', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364796', '1536', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364800', '1618', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364801', '1645', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364805', '1741', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364807', '1786', '2014', '3', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364809', '315', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364820', '425', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364824', '483', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364840', '615', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364858', '675', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364862', '696', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364870', '749', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364892', '894', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364896', '911', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364904', '968', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364914', '1028', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364916', '1038', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364917', '1060', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364923', '1122', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364925', '1157', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364933', '1236', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364943', '1309', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364946', '1329', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364949', '1353', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364951', '1381', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364955', '1413', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364957', '1445', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364958', '1456', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364959', '1463', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364960', '1466', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364962', '1482', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364964', '1510', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364965', '1536', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364973', '1618', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364975', '1645', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364979', '1741', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364980', '1786', '2014', '3', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364986', '48', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('364996', '97', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365000', '110', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365015', '147', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365020', '158', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365021', '159', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365023', '162', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365027', '172', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365030', '180', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365048', '218', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365051', '242', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365053', '249', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365055', '254', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365057', '257', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365068', '278', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365069', '279', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365071', '282', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365074', '289', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365075', '294', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365080', '313', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365081', '314', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365082', '316', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365086', '329', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365096', '358', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365101', '368', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365104', '376', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365111', '394', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365112', '395', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365117', '418', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365122', '425', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365123', '428', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365124', '429', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365129', '443', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365130', '447', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365134', '458', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365141', '473', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365150', '503', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365153', '506', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365164', '544', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365165', '548', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365167', '560', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365169', '566', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365171', '581', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365176', '594', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365178', '605', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365193', '756', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365194', '757', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365200', '809', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365207', '980', '2014', '2', '1', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365212', '48', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365225', '97', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365229', '110', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365248', '147', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365255', '158', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365256', '159', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365258', '162', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365263', '172', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365267', '180', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365289', '218', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365299', '242', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365300', '244', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365303', '249', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365305', '254', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365307', '257', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365320', '278', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365321', '279', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365323', '282', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365328', '289', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365330', '294', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365339', '313', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365340', '314', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365341', '316', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365347', '329', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365357', '348', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365361', '358', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365368', '368', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365372', '376', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365381', '394', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365382', '395', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365390', '412', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365391', '418', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365396', '425', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365397', '428', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365398', '429', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365404', '443', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365405', '447', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365412', '458', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365419', '473', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365431', '503', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365434', '506', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365450', '544', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365452', '548', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365456', '560', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365459', '566', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365462', '581', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365468', '594', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365475', '605', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365485', '646', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365502', '756', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365503', '757', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365508', '809', '2014', '2', '2', '13', '0', '0', '0');
INSERT INTO `school_recruit` VALUES ('365519', '980', '2014', '2', '2', '13', '0', '0', '0');

-- ----------------------------
-- Table structure for zytybmb
-- ----------------------------
DROP TABLE IF EXISTS `zytybmb`;
CREATE TABLE `zytybmb` (
  `zytydm` varchar(10) NOT NULL DEFAULT '',
  `zymc` varchar(50) NOT NULL DEFAULT '',
  `pysx` varchar(6) DEFAULT NULL,
  PRIMARY KEY (`zytydm`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of zytybmb
-- ----------------------------
INSERT INTO `zytybmb` VALUES ('010000', '哲学', null);
INSERT INTO `zytybmb` VALUES ('010100', '哲学类', null);
INSERT INTO `zytybmb` VALUES ('010101', '哲学', null);
INSERT INTO `zytybmb` VALUES ('01010101', '哲学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('01010102', '哲学(基地)', null);
INSERT INTO `zytybmb` VALUES ('01010103', '哲学(基地班)', null);
INSERT INTO `zytybmb` VALUES ('01010104', '哲学基地班', null);
INSERT INTO `zytybmb` VALUES ('01010105', '哲学专业( Philosophy Program )', null);
INSERT INTO `zytybmb` VALUES ('01010106', '文史哲基地(哲学)', null);
INSERT INTO `zytybmb` VALUES ('010102', '逻辑学', null);
INSERT INTO `zytybmb` VALUES ('010103K', '宗教学', null);
INSERT INTO `zytybmb` VALUES ('010104T', '伦理学', null);
INSERT INTO `zytybmb` VALUES ('020000', '经济学', null);
INSERT INTO `zytybmb` VALUES ('020100', '经济学类', null);
INSERT INTO `zytybmb` VALUES ('020101', '经济学', null);
INSERT INTO `zytybmb` VALUES ('02010101', '网络经济学', null);
INSERT INTO `zytybmb` VALUES ('02010102', '经济学(国际金融方向)', null);
INSERT INTO `zytybmb` VALUES ('02010103', '经济学(基地班)', null);
INSERT INTO `zytybmb` VALUES ('02010104', '经济学(金融服务与理财方向)', null);
INSERT INTO `zytybmb` VALUES ('02010105', '经济学(金融学)', null);
INSERT INTO `zytybmb` VALUES ('02010106', '经济学(金融学方向)', null);
INSERT INTO `zytybmb` VALUES ('02010107', '经济学(理)', null);
INSERT INTO `zytybmb` VALUES ('02010108', '经济学(企业财务会计方向)', null);
INSERT INTO `zytybmb` VALUES ('02010109', '经济学(数理经济学试验班)', null);
INSERT INTO `zytybmb` VALUES ('02010110', '经济学(投资学)', null);
INSERT INTO `zytybmb` VALUES ('02010111', '经济学(卫生经济)本科', null);
INSERT INTO `zytybmb` VALUES ('02010112', '经济学(文)', null);
INSERT INTO `zytybmb` VALUES ('02010113', '经济学(中加合作)', null);
INSERT INTO `zytybmb` VALUES ('02010114', '经济学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('02010115', '经济学１', null);
INSERT INTO `zytybmb` VALUES ('02010116', '经济学1', null);
INSERT INTO `zytybmb` VALUES ('02010117', '经济学基地班', null);
INSERT INTO `zytybmb` VALUES ('02010118', '经济学类(含金融学、财政学、经济学、国际经济与贸易、保险学专业)', null);
INSERT INTO `zytybmb` VALUES ('02010119', '经济学类(含经济学、国际经济与贸易)', null);
INSERT INTO `zytybmb` VALUES ('02010120', '经济学类(含经济学、国际经济与贸易、金融工程、数学经济学交叉培养班、法学经济学交叉培养班)', null);
INSERT INTO `zytybmb` VALUES ('02010121', '经济学类(含经济学、金融学、国际经济与贸易、财政学专业)', null);
INSERT INTO `zytybmb` VALUES ('02010122', '经济学类(经济学、国际经济与贸易、金融学、统计学)', null);
INSERT INTO `zytybmb` VALUES ('02010123', '经济学类(中外)', null);
INSERT INTO `zytybmb` VALUES ('02010124', '经济学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('02010125', '经济学类创新班(本硕连读)', null);
INSERT INTO `zytybmb` VALUES ('02010126', '经济学类专业(国际经济与贸易、金融学)', null);
INSERT INTO `zytybmb` VALUES ('02010127', '经济学院', null);
INSERT INTO `zytybmb` VALUES ('02010128', '经济学注册会计师', null);
INSERT INTO `zytybmb` VALUES ('02010129', '经济学专业', null);
INSERT INTO `zytybmb` VALUES ('02010130', '海洋经济学', null);
INSERT INTO `zytybmb` VALUES ('02010131', '经济学(国际会计方向)', null);
INSERT INTO `zytybmb` VALUES ('020102', '经济统计学', null);
INSERT INTO `zytybmb` VALUES ('02010201', '经济统计', null);
INSERT INTO `zytybmb` VALUES ('02010202', '经济统计学金融分析方向', null);
INSERT INTO `zytybmb` VALUES ('020103T', '国民经济管理', null);
INSERT INTO `zytybmb` VALUES ('020104T', '资源与环境经济学', null);
INSERT INTO `zytybmb` VALUES ('020104T1', '环境资源与发展经济学', null);
INSERT INTO `zytybmb` VALUES ('020104T2', '环境资源与经济学', null);
INSERT INTO `zytybmb` VALUES ('020105T', '商务经济学', null);
INSERT INTO `zytybmb` VALUES ('020106T', '能源经济', null);
INSERT INTO `zytybmb` VALUES ('020200', '财政学类', null);
INSERT INTO `zytybmb` VALUES ('020201K', '财政学', null);
INSERT INTO `zytybmb` VALUES ('020201K1', '财经学', null);
INSERT INTO `zytybmb` VALUES ('020201K2', '财政学(绩效评价方向)', null);
INSERT INTO `zytybmb` VALUES ('020201K3', '财政学税务筹划、理财方向', null);
INSERT INTO `zytybmb` VALUES ('020202', '税收学', null);
INSERT INTO `zytybmb` VALUES ('02020201', '税收学(注册税务师)', null);
INSERT INTO `zytybmb` VALUES ('02020203', '税收学(注册税务师方向)', null);
INSERT INTO `zytybmb` VALUES ('020300', '金融学类', null);
INSERT INTO `zytybmb` VALUES ('02030001', '金融学类(经济学)', null);
INSERT INTO `zytybmb` VALUES ('02030002', '金融学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('02030003', '金融学类(中外合作办学)(金融学)', null);
INSERT INTO `zytybmb` VALUES ('020301K', '金融学', null);
INSERT INTO `zytybmb` VALUES ('020301K01', '金融学(保险、证券、银行)', null);
INSERT INTO `zytybmb` VALUES ('020301K02', '金融学(国际金融)', null);
INSERT INTO `zytybmb` VALUES ('020301K03', '金融学(国际金融方向)', null);
INSERT INTO `zytybmb` VALUES ('020301K04', '金融学(货币银行、证券投资与保险)', null);
INSERT INTO `zytybmb` VALUES ('020301K05', '金融学(金融理财)', null);
INSERT INTO `zytybmb` VALUES ('020301K06', '金融学(金融市场与投资)', null);
INSERT INTO `zytybmb` VALUES ('020301K07', '金融学(金融事务与管理)', null);
INSERT INTO `zytybmb` VALUES ('020301K08', '金融学(金融投资方向)', null);
INSERT INTO `zytybmb` VALUES ('020301K09', '金融学(全英班)', null);
INSERT INTO `zytybmb` VALUES ('020301K10', '金融学(数理金融实验班)', null);
INSERT INTO `zytybmb` VALUES ('020301K11', '金融学(双语教学)', null);
INSERT INTO `zytybmb` VALUES ('020301K12', '金融学(五年)', null);
INSERT INTO `zytybmb` VALUES ('020301K13', '金融学(英文教学', null);
INSERT INTO `zytybmb` VALUES ('020301K14', '金融学(英文教学)', null);
INSERT INTO `zytybmb` VALUES ('020301K15', '金融学(中俄学院)', null);
INSERT INTO `zytybmb` VALUES ('020301K16', '金融学(中加合作办学项目)', null);
INSERT INTO `zytybmb` VALUES ('020301K17', '金融学(中加合作项目)', null);
INSERT INTO `zytybmb` VALUES ('020301K18', '金融学(中美合作办学)', null);
INSERT INTO `zytybmb` VALUES ('020301K19', '金融学(中新合作办学)', null);
INSERT INTO `zytybmb` VALUES ('020301K20', '金融学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('020301K21', '金融学国际金融、互联网金融方向', null);
INSERT INTO `zytybmb` VALUES ('020301K22', '金融学国际金融学方向', null);
INSERT INTO `zytybmb` VALUES ('020301K23', '金融学金融服务方向', null);
INSERT INTO `zytybmb` VALUES ('020301K24', '金融学金融管理方向', null);
INSERT INTO `zytybmb` VALUES ('020301K25', '金融学专业', null);
INSERT INTO `zytybmb` VALUES ('020301K26', '金融学专业(非师范，文理兼招)', null);
INSERT INTO `zytybmb` VALUES ('020301K27', '金融学专业(含金融学双语班)', null);
INSERT INTO `zytybmb` VALUES ('020301K28', '国际金融(含金融信用管理、投资与理财)', null);
INSERT INTO `zytybmb` VALUES ('020301K29', '金融学投资理财方向', null);
INSERT INTO `zytybmb` VALUES ('020302', '金融工程', null);
INSERT INTO `zytybmb` VALUES ('02030201', '金融工程(含碳金融)', null);
INSERT INTO `zytybmb` VALUES ('02030202', '金融工程(金融工程方向，碳金融方向)', null);
INSERT INTO `zytybmb` VALUES ('02030203', '金融工程(金融工程方向、碳金融方向)', null);
INSERT INTO `zytybmb` VALUES ('02030204', '金融工程(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('020303', '保险学', null);
INSERT INTO `zytybmb` VALUES ('02030302', '保险学(精算方向)', null);
INSERT INTO `zytybmb` VALUES ('02030303', '保险学(理财与保险规划方向)', null);
INSERT INTO `zytybmb` VALUES ('02030304', '保险学风险管理与保险方向', null);
INSERT INTO `zytybmb` VALUES ('020304', '投资学', null);
INSERT INTO `zytybmb` VALUES ('020305T', '金融数学', null);
INSERT INTO `zytybmb` VALUES ('020306T', '信用管理', null);
INSERT INTO `zytybmb` VALUES ('020306T1', '信用管理(金融风险控制)', null);
INSERT INTO `zytybmb` VALUES ('020307T', '经济与金融', null);
INSERT INTO `zytybmb` VALUES ('020400', '经济与贸易类', null);
INSERT INTO `zytybmb` VALUES ('020401', '国际经济与贸易', null);
INSERT INTO `zytybmb` VALUES ('02040101', '经济与贸易类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('02040102', '经济与贸易类(经济学、金融学、经济统计学、国际经济与贸易)', null);
INSERT INTO `zytybmb` VALUES ('02040103', '国际经济与贸易(本)', null);
INSERT INTO `zytybmb` VALUES ('02040104', '国际经济与贸易(供应链规划与管理方向)', null);
INSERT INTO `zytybmb` VALUES ('02040105', '国际经济与贸易(国际金融)', null);
INSERT INTO `zytybmb` VALUES ('02040106', '国际经济与贸易(国际贸易、国际商务)', null);
INSERT INTO `zytybmb` VALUES ('02040107', '国际经济与贸易(国际商务，3+1.5中澳学分互认项目)', null);
INSERT INTO `zytybmb` VALUES ('02040108', '国际经济与贸易(国贸英语实验班)', null);
INSERT INTO `zytybmb` VALUES ('02040109', '国际经济与贸易(含报关员、国际金融、货运代理科)', null);
INSERT INTO `zytybmb` VALUES ('02040110', '国际经济与贸易(金融方向)', null);
INSERT INTO `zytybmb` VALUES ('02040111', '国际经济与贸易(金融服务外包方向)', null);
INSERT INTO `zytybmb` VALUES ('02040112', '国际经济与贸易(理)', null);
INSERT INTO `zytybmb` VALUES ('02040113', '国际经济与贸易(理科)', null);
INSERT INTO `zytybmb` VALUES ('02040114', '国际经济与贸易(贸易经济方向)(理科)', null);
INSERT INTO `zytybmb` VALUES ('02040115', '国际经济与贸易(贸易经济方向)(文科)', null);
INSERT INTO `zytybmb` VALUES ('02040116', '国际经济与贸易(实验班)', null);
INSERT INTO `zytybmb` VALUES ('02040117', '国际经济与贸易(文)', null);
INSERT INTO `zytybmb` VALUES ('02040118', '国际经济与贸易(文科)', null);
INSERT INTO `zytybmb` VALUES ('02040119', '国际经济与贸易(五年)', null);
INSERT INTO `zytybmb` VALUES ('02040120', '国际经济与贸易(英文教学)', null);
INSERT INTO `zytybmb` VALUES ('02040121', '国际经济与贸易(英文授课班)', null);
INSERT INTO `zytybmb` VALUES ('02040122', '国际经济与贸易(中美合作办学)', null);
INSERT INTO `zytybmb` VALUES ('02040123', '国际经济与贸易(专)', null);
INSERT INTO `zytybmb` VALUES ('02040124', '国际经济与贸易(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('02040125', '国际经济与贸易国际贸易与商务方向', null);
INSERT INTO `zytybmb` VALUES ('02040126', '国际经济与贸易国际商务方向', null);
INSERT INTO `zytybmb` VALUES ('02040127', '国际经济与贸易跨国公司经营与管理方向', null);
INSERT INTO `zytybmb` VALUES ('02040128', '国际经济与贸易外贸会计方向', null);
INSERT INTO `zytybmb` VALUES ('02040129', '国际经济与贸易专业', null);
INSERT INTO `zytybmb` VALUES ('02040130', '国际经济与贸易专业(含国际经济与贸易双语班)', null);
INSERT INTO `zytybmb` VALUES ('020402', '贸易经济', null);
INSERT INTO `zytybmb` VALUES ('030000', '法学', null);
INSERT INTO `zytybmb` VALUES ('030100', '法学类', null);
INSERT INTO `zytybmb` VALUES ('03010101', '法学(理科)', null);
INSERT INTO `zytybmb` VALUES ('03010102', '法学(实验学院)', null);
INSERT INTO `zytybmb` VALUES ('030101023', '法学(知识产权方向)', null);
INSERT INTO `zytybmb` VALUES ('03010103', '法学(文)', null);
INSERT INTO `zytybmb` VALUES ('03010104', '法学(房地产法律实务)', null);
INSERT INTO `zytybmb` VALUES ('03010105', '法学类(卓越法律班)', null);
INSERT INTO `zytybmb` VALUES ('03010106', '法学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('03010107', '法学类(含法学、知识产权)', null);
INSERT INTO `zytybmb` VALUES ('03010108', '法学(定向)', null);
INSERT INTO `zytybmb` VALUES ('03010109', '法学专业', null);
INSERT INTO `zytybmb` VALUES ('03010110', '法学(环境执法方向)', null);
INSERT INTO `zytybmb` VALUES ('03010111', '法学专业(民商法、律师实务与纠纷解决方向)', null);
INSERT INTO `zytybmb` VALUES ('03010112', '法学国际经济法方向', null);
INSERT INTO `zytybmb` VALUES ('03010113', '四年制法学(卫生法学方向)', null);
INSERT INTO `zytybmb` VALUES ('03010114', '法学国际法、民商法、刑事法、行政法方向', null);
INSERT INTO `zytybmb` VALUES ('03010115', '法学专业(国际经济法、民商法、律师实务与纠纷解决方向)', null);
INSERT INTO `zytybmb` VALUES ('03010116', '法学类(含法学、法学经济学交叉培养班)', null);
INSERT INTO `zytybmb` VALUES ('03010117', '法学(中俄学院)', null);
INSERT INTO `zytybmb` VALUES ('03010118', '法学(本)', null);
INSERT INTO `zytybmb` VALUES ('03010119', '法学(海商法方向)', null);
INSERT INTO `zytybmb` VALUES ('03010120', '法学(卓越律师实验班)(本科)', null);
INSERT INTO `zytybmb` VALUES ('03010121', '法学专业(境外实践英语特色班)', null);
INSERT INTO `zytybmb` VALUES ('03010122', '法学企业法律实务', null);
INSERT INTO `zytybmb` VALUES ('03010124', '法学(藏汉双语)', null);
INSERT INTO `zytybmb` VALUES ('03010125', '法学本科', null);
INSERT INTO `zytybmb` VALUES ('03010126', '法学(文科)', null);
INSERT INTO `zytybmb` VALUES ('03010127', '法学民商法方向', null);
INSERT INTO `zytybmb` VALUES ('030101K', '法学', null);
INSERT INTO `zytybmb` VALUES ('030101K01', '法学(法律实务方向)', null);
INSERT INTO `zytybmb` VALUES ('030101K02', '法学(金融法方向)', null);
INSERT INTO `zytybmb` VALUES ('030101K03', '法学(经济法)', null);
INSERT INTO `zytybmb` VALUES ('030101K04', '法学(经济法方向)', null);
INSERT INTO `zytybmb` VALUES ('030101K05', '法学(律师方向)', null);
INSERT INTO `zytybmb` VALUES ('030101K06', '法学(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('030101K07', '法学(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('030101K08', '法学(卓越法律人才培养试点班)', null);
INSERT INTO `zytybmb` VALUES ('030101K09', '法学海商法方向', null);
INSERT INTO `zytybmb` VALUES ('030101K10', '法学类(中外)', null);
INSERT INTO `zytybmb` VALUES ('030101K11', '法学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('030101K12', '法学刑事司法方向', null);
INSERT INTO `zytybmb` VALUES ('030102T', '知识产权', null);
INSERT INTO `zytybmb` VALUES ('030102T01', '知识产权(理科)', null);
INSERT INTO `zytybmb` VALUES ('030102T02', '知识产权(文科)', null);
INSERT INTO `zytybmb` VALUES ('030102T03', '知识产权法', null);
INSERT INTO `zytybmb` VALUES ('030103T', '监狱学', null);
INSERT INTO `zytybmb` VALUES ('030200', '政治学类', null);
INSERT INTO `zytybmb` VALUES ('03020001', '政治学', null);
INSERT INTO `zytybmb` VALUES ('03020002', '政治学类(非师范)', null);
INSERT INTO `zytybmb` VALUES ('03020003', '政治学类(含国际政治、哲学、思想政治教育)', null);
INSERT INTO `zytybmb` VALUES ('03020004', '政治学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('030201', '政治学与行政学', null);
INSERT INTO `zytybmb` VALUES ('03020101', '政治学与行政学(文)', null);
INSERT INTO `zytybmb` VALUES ('03020102', '政治学与行政学(政治工作)', null);
INSERT INTO `zytybmb` VALUES ('03020103', '政治学与行政学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('030202', '国际政治', null);
INSERT INTO `zytybmb` VALUES ('030203', '外交学', null);
INSERT INTO `zytybmb` VALUES ('030204T', '国际事务与国际关系', null);
INSERT INTO `zytybmb` VALUES ('030204T01', '国际事务与国际关系(国际文化交流)', null);
INSERT INTO `zytybmb` VALUES ('030204T02', '国际事务与同际关系', null);
INSERT INTO `zytybmb` VALUES ('030204T03', '国际关系与安全', null);
INSERT INTO `zytybmb` VALUES ('030205T', '政治学、经济学与哲学', null);
INSERT INTO `zytybmb` VALUES ('030205T1', '政治经济学', null);
INSERT INTO `zytybmb` VALUES ('030300', '社会学类', null);
INSERT INTO `zytybmb` VALUES ('03030001', '社会学类(含社会学、社会工作)', null);
INSERT INTO `zytybmb` VALUES ('03030002', '社会学类(含社会学、社会工作专业)', null);
INSERT INTO `zytybmb` VALUES ('03030003', '社会学专业( Sociology Program )', null);
INSERT INTO `zytybmb` VALUES ('03030004', '社会学专业', null);
INSERT INTO `zytybmb` VALUES ('03030005', '社会学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('03030006', '社会学1', null);
INSERT INTO `zytybmb` VALUES ('03030007', '社会学(城市文化规划与设计)', null);
INSERT INTO `zytybmb` VALUES ('030301', '社会学', null);
INSERT INTO `zytybmb` VALUES ('03030102', '社会科学实验班', null);
INSERT INTO `zytybmb` VALUES ('03030103', '社会科学试验班', null);
INSERT INTO `zytybmb` VALUES ('030302', '社会工作', null);
INSERT INTO `zytybmb` VALUES ('03030201', '社会工作(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('03030202', '社会工作(社会管理方向)', null);
INSERT INTO `zytybmb` VALUES ('03030203', '社会工作专业( Social Work Program )', null);
INSERT INTO `zytybmb` VALUES ('03030204', '社会工作(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('03030205', '社会工作(中澳班)', null);
INSERT INTO `zytybmb` VALUES ('03030206', '社会工作(社区管理方向)', null);
INSERT INTO `zytybmb` VALUES ('03030207', '社会工怍', null);
INSERT INTO `zytybmb` VALUES ('030303T', '人类学', null);
INSERT INTO `zytybmb` VALUES ('030303T1', '人类学(含人类学、民族学、考古学专业)', null);
INSERT INTO `zytybmb` VALUES ('030304T', '女性学', null);
INSERT INTO `zytybmb` VALUES ('030305T', '家政学', null);
INSERT INTO `zytybmb` VALUES ('030400', '民族学类', null);
INSERT INTO `zytybmb` VALUES ('030401', '民族学', null);
INSERT INTO `zytybmb` VALUES ('03040101', '民族学(藏学)', null);
INSERT INTO `zytybmb` VALUES ('030401011', '藏学', null);
INSERT INTO `zytybmb` VALUES ('03040102', '民族学(文化人类学)', null);
INSERT INTO `zytybmb` VALUES ('03040103', '民族学专业', null);
INSERT INTO `zytybmb` VALUES ('03040104', '民族预科班', null);
INSERT INTO `zytybmb` VALUES ('030500', '马克思主义理论类', null);
INSERT INTO `zytybmb` VALUES ('030501', '科学社会主义', null);
INSERT INTO `zytybmb` VALUES ('03050101', '科学社会主义与国际共产主义运', null);
INSERT INTO `zytybmb` VALUES ('03050102', '科学社会主义与国际共产主义运动', null);
INSERT INTO `zytybmb` VALUES ('03050103', '科学社会主义与旧际共产主义运动', null);
INSERT INTO `zytybmb` VALUES ('03050104', '科学社会主义与围际共产主义运动', null);
INSERT INTO `zytybmb` VALUES ('03050105', '科技与社会主义', null);
INSERT INTO `zytybmb` VALUES ('030502', '中国共产党历史', null);
INSERT INTO `zytybmb` VALUES ('03050201', '中国革命史与中国共产党党员', null);
INSERT INTO `zytybmb` VALUES ('03050202', '中国革命史与中国共产党党史', null);
INSERT INTO `zytybmb` VALUES ('030503', '思想政治教育', null);
INSERT INTO `zytybmb` VALUES ('03050301', '思想与政治教育', null);
INSERT INTO `zytybmb` VALUES ('03050302', '思想政治教育 (师范)', null);
INSERT INTO `zytybmb` VALUES ('03050303', '思想政治教育(法制教育方向)', null);
INSERT INTO `zytybmb` VALUES ('03050304', '思想政治教育(含青年社会心理方向)', null);
INSERT INTO `zytybmb` VALUES ('03050305', '思想政治教育(行知实验班)', null);
INSERT INTO `zytybmb` VALUES ('03050306', '思想政治教育(理科)', null);
INSERT INTO `zytybmb` VALUES ('03050307', '思想政治教育(免费师范)', null);
INSERT INTO `zytybmb` VALUES ('03050308', '思想政治教育(师范)', null);
INSERT INTO `zytybmb` VALUES ('03050309', '思想政治教育(师范类)', null);
INSERT INTO `zytybmb` VALUES ('03050310', '思想政治教育(文科)', null);
INSERT INTO `zytybmb` VALUES ('03050311', '思想政治教育(卓越教师实验班)(本科)', null);
INSERT INTO `zytybmb` VALUES ('03050312', '思想政治教育专业', null);
INSERT INTO `zytybmb` VALUES ('030600', '公安学类', null);
INSERT INTO `zytybmb` VALUES ('03060101', '公安学', null);
INSERT INTO `zytybmb` VALUES ('030601K', '治安学', null);
INSERT INTO `zytybmb` VALUES ('030602K', '侦查学', null);
INSERT INTO `zytybmb` VALUES ('030602K01', '侦查学(经济侦查、刑事侦查方向)', null);
INSERT INTO `zytybmb` VALUES ('030602K02', '侦察学', null);
INSERT INTO `zytybmb` VALUES ('030602K03', '侦察与特种兵指挥', null);
INSERT INTO `zytybmb` VALUES ('030603K', '边防管理', null);
INSERT INTO `zytybmb` VALUES ('030604TK', '禁毒学', null);
INSERT INTO `zytybmb` VALUES ('030605TK', '警犬技术', null);
INSERT INTO `zytybmb` VALUES ('030606TK', '经济犯罪侦查', null);
INSERT INTO `zytybmb` VALUES ('030607TK', '边防指挥', null);
INSERT INTO `zytybmb` VALUES ('030608TK', '消防指挥', null);
INSERT INTO `zytybmb` VALUES ('030609TK', '警卫学', null);
INSERT INTO `zytybmb` VALUES ('030610TK', '公安情报学', null);
INSERT INTO `zytybmb` VALUES ('030611TK', '犯罪学', null);
INSERT INTO `zytybmb` VALUES ('030612TK', '公安管理学', null);
INSERT INTO `zytybmb` VALUES ('030613TK', '涉外警务', null);
INSERT INTO `zytybmb` VALUES ('030614TK', '国内安全保卫', null);
INSERT INTO `zytybmb` VALUES ('030615TK', '警务指挥与战术', null);
INSERT INTO `zytybmb` VALUES ('040000', '教育学', null);
INSERT INTO `zytybmb` VALUES ('040100', '教育学类', null);
INSERT INTO `zytybmb` VALUES ('04010001', '教育学类(含教育学、小学教育、学前教育)', null);
INSERT INTO `zytybmb` VALUES ('04010002', '教育学类(含教育学、小学教育、学前教育)(师范)', null);
INSERT INTO `zytybmb` VALUES ('04010003', '教育学类(含教育学、小学教育、学前教育)(师范类)', null);
INSERT INTO `zytybmb` VALUES ('04010004', '教育学类(师范)', null);
INSERT INTO `zytybmb` VALUES ('04010005', '教育学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('040101', '教育学', null);
INSERT INTO `zytybmb` VALUES ('040102', '科学教育', null);
INSERT INTO `zytybmb` VALUES ('04010201', '科学教育(师范)', null);
INSERT INTO `zytybmb` VALUES ('040103', '人文教育', null);
INSERT INTO `zytybmb` VALUES ('04010301', '人文科学实验班', null);
INSERT INTO `zytybmb` VALUES ('04010302', '人文科学试验班', null);
INSERT INTO `zytybmb` VALUES ('04010303', '人文科学试验班类', null);
INSERT INTO `zytybmb` VALUES ('040104', '教育技术学', null);
INSERT INTO `zytybmb` VALUES ('04010401', '教育技术', null);
INSERT INTO `zytybmb` VALUES ('04010402', '教育技术学(师范)', null);
INSERT INTO `zytybmb` VALUES ('04010403', '教育学(含小学教育和心理健康教育方向)(师范类)', null);
INSERT INTO `zytybmb` VALUES ('04010404', '教育学(师范)', null);
INSERT INTO `zytybmb` VALUES ('04010405', '教育康复学', null);
INSERT INTO `zytybmb` VALUES ('04010406', '教育技术学(游戏软件开发方向)', null);
INSERT INTO `zytybmb` VALUES ('04010407', '教育技术学专业', null);
INSERT INTO `zytybmb` VALUES ('04010408', '教育技术学专业(媒体制作与传播)', null);
INSERT INTO `zytybmb` VALUES ('04010409', '教育学(师范类)', null);
INSERT INTO `zytybmb` VALUES ('04010410', '教育技术学(师范类)', null);
INSERT INTO `zytybmb` VALUES ('04010411', '教育技术学(数字媒体技术)', null);
INSERT INTO `zytybmb` VALUES ('04010412', '教育技术学(信息技术教育 师范)', null);
INSERT INTO `zytybmb` VALUES ('04010413', '教育学(非师范', null);
INSERT INTO `zytybmb` VALUES ('040105', '艺术教育', null);
INSERT INTO `zytybmb` VALUES ('04010501', '艺术教育(音乐教育与表演方向)', null);
INSERT INTO `zytybmb` VALUES ('040106', '学前教育', null);
INSERT INTO `zytybmb` VALUES ('04010601', '学前教育(师范类)', null);
INSERT INTO `zytybmb` VALUES ('04010603', '学前教育专业', null);
INSERT INTO `zytybmb` VALUES ('04010604', '学前教育(中澳班)', null);
INSERT INTO `zytybmb` VALUES ('04010605', '学前教育(三位一体)', null);
INSERT INTO `zytybmb` VALUES ('04010606', '学前教育(免费师范)', null);
INSERT INTO `zytybmb` VALUES ('04010607', '学前教育(免费师范，定克)', null);
INSERT INTO `zytybmb` VALUES ('04010608', '学前教育(文科师范)', null);
INSERT INTO `zytybmb` VALUES ('04010610', '学前教育(专科)', null);
INSERT INTO `zytybmb` VALUES ('040107', '小学教育', null);
INSERT INTO `zytybmb` VALUES ('04010701', '小学教育(理科师范)', null);
INSERT INTO `zytybmb` VALUES ('04010702', '小学教育(全科教师)', null);
INSERT INTO `zytybmb` VALUES ('04010703', '小学教育(三位一体)', null);
INSERT INTO `zytybmb` VALUES ('04010704', '小学教育(师范)', null);
INSERT INTO `zytybmb` VALUES ('04010705', '小学教育(师范类)', null);
INSERT INTO `zytybmb` VALUES ('04010706', '小学教育(文科师范)', null);
INSERT INTO `zytybmb` VALUES ('04010707', '小学教育(英语 师范)', null);
INSERT INTO `zytybmb` VALUES ('04010708', '小学教育专业', null);
INSERT INTO `zytybmb` VALUES ('04010709', '小学全科教师(定向丰都县)', null);
INSERT INTO `zytybmb` VALUES ('04010710', '小学全科教师(定向奉节县)', null);
INSERT INTO `zytybmb` VALUES ('04010711', '小学全科教师(定向开县)', null);
INSERT INTO `zytybmb` VALUES ('04010712', '小学全科教师(定向彭水县)', null);
INSERT INTO `zytybmb` VALUES ('04010713', '小学全科教师(定向綦江区)', null);
INSERT INTO `zytybmb` VALUES ('04010714', '小学全科教师(定向黔江区)', null);
INSERT INTO `zytybmb` VALUES ('04010715', '小学全科教师(定向酉阳县)', null);
INSERT INTO `zytybmb` VALUES ('040108', '特殊教育', null);
INSERT INTO `zytybmb` VALUES ('04010801', '特殊教育(免费师范)', null);
INSERT INTO `zytybmb` VALUES ('04010802', '特殊教育(师范)', null);
INSERT INTO `zytybmb` VALUES ('040109T', '华文教育', null);
INSERT INTO `zytybmb` VALUES ('040200', '体育学类', null);
INSERT INTO `zytybmb` VALUES ('040201', '体育教育', null);
INSERT INTO `zytybmb` VALUES ('040202K', '运动训练', null);
INSERT INTO `zytybmb` VALUES ('040203', '社会体育指导与管理', null);
INSERT INTO `zytybmb` VALUES ('040204K', '武术与民族传统体育', null);
INSERT INTO `zytybmb` VALUES ('040205', '运动人体科学', null);
INSERT INTO `zytybmb` VALUES ('040206T', '运动康复', null);
INSERT INTO `zytybmb` VALUES ('040206T1', '运动康复与健康', null);
INSERT INTO `zytybmb` VALUES ('040207T', '休闲体育', null);
INSERT INTO `zytybmb` VALUES ('050000', '文学', null);
INSERT INTO `zytybmb` VALUES ('050100', '中国语言文学类', null);
INSERT INTO `zytybmb` VALUES ('05010001', '中国语言文科学类', null);
INSERT INTO `zytybmb` VALUES ('05010002', '中国语言文学', null);
INSERT INTO `zytybmb` VALUES ('05010003', '中国语言文学基地班', null);
INSERT INTO `zytybmb` VALUES ('05010004', '中国语言文学基地班、汉语言文学', null);
INSERT INTO `zytybmb` VALUES ('05010005', '中国语言文学类(含汉语言文学(师范类)、秘书学)', null);
INSERT INTO `zytybmb` VALUES ('05010006', '中国语言文学类(含汉语言文学、秘书学)', null);
INSERT INTO `zytybmb` VALUES ('05010007', '中国语言文学类(含汉语言文学基地班、汉语言、汉语国际教育)', null);
INSERT INTO `zytybmb` VALUES ('05010008', '中国语言文学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('050101', '汉语言文学', null);
INSERT INTO `zytybmb` VALUES ('05010101', '汉语言文科学', null);
INSERT INTO `zytybmb` VALUES ('05010103', '汉语言文科学(师范)', null);
INSERT INTO `zytybmb` VALUES ('05010104', '汉语言文科学(文科秘方向)', null);
INSERT INTO `zytybmb` VALUES ('05010105', '汉语言文学(财经文秘方向)', null);
INSERT INTO `zytybmb` VALUES ('05010106', '汉语言文学(法商文秘方向)', null);
INSERT INTO `zytybmb` VALUES ('05010107', '汉语言文学(高级文秘方向)', null);
INSERT INTO `zytybmb` VALUES ('05010108', '汉语言文学(汉语言文学)', null);
INSERT INTO `zytybmb` VALUES ('05010109', '汉语言文学(行知实验班)', null);
INSERT INTO `zytybmb` VALUES ('05010110', '汉语言文学(基地)', null);
INSERT INTO `zytybmb` VALUES ('05010111', '汉语言文学(基地))', null);
INSERT INTO `zytybmb` VALUES ('05010112', '汉语言文学(基地班)', null);
INSERT INTO `zytybmb` VALUES ('05010113', '汉语言文学(免费师范)', null);
INSERT INTO `zytybmb` VALUES ('05010114', '汉语言文学(免费师范，定克)', null);
INSERT INTO `zytybmb` VALUES ('05010115', '汉语言文学(师范)', null);
INSERT INTO `zytybmb` VALUES ('05010116', '汉语言文学(师范兼非师范类)(', null);
INSERT INTO `zytybmb` VALUES ('05010117', '汉语言文学(师范类)', null);
INSERT INTO `zytybmb` VALUES ('05010118', '汉语言文学(网络传播)', null);
INSERT INTO `zytybmb` VALUES ('05010119', '汉语言文学(文)', null);
INSERT INTO `zytybmb` VALUES ('05010120', '汉语言文学(文化创意)专业方向', null);
INSERT INTO `zytybmb` VALUES ('05010121', '汉语言文学(文化创意产业方向)', null);
INSERT INTO `zytybmb` VALUES ('05010122', '汉语言文学(文科师范)', null);
INSERT INTO `zytybmb` VALUES ('05010123', '汉语言文学(文科师范编辑方向)', null);
INSERT INTO `zytybmb` VALUES ('05010124', '汉语言文学(文科师范企业秘书方向)', null);
INSERT INTO `zytybmb` VALUES ('05010125', '汉语言文学(文秘方向)', null);
INSERT INTO `zytybmb` VALUES ('05010126', '汉语言文学(文秘与行政管理方向)', null);
INSERT INTO `zytybmb` VALUES ('05010127', '汉语言文学(新媒体与网络传播)', null);
INSERT INTO `zytybmb` VALUES ('05010128', '汉语言文学(新闻采编)', null);
INSERT INTO `zytybmb` VALUES ('05010129', '汉语言文学(影视编导)', null);
INSERT INTO `zytybmb` VALUES ('05010130', '汉语言文学(政务文秘)', null);
INSERT INTO `zytybmb` VALUES ('05010131', '汉语言文学高级文秘、新闻方向', null);
INSERT INTO `zytybmb` VALUES ('05010132', '汉语言文学高级文员方向', null);
INSERT INTO `zytybmb` VALUES ('05010133', '汉语言文学文秘方向', null);
INSERT INTO `zytybmb` VALUES ('05010134', '汉语言文学专业', null);
INSERT INTO `zytybmb` VALUES ('05010135', '汉语言文学专业(中国语言文化、文秘实务、传媒实务方向)', null);
INSERT INTO `zytybmb` VALUES ('05010136', '汉语言文学专业(中国语言与文学、文员文秘、文化传媒方向)', null);
INSERT INTO `zytybmb` VALUES ('05010137', '汉语言义学', null);
INSERT INTO `zytybmb` VALUES ('05010138', '古典文学', null);
INSERT INTO `zytybmb` VALUES ('05010139', '汉语言文科学(含新闻传播、国际汉语)', null);
INSERT INTO `zytybmb` VALUES ('05010140', '文史哲基地(汉语言文学)', null);
INSERT INTO `zytybmb` VALUES ('050102', '汉语言', null);
INSERT INTO `zytybmb` VALUES ('050103', '汉语国际教育', null);
INSERT INTO `zytybmb` VALUES ('05010301', '汉语国际教育(对外汉语)', null);
INSERT INTO `zytybmb` VALUES ('05010302', '汉语国际教育(理科师范)', null);
INSERT INTO `zytybmb` VALUES ('05010303', '汉语国际教育(师范)', null);
INSERT INTO `zytybmb` VALUES ('05010304', '汉语国际教育(师范类)', null);
INSERT INTO `zytybmb` VALUES ('05010305', '汉语国际教育(文科师范)', null);
INSERT INTO `zytybmb` VALUES ('05010306', '汉语国际教育(原对外汉语)', null);
INSERT INTO `zytybmb` VALUES ('05010307', '汉语国际教育(中外文化交流)', null);
INSERT INTO `zytybmb` VALUES ('05010308', '汉语国际教育涉外秘书方向', null);
INSERT INTO `zytybmb` VALUES ('05010309', '汉语闲际教育', null);
INSERT INTO `zytybmb` VALUES ('05010310', '汉语言国际教育(汉语言国际教育)', null);
INSERT INTO `zytybmb` VALUES ('05010311', '对外汉语', null);
INSERT INTO `zytybmb` VALUES ('05010312', '对外汉语(英语方向、日语方向、韩语方向)', null);
INSERT INTO `zytybmb` VALUES ('05010313', '对外汉语学', null);
INSERT INTO `zytybmb` VALUES ('05010314', '对外汉语专业(对外汉语教学、对外文化交流、汉语培训方向)', null);
INSERT INTO `zytybmb` VALUES ('05010315', '对外语言文学', null);
INSERT INTO `zytybmb` VALUES ('050104', '中国少数民族语言文学', null);
INSERT INTO `zytybmb` VALUES ('05010401', '中国少数民族语言文学(藏汉双语行政管理)', null);
INSERT INTO `zytybmb` VALUES ('05010402', '中国少数民族语言文学(藏学)', null);
INSERT INTO `zytybmb` VALUES ('05010403', '中国少数民族语言文学(藏语言文学)', null);
INSERT INTO `zytybmb` VALUES ('05010404', '中国少数民族语言文学(文理综合班)', null);
INSERT INTO `zytybmb` VALUES ('05010405', '中国少数民族语言文学(彝汉双语)', null);
INSERT INTO `zytybmb` VALUES ('05010406', '中国少数民族语言学', null);
INSERT INTO `zytybmb` VALUES ('050105', '古典文献学', null);
INSERT INTO `zytybmb` VALUES ('05010501', '古典文献', null);
INSERT INTO `zytybmb` VALUES ('05010502', '古典文献学(古籍修复)', null);
INSERT INTO `zytybmb` VALUES ('050106T', '应用语言学', null);
INSERT INTO `zytybmb` VALUES ('050107T', '秘书学', null);
INSERT INTO `zytybmb` VALUES ('050107T01', '秘书学(师范类)', null);
INSERT INTO `zytybmb` VALUES ('050107T02', '秘书学专业', null);
INSERT INTO `zytybmb` VALUES ('050200', '外国语言文学类', null);
INSERT INTO `zytybmb` VALUES ('050201', '英语', null);
INSERT INTO `zytybmb` VALUES ('05020101', '英语(“英+西”方向)', null);
INSERT INTO `zytybmb` VALUES ('05020102', '英语(大类招生)', null);
INSERT INTO `zytybmb` VALUES ('05020103', '英语(法律经贸方向)', null);
INSERT INTO `zytybmb` VALUES ('05020104', '英语(翻译)', null);
INSERT INTO `zytybmb` VALUES ('05020105', '英语(翻译、英语西班牙语双语、英法双语、英德双语)', null);
INSERT INTO `zytybmb` VALUES ('05020106', '英语(翻译方向)', null);
INSERT INTO `zytybmb` VALUES ('05020107', '英语(非师)', null);
INSERT INTO `zytybmb` VALUES ('05020108', '英语(国际工程管理)', null);
INSERT INTO `zytybmb` VALUES ('05020109', '英语(国际经贸)', null);
INSERT INTO `zytybmb` VALUES ('05020110', '英语(国际商务)', null);
INSERT INTO `zytybmb` VALUES ('05020111', '英语(国际商务方向)', null);
INSERT INTO `zytybmb` VALUES ('05020112', '英语(国际商务英语、英美文化)', null);
INSERT INTO `zytybmb` VALUES ('05020113', '英语(国际商务英语方向)(师范)', null);
INSERT INTO `zytybmb` VALUES ('05020114', '英语(国际英语教学方向)', null);
INSERT INTO `zytybmb` VALUES ('05020115', '英语(含商务英语)', null);
INSERT INTO `zytybmb` VALUES ('05020116', '英语(会议展览与国际营销，国际企业与贸易，运动与休闲)', null);
INSERT INTO `zytybmb` VALUES ('05020117', '英语(会议展览与国际营销，国际企业与贸易，运动与休闲管理科，英语)', null);
INSERT INTO `zytybmb` VALUES ('05020118', '英语(会议展览与国际营销，国际企业与贸易，运动与休闲管理科，英语教育)', null);
INSERT INTO `zytybmb` VALUES ('05020119', '英语(会议展览与国际营销、国际企业与贸易、运动与休闲管理科、英语教', null);
INSERT INTO `zytybmb` VALUES ('05020120', '英语(会议展览与国际营销、国际企业与贸易、运动与休闲管理科、英语教育)', null);
INSERT INTO `zytybmb` VALUES ('05020121', '英语(金融英语方向)', null);
INSERT INTO `zytybmb` VALUES ('05020122', '英语(经贸英语)', null);
INSERT INTO `zytybmb` VALUES ('05020123', '英语(科技)', null);
INSERT INTO `zytybmb` VALUES ('05020124', '英语(科技翻译、国际商务、英语教育)', null);
INSERT INTO `zytybmb` VALUES ('05020125', '英语(科技英语方向)', null);
INSERT INTO `zytybmb` VALUES ('05020126', '英语(跨国银行管理)', null);
INSERT INTO `zytybmb` VALUES ('05020127', '英语(理科师范)', null);
INSERT INTO `zytybmb` VALUES ('05020128', '英语(理科师范同声翻译方向)', null);
INSERT INTO `zytybmb` VALUES ('05020129', '英语(旅业商务英语)', null);
INSERT INTO `zytybmb` VALUES ('05020130', '英语(旅游英语)', null);
INSERT INTO `zytybmb` VALUES ('05020131', '英语(旅游英语方向)', null);
INSERT INTO `zytybmb` VALUES ('05020132', '英语(免费师范)', null);
INSERT INTO `zytybmb` VALUES ('05020133', '英语(免费师范，定克)', null);
INSERT INTO `zytybmb` VALUES ('05020134', '英语(民航英语方向)', null);
INSERT INTO `zytybmb` VALUES ('05020135', '英语(三位一体)', null);
INSERT INTO `zytybmb` VALUES ('05020136', '英语(商贸方向)', null);
INSERT INTO `zytybmb` VALUES ('05020137', '英语(商务)', null);
INSERT INTO `zytybmb` VALUES ('05020138', '英语(商务，翻译)', null);
INSERT INTO `zytybmb` VALUES ('05020139', '英语(商务翻译)', null);
INSERT INTO `zytybmb` VALUES ('05020140', '英语(商务方向)', null);
INSERT INTO `zytybmb` VALUES ('05020141', '英语(商务英语)', null);
INSERT INTO `zytybmb` VALUES ('05020142', '英语(商务英语方向)', null);
INSERT INTO `zytybmb` VALUES ('05020143', '英语(涉外法商方向)', null);
INSERT INTO `zytybmb` VALUES ('05020144', '英语(师范', null);
INSERT INTO `zytybmb` VALUES ('05020145', '英语(师范)', null);
INSERT INTO `zytybmb` VALUES ('05020146', '英语(师范/非师范)', null);
INSERT INTO `zytybmb` VALUES ('05020147', '英语(师范方向)', null);
INSERT INTO `zytybmb` VALUES ('05020148', '英语(师范类)', null);
INSERT INTO `zytybmb` VALUES ('05020149', '英语(实用英语)', null);
INSERT INTO `zytybmb` VALUES ('05020150', '英语(文)', null);
INSERT INTO `zytybmb` VALUES ('05020151', '英语(文科师范)', null);
INSERT INTO `zytybmb` VALUES ('05020152', '英语(文科师范同声翻译方向)', null);
INSERT INTO `zytybmb` VALUES ('05020153', '英语(文学)', null);
INSERT INTO `zytybmb` VALUES ('05020154', '英语(医学英语)本科', null);
INSERT INTO `zytybmb` VALUES ('05020155', '英语(英美文化)', null);
INSERT INTO `zytybmb` VALUES ('05020156', '英语(英西双语)', null);
INSERT INTO `zytybmb` VALUES ('05020157', '英语(英语翻译)', null);
INSERT INTO `zytybmb` VALUES ('05020158', '英语(英语翻译)本科', null);
INSERT INTO `zytybmb` VALUES ('05020159', '英语(英语方向)', null);
INSERT INTO `zytybmb` VALUES ('05020160', '英语(英语和国际经济与贸易双学位班)', null);
INSERT INTO `zytybmb` VALUES ('05020161', '英语(英语教育)', null);
INSERT INTO `zytybmb` VALUES ('05020162', '英语(英语教育方向)', null);
INSERT INTO `zytybmb` VALUES ('05020163', '英语(英语语言文学方向、口译和笔译方向)', null);
INSERT INTO `zytybmb` VALUES ('05020164', '英语(应用翻译)', null);
INSERT INTO `zytybmb` VALUES ('05020165', '英语(语言学与应用语言学、英语文学、跨文化交际与翻译方向)', null);
INSERT INTO `zytybmb` VALUES ('05020166', '英语(只招英语考生)', null);
INSERT INTO `zytybmb` VALUES ('05020167', '英语(中加合作办学)', null);
INSERT INTO `zytybmb` VALUES ('05020168', '英语(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('05020169', '英语国际商务管理方向', null);
INSERT INTO `zytybmb` VALUES ('05020170', '英语含经贸、翻译方向', null);
INSERT INTO `zytybmb` VALUES ('05020174', '英语商务方向', null);
INSERT INTO `zytybmb` VALUES ('05020175', '英语商务英语、英语语言文学、英语翻译方', null);
INSERT INTO `zytybmb` VALUES ('05020176', '英语专业(文理兼招)', null);
INSERT INTO `zytybmb` VALUES ('05020177', '英语专业(语言学与应用语言学、英美文学、跨文化交际与翻译方向)', null);
INSERT INTO `zytybmb` VALUES ('05020178', '英语专业(语言学与应用语言学、英语文学、跨文化交际与翻译方向)', null);
INSERT INTO `zytybmb` VALUES ('050202', '俄语', null);
INSERT INTO `zytybmb` VALUES ('05020201', '俄语(商务俄语)', null);
INSERT INTO `zytybmb` VALUES ('05020202', '俄语(商务俄语方向)', null);
INSERT INTO `zytybmb` VALUES ('05020203', '俄语(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('050203', '德语', null);
INSERT INTO `zytybmb` VALUES ('05020301', '德语专业', null);
INSERT INTO `zytybmb` VALUES ('05020302', '德语(国防生)', null);
INSERT INTO `zytybmb` VALUES ('050204', '法语', null);
INSERT INTO `zytybmb` VALUES ('05020401', '法语(法语语言文学)', null);
INSERT INTO `zytybmb` VALUES ('050205', '西班牙语', null);
INSERT INTO `zytybmb` VALUES ('05020501', '西班牙语(国防生)', null);
INSERT INTO `zytybmb` VALUES ('05020503', '西班牙语(西英双语)专业', null);
INSERT INTO `zytybmb` VALUES ('050206', '阿拉伯语', null);
INSERT INTO `zytybmb` VALUES ('050207', '日语', null);
INSERT INTO `zytybmb` VALUES ('05020701', '日语(国际商务)', null);
INSERT INTO `zytybmb` VALUES ('05020702', '日语(商务旅游、科技翻译)', null);
INSERT INTO `zytybmb` VALUES ('05020703', '日语(商务日语)', null);
INSERT INTO `zytybmb` VALUES ('05020704', '日语(商务日语方向)', null);
INSERT INTO `zytybmb` VALUES ('05020705', '日语IT日语', null);
INSERT INTO `zytybmb` VALUES ('05020706', '日语(涉外法商方向)', null);
INSERT INTO `zytybmb` VALUES ('05020707', '日语(师范类)', null);
INSERT INTO `zytybmb` VALUES ('05020708', '日  语', null);
INSERT INTO `zytybmb` VALUES ('05020709', '日语(旅游日语、日英双语)', null);
INSERT INTO `zytybmb` VALUES ('05020710', '日语(国际经济与贸易日语、日语翻译)', null);
INSERT INTO `zytybmb` VALUES ('05020711', '日语(理科师范)', null);
INSERT INTO `zytybmb` VALUES ('05020712', '日语(说明：服务外包方向)', null);
INSERT INTO `zytybmb` VALUES ('05020713', '日语(师范)', null);
INSERT INTO `zytybmb` VALUES ('05020714', '日语(语言与文化)', null);
INSERT INTO `zytybmb` VALUES ('05020715', '日语(外经贸翻译方向)', null);
INSERT INTO `zytybmb` VALUES ('05020716', '日语(文科师范)', null);
INSERT INTO `zytybmb` VALUES ('05020717', '日语(国际商务)专业', null);
INSERT INTO `zytybmb` VALUES ('05020718', '日语(“日+英”', null);
INSERT INTO `zytybmb` VALUES ('05020719', '日语(旅业商务日语)', null);
INSERT INTO `zytybmb` VALUES ('05020720', '日语含经贸、日本文化方向', null);
INSERT INTO `zytybmb` VALUES ('050208', '波斯语', null);
INSERT INTO `zytybmb` VALUES ('050209', '朝鲜语', null);
INSERT INTO `zytybmb` VALUES ('05020901', '朝鲜语(韩国语)', null);
INSERT INTO `zytybmb` VALUES ('05020902', '朝鲜语(3+1中韩学分互认项目)', null);
INSERT INTO `zytybmb` VALUES ('05020903', '朝鲜语(朝英复语)', null);
INSERT INTO `zytybmb` VALUES ('05020904', '朝鲜语(韩英双语)', null);
INSERT INTO `zytybmb` VALUES ('05020905', '朝鲜(韩)语', null);
INSERT INTO `zytybmb` VALUES ('05020906', '朝鲜语(商务旅游、翻译)', null);
INSERT INTO `zytybmb` VALUES ('05020907', '朝鲜语(韩语)', null);
INSERT INTO `zytybmb` VALUES ('05020908', '朝鲜语(韩国语方向)', null);
INSERT INTO `zytybmb` VALUES ('050210', '菲律宾语', null);
INSERT INTO `zytybmb` VALUES ('050211', '梵语巴利语', null);
INSERT INTO `zytybmb` VALUES ('050212', '印度尼西亚语', null);
INSERT INTO `zytybmb` VALUES ('050213', '印地语', null);
INSERT INTO `zytybmb` VALUES ('050214', '柬埔寨语', null);
INSERT INTO `zytybmb` VALUES ('050215', '老挝语', null);
INSERT INTO `zytybmb` VALUES ('050216', '缅甸语', null);
INSERT INTO `zytybmb` VALUES ('05021601', '缅甸语专业(非师范，文理兼招)', null);
INSERT INTO `zytybmb` VALUES ('050217', '马来语', null);
INSERT INTO `zytybmb` VALUES ('050218', '蒙古语', null);
INSERT INTO `zytybmb` VALUES ('050219', '僧伽罗语', null);
INSERT INTO `zytybmb` VALUES ('050220', '泰语', null);
INSERT INTO `zytybmb` VALUES ('05022001', '泰语(高职本科旅游方向)', null);
INSERT INTO `zytybmb` VALUES ('05022002', '泰语(高职本科商务方向)', null);
INSERT INTO `zytybmb` VALUES ('05022003', '泰语专业(非师范，文理兼招)', null);
INSERT INTO `zytybmb` VALUES ('050221', '乌尔都语', null);
INSERT INTO `zytybmb` VALUES ('050222', '希伯来语', null);
INSERT INTO `zytybmb` VALUES ('05022201', '希伯莱语', null);
INSERT INTO `zytybmb` VALUES ('050223', '越南语', null);
INSERT INTO `zytybmb` VALUES ('05022301', '越南语专业(非师范，文理兼招)', null);
INSERT INTO `zytybmb` VALUES ('050224', '豪萨语', null);
INSERT INTO `zytybmb` VALUES ('050225', '斯瓦希里语', null);
INSERT INTO `zytybmb` VALUES ('050226', '阿尔巴尼亚语', null);
INSERT INTO `zytybmb` VALUES ('050227', '保加利亚语', null);
INSERT INTO `zytybmb` VALUES ('050228', '波兰语', null);
INSERT INTO `zytybmb` VALUES ('050229', '捷克语', null);
INSERT INTO `zytybmb` VALUES ('05022901', '捷克语-斯洛伐克语', null);
INSERT INTO `zytybmb` VALUES ('05022902', '捷克语—斯洛伐克语', null);
INSERT INTO `zytybmb` VALUES ('05022903', '捷克语一斯洛伐克语', null);
INSERT INTO `zytybmb` VALUES ('050230', '斯洛伐克语', null);
INSERT INTO `zytybmb` VALUES ('050231', '罗马尼亚语', null);
INSERT INTO `zytybmb` VALUES ('050232', '葡萄牙语', null);
INSERT INTO `zytybmb` VALUES ('050233', '瑞典语', null);
INSERT INTO `zytybmb` VALUES ('050234', '塞尔维亚语', null);
INSERT INTO `zytybmb` VALUES ('05023401', '塞尔维亚—克罗地亚语', null);
INSERT INTO `zytybmb` VALUES ('050235', '土耳其语', null);
INSERT INTO `zytybmb` VALUES ('050236', '希腊语', null);
INSERT INTO `zytybmb` VALUES ('050237', '匈牙利语', null);
INSERT INTO `zytybmb` VALUES ('050238', '意大利语', null);
INSERT INTO `zytybmb` VALUES ('050239', '泰米尔语', null);
INSERT INTO `zytybmb` VALUES ('050240', '普什图语', null);
INSERT INTO `zytybmb` VALUES ('050241', '世界语', null);
INSERT INTO `zytybmb` VALUES ('050242', '孟加拉语', null);
INSERT INTO `zytybmb` VALUES ('050243', '尼泊尔语', null);
INSERT INTO `zytybmb` VALUES ('050244', '克罗地亚语', null);
INSERT INTO `zytybmb` VALUES ('050245', '荷兰语', null);
INSERT INTO `zytybmb` VALUES ('050246', '芬兰语', null);
INSERT INTO `zytybmb` VALUES ('050247', '乌克兰语', null);
INSERT INTO `zytybmb` VALUES ('050248', '挪威语', null);
INSERT INTO `zytybmb` VALUES ('050249', '丹麦语', null);
INSERT INTO `zytybmb` VALUES ('050250', '冰岛语', null);
INSERT INTO `zytybmb` VALUES ('050251', '爱尔兰语', null);
INSERT INTO `zytybmb` VALUES ('050252', '拉脱维亚语', null);
INSERT INTO `zytybmb` VALUES ('050253', '立陶宛语', null);
INSERT INTO `zytybmb` VALUES ('050254', '斯洛文尼亚语', null);
INSERT INTO `zytybmb` VALUES ('050255', '爱沙尼亚语', null);
INSERT INTO `zytybmb` VALUES ('050256', '马耳他语', null);
INSERT INTO `zytybmb` VALUES ('050257', '哈萨克语', null);
INSERT INTO `zytybmb` VALUES ('050258', '乌兹别克语', null);
INSERT INTO `zytybmb` VALUES ('050259', '祖鲁语', null);
INSERT INTO `zytybmb` VALUES ('050260', '拉丁语', null);
INSERT INTO `zytybmb` VALUES ('050261', '翻译', null);
INSERT INTO `zytybmb` VALUES ('05026101', '翻译(“汉+英+法”方向)', null);
INSERT INTO `zytybmb` VALUES ('05026102', '翻译(俄语)', null);
INSERT INTO `zytybmb` VALUES ('05026103', '翻译(法语方向)', null);
INSERT INTO `zytybmb` VALUES ('05026104', '翻译(英语方向)', null);
INSERT INTO `zytybmb` VALUES ('05026105', '翻译(英语)', null);
INSERT INTO `zytybmb` VALUES ('050262', '商务英语', null);
INSERT INTO `zytybmb` VALUES ('05026201', '商务策划管理', null);
INSERT INTO `zytybmb` VALUES ('05026203', '商务英语(翻译)', null);
INSERT INTO `zytybmb` VALUES ('05026205', '商务英语(国际贸易)', null);
INSERT INTO `zytybmb` VALUES ('05026206', '商务英语(国际贸易、涉外文秘)', null);
INSERT INTO `zytybmb` VALUES ('05026208', '商务英语(含国际贸易、涉外文秘)', null);
INSERT INTO `zytybmb` VALUES ('05026209', '商务英语(含国际贸易、涉外文秘方向)', null);
INSERT INTO `zytybmb` VALUES ('05026212', '商务英语(跨境电子商务)', null);
INSERT INTO `zytybmb` VALUES ('05026213', '商务英语(理科)', null);
INSERT INTO `zytybmb` VALUES ('05026217', '商务英语(文科)', null);
INSERT INTO `zytybmb` VALUES ('050300', '新闻传播学类', null);
INSERT INTO `zytybmb` VALUES ('050301', '新闻学', null);
INSERT INTO `zytybmb` VALUES ('05030101', '新闻传播学', null);
INSERT INTO `zytybmb` VALUES ('05030102', '新闻学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('05030103', '新闻学(国际新闻)专业方向', null);
INSERT INTO `zytybmb` VALUES ('05030104', '新闻传播学类(含新闻学、公共关系学、传播学、网络与新媒体专业)', null);
INSERT INTO `zytybmb` VALUES ('05030105', '新闻传播学类(外向型人才实验班)', null);
INSERT INTO `zytybmb` VALUES ('05030106', '新闻学(经济新闻)', null);
INSERT INTO `zytybmb` VALUES ('05030107', '新闻传播学类专业(新闻学、广播电视学、广告学、编辑出版学)', null);
INSERT INTO `zytybmb` VALUES ('05030108', '新闻传播学类专业(新闻学、广播电视新闻学、广告学、编辑出版学)', null);
INSERT INTO `zytybmb` VALUES ('05030109', '新闻学(法制新闻方向)', null);
INSERT INTO `zytybmb` VALUES ('05030110', '新闻传播学类(含新闻学、广播电视学)', null);
INSERT INTO `zytybmb` VALUES ('05030111', '新闻学(含新闻学方向、国际传播方向)', null);
INSERT INTO `zytybmb` VALUES ('05030112', '新闻学(媒介经营与管理)', null);
INSERT INTO `zytybmb` VALUES ('05030113', '新闻传播学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('05030114', '新闻学(综合方向)', null);
INSERT INTO `zytybmb` VALUES ('05030115', '新闻学(国际新闻传播)', null);
INSERT INTO `zytybmb` VALUES ('05030116', '新闻学(应用技术本科)', null);
INSERT INTO `zytybmb` VALUES ('05030117', '新闻传播学类(中外台作办学)', null);
INSERT INTO `zytybmb` VALUES ('05030118', '新闻学专业', null);
INSERT INTO `zytybmb` VALUES ('05030119', '新闻学 (新闻业务)', null);
INSERT INTO `zytybmb` VALUES ('05030122', '新闻采编与制作(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('050302', '广播电视学', null);
INSERT INTO `zytybmb` VALUES ('05030201', '广播电视学(广告创意与策划)', null);
INSERT INTO `zytybmb` VALUES ('05030202', '广播电视学(师范类)', null);
INSERT INTO `zytybmb` VALUES ('05030203', '广播电视学影视多媒体技术方向', null);
INSERT INTO `zytybmb` VALUES ('05030204', '广播电视新闻学', null);
INSERT INTO `zytybmb` VALUES ('050303', '广告学', null);
INSERT INTO `zytybmb` VALUES ('05030301', '广告学(会展策划)专业方向', null);
INSERT INTO `zytybmb` VALUES ('05030302', '广告学(品牌传播)', null);
INSERT INTO `zytybmb` VALUES ('05030303', '广告学(网络传播方向)', null);
INSERT INTO `zytybmb` VALUES ('05030304', '广告学(文)', null);
INSERT INTO `zytybmb` VALUES ('05030305', '广告学(艺)', null);
INSERT INTO `zytybmb` VALUES ('05030306', '广告学(英文教学)', null);
INSERT INTO `zytybmb` VALUES ('05030307', '广告学创意传媒方向', null);
INSERT INTO `zytybmb` VALUES ('05030308', '广告', null);
INSERT INTO `zytybmb` VALUES ('050304', '传播学', null);
INSERT INTO `zytybmb` VALUES ('05030401', '传播学(跨文化传播)专业方向', null);
INSERT INTO `zytybmb` VALUES ('05030402', '传播学(英文教学)', null);
INSERT INTO `zytybmb` VALUES ('05030403', '传播学(网络媒体经营与管理方向)', null);
INSERT INTO `zytybmb` VALUES ('05030404', '传播学(网络与新媒体方向)', null);
INSERT INTO `zytybmb` VALUES ('05030405', '传播学(网络传播方向)', null);
INSERT INTO `zytybmb` VALUES ('05030406', '传播学(网络与新媒体)', null);
INSERT INTO `zytybmb` VALUES ('05030407', '传播学(网络与新媒体方向', null);
INSERT INTO `zytybmb` VALUES ('05030408', '传播学(网络经营与管理', null);
INSERT INTO `zytybmb` VALUES ('050305', '编辑出版学', null);
INSERT INTO `zytybmb` VALUES ('05030501', '编辑出版学(数字出版)', null);
INSERT INTO `zytybmb` VALUES ('05030502', '编辑出版', null);
INSERT INTO `zytybmb` VALUES ('05030601', '媒体创意', null);
INSERT INTO `zytybmb` VALUES ('050306T', '网络与新媒体', null);
INSERT INTO `zytybmb` VALUES ('050306T1', '新媒体与信息网络', null);
INSERT INTO `zytybmb` VALUES ('050307T', '数字出版', null);
INSERT INTO `zytybmb` VALUES ('060000', '历史学', null);
INSERT INTO `zytybmb` VALUES ('060100', '历史学类', null);
INSERT INTO `zytybmb` VALUES ('060101', '历史学', null);
INSERT INTO `zytybmb` VALUES ('06010101', '历史学(行知实验班)', null);
INSERT INTO `zytybmb` VALUES ('06010102', '历史学(基地)', null);
INSERT INTO `zytybmb` VALUES ('06010103', '历史学(基地班)', null);
INSERT INTO `zytybmb` VALUES ('06010104', '历史学(免费师范)', null);
INSERT INTO `zytybmb` VALUES ('06010105', '历史学(师范)', null);
INSERT INTO `zytybmb` VALUES ('06010106', '历史学(师范类)', null);
INSERT INTO `zytybmb` VALUES ('06010107', '历史学(文化遗产)', null);
INSERT INTO `zytybmb` VALUES ('06010108', '历史学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('06010109', '历史学基础班', null);
INSERT INTO `zytybmb` VALUES ('06010110', '历史学基地班', null);
INSERT INTO `zytybmb` VALUES ('06010111', '历史学历史信息系统方向', null);
INSERT INTO `zytybmb` VALUES ('06010112', '历史学文档信息管理方向', null);
INSERT INTO `zytybmb` VALUES ('06010113', '历史学专业', null);
INSERT INTO `zytybmb` VALUES ('06010114', '文史哲基地(历史学)', null);
INSERT INTO `zytybmb` VALUES ('060102', '世界史', null);
INSERT INTO `zytybmb` VALUES ('06010201', '世界历史', null);
INSERT INTO `zytybmb` VALUES ('060103', '考古学', null);
INSERT INTO `zytybmb` VALUES ('06010301', '考古', null);
INSERT INTO `zytybmb` VALUES ('060104', '文物与博物馆学', null);
INSERT INTO `zytybmb` VALUES ('06010401', '博物馆学', null);
INSERT INTO `zytybmb` VALUES ('06010402', '文物与博物馆学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('06010403', '文物与博物馆学(博物馆学方向)', null);
INSERT INTO `zytybmb` VALUES ('060105T', '文物保护技术', null);
INSERT INTO `zytybmb` VALUES ('060106T', '外国语言与外国历史', null);
INSERT INTO `zytybmb` VALUES ('060106T01', '外国语言文学', null);
INSERT INTO `zytybmb` VALUES ('060106T02', '外国语言文学类(中外合作办学)(', null);
INSERT INTO `zytybmb` VALUES ('060106T03', '外国语言文学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('060106T04', '外国语言文学类(含英语、阿拉伯语、西班牙语、朝鲜语、俄语专业)', null);
INSERT INTO `zytybmb` VALUES ('060106T05', '外国语言文学类(中外)', null);
INSERT INTO `zytybmb` VALUES ('060106T06', '外国语言文学类(英语、翻译)', null);
INSERT INTO `zytybmb` VALUES ('060106T07', '外国语言文学(外国军事)', null);
INSERT INTO `zytybmb` VALUES ('060106T08', '外国语言文学(中外)', null);
INSERT INTO `zytybmb` VALUES ('060106T09', '外围语言文学类', null);
INSERT INTO `zytybmb` VALUES ('070000', '理学', null);
INSERT INTO `zytybmb` VALUES ('070100', '数学类', null);
INSERT INTO `zytybmb` VALUES ('07010001', '数学', null);
INSERT INTO `zytybmb` VALUES ('07010002', '数学基础班', null);
INSERT INTO `zytybmb` VALUES ('07010003', '数学类(含数学与应用数学、统计学、信息与计算科学、应用统计学专业)', null);
INSERT INTO `zytybmb` VALUES ('07010004', '数学类(含数学与应用数学、信息与计算科学)', null);
INSERT INTO `zytybmb` VALUES ('07010005', '数学类(基地)', null);
INSERT INTO `zytybmb` VALUES ('07010006', '数学类(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('07010007', '数学类(泰山学堂、潘承洞班)', null);
INSERT INTO `zytybmb` VALUES ('07010008', '数学类(信息与计算科学、数学与应用数学)', null);
INSERT INTO `zytybmb` VALUES ('07010009', '数学类(中外)', null);
INSERT INTO `zytybmb` VALUES ('07010010', '数学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('07010011', '数学类(国防生)', null);
INSERT INTO `zytybmb` VALUES ('07010012', '数学基地班', null);
INSERT INTO `zytybmb` VALUES ('07010013', '数学菁英班', null);
INSERT INTO `zytybmb` VALUES ('07010014', '数学类(含数学与应用数学(师范类)、信息与计算科学)', null);
INSERT INTO `zytybmb` VALUES ('070101', '数学与应用数学', null);
INSERT INTO `zytybmb` VALUES ('07010102', '数学应用数学(行知实验班)', null);
INSERT INTO `zytybmb` VALUES ('07010103', '数学与应用数', null);
INSERT INTO `zytybmb` VALUES ('07010104', '数学与应用数学(按数学类招生)', null);
INSERT INTO `zytybmb` VALUES ('07010105', '数学与应用数学(含数学与应用数学、数学经济学交叉培养班)', null);
INSERT INTO `zytybmb` VALUES ('07010106', '数学与应用数学(金融)', null);
INSERT INTO `zytybmb` VALUES ('07010107', '数学与应用数学(金融方向)', null);
INSERT INTO `zytybmb` VALUES ('07010108', '数学与应用数学(金融数学)', null);
INSERT INTO `zytybmb` VALUES ('07010109', '数学与应用数学(金融数学、应用数学方向)', null);
INSERT INTO `zytybmb` VALUES ('07010110', '数学与应用数学(金融数学方向)', null);
INSERT INTO `zytybmb` VALUES ('07010111', '数学与应用数学(经济数学方向)', null);
INSERT INTO `zytybmb` VALUES ('07010112', '数学与应用数学(免费师范)', null);
INSERT INTO `zytybmb` VALUES ('07010113', '数学与应用数学(免费师范，定克)', null);
INSERT INTO `zytybmb` VALUES ('07010114', '数学与应用数学(师范)', null);
INSERT INTO `zytybmb` VALUES ('07010115', '数学与应用数学(师范、定向西藏)', null);
INSERT INTO `zytybmb` VALUES ('07010116', '数学与应用数学(师范类)', null);
INSERT INTO `zytybmb` VALUES ('07010117', '数学与应用数学(数理金融)', null);
INSERT INTO `zytybmb` VALUES ('07010118', '数学与应用数学(双学位实验班)', null);
INSERT INTO `zytybmb` VALUES ('07010119', '数学与应用数学(中俄学院)', null);
INSERT INTO `zytybmb` VALUES ('07010120', '数学与应用数学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('07010121', '数学与应用数学保险精算方向', null);
INSERT INTO `zytybmb` VALUES ('07010122', '数学与应用数学创新班(本硕、本博连读)', null);
INSERT INTO `zytybmb` VALUES ('07010123', '数学与应用数学金融统计方向', null);
INSERT INTO `zytybmb` VALUES ('07010124', '数学与应用数学金融与统计方向', null);
INSERT INTO `zytybmb` VALUES ('07010125', '数学与应用数学专业', null);
INSERT INTO `zytybmb` VALUES ('07010126', '数学与应用数学专业(金融工程)', null);
INSERT INTO `zytybmb` VALUES ('07010127', '数学与应用数学专业(金融数学、应用数学方向)', null);
INSERT INTO `zytybmb` VALUES ('07010128', '数学与运用数学', null);
INSERT INTO `zytybmb` VALUES ('07010129', '数学应用数学', null);
INSERT INTO `zytybmb` VALUES ('070102', '信息与计算科学', null);
INSERT INTO `zytybmb` VALUES ('07010201', '信息与计算机科学', null);
INSERT INTO `zytybmb` VALUES ('07010202', '信息与计算机学', null);
INSERT INTO `zytybmb` VALUES ('07010203', '信息与计算科学(非师范)', null);
INSERT INTO `zytybmb` VALUES ('07010204', '信息与计算科学(高智能手机开发方向)', null);
INSERT INTO `zytybmb` VALUES ('07010205', '信息与计算科学(工程计算与数据处理)', null);
INSERT INTO `zytybmb` VALUES ('07010206', '信息与计算科学(计算数学与软件方向)', null);
INSERT INTO `zytybmb` VALUES ('07010207', '信息与计算科学(商业分析)', null);
INSERT INTO `zytybmb` VALUES ('07010208', '信息与计算科学(师范)', null);
INSERT INTO `zytybmb` VALUES ('07010209', '信息与计算科学(数理金融)', null);
INSERT INTO `zytybmb` VALUES ('07010210', '信息与计算科学(数量金融)', null);
INSERT INTO `zytybmb` VALUES ('07010211', '信息与计算科学(信息安全)', null);
INSERT INTO `zytybmb` VALUES ('07010212', '信息与计算科学(信息处理方向)', null);
INSERT INTO `zytybmb` VALUES ('07010213', '信息与计算科学(信息计算)', null);
INSERT INTO `zytybmb` VALUES ('07010214', '信息与计算科学(医学信息学)', null);
INSERT INTO `zytybmb` VALUES ('07010215', '信息与计算科学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('07010216', '信息与计算科学专业', null);
INSERT INTO `zytybmb` VALUES ('07010217', '信息与技术科学(嵌入式培养)', null);
INSERT INTO `zytybmb` VALUES ('070103T', '数理基础科学', null);
INSERT INTO `zytybmb` VALUES ('070103T01', '数理基础科学班', null);
INSERT INTO `zytybmb` VALUES ('070103T02', '数理基础实验班', null);
INSERT INTO `zytybmb` VALUES ('070103T03', '数理学基地(数学)', null);
INSERT INTO `zytybmb` VALUES ('070103T04', '数理学基地(物理)', null);
INSERT INTO `zytybmb` VALUES ('070200', '物理学类', null);
INSERT INTO `zytybmb` VALUES ('07020001', '物理学类(基地)', null);
INSERT INTO `zytybmb` VALUES ('07020002', '物理学类(数学物理交叉培养班)', null);
INSERT INTO `zytybmb` VALUES ('07020003', '物理学类(泰山学堂、王淦昌班)', null);
INSERT INTO `zytybmb` VALUES ('07020004', '物理学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('07020005', '物理学专业', null);
INSERT INTO `zytybmb` VALUES ('070201', '物理学', null);
INSERT INTO `zytybmb` VALUES ('07020101', '物理', null);
INSERT INTO `zytybmb` VALUES ('07020102', '物理工程', null);
INSERT INTO `zytybmb` VALUES ('07020103', '物理菁英班', null);
INSERT INTO `zytybmb` VALUES ('07020104', '物理菁英班(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('07020105', '物理科学', null);
INSERT INTO `zytybmb` VALUES ('07020106', '物理科学(师范)', null);
INSERT INTO `zytybmb` VALUES ('07020107', '物理学(光电检测)', null);
INSERT INTO `zytybmb` VALUES ('07020108', '物理学(行知实验班)', null);
INSERT INTO `zytybmb` VALUES ('07020109', '物理学(基地班)', null);
INSERT INTO `zytybmb` VALUES ('07020110', '物理学(免费师范)', null);
INSERT INTO `zytybmb` VALUES ('07020111', '物理学(免费师范，定克)', null);
INSERT INTO `zytybmb` VALUES ('07020112', '物理学(师范)', null);
INSERT INTO `zytybmb` VALUES ('07020113', '物理学(师范类)', null);
INSERT INTO `zytybmb` VALUES ('07020114', '物理学(通用技术)', null);
INSERT INTO `zytybmb` VALUES ('07020115', '物理学光电子技术方向', null);
INSERT INTO `zytybmb` VALUES ('07020116', '物理学光电子技术与应用方向', null);
INSERT INTO `zytybmb` VALUES ('07020117', '物理学基地班', null);
INSERT INTO `zytybmb` VALUES ('070202', '应用物理学', null);
INSERT INTO `zytybmb` VALUES ('07020201', '应用物理科学', null);
INSERT INTO `zytybmb` VALUES ('07020202', '应用物理学(光通信与光电子技术)', null);
INSERT INTO `zytybmb` VALUES ('07020203', '应用物理学(通信基础科学)', null);
INSERT INTO `zytybmb` VALUES ('07020204', '应用物理学(微电子方向)', null);
INSERT INTO `zytybmb` VALUES ('07020205', '应用物理学(新能源和微电子)', null);
INSERT INTO `zytybmb` VALUES ('07020206', '应用物理学(中俄学院)', null);
INSERT INTO `zytybmb` VALUES ('07020207', '应用物理学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('07020208', '应用物理学专业(光电子技术与通信、光电信息工程方向)', null);
INSERT INTO `zytybmb` VALUES ('07020209', '应用物理学专业(光电子技术与通信方向)', null);
INSERT INTO `zytybmb` VALUES ('070203', '核物理', null);
INSERT INTO `zytybmb` VALUES ('07020301', '核反应堆工程', null);
INSERT INTO `zytybmb` VALUES ('070204T', '声学', null);
INSERT INTO `zytybmb` VALUES ('070300', '化学类', null);
INSERT INTO `zytybmb` VALUES ('070301', '化学', null);
INSERT INTO `zytybmb` VALUES ('07030101', '化学类(基地)', null);
INSERT INTO `zytybmb` VALUES ('07030102', '化学工程与工艺(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('07030103', '化学基地班', null);
INSERT INTO `zytybmb` VALUES ('07030104', '化学类(含化学、化学工程与工艺、高分子材料与工程、材料化学、应用化学、化学生物学专业)', null);
INSERT INTO `zytybmb` VALUES ('07030105', '化学(与香港理工大学联合培养)', null);
INSERT INTO `zytybmb` VALUES ('07030106', '化学类(泰山学堂、邓从豪班)', null);
INSERT INTO `zytybmb` VALUES ('07030107', '化学工程与工艺(无机化工、有机化工、能源化工、高分子化工方向)', null);
INSERT INTO `zytybmb` VALUES ('07030108', '化学类创新班(本硕、本博连读)', null);
INSERT INTO `zytybmb` VALUES ('07030109', '化学菁英班', null);
INSERT INTO `zytybmb` VALUES ('07030110', '化学菁英班(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('07030111', '化学(师范类)', null);
INSERT INTO `zytybmb` VALUES ('07030112', '化学(师范)', null);
INSERT INTO `zytybmb` VALUES ('07030113', '化学类(应用化学、材料化学)', null);
INSERT INTO `zytybmb` VALUES ('07030114', '化学类(中外)', null);
INSERT INTO `zytybmb` VALUES ('07030115', '化学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('07030116', '化学工程与工艺(卓越工程师班)', null);
INSERT INTO `zytybmb` VALUES ('07030117', '化学与化工学院', null);
INSERT INTO `zytybmb` VALUES ('07030118', '化学(国家特色专业、设有基础专业奖学金)', null);
INSERT INTO `zytybmb` VALUES ('07030119', '化学类(含化学、应用化学、化学英才班、化学生物交叉培养班)', null);
INSERT INTO `zytybmb` VALUES ('07030120', '化学工程与工艺(卓越班)', null);
INSERT INTO `zytybmb` VALUES ('07030121', '化学工程与工艺(贫困A)', null);
INSERT INTO `zytybmb` VALUES ('07030122', '化学工程与工艺(中俄学院)', null);
INSERT INTO `zytybmb` VALUES ('07030123', '化学工程与工艺(精细化工方向)', null);
INSERT INTO `zytybmb` VALUES ('07030124', '化学工程与工艺(英才计划)', null);
INSERT INTO `zytybmb` VALUES ('07030125', '化学(免费师范)', null);
INSERT INTO `zytybmb` VALUES ('07030126', '化学(师范', null);
INSERT INTO `zytybmb` VALUES ('07030127', '化学１', null);
INSERT INTO `zytybmb` VALUES ('07030128', '化学(生物化学方向)', null);
INSERT INTO `zytybmb` VALUES ('07030129', '化学(行知实验班)', null);
INSERT INTO `zytybmb` VALUES ('07030130', '化学(应用化学)', null);
INSERT INTO `zytybmb` VALUES ('07030131', '化学生物学专业', null);
INSERT INTO `zytybmb` VALUES ('07030132', '化学专业', null);
INSERT INTO `zytybmb` VALUES ('07030133', '化学工程与工艺(过程装备及控制工程方向)', null);
INSERT INTO `zytybmb` VALUES ('07030134', '化学工程与工艺(贫困B)', null);
INSERT INTO `zytybmb` VALUES ('07030135', '化学工程与工艺(职教师资方向)', null);
INSERT INTO `zytybmb` VALUES ('07030136', '化学工程与工艺(煤化工与磷化工方向)', null);
INSERT INTO `zytybmb` VALUES ('07030137', '化学工程与工艺(能源变换材料及工程方向)', null);
INSERT INTO `zytybmb` VALUES ('07030138', '化学工程与工艺(过程装备)', null);
INSERT INTO `zytybmb` VALUES ('07030139', '化学工程与工艺(能源变化)', null);
INSERT INTO `zytybmb` VALUES ('070302', '应用化学', null);
INSERT INTO `zytybmb` VALUES ('07030201', '应用化学(材料化学、分析科学方向)', null);
INSERT INTO `zytybmb` VALUES ('07030202', '应用化学(工业分析与检验方向)', null);
INSERT INTO `zytybmb` VALUES ('07030203', '应用化学(国防生，男生，军检线，指挥)', null);
INSERT INTO `zytybmb` VALUES ('07030204', '应用化学(化工与制药)', null);
INSERT INTO `zytybmb` VALUES ('07030205', '应用化学(化学生物学)', null);
INSERT INTO `zytybmb` VALUES ('07030206', '应用化学(精细合成、工业分析)', null);
INSERT INTO `zytybmb` VALUES ('07030207', '应用化学(精细化工方向)', null);
INSERT INTO `zytybmb` VALUES ('07030208', '应用化学(四年制本科)', null);
INSERT INTO `zytybmb` VALUES ('07030209', '应用化学(药物分析与检测)', null);
INSERT INTO `zytybmb` VALUES ('07030210', '应用化学(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('07030211', '应用化学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('07030212', '应用化学环境监测方向', null);
INSERT INTO `zytybmb` VALUES ('07030213', '应用化学环境科学与技术方向', null);
INSERT INTO `zytybmb` VALUES ('07030214', '应用化学精细化工方向', null);
INSERT INTO `zytybmb` VALUES ('07030215', '应用化学药物合成方向', null);
INSERT INTO `zytybmb` VALUES ('07030216', '应用化学专业(材料化学、分析科学方向)', null);
INSERT INTO `zytybmb` VALUES ('07030301', '生物化学与分子生物学', null);
INSERT INTO `zytybmb` VALUES ('070303T', '化学生物学', null);
INSERT INTO `zytybmb` VALUES ('070304T', '分子科学与工程', null);
INSERT INTO `zytybmb` VALUES ('070400', '天文学类', null);
INSERT INTO `zytybmb` VALUES ('070401', '天文学', null);
INSERT INTO `zytybmb` VALUES ('070500', '地理科学类', null);
INSERT INTO `zytybmb` VALUES ('070501', '地理科学', null);
INSERT INTO `zytybmb` VALUES ('07050101', '地理信息系统', null);
INSERT INTO `zytybmb` VALUES ('07050102', '地理科学类(含人文地理与城乡规划、自然地理与资源环境、地理信息科学)', null);
INSERT INTO `zytybmb` VALUES ('07050103', '地理科学类(含自然地理与资源环境、人文地理与城乡规划、地理科学、地理信息科学专业)', null);
INSERT INTO `zytybmb` VALUES ('07050104', '地理学基地班', null);
INSERT INTO `zytybmb` VALUES ('07050105', '地理科学(师范)', null);
INSERT INTO `zytybmb` VALUES ('07050106', '地理刚情监测', null);
INSERT INTO `zytybmb` VALUES ('07050107', '地理信息学', null);
INSERT INTO `zytybmb` VALUES ('07050108', '地理信自科学', null);
INSERT INTO `zytybmb` VALUES ('07050109', '地理科科学类', null);
INSERT INTO `zytybmb` VALUES ('07050110', '地理科信息科学', null);
INSERT INTO `zytybmb` VALUES ('07050111', '地理信息科学空间信息技术方向', null);
INSERT INTO `zytybmb` VALUES ('07050112', '地理科学(旅游资源开发方向)', null);
INSERT INTO `zytybmb` VALUES ('07050113', '地理科学类(含地理科学、人文地理与城乡规划)', null);
INSERT INTO `zytybmb` VALUES ('07050114', '地理科学类(含地理科学、自然地理与资源环境、人文地理与城乡规划)', null);
INSERT INTO `zytybmb` VALUES ('07050115', '地理科学类(含地理科学、自然地理与资源环境、人文地理与城乡规划、', null);
INSERT INTO `zytybmb` VALUES ('07050116', '地理科学类(含地理科学(师范类)、自然地理与资源环境、人文地理与', null);
INSERT INTO `zytybmb` VALUES ('07050117', '地理科学类(含地理科学、自然地理与资源环境、人文地理与城乡规划', null);
INSERT INTO `zytybmb` VALUES ('07050118', '地理科学类(中外)', null);
INSERT INTO `zytybmb` VALUES ('07050119', '地理科学类(含地理科学(师范类)、人文地理与城乡规划)', null);
INSERT INTO `zytybmb` VALUES ('07050120', '地理科科学(师范)', null);
INSERT INTO `zytybmb` VALUES ('07050121', '地理信息科学(定向)', null);
INSERT INTO `zytybmb` VALUES ('07050122', '地理科学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('07050123', '地理科学(免费师范)', null);
INSERT INTO `zytybmb` VALUES ('07050124', '地理同情监测', null);
INSERT INTO `zytybmb` VALUES ('07050125', '地理科学(师范', null);
INSERT INTO `zytybmb` VALUES ('07050126', '地理科学(师范类)', null);
INSERT INTO `zytybmb` VALUES ('07050127', '地理科学(行知实验班)', null);
INSERT INTO `zytybmb` VALUES ('070502', '自然地理与资源环境', null);
INSERT INTO `zytybmb` VALUES ('07050201', '自然地理', null);
INSERT INTO `zytybmb` VALUES ('07050202', '自然地理科与资源环境', null);
INSERT INTO `zytybmb` VALUES ('07050203', '自然地理与资源环境', null);
INSERT INTO `zytybmb` VALUES ('07050204', '自然地理与资源环境(定向)', null);
INSERT INTO `zytybmb` VALUES ('07050205', '自然地理与资源环境(国土规划与整治)', null);
INSERT INTO `zytybmb` VALUES ('07050206', '自然地理与资源环境土地利用与景观规划方', null);
INSERT INTO `zytybmb` VALUES ('070503', '人文地理与城乡规划', null);
INSERT INTO `zytybmb` VALUES ('07050301', '人文地理及城乡规划', null);
INSERT INTO `zytybmb` VALUES ('07050302', '人文地理与城乡规划(定向)', null);
INSERT INTO `zytybmb` VALUES ('07050303', '人文地理与城乡规划城乡规划方向', null);
INSERT INTO `zytybmb` VALUES ('07050304', '人文地理与城乡规划城乡建设与房地产开发', null);
INSERT INTO `zytybmb` VALUES ('07050305', '人文地理与城乡规划房地产开发与管理方向', null);
INSERT INTO `zytybmb` VALUES ('07050306', '人文地理与城乡规划旅游开发与管理方向', null);
INSERT INTO `zytybmb` VALUES ('07050307', '人文科地理科与城乡规划', null);
INSERT INTO `zytybmb` VALUES ('07050308', '环境资源与城乡规划管理', null);
INSERT INTO `zytybmb` VALUES ('070504', '地理信息科学', null);
INSERT INTO `zytybmb` VALUES ('070600', '大气科学类', null);
INSERT INTO `zytybmb` VALUES ('070601', '大气科学', null);
INSERT INTO `zytybmb` VALUES ('07060103', '大气科学类(含大气科学、应用气象学专业)', null);
INSERT INTO `zytybmb` VALUES ('070602', '应用气象学', null);
INSERT INTO `zytybmb` VALUES ('070700', '海洋科学类', null);
INSERT INTO `zytybmb` VALUES ('070701', '海洋科学', null);
INSERT INTO `zytybmb` VALUES ('07070101', '海洋科学专业', null);
INSERT INTO `zytybmb` VALUES ('07070102', '海洋管理', null);
INSERT INTO `zytybmb` VALUES ('070702', '海洋技术', null);
INSERT INTO `zytybmb` VALUES ('07070201', '海洋技术专业', null);
INSERT INTO `zytybmb` VALUES ('070703T', '海洋资源与环境', null);
INSERT INTO `zytybmb` VALUES ('070703T1', '海洋生物资源与环境', null);
INSERT INTO `zytybmb` VALUES ('070704T', '军事海洋学', null);
INSERT INTO `zytybmb` VALUES ('070800', '地球物理学类', null);
INSERT INTO `zytybmb` VALUES ('070801', '地球物理学', null);
INSERT INTO `zytybmb` VALUES ('070802', '空间科学与技术', null);
INSERT INTO `zytybmb` VALUES ('070900', '地质学类', null);
INSERT INTO `zytybmb` VALUES ('070901', '地质学', null);
INSERT INTO `zytybmb` VALUES ('07090101', '地质工程(卓越班)', null);
INSERT INTO `zytybmb` VALUES ('07090102', '地质学类(含地质学、地球信息科学与技术、地质工程专业)', null);
INSERT INTO `zytybmb` VALUES ('07090103', '地质学基地班', null);
INSERT INTO `zytybmb` VALUES ('07090104', '地质工程(贫困A)', null);
INSERT INTO `zytybmb` VALUES ('07090105', '地质工程(贫困B)', null);
INSERT INTO `zytybmb` VALUES ('07090106', '地质工程(工程地质方向)', null);
INSERT INTO `zytybmb` VALUES ('070902', '地球化学', null);
INSERT INTO `zytybmb` VALUES ('070903T', '地球信息科学与技术', null);
INSERT INTO `zytybmb` VALUES ('070903T1', '地球环境科学', null);
INSERT INTO `zytybmb` VALUES ('070903T2', '地球与空间科学', null);
INSERT INTO `zytybmb` VALUES ('070903T3', '地图学与地理信息工程', null);
INSERT INTO `zytybmb` VALUES ('070904T', '古生物学', null);
INSERT INTO `zytybmb` VALUES ('071000', '生物科学类', null);
INSERT INTO `zytybmb` VALUES ('07100001', '生物科学类(含生物技术、生物工程、生物科学)', null);
INSERT INTO `zytybmb` VALUES ('07100002', '生物科学类(含生物科学、生物技术、化学生物交叉培养班)', null);
INSERT INTO `zytybmb` VALUES ('07100003', '生物科学类(含生物科学、生物技术、生态学、生物工程专业)', null);
INSERT INTO `zytybmb` VALUES ('07100004', '生物科学类(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('07100005', '生物科学类(生物科学、生物技术、生物工程)', null);
INSERT INTO `zytybmb` VALUES ('07100006', '生物科学类(生物科学方向)', null);
INSERT INTO `zytybmb` VALUES ('07100007', '生物科学类(泰山学堂、童第周班)', null);
INSERT INTO `zytybmb` VALUES ('07100008', '生物科学类(中外)', null);
INSERT INTO `zytybmb` VALUES ('07100009', '生物科学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('07100010', '生物科学类(中外合作办学)(生物技术)', null);
INSERT INTO `zytybmb` VALUES ('07100011', '生物科学与生物技术', null);
INSERT INTO `zytybmb` VALUES ('07100012', '生物科学专业', null);
INSERT INTO `zytybmb` VALUES ('07100013', '生物系统工程', null);
INSERT INTO `zytybmb` VALUES ('071001', '生物科学', null);
INSERT INTO `zytybmb` VALUES ('07100101', '生物科学(动物科学)', null);
INSERT INTO `zytybmb` VALUES ('07100102', '生物科学(动物学)', null);
INSERT INTO `zytybmb` VALUES ('07100103', '生物科学(动物学)(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('07100104', '生物科学(行知实验班)', null);
INSERT INTO `zytybmb` VALUES ('07100105', '生物科学(基地)', null);
INSERT INTO `zytybmb` VALUES ('07100106', '生物科学(理科实验班)', null);
INSERT INTO `zytybmb` VALUES ('07100107', '生物科学(免费师范)', null);
INSERT INTO `zytybmb` VALUES ('07100108', '生物科学(生态监测与评价方向)', null);
INSERT INTO `zytybmb` VALUES ('07100109', '生物科学(生态学基地)', null);
INSERT INTO `zytybmb` VALUES ('07100110', '生物科学(生物学基地班)', null);
INSERT INTO `zytybmb` VALUES ('07100111', '生物科学(师范', null);
INSERT INTO `zytybmb` VALUES ('07100112', '生物科学(师范)', null);
INSERT INTO `zytybmb` VALUES ('07100113', '生物科学(师范类)', null);
INSERT INTO `zytybmb` VALUES ('07100114', '生物科学(药用植物资源与利用方向)', null);
INSERT INTO `zytybmb` VALUES ('07100115', '生物科学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('07100116', '生物科学基地班', null);
INSERT INTO `zytybmb` VALUES ('07100117', '生物学', null);
INSERT INTO `zytybmb` VALUES ('07100118', '生物学基地班', null);
INSERT INTO `zytybmb` VALUES ('07100119', '生物学基地班(生态学)', null);
INSERT INTO `zytybmb` VALUES ('071002', '生物技术', null);
INSERT INTO `zytybmb` VALUES ('07100201', '生物技术(基地)', null);
INSERT INTO `zytybmb` VALUES ('07100202', '生物技术(基地班)', null);
INSERT INTO `zytybmb` VALUES ('07100203', '生物技术(生物工程)', null);
INSERT INTO `zytybmb` VALUES ('07100204', '生物技术(生物化学方向)', null);
INSERT INTO `zytybmb` VALUES ('07100205', '生物技术(生物制药)', null);
INSERT INTO `zytybmb` VALUES ('07100206', '生物技术(生物制药方向)', null);
INSERT INTO `zytybmb` VALUES ('07100207', '生物技术(师范)', null);
INSERT INTO `zytybmb` VALUES ('07100208', '生物技术(师范类)', null);
INSERT INTO `zytybmb` VALUES ('07100209', '生物技术(食用菌方向)', null);
INSERT INTO `zytybmb` VALUES ('07100210', '生物技术(应用生物化学与食品安全、海洋生物技术与药物开发方向)', null);
INSERT INTO `zytybmb` VALUES ('07100211', '生物技术(中澳班)', null);
INSERT INTO `zytybmb` VALUES ('07100212', '生物技术(中俄学院)', null);
INSERT INTO `zytybmb` VALUES ('07100213', '生物技术(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('07100214', '生物技术基地班', null);
INSERT INTO `zytybmb` VALUES ('07100215', '生物技术专业', null);
INSERT INTO `zytybmb` VALUES ('07100216', '生物技术专业(应用生物化学与食品安全、海洋生物技术与药物开发方向)', null);
INSERT INTO `zytybmb` VALUES ('07100217', '生物技术专业(应用生物化学与食品生物技术、海洋生物技术方向)', null);
INSERT INTO `zytybmb` VALUES ('071003', '生物信息学', null);
INSERT INTO `zytybmb` VALUES ('07100301', '生物信息技术', null);
INSERT INTO `zytybmb` VALUES ('07100302', '生物信息学本科', null);
INSERT INTO `zytybmb` VALUES ('071004', '生态学', null);
INSERT INTO `zytybmb` VALUES ('07100401', '生态学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('071100', '心理学类', null);
INSERT INTO `zytybmb` VALUES ('07110001', '心理学类(含心理学、应用心理学)', null);
INSERT INTO `zytybmb` VALUES ('07110002', '心理学类(含心理学、应用心理学专业)', null);
INSERT INTO `zytybmb` VALUES ('07110003', '心理学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('071101', '心理学', null);
INSERT INTO `zytybmb` VALUES ('07110101', '心理科学', null);
INSERT INTO `zytybmb` VALUES ('07110102', '心理学(理科师范)', null);
INSERT INTO `zytybmb` VALUES ('07110103', '心理学(免费师范)', null);
INSERT INTO `zytybmb` VALUES ('07110104', '心理学(人力资源开发与测评方向)(理科)', null);
INSERT INTO `zytybmb` VALUES ('07110105', '心理学(人力资源开发与测评方向)(文科)', null);
INSERT INTO `zytybmb` VALUES ('07110106', '心理学(师范', null);
INSERT INTO `zytybmb` VALUES ('07110107', '心理学(师范类)', null);
INSERT INTO `zytybmb` VALUES ('07110108', '心理学(文科师范)', null);
INSERT INTO `zytybmb` VALUES ('071102', '应用心理学', null);
INSERT INTO `zytybmb` VALUES ('07110204', '应用心理科学(师范)', null);
INSERT INTO `zytybmb` VALUES ('07110205', '应用心理学(本科)', null);
INSERT INTO `zytybmb` VALUES ('07110206', '应用心理学(人力资源开发与管理)', null);
INSERT INTO `zytybmb` VALUES ('07110207', '应用心理学(师范)', null);
INSERT INTO `zytybmb` VALUES ('07110208', '应用心理学(心理健康咨询与教育方向)', null);
INSERT INTO `zytybmb` VALUES ('07110209', '应用心理学(心理咨询方向)', null);
INSERT INTO `zytybmb` VALUES ('07110210', '应用心理学(心理咨询与治疗方向)', null);
INSERT INTO `zytybmb` VALUES ('07110211', '应用心理学本科', null);
INSERT INTO `zytybmb` VALUES ('071200', '统计学类', null);
INSERT INTO `zytybmb` VALUES ('071201', '统计学', null);
INSERT INTO `zytybmb` VALUES ('07120101', '统计学(非师范)', null);
INSERT INTO `zytybmb` VALUES ('07120102', '统计学(生物统计)', null);
INSERT INTO `zytybmb` VALUES ('07120103', '统计学(生物统计学)', null);
INSERT INTO `zytybmb` VALUES ('07120104', '统计学(生物统计学)', null);
INSERT INTO `zytybmb` VALUES ('07120105', '统计学(师范)', null);
INSERT INTO `zytybmb` VALUES ('07120106', '统计学(统计实务方向)', null);
INSERT INTO `zytybmb` VALUES ('07120107', '统计学(应用数理统计)', null);
INSERT INTO `zytybmb` VALUES ('07120108', '统计学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('07120109', '统计学专业', null);
INSERT INTO `zytybmb` VALUES ('07120110', '统计学专业(非师范，招收理工类考生)', null);
INSERT INTO `zytybmb` VALUES ('07120111', '统计学专业(金融统计与风险管理)', null);
INSERT INTO `zytybmb` VALUES ('071202', '应用统计学', null);
INSERT INTO `zytybmb` VALUES ('07120201', '应用统计学(生物统计)本科', null);
INSERT INTO `zytybmb` VALUES ('07120202', '应用统计学专业', null);
INSERT INTO `zytybmb` VALUES ('07120203', '应用统汁学', null);
INSERT INTO `zytybmb` VALUES ('07120204', '应用统计学专业', null);
INSERT INTO `zytybmb` VALUES ('080000', '工学', null);
INSERT INTO `zytybmb` VALUES ('080100', '力学类', null);
INSERT INTO `zytybmb` VALUES ('08010001', '力学', null);
INSERT INTO `zytybmb` VALUES ('08010002', '力学基地班', null);
INSERT INTO `zytybmb` VALUES ('08010003', '工程力学(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('08010004', '工程力学创新班(本硕、本博连读)', null);
INSERT INTO `zytybmb` VALUES ('08010005', '工程力学定向生', null);
INSERT INTO `zytybmb` VALUES ('08010006', '工程力学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08010007', '工程力学与航天航空工程', null);
INSERT INTO `zytybmb` VALUES ('08010008', '力学类(茅以升学院)', null);
INSERT INTO `zytybmb` VALUES ('08010009', '工程力学(工程计算与软件)', null);
INSERT INTO `zytybmb` VALUES ('080101', '理论与应用力学', null);
INSERT INTO `zytybmb` VALUES ('080102', '工程力学', null);
INSERT INTO `zytybmb` VALUES ('080200', '机械类', null);
INSERT INTO `zytybmb` VALUES ('08020001', '机械类(机械设计制造及其自动化)', null);
INSERT INTO `zytybmb` VALUES ('08020002', '机械类(机械设计制造及其自动化、机械电子工程、过程装备及控制工程、材料成型与控制工程、工业工程)', null);
INSERT INTO `zytybmb` VALUES ('08020003', '机械类创新班(本硕、本博连读)', null);
INSERT INTO `zytybmb` VALUES ('08020004', '机械类(机械设计制造及其自动化、机械电子工程)', null);
INSERT INTO `zytybmb` VALUES ('08020005', '机械类(过程装备与控制工程)', null);
INSERT INTO `zytybmb` VALUES ('08020006', '机械类(中外)', null);
INSERT INTO `zytybmb` VALUES ('08020007', '机械类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08020008', '机械类(茅以升学院)', null);
INSERT INTO `zytybmb` VALUES ('08020009', '机械类(工学Ⅰ)', null);
INSERT INTO `zytybmb` VALUES ('08020010', '机械类(机械设计制造及其自动化、机械电子工程、过程装备与控制工程、材料成型及控制工程、工业工程)', null);
INSERT INTO `zytybmb` VALUES ('08020011', '机械类(含机械设计制造及其自动化、车辆工程、机械电子工程)', null);
INSERT INTO `zytybmb` VALUES ('08020012', '机械类(机械电子工程)', null);
INSERT INTO `zytybmb` VALUES ('08020013', '机械类(中外合作办学)(专业名称：机械设计制造及其自动化、合作学校', null);
INSERT INTO `zytybmb` VALUES ('08020014', '机械类(含车辆工程、机械设计制造及其自动化、机械电子工程)', null);
INSERT INTO `zytybmb` VALUES ('08020015', '机械类(定克)', null);
INSERT INTO `zytybmb` VALUES ('08020016', '机械类(机械设计制造及其自动化、车辆工程、机械电子工程)', null);
INSERT INTO `zytybmb` VALUES ('080201', '机械工程', null);
INSERT INTO `zytybmb` VALUES ('08020101', '机械工程(机械制造)', null);
INSERT INTO `zytybmb` VALUES ('08020102', '机械工程(机械制造)卓越工程师班', null);
INSERT INTO `zytybmb` VALUES ('08020103', '机械工程(机械制造)(卓越工程师班)', null);
INSERT INTO `zytybmb` VALUES ('08020105', '机械工程(飞行器制造工程)', null);
INSERT INTO `zytybmb` VALUES ('08020106', '机械工程(机械设计)', null);
INSERT INTO `zytybmb` VALUES ('08020107', '机械工程(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('08020108', '机械工程(高分子加工机械方向)', null);
INSERT INTO `zytybmb` VALUES ('08020109', '机械工程(机械制造与自动化方向)', null);
INSERT INTO `zytybmb` VALUES ('08020110', '机械工程(英才计划)', null);
INSERT INTO `zytybmb` VALUES ('08020111', '机械工程(输电线路工程)', null);
INSERT INTO `zytybmb` VALUES ('08020112', '机械工程(数控技术、模具与计算机辅助设计、装备及其自动化、机电创新班)', null);
INSERT INTO `zytybmb` VALUES ('08020113', '机械工程(数控技术，模具与计算机辅助设计，机械装备及其自动化)', null);
INSERT INTO `zytybmb` VALUES ('08020114', '机械工程(数控技术、模具与计算机辅助设计、机械装备及其自动化)', null);
INSERT INTO `zytybmb` VALUES ('08020115', '机械工程(数控技术方向，模具与计算机辅助设计方向，装备及其自动化)', null);
INSERT INTO `zytybmb` VALUES ('08020116', '机械工程其及自动化', null);
INSERT INTO `zytybmb` VALUES ('08020117', '机械工程及自动化(高速列车及数控技术)', null);
INSERT INTO `zytybmb` VALUES ('08020118', '机械成型及控制工程', null);
INSERT INTO `zytybmb` VALUES ('08020119', '机械维修及检测技术教育', null);
INSERT INTO `zytybmb` VALUES ('080202', '机械设计制造及其自动化', null);
INSERT INTO `zytybmb` VALUES ('08020201', '机械没计制造及其自动化', null);
INSERT INTO `zytybmb` VALUES ('08020202', '机械设计创造及其自动化', null);
INSERT INTO `zytybmb` VALUES ('08020203', '机械设计及其自动化', null);
INSERT INTO `zytybmb` VALUES ('08020206', '机械设计造及其自动化', null);
INSERT INTO `zytybmb` VALUES ('08020207', '机械设计制造及控制工程', null);
INSERT INTO `zytybmb` VALUES ('08020208', '机械设计制造及其内动化', null);
INSERT INTO `zytybmb` VALUES ('08020209', '机械设计制造及其自动化(城轨道交通车辆工程)', null);
INSERT INTO `zytybmb` VALUES ('08020210', '机械设计制造及其自动化(创新班)', null);
INSERT INTO `zytybmb` VALUES ('08020211', '机械设计制造及其自动化(工程机械)', null);
INSERT INTO `zytybmb` VALUES ('08020212', '机械设计制造及其自动化(国际班)', null);
INSERT INTO `zytybmb` VALUES ('08020213', '机械设计制造及其自动化(焊接技术方向)', null);
INSERT INTO `zytybmb` VALUES ('08020214', '机械设计制造及其自动化(机电传动与控制方向)', null);
INSERT INTO `zytybmb` VALUES ('08020215', '机械设计制造及其自动化(机电一体化)', null);
INSERT INTO `zytybmb` VALUES ('08020216', '机械设计制造及其自动化(机电一体化方向)', null);
INSERT INTO `zytybmb` VALUES ('08020217', '机械设计制造及其自动化(机械电子工程)', null);
INSERT INTO `zytybmb` VALUES ('08020218', '机械设计制造及其自动化(机械类)', null);
INSERT INTO `zytybmb` VALUES ('08020219', '机械设计制造及其自动化(机械设计、精密制造技术、机械制造装备)', null);
INSERT INTO `zytybmb` VALUES ('08020220', '机械设计制造及其自动化(机械制造工艺与设备)', null);
INSERT INTO `zytybmb` VALUES ('08020221', '机械设计制造及其自动化(金属材料方向)', null);
INSERT INTO `zytybmb` VALUES ('08020222', '机械设计制造及其自动化(金属材料方向方向)', null);
INSERT INTO `zytybmb` VALUES ('08020223', '机械设计制造及其自动化(流体传动与控制)', null);
INSERT INTO `zytybmb` VALUES ('08020224', '机械设计制造及其自动化(贫困A)', null);
INSERT INTO `zytybmb` VALUES ('08020225', '机械设计制造及其自动化(贫困B)', null);
INSERT INTO `zytybmb` VALUES ('08020226', '机械设计制造及其自动化(汽车工程)[中美合作]', null);
INSERT INTO `zytybmb` VALUES ('08020227', '机械设计制造及其自动化(设计自动化方向)', null);
INSERT INTO `zytybmb` VALUES ('08020228', '机械设计制造及其自动化(数控技术方向)', null);
INSERT INTO `zytybmb` VALUES ('08020229', '机械设计制造及其自动化(铁道车辆)', null);
INSERT INTO `zytybmb` VALUES ('08020230', '机械设计制造及其自动化(微电子制造装备及自动化)', null);
INSERT INTO `zytybmb` VALUES ('08020231', '机械设计制造及其自动化(现代设计制造工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08020232', '机械设计制造及其自动化(现代制造方向)', null);
INSERT INTO `zytybmb` VALUES ('08020233', '机械设计制造及其自动化(现代装备与控制工程)', null);
INSERT INTO `zytybmb` VALUES ('08020234', '机械设计制造及其自动化(一批)', null);
INSERT INTO `zytybmb` VALUES ('08020235', '机械设计制造及其自动化(职教师方向资)', null);
INSERT INTO `zytybmb` VALUES ('08020236', '机械设计制造及其自动化(职教师资方向)', null);
INSERT INTO `zytybmb` VALUES ('08020237', '机械设计制造及其自动化(制造制动化与测控技术方向)', null);
INSERT INTO `zytybmb` VALUES ('08020238', '机械设计制造及其自动化(制造自动化与测控技术方向)', null);
INSERT INTO `zytybmb` VALUES ('08020239', '机械设计制造及其自动化(中美合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08020240', '机械设计制造及其自动化(中外课程合作项目)', null);
INSERT INTO `zytybmb` VALUES ('08020241', '机械设计制造及其自动化(卓越班)', null);
INSERT INTO `zytybmb` VALUES ('08020242', '机械设计制造及其自动化(卓越工程师班)', null);
INSERT INTO `zytybmb` VALUES ('08020243', '机械设计制造及其自动化(卓越工程师培养计划)', null);
INSERT INTO `zytybmb` VALUES ('08020244', '机械设计制造及其自动化专业', null);
INSERT INTO `zytybmb` VALUES ('08020245', '机械设计制造及其自动化专业(教育部卓越工程师班)', null);
INSERT INTO `zytybmb` VALUES ('08020246', '机械设计制造及自动化', null);
INSERT INTO `zytybmb` VALUES ('08020247', '机械设计制造极其自动化', null);
INSERT INTO `zytybmb` VALUES ('08020248', '机械设计制作及其自动化', null);
INSERT INTO `zytybmb` VALUES ('08020249', '机械设汁制造及其自动化', null);
INSERT INTO `zytybmb` VALUES ('080203', '材料成型及控制工程', null);
INSERT INTO `zytybmb` VALUES ('08020301', '材料成型机控制工程', null);
INSERT INTO `zytybmb` VALUES ('08020302', '材料成型及控制工程(高分子材料成型及控制)', null);
INSERT INTO `zytybmb` VALUES ('08020303', '材料成型及控制工程(焊接方向)', null);
INSERT INTO `zytybmb` VALUES ('08020304', '材料成型及控制工程(金属材料成型及控制)', null);
INSERT INTO `zytybmb` VALUES ('08020305', '材料成型及控制工程(模具CAD/CAM)', null);
INSERT INTO `zytybmb` VALUES ('08020306', '材料成型及控制工程(模具方向)', null);
INSERT INTO `zytybmb` VALUES ('08020307', '材料成型及控制工程(模具设计)', null);
INSERT INTO `zytybmb` VALUES ('08020308', '材料成型及控制工程(模具设计制造、3D打印技术)', null);
INSERT INTO `zytybmb` VALUES ('08020309', '材料成型及控制工程(卓越工程师班)', null);
INSERT INTO `zytybmb` VALUES ('08020310', '材料成型及控制工程+软件工程', null);
INSERT INTO `zytybmb` VALUES ('08020311', '材料成型及其控制工程', null);
INSERT INTO `zytybmb` VALUES ('08020312', '材料成型与控制工程', null);
INSERT INTO `zytybmb` VALUES ('080204', '机械电子工程', null);
INSERT INTO `zytybmb` VALUES ('08020401', '机械电子工程(机电系统设计方向)', null);
INSERT INTO `zytybmb` VALUES ('08020402', '机械电子工程(机电一体化、机器人技术及其应用)', null);
INSERT INTO `zytybmb` VALUES ('08020403', '机械电子工程(机电一体化等方向)', null);
INSERT INTO `zytybmb` VALUES ('08020404', '机械电子工程(数控加工方向)', null);
INSERT INTO `zytybmb` VALUES ('08020405', '机械电子工程汽车技术方向', null);
INSERT INTO `zytybmb` VALUES ('080205', '工业设计', null);
INSERT INTO `zytybmb` VALUES ('08020501', '工业设计(产品设计与检测)', null);
INSERT INTO `zytybmb` VALUES ('08020502', '工业设计(家具设计)', null);
INSERT INTO `zytybmb` VALUES ('08020503', '工业设计(交通工具、时尚产品设计)', null);
INSERT INTO `zytybmb` VALUES ('08020504', '工业设计(理)', null);
INSERT INTO `zytybmb` VALUES ('08020505', '工业设计(理工类)', null);
INSERT INTO `zytybmb` VALUES ('08020506', '工业设计(理科)', null);
INSERT INTO `zytybmb` VALUES ('080206', '过程装备与控制工程', null);
INSERT INTO `zytybmb` VALUES ('08020601', '过程设备与控制工程', null);
INSERT INTO `zytybmb` VALUES ('08020602', '过程装备及控制工程', null);
INSERT INTO `zytybmb` VALUES ('08020603', '过程装备与控制工程(辽阳校区)', null);
INSERT INTO `zytybmb` VALUES ('08020604', '过程装备与控制工程(轻工机械及塑料模具)', null);
INSERT INTO `zytybmb` VALUES ('080207', '车辆工程', null);
INSERT INTO `zytybmb` VALUES ('08020701', '车辆工程(城市轨道交通车辆工程)', null);
INSERT INTO `zytybmb` VALUES ('08020702', '车辆工程(汽车工程、城市轨道交通管理科)', null);
INSERT INTO `zytybmb` VALUES ('08020703', '车辆工程(汽车设计与制造、汽车电子技术、新能源汽车)', null);
INSERT INTO `zytybmb` VALUES ('08020704', '车辆工程(汽车设计与制造方向，汽车电子技术方向，新能源汽车方向)', null);
INSERT INTO `zytybmb` VALUES ('08020705', '车辆工程(汽车设计与制造方向、汽车电子技术方向、新能源汽车方向)', null);
INSERT INTO `zytybmb` VALUES ('08020706', '车辆工程城市轨道交通车辆工程', null);
INSERT INTO `zytybmb` VALUES ('08020707', '车辆运用工程', null);
INSERT INTO `zytybmb` VALUES ('080208', '汽车服务工程', null);
INSERT INTO `zytybmb` VALUES ('08020801', '汽车服务工程(含检测工程方向和运用工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08020802', '汽车服务工程(汽车服务与金融营销、交通运输管理科)', null);
INSERT INTO `zytybmb` VALUES ('08020803', '汽车服务工程(汽车性能检测技术服务', null);
INSERT INTO `zytybmb` VALUES ('08020804', '汽车服务工程(汽车性能检测技术服务，汽车智能化技术服务，汽车后)', null);
INSERT INTO `zytybmb` VALUES ('08020805', '汽车服务工程(汽车性能检测技术服务，汽车智能化技术服务，汽车后市', null);
INSERT INTO `zytybmb` VALUES ('08020806', '汽车服务工程(汽车性能检测技术服务、汽车智能化技术服务、汽车后市', null);
INSERT INTO `zytybmb` VALUES ('08020807', '汽车服务工程(三校生)', null);
INSERT INTO `zytybmb` VALUES ('08020808', '汽车服务工程(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('08020809', '汽车服务与工程', null);
INSERT INTO `zytybmb` VALUES ('08020810', '汽车与服务工程', null);
INSERT INTO `zytybmb` VALUES ('080209T', '机械工艺技术', null);
INSERT INTO `zytybmb` VALUES ('080209T02', '机械制造工艺教育', null);
INSERT INTO `zytybmb` VALUES ('080210T', '微机电系统工程', null);
INSERT INTO `zytybmb` VALUES ('080211T', '机电技术教育', null);
INSERT INTO `zytybmb` VALUES ('080212T', '汽车维修工程教育', null);
INSERT INTO `zytybmb` VALUES ('080300', '仪器类', null);
INSERT INTO `zytybmb` VALUES ('08030001', '仪器类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08030002', '仪器仪表', null);
INSERT INTO `zytybmb` VALUES ('08030003', '仪器仪表类', null);
INSERT INTO `zytybmb` VALUES ('08030004', '仪器仪表类(中外)', null);
INSERT INTO `zytybmb` VALUES ('08030005', '仪器仪表类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('080301', '测控技术与仪器', null);
INSERT INTO `zytybmb` VALUES ('08030101', '测控工程', null);
INSERT INTO `zytybmb` VALUES ('08030102', '测控技术与仪器(电子仪器及测量技术)', null);
INSERT INTO `zytybmb` VALUES ('08030103', '测控技术与仪器(光机电一体化)', null);
INSERT INTO `zytybmb` VALUES ('08030104', '测控技术与仪器(计算机测控技术)', null);
INSERT INTO `zytybmb` VALUES ('08030105', '测控技术与仪器', null);
INSERT INTO `zytybmb` VALUES ('080400', '材料类', null);
INSERT INTO `zytybmb` VALUES ('080401', '材料科学与工程', null);
INSERT INTO `zytybmb` VALUES ('08040101', '材料科学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08040102', '材料工程', null);
INSERT INTO `zytybmb` VALUES ('08040103', '材料科学', null);
INSERT INTO `zytybmb` VALUES ('08040104', '材料科学与工程(无机非金属材料科学与工程)', null);
INSERT INTO `zytybmb` VALUES ('08040105', '材料科学与工程(材料化学)', null);
INSERT INTO `zytybmb` VALUES ('08040106', '材料科学类(中外)', null);
INSERT INTO `zytybmb` VALUES ('08040107', '材料科学与工程(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('08040108', '材料科学与工程(新能源材料与器件)', null);
INSERT INTO `zytybmb` VALUES ('08040109', '材料科学与工程(实验班)', null);
INSERT INTO `zytybmb` VALUES ('08040110', '材料科学与工程(贫困B)', null);
INSERT INTO `zytybmb` VALUES ('08040111', '电子信息科学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08040112', '材料科学工程', null);
INSERT INTO `zytybmb` VALUES ('08040113', '材料科学与工程(贫困A)', null);
INSERT INTO `zytybmb` VALUES ('08040122', '电子信息科学', null);
INSERT INTO `zytybmb` VALUES ('08040123', '电子信息科学类', null);
INSERT INTO `zytybmb` VALUES ('08040130', '电子信息技术及仪器', null);
INSERT INTO `zytybmb` VALUES ('08040131', '材料', null);
INSERT INTO `zytybmb` VALUES ('08040132', '材料科学与工程(金属材料科学与工程)', null);
INSERT INTO `zytybmb` VALUES ('08040133', '电子信息科学类(中外)', null);
INSERT INTO `zytybmb` VALUES ('08040134', '材料科学与工程(视光材料与应用)', null);
INSERT INTO `zytybmb` VALUES ('080402', '材料物理', null);
INSERT INTO `zytybmb` VALUES ('080403', '材料化学', null);
INSERT INTO `zytybmb` VALUES ('08040301', '材料化学(稀土材料)(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('08040302', '材料化学(稀土材料)', null);
INSERT INTO `zytybmb` VALUES ('08040303', '材料化学生物实验班', null);
INSERT INTO `zytybmb` VALUES ('08040304', '材料化学(功能材料)', null);
INSERT INTO `zytybmb` VALUES ('080404', '冶金工程', null);
INSERT INTO `zytybmb` VALUES ('080405', '金属材料工程', null);
INSERT INTO `zytybmb` VALUES ('08040501', '金属材料工程(金属材料制备与模具)', null);
INSERT INTO `zytybmb` VALUES ('08040502', '金属材料式程', null);
INSERT INTO `zytybmb` VALUES ('080406', '无机非金属材料工程', null);
INSERT INTO `zytybmb` VALUES ('08040601', '无机非金属材料工程专业', null);
INSERT INTO `zytybmb` VALUES ('080407', '高分子材料与工程', null);
INSERT INTO `zytybmb` VALUES ('08040701', '高分子材料工程', null);
INSERT INTO `zytybmb` VALUES ('08040702', '高分子材料加工工程', null);
INSERT INTO `zytybmb` VALUES ('08040703', '高分子材料与工程(电气绝缘材料)', null);
INSERT INTO `zytybmb` VALUES ('08040704', '高分子材料与工程(合成方向)', null);
INSERT INTO `zytybmb` VALUES ('08040705', '高分子材料与工程(辽阳校区)', null);
INSERT INTO `zytybmb` VALUES ('08040706', '高分子材料与工程(塑料工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08040707', '高分子材料与工程(橡胶工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08040708', '高分子材料与工程(英才计划)', null);
INSERT INTO `zytybmb` VALUES ('08040709', '高分子材料与科学', null);
INSERT INTO `zytybmb` VALUES ('080408', '复合材料与工程', null);
INSERT INTO `zytybmb` VALUES ('08040801', '复合材料与工程专业', null);
INSERT INTO `zytybmb` VALUES ('080409T', '粉体材料科学与工程', null);
INSERT INTO `zytybmb` VALUES ('080410T', '宝石及材料工艺学', null);
INSERT INTO `zytybmb` VALUES ('080410T1', '宝石及材料工艺学(珠宝鉴定与营销方向)', null);
INSERT INTO `zytybmb` VALUES ('080410T2', '宝石及材料工艺学(珠宝鉴定与营销)', null);
INSERT INTO `zytybmb` VALUES ('080411T', '焊接技术与工程', null);
INSERT INTO `zytybmb` VALUES ('080412T', '功能材料', null);
INSERT INTO `zytybmb` VALUES ('080413T', '纳米材料与技术', null);
INSERT INTO `zytybmb` VALUES ('080414T', '新能源材料与器件', null);
INSERT INTO `zytybmb` VALUES ('080414T1', '新能源材料与器件(英才计划)', null);
INSERT INTO `zytybmb` VALUES ('080500', '能源动力类', null);
INSERT INTO `zytybmb` VALUES ('08050001', '能源动力', null);
INSERT INTO `zytybmb` VALUES ('08050002', '能源动力类(工学Ⅱ)', null);
INSERT INTO `zytybmb` VALUES ('08050003', '能源动力类(中外)', null);
INSERT INTO `zytybmb` VALUES ('08050004', '能源动力类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08050005', '能源动力系统及自动化', null);
INSERT INTO `zytybmb` VALUES ('08050006', '能源工程及自动化', null);
INSERT INTO `zytybmb` VALUES ('08050007', '能源与动力工程(车用发动机)', null);
INSERT INTO `zytybmb` VALUES ('08050008', '能源与动力工程(火电厂集控运行)', null);
INSERT INTO `zytybmb` VALUES ('08050009', '能源与动力工程(热电工程)', null);
INSERT INTO `zytybmb` VALUES ('08050010', '能源与动力工程(绍骙实验班)', null);
INSERT INTO `zytybmb` VALUES ('08050011', '能源与动力工程(生产过程自动化)', null);
INSERT INTO `zytybmb` VALUES ('08050012', '能源与动力工程(制冷空调)', null);
INSERT INTO `zytybmb` VALUES ('08050013', '能源与动力工程(制冷与空调)', null);
INSERT INTO `zytybmb` VALUES ('08050014', '能源与动力工程(制冷与空调工程)', null);
INSERT INTO `zytybmb` VALUES ('080501', '能源与动力工程', null);
INSERT INTO `zytybmb` VALUES ('08050101', '风能与动力工程', null);
INSERT INTO `zytybmb` VALUES ('08050102', '热能与动力工程', null);
INSERT INTO `zytybmb` VALUES ('08050103', '热能与动力工程(汽车发动机)', null);
INSERT INTO `zytybmb` VALUES ('08050104', '热能与动力工程(制冷与空调方向)专业', null);
INSERT INTO `zytybmb` VALUES ('080502T', '能源与环境系统工程', null);
INSERT INTO `zytybmb` VALUES ('080503T', '新能源科学与工程', null);
INSERT INTO `zytybmb` VALUES ('080503T01', '新能源科学与工程(太阳能、风能、核能)', null);
INSERT INTO `zytybmb` VALUES ('080503T02', '新能源科学与工程专业', null);
INSERT INTO `zytybmb` VALUES ('080503T04', '新能源应用技术(风电', null);
INSERT INTO `zytybmb` VALUES ('080600', '电气类', null);
INSERT INTO `zytybmb` VALUES ('08060001', '电气类(茅以升学院)', null);
INSERT INTO `zytybmb` VALUES ('08060002', '电气类(自动化、电气工程及其自动化、测控技术与仪器)', null);
INSERT INTO `zytybmb` VALUES ('08060003', '电气类(工学Ⅳ)', null);
INSERT INTO `zytybmb` VALUES ('08060004', '电气类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08060005', '电气类(电气工程及其自动化、电子信息工程、通信工程、自动化)', null);
INSERT INTO `zytybmb` VALUES ('08060006', '电气信息类', null);
INSERT INTO `zytybmb` VALUES ('08060007', '电气信息类(中外)', null);
INSERT INTO `zytybmb` VALUES ('08060008', '电气信息类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('080601', '电气工程及其自动化', null);
INSERT INTO `zytybmb` VALUES ('08060101', '电气工程及其自动化(卓越班)', null);
INSERT INTO `zytybmb` VALUES ('08060102', '电气工程与自动化', null);
INSERT INTO `zytybmb` VALUES ('08060103', '电气工程及其自动化(电力系统自动化)', null);
INSERT INTO `zytybmb` VALUES ('08060104', '电气工程及其自动化(卓越工程师培养计划)', null);
INSERT INTO `zytybmb` VALUES ('08060105', '电气工程及其自动化(城轨及磁浮交通电气化)', null);
INSERT INTO `zytybmb` VALUES ('08060106', '电气工程及其自动化(电力系统及其自动化)', null);
INSERT INTO `zytybmb` VALUES ('08060107', '电气工程及其自动化(电力电子与传动控制)', null);
INSERT INTO `zytybmb` VALUES ('08060108', '电气工程及其自动化(建筑电气与智能化)', null);
INSERT INTO `zytybmb` VALUES ('08060109', '电气工程及其自动化(电力机车)', null);
INSERT INTO `zytybmb` VALUES ('08060110', '电气工程及其自动化(铁道电气化)', null);
INSERT INTO `zytybmb` VALUES ('08060111', '电气工程及其自动化(铁道通信信号)', null);
INSERT INTO `zytybmb` VALUES ('08060112', '电气工程及其自动化(城轨道交通供电)', null);
INSERT INTO `zytybmb` VALUES ('08060113', '电气工程及其自动化(电力系统与自动化)', null);
INSERT INTO `zytybmb` VALUES ('08060114', '电气工程及其自动化(现代建筑电气)', null);
INSERT INTO `zytybmb` VALUES ('08060115', '电气工程及其自动化(电气与电子技术)', null);
INSERT INTO `zytybmb` VALUES ('08060116', '电气工程及其自动化(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('08060117', '电气工程及其自动化(输配电工程)', null);
INSERT INTO `zytybmb` VALUES ('08060118', '电气工程及其自动化(电机电器及其控制)', null);
INSERT INTO `zytybmb` VALUES ('08060119', '电气工程及其自动化(贫困B)', null);
INSERT INTO `zytybmb` VALUES ('08060120', '电气工程及其自动化(国际班)', null);
INSERT INTO `zytybmb` VALUES ('08060121', '电气工程及其自动化(输电线路工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08060122', '电气工程及其自动化(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08060123', '电气工程及其自动化(一批)', null);
INSERT INTO `zytybmb` VALUES ('08060124', '电气工程及其自动化(本科)', null);
INSERT INTO `zytybmb` VALUES ('08060125', '电气工程及其自动化(智能微电网、注册电气工程师、电力工程与管理科)', null);
INSERT INTO `zytybmb` VALUES ('08060126', '电气工程及其自动化(电力系统等方向)', null);
INSERT INTO `zytybmb` VALUES ('08060127', '电气工程及其自动化(电气工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08060128', '电气工程及其自动化专业', null);
INSERT INTO `zytybmb` VALUES ('08060129', '电气工程及其自动化(含输电线路工程、电力配营技术及管理科)', null);
INSERT INTO `zytybmb` VALUES ('08060130', '电气工程及其自动化(供配电技术方向)', null);
INSERT INTO `zytybmb` VALUES ('08060131', '电气工程及其自动化(城市轨道交通信号与控制方向)', null);
INSERT INTO `zytybmb` VALUES ('08060132', '电气工程及其自动化(贫困A)', null);
INSERT INTO `zytybmb` VALUES ('08060133', '电气工程及其自动化(网络工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08060134', '电气工程及其自动化(职教师资方向)', null);
INSERT INTO `zytybmb` VALUES ('08060135', '电气工程及其自动化(新能源装置运行与控制方向)', null);
INSERT INTO `zytybmb` VALUES ('08060136', '电气工程及其自动化(新能源装置运行与控制', null);
INSERT INTO `zytybmb` VALUES ('08060137', '电气工程及其自动化(代号91)', null);
INSERT INTO `zytybmb` VALUES ('08060138', '电气工程及其自动化(代号96)', null);
INSERT INTO `zytybmb` VALUES ('08060139', '电气工程及自动化', null);
INSERT INTO `zytybmb` VALUES ('08060140', '电气信息工程', null);
INSERT INTO `zytybmb` VALUES ('08060141', '电气工程及其自动化(电力系统继电保护)', null);
INSERT INTO `zytybmb` VALUES ('08060143', '电气工程与管理', null);
INSERT INTO `zytybmb` VALUES ('08060144', '电气工程及其内动化', null);
INSERT INTO `zytybmb` VALUES ('08060145', '电气工程于自动化', null);
INSERT INTO `zytybmb` VALUES ('080602T', '智能电网信息工程', null);
INSERT INTO `zytybmb` VALUES ('080603T', '光源与照明', null);
INSERT INTO `zytybmb` VALUES ('080603T1', '光源与照明专业', null);
INSERT INTO `zytybmb` VALUES ('080604T', '电气工程与智能控制', null);
INSERT INTO `zytybmb` VALUES ('080700', '电子信息类', null);
INSERT INTO `zytybmb` VALUES ('080701', '电子信息工程', null);
INSERT INTO `zytybmb` VALUES ('08070101', '电子信息', null);
INSERT INTO `zytybmb` VALUES ('08070102', '电子信息工程(北京华清远见嵌入式系统)', null);
INSERT INTO `zytybmb` VALUES ('08070103', '电子信息工程(城轨道交通电子测控)', null);
INSERT INTO `zytybmb` VALUES ('08070104', '电子信息工程(达内科技嵌入式)', null);
INSERT INTO `zytybmb` VALUES ('08070105', '电子信息工程(电路设计及应用方向)', null);
INSERT INTO `zytybmb` VALUES ('08070106', '电子信息工程(电子工程、嵌入式系统)', null);
INSERT INTO `zytybmb` VALUES ('08070107', '电子信息工程(电子类)', null);
INSERT INTO `zytybmb` VALUES ('08070108', '电子信息工程(定向)', null);
INSERT INTO `zytybmb` VALUES ('08070109', '电子信息工程(国际班)', null);
INSERT INTO `zytybmb` VALUES ('08070110', '电子信息工程(贫困A)', null);
INSERT INTO `zytybmb` VALUES ('08070111', '电子信息工程(贫困B)', null);
INSERT INTO `zytybmb` VALUES ('08070112', '电子信息工程(嵌入式系统方向)', null);
INSERT INTO `zytybmb` VALUES ('08070113', '电子信息工程(师范)', null);
INSERT INTO `zytybmb` VALUES ('08070114', '电子信息工程(实验班)', null);
INSERT INTO `zytybmb` VALUES ('08070115', '电子信息工程(水声)', null);
INSERT INTO `zytybmb` VALUES ('08070116', '电子信息工程(说明：集成电路方向)', null);
INSERT INTO `zytybmb` VALUES ('08070117', '电子信息工程(铁道通信信号方向)', null);
INSERT INTO `zytybmb` VALUES ('08070118', '电子信息工程(通信等方向)', null);
INSERT INTO `zytybmb` VALUES ('08070119', '电子信息工程(现代通信方向)', null);
INSERT INTO `zytybmb` VALUES ('08070120', '电子信息工程(与佛山职业技术学院联合办学)', null);
INSERT INTO `zytybmb` VALUES ('08070121', '电子信息工程(中软国际3G通信)', null);
INSERT INTO `zytybmb` VALUES ('08070122', '电子信息工程(自动化方向)', null);
INSERT INTO `zytybmb` VALUES ('08070123', '电子信息工程(自动控制方向)', null);
INSERT INTO `zytybmb` VALUES ('08070124', '电子信息工程(自动识别技术)', null);
INSERT INTO `zytybmb` VALUES ('08070125', '电子信息工程[中美合作]', null);
INSERT INTO `zytybmb` VALUES ('08070126', '电子信息工程本科', null);
INSERT INTO `zytybmb` VALUES ('08070127', '电子信息工程电子系统工程、光电信息工程', null);
INSERT INTO `zytybmb` VALUES ('08070128', '电子信息工程技术(安卓手机方向)', null);
INSERT INTO `zytybmb` VALUES ('08070130', '电子信息工程专业', null);
INSERT INTO `zytybmb` VALUES ('08070131', '电子信息工程专业(教育部卓越工程师班)', null);
INSERT INTO `zytybmb` VALUES ('08070132', '电子信息科学与工程', null);
INSERT INTO `zytybmb` VALUES ('08070133', '电子与信息工程', null);
INSERT INTO `zytybmb` VALUES ('080702', '电子科学与技术', null);
INSERT INTO `zytybmb` VALUES ('08070201', '电子科学与技术(电子材料与元器件)', null);
INSERT INTO `zytybmb` VALUES ('08070202', '电子科学与技术(电子信息材料及元器件)', null);
INSERT INTO `zytybmb` VALUES ('08070203', '电子科学与技术(国防生非指挥类)', null);
INSERT INTO `zytybmb` VALUES ('08070204', '电子科学与技术(微电子方向)', null);
INSERT INTO `zytybmb` VALUES ('08070205', '电子科学与技术(微电子技术)', null);
INSERT INTO `zytybmb` VALUES ('08070206', '电子科学与技术(微电子技术方向)', null);
INSERT INTO `zytybmb` VALUES ('08070207', '电子科学与技术(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('08070208', '电子科学与技术(卓越工程师班)', null);
INSERT INTO `zytybmb` VALUES ('08070209', '电子科学与技术学院', null);
INSERT INTO `zytybmb` VALUES ('08070210', '电子科学与技术印制电路技术与工艺方向', null);
INSERT INTO `zytybmb` VALUES ('08070211', '电子科学与技术自动化方向', null);
INSERT INTO `zytybmb` VALUES ('08070212', '真空电子技术', null);
INSERT INTO `zytybmb` VALUES ('080703', '通信工程', null);
INSERT INTO `zytybmb` VALUES ('08070301', '通信工程(城轨道交通控制工程)', null);
INSERT INTO `zytybmb` VALUES ('08070302', '通信工程(电力通信)', null);
INSERT INTO `zytybmb` VALUES ('08070303', '通信工程(定向)', null);
INSERT INTO `zytybmb` VALUES ('08070304', '通信工程(国防生，男生，军检线，指挥)', null);
INSERT INTO `zytybmb` VALUES ('08070305', '通信工程(国防生指挥类)', null);
INSERT INTO `zytybmb` VALUES ('08070306', '通信工程(计算机通信)', null);
INSERT INTO `zytybmb` VALUES ('08070307', '通信工程(建筑智能化方向)', null);
INSERT INTO `zytybmb` VALUES ('08070308', '通信工程(军区通信指挥干部)(军事指挥类)', null);
INSERT INTO `zytybmb` VALUES ('08070309', '通信工程(贫困A)', null);
INSERT INTO `zytybmb` VALUES ('08070310', '通信工程(贫困B)', null);
INSERT INTO `zytybmb` VALUES ('08070311', '通信工程(嵌入式培养)', null);
INSERT INTO `zytybmb` VALUES ('08070312', '通信工程(铁道信号)', null);
INSERT INTO `zytybmb` VALUES ('08070313', '通信工程(移动通信技术、通信与广电建造师)', null);
INSERT INTO `zytybmb` VALUES ('08070314', '通信工程(移动通讯、下一代网络及信息技术、移动互联网技术)', null);
INSERT INTO `zytybmb` VALUES ('08070315', '通信工程(指挥类)', null);
INSERT INTO `zytybmb` VALUES ('08070316', '通信工程(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('08070318', '通信工程专业', null);
INSERT INTO `zytybmb` VALUES ('08070319', '通信工程专业(教育部卓越工程师班)', null);
INSERT INTO `zytybmb` VALUES ('08070321', '通讯工程', null);
INSERT INTO `zytybmb` VALUES ('08070322', '通讯工程(国防生指挥类)', null);
INSERT INTO `zytybmb` VALUES ('080704', '微电子科学与工程', null);
INSERT INTO `zytybmb` VALUES ('08070401', '微电子科学工程', null);
INSERT INTO `zytybmb` VALUES ('08070402', '微电子学', null);
INSERT INTO `zytybmb` VALUES ('08070403', '微电子制造工程', null);
INSERT INTO `zytybmb` VALUES ('080705', '光电信息科学与工程', null);
INSERT INTO `zytybmb` VALUES ('08070501', '光电信息工程', null);
INSERT INTO `zytybmb` VALUES ('08070502', '光电信息科学工程', null);
INSERT INTO `zytybmb` VALUES ('08070503', '光电信息科学与工程(光电器件)', null);
INSERT INTO `zytybmb` VALUES ('08070504', '光电信息科学与工程(光电信息)', null);
INSERT INTO `zytybmb` VALUES ('08070505', '光电信息科学与工程(光电子技术与通信方向)', null);
INSERT INTO `zytybmb` VALUES ('08070506', '光电信息科学与工程(国防生)', null);
INSERT INTO `zytybmb` VALUES ('08070507', '光电信息科学与工程(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('08070508', '光电信息科学与工程专业(光电子技术与通信方向)', null);
INSERT INTO `zytybmb` VALUES ('08070509', '光电信息科学与技术', null);
INSERT INTO `zytybmb` VALUES ('08070510', '光电子材料与器件', null);
INSERT INTO `zytybmb` VALUES ('08070512', '光电子技术科学', null);
INSERT INTO `zytybmb` VALUES ('08070514', '光信科技学与技术', null);
INSERT INTO `zytybmb` VALUES ('08070515', '光信息科技学与技术', null);
INSERT INTO `zytybmb` VALUES ('08070516', '光信息科技与技术', null);
INSERT INTO `zytybmb` VALUES ('08070517', '光信息科学与工程', null);
INSERT INTO `zytybmb` VALUES ('08070518', '光信息科学与技术', null);
INSERT INTO `zytybmb` VALUES ('08070519', '光信息与技术', null);
INSERT INTO `zytybmb` VALUES ('080706', '信息工程', null);
INSERT INTO `zytybmb` VALUES ('08070601', '信息工程(电子信息工程)', null);
INSERT INTO `zytybmb` VALUES ('08070602', '信息工程(应用电子技术)', null);
INSERT INTO `zytybmb` VALUES ('08070603', '信息工程(卓越班)', null);
INSERT INTO `zytybmb` VALUES ('08070604', '信息工程(卓越工程师班)', null);
INSERT INTO `zytybmb` VALUES ('08070605', '信息工程学院', null);
INSERT INTO `zytybmb` VALUES ('080707T', '广播电视工程', null);
INSERT INTO `zytybmb` VALUES ('080707T1', '广电信息科学与工程', null);
INSERT INTO `zytybmb` VALUES ('080708T', '水声工程', null);
INSERT INTO `zytybmb` VALUES ('080709T', '电子封装技术', null);
INSERT INTO `zytybmb` VALUES ('080710T', '集成电路设计与集成系统', null);
INSERT INTO `zytybmb` VALUES ('080710T1', '集成电路设计与集成系统(集成电路设计)', null);
INSERT INTO `zytybmb` VALUES ('080711T', '医学信息工程', null);
INSERT INTO `zytybmb` VALUES ('080711T01', '医学信息', null);
INSERT INTO `zytybmb` VALUES ('080711T02', '医学信息学', null);
INSERT INTO `zytybmb` VALUES ('080712T', '电磁场与无线技术', null);
INSERT INTO `zytybmb` VALUES ('080712T1', '电磁学与无线技术', null);
INSERT INTO `zytybmb` VALUES ('080713T', '电波传播与天线', null);
INSERT INTO `zytybmb` VALUES ('080714T', '电子信息科学与技术', null);
INSERT INTO `zytybmb` VALUES ('080714T01', '电子信息科学与技术(拔尖创新人才培养实验班)', null);
INSERT INTO `zytybmb` VALUES ('080714T02', '电子信息科学与技术(矿山机电方向)', null);
INSERT INTO `zytybmb` VALUES ('080714T03', '电子信息科学与技术(物联网技术方向)', null);
INSERT INTO `zytybmb` VALUES ('080714T04', '电子信息科学与技术(信息与安全)', null);
INSERT INTO `zytybmb` VALUES ('080714T05', '电子信息科学与技术(与香港中文大学联合培养)', null);
INSERT INTO `zytybmb` VALUES ('080714T06', '电子信息科学与技术(战略性新兴产业人才培养计划)', null);
INSERT INTO `zytybmb` VALUES ('080714T07', '电子信息科学与技术(智能电子方向)', null);
INSERT INTO `zytybmb` VALUES ('080714T08', '电子信息科学与技术(中英合作)', null);
INSERT INTO `zytybmb` VALUES ('080714T09', '电子信息科学与技术(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('080714T10', '电子信息科学与技术专业', null);
INSERT INTO `zytybmb` VALUES ('080714T11', '电子信息类(通信工程、电子信息工程、电子信息科学与技术)', null);
INSERT INTO `zytybmb` VALUES ('080714T12', '电子信息类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('080714T13', '电子信息实验班+CC97:C109+C103:C109', null);
INSERT INTO `zytybmb` VALUES ('080714T14', '电子信息类(电子信息工程、通信工程)', null);
INSERT INTO `zytybmb` VALUES ('080714T15', '电子信息类(电子信息科学与技术、电子信息工程、通信工程)', null);
INSERT INTO `zytybmb` VALUES ('080714T16', '电子信息类(定克)', null);
INSERT INTO `zytybmb` VALUES ('080714T17', '电子信息类(工学Ⅲ)', null);
INSERT INTO `zytybmb` VALUES ('080714T18', '电子信息类(国防生)', null);
INSERT INTO `zytybmb` VALUES ('080714T19', '电子信息类(含电子信息工程、通信工程)', null);
INSERT INTO `zytybmb` VALUES ('080714T20', '电子信息类(含电子信息科学与技术、通信工程专业)', null);
INSERT INTO `zytybmb` VALUES ('080714T21', '电子信息类(含通信工程、电子信息科学与技术、电子信息工程)', null);
INSERT INTO `zytybmb` VALUES ('080714T22', '电子信息类(茅以升学院)', null);
INSERT INTO `zytybmb` VALUES ('080714T23', '电子信息类(实验班)', null);
INSERT INTO `zytybmb` VALUES ('080715T', '电信工程及管理', null);
INSERT INTO `zytybmb` VALUES ('080716T', '应用电子技术教育', null);
INSERT INTO `zytybmb` VALUES ('080716T1', '应用电子技术教育专业', null);
INSERT INTO `zytybmb` VALUES ('080800', '自动化类', null);
INSERT INTO `zytybmb` VALUES ('080801', '自动化', null);
INSERT INTO `zytybmb` VALUES ('08080101', '自动化(创新班)', null);
INSERT INTO `zytybmb` VALUES ('08080102', '自动化(国防生)', null);
INSERT INTO `zytybmb` VALUES ('08080103', '自动化(机器人)', null);
INSERT INTO `zytybmb` VALUES ('08080104', '自动化(贫困A)', null);
INSERT INTO `zytybmb` VALUES ('08080105', '自动化(贫困B)', null);
INSERT INTO `zytybmb` VALUES ('08080106', '自动化(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('08080107', '自动化(汽车电子工程)[中美合作]', null);
INSERT INTO `zytybmb` VALUES ('08080108', '自动化(数控技术)', null);
INSERT INTO `zytybmb` VALUES ('08080109', '自动化(智能建筑与楼宇自动化)', null);
INSERT INTO `zytybmb` VALUES ('08080110', '自动化(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('08080111', '自动化(卓越工程师班)', null);
INSERT INTO `zytybmb` VALUES ('08080112', '自动化创新班(本硕连读)', null);
INSERT INTO `zytybmb` VALUES ('08080113', '自动化电气自动化方向', null);
INSERT INTO `zytybmb` VALUES ('08080114', '自动化类(含自动化、智能科学与技术专业)', null);
INSERT INTO `zytybmb` VALUES ('08080115', '自动化类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08080117', '自动化类(中外合作办学，自动化)', null);
INSERT INTO `zytybmb` VALUES ('08080118', '自动化专业', null);
INSERT INTO `zytybmb` VALUES ('080802T', '轨道交通信号与控制', null);
INSERT INTO `zytybmb` VALUES ('080900', '计算机类', null);
INSERT INTO `zytybmb` VALUES ('080901', '计算机科学与技术', null);
INSERT INTO `zytybmb` VALUES ('08090101', '计算机科学与技术(2+2中澳学分互认项目)', null);
INSERT INTO `zytybmb` VALUES ('08090102', '计算机科学与技术(ios应用技术)', null);
INSERT INTO `zytybmb` VALUES ('08090103', '计算机类(含计算机科学与技术、网络工程、信息安全专业)', null);
INSERT INTO `zytybmb` VALUES ('08090104', '计算机科学与技术(大连华信对日软件)', null);
INSERT INTO `zytybmb` VALUES ('08090105', '计算机科学与技术(定向)', null);
INSERT INTO `zytybmb` VALUES ('08090106', '计算机科学与技术(多媒体技术方向)专业', null);
INSERT INTO `zytybmb` VALUES ('08090107', '计算机科学与技术(二表B)', null);
INSERT INTO `zytybmb` VALUES ('08090108', '计算机科学与技术(非师范)', null);
INSERT INTO `zytybmb` VALUES ('08090109', '计算机科学与技术(服务外包方向)', null);
INSERT INTO `zytybmb` VALUES ('08090110', '计算机科学与技术(国防生)', null);
INSERT INTO `zytybmb` VALUES ('08090111', '计算机科学与技术(海康软件)', null);
INSERT INTO `zytybmb` VALUES ('08090112', '计算机科学与技术(含网络方向和软件开发方向)', null);
INSERT INTO `zytybmb` VALUES ('08090113', '计算机科学与技术(行知实验班)', null);
INSERT INTO `zytybmb` VALUES ('08090114', '计算机科学与技术(计算机应用)', null);
INSERT INTO `zytybmb` VALUES ('08090115', '计算机科学与技术(教师教育方向)', null);
INSERT INTO `zytybmb` VALUES ('08090116', '计算机科学与技术(金融信息技术方向)', null);
INSERT INTO `zytybmb` VALUES ('08090117', '计算机科学与技术(理科师范)', null);
INSERT INTO `zytybmb` VALUES ('08090118', '计算机科学与技术(免费师范)', null);
INSERT INTO `zytybmb` VALUES ('08090119', '计算机科学与技术(免费师范，定克)', null);
INSERT INTO `zytybmb` VALUES ('08090120', '计算机科学与技术(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('08090125', '嵌入式软件人才培养', null);
INSERT INTO `zytybmb` VALUES ('08090127', '计算机类(含计算机科学与技术、网络工程)', null);
INSERT INTO `zytybmb` VALUES ('08090128', '计算机科学与技术(北大青鸟)', null);
INSERT INTO `zytybmb` VALUES ('08090129', '计算机类(计算机科学与技术、软件工程、网络工程、数字媒体技术)', null);
INSERT INTO `zytybmb` VALUES ('08090130', '计算机类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08090131', '计算机类(中外合作办学)(软件工程)', null);
INSERT INTO `zytybmb` VALUES ('08090132', '计算机类(中外合作办学)(物联网工程)', null);
INSERT INTO `zytybmb` VALUES ('08090133', '计算机类(中外合作办学，软件工程)', null);
INSERT INTO `zytybmb` VALUES ('08090134', '游戏软件(游戏设计与制作方向)', null);
INSERT INTO `zytybmb` VALUES ('08090135', '计算机科学与技术(师范)', null);
INSERT INTO `zytybmb` VALUES ('08090136', '计算机类(含计算机科学与技术、软件工程、物联网工程)', null);
INSERT INTO `zytybmb` VALUES ('08090137', '计算机科学与技术(数据库工程师)', null);
INSERT INTO `zytybmb` VALUES ('08090138', '计算机科学与技术(数据库工程师、数字媒体技术)', null);
INSERT INTO `zytybmb` VALUES ('08090139', '计算机科学与技术(数据库应用系统开发方向)', null);
INSERT INTO `zytybmb` VALUES ('08090140', '计算机科学与技术(数字仿真与游戏设计方向)', null);
INSERT INTO `zytybmb` VALUES ('08090141', '计算机科学与技术(数字媒体技术方向)', null);
INSERT INTO `zytybmb` VALUES ('08090142', '计算机科学与技术(网络工程)', null);
INSERT INTO `zytybmb` VALUES ('08090143', '计算机科学与技术(网络与信息安全方向)', null);
INSERT INTO `zytybmb` VALUES ('08090144', '计算机科学与技术(微软IT教育)', null);
INSERT INTO `zytybmb` VALUES ('08090145', '计算机科学与技术(信息对抗与管理方向)', null);
INSERT INTO `zytybmb` VALUES ('08090147', '计算机科学与技术(移动互联网)', null);
INSERT INTO `zytybmb` VALUES ('08090148', '计算机科学与技术(应用技术本科)', null);
INSERT INTO `zytybmb` VALUES ('08090149', '计算机科学与技术(与惠普合作)', null);
INSERT INTO `zytybmb` VALUES ('08090150', '计算机科学与技术(中澳联合培养)', null);
INSERT INTO `zytybmb` VALUES ('08090151', '计算机科学与技术(中加)', null);
INSERT INTO `zytybmb` VALUES ('08090152', '计算机科学与技术(中软国际软件工程)', null);
INSERT INTO `zytybmb` VALUES ('08090153', '计算机科学与技术(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08090154', '计算机科学与技术(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('08090155', '计算机科学与技术(卓越工程师班)', null);
INSERT INTO `zytybmb` VALUES ('08090156', '计算机科学与技术嵌入式应用方向', null);
INSERT INTO `zytybmb` VALUES ('08090157', '计算机科学与技术全英创新班(本硕、本博连读)', null);
INSERT INTO `zytybmb` VALUES ('08090158', '计算机科学与技术商务智能方向', null);
INSERT INTO `zytybmb` VALUES ('08090159', '计算机科学与技术网络与信息安全方向', null);
INSERT INTO `zytybmb` VALUES ('08090160', '计算机科学与技术物联网方向', null);
INSERT INTO `zytybmb` VALUES ('08090161', '计算机科学与技术专业', null);
INSERT INTO `zytybmb` VALUES ('08090162', '计算机科学与技术专业(教育部卓越工程师班)', null);
INSERT INTO `zytybmb` VALUES ('08090163', '计算机科学与技术专业(软件工程、网络工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08090164', '计算科学与技术', null);
INSERT INTO `zytybmb` VALUES ('08090165', '计算机科学与技术(嵌入式培养)', null);
INSERT INTO `zytybmb` VALUES ('08090166', '嵌入式技术应用', null);
INSERT INTO `zytybmb` VALUES ('08090167', '计算机科学与技术(嵌入式软件外包方向)', null);
INSERT INTO `zytybmb` VALUES ('08090168', '嵌入式技术与应用', null);
INSERT INTO `zytybmb` VALUES ('08090169', '计算机科学与技术(嵌入式系统)', null);
INSERT INTO `zytybmb` VALUES ('08090170', '嵌入式技术与应用(嵌入式计算机软件技术方向)', null);
INSERT INTO `zytybmb` VALUES ('08090171', '计算机科学与技术(软件测试)', null);
INSERT INTO `zytybmb` VALUES ('08090172', '计算机科学与技术(软件方向)', null);
INSERT INTO `zytybmb` VALUES ('08090173', '计算机科学与技术(软件服务外包方向)', null);
INSERT INTO `zytybmb` VALUES ('08090174', '计算机科学与技术(软件工程)', null);
INSERT INTO `zytybmb` VALUES ('08090175', '计算机科学与技术(软件工程、IT与金融管理科、网络工程)', null);
INSERT INTO `zytybmb` VALUES ('08090176', '计算机科学与技术(软件工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08090177', '计算机科学与技术(软件技术)', null);
INSERT INTO `zytybmb` VALUES ('08090178', '计算机科学与技术(软件开发)', null);
INSERT INTO `zytybmb` VALUES ('08090179', '计算机科学与技术(软件设计)', null);
INSERT INTO `zytybmb` VALUES ('08090180', '计算机科学与技术(商业智能)', null);
INSERT INTO `zytybmb` VALUES ('08090181', '计算机科学与技术(沈阳东鹏嵌入式)', null);
INSERT INTO `zytybmb` VALUES ('08090182', '计算机科学与技术(实验班)', null);
INSERT INTO `zytybmb` VALUES ('08090183', '计算机科学与技术(信息技术方向)', null);
INSERT INTO `zytybmb` VALUES ('080902', '软件工程', null);
INSERT INTO `zytybmb` VALUES ('08090201', '软件工程(实验班)', null);
INSERT INTO `zytybmb` VALUES ('08090202', '软件工程(嵌入式系统实验班)', null);
INSERT INTO `zytybmb` VALUES ('08090203', '软件工程(移动信息工程)', null);
INSERT INTO `zytybmb` VALUES ('08090204', '软件工程( 软件工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08090205', '软件工程(卓越班)', null);
INSERT INTO `zytybmb` VALUES ('08090206', '软件工程(国防生)', null);
INSERT INTO `zytybmb` VALUES ('08090207', '软件工程(嵌入式培养)', null);
INSERT INTO `zytybmb` VALUES ('08090208', '软件工程(软件技术)', null);
INSERT INTO `zytybmb` VALUES ('08090209', '软件工程(企业信息化)', null);
INSERT INTO `zytybmb` VALUES ('08090210', '软件工程(软件设计与开发方向)', null);
INSERT INTO `zytybmb` VALUES ('08090211', '软件工程(软件设计方向)', null);
INSERT INTO `zytybmb` VALUES ('08090212', '软件工程(与湖南大学联合培养)', null);
INSERT INTO `zytybmb` VALUES ('08090213', '软件工程(软件测试方向)', null);
INSERT INTO `zytybmb` VALUES ('08090214', '软件工程(卓越工程师班)', null);
INSERT INTO `zytybmb` VALUES ('08090215', '软件工程(云计算方向)', null);
INSERT INTO `zytybmb` VALUES ('08090216', '软件工程嵌入式系统开发方向', null);
INSERT INTO `zytybmb` VALUES ('08090217', '软件工程数字媒体方向', null);
INSERT INTO `zytybmb` VALUES ('08090218', '软件工程金融服务外包方向', null);
INSERT INTO `zytybmb` VALUES ('08090219', '软件工程系统运维外包方向', null);
INSERT INTO `zytybmb` VALUES ('08090220', '软件工程(软件测试)', null);
INSERT INTO `zytybmb` VALUES ('08090221', '软件工程(软件开发)', null);
INSERT INTO `zytybmb` VALUES ('08090222', '软件工程(软件外包)', null);
INSERT INTO `zytybmb` VALUES ('08090223', '软件工程(数字影视特效技术方向)', null);
INSERT INTO `zytybmb` VALUES ('08090224', '软件工程(大数据方向)', null);
INSERT INTO `zytybmb` VALUES ('08090225', '软件工程(云计算系统架构)', null);
INSERT INTO `zytybmb` VALUES ('08090226', '软件工程(移动云计算方向)', null);
INSERT INTO `zytybmb` VALUES ('08090227', '软件工程(云安全方向)', null);
INSERT INTO `zytybmb` VALUES ('08090228', '软件工程(云应用方向)', null);
INSERT INTO `zytybmb` VALUES ('08090229', '软件工程会计信息化方向', null);
INSERT INTO `zytybmb` VALUES ('08090230', '软件工程新媒体工程方向', null);
INSERT INTO `zytybmb` VALUES ('08090231', '软件工程移动云办公方向', null);
INSERT INTO `zytybmb` VALUES ('08090232', '软件工程(图形图像制作等方向)', null);
INSERT INTO `zytybmb` VALUES ('08090233', '软件工程金融服务工程方向', null);
INSERT INTO `zytybmb` VALUES ('08090234', '软件工程(移动云计算)', null);
INSERT INTO `zytybmb` VALUES ('08090235', '软件工程软件开发方向', null);
INSERT INTO `zytybmb` VALUES ('08090236', '软件工程网络系统集成方向', null);
INSERT INTO `zytybmb` VALUES ('08090237', '软件工程信息管理方向', null);
INSERT INTO `zytybmb` VALUES ('08090238', '软件工程软件服务外包方向', null);
INSERT INTO `zytybmb` VALUES ('08090239', '软件工程(说明：高智能移动技术方向)', null);
INSERT INTO `zytybmb` VALUES ('08090240', '软件工程(说明：与惠普合作培养软件测试)', null);
INSERT INTO `zytybmb` VALUES ('08090241', '软件工程(说明：与惠普合作培养软件开发)', null);
INSERT INTO `zytybmb` VALUES ('08090242', '软件工程(JV技术应用方向)', null);
INSERT INTO `zytybmb` VALUES ('08090243', '软件工程(游戏开发技术方向)', null);
INSERT INTO `zytybmb` VALUES ('08090244', '软件工程(嵌入式培养.NIIT)', null);
INSERT INTO `zytybmb` VALUES ('08090245', '软件工程(大数据技术方向)', null);
INSERT INTO `zytybmb` VALUES ('08090246', '软件工程专', null);
INSERT INTO `zytybmb` VALUES ('080903', '网络工程', null);
INSERT INTO `zytybmb` VALUES ('08090301', '网路工程', null);
INSERT INTO `zytybmb` VALUES ('08090302', '网络工程(说明：物联网技术方向)', null);
INSERT INTO `zytybmb` VALUES ('08090303', '网络工程(网络安全与攻防方向)', null);
INSERT INTO `zytybmb` VALUES ('08090304', '网络工程(网络工程与管理方向)', null);
INSERT INTO `zytybmb` VALUES ('08090305', '网络工程(网络管理方向)', null);
INSERT INTO `zytybmb` VALUES ('08090306', '网络工程(网络管理科、物联网技术及应用)', null);
INSERT INTO `zytybmb` VALUES ('08090307', '网络工程(物联网)', null);
INSERT INTO `zytybmb` VALUES ('08090308', '网络工程(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('08090309', '网络工程专业', null);
INSERT INTO `zytybmb` VALUES ('08090412', '嵌入式技术与应用(嵌入式计算机系统工程方向)', null);
INSERT INTO `zytybmb` VALUES ('080904K', '信息安全', null);
INSERT INTO `zytybmb` VALUES ('080904K01', '信息安全(保密方向)', null);
INSERT INTO `zytybmb` VALUES ('080904K02', '信息安全(保密技术)', null);
INSERT INTO `zytybmb` VALUES ('080904K03', '信息安全数据恢复与电子证据取证技术方向', null);
INSERT INTO `zytybmb` VALUES ('080905', '物联网工程', null);
INSERT INTO `zytybmb` VALUES ('08090501', '物联网工程(电子工程学院)', null);
INSERT INTO `zytybmb` VALUES ('08090502', '物联网工程(计算机科学技术学院)', null);
INSERT INTO `zytybmb` VALUES ('08090503', '物联网工程(理科)', null);
INSERT INTO `zytybmb` VALUES ('08090504', '物联网工程(智能交通等方向)', null);
INSERT INTO `zytybmb` VALUES ('08090506', '物联网应用技术(含智能家居)', null);
INSERT INTO `zytybmb` VALUES ('080906', '数字媒体技术', null);
INSERT INTO `zytybmb` VALUES ('08090602', '数字媒体技术(达内)', null);
INSERT INTO `zytybmb` VALUES ('08090603', '数字媒体技术(音乐学院就读)', null);
INSERT INTO `zytybmb` VALUES ('08090604', '数字媒体技术专业', null);
INSERT INTO `zytybmb` VALUES ('080907T', '智能科学与技术', null);
INSERT INTO `zytybmb` VALUES ('080908T', '空间信息与数字技术', null);
INSERT INTO `zytybmb` VALUES ('08090901', '电子对抗指挥与工程', null);
INSERT INTO `zytybmb` VALUES ('080909T', '电子与计算机工程', null);
INSERT INTO `zytybmb` VALUES ('081000', '土木类', null);
INSERT INTO `zytybmb` VALUES ('081001', '土木工程', null);
INSERT INTO `zytybmb` VALUES ('08100101', '土木工程(城地下空间工程)', null);
INSERT INTO `zytybmb` VALUES ('08100102', '土木工程(道路桥梁方向)', null);
INSERT INTO `zytybmb` VALUES ('08100103', '土木工程(道路桥梁与渡河工程)', null);
INSERT INTO `zytybmb` VALUES ('08100104', '土木工程(道路与桥梁)', null);
INSERT INTO `zytybmb` VALUES ('08100105', '土木工程(道路与桥梁工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08100106', '土木工程(二表B)', null);
INSERT INTO `zytybmb` VALUES ('08100107', '土木工程(房屋建筑方向)', null);
INSERT INTO `zytybmb` VALUES ('08100108', '土木工程(工程造价)', null);
INSERT INTO `zytybmb` VALUES ('08100109', '土木工程(工程造价方向)', null);
INSERT INTO `zytybmb` VALUES ('08100110', '土木工程(公路与桥梁)', null);
INSERT INTO `zytybmb` VALUES ('08100111', '土木工程(国防生)', null);
INSERT INTO `zytybmb` VALUES ('08100112', '土木工程(国际班)', null);
INSERT INTO `zytybmb` VALUES ('08100113', '土木工程(合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08100114', '土木工程(机场工程)', null);
INSERT INTO `zytybmb` VALUES ('08100115', '土木工程(建筑工程)', null);
INSERT INTO `zytybmb` VALUES ('08100116', '土木工程(建筑工程、工程管理科)', null);
INSERT INTO `zytybmb` VALUES ('08100117', '土木工程(建筑工程方向', null);
INSERT INTO `zytybmb` VALUES ('08100118', '土木工程(建筑工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08100119', '土木工程(建筑工程方向，工程管理科方向)', null);
INSERT INTO `zytybmb` VALUES ('08100120', '土木工程(建筑工程方向、工程管理科方向)', null);
INSERT INTO `zytybmb` VALUES ('08100121', '土木工程(交通土建)', null);
INSERT INTO `zytybmb` VALUES ('08100122', '土木工程(交通土建工程)', null);
INSERT INTO `zytybmb` VALUES ('08100123', '土木工程(交通土建工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08100124', '土木工程(矿井建设)', null);
INSERT INTO `zytybmb` VALUES ('08100125', '土木工程(理科)', null);
INSERT INTO `zytybmb` VALUES ('08100126', '土木工程(贫困A)', null);
INSERT INTO `zytybmb` VALUES ('08100127', '土木工程(贫困B)', null);
INSERT INTO `zytybmb` VALUES ('08100128', '土木工程(铁道工程)', null);
INSERT INTO `zytybmb` VALUES ('08100129', '土木工程(小城镇建设方向)', null);
INSERT INTO `zytybmb` VALUES ('08100130', '土木工程(岩土与地下工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08100131', '土木工程(英语强化)', null);
INSERT INTO `zytybmb` VALUES ('08100132', '土木工程(造价管理)', null);
INSERT INTO `zytybmb` VALUES ('08100133', '土木工程(职教师资方向)', null);
INSERT INTO `zytybmb` VALUES ('08100134', '土木工程(中澳)', null);
INSERT INTO `zytybmb` VALUES ('08100135', '土木工程(中俄)', null);
INSERT INTO `zytybmb` VALUES ('08100136', '土木工程(注册建造师)', null);
INSERT INTO `zytybmb` VALUES ('08100137', '土木工程(装饰工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08100138', '土木工程(卓越班)', null);
INSERT INTO `zytybmb` VALUES ('08100139', '土木工程房屋建筑工程', null);
INSERT INTO `zytybmb` VALUES ('08100141', '土木工程建筑工程', null);
INSERT INTO `zytybmb` VALUES ('08100142', '土木工程建筑工程方向', null);
INSERT INTO `zytybmb` VALUES ('08100143', '土木工程交通土建方向', null);
INSERT INTO `zytybmb` VALUES ('08100144', '土木工程学院', null);
INSERT INTO `zytybmb` VALUES ('08100145', '土木工程专业', null);
INSERT INTO `zytybmb` VALUES ('08100146', '土木工程专业(建筑工程、建筑工程管理方向)', null);
INSERT INTO `zytybmb` VALUES ('08100147', '土木类(茅以升学院)', null);
INSERT INTO `zytybmb` VALUES ('08100148', '土木类(土木工程、交通工程)', null);
INSERT INTO `zytybmb` VALUES ('08100149', '土木类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08100150', '土木工程', null);
INSERT INTO `zytybmb` VALUES ('081002', '建筑环境与能源应用工程', null);
INSERT INTO `zytybmb` VALUES ('08100201', '建筑环境与能源应用工程(中澳)', null);
INSERT INTO `zytybmb` VALUES ('08100202', '建筑环境与能源应用工程专业', null);
INSERT INTO `zytybmb` VALUES ('08100203', '建筑环境与设备工程', null);
INSERT INTO `zytybmb` VALUES ('08100204', '建筑环境与设备工程专业', null);
INSERT INTO `zytybmb` VALUES ('08100205', '建筑节能技术与工程', null);
INSERT INTO `zytybmb` VALUES ('081003', '给排水科学与工程', null);
INSERT INTO `zytybmb` VALUES ('08100301', '给排水工程', null);
INSERT INTO `zytybmb` VALUES ('08100302', '给排水科学与工程专业', null);
INSERT INTO `zytybmb` VALUES ('08100303', '给水排水工程', null);
INSERT INTO `zytybmb` VALUES ('08100304', '给水排水工程专业', null);
INSERT INTO `zytybmb` VALUES ('081004', '建筑电气与智能化', null);
INSERT INTO `zytybmb` VALUES ('08100401', '建筑电气及智能化', null);
INSERT INTO `zytybmb` VALUES ('081005T', '城市地下空间工程', null);
INSERT INTO `zytybmb` VALUES ('081005T1', '城地下空间工程', null);
INSERT INTO `zytybmb` VALUES ('081006T', '道路桥梁与渡河工程', null);
INSERT INTO `zytybmb` VALUES ('081006T01', '道路桥梁与渡河濒海工程', null);
INSERT INTO `zytybmb` VALUES ('081006T02', '道路桥梁与渡河工程(道桥方向)', null);
INSERT INTO `zytybmb` VALUES ('081006T03', '道路桥梁与渡河工程(轨道方向)', null);
INSERT INTO `zytybmb` VALUES ('081006T04', '道路桥梁与渡河工程专业', null);
INSERT INTO `zytybmb` VALUES ('081100', '水利类', null);
INSERT INTO `zytybmb` VALUES ('081101', '水利水电工程', null);
INSERT INTO `zytybmb` VALUES ('08110101', '水和水电工程', null);
INSERT INTO `zytybmb` VALUES ('08110102', '水利', null);
INSERT INTO `zytybmb` VALUES ('08110103', '水利水电程', null);
INSERT INTO `zytybmb` VALUES ('08110104', '水利水电工', null);
INSERT INTO `zytybmb` VALUES ('08110105', '水利水电工程专业(水务工程专业方向)', null);
INSERT INTO `zytybmb` VALUES ('08110107', '水利水工程', null);
INSERT INTO `zytybmb` VALUES ('081102', '水文与水资源工程', null);
INSERT INTO `zytybmb` VALUES ('08110201', '水文科与水资源工程', null);
INSERT INTO `zytybmb` VALUES ('081103', '港口航道与海岸工程', null);
INSERT INTO `zytybmb` VALUES ('081104T', '水务工程', null);
INSERT INTO `zytybmb` VALUES ('081200', '测绘类', null);
INSERT INTO `zytybmb` VALUES ('081201', '测绘工程', null);
INSERT INTO `zytybmb` VALUES ('08120101', '测绘', null);
INSERT INTO `zytybmb` VALUES ('08120102', '测绘工程(贫困A)', null);
INSERT INTO `zytybmb` VALUES ('08120103', '测绘工程(贫困B)', null);
INSERT INTO `zytybmb` VALUES ('08120104', '测绘工程(卓越班)', null);
INSERT INTO `zytybmb` VALUES ('08120105', '测绘工程测量工程方向', null);
INSERT INTO `zytybmb` VALUES ('08120106', '测绘工程摄影测量与遥感方向', null);
INSERT INTO `zytybmb` VALUES ('08120107', '测绘工程专业', null);
INSERT INTO `zytybmb` VALUES ('08120108', '测绘类(茅以升学院)', null);
INSERT INTO `zytybmb` VALUES ('081202', '遥感科学与技术', null);
INSERT INTO `zytybmb` VALUES ('081203T', '导航工程', null);
INSERT INTO `zytybmb` VALUES ('081203T1', '导航丁程', null);
INSERT INTO `zytybmb` VALUES ('081204T', '地理国情监测', null);
INSERT INTO `zytybmb` VALUES ('081204T1', '地理国情监测', null);
INSERT INTO `zytybmb` VALUES ('081300', '化工与制药类', null);
INSERT INTO `zytybmb` VALUES ('08130001', '化工与制类', null);
INSERT INTO `zytybmb` VALUES ('08130002', '化工与制药', null);
INSERT INTO `zytybmb` VALUES ('08130003', '化工与制药类(含化学工程与工艺、制药工程)(创新班)', null);
INSERT INTO `zytybmb` VALUES ('08130004', '化工与制药类(化学工程与工艺、轻化工程)', null);
INSERT INTO `zytybmb` VALUES ('08130005', '化工与制药类(化学工程与工艺方向)', null);
INSERT INTO `zytybmb` VALUES ('08130006', '化工与制药类(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('08130007', '化工与制药类(中外)', null);
INSERT INTO `zytybmb` VALUES ('08130008', '化工与制药类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('081301', '化学工程与工艺', null);
INSERT INTO `zytybmb` VALUES ('081302', '制药工程', null);
INSERT INTO `zytybmb` VALUES ('08130201', '制药工程(化学与生物制药工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08130202', '制药工程(民族制药方向)', null);
INSERT INTO `zytybmb` VALUES ('08130203', '制药工程(民族制约方向)', null);
INSERT INTO `zytybmb` VALUES ('08130204', '制药工程(农药方向)', null);
INSERT INTO `zytybmb` VALUES ('08130205', '制药工程(生物制药方向)', null);
INSERT INTO `zytybmb` VALUES ('08130206', '制药工程(食品与药品安全方向)', null);
INSERT INTO `zytybmb` VALUES ('08130207', '制药工程(兽药方向)', null);
INSERT INTO `zytybmb` VALUES ('08130208', '制药工程(职教师资方向)', null);
INSERT INTO `zytybmb` VALUES ('081303T', '资源循环科学与工程', null);
INSERT INTO `zytybmb` VALUES ('081304T', '能源化学工程', null);
INSERT INTO `zytybmb` VALUES ('081305T', '化学工程与工业生物工程', null);
INSERT INTO `zytybmb` VALUES ('081400', '地质类', null);
INSERT INTO `zytybmb` VALUES ('081401', '地质工程', null);
INSERT INTO `zytybmb` VALUES ('081402', '勘查技术与工程', null);
INSERT INTO `zytybmb` VALUES ('08140201', '勘查技术与工程(录井技术与工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08140202', '勘察技术与工程', null);
INSERT INTO `zytybmb` VALUES ('08140203', '勘察技术与仪器', null);
INSERT INTO `zytybmb` VALUES ('081403', '资源勘查工程', null);
INSERT INTO `zytybmb` VALUES ('08140301', '资源勘查工程(工程地质勘查与地质灾害防治方向)', null);
INSERT INTO `zytybmb` VALUES ('08140302', '资源勘查工程(工程地质勘察与地质灾害防治方向)', null);
INSERT INTO `zytybmb` VALUES ('08140303', '资源勘查工程(固体矿产勘查方向)', null);
INSERT INTO `zytybmb` VALUES ('08140304', '资源科学与工程', null);
INSERT INTO `zytybmb` VALUES ('08140305', '资源勘查工程(贫困B)', null);
INSERT INTO `zytybmb` VALUES ('08140306', '资源勘查工程(职教师资方向)', null);
INSERT INTO `zytybmb` VALUES ('08140307', '资源勘察工程', null);
INSERT INTO `zytybmb` VALUES ('08140309', '资源勘查工程(贫困A)', null);
INSERT INTO `zytybmb` VALUES ('081404T', '地下水科学与工程', null);
INSERT INTO `zytybmb` VALUES ('081500', '矿业类', null);
INSERT INTO `zytybmb` VALUES ('081501', '采矿工程', null);
INSERT INTO `zytybmb` VALUES ('08150101', '采矿工程(采矿工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08150102', '采矿工程(贫困A)', null);
INSERT INTO `zytybmb` VALUES ('08150103', '采矿工程(二表B)', null);
INSERT INTO `zytybmb` VALUES ('08150104', '采矿工程(贫困B)', null);
INSERT INTO `zytybmb` VALUES ('08150105', '采矿工程(中俄)', null);
INSERT INTO `zytybmb` VALUES ('08150106', '采矿工程(卓越班)', null);
INSERT INTO `zytybmb` VALUES ('081502', '石油工程', null);
INSERT INTO `zytybmb` VALUES ('081503', '矿物加工工程', null);
INSERT INTO `zytybmb` VALUES ('081504', '油气储运工程', null);
INSERT INTO `zytybmb` VALUES ('08150402', '油气输运工程', null);
INSERT INTO `zytybmb` VALUES ('081505T', '矿物资源工程', null);
INSERT INTO `zytybmb` VALUES ('081506T', '海洋油气工程', null);
INSERT INTO `zytybmb` VALUES ('081600', '纺织类', null);
INSERT INTO `zytybmb` VALUES ('08160001', '纺织类(纺织工程、非织造材料与工程)', null);
INSERT INTO `zytybmb` VALUES ('08160002', '纺织类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('081601', '纺织工程', null);
INSERT INTO `zytybmb` VALUES ('08160106', '纺织工程(国防生)', null);
INSERT INTO `zytybmb` VALUES ('081602', '服装设计与工程', null);
INSERT INTO `zytybmb` VALUES ('08160201', '服装设计与工程(服装CAD/CAM)', null);
INSERT INTO `zytybmb` VALUES ('08160202', '服装设计与工程(中美合作项目)', null);
INSERT INTO `zytybmb` VALUES ('08160301', '非纺织材料与工程', null);
INSERT INTO `zytybmb` VALUES ('081603T', '非织造材料与工程', null);
INSERT INTO `zytybmb` VALUES ('081604T', '服装设计与工艺教育', null);
INSERT INTO `zytybmb` VALUES ('081700', '轻工类', null);
INSERT INTO `zytybmb` VALUES ('08170001', '轻工纺织食品', null);
INSERT INTO `zytybmb` VALUES ('08170002', '轻工纺织食品类(中外)', null);
INSERT INTO `zytybmb` VALUES ('08170003', '轻工纺织食品类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08170004', '轻工类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08170005', '轻工生物技术', null);
INSERT INTO `zytybmb` VALUES ('08170006', '轻工业纺织食品', null);
INSERT INTO `zytybmb` VALUES ('081701', '轻化工程', null);
INSERT INTO `zytybmb` VALUES ('08170101', '轻化丁程', null);
INSERT INTO `zytybmb` VALUES ('08170102', '轻化工程(浆纸方向)', null);
INSERT INTO `zytybmb` VALUES ('08170103', '轻化工程(染整工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08170104', '轻化工程(制浆造纸工程)', null);
INSERT INTO `zytybmb` VALUES ('081702', '包装工程', null);
INSERT INTO `zytybmb` VALUES ('081703', '印刷工程', null);
INSERT INTO `zytybmb` VALUES ('08170301', '印刷工程(卓越工程师班)', null);
INSERT INTO `zytybmb` VALUES ('081800', '交通运输类', null);
INSERT INTO `zytybmb` VALUES ('08180001', '交通运输类(茅以升学院)', null);
INSERT INTO `zytybmb` VALUES ('08180002', '交通运输类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('081801', '交通运输', null);
INSERT INTO `zytybmb` VALUES ('08180101', '交通运输(车辆工程)', null);
INSERT INTO `zytybmb` VALUES ('08180102', '交通运输(城轨道交通运营管理)', null);
INSERT INTO `zytybmb` VALUES ('08180103', '交通运输(城市轨道交通运营管理)', null);
INSERT INTO `zytybmb` VALUES ('08180104', '交通运输(公路物流)', null);
INSERT INTO `zytybmb` VALUES ('08180105', '交通运输(国防生，男生，军检线，指挥)', null);
INSERT INTO `zytybmb` VALUES ('08180106', '交通运输(航空器械维修)', null);
INSERT INTO `zytybmb` VALUES ('08180107', '交通运输(汽车运用工程)', null);
INSERT INTO `zytybmb` VALUES ('08180108', '交通运输(汽车运用工程)[中美合作]', null);
INSERT INTO `zytybmb` VALUES ('08180109', '交通运输(汽车运用工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08180110', '交通运输(铁道运输)', null);
INSERT INTO `zytybmb` VALUES ('08180111', '交通运输(外贸运输)', null);
INSERT INTO `zytybmb` VALUES ('08180112', '交通运输(物资采购与管理)', null);
INSERT INTO `zytybmb` VALUES ('08180113', '交通运输(指挥类)', null);
INSERT INTO `zytybmb` VALUES ('08180114', '交通运输(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('08180115', '交通运输国际航运管理方向', null);
INSERT INTO `zytybmb` VALUES ('08180116', '交通运输空中交通管制、飞行签派、航行情', null);
INSERT INTO `zytybmb` VALUES ('08180117', '交通运输专业', null);
INSERT INTO `zytybmb` VALUES ('08180118', '交通运输专业(智能控制技术方向)', null);
INSERT INTO `zytybmb` VALUES ('081802', '交通工程', null);
INSERT INTO `zytybmb` VALUES ('08180201', '交通工程(城市轨道交通)', null);
INSERT INTO `zytybmb` VALUES ('08180202', '交通工程(实验班)', null);
INSERT INTO `zytybmb` VALUES ('08180203', '交通工程道路交通方向', null);
INSERT INTO `zytybmb` VALUES ('08180204', '交通工程轨道交通管理方向', null);
INSERT INTO `zytybmb` VALUES ('08180205', '交通工程轨道运营方向', null);
INSERT INTO `zytybmb` VALUES ('08180206', '交通信息与控制工程', null);
INSERT INTO `zytybmb` VALUES ('08180207', '交通工程运营与管理方向', null);
INSERT INTO `zytybmb` VALUES ('081803K', '航海技术', null);
INSERT INTO `zytybmb` VALUES ('081803K03', '航海技术专业', null);
INSERT INTO `zytybmb` VALUES ('081804K', '轮机工程', null);
INSERT INTO `zytybmb` VALUES ('081804K03', '轮机工程专业', null);
INSERT INTO `zytybmb` VALUES ('081805K', '飞行技术', null);
INSERT INTO `zytybmb` VALUES ('081806T', '交通设备与控制工程', null);
INSERT INTO `zytybmb` VALUES ('081806T01', '交通建设与装备', null);
INSERT INTO `zytybmb` VALUES ('081806T02', '交通设备信息工程', null);
INSERT INTO `zytybmb` VALUES ('081807T', '救助与打捞工程', null);
INSERT INTO `zytybmb` VALUES ('081808TK', '船舶电子电气工程', null);
INSERT INTO `zytybmb` VALUES ('081900', '海洋工程类', null);
INSERT INTO `zytybmb` VALUES ('081901', '船舶与海洋工程', null);
INSERT INTO `zytybmb` VALUES ('08190101', '船舶与海洋工程(游艇方向)', null);
INSERT INTO `zytybmb` VALUES ('08190201', '水资源与海洋工程', null);
INSERT INTO `zytybmb` VALUES ('08190202', '船舶与海洋工程专业', null);
INSERT INTO `zytybmb` VALUES ('081902T', '海洋工程与技术', null);
INSERT INTO `zytybmb` VALUES ('081902T01', '海洋工程', null);
INSERT INTO `zytybmb` VALUES ('081903T', '海洋资源开发技术', null);
INSERT INTO `zytybmb` VALUES ('082000', '航空航天类', null);
INSERT INTO `zytybmb` VALUES ('08200001', '航空航天', null);
INSERT INTO `zytybmb` VALUES ('08200002', '航空航天类(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('08200003', '航天运输与控制', null);
INSERT INTO `zytybmb` VALUES ('08200004', '航运管理', null);
INSERT INTO `zytybmb` VALUES ('082001', '航空航天工程', null);
INSERT INTO `zytybmb` VALUES ('082002', '飞行器设计与工程', null);
INSERT INTO `zytybmb` VALUES ('08200201', '飞行器设计与工程(国际班)', null);
INSERT INTO `zytybmb` VALUES ('082003', '飞行器制造工程', null);
INSERT INTO `zytybmb` VALUES ('082004', '飞行器动力工程', null);
INSERT INTO `zytybmb` VALUES ('082005', '飞行器环境与生命保障工程', null);
INSERT INTO `zytybmb` VALUES ('082006T', '飞行器质量与可靠性', null);
INSERT INTO `zytybmb` VALUES ('082006T01', '飞行器环境与生命保障', null);
INSERT INTO `zytybmb` VALUES ('082006T02', '飞行器质量与可靠性专业', null);
INSERT INTO `zytybmb` VALUES ('082007T', '飞行器适航技术', null);
INSERT INTO `zytybmb` VALUES ('082100', '兵器类', null);
INSERT INTO `zytybmb` VALUES ('08210001', '兵器工程', null);
INSERT INTO `zytybmb` VALUES ('082101', '武器系统与工程', null);
INSERT INTO `zytybmb` VALUES ('08210101', '地面武器机动工程', null);
INSERT INTO `zytybmb` VALUES ('08210102', '武器系统与工程(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('082102', '武器发射工程', null);
INSERT INTO `zytybmb` VALUES ('08210201', '武器', null);
INSERT INTO `zytybmb` VALUES ('08210202', '武器系统与发射工程', null);
INSERT INTO `zytybmb` VALUES ('082103', '探测制导与控制技术', null);
INSERT INTO `zytybmb` VALUES ('08210301', '导弹工程', null);
INSERT INTO `zytybmb` VALUES ('08210302', '探测制导与测控技术', null);
INSERT INTO `zytybmb` VALUES ('082104', '弹药工程与爆炸技术', null);
INSERT INTO `zytybmb` VALUES ('08210401', '弹药工程', null);
INSERT INTO `zytybmb` VALUES ('08210403', '地雷爆破与障碍工程', null);
INSERT INTO `zytybmb` VALUES ('082105', '特种能源技术与工程', null);
INSERT INTO `zytybmb` VALUES ('08210501', '特种能源工程与烟火技术', null);
INSERT INTO `zytybmb` VALUES ('082106', '装甲车辆工程', null);
INSERT INTO `zytybmb` VALUES ('082107', '信息对抗技术', null);
INSERT INTO `zytybmb` VALUES ('082200', '核工程类', null);
INSERT INTO `zytybmb` VALUES ('082201', '核工程与核技术', null);
INSERT INTO `zytybmb` VALUES ('08220101', '核工程与核技术(辐照化工方向)', null);
INSERT INTO `zytybmb` VALUES ('08220102', '核工程与核技术(核电站)', null);
INSERT INTO `zytybmb` VALUES ('08220103', '核技术', null);
INSERT INTO `zytybmb` VALUES ('08220104', '核工程类(中外合作办学)(核工程与核技术专业)', null);
INSERT INTO `zytybmb` VALUES ('08220105', '核安全工程', null);
INSERT INTO `zytybmb` VALUES ('08220106', '核动力工程', null);
INSERT INTO `zytybmb` VALUES ('08220107', '核工程类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('082202', '辐射防护与核安全', null);
INSERT INTO `zytybmb` VALUES ('08220201', '辐射防护与环境工程', null);
INSERT INTO `zytybmb` VALUES ('082203', '工程物理', null);
INSERT INTO `zytybmb` VALUES ('082204', '核化工与核燃料工程', null);
INSERT INTO `zytybmb` VALUES ('082300', '农业工程类', null);
INSERT INTO `zytybmb` VALUES ('082301', '农业工程', null);
INSERT INTO `zytybmb` VALUES ('082302', '农业机械化及其自动化', null);
INSERT INTO `zytybmb` VALUES ('08230201', '农业机械化及其自动化(拔尖人才培养班)', null);
INSERT INTO `zytybmb` VALUES ('08230202', '农业机械及其自动化', null);
INSERT INTO `zytybmb` VALUES ('08230203', '机械制造及自动化(计算机辅助设计方向)', null);
INSERT INTO `zytybmb` VALUES ('08230204', '机械制造与自动化(游艺设备维护与管理)', null);
INSERT INTO `zytybmb` VALUES ('082303', '农业电气化', null);
INSERT INTO `zytybmb` VALUES ('08230301', '农业电气化与自动化', null);
INSERT INTO `zytybmb` VALUES ('08230302', '农业电气与自动化', null);
INSERT INTO `zytybmb` VALUES ('082304', '农业建筑环境与能源工程', null);
INSERT INTO `zytybmb` VALUES ('08230401', '农业建筑环境与能源工程(农村能源方向)', null);
INSERT INTO `zytybmb` VALUES ('082305', '农业水利工程', null);
INSERT INTO `zytybmb` VALUES ('082400', '林业工程类', null);
INSERT INTO `zytybmb` VALUES ('08240001', '林业工程类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('082401', '森林工程', null);
INSERT INTO `zytybmb` VALUES ('08240101', '森林工程(路桥方向)', null);
INSERT INTO `zytybmb` VALUES ('082402', '木材科学与工程', null);
INSERT INTO `zytybmb` VALUES ('08240201', '木材抖学与工程', null);
INSERT INTO `zytybmb` VALUES ('08240202', '木材科学与工程(木结构建筑)', null);
INSERT INTO `zytybmb` VALUES ('08240203', '木材科学与工程工程', null);
INSERT INTO `zytybmb` VALUES ('08240204', '木材科学与工程', null);
INSERT INTO `zytybmb` VALUES ('082403', '林产化工', null);
INSERT INTO `zytybmb` VALUES ('082500', '环境科学与工程类', null);
INSERT INTO `zytybmb` VALUES ('08250001', '环境科学与工程类(含环境科学、环境工程专业)', null);
INSERT INTO `zytybmb` VALUES ('08250002', '环境科学与工程类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('082501', '环境科学与工程', null);
INSERT INTO `zytybmb` VALUES ('08250101', '环境与安全', null);
INSERT INTO `zytybmb` VALUES ('08250102', '环境与安全类(中外)', null);
INSERT INTO `zytybmb` VALUES ('08250103', '环境与安全类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('082502', '环境工程', null);
INSERT INTO `zytybmb` VALUES ('08250201', '环境工程(全英班)', null);
INSERT INTO `zytybmb` VALUES ('08250202', '环境工程(电力环保)', null);
INSERT INTO `zytybmb` VALUES ('08250203', '环境工程专业', null);
INSERT INTO `zytybmb` VALUES ('08250204', '环境工程(定向)', null);
INSERT INTO `zytybmb` VALUES ('08250205', '环境工程(贫困计划)', null);
INSERT INTO `zytybmb` VALUES ('08250206', '环境工程(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('08250207', '环境工程(农村环境治理)', null);
INSERT INTO `zytybmb` VALUES ('08250209', '环境工程', null);
INSERT INTO `zytybmb` VALUES ('08250210', '环境工程(环保与给排水方向)', null);
INSERT INTO `zytybmb` VALUES ('082503', '环境科学', null);
INSERT INTO `zytybmb` VALUES ('08250301', '环境科学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('08250302', '环境科学环境工程与管理方向', null);
INSERT INTO `zytybmb` VALUES ('08250303', '环境科学景观规划设计方向', null);
INSERT INTO `zytybmb` VALUES ('08250304', '环境科学类(中外)', null);
INSERT INTO `zytybmb` VALUES ('08250305', '环境科学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('082504', '环境生态工程', null);
INSERT INTO `zytybmb` VALUES ('08250401', '环境生态', null);
INSERT INTO `zytybmb` VALUES ('08250402', '环境生态类(中外)', null);
INSERT INTO `zytybmb` VALUES ('08250403', '环境生态类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('082505T', '环保设备工程', null);
INSERT INTO `zytybmb` VALUES ('082506T', '资源环境科学', null);
INSERT INTO `zytybmb` VALUES ('082507T', '水质科学与技术', null);
INSERT INTO `zytybmb` VALUES ('082600', '生物医学工程类', null);
INSERT INTO `zytybmb` VALUES ('08260001', '生物医学工程类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08260002', '生物医学工程专业', null);
INSERT INTO `zytybmb` VALUES ('082601', '生物医学工程', null);
INSERT INTO `zytybmb` VALUES ('08260101', '生命科学与技术基础班', null);
INSERT INTO `zytybmb` VALUES ('08260102', '生命科学与技术基地班', null);
INSERT INTO `zytybmb` VALUES ('08260103', '生命科学与技术基地班(生物工程)', null);
INSERT INTO `zytybmb` VALUES ('08260104', '生命科学与技术基地班(生物技术)', null);
INSERT INTO `zytybmb` VALUES ('08260105', '生命科学与技术基地班(生物技术制药)', null);
INSERT INTO `zytybmb` VALUES ('08260106', '生物安全', null);
INSERT INTO `zytybmb` VALUES ('08260107', '四年制生物医学工程', null);
INSERT INTO `zytybmb` VALUES ('082602T', '假肢矫形工程', null);
INSERT INTO `zytybmb` VALUES ('082602T01', '四年制假肢矫形工程', null);
INSERT INTO `zytybmb` VALUES ('082602T02', '四年制本科假肢矫形工程专业', null);
INSERT INTO `zytybmb` VALUES ('082700', '食品科学与工程类', null);
INSERT INTO `zytybmb` VALUES ('08270001', '法警', null);
INSERT INTO `zytybmb` VALUES ('082700018', '食品科学与工程类(含食品科学与工程、食品质量与安全)', null);
INSERT INTO `zytybmb` VALUES ('08270002', '食品科学工程类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08270003', '食品科学与工程专业', null);
INSERT INTO `zytybmb` VALUES ('08270004', '食品科学与工程(五年制)', null);
INSERT INTO `zytybmb` VALUES ('08270005', '食品科学与工程(拔尖人才培养班)', null);
INSERT INTO `zytybmb` VALUES ('08270006', '食品科学与安全', null);
INSERT INTO `zytybmb` VALUES ('08270007', '食品科学与工程(食品资源开发)', null);
INSERT INTO `zytybmb` VALUES ('08270008', '食品科学与工程类(食品质量与安全、粮食工程)', null);
INSERT INTO `zytybmb` VALUES ('08270009', '食品科学与工程类(中外合作办学)(食品科学与工程)', null);
INSERT INTO `zytybmb` VALUES ('08270010', '食品科学与工程(农产品加工)', null);
INSERT INTO `zytybmb` VALUES ('08270011', '食品科学与工程(烟草工程)', null);
INSERT INTO `zytybmb` VALUES ('08270012', '食品科学与工程类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08270013', '食品科学与工程类(中外合作办学)(啤酒酿造及饮料工艺)', null);
INSERT INTO `zytybmb` VALUES ('08270014', '食品科学与工程(师范类)', null);
INSERT INTO `zytybmb` VALUES ('08270015', '食品科学与工程(畜产品加工与贮藏方向)', null);
INSERT INTO `zytybmb` VALUES ('08270016', '食品科学与工程(食品质量与安全)', null);
INSERT INTO `zytybmb` VALUES ('08270017', '食品科学与工程食品安全与检验方向', null);
INSERT INTO `zytybmb` VALUES ('082701', '食品科学与工程', null);
INSERT INTO `zytybmb` VALUES ('082702', '食品质量与安全', null);
INSERT INTO `zytybmb` VALUES ('08270201', '食品质量与安全(儿童营养与健康)', null);
INSERT INTO `zytybmb` VALUES ('08270202', '食品质量与安全(食品检验方向)', null);
INSERT INTO `zytybmb` VALUES ('08270203', '食品质量与安全(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('08270205', '食品质量与安全专业', null);
INSERT INTO `zytybmb` VALUES ('08270206', '食品质嫱与安全', null);
INSERT INTO `zytybmb` VALUES ('08270207', '食品质最与安全', null);
INSERT INTO `zytybmb` VALUES ('082703', '粮食工程', null);
INSERT INTO `zytybmb` VALUES ('082704', '乳品工程', null);
INSERT INTO `zytybmb` VALUES ('082705', '酿酒工程', null);
INSERT INTO `zytybmb` VALUES ('082706T', '葡萄与葡萄酒工程', null);
INSERT INTO `zytybmb` VALUES ('082706T1', '葡萄与葡萄洒工程', null);
INSERT INTO `zytybmb` VALUES ('082707T', '食品营养与检验教育', null);
INSERT INTO `zytybmb` VALUES ('082708T', '烹饪与营养教育', null);
INSERT INTO `zytybmb` VALUES ('082800', '建筑类', null);
INSERT INTO `zytybmb` VALUES ('08280001', '建筑类(建筑学)', null);
INSERT INTO `zytybmb` VALUES ('08280002', '建筑类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('082801', '建筑学', null);
INSERT INTO `zytybmb` VALUES ('08280101', '建筑学(古建筑修缮与保护方向)', null);
INSERT INTO `zytybmb` VALUES ('08280102', '建筑学(五年制)', null);
INSERT INTO `zytybmb` VALUES ('08280103', '建筑学(五年制本科)', null);
INSERT INTO `zytybmb` VALUES ('08280104', '建筑学(学制5年)', null);
INSERT INTO `zytybmb` VALUES ('08280105', '建筑学(学制五年)', null);
INSERT INTO `zytybmb` VALUES ('08280106', '建筑学(与湖南大学联合培养)', null);
INSERT INTO `zytybmb` VALUES ('08280107', '建筑学(中国—新西兰联合教学班)', null);
INSERT INTO `zytybmb` VALUES ('08280108', '建筑学(注册建筑师)', null);
INSERT INTO `zytybmb` VALUES ('08280109', '建筑学(注册建筑师)(5年)', null);
INSERT INTO `zytybmb` VALUES ('08280110', '建筑学专业', null);
INSERT INTO `zytybmb` VALUES ('082802', '城乡规划', null);
INSERT INTO `zytybmb` VALUES ('08280201', '城乡规划(农村社区规划与建设)', null);
INSERT INTO `zytybmb` VALUES ('08280202', '城乡规划(五年制)', null);
INSERT INTO `zytybmb` VALUES ('08280203', '城乡规划(学制5年)', null);
INSERT INTO `zytybmb` VALUES ('08280204', '城乡规划专业', null);
INSERT INTO `zytybmb` VALUES ('082803', '风景园林', null);
INSERT INTO `zytybmb` VALUES ('08280301', '风景园林(园林工程技术方向)', null);
INSERT INTO `zytybmb` VALUES ('08280302', '风景园林景观建筑设计方向', null);
INSERT INTO `zytybmb` VALUES ('082804T', '历史建筑保护工程', null);
INSERT INTO `zytybmb` VALUES ('082900', '安全科学与工程类', null);
INSERT INTO `zytybmb` VALUES ('082901', '安全工程', null);
INSERT INTO `zytybmb` VALUES ('08290101', '安全工程(交通运输安全与信息技术)', null);
INSERT INTO `zytybmb` VALUES ('08290102', '安全工程(安全管理科信息系统)', null);
INSERT INTO `zytybmb` VALUES ('08290103', '安全工程(安全防范方向)', null);
INSERT INTO `zytybmb` VALUES ('08290104', '安全工程(安全管理信息系统)', null);
INSERT INTO `zytybmb` VALUES ('08290105', '安全工程专业', null);
INSERT INTO `zytybmb` VALUES ('08290106', '安全工程(卓越班)', null);
INSERT INTO `zytybmb` VALUES ('08290107', '安全工程(贫困A)', null);
INSERT INTO `zytybmb` VALUES ('08290108', '安全工程(贫困B)', null);
INSERT INTO `zytybmb` VALUES ('08290109', '安全工程(采矿工程方向)', null);
INSERT INTO `zytybmb` VALUES ('08290110', '安全工程(非煤矿山方向)', null);
INSERT INTO `zytybmb` VALUES ('083000', '生物工程类', null);
INSERT INTO `zytybmb` VALUES ('083001', '生物工程', null);
INSERT INTO `zytybmb` VALUES ('08300101', '生物个程', null);
INSERT INTO `zytybmb` VALUES ('08300102', '生物工程(环境生物技术)', null);
INSERT INTO `zytybmb` VALUES ('08300103', '生物工程(绍骙实验班)', null);
INSERT INTO `zytybmb` VALUES ('08300104', '生物工程(生物化工、微生物工程)', null);
INSERT INTO `zytybmb` VALUES ('08300105', '生物工程(生物技术与制药)', null);
INSERT INTO `zytybmb` VALUES ('08300106', '生物工程(生物制剂)', null);
INSERT INTO `zytybmb` VALUES ('08300107', '生物工程(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08300108', '生物工程(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('08300109', '生物工程类(生物工程、生物技术)', null);
INSERT INTO `zytybmb` VALUES ('08300110', '生物工程类(中外)', null);
INSERT INTO `zytybmb` VALUES ('08300111', '生物工程类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('08300112', '生物工程类(中外合作办学)(专业名称：生物工程、合作学校：韩国建国', null);
INSERT INTO `zytybmb` VALUES ('08300113', '生物功能材料', null);
INSERT INTO `zytybmb` VALUES ('08300114', '生物资源科学', null);
INSERT INTO `zytybmb` VALUES ('083002T', '生物制药', null);
INSERT INTO `zytybmb` VALUES ('083002T01', '生物制药(分子生物学——药物研制)(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('083002T02', '生物制药(战略性新兴产业人才培养计划)', null);
INSERT INTO `zytybmb` VALUES ('083002T03', '生物制约', null);
INSERT INTO `zytybmb` VALUES ('083100', '公安技术类', null);
INSERT INTO `zytybmb` VALUES ('083101K', '刑事科学技术', null);
INSERT INTO `zytybmb` VALUES ('083102K', '消防工程', null);
INSERT INTO `zytybmb` VALUES ('083103TK', '交通管理工程', null);
INSERT INTO `zytybmb` VALUES ('083104TK', '安全防范工程', null);
INSERT INTO `zytybmb` VALUES ('083105TK', '公安视听技术', null);
INSERT INTO `zytybmb` VALUES ('08310601', '预警探测指挥', null);
INSERT INTO `zytybmb` VALUES ('083106TK', '抢险救援指挥与技术', null);
INSERT INTO `zytybmb` VALUES ('083107TK', '火灾勘查', null);
INSERT INTO `zytybmb` VALUES ('083108TK', '网络安全与执法', null);
INSERT INTO `zytybmb` VALUES ('083109TK', '核生化消防', null);
INSERT INTO `zytybmb` VALUES ('090000', '农学', null);
INSERT INTO `zytybmb` VALUES ('09000001', '农学(拔尖人才培养班)', null);
INSERT INTO `zytybmb` VALUES ('09000002', '农学(含农学、植物科学与技术、种子科学与工程)', null);
INSERT INTO `zytybmb` VALUES ('09000003', '农学(农产品安全与贸易方向)', null);
INSERT INTO `zytybmb` VALUES ('09000004', '农学(农产品标准化与质量检测)', null);
INSERT INTO `zytybmb` VALUES ('09000005', '农学(生物育种方向)', null);
INSERT INTO `zytybmb` VALUES ('09000006', '农学(作物生物技术)', null);
INSERT INTO `zytybmb` VALUES ('090100', '植物生产类', null);
INSERT INTO `zytybmb` VALUES ('09010001', '植物生产', null);
INSERT INTO `zytybmb` VALUES ('09010002', '植物生产类(中外)', null);
INSERT INTO `zytybmb` VALUES ('09010003', '植物生产类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('090101', '农学', null);
INSERT INTO `zytybmb` VALUES ('09010111', '工程机械', null);
INSERT INTO `zytybmb` VALUES ('09010112', '工程结构分析', null);
INSERT INTO `zytybmb` VALUES ('090102', '园艺', null);
INSERT INTO `zytybmb` VALUES ('09010201', '景观学', null);
INSERT INTO `zytybmb` VALUES ('090103', '植物保护', null);
INSERT INTO `zytybmb` VALUES ('09010301', '植物保护(检验检疫方向)', null);
INSERT INTO `zytybmb` VALUES ('09010302', '植物保护(农药方向)', null);
INSERT INTO `zytybmb` VALUES ('09010303', '植物保护(农药与农产品安全方向)', null);
INSERT INTO `zytybmb` VALUES ('09010304', '植物保护(植物检疫方向)', null);
INSERT INTO `zytybmb` VALUES ('09010305', '植物保护(植物医学方向)', null);
INSERT INTO `zytybmb` VALUES ('090104', '植物科学与技术', null);
INSERT INTO `zytybmb` VALUES ('09010401', '植物生物技术', null);
INSERT INTO `zytybmb` VALUES ('09010402', '植物资源工程', null);
INSERT INTO `zytybmb` VALUES ('090105', '种子科学与工程', null);
INSERT INTO `zytybmb` VALUES ('090106', '设施农业科学与工程', null);
INSERT INTO `zytybmb` VALUES ('09010601', '设施农业科学与工程(都市园艺方向)', null);
INSERT INTO `zytybmb` VALUES ('09010602', '设施农业与工程', null);
INSERT INTO `zytybmb` VALUES ('090107T', '茶学', null);
INSERT INTO `zytybmb` VALUES ('090107T01', '茶学(茶学院)', null);
INSERT INTO `zytybmb` VALUES ('090107T02', '茶学(创意设计方向)', null);
INSERT INTO `zytybmb` VALUES ('090107T03', '茶学(理科)', null);
INSERT INTO `zytybmb` VALUES ('090107T04', '茶学(文科)', null);
INSERT INTO `zytybmb` VALUES ('090107T05', '茶学茶企业经营管理方向', null);
INSERT INTO `zytybmb` VALUES ('090107T06', '茶学茶文化经济方向', null);
INSERT INTO `zytybmb` VALUES ('090108T', '烟草', null);
INSERT INTO `zytybmb` VALUES ('090109T', '应用生物科学', null);
INSERT INTO `zytybmb` VALUES ('090109T1', '应用生物教育', null);
INSERT INTO `zytybmb` VALUES ('090110T', '农艺教育', null);
INSERT INTO `zytybmb` VALUES ('090111T', '园艺教育', null);
INSERT INTO `zytybmb` VALUES ('090200', '自然保护与环境生态类', null);
INSERT INTO `zytybmb` VALUES ('09020001', '自然保护与环境生态类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('090201', '农业资源与环境', null);
INSERT INTO `zytybmb` VALUES ('090202', '野生动物与自然保护区管理', null);
INSERT INTO `zytybmb` VALUES ('090203', '水土保持与荒漠化防治', null);
INSERT INTO `zytybmb` VALUES ('09020301', '水土保持与荒淡化防治', null);
INSERT INTO `zytybmb` VALUES ('09020302', '水土保持与沙漠化防治', null);
INSERT INTO `zytybmb` VALUES ('090300', '动物生产类', null);
INSERT INTO `zytybmb` VALUES ('09030001', '动物生产类(中外)', null);
INSERT INTO `zytybmb` VALUES ('09030002', '动物生产类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('09030003', '动物生产', null);
INSERT INTO `zytybmb` VALUES ('090301', '动物科学', null);
INSERT INTO `zytybmb` VALUES ('09030101', '动物科学(拔尖人才培养班)', null);
INSERT INTO `zytybmb` VALUES ('09030102', '动物科学(动物营养工程)', null);
INSERT INTO `zytybmb` VALUES ('09030103', '动物科学(含动物医学、动物科学、水产养殖', null);
INSERT INTO `zytybmb` VALUES ('09030104', '动物科学(含动物医学、动物科学、水产养殖)', null);
INSERT INTO `zytybmb` VALUES ('090302T', '蚕学', null);
INSERT INTO `zytybmb` VALUES ('090303T', '蜂学', null);
INSERT INTO `zytybmb` VALUES ('090400', '动物医学类', null);
INSERT INTO `zytybmb` VALUES ('09040001', '动物医学类(中外)', null);
INSERT INTO `zytybmb` VALUES ('09040002', '动植物检疫(动物检疫)', null);
INSERT INTO `zytybmb` VALUES ('09040003', '动植物检疫(植物检疫)', null);
INSERT INTO `zytybmb` VALUES ('09040004', '动植物检疫(动检方向)', null);
INSERT INTO `zytybmb` VALUES ('09040005', '动植物检疫(植物检疫方向)', null);
INSERT INTO `zytybmb` VALUES ('09040006', '动植物检疫(植检方向)', null);
INSERT INTO `zytybmb` VALUES ('090401', '动物医学', null);
INSERT INTO `zytybmb` VALUES ('09040101', '动物医学(本)', null);
INSERT INTO `zytybmb` VALUES ('09040102', '动物医学(本硕分流培养)', null);
INSERT INTO `zytybmb` VALUES ('09040103', '动物医学(五年)', null);
INSERT INTO `zytybmb` VALUES ('09040104', '水生动物医学', null);
INSERT INTO `zytybmb` VALUES ('09040105', '动物医药', null);
INSERT INTO `zytybmb` VALUES ('090402', '动物药学', null);
INSERT INTO `zytybmb` VALUES ('090403T', '动植物检疫', null);
INSERT INTO `zytybmb` VALUES ('090500', '林学类', null);
INSERT INTO `zytybmb` VALUES ('09050001', '林学类(成栋实验班)', null);
INSERT INTO `zytybmb` VALUES ('09050002', '林学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('090501', '林学', null);
INSERT INTO `zytybmb` VALUES ('09050101', '林学(水土保持与生态工程)', null);
INSERT INTO `zytybmb` VALUES ('090502', '园林', null);
INSERT INTO `zytybmb` VALUES ('09050201', '园   艺(景观规划与设计)', null);
INSERT INTO `zytybmb` VALUES ('09050202', '园林(城市景观设计)', null);
INSERT INTO `zytybmb` VALUES ('09050203', '园林(城市景观与规划设计)', null);
INSERT INTO `zytybmb` VALUES ('09050204', '园林(城市景光设计)', null);
INSERT INTO `zytybmb` VALUES ('09050205', '园林(景观设计方向)', null);
INSERT INTO `zytybmb` VALUES ('09050206', '园林(绍骙实验班)', null);
INSERT INTO `zytybmb` VALUES ('09050207', '园林(园林建筑方向)', null);
INSERT INTO `zytybmb` VALUES ('09050208', '园林(园林设计)', null);
INSERT INTO `zytybmb` VALUES ('09050209', '园艺(草坪科学与工程方向)', null);
INSERT INTO `zytybmb` VALUES ('09050210', '园艺(花卉与景观设计方向)', null);
INSERT INTO `zytybmb` VALUES ('09050211', '园艺(园艺技术与工程)', null);
INSERT INTO `zytybmb` VALUES ('09050212', '园艺(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('090503', '森林保护', null);
INSERT INTO `zytybmb` VALUES ('09050301', '森林保护(菌物资源与利用)', null);
INSERT INTO `zytybmb` VALUES ('09050302', '森林保护(有害生物防控)', null);
INSERT INTO `zytybmb` VALUES ('09050303', '森林保护(有害生物防控方向)', null);
INSERT INTO `zytybmb` VALUES ('09050405', '应急管理', null);
INSERT INTO `zytybmb` VALUES ('090600', '水产类', null);
INSERT INTO `zytybmb` VALUES ('09060001', '水产', null);
INSERT INTO `zytybmb` VALUES ('090601', '水产养殖学', null);
INSERT INTO `zytybmb` VALUES ('09060101', '水产养殖业', null);
INSERT INTO `zytybmb` VALUES ('09060102', '水产养殖教育', null);
INSERT INTO `zytybmb` VALUES ('090602', '海洋渔业科学与技术', null);
INSERT INTO `zytybmb` VALUES ('09060201', '海洋渔业科学与技术(五年制)', null);
INSERT INTO `zytybmb` VALUES ('09060202', '海洋渔业科学与技术专业', null);
INSERT INTO `zytybmb` VALUES ('090603T', '水族科学与技术', null);
INSERT INTO `zytybmb` VALUES ('090700', '草学类', null);
INSERT INTO `zytybmb` VALUES ('090701', '草业科学', null);
INSERT INTO `zytybmb` VALUES ('09070101', '草业科学类(中外)', null);
INSERT INTO `zytybmb` VALUES ('09070102', '草业科学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('09070103', '草学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('09080101', '工程兵指挥', null);
INSERT INTO `zytybmb` VALUES ('100000', '医学', null);
INSERT INTO `zytybmb` VALUES ('100100', '基础医学类', null);
INSERT INTO `zytybmb` VALUES ('100101K', '基础医学', null);
INSERT INTO `zytybmb` VALUES ('100101K01', '基础医学(本硕连读)', null);
INSERT INTO `zytybmb` VALUES ('100101K02', '基础医学本科', null);
INSERT INTO `zytybmb` VALUES ('100101K03', '基础医学基地班', null);
INSERT INTO `zytybmb` VALUES ('100101K04', '五年制基础医学', null);
INSERT INTO `zytybmb` VALUES ('100101K05', '五年制本科基础医学专业', null);
INSERT INTO `zytybmb` VALUES ('100200', '临床医学类', null);
INSERT INTO `zytybmb` VALUES ('10020101', '临床医学(通州区定向)', null);
INSERT INTO `zytybmb` VALUES ('10020102', '临床医学(儿科班)', null);
INSERT INTO `zytybmb` VALUES ('10020103', '五年制本科临床医学专业', null);
INSERT INTO `zytybmb` VALUES ('10020104', '五年制临床医学(怀柔区定向)', null);
INSERT INTO `zytybmb` VALUES ('10020105', '临床医学(本)', null);
INSERT INTO `zytybmb` VALUES ('10020106', '临床医学(贫困专项)', null);
INSERT INTO `zytybmb` VALUES ('10020107', '临床医学(本硕博连读)八年制', null);
INSERT INTO `zytybmb` VALUES ('10020108', '五年制临床医学', null);
INSERT INTO `zytybmb` VALUES ('10020109', '临床医学专业(肿瘤学方向，七年制本硕连读)', null);
INSERT INTO `zytybmb` VALUES ('10020110', '临床医学(药学方向、七年制)', null);
INSERT INTO `zytybmb` VALUES ('10020111', '临床医学(延庆县定向)', null);
INSERT INTO `zytybmb` VALUES ('10020112', '临床医学(八年制)', null);
INSERT INTO `zytybmb` VALUES ('10020113', '临床医学与医学技术', null);
INSERT INTO `zytybmb` VALUES ('10020114', '临床医学(昌平区定向)', null);
INSERT INTO `zytybmb` VALUES ('10020115', '五年制临床医学(顺义区定向)', null);
INSERT INTO `zytybmb` VALUES ('10020116', '临床医学(定向培养)', null);
INSERT INTO `zytybmb` VALUES ('10020117', '临床医学(实验班)', null);
INSERT INTO `zytybmb` VALUES ('10020118', '五年制临床医学(基地本科班)', null);
INSERT INTO `zytybmb` VALUES ('10020119', '临床医学(日语班)', null);
INSERT INTO `zytybmb` VALUES ('10020120', '临床医学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('10020121', '临床医学(7年制)', null);
INSERT INTO `zytybmb` VALUES ('10020122', '临床医学专业(肿瘤学，七年制本硕连读)', null);
INSERT INTO `zytybmb` VALUES ('10020124', '五年制临床医学(海淀区定向)', null);
INSERT INTO `zytybmb` VALUES ('10020125', '临床医学(俄语班)', null);
INSERT INTO `zytybmb` VALUES ('10020126', '五年制临床医学(密云县定向)', null);
INSERT INTO `zytybmb` VALUES ('10020127', '五年制临床医学(昌平区定向)', null);
INSERT INTO `zytybmb` VALUES ('10020128', '临床医学专业(医学影像学方向，七年制本硕连读)', null);
INSERT INTO `zytybmb` VALUES ('10020130', '七年制临床医学专业', null);
INSERT INTO `zytybmb` VALUES ('10020132', '临床医学(怀柔区定向)', null);
INSERT INTO `zytybmb` VALUES ('10020133', '临床医学(七年制)', null);
INSERT INTO `zytybmb` VALUES ('10020134', '临床医学(定向)', null);
INSERT INTO `zytybmb` VALUES ('100201K', '临床医学', null);
INSERT INTO `zytybmb` VALUES ('100201K01', '五年制临床医学(朝阳区定向)', null);
INSERT INTO `zytybmb` VALUES ('100201K02', '五年制临床医学(大兴区定向)', null);
INSERT INTO `zytybmb` VALUES ('100201K03', '五年制临床医学(房山区定向)', null);
INSERT INTO `zytybmb` VALUES ('100201K04', '五年制临床医学(门头沟区定向)', null);
INSERT INTO `zytybmb` VALUES ('100201K05', '五年制临床医学(平谷区定向)', null);
INSERT INTO `zytybmb` VALUES ('100201K06', '五年制临床医学(通州区定向)', null);
INSERT INTO `zytybmb` VALUES ('100201K07', '临床医学(本科)', null);
INSERT INTO `zytybmb` VALUES ('100201K08', '临床医学(本硕连读)', null);
INSERT INTO `zytybmb` VALUES ('100201K09', '临床医学(定向 本科)', null);
INSERT INTO `zytybmb` VALUES ('100201K10', '临床医学(定向 专科)', null);
INSERT INTO `zytybmb` VALUES ('100201K11', '临床医学(儿科医学方向)', null);
INSERT INTO `zytybmb` VALUES ('100201K12', '临床医学(基地本科班)', null);
INSERT INTO `zytybmb` VALUES ('100201K13', '临床医学(门头沟区定向)', null);
INSERT INTO `zytybmb` VALUES ('100201K14', '临床医学(密云县定向)', null);
INSERT INTO `zytybmb` VALUES ('100201K15', '临床医学(免费医学生方向)', null);
INSERT INTO `zytybmb` VALUES ('100201K16', '临床医学(农村专项)', null);
INSERT INTO `zytybmb` VALUES ('100201K17', '临床医学(平谷区定向)', null);
INSERT INTO `zytybmb` VALUES ('100201K18', '临床医学(全科医学)', null);
INSERT INTO `zytybmb` VALUES ('100201K19', '临床医学(顺义区定向)', null);
INSERT INTO `zytybmb` VALUES ('100201K20', '临床医学(五年制)', null);
INSERT INTO `zytybmb` VALUES ('100201K21', '临床医学(医学美容)', null);
INSERT INTO `zytybmb` VALUES ('100201K22', '临床医学(英语班)', null);
INSERT INTO `zytybmb` VALUES ('100201K23', '临床医学(专科)', null);
INSERT INTO `zytybmb` VALUES ('100201K24', '临床医学本科', null);
INSERT INTO `zytybmb` VALUES ('100201K25', '临床医学专业', null);
INSERT INTO `zytybmb` VALUES ('100201K26', '临床医学专业(儿科方向，七年制本硕连读)', null);
INSERT INTO `zytybmb` VALUES ('100201K27', '临床医学专业(儿科学方向，七年制本硕连读)', null);
INSERT INTO `zytybmb` VALUES ('100201K28', '临床医学专业(七年制本硕连读)', null);
INSERT INTO `zytybmb` VALUES ('100201K29', '临床医学专业(五年制本科)', null);
INSERT INTO `zytybmb` VALUES ('100201K30', '临床医学专业(香港中文大学联合培养预备班，七年制本硕连读)', null);
INSERT INTO `zytybmb` VALUES ('100201K31', '临床医学专业(眼科方向，七年制本硕连读)', null);
INSERT INTO `zytybmb` VALUES ('100201K32', '临床医学专业(眼科学方向，七年制本硕连读)', null);
INSERT INTO `zytybmb` VALUES ('100201K33', '七年制临床医学', null);
INSERT INTO `zytybmb` VALUES ('100201K34', '七年制临床医学(儿科医学方向)', null);
INSERT INTO `zytybmb` VALUES ('100201K35', '七年制临床医学专业(儿科医学专业方向)', null);
INSERT INTO `zytybmb` VALUES ('100201K36', '三年制临床医学(北京农村基层定向)', null);
INSERT INTO `zytybmb` VALUES ('100201K37', '三年制临床医学(北京山区、半山区定向)', null);
INSERT INTO `zytybmb` VALUES ('100201K38', '五年制临床医学(延庆县定向)', null);
INSERT INTO `zytybmb` VALUES ('100202TK', '麻醉学', null);
INSERT INTO `zytybmb` VALUES ('100202TK01', '麻醉学(本科)', null);
INSERT INTO `zytybmb` VALUES ('100202TK02', '麻醉学专业', null);
INSERT INTO `zytybmb` VALUES ('100203TK', '医学影像学', null);
INSERT INTO `zytybmb` VALUES ('100203TK01', '医学影象学', null);
INSERT INTO `zytybmb` VALUES ('100203TK02', '医学影像工程', null);
INSERT INTO `zytybmb` VALUES ('100203TK03', '医学影像学(本科)', null);
INSERT INTO `zytybmb` VALUES ('100203TK04', '医学影像学(农村专项)', null);
INSERT INTO `zytybmb` VALUES ('100203TK05', '医学影像学(贫困专项)', null);
INSERT INTO `zytybmb` VALUES ('100203TK06', '医学影像学本科', null);
INSERT INTO `zytybmb` VALUES ('100203TK07', '医学影像学专业', null);
INSERT INTO `zytybmb` VALUES ('100204TK', '眼视光医学', null);
INSERT INTO `zytybmb` VALUES ('100205TK', '精神医学', null);
INSERT INTO `zytybmb` VALUES ('100206TK', '放射医学', null);
INSERT INTO `zytybmb` VALUES ('100300', '口腔医学类', null);
INSERT INTO `zytybmb` VALUES ('100301K', '口腔医学', null);
INSERT INTO `zytybmb` VALUES ('100301K01', '五年制口腔医学', null);
INSERT INTO `zytybmb` VALUES ('100301K02', '五年制本科口腔医学专业', null);
INSERT INTO `zytybmb` VALUES ('100301K03', '七年制口腔医学', null);
INSERT INTO `zytybmb` VALUES ('100301K04', '七年制口腔医学专业', null);
INSERT INTO `zytybmb` VALUES ('100301K05', '口控医学', null);
INSERT INTO `zytybmb` VALUES ('100301K07', '口腔氏学', null);
INSERT INTO `zytybmb` VALUES ('100301K08', '口腔修复工艺学', null);
INSERT INTO `zytybmb` VALUES ('100301K09', '口腔医学(农村专项)', null);
INSERT INTO `zytybmb` VALUES ('100301K10', '口腔医学(七年制)', null);
INSERT INTO `zytybmb` VALUES ('100301K11', '口腔医学(五年制)', null);
INSERT INTO `zytybmb` VALUES ('100301K12', '口腔医学本科', null);
INSERT INTO `zytybmb` VALUES ('100301K13', '口腔医学专业', null);
INSERT INTO `zytybmb` VALUES ('100400', '公共卫生与预防医学类', null);
INSERT INTO `zytybmb` VALUES ('100401K', '预防医学', null);
INSERT INTO `zytybmb` VALUES ('100401K01', '预防医学(农村专项)', null);
INSERT INTO `zytybmb` VALUES ('100401K02', '预防医学(五年制)', null);
INSERT INTO `zytybmb` VALUES ('100401K03', '预防医学(预防医学方向)', null);
INSERT INTO `zytybmb` VALUES ('100401K04', '预防医学专业', null);
INSERT INTO `zytybmb` VALUES ('100401K05', '五年制预防医学(房山区定向)', null);
INSERT INTO `zytybmb` VALUES ('100401K06', '五年制预防医学(海淀区定向)', null);
INSERT INTO `zytybmb` VALUES ('100401K07', '五年制预防医学(怀柔区定向)', null);
INSERT INTO `zytybmb` VALUES ('100401K08', '五年制预防医学(门头沟区定向)', null);
INSERT INTO `zytybmb` VALUES ('100401K09', '五年制预防医学(密云县定向)', null);
INSERT INTO `zytybmb` VALUES ('100401K10', '五年制预防医学(平谷区定向)', null);
INSERT INTO `zytybmb` VALUES ('100401K11', '五年制预防医学(顺义区定向)', null);
INSERT INTO `zytybmb` VALUES ('100401K12', '五年制预防医学(通州区定向)', null);
INSERT INTO `zytybmb` VALUES ('100401K13', '五年制预防医学(延庆县定向)', null);
INSERT INTO `zytybmb` VALUES ('100401K14', '五年制本科预防医学专业', null);
INSERT INTO `zytybmb` VALUES ('100401K15', '五年制预防医学', null);
INSERT INTO `zytybmb` VALUES ('100401K16', '五年制预防医学(昌平区定向)', null);
INSERT INTO `zytybmb` VALUES ('100401K17', '五年制预防医学(朝阳区定向)', null);
INSERT INTO `zytybmb` VALUES ('100401K18', '五年制预防医学(大兴区定向)', null);
INSERT INTO `zytybmb` VALUES ('100402', '食品卫生与营养学', null);
INSERT INTO `zytybmb` VALUES ('10040201', '营养学', null);
INSERT INTO `zytybmb` VALUES ('100403TK', '妇幼保健医学', null);
INSERT INTO `zytybmb` VALUES ('100403TK1', '妇幼保地医学', null);
INSERT INTO `zytybmb` VALUES ('100404TK', '卫生监督', null);
INSERT INTO `zytybmb` VALUES ('100405TK', '全球健康学', null);
INSERT INTO `zytybmb` VALUES ('100500', '中医学类', null);
INSERT INTO `zytybmb` VALUES ('100501K', '中医学', null);
INSERT INTO `zytybmb` VALUES ('100501K01', '五年制本科中医学专业', null);
INSERT INTO `zytybmb` VALUES ('100501K02', '四年制中药学', null);
INSERT INTO `zytybmb` VALUES ('100501K03', '临床药学专业', null);
INSERT INTO `zytybmb` VALUES ('100501K04', '中医学(定向培养)', null);
INSERT INTO `zytybmb` VALUES ('100501K05', '中医学(免费医学定向)', null);
INSERT INTO `zytybmb` VALUES ('100501K06', '中医学(七年长学制，本硕连读)', null);
INSERT INTO `zytybmb` VALUES ('100501K07', '中医学(五年制本科)', null);
INSERT INTO `zytybmb` VALUES ('100501K08', '中医学1', null);
INSERT INTO `zytybmb` VALUES ('100501K09', '中医学对外中医方向', null);
INSERT INTO `zytybmb` VALUES ('100501K10', '中医学骨伤科学方向', null);
INSERT INTO `zytybmb` VALUES ('100501K11', '中医学全科医生方向', null);
INSERT INTO `zytybmb` VALUES ('100501K12', '中医学外科学方向', null);
INSERT INTO `zytybmb` VALUES ('100501K13', '中医学医学心理学方向', null);
INSERT INTO `zytybmb` VALUES ('100501K14', '中医临床医学', null);
INSERT INTO `zytybmb` VALUES ('100501K15', '五年制中医学', null);
INSERT INTO `zytybmb` VALUES ('100501K16', '中医学(本科)', null);
INSERT INTO `zytybmb` VALUES ('100501K17', '中医学(本硕连读)', null);
INSERT INTO `zytybmb` VALUES ('100502K', '针灸推拿学', null);
INSERT INTO `zytybmb` VALUES ('100502K01', '针灸推拿学(本科)', null);
INSERT INTO `zytybmb` VALUES ('100502K02', '针灸推拿学(国家特色专业建设点)', null);
INSERT INTO `zytybmb` VALUES ('100502K03', '针灸推拿学(贫困专项)', null);
INSERT INTO `zytybmb` VALUES ('100502K04', '针炙推拿学', null);
INSERT INTO `zytybmb` VALUES ('100503K', '藏医学', null);
INSERT INTO `zytybmb` VALUES ('100504K', '蒙医学', null);
INSERT INTO `zytybmb` VALUES ('100505K', '维医学', null);
INSERT INTO `zytybmb` VALUES ('100506K', '壮医学', null);
INSERT INTO `zytybmb` VALUES ('100507K', '哈医学', null);
INSERT INTO `zytybmb` VALUES ('100600', '中西医结合类', null);
INSERT INTO `zytybmb` VALUES ('10060001', '中西医临床医学(本科)', null);
INSERT INTO `zytybmb` VALUES ('10060002', '中医学中西医结合临床方向', null);
INSERT INTO `zytybmb` VALUES ('10060003', '中西医临床医学(贫困专项)', null);
INSERT INTO `zytybmb` VALUES ('10060004', '中医学(中西医结合)(本硕连读)(', null);
INSERT INTO `zytybmb` VALUES ('10060005', '中西医临床医学全科医生方向', null);
INSERT INTO `zytybmb` VALUES ('10060006', '中西医临床医学(农村专项)', null);
INSERT INTO `zytybmb` VALUES ('100601K', '中西医临床医学', null);
INSERT INTO `zytybmb` VALUES ('100700', '药学类', null);
INSERT INTO `zytybmb` VALUES ('100701', '药学', null);
INSERT INTO `zytybmb` VALUES ('10070101', '药学(临床药学方向)', null);
INSERT INTO `zytybmb` VALUES ('10070102', '药学(农村专项)', null);
INSERT INTO `zytybmb` VALUES ('10070103', '药学(医学院)', null);
INSERT INTO `zytybmb` VALUES ('10070104', '药学1', null);
INSERT INTO `zytybmb` VALUES ('10070105', '药学类(中外)', null);
INSERT INTO `zytybmb` VALUES ('10070106', '药学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('10070107', '药学类(中外合作办学)(药物制剂)', null);
INSERT INTO `zytybmb` VALUES ('10070108', '药学专业', null);
INSERT INTO `zytybmb` VALUES ('10070109', '基础药学基地班', null);
INSERT INTO `zytybmb` VALUES ('10070110', '四年制药学', null);
INSERT INTO `zytybmb` VALUES ('100702', '药物制剂', null);
INSERT INTO `zytybmb` VALUES ('10070201', '药物制剂(生物制药方向)中美)', null);
INSERT INTO `zytybmb` VALUES ('10070202', '药物制剂本科', null);
INSERT INTO `zytybmb` VALUES ('100703TK', '临床药学', null);
INSERT INTO `zytybmb` VALUES ('100703TK1', '五年制本科临床药学专业', null);
INSERT INTO `zytybmb` VALUES ('100703TK2', '五年制临床药学', null);
INSERT INTO `zytybmb` VALUES ('10070401', '药物管理', null);
INSERT INTO `zytybmb` VALUES ('100704T', '药事管理', null);
INSERT INTO `zytybmb` VALUES ('100705T', '药物分析', null);
INSERT INTO `zytybmb` VALUES ('100705T1', '药物分析', null);
INSERT INTO `zytybmb` VALUES ('100706T', '药物化学', null);
INSERT INTO `zytybmb` VALUES ('100707T', '海洋药学', null);
INSERT INTO `zytybmb` VALUES ('100800', '中药学类', null);
INSERT INTO `zytybmb` VALUES ('100801', '中药学', null);
INSERT INTO `zytybmb` VALUES ('10080101', '中药学(本科)', null);
INSERT INTO `zytybmb` VALUES ('10080102', '中药学(国家特色专业建设点)', null);
INSERT INTO `zytybmb` VALUES ('10080103', '中药学(药用植物)', null);
INSERT INTO `zytybmb` VALUES ('10080104', '中药学(彝药学)', null);
INSERT INTO `zytybmb` VALUES ('10080105', '中药资源与开发(国家特色专业建设点)', null);
INSERT INTO `zytybmb` VALUES ('100802', '中药资源与开发', null);
INSERT INTO `zytybmb` VALUES ('100803T', '藏药学', null);
INSERT INTO `zytybmb` VALUES ('100804T', '蒙药学', null);
INSERT INTO `zytybmb` VALUES ('100805T', '中药制药', null);
INSERT INTO `zytybmb` VALUES ('100806T', '中草药栽培与鉴定', null);
INSERT INTO `zytybmb` VALUES ('100900', '法医学类', null);
INSERT INTO `zytybmb` VALUES ('100901K', '法医学', null);
INSERT INTO `zytybmb` VALUES ('100901K1', '法医学专业', null);
INSERT INTO `zytybmb` VALUES ('101000', '医学技术类', null);
INSERT INTO `zytybmb` VALUES ('101001', '医学检验技术', null);
INSERT INTO `zytybmb` VALUES ('10100101', '医学检测', null);
INSERT INTO `zytybmb` VALUES ('10100102', '医学检查', null);
INSERT INTO `zytybmb` VALUES ('10100103', '医学检验', null);
INSERT INTO `zytybmb` VALUES ('10100104', '医学检验技术(农村专项)', null);
INSERT INTO `zytybmb` VALUES ('10100105', '医学检验技术(专科)', null);
INSERT INTO `zytybmb` VALUES ('10100106', '医学检验技术本科', null);
INSERT INTO `zytybmb` VALUES ('10100107', '医学检验学', null);
INSERT INTO `zytybmb` VALUES ('10100108', '四年制医学检验技术', null);
INSERT INTO `zytybmb` VALUES ('101002', '医学实验技术', null);
INSERT INTO `zytybmb` VALUES ('10100201', '医学实验技术本科', null);
INSERT INTO `zytybmb` VALUES ('10100202', '医学实验学', null);
INSERT INTO `zytybmb` VALUES ('10100203', '医学试验班', null);
INSERT INTO `zytybmb` VALUES ('10100204', '医学试验班类', null);
INSERT INTO `zytybmb` VALUES ('101003', '医学影像技术', null);
INSERT INTO `zytybmb` VALUES ('10100301', '医学形像技术', null);
INSERT INTO `zytybmb` VALUES ('101004', '眼视光学', null);
INSERT INTO `zytybmb` VALUES ('101005', '康复治疗学', null);
INSERT INTO `zytybmb` VALUES ('10100501', '四年制康复治疗学', null);
INSERT INTO `zytybmb` VALUES ('101006', '口腔医学技术', null);
INSERT INTO `zytybmb` VALUES ('101007', '卫生检验与检疫', null);
INSERT INTO `zytybmb` VALUES ('10100701', '卫生检验', null);
INSERT INTO `zytybmb` VALUES ('10100702', '卫生检验与栓疫', null);
INSERT INTO `zytybmb` VALUES ('101008T', '听力与言语康复学', null);
INSERT INTO `zytybmb` VALUES ('101008T1', '听力学', null);
INSERT INTO `zytybmb` VALUES ('101008T2', '言语听觉科学', null);
INSERT INTO `zytybmb` VALUES ('101100', '护理学类', null);
INSERT INTO `zytybmb` VALUES ('101101', '护理学', null);
INSERT INTO `zytybmb` VALUES ('10110101', '护科学', null);
INSERT INTO `zytybmb` VALUES ('10110102', '护理(定向)', null);
INSERT INTO `zytybmb` VALUES ('10110103', '四年制本科护理学专业', null);
INSERT INTO `zytybmb` VALUES ('10110105', '四年制护理学', null);
INSERT INTO `zytybmb` VALUES ('10110107', '护理学(本科)', null);
INSERT INTO `zytybmb` VALUES ('10110108', '护理学(定向)', null);
INSERT INTO `zytybmb` VALUES ('10110109', '护理学(国家特色专业建设点)', null);
INSERT INTO `zytybmb` VALUES ('10110110', '护理学(民族传统体育与保健英语方向)', null);
INSERT INTO `zytybmb` VALUES ('10110111', '护理学(农村专项)', null);
INSERT INTO `zytybmb` VALUES ('10110112', '护理学(贫困专项)', null);
INSERT INTO `zytybmb` VALUES ('10110113', '护理学(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('10110114', '护理学(助产)本科', null);
INSERT INTO `zytybmb` VALUES ('10110115', '护理学本科', null);
INSERT INTO `zytybmb` VALUES ('10110116', '护理学类(中外)', null);
INSERT INTO `zytybmb` VALUES ('10110117', '护理学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('10110118', '护理学特需护理方向', null);
INSERT INTO `zytybmb` VALUES ('10110119', '护理学英语方向', null);
INSERT INTO `zytybmb` VALUES ('10110120', '护理学专业', null);
INSERT INTO `zytybmb` VALUES ('10110121', '护理学专业(全英预备班，四年制本科)', null);
INSERT INTO `zytybmb` VALUES ('10110122', '护理学专业(四年制本科)', null);
INSERT INTO `zytybmb` VALUES ('10110131', '护理学(含涉外护理方向)', null);
INSERT INTO `zytybmb` VALUES ('10110132', '护理学(蒙授理科)', null);
INSERT INTO `zytybmb` VALUES ('120000', '管理学', null);
INSERT INTO `zytybmb` VALUES ('120100', '管理科学与工程类', null);
INSERT INTO `zytybmb` VALUES ('12010001', '管理科学与工程类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('120101', '管理科学', null);
INSERT INTO `zytybmb` VALUES ('12010101', '管理科学与工程', null);
INSERT INTO `zytybmb` VALUES ('12010102', '管理科学(工程项目管理)', null);
INSERT INTO `zytybmb` VALUES ('12010103', '管理科学(金融风险管理)', null);
INSERT INTO `zytybmb` VALUES ('12010104', '管理科学与工程类(含国际商务、物流管理、管理科学专业)', null);
INSERT INTO `zytybmb` VALUES ('12010105', '管理科学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('12010124', '管理科学(东方管理)', null);
INSERT INTO `zytybmb` VALUES ('12010126', '管理科学与工程类(电子商务、信息管理与信息系统)', null);
INSERT INTO `zytybmb` VALUES ('12010127', '管理科学与工程类(工程管理)', null);
INSERT INTO `zytybmb` VALUES ('12010128', '管理科学(金融理财)', null);
INSERT INTO `zytybmb` VALUES ('12010129', '管理科学与工程类(中外)', null);
INSERT INTO `zytybmb` VALUES ('120102', '信息管理与信息系统', null);
INSERT INTO `zytybmb` VALUES ('12010201', '信息管理科与信息系统', null);
INSERT INTO `zytybmb` VALUES ('12010202', '信息管理科与信息系统(电商大数据技术方向)', null);
INSERT INTO `zytybmb` VALUES ('12010203', '信息管理科与信息系统(含电子商务)', null);
INSERT INTO `zytybmb` VALUES ('12010204', '系统工程', null);
INSERT INTO `zytybmb` VALUES ('12010205', '系统科学', null);
INSERT INTO `zytybmb` VALUES ('12010206', '系统科学与工程', null);
INSERT INTO `zytybmb` VALUES ('12010207', '信息管理信息系统', null);
INSERT INTO `zytybmb` VALUES ('12010208', '信息管理与信息系统(电子商务)', null);
INSERT INTO `zytybmb` VALUES ('12010209', '信息管理与信息系统(服务外包)', null);
INSERT INTO `zytybmb` VALUES ('12010211', '信息管理与信息系统(卫生事业管理方向)', null);
INSERT INTO `zytybmb` VALUES ('12010212', '信息管理与信息系统(医学信息方向)', null);
INSERT INTO `zytybmb` VALUES ('12010213', '信息管理与信息系统信息系统开发、企业信', null);
INSERT INTO `zytybmb` VALUES ('12010214', '信息管理与信息系统专业', null);
INSERT INTO `zytybmb` VALUES ('12010215', '信息计算与科学', null);
INSERT INTO `zytybmb` VALUES ('12010216', '信息科学技术', null);
INSERT INTO `zytybmb` VALUES ('12010217', '信息科学与工程类', null);
INSERT INTO `zytybmb` VALUES ('12010218', '信息科学与技术', null);
INSERT INTO `zytybmb` VALUES ('12010219', '信息物理工程', null);
INSERT INTO `zytybmb` VALUES ('12010220', '信息系统与信息管理', null);
INSERT INTO `zytybmb` VALUES ('12010221', '信息显示与光电技术', null);
INSERT INTO `zytybmb` VALUES ('12010222', '信息研究安全(密码学)', null);
INSERT INTO `zytybmb` VALUES ('12010223', '信息研究与安全(密码学)', null);
INSERT INTO `zytybmb` VALUES ('12010241', '信息管理与信息系统(计算机)', null);
INSERT INTO `zytybmb` VALUES ('12010242', '信息管理与信息系统(计算机信息网络)', null);
INSERT INTO `zytybmb` VALUES ('12010243', '信息管理与信息系统(金融信息管理方向)', null);
INSERT INTO `zytybmb` VALUES ('12010244', '信息管理与信息系统(金融信息化)', null);
INSERT INTO `zytybmb` VALUES ('120103', '工程管理', null);
INSERT INTO `zytybmb` VALUES ('12010301', '工程管理科', null);
INSERT INTO `zytybmb` VALUES ('12010302', '工程管理专业', null);
INSERT INTO `zytybmb` VALUES ('12010303', '工程管理(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('12010304', '工程管理(项目管理与造价管理方向)', null);
INSERT INTO `zytybmb` VALUES ('12010305', '工程管理工商项目管理方向', null);
INSERT INTO `zytybmb` VALUES ('12010306', '工程管理科(工程造价方向)', null);
INSERT INTO `zytybmb` VALUES ('12010307', '工程管理房建工程项目管理方向', null);
INSERT INTO `zytybmb` VALUES ('12010308', '工程管理工程项目管理方向', null);
INSERT INTO `zytybmb` VALUES ('12010309', '项目管理', null);
INSERT INTO `zytybmb` VALUES ('120104', '房地产开发与管理', null);
INSERT INTO `zytybmb` VALUES ('12010401', '仿真科学与技术', null);
INSERT INTO `zytybmb` VALUES ('120105', '工程造价', null);
INSERT INTO `zytybmb` VALUES ('12010501', '工程造价(注册造价工程师方向)', null);
INSERT INTO `zytybmb` VALUES ('12010503', '工程造价土木建筑工程方向', null);
INSERT INTO `zytybmb` VALUES ('120106TK', '保密管理', null);
INSERT INTO `zytybmb` VALUES ('120200', '工商管理类', null);
INSERT INTO `zytybmb` VALUES ('12020001', '工商管理(CAPM美国助理项目管理师)', null);
INSERT INTO `zytybmb` VALUES ('12020002', '工商管理(本)', null);
INSERT INTO `zytybmb` VALUES ('12020003', '工商管理(国际酒店管理)', null);
INSERT INTO `zytybmb` VALUES ('12020004', '工商管理(国际企业管理)', null);
INSERT INTO `zytybmb` VALUES ('12020005', '工商管理(国际企业管理方向)', null);
INSERT INTO `zytybmb` VALUES ('12020006', '工商管理(含国际合作班2+2', null);
INSERT INTO `zytybmb` VALUES ('12020007', '工商管理(航空经营管理)', null);
INSERT INTO `zytybmb` VALUES ('12020008', '工商管理(环境商务)', null);
INSERT INTO `zytybmb` VALUES ('12020009', '工商管理(酒店管理方向)', null);
INSERT INTO `zytybmb` VALUES ('12020010', '工商管理(跨国公司管理)', null);
INSERT INTO `zytybmb` VALUES ('12020011', '工商管理(理科)', null);
INSERT INTO `zytybmb` VALUES ('12020012', '工商管理(面向体育高水平学生)', null);
INSERT INTO `zytybmb` VALUES ('12020013', '工商管理(企业管理方向)', null);
INSERT INTO `zytybmb` VALUES ('12020014', '工商管理(特许经营管理)', null);
INSERT INTO `zytybmb` VALUES ('12020015', '工商管理(外向型人才实验班)', null);
INSERT INTO `zytybmb` VALUES ('12020016', '工商管理(文)', null);
INSERT INTO `zytybmb` VALUES ('12020017', '工商管理(文科)', null);
INSERT INTO `zytybmb` VALUES ('12020018', '工商管理(五年)', null);
INSERT INTO `zytybmb` VALUES ('12020019', '工商管理(物流与供应链管理方向)', null);
INSERT INTO `zytybmb` VALUES ('12020020', '工商管理(英文授课班)', null);
INSERT INTO `zytybmb` VALUES ('12020021', '工商管理(营销管理)', null);
INSERT INTO `zytybmb` VALUES ('12020022', '工商管理(营销管理方向)', null);
INSERT INTO `zytybmb` VALUES ('12020023', '工商管理(应用技术本科)', null);
INSERT INTO `zytybmb` VALUES ('12020024', '工商管理(中外课程合作项目)', null);
INSERT INTO `zytybmb` VALUES ('12020025', '工商管理(中英合作)', null);
INSERT INTO `zytybmb` VALUES ('12020026', '工商管理(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('12020027', '工商管理1', null);
INSERT INTO `zytybmb` VALUES ('12020028', '工商管理大类(工商管理专业、市场营销专业、会计学专业)', null);
INSERT INTO `zytybmb` VALUES ('12020029', '工商管理科', null);
INSERT INTO `zytybmb` VALUES ('12020030', '工商管理科(人力资源管理科、企业管理科、旅游与酒店管理科、房地产经营管理科', null);
INSERT INTO `zytybmb` VALUES ('12020031', '工商管理科(人力资源管理科、企业管理科、旅游与酒店管理科、房地产经营管理科)', null);
INSERT INTO `zytybmb` VALUES ('12020032', '工商管理科(外向型人才实验班)', null);
INSERT INTO `zytybmb` VALUES ('12020033', '工商管理科科科', null);
INSERT INTO `zytybmb` VALUES ('12020034', '工商管理科类', null);
INSERT INTO `zytybmb` VALUES ('12020035', '工商管理类(定克)', null);
INSERT INTO `zytybmb` VALUES ('12020036', '工商管理类(工商管理、人力资源管理、市场营销、会计学)', null);
INSERT INTO `zytybmb` VALUES ('12020037', '工商管理类(工商管理、市场营销、会计学、旅游管理)', null);
INSERT INTO `zytybmb` VALUES ('12020038', '工商管理类(工商管理方向)', null);
INSERT INTO `zytybmb` VALUES ('12020039', '工商管理类(含工商管理、房地产经营管理、人力资源管理、财务会计教育)', null);
INSERT INTO `zytybmb` VALUES ('12020040', '工商管理类(含工商管理、会计学、市场营销、物流管理专业)', null);
INSERT INTO `zytybmb` VALUES ('12020041', '工商管理类(含工商管理、人力资源管理、电子商务、财务管理、会计学、市场营销、旅游管理、国际商务专业)', null);
INSERT INTO `zytybmb` VALUES ('12020042', '工商管理类(会计学、工商管理、人力资源管理、市场营销)', null);
INSERT INTO `zytybmb` VALUES ('12020043', '工商管理类(中外)', null);
INSERT INTO `zytybmb` VALUES ('12020044', '工商管理类(市场营销)', null);
INSERT INTO `zytybmb` VALUES ('12020045', '工商管理类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('12020046', '工商管理类专业(工商管理、市场营销、会计学)', null);
INSERT INTO `zytybmb` VALUES ('12020047', '工商管理商务策划方向', null);
INSERT INTO `zytybmb` VALUES ('12020048', '工商管理物流与供应链管理方向', null);
INSERT INTO `zytybmb` VALUES ('12020101', '企业资源计划管理', null);
INSERT INTO `zytybmb` VALUES ('12020102', '企业资源计划管理(ERP管理)', null);
INSERT INTO `zytybmb` VALUES ('12020103', '企业资源计划管理(企业信息化方向)', null);
INSERT INTO `zytybmb` VALUES ('120201K', '工商管理', null);
INSERT INTO `zytybmb` VALUES ('120202', '市场营销', null);
INSERT INTO `zytybmb` VALUES ('120203K', '会计学', null);
INSERT INTO `zytybmb` VALUES ('120204', '财务管理', null);
INSERT INTO `zytybmb` VALUES ('12020401', '财务管理(包括CIMA方向)', null);
INSERT INTO `zytybmb` VALUES ('12020402', '财务管理(财务管理方向)', null);
INSERT INTO `zytybmb` VALUES ('12020403', '财务管理(财务会计方向)(理科)', null);
INSERT INTO `zytybmb` VALUES ('12020404', '财务管理(财务会计方向)(文科)', null);
INSERT INTO `zytybmb` VALUES ('12020406', '财务管理(管理学)', null);
INSERT INTO `zytybmb` VALUES ('12020407', '财务管理(含税务)', null);
INSERT INTO `zytybmb` VALUES ('12020408', '财务管理(理科)', null);
INSERT INTO `zytybmb` VALUES ('12020409', '财务管理(企业理财方向)', null);
INSERT INTO `zytybmb` VALUES ('12020410', '财务管理(文科)', null);
INSERT INTO `zytybmb` VALUES ('12020411', '财务管理(中外课程合作项目)', null);
INSERT INTO `zytybmb` VALUES ('12020412', '财务管理(注册会计师方向)', null);
INSERT INTO `zytybmb` VALUES ('12020413', '财务管理(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('12020414', '财务管理本科(中美合作办学)', null);
INSERT INTO `zytybmb` VALUES ('12020415', '财务管理财务核算方向', null);
INSERT INTO `zytybmb` VALUES ('12020416', '财务管理财务与资本运营方向', null);
INSERT INTO `zytybmb` VALUES ('12020417', '财务管理公司理财方向', null);
INSERT INTO `zytybmb` VALUES ('12020418', '财务管理国际财务管理方向', null);
INSERT INTO `zytybmb` VALUES ('12020419', '财务管理国际会计方向', null);
INSERT INTO `zytybmb` VALUES ('12020420', '财务管理金融管理方向', null);
INSERT INTO `zytybmb` VALUES ('12020421', '财务管理金融投资方向', null);
INSERT INTO `zytybmb` VALUES ('12020424', '财务管理项目投融资管理方向', null);
INSERT INTO `zytybmb` VALUES ('12020425', '财务管理专业', null);
INSERT INTO `zytybmb` VALUES ('120205', '国际商务', null);
INSERT INTO `zytybmb` VALUES ('12020501', '国际商务(含报关与跟单)', null);
INSERT INTO `zytybmb` VALUES ('120206', '人力资源管理', null);
INSERT INTO `zytybmb` VALUES ('120207', '审计学', null);
INSERT INTO `zytybmb` VALUES ('12020701', '审计学(注册会计师方向)', null);
INSERT INTO `zytybmb` VALUES ('12020702', '审计学事务所审计方向', null);
INSERT INTO `zytybmb` VALUES ('12020703', '审计学专业(注册会计师方向)', null);
INSERT INTO `zytybmb` VALUES ('120208', '资产评估', null);
INSERT INTO `zytybmb` VALUES ('12020801', '资产评估(注册资产评估师方向)', null);
INSERT INTO `zytybmb` VALUES ('120209', '物业管理', null);
INSERT INTO `zytybmb` VALUES ('120210', '文化产业管理', null);
INSERT INTO `zytybmb` VALUES ('12021001', '文化产业管理媒体创意方向', null);
INSERT INTO `zytybmb` VALUES ('12021002', '文化产业管理数字出版方向', null);
INSERT INTO `zytybmb` VALUES ('12021003', '国际文化交流', null);
INSERT INTO `zytybmb` VALUES ('12021004', '国际文化贸易', null);
INSERT INTO `zytybmb` VALUES ('120211T', '劳动关系', null);
INSERT INTO `zytybmb` VALUES ('120212T', '体育经济与管理', null);
INSERT INTO `zytybmb` VALUES ('120213T', '财务会计教育', null);
INSERT INTO `zytybmb` VALUES ('120214T', '市场营销教育', null);
INSERT INTO `zytybmb` VALUES ('120300', '农业经济管理类', null);
INSERT INTO `zytybmb` VALUES ('120301', '农林经济管理', null);
INSERT INTO `zytybmb` VALUES ('12030101', '农林经济管理(拔尖人才培养班)', null);
INSERT INTO `zytybmb` VALUES ('12030102', '农林经济管理(农村发展与管理)', null);
INSERT INTO `zytybmb` VALUES ('12030103', '农林经济管理(农业资源与经济)', null);
INSERT INTO `zytybmb` VALUES ('12030104', '农业经济管理类(中外)', null);
INSERT INTO `zytybmb` VALUES ('12030105', '农业经济管理类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('12030107', '农林经济管理科', null);
INSERT INTO `zytybmb` VALUES ('120302', '农村区域发展', null);
INSERT INTO `zytybmb` VALUES ('120400', '公共管理类', null);
INSERT INTO `zytybmb` VALUES ('120401', '公共事业管理', null);
INSERT INTO `zytybmb` VALUES ('12040101', '公共政策学', null);
INSERT INTO `zytybmb` VALUES ('12040102', '四年制公共事业管理(卫生管理方向)', null);
INSERT INTO `zytybmb` VALUES ('12040103', '四年制公共事业管理(卫生管理)', null);
INSERT INTO `zytybmb` VALUES ('120402', '行政管理', null);
INSERT INTO `zytybmb` VALUES ('12040201', '行政管理(电子政务方向)', null);
INSERT INTO `zytybmb` VALUES ('12040202', '行政管理(行政文秘方向)', null);
INSERT INTO `zytybmb` VALUES ('12040204', '行政管理(金融事务助理方向)', null);
INSERT INTO `zytybmb` VALUES ('12040205', '行政管理(理科)', null);
INSERT INTO `zytybmb` VALUES ('12040206', '行政管理(农村社区管理)', null);
INSERT INTO `zytybmb` VALUES ('12040207', '行政管理(人力资源管理方向)', null);
INSERT INTO `zytybmb` VALUES ('12040208', '行政管理(文科)', null);
INSERT INTO `zytybmb` VALUES ('12040209', '行政管理(中英文秘书方向)', null);
INSERT INTO `zytybmb` VALUES ('12040210', '行政管理(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('12040211', '行政管理公共安全管理方向', null);
INSERT INTO `zytybmb` VALUES ('12040212', '行政管理科', null);
INSERT INTO `zytybmb` VALUES ('12040213', '行政管理专业(行政管理、人力资源管理方向)', null);
INSERT INTO `zytybmb` VALUES ('12040214', '行政管理专业(人力资源管理方向)', null);
INSERT INTO `zytybmb` VALUES ('120403', '劳动与社会保障', null);
INSERT INTO `zytybmb` VALUES ('12040301', '劳动与社会保障(医疗保险)', null);
INSERT INTO `zytybmb` VALUES ('12040302', '劳动与社会保障(医疗保险)', null);
INSERT INTO `zytybmb` VALUES ('12040303', '劳动与社会保障(医疗保险方向)', null);
INSERT INTO `zytybmb` VALUES ('12040304', '劳动与社会保障(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('12040305', '劳动与社会保障专业', null);
INSERT INTO `zytybmb` VALUES ('120404', '土地资源管理', null);
INSERT INTO `zytybmb` VALUES ('12040401', '土地资源管理(国土资源与房地产开发)', null);
INSERT INTO `zytybmb` VALUES ('12040402', '土地资源管理(中英合作)', null);
INSERT INTO `zytybmb` VALUES ('12040403', '土地资源管理(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('12040404', '土地资源管理科', null);
INSERT INTO `zytybmb` VALUES ('12040405', '土地资源管理专业', null);
INSERT INTO `zytybmb` VALUES ('120405', '城市管理', null);
INSERT INTO `zytybmb` VALUES ('12040501', '城市规划', null);
INSERT INTO `zytybmb` VALUES ('12040502', '城市规划(城市规划与设计、人居环境设计)', null);
INSERT INTO `zytybmb` VALUES ('12040503', '城市规划(景观规划设计)', null);
INSERT INTO `zytybmb` VALUES ('12040504', '城市管理科', null);
INSERT INTO `zytybmb` VALUES ('120406TK', '海关管理', null);
INSERT INTO `zytybmb` VALUES ('120407T', '交通管理', null);
INSERT INTO `zytybmb` VALUES ('120408T', '海事管理', null);
INSERT INTO `zytybmb` VALUES ('12040901', '公共关系文学', null);
INSERT INTO `zytybmb` VALUES ('120409T', '公共关系学', null);
INSERT INTO `zytybmb` VALUES ('120409T1', '公共关系学(品牌传播与管理)', null);
INSERT INTO `zytybmb` VALUES ('120500', '图书情报与档案管理类', null);
INSERT INTO `zytybmb` VALUES ('120501', '图书馆学', null);
INSERT INTO `zytybmb` VALUES ('120502', '档案学', null);
INSERT INTO `zytybmb` VALUES ('12050201', '档案学(信息开发)', null);
INSERT INTO `zytybmb` VALUES ('120503', '信息资源管理', null);
INSERT INTO `zytybmb` VALUES ('120600', '物流管理与工程类', null);
INSERT INTO `zytybmb` VALUES ('120601', '物流管理', null);
INSERT INTO `zytybmb` VALUES ('120602', '物流工程', null);
INSERT INTO `zytybmb` VALUES ('12060201', '物流工程(物流系统分析与规划、物流与供应链管理科、物流经济与金融)', null);
INSERT INTO `zytybmb` VALUES ('12060202', '物流工程专业', null);
INSERT INTO `zytybmb` VALUES ('120603T', '采购管理', null);
INSERT INTO `zytybmb` VALUES ('120700', '工业工程类', null);
INSERT INTO `zytybmb` VALUES ('12070001', '工业工程类(管理学)', null);
INSERT INTO `zytybmb` VALUES ('120701', '工业工程', null);
INSERT INTO `zytybmb` VALUES ('12070101', '工业工程专业', null);
INSERT INTO `zytybmb` VALUES ('120702T', '标准化工程', null);
INSERT INTO `zytybmb` VALUES ('12070301', '产品质量工程', null);
INSERT INTO `zytybmb` VALUES ('12070302', '质量与可靠性工程', null);
INSERT INTO `zytybmb` VALUES ('120703T', '质量管理工程', null);
INSERT INTO `zytybmb` VALUES ('120800', '电子商务类', null);
INSERT INTO `zytybmb` VALUES ('120801', '电子商务', null);
INSERT INTO `zytybmb` VALUES ('120802T', '电子商务及法律', null);
INSERT INTO `zytybmb` VALUES ('120900', '旅游管理类', null);
INSERT INTO `zytybmb` VALUES ('120901K', '旅游管理', null);
INSERT INTO `zytybmb` VALUES ('120901K02', '旅游管理(导游管理', null);
INSERT INTO `zytybmb` VALUES ('120901K03', '旅游管理(高尔夫管理)', null);
INSERT INTO `zytybmb` VALUES ('120901K06', '旅游管理(理科)', null);
INSERT INTO `zytybmb` VALUES ('120901K08', '旅游管理(旅游规划与景区管理方向)', null);
INSERT INTO `zytybmb` VALUES ('120901K09', '旅游管理(旅游信息管理方向)', null);
INSERT INTO `zytybmb` VALUES ('120901K10', '旅游管理(设有旅游企业管理、国际酒店管理、旅游规划与开发管理、旅游信息管理和应用外语(英、日)等方向', null);
INSERT INTO `zytybmb` VALUES ('120901K12', '旅游管理(外向型人才实验班)', null);
INSERT INTO `zytybmb` VALUES ('120901K13', '旅游管理(文)', null);
INSERT INTO `zytybmb` VALUES ('120901K14', '旅游管理(文科)', null);
INSERT INTO `zytybmb` VALUES ('120901K17', '旅游管理(休闲与服务管理方向)', null);
INSERT INTO `zytybmb` VALUES ('120901K18', '旅游管理(应用技术本科)', null);
INSERT INTO `zytybmb` VALUES ('120901K19', '旅游管理(应用外语方向(英、日))', null);
INSERT INTO `zytybmb` VALUES ('120901K20', '旅游管理(邮轮经济)', null);
INSERT INTO `zytybmb` VALUES ('120901K21', '旅游管理(与美国俄克拉荷马州立大学联合培养)', null);
INSERT INTO `zytybmb` VALUES ('120901K25', '旅游管理(专科)', null);
INSERT INTO `zytybmb` VALUES ('120901K26', '旅游管理(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('120901K27', '旅游管理国际旅行社经营管理方向', null);
INSERT INTO `zytybmb` VALUES ('120901K28', '旅游管理国际旅游管理', null);
INSERT INTO `zytybmb` VALUES ('120901K29', '旅游管理国际旅游市场营销管理方向', null);
INSERT INTO `zytybmb` VALUES ('120901K30', '旅游管理会展旅游管理方向', null);
INSERT INTO `zytybmb` VALUES ('120901K31', '旅游管理科', null);
INSERT INTO `zytybmb` VALUES ('120901K32', '旅游管理科(外向型人才实验班)', null);
INSERT INTO `zytybmb` VALUES ('120901K33', '旅游管理科类', null);
INSERT INTO `zytybmb` VALUES ('120901K34', '旅游管理科类(含旅游管理科、酒店管理科专业)', null);
INSERT INTO `zytybmb` VALUES ('120901K35', '旅游管理类(含旅游管理、酒店管理、会展经济与管理专业)', null);
INSERT INTO `zytybmb` VALUES ('120901K36', '旅游管理类(会展经济与管理)(', null);
INSERT INTO `zytybmb` VALUES ('120901K37', '旅游管理类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('120901K38', '旅游管理涉外酒店管理方向', null);
INSERT INTO `zytybmb` VALUES ('120901K39', '旅游管理专业', null);
INSERT INTO `zytybmb` VALUES ('120902', '酒店管理', null);
INSERT INTO `zytybmb` VALUES ('12090202', '酒店管理(含国际酒店职业经理人、国际连锁品牌管理)', null);
INSERT INTO `zytybmb` VALUES ('12090203', '酒店管理(理科)', null);
INSERT INTO `zytybmb` VALUES ('12090205', '酒店管理(文科)', null);
INSERT INTO `zytybmb` VALUES ('12090207', '酒店管理(喜达屋集团订单班)', null);
INSERT INTO `zytybmb` VALUES ('12090209', '酒店管理(洲际集团订单班)', null);
INSERT INTO `zytybmb` VALUES ('12090210', '酒店管理(专科)', null);
INSERT INTO `zytybmb` VALUES ('12090211', '酒店管理航空旅游服务方向', null);
INSERT INTO `zytybmb` VALUES ('12090212', '酒店管理烘焙管理方向', null);
INSERT INTO `zytybmb` VALUES ('12090213', '酒店管理旅游方向', null);
INSERT INTO `zytybmb` VALUES ('120903', '会展经济与管理', null);
INSERT INTO `zytybmb` VALUES ('12090303', '会展策划与管理(中澳合作)', null);
INSERT INTO `zytybmb` VALUES ('12090304', '会展经济与管理(会展策划师方向)', null);
INSERT INTO `zytybmb` VALUES ('12090305', '会展经济与管理(与澳大利亚昆士兰大学联合培养)', null);
INSERT INTO `zytybmb` VALUES ('12090306', '会展经济与管理(中英合作)', null);
INSERT INTO `zytybmb` VALUES ('12090307', '会展经济与管理科', null);
INSERT INTO `zytybmb` VALUES ('12090308', '会展经济与管理专业', null);
INSERT INTO `zytybmb` VALUES ('12090309', '会展艺术与技术', null);
INSERT INTO `zytybmb` VALUES ('120904T', '旅游管理与服务教育', null);
INSERT INTO `zytybmb` VALUES ('120904T1', '旅游管理(师范类)', null);
INSERT INTO `zytybmb` VALUES ('130000', '艺术学', null);
INSERT INTO `zytybmb` VALUES ('13000001', '艺术学', null);
INSERT INTO `zytybmb` VALUES ('13000002', '艺术与科技音乐工程方向', null);
INSERT INTO `zytybmb` VALUES ('13000003', '艺术类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('13000004', '艺术类专业(美术学、艺术类设计、艺术类设计学、工业设计、公共艺术类、数字媒体设计)', null);
INSERT INTO `zytybmb` VALUES ('130100', '艺术学理论类', null);
INSERT INTO `zytybmb` VALUES ('130101', '艺术史论', null);
INSERT INTO `zytybmb` VALUES ('13010111', '表演(人物形象设计)', null);
INSERT INTO `zytybmb` VALUES ('13010112', '表演(时装表演艺术)', null);
INSERT INTO `zytybmb` VALUES ('130200', '音乐与舞蹈学类', null);
INSERT INTO `zytybmb` VALUES ('130201', '音乐表演', null);
INSERT INTO `zytybmb` VALUES ('13020101', '音乐表演(器乐)', null);
INSERT INTO `zytybmb` VALUES ('13020102', '音乐表演(声乐)', null);
INSERT INTO `zytybmb` VALUES ('13020103', '音乐表演(艺术学)', null);
INSERT INTO `zytybmb` VALUES ('130202', '音乐学', null);
INSERT INTO `zytybmb` VALUES ('13020201', '音乐学(师范)', null);
INSERT INTO `zytybmb` VALUES ('13020202', '音乐学(师范类)', null);
INSERT INTO `zytybmb` VALUES ('13020203', '音乐科技与艺术', null);
INSERT INTO `zytybmb` VALUES ('130203', '作曲与作曲技术理论', null);
INSERT INTO `zytybmb` VALUES ('130204', '舞蹈表演', null);
INSERT INTO `zytybmb` VALUES ('130205', '舞蹈学', null);
INSERT INTO `zytybmb` VALUES ('130206', '舞蹈编导', null);
INSERT INTO `zytybmb` VALUES ('130300', '戏剧与影视学类', null);
INSERT INTO `zytybmb` VALUES ('13030001', '戏剧与影视学类(动画)(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('13030002', '戏剧与影视学类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('130301', '表演', null);
INSERT INTO `zytybmb` VALUES ('130302', '戏剧学', null);
INSERT INTO `zytybmb` VALUES ('130303', '电影学', null);
INSERT INTO `zytybmb` VALUES ('130304', '戏剧影视文学', null);
INSERT INTO `zytybmb` VALUES ('13030401', '影视学', null);
INSERT INTO `zytybmb` VALUES ('130305', '广播电视编导', null);
INSERT INTO `zytybmb` VALUES ('130306', '戏剧影视导演', null);
INSERT INTO `zytybmb` VALUES ('130307', '戏剧影视美术设计', null);
INSERT INTO `zytybmb` VALUES ('130308', '录音艺术', null);
INSERT INTO `zytybmb` VALUES ('130309', '播音与主持艺术', null);
INSERT INTO `zytybmb` VALUES ('13030902', '播音与主持艺术(英语节目主持方向)', null);
INSERT INTO `zytybmb` VALUES ('130310', '动画', null);
INSERT INTO `zytybmb` VALUES ('130311T', '影视摄影与制作', null);
INSERT INTO `zytybmb` VALUES ('130400', '美术学类', null);
INSERT INTO `zytybmb` VALUES ('130401', '美术学', null);
INSERT INTO `zytybmb` VALUES ('13040101', '美术学(插画与三维动画)', null);
INSERT INTO `zytybmb` VALUES ('13040102', '美术学(商业插画)', null);
INSERT INTO `zytybmb` VALUES ('13040103', '美术学(师范)', null);
INSERT INTO `zytybmb` VALUES ('13040104', '美术学(书法方向)(师范)', null);
INSERT INTO `zytybmb` VALUES ('13040105', '美术学(应用插画方向)', null);
INSERT INTO `zytybmb` VALUES ('13040106', '美术学(中国画与数字艺术)', null);
INSERT INTO `zytybmb` VALUES ('13040107', '美术学专业', null);
INSERT INTO `zytybmb` VALUES ('13040108', '门腔医学', null);
INSERT INTO `zytybmb` VALUES ('130402', '绘画', null);
INSERT INTO `zytybmb` VALUES ('130403', '雕塑', null);
INSERT INTO `zytybmb` VALUES ('130404', '摄影', null);
INSERT INTO `zytybmb` VALUES ('130405T', '书法学', null);
INSERT INTO `zytybmb` VALUES ('130406T', '中国画', null);
INSERT INTO `zytybmb` VALUES ('130500', '设计学类', null);
INSERT INTO `zytybmb` VALUES ('13050001', '设计学类(视觉传达设计(视传、广告)、环境设计、产品设计(产品、家具))', null);
INSERT INTO `zytybmb` VALUES ('13050002', '设计学类(视觉传达设计、环境设计、产品设计)', null);
INSERT INTO `zytybmb` VALUES ('13050003', '设计学类专业(视觉传达设计、环境设计、产品设计、公共艺术类、数字媒体艺术类)', null);
INSERT INTO `zytybmb` VALUES ('13050004', '设计学类专业(艺术类设计学、视觉传达设计、环境设计、产品设计、公共艺术类、数字媒体艺术类)', null);
INSERT INTO `zytybmb` VALUES ('130501', '艺术设计学', null);
INSERT INTO `zytybmb` VALUES ('130502', '视觉传达设计', null);
INSERT INTO `zytybmb` VALUES ('13050201', '视觉传达设计(动画与游戏美术)', null);
INSERT INTO `zytybmb` VALUES ('13050202', '视觉传达设计(广告设计)', null);
INSERT INTO `zytybmb` VALUES ('13050203', '视觉传达设计(空间艺术)', null);
INSERT INTO `zytybmb` VALUES ('13050204', '视觉传达设计(时尚艺术)', null);
INSERT INTO `zytybmb` VALUES ('13050205', '视觉传达设计(艺术类)', null);
INSERT INTO `zytybmb` VALUES ('13050206', '视觉传达设计(影视与数字特效设计)', null);
INSERT INTO `zytybmb` VALUES ('130503', '环境设计', null);
INSERT INTO `zytybmb` VALUES ('13050301', '环境设计(室内设计)', null);
INSERT INTO `zytybmb` VALUES ('13050302', '环境设计(展示设计)', null);
INSERT INTO `zytybmb` VALUES ('13050303', '环境设计、产品设计、视觉传达设计)', null);
INSERT INTO `zytybmb` VALUES ('130504', '产品设计', null);
INSERT INTO `zytybmb` VALUES ('13050401', '产品设计(产品造型设计)', null);
INSERT INTO `zytybmb` VALUES ('13050402', '产品设计(纺织品艺术设计)', null);
INSERT INTO `zytybmb` VALUES ('13050403', '产品设计(家具设计)', null);
INSERT INTO `zytybmb` VALUES ('13050404', '产品设计(鞋类与皮具设计)', null);
INSERT INTO `zytybmb` VALUES ('13050405', '产品设计(艺文)', null);
INSERT INTO `zytybmb` VALUES ('130505', '服装与服饰设计', null);
INSERT INTO `zytybmb` VALUES ('13050501', '服装与服饰设计(服装艺术设计、服饰品设计、人物形象设计)', null);
INSERT INTO `zytybmb` VALUES ('13050502', '服装与服饰设计(服装设计 中美合作项目)', null);
INSERT INTO `zytybmb` VALUES ('13050503', '服装与服饰设计(设计与营销  中美合作项目)', null);
INSERT INTO `zytybmb` VALUES ('13050504', '服装与服饰设计(服饰品设计)', null);
INSERT INTO `zytybmb` VALUES ('13050505', '服装与服饰设计(设计与营销 中美合作项目)', null);
INSERT INTO `zytybmb` VALUES ('13050506', '服装与服饰设计(服装设计  中美合作项目)', null);
INSERT INTO `zytybmb` VALUES ('13050507', '服装与服饰设计(服装艺术设计、服饰品设计)', null);
INSERT INTO `zytybmb` VALUES ('130506', '公共艺术', null);
INSERT INTO `zytybmb` VALUES ('130507', '工艺美术', null);
INSERT INTO `zytybmb` VALUES ('130508', '数字媒体艺术', null);
INSERT INTO `zytybmb` VALUES ('13050901', '科技与创意设计试验班', null);
INSERT INTO `zytybmb` VALUES ('130509T', '艺术与科技', null);
INSERT INTO `zytybmb` VALUES ('510000', '农林牧渔大类', null);
INSERT INTO `zytybmb` VALUES ('510100', '农业技术类', null);
INSERT INTO `zytybmb` VALUES ('510101', '作物生产技术 ', null);
INSERT INTO `zytybmb` VALUES ('510102', '种子生产与经营 ', null);
INSERT INTO `zytybmb` VALUES ('510103', '设施农业技术 ', null);
INSERT INTO `zytybmb` VALUES ('51010301', '设施农业技术(农业水利)', null);
INSERT INTO `zytybmb` VALUES ('510104', '观光农业 ', null);
INSERT INTO `zytybmb` VALUES ('510105', '园艺技术 ', null);
INSERT INTO `zytybmb` VALUES ('51010501', '商品花卉', null);
INSERT INTO `zytybmb` VALUES ('51010506', '都市园艺', null);
INSERT INTO `zytybmb` VALUES ('510106', '茶叶生产加工技术 ', null);
INSERT INTO `zytybmb` VALUES ('510107', '中草药栽培技术 ', null);
INSERT INTO `zytybmb` VALUES ('510108', '烟草栽培技术 ', null);
INSERT INTO `zytybmb` VALUES ('510109', '植物保护 ', null);
INSERT INTO `zytybmb` VALUES ('510110', '植物检疫 ', null);
INSERT INTO `zytybmb` VALUES ('510111', '农产品质量检测', null);
INSERT INTO `zytybmb` VALUES ('51011101', '农产品质量与安全', null);
INSERT INTO `zytybmb` VALUES ('510200', '林业技术类', null);
INSERT INTO `zytybmb` VALUES ('510201', '林业技术 ', null);
INSERT INTO `zytybmb` VALUES ('510202', '园林技术 ', null);
INSERT INTO `zytybmb` VALUES ('510203', '森林资源保护 ', null);
INSERT INTO `zytybmb` VALUES ('51020301', '森林资源', null);
INSERT INTO `zytybmb` VALUES ('51020302', '森林资源保护与游憩', null);
INSERT INTO `zytybmb` VALUES ('51020303', '森林资源类(中外)', null);
INSERT INTO `zytybmb` VALUES ('51020304', '森林资源类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('51020305', '森林资源与保护游憩', null);
INSERT INTO `zytybmb` VALUES ('510204', '野生植物资源开发与利用 ', null);
INSERT INTO `zytybmb` VALUES ('510205', '野生动物保护 ', null);
INSERT INTO `zytybmb` VALUES ('510206', '自然保护区建设与管理 ', null);
INSERT INTO `zytybmb` VALUES ('510207', '森林生态旅游 ', null);
INSERT INTO `zytybmb` VALUES ('510208', '林产化工技术 ', null);
INSERT INTO `zytybmb` VALUES ('510209', '木材加工技术 ', null);
INSERT INTO `zytybmb` VALUES ('510210', '森林采运工程 ', null);
INSERT INTO `zytybmb` VALUES ('510300', '畜牧兽医类 ', null);
INSERT INTO `zytybmb` VALUES ('510301', '畜牧兽医 ', null);
INSERT INTO `zytybmb` VALUES ('510302', '畜牧 ', null);
INSERT INTO `zytybmb` VALUES ('510303', '饲料与动物营养 ', null);
INSERT INTO `zytybmb` VALUES ('510304', '特种动物养殖 ', null);
INSERT INTO `zytybmb` VALUES ('510305', '兽医 ', null);
INSERT INTO `zytybmb` VALUES ('51030501', '宠物医学', null);
INSERT INTO `zytybmb` VALUES ('510306', '兽医医药 ', null);
INSERT INTO `zytybmb` VALUES ('51030601', '兽医兽药', null);
INSERT INTO `zytybmb` VALUES ('510307', '动物防疫与检疫 ', null);
INSERT INTO `zytybmb` VALUES ('51030701', '宠物养护与疫病防治', null);
INSERT INTO `zytybmb` VALUES ('51030702', '动物生物技术', null);
INSERT INTO `zytybmb` VALUES ('51030703', '动物防疫与检验', null);
INSERT INTO `zytybmb` VALUES ('510308', '兽药生产与营销', null);
INSERT INTO `zytybmb` VALUES ('510400', '水产养殖类', null);
INSERT INTO `zytybmb` VALUES ('510401', '水产养殖技术 ', null);
INSERT INTO `zytybmb` VALUES ('510402', '水生动植物保护 ', null);
INSERT INTO `zytybmb` VALUES ('510403', '海洋捕捞技术 ', null);
INSERT INTO `zytybmb` VALUES ('51040301', '海洋工程技术', null);
INSERT INTO `zytybmb` VALUES ('510404', '渔业综合技术 ', null);
INSERT INTO `zytybmb` VALUES ('510500', '农林管理类', null);
INSERT INTO `zytybmb` VALUES ('510501', '农业经济管理 ', null);
INSERT INTO `zytybmb` VALUES ('510502', '农村行政管理 ', null);
INSERT INTO `zytybmb` VALUES ('510503', '乡镇企业管理 ', null);
INSERT INTO `zytybmb` VALUES ('510504', '林业经济信息管理 ', null);
INSERT INTO `zytybmb` VALUES ('510505', '渔业资源与渔政管理', null);
INSERT INTO `zytybmb` VALUES ('520000', '交通运输大类', null);
INSERT INTO `zytybmb` VALUES ('520100', '公路运输类', null);
INSERT INTO `zytybmb` VALUES ('520101', '公路运输与管理 ', null);
INSERT INTO `zytybmb` VALUES ('520102', '高等级公路维护与管理 ', null);
INSERT INTO `zytybmb` VALUES ('520103', '路政管理 ', null);
INSERT INTO `zytybmb` VALUES ('520104', '汽车运用技术 ', null);
INSERT INTO `zytybmb` VALUES ('52010401', '汽车运用技术    (服务与营销方向)', null);
INSERT INTO `zytybmb` VALUES ('52010402', '汽车运用技术    (检测与维修方向)', null);
INSERT INTO `zytybmb` VALUES ('520105', '交通安全与智能控制 ', null);
INSERT INTO `zytybmb` VALUES ('520106', '城市交通运输 ', null);
INSERT INTO `zytybmb` VALUES ('52010601', '交通运营管理', null);
INSERT INTO `zytybmb` VALUES ('52010603', '城市轨道交通工程技术(通信信号)', null);
INSERT INTO `zytybmb` VALUES ('520107', '公路监理 ', null);
INSERT INTO `zytybmb` VALUES ('520108', '道路桥梁工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('520109', '工程机械控制技术 ', null);
INSERT INTO `zytybmb` VALUES ('520110', '工程机械运用与维护 ', null);
INSERT INTO `zytybmb` VALUES ('520200', '铁道运输类', null);
INSERT INTO `zytybmb` VALUES ('520201', '高速铁道技术 ', null);
INSERT INTO `zytybmb` VALUES ('520202', '电气化铁道技术 ', null);
INSERT INTO `zytybmb` VALUES ('520203', '铁道车辆 ', null);
INSERT INTO `zytybmb` VALUES ('520204', '铁道机车车辆 ', null);
INSERT INTO `zytybmb` VALUES ('520205', '铁道通信信号 ', null);
INSERT INTO `zytybmb` VALUES ('520206', '铁道交通运营管理 ', null);
INSERT INTO `zytybmb` VALUES ('52020601', '铁道交通运营管理 文', null);
INSERT INTO `zytybmb` VALUES ('520207', '铁道运输经济 ', null);
INSERT INTO `zytybmb` VALUES ('520208', '铁道工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('52020801', '铁路工程机械', null);
INSERT INTO `zytybmb` VALUES ('520300', '城市轨道运输类', null);
INSERT INTO `zytybmb` VALUES ('520301', '城市轨道交通车辆 ', null);
INSERT INTO `zytybmb` VALUES ('520302', '城市轨道交通控制 ', null);
INSERT INTO `zytybmb` VALUES ('520303', '城市轨道交通工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('520304', '城市轨道交通运营管理 ', null);
INSERT INTO `zytybmb` VALUES ('520400', '水上运输类', null);
INSERT INTO `zytybmb` VALUES ('520401', '航海技术 ', null);
INSERT INTO `zytybmb` VALUES ('52040101', '航海技术(理工)', null);
INSERT INTO `zytybmb` VALUES ('52040102', '航海技术(文史)', null);
INSERT INTO `zytybmb` VALUES ('520402', '水运管理 ', null);
INSERT INTO `zytybmb` VALUES ('52040201', '船舶电气工程技术', null);
INSERT INTO `zytybmb` VALUES ('520403', '国际航运业务管理 ', null);
INSERT INTO `zytybmb` VALUES ('52040301', '国际邮轮乘务', null);
INSERT INTO `zytybmb` VALUES ('520404', '海事管理 ', null);
INSERT INTO `zytybmb` VALUES ('520405', '轮机工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('52040501', '轮机工程(理工)', null);
INSERT INTO `zytybmb` VALUES ('52040502', '轮机工程(文史)', null);
INSERT INTO `zytybmb` VALUES ('52040503', '轮机工程技术(海军士官)', null);
INSERT INTO `zytybmb` VALUES ('520406', '船舶工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('52040601', '船舶电子电气技术', null);
INSERT INTO `zytybmb` VALUES ('52040602', '船舶工程技术(海军士官)', null);
INSERT INTO `zytybmb` VALUES ('52040603', '船舶动力工程', null);
INSERT INTO `zytybmb` VALUES ('520407', '船舶检验 ', null);
INSERT INTO `zytybmb` VALUES ('520408', '航道工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('520500', '民航运输类 ', null);
INSERT INTO `zytybmb` VALUES ('520501', '民航运输 ', null);
INSERT INTO `zytybmb` VALUES ('520502', '飞行技术 ', null);
INSERT INTO `zytybmb` VALUES ('52050201', '飞行器系统与工程', null);
INSERT INTO `zytybmb` VALUES ('520503', '空中乘务 ', null);
INSERT INTO `zytybmb` VALUES ('520504', '航空服务 ', null);
INSERT INTO `zytybmb` VALUES ('520505', '民航商务 ', null);
INSERT INTO `zytybmb` VALUES ('520506', '航空机电设备维修 ', null);
INSERT INTO `zytybmb` VALUES ('520507', '航空电子设备维修 ', null);
INSERT INTO `zytybmb` VALUES ('520508', '民航特种车辆维修 ', null);
INSERT INTO `zytybmb` VALUES ('520509', '航空通信技术 ', null);
INSERT INTO `zytybmb` VALUES ('520510', '空中交通管理 ', null);
INSERT INTO `zytybmb` VALUES ('520511', '民航安全技术管理 ', null);
INSERT INTO `zytybmb` VALUES ('520512', '航空油料管理和应用 ', null);
INSERT INTO `zytybmb` VALUES ('520513', '飞机制造技术 ', null);
INSERT INTO `zytybmb` VALUES ('52051301', '无人机运用工程', null);
INSERT INTO `zytybmb` VALUES ('520600', '港口运输类', null);
INSERT INTO `zytybmb` VALUES ('520601', '港口业务管理 ', null);
INSERT INTO `zytybmb` VALUES ('52060101', '港口与航运管理', null);
INSERT INTO `zytybmb` VALUES ('520602', '港口物流设备与自动控制 ', null);
INSERT INTO `zytybmb` VALUES ('520603', '集装箱运输管理 ', null);
INSERT INTO `zytybmb` VALUES ('520604', '港口工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('52060401', '港口航道与海岸工程专业', null);
INSERT INTO `zytybmb` VALUES ('52060402', '港口航道与海洋工程', null);
INSERT INTO `zytybmb` VALUES ('520605', '报关与国际货运 ', null);
INSERT INTO `zytybmb` VALUES ('520700', '管道运输类', null);
INSERT INTO `zytybmb` VALUES ('520701', '管道工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('520702', '管道工程施工 ', null);
INSERT INTO `zytybmb` VALUES ('520703', '管道运输管理', null);
INSERT INTO `zytybmb` VALUES ('530000', '生化与药品大类', null);
INSERT INTO `zytybmb` VALUES ('530100', '生物技术类', null);
INSERT INTO `zytybmb` VALUES ('530101', '生物技术及应用 ', null);
INSERT INTO `zytybmb` VALUES ('530102', '生物实验技术 ', null);
INSERT INTO `zytybmb` VALUES ('530103', '生物化工工艺 ', null);
INSERT INTO `zytybmb` VALUES ('530104', '微生物技术及应用', null);
INSERT INTO `zytybmb` VALUES ('530200', '化工技术类 ', null);
INSERT INTO `zytybmb` VALUES ('530201', '应用化工技术 ', null);
INSERT INTO `zytybmb` VALUES ('53020101', '海洋化工生产技术', null);
INSERT INTO `zytybmb` VALUES ('530202', '有机化工生产技术 ', null);
INSERT INTO `zytybmb` VALUES ('530203', '高聚物生产技术 ', null);
INSERT INTO `zytybmb` VALUES ('530204', '化纤生产技术 ', null);
INSERT INTO `zytybmb` VALUES ('530205', '精细化学品生产技术 ', null);
INSERT INTO `zytybmb` VALUES ('530206', '石油化工生产技术 ', null);
INSERT INTO `zytybmb` VALUES ('53020601', '稀土工程', null);
INSERT INTO `zytybmb` VALUES ('530207', '炼油技术 ', null);
INSERT INTO `zytybmb` VALUES ('530208', '工业分析与检验 ', null);
INSERT INTO `zytybmb` VALUES ('530209', '化工设备维修技术 ', null);
INSERT INTO `zytybmb` VALUES ('530300', '制药技术类', null);
INSERT INTO `zytybmb` VALUES ('530301', '生化制药技术 ', null);
INSERT INTO `zytybmb` VALUES ('530302', '生物制药技术 ', null);
INSERT INTO `zytybmb` VALUES ('530303', '化学制药技术 ', null);
INSERT INTO `zytybmb` VALUES ('530304', '中药制药技术 ', null);
INSERT INTO `zytybmb` VALUES ('530305', '药物制剂技术 ', null);
INSERT INTO `zytybmb` VALUES ('530306', '药物分析技术', null);
INSERT INTO `zytybmb` VALUES ('530400', '食品药品管理类', null);
INSERT INTO `zytybmb` VALUES ('53040001', '绿色食品生产与检验', null);
INSERT INTO `zytybmb` VALUES ('53040002', '绿色食品生产与经营', null);
INSERT INTO `zytybmb` VALUES ('530401', '食品药品监督管理 ', null);
INSERT INTO `zytybmb` VALUES ('53040101', '食品质量与安全监管', null);
INSERT INTO `zytybmb` VALUES ('530402', '药品质量检测技术 ', null);
INSERT INTO `zytybmb` VALUES ('530403', '药品经营与管理 ', null);
INSERT INTO `zytybmb` VALUES ('53040301', '特许经营管理', null);
INSERT INTO `zytybmb` VALUES ('530404', '保健品开发与管理', null);
INSERT INTO `zytybmb` VALUES ('540000', '资源开发与测绘大类 ', null);
INSERT INTO `zytybmb` VALUES ('540100', '资源勘查类', null);
INSERT INTO `zytybmb` VALUES ('540101', '国土资源调查 ', null);
INSERT INTO `zytybmb` VALUES ('540102', '区域地质调查及矿产普查 ', null);
INSERT INTO `zytybmb` VALUES ('54010201', '工程地质勘察', null);
INSERT INTO `zytybmb` VALUES ('540103', '煤田地质与勘查技术 ', null);
INSERT INTO `zytybmb` VALUES ('540104', '油气地质与勘查技术 ', null);
INSERT INTO `zytybmb` VALUES ('540105', '水文地质与勘查技术 ', null);
INSERT INTO `zytybmb` VALUES ('540106', '金属矿产地质与勘查技术 ', null);
INSERT INTO `zytybmb` VALUES ('54010601', '金属矿地质与勘查技术', null);
INSERT INTO `zytybmb` VALUES ('540107', '铀矿地质与勘查技术 ', null);
INSERT INTO `zytybmb` VALUES ('540108', '非金属矿产地质与勘查技术 ', null);
INSERT INTO `zytybmb` VALUES ('540109', '岩矿分析与鉴定技术 ', null);
INSERT INTO `zytybmb` VALUES ('540110', '宝玉石鉴定与加工技术 ', null);
INSERT INTO `zytybmb` VALUES ('540200', '地质工程与技术类 ', null);
INSERT INTO `zytybmb` VALUES ('540201', '矿山地质 ', null);
INSERT INTO `zytybmb` VALUES ('540202', '工程地质勘查 ', null);
INSERT INTO `zytybmb` VALUES ('540203', '水文与工程地质 ', null);
INSERT INTO `zytybmb` VALUES ('540204', '钻探技术 ', null);
INSERT INTO `zytybmb` VALUES ('540205', '地球物理勘查技术 ', null);
INSERT INTO `zytybmb` VALUES ('540206', '地球物理测井技术 ', null);
INSERT INTO `zytybmb` VALUES ('540207', '地球化学勘查技术 ', null);
INSERT INTO `zytybmb` VALUES ('540300', '矿业工程类', null);
INSERT INTO `zytybmb` VALUES ('54030001', '工程类', null);
INSERT INTO `zytybmb` VALUES ('540301', '煤矿开采技术 ', null);
INSERT INTO `zytybmb` VALUES ('54030101', '地矿', null);
INSERT INTO `zytybmb` VALUES ('54030102', '地矿类', null);
INSERT INTO `zytybmb` VALUES ('540302', '金属矿开采技术 ', null);
INSERT INTO `zytybmb` VALUES ('540303', '非金属矿开采技术 ', null);
INSERT INTO `zytybmb` VALUES ('540304', '固体矿床露天开采技术 ', null);
INSERT INTO `zytybmb` VALUES ('540305', '沙矿床开采技术 ', null);
INSERT INTO `zytybmb` VALUES ('540306', '矿井建设 ', null);
INSERT INTO `zytybmb` VALUES ('540307', '矿山机电 ', null);
INSERT INTO `zytybmb` VALUES ('540308', '矿井通风与安全 ', null);
INSERT INTO `zytybmb` VALUES ('540309', '矿井运输与提升 ', null);
INSERT INTO `zytybmb` VALUES ('540400', '石油与天然气类', null);
INSERT INTO `zytybmb` VALUES ('540401', '钻井技术 ', null);
INSERT INTO `zytybmb` VALUES ('540402', '油气开采技术 ', null);
INSERT INTO `zytybmb` VALUES ('540403', '油气储运技术 ', null);
INSERT INTO `zytybmb` VALUES ('54040301', '油料储运工程', null);
INSERT INTO `zytybmb` VALUES ('540404', '油气藏分析技术 ', null);
INSERT INTO `zytybmb` VALUES ('540405', '油田化学应用技术 ', null);
INSERT INTO `zytybmb` VALUES ('540406', '石油与天然气地质勘探技术 ', null);
INSERT INTO `zytybmb` VALUES ('540500', '矿物加工类', null);
INSERT INTO `zytybmb` VALUES ('540501', '矿物加工技术 ', null);
INSERT INTO `zytybmb` VALUES ('540502', '选矿技术 ', null);
INSERT INTO `zytybmb` VALUES ('540503', '选煤技术 ', null);
INSERT INTO `zytybmb` VALUES ('540504', '煤炭深加工与利用 ', null);
INSERT INTO `zytybmb` VALUES ('54050401', '煤及煤层气工程', null);
INSERT INTO `zytybmb` VALUES ('540505', '煤质分析技术 ', null);
INSERT INTO `zytybmb` VALUES ('540506', '选矿机电技术 ', null);
INSERT INTO `zytybmb` VALUES ('540600', '测绘类', null);
INSERT INTO `zytybmb` VALUES ('540601', '工程测量技术 ', null);
INSERT INTO `zytybmb` VALUES ('54060101', '测量工程', null);
INSERT INTO `zytybmb` VALUES ('540602', '工程测量与监理 ', null);
INSERT INTO `zytybmb` VALUES ('540603', '摄影测量与遥感技术 ', null);
INSERT INTO `zytybmb` VALUES ('54060301', '感应科学与技术', null);
INSERT INTO `zytybmb` VALUES ('540604', '大地测量与卫星定位技术 ', null);
INSERT INTO `zytybmb` VALUES ('540605', '地理信息系统与地图制图技术 ', null);
INSERT INTO `zytybmb` VALUES ('540606', '地籍测绘与土地管理信息技术 ', null);
INSERT INTO `zytybmb` VALUES ('54060601', '测绘与地理信息技术', null);
INSERT INTO `zytybmb` VALUES ('540607', '矿山测量', null);
INSERT INTO `zytybmb` VALUES ('550000', '材料与能源大类', null);
INSERT INTO `zytybmb` VALUES ('550100', '材料类', null);
INSERT INTO `zytybmb` VALUES ('55010001', '材料类(宝石及材料工艺学(珠宝鉴定与营销))(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('55010002', '材料类(材料成型及控制工程、材料科学与工程、高分子材料与工程、焊接技术与工程)', null);
INSERT INTO `zytybmb` VALUES ('55010003', '材料类(材料科学与工程、包装工程)', null);
INSERT INTO `zytybmb` VALUES ('55010004', '材料类(创新班)(含金属材料工程、高分子材料与工程专业)', null);
INSERT INTO `zytybmb` VALUES ('55010005', '材料类(含材料化学、金属材料工程、高分子材料与工程、材料科学与工', null);
INSERT INTO `zytybmb` VALUES ('55010006', '材料类(含金属材料工程、高分子材料与工程)(创新班)', null);
INSERT INTO `zytybmb` VALUES ('55010007', '材料类(茅以升学院)', null);
INSERT INTO `zytybmb` VALUES ('55010008', '材料类(中外)', null);
INSERT INTO `zytybmb` VALUES ('55010009', '材料类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('55010010', '材料类创新班(本硕、本博连读)', null);
INSERT INTO `zytybmb` VALUES ('55010011', '材料物理科', null);
INSERT INTO `zytybmb` VALUES ('55010012', '材料物理专业(金属材料方向)', null);
INSERT INTO `zytybmb` VALUES ('55010013', '材料学', null);
INSERT INTO `zytybmb` VALUES ('550101', '金属材料与热处理技术 ', null);
INSERT INTO `zytybmb` VALUES ('550102', '冶金技术 ', null);
INSERT INTO `zytybmb` VALUES ('55010201', '冶金技术(高端金属材料)', null);
INSERT INTO `zytybmb` VALUES ('550103', '高分子材料应用技术 ', null);
INSERT INTO `zytybmb` VALUES ('550104', '复合材料加工与应用技术 ', null);
INSERT INTO `zytybmb` VALUES ('550105', '材料工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('550106', '建筑装饰材料及检测', null);
INSERT INTO `zytybmb` VALUES ('55010601', '土木工程检测技术', null);
INSERT INTO `zytybmb` VALUES ('55010602', '道桥工程检测技术', null);
INSERT INTO `zytybmb` VALUES ('550200', '能源类', null);
INSERT INTO `zytybmb` VALUES ('550201', '热能动力设备与应用 ', null);
INSERT INTO `zytybmb` VALUES ('55020101', '热能动力设备及应用', null);
INSERT INTO `zytybmb` VALUES ('55020104', '新能源应用技术', null);
INSERT INTO `zytybmb` VALUES ('550202', '城市热能应用技术 ', null);
INSERT INTO `zytybmb` VALUES ('550203', '农村能源与环境技术 ', null);
INSERT INTO `zytybmb` VALUES ('550204', '制冷与冷藏技术 ', null);
INSERT INTO `zytybmb` VALUES ('550300', '电力技术类 ', null);
INSERT INTO `zytybmb` VALUES ('550301', '发电厂及电力系统 ', null);
INSERT INTO `zytybmb` VALUES ('55030101', '光伏发电技术及应用', null);
INSERT INTO `zytybmb` VALUES ('550302', '电厂设备运行与维护 ', null);
INSERT INTO `zytybmb` VALUES ('55030201', '电厂集控运行', null);
INSERT INTO `zytybmb` VALUES ('550303', '电厂热能动力装置 ', null);
INSERT INTO `zytybmb` VALUES ('55030301', '电厂热工仪表与化学分析', null);
INSERT INTO `zytybmb` VALUES ('55030302', '电厂热能与动力工程', null);
INSERT INTO `zytybmb` VALUES ('55030303', '电力工程与管理', null);
INSERT INTO `zytybmb` VALUES ('550304', '火电厂集控运行 ', null);
INSERT INTO `zytybmb` VALUES ('55030401', '火力指挥与控制工程', null);
INSERT INTO `zytybmb` VALUES ('550305', '小型水电站及电力网 ', null);
INSERT INTO `zytybmb` VALUES ('550306', '供用电技术 ', null);
INSERT INTO `zytybmb` VALUES ('550307', '电网监控技术 ', null);
INSERT INTO `zytybmb` VALUES ('550308', '电力系统继电保护与自动化 ', null);
INSERT INTO `zytybmb` VALUES ('550309', '高压输配电线路施工运行与维护 ', null);
INSERT INTO `zytybmb` VALUES ('550310', '农村电气化技术 ', null);
INSERT INTO `zytybmb` VALUES ('550311', '电厂化学', null);
INSERT INTO `zytybmb` VALUES ('560000', '土建大类', null);
INSERT INTO `zytybmb` VALUES ('56000001', '土建', null);
INSERT INTO `zytybmb` VALUES ('56000002', '土建类', null);
INSERT INTO `zytybmb` VALUES ('56000003', '土建类(土木工程)', null);
INSERT INTO `zytybmb` VALUES ('56000004', '土建类(中外)', null);
INSERT INTO `zytybmb` VALUES ('56000005', '土建类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('560100', '建筑设计类 ', null);
INSERT INTO `zytybmb` VALUES ('560101', '建筑设计技术 ', null);
INSERT INTO `zytybmb` VALUES ('56010101', '建筑工程技术(专本贯通)', null);
INSERT INTO `zytybmb` VALUES ('56010102', '建筑动画设计与制作', null);
INSERT INTO `zytybmb` VALUES ('56010104', '景观建筑设计', null);
INSERT INTO `zytybmb` VALUES ('560102', '建筑装饰工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('560103', '中国古建筑工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('560104', '室内设计技术 ', null);
INSERT INTO `zytybmb` VALUES ('560105', '环境艺术设计 ', null);
INSERT INTO `zytybmb` VALUES ('56010501', '环境艺术', null);
INSERT INTO `zytybmb` VALUES ('56010502', '环境艺术设计(含室内设计、建筑景观设计方向)', null);
INSERT INTO `zytybmb` VALUES ('56010503', '环境艺术设计(美术类)', null);
INSERT INTO `zytybmb` VALUES ('56010504', '环境艺术设计(施工管理)', null);
INSERT INTO `zytybmb` VALUES ('56010505', '环境艺术设计(室内设计)', null);
INSERT INTO `zytybmb` VALUES ('56010506', '环境艺术设计(室内设计、建筑景观设计)', null);
INSERT INTO `zytybmb` VALUES ('56010507', '环境艺术设计(艺术类)', null);
INSERT INTO `zytybmb` VALUES ('56010508', '环境艺术设计(园林景观设计)', null);
INSERT INTO `zytybmb` VALUES ('560106', '园林工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('560200', '城镇规划与管理类', null);
INSERT INTO `zytybmb` VALUES ('560201', '城镇规划 ', null);
INSERT INTO `zytybmb` VALUES ('56020101', '城镇建设', null);
INSERT INTO `zytybmb` VALUES ('560202', '城市管理与监察 ', null);
INSERT INTO `zytybmb` VALUES ('560300', '土建施工类', null);
INSERT INTO `zytybmb` VALUES ('56030001', '土建施工类(建筑工程技术)', null);
INSERT INTO `zytybmb` VALUES ('560301', '建筑工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('560302', '地下工程与隧道工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('560303', '基础工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('560400', '建筑设备类', null);
INSERT INTO `zytybmb` VALUES ('560401', '建筑设备工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('56040101', '建筑钢结构工程技术', null);
INSERT INTO `zytybmb` VALUES ('56040102', '建筑设备工程技术(暖通空调方向)', null);
INSERT INTO `zytybmb` VALUES ('56040103', '建筑设备与环境工程', null);
INSERT INTO `zytybmb` VALUES ('56040104', '建筑设施智能技术', null);
INSERT INTO `zytybmb` VALUES ('56040105', '建筑新能源工程技术', null);
INSERT INTO `zytybmb` VALUES ('56040111', '建筑设备工程技术(建筑水电工程)', null);
INSERT INTO `zytybmb` VALUES ('560402', '供热通风与空调工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('560403', '建筑电气工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('560404', '楼宇智能化工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('56040801', '电气设备应用与维护', null);
INSERT INTO `zytybmb` VALUES ('56040802', '电气技术教育', null);
INSERT INTO `zytybmb` VALUES ('560500', '工程管理类', null);
INSERT INTO `zytybmb` VALUES ('560501', '建筑工程管理 ', null);
INSERT INTO `zytybmb` VALUES ('56050101', '建筑工程管理(施工项目经理)', null);
INSERT INTO `zytybmb` VALUES ('56050102', '建筑工程项目管理', null);
INSERT INTO `zytybmb` VALUES ('56050103', '建筑工程质量与安全技术管理', null);
INSERT INTO `zytybmb` VALUES ('560502', '工程造价 ', null);
INSERT INTO `zytybmb` VALUES ('56050201', '工程造价(注册造价师)', null);
INSERT INTO `zytybmb` VALUES ('560503', '建筑经济管理 ', null);
INSERT INTO `zytybmb` VALUES ('560504', '工程监理 ', null);
INSERT INTO `zytybmb` VALUES ('560600', '市政工程类', null);
INSERT INTO `zytybmb` VALUES ('560601', '市政工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('56060101', '空间工程', null);
INSERT INTO `zytybmb` VALUES ('560602', '城市燃气工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('560603', '给排水工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('560604', '水工业技术 ', null);
INSERT INTO `zytybmb` VALUES ('560605', '消防工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('560700', '房地产类', null);
INSERT INTO `zytybmb` VALUES ('560701', '房地产经营与估价 ', null);
INSERT INTO `zytybmb` VALUES ('56070101', '房地产经营管理', null);
INSERT INTO `zytybmb` VALUES ('56070102', '房地产经营与估计', null);
INSERT INTO `zytybmb` VALUES ('56070103', '房地产经营与估价(开发项目经理)', null);
INSERT INTO `zytybmb` VALUES ('56070104', '房地产经营与股价', null);
INSERT INTO `zytybmb` VALUES ('560702', '物业管理 ', null);
INSERT INTO `zytybmb` VALUES ('560703', '物业设施管理', null);
INSERT INTO `zytybmb` VALUES ('570000', '水利大类', null);
INSERT INTO `zytybmb` VALUES ('570100', '水文与水资源类', null);
INSERT INTO `zytybmb` VALUES ('570101', '水文与水资源 ', null);
INSERT INTO `zytybmb` VALUES ('57010101', '冰文与水资源工程', null);
INSERT INTO `zytybmb` VALUES ('570102', '水文自动化测报技术 ', null);
INSERT INTO `zytybmb` VALUES ('570103', '水信息技术 ', null);
INSERT INTO `zytybmb` VALUES ('570104', '水政水资源管理 ', null);
INSERT INTO `zytybmb` VALUES ('570200', '水利工程与管理类', null);
INSERT INTO `zytybmb` VALUES ('570201', '水利工程 ', null);
INSERT INTO `zytybmb` VALUES ('570202', '水利工程施工技术 ', null);
INSERT INTO `zytybmb` VALUES ('570203', '水利水电建筑工程 ', null);
INSERT INTO `zytybmb` VALUES ('570204', '灌溉与排水技术 ', null);
INSERT INTO `zytybmb` VALUES ('570205', '港口航道与治河工程 ', null);
INSERT INTO `zytybmb` VALUES ('570206', '河务工程与管理 ', null);
INSERT INTO `zytybmb` VALUES ('570207', '城市水利 ', null);
INSERT INTO `zytybmb` VALUES ('570208', '水利水电工程管理 ', null);
INSERT INTO `zytybmb` VALUES ('570209', '水务管理 ', null);
INSERT INTO `zytybmb` VALUES ('570210', '水利工程监理 ', null);
INSERT INTO `zytybmb` VALUES ('570300', '水利水电设备类 ', null);
INSERT INTO `zytybmb` VALUES ('570301', '水电站动力设备与管理 ', null);
INSERT INTO `zytybmb` VALUES ('57030101', '水利水电建筑工程(施工方向)', null);
INSERT INTO `zytybmb` VALUES ('570302', '机电设备运行与维护 ', null);
INSERT INTO `zytybmb` VALUES ('570303', '机电排灌设备与管理 ', null);
INSERT INTO `zytybmb` VALUES ('570400', '水土保持与水环境类', null);
INSERT INTO `zytybmb` VALUES ('570401', '水土保持 ', null);
INSERT INTO `zytybmb` VALUES ('570402', '水环境监测与分析', null);
INSERT INTO `zytybmb` VALUES ('580000', '制造大类', null);
INSERT INTO `zytybmb` VALUES ('580100', '机械设计制造类', null);
INSERT INTO `zytybmb` VALUES ('580101', '机械设计与制造 ', null);
INSERT INTO `zytybmb` VALUES ('58010101', '机械工程及自动化', null);
INSERT INTO `zytybmb` VALUES ('58010102', '机械设计与制造(CAD/CAM)', null);
INSERT INTO `zytybmb` VALUES ('58010103', '机械设计与制造(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('58010104', '制造自动化与测控技术', null);
INSERT INTO `zytybmb` VALUES ('58010105', '制造工程', null);
INSERT INTO `zytybmb` VALUES ('58010122', '机械', null);
INSERT INTO `zytybmb` VALUES ('580102', '机械制造与自动化 ', null);
INSERT INTO `zytybmb` VALUES ('58010201', '机械制造工艺及设备', null);
INSERT INTO `zytybmb` VALUES ('580103', '数控技术 ', null);
INSERT INTO `zytybmb` VALUES ('58010301', '数控技术(数控加工与工艺编程)', null);
INSERT INTO `zytybmb` VALUES ('58010302', '数控技术(数控设备应用与维修)', null);
INSERT INTO `zytybmb` VALUES ('580104', '电机与电器 ', null);
INSERT INTO `zytybmb` VALUES ('58010401', '电器信息', null);
INSERT INTO `zytybmb` VALUES ('58010402', '低压电器制造及应用', null);
INSERT INTO `zytybmb` VALUES ('58010403', '电机电器智能化', null);
INSERT INTO `zytybmb` VALUES ('580105', '玩具设计与制造 ', null);
INSERT INTO `zytybmb` VALUES ('580106', '模具设计与制造 ', null);
INSERT INTO `zytybmb` VALUES ('58010601', '模具设计与制造(3D造型与快速制造)', null);
INSERT INTO `zytybmb` VALUES ('58010602', '模具设计与制造(普高生、3＋技能证书)', null);
INSERT INTO `zytybmb` VALUES ('580107', '材料成型与控制技术 ', null);
INSERT INTO `zytybmb` VALUES ('58010701', '材料成型及控制工程', null);
INSERT INTO `zytybmb` VALUES ('580108', '焊接技术及自动化 ', null);
INSERT INTO `zytybmb` VALUES ('58010801', '焊接技术与自动化', null);
INSERT INTO `zytybmb` VALUES ('580109', '工业设计 ', null);
INSERT INTO `zytybmb` VALUES ('580110', '计算机辅助设计与制造 ', null);
INSERT INTO `zytybmb` VALUES ('58011001', '计算机辅助设计与制造(家电产品设计)', null);
INSERT INTO `zytybmb` VALUES ('58011002', '计算机辅助设计与制造(中德合作)', null);
INSERT INTO `zytybmb` VALUES ('580111', '精密机械技术 ', null);
INSERT INTO `zytybmb` VALUES ('580112', '医疗器械制造与维护 ', null);
INSERT INTO `zytybmb` VALUES ('58011201', '医疗器械工程', null);
INSERT INTO `zytybmb` VALUES ('580200', '自动化类', null);
INSERT INTO `zytybmb` VALUES ('58020001', '自动化类(中外合作办学)(中澳合作)', null);
INSERT INTO `zytybmb` VALUES ('580201', '机电一体化技术 ', null);
INSERT INTO `zytybmb` VALUES ('58020101', '机电设备与维修管理', null);
INSERT INTO `zytybmb` VALUES ('58020102', '指挥自动化工程', null);
INSERT INTO `zytybmb` VALUES ('580202', '电气自动化技术 ', null);
INSERT INTO `zytybmb` VALUES ('58020201', '机电一体化', null);
INSERT INTO `zytybmb` VALUES ('58020202', '电气自动化技术(本专衔接)', null);
INSERT INTO `zytybmb` VALUES ('58020203', '电气自动化技术(衔接济南大学)', null);
INSERT INTO `zytybmb` VALUES ('58020204', '电气自动化', null);
INSERT INTO `zytybmb` VALUES ('58020206', '电气信息', null);
INSERT INTO `zytybmb` VALUES ('580203', '生产过程自动化技术 ', null);
INSERT INTO `zytybmb` VALUES ('58020301', '机电一体化技术(机电设备维护与管理)', null);
INSERT INTO `zytybmb` VALUES ('580204', '电力系统自动化技术 ', null);
INSERT INTO `zytybmb` VALUES ('58020401', '机电一体化技术(中德合作)', null);
INSERT INTO `zytybmb` VALUES ('58020402', '电力工程', null);
INSERT INTO `zytybmb` VALUES ('58020403', '电力工程及其自动化', null);
INSERT INTO `zytybmb` VALUES ('580205', '计算机控制技术 ', null);
INSERT INTO `zytybmb` VALUES ('58020501', '计算机控制技术(嵌入式系统设计方向)', null);
INSERT INTO `zytybmb` VALUES ('58020502', '计算机控制技术(智能电子产品设计方向)', null);
INSERT INTO `zytybmb` VALUES ('58020503', '计算机控制技术(智能电子产品设计与制作方', null);
INSERT INTO `zytybmb` VALUES ('58020505', '机电一体化技术(自动机与自动线)', null);
INSERT INTO `zytybmb` VALUES ('580206', '工业网络技术 ', null);
INSERT INTO `zytybmb` VALUES ('58020601', '机电一体机技术', null);
INSERT INTO `zytybmb` VALUES ('580207', '检测技术及应用 ', null);
INSERT INTO `zytybmb` VALUES ('580208', '理化测试及质检技术 ', null);
INSERT INTO `zytybmb` VALUES ('580209', '液压与气动技术 ', null);
INSERT INTO `zytybmb` VALUES ('580300', '机电设备类', null);
INSERT INTO `zytybmb` VALUES ('580301', '机电设备维修与管理 ', null);
INSERT INTO `zytybmb` VALUES ('580302', '数控设备应用与维护 ', null);
INSERT INTO `zytybmb` VALUES ('580303', '自动化生产设备应用 ', null);
INSERT INTO `zytybmb` VALUES ('580304', '医用电子仪器与维护 ', null);
INSERT INTO `zytybmb` VALUES ('580305', '医学影像设备管理与维护 ', null);
INSERT INTO `zytybmb` VALUES ('580400', '汽车类 ', null);
INSERT INTO `zytybmb` VALUES ('58040001', '汽车类(中外合作办学)(中韩合作)', null);
INSERT INTO `zytybmb` VALUES ('580401', '汽车制造与装配技术 ', null);
INSERT INTO `zytybmb` VALUES ('580402', '汽车检测与维修技术 ', null);
INSERT INTO `zytybmb` VALUES ('58040201', '汽车检测与维修', null);
INSERT INTO `zytybmb` VALUES ('58040202', '汽车检测与维修技术(含汽车电子技术、汽车售前服务技术)', null);
INSERT INTO `zytybmb` VALUES ('58040203', '汽车检测与维修技术(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('580403', '汽车电子技术 ', null);
INSERT INTO `zytybmb` VALUES ('580404', '汽车改装技术 ', null);
INSERT INTO `zytybmb` VALUES ('580405', '汽车技术服务与营销 ', null);
INSERT INTO `zytybmb` VALUES ('580406', '汽车整形技术', null);
INSERT INTO `zytybmb` VALUES ('58040601', '汽车整形技术(美容与装潢方向)', null);
INSERT INTO `zytybmb` VALUES ('590000', '电子信息大类', null);
INSERT INTO `zytybmb` VALUES ('590100', '计算机类', null);
INSERT INTO `zytybmb` VALUES ('590101', '计算机应用技术 ', null);
INSERT INTO `zytybmb` VALUES ('59010101', '计算机教育', null);
INSERT INTO `zytybmb` VALUES ('59010102', '嵌入式系统工程', null);
INSERT INTO `zytybmb` VALUES ('59010103', '仿真工程', null);
INSERT INTO `zytybmb` VALUES ('59010104', '物联网应用技术', null);
INSERT INTO `zytybmb` VALUES ('59010105', '计算机应用技术(嵌入式应用技术)', null);
INSERT INTO `zytybmb` VALUES ('59010106', '计算机应用技术(软件应用方向)', null);
INSERT INTO `zytybmb` VALUES ('59010107', '计算机应用技术(手机)', null);
INSERT INTO `zytybmb` VALUES ('59010108', '计算机应用技术(信息管理方向)', null);
INSERT INTO `zytybmb` VALUES ('59010109', '计算机应用技术(学制两年)', null);
INSERT INTO `zytybmb` VALUES ('59010110', '计算机应用技术(医药卫生方向)(学制2年)', null);
INSERT INTO `zytybmb` VALUES ('59010112', '数据库管理与开发(计算机信息管理)', null);
INSERT INTO `zytybmb` VALUES ('59010113', '数据库管理与开发(计算机信息管理方向)', null);
INSERT INTO `zytybmb` VALUES ('59010114', '网站规划与开发技术', null);
INSERT INTO `zytybmb` VALUES ('59010115', '网站规划与开发技术(互联网应用开发)', null);
INSERT INTO `zytybmb` VALUES ('59010116', '网站规划与开发技术(互联网应用开发方向)', null);
INSERT INTO `zytybmb` VALUES ('59010121', '计算机应用(室内设计方向)', null);
INSERT INTO `zytybmb` VALUES ('59010122', '计算机应用技术(电脑艺术设计方向)', null);
INSERT INTO `zytybmb` VALUES ('59010123', '计算机应用技术(含软件工程师)', null);
INSERT INTO `zytybmb` VALUES ('59010124', '计算机应用技术(广告设计方向)', null);
INSERT INTO `zytybmb` VALUES ('590102', '计算机网络技术 ', null);
INSERT INTO `zytybmb` VALUES ('59010201', '计算机网络技术(电子商务方向)', null);
INSERT INTO `zytybmb` VALUES ('59010202', '计算机网络技术(含智能手机应用开发)', null);
INSERT INTO `zytybmb` VALUES ('59010203', '计算机网络技术(网络工程管理方向)', null);
INSERT INTO `zytybmb` VALUES ('59010204', '计算机网络技术(物联网技术)', null);
INSERT INTO `zytybmb` VALUES ('59010205', '计算机网络技术(学制两年)', null);
INSERT INTO `zytybmb` VALUES ('59010206', '计算机网络技术(医药卫生方向)(学制2年)', null);
INSERT INTO `zytybmb` VALUES ('59010207', '计算机网络与安全管理', null);
INSERT INTO `zytybmb` VALUES ('590103', '计算机多媒体技术 ', null);
INSERT INTO `zytybmb` VALUES ('59010301', '计算机多媒体技术(动漫)', null);
INSERT INTO `zytybmb` VALUES ('59010302', '计算机多媒体技术(网络与影视技术、新媒体艺术)', null);
INSERT INTO `zytybmb` VALUES ('59010303', '计算机多媒体技术(新媒体艺术方向)', null);
INSERT INTO `zytybmb` VALUES ('590104', '计算机系统维护 ', null);
INSERT INTO `zytybmb` VALUES ('590105', '计算机硬件与外设 ', null);
INSERT INTO `zytybmb` VALUES ('590106', '计算机信息管理 ', null);
INSERT INTO `zytybmb` VALUES ('59010601', '计算机信息管理(城市轨道交通信息管理)', null);
INSERT INTO `zytybmb` VALUES ('59010602', '计算机信息管理(医药卫生方向)(学制2年)', null);
INSERT INTO `zytybmb` VALUES ('590107', '网络系统管理 ', null);
INSERT INTO `zytybmb` VALUES ('590108', '软件技术 ', null);
INSERT INTO `zytybmb` VALUES ('59010801', '软件技术        (软件开发方向)', null);
INSERT INTO `zytybmb` VALUES ('59010802', '软件技术(嵌入式培养)', null);
INSERT INTO `zytybmb` VALUES ('59010803', '软件技术(软件开发)', null);
INSERT INTO `zytybmb` VALUES ('59010804', '软件技术(软件开发方向)', null);
INSERT INTO `zytybmb` VALUES ('59010805', '软件技术(网站开发方向)', null);
INSERT INTO `zytybmb` VALUES ('59010806', '软件技术(网站设计方向)', null);
INSERT INTO `zytybmb` VALUES ('59010807', '软件技术(学制两年)', null);
INSERT INTO `zytybmb` VALUES ('59010808', '软件技术(医药卫生方向)(学制2年)', null);
INSERT INTO `zytybmb` VALUES ('59010809', '软件技术(移动应用软件开发)', null);
INSERT INTO `zytybmb` VALUES ('59010810', '软件技术(游戏软件开发)', null);
INSERT INTO `zytybmb` VALUES ('59010811', '软件技术(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('59010812', '软件开发与项目管理', null);
INSERT INTO `zytybmb` VALUES ('59010813', '软件外包服务', null);
INSERT INTO `zytybmb` VALUES ('59010814', '软件外包服务(校企合作)', null);
INSERT INTO `zytybmb` VALUES ('59010815', '计算机软件', null);
INSERT INTO `zytybmb` VALUES ('59010816', '软件测试技术', null);
INSERT INTO `zytybmb` VALUES ('59010817', '软件测试技术(自动化测试技术方向)', null);
INSERT INTO `zytybmb` VALUES ('590109', '图形图像制作 ', null);
INSERT INTO `zytybmb` VALUES ('59010901', '图形图像制作(医药卫生方向)(学制2年)', null);
INSERT INTO `zytybmb` VALUES ('590110', '动漫设计与制作 ', null);
INSERT INTO `zytybmb` VALUES ('59011001', '动漫设计与制作(美术类)', null);
INSERT INTO `zytybmb` VALUES ('59011002', '动漫设计与制作(学制两年)', null);
INSERT INTO `zytybmb` VALUES ('59011003', '动漫设计与制作(艺术类)', null);
INSERT INTO `zytybmb` VALUES ('59011004', '动漫设计与制作(中韩)', null);
INSERT INTO `zytybmb` VALUES ('590200', '电子信息类', null);
INSERT INTO `zytybmb` VALUES ('590201', '电子信息工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('59020101', '电子信息工程技术(中韩)', null);
INSERT INTO `zytybmb` VALUES ('59020102', '电子工程', null);
INSERT INTO `zytybmb` VALUES ('590202', '应用电子技术 ', null);
INSERT INTO `zytybmb` VALUES ('59020201', '光电子技术', null);
INSERT INTO `zytybmb` VALUES ('59020202', '应用电子技术(电子电器产品质量管理方向)', null);
INSERT INTO `zytybmb` VALUES ('59020203', '应用电子技术(电子电器产品质量检测方向)', null);
INSERT INTO `zytybmb` VALUES ('59020204', '应用电子技术(含移动通信技术)', null);
INSERT INTO `zytybmb` VALUES ('59020205', '应用电子技术(集成电路设计技术方向)', null);
INSERT INTO `zytybmb` VALUES ('59020208', '应用电子', null);
INSERT INTO `zytybmb` VALUES ('590203', '电子测量技术与仪器 ', null);
INSERT INTO `zytybmb` VALUES ('590204', '电子仪器仪表与维修 ', null);
INSERT INTO `zytybmb` VALUES ('590205', '电子设备与运行管理 ', null);
INSERT INTO `zytybmb` VALUES ('590206', '电子声像技术 ', null);
INSERT INTO `zytybmb` VALUES ('590207', '电子工艺与管理 ', null);
INSERT INTO `zytybmb` VALUES ('590208', '信息安全技术 ', null);
INSERT INTO `zytybmb` VALUES ('590209', '图文信息技术 ', null);
INSERT INTO `zytybmb` VALUES ('590210', '微电子技术 ', null);
INSERT INTO `zytybmb` VALUES ('590211', '无线电技术 ', null);
INSERT INTO `zytybmb` VALUES ('590212', '广播电视网络技术 ', null);
INSERT INTO `zytybmb` VALUES ('590213', '有线电视工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('590300', '通信类', null);
INSERT INTO `zytybmb` VALUES ('59030001', '通信类1(移动)', null);
INSERT INTO `zytybmb` VALUES ('59030002', '通信类2(设备)', null);
INSERT INTO `zytybmb` VALUES ('590301', '通信技术 ', null);
INSERT INTO `zytybmb` VALUES ('59030101', '通信工程设计与施工', null);
INSERT INTO `zytybmb` VALUES ('590302', '移动通信技术 ', null);
INSERT INTO `zytybmb` VALUES ('59030201', '移动通信运营与服务', null);
INSERT INTO `zytybmb` VALUES ('59030202', '传感网技术', null);
INSERT INTO `zytybmb` VALUES ('590303', '计算机通信 ', null);
INSERT INTO `zytybmb` VALUES ('590304', '程控交换技术 ', null);
INSERT INTO `zytybmb` VALUES ('590305', '通信网络与设备 ', null);
INSERT INTO `zytybmb` VALUES ('590306', '通信系统运行管理', null);
INSERT INTO `zytybmb` VALUES ('600000', '环保、气象与安全大类', null);
INSERT INTO `zytybmb` VALUES ('600100', '环保类', null);
INSERT INTO `zytybmb` VALUES ('600101', '环境监测与治理技术 ', null);
INSERT INTO `zytybmb` VALUES ('60010101', '环境监测', null);
INSERT INTO `zytybmb` VALUES ('60010102', '环境监测与治理技术(工业分析方向)', null);
INSERT INTO `zytybmb` VALUES ('60010103', '环境监测与治理技术(环境保护)', null);
INSERT INTO `zytybmb` VALUES ('60010104', '环境监测与治理技术(环境工程)', null);
INSERT INTO `zytybmb` VALUES ('60010105', '环境监察', null);
INSERT INTO `zytybmb` VALUES ('600102', '环境监测与评价 ', null);
INSERT INTO `zytybmb` VALUES ('60010201', '环境工程技术', null);
INSERT INTO `zytybmb` VALUES ('600103', '农业环境保护技术 ', null);
INSERT INTO `zytybmb` VALUES ('600104', '资源环境与城市管理 ', null);
INSERT INTO `zytybmb` VALUES ('60010401', '资源管理与城乡规划', null);
INSERT INTO `zytybmb` VALUES ('60010402', '资源管理与城乡规划管理', null);
INSERT INTO `zytybmb` VALUES ('60010403', '资源环保与城乡规划管理', null);
INSERT INTO `zytybmb` VALUES ('60010404', '资源环境城乡规划管理与', null);
INSERT INTO `zytybmb` VALUES ('60010405', '资源环境与城市规划管理', null);
INSERT INTO `zytybmb` VALUES ('60010406', '资源环境与城市乡划管理', null);
INSERT INTO `zytybmb` VALUES ('60010407', '资源环境与城乡管理', null);
INSERT INTO `zytybmb` VALUES ('60010408', '资源环境与城乡规划管理', null);
INSERT INTO `zytybmb` VALUES ('60010409', '资源环境与城乡规化管理', null);
INSERT INTO `zytybmb` VALUES ('600105', '城市检测与工程技术 ', null);
INSERT INTO `zytybmb` VALUES ('600106', '水环境监测与保护 ', null);
INSERT INTO `zytybmb` VALUES ('600107', '城市水净化技术 ', null);
INSERT INTO `zytybmb` VALUES ('600108', '室内检测与控制技术 ', null);
INSERT INTO `zytybmb` VALUES ('600200', '气象类', null);
INSERT INTO `zytybmb` VALUES ('600201', '大气科学技术 ', null);
INSERT INTO `zytybmb` VALUES ('600202', '大气探测技术 ', null);
INSERT INTO `zytybmb` VALUES ('600203', '应用气象技术 ', null);
INSERT INTO `zytybmb` VALUES ('600204', '防雷技术 ', null);
INSERT INTO `zytybmb` VALUES ('600300', '安全类 ', null);
INSERT INTO `zytybmb` VALUES ('600301', '工业环保与安全技术 ', null);
INSERT INTO `zytybmb` VALUES ('60030101', '安全技术', null);
INSERT INTO `zytybmb` VALUES ('600302', '救援技术 ', null);
INSERT INTO `zytybmb` VALUES ('600303', '安全技术管理', null);
INSERT INTO `zytybmb` VALUES ('610000', '轻纺食品大类', null);
INSERT INTO `zytybmb` VALUES ('610100', '轻化工类', null);
INSERT INTO `zytybmb` VALUES ('610101', '染整技术 ', null);
INSERT INTO `zytybmb` VALUES ('610102', '高分子材料加工技术 ', null);
INSERT INTO `zytybmb` VALUES ('610103', '制浆造纸技术 ', null);
INSERT INTO `zytybmb` VALUES ('610104', '香料香精工艺 ', null);
INSERT INTO `zytybmb` VALUES ('610105', '表面精饰工艺 ', null);
INSERT INTO `zytybmb` VALUES ('610200', '纺织服装类', null);
INSERT INTO `zytybmb` VALUES ('610201', '现代纺织技术 ', null);
INSERT INTO `zytybmb` VALUES ('610202', '针织技术与针织服装 ', null);
INSERT INTO `zytybmb` VALUES ('610203', '丝绸技术 ', null);
INSERT INTO `zytybmb` VALUES ('610204', '服装设计 ', null);
INSERT INTO `zytybmb` VALUES ('61020401', '鞋类设计与工艺', null);
INSERT INTO `zytybmb` VALUES ('61020402', '服装工艺技术', null);
INSERT INTO `zytybmb` VALUES ('61020403', '服装制版与工艺', null);
INSERT INTO `zytybmb` VALUES ('610205', '染织艺术设计 ', null);
INSERT INTO `zytybmb` VALUES ('610206', '纺织品装饰艺术设计 ', null);
INSERT INTO `zytybmb` VALUES ('61020601', '纺织品设计', null);
INSERT INTO `zytybmb` VALUES ('610207', '新型纺织机电技术 ', null);
INSERT INTO `zytybmb` VALUES ('610208', '纺织品检验与贸易 ', null);
INSERT INTO `zytybmb` VALUES ('610300', '食品类', null);
INSERT INTO `zytybmb` VALUES ('61030001', '食品', null);
INSERT INTO `zytybmb` VALUES ('61030002', '食品检测及管理', null);
INSERT INTO `zytybmb` VALUES ('61030003', '食品经济管理', null);
INSERT INTO `zytybmb` VALUES ('610301', '食品加工技术 ', null);
INSERT INTO `zytybmb` VALUES ('61030101', '食品加工技术(本)', null);
INSERT INTO `zytybmb` VALUES ('61030102', '食品加工技术(专本贯通)', null);
INSERT INTO `zytybmb` VALUES ('610302', '食品营养与检测 ', null);
INSERT INTO `zytybmb` VALUES ('61030201', '食品营养与检测(中澳合作)', null);
INSERT INTO `zytybmb` VALUES ('610303', '食品贮运与营销 ', null);
INSERT INTO `zytybmb` VALUES ('610304', '食品机械与管理 ', null);
INSERT INTO `zytybmb` VALUES ('610305', '食品生物技术 ', null);
INSERT INTO `zytybmb` VALUES ('610306', '农畜特产品加工 ', null);
INSERT INTO `zytybmb` VALUES ('610307', '粮食工程 ', null);
INSERT INTO `zytybmb` VALUES ('610400', '包装印刷类', null);
INSERT INTO `zytybmb` VALUES ('610401', '包装技术与设计 ', null);
INSERT INTO `zytybmb` VALUES ('610402', '印刷技术 ', null);
INSERT INTO `zytybmb` VALUES ('610403', '印刷图文信息处理 ', null);
INSERT INTO `zytybmb` VALUES ('610404', '印刷设备及工艺 ', null);
INSERT INTO `zytybmb` VALUES ('610405', '出版与发行', null);
INSERT INTO `zytybmb` VALUES ('620000', '财经大类', null);
INSERT INTO `zytybmb` VALUES ('620100', '财政金融类', null);
INSERT INTO `zytybmb` VALUES ('620101', '财政 ', null);
INSERT INTO `zytybmb` VALUES ('620102', '税务 ', null);
INSERT INTO `zytybmb` VALUES ('62010201', '税务(税务会计方向)', null);
INSERT INTO `zytybmb` VALUES ('620103', '金融管理与实务 ', null);
INSERT INTO `zytybmb` VALUES ('62010301', '金融管理', null);
INSERT INTO `zytybmb` VALUES ('62010302', '金融管理实务', null);
INSERT INTO `zytybmb` VALUES ('620104', '国际金融 ', null);
INSERT INTO `zytybmb` VALUES ('620105', '金融与证券 ', null);
INSERT INTO `zytybmb` VALUES ('620106', '金融保险 ', null);
INSERT INTO `zytybmb` VALUES ('62010601', '保险', null);
INSERT INTO `zytybmb` VALUES ('620107', '保险实务 ', null);
INSERT INTO `zytybmb` VALUES ('62010701', '机动车保险实务', null);
INSERT INTO `zytybmb` VALUES ('620108', '医疗保险实务 ', null);
INSERT INTO `zytybmb` VALUES ('620109', '资产评估与管理 ', null);
INSERT INTO `zytybmb` VALUES ('620110', '证券投资与管理 ', null);
INSERT INTO `zytybmb` VALUES ('620111', '投资与理财 ', null);
INSERT INTO `zytybmb` VALUES ('62011101', '投资与理财(理财规划师)', null);
INSERT INTO `zytybmb` VALUES ('620112', '证券与期货 ', null);
INSERT INTO `zytybmb` VALUES ('620200', '财务会计类', null);
INSERT INTO `zytybmb` VALUES ('620201', '财务管理 ', null);
INSERT INTO `zytybmb` VALUES ('62020101', '财务管理(财务主管)', null);
INSERT INTO `zytybmb` VALUES ('62020102', '财务管理科(含理科财规划师)', null);
INSERT INTO `zytybmb` VALUES ('62020103', '财务管理科', null);
INSERT INTO `zytybmb` VALUES ('620202', '财务信息管理 ', null);
INSERT INTO `zytybmb` VALUES ('620203', '会计 ', null);
INSERT INTO `zytybmb` VALUES ('62020301', '会计学(五年制)', null);
INSERT INTO `zytybmb` VALUES ('62020302', '会计学(会计信息化方向)', null);
INSERT INTO `zytybmb` VALUES ('62020303', '会计学(财经类)', null);
INSERT INTO `zytybmb` VALUES ('62020304', '会计学(注册会计)', null);
INSERT INTO `zytybmb` VALUES ('62020305', '会计学(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('62020306', '会计学(文理兼招)', null);
INSERT INTO `zytybmb` VALUES ('62020307', '会计学(CIMA班)', null);
INSERT INTO `zytybmb` VALUES ('62020308', '会计学(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('62020309', '会计学(会计电算化方向)', null);
INSERT INTO `zytybmb` VALUES ('62020310', '会计学(税务方向)', null);
INSERT INTO `zytybmb` VALUES ('62020311', '会计学(注册会计师方向)', null);
INSERT INTO `zytybmb` VALUES ('62020312', '会计学(涉外会计方向)', null);
INSERT INTO `zytybmb` VALUES ('62020313', '会计学(中新合作)', null);
INSERT INTO `zytybmb` VALUES ('62020314', '会计(涉外)', null);
INSERT INTO `zytybmb` VALUES ('62020315', '会计学注册会计师方向', null);
INSERT INTO `zytybmb` VALUES ('62020316', '会计学(国防生)', null);
INSERT INTO `zytybmb` VALUES ('62020317', '会计学(含注册会计师、会计与税务)', null);
INSERT INTO `zytybmb` VALUES ('62020318', '会计(含注册会计师、涉外会计)', null);
INSERT INTO `zytybmb` VALUES ('62020319', '会计(注册会计师方向)', null);
INSERT INTO `zytybmb` VALUES ('62020320', '会计学(2+2中澳学分互认项目)', null);
INSERT INTO `zytybmb` VALUES ('62020321', '会计学(财务管理)', null);
INSERT INTO `zytybmb` VALUES ('62020322', '会计学(应用技术本科)', null);
INSERT INTO `zytybmb` VALUES ('62020323', '会计(注册会计师 )', null);
INSERT INTO `zytybmb` VALUES ('62020324', '会计学(ACCA)', null);
INSERT INTO `zytybmb` VALUES ('62020325', '会计学(CGA)', null);
INSERT INTO `zytybmb` VALUES ('62020326', '会计(海本)', null);
INSERT INTO `zytybmb` VALUES ('62020327', '会计电算化 文', null);
INSERT INTO `zytybmb` VALUES ('62020328', '会计学(ACA国际注册会计师方向)', null);
INSERT INTO `zytybmb` VALUES ('62020329', '会计学(国际会计)', null);
INSERT INTO `zytybmb` VALUES ('62020330', '会计学(国际会计、国际财务管理科)', null);
INSERT INTO `zytybmb` VALUES ('62020331', '会计电算化(南校区就读)', null);
INSERT INTO `zytybmb` VALUES ('62020332', '会计学财务会计', null);
INSERT INTO `zytybmb` VALUES ('62020333', '会计学注册会计师', null);
INSERT INTO `zytybmb` VALUES ('62020334', '会计学(含注册会计师)', null);
INSERT INTO `zytybmb` VALUES ('62020335', '会计学(本)', null);
INSERT INTO `zytybmb` VALUES ('62020336', '会计学含注册会计师、会计电算化、注册税', null);
INSERT INTO `zytybmb` VALUES ('62020337', '会计学国际会计学方向', null);
INSERT INTO `zytybmb` VALUES ('62020338', '会计学(国防生，男18女2，军检线，非指挥)', null);
INSERT INTO `zytybmb` VALUES ('62020339', '会计学(审计、财务会计、会计信息化、', null);
INSERT INTO `zytybmb` VALUES ('62020340', '会计学金融会计方向', null);
INSERT INTO `zytybmb` VALUES ('62020341', '会计(税务会计方向)', null);
INSERT INTO `zytybmb` VALUES ('62020342', '会计与审计(注册会计师)', null);
INSERT INTO `zytybmb` VALUES ('62020343', '财务会计类(会计)', null);
INSERT INTO `zytybmb` VALUES ('620204', '会计电算化 ', null);
INSERT INTO `zytybmb` VALUES ('620205', '会计与统计核算 ', null);
INSERT INTO `zytybmb` VALUES ('620206', '会计与审计 ', null);
INSERT INTO `zytybmb` VALUES ('620207', '审计实务 ', null);
INSERT INTO `zytybmb` VALUES ('620208', '统计实务 ', null);
INSERT INTO `zytybmb` VALUES ('620300', '经济贸易类', null);
INSERT INTO `zytybmb` VALUES ('620301', '经济管理 ', null);
INSERT INTO `zytybmb` VALUES ('62030101', '经济管理(财务管理方向)', null);
INSERT INTO `zytybmb` VALUES ('62030102', '经济管理实验班', null);
INSERT INTO `zytybmb` VALUES ('62030103', '经济管理试验班', null);
INSERT INTO `zytybmb` VALUES ('62030104', '经济试验班', null);
INSERT INTO `zytybmb` VALUES ('620302', '经济信息管理 ', null);
INSERT INTO `zytybmb` VALUES ('620303', '国际经济与贸易 ', null);
INSERT INTO `zytybmb` VALUES ('620304', '国际贸易实务 ', null);
INSERT INTO `zytybmb` VALUES ('62030401', '国际贸易', null);
INSERT INTO `zytybmb` VALUES ('620305', '国际商务 ', null);
INSERT INTO `zytybmb` VALUES ('62030501', '国际贸易实务(外贸业务经理)', null);
INSERT INTO `zytybmb` VALUES ('620306', '商务经纪与代理 ', null);
INSERT INTO `zytybmb` VALUES ('620400', '市场营销类', null);
INSERT INTO `zytybmb` VALUES ('620401', '市场营销 ', null);
INSERT INTO `zytybmb` VALUES ('62040101', '产权交易与实务', null);
INSERT INTO `zytybmb` VALUES ('62040102', '市场营销类(市场营销)', null);
INSERT INTO `zytybmb` VALUES ('62040103', '市场营销(2+2中澳学分互认项目)', null);
INSERT INTO `zytybmb` VALUES ('62040104', '市场营销(本)', null);
INSERT INTO `zytybmb` VALUES ('62040105', '市场营销(出版营销)', null);
INSERT INTO `zytybmb` VALUES ('62040106', '市场营销(电子商务方向)', null);
INSERT INTO `zytybmb` VALUES ('62040107', '市场营销(房地产经营与管理)', null);
INSERT INTO `zytybmb` VALUES ('62040108', '市场营销(服装营销)', null);
INSERT INTO `zytybmb` VALUES ('62040109', '市场营销(高端装备营销管理方向)', null);
INSERT INTO `zytybmb` VALUES ('62040110', '市场营销(高职统考)', null);
INSERT INTO `zytybmb` VALUES ('62040111', '市场营销(国际贸易)', null);
INSERT INTO `zytybmb` VALUES ('62040112', '市场营销(国际市场营销)', null);
INSERT INTO `zytybmb` VALUES ('62040113', '市场营销(国际市场营销方向)', null);
INSERT INTO `zytybmb` VALUES ('62040114', '市场营销(国际物流)', null);
INSERT INTO `zytybmb` VALUES ('62040115', '市场营销(国际营销)', null);
INSERT INTO `zytybmb` VALUES ('62040116', '市场营销(含市场策划、证劵投资、物流、项目管理科)', null);
INSERT INTO `zytybmb` VALUES ('62040117', '市场营销(金融营销方向)', null);
INSERT INTO `zytybmb` VALUES ('62040118', '市场营销(理科)', null);
INSERT INTO `zytybmb` VALUES ('62040119', '市场营销(理科网络营销方向)', null);
INSERT INTO `zytybmb` VALUES ('62040120', '市场营销(旅游市场营销方向)', null);
INSERT INTO `zytybmb` VALUES ('62040121', '市场营销(南校区就读)', null);
INSERT INTO `zytybmb` VALUES ('62040122', '市场营销(品牌管理)', null);
INSERT INTO `zytybmb` VALUES ('62040123', '市场营销(汽车服务与营销)', null);
INSERT INTO `zytybmb` VALUES ('62040124', '市场营销(汽车营销)', null);
INSERT INTO `zytybmb` VALUES ('62040125', '市场营销(设有旅游市场营销和电子商务方向)', null);
INSERT INTO `zytybmb` VALUES ('62040126', '市场营销(师范类)', null);
INSERT INTO `zytybmb` VALUES ('62040127', '市场营销(双语教学)', null);
INSERT INTO `zytybmb` VALUES ('62040128', '市场营销(网络营销方向)', null);
INSERT INTO `zytybmb` VALUES ('62040129', '市场营销(文科)', null);
INSERT INTO `zytybmb` VALUES ('62040130', '市场营销(文科网络营销方向)', null);
INSERT INTO `zytybmb` VALUES ('62040131', '市场营销(物流)', null);
INSERT INTO `zytybmb` VALUES ('62040132', '市场营销(销售管理科、商务策划与管理科、电子商务、连锁经营管理科)', null);
INSERT INTO `zytybmb` VALUES ('62040133', '市场营销(营销策划)', null);
INSERT INTO `zytybmb` VALUES ('62040134', '市场营销(营销管理科、商务策划与管理科、电子商务、连锁经营管理科)', null);
INSERT INTO `zytybmb` VALUES ('62040135', '市场营销(专科)', null);
INSERT INTO `zytybmb` VALUES ('62040136', '市场营销(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('62040137', '市场营销互联网营销与管理方向', null);
INSERT INTO `zytybmb` VALUES ('62040138', '市场营销类(电子商务)(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('62040139', '市场营销类(中澳)', null);
INSERT INTO `zytybmb` VALUES ('62040140', '市场营销类(中英)', null);
INSERT INTO `zytybmb` VALUES ('62040141', '市场营销网络营销', null);
INSERT INTO `zytybmb` VALUES ('62040142', '市场营销学', null);
INSERT INTO `zytybmb` VALUES ('62040143', '网络营销', null);
INSERT INTO `zytybmb` VALUES ('62040144', '市场开发与营销 文', null);
INSERT INTO `zytybmb` VALUES ('62040145', '市场(医药)营销专业', null);
INSERT INTO `zytybmb` VALUES ('620402', '市场开发与营销 ', null);
INSERT INTO `zytybmb` VALUES ('620403', '营销与策划 ', null);
INSERT INTO `zytybmb` VALUES ('62040301', '服装营销与管理', null);
INSERT INTO `zytybmb` VALUES ('62040302', '行销与策划', null);
INSERT INTO `zytybmb` VALUES ('62040303', '营销与策划(服装)', null);
INSERT INTO `zytybmb` VALUES ('620404', '医药营销 ', null);
INSERT INTO `zytybmb` VALUES ('620405', '电子商务 ', null);
INSERT INTO `zytybmb` VALUES ('62040501', '电子商务 文', null);
INSERT INTO `zytybmb` VALUES ('62040502', '电子商务(含网络营销、金融信息化方向)', null);
INSERT INTO `zytybmb` VALUES ('62040503', '电子商务(含网络营销创业)', null);
INSERT INTO `zytybmb` VALUES ('62040504', '电子商务(少数民族班)', null);
INSERT INTO `zytybmb` VALUES ('62040505', '电子商务(网络营销)', null);
INSERT INTO `zytybmb` VALUES ('62040506', '电子商务(网络营销、金融信息化)', null);
INSERT INTO `zytybmb` VALUES ('62040507', '电子商务(文)', null);
INSERT INTO `zytybmb` VALUES ('62040508', '电子商务(应用技术本科)', null);
INSERT INTO `zytybmb` VALUES ('62040509', '电子商务(院教改试点专业)', null);
INSERT INTO `zytybmb` VALUES ('62040510', '电子商务(支付清算方向)', null);
INSERT INTO `zytybmb` VALUES ('62040511', '电子商务(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('62040512', '电子商务(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('62040513', '电子商务类(含信息管理与信息系统、信息资源管理、电子商务)', null);
INSERT INTO `zytybmb` VALUES ('62040514', '电子商务网络经济与金融方向', null);
INSERT INTO `zytybmb` VALUES ('62040515', '电子商务运营管理方向', null);
INSERT INTO `zytybmb` VALUES ('62040516', '电子商务专业', null);
INSERT INTO `zytybmb` VALUES ('62040517', '电子商务资讯科技与管理方向', null);
INSERT INTO `zytybmb` VALUES ('620500', '工商管理类', null);
INSERT INTO `zytybmb` VALUES ('620501', '工商企业管理 ', null);
INSERT INTO `zytybmb` VALUES ('62050101', '工商企业管理(连锁经营与管理方向)', null);
INSERT INTO `zytybmb` VALUES ('62050102', '工商企业管理(企业信息化方向)', null);
INSERT INTO `zytybmb` VALUES ('62050103', '工商企业管理(涉外企业管理)', null);
INSERT INTO `zytybmb` VALUES ('62050104', '工商企业管理(市场开发与营销方向)', null);
INSERT INTO `zytybmb` VALUES ('62050105', '工商企业管理(中小企业经营与管理方向)', null);
INSERT INTO `zytybmb` VALUES ('62050106', '中小企业创业与经营', null);
INSERT INTO `zytybmb` VALUES ('62050107', '中小企业创业与经营(企业会计方向)', null);
INSERT INTO `zytybmb` VALUES ('620502', '工商行政管理 ', null);
INSERT INTO `zytybmb` VALUES ('620503', '商务管理 ', null);
INSERT INTO `zytybmb` VALUES ('620504', '连锁经营管理 ', null);
INSERT INTO `zytybmb` VALUES ('620505', '物流管理 ', null);
INSERT INTO `zytybmb` VALUES ('62050501', '物流管理 文', null);
INSERT INTO `zytybmb` VALUES ('62050502', '物流管理(本专衔接)', null);
INSERT INTO `zytybmb` VALUES ('62050503', '物流管理(电子商务)', null);
INSERT INTO `zytybmb` VALUES ('62050504', '物流管理(含采购管理、物流管理方向)', null);
INSERT INTO `zytybmb` VALUES ('62050505', '物流管理(含电商物流)', null);
INSERT INTO `zytybmb` VALUES ('62050506', '物流管理(航空物流)', null);
INSERT INTO `zytybmb` VALUES ('62050507', '物流管理(航空与快递方向)', null);
INSERT INTO `zytybmb` VALUES ('62050508', '物流管理(连锁企业物流经理)', null);
INSERT INTO `zytybmb` VALUES ('62050509', '物流管理(闽台)', null);
INSERT INTO `zytybmb` VALUES ('62050510', '物流管理(涉外方向)', null);
INSERT INTO `zytybmb` VALUES ('62050511', '物流管理(物流管理)', null);
INSERT INTO `zytybmb` VALUES ('62050512', '物流管理(物流金融、国际商务与报关)', null);
INSERT INTO `zytybmb` VALUES ('62050513', '物流管理(物流金融管理方向)', null);
INSERT INTO `zytybmb` VALUES ('62050514', '物流管理(中丹合作办学)', null);
INSERT INTO `zytybmb` VALUES ('62050515', '物流管理(中韩合作办学)', null);
INSERT INTO `zytybmb` VALUES ('62050516', '物流管理(中外合作)', null);
INSERT INTO `zytybmb` VALUES ('62050517', '物流管理科', null);
INSERT INTO `zytybmb` VALUES ('62050518', '物流管理科(国际物流管理科、采购与供应链管理科)', null);
INSERT INTO `zytybmb` VALUES ('62050519', '物流管理与工程类(物流管理)(', null);
INSERT INTO `zytybmb` VALUES ('62050520', '物流管理与工程类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('62050521', '物流装备', null);
INSERT INTO `zytybmb` VALUES ('62050522', '物业管理(中俄)', null);
INSERT INTO `zytybmb` VALUES ('62050523', '速递服务与管理', null);
INSERT INTO `zytybmb` VALUES ('62050524', '物流', null);
INSERT INTO `zytybmb` VALUES ('62050601', '行政管理(行政助理)', null);
INSERT INTO `zytybmb` VALUES ('630000', '医药卫生大类', null);
INSERT INTO `zytybmb` VALUES ('630100', '临床医学类', null);
INSERT INTO `zytybmb` VALUES ('630101', '临床医学 ', null);
INSERT INTO `zytybmb` VALUES ('63010101', '临床医学(社区医学)', null);
INSERT INTO `zytybmb` VALUES ('63010102', '临床医学(社区医学方向)', null);
INSERT INTO `zytybmb` VALUES ('63010103', '口腔', null);
INSERT INTO `zytybmb` VALUES ('630102', '口腔医学 ', null);
INSERT INTO `zytybmb` VALUES ('630103', '中医学 ', null);
INSERT INTO `zytybmb` VALUES ('630104', '蒙医学 ', null);
INSERT INTO `zytybmb` VALUES ('630105', '藏医学 ', null);
INSERT INTO `zytybmb` VALUES ('630106', '维医学 ', null);
INSERT INTO `zytybmb` VALUES ('630107', '中西医结合 ', null);
INSERT INTO `zytybmb` VALUES ('630108', '针灸推拿 ', null);
INSERT INTO `zytybmb` VALUES ('630109', '中医骨伤 ', null);
INSERT INTO `zytybmb` VALUES ('630200', '护理类', null);
INSERT INTO `zytybmb` VALUES ('630201', '护理 ', null);
INSERT INTO `zytybmb` VALUES ('63020101', '护理科', null);
INSERT INTO `zytybmb` VALUES ('63020102', '护理科(英语方向)', null);
INSERT INTO `zytybmb` VALUES ('630202', '助产 ', null);
INSERT INTO `zytybmb` VALUES ('63020201', '助产专业', null);
INSERT INTO `zytybmb` VALUES ('630300', '药学类', null);
INSERT INTO `zytybmb` VALUES ('630301', '药学 ', null);
INSERT INTO `zytybmb` VALUES ('63030101', '应用药学', null);
INSERT INTO `zytybmb` VALUES ('630302', '中药 ', null);
INSERT INTO `zytybmb` VALUES ('630400', '医学技术类', null);
INSERT INTO `zytybmb` VALUES ('630401', '医学检验技术 ', null);
INSERT INTO `zytybmb` VALUES ('63040101', '医学技术', null);
INSERT INTO `zytybmb` VALUES ('630402', '医学生物技术 ', null);
INSERT INTO `zytybmb` VALUES ('630403', '医学影像技术 ', null);
INSERT INTO `zytybmb` VALUES ('63040301', '医电', null);
INSERT INTO `zytybmb` VALUES ('630404', '眼视光技术 ', null);
INSERT INTO `zytybmb` VALUES ('630405', '康复治疗技术 ', null);
INSERT INTO `zytybmb` VALUES ('63040501', '康复', null);
INSERT INTO `zytybmb` VALUES ('63040502', '康复治疗学(本科)', null);
INSERT INTO `zytybmb` VALUES ('63040503', '康复治疗学(贫困专项)', null);
INSERT INTO `zytybmb` VALUES ('63040504', '康复治疗学本科', null);
INSERT INTO `zytybmb` VALUES ('630406', '口腔医学技术 ', null);
INSERT INTO `zytybmb` VALUES ('630407', '医学营养 ', null);
INSERT INTO `zytybmb` VALUES ('630408', '医疗美容技术 ', null);
INSERT INTO `zytybmb` VALUES ('63040801', '医学美容技术', null);
INSERT INTO `zytybmb` VALUES ('63040802', '化妆品营销与使用技术', null);
INSERT INTO `zytybmb` VALUES ('630409', '呼吸治疗技术 ', null);
INSERT INTO `zytybmb` VALUES ('630410', '卫生检验与检疫技术 ', null);
INSERT INTO `zytybmb` VALUES ('630500', '卫生管理类', null);
INSERT INTO `zytybmb` VALUES ('630501', '卫生监督 ', null);
INSERT INTO `zytybmb` VALUES ('63050101', '营养与食品卫生', null);
INSERT INTO `zytybmb` VALUES ('630502', '卫生信息管理 ', null);
INSERT INTO `zytybmb` VALUES ('630503', '公共卫生管理 ', null);
INSERT INTO `zytybmb` VALUES ('63050301', '公共卫生事业管理', null);
INSERT INTO `zytybmb` VALUES ('630504', '医学文秘', null);
INSERT INTO `zytybmb` VALUES ('640000', '旅游大类', null);
INSERT INTO `zytybmb` VALUES ('640100', '旅游管理类', null);
INSERT INTO `zytybmb` VALUES ('640101', '旅游管理 ', null);
INSERT INTO `zytybmb` VALUES ('64010101', '休闲服务与管理', null);
INSERT INTO `zytybmb` VALUES ('64010102', '旅游管理(财会方向)', null);
INSERT INTO `zytybmb` VALUES ('64010103', '旅游管理(酒店管理方向)', null);
INSERT INTO `zytybmb` VALUES ('64010104', '旅游管理(旅行社管理)', null);
INSERT INTO `zytybmb` VALUES ('64010105', '旅游管理(生态旅游方向)', null);
INSERT INTO `zytybmb` VALUES ('64010106', '旅游管理(休闲管理)', null);
INSERT INTO `zytybmb` VALUES ('64010107', '旅游管理(休闲旅游方向)', null);
INSERT INTO `zytybmb` VALUES ('64010108', '旅游管理(中澳合作、毕业获双证)', null);
INSERT INTO `zytybmb` VALUES ('64010109', '旅游管理(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('64010110', '旅游管理(中新合办)', null);
INSERT INTO `zytybmb` VALUES ('64010111', '旅游管理(酒店管理)', null);
INSERT INTO `zytybmb` VALUES ('640102', '涉外旅游 ', null);
INSERT INTO `zytybmb` VALUES ('64010201', '涉外旅游(海本)', null);
INSERT INTO `zytybmb` VALUES ('64010202', '涉外旅游(含城市轨道交通运营与管理)', null);
INSERT INTO `zytybmb` VALUES ('640103', '导游 ', null);
INSERT INTO `zytybmb` VALUES ('640104', '旅行社经营管理 ', null);
INSERT INTO `zytybmb` VALUES ('640105', '景区开发与管理 ', null);
INSERT INTO `zytybmb` VALUES ('640106', '酒店管理 ', null);
INSERT INTO `zytybmb` VALUES ('64010601', '酒店管理(贵州饭店订单班)', null);
INSERT INTO `zytybmb` VALUES ('64010602', '酒店管理(闽台)', null);
INSERT INTO `zytybmb` VALUES ('64010603', '酒店管理(喜达登订单班)', null);
INSERT INTO `zytybmb` VALUES ('64010604', '酒店管理(营销方向)', null);
INSERT INTO `zytybmb` VALUES ('64010605', '酒店管理专业(涉外方向)', null);
INSERT INTO `zytybmb` VALUES ('640200', '餐饮管理与服务类', null);
INSERT INTO `zytybmb` VALUES ('640201', '餐饮管理与服务 ', null);
INSERT INTO `zytybmb` VALUES ('640202', '烹饪工艺与营养', null);
INSERT INTO `zytybmb` VALUES ('64020203', '烹饪工艺与营养(中餐方向)', null);
INSERT INTO `zytybmb` VALUES ('650000', '公共事业大类', null);
INSERT INTO `zytybmb` VALUES ('650100', '公共事业类', null);
INSERT INTO `zytybmb` VALUES ('650101', '社会工作 ', null);
INSERT INTO `zytybmb` VALUES ('650102', '社区管理与服务 ', null);
INSERT INTO `zytybmb` VALUES ('650103', '青少年工作与管理 ', null);
INSERT INTO `zytybmb` VALUES ('650104', '社会福利事业管理 ', null);
INSERT INTO `zytybmb` VALUES ('650105', '公共关系 ', null);
INSERT INTO `zytybmb` VALUES ('650106', '商检技术 ', null);
INSERT INTO `zytybmb` VALUES ('650107', '人民武装 ', null);
INSERT INTO `zytybmb` VALUES ('650108', '涉外事务管理 ', null);
INSERT INTO `zytybmb` VALUES ('650200', '公共管理类', null);
INSERT INTO `zytybmb` VALUES ('65020001', '公共管理', null);
INSERT INTO `zytybmb` VALUES ('65020002', '公共管理科类', null);
INSERT INTO `zytybmb` VALUES ('65020003', '公共管理科类(外向型人才实验班)', null);
INSERT INTO `zytybmb` VALUES ('65020004', '公共管理类(公共事业管理、行政管理)', null);
INSERT INTO `zytybmb` VALUES ('65020005', '公共管理类(含行政管理、公共事业管理)', null);
INSERT INTO `zytybmb` VALUES ('65020006', '公共管理类(含行政管理、政治学与行政学专业)', null);
INSERT INTO `zytybmb` VALUES ('65020007', '公共管理类(贫困地区专项计划)', null);
INSERT INTO `zytybmb` VALUES ('65020008', '公共管理类(外向型人才实验班)', null);
INSERT INTO `zytybmb` VALUES ('65020009', '公共管理类(中外)', null);
INSERT INTO `zytybmb` VALUES ('65020010', '公共管理类(中外合作办学)', null);
INSERT INTO `zytybmb` VALUES ('65020011', '公共事业管理(城市管理方向)', null);
INSERT INTO `zytybmb` VALUES ('65020012', '公共事业管理(城市管理与社会服务方向)', null);
INSERT INTO `zytybmb` VALUES ('65020013', '公共事业管理(教育管理方向)', null);
INSERT INTO `zytybmb` VALUES ('65020014', '公共事业管理(教育管理方向)(', null);
INSERT INTO `zytybmb` VALUES ('65020015', '公共事业管理(民族班)', null);
INSERT INTO `zytybmb` VALUES ('65020016', '公共事业管理(社区管理)', null);
INSERT INTO `zytybmb` VALUES ('65020017', '公共事业管理(卫生事业管理)', null);
INSERT INTO `zytybmb` VALUES ('65020018', '公共事业管理(卫生事业管理方向)', null);
INSERT INTO `zytybmb` VALUES ('65020019', '公共事业管理(医患事务管理方向)', null);
INSERT INTO `zytybmb` VALUES ('65020020', '公共事业管理(医疗服务管理)', null);
INSERT INTO `zytybmb` VALUES ('65020021', '公共事业管理(医院管理)', null);
INSERT INTO `zytybmb` VALUES ('65020022', '公共事业管理(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('65020023', '公共事业管理酒店运营方向', null);
INSERT INTO `zytybmb` VALUES ('65020024', '公共事业管理学', null);
INSERT INTO `zytybmb` VALUES ('65020025', '公共事业管理专业', null);
INSERT INTO `zytybmb` VALUES ('65020026', '公共事业管理专业(城市管理与社会服务方向)', null);
INSERT INTO `zytybmb` VALUES ('65020027', '公共事业管理专业(公共事业管理、社会工作方向)', null);
INSERT INTO `zytybmb` VALUES ('650201', '公共事务管理 ', null);
INSERT INTO `zytybmb` VALUES ('65020101', '管理工程', null);
INSERT INTO `zytybmb` VALUES ('650202', '民政管理 ', null);
INSERT INTO `zytybmb` VALUES ('650203', '行政管理 ', null);
INSERT INTO `zytybmb` VALUES ('650204', '人力资源管理 ', null);
INSERT INTO `zytybmb` VALUES ('65020401', '人力资源管理 (文科)', null);
INSERT INTO `zytybmb` VALUES ('65020402', '人力资源管理(理科)', null);
INSERT INTO `zytybmb` VALUES ('65020403', '人力资源管理(旅游人力资源管理方向)', null);
INSERT INTO `zytybmb` VALUES ('65020404', '人力资源管理(人力资源管理师方向)', null);
INSERT INTO `zytybmb` VALUES ('65020405', '人力资源管理(专项计划)', null);
INSERT INTO `zytybmb` VALUES ('65020406', '人力资源管理科', null);
INSERT INTO `zytybmb` VALUES ('65020407', '人力资源管理企业人力资源管理、国际人力', null);
INSERT INTO `zytybmb` VALUES ('65020408', '人力资源管理专业', null);
INSERT INTO `zytybmb` VALUES ('650205', '劳动与社会保障 ', null);
INSERT INTO `zytybmb` VALUES ('650206', '国土资源管理 ', null);
INSERT INTO `zytybmb` VALUES ('650207', '海关管理 ', null);
INSERT INTO `zytybmb` VALUES ('650208', '环境规划与管理 ', null);
INSERT INTO `zytybmb` VALUES ('650300', '公共服务类', null);
INSERT INTO `zytybmb` VALUES ('650301', '家政服务 ', null);
INSERT INTO `zytybmb` VALUES ('65030101', '家政服务(涉外方向)', null);
INSERT INTO `zytybmb` VALUES ('650302', '老年服务与管理 ', null);
INSERT INTO `zytybmb` VALUES ('650303', '社区康复 ', null);
INSERT INTO `zytybmb` VALUES ('650304', '心理咨询 ', null);
INSERT INTO `zytybmb` VALUES ('65030401', '心理咨询(教育方向)', null);
INSERT INTO `zytybmb` VALUES ('650305', '科技成果中介服务 ', null);
INSERT INTO `zytybmb` VALUES ('650306', '职业中介服务 ', null);
INSERT INTO `zytybmb` VALUES ('650307', '现代殡仪技术与管理 ', null);
INSERT INTO `zytybmb` VALUES ('650308', '戒毒康复', null);
INSERT INTO `zytybmb` VALUES ('660000', '文化教育大类', null);
INSERT INTO `zytybmb` VALUES ('660100', '语言文化类', null);
INSERT INTO `zytybmb` VALUES ('660101', '汉语 ', null);
INSERT INTO `zytybmb` VALUES ('660102', '应用英语 ', null);
INSERT INTO `zytybmb` VALUES ('66010201', '应用英语(国际)', null);
INSERT INTO `zytybmb` VALUES ('66010202', '应用英语(国际交流)', null);
INSERT INTO `zytybmb` VALUES ('66010203', '应用英语(含翻译)', null);
INSERT INTO `zytybmb` VALUES ('66010204', '应用英语(涉外行政管理)', null);
INSERT INTO `zytybmb` VALUES ('66010205', '应用英语(文化与翻译方向)', null);
INSERT INTO `zytybmb` VALUES ('66010206', '应用英语(英语口译)', null);
INSERT INTO `zytybmb` VALUES ('660103', '应用日语 ', null);
INSERT INTO `zytybmb` VALUES ('66010301', '应用日语(IT方向)', null);
INSERT INTO `zytybmb` VALUES ('660104', '应用俄语 ', null);
INSERT INTO `zytybmb` VALUES ('66010401', '应用俄语(翻译方向)', null);
INSERT INTO `zytybmb` VALUES ('66010402', '应用俄语(商务方向)', null);
INSERT INTO `zytybmb` VALUES ('660105', '应用德语 ', null);
INSERT INTO `zytybmb` VALUES ('660106', '应用法语 ', null);
INSERT INTO `zytybmb` VALUES ('660107', '应用韩语 ', null);
INSERT INTO `zytybmb` VALUES ('66010701', '应用西班牙语', null);
INSERT INTO `zytybmb` VALUES ('66010702', '应用韩语(商务方向)', null);
INSERT INTO `zytybmb` VALUES ('66010703', '应用韩语(旅游酒店方向)', null);
INSERT INTO `zytybmb` VALUES ('66010704', '韩语(商务方向)', null);
INSERT INTO `zytybmb` VALUES ('66010705', '韩国语', null);
INSERT INTO `zytybmb` VALUES ('66010709', '应用阿拉伯语', null);
INSERT INTO `zytybmb` VALUES ('660108', '商务英语 ', null);
INSERT INTO `zytybmb` VALUES ('66010801', '商务英语(对外贸易方向)', null);
INSERT INTO `zytybmb` VALUES ('66010802', '商务英语(翻译方向)', null);
INSERT INTO `zytybmb` VALUES ('66010803', '商务英语(海本)', null);
INSERT INTO `zytybmb` VALUES ('66010804', '商务英语(航运英语)', null);
INSERT INTO `zytybmb` VALUES ('66010805', '商务英语(会展方向)', null);
INSERT INTO `zytybmb` VALUES ('66010806', '商务英语(旅游与酒店英语)', null);
INSERT INTO `zytybmb` VALUES ('66010807', '商务英语(涉外文秘方向)', null);
INSERT INTO `zytybmb` VALUES ('66010808', '商务英语(外事方向)', null);
INSERT INTO `zytybmb` VALUES ('660109', '旅游英语 ', null);
INSERT INTO `zytybmb` VALUES ('66010901', '旅游英语(酒店方向)', null);
INSERT INTO `zytybmb` VALUES ('66010902', '旅游英语(旅游策划与管理)', null);
INSERT INTO `zytybmb` VALUES ('66010903', '旅游英语(旅游方向)', null);
INSERT INTO `zytybmb` VALUES ('66010904', '旅游英语(涉外导游方向)', null);
INSERT INTO `zytybmb` VALUES ('660110', '商务日语 ', null);
INSERT INTO `zytybmb` VALUES ('66011001', '商务日语(国际贸易、涉外文秘)', null);
INSERT INTO `zytybmb` VALUES ('66011002', '商务日语(含国际贸易、涉外文秘)', null);
INSERT INTO `zytybmb` VALUES ('66011003', '商务日语(含国际贸易、涉外文秘方向)', null);
INSERT INTO `zytybmb` VALUES ('660111', '旅游日语 ', null);
INSERT INTO `zytybmb` VALUES ('660112', '文秘 ', null);
INSERT INTO `zytybmb` VALUES ('66011201', '文秘(含办公室管理)', null);
INSERT INTO `zytybmb` VALUES ('66011202', '文秘(涉外商务秘书)', null);
INSERT INTO `zytybmb` VALUES ('66011203', '文秘(校企合作)', null);
INSERT INTO `zytybmb` VALUES ('66011204', '文秘(校企合作)征集', null);
INSERT INTO `zytybmb` VALUES ('66011205', '文秘教育', null);
INSERT INTO `zytybmb` VALUES ('660113', '文物鉴定与修复 ', null);
INSERT INTO `zytybmb` VALUES ('660114', '文化事业管理 ', null);
INSERT INTO `zytybmb` VALUES ('660115', '文化市场经营与管理 ', null);
INSERT INTO `zytybmb` VALUES ('660116', '图书档案管理 ', null);
INSERT INTO `zytybmb` VALUES ('66011601', '图书档案管理(外文文献管理方向)', null);
INSERT INTO `zytybmb` VALUES ('66011602', '图书档案学', null);
INSERT INTO `zytybmb` VALUES ('66011603', '图书档案学类', null);
INSERT INTO `zytybmb` VALUES ('66011604', '图书馆档案学', null);
INSERT INTO `zytybmb` VALUES ('66011605', '图书情报与档案管理类(含图书馆学、档案学专业)', null);
INSERT INTO `zytybmb` VALUES ('66011606', '图学馆档案学', null);
INSERT INTO `zytybmb` VALUES ('660200', '教育类', null);
INSERT INTO `zytybmb` VALUES ('660201', '语文教育 ', null);
INSERT INTO `zytybmb` VALUES ('66020101', '语文教育(师范)', null);
INSERT INTO `zytybmb` VALUES ('66020102', '语文教育(师范类)', null);
INSERT INTO `zytybmb` VALUES ('660202', '数学教育 ', null);
INSERT INTO `zytybmb` VALUES ('66020201', '数学教育(师范)', null);
INSERT INTO `zytybmb` VALUES ('66020207', '应用数学', null);
INSERT INTO `zytybmb` VALUES ('660203', '英语教育 ', null);
INSERT INTO `zytybmb` VALUES ('66020301', '英语教育(家庭教育指导师方向)', null);
INSERT INTO `zytybmb` VALUES ('66020302', '英语教育(师范)', null);
INSERT INTO `zytybmb` VALUES ('66020303', '英语教育(师范类)', null);
INSERT INTO `zytybmb` VALUES ('660204', '物理教育 ', null);
INSERT INTO `zytybmb` VALUES ('660205', '化学教育 ', null);
INSERT INTO `zytybmb` VALUES ('660206', '生物教育 ', null);
INSERT INTO `zytybmb` VALUES ('660207', '历史教育 ', null);
INSERT INTO `zytybmb` VALUES ('660208', '地理教育 ', null);
INSERT INTO `zytybmb` VALUES ('660209', '音乐教育 ', null);
INSERT INTO `zytybmb` VALUES ('660210', '美术教育 ', null);
INSERT INTO `zytybmb` VALUES ('660211', '体育教育 ', null);
INSERT INTO `zytybmb` VALUES ('660212', '思想政治教育 ', null);
INSERT INTO `zytybmb` VALUES ('660213', '初等教育 ', null);
INSERT INTO `zytybmb` VALUES ('66021301', '初等教育(师范)', null);
INSERT INTO `zytybmb` VALUES ('66021302', '初等教育(数学与科学)', null);
INSERT INTO `zytybmb` VALUES ('66021303', '初等教育(数学与科学方向)', null);
INSERT INTO `zytybmb` VALUES ('66021304', '初等教育(英语)', null);
INSERT INTO `zytybmb` VALUES ('66021305', '初等教育(英语方向)', null);
INSERT INTO `zytybmb` VALUES ('66021306', '初等教育(中文与社会)', null);
INSERT INTO `zytybmb` VALUES ('66021307', '初等教育(中文与社会方向)', null);
INSERT INTO `zytybmb` VALUES ('660214', '学前教育 ', null);
INSERT INTO `zytybmb` VALUES ('66021401', '学前教育(师范)', null);
INSERT INTO `zytybmb` VALUES ('66021402', '学前教育(师范)(海外本科直通车)', null);
INSERT INTO `zytybmb` VALUES ('66021403', '学前教育(双语教育方向)', null);
INSERT INTO `zytybmb` VALUES ('66021404', '学前教育(早教方向)', null);
INSERT INTO `zytybmb` VALUES ('660215', '现代教育技术 ', null);
INSERT INTO `zytybmb` VALUES ('660216', '特殊教育 ', null);
INSERT INTO `zytybmb` VALUES ('660217', '儿童康复 ', null);
INSERT INTO `zytybmb` VALUES ('660218', '人群康复 ', null);
INSERT INTO `zytybmb` VALUES ('66021901', '职业技术教育管理', null);
INSERT INTO `zytybmb` VALUES ('660300', '体育类', null);
INSERT INTO `zytybmb` VALUES ('66030001', '体育产业管理', null);
INSERT INTO `zytybmb` VALUES ('66030002', '体育教育专业', null);
INSERT INTO `zytybmb` VALUES ('66030003', '体育经济', null);
INSERT INTO `zytybmb` VALUES ('66030004', '体育装备工程', null);
INSERT INTO `zytybmb` VALUES ('660301', '竞技体育 ', null);
INSERT INTO `zytybmb` VALUES ('660302', '运动训练 ', null);
INSERT INTO `zytybmb` VALUES ('660303', '社会体育 ', null);
INSERT INTO `zytybmb` VALUES ('66030301', '社会体育(太极拳)', null);
INSERT INTO `zytybmb` VALUES ('66030302', '社会体育与指导管理', null);
INSERT INTO `zytybmb` VALUES ('660304', '体育保健 ', null);
INSERT INTO `zytybmb` VALUES ('660305', '体育服务与管理', null);
INSERT INTO `zytybmb` VALUES ('670000', '艺术设计传媒大类', null);
INSERT INTO `zytybmb` VALUES ('670100', '艺术设计类', null);
INSERT INTO `zytybmb` VALUES ('670101', '艺术设计 ', null);
INSERT INTO `zytybmb` VALUES ('67010101', '艺术类设计', null);
INSERT INTO `zytybmb` VALUES ('67010102', '艺术设计(产品设计)', null);
INSERT INTO `zytybmb` VALUES ('67010103', '艺术设计(服饰品设计与营销)', null);
INSERT INTO `zytybmb` VALUES ('67010104', '艺术设计(服装设计 中美合作项目)', null);
INSERT INTO `zytybmb` VALUES ('67010105', '艺术设计(服装设计 中美合作项目方向)', null);
INSERT INTO `zytybmb` VALUES ('67010106', '艺术设计(服装设计)', null);
INSERT INTO `zytybmb` VALUES ('67010107', '艺术设计(服装设计方向)', null);
INSERT INTO `zytybmb` VALUES ('67010108', '艺术设计(服装设计与营销  中美合作项目)', null);
INSERT INTO `zytybmb` VALUES ('67010109', '艺术设计(服装设计与营销 中美合作项目)', null);
INSERT INTO `zytybmb` VALUES ('67010110', '艺术设计(服装艺术设计  中美合作项目)', null);
INSERT INTO `zytybmb` VALUES ('67010111', '艺术设计(服装艺术设计 中美合作项目)', null);
INSERT INTO `zytybmb` VALUES ('67010112', '艺术设计(服装艺术设计)', null);
INSERT INTO `zytybmb` VALUES ('67010113', '艺术设计(广告设计)', null);
INSERT INTO `zytybmb` VALUES ('67010114', '艺术设计(环境艺术设计)', null);
INSERT INTO `zytybmb` VALUES ('67010115', '艺术设计(环境艺术设计方向)', null);
INSERT INTO `zytybmb` VALUES ('67010116', '艺术设计(家具设计)', null);
INSERT INTO `zytybmb` VALUES ('67010117', '艺术设计(美术类)', null);
INSERT INTO `zytybmb` VALUES ('67010118', '艺术设计(平面、环境、造型等设计)', null);
INSERT INTO `zytybmb` VALUES ('67010119', '艺术设计(平面设计方向)', null);
INSERT INTO `zytybmb` VALUES ('67010120', '艺术设计(染织艺术设计)', null);
INSERT INTO `zytybmb` VALUES ('67010121', '艺术设计(人物造型设计)', null);
INSERT INTO `zytybmb` VALUES ('67010122', '艺术设计(设计与营销 中美合作项目)', null);
INSERT INTO `zytybmb` VALUES ('67010123', '艺术设计(设计与营销 中美合作项目方向)', null);
INSERT INTO `zytybmb` VALUES ('67010124', '艺术设计(时装表演及营销)', null);
INSERT INTO `zytybmb` VALUES ('67010125', '艺术设计(视觉传达，环境艺术)', null);
INSERT INTO `zytybmb` VALUES ('67010126', '艺术设计(视觉传达设计)', null);
INSERT INTO `zytybmb` VALUES ('67010127', '应用艺术设计', null);
INSERT INTO `zytybmb` VALUES ('670102', '产品造型设计 ', null);
INSERT INTO `zytybmb` VALUES ('67010201', '产品造型设计(轻工产品造型设计)', null);
INSERT INTO `zytybmb` VALUES ('670103', '视觉传达艺术设计 ', null);
INSERT INTO `zytybmb` VALUES ('67010301', '录音技术与艺术', null);
INSERT INTO `zytybmb` VALUES ('67010302', '视觉传达艺术设计(广告与包装设计)', null);
INSERT INTO `zytybmb` VALUES ('67010303', '视觉传达艺术设计(广告与包装设计方向)', null);
INSERT INTO `zytybmb` VALUES ('67010304', '视觉传达艺术设计(广告设计制作)', null);
INSERT INTO `zytybmb` VALUES ('67010305', '视觉传达艺术设计(品牌设计)', null);
INSERT INTO `zytybmb` VALUES ('670104', '电脑艺术设计 ', null);
INSERT INTO `zytybmb` VALUES ('67010401', '会展策划与管理', null);
INSERT INTO `zytybmb` VALUES ('67010402', '会展策划与管理(会展策划师)', null);
INSERT INTO `zytybmb` VALUES ('67010406', '电脑艺术设计(新媒体艺术、游戏设计与制作)', null);
INSERT INTO `zytybmb` VALUES ('67010407', '电脑艺术设计(产品设计方向)', null);
INSERT INTO `zytybmb` VALUES ('670105', '人物形象设计 ', null);
INSERT INTO `zytybmb` VALUES ('670106', '装潢艺术设计 ', null);
INSERT INTO `zytybmb` VALUES ('67010601', '装潢设计技术', null);
INSERT INTO `zytybmb` VALUES ('67010602', '装潢设计与工艺教育', null);
INSERT INTO `zytybmb` VALUES ('67010603', '装潢艺术设计(艺术类)', null);
INSERT INTO `zytybmb` VALUES ('670107', '装饰艺术设计 ', null);
INSERT INTO `zytybmb` VALUES ('67010701', '装饰艺术设计(家纺设计)', null);
INSERT INTO `zytybmb` VALUES ('67010702', '装饰艺术设计(首饰造型设计)', null);
INSERT INTO `zytybmb` VALUES ('67010703', '装饰艺术设计(陶瓷美术设计)', null);
INSERT INTO `zytybmb` VALUES ('670108', '雕塑艺术设计 ', null);
INSERT INTO `zytybmb` VALUES ('670109', '珠宝首饰工艺及鉴定 ', null);
INSERT INTO `zytybmb` VALUES ('670110', '雕刻艺术与家具设计 ', null);
INSERT INTO `zytybmb` VALUES ('670111', '旅游工艺品设计与制作 ', null);
INSERT INTO `zytybmb` VALUES ('670112', '广告设计与制作 ', null);
INSERT INTO `zytybmb` VALUES ('67011201', '广告设计与制作(美术类)', null);
INSERT INTO `zytybmb` VALUES ('67011202', '广告设计与制作(摄影摄像方向)', null);
INSERT INTO `zytybmb` VALUES ('67011203', '信息传播与策划(平面广告设计)', null);
INSERT INTO `zytybmb` VALUES ('67011204', '信息传播与策划(企业会展设计)', null);
INSERT INTO `zytybmb` VALUES ('67011211', '广告经营与管理', null);
INSERT INTO `zytybmb` VALUES ('670113', '多媒体设计与制作 ', null);
INSERT INTO `zytybmb` VALUES ('670200', '表演艺术类', null);
INSERT INTO `zytybmb` VALUES ('670201', '表演艺术 ', null);
INSERT INTO `zytybmb` VALUES ('670202', '音乐表演 ', null);
INSERT INTO `zytybmb` VALUES ('670203', '舞蹈表演 ', null);
INSERT INTO `zytybmb` VALUES ('670204', '服装表演 ', null);
INSERT INTO `zytybmb` VALUES ('67020401', '服装表演(空中乘务)', null);
INSERT INTO `zytybmb` VALUES ('670205', '影视表演 ', null);
INSERT INTO `zytybmb` VALUES ('670206', '戏曲表演 ', null);
INSERT INTO `zytybmb` VALUES ('670207', '编导 ', null);
INSERT INTO `zytybmb` VALUES ('670300', '广播影视类 ', null);
INSERT INTO `zytybmb` VALUES ('67030001', '广播影视编导', null);
INSERT INTO `zytybmb` VALUES ('670301', '广播电视技术 ', null);
INSERT INTO `zytybmb` VALUES ('670302', '摄影摄像技术 ', null);
INSERT INTO `zytybmb` VALUES ('670303', '音像技术 ', null);
INSERT INTO `zytybmb` VALUES ('670304', '影视多媒体技术 ', null);
INSERT INTO `zytybmb` VALUES ('67030401', '数字媒体', null);
INSERT INTO `zytybmb` VALUES ('67030402', '影视艺术技术', null);
INSERT INTO `zytybmb` VALUES ('67030403', '影像', null);
INSERT INTO `zytybmb` VALUES ('67030408', '影视灯光艺术', null);
INSERT INTO `zytybmb` VALUES ('670305', '影视动画 ', null);
INSERT INTO `zytybmb` VALUES ('67030501', '影视动画(动漫设计制作(二维))', null);
INSERT INTO `zytybmb` VALUES ('67030502', '影视动画(计算机多媒体)', null);
INSERT INTO `zytybmb` VALUES ('67030503', '影视动画(三维动画设计)', null);
INSERT INTO `zytybmb` VALUES ('67030504', '影视动画(摄影与摄像技术)', null);
INSERT INTO `zytybmb` VALUES ('67030505', '影视动画(影视多媒体制作)', null);
INSERT INTO `zytybmb` VALUES ('670306', '影视广告 ', null);
INSERT INTO `zytybmb` VALUES ('670307', '主持与播音 ', null);
INSERT INTO `zytybmb` VALUES ('670308', '新闻采编与制作 ', null);
INSERT INTO `zytybmb` VALUES ('67030801', '新闻采编与制作(影视制作技术)', null);
INSERT INTO `zytybmb` VALUES ('67030802', '新闻与传播', null);
INSERT INTO `zytybmb` VALUES ('670309', '电视节目制作 ', null);
INSERT INTO `zytybmb` VALUES ('670310', '电视制片管理', null);
INSERT INTO `zytybmb` VALUES ('680000', '公安大类', null);
INSERT INTO `zytybmb` VALUES ('680100', '公安管理类', null);
INSERT INTO `zytybmb` VALUES ('680101', '侦查 ', null);
INSERT INTO `zytybmb` VALUES ('680102', '经济犯罪侦查 ', null);
INSERT INTO `zytybmb` VALUES ('680103', '安全保卫 ', null);
INSERT INTO `zytybmb` VALUES ('680104', '警卫 ', null);
INSERT INTO `zytybmb` VALUES ('680105', '治安管理 ', null);
INSERT INTO `zytybmb` VALUES ('680106', '交通管理 ', null);
INSERT INTO `zytybmb` VALUES ('680107', '警察管理 ', null);
INSERT INTO `zytybmb` VALUES ('680108', '公共安全管理 ', null);
INSERT INTO `zytybmb` VALUES ('680109', '信息网络安全监察 ', null);
INSERT INTO `zytybmb` VALUES ('680110', '防火管理 ', null);
INSERT INTO `zytybmb` VALUES ('680111', '森林消防 ', null);
INSERT INTO `zytybmb` VALUES ('680112', '边防检查 ', null);
INSERT INTO `zytybmb` VALUES ('680113', '边境管理 ', null);
INSERT INTO `zytybmb` VALUES ('680114', '禁毒 ', null);
INSERT INTO `zytybmb` VALUES ('680200', '公安指挥类', null);
INSERT INTO `zytybmb` VALUES ('680201', '警察指挥与战术 ', null);
INSERT INTO `zytybmb` VALUES ('680202', '边防指挥 ', null);
INSERT INTO `zytybmb` VALUES ('680203', '边防船艇指挥 ', null);
INSERT INTO `zytybmb` VALUES ('680204', '边防通信指挥 ', null);
INSERT INTO `zytybmb` VALUES ('680205', '消防指挥 ', null);
INSERT INTO `zytybmb` VALUES ('68020501', '防化兵指挥', null);
INSERT INTO `zytybmb` VALUES ('680206', '参谋业务 ', null);
INSERT INTO `zytybmb` VALUES ('680207', '抢险救援 ', null);
INSERT INTO `zytybmb` VALUES ('680300', '公安技术类 ', null);
INSERT INTO `zytybmb` VALUES ('680301', '刑事技术 ', null);
INSERT INTO `zytybmb` VALUES ('680302', '警犬技术 ', null);
INSERT INTO `zytybmb` VALUES ('680303', '船艇动力管理 ', null);
INSERT INTO `zytybmb` VALUES ('680304', '船艇技术 ', null);
INSERT INTO `zytybmb` VALUES ('680305', '边防机要 ', null);
INSERT INTO `zytybmb` VALUES ('680400', '部队基础工作类', null);
INSERT INTO `zytybmb` VALUES ('680401', '部队政治工作 ', null);
INSERT INTO `zytybmb` VALUES ('680402', '部队财务会计 ', null);
INSERT INTO `zytybmb` VALUES ('680403', '部队后勤管理', null);
INSERT INTO `zytybmb` VALUES ('690000', '法律大类', null);
INSERT INTO `zytybmb` VALUES ('690100', '法律实务类', null);
INSERT INTO `zytybmb` VALUES ('690101', '司法助理 ', null);
INSERT INTO `zytybmb` VALUES ('690102', '法律文秘 ', null);
INSERT INTO `zytybmb` VALUES ('690103', '司法警务 ', null);
INSERT INTO `zytybmb` VALUES ('690104', '法律事务 ', null);
INSERT INTO `zytybmb` VALUES ('690105', '书记官 ', null);
INSERT INTO `zytybmb` VALUES ('690200', '法律执行类', null);
INSERT INTO `zytybmb` VALUES ('690201', '刑事执行 ', null);
INSERT INTO `zytybmb` VALUES ('690202', '民事执行 ', null);
INSERT INTO `zytybmb` VALUES ('690203', '行政执行 ', null);
INSERT INTO `zytybmb` VALUES ('690300', '司法技术类', null);
INSERT INTO `zytybmb` VALUES ('690301', '刑事侦查技术 ', null);
INSERT INTO `zytybmb` VALUES ('690302', '司法鉴定技术 ', null);
INSERT INTO `zytybmb` VALUES ('690303', '安全防范技术 ', null);
INSERT INTO `zytybmb` VALUES ('690304', '司法信息技术 ', null);
INSERT INTO `zytybmb` VALUES ('690305', '司法信息安全 ', null);
INSERT INTO `zytybmb` VALUES ('90000001', '本科预科班', null);
INSERT INTO `zytybmb` VALUES ('90000002', '本科预科班(预科)', null);
INSERT INTO `zytybmb` VALUES ('90000301', '中德联合培养各专业(简称“2+3”项目)', null);
INSERT INTO `zytybmb` VALUES ('90000406', '装备保障指挥', null);
INSERT INTO `zytybmb` VALUES ('90000407', '装备经济管理', null);
INSERT INTO `zytybmb` VALUES ('90010101', '14级少数民族预科', null);
INSERT INTO `zytybmb` VALUES ('90010102', '少数民族本科预科', null);
INSERT INTO `zytybmb` VALUES ('90010103', '少数民族预科班', null);
INSERT INTO `zytybmb` VALUES ('90010104', '少数民族预科班(本科)', null);
INSERT INTO `zytybmb` VALUES ('90010105', '预科班(学制5年)', null);
INSERT INTO `zytybmb` VALUES ('90010106', '预科班', null);
INSERT INTO `zytybmb` VALUES ('90010107', '预科班(只招少数民族考生，培养地点为南昌工学院)', null);
INSERT INTO `zytybmb` VALUES ('90020101', '灾害防治工程', null);
INSERT INTO `zytybmb` VALUES ('90020102', '再生资源科学与技术', null);
INSERT INTO `zytybmb` VALUES ('90020103', '展览展示艺术设计', null);
INSERT INTO `zytybmb` VALUES ('90020104', '展示设计', null);
INSERT INTO `zytybmb` VALUES ('90020105', '自然科学试验班', null);
INSERT INTO `zytybmb` VALUES ('90020106', '综合理科教育', null);
INSERT INTO `zytybmb` VALUES ('90020107', '综合文科教育', null);
INSERT INTO `zytybmb` VALUES ('90020108', '综合文科教育(历史)', null);
INSERT INTO `zytybmb` VALUES ('90020109', '综合文科教育(人文)', null);
INSERT INTO `zytybmb` VALUES ('90020110', '综合文科教育(思政)', null);
INSERT INTO `zytybmb` VALUES ('90020111', '总图设计与工业运输', null);
INSERT INTO `zytybmb` VALUES ('99000001', '工科实验班', null);
INSERT INTO `zytybmb` VALUES ('99000002', '工科实验班(中欧航空工程师)', null);
INSERT INTO `zytybmb` VALUES ('99000003', '工科试验班', null);
INSERT INTO `zytybmb` VALUES ('99000004', '工科试验班类', null);
INSERT INTO `zytybmb` VALUES ('99020101', '国防工程与防护', null);
INSERT INTO `zytybmb` VALUES ('99020102', '国防建筑设备工程', null);
INSERT INTO `zytybmb` VALUES ('99020103', '国防建筑学', null);
INSERT INTO `zytybmb` VALUES ('99020104', '国防教育与管理', null);
INSERT INTO `zytybmb` VALUES ('99020501', '口语', null);
INSERT INTO `zytybmb` VALUES ('99030101', '技术科学试验班', null);
INSERT INTO `zytybmb` VALUES ('99030102', '理科论与应用力学', null);
INSERT INTO `zytybmb` VALUES ('99030103', '理科实验班', null);
INSERT INTO `zytybmb` VALUES ('99030104', '理科试验班', null);
INSERT INTO `zytybmb` VALUES ('99030105', '理科试验班类', null);
INSERT INTO `zytybmb` VALUES ('99030106', '理学试验班', null);
INSERT INTO `zytybmb` VALUES ('99030107', '理工实验班', null);
INSERT INTO `zytybmb` VALUES ('99040101', '内燃机制造与维修', null);
INSERT INTO `zytybmb` VALUES ('99040102', '数字印刷', null);
INSERT INTO `zytybmb` VALUES ('99040103', '数字游戏设计', null);
INSERT INTO `zytybmb` VALUES ('99040104', '视频质量与安全', null);
INSERT INTO `zytybmb` VALUES ('99040201', '伪装工程', null);
INSERT INTO `zytybmb` VALUES ('99040202', '文科化产业管理科', null);
INSERT INTO `zytybmb` VALUES ('99050101', '商品学', null);
INSERT INTO `zytybmb` VALUES ('99050201', '文科实验班', null);
INSERT INTO `zytybmb` VALUES ('99050202', '文科试验班', null);
INSERT INTO `zytybmb` VALUES ('99050203', '文科试验班类', null);
INSERT INTO `zytybmb` VALUES ('99050204', '文科物与博物馆学', null);
INSERT INTO `zytybmb` VALUES ('99050301', '徐特立英才班', null);
INSERT INTO `zytybmb` VALUES ('99060101', '军事光电工程', null);
INSERT INTO `zytybmb` VALUES ('99060102', '军事交通指挥与工程', null);
INSERT INTO `zytybmb` VALUES ('99060103', '军事历史', null);
INSERT INTO `zytybmb` VALUES ('99060104', '军事气象学', null);
INSERT INTO `zytybmb` VALUES ('99060105', '军事情报', null);
INSERT INTO `zytybmb` VALUES ('99060106', '军事外交', null);
INSERT INTO `zytybmb` VALUES ('99060107', '军事心理学', null);
INSERT INTO `zytybmb` VALUES ('99060108', '军用材料工程', null);
INSERT INTO `zytybmb` VALUES ('99060109', '军用光电工程', null);
INSERT INTO `zytybmb` VALUES ('99060112', '炮兵指挥', null);
INSERT INTO `zytybmb` VALUES ('99060113', '汽车指挥', null);
INSERT INTO `zytybmb` VALUES ('99060201', '雷达工程', null);
INSERT INTO `zytybmb` VALUES ('99060202', '雷电防护科学与技术', null);
